#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1961
#define LARGE_STATE_COUNT 604
#define SYMBOL_COUNT 338
#define ALIAS_COUNT 3
#define TOKEN_COUNT 159
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 39
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 125

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_extern = 45,
  anon_sym___attribute__ = 46,
  anon_sym_COLON_COLON = 47,
  anon_sym_LBRACK_LBRACK = 48,
  anon_sym_RBRACK_RBRACK = 49,
  anon_sym___declspec = 50,
  anon_sym___based = 51,
  anon_sym___cdecl = 52,
  anon_sym___clrcall = 53,
  anon_sym___stdcall = 54,
  anon_sym___fastcall = 55,
  anon_sym___thiscall = 56,
  anon_sym___vectorcall = 57,
  sym_ms_restrict_modifier = 58,
  sym_ms_unsigned_ptr_modifier = 59,
  sym_ms_signed_ptr_modifier = 60,
  anon_sym__unaligned = 61,
  anon_sym___unaligned = 62,
  anon_sym_LBRACE = 63,
  anon_sym_RBRACE = 64,
  anon_sym_signed = 65,
  anon_sym_unsigned = 66,
  anon_sym_long = 67,
  anon_sym_short = 68,
  anon_sym_LBRACK = 69,
  anon_sym_RBRACK = 70,
  anon_sym_EQ = 71,
  anon_sym_static = 72,
  anon_sym_auto = 73,
  anon_sym_register = 74,
  anon_sym_inline = 75,
  anon_sym___inline = 76,
  anon_sym___inline__ = 77,
  anon_sym___forceinline = 78,
  anon_sym_thread_local = 79,
  anon_sym___thread = 80,
  anon_sym_const = 81,
  anon_sym_constexpr = 82,
  anon_sym_volatile = 83,
  anon_sym_restrict = 84,
  anon_sym___restrict__ = 85,
  anon_sym__Atomic = 86,
  anon_sym__Noreturn = 87,
  anon_sym_noreturn = 88,
  sym_primitive_type = 89,
  anon_sym_enum = 90,
  anon_sym_COLON = 91,
  anon_sym_struct = 92,
  anon_sym_union = 93,
  anon_sym_if = 94,
  anon_sym_else = 95,
  anon_sym_switch = 96,
  anon_sym_case = 97,
  anon_sym_default = 98,
  anon_sym_while = 99,
  anon_sym_do = 100,
  anon_sym_for = 101,
  anon_sym_return = 102,
  anon_sym_break = 103,
  anon_sym_continue = 104,
  anon_sym_goto = 105,
  anon_sym_QMARK = 106,
  anon_sym_STAR_EQ = 107,
  anon_sym_SLASH_EQ = 108,
  anon_sym_PERCENT_EQ = 109,
  anon_sym_PLUS_EQ = 110,
  anon_sym_DASH_EQ = 111,
  anon_sym_LT_LT_EQ = 112,
  anon_sym_GT_GT_EQ = 113,
  anon_sym_AMP_EQ = 114,
  anon_sym_CARET_EQ = 115,
  anon_sym_PIPE_EQ = 116,
  anon_sym_DASH_DASH = 117,
  anon_sym_PLUS_PLUS = 118,
  anon_sym_sizeof = 119,
  anon_sym___alignof__ = 120,
  anon_sym___alignof = 121,
  anon_sym__alignof = 122,
  anon_sym_alignof = 123,
  anon_sym__Alignof = 124,
  anon_sym_offsetof = 125,
  anon_sym__Generic = 126,
  anon_sym_asm = 127,
  anon_sym___asm__ = 128,
  anon_sym_DOT = 129,
  anon_sym_DASH_GT = 130,
  sym_number_literal = 131,
  anon_sym_L_SQUOTE = 132,
  anon_sym_u_SQUOTE = 133,
  anon_sym_U_SQUOTE = 134,
  anon_sym_u8_SQUOTE = 135,
  anon_sym_SQUOTE = 136,
  aux_sym_char_literal_token1 = 137,
  anon_sym_L_DQUOTE = 138,
  anon_sym_u_DQUOTE = 139,
  anon_sym_U_DQUOTE = 140,
  anon_sym_u8_DQUOTE = 141,
  anon_sym_DQUOTE = 142,
  aux_sym_string_literal_token1 = 143,
  sym_escape_sequence = 144,
  sym_system_lib_string = 145,
  sym_true = 146,
  sym_false = 147,
  anon_sym_NULL = 148,
  anon_sym_nullptr = 149,
  sym_comment = 150,
  anon_sym_task = 151,
  anon_sym_sub = 152,
  anon_sym_until = 153,
  anon_sym_acquire = 154,
  anon_sym_catch = 155,
  anon_sym_monitor = 156,
  anon_sym_start = 157,
  anon_sym_stop = 158,
  sym_translation_unit = 159,
  sym_preproc_include = 160,
  sym_preproc_def = 161,
  sym_preproc_function_def = 162,
  sym_preproc_params = 163,
  sym_preproc_call = 164,
  sym_preproc_if = 165,
  sym_preproc_ifdef = 166,
  sym_preproc_else = 167,
  sym_preproc_elif = 168,
  sym_preproc_elifdef = 169,
  sym_preproc_if_in_field_declaration_list = 170,
  sym_preproc_ifdef_in_field_declaration_list = 171,
  sym_preproc_else_in_field_declaration_list = 172,
  sym_preproc_elif_in_field_declaration_list = 173,
  sym__preproc_expression = 174,
  sym_preproc_parenthesized_expression = 175,
  sym_preproc_defined = 176,
  sym_preproc_unary_expression = 177,
  sym_preproc_call_expression = 178,
  sym_preproc_argument_list = 179,
  sym_preproc_binary_expression = 180,
  sym_function_definition = 181,
  sym__old_style_function_definition = 182,
  sym_declaration = 183,
  sym__declaration_declarator = 184,
  sym_type_definition = 185,
  sym__type_definition_type = 186,
  sym__type_definition_declarators = 187,
  sym__declaration_modifiers = 188,
  sym__declaration_specifiers = 189,
  sym_linkage_specification = 190,
  sym_attribute_specifier = 191,
  sym_attribute = 192,
  sym_attribute_declaration = 193,
  sym_ms_declspec_modifier = 194,
  sym_ms_based_modifier = 195,
  sym_ms_call_modifier = 196,
  sym_ms_unaligned_ptr_modifier = 197,
  sym_ms_pointer_modifier = 198,
  sym_declaration_list = 199,
  sym__declarator = 200,
  sym__field_declarator = 201,
  sym__type_declarator = 202,
  sym__abstract_declarator = 203,
  sym_parenthesized_declarator = 204,
  sym_parenthesized_field_declarator = 205,
  sym_parenthesized_type_declarator = 206,
  sym_abstract_parenthesized_declarator = 207,
  sym_attributed_declarator = 208,
  sym_attributed_field_declarator = 209,
  sym_attributed_type_declarator = 210,
  sym_pointer_declarator = 211,
  sym_pointer_field_declarator = 212,
  sym_pointer_type_declarator = 213,
  sym_abstract_pointer_declarator = 214,
  sym_function_declarator = 215,
  sym_function_field_declarator = 216,
  sym_function_type_declarator = 217,
  sym_abstract_function_declarator = 218,
  sym__old_style_function_declarator = 219,
  sym_array_declarator = 220,
  sym_array_field_declarator = 221,
  sym_array_type_declarator = 222,
  sym_abstract_array_declarator = 223,
  sym_init_declarator = 224,
  sym_compound_statement = 225,
  sym_storage_class_specifier = 226,
  sym_type_qualifier = 227,
  sym__type_specifier = 228,
  sym_sized_type_specifier = 229,
  sym_enum_specifier = 230,
  sym_enumerator_list = 231,
  sym_struct_specifier = 232,
  sym_union_specifier = 233,
  sym_field_declaration_list = 234,
  sym__field_declaration_list_item = 235,
  sym_field_declaration = 236,
  sym__field_declaration_declarator = 237,
  sym_bitfield_clause = 238,
  sym_enumerator = 239,
  sym_variadic_parameter = 240,
  sym_parameter_list = 241,
  sym__old_style_parameter_list = 242,
  sym_parameter_declaration = 243,
  sym_attributed_statement = 244,
  sym_labeled_statement = 245,
  sym__top_level_expression_statement = 246,
  sym_expression_statement = 247,
  sym_if_statement = 248,
  sym_else_clause = 249,
  sym_switch_statement = 250,
  sym_case_statement = 251,
  sym_while_statement = 252,
  sym_do_statement = 253,
  sym_for_statement = 254,
  sym__for_statement_body = 255,
  sym_return_statement = 256,
  sym_break_statement = 257,
  sym_continue_statement = 258,
  sym_goto_statement = 259,
  sym__expression = 260,
  sym__expression_not_binary = 261,
  sym_comma_expression = 262,
  sym_conditional_expression = 263,
  sym_assignment_expression = 264,
  sym_pointer_expression = 265,
  sym_unary_expression = 266,
  sym_binary_expression = 267,
  sym_update_expression = 268,
  sym_cast_expression = 269,
  sym_type_descriptor = 270,
  sym_sizeof_expression = 271,
  sym_alignof_expression = 272,
  sym_offsetof_expression = 273,
  sym_generic_expression = 274,
  sym_subscript_expression = 275,
  sym_call_expression = 276,
  sym_gnu_asm_expression = 277,
  sym_gnu_asm_qualifier = 278,
  sym_gnu_asm_output_operand_list = 279,
  sym_gnu_asm_output_operand = 280,
  sym_gnu_asm_input_operand_list = 281,
  sym_gnu_asm_input_operand = 282,
  sym_gnu_asm_clobber_list = 283,
  sym_gnu_asm_goto_list = 284,
  sym_argument_list = 285,
  sym_field_expression = 286,
  sym_compound_literal_expression = 287,
  sym_parenthesized_expression = 288,
  sym_initializer_list = 289,
  sym_initializer_pair = 290,
  sym_subscript_designator = 291,
  sym_field_designator = 292,
  sym_char_literal = 293,
  sym_concatenated_string = 294,
  sym_string_literal = 295,
  sym_null = 296,
  sym__empty_declaration = 297,
  sym_macro_type_specifier = 298,
  sym_task_definition = 299,
  sym_until_statement = 300,
  sym_acquire_statement = 301,
  sym_catch_clause = 302,
  sym_monitor_statement = 303,
  sym_start_statement = 304,
  sym_stop_statement = 305,
  aux_sym_translation_unit_repeat1 = 306,
  aux_sym_preproc_params_repeat1 = 307,
  aux_sym_preproc_if_repeat1 = 308,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 309,
  aux_sym_preproc_argument_list_repeat1 = 310,
  aux_sym__old_style_function_definition_repeat1 = 311,
  aux_sym__declaration_declarator_repeat1 = 312,
  aux_sym_type_definition_repeat1 = 313,
  aux_sym__type_definition_type_repeat1 = 314,
  aux_sym__type_definition_declarators_repeat1 = 315,
  aux_sym__declaration_specifiers_repeat1 = 316,
  aux_sym_attribute_declaration_repeat1 = 317,
  aux_sym_attributed_declarator_repeat1 = 318,
  aux_sym_pointer_declarator_repeat1 = 319,
  aux_sym_sized_type_specifier_repeat1 = 320,
  aux_sym_enumerator_list_repeat1 = 321,
  aux_sym__field_declaration_declarator_repeat1 = 322,
  aux_sym_parameter_list_repeat1 = 323,
  aux_sym__old_style_parameter_list_repeat1 = 324,
  aux_sym_case_statement_repeat1 = 325,
  aux_sym_generic_expression_repeat1 = 326,
  aux_sym_gnu_asm_expression_repeat1 = 327,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 328,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 329,
  aux_sym_gnu_asm_clobber_list_repeat1 = 330,
  aux_sym_gnu_asm_goto_list_repeat1 = 331,
  aux_sym_argument_list_repeat1 = 332,
  aux_sym_initializer_list_repeat1 = 333,
  aux_sym_initializer_pair_repeat1 = 334,
  aux_sym_concatenated_string_repeat1 = 335,
  aux_sym_string_literal_repeat1 = 336,
  aux_sym_monitor_statement_repeat1 = 337,
  alias_sym_field_identifier = 338,
  alias_sym_statement_identifier = 339,
  alias_sym_type_identifier = 340,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [anon_sym_task] = "task",
  [anon_sym_sub] = "sub",
  [anon_sym_until] = "until",
  [anon_sym_acquire] = "acquire",
  [anon_sym_catch] = "catch",
  [anon_sym_monitor] = "monitor",
  [anon_sym_start] = "start",
  [anon_sym_stop] = "stop",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym__old_style_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym__declaration_declarator] = "_declaration_declarator",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym__old_style_function_declarator] = "function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym__field_declaration_declarator] = "_field_declaration_declarator",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter_list] = "parameter_list",
  [sym__old_style_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym__expression_not_binary] = "_expression_not_binary",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [sym_task_definition] = "task_definition",
  [sym_until_statement] = "until_statement",
  [sym_acquire_statement] = "acquire_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_monitor_statement] = "monitor_statement",
  [sym_start_statement] = "start_statement",
  [sym_stop_statement] = "stop_statement",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym__old_style_function_definition_repeat1] = "_old_style_function_definition_repeat1",
  [aux_sym__declaration_declarator_repeat1] = "_declaration_declarator_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym__field_declaration_declarator_repeat1] = "_field_declaration_declarator_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym__old_style_parameter_list_repeat1] = "_old_style_parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_monitor_statement_repeat1] = "monitor_statement_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_auto] = anon_sym_auto,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [anon_sym_task] = anon_sym_task,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_acquire] = anon_sym_acquire,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_monitor] = anon_sym_monitor,
  [anon_sym_start] = anon_sym_start,
  [anon_sym_stop] = anon_sym_stop,
  [sym_translation_unit] = sym_translation_unit,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym__old_style_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym__declaration_declarator] = sym__declaration_declarator,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym__old_style_function_declarator] = sym_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym__type_specifier] = sym__type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym__field_declaration_declarator] = sym__field_declaration_declarator,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter_list] = sym_parameter_list,
  [sym__old_style_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym__expression] = sym__expression,
  [sym__expression_not_binary] = sym__expression_not_binary,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_macro_type_specifier] = sym_macro_type_specifier,
  [sym_task_definition] = sym_task_definition,
  [sym_until_statement] = sym_until_statement,
  [sym_acquire_statement] = sym_acquire_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_monitor_statement] = sym_monitor_statement,
  [sym_start_statement] = sym_start_statement,
  [sym_stop_statement] = sym_stop_statement,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym__old_style_function_definition_repeat1] = aux_sym__old_style_function_definition_repeat1,
  [aux_sym__declaration_declarator_repeat1] = aux_sym__declaration_declarator_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym__field_declaration_declarator_repeat1] = aux_sym__field_declaration_declarator_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym__old_style_parameter_list_repeat1] = aux_sym__old_style_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_monitor_statement_repeat1] = aux_sym_monitor_statement_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_task] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_acquire] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_monitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_start] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stop] = {
    .visible = true,
    .named = false,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_not_binary] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_task_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_until_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_acquire_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_monitor_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_start_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_stop_statement] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__old_style_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_declaration_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__old_style_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_monitor_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_body = 5,
  field_clobbers = 6,
  field_condition = 7,
  field_consequence = 8,
  field_constraint = 9,
  field_declarator = 10,
  field_designator = 11,
  field_directive = 12,
  field_event = 13,
  field_field = 14,
  field_function = 15,
  field_goto_labels = 16,
  field_index = 17,
  field_initializer = 18,
  field_input_operands = 19,
  field_item = 20,
  field_label = 21,
  field_left = 22,
  field_member = 23,
  field_name = 24,
  field_operand = 25,
  field_operator = 26,
  field_output_operands = 27,
  field_parameters = 28,
  field_path = 29,
  field_prefix = 30,
  field_register = 31,
  field_right = 32,
  field_size = 33,
  field_symbol = 34,
  field_task = 35,
  field_type = 36,
  field_underlying_type = 37,
  field_update = 38,
  field_value = 39,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_body] = "body",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_event] = "event",
  [field_field] = "field",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_item] = "item",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_right] = "right",
  [field_size] = "size",
  [field_symbol] = "symbol",
  [field_task] = "task",
  [field_type] = "type",
  [field_underlying_type] = "underlying_type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 3},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 17, .length = 1},
  [16] = {.index = 18, .length = 1},
  [17] = {.index = 8, .length = 1},
  [18] = {.index = 19, .length = 2},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 1},
  [22] = {.index = 24, .length = 2},
  [23] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 1},
  [25] = {.index = 29, .length = 1},
  [26] = {.index = 30, .length = 2},
  [27] = {.index = 32, .length = 2},
  [28] = {.index = 34, .length = 1},
  [29] = {.index = 35, .length = 3},
  [30] = {.index = 38, .length = 1},
  [31] = {.index = 39, .length = 2},
  [32] = {.index = 41, .length = 1},
  [33] = {.index = 42, .length = 2},
  [34] = {.index = 44, .length = 3},
  [35] = {.index = 47, .length = 2},
  [36] = {.index = 49, .length = 2},
  [37] = {.index = 51, .length = 2},
  [38] = {.index = 53, .length = 5},
  [39] = {.index = 58, .length = 3},
  [40] = {.index = 61, .length = 2},
  [41] = {.index = 63, .length = 2},
  [42] = {.index = 65, .length = 1},
  [43] = {.index = 66, .length = 2},
  [44] = {.index = 68, .length = 1},
  [45] = {.index = 69, .length = 2},
  [46] = {.index = 71, .length = 2},
  [47] = {.index = 73, .length = 2},
  [48] = {.index = 75, .length = 2},
  [49] = {.index = 77, .length = 2},
  [50] = {.index = 79, .length = 2},
  [51] = {.index = 81, .length = 2},
  [53] = {.index = 83, .length = 2},
  [54] = {.index = 85, .length = 1},
  [55] = {.index = 86, .length = 1},
  [56] = {.index = 87, .length = 3},
  [57] = {.index = 90, .length = 1},
  [58] = {.index = 91, .length = 1},
  [59] = {.index = 92, .length = 1},
  [60] = {.index = 93, .length = 2},
  [61] = {.index = 95, .length = 2},
  [62] = {.index = 97, .length = 1},
  [63] = {.index = 98, .length = 2},
  [64] = {.index = 100, .length = 3},
  [65] = {.index = 103, .length = 2},
  [66] = {.index = 105, .length = 5},
  [67] = {.index = 110, .length = 3},
  [68] = {.index = 113, .length = 5},
  [69] = {.index = 118, .length = 2},
  [70] = {.index = 120, .length = 2},
  [71] = {.index = 122, .length = 3},
  [72] = {.index = 125, .length = 2},
  [73] = {.index = 127, .length = 2},
  [74] = {.index = 129, .length = 2},
  [75] = {.index = 131, .length = 1},
  [76] = {.index = 132, .length = 2},
  [77] = {.index = 134, .length = 2},
  [78] = {.index = 136, .length = 2},
  [79] = {.index = 138, .length = 3},
  [80] = {.index = 141, .length = 2},
  [81] = {.index = 143, .length = 2},
  [82] = {.index = 145, .length = 1},
  [83] = {.index = 146, .length = 2},
  [84] = {.index = 148, .length = 2},
  [85] = {.index = 150, .length = 4},
  [86] = {.index = 154, .length = 1},
  [87] = {.index = 155, .length = 2},
  [88] = {.index = 157, .length = 1},
  [89] = {.index = 158, .length = 1},
  [90] = {.index = 159, .length = 2},
  [91] = {.index = 161, .length = 2},
  [92] = {.index = 163, .length = 5},
  [93] = {.index = 168, .length = 3},
  [94] = {.index = 171, .length = 2},
  [95] = {.index = 173, .length = 1},
  [97] = {.index = 174, .length = 2},
  [98] = {.index = 176, .length = 2},
  [99] = {.index = 178, .length = 3},
  [100] = {.index = 181, .length = 2},
  [101] = {.index = 183, .length = 2},
  [102] = {.index = 185, .length = 2},
  [103] = {.index = 187, .length = 2},
  [104] = {.index = 189, .length = 3},
  [105] = {.index = 192, .length = 2},
  [106] = {.index = 194, .length = 1},
  [107] = {.index = 195, .length = 2},
  [108] = {.index = 197, .length = 2},
  [109] = {.index = 199, .length = 3},
  [110] = {.index = 202, .length = 2},
  [111] = {.index = 204, .length = 1},
  [112] = {.index = 205, .length = 4},
  [113] = {.index = 209, .length = 3},
  [114] = {.index = 212, .length = 2},
  [115] = {.index = 214, .length = 2},
  [116] = {.index = 34, .length = 1},
  [117] = {.index = 216, .length = 5},
  [118] = {.index = 221, .length = 4},
  [119] = {.index = 225, .length = 2},
  [120] = {.index = 227, .length = 2},
  [121] = {.index = 229, .length = 2},
  [122] = {.index = 231, .length = 5},
  [123] = {.index = 236, .length = 2},
  [124] = {.index = 238, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 0, .inherited = true},
    {field_declarator, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [3] =
    {field_type, 0},
  [4] =
    {field_directive, 0},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_name, 0},
  [8] =
    {field_name, 1},
  [9] =
    {field_body, 1},
  [10] =
    {field_value, 1},
  [11] =
    {field_task, 1},
  [12] =
    {field_declarator, 0},
  [13] =
    {field_argument, 0},
    {field_operator, 1},
  [15] =
    {field_arguments, 1},
    {field_function, 0},
  [17] =
    {field_type, 1},
  [18] =
    {field_path, 1},
  [19] =
    {field_argument, 1},
    {field_directive, 0},
  [21] =
    {field_declarator, 1},
    {field_type, 0},
  [23] =
    {field_parameters, 0},
  [24] =
    {field_body, 2},
    {field_value, 1},
  [26] =
    {field_body, 2},
    {field_name, 1},
  [28] =
    {field_name, 2},
  [29] =
    {field_body, 2},
  [30] =
    {field_condition, 1},
    {field_consequence, 2},
  [32] =
    {field_body, 2},
    {field_condition, 1},
  [34] =
    {field_label, 1},
  [35] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [38] =
    {field_label, 0},
  [39] =
    {field_body, 2},
    {field_item, 1},
  [41] =
    {field_declarator, 1},
  [42] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [44] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [47] =
    {field_declarator, 0},
    {field_parameters, 1},
  [49] =
    {field_declarator, 0},
    {field_declarator, 1},
  [51] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [53] =
    {field_body, 2},
    {field_declarator, 1},
    {field_declarator, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [58] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [61] =
    {field_name, 1},
    {field_value, 2},
  [63] =
    {field_name, 1},
    {field_parameters, 2},
  [65] =
    {field_condition, 1},
  [66] =
    {field_alternative, 2},
    {field_name, 1},
  [68] =
    {field_type, 0, .inherited = true},
  [69] =
    {field_declarator, 2},
    {field_type, 0},
  [71] =
    {field_left, 0},
    {field_right, 2},
  [73] =
    {field_type, 1},
    {field_value, 3},
  [75] =
    {field_declarator, 2},
    {field_type, 1},
  [77] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [79] =
    {field_name, 2},
    {field_prefix, 0},
  [81] =
    {field_name, 1},
    {field_underlying_type, 3},
  [83] =
    {field_body, 3},
    {field_name, 2},
  [85] =
    {field_name, 3},
  [86] =
    {field_body, 3},
  [87] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [90] =
    {field_initializer, 0},
  [91] =
    {field_type, 2},
  [92] =
    {field_assembly_code, 2},
  [93] =
    {field_name, 0},
    {field_type, 2},
  [95] =
    {field_body, 3},
    {field_parameters, 2},
  [97] =
    {field_declarator, 2},
  [98] =
    {field_declarator, 0},
    {field_value, 2},
  [100] =
    {field_declarator, 0},
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
  [103] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [105] =
    {field_body, 3},
    {field_declarator, 1},
    {field_declarator, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [110] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [113] =
    {field_body, 3},
    {field_declarator, 2},
    {field_declarator, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [118] =
    {field_argument, 0},
    {field_index, 2},
  [120] =
    {field_alternative, 3},
    {field_condition, 0},
  [122] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [125] =
    {field_alternative, 3},
    {field_condition, 1},
  [127] =
    {field_alternative, 3},
    {field_name, 1},
  [129] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [131] =
    {field_size, 1},
  [132] =
    {field_declarator, 3},
    {field_type, 1},
  [134] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [136] =
    {field_name, 0},
    {field_value, 2},
  [138] =
    {field_body, 4},
    {field_name, 1},
    {field_underlying_type, 3},
  [141] =
    {field_body, 4},
    {field_name, 3},
  [143] =
    {field_body, 1},
    {field_condition, 3},
  [145] =
    {field_update, 2},
  [146] =
    {field_initializer, 0},
    {field_update, 2},
  [148] =
    {field_condition, 1},
    {field_initializer, 0},
  [150] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [154] =
    {field_operand, 1},
  [155] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [157] =
    {field_assembly_code, 3},
  [158] =
    {field_declarator, 3},
  [159] =
    {field_declarator, 1},
    {field_declarator, 2},
  [161] =
    {field_declarator, 0},
    {field_size, 2},
  [163] =
    {field_body, 4},
    {field_declarator, 2},
    {field_declarator, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [168] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [171] =
    {field_alternative, 4},
    {field_condition, 1},
  [173] =
    {field_size, 2},
  [174] =
    {field_declarator, 0},
    {field_declarator, 2, .inherited = true},
  [176] =
    {field_condition, 1},
    {field_update, 3},
  [178] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [181] =
    {field_initializer, 0},
    {field_update, 3},
  [183] =
    {field_condition, 2},
    {field_initializer, 0},
  [185] =
    {field_member, 4},
    {field_type, 2},
  [187] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [189] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [192] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [194] =
    {field_declarator, 4},
  [195] =
    {field_declarator, 0},
    {field_size, 3},
  [197] =
    {field_designator, 0},
    {field_value, 2},
  [199] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [202] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [204] =
    {field_register, 1},
  [205] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [209] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [212] =
    {field_constraint, 0},
    {field_value, 2},
  [214] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [216] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [221] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [225] =
    {field_body, 4},
    {field_event, 2},
  [227] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [229] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [231] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [236] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [238] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = alias_sym_type_identifier,
  },
  [21] = {
    [0] = sym_primitive_type,
  },
  [23] = {
    [1] = alias_sym_type_identifier,
  },
  [24] = {
    [2] = alias_sym_type_identifier,
  },
  [28] = {
    [1] = alias_sym_statement_identifier,
  },
  [30] = {
    [0] = alias_sym_statement_identifier,
  },
  [39] = {
    [2] = alias_sym_field_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = alias_sym_field_identifier,
  },
  [53] = {
    [2] = alias_sym_type_identifier,
  },
  [54] = {
    [3] = alias_sym_type_identifier,
  },
  [79] = {
    [1] = alias_sym_type_identifier,
  },
  [80] = {
    [3] = alias_sym_type_identifier,
  },
  [96] = {
    [1] = alias_sym_field_identifier,
  },
  [102] = {
    [4] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 5,
  [7] = 5,
  [8] = 2,
  [9] = 5,
  [10] = 5,
  [11] = 2,
  [12] = 12,
  [13] = 12,
  [14] = 14,
  [15] = 15,
  [16] = 15,
  [17] = 17,
  [18] = 12,
  [19] = 19,
  [20] = 20,
  [21] = 15,
  [22] = 12,
  [23] = 15,
  [24] = 24,
  [25] = 12,
  [26] = 15,
  [27] = 20,
  [28] = 28,
  [29] = 20,
  [30] = 30,
  [31] = 30,
  [32] = 30,
  [33] = 33,
  [34] = 20,
  [35] = 35,
  [36] = 35,
  [37] = 35,
  [38] = 38,
  [39] = 30,
  [40] = 28,
  [41] = 28,
  [42] = 42,
  [43] = 38,
  [44] = 38,
  [45] = 28,
  [46] = 28,
  [47] = 35,
  [48] = 38,
  [49] = 38,
  [50] = 30,
  [51] = 51,
  [52] = 52,
  [53] = 35,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 54,
  [60] = 57,
  [61] = 56,
  [62] = 58,
  [63] = 55,
  [64] = 56,
  [65] = 55,
  [66] = 58,
  [67] = 54,
  [68] = 57,
  [69] = 58,
  [70] = 54,
  [71] = 55,
  [72] = 58,
  [73] = 56,
  [74] = 57,
  [75] = 54,
  [76] = 56,
  [77] = 55,
  [78] = 57,
  [79] = 54,
  [80] = 58,
  [81] = 56,
  [82] = 57,
  [83] = 55,
  [84] = 84,
  [85] = 84,
  [86] = 84,
  [87] = 84,
  [88] = 84,
  [89] = 84,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 91,
  [108] = 108,
  [109] = 90,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 92,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 92,
  [145] = 93,
  [146] = 94,
  [147] = 91,
  [148] = 98,
  [149] = 143,
  [150] = 90,
  [151] = 151,
  [152] = 143,
  [153] = 118,
  [154] = 119,
  [155] = 96,
  [156] = 94,
  [157] = 120,
  [158] = 121,
  [159] = 124,
  [160] = 125,
  [161] = 129,
  [162] = 130,
  [163] = 90,
  [164] = 123,
  [165] = 126,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 97,
  [171] = 91,
  [172] = 172,
  [173] = 131,
  [174] = 135,
  [175] = 98,
  [176] = 99,
  [177] = 100,
  [178] = 178,
  [179] = 101,
  [180] = 137,
  [181] = 181,
  [182] = 182,
  [183] = 141,
  [184] = 102,
  [185] = 185,
  [186] = 91,
  [187] = 108,
  [188] = 111,
  [189] = 189,
  [190] = 190,
  [191] = 92,
  [192] = 105,
  [193] = 117,
  [194] = 90,
  [195] = 132,
  [196] = 95,
  [197] = 142,
  [198] = 198,
  [199] = 103,
  [200] = 134,
  [201] = 115,
  [202] = 140,
  [203] = 114,
  [204] = 93,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 106,
  [209] = 209,
  [210] = 104,
  [211] = 133,
  [212] = 212,
  [213] = 116,
  [214] = 128,
  [215] = 138,
  [216] = 136,
  [217] = 113,
  [218] = 92,
  [219] = 112,
  [220] = 220,
  [221] = 110,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 127,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 122,
  [230] = 230,
  [231] = 125,
  [232] = 118,
  [233] = 121,
  [234] = 138,
  [235] = 120,
  [236] = 115,
  [237] = 114,
  [238] = 116,
  [239] = 93,
  [240] = 113,
  [241] = 134,
  [242] = 112,
  [243] = 119,
  [244] = 133,
  [245] = 103,
  [246] = 135,
  [247] = 110,
  [248] = 102,
  [249] = 100,
  [250] = 137,
  [251] = 101,
  [252] = 94,
  [253] = 97,
  [254] = 124,
  [255] = 129,
  [256] = 105,
  [257] = 130,
  [258] = 94,
  [259] = 136,
  [260] = 117,
  [261] = 131,
  [262] = 93,
  [263] = 96,
  [264] = 132,
  [265] = 95,
  [266] = 140,
  [267] = 111,
  [268] = 126,
  [269] = 123,
  [270] = 106,
  [271] = 127,
  [272] = 122,
  [273] = 108,
  [274] = 142,
  [275] = 141,
  [276] = 99,
  [277] = 104,
  [278] = 128,
  [279] = 279,
  [280] = 128,
  [281] = 135,
  [282] = 130,
  [283] = 283,
  [284] = 283,
  [285] = 111,
  [286] = 129,
  [287] = 137,
  [288] = 125,
  [289] = 289,
  [290] = 124,
  [291] = 97,
  [292] = 143,
  [293] = 279,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 283,
  [298] = 172,
  [299] = 121,
  [300] = 120,
  [301] = 119,
  [302] = 302,
  [303] = 142,
  [304] = 304,
  [305] = 118,
  [306] = 126,
  [307] = 122,
  [308] = 143,
  [309] = 227,
  [310] = 116,
  [311] = 106,
  [312] = 115,
  [313] = 313,
  [314] = 141,
  [315] = 166,
  [316] = 114,
  [317] = 123,
  [318] = 318,
  [319] = 304,
  [320] = 140,
  [321] = 113,
  [322] = 302,
  [323] = 313,
  [324] = 324,
  [325] = 112,
  [326] = 137,
  [327] = 296,
  [328] = 103,
  [329] = 295,
  [330] = 104,
  [331] = 324,
  [332] = 135,
  [333] = 95,
  [334] = 324,
  [335] = 134,
  [336] = 168,
  [337] = 110,
  [338] = 108,
  [339] = 318,
  [340] = 112,
  [341] = 113,
  [342] = 114,
  [343] = 115,
  [344] = 116,
  [345] = 118,
  [346] = 119,
  [347] = 120,
  [348] = 121,
  [349] = 124,
  [350] = 125,
  [351] = 129,
  [352] = 110,
  [353] = 130,
  [354] = 131,
  [355] = 132,
  [356] = 178,
  [357] = 95,
  [358] = 140,
  [359] = 132,
  [360] = 198,
  [361] = 295,
  [362] = 296,
  [363] = 283,
  [364] = 123,
  [365] = 206,
  [366] = 302,
  [367] = 304,
  [368] = 133,
  [369] = 128,
  [370] = 182,
  [371] = 133,
  [372] = 190,
  [373] = 106,
  [374] = 131,
  [375] = 294,
  [376] = 230,
  [377] = 104,
  [378] = 224,
  [379] = 313,
  [380] = 223,
  [381] = 222,
  [382] = 220,
  [383] = 122,
  [384] = 108,
  [385] = 289,
  [386] = 167,
  [387] = 318,
  [388] = 103,
  [389] = 141,
  [390] = 111,
  [391] = 126,
  [392] = 313,
  [393] = 313,
  [394] = 169,
  [395] = 283,
  [396] = 142,
  [397] = 304,
  [398] = 294,
  [399] = 302,
  [400] = 279,
  [401] = 205,
  [402] = 212,
  [403] = 296,
  [404] = 97,
  [405] = 295,
  [406] = 151,
  [407] = 98,
  [408] = 209,
  [409] = 99,
  [410] = 318,
  [411] = 324,
  [412] = 138,
  [413] = 324,
  [414] = 295,
  [415] = 296,
  [416] = 318,
  [417] = 98,
  [418] = 279,
  [419] = 207,
  [420] = 302,
  [421] = 289,
  [422] = 189,
  [423] = 304,
  [424] = 283,
  [425] = 289,
  [426] = 289,
  [427] = 99,
  [428] = 136,
  [429] = 294,
  [430] = 100,
  [431] = 313,
  [432] = 318,
  [433] = 324,
  [434] = 100,
  [435] = 101,
  [436] = 102,
  [437] = 127,
  [438] = 105,
  [439] = 101,
  [440] = 102,
  [441] = 279,
  [442] = 134,
  [443] = 117,
  [444] = 294,
  [445] = 185,
  [446] = 138,
  [447] = 96,
  [448] = 136,
  [449] = 279,
  [450] = 127,
  [451] = 226,
  [452] = 228,
  [453] = 304,
  [454] = 302,
  [455] = 296,
  [456] = 105,
  [457] = 117,
  [458] = 294,
  [459] = 181,
  [460] = 295,
  [461] = 96,
  [462] = 227,
  [463] = 182,
  [464] = 222,
  [465] = 223,
  [466] = 224,
  [467] = 224,
  [468] = 226,
  [469] = 205,
  [470] = 228,
  [471] = 230,
  [472] = 190,
  [473] = 230,
  [474] = 190,
  [475] = 172,
  [476] = 198,
  [477] = 169,
  [478] = 209,
  [479] = 206,
  [480] = 209,
  [481] = 168,
  [482] = 223,
  [483] = 483,
  [484] = 222,
  [485] = 178,
  [486] = 486,
  [487] = 198,
  [488] = 212,
  [489] = 220,
  [490] = 190,
  [491] = 205,
  [492] = 230,
  [493] = 227,
  [494] = 151,
  [495] = 226,
  [496] = 178,
  [497] = 228,
  [498] = 207,
  [499] = 169,
  [500] = 212,
  [501] = 220,
  [502] = 228,
  [503] = 226,
  [504] = 224,
  [505] = 212,
  [506] = 189,
  [507] = 205,
  [508] = 209,
  [509] = 167,
  [510] = 207,
  [511] = 189,
  [512] = 167,
  [513] = 172,
  [514] = 207,
  [515] = 166,
  [516] = 227,
  [517] = 206,
  [518] = 169,
  [519] = 189,
  [520] = 168,
  [521] = 521,
  [522] = 223,
  [523] = 222,
  [524] = 185,
  [525] = 151,
  [526] = 151,
  [527] = 178,
  [528] = 185,
  [529] = 182,
  [530] = 198,
  [531] = 166,
  [532] = 181,
  [533] = 185,
  [534] = 181,
  [535] = 182,
  [536] = 220,
  [537] = 168,
  [538] = 181,
  [539] = 167,
  [540] = 172,
  [541] = 206,
  [542] = 542,
  [543] = 542,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 547,
  [549] = 546,
  [550] = 546,
  [551] = 547,
  [552] = 547,
  [553] = 546,
  [554] = 94,
  [555] = 542,
  [556] = 556,
  [557] = 542,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 568,
  [570] = 568,
  [571] = 568,
  [572] = 568,
  [573] = 568,
  [574] = 568,
  [575] = 568,
  [576] = 568,
  [577] = 568,
  [578] = 568,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 582,
  [584] = 581,
  [585] = 585,
  [586] = 582,
  [587] = 587,
  [588] = 581,
  [589] = 582,
  [590] = 590,
  [591] = 581,
  [592] = 592,
  [593] = 593,
  [594] = 593,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 596,
  [599] = 599,
  [600] = 596,
  [601] = 596,
  [602] = 593,
  [603] = 593,
  [604] = 604,
  [605] = 599,
  [606] = 604,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 612,
  [614] = 612,
  [615] = 615,
  [616] = 608,
  [617] = 599,
  [618] = 618,
  [619] = 619,
  [620] = 608,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 608,
  [625] = 612,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 608,
  [633] = 599,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 640,
  [643] = 641,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 641,
  [648] = 648,
  [649] = 649,
  [650] = 641,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 656,
  [658] = 658,
  [659] = 656,
  [660] = 656,
  [661] = 654,
  [662] = 654,
  [663] = 663,
  [664] = 664,
  [665] = 653,
  [666] = 666,
  [667] = 656,
  [668] = 656,
  [669] = 664,
  [670] = 670,
  [671] = 671,
  [672] = 653,
  [673] = 673,
  [674] = 653,
  [675] = 666,
  [676] = 664,
  [677] = 677,
  [678] = 670,
  [679] = 652,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 666,
  [684] = 655,
  [685] = 685,
  [686] = 686,
  [687] = 658,
  [688] = 688,
  [689] = 689,
  [690] = 673,
  [691] = 686,
  [692] = 664,
  [693] = 658,
  [694] = 688,
  [695] = 695,
  [696] = 696,
  [697] = 680,
  [698] = 698,
  [699] = 666,
  [700] = 700,
  [701] = 685,
  [702] = 680,
  [703] = 670,
  [704] = 696,
  [705] = 689,
  [706] = 706,
  [707] = 695,
  [708] = 689,
  [709] = 688,
  [710] = 654,
  [711] = 663,
  [712] = 686,
  [713] = 685,
  [714] = 714,
  [715] = 695,
  [716] = 655,
  [717] = 717,
  [718] = 696,
  [719] = 663,
  [720] = 652,
  [721] = 682,
  [722] = 722,
  [723] = 723,
  [724] = 654,
  [725] = 663,
  [726] = 652,
  [727] = 722,
  [728] = 655,
  [729] = 685,
  [730] = 730,
  [731] = 686,
  [732] = 658,
  [733] = 688,
  [734] = 689,
  [735] = 695,
  [736] = 696,
  [737] = 670,
  [738] = 680,
  [739] = 739,
  [740] = 739,
  [741] = 739,
  [742] = 739,
  [743] = 739,
  [744] = 545,
  [745] = 544,
  [746] = 746,
  [747] = 579,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 752,
  [755] = 752,
  [756] = 751,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 751,
  [761] = 752,
  [762] = 758,
  [763] = 758,
  [764] = 758,
  [765] = 753,
  [766] = 753,
  [767] = 751,
  [768] = 753,
  [769] = 758,
  [770] = 753,
  [771] = 751,
  [772] = 752,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 776,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 792,
  [794] = 794,
  [795] = 794,
  [796] = 792,
  [797] = 794,
  [798] = 794,
  [799] = 794,
  [800] = 792,
  [801] = 792,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 804,
  [806] = 804,
  [807] = 804,
  [808] = 808,
  [809] = 804,
  [810] = 804,
  [811] = 746,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 776,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 198,
  [854] = 167,
  [855] = 169,
  [856] = 228,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 226,
  [861] = 861,
  [862] = 151,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 864,
  [873] = 873,
  [874] = 198,
  [875] = 857,
  [876] = 167,
  [877] = 877,
  [878] = 169,
  [879] = 879,
  [880] = 228,
  [881] = 226,
  [882] = 151,
  [883] = 883,
  [884] = 858,
  [885] = 808,
  [886] = 869,
  [887] = 859,
  [888] = 861,
  [889] = 868,
  [890] = 890,
  [891] = 891,
  [892] = 870,
  [893] = 867,
  [894] = 866,
  [895] = 863,
  [896] = 896,
  [897] = 865,
  [898] = 898,
  [899] = 812,
  [900] = 834,
  [901] = 828,
  [902] = 851,
  [903] = 836,
  [904] = 824,
  [905] = 846,
  [906] = 815,
  [907] = 833,
  [908] = 842,
  [909] = 545,
  [910] = 544,
  [911] = 849,
  [912] = 912,
  [913] = 837,
  [914] = 838,
  [915] = 848,
  [916] = 773,
  [917] = 839,
  [918] = 841,
  [919] = 823,
  [920] = 774,
  [921] = 840,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 864,
  [926] = 228,
  [927] = 167,
  [928] = 922,
  [929] = 863,
  [930] = 922,
  [931] = 850,
  [932] = 151,
  [933] = 933,
  [934] = 934,
  [935] = 198,
  [936] = 825,
  [937] = 169,
  [938] = 852,
  [939] = 859,
  [940] = 858,
  [941] = 868,
  [942] = 864,
  [943] = 943,
  [944] = 944,
  [945] = 857,
  [946] = 857,
  [947] = 947,
  [948] = 865,
  [949] = 866,
  [950] = 818,
  [951] = 951,
  [952] = 858,
  [953] = 861,
  [954] = 867,
  [955] = 870,
  [956] = 226,
  [957] = 859,
  [958] = 870,
  [959] = 959,
  [960] = 861,
  [961] = 865,
  [962] = 866,
  [963] = 867,
  [964] = 869,
  [965] = 151,
  [966] = 966,
  [967] = 922,
  [968] = 226,
  [969] = 832,
  [970] = 228,
  [971] = 971,
  [972] = 169,
  [973] = 167,
  [974] = 198,
  [975] = 869,
  [976] = 976,
  [977] = 922,
  [978] = 868,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 863,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 96,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1020,
  [1022] = 1020,
  [1023] = 1020,
  [1024] = 1020,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 840,
  [1028] = 1028,
  [1029] = 1028,
  [1030] = 1028,
  [1031] = 1031,
  [1032] = 842,
  [1033] = 841,
  [1034] = 1034,
  [1035] = 824,
  [1036] = 1028,
  [1037] = 828,
  [1038] = 1038,
  [1039] = 834,
  [1040] = 815,
  [1041] = 833,
  [1042] = 836,
  [1043] = 837,
  [1044] = 96,
  [1045] = 838,
  [1046] = 1028,
  [1047] = 849,
  [1048] = 839,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1064,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1063,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1077,
  [1080] = 1078,
  [1081] = 1077,
  [1082] = 1076,
  [1083] = 1083,
  [1084] = 1078,
  [1085] = 1085,
  [1086] = 1077,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1073,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1076,
  [1096] = 1096,
  [1097] = 1076,
  [1098] = 1078,
  [1099] = 1087,
  [1100] = 1100,
  [1101] = 1073,
  [1102] = 1102,
  [1103] = 1073,
  [1104] = 1077,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1073,
  [1113] = 1113,
  [1114] = 1078,
  [1115] = 1076,
  [1116] = 1116,
  [1117] = 839,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 834,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 837,
  [1124] = 838,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 841,
  [1128] = 842,
  [1129] = 1125,
  [1130] = 828,
  [1131] = 1131,
  [1132] = 840,
  [1133] = 1133,
  [1134] = 824,
  [1135] = 1135,
  [1136] = 1121,
  [1137] = 1125,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1119,
  [1141] = 1119,
  [1142] = 1121,
  [1143] = 836,
  [1144] = 1144,
  [1145] = 815,
  [1146] = 1146,
  [1147] = 1125,
  [1148] = 833,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1125,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1121,
  [1156] = 1156,
  [1157] = 1121,
  [1158] = 1158,
  [1159] = 849,
  [1160] = 788,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1121,
  [1164] = 1164,
  [1165] = 1119,
  [1166] = 1146,
  [1167] = 1026,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1025,
  [1172] = 1049,
  [1173] = 1053,
  [1174] = 1050,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1005,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1191,
  [1193] = 1191,
  [1194] = 1194,
  [1195] = 1185,
  [1196] = 1194,
  [1197] = 1194,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 830,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1223,
  [1238] = 1224,
  [1239] = 1225,
  [1240] = 1226,
  [1241] = 1206,
  [1242] = 1228,
  [1243] = 1221,
  [1244] = 1229,
  [1245] = 1245,
  [1246] = 1230,
  [1247] = 1207,
  [1248] = 1221,
  [1249] = 1231,
  [1250] = 1207,
  [1251] = 1232,
  [1252] = 1199,
  [1253] = 1253,
  [1254] = 1221,
  [1255] = 1221,
  [1256] = 1256,
  [1257] = 1235,
  [1258] = 1207,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1210,
  [1262] = 1219,
  [1263] = 1218,
  [1264] = 1264,
  [1265] = 1217,
  [1266] = 1259,
  [1267] = 1267,
  [1268] = 1259,
  [1269] = 1264,
  [1270] = 1216,
  [1271] = 1271,
  [1272] = 1215,
  [1273] = 1200,
  [1274] = 1214,
  [1275] = 1204,
  [1276] = 1264,
  [1277] = 1213,
  [1278] = 1209,
  [1279] = 1264,
  [1280] = 830,
  [1281] = 1202,
  [1282] = 1264,
  [1283] = 1233,
  [1284] = 1198,
  [1285] = 1234,
  [1286] = 1271,
  [1287] = 1005,
  [1288] = 1201,
  [1289] = 1211,
  [1290] = 1212,
  [1291] = 1259,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1025,
  [1295] = 1293,
  [1296] = 1292,
  [1297] = 1292,
  [1298] = 1293,
  [1299] = 1293,
  [1300] = 1292,
  [1301] = 1293,
  [1302] = 1292,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1303,
  [1306] = 1303,
  [1307] = 1303,
  [1308] = 1308,
  [1309] = 1303,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1311,
  [1313] = 1311,
  [1314] = 1310,
  [1315] = 1311,
  [1316] = 1311,
  [1317] = 1310,
  [1318] = 1310,
  [1319] = 1319,
  [1320] = 1319,
  [1321] = 1319,
  [1322] = 1319,
  [1323] = 1323,
  [1324] = 1319,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1331,
  [1334] = 1334,
  [1335] = 1331,
  [1336] = 1328,
  [1337] = 1331,
  [1338] = 1331,
  [1339] = 1331,
  [1340] = 1328,
  [1341] = 1341,
  [1342] = 1328,
  [1343] = 1343,
  [1344] = 1331,
  [1345] = 1345,
  [1346] = 1328,
  [1347] = 1347,
  [1348] = 1347,
  [1349] = 1349,
  [1350] = 1347,
  [1351] = 1347,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1347,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1359,
  [1368] = 1359,
  [1369] = 1359,
  [1370] = 1370,
  [1371] = 1359,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1386,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1389,
  [1391] = 1389,
  [1392] = 1386,
  [1393] = 1389,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1389,
  [1397] = 1386,
  [1398] = 1398,
  [1399] = 1386,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1402,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1402,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1402,
  [1417] = 1402,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1464,
  [1466] = 1466,
  [1467] = 1464,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1470,
  [1472] = 1470,
  [1473] = 1470,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1468,
  [1479] = 1464,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1470,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1477,
  [1488] = 1488,
  [1489] = 1468,
  [1490] = 1490,
  [1491] = 1468,
  [1492] = 1470,
  [1493] = 1475,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1475,
  [1497] = 1477,
  [1498] = 1475,
  [1499] = 1477,
  [1500] = 1470,
  [1501] = 1477,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1464,
  [1506] = 1502,
  [1507] = 1504,
  [1508] = 1508,
  [1509] = 1475,
  [1510] = 1468,
  [1511] = 1511,
  [1512] = 1504,
  [1513] = 1470,
  [1514] = 1502,
  [1515] = 1515,
  [1516] = 1470,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1524,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1526,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1524,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1524,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1539,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1545,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1538,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1560,
  [1561] = 1526,
  [1562] = 1559,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1559,
  [1567] = 1538,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1551,
  [1578] = 1545,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1538,
  [1583] = 1583,
  [1584] = 1579,
  [1585] = 1579,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1538,
  [1592] = 1592,
  [1593] = 1586,
  [1594] = 1594,
  [1595] = 1545,
  [1596] = 1596,
  [1597] = 1524,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1572,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1539,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1606,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1605,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1605,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1606,
  [1622] = 1620,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1612,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1628,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1619,
  [1639] = 1617,
  [1640] = 1605,
  [1641] = 1641,
  [1642] = 1613,
  [1643] = 1612,
  [1644] = 1611,
  [1645] = 1645,
  [1646] = 1606,
  [1647] = 1647,
  [1648] = 1611,
  [1649] = 1628,
  [1650] = 1613,
  [1651] = 1651,
  [1652] = 1634,
  [1653] = 1605,
  [1654] = 1617,
  [1655] = 1619,
  [1656] = 1656,
  [1657] = 1619,
  [1658] = 1617,
  [1659] = 1605,
  [1660] = 1615,
  [1661] = 1613,
  [1662] = 1612,
  [1663] = 1611,
  [1664] = 1608,
  [1665] = 1624,
  [1666] = 1618,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1618,
  [1670] = 1634,
  [1671] = 1628,
  [1672] = 1620,
  [1673] = 1628,
  [1674] = 1606,
  [1675] = 1618,
  [1676] = 1634,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1619,
  [1680] = 1617,
  [1681] = 1681,
  [1682] = 1615,
  [1683] = 1613,
  [1684] = 1684,
  [1685] = 1612,
  [1686] = 1611,
  [1687] = 1687,
  [1688] = 1608,
  [1689] = 1634,
  [1690] = 1606,
  [1691] = 1634,
  [1692] = 1606,
  [1693] = 1618,
  [1694] = 1634,
  [1695] = 1606,
  [1696] = 1619,
  [1697] = 1634,
  [1698] = 1613,
  [1699] = 1699,
  [1700] = 1617,
  [1701] = 1701,
  [1702] = 1620,
  [1703] = 1634,
  [1704] = 1704,
  [1705] = 1606,
  [1706] = 1706,
  [1707] = 1611,
  [1708] = 1620,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1723,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1717,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1711,
  [1734] = 1712,
  [1735] = 1735,
  [1736] = 1718,
  [1737] = 1710,
  [1738] = 1738,
  [1739] = 1732,
  [1740] = 1711,
  [1741] = 1712,
  [1742] = 1742,
  [1743] = 1718,
  [1744] = 1719,
  [1745] = 1745,
  [1746] = 1732,
  [1747] = 1712,
  [1748] = 1748,
  [1749] = 1718,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1732,
  [1753] = 1712,
  [1754] = 1731,
  [1755] = 1718,
  [1756] = 1201,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1735,
  [1761] = 1761,
  [1762] = 1732,
  [1763] = 1763,
  [1764] = 1732,
  [1765] = 1763,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1727,
  [1769] = 1769,
  [1770] = 1731,
  [1771] = 1748,
  [1772] = 1727,
  [1773] = 1723,
  [1774] = 1721,
  [1775] = 1720,
  [1776] = 1719,
  [1777] = 1777,
  [1778] = 1718,
  [1779] = 1713,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1714,
  [1787] = 1716,
  [1788] = 1713,
  [1789] = 1750,
  [1790] = 1712,
  [1791] = 1735,
  [1792] = 1711,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1795,
  [1797] = 1710,
  [1798] = 1759,
  [1799] = 1767,
  [1800] = 1717,
  [1801] = 1784,
  [1802] = 1783,
  [1803] = 1738,
  [1804] = 1712,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1204,
  [1809] = 1809,
  [1810] = 1745,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1711,
  [1815] = 1815,
  [1816] = 1784,
  [1817] = 1750,
  [1818] = 1751,
  [1819] = 1819,
  [1820] = 1793,
  [1821] = 1769,
  [1822] = 1822,
  [1823] = 1759,
  [1824] = 1732,
  [1825] = 1794,
  [1826] = 1826,
  [1827] = 1763,
  [1828] = 1757,
  [1829] = 1758,
  [1830] = 1710,
  [1831] = 1831,
  [1832] = 1777,
  [1833] = 1783,
  [1834] = 1794,
  [1835] = 1716,
  [1836] = 1794,
  [1837] = 1766,
  [1838] = 1727,
  [1839] = 1748,
  [1840] = 1840,
  [1841] = 1793,
  [1842] = 1842,
  [1843] = 1723,
  [1844] = 1711,
  [1845] = 1721,
  [1846] = 1712,
  [1847] = 1714,
  [1848] = 773,
  [1849] = 1713,
  [1850] = 1767,
  [1851] = 1784,
  [1852] = 1784,
  [1853] = 1717,
  [1854] = 1783,
  [1855] = 1720,
  [1856] = 1719,
  [1857] = 1200,
  [1858] = 1757,
  [1859] = 1758,
  [1860] = 1750,
  [1861] = 1718,
  [1862] = 1718,
  [1863] = 1863,
  [1864] = 1719,
  [1865] = 1766,
  [1866] = 1720,
  [1867] = 1720,
  [1868] = 1721,
  [1869] = 1869,
  [1870] = 1785,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1713,
  [1874] = 1874,
  [1875] = 1767,
  [1876] = 1723,
  [1877] = 1784,
  [1878] = 1712,
  [1879] = 1751,
  [1880] = 1745,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1757,
  [1884] = 1758,
  [1885] = 1727,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1766,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1735,
  [1894] = 1711,
  [1895] = 1759,
  [1896] = 1896,
  [1897] = 1751,
  [1898] = 1757,
  [1899] = 1769,
  [1900] = 1757,
  [1901] = 1757,
  [1902] = 1757,
  [1903] = 1745,
  [1904] = 1822,
  [1905] = 1732,
  [1906] = 1738,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1738,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1769,
  [1913] = 1794,
  [1914] = 1763,
  [1915] = 1831,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1731,
  [1919] = 1748,
  [1920] = 1710,
  [1921] = 1717,
  [1922] = 1716,
  [1923] = 1923,
  [1924] = 1202,
  [1925] = 1907,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1831,
  [1929] = 1714,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1935,
  [1936] = 1766,
  [1937] = 1831,
  [1938] = 1714,
  [1939] = 1716,
  [1940] = 1940,
  [1941] = 1907,
  [1942] = 1942,
  [1943] = 1750,
  [1944] = 1717,
  [1945] = 1718,
  [1946] = 1831,
  [1947] = 1732,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1748,
  [1951] = 1951,
  [1952] = 1907,
  [1953] = 1731,
  [1954] = 1954,
  [1955] = 1907,
  [1956] = 1763,
  [1957] = 1758,
  [1958] = 1907,
  [1959] = 774,
  [1960] = 1757,
};

static inline bool sym_number_literal_character_set_1(int32_t c) {
  return (c < 'b'
    ? (c < 'L'
      ? (c < 'D'
        ? c == 'B'
        : c <= 'F')
      : (c <= 'L' || (c < 'W'
        ? c == 'U'
        : c <= 'W')))
    : (c <= 'b' || (c < 'u'
      ? (c < 'l'
        ? (c >= 'd' && c <= 'f')
        : c <= 'l')
      : (c <= 'u' || c == 'w'))));
}

static inline bool sym_number_literal_character_set_2(int32_t c) {
  return (c < 'b'
    ? (c < 'L'
      ? (c < 'D'
        ? c == 'B'
        : (c <= 'D' || c == 'F'))
      : (c <= 'L' || (c < 'W'
        ? c == 'U'
        : c <= 'W')))
    : (c <= 'b' || (c < 'l'
      ? (c < 'f'
        ? c == 'd'
        : c <= 'f')
      : (c <= 'l' || (c < 'w'
        ? c == 'u'
        : c <= 'w')))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'v'
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 't')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43494
    ? (c < 4186
      ? (c < 2703
        ? (c < 1969
          ? (c < 908
            ? (c < 710
              ? (c < 181
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 't' || (c < 170
                    ? (c >= 'v' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))))
              : (c <= 721 || (c < 886
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c >= 880 && c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 902 || (c >= 904 && c <= 906)))))))
            : (c <= 908 || (c < 1646
              ? (c < 1369
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1519
                  ? (c < 1488
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))))
              : (c <= 1647 || (c < 1786
                ? (c < 1765
                  ? (c < 1749
                    ? (c >= 1649 && c <= 1747)
                    : c <= 1749)
                  : (c <= 1766 || (c >= 1774 && c <= 1775)))
                : (c <= 1788 || (c < 1810
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1808)
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))))))))
          : (c <= 1969 || (c < 2474
            ? (c < 2185
              ? (c < 2084
                ? (c < 2042
                  ? (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)
                  : (c <= 2042 || (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)))
                : (c <= 2084 || (c < 2144
                  ? (c < 2112
                    ? c == 2088
                    : c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))))
              : (c <= 2190 || (c < 2392
                ? (c < 2365
                  ? (c < 2308
                    ? (c >= 2208 && c <= 2249)
                    : c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2447
                  ? (c < 2437
                    ? (c >= 2417 && c <= 2432)
                    : c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))))
            : (c <= 2480 || (c < 2575
              ? (c < 2524
                ? (c < 2493
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2556
                  ? (c < 2544
                    ? (c >= 2527 && c <= 2529)
                    : c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))))
              : (c <= 2576 || (c < 2616
                ? (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c >= 2613 && c <= 2614)))
                : (c <= 2617 || (c < 2674
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2676 || (c >= 2693 && c <= 2701)))))))))))
        : (c <= 2705 || (c < 3218
          ? (c < 2958
            ? (c < 2835
              ? (c < 2768
                ? (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)))
                : (c <= 2768 || (c < 2821
                  ? (c < 2809
                    ? (c >= 2784 && c <= 2785)
                    : c <= 2809)
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))))
              : (c <= 2856 || (c < 2908
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2947
                  ? (c < 2929
                    ? (c >= 2911 && c <= 2913)
                    : c <= 2929)
                  : (c <= 2947 || (c >= 2949 && c <= 2954)))))))
            : (c <= 2960 || (c < 3086
              ? (c < 2979
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c >= 2974 && c <= 2975)))
                : (c <= 2980 || (c < 3024
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))))
              : (c <= 3088 || (c < 3165
                ? (c < 3133
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3205
                  ? (c < 3200
                    ? (c >= 3168 && c <= 3169)
                    : c <= 3200)
                  : (c <= 3212 || (c >= 3214 && c <= 3216)))))))))
          : (c <= 3240 || (c < 3634
            ? (c < 3406
              ? (c < 3313
                ? (c < 3261
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3261 || (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3332 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3386 || c == 3389))))
              : (c <= 3406 || (c < 3482
                ? (c < 3450
                  ? (c < 3423
                    ? (c >= 3412 && c <= 3414)
                    : c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c >= 3585 && c <= 3632)))))))
            : (c <= 3634 || (c < 3776
              ? (c < 3724
                ? (c < 3716
                  ? (c < 3713
                    ? (c >= 3648 && c <= 3654)
                    : c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3762
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3760)
                  : (c <= 3762 || c == 3773))))
              : (c <= 3780 || (c < 3913
                ? (c < 3840
                  ? (c < 3804
                    ? c == 3782
                    : c <= 3807)
                  : (c <= 3840 || (c >= 3904 && c <= 3911)))
                : (c <= 3948 || (c < 4159
                  ? (c < 4096
                    ? (c >= 3976 && c <= 3980)
                    : c <= 4138)
                  : (c <= 4159 || (c >= 4176 && c <= 4181)))))))))))))
      : (c <= 4189 || (c < 8130
        ? (c < 6108
          ? (c < 4802
            ? (c < 4682
              ? (c < 4256
                ? (c < 4206
                  ? (c < 4197
                    ? c == 4193
                    : c <= 4198)
                  : (c <= 4208 || (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))))
              : (c <= 4685 || (c < 4746
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || c == 4800))))))
            : (c <= 4805 || (c < 5761
              ? (c < 4992
                ? (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c >= 4888 && c <= 4954)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))))
              : (c <= 5786 || (c < 5952
                ? (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 6016
                  ? (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)
                  : (c <= 6067 || c == 6103))))))))
          : (c <= 6108 || (c < 7296
            ? (c < 6688
              ? (c < 6480
                ? (c < 6314
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6312)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c >= 6656 && c <= 6678)))))
              : (c <= 6740 || (c < 7086
                ? (c < 6981
                  ? (c < 6917
                    ? c == 6823
                    : c <= 6963)
                  : (c <= 6988 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7245
                  ? (c < 7168
                    ? (c >= 7098 && c <= 7141)
                    : c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))))))
            : (c <= 7304 || (c < 7968
              ? (c < 7413
                ? (c < 7401
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7404 || (c >= 7406 && c <= 7411)))
                : (c <= 7414 || (c < 7680
                  ? (c < 7424
                    ? c == 7418
                    : c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))))
              : (c <= 8005 || (c < 8029
                ? (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))
                : (c <= 8029 || (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || c == 8126))))))))))
        : (c <= 8132 || (c < 12321
          ? (c < 8526
            ? (c < 8455
              ? (c < 8182
                ? (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))
                : (c <= 8188 || (c < 8336
                  ? (c < 8319
                    ? c == 8305
                    : c <= 8319)
                  : (c <= 8348 || c == 8450))))
              : (c <= 8455 || (c < 8486
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || c == 8484))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))))))
            : (c <= 8526 || (c < 11648
              ? (c < 11520
                ? (c < 11499
                  ? (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || c == 11631))))
              : (c <= 11670 || (c < 11712
                ? (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c >= 12293 && c <= 12295)))))))))
          : (c <= 12329 || (c < 42786
            ? (c < 13312
              ? (c < 12540
                ? (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))
                : (c <= 12543 || (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))))
              : (c <= 19903 || (c < 42538
                ? (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c >= 42512 && c <= 42527)))
                : (c <= 42539 || (c < 42656
                  ? (c < 42623
                    ? (c >= 42560 && c <= 42606)
                    : c <= 42653)
                  : (c <= 42735 || (c >= 42775 && c <= 42783)))))))
            : (c <= 42888 || (c < 43138
              ? (c < 42994
                ? (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c >= 42965 && c <= 42969)))
                : (c <= 43009 || (c < 43020
                  ? (c < 43015
                    ? (c >= 43011 && c <= 43013)
                    : c <= 43018)
                  : (c <= 43042 || (c >= 43072 && c <= 43123)))))
              : (c <= 43187 || (c < 43312
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43250 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43471
                  ? (c < 43396
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43442)
                  : (c <= 43471 || (c >= 43488 && c <= 43492)))))))))))))))
    : (c <= 43503 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43824
            ? (c < 43712
              ? (c < 43642
                ? (c < 43584
                  ? (c < 43520
                    ? (c >= 43514 && c <= 43518)
                    : c <= 43560)
                  : (c <= 43586 || (c < 43616
                    ? (c >= 43588 && c <= 43595)
                    : c <= 43638)))
                : (c <= 43642 || (c < 43701
                  ? (c < 43697
                    ? (c >= 43646 && c <= 43695)
                    : c <= 43697)
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))))
              : (c <= 43712 || (c < 43777
                ? (c < 43744
                  ? (c < 43739
                    ? c == 43714
                    : c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c >= 43816 && c <= 43822)))))))
            : (c <= 43866 || (c < 64287
              ? (c < 63744
                ? (c < 44032
                  ? (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44002)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(178);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(72);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(181);
      if (lookahead == '.') ADVANCE(243);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(225);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(109)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(40)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(40)
      if (lookahead == '\r') SKIP(1)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(43)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(43)
      if (lookahead == '\r') SKIP(3)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(42)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(42)
      if (lookahead == '\r') SKIP(5)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(45)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(45)
      if (lookahead == '\r') SKIP(7)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(47)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(47)
      if (lookahead == '\r') SKIP(9)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(49)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(49)
      if (lookahead == '\r') SKIP(11)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(50)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(50)
      if (lookahead == '\r') SKIP(13)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(48)
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(48)
      if (lookahead == '\r') SKIP(15)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(53)
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(53)
      if (lookahead == '\r') SKIP(17)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(46)
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(46)
      if (lookahead == '\r') SKIP(19)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(23)
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '\r') SKIP(21)
      END_STATE();
    case 23:
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead == '!') ADVANCE(65);
      if (lookahead == '%') ADVANCE(194);
      if (lookahead == '&') ADVANCE(203);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(180);
      if (lookahead == '/') ADVANCE(192);
      if (lookahead == '<') ADVANCE(212);
      if (lookahead == '=') ADVANCE(66);
      if (lookahead == '>') ADVANCE(208);
      if (lookahead == '\\') SKIP(22)
      if (lookahead == '^') ADVANCE(200);
      if (lookahead == '|') ADVANCE(199);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(51)
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(51)
      if (lookahead == '\r') SKIP(24)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 26:
      if (lookahead == '\n') ADVANCE(113);
      if (lookahead == '\r') ADVANCE(30);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '/') ADVANCE(135);
      if (lookahead == '\\') ADVANCE(133);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(63)
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 27:
      if (lookahead == '\n') ADVANCE(113);
      if (lookahead == '\r') ADVANCE(30);
      if (lookahead == '/') ADVANCE(135);
      if (lookahead == '\\') ADVANCE(133);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(63)
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 28:
      if (lookahead == '\n') ADVANCE(113);
      if (lookahead == '\r') ADVANCE(29);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '\\') SKIP(34)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(54)
      END_STATE();
    case 29:
      if (lookahead == '\n') ADVANCE(113);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '\\') SKIP(34)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54)
      END_STATE();
    case 30:
      if (lookahead == '\n') ADVANCE(113);
      if (lookahead == '/') ADVANCE(135);
      if (lookahead == '\\') ADVANCE(133);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63)
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(52)
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '/') ADVANCE(277);
      if (lookahead == '\\') ADVANCE(32);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(280);
      if (lookahead != 0) ADVANCE(281);
      END_STATE();
    case 32:
      if (lookahead == '\n') ADVANCE(283);
      if (lookahead == '\r') ADVANCE(282);
      if (lookahead == 'U') ADVANCE(106);
      if (lookahead == 'u') ADVANCE(98);
      if (lookahead == 'x') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(285);
      if (lookahead != 0) ADVANCE(282);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(54)
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(54)
      if (lookahead == '\r') SKIP(33)
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(62)
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '\\') ADVANCE(269);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(271);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(268);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(41)
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(41)
      if (lookahead == '\r') SKIP(36)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(44)
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(44)
      if (lookahead == '\r') SKIP(38)
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == '!') ADVANCE(178);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(72);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(181);
      if (lookahead == '.') ADVANCE(243);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(225);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 41:
      if (lookahead == '!') ADVANCE(178);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(81);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(181);
      if (lookahead == '.') ADVANCE(244);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(223);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(225);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 42:
      if (lookahead == '!') ADVANCE(177);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(72);
      if (lookahead == '&') ADVANCE(202);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(187);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(182);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(64);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == ']') ADVANCE(71);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 43:
      if (lookahead == '!') ADVANCE(177);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(78);
      if (lookahead == '&') ADVANCE(202);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(187);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(182);
      if (lookahead == '.') ADVANCE(244);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '=') ADVANCE(226);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == ']') ADVANCE(225);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '}') ADVANCE(222);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 44:
      if (lookahead == '!') ADVANCE(177);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(74);
      if (lookahead == '&') ADVANCE(202);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(187);
      if (lookahead == '-') ADVANCE(182);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(39);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 45:
      if (lookahead == '!') ADVANCE(177);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(76);
      if (lookahead == '&') ADVANCE(202);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(187);
      if (lookahead == '-') ADVANCE(182);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(8);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 46:
      if (lookahead == '!') ADVANCE(177);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '+') ADVANCE(189);
      if (lookahead == '-') ADVANCE(184);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == 'L') ADVANCE(296);
      if (lookahead == 'U') ADVANCE(297);
      if (lookahead == '\\') ADVANCE(20);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(298);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 47:
      if (lookahead == '!') ADVANCE(65);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(188);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == 'L') ADVANCE(289);
      if (lookahead == 'U') ADVANCE(291);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(225);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(293);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47)
      END_STATE();
    case 48:
      if (lookahead == '!') ADVANCE(65);
      if (lookahead == '#') ADVANCE(79);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(188);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == ']') ADVANCE(71);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(300);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48)
      END_STATE();
    case 49:
      if (lookahead == '!') ADVANCE(65);
      if (lookahead == '#') ADVANCE(73);
      if (lookahead == '%') ADVANCE(194);
      if (lookahead == '&') ADVANCE(203);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(180);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(192);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(212);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(208);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '^') ADVANCE(200);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(300);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(222);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49)
      END_STATE();
    case 50:
      if (lookahead == '!') ADVANCE(65);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(188);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == ']') ADVANCE(225);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(300);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50)
      END_STATE();
    case 51:
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == 'L') ADVANCE(289);
      if (lookahead == 'U') ADVANCE(291);
      if (lookahead == '\\') ADVANCE(25);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(293);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51)
      END_STATE();
    case 52:
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(32);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52)
      END_STATE();
    case 53:
      if (lookahead == '#') ADVANCE(75);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '[') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(18);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(300);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53)
      END_STATE();
    case 54:
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '\\') SKIP(34)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54)
      END_STATE();
    case 55:
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == '/') ADVANCE(305);
      END_STATE();
    case 56:
      if (lookahead == '*') ADVANCE(56);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead != 0) ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == '*') ADVANCE(56);
      if (lookahead != 0) ADVANCE(57);
      END_STATE();
    case 58:
      if (lookahead == '*') ADVANCE(56);
      if (lookahead != 0) ADVANCE(131);
      END_STATE();
    case 59:
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(247);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(248);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      END_STATE();
    case 60:
      if (lookahead == '.') ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == '.') ADVANCE(116);
      END_STATE();
    case 62:
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(32);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(62)
      END_STATE();
    case 63:
      if (lookahead == '/') ADVANCE(135);
      if (lookahead == '\\') ADVANCE(133);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63)
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 64:
      if (lookahead == ':') ADVANCE(218);
      END_STATE();
    case 65:
      if (lookahead == '=') ADVANCE(206);
      END_STATE();
    case 66:
      if (lookahead == '=') ADVANCE(205);
      END_STATE();
    case 67:
      if (lookahead == '>') ADVANCE(286);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(67);
      END_STATE();
    case 68:
      if (lookahead == '>') ADVANCE(287);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(67);
      END_STATE();
    case 69:
      if (lookahead == 'U') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 70:
      if (lookahead == '[') ADVANCE(219);
      END_STATE();
    case 71:
      if (lookahead == ']') ADVANCE(220);
      END_STATE();
    case 72:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'e') ADVANCE(169);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 73:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'e') ADVANCE(169);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 74:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'e') ADVANCE(172);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 75:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'e') ADVANCE(172);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 76:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'e') ADVANCE(171);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'e') ADVANCE(171);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 79:
      if (lookahead == 'd') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 80:
      if (lookahead == 'd') ADVANCE(83);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(81);
      END_STATE();
    case 82:
      if (lookahead == 'f') ADVANCE(121);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(300);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(254);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(252);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(282);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(94);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(95);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(97);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(98);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(99);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(100);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(101);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(102);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(103);
      END_STATE();
    case 106:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 107:
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(305);
      if (lookahead == '\r') ADVANCE(309);
      if (lookahead == '\\') ADVANCE(307);
      END_STATE();
    case 108:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(136);
      END_STATE();
    case 109:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(178);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(72);
      if (lookahead == '%') ADVANCE(195);
      if (lookahead == '&') ADVANCE(204);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(181);
      if (lookahead == '.') ADVANCE(243);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '<') ADVANCE(211);
      if (lookahead == '=') ADVANCE(227);
      if (lookahead == '>') ADVANCE(207);
      if (lookahead == '?') ADVANCE(229);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(225);
      if (lookahead == '^') ADVANCE(201);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '}') ADVANCE(222);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(109)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 110:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(177);
      if (lookahead == '"') ADVANCE(276);
      if (lookahead == '#') ADVANCE(78);
      if (lookahead == '&') ADVANCE(202);
      if (lookahead == '\'') ADVANCE(267);
      if (lookahead == '(') ADVANCE(176);
      if (lookahead == ')') ADVANCE(118);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '+') ADVANCE(187);
      if (lookahead == ',') ADVANCE(117);
      if (lookahead == '-') ADVANCE(182);
      if (lookahead == '.') ADVANCE(244);
      if (lookahead == '/') ADVANCE(55);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == ':') ADVANCE(228);
      if (lookahead == ';') ADVANCE(217);
      if (lookahead == '=') ADVANCE(226);
      if (lookahead == 'L') ADVANCE(288);
      if (lookahead == 'U') ADVANCE(290);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == ']') ADVANCE(225);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(300);
      if (lookahead == 'u') ADVANCE(292);
      if (lookahead == '{') ADVANCE(221);
      if (lookahead == '}') ADVANCE(222);
      if (lookahead == '~') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(110)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(151);
      if (lookahead == 'n') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(153);
      if (lookahead == 'n') ADVANCE(146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(57);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '\\') ADVANCE(137);
      if (lookahead != 0) ADVANCE(131);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(57);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(137);
      if (lookahead != 0) ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(305);
      if (lookahead == '\r') ADVANCE(302);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(306);
      if (lookahead != 0) ADVANCE(304);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(63)
      if (lookahead == '\r') ADVANCE(134);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '\\') ADVANCE(138);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(63)
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '\\') ADVANCE(138);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '\\') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '*' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(131);
      if (lookahead == '\r') ADVANCE(140);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(136);
      if (lookahead == '\r') ADVANCE(141);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '\\') ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(304);
      if (lookahead == '\r') ADVANCE(308);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(306);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(131);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(137);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(136);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '\\') ADVANCE(138);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(119);
      if (lookahead == 'n') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(158);
      if (lookahead == 's') ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(164);
      if (lookahead == 's') ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(166);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(168);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(206);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(240);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == '=') ADVANCE(234);
      if (lookahead == '>') ADVANCE(245);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(240);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(240);
      if (lookahead == '=') ADVANCE(234);
      if (lookahead == '>') ADVANCE(245);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(241);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(249);
      if (lookahead == '=') ADVANCE(233);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(241);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(241);
      if (lookahead == '=') ADVANCE(233);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(230);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == '/') ADVANCE(305);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == '/') ADVANCE(305);
      if (lookahead == '=') ADVANCE(231);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(232);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(239);
      if (lookahead == '|') ADVANCE(196);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(196);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(238);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(197);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(197);
      if (lookahead == '=') ADVANCE(237);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(209);
      if (lookahead == '>') ADVANCE(216);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(209);
      if (lookahead == '>') ADVANCE(215);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(214);
      if (lookahead == '=') ADVANCE(210);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(213);
      if (lookahead == '=') ADVANCE(210);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(235);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(236);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(219);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(205);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      if (sym_number_literal_character_set_1(lookahead)) ADVANCE(262);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(87);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(256);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(255);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(90);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(257);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(87);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(255);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'A' ||
          lookahead == 'C' ||
          lookahead == 'a' ||
          lookahead == 'c') ADVANCE(257);
      if (('B' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(258);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(259);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(261);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(90);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(259);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      if (sym_number_literal_character_set_1(lookahead)) ADVANCE(262);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(91);
      if (lookahead == 'B' ||
          lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(252);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(89);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(91);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(253);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(254);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(254);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(89);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(253);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(254);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(254);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(90);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(91);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(255);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(257);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(90);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(255);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'A' ||
          lookahead == 'C' ||
          lookahead == 'a' ||
          lookahead == 'c') ADVANCE(257);
      if (('B' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(90);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(255);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(257);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '0') ADVANCE(250);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(251);
      if (sym_number_literal_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(91);
      if (lookahead == 'B' ||
          lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(252);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(252);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(253);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(259);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(254);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(254);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      if (sym_number_literal_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_number_literal);
      if (sym_number_literal_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(283);
      if (lookahead == '\r') ADVANCE(282);
      if (lookahead == 'U') ADVANCE(106);
      if (lookahead == 'u') ADVANCE(98);
      if (lookahead == 'x') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(285);
      if (lookahead != 0) ADVANCE(282);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == '/') ADVANCE(305);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(32);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(279);
      if (lookahead == '/') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(281);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(279);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(279);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(277);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(281);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(281);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(32);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(284);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(286);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(67);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(263);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(272);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '\'') ADVANCE(265);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '\'') ADVANCE(264);
      if (lookahead == '8') ADVANCE(294);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '8') ADVANCE(295);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(275);
      if (lookahead == '\'') ADVANCE(266);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(275);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(263);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(265);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(264);
      if (lookahead == '8') ADVANCE(299);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(266);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(69);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(300);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(305);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(139);
      if (lookahead != 0) ADVANCE(304);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(132);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(304);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(304);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(305);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(304);
      if (lookahead == '\r') ADVANCE(308);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(306);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(305);
      if (lookahead == '\r') ADVANCE(309);
      if (lookahead == '\\') ADVANCE(307);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(304);
      if (lookahead == '/') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(139);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(107);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'm') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'p') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      if (lookahead == 's') ADVANCE(20);
      if (lookahead == 't') ADVANCE(21);
      if (lookahead == 'u') ADVANCE(22);
      if (lookahead == 'v') ADVANCE(23);
      if (lookahead == 'w') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'U') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(28)
      END_STATE();
    case 5:
      if (lookahead == 'A') ADVANCE(29);
      if (lookahead == 'G') ADVANCE(30);
      if (lookahead == 'N') ADVANCE(31);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'c') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 's') ADVANCE(37);
      if (lookahead == 'u') ADVANCE(38);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'h') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'l') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 14:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(56);
      if (lookahead == 'o') ADVANCE(57);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 17:
      if (lookahead == 'f') ADVANCE(60);
      END_STATE();
    case 18:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'i') ADVANCE(64);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead == 't') ADVANCE(66);
      if (lookahead == 'u') ADVANCE(67);
      if (lookahead == 'w') ADVANCE(68);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'h') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(73);
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(76);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(77);
      END_STATE();
    case 26:
      if (lookahead == 'L') ADVANCE(78);
      END_STATE();
    case 27:
      if (lookahead == 'U') ADVANCE(79);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(80);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(84);
      if (lookahead == 'b') ADVANCE(85);
      if (lookahead == 'c') ADVANCE(86);
      if (lookahead == 'd') ADVANCE(87);
      if (lookahead == 'e') ADVANCE(88);
      if (lookahead == 'f') ADVANCE(89);
      if (lookahead == 'i') ADVANCE(90);
      if (lookahead == 'r') ADVANCE(91);
      if (lookahead == 's') ADVANCE(92);
      if (lookahead == 't') ADVANCE(93);
      if (lookahead == 'u') ADVANCE(94);
      if (lookahead == 'v') ADVANCE(95);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(96);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 35:
      if (lookahead == 'q') ADVANCE(98);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(100);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(104);
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(106);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 44:
      if (lookahead == 'f') ADVANCE(108);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(109);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 50:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 54:
      if (lookahead == 'l') ADVANCE(117);
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 55:
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 56:
      if (lookahead == 'x') ADVANCE(120);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(121);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 59:
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 60:
      if (lookahead == 'f') ADVANCE(124);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 62:
      if (lookahead == 'g') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 63:
      if (lookahead == 'o') ADVANCE(129);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(130);
      if (lookahead == 'z') ADVANCE(131);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(132);
      END_STATE();
    case 66:
      if (lookahead == 'a') ADVANCE(133);
      if (lookahead == 'o') ADVANCE(134);
      if (lookahead == 'r') ADVANCE(135);
      END_STATE();
    case 67:
      if (lookahead == 'b') ADVANCE(136);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(137);
      END_STATE();
    case 69:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 72:
      if (lookahead == 'p') ADVANCE(141);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(143);
      if (lookahead == 's') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(146);
      if (lookahead == 'l') ADVANCE(147);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 77:
      if (lookahead == 'S') ADVANCE(149);
      END_STATE();
    case 78:
      if (lookahead == 'L') ADVANCE(150);
      END_STATE();
    case 79:
      if (lookahead == 'E') ADVANCE(151);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(153);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(154);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(155);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(156);
      if (lookahead == 's') ADVANCE(157);
      if (lookahead == 't') ADVANCE(158);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 86:
      if (lookahead == 'd') ADVANCE(160);
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 88:
      if (lookahead == 'x') ADVANCE(163);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(164);
      if (lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(166);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 92:
      if (lookahead == 'p') ADVANCE(168);
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 93:
      if (lookahead == 'h') ADVANCE(170);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(171);
      if (lookahead == 'p') ADVANCE(172);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 96:
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(175);
      END_STATE();
    case 98:
      if (lookahead == 'u') ADVANCE(176);
      END_STATE();
    case 99:
      if (lookahead == 'g') ADVANCE(177);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 101:
      if (lookahead == 'o') ADVANCE(178);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(179);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(180);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(182);
      END_STATE();
    case 106:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(184);
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 'i') ADVANCE(187);
      END_STATE();
    case 109:
      if (lookahead == 'b') ADVANCE(188);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 111:
      if (lookahead == 'm') ADVANCE(190);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(192);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(193);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 116:
      if (lookahead == 'o') ADVANCE(194);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(196);
      if (lookahead == '3') ADVANCE(197);
      if (lookahead == '6') ADVANCE(198);
      if (lookahead == '8') ADVANCE(199);
      if (lookahead == 'p') ADVANCE(200);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(201);
      END_STATE();
    case 120:
      if (lookahead == '_') ADVANCE(202);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 124:
      if (lookahead == 's') ADVANCE(206);
      END_STATE();
    case 125:
      if (lookahead == 'd') ADVANCE(207);
      END_STATE();
    case 126:
      if (lookahead == 'i') ADVANCE(208);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 132:
      if (lookahead == 'z') ADVANCE(214);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(215);
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 134:
      if (lookahead == 'p') ADVANCE(217);
      END_STATE();
    case 135:
      if (lookahead == 'u') ADVANCE(218);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 138:
      if (lookahead == 'k') ADVANCE(220);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 143:
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(225);
      END_STATE();
    case 145:
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 146:
      if (lookahead == 'd') ADVANCE(179);
      END_STATE();
    case 147:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 148:
      if (lookahead == 'l') ADVANCE(228);
      END_STATE();
    case 149:
      if (lookahead == 'E') ADVANCE(229);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 152:
      if (lookahead == 'g') ADVANCE(230);
      END_STATE();
    case 153:
      if (lookahead == 'm') ADVANCE(231);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(233);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 157:
      if (lookahead == 'm') ADVANCE(235);
      END_STATE();
    case 158:
      if (lookahead == 't') ADVANCE(236);
      END_STATE();
    case 159:
      if (lookahead == 's') ADVANCE(237);
      END_STATE();
    case 160:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(240);
      END_STATE();
    case 163:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(242);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 166:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 167:
      if (lookahead == 's') ADVANCE(245);
      END_STATE();
    case 168:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 169:
      if (lookahead == 'd') ADVANCE(247);
      END_STATE();
    case 170:
      if (lookahead == 'i') ADVANCE(248);
      if (lookahead == 'r') ADVANCE(249);
      END_STATE();
    case 171:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 172:
      if (lookahead == 't') ADVANCE(251);
      END_STATE();
    case 173:
      if (lookahead == 'c') ADVANCE(252);
      END_STATE();
    case 174:
      if (lookahead == 'g') ADVANCE(253);
      END_STATE();
    case 175:
      if (lookahead == 'l') ADVANCE(254);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 177:
      if (lookahead == 'n') ADVANCE(256);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 180:
      if (lookahead == 'k') ADVANCE(257);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 182:
      if (lookahead == 'h') ADVANCE(258);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(259);
      if (lookahead == '3') ADVANCE(260);
      if (lookahead == '6') ADVANCE(261);
      if (lookahead == '8') ADVANCE(262);
      if (lookahead == 'p') ADVANCE(263);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 185:
      if (lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 186:
      if (lookahead == 'u') ADVANCE(266);
      END_STATE();
    case 187:
      if (lookahead == 'n') ADVANCE(267);
      END_STATE();
    case 188:
      if (lookahead == 'l') ADVANCE(268);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 191:
      if (lookahead == 'r') ADVANCE(269);
      END_STATE();
    case 192:
      if (lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 193:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 195:
      if (lookahead == 'n') ADVANCE(270);
      END_STATE();
    case 196:
      if (lookahead == '6') ADVANCE(271);
      END_STATE();
    case 197:
      if (lookahead == '2') ADVANCE(272);
      END_STATE();
    case 198:
      if (lookahead == '4') ADVANCE(273);
      END_STATE();
    case 199:
      if (lookahead == '_') ADVANCE(274);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(275);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 202:
      if (lookahead == 'a') ADVANCE(276);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 205:
      if (lookahead == 'p') ADVANCE(279);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(280);
      END_STATE();
    case 207:
      if (lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(282);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(283);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(285);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 213:
      if (lookahead == '_') ADVANCE(287);
      if (lookahead == 'o') ADVANCE(288);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(290);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_stop);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(292);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_task);
      END_STATE();
    case 221:
      if (lookahead == 'a') ADVANCE(294);
      END_STATE();
    case 222:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 223:
      if (lookahead == '1') ADVANCE(296);
      if (lookahead == '3') ADVANCE(297);
      if (lookahead == '6') ADVANCE(298);
      if (lookahead == '8') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(300);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(301);
      END_STATE();
    case 225:
      if (lookahead == 'g') ADVANCE(302);
      END_STATE();
    case 226:
      if (lookahead == 'l') ADVANCE(303);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(304);
      END_STATE();
    case 228:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 230:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(307);
      END_STATE();
    case 232:
      if (lookahead == 'r') ADVANCE(308);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 234:
      if (lookahead == 'g') ADVANCE(310);
      END_STATE();
    case 235:
      if (lookahead == '_') ADVANCE(311);
      END_STATE();
    case 236:
      if (lookahead == 'r') ADVANCE(312);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 238:
      if (lookahead == 'c') ADVANCE(314);
      END_STATE();
    case 239:
      if (lookahead == 'c') ADVANCE(315);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(316);
      END_STATE();
    case 241:
      if (lookahead == 'e') ADVANCE(317);
      END_STATE();
    case 242:
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 243:
      if (lookahead == 'c') ADVANCE(319);
      END_STATE();
    case 244:
      if (lookahead == 'i') ADVANCE(320);
      END_STATE();
    case 245:
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 246:
      if (lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 247:
      if (lookahead == 'c') ADVANCE(323);
      END_STATE();
    case 248:
      if (lookahead == 's') ADVANCE(324);
      END_STATE();
    case 249:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 251:
      if (lookahead == 'r') ADVANCE(327);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(328);
      END_STATE();
    case 253:
      if (lookahead == 'n') ADVANCE(329);
      END_STATE();
    case 254:
      if (lookahead == 'i') ADVANCE(330);
      END_STATE();
    case 255:
      if (lookahead == 'r') ADVANCE(331);
      END_STATE();
    case 256:
      if (lookahead == 'o') ADVANCE(332);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 259:
      if (lookahead == '6') ADVANCE(333);
      END_STATE();
    case 260:
      if (lookahead == '2') ADVANCE(334);
      END_STATE();
    case 261:
      if (lookahead == '4') ADVANCE(335);
      END_STATE();
    case 262:
      if (lookahead == '_') ADVANCE(336);
      END_STATE();
    case 263:
      if (lookahead == 't') ADVANCE(337);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(338);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(339);
      END_STATE();
    case 266:
      if (lookahead == 'l') ADVANCE(340);
      END_STATE();
    case 267:
      if (lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 268:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 271:
      if (lookahead == '_') ADVANCE(344);
      END_STATE();
    case 272:
      if (lookahead == '_') ADVANCE(345);
      END_STATE();
    case 273:
      if (lookahead == '_') ADVANCE(346);
      END_STATE();
    case 274:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 275:
      if (lookahead == 'r') ADVANCE(347);
      END_STATE();
    case 276:
      if (lookahead == 'l') ADVANCE(348);
      END_STATE();
    case 277:
      if (lookahead == 'o') ADVANCE(349);
      END_STATE();
    case 278:
      if (lookahead == 'u') ADVANCE(350);
      END_STATE();
    case 279:
      if (lookahead == 't') ADVANCE(351);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(352);
      END_STATE();
    case 281:
      if (lookahead == 'f') ADVANCE(353);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(354);
      END_STATE();
    case 283:
      if (lookahead == 'i') ADVANCE(355);
      END_STATE();
    case 284:
      if (lookahead == 'n') ADVANCE(356);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(357);
      END_STATE();
    case 287:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 288:
      if (lookahead == 'f') ADVANCE(358);
      END_STATE();
    case 289:
      if (lookahead == '_') ADVANCE(359);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_start);
      END_STATE();
    case 291:
      if (lookahead == 'c') ADVANCE(360);
      END_STATE();
    case 292:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 293:
      if (lookahead == 'h') ADVANCE(362);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(363);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 296:
      if (lookahead == '6') ADVANCE(365);
      END_STATE();
    case 297:
      if (lookahead == '2') ADVANCE(366);
      END_STATE();
    case 298:
      if (lookahead == '4') ADVANCE(367);
      END_STATE();
    case 299:
      if (lookahead == '_') ADVANCE(368);
      END_STATE();
    case 300:
      if (lookahead == 't') ADVANCE(369);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 302:
      if (lookahead == 'n') ADVANCE(370);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 304:
      if (lookahead == 'i') ADVANCE(371);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 306:
      if (lookahead == 'o') ADVANCE(372);
      END_STATE();
    case 307:
      if (lookahead == 'c') ADVANCE(373);
      END_STATE();
    case 308:
      if (lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 309:
      if (lookahead == 'u') ADVANCE(375);
      END_STATE();
    case 310:
      if (lookahead == 'n') ADVANCE(376);
      END_STATE();
    case 311:
      if (lookahead == '_') ADVANCE(377);
      END_STATE();
    case 312:
      if (lookahead == 'i') ADVANCE(378);
      END_STATE();
    case 313:
      if (lookahead == 'd') ADVANCE(379);
      END_STATE();
    case 314:
      if (lookahead == 'l') ADVANCE(380);
      END_STATE();
    case 315:
      if (lookahead == 'a') ADVANCE(381);
      END_STATE();
    case 316:
      if (lookahead == 's') ADVANCE(382);
      END_STATE();
    case 317:
      if (lookahead == 'n') ADVANCE(383);
      END_STATE();
    case 318:
      if (lookahead == 'c') ADVANCE(384);
      END_STATE();
    case 319:
      if (lookahead == 'e') ADVANCE(385);
      END_STATE();
    case 320:
      if (lookahead == 'n') ADVANCE(386);
      END_STATE();
    case 321:
      if (lookahead == 'r') ADVANCE(387);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 323:
      if (lookahead == 'a') ADVANCE(388);
      END_STATE();
    case 324:
      if (lookahead == 'c') ADVANCE(389);
      END_STATE();
    case 325:
      if (lookahead == 'a') ADVANCE(390);
      END_STATE();
    case 326:
      if (lookahead == 'i') ADVANCE(391);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 328:
      if (lookahead == 'o') ADVANCE(392);
      END_STATE();
    case 329:
      if (lookahead == 'o') ADVANCE(393);
      END_STATE();
    case 330:
      if (lookahead == 'g') ADVANCE(394);
      END_STATE();
    case 331:
      if (lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 332:
      if (lookahead == 'f') ADVANCE(396);
      END_STATE();
    case 333:
      if (lookahead == '_') ADVANCE(397);
      END_STATE();
    case 334:
      if (lookahead == '_') ADVANCE(398);
      END_STATE();
    case 335:
      if (lookahead == '_') ADVANCE(399);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 337:
      if (lookahead == 'r') ADVANCE(400);
      END_STATE();
    case 338:
      if (lookahead == 'x') ADVANCE(401);
      END_STATE();
    case 339:
      if (lookahead == 'u') ADVANCE(402);
      END_STATE();
    case 340:
      if (lookahead == 't') ADVANCE(403);
      END_STATE();
    case 341:
      if (lookahead == 'd') ADVANCE(404);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 344:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 345:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 346:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 347:
      if (lookahead == '_') ADVANCE(405);
      END_STATE();
    case 348:
      if (lookahead == 'i') ADVANCE(406);
      END_STATE();
    case 349:
      if (lookahead == 'r') ADVANCE(407);
      END_STATE();
    case 350:
      if (lookahead == 'r') ADVANCE(408);
      END_STATE();
    case 351:
      if (lookahead == 'r') ADVANCE(409);
      END_STATE();
    case 352:
      if (lookahead == 'o') ADVANCE(410);
      END_STATE();
    case 353:
      if (lookahead == 'f') ADVANCE(411);
      END_STATE();
    case 354:
      if (lookahead == 'e') ADVANCE(412);
      END_STATE();
    case 355:
      if (lookahead == 'c') ADVANCE(413);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 359:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 363:
      if (lookahead == '_') ADVANCE(414);
      END_STATE();
    case 364:
      if (lookahead == 'f') ADVANCE(415);
      END_STATE();
    case 365:
      if (lookahead == '_') ADVANCE(416);
      END_STATE();
    case 366:
      if (lookahead == '_') ADVANCE(417);
      END_STATE();
    case 367:
      if (lookahead == '_') ADVANCE(418);
      END_STATE();
    case 368:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 369:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 371:
      if (lookahead == 'l') ADVANCE(421);
      END_STATE();
    case 372:
      if (lookahead == 'f') ADVANCE(422);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 374:
      if (lookahead == 'c') ADVANCE(423);
      END_STATE();
    case 375:
      if (lookahead == 'r') ADVANCE(424);
      END_STATE();
    case 376:
      if (lookahead == 'o') ADVANCE(425);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 378:
      if (lookahead == 'b') ADVANCE(426);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 381:
      if (lookahead == 'l') ADVANCE(427);
      END_STATE();
    case 382:
      if (lookahead == 'p') ADVANCE(428);
      END_STATE();
    case 383:
      if (lookahead == 's') ADVANCE(429);
      END_STATE();
    case 384:
      if (lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 385:
      if (lookahead == 'i') ADVANCE(431);
      END_STATE();
    case 386:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 387:
      if (lookahead == 'i') ADVANCE(433);
      END_STATE();
    case 388:
      if (lookahead == 'l') ADVANCE(434);
      END_STATE();
    case 389:
      if (lookahead == 'a') ADVANCE(435);
      END_STATE();
    case 390:
      if (lookahead == 'd') ADVANCE(436);
      END_STATE();
    case 391:
      if (lookahead == 'g') ADVANCE(437);
      END_STATE();
    case 392:
      if (lookahead == 'r') ADVANCE(438);
      END_STATE();
    case 393:
      if (lookahead == 'f') ADVANCE(439);
      END_STATE();
    case 394:
      if (lookahead == 'n') ADVANCE(440);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_acquire);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 398:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 399:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 400:
      if (lookahead == '_') ADVANCE(441);
      END_STATE();
    case 401:
      if (lookahead == 'p') ADVANCE(442);
      END_STATE();
    case 402:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 405:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 406:
      if (lookahead == 'g') ADVANCE(444);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_monitor);
      END_STATE();
    case 408:
      if (lookahead == 'n') ADVANCE(445);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_nullptr);
      if (lookahead == '_') ADVANCE(446);
      END_STATE();
    case 410:
      if (lookahead == 'f') ADVANCE(447);
      END_STATE();
    case 411:
      if (lookahead == '_') ADVANCE(448);
      END_STATE();
    case 412:
      if (lookahead == 'r') ADVANCE(449);
      END_STATE();
    case 413:
      if (lookahead == 't') ADVANCE(450);
      END_STATE();
    case 414:
      if (lookahead == 'l') ADVANCE(451);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 416:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 417:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 418:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 419:
      if (lookahead == '_') ADVANCE(452);
      END_STATE();
    case 420:
      if (lookahead == 'd') ADVANCE(453);
      END_STATE();
    case 421:
      if (lookahead == 'e') ADVANCE(454);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 424:
      if (lookahead == 'n') ADVANCE(455);
      END_STATE();
    case 425:
      if (lookahead == 'f') ADVANCE(456);
      END_STATE();
    case 426:
      if (lookahead == 'u') ADVANCE(457);
      END_STATE();
    case 427:
      if (lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 428:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 429:
      if (lookahead == 'i') ADVANCE(460);
      END_STATE();
    case 430:
      if (lookahead == 'l') ADVANCE(461);
      END_STATE();
    case 431:
      if (lookahead == 'n') ADVANCE(462);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(463);
      END_STATE();
    case 433:
      if (lookahead == 'c') ADVANCE(464);
      END_STATE();
    case 434:
      if (lookahead == 'l') ADVANCE(465);
      END_STATE();
    case 435:
      if (lookahead == 'l') ADVANCE(466);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 437:
      if (lookahead == 'n') ADVANCE(467);
      END_STATE();
    case 438:
      if (lookahead == 'c') ADVANCE(468);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 440:
      if (lookahead == 'e') ADVANCE(469);
      END_STATE();
    case 441:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 442:
      if (lookahead == 'r') ADVANCE(470);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 444:
      if (lookahead == 'n') ADVANCE(471);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 446:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 448:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 451:
      if (lookahead == 'o') ADVANCE(472);
      END_STATE();
    case 452:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(473);
      END_STATE();
    case 457:
      if (lookahead == 't') ADVANCE(474);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 459:
      if (lookahead == 'c') ADVANCE(475);
      END_STATE();
    case 460:
      if (lookahead == 'o') ADVANCE(476);
      END_STATE();
    case 461:
      if (lookahead == 'l') ADVANCE(477);
      END_STATE();
    case 462:
      if (lookahead == 'l') ADVANCE(478);
      END_STATE();
    case 463:
      if (lookahead == '_') ADVANCE(479);
      END_STATE();
    case 464:
      if (lookahead == 't') ADVANCE(480);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 466:
      if (lookahead == 'l') ADVANCE(481);
      END_STATE();
    case 467:
      if (lookahead == 'e') ADVANCE(482);
      END_STATE();
    case 468:
      if (lookahead == 'a') ADVANCE(483);
      END_STATE();
    case 469:
      if (lookahead == 'd') ADVANCE(484);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 471:
      if (lookahead == '_') ADVANCE(485);
      END_STATE();
    case 472:
      if (lookahead == 'c') ADVANCE(486);
      END_STATE();
    case 473:
      if (lookahead == '_') ADVANCE(487);
      END_STATE();
    case 474:
      if (lookahead == 'e') ADVANCE(488);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 476:
      if (lookahead == 'n') ADVANCE(489);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 478:
      if (lookahead == 'i') ADVANCE(490);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(491);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 482:
      if (lookahead == 'd') ADVANCE(492);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(493);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 485:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 486:
      if (lookahead == 'a') ADVANCE(494);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 488:
      if (lookahead == '_') ADVANCE(495);
      END_STATE();
    case 489:
      if (lookahead == '_') ADVANCE(496);
      END_STATE();
    case 490:
      if (lookahead == 'n') ADVANCE(497);
      END_STATE();
    case 491:
      if (lookahead == '_') ADVANCE(498);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 493:
      if (lookahead == 'l') ADVANCE(499);
      END_STATE();
    case 494:
      if (lookahead == 'l') ADVANCE(500);
      END_STATE();
    case 495:
      if (lookahead == '_') ADVANCE(501);
      END_STATE();
    case 496:
      if (lookahead == '_') ADVANCE(502);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(503);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 110},
  [2] = {.lex_state = 42},
  [3] = {.lex_state = 42},
  [4] = {.lex_state = 42},
  [5] = {.lex_state = 42},
  [6] = {.lex_state = 42},
  [7] = {.lex_state = 42},
  [8] = {.lex_state = 42},
  [9] = {.lex_state = 42},
  [10] = {.lex_state = 42},
  [11] = {.lex_state = 42},
  [12] = {.lex_state = 45},
  [13] = {.lex_state = 45},
  [14] = {.lex_state = 45},
  [15] = {.lex_state = 45},
  [16] = {.lex_state = 45},
  [17] = {.lex_state = 45},
  [18] = {.lex_state = 45},
  [19] = {.lex_state = 45},
  [20] = {.lex_state = 42},
  [21] = {.lex_state = 45},
  [22] = {.lex_state = 45},
  [23] = {.lex_state = 45},
  [24] = {.lex_state = 45},
  [25] = {.lex_state = 45},
  [26] = {.lex_state = 45},
  [27] = {.lex_state = 45},
  [28] = {.lex_state = 110},
  [29] = {.lex_state = 110},
  [30] = {.lex_state = 110},
  [31] = {.lex_state = 110},
  [32] = {.lex_state = 110},
  [33] = {.lex_state = 110},
  [34] = {.lex_state = 44},
  [35] = {.lex_state = 110},
  [36] = {.lex_state = 110},
  [37] = {.lex_state = 110},
  [38] = {.lex_state = 110},
  [39] = {.lex_state = 110},
  [40] = {.lex_state = 110},
  [41] = {.lex_state = 110},
  [42] = {.lex_state = 44},
  [43] = {.lex_state = 110},
  [44] = {.lex_state = 110},
  [45] = {.lex_state = 110},
  [46] = {.lex_state = 110},
  [47] = {.lex_state = 110},
  [48] = {.lex_state = 110},
  [49] = {.lex_state = 110},
  [50] = {.lex_state = 110},
  [51] = {.lex_state = 44},
  [52] = {.lex_state = 110},
  [53] = {.lex_state = 110},
  [54] = {.lex_state = 42},
  [55] = {.lex_state = 42},
  [56] = {.lex_state = 42},
  [57] = {.lex_state = 42},
  [58] = {.lex_state = 42},
  [59] = {.lex_state = 45},
  [60] = {.lex_state = 45},
  [61] = {.lex_state = 45},
  [62] = {.lex_state = 45},
  [63] = {.lex_state = 45},
  [64] = {.lex_state = 110},
  [65] = {.lex_state = 110},
  [66] = {.lex_state = 110},
  [67] = {.lex_state = 110},
  [68] = {.lex_state = 110},
  [69] = {.lex_state = 44},
  [70] = {.lex_state = 44},
  [71] = {.lex_state = 110},
  [72] = {.lex_state = 110},
  [73] = {.lex_state = 110},
  [74] = {.lex_state = 110},
  [75] = {.lex_state = 110},
  [76] = {.lex_state = 44},
  [77] = {.lex_state = 44},
  [78] = {.lex_state = 44},
  [79] = {.lex_state = 110},
  [80] = {.lex_state = 110},
  [81] = {.lex_state = 110},
  [82] = {.lex_state = 110},
  [83] = {.lex_state = 110},
  [84] = {.lex_state = 110},
  [85] = {.lex_state = 110},
  [86] = {.lex_state = 110},
  [87] = {.lex_state = 110},
  [88] = {.lex_state = 110},
  [89] = {.lex_state = 110},
  [90] = {.lex_state = 42},
  [91] = {.lex_state = 42},
  [92] = {.lex_state = 42},
  [93] = {.lex_state = 42},
  [94] = {.lex_state = 42},
  [95] = {.lex_state = 42},
  [96] = {.lex_state = 42},
  [97] = {.lex_state = 42},
  [98] = {.lex_state = 42},
  [99] = {.lex_state = 42},
  [100] = {.lex_state = 42},
  [101] = {.lex_state = 42},
  [102] = {.lex_state = 42},
  [103] = {.lex_state = 42},
  [104] = {.lex_state = 42},
  [105] = {.lex_state = 42},
  [106] = {.lex_state = 42},
  [107] = {.lex_state = 45},
  [108] = {.lex_state = 42},
  [109] = {.lex_state = 45},
  [110] = {.lex_state = 42},
  [111] = {.lex_state = 42},
  [112] = {.lex_state = 42},
  [113] = {.lex_state = 42},
  [114] = {.lex_state = 42},
  [115] = {.lex_state = 42},
  [116] = {.lex_state = 42},
  [117] = {.lex_state = 42},
  [118] = {.lex_state = 42},
  [119] = {.lex_state = 42},
  [120] = {.lex_state = 42},
  [121] = {.lex_state = 42},
  [122] = {.lex_state = 42},
  [123] = {.lex_state = 42},
  [124] = {.lex_state = 42},
  [125] = {.lex_state = 42},
  [126] = {.lex_state = 42},
  [127] = {.lex_state = 42},
  [128] = {.lex_state = 42},
  [129] = {.lex_state = 42},
  [130] = {.lex_state = 42},
  [131] = {.lex_state = 42},
  [132] = {.lex_state = 42},
  [133] = {.lex_state = 42},
  [134] = {.lex_state = 42},
  [135] = {.lex_state = 42},
  [136] = {.lex_state = 42},
  [137] = {.lex_state = 42},
  [138] = {.lex_state = 42},
  [139] = {.lex_state = 45},
  [140] = {.lex_state = 42},
  [141] = {.lex_state = 42},
  [142] = {.lex_state = 42},
  [143] = {.lex_state = 42},
  [144] = {.lex_state = 110},
  [145] = {.lex_state = 45},
  [146] = {.lex_state = 45},
  [147] = {.lex_state = 110},
  [148] = {.lex_state = 110},
  [149] = {.lex_state = 110},
  [150] = {.lex_state = 110},
  [151] = {.lex_state = 42},
  [152] = {.lex_state = 45},
  [153] = {.lex_state = 45},
  [154] = {.lex_state = 45},
  [155] = {.lex_state = 45},
  [156] = {.lex_state = 110},
  [157] = {.lex_state = 45},
  [158] = {.lex_state = 45},
  [159] = {.lex_state = 45},
  [160] = {.lex_state = 45},
  [161] = {.lex_state = 45},
  [162] = {.lex_state = 45},
  [163] = {.lex_state = 44},
  [164] = {.lex_state = 45},
  [165] = {.lex_state = 45},
  [166] = {.lex_state = 42},
  [167] = {.lex_state = 42},
  [168] = {.lex_state = 42},
  [169] = {.lex_state = 42},
  [170] = {.lex_state = 45},
  [171] = {.lex_state = 110},
  [172] = {.lex_state = 42},
  [173] = {.lex_state = 45},
  [174] = {.lex_state = 45},
  [175] = {.lex_state = 45},
  [176] = {.lex_state = 45},
  [177] = {.lex_state = 45},
  [178] = {.lex_state = 42},
  [179] = {.lex_state = 45},
  [180] = {.lex_state = 45},
  [181] = {.lex_state = 42},
  [182] = {.lex_state = 42},
  [183] = {.lex_state = 45},
  [184] = {.lex_state = 45},
  [185] = {.lex_state = 42},
  [186] = {.lex_state = 44},
  [187] = {.lex_state = 45},
  [188] = {.lex_state = 45},
  [189] = {.lex_state = 42},
  [190] = {.lex_state = 42},
  [191] = {.lex_state = 44},
  [192] = {.lex_state = 45},
  [193] = {.lex_state = 45},
  [194] = {.lex_state = 110},
  [195] = {.lex_state = 45},
  [196] = {.lex_state = 45},
  [197] = {.lex_state = 45},
  [198] = {.lex_state = 42},
  [199] = {.lex_state = 45},
  [200] = {.lex_state = 45},
  [201] = {.lex_state = 45},
  [202] = {.lex_state = 45},
  [203] = {.lex_state = 45},
  [204] = {.lex_state = 110},
  [205] = {.lex_state = 42},
  [206] = {.lex_state = 42},
  [207] = {.lex_state = 42},
  [208] = {.lex_state = 45},
  [209] = {.lex_state = 42},
  [210] = {.lex_state = 45},
  [211] = {.lex_state = 45},
  [212] = {.lex_state = 42},
  [213] = {.lex_state = 45},
  [214] = {.lex_state = 45},
  [215] = {.lex_state = 45},
  [216] = {.lex_state = 45},
  [217] = {.lex_state = 45},
  [218] = {.lex_state = 110},
  [219] = {.lex_state = 45},
  [220] = {.lex_state = 42},
  [221] = {.lex_state = 45},
  [222] = {.lex_state = 42},
  [223] = {.lex_state = 42},
  [224] = {.lex_state = 42},
  [225] = {.lex_state = 45},
  [226] = {.lex_state = 42},
  [227] = {.lex_state = 42},
  [228] = {.lex_state = 42},
  [229] = {.lex_state = 45},
  [230] = {.lex_state = 42},
  [231] = {.lex_state = 110},
  [232] = {.lex_state = 110},
  [233] = {.lex_state = 110},
  [234] = {.lex_state = 110},
  [235] = {.lex_state = 110},
  [236] = {.lex_state = 110},
  [237] = {.lex_state = 110},
  [238] = {.lex_state = 110},
  [239] = {.lex_state = 110},
  [240] = {.lex_state = 110},
  [241] = {.lex_state = 110},
  [242] = {.lex_state = 110},
  [243] = {.lex_state = 110},
  [244] = {.lex_state = 110},
  [245] = {.lex_state = 110},
  [246] = {.lex_state = 110},
  [247] = {.lex_state = 110},
  [248] = {.lex_state = 110},
  [249] = {.lex_state = 110},
  [250] = {.lex_state = 110},
  [251] = {.lex_state = 110},
  [252] = {.lex_state = 110},
  [253] = {.lex_state = 110},
  [254] = {.lex_state = 110},
  [255] = {.lex_state = 110},
  [256] = {.lex_state = 110},
  [257] = {.lex_state = 110},
  [258] = {.lex_state = 44},
  [259] = {.lex_state = 110},
  [260] = {.lex_state = 110},
  [261] = {.lex_state = 110},
  [262] = {.lex_state = 44},
  [263] = {.lex_state = 110},
  [264] = {.lex_state = 110},
  [265] = {.lex_state = 110},
  [266] = {.lex_state = 110},
  [267] = {.lex_state = 110},
  [268] = {.lex_state = 110},
  [269] = {.lex_state = 110},
  [270] = {.lex_state = 110},
  [271] = {.lex_state = 110},
  [272] = {.lex_state = 110},
  [273] = {.lex_state = 110},
  [274] = {.lex_state = 110},
  [275] = {.lex_state = 110},
  [276] = {.lex_state = 110},
  [277] = {.lex_state = 110},
  [278] = {.lex_state = 110},
  [279] = {.lex_state = 110},
  [280] = {.lex_state = 44},
  [281] = {.lex_state = 44},
  [282] = {.lex_state = 44},
  [283] = {.lex_state = 110},
  [284] = {.lex_state = 110},
  [285] = {.lex_state = 44},
  [286] = {.lex_state = 44},
  [287] = {.lex_state = 44},
  [288] = {.lex_state = 44},
  [289] = {.lex_state = 110},
  [290] = {.lex_state = 44},
  [291] = {.lex_state = 110},
  [292] = {.lex_state = 44},
  [293] = {.lex_state = 110},
  [294] = {.lex_state = 110},
  [295] = {.lex_state = 110},
  [296] = {.lex_state = 110},
  [297] = {.lex_state = 110},
  [298] = {.lex_state = 45},
  [299] = {.lex_state = 44},
  [300] = {.lex_state = 44},
  [301] = {.lex_state = 44},
  [302] = {.lex_state = 110},
  [303] = {.lex_state = 44},
  [304] = {.lex_state = 110},
  [305] = {.lex_state = 44},
  [306] = {.lex_state = 44},
  [307] = {.lex_state = 44},
  [308] = {.lex_state = 110},
  [309] = {.lex_state = 45},
  [310] = {.lex_state = 44},
  [311] = {.lex_state = 44},
  [312] = {.lex_state = 44},
  [313] = {.lex_state = 110},
  [314] = {.lex_state = 44},
  [315] = {.lex_state = 45},
  [316] = {.lex_state = 44},
  [317] = {.lex_state = 44},
  [318] = {.lex_state = 110},
  [319] = {.lex_state = 110},
  [320] = {.lex_state = 44},
  [321] = {.lex_state = 44},
  [322] = {.lex_state = 110},
  [323] = {.lex_state = 110},
  [324] = {.lex_state = 110},
  [325] = {.lex_state = 44},
  [326] = {.lex_state = 110},
  [327] = {.lex_state = 110},
  [328] = {.lex_state = 110},
  [329] = {.lex_state = 110},
  [330] = {.lex_state = 110},
  [331] = {.lex_state = 110},
  [332] = {.lex_state = 110},
  [333] = {.lex_state = 44},
  [334] = {.lex_state = 110},
  [335] = {.lex_state = 110},
  [336] = {.lex_state = 45},
  [337] = {.lex_state = 110},
  [338] = {.lex_state = 44},
  [339] = {.lex_state = 110},
  [340] = {.lex_state = 110},
  [341] = {.lex_state = 110},
  [342] = {.lex_state = 110},
  [343] = {.lex_state = 110},
  [344] = {.lex_state = 110},
  [345] = {.lex_state = 110},
  [346] = {.lex_state = 110},
  [347] = {.lex_state = 110},
  [348] = {.lex_state = 110},
  [349] = {.lex_state = 110},
  [350] = {.lex_state = 110},
  [351] = {.lex_state = 110},
  [352] = {.lex_state = 44},
  [353] = {.lex_state = 110},
  [354] = {.lex_state = 110},
  [355] = {.lex_state = 110},
  [356] = {.lex_state = 45},
  [357] = {.lex_state = 110},
  [358] = {.lex_state = 110},
  [359] = {.lex_state = 44},
  [360] = {.lex_state = 45},
  [361] = {.lex_state = 110},
  [362] = {.lex_state = 110},
  [363] = {.lex_state = 110},
  [364] = {.lex_state = 110},
  [365] = {.lex_state = 45},
  [366] = {.lex_state = 110},
  [367] = {.lex_state = 110},
  [368] = {.lex_state = 110},
  [369] = {.lex_state = 110},
  [370] = {.lex_state = 45},
  [371] = {.lex_state = 44},
  [372] = {.lex_state = 45},
  [373] = {.lex_state = 110},
  [374] = {.lex_state = 44},
  [375] = {.lex_state = 110},
  [376] = {.lex_state = 45},
  [377] = {.lex_state = 44},
  [378] = {.lex_state = 45},
  [379] = {.lex_state = 110},
  [380] = {.lex_state = 45},
  [381] = {.lex_state = 45},
  [382] = {.lex_state = 45},
  [383] = {.lex_state = 110},
  [384] = {.lex_state = 110},
  [385] = {.lex_state = 110},
  [386] = {.lex_state = 45},
  [387] = {.lex_state = 110},
  [388] = {.lex_state = 44},
  [389] = {.lex_state = 110},
  [390] = {.lex_state = 110},
  [391] = {.lex_state = 110},
  [392] = {.lex_state = 110},
  [393] = {.lex_state = 110},
  [394] = {.lex_state = 45},
  [395] = {.lex_state = 110},
  [396] = {.lex_state = 110},
  [397] = {.lex_state = 110},
  [398] = {.lex_state = 110},
  [399] = {.lex_state = 110},
  [400] = {.lex_state = 110},
  [401] = {.lex_state = 45},
  [402] = {.lex_state = 45},
  [403] = {.lex_state = 110},
  [404] = {.lex_state = 44},
  [405] = {.lex_state = 110},
  [406] = {.lex_state = 45},
  [407] = {.lex_state = 44},
  [408] = {.lex_state = 45},
  [409] = {.lex_state = 44},
  [410] = {.lex_state = 110},
  [411] = {.lex_state = 110},
  [412] = {.lex_state = 110},
  [413] = {.lex_state = 110},
  [414] = {.lex_state = 110},
  [415] = {.lex_state = 110},
  [416] = {.lex_state = 110},
  [417] = {.lex_state = 110},
  [418] = {.lex_state = 110},
  [419] = {.lex_state = 45},
  [420] = {.lex_state = 110},
  [421] = {.lex_state = 110},
  [422] = {.lex_state = 45},
  [423] = {.lex_state = 110},
  [424] = {.lex_state = 110},
  [425] = {.lex_state = 110},
  [426] = {.lex_state = 110},
  [427] = {.lex_state = 110},
  [428] = {.lex_state = 110},
  [429] = {.lex_state = 110},
  [430] = {.lex_state = 44},
  [431] = {.lex_state = 110},
  [432] = {.lex_state = 110},
  [433] = {.lex_state = 110},
  [434] = {.lex_state = 110},
  [435] = {.lex_state = 44},
  [436] = {.lex_state = 44},
  [437] = {.lex_state = 110},
  [438] = {.lex_state = 44},
  [439] = {.lex_state = 110},
  [440] = {.lex_state = 110},
  [441] = {.lex_state = 110},
  [442] = {.lex_state = 44},
  [443] = {.lex_state = 44},
  [444] = {.lex_state = 110},
  [445] = {.lex_state = 45},
  [446] = {.lex_state = 44},
  [447] = {.lex_state = 44},
  [448] = {.lex_state = 44},
  [449] = {.lex_state = 110},
  [450] = {.lex_state = 44},
  [451] = {.lex_state = 45},
  [452] = {.lex_state = 45},
  [453] = {.lex_state = 110},
  [454] = {.lex_state = 110},
  [455] = {.lex_state = 110},
  [456] = {.lex_state = 110},
  [457] = {.lex_state = 110},
  [458] = {.lex_state = 110},
  [459] = {.lex_state = 45},
  [460] = {.lex_state = 110},
  [461] = {.lex_state = 110},
  [462] = {.lex_state = 110},
  [463] = {.lex_state = 110},
  [464] = {.lex_state = 44},
  [465] = {.lex_state = 44},
  [466] = {.lex_state = 110},
  [467] = {.lex_state = 44},
  [468] = {.lex_state = 110},
  [469] = {.lex_state = 110},
  [470] = {.lex_state = 110},
  [471] = {.lex_state = 44},
  [472] = {.lex_state = 44},
  [473] = {.lex_state = 110},
  [474] = {.lex_state = 110},
  [475] = {.lex_state = 110},
  [476] = {.lex_state = 110},
  [477] = {.lex_state = 110},
  [478] = {.lex_state = 110},
  [479] = {.lex_state = 44},
  [480] = {.lex_state = 44},
  [481] = {.lex_state = 110},
  [482] = {.lex_state = 110},
  [483] = {.lex_state = 110},
  [484] = {.lex_state = 110},
  [485] = {.lex_state = 44},
  [486] = {.lex_state = 110},
  [487] = {.lex_state = 110},
  [488] = {.lex_state = 110},
  [489] = {.lex_state = 110},
  [490] = {.lex_state = 110},
  [491] = {.lex_state = 110},
  [492] = {.lex_state = 110},
  [493] = {.lex_state = 44},
  [494] = {.lex_state = 44},
  [495] = {.lex_state = 44},
  [496] = {.lex_state = 110},
  [497] = {.lex_state = 44},
  [498] = {.lex_state = 44},
  [499] = {.lex_state = 44},
  [500] = {.lex_state = 110},
  [501] = {.lex_state = 110},
  [502] = {.lex_state = 110},
  [503] = {.lex_state = 110},
  [504] = {.lex_state = 110},
  [505] = {.lex_state = 44},
  [506] = {.lex_state = 44},
  [507] = {.lex_state = 44},
  [508] = {.lex_state = 110},
  [509] = {.lex_state = 44},
  [510] = {.lex_state = 110},
  [511] = {.lex_state = 110},
  [512] = {.lex_state = 110},
  [513] = {.lex_state = 110},
  [514] = {.lex_state = 110},
  [515] = {.lex_state = 44},
  [516] = {.lex_state = 110},
  [517] = {.lex_state = 110},
  [518] = {.lex_state = 110},
  [519] = {.lex_state = 110},
  [520] = {.lex_state = 110},
  [521] = {.lex_state = 110},
  [522] = {.lex_state = 110},
  [523] = {.lex_state = 110},
  [524] = {.lex_state = 44},
  [525] = {.lex_state = 110},
  [526] = {.lex_state = 110},
  [527] = {.lex_state = 110},
  [528] = {.lex_state = 110},
  [529] = {.lex_state = 110},
  [530] = {.lex_state = 44},
  [531] = {.lex_state = 110},
  [532] = {.lex_state = 44},
  [533] = {.lex_state = 110},
  [534] = {.lex_state = 110},
  [535] = {.lex_state = 44},
  [536] = {.lex_state = 44},
  [537] = {.lex_state = 44},
  [538] = {.lex_state = 110},
  [539] = {.lex_state = 110},
  [540] = {.lex_state = 44},
  [541] = {.lex_state = 110},
  [542] = {.lex_state = 41},
  [543] = {.lex_state = 41},
  [544] = {.lex_state = 110},
  [545] = {.lex_state = 110},
  [546] = {.lex_state = 110},
  [547] = {.lex_state = 110},
  [548] = {.lex_state = 110},
  [549] = {.lex_state = 110},
  [550] = {.lex_state = 110},
  [551] = {.lex_state = 110},
  [552] = {.lex_state = 110},
  [553] = {.lex_state = 110},
  [554] = {.lex_state = 110},
  [555] = {.lex_state = 41},
  [556] = {.lex_state = 110},
  [557] = {.lex_state = 41},
  [558] = {.lex_state = 110},
  [559] = {.lex_state = 110},
  [560] = {.lex_state = 110},
  [561] = {.lex_state = 110},
  [562] = {.lex_state = 110},
  [563] = {.lex_state = 110},
  [564] = {.lex_state = 110},
  [565] = {.lex_state = 110},
  [566] = {.lex_state = 110},
  [567] = {.lex_state = 110},
  [568] = {.lex_state = 47},
  [569] = {.lex_state = 47},
  [570] = {.lex_state = 47},
  [571] = {.lex_state = 47},
  [572] = {.lex_state = 47},
  [573] = {.lex_state = 47},
  [574] = {.lex_state = 47},
  [575] = {.lex_state = 47},
  [576] = {.lex_state = 47},
  [577] = {.lex_state = 47},
  [578] = {.lex_state = 47},
  [579] = {.lex_state = 47},
  [580] = {.lex_state = 110},
  [581] = {.lex_state = 49},
  [582] = {.lex_state = 49},
  [583] = {.lex_state = 49},
  [584] = {.lex_state = 49},
  [585] = {.lex_state = 110},
  [586] = {.lex_state = 49},
  [587] = {.lex_state = 49},
  [588] = {.lex_state = 49},
  [589] = {.lex_state = 49},
  [590] = {.lex_state = 110},
  [591] = {.lex_state = 49},
  [592] = {.lex_state = 110},
  [593] = {.lex_state = 50},
  [594] = {.lex_state = 50},
  [595] = {.lex_state = 50},
  [596] = {.lex_state = 50},
  [597] = {.lex_state = 50},
  [598] = {.lex_state = 50},
  [599] = {.lex_state = 49},
  [600] = {.lex_state = 50},
  [601] = {.lex_state = 50},
  [602] = {.lex_state = 50},
  [603] = {.lex_state = 50},
  [604] = {.lex_state = 110},
  [605] = {.lex_state = 50},
  [606] = {.lex_state = 110},
  [607] = {.lex_state = 110},
  [608] = {.lex_state = 110},
  [609] = {.lex_state = 110},
  [610] = {.lex_state = 110},
  [611] = {.lex_state = 48},
  [612] = {.lex_state = 110},
  [613] = {.lex_state = 110},
  [614] = {.lex_state = 110},
  [615] = {.lex_state = 53},
  [616] = {.lex_state = 110},
  [617] = {.lex_state = 53},
  [618] = {.lex_state = 110},
  [619] = {.lex_state = 110},
  [620] = {.lex_state = 110},
  [621] = {.lex_state = 110},
  [622] = {.lex_state = 110},
  [623] = {.lex_state = 110},
  [624] = {.lex_state = 110},
  [625] = {.lex_state = 110},
  [626] = {.lex_state = 110},
  [627] = {.lex_state = 53},
  [628] = {.lex_state = 110},
  [629] = {.lex_state = 48},
  [630] = {.lex_state = 110},
  [631] = {.lex_state = 110},
  [632] = {.lex_state = 110},
  [633] = {.lex_state = 48},
  [634] = {.lex_state = 110},
  [635] = {.lex_state = 110},
  [636] = {.lex_state = 110},
  [637] = {.lex_state = 110},
  [638] = {.lex_state = 110},
  [639] = {.lex_state = 110},
  [640] = {.lex_state = 110},
  [641] = {.lex_state = 110},
  [642] = {.lex_state = 110},
  [643] = {.lex_state = 110},
  [644] = {.lex_state = 110},
  [645] = {.lex_state = 110},
  [646] = {.lex_state = 49},
  [647] = {.lex_state = 110},
  [648] = {.lex_state = 110},
  [649] = {.lex_state = 110},
  [650] = {.lex_state = 110},
  [651] = {.lex_state = 110},
  [652] = {.lex_state = 110},
  [653] = {.lex_state = 110},
  [654] = {.lex_state = 110},
  [655] = {.lex_state = 110},
  [656] = {.lex_state = 110},
  [657] = {.lex_state = 110},
  [658] = {.lex_state = 110},
  [659] = {.lex_state = 110},
  [660] = {.lex_state = 110},
  [661] = {.lex_state = 110},
  [662] = {.lex_state = 110},
  [663] = {.lex_state = 110},
  [664] = {.lex_state = 110},
  [665] = {.lex_state = 110},
  [666] = {.lex_state = 110},
  [667] = {.lex_state = 110},
  [668] = {.lex_state = 110},
  [669] = {.lex_state = 110},
  [670] = {.lex_state = 110},
  [671] = {.lex_state = 110},
  [672] = {.lex_state = 110},
  [673] = {.lex_state = 110},
  [674] = {.lex_state = 110},
  [675] = {.lex_state = 110},
  [676] = {.lex_state = 110},
  [677] = {.lex_state = 110},
  [678] = {.lex_state = 110},
  [679] = {.lex_state = 110},
  [680] = {.lex_state = 110},
  [681] = {.lex_state = 110},
  [682] = {.lex_state = 110},
  [683] = {.lex_state = 110},
  [684] = {.lex_state = 110},
  [685] = {.lex_state = 110},
  [686] = {.lex_state = 110},
  [687] = {.lex_state = 110},
  [688] = {.lex_state = 110},
  [689] = {.lex_state = 110},
  [690] = {.lex_state = 110},
  [691] = {.lex_state = 110},
  [692] = {.lex_state = 110},
  [693] = {.lex_state = 110},
  [694] = {.lex_state = 110},
  [695] = {.lex_state = 110},
  [696] = {.lex_state = 110},
  [697] = {.lex_state = 110},
  [698] = {.lex_state = 110},
  [699] = {.lex_state = 110},
  [700] = {.lex_state = 110},
  [701] = {.lex_state = 110},
  [702] = {.lex_state = 110},
  [703] = {.lex_state = 110},
  [704] = {.lex_state = 110},
  [705] = {.lex_state = 110},
  [706] = {.lex_state = 110},
  [707] = {.lex_state = 110},
  [708] = {.lex_state = 110},
  [709] = {.lex_state = 110},
  [710] = {.lex_state = 110},
  [711] = {.lex_state = 110},
  [712] = {.lex_state = 110},
  [713] = {.lex_state = 110},
  [714] = {.lex_state = 110},
  [715] = {.lex_state = 110},
  [716] = {.lex_state = 110},
  [717] = {.lex_state = 110},
  [718] = {.lex_state = 110},
  [719] = {.lex_state = 110},
  [720] = {.lex_state = 110},
  [721] = {.lex_state = 110},
  [722] = {.lex_state = 110},
  [723] = {.lex_state = 110},
  [724] = {.lex_state = 110},
  [725] = {.lex_state = 110},
  [726] = {.lex_state = 110},
  [727] = {.lex_state = 110},
  [728] = {.lex_state = 110},
  [729] = {.lex_state = 110},
  [730] = {.lex_state = 110},
  [731] = {.lex_state = 110},
  [732] = {.lex_state = 110},
  [733] = {.lex_state = 110},
  [734] = {.lex_state = 110},
  [735] = {.lex_state = 110},
  [736] = {.lex_state = 110},
  [737] = {.lex_state = 110},
  [738] = {.lex_state = 110},
  [739] = {.lex_state = 49},
  [740] = {.lex_state = 49},
  [741] = {.lex_state = 49},
  [742] = {.lex_state = 49},
  [743] = {.lex_state = 49},
  [744] = {.lex_state = 110},
  [745] = {.lex_state = 110},
  [746] = {.lex_state = 110},
  [747] = {.lex_state = 47},
  [748] = {.lex_state = 47},
  [749] = {.lex_state = 47},
  [750] = {.lex_state = 47},
  [751] = {.lex_state = 49},
  [752] = {.lex_state = 49},
  [753] = {.lex_state = 49},
  [754] = {.lex_state = 49},
  [755] = {.lex_state = 49},
  [756] = {.lex_state = 49},
  [757] = {.lex_state = 49},
  [758] = {.lex_state = 49},
  [759] = {.lex_state = 49},
  [760] = {.lex_state = 49},
  [761] = {.lex_state = 49},
  [762] = {.lex_state = 49},
  [763] = {.lex_state = 49},
  [764] = {.lex_state = 49},
  [765] = {.lex_state = 49},
  [766] = {.lex_state = 49},
  [767] = {.lex_state = 49},
  [768] = {.lex_state = 49},
  [769] = {.lex_state = 49},
  [770] = {.lex_state = 49},
  [771] = {.lex_state = 49},
  [772] = {.lex_state = 49},
  [773] = {.lex_state = 47},
  [774] = {.lex_state = 47},
  [775] = {.lex_state = 49},
  [776] = {.lex_state = 47},
  [777] = {.lex_state = 49},
  [778] = {.lex_state = 49},
  [779] = {.lex_state = 47},
  [780] = {.lex_state = 47},
  [781] = {.lex_state = 50},
  [782] = {.lex_state = 50},
  [783] = {.lex_state = 50},
  [784] = {.lex_state = 50},
  [785] = {.lex_state = 50},
  [786] = {.lex_state = 50},
  [787] = {.lex_state = 50},
  [788] = {.lex_state = 110},
  [789] = {.lex_state = 50},
  [790] = {.lex_state = 50},
  [791] = {.lex_state = 50},
  [792] = {.lex_state = 49},
  [793] = {.lex_state = 49},
  [794] = {.lex_state = 49},
  [795] = {.lex_state = 49},
  [796] = {.lex_state = 49},
  [797] = {.lex_state = 49},
  [798] = {.lex_state = 49},
  [799] = {.lex_state = 49},
  [800] = {.lex_state = 49},
  [801] = {.lex_state = 49},
  [802] = {.lex_state = 49},
  [803] = {.lex_state = 49},
  [804] = {.lex_state = 47},
  [805] = {.lex_state = 47},
  [806] = {.lex_state = 47},
  [807] = {.lex_state = 47},
  [808] = {.lex_state = 110},
  [809] = {.lex_state = 47},
  [810] = {.lex_state = 47},
  [811] = {.lex_state = 50},
  [812] = {.lex_state = 50},
  [813] = {.lex_state = 50},
  [814] = {.lex_state = 50},
  [815] = {.lex_state = 50},
  [816] = {.lex_state = 50},
  [817] = {.lex_state = 49},
  [818] = {.lex_state = 48},
  [819] = {.lex_state = 50},
  [820] = {.lex_state = 50},
  [821] = {.lex_state = 50},
  [822] = {.lex_state = 50},
  [823] = {.lex_state = 50},
  [824] = {.lex_state = 50},
  [825] = {.lex_state = 48},
  [826] = {.lex_state = 50},
  [827] = {.lex_state = 50},
  [828] = {.lex_state = 50},
  [829] = {.lex_state = 50},
  [830] = {.lex_state = 50},
  [831] = {.lex_state = 50},
  [832] = {.lex_state = 48},
  [833] = {.lex_state = 50},
  [834] = {.lex_state = 50},
  [835] = {.lex_state = 47},
  [836] = {.lex_state = 50},
  [837] = {.lex_state = 50},
  [838] = {.lex_state = 50},
  [839] = {.lex_state = 50},
  [840] = {.lex_state = 50},
  [841] = {.lex_state = 50},
  [842] = {.lex_state = 50},
  [843] = {.lex_state = 50},
  [844] = {.lex_state = 50},
  [845] = {.lex_state = 50},
  [846] = {.lex_state = 50},
  [847] = {.lex_state = 50},
  [848] = {.lex_state = 50},
  [849] = {.lex_state = 50},
  [850] = {.lex_state = 48},
  [851] = {.lex_state = 50},
  [852] = {.lex_state = 50},
  [853] = {.lex_state = 49},
  [854] = {.lex_state = 49},
  [855] = {.lex_state = 49},
  [856] = {.lex_state = 49},
  [857] = {.lex_state = 49},
  [858] = {.lex_state = 49},
  [859] = {.lex_state = 49},
  [860] = {.lex_state = 49},
  [861] = {.lex_state = 49},
  [862] = {.lex_state = 49},
  [863] = {.lex_state = 49},
  [864] = {.lex_state = 49},
  [865] = {.lex_state = 49},
  [866] = {.lex_state = 49},
  [867] = {.lex_state = 49},
  [868] = {.lex_state = 49},
  [869] = {.lex_state = 49},
  [870] = {.lex_state = 49},
  [871] = {.lex_state = 49},
  [872] = {.lex_state = 50},
  [873] = {.lex_state = 49},
  [874] = {.lex_state = 50},
  [875] = {.lex_state = 50},
  [876] = {.lex_state = 50},
  [877] = {.lex_state = 49},
  [878] = {.lex_state = 50},
  [879] = {.lex_state = 49},
  [880] = {.lex_state = 50},
  [881] = {.lex_state = 50},
  [882] = {.lex_state = 50},
  [883] = {.lex_state = 49},
  [884] = {.lex_state = 50},
  [885] = {.lex_state = 49},
  [886] = {.lex_state = 50},
  [887] = {.lex_state = 50},
  [888] = {.lex_state = 50},
  [889] = {.lex_state = 50},
  [890] = {.lex_state = 49},
  [891] = {.lex_state = 49},
  [892] = {.lex_state = 50},
  [893] = {.lex_state = 50},
  [894] = {.lex_state = 50},
  [895] = {.lex_state = 50},
  [896] = {.lex_state = 49},
  [897] = {.lex_state = 50},
  [898] = {.lex_state = 49},
  [899] = {.lex_state = 47},
  [900] = {.lex_state = 47},
  [901] = {.lex_state = 47},
  [902] = {.lex_state = 47},
  [903] = {.lex_state = 47},
  [904] = {.lex_state = 47},
  [905] = {.lex_state = 47},
  [906] = {.lex_state = 47},
  [907] = {.lex_state = 47},
  [908] = {.lex_state = 47},
  [909] = {.lex_state = 49},
  [910] = {.lex_state = 49},
  [911] = {.lex_state = 47},
  [912] = {.lex_state = 49},
  [913] = {.lex_state = 47},
  [914] = {.lex_state = 47},
  [915] = {.lex_state = 47},
  [916] = {.lex_state = 49},
  [917] = {.lex_state = 47},
  [918] = {.lex_state = 47},
  [919] = {.lex_state = 47},
  [920] = {.lex_state = 49},
  [921] = {.lex_state = 47},
  [922] = {.lex_state = 47},
  [923] = {.lex_state = 49},
  [924] = {.lex_state = 49},
  [925] = {.lex_state = 48},
  [926] = {.lex_state = 48},
  [927] = {.lex_state = 48},
  [928] = {.lex_state = 47},
  [929] = {.lex_state = 48},
  [930] = {.lex_state = 47},
  [931] = {.lex_state = 47},
  [932] = {.lex_state = 48},
  [933] = {.lex_state = 49},
  [934] = {.lex_state = 49},
  [935] = {.lex_state = 48},
  [936] = {.lex_state = 47},
  [937] = {.lex_state = 48},
  [938] = {.lex_state = 47},
  [939] = {.lex_state = 48},
  [940] = {.lex_state = 48},
  [941] = {.lex_state = 53},
  [942] = {.lex_state = 53},
  [943] = {.lex_state = 49},
  [944] = {.lex_state = 49},
  [945] = {.lex_state = 53},
  [946] = {.lex_state = 48},
  [947] = {.lex_state = 49},
  [948] = {.lex_state = 48},
  [949] = {.lex_state = 48},
  [950] = {.lex_state = 47},
  [951] = {.lex_state = 49},
  [952] = {.lex_state = 53},
  [953] = {.lex_state = 48},
  [954] = {.lex_state = 48},
  [955] = {.lex_state = 53},
  [956] = {.lex_state = 48},
  [957] = {.lex_state = 53},
  [958] = {.lex_state = 48},
  [959] = {.lex_state = 49},
  [960] = {.lex_state = 53},
  [961] = {.lex_state = 53},
  [962] = {.lex_state = 53},
  [963] = {.lex_state = 53},
  [964] = {.lex_state = 53},
  [965] = {.lex_state = 53},
  [966] = {.lex_state = 49},
  [967] = {.lex_state = 47},
  [968] = {.lex_state = 53},
  [969] = {.lex_state = 47},
  [970] = {.lex_state = 53},
  [971] = {.lex_state = 49},
  [972] = {.lex_state = 53},
  [973] = {.lex_state = 53},
  [974] = {.lex_state = 53},
  [975] = {.lex_state = 48},
  [976] = {.lex_state = 49},
  [977] = {.lex_state = 47},
  [978] = {.lex_state = 48},
  [979] = {.lex_state = 49},
  [980] = {.lex_state = 49},
  [981] = {.lex_state = 49},
  [982] = {.lex_state = 53},
  [983] = {.lex_state = 49},
  [984] = {.lex_state = 49},
  [985] = {.lex_state = 49},
  [986] = {.lex_state = 49},
  [987] = {.lex_state = 49},
  [988] = {.lex_state = 49},
  [989] = {.lex_state = 49},
  [990] = {.lex_state = 49},
  [991] = {.lex_state = 49},
  [992] = {.lex_state = 49},
  [993] = {.lex_state = 49},
  [994] = {.lex_state = 49},
  [995] = {.lex_state = 110},
  [996] = {.lex_state = 49},
  [997] = {.lex_state = 49},
  [998] = {.lex_state = 49},
  [999] = {.lex_state = 49},
  [1000] = {.lex_state = 49},
  [1001] = {.lex_state = 49},
  [1002] = {.lex_state = 49},
  [1003] = {.lex_state = 49},
  [1004] = {.lex_state = 49},
  [1005] = {.lex_state = 49},
  [1006] = {.lex_state = 49},
  [1007] = {.lex_state = 49},
  [1008] = {.lex_state = 49},
  [1009] = {.lex_state = 49},
  [1010] = {.lex_state = 49},
  [1011] = {.lex_state = 49},
  [1012] = {.lex_state = 49},
  [1013] = {.lex_state = 49},
  [1014] = {.lex_state = 49},
  [1015] = {.lex_state = 49},
  [1016] = {.lex_state = 49},
  [1017] = {.lex_state = 49},
  [1018] = {.lex_state = 49},
  [1019] = {.lex_state = 49},
  [1020] = {.lex_state = 49},
  [1021] = {.lex_state = 49},
  [1022] = {.lex_state = 49},
  [1023] = {.lex_state = 49},
  [1024] = {.lex_state = 49},
  [1025] = {.lex_state = 49},
  [1026] = {.lex_state = 49},
  [1027] = {.lex_state = 50},
  [1028] = {.lex_state = 49},
  [1029] = {.lex_state = 49},
  [1030] = {.lex_state = 49},
  [1031] = {.lex_state = 49},
  [1032] = {.lex_state = 50},
  [1033] = {.lex_state = 50},
  [1034] = {.lex_state = 49},
  [1035] = {.lex_state = 50},
  [1036] = {.lex_state = 49},
  [1037] = {.lex_state = 50},
  [1038] = {.lex_state = 49},
  [1039] = {.lex_state = 50},
  [1040] = {.lex_state = 50},
  [1041] = {.lex_state = 50},
  [1042] = {.lex_state = 50},
  [1043] = {.lex_state = 50},
  [1044] = {.lex_state = 49},
  [1045] = {.lex_state = 50},
  [1046] = {.lex_state = 49},
  [1047] = {.lex_state = 50},
  [1048] = {.lex_state = 50},
  [1049] = {.lex_state = 49},
  [1050] = {.lex_state = 49},
  [1051] = {.lex_state = 49},
  [1052] = {.lex_state = 49},
  [1053] = {.lex_state = 49},
  [1054] = {.lex_state = 49},
  [1055] = {.lex_state = 49},
  [1056] = {.lex_state = 49},
  [1057] = {.lex_state = 49},
  [1058] = {.lex_state = 49},
  [1059] = {.lex_state = 49},
  [1060] = {.lex_state = 49},
  [1061] = {.lex_state = 49},
  [1062] = {.lex_state = 49},
  [1063] = {.lex_state = 47},
  [1064] = {.lex_state = 47},
  [1065] = {.lex_state = 47},
  [1066] = {.lex_state = 47},
  [1067] = {.lex_state = 47},
  [1068] = {.lex_state = 47},
  [1069] = {.lex_state = 47},
  [1070] = {.lex_state = 49},
  [1071] = {.lex_state = 49},
  [1072] = {.lex_state = 50},
  [1073] = {.lex_state = 47},
  [1074] = {.lex_state = 47},
  [1075] = {.lex_state = 49},
  [1076] = {.lex_state = 47},
  [1077] = {.lex_state = 49},
  [1078] = {.lex_state = 49},
  [1079] = {.lex_state = 49},
  [1080] = {.lex_state = 49},
  [1081] = {.lex_state = 49},
  [1082] = {.lex_state = 47},
  [1083] = {.lex_state = 47},
  [1084] = {.lex_state = 49},
  [1085] = {.lex_state = 49},
  [1086] = {.lex_state = 49},
  [1087] = {.lex_state = 47},
  [1088] = {.lex_state = 47},
  [1089] = {.lex_state = 47},
  [1090] = {.lex_state = 49},
  [1091] = {.lex_state = 47},
  [1092] = {.lex_state = 47},
  [1093] = {.lex_state = 47},
  [1094] = {.lex_state = 47},
  [1095] = {.lex_state = 47},
  [1096] = {.lex_state = 47},
  [1097] = {.lex_state = 47},
  [1098] = {.lex_state = 49},
  [1099] = {.lex_state = 47},
  [1100] = {.lex_state = 47},
  [1101] = {.lex_state = 47},
  [1102] = {.lex_state = 47},
  [1103] = {.lex_state = 47},
  [1104] = {.lex_state = 49},
  [1105] = {.lex_state = 47},
  [1106] = {.lex_state = 47},
  [1107] = {.lex_state = 47},
  [1108] = {.lex_state = 49},
  [1109] = {.lex_state = 47},
  [1110] = {.lex_state = 49},
  [1111] = {.lex_state = 47},
  [1112] = {.lex_state = 47},
  [1113] = {.lex_state = 47},
  [1114] = {.lex_state = 49},
  [1115] = {.lex_state = 47},
  [1116] = {.lex_state = 47},
  [1117] = {.lex_state = 47},
  [1118] = {.lex_state = 47},
  [1119] = {.lex_state = 47},
  [1120] = {.lex_state = 47},
  [1121] = {.lex_state = 47},
  [1122] = {.lex_state = 47},
  [1123] = {.lex_state = 47},
  [1124] = {.lex_state = 47},
  [1125] = {.lex_state = 47},
  [1126] = {.lex_state = 47},
  [1127] = {.lex_state = 47},
  [1128] = {.lex_state = 47},
  [1129] = {.lex_state = 47},
  [1130] = {.lex_state = 47},
  [1131] = {.lex_state = 49},
  [1132] = {.lex_state = 47},
  [1133] = {.lex_state = 47},
  [1134] = {.lex_state = 47},
  [1135] = {.lex_state = 47},
  [1136] = {.lex_state = 47},
  [1137] = {.lex_state = 47},
  [1138] = {.lex_state = 49},
  [1139] = {.lex_state = 47},
  [1140] = {.lex_state = 47},
  [1141] = {.lex_state = 47},
  [1142] = {.lex_state = 47},
  [1143] = {.lex_state = 47},
  [1144] = {.lex_state = 47},
  [1145] = {.lex_state = 47},
  [1146] = {.lex_state = 49},
  [1147] = {.lex_state = 47},
  [1148] = {.lex_state = 47},
  [1149] = {.lex_state = 47},
  [1150] = {.lex_state = 49},
  [1151] = {.lex_state = 47},
  [1152] = {.lex_state = 47},
  [1153] = {.lex_state = 47},
  [1154] = {.lex_state = 47},
  [1155] = {.lex_state = 47},
  [1156] = {.lex_state = 47},
  [1157] = {.lex_state = 47},
  [1158] = {.lex_state = 49},
  [1159] = {.lex_state = 47},
  [1160] = {.lex_state = 49},
  [1161] = {.lex_state = 47},
  [1162] = {.lex_state = 47},
  [1163] = {.lex_state = 47},
  [1164] = {.lex_state = 47},
  [1165] = {.lex_state = 47},
  [1166] = {.lex_state = 49},
  [1167] = {.lex_state = 49},
  [1168] = {.lex_state = 47},
  [1169] = {.lex_state = 47},
  [1170] = {.lex_state = 49},
  [1171] = {.lex_state = 49},
  [1172] = {.lex_state = 49},
  [1173] = {.lex_state = 49},
  [1174] = {.lex_state = 49},
  [1175] = {.lex_state = 49},
  [1176] = {.lex_state = 49},
  [1177] = {.lex_state = 49},
  [1178] = {.lex_state = 49},
  [1179] = {.lex_state = 49},
  [1180] = {.lex_state = 49},
  [1181] = {.lex_state = 49},
  [1182] = {.lex_state = 49},
  [1183] = {.lex_state = 49},
  [1184] = {.lex_state = 49},
  [1185] = {.lex_state = 49},
  [1186] = {.lex_state = 49},
  [1187] = {.lex_state = 49},
  [1188] = {.lex_state = 49},
  [1189] = {.lex_state = 49},
  [1190] = {.lex_state = 49},
  [1191] = {.lex_state = 49},
  [1192] = {.lex_state = 49},
  [1193] = {.lex_state = 49},
  [1194] = {.lex_state = 46},
  [1195] = {.lex_state = 23},
  [1196] = {.lex_state = 46},
  [1197] = {.lex_state = 46},
  [1198] = {.lex_state = 49},
  [1199] = {.lex_state = 46},
  [1200] = {.lex_state = 49},
  [1201] = {.lex_state = 49},
  [1202] = {.lex_state = 49},
  [1203] = {.lex_state = 49},
  [1204] = {.lex_state = 49},
  [1205] = {.lex_state = 49},
  [1206] = {.lex_state = 46},
  [1207] = {.lex_state = 46},
  [1208] = {.lex_state = 49},
  [1209] = {.lex_state = 49},
  [1210] = {.lex_state = 49},
  [1211] = {.lex_state = 49},
  [1212] = {.lex_state = 49},
  [1213] = {.lex_state = 49},
  [1214] = {.lex_state = 49},
  [1215] = {.lex_state = 49},
  [1216] = {.lex_state = 49},
  [1217] = {.lex_state = 49},
  [1218] = {.lex_state = 49},
  [1219] = {.lex_state = 49},
  [1220] = {.lex_state = 49},
  [1221] = {.lex_state = 46},
  [1222] = {.lex_state = 49},
  [1223] = {.lex_state = 46},
  [1224] = {.lex_state = 46},
  [1225] = {.lex_state = 46},
  [1226] = {.lex_state = 46},
  [1227] = {.lex_state = 46},
  [1228] = {.lex_state = 46},
  [1229] = {.lex_state = 46},
  [1230] = {.lex_state = 46},
  [1231] = {.lex_state = 46},
  [1232] = {.lex_state = 46},
  [1233] = {.lex_state = 49},
  [1234] = {.lex_state = 49},
  [1235] = {.lex_state = 46},
  [1236] = {.lex_state = 46},
  [1237] = {.lex_state = 46},
  [1238] = {.lex_state = 46},
  [1239] = {.lex_state = 46},
  [1240] = {.lex_state = 46},
  [1241] = {.lex_state = 46},
  [1242] = {.lex_state = 46},
  [1243] = {.lex_state = 46},
  [1244] = {.lex_state = 46},
  [1245] = {.lex_state = 46},
  [1246] = {.lex_state = 46},
  [1247] = {.lex_state = 46},
  [1248] = {.lex_state = 46},
  [1249] = {.lex_state = 46},
  [1250] = {.lex_state = 46},
  [1251] = {.lex_state = 46},
  [1252] = {.lex_state = 46},
  [1253] = {.lex_state = 49},
  [1254] = {.lex_state = 46},
  [1255] = {.lex_state = 46},
  [1256] = {.lex_state = 49},
  [1257] = {.lex_state = 46},
  [1258] = {.lex_state = 46},
  [1259] = {.lex_state = 23},
  [1260] = {.lex_state = 23},
  [1261] = {.lex_state = 23},
  [1262] = {.lex_state = 23},
  [1263] = {.lex_state = 23},
  [1264] = {.lex_state = 23},
  [1265] = {.lex_state = 23},
  [1266] = {.lex_state = 23},
  [1267] = {.lex_state = 23},
  [1268] = {.lex_state = 23},
  [1269] = {.lex_state = 23},
  [1270] = {.lex_state = 23},
  [1271] = {.lex_state = 49},
  [1272] = {.lex_state = 23},
  [1273] = {.lex_state = 23},
  [1274] = {.lex_state = 23},
  [1275] = {.lex_state = 23},
  [1276] = {.lex_state = 23},
  [1277] = {.lex_state = 23},
  [1278] = {.lex_state = 23},
  [1279] = {.lex_state = 23},
  [1280] = {.lex_state = 23},
  [1281] = {.lex_state = 23},
  [1282] = {.lex_state = 23},
  [1283] = {.lex_state = 23},
  [1284] = {.lex_state = 23},
  [1285] = {.lex_state = 23},
  [1286] = {.lex_state = 49},
  [1287] = {.lex_state = 49},
  [1288] = {.lex_state = 23},
  [1289] = {.lex_state = 23},
  [1290] = {.lex_state = 23},
  [1291] = {.lex_state = 23},
  [1292] = {.lex_state = 49},
  [1293] = {.lex_state = 49},
  [1294] = {.lex_state = 49},
  [1295] = {.lex_state = 49},
  [1296] = {.lex_state = 49},
  [1297] = {.lex_state = 49},
  [1298] = {.lex_state = 49},
  [1299] = {.lex_state = 49},
  [1300] = {.lex_state = 49},
  [1301] = {.lex_state = 49},
  [1302] = {.lex_state = 49},
  [1303] = {.lex_state = 49},
  [1304] = {.lex_state = 49},
  [1305] = {.lex_state = 49},
  [1306] = {.lex_state = 49},
  [1307] = {.lex_state = 49},
  [1308] = {.lex_state = 49},
  [1309] = {.lex_state = 49},
  [1310] = {.lex_state = 49},
  [1311] = {.lex_state = 49},
  [1312] = {.lex_state = 49},
  [1313] = {.lex_state = 49},
  [1314] = {.lex_state = 49},
  [1315] = {.lex_state = 49},
  [1316] = {.lex_state = 49},
  [1317] = {.lex_state = 49},
  [1318] = {.lex_state = 49},
  [1319] = {.lex_state = 49},
  [1320] = {.lex_state = 49},
  [1321] = {.lex_state = 49},
  [1322] = {.lex_state = 49},
  [1323] = {.lex_state = 49},
  [1324] = {.lex_state = 49},
  [1325] = {.lex_state = 49},
  [1326] = {.lex_state = 49},
  [1327] = {.lex_state = 49},
  [1328] = {.lex_state = 49},
  [1329] = {.lex_state = 49},
  [1330] = {.lex_state = 49},
  [1331] = {.lex_state = 49},
  [1332] = {.lex_state = 49},
  [1333] = {.lex_state = 49},
  [1334] = {.lex_state = 49},
  [1335] = {.lex_state = 49},
  [1336] = {.lex_state = 49},
  [1337] = {.lex_state = 49},
  [1338] = {.lex_state = 49},
  [1339] = {.lex_state = 49},
  [1340] = {.lex_state = 49},
  [1341] = {.lex_state = 49},
  [1342] = {.lex_state = 49},
  [1343] = {.lex_state = 49},
  [1344] = {.lex_state = 49},
  [1345] = {.lex_state = 49},
  [1346] = {.lex_state = 49},
  [1347] = {.lex_state = 49},
  [1348] = {.lex_state = 49},
  [1349] = {.lex_state = 49},
  [1350] = {.lex_state = 49},
  [1351] = {.lex_state = 49},
  [1352] = {.lex_state = 49},
  [1353] = {.lex_state = 49},
  [1354] = {.lex_state = 49},
  [1355] = {.lex_state = 49},
  [1356] = {.lex_state = 49},
  [1357] = {.lex_state = 49},
  [1358] = {.lex_state = 49},
  [1359] = {.lex_state = 49},
  [1360] = {.lex_state = 49},
  [1361] = {.lex_state = 49},
  [1362] = {.lex_state = 49},
  [1363] = {.lex_state = 49},
  [1364] = {.lex_state = 49},
  [1365] = {.lex_state = 49},
  [1366] = {.lex_state = 49},
  [1367] = {.lex_state = 49},
  [1368] = {.lex_state = 49},
  [1369] = {.lex_state = 49},
  [1370] = {.lex_state = 49},
  [1371] = {.lex_state = 49},
  [1372] = {.lex_state = 49},
  [1373] = {.lex_state = 49},
  [1374] = {.lex_state = 49},
  [1375] = {.lex_state = 49},
  [1376] = {.lex_state = 49},
  [1377] = {.lex_state = 49},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 49},
  [1381] = {.lex_state = 49},
  [1382] = {.lex_state = 49},
  [1383] = {.lex_state = 49},
  [1384] = {.lex_state = 49},
  [1385] = {.lex_state = 49},
  [1386] = {.lex_state = 110},
  [1387] = {.lex_state = 110},
  [1388] = {.lex_state = 49},
  [1389] = {.lex_state = 51},
  [1390] = {.lex_state = 51},
  [1391] = {.lex_state = 51},
  [1392] = {.lex_state = 110},
  [1393] = {.lex_state = 51},
  [1394] = {.lex_state = 49},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 51},
  [1397] = {.lex_state = 110},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 110},
  [1400] = {.lex_state = 49},
  [1401] = {.lex_state = 49},
  [1402] = {.lex_state = 110},
  [1403] = {.lex_state = 49},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 47},
  [1406] = {.lex_state = 0},
  [1407] = {.lex_state = 110},
  [1408] = {.lex_state = 49},
  [1409] = {.lex_state = 49},
  [1410] = {.lex_state = 49},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 49},
  [1413] = {.lex_state = 110},
  [1414] = {.lex_state = 110},
  [1415] = {.lex_state = 49},
  [1416] = {.lex_state = 110},
  [1417] = {.lex_state = 110},
  [1418] = {.lex_state = 47},
  [1419] = {.lex_state = 49},
  [1420] = {.lex_state = 49},
  [1421] = {.lex_state = 49},
  [1422] = {.lex_state = 110},
  [1423] = {.lex_state = 49},
  [1424] = {.lex_state = 49},
  [1425] = {.lex_state = 49},
  [1426] = {.lex_state = 49},
  [1427] = {.lex_state = 110},
  [1428] = {.lex_state = 49},
  [1429] = {.lex_state = 49},
  [1430] = {.lex_state = 49},
  [1431] = {.lex_state = 110},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 110},
  [1434] = {.lex_state = 110},
  [1435] = {.lex_state = 110},
  [1436] = {.lex_state = 110},
  [1437] = {.lex_state = 49},
  [1438] = {.lex_state = 110},
  [1439] = {.lex_state = 49},
  [1440] = {.lex_state = 110},
  [1441] = {.lex_state = 110},
  [1442] = {.lex_state = 110},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 0},
  [1445] = {.lex_state = 49},
  [1446] = {.lex_state = 0},
  [1447] = {.lex_state = 110},
  [1448] = {.lex_state = 42},
  [1449] = {.lex_state = 110},
  [1450] = {.lex_state = 49},
  [1451] = {.lex_state = 110},
  [1452] = {.lex_state = 110},
  [1453] = {.lex_state = 110},
  [1454] = {.lex_state = 110},
  [1455] = {.lex_state = 110},
  [1456] = {.lex_state = 49},
  [1457] = {.lex_state = 110},
  [1458] = {.lex_state = 110},
  [1459] = {.lex_state = 110},
  [1460] = {.lex_state = 110},
  [1461] = {.lex_state = 110},
  [1462] = {.lex_state = 110},
  [1463] = {.lex_state = 49},
  [1464] = {.lex_state = 49},
  [1465] = {.lex_state = 49},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 49},
  [1468] = {.lex_state = 49},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 26},
  [1471] = {.lex_state = 26},
  [1472] = {.lex_state = 26},
  [1473] = {.lex_state = 26},
  [1474] = {.lex_state = 49},
  [1475] = {.lex_state = 49},
  [1476] = {.lex_state = 49},
  [1477] = {.lex_state = 49},
  [1478] = {.lex_state = 49},
  [1479] = {.lex_state = 49},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 49},
  [1482] = {.lex_state = 26},
  [1483] = {.lex_state = 31},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 0},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 49},
  [1488] = {.lex_state = 110},
  [1489] = {.lex_state = 49},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 49},
  [1492] = {.lex_state = 26},
  [1493] = {.lex_state = 49},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 49},
  [1496] = {.lex_state = 49},
  [1497] = {.lex_state = 49},
  [1498] = {.lex_state = 49},
  [1499] = {.lex_state = 49},
  [1500] = {.lex_state = 26},
  [1501] = {.lex_state = 49},
  [1502] = {.lex_state = 31},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 31},
  [1505] = {.lex_state = 49},
  [1506] = {.lex_state = 31},
  [1507] = {.lex_state = 31},
  [1508] = {.lex_state = 49},
  [1509] = {.lex_state = 49},
  [1510] = {.lex_state = 49},
  [1511] = {.lex_state = 49},
  [1512] = {.lex_state = 31},
  [1513] = {.lex_state = 26},
  [1514] = {.lex_state = 31},
  [1515] = {.lex_state = 49},
  [1516] = {.lex_state = 26},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 42},
  [1519] = {.lex_state = 0},
  [1520] = {.lex_state = 0},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 0},
  [1523] = {.lex_state = 42},
  [1524] = {.lex_state = 28},
  [1525] = {.lex_state = 28},
  [1526] = {.lex_state = 42},
  [1527] = {.lex_state = 49},
  [1528] = {.lex_state = 42},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 0},
  [1531] = {.lex_state = 0},
  [1532] = {.lex_state = 28},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 49},
  [1536] = {.lex_state = 49},
  [1537] = {.lex_state = 49},
  [1538] = {.lex_state = 110},
  [1539] = {.lex_state = 49},
  [1540] = {.lex_state = 49},
  [1541] = {.lex_state = 0},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 28},
  [1544] = {.lex_state = 49},
  [1545] = {.lex_state = 49},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 0},
  [1548] = {.lex_state = 49},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 0},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 49},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 49},
  [1557] = {.lex_state = 110},
  [1558] = {.lex_state = 0},
  [1559] = {.lex_state = 42},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 42},
  [1562] = {.lex_state = 42},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 42},
  [1567] = {.lex_state = 110},
  [1568] = {.lex_state = 110},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 0},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 49},
  [1579] = {.lex_state = 0},
  [1580] = {.lex_state = 0},
  [1581] = {.lex_state = 0},
  [1582] = {.lex_state = 110},
  [1583] = {.lex_state = 0},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 0},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 110},
  [1588] = {.lex_state = 49},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 0},
  [1591] = {.lex_state = 110},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 0},
  [1594] = {.lex_state = 0},
  [1595] = {.lex_state = 49},
  [1596] = {.lex_state = 0},
  [1597] = {.lex_state = 28},
  [1598] = {.lex_state = 0},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 0},
  [1603] = {.lex_state = 0},
  [1604] = {.lex_state = 49},
  [1605] = {.lex_state = 110},
  [1606] = {.lex_state = 27},
  [1607] = {.lex_state = 27},
  [1608] = {.lex_state = 49},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 110},
  [1611] = {.lex_state = 110},
  [1612] = {.lex_state = 110},
  [1613] = {.lex_state = 110},
  [1614] = {.lex_state = 27},
  [1615] = {.lex_state = 35},
  [1616] = {.lex_state = 110},
  [1617] = {.lex_state = 110},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 110},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 27},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 49},
  [1624] = {.lex_state = 49},
  [1625] = {.lex_state = 0},
  [1626] = {.lex_state = 0},
  [1627] = {.lex_state = 0},
  [1628] = {.lex_state = 110},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 110},
  [1631] = {.lex_state = 110},
  [1632] = {.lex_state = 49},
  [1633] = {.lex_state = 110},
  [1634] = {.lex_state = 27},
  [1635] = {.lex_state = 0},
  [1636] = {.lex_state = 27},
  [1637] = {.lex_state = 0},
  [1638] = {.lex_state = 110},
  [1639] = {.lex_state = 110},
  [1640] = {.lex_state = 110},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 110},
  [1643] = {.lex_state = 110},
  [1644] = {.lex_state = 110},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 27},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 110},
  [1649] = {.lex_state = 110},
  [1650] = {.lex_state = 110},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 27},
  [1653] = {.lex_state = 110},
  [1654] = {.lex_state = 110},
  [1655] = {.lex_state = 110},
  [1656] = {.lex_state = 0},
  [1657] = {.lex_state = 110},
  [1658] = {.lex_state = 110},
  [1659] = {.lex_state = 110},
  [1660] = {.lex_state = 35},
  [1661] = {.lex_state = 110},
  [1662] = {.lex_state = 110},
  [1663] = {.lex_state = 110},
  [1664] = {.lex_state = 49},
  [1665] = {.lex_state = 49},
  [1666] = {.lex_state = 0},
  [1667] = {.lex_state = 110},
  [1668] = {.lex_state = 110},
  [1669] = {.lex_state = 0},
  [1670] = {.lex_state = 27},
  [1671] = {.lex_state = 110},
  [1672] = {.lex_state = 0},
  [1673] = {.lex_state = 110},
  [1674] = {.lex_state = 27},
  [1675] = {.lex_state = 0},
  [1676] = {.lex_state = 27},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 42},
  [1679] = {.lex_state = 110},
  [1680] = {.lex_state = 110},
  [1681] = {.lex_state = 27},
  [1682] = {.lex_state = 35},
  [1683] = {.lex_state = 110},
  [1684] = {.lex_state = 49},
  [1685] = {.lex_state = 110},
  [1686] = {.lex_state = 110},
  [1687] = {.lex_state = 42},
  [1688] = {.lex_state = 49},
  [1689] = {.lex_state = 27},
  [1690] = {.lex_state = 27},
  [1691] = {.lex_state = 27},
  [1692] = {.lex_state = 27},
  [1693] = {.lex_state = 0},
  [1694] = {.lex_state = 27},
  [1695] = {.lex_state = 27},
  [1696] = {.lex_state = 110},
  [1697] = {.lex_state = 27},
  [1698] = {.lex_state = 110},
  [1699] = {.lex_state = 0},
  [1700] = {.lex_state = 110},
  [1701] = {.lex_state = 49},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 27},
  [1704] = {.lex_state = 42},
  [1705] = {.lex_state = 27},
  [1706] = {.lex_state = 0},
  [1707] = {.lex_state = 110},
  [1708] = {.lex_state = 0},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 0},
  [1711] = {.lex_state = 0},
  [1712] = {.lex_state = 28},
  [1713] = {.lex_state = 41},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 0},
  [1716] = {.lex_state = 0},
  [1717] = {.lex_state = 0},
  [1718] = {.lex_state = 28},
  [1719] = {.lex_state = 41},
  [1720] = {.lex_state = 41},
  [1721] = {.lex_state = 0},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 0},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 0},
  [1727] = {.lex_state = 41},
  [1728] = {.lex_state = 0},
  [1729] = {.lex_state = 49},
  [1730] = {.lex_state = 0},
  [1731] = {.lex_state = 49},
  [1732] = {.lex_state = 28},
  [1733] = {.lex_state = 0},
  [1734] = {.lex_state = 28},
  [1735] = {.lex_state = 41},
  [1736] = {.lex_state = 28},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 41},
  [1739] = {.lex_state = 28},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 28},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 28},
  [1744] = {.lex_state = 41},
  [1745] = {.lex_state = 41},
  [1746] = {.lex_state = 28},
  [1747] = {.lex_state = 28},
  [1748] = {.lex_state = 49},
  [1749] = {.lex_state = 28},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 41},
  [1752] = {.lex_state = 28},
  [1753] = {.lex_state = 28},
  [1754] = {.lex_state = 49},
  [1755] = {.lex_state = 28},
  [1756] = {.lex_state = 28},
  [1757] = {.lex_state = 49},
  [1758] = {.lex_state = 49},
  [1759] = {.lex_state = 0},
  [1760] = {.lex_state = 41},
  [1761] = {.lex_state = 49},
  [1762] = {.lex_state = 28},
  [1763] = {.lex_state = 28},
  [1764] = {.lex_state = 28},
  [1765] = {.lex_state = 28},
  [1766] = {.lex_state = 49},
  [1767] = {.lex_state = 49},
  [1768] = {.lex_state = 41},
  [1769] = {.lex_state = 0},
  [1770] = {.lex_state = 49},
  [1771] = {.lex_state = 49},
  [1772] = {.lex_state = 41},
  [1773] = {.lex_state = 0},
  [1774] = {.lex_state = 0},
  [1775] = {.lex_state = 41},
  [1776] = {.lex_state = 41},
  [1777] = {.lex_state = 0},
  [1778] = {.lex_state = 28},
  [1779] = {.lex_state = 41},
  [1780] = {.lex_state = 49},
  [1781] = {.lex_state = 0},
  [1782] = {.lex_state = 49},
  [1783] = {.lex_state = 0},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 49},
  [1786] = {.lex_state = 0},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 41},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 28},
  [1791] = {.lex_state = 41},
  [1792] = {.lex_state = 0},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 0},
  [1795] = {.lex_state = 49},
  [1796] = {.lex_state = 49},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 0},
  [1799] = {.lex_state = 49},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 0},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 41},
  [1804] = {.lex_state = 28},
  [1805] = {.lex_state = 0},
  [1806] = {.lex_state = 0},
  [1807] = {.lex_state = 0},
  [1808] = {.lex_state = 28},
  [1809] = {.lex_state = 49},
  [1810] = {.lex_state = 41},
  [1811] = {.lex_state = 0},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 0},
  [1814] = {.lex_state = 0},
  [1815] = {.lex_state = 41},
  [1816] = {.lex_state = 0},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 41},
  [1819] = {.lex_state = 110},
  [1820] = {.lex_state = 0},
  [1821] = {.lex_state = 0},
  [1822] = {.lex_state = 0},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 28},
  [1825] = {.lex_state = 0},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 28},
  [1828] = {.lex_state = 49},
  [1829] = {.lex_state = 49},
  [1830] = {.lex_state = 0},
  [1831] = {.lex_state = 49},
  [1832] = {.lex_state = 0},
  [1833] = {.lex_state = 0},
  [1834] = {.lex_state = 0},
  [1835] = {.lex_state = 0},
  [1836] = {.lex_state = 0},
  [1837] = {.lex_state = 49},
  [1838] = {.lex_state = 41},
  [1839] = {.lex_state = 49},
  [1840] = {.lex_state = 0},
  [1841] = {.lex_state = 0},
  [1842] = {.lex_state = 0},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 0},
  [1845] = {.lex_state = 0},
  [1846] = {.lex_state = 28},
  [1847] = {.lex_state = 0},
  [1848] = {.lex_state = 28},
  [1849] = {.lex_state = 41},
  [1850] = {.lex_state = 49},
  [1851] = {.lex_state = 0},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 41},
  [1856] = {.lex_state = 41},
  [1857] = {.lex_state = 28},
  [1858] = {.lex_state = 49},
  [1859] = {.lex_state = 49},
  [1860] = {.lex_state = 0},
  [1861] = {.lex_state = 28},
  [1862] = {.lex_state = 28},
  [1863] = {.lex_state = 49},
  [1864] = {.lex_state = 41},
  [1865] = {.lex_state = 49},
  [1866] = {.lex_state = 41},
  [1867] = {.lex_state = 41},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 0},
  [1870] = {.lex_state = 49},
  [1871] = {.lex_state = 41},
  [1872] = {.lex_state = 41},
  [1873] = {.lex_state = 41},
  [1874] = {.lex_state = 49},
  [1875] = {.lex_state = 49},
  [1876] = {.lex_state = 0},
  [1877] = {.lex_state = 0},
  [1878] = {.lex_state = 28},
  [1879] = {.lex_state = 41},
  [1880] = {.lex_state = 41},
  [1881] = {.lex_state = 0},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 49},
  [1884] = {.lex_state = 49},
  [1885] = {.lex_state = 41},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 49},
  [1889] = {.lex_state = 0},
  [1890] = {.lex_state = 49},
  [1891] = {.lex_state = 49},
  [1892] = {.lex_state = 110},
  [1893] = {.lex_state = 41},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 41},
  [1897] = {.lex_state = 41},
  [1898] = {.lex_state = 49},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 49},
  [1901] = {.lex_state = 49},
  [1902] = {.lex_state = 49},
  [1903] = {.lex_state = 41},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 28},
  [1906] = {.lex_state = 41},
  [1907] = {.lex_state = 110},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 41},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 0},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 0},
  [1914] = {.lex_state = 28},
  [1915] = {.lex_state = 49},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 0},
  [1918] = {.lex_state = 49},
  [1919] = {.lex_state = 49},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 0},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 41},
  [1924] = {.lex_state = 28},
  [1925] = {.lex_state = 110},
  [1926] = {.lex_state = 49},
  [1927] = {.lex_state = 110},
  [1928] = {.lex_state = 49},
  [1929] = {.lex_state = 0},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 41},
  [1932] = {.lex_state = 110},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 110},
  [1935] = {.lex_state = 110},
  [1936] = {.lex_state = 49},
  [1937] = {.lex_state = 49},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 49},
  [1941] = {.lex_state = 110},
  [1942] = {.lex_state = 110},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 28},
  [1946] = {.lex_state = 49},
  [1947] = {.lex_state = 28},
  [1948] = {.lex_state = 49},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 49},
  [1951] = {.lex_state = 110},
  [1952] = {.lex_state = 110},
  [1953] = {.lex_state = 49},
  [1954] = {.lex_state = 110},
  [1955] = {.lex_state = 110},
  [1956] = {.lex_state = 28},
  [1957] = {.lex_state = 49},
  [1958] = {.lex_state = 110},
  [1959] = {.lex_state = 28},
  [1960] = {.lex_state = 49},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_auto] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_acquire] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_monitor] = ACTIONS(1),
    [anon_sym_start] = ACTIONS(1),
    [anon_sym_stop] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(1917),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym__old_style_function_definition] = STATE(486),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1319),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(801),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1021),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym__top_level_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym__expression] = STATE(1168),
    [sym__expression_not_binary] = STATE(1169),
    [sym_conditional_expression] = STATE(1169),
    [sym_assignment_expression] = STATE(1169),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(1169),
    [sym_cast_expression] = STATE(1169),
    [sym_sizeof_expression] = STATE(1169),
    [sym_alignof_expression] = STATE(1169),
    [sym_offsetof_expression] = STATE(1169),
    [sym_generic_expression] = STATE(1169),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(1169),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(1169),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(1169),
    [sym_concatenated_string] = STATE(1169),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(1169),
    [sym__empty_declaration] = STATE(33),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_task_definition] = STATE(33),
    [sym_until_statement] = STATE(33),
    [sym_acquire_statement] = STATE(33),
    [sym_monitor_statement] = STATE(33),
    [sym_start_statement] = STATE(33),
    [sym_stop_statement] = STATE(33),
    [aux_sym_translation_unit_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(31),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(91),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [2] = {
    [sym_preproc_include] = STATE(7),
    [sym_preproc_def] = STATE(7),
    [sym_preproc_function_def] = STATE(7),
    [sym_preproc_call] = STATE(7),
    [sym_preproc_if] = STATE(7),
    [sym_preproc_ifdef] = STATE(7),
    [sym_preproc_else] = STATE(1713),
    [sym_preproc_elif] = STATE(1713),
    [sym_preproc_elifdef] = STATE(1713),
    [sym_function_definition] = STATE(7),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(7),
    [sym_type_definition] = STATE(7),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(7),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(7),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_case_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_goto_statement] = STATE(7),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(7),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(7),
    [sym_acquire_statement] = STATE(7),
    [sym_monitor_statement] = STATE(7),
    [sym_start_statement] = STATE(7),
    [sym_stop_statement] = STATE(7),
    [aux_sym_preproc_if_repeat1] = STATE(7),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(121),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [3] = {
    [sym_preproc_include] = STATE(5),
    [sym_preproc_def] = STATE(5),
    [sym_preproc_function_def] = STATE(5),
    [sym_preproc_call] = STATE(5),
    [sym_preproc_if] = STATE(5),
    [sym_preproc_ifdef] = STATE(5),
    [sym_preproc_else] = STATE(1849),
    [sym_preproc_elif] = STATE(1849),
    [sym_preproc_elifdef] = STATE(1849),
    [sym_function_definition] = STATE(5),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(5),
    [sym_type_definition] = STATE(5),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(5),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(5),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(5),
    [sym_labeled_statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_switch_statement] = STATE(5),
    [sym_case_statement] = STATE(5),
    [sym_while_statement] = STATE(5),
    [sym_do_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_break_statement] = STATE(5),
    [sym_continue_statement] = STATE(5),
    [sym_goto_statement] = STATE(5),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(5),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(5),
    [sym_acquire_statement] = STATE(5),
    [sym_monitor_statement] = STATE(5),
    [sym_start_statement] = STATE(5),
    [sym_stop_statement] = STATE(5),
    [aux_sym_preproc_if_repeat1] = STATE(5),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [4] = {
    [sym_preproc_include] = STATE(9),
    [sym_preproc_def] = STATE(9),
    [sym_preproc_function_def] = STATE(9),
    [sym_preproc_call] = STATE(9),
    [sym_preproc_if] = STATE(9),
    [sym_preproc_ifdef] = STATE(9),
    [sym_preproc_else] = STATE(1788),
    [sym_preproc_elif] = STATE(1788),
    [sym_preproc_elifdef] = STATE(1788),
    [sym_function_definition] = STATE(9),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(9),
    [sym_type_definition] = STATE(9),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(9),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(9),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_case_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_goto_statement] = STATE(9),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(9),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(9),
    [sym_acquire_statement] = STATE(9),
    [sym_monitor_statement] = STATE(9),
    [sym_start_statement] = STATE(9),
    [sym_stop_statement] = STATE(9),
    [aux_sym_preproc_if_repeat1] = STATE(9),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [5] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1867),
    [sym_preproc_elif] = STATE(1867),
    [sym_preproc_elifdef] = STATE(1867),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(20),
    [sym_acquire_statement] = STATE(20),
    [sym_monitor_statement] = STATE(20),
    [sym_start_statement] = STATE(20),
    [sym_stop_statement] = STATE(20),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [6] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1855),
    [sym_preproc_elif] = STATE(1855),
    [sym_preproc_elifdef] = STATE(1855),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(20),
    [sym_acquire_statement] = STATE(20),
    [sym_monitor_statement] = STATE(20),
    [sym_start_statement] = STATE(20),
    [sym_stop_statement] = STATE(20),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [7] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1720),
    [sym_preproc_elif] = STATE(1720),
    [sym_preproc_elifdef] = STATE(1720),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(20),
    [sym_acquire_statement] = STATE(20),
    [sym_monitor_statement] = STATE(20),
    [sym_start_statement] = STATE(20),
    [sym_stop_statement] = STATE(20),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [8] = {
    [sym_preproc_include] = STATE(10),
    [sym_preproc_def] = STATE(10),
    [sym_preproc_function_def] = STATE(10),
    [sym_preproc_call] = STATE(10),
    [sym_preproc_if] = STATE(10),
    [sym_preproc_ifdef] = STATE(10),
    [sym_preproc_else] = STATE(1779),
    [sym_preproc_elif] = STATE(1779),
    [sym_preproc_elifdef] = STATE(1779),
    [sym_function_definition] = STATE(10),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(10),
    [sym_type_definition] = STATE(10),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(10),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(10),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_case_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_goto_statement] = STATE(10),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(10),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(10),
    [sym_acquire_statement] = STATE(10),
    [sym_monitor_statement] = STATE(10),
    [sym_start_statement] = STATE(10),
    [sym_stop_statement] = STATE(10),
    [aux_sym_preproc_if_repeat1] = STATE(10),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [9] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1775),
    [sym_preproc_elif] = STATE(1775),
    [sym_preproc_elifdef] = STATE(1775),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(20),
    [sym_acquire_statement] = STATE(20),
    [sym_monitor_statement] = STATE(20),
    [sym_start_statement] = STATE(20),
    [sym_stop_statement] = STATE(20),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [10] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1866),
    [sym_preproc_elif] = STATE(1866),
    [sym_preproc_elifdef] = STATE(1866),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(20),
    [sym_acquire_statement] = STATE(20),
    [sym_monitor_statement] = STATE(20),
    [sym_start_statement] = STATE(20),
    [sym_stop_statement] = STATE(20),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [11] = {
    [sym_preproc_include] = STATE(6),
    [sym_preproc_def] = STATE(6),
    [sym_preproc_function_def] = STATE(6),
    [sym_preproc_call] = STATE(6),
    [sym_preproc_if] = STATE(6),
    [sym_preproc_ifdef] = STATE(6),
    [sym_preproc_else] = STATE(1873),
    [sym_preproc_elif] = STATE(1873),
    [sym_preproc_elifdef] = STATE(1873),
    [sym_function_definition] = STATE(6),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(6),
    [sym_type_definition] = STATE(6),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(6),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(6),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_case_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_goto_statement] = STATE(6),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(6),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(6),
    [sym_acquire_statement] = STATE(6),
    [sym_monitor_statement] = STATE(6),
    [sym_start_statement] = STATE(6),
    [sym_stop_statement] = STATE(6),
    [aux_sym_preproc_if_repeat1] = STATE(6),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(139),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [12] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1768),
    [sym_preproc_elif] = STATE(1768),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [13] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1772),
    [sym_preproc_elif] = STATE(1772),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [14] = {
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(1871),
    [sym_preproc_elif] = STATE(1871),
    [sym_function_definition] = STATE(19),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(19),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_goto_statement] = STATE(19),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(19),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(19),
    [sym_acquire_statement] = STATE(19),
    [sym_monitor_statement] = STATE(19),
    [sym_start_statement] = STATE(19),
    [sym_stop_statement] = STATE(19),
    [aux_sym_preproc_if_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [15] = {
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(1744),
    [sym_preproc_elif] = STATE(1744),
    [sym_function_definition] = STATE(13),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(13),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_case_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_goto_statement] = STATE(13),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(13),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(13),
    [sym_acquire_statement] = STATE(13),
    [sym_monitor_statement] = STATE(13),
    [sym_start_statement] = STATE(13),
    [sym_stop_statement] = STATE(13),
    [aux_sym_preproc_if_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [16] = {
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(1856),
    [sym_preproc_elif] = STATE(1856),
    [sym_function_definition] = STATE(25),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(25),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_goto_statement] = STATE(25),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(25),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(25),
    [sym_acquire_statement] = STATE(25),
    [sym_monitor_statement] = STATE(25),
    [sym_start_statement] = STATE(25),
    [sym_stop_statement] = STATE(25),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [17] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1872),
    [sym_preproc_elif] = STATE(1872),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [18] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1885),
    [sym_preproc_elif] = STATE(1885),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(263),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [19] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1896),
    [sym_preproc_elif] = STATE(1896),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [20] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(166),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1322),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(793),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(20),
    [sym_acquire_statement] = STATE(20),
    [sym_monitor_statement] = STATE(20),
    [sym_start_statement] = STATE(20),
    [sym_stop_statement] = STATE(20),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(270),
    [aux_sym_preproc_def_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token1] = ACTIONS(276),
    [aux_sym_preproc_if_token2] = ACTIONS(279),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(281),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(279),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(284),
    [anon_sym_LPAREN2] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(290),
    [anon_sym_TILDE] = ACTIONS(290),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(296),
    [anon_sym_AMP] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym___extension__] = ACTIONS(302),
    [anon_sym_typedef] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(308),
    [anon_sym___attribute__] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(314),
    [anon_sym___declspec] = ACTIONS(317),
    [anon_sym___cdecl] = ACTIONS(320),
    [anon_sym___clrcall] = ACTIONS(320),
    [anon_sym___stdcall] = ACTIONS(320),
    [anon_sym___fastcall] = ACTIONS(320),
    [anon_sym___thiscall] = ACTIONS(320),
    [anon_sym___vectorcall] = ACTIONS(320),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_signed] = ACTIONS(326),
    [anon_sym_unsigned] = ACTIONS(326),
    [anon_sym_long] = ACTIONS(326),
    [anon_sym_short] = ACTIONS(326),
    [anon_sym_static] = ACTIONS(329),
    [anon_sym_auto] = ACTIONS(329),
    [anon_sym_register] = ACTIONS(329),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym___inline] = ACTIONS(329),
    [anon_sym___inline__] = ACTIONS(329),
    [anon_sym___forceinline] = ACTIONS(329),
    [anon_sym_thread_local] = ACTIONS(329),
    [anon_sym___thread] = ACTIONS(329),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_constexpr] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym___restrict__] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym__Noreturn] = ACTIONS(332),
    [anon_sym_noreturn] = ACTIONS(332),
    [sym_primitive_type] = ACTIONS(335),
    [anon_sym_enum] = ACTIONS(338),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(347),
    [anon_sym_switch] = ACTIONS(350),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(356),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_do] = ACTIONS(362),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_return] = ACTIONS(368),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(374),
    [anon_sym_goto] = ACTIONS(377),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_sizeof] = ACTIONS(383),
    [anon_sym___alignof__] = ACTIONS(386),
    [anon_sym___alignof] = ACTIONS(386),
    [anon_sym__alignof] = ACTIONS(386),
    [anon_sym_alignof] = ACTIONS(386),
    [anon_sym__Alignof] = ACTIONS(386),
    [anon_sym_offsetof] = ACTIONS(389),
    [anon_sym__Generic] = ACTIONS(392),
    [anon_sym_asm] = ACTIONS(395),
    [anon_sym___asm__] = ACTIONS(395),
    [sym_number_literal] = ACTIONS(398),
    [anon_sym_L_SQUOTE] = ACTIONS(401),
    [anon_sym_u_SQUOTE] = ACTIONS(401),
    [anon_sym_U_SQUOTE] = ACTIONS(401),
    [anon_sym_u8_SQUOTE] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_L_DQUOTE] = ACTIONS(404),
    [anon_sym_u_DQUOTE] = ACTIONS(404),
    [anon_sym_U_DQUOTE] = ACTIONS(404),
    [anon_sym_u8_DQUOTE] = ACTIONS(404),
    [anon_sym_DQUOTE] = ACTIONS(404),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [anon_sym_NULL] = ACTIONS(410),
    [anon_sym_nullptr] = ACTIONS(410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_acquire] = ACTIONS(416),
    [anon_sym_monitor] = ACTIONS(419),
    [anon_sym_start] = ACTIONS(422),
    [anon_sym_stop] = ACTIONS(425),
  },
  [21] = {
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1719),
    [sym_preproc_elif] = STATE(1719),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(22),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_goto_statement] = STATE(22),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(22),
    [sym_acquire_statement] = STATE(22),
    [sym_monitor_statement] = STATE(22),
    [sym_start_statement] = STATE(22),
    [sym_stop_statement] = STATE(22),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [22] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1727),
    [sym_preproc_elif] = STATE(1727),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(430),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [23] = {
    [sym_preproc_include] = STATE(12),
    [sym_preproc_def] = STATE(12),
    [sym_preproc_function_def] = STATE(12),
    [sym_preproc_call] = STATE(12),
    [sym_preproc_if] = STATE(12),
    [sym_preproc_ifdef] = STATE(12),
    [sym_preproc_else] = STATE(1776),
    [sym_preproc_elif] = STATE(1776),
    [sym_function_definition] = STATE(12),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(12),
    [sym_type_definition] = STATE(12),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(12),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(12),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_case_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_goto_statement] = STATE(12),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(12),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(12),
    [sym_acquire_statement] = STATE(12),
    [sym_monitor_statement] = STATE(12),
    [sym_start_statement] = STATE(12),
    [sym_stop_statement] = STATE(12),
    [aux_sym_preproc_if_repeat1] = STATE(12),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(432),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [24] = {
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(1815),
    [sym_preproc_elif] = STATE(1815),
    [sym_function_definition] = STATE(17),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(17),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_case_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_goto_statement] = STATE(17),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(17),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(17),
    [sym_acquire_statement] = STATE(17),
    [sym_monitor_statement] = STATE(17),
    [sym_start_statement] = STATE(17),
    [sym_stop_statement] = STATE(17),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [25] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(1838),
    [sym_preproc_elif] = STATE(1838),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [26] = {
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(1864),
    [sym_preproc_elif] = STATE(1864),
    [sym_function_definition] = STATE(18),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(18),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_case_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_goto_statement] = STATE(18),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(18),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(18),
    [sym_acquire_statement] = STATE(18),
    [sym_monitor_statement] = STATE(18),
    [sym_start_statement] = STATE(18),
    [sym_stop_statement] = STATE(18),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(197),
    [aux_sym_preproc_include_token1] = ACTIONS(199),
    [aux_sym_preproc_def_token1] = ACTIONS(201),
    [aux_sym_preproc_if_token1] = ACTIONS(203),
    [aux_sym_preproc_if_token2] = ACTIONS(438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(207),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [sym_preproc_directive] = ACTIONS(209),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [27] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(315),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1324),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(796),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1024),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(27),
    [sym_acquire_statement] = STATE(27),
    [sym_monitor_statement] = STATE(27),
    [sym_start_statement] = STATE(27),
    [sym_stop_statement] = STATE(27),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(440),
    [aux_sym_preproc_include_token1] = ACTIONS(443),
    [aux_sym_preproc_def_token1] = ACTIONS(446),
    [aux_sym_preproc_if_token1] = ACTIONS(449),
    [aux_sym_preproc_if_token2] = ACTIONS(279),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(452),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(279),
    [sym_preproc_directive] = ACTIONS(455),
    [anon_sym_LPAREN2] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(290),
    [anon_sym_TILDE] = ACTIONS(290),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(296),
    [anon_sym_AMP] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(458),
    [anon_sym___extension__] = ACTIONS(461),
    [anon_sym_typedef] = ACTIONS(464),
    [anon_sym_extern] = ACTIONS(467),
    [anon_sym___attribute__] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(314),
    [anon_sym___declspec] = ACTIONS(317),
    [anon_sym___cdecl] = ACTIONS(320),
    [anon_sym___clrcall] = ACTIONS(320),
    [anon_sym___stdcall] = ACTIONS(320),
    [anon_sym___fastcall] = ACTIONS(320),
    [anon_sym___thiscall] = ACTIONS(320),
    [anon_sym___vectorcall] = ACTIONS(320),
    [anon_sym_LBRACE] = ACTIONS(470),
    [anon_sym_signed] = ACTIONS(326),
    [anon_sym_unsigned] = ACTIONS(326),
    [anon_sym_long] = ACTIONS(326),
    [anon_sym_short] = ACTIONS(326),
    [anon_sym_static] = ACTIONS(329),
    [anon_sym_auto] = ACTIONS(329),
    [anon_sym_register] = ACTIONS(329),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym___inline] = ACTIONS(329),
    [anon_sym___inline__] = ACTIONS(329),
    [anon_sym___forceinline] = ACTIONS(329),
    [anon_sym_thread_local] = ACTIONS(329),
    [anon_sym___thread] = ACTIONS(329),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_constexpr] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym___restrict__] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym__Noreturn] = ACTIONS(332),
    [anon_sym_noreturn] = ACTIONS(332),
    [sym_primitive_type] = ACTIONS(335),
    [anon_sym_enum] = ACTIONS(338),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_switch] = ACTIONS(476),
    [anon_sym_case] = ACTIONS(479),
    [anon_sym_default] = ACTIONS(482),
    [anon_sym_while] = ACTIONS(485),
    [anon_sym_do] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_return] = ACTIONS(494),
    [anon_sym_break] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(500),
    [anon_sym_goto] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_sizeof] = ACTIONS(383),
    [anon_sym___alignof__] = ACTIONS(386),
    [anon_sym___alignof] = ACTIONS(386),
    [anon_sym__alignof] = ACTIONS(386),
    [anon_sym_alignof] = ACTIONS(386),
    [anon_sym__Alignof] = ACTIONS(386),
    [anon_sym_offsetof] = ACTIONS(389),
    [anon_sym__Generic] = ACTIONS(392),
    [anon_sym_asm] = ACTIONS(395),
    [anon_sym___asm__] = ACTIONS(395),
    [sym_number_literal] = ACTIONS(398),
    [anon_sym_L_SQUOTE] = ACTIONS(401),
    [anon_sym_u_SQUOTE] = ACTIONS(401),
    [anon_sym_U_SQUOTE] = ACTIONS(401),
    [anon_sym_u8_SQUOTE] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_L_DQUOTE] = ACTIONS(404),
    [anon_sym_u_DQUOTE] = ACTIONS(404),
    [anon_sym_U_DQUOTE] = ACTIONS(404),
    [anon_sym_u8_DQUOTE] = ACTIONS(404),
    [anon_sym_DQUOTE] = ACTIONS(404),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [anon_sym_NULL] = ACTIONS(410),
    [anon_sym_nullptr] = ACTIONS(410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(506),
    [anon_sym_acquire] = ACTIONS(509),
    [anon_sym_monitor] = ACTIONS(512),
    [anon_sym_start] = ACTIONS(515),
    [anon_sym_stop] = ACTIONS(518),
  },
  [28] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(543),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [29] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(577),
    [aux_sym_preproc_include_token1] = ACTIONS(580),
    [aux_sym_preproc_def_token1] = ACTIONS(583),
    [aux_sym_preproc_if_token1] = ACTIONS(586),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(589),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(589),
    [sym_preproc_directive] = ACTIONS(592),
    [anon_sym_LPAREN2] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(290),
    [anon_sym_TILDE] = ACTIONS(290),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(296),
    [anon_sym_AMP] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(595),
    [anon_sym___extension__] = ACTIONS(598),
    [anon_sym_typedef] = ACTIONS(601),
    [anon_sym_extern] = ACTIONS(604),
    [anon_sym___attribute__] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(314),
    [anon_sym___declspec] = ACTIONS(317),
    [anon_sym___cdecl] = ACTIONS(320),
    [anon_sym___clrcall] = ACTIONS(320),
    [anon_sym___stdcall] = ACTIONS(320),
    [anon_sym___fastcall] = ACTIONS(320),
    [anon_sym___thiscall] = ACTIONS(320),
    [anon_sym___vectorcall] = ACTIONS(320),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_signed] = ACTIONS(326),
    [anon_sym_unsigned] = ACTIONS(326),
    [anon_sym_long] = ACTIONS(326),
    [anon_sym_short] = ACTIONS(326),
    [anon_sym_static] = ACTIONS(329),
    [anon_sym_auto] = ACTIONS(329),
    [anon_sym_register] = ACTIONS(329),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym___inline] = ACTIONS(329),
    [anon_sym___inline__] = ACTIONS(329),
    [anon_sym___forceinline] = ACTIONS(329),
    [anon_sym_thread_local] = ACTIONS(329),
    [anon_sym___thread] = ACTIONS(329),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_constexpr] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym___restrict__] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym__Noreturn] = ACTIONS(332),
    [anon_sym_noreturn] = ACTIONS(332),
    [sym_primitive_type] = ACTIONS(335),
    [anon_sym_enum] = ACTIONS(338),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(612),
    [anon_sym_switch] = ACTIONS(615),
    [anon_sym_case] = ACTIONS(618),
    [anon_sym_default] = ACTIONS(621),
    [anon_sym_while] = ACTIONS(624),
    [anon_sym_do] = ACTIONS(627),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_break] = ACTIONS(636),
    [anon_sym_continue] = ACTIONS(639),
    [anon_sym_goto] = ACTIONS(642),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_sizeof] = ACTIONS(383),
    [anon_sym___alignof__] = ACTIONS(386),
    [anon_sym___alignof] = ACTIONS(386),
    [anon_sym__alignof] = ACTIONS(386),
    [anon_sym_alignof] = ACTIONS(386),
    [anon_sym__Alignof] = ACTIONS(386),
    [anon_sym_offsetof] = ACTIONS(389),
    [anon_sym__Generic] = ACTIONS(392),
    [anon_sym_asm] = ACTIONS(395),
    [anon_sym___asm__] = ACTIONS(395),
    [sym_number_literal] = ACTIONS(398),
    [anon_sym_L_SQUOTE] = ACTIONS(401),
    [anon_sym_u_SQUOTE] = ACTIONS(401),
    [anon_sym_U_SQUOTE] = ACTIONS(401),
    [anon_sym_u8_SQUOTE] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_L_DQUOTE] = ACTIONS(404),
    [anon_sym_u_DQUOTE] = ACTIONS(404),
    [anon_sym_U_DQUOTE] = ACTIONS(404),
    [anon_sym_u8_DQUOTE] = ACTIONS(404),
    [anon_sym_DQUOTE] = ACTIONS(404),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [anon_sym_NULL] = ACTIONS(410),
    [anon_sym_nullptr] = ACTIONS(410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(645),
    [anon_sym_acquire] = ACTIONS(648),
    [anon_sym_monitor] = ACTIONS(651),
    [anon_sym_start] = ACTIONS(654),
    [anon_sym_stop] = ACTIONS(657),
  },
  [30] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [31] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [32] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [33] = {
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym__old_style_function_definition] = STATE(486),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1319),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(801),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1021),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym__top_level_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_case_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym__expression] = STATE(1168),
    [sym__expression_not_binary] = STATE(1169),
    [sym_conditional_expression] = STATE(1169),
    [sym_assignment_expression] = STATE(1169),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(1169),
    [sym_cast_expression] = STATE(1169),
    [sym_sizeof_expression] = STATE(1169),
    [sym_alignof_expression] = STATE(1169),
    [sym_offsetof_expression] = STATE(1169),
    [sym_generic_expression] = STATE(1169),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(1169),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(1169),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(1169),
    [sym_concatenated_string] = STATE(1169),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(1169),
    [sym__empty_declaration] = STATE(52),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_task_definition] = STATE(52),
    [sym_until_statement] = STATE(52),
    [sym_acquire_statement] = STATE(52),
    [sym_monitor_statement] = STATE(52),
    [sym_start_statement] = STATE(52),
    [sym_stop_statement] = STATE(52),
    [aux_sym_translation_unit_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [ts_builtin_sym_end] = ACTIONS(666),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(31),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(91),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [34] = {
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym__old_style_function_definition] = STATE(515),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1320),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(800),
    [sym_compound_statement] = STATE(34),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1020),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(34),
    [sym_labeled_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_switch_statement] = STATE(34),
    [sym_case_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(34),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(34),
    [sym_acquire_statement] = STATE(34),
    [sym_monitor_statement] = STATE(34),
    [sym_start_statement] = STATE(34),
    [sym_stop_statement] = STATE(34),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(668),
    [aux_sym_preproc_include_token1] = ACTIONS(671),
    [aux_sym_preproc_def_token1] = ACTIONS(674),
    [aux_sym_preproc_if_token1] = ACTIONS(677),
    [aux_sym_preproc_if_token2] = ACTIONS(279),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(680),
    [sym_preproc_directive] = ACTIONS(683),
    [anon_sym_LPAREN2] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(290),
    [anon_sym_TILDE] = ACTIONS(290),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(296),
    [anon_sym_AMP] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym___extension__] = ACTIONS(689),
    [anon_sym_typedef] = ACTIONS(692),
    [anon_sym_extern] = ACTIONS(695),
    [anon_sym___attribute__] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(314),
    [anon_sym___declspec] = ACTIONS(317),
    [anon_sym___cdecl] = ACTIONS(320),
    [anon_sym___clrcall] = ACTIONS(320),
    [anon_sym___stdcall] = ACTIONS(320),
    [anon_sym___fastcall] = ACTIONS(320),
    [anon_sym___thiscall] = ACTIONS(320),
    [anon_sym___vectorcall] = ACTIONS(320),
    [anon_sym_LBRACE] = ACTIONS(698),
    [anon_sym_signed] = ACTIONS(326),
    [anon_sym_unsigned] = ACTIONS(326),
    [anon_sym_long] = ACTIONS(326),
    [anon_sym_short] = ACTIONS(326),
    [anon_sym_static] = ACTIONS(329),
    [anon_sym_auto] = ACTIONS(329),
    [anon_sym_register] = ACTIONS(329),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym___inline] = ACTIONS(329),
    [anon_sym___inline__] = ACTIONS(329),
    [anon_sym___forceinline] = ACTIONS(329),
    [anon_sym_thread_local] = ACTIONS(329),
    [anon_sym___thread] = ACTIONS(329),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_constexpr] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym___restrict__] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym__Noreturn] = ACTIONS(332),
    [anon_sym_noreturn] = ACTIONS(332),
    [sym_primitive_type] = ACTIONS(335),
    [anon_sym_enum] = ACTIONS(338),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_switch] = ACTIONS(704),
    [anon_sym_case] = ACTIONS(707),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(719),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_break] = ACTIONS(725),
    [anon_sym_continue] = ACTIONS(728),
    [anon_sym_goto] = ACTIONS(731),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_sizeof] = ACTIONS(383),
    [anon_sym___alignof__] = ACTIONS(386),
    [anon_sym___alignof] = ACTIONS(386),
    [anon_sym__alignof] = ACTIONS(386),
    [anon_sym_alignof] = ACTIONS(386),
    [anon_sym__Alignof] = ACTIONS(386),
    [anon_sym_offsetof] = ACTIONS(389),
    [anon_sym__Generic] = ACTIONS(392),
    [anon_sym_asm] = ACTIONS(395),
    [anon_sym___asm__] = ACTIONS(395),
    [sym_number_literal] = ACTIONS(398),
    [anon_sym_L_SQUOTE] = ACTIONS(401),
    [anon_sym_u_SQUOTE] = ACTIONS(401),
    [anon_sym_U_SQUOTE] = ACTIONS(401),
    [anon_sym_u8_SQUOTE] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_L_DQUOTE] = ACTIONS(404),
    [anon_sym_u_DQUOTE] = ACTIONS(404),
    [anon_sym_U_DQUOTE] = ACTIONS(404),
    [anon_sym_u8_DQUOTE] = ACTIONS(404),
    [anon_sym_DQUOTE] = ACTIONS(404),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [anon_sym_NULL] = ACTIONS(410),
    [anon_sym_nullptr] = ACTIONS(410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(734),
    [anon_sym_acquire] = ACTIONS(737),
    [anon_sym_monitor] = ACTIONS(740),
    [anon_sym_start] = ACTIONS(743),
    [anon_sym_stop] = ACTIONS(746),
  },
  [35] = {
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(31),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(31),
    [sym_labeled_statement] = STATE(31),
    [sym_expression_statement] = STATE(31),
    [sym_if_statement] = STATE(31),
    [sym_switch_statement] = STATE(31),
    [sym_case_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_do_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_return_statement] = STATE(31),
    [sym_break_statement] = STATE(31),
    [sym_continue_statement] = STATE(31),
    [sym_goto_statement] = STATE(31),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(31),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(31),
    [sym_acquire_statement] = STATE(31),
    [sym_monitor_statement] = STATE(31),
    [sym_start_statement] = STATE(31),
    [sym_stop_statement] = STATE(31),
    [aux_sym_preproc_if_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [36] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(39),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(39),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(39),
    [sym_acquire_statement] = STATE(39),
    [sym_monitor_statement] = STATE(39),
    [sym_start_statement] = STATE(39),
    [sym_stop_statement] = STATE(39),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [37] = {
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(30),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_case_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(30),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(30),
    [sym_acquire_statement] = STATE(30),
    [sym_monitor_statement] = STATE(30),
    [sym_start_statement] = STATE(30),
    [sym_stop_statement] = STATE(30),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [38] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(40),
    [sym_acquire_statement] = STATE(40),
    [sym_monitor_statement] = STATE(40),
    [sym_start_statement] = STATE(40),
    [sym_stop_statement] = STATE(40),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [39] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [40] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [41] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [42] = {
    [sym_preproc_include] = STATE(51),
    [sym_preproc_def] = STATE(51),
    [sym_preproc_function_def] = STATE(51),
    [sym_preproc_call] = STATE(51),
    [sym_preproc_if] = STATE(51),
    [sym_preproc_ifdef] = STATE(51),
    [sym_function_definition] = STATE(51),
    [sym__old_style_function_definition] = STATE(515),
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1320),
    [sym_linkage_specification] = STATE(51),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(800),
    [sym_compound_statement] = STATE(51),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1020),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(51),
    [sym_labeled_statement] = STATE(51),
    [sym_expression_statement] = STATE(51),
    [sym_if_statement] = STATE(51),
    [sym_switch_statement] = STATE(51),
    [sym_case_statement] = STATE(51),
    [sym_while_statement] = STATE(51),
    [sym_do_statement] = STATE(51),
    [sym_for_statement] = STATE(51),
    [sym_return_statement] = STATE(51),
    [sym_break_statement] = STATE(51),
    [sym_continue_statement] = STATE(51),
    [sym_goto_statement] = STATE(51),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(51),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(51),
    [sym_acquire_statement] = STATE(51),
    [sym_monitor_statement] = STATE(51),
    [sym_start_statement] = STATE(51),
    [sym_stop_statement] = STATE(51),
    [aux_sym_preproc_if_repeat1] = STATE(51),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(763),
    [aux_sym_preproc_include_token1] = ACTIONS(765),
    [aux_sym_preproc_def_token1] = ACTIONS(767),
    [aux_sym_preproc_if_token1] = ACTIONS(769),
    [aux_sym_preproc_if_token2] = ACTIONS(771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(773),
    [sym_preproc_directive] = ACTIONS(775),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym___extension__] = ACTIONS(779),
    [anon_sym_typedef] = ACTIONS(781),
    [anon_sym_extern] = ACTIONS(783),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [43] = {
    [sym_preproc_include] = STATE(45),
    [sym_preproc_def] = STATE(45),
    [sym_preproc_function_def] = STATE(45),
    [sym_preproc_call] = STATE(45),
    [sym_preproc_if] = STATE(45),
    [sym_preproc_ifdef] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(45),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(45),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(45),
    [sym_labeled_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(45),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(45),
    [sym_acquire_statement] = STATE(45),
    [sym_monitor_statement] = STATE(45),
    [sym_start_statement] = STATE(45),
    [sym_stop_statement] = STATE(45),
    [aux_sym_preproc_if_repeat1] = STATE(45),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [44] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(41),
    [sym_acquire_statement] = STATE(41),
    [sym_monitor_statement] = STATE(41),
    [sym_start_statement] = STATE(41),
    [sym_stop_statement] = STATE(41),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [45] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(823),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [46] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [47] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(32),
    [sym_acquire_statement] = STATE(32),
    [sym_monitor_statement] = STATE(32),
    [sym_start_statement] = STATE(32),
    [sym_stop_statement] = STATE(32),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(827),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [48] = {
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(28),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_goto_statement] = STATE(28),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(28),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(28),
    [sym_acquire_statement] = STATE(28),
    [sym_monitor_statement] = STATE(28),
    [sym_start_statement] = STATE(28),
    [sym_stop_statement] = STATE(28),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [49] = {
    [sym_preproc_include] = STATE(46),
    [sym_preproc_def] = STATE(46),
    [sym_preproc_function_def] = STATE(46),
    [sym_preproc_call] = STATE(46),
    [sym_preproc_if] = STATE(46),
    [sym_preproc_ifdef] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(46),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_case_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(46),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(46),
    [sym_acquire_statement] = STATE(46),
    [sym_monitor_statement] = STATE(46),
    [sym_start_statement] = STATE(46),
    [sym_stop_statement] = STATE(46),
    [aux_sym_preproc_if_repeat1] = STATE(46),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [50] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(29),
    [sym_acquire_statement] = STATE(29),
    [sym_monitor_statement] = STATE(29),
    [sym_start_statement] = STATE(29),
    [sym_stop_statement] = STATE(29),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [51] = {
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym__old_style_function_definition] = STATE(515),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1320),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(800),
    [sym_compound_statement] = STATE(34),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1020),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(34),
    [sym_labeled_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_switch_statement] = STATE(34),
    [sym_case_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(34),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(34),
    [sym_acquire_statement] = STATE(34),
    [sym_monitor_statement] = STATE(34),
    [sym_start_statement] = STATE(34),
    [sym_stop_statement] = STATE(34),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(763),
    [aux_sym_preproc_include_token1] = ACTIONS(765),
    [aux_sym_preproc_def_token1] = ACTIONS(767),
    [aux_sym_preproc_if_token1] = ACTIONS(769),
    [aux_sym_preproc_if_token2] = ACTIONS(835),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(773),
    [sym_preproc_directive] = ACTIONS(775),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym___extension__] = ACTIONS(779),
    [anon_sym_typedef] = ACTIONS(781),
    [anon_sym_extern] = ACTIONS(783),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [52] = {
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym__old_style_function_definition] = STATE(486),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1319),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(801),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1021),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym__top_level_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_case_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym__expression] = STATE(1168),
    [sym__expression_not_binary] = STATE(1169),
    [sym_conditional_expression] = STATE(1169),
    [sym_assignment_expression] = STATE(1169),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(1169),
    [sym_cast_expression] = STATE(1169),
    [sym_sizeof_expression] = STATE(1169),
    [sym_alignof_expression] = STATE(1169),
    [sym_offsetof_expression] = STATE(1169),
    [sym_generic_expression] = STATE(1169),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(1169),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(1169),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(1169),
    [sym_concatenated_string] = STATE(1169),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(1169),
    [sym__empty_declaration] = STATE(52),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_task_definition] = STATE(52),
    [sym_until_statement] = STATE(52),
    [sym_acquire_statement] = STATE(52),
    [sym_monitor_statement] = STATE(52),
    [sym_start_statement] = STATE(52),
    [sym_stop_statement] = STATE(52),
    [aux_sym_translation_unit_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(839),
    [aux_sym_preproc_include_token1] = ACTIONS(842),
    [aux_sym_preproc_def_token1] = ACTIONS(845),
    [aux_sym_preproc_if_token1] = ACTIONS(848),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(851),
    [sym_preproc_directive] = ACTIONS(854),
    [anon_sym_LPAREN2] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_TILDE] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(866),
    [anon_sym_AMP] = ACTIONS(866),
    [anon_sym___extension__] = ACTIONS(869),
    [anon_sym_typedef] = ACTIONS(872),
    [anon_sym_extern] = ACTIONS(875),
    [anon_sym___attribute__] = ACTIONS(878),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(881),
    [anon_sym___declspec] = ACTIONS(884),
    [anon_sym___cdecl] = ACTIONS(887),
    [anon_sym___clrcall] = ACTIONS(887),
    [anon_sym___stdcall] = ACTIONS(887),
    [anon_sym___fastcall] = ACTIONS(887),
    [anon_sym___thiscall] = ACTIONS(887),
    [anon_sym___vectorcall] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(890),
    [anon_sym_signed] = ACTIONS(893),
    [anon_sym_unsigned] = ACTIONS(893),
    [anon_sym_long] = ACTIONS(893),
    [anon_sym_short] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(896),
    [anon_sym_auto] = ACTIONS(896),
    [anon_sym_register] = ACTIONS(896),
    [anon_sym_inline] = ACTIONS(896),
    [anon_sym___inline] = ACTIONS(896),
    [anon_sym___inline__] = ACTIONS(896),
    [anon_sym___forceinline] = ACTIONS(896),
    [anon_sym_thread_local] = ACTIONS(896),
    [anon_sym___thread] = ACTIONS(896),
    [anon_sym_const] = ACTIONS(899),
    [anon_sym_constexpr] = ACTIONS(899),
    [anon_sym_volatile] = ACTIONS(899),
    [anon_sym_restrict] = ACTIONS(899),
    [anon_sym___restrict__] = ACTIONS(899),
    [anon_sym__Atomic] = ACTIONS(899),
    [anon_sym__Noreturn] = ACTIONS(899),
    [anon_sym_noreturn] = ACTIONS(899),
    [sym_primitive_type] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_struct] = ACTIONS(908),
    [anon_sym_union] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(917),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_default] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(941),
    [anon_sym_goto] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(947),
    [anon_sym_sizeof] = ACTIONS(950),
    [anon_sym___alignof__] = ACTIONS(953),
    [anon_sym___alignof] = ACTIONS(953),
    [anon_sym__alignof] = ACTIONS(953),
    [anon_sym_alignof] = ACTIONS(953),
    [anon_sym__Alignof] = ACTIONS(953),
    [anon_sym_offsetof] = ACTIONS(956),
    [anon_sym__Generic] = ACTIONS(959),
    [anon_sym_asm] = ACTIONS(962),
    [anon_sym___asm__] = ACTIONS(962),
    [sym_number_literal] = ACTIONS(965),
    [anon_sym_L_SQUOTE] = ACTIONS(968),
    [anon_sym_u_SQUOTE] = ACTIONS(968),
    [anon_sym_U_SQUOTE] = ACTIONS(968),
    [anon_sym_u8_SQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_L_DQUOTE] = ACTIONS(971),
    [anon_sym_u_DQUOTE] = ACTIONS(971),
    [anon_sym_U_DQUOTE] = ACTIONS(971),
    [anon_sym_u8_DQUOTE] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [anon_sym_NULL] = ACTIONS(977),
    [anon_sym_nullptr] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(980),
    [anon_sym_until] = ACTIONS(983),
    [anon_sym_acquire] = ACTIONS(986),
    [anon_sym_monitor] = ACTIONS(989),
    [anon_sym_start] = ACTIONS(992),
    [anon_sym_stop] = ACTIONS(995),
  },
  [53] = {
    [sym_preproc_include] = STATE(50),
    [sym_preproc_def] = STATE(50),
    [sym_preproc_function_def] = STATE(50),
    [sym_preproc_call] = STATE(50),
    [sym_preproc_if] = STATE(50),
    [sym_preproc_ifdef] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym__old_style_function_definition] = STATE(531),
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1321),
    [sym_linkage_specification] = STATE(50),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_call_modifier] = STATE(792),
    [sym_compound_statement] = STATE(50),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(1022),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(50),
    [sym_labeled_statement] = STATE(50),
    [sym_expression_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_return_statement] = STATE(50),
    [sym_break_statement] = STATE(50),
    [sym_continue_statement] = STATE(50),
    [sym_goto_statement] = STATE(50),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym__empty_declaration] = STATE(50),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(50),
    [sym_acquire_statement] = STATE(50),
    [sym_monitor_statement] = STATE(50),
    [sym_start_statement] = STATE(50),
    [sym_stop_statement] = STATE(50),
    [aux_sym_preproc_if_repeat1] = STATE(50),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(521),
    [aux_sym_preproc_include_token1] = ACTIONS(523),
    [aux_sym_preproc_def_token1] = ACTIONS(525),
    [aux_sym_preproc_if_token1] = ACTIONS(527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(529),
    [sym_preproc_directive] = ACTIONS(531),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(539),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [54] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1337),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(54),
    [sym_acquire_statement] = STATE(54),
    [sym_monitor_statement] = STATE(54),
    [sym_start_statement] = STATE(54),
    [sym_stop_statement] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1003),
    [aux_sym_preproc_def_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token2] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1003),
    [aux_sym_preproc_else_token1] = ACTIONS(1003),
    [aux_sym_preproc_elif_token1] = ACTIONS(1003),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1003),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1003),
    [sym_preproc_directive] = ACTIONS(1003),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1017),
    [anon_sym___extension__] = ACTIONS(1020),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym___attribute__] = ACTIONS(1029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1035),
    [anon_sym___cdecl] = ACTIONS(1003),
    [anon_sym___clrcall] = ACTIONS(1003),
    [anon_sym___stdcall] = ACTIONS(1003),
    [anon_sym___fastcall] = ACTIONS(1003),
    [anon_sym___thiscall] = ACTIONS(1003),
    [anon_sym___vectorcall] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_auto] = ACTIONS(1026),
    [anon_sym_register] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym___inline] = ACTIONS(1026),
    [anon_sym___inline__] = ACTIONS(1026),
    [anon_sym___forceinline] = ACTIONS(1026),
    [anon_sym_thread_local] = ACTIONS(1026),
    [anon_sym___thread] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_constexpr] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym___restrict__] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym__Noreturn] = ACTIONS(1044),
    [anon_sym_noreturn] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1071),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1077),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1089),
    [anon_sym___alignof__] = ACTIONS(1092),
    [anon_sym___alignof] = ACTIONS(1092),
    [anon_sym__alignof] = ACTIONS(1092),
    [anon_sym_alignof] = ACTIONS(1092),
    [anon_sym__Alignof] = ACTIONS(1092),
    [anon_sym_offsetof] = ACTIONS(1095),
    [anon_sym__Generic] = ACTIONS(1098),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym___asm__] = ACTIONS(1101),
    [sym_number_literal] = ACTIONS(1104),
    [anon_sym_L_SQUOTE] = ACTIONS(1107),
    [anon_sym_u_SQUOTE] = ACTIONS(1107),
    [anon_sym_U_SQUOTE] = ACTIONS(1107),
    [anon_sym_u8_SQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [anon_sym_NULL] = ACTIONS(1116),
    [anon_sym_nullptr] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1119),
    [anon_sym_acquire] = ACTIONS(1122),
    [anon_sym_catch] = ACTIONS(1003),
    [anon_sym_monitor] = ACTIONS(1125),
    [anon_sym_start] = ACTIONS(1128),
    [anon_sym_stop] = ACTIONS(1131),
  },
  [55] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1337),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(54),
    [sym_acquire_statement] = STATE(54),
    [sym_monitor_statement] = STATE(54),
    [sym_start_statement] = STATE(54),
    [sym_stop_statement] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(1134),
    [aux_sym_preproc_include_token1] = ACTIONS(1136),
    [aux_sym_preproc_def_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token2] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1136),
    [aux_sym_preproc_else_token1] = ACTIONS(1136),
    [aux_sym_preproc_elif_token1] = ACTIONS(1136),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1136),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1136),
    [sym_preproc_directive] = ACTIONS(1136),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1136),
    [anon_sym___clrcall] = ACTIONS(1136),
    [anon_sym___stdcall] = ACTIONS(1136),
    [anon_sym___fastcall] = ACTIONS(1136),
    [anon_sym___thiscall] = ACTIONS(1136),
    [anon_sym___vectorcall] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [56] = {
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1337),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(57),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(57),
    [sym_labeled_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_switch_statement] = STATE(57),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(57),
    [sym_acquire_statement] = STATE(57),
    [sym_monitor_statement] = STATE(57),
    [sym_start_statement] = STATE(57),
    [sym_stop_statement] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(1134),
    [aux_sym_preproc_include_token1] = ACTIONS(1138),
    [aux_sym_preproc_def_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token2] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1138),
    [aux_sym_preproc_else_token1] = ACTIONS(1138),
    [aux_sym_preproc_elif_token1] = ACTIONS(1138),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1138),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1138),
    [sym_preproc_directive] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1138),
    [anon_sym___clrcall] = ACTIONS(1138),
    [anon_sym___stdcall] = ACTIONS(1138),
    [anon_sym___fastcall] = ACTIONS(1138),
    [anon_sym___thiscall] = ACTIONS(1138),
    [anon_sym___vectorcall] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(1138),
    [anon_sym_default] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_catch] = ACTIONS(1138),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [57] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1337),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(54),
    [sym_acquire_statement] = STATE(54),
    [sym_monitor_statement] = STATE(54),
    [sym_start_statement] = STATE(54),
    [sym_stop_statement] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(1134),
    [aux_sym_preproc_include_token1] = ACTIONS(1140),
    [aux_sym_preproc_def_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token2] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1140),
    [aux_sym_preproc_else_token1] = ACTIONS(1140),
    [aux_sym_preproc_elif_token1] = ACTIONS(1140),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1140),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1140),
    [sym_preproc_directive] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1140),
    [anon_sym___clrcall] = ACTIONS(1140),
    [anon_sym___stdcall] = ACTIONS(1140),
    [anon_sym___fastcall] = ACTIONS(1140),
    [anon_sym___thiscall] = ACTIONS(1140),
    [anon_sym___vectorcall] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [58] = {
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1337),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(55),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(55),
    [sym_acquire_statement] = STATE(55),
    [sym_monitor_statement] = STATE(55),
    [sym_start_statement] = STATE(55),
    [sym_stop_statement] = STATE(55),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(1134),
    [aux_sym_preproc_include_token1] = ACTIONS(1142),
    [aux_sym_preproc_def_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token2] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1142),
    [aux_sym_preproc_else_token1] = ACTIONS(1142),
    [aux_sym_preproc_elif_token1] = ACTIONS(1142),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1142),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1142),
    [sym_preproc_directive] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym___extension__] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1142),
    [anon_sym___clrcall] = ACTIONS(1142),
    [anon_sym___stdcall] = ACTIONS(1142),
    [anon_sym___fastcall] = ACTIONS(1142),
    [anon_sym___thiscall] = ACTIONS(1142),
    [anon_sym___vectorcall] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [59] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1338),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(59),
    [sym_acquire_statement] = STATE(59),
    [sym_monitor_statement] = STATE(59),
    [sym_start_statement] = STATE(59),
    [sym_stop_statement] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(1144),
    [aux_sym_preproc_include_token1] = ACTIONS(1003),
    [aux_sym_preproc_def_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token2] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1003),
    [aux_sym_preproc_else_token1] = ACTIONS(1003),
    [aux_sym_preproc_elif_token1] = ACTIONS(1003),
    [sym_preproc_directive] = ACTIONS(1003),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym___extension__] = ACTIONS(1150),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym___attribute__] = ACTIONS(1029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1035),
    [anon_sym___cdecl] = ACTIONS(1003),
    [anon_sym___clrcall] = ACTIONS(1003),
    [anon_sym___stdcall] = ACTIONS(1003),
    [anon_sym___fastcall] = ACTIONS(1003),
    [anon_sym___thiscall] = ACTIONS(1003),
    [anon_sym___vectorcall] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1156),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_auto] = ACTIONS(1026),
    [anon_sym_register] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym___inline] = ACTIONS(1026),
    [anon_sym___inline__] = ACTIONS(1026),
    [anon_sym___forceinline] = ACTIONS(1026),
    [anon_sym_thread_local] = ACTIONS(1026),
    [anon_sym___thread] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_constexpr] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym___restrict__] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym__Noreturn] = ACTIONS(1044),
    [anon_sym_noreturn] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1174),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_goto] = ACTIONS(1183),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1089),
    [anon_sym___alignof__] = ACTIONS(1092),
    [anon_sym___alignof] = ACTIONS(1092),
    [anon_sym__alignof] = ACTIONS(1092),
    [anon_sym_alignof] = ACTIONS(1092),
    [anon_sym__Alignof] = ACTIONS(1092),
    [anon_sym_offsetof] = ACTIONS(1095),
    [anon_sym__Generic] = ACTIONS(1098),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym___asm__] = ACTIONS(1101),
    [sym_number_literal] = ACTIONS(1104),
    [anon_sym_L_SQUOTE] = ACTIONS(1107),
    [anon_sym_u_SQUOTE] = ACTIONS(1107),
    [anon_sym_U_SQUOTE] = ACTIONS(1107),
    [anon_sym_u8_SQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [anon_sym_NULL] = ACTIONS(1116),
    [anon_sym_nullptr] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1186),
    [anon_sym_acquire] = ACTIONS(1189),
    [anon_sym_catch] = ACTIONS(1003),
    [anon_sym_monitor] = ACTIONS(1192),
    [anon_sym_start] = ACTIONS(1195),
    [anon_sym_stop] = ACTIONS(1198),
  },
  [60] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1338),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(59),
    [sym_acquire_statement] = STATE(59),
    [sym_monitor_statement] = STATE(59),
    [sym_start_statement] = STATE(59),
    [sym_stop_statement] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1140),
    [aux_sym_preproc_def_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token2] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1140),
    [aux_sym_preproc_else_token1] = ACTIONS(1140),
    [aux_sym_preproc_elif_token1] = ACTIONS(1140),
    [sym_preproc_directive] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1140),
    [anon_sym___clrcall] = ACTIONS(1140),
    [anon_sym___stdcall] = ACTIONS(1140),
    [anon_sym___fastcall] = ACTIONS(1140),
    [anon_sym___thiscall] = ACTIONS(1140),
    [anon_sym___vectorcall] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [61] = {
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1338),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(60),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(60),
    [sym_labeled_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_switch_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(60),
    [sym_acquire_statement] = STATE(60),
    [sym_monitor_statement] = STATE(60),
    [sym_start_statement] = STATE(60),
    [sym_stop_statement] = STATE(60),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1138),
    [aux_sym_preproc_def_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token2] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1138),
    [aux_sym_preproc_else_token1] = ACTIONS(1138),
    [aux_sym_preproc_elif_token1] = ACTIONS(1138),
    [sym_preproc_directive] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1138),
    [anon_sym___clrcall] = ACTIONS(1138),
    [anon_sym___stdcall] = ACTIONS(1138),
    [anon_sym___fastcall] = ACTIONS(1138),
    [anon_sym___thiscall] = ACTIONS(1138),
    [anon_sym___vectorcall] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(1138),
    [anon_sym_default] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_catch] = ACTIONS(1138),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [62] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1338),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(63),
    [sym_acquire_statement] = STATE(63),
    [sym_monitor_statement] = STATE(63),
    [sym_start_statement] = STATE(63),
    [sym_stop_statement] = STATE(63),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1142),
    [aux_sym_preproc_def_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token2] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1142),
    [aux_sym_preproc_else_token1] = ACTIONS(1142),
    [aux_sym_preproc_elif_token1] = ACTIONS(1142),
    [sym_preproc_directive] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1142),
    [anon_sym___clrcall] = ACTIONS(1142),
    [anon_sym___stdcall] = ACTIONS(1142),
    [anon_sym___fastcall] = ACTIONS(1142),
    [anon_sym___thiscall] = ACTIONS(1142),
    [anon_sym___vectorcall] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [63] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1338),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(59),
    [sym_acquire_statement] = STATE(59),
    [sym_monitor_statement] = STATE(59),
    [sym_start_statement] = STATE(59),
    [sym_stop_statement] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1136),
    [aux_sym_preproc_def_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token2] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1136),
    [aux_sym_preproc_else_token1] = ACTIONS(1136),
    [aux_sym_preproc_elif_token1] = ACTIONS(1136),
    [sym_preproc_directive] = ACTIONS(1136),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym___extension__] = ACTIONS(213),
    [anon_sym_typedef] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1136),
    [anon_sym___clrcall] = ACTIONS(1136),
    [anon_sym___stdcall] = ACTIONS(1136),
    [anon_sym___fastcall] = ACTIONS(1136),
    [anon_sym___thiscall] = ACTIONS(1136),
    [anon_sym___vectorcall] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [64] = {
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(68),
    [sym_acquire_statement] = STATE(68),
    [sym_monitor_statement] = STATE(68),
    [sym_start_statement] = STATE(68),
    [sym_stop_statement] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(1203),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1138),
    [aux_sym_preproc_def_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1138),
    [sym_preproc_directive] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1138),
    [anon_sym___clrcall] = ACTIONS(1138),
    [anon_sym___stdcall] = ACTIONS(1138),
    [anon_sym___fastcall] = ACTIONS(1138),
    [anon_sym___thiscall] = ACTIONS(1138),
    [anon_sym___vectorcall] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1138),
    [anon_sym_default] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1138),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_catch] = ACTIONS(1138),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [65] = {
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(67),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(67),
    [sym_labeled_statement] = STATE(67),
    [sym_expression_statement] = STATE(67),
    [sym_if_statement] = STATE(67),
    [sym_switch_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_do_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_return_statement] = STATE(67),
    [sym_break_statement] = STATE(67),
    [sym_continue_statement] = STATE(67),
    [sym_goto_statement] = STATE(67),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(67),
    [sym_acquire_statement] = STATE(67),
    [sym_monitor_statement] = STATE(67),
    [sym_start_statement] = STATE(67),
    [sym_stop_statement] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(67),
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1136),
    [aux_sym_preproc_def_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1136),
    [sym_preproc_directive] = ACTIONS(1136),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1136),
    [anon_sym___clrcall] = ACTIONS(1136),
    [anon_sym___stdcall] = ACTIONS(1136),
    [anon_sym___fastcall] = ACTIONS(1136),
    [anon_sym___thiscall] = ACTIONS(1136),
    [anon_sym___vectorcall] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1136),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [66] = {
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(65),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(65),
    [sym_labeled_statement] = STATE(65),
    [sym_expression_statement] = STATE(65),
    [sym_if_statement] = STATE(65),
    [sym_switch_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_do_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_return_statement] = STATE(65),
    [sym_break_statement] = STATE(65),
    [sym_continue_statement] = STATE(65),
    [sym_goto_statement] = STATE(65),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(65),
    [sym_acquire_statement] = STATE(65),
    [sym_monitor_statement] = STATE(65),
    [sym_start_statement] = STATE(65),
    [sym_stop_statement] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(65),
    [ts_builtin_sym_end] = ACTIONS(1211),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1142),
    [aux_sym_preproc_def_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1142),
    [sym_preproc_directive] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1142),
    [anon_sym___clrcall] = ACTIONS(1142),
    [anon_sym___stdcall] = ACTIONS(1142),
    [anon_sym___fastcall] = ACTIONS(1142),
    [anon_sym___thiscall] = ACTIONS(1142),
    [anon_sym___vectorcall] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1142),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [67] = {
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(67),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(67),
    [sym_labeled_statement] = STATE(67),
    [sym_expression_statement] = STATE(67),
    [sym_if_statement] = STATE(67),
    [sym_switch_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_do_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_return_statement] = STATE(67),
    [sym_break_statement] = STATE(67),
    [sym_continue_statement] = STATE(67),
    [sym_goto_statement] = STATE(67),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(67),
    [sym_acquire_statement] = STATE(67),
    [sym_monitor_statement] = STATE(67),
    [sym_start_statement] = STATE(67),
    [sym_stop_statement] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(67),
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [aux_sym_preproc_include_token1] = ACTIONS(1003),
    [aux_sym_preproc_def_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1003),
    [sym_preproc_directive] = ACTIONS(1003),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1218),
    [anon_sym___extension__] = ACTIONS(1221),
    [anon_sym_typedef] = ACTIONS(1224),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym___attribute__] = ACTIONS(1029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1035),
    [anon_sym___cdecl] = ACTIONS(1003),
    [anon_sym___clrcall] = ACTIONS(1003),
    [anon_sym___stdcall] = ACTIONS(1003),
    [anon_sym___fastcall] = ACTIONS(1003),
    [anon_sym___thiscall] = ACTIONS(1003),
    [anon_sym___vectorcall] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_auto] = ACTIONS(1026),
    [anon_sym_register] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym___inline] = ACTIONS(1026),
    [anon_sym___inline__] = ACTIONS(1026),
    [anon_sym___forceinline] = ACTIONS(1026),
    [anon_sym_thread_local] = ACTIONS(1026),
    [anon_sym___thread] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_constexpr] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym___restrict__] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym__Noreturn] = ACTIONS(1044),
    [anon_sym_noreturn] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1251),
    [anon_sym_goto] = ACTIONS(1254),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1089),
    [anon_sym___alignof__] = ACTIONS(1092),
    [anon_sym___alignof] = ACTIONS(1092),
    [anon_sym__alignof] = ACTIONS(1092),
    [anon_sym_alignof] = ACTIONS(1092),
    [anon_sym__Alignof] = ACTIONS(1092),
    [anon_sym_offsetof] = ACTIONS(1095),
    [anon_sym__Generic] = ACTIONS(1098),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym___asm__] = ACTIONS(1101),
    [sym_number_literal] = ACTIONS(1104),
    [anon_sym_L_SQUOTE] = ACTIONS(1107),
    [anon_sym_u_SQUOTE] = ACTIONS(1107),
    [anon_sym_U_SQUOTE] = ACTIONS(1107),
    [anon_sym_u8_SQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [anon_sym_NULL] = ACTIONS(1116),
    [anon_sym_nullptr] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1257),
    [anon_sym_acquire] = ACTIONS(1260),
    [anon_sym_catch] = ACTIONS(1003),
    [anon_sym_monitor] = ACTIONS(1263),
    [anon_sym_start] = ACTIONS(1266),
    [anon_sym_stop] = ACTIONS(1269),
  },
  [68] = {
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(67),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(67),
    [sym_labeled_statement] = STATE(67),
    [sym_expression_statement] = STATE(67),
    [sym_if_statement] = STATE(67),
    [sym_switch_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_do_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_return_statement] = STATE(67),
    [sym_break_statement] = STATE(67),
    [sym_continue_statement] = STATE(67),
    [sym_goto_statement] = STATE(67),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(67),
    [sym_acquire_statement] = STATE(67),
    [sym_monitor_statement] = STATE(67),
    [sym_start_statement] = STATE(67),
    [sym_stop_statement] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(67),
    [ts_builtin_sym_end] = ACTIONS(1272),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1140),
    [aux_sym_preproc_def_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1140),
    [sym_preproc_directive] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1140),
    [anon_sym___clrcall] = ACTIONS(1140),
    [anon_sym___stdcall] = ACTIONS(1140),
    [anon_sym___fastcall] = ACTIONS(1140),
    [anon_sym___thiscall] = ACTIONS(1140),
    [anon_sym___vectorcall] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1140),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [69] = {
    [sym_declaration] = STATE(77),
    [sym_type_definition] = STATE(77),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1339),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(77),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(77),
    [sym_labeled_statement] = STATE(77),
    [sym_expression_statement] = STATE(77),
    [sym_if_statement] = STATE(77),
    [sym_switch_statement] = STATE(77),
    [sym_while_statement] = STATE(77),
    [sym_do_statement] = STATE(77),
    [sym_for_statement] = STATE(77),
    [sym_return_statement] = STATE(77),
    [sym_break_statement] = STATE(77),
    [sym_continue_statement] = STATE(77),
    [sym_goto_statement] = STATE(77),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(77),
    [sym_acquire_statement] = STATE(77),
    [sym_monitor_statement] = STATE(77),
    [sym_start_statement] = STATE(77),
    [sym_stop_statement] = STATE(77),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(1274),
    [aux_sym_preproc_include_token1] = ACTIONS(1142),
    [aux_sym_preproc_def_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token2] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1142),
    [sym_preproc_directive] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym___extension__] = ACTIONS(779),
    [anon_sym_typedef] = ACTIONS(781),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1142),
    [anon_sym___clrcall] = ACTIONS(1142),
    [anon_sym___stdcall] = ACTIONS(1142),
    [anon_sym___fastcall] = ACTIONS(1142),
    [anon_sym___thiscall] = ACTIONS(1142),
    [anon_sym___vectorcall] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [70] = {
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1339),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(70),
    [sym_acquire_statement] = STATE(70),
    [sym_monitor_statement] = STATE(70),
    [sym_start_statement] = STATE(70),
    [sym_stop_statement] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(70),
    [sym_identifier] = ACTIONS(1276),
    [aux_sym_preproc_include_token1] = ACTIONS(1003),
    [aux_sym_preproc_def_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token2] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1003),
    [sym_preproc_directive] = ACTIONS(1003),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym___extension__] = ACTIONS(1282),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym___attribute__] = ACTIONS(1029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1035),
    [anon_sym___cdecl] = ACTIONS(1003),
    [anon_sym___clrcall] = ACTIONS(1003),
    [anon_sym___stdcall] = ACTIONS(1003),
    [anon_sym___fastcall] = ACTIONS(1003),
    [anon_sym___thiscall] = ACTIONS(1003),
    [anon_sym___vectorcall] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_auto] = ACTIONS(1026),
    [anon_sym_register] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym___inline] = ACTIONS(1026),
    [anon_sym___inline__] = ACTIONS(1026),
    [anon_sym___forceinline] = ACTIONS(1026),
    [anon_sym_thread_local] = ACTIONS(1026),
    [anon_sym___thread] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_constexpr] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym___restrict__] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym__Noreturn] = ACTIONS(1044),
    [anon_sym_noreturn] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1294),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1300),
    [anon_sym_for] = ACTIONS(1303),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1312),
    [anon_sym_goto] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1089),
    [anon_sym___alignof__] = ACTIONS(1092),
    [anon_sym___alignof] = ACTIONS(1092),
    [anon_sym__alignof] = ACTIONS(1092),
    [anon_sym_alignof] = ACTIONS(1092),
    [anon_sym__Alignof] = ACTIONS(1092),
    [anon_sym_offsetof] = ACTIONS(1095),
    [anon_sym__Generic] = ACTIONS(1098),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym___asm__] = ACTIONS(1101),
    [sym_number_literal] = ACTIONS(1104),
    [anon_sym_L_SQUOTE] = ACTIONS(1107),
    [anon_sym_u_SQUOTE] = ACTIONS(1107),
    [anon_sym_U_SQUOTE] = ACTIONS(1107),
    [anon_sym_u8_SQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [anon_sym_NULL] = ACTIONS(1116),
    [anon_sym_nullptr] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1318),
    [anon_sym_acquire] = ACTIONS(1321),
    [anon_sym_catch] = ACTIONS(1003),
    [anon_sym_monitor] = ACTIONS(1324),
    [anon_sym_start] = ACTIONS(1327),
    [anon_sym_stop] = ACTIONS(1330),
  },
  [71] = {
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1333),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(75),
    [sym_acquire_statement] = STATE(75),
    [sym_monitor_statement] = STATE(75),
    [sym_start_statement] = STATE(75),
    [sym_stop_statement] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1136),
    [aux_sym_preproc_def_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1136),
    [sym_preproc_directive] = ACTIONS(1136),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1136),
    [anon_sym___clrcall] = ACTIONS(1136),
    [anon_sym___stdcall] = ACTIONS(1136),
    [anon_sym___fastcall] = ACTIONS(1136),
    [anon_sym___thiscall] = ACTIONS(1136),
    [anon_sym___vectorcall] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [72] = {
    [sym_declaration] = STATE(71),
    [sym_type_definition] = STATE(71),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1333),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(71),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(71),
    [sym_labeled_statement] = STATE(71),
    [sym_expression_statement] = STATE(71),
    [sym_if_statement] = STATE(71),
    [sym_switch_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_do_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_return_statement] = STATE(71),
    [sym_break_statement] = STATE(71),
    [sym_continue_statement] = STATE(71),
    [sym_goto_statement] = STATE(71),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(71),
    [sym_acquire_statement] = STATE(71),
    [sym_monitor_statement] = STATE(71),
    [sym_start_statement] = STATE(71),
    [sym_stop_statement] = STATE(71),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(71),
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1142),
    [aux_sym_preproc_def_token1] = ACTIONS(1142),
    [aux_sym_preproc_if_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1142),
    [sym_preproc_directive] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1142),
    [anon_sym___clrcall] = ACTIONS(1142),
    [anon_sym___stdcall] = ACTIONS(1142),
    [anon_sym___fastcall] = ACTIONS(1142),
    [anon_sym___thiscall] = ACTIONS(1142),
    [anon_sym___vectorcall] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [73] = {
    [sym_declaration] = STATE(74),
    [sym_type_definition] = STATE(74),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1333),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(74),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(74),
    [sym_labeled_statement] = STATE(74),
    [sym_expression_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym_switch_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_return_statement] = STATE(74),
    [sym_break_statement] = STATE(74),
    [sym_continue_statement] = STATE(74),
    [sym_goto_statement] = STATE(74),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(74),
    [sym_acquire_statement] = STATE(74),
    [sym_monitor_statement] = STATE(74),
    [sym_start_statement] = STATE(74),
    [sym_stop_statement] = STATE(74),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1138),
    [aux_sym_preproc_def_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1138),
    [sym_preproc_directive] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1138),
    [anon_sym___clrcall] = ACTIONS(1138),
    [anon_sym___stdcall] = ACTIONS(1138),
    [anon_sym___fastcall] = ACTIONS(1138),
    [anon_sym___thiscall] = ACTIONS(1138),
    [anon_sym___vectorcall] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(1138),
    [anon_sym_default] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_catch] = ACTIONS(1138),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [74] = {
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1333),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(75),
    [sym_acquire_statement] = STATE(75),
    [sym_monitor_statement] = STATE(75),
    [sym_start_statement] = STATE(75),
    [sym_stop_statement] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1140),
    [aux_sym_preproc_def_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1140),
    [sym_preproc_directive] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(535),
    [anon_sym_typedef] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1140),
    [anon_sym___clrcall] = ACTIONS(1140),
    [anon_sym___stdcall] = ACTIONS(1140),
    [anon_sym___fastcall] = ACTIONS(1140),
    [anon_sym___thiscall] = ACTIONS(1140),
    [anon_sym___vectorcall] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(1272),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [75] = {
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1333),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(75),
    [sym_acquire_statement] = STATE(75),
    [sym_monitor_statement] = STATE(75),
    [sym_start_statement] = STATE(75),
    [sym_stop_statement] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(1335),
    [aux_sym_preproc_include_token1] = ACTIONS(1003),
    [aux_sym_preproc_def_token1] = ACTIONS(1003),
    [aux_sym_preproc_if_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1003),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1003),
    [sym_preproc_directive] = ACTIONS(1003),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1344),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym___attribute__] = ACTIONS(1029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1035),
    [anon_sym___cdecl] = ACTIONS(1003),
    [anon_sym___clrcall] = ACTIONS(1003),
    [anon_sym___stdcall] = ACTIONS(1003),
    [anon_sym___fastcall] = ACTIONS(1003),
    [anon_sym___thiscall] = ACTIONS(1003),
    [anon_sym___vectorcall] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_auto] = ACTIONS(1026),
    [anon_sym_register] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym___inline] = ACTIONS(1026),
    [anon_sym___inline__] = ACTIONS(1026),
    [anon_sym___forceinline] = ACTIONS(1026),
    [anon_sym_thread_local] = ACTIONS(1026),
    [anon_sym___thread] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_constexpr] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym___restrict__] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym__Noreturn] = ACTIONS(1044),
    [anon_sym_noreturn] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1371),
    [anon_sym_goto] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1089),
    [anon_sym___alignof__] = ACTIONS(1092),
    [anon_sym___alignof] = ACTIONS(1092),
    [anon_sym__alignof] = ACTIONS(1092),
    [anon_sym_alignof] = ACTIONS(1092),
    [anon_sym__Alignof] = ACTIONS(1092),
    [anon_sym_offsetof] = ACTIONS(1095),
    [anon_sym__Generic] = ACTIONS(1098),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym___asm__] = ACTIONS(1101),
    [sym_number_literal] = ACTIONS(1104),
    [anon_sym_L_SQUOTE] = ACTIONS(1107),
    [anon_sym_u_SQUOTE] = ACTIONS(1107),
    [anon_sym_U_SQUOTE] = ACTIONS(1107),
    [anon_sym_u8_SQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [anon_sym_NULL] = ACTIONS(1116),
    [anon_sym_nullptr] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1377),
    [anon_sym_acquire] = ACTIONS(1380),
    [anon_sym_catch] = ACTIONS(1003),
    [anon_sym_monitor] = ACTIONS(1383),
    [anon_sym_start] = ACTIONS(1386),
    [anon_sym_stop] = ACTIONS(1389),
  },
  [76] = {
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1339),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(78),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(78),
    [sym_acquire_statement] = STATE(78),
    [sym_monitor_statement] = STATE(78),
    [sym_start_statement] = STATE(78),
    [sym_stop_statement] = STATE(78),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(1274),
    [aux_sym_preproc_include_token1] = ACTIONS(1138),
    [aux_sym_preproc_def_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token1] = ACTIONS(1138),
    [aux_sym_preproc_if_token2] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1138),
    [sym_preproc_directive] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym___extension__] = ACTIONS(779),
    [anon_sym_typedef] = ACTIONS(781),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1138),
    [anon_sym___clrcall] = ACTIONS(1138),
    [anon_sym___stdcall] = ACTIONS(1138),
    [anon_sym___fastcall] = ACTIONS(1138),
    [anon_sym___thiscall] = ACTIONS(1138),
    [anon_sym___vectorcall] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(1138),
    [anon_sym_default] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_catch] = ACTIONS(1138),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [77] = {
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1339),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(70),
    [sym_acquire_statement] = STATE(70),
    [sym_monitor_statement] = STATE(70),
    [sym_start_statement] = STATE(70),
    [sym_stop_statement] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(70),
    [sym_identifier] = ACTIONS(1274),
    [aux_sym_preproc_include_token1] = ACTIONS(1136),
    [aux_sym_preproc_def_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token1] = ACTIONS(1136),
    [aux_sym_preproc_if_token2] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1136),
    [sym_preproc_directive] = ACTIONS(1136),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym___extension__] = ACTIONS(779),
    [anon_sym_typedef] = ACTIONS(781),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1136),
    [anon_sym___clrcall] = ACTIONS(1136),
    [anon_sym___stdcall] = ACTIONS(1136),
    [anon_sym___fastcall] = ACTIONS(1136),
    [anon_sym___thiscall] = ACTIONS(1136),
    [anon_sym___vectorcall] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [78] = {
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1339),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(70),
    [sym_acquire_statement] = STATE(70),
    [sym_monitor_statement] = STATE(70),
    [sym_start_statement] = STATE(70),
    [sym_stop_statement] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(70),
    [sym_identifier] = ACTIONS(1274),
    [aux_sym_preproc_include_token1] = ACTIONS(1140),
    [aux_sym_preproc_def_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token1] = ACTIONS(1140),
    [aux_sym_preproc_if_token2] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1140),
    [sym_preproc_directive] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym___extension__] = ACTIONS(779),
    [anon_sym_typedef] = ACTIONS(781),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1140),
    [anon_sym___clrcall] = ACTIONS(1140),
    [anon_sym___stdcall] = ACTIONS(1140),
    [anon_sym___fastcall] = ACTIONS(1140),
    [anon_sym___thiscall] = ACTIONS(1140),
    [anon_sym___vectorcall] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [79] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(79),
    [sym_acquire_statement] = STATE(79),
    [sym_monitor_statement] = STATE(79),
    [sym_start_statement] = STATE(79),
    [sym_stop_statement] = STATE(79),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym___extension__] = ACTIONS(1221),
    [anon_sym_typedef] = ACTIONS(1224),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym___attribute__] = ACTIONS(1029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_signed] = ACTIONS(1041),
    [anon_sym_unsigned] = ACTIONS(1041),
    [anon_sym_long] = ACTIONS(1041),
    [anon_sym_short] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_auto] = ACTIONS(1026),
    [anon_sym_register] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym___inline] = ACTIONS(1026),
    [anon_sym___inline__] = ACTIONS(1026),
    [anon_sym___forceinline] = ACTIONS(1026),
    [anon_sym_thread_local] = ACTIONS(1026),
    [anon_sym___thread] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_constexpr] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym___restrict__] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym__Noreturn] = ACTIONS(1044),
    [anon_sym_noreturn] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1251),
    [anon_sym_goto] = ACTIONS(1254),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1089),
    [anon_sym___alignof__] = ACTIONS(1092),
    [anon_sym___alignof] = ACTIONS(1092),
    [anon_sym__alignof] = ACTIONS(1092),
    [anon_sym_alignof] = ACTIONS(1092),
    [anon_sym__Alignof] = ACTIONS(1092),
    [anon_sym_offsetof] = ACTIONS(1095),
    [anon_sym__Generic] = ACTIONS(1098),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym___asm__] = ACTIONS(1101),
    [sym_number_literal] = ACTIONS(1104),
    [anon_sym_L_SQUOTE] = ACTIONS(1107),
    [anon_sym_u_SQUOTE] = ACTIONS(1107),
    [anon_sym_U_SQUOTE] = ACTIONS(1107),
    [anon_sym_u8_SQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [anon_sym_NULL] = ACTIONS(1116),
    [anon_sym_nullptr] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1404),
    [anon_sym_acquire] = ACTIONS(1407),
    [anon_sym_catch] = ACTIONS(1003),
    [anon_sym_monitor] = ACTIONS(1410),
    [anon_sym_start] = ACTIONS(1266),
    [anon_sym_stop] = ACTIONS(1269),
  },
  [80] = {
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(83),
    [sym_acquire_statement] = STATE(83),
    [sym_monitor_statement] = STATE(83),
    [sym_start_statement] = STATE(83),
    [sym_stop_statement] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [81] = {
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(82),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(82),
    [sym_labeled_statement] = STATE(82),
    [sym_expression_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_switch_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_do_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_return_statement] = STATE(82),
    [sym_break_statement] = STATE(82),
    [sym_continue_statement] = STATE(82),
    [sym_goto_statement] = STATE(82),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(82),
    [sym_acquire_statement] = STATE(82),
    [sym_monitor_statement] = STATE(82),
    [sym_start_statement] = STATE(82),
    [sym_stop_statement] = STATE(82),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_catch] = ACTIONS(1138),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [82] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(79),
    [sym_acquire_statement] = STATE(79),
    [sym_monitor_statement] = STATE(79),
    [sym_start_statement] = STATE(79),
    [sym_stop_statement] = STATE(79),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [83] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1335),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(556),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [sym_until_statement] = STATE(79),
    [sym_acquire_statement] = STATE(79),
    [sym_monitor_statement] = STATE(79),
    [sym_start_statement] = STATE(79),
    [sym_stop_statement] = STATE(79),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [84] = {
    [sym_declaration] = STATE(610),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1344),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__for_statement_body] = STATE(1852),
    [sym__expression] = STATE(1111),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1826),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_declaration] = STATE(610),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1344),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__for_statement_body] = STATE(1816),
    [sym__expression] = STATE(1111),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1826),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_declaration] = STATE(610),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1344),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__for_statement_body] = STATE(1877),
    [sym__expression] = STATE(1111),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1826),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_declaration] = STATE(610),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1344),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__for_statement_body] = STATE(1801),
    [sym__expression] = STATE(1111),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1826),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_declaration] = STATE(610),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1344),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__for_statement_body] = STATE(1851),
    [sym__expression] = STATE(1111),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1826),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_declaration] = STATE(610),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1344),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__for_statement_body] = STATE(1784),
    [sym__expression] = STATE(1111),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1826),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_catch_clause] = STATE(90),
    [aux_sym_monitor_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [aux_sym_preproc_else_token1] = ACTIONS(1433),
    [aux_sym_preproc_elif_token1] = ACTIONS(1433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_acquire] = ACTIONS(1433),
    [anon_sym_catch] = ACTIONS(1437),
    [anon_sym_monitor] = ACTIONS(1433),
    [anon_sym_start] = ACTIONS(1433),
    [anon_sym_stop] = ACTIONS(1433),
  },
  [91] = {
    [sym_catch_clause] = STATE(90),
    [aux_sym_monitor_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_include_token1] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token2] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [aux_sym_preproc_else_token1] = ACTIONS(1440),
    [aux_sym_preproc_elif_token1] = ACTIONS(1440),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym___extension__] = ACTIONS(1440),
    [anon_sym_typedef] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym___cdecl] = ACTIONS(1440),
    [anon_sym___clrcall] = ACTIONS(1440),
    [anon_sym___stdcall] = ACTIONS(1440),
    [anon_sym___fastcall] = ACTIONS(1440),
    [anon_sym___thiscall] = ACTIONS(1440),
    [anon_sym___vectorcall] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym___inline] = ACTIONS(1440),
    [anon_sym___inline__] = ACTIONS(1440),
    [anon_sym___forceinline] = ACTIONS(1440),
    [anon_sym_thread_local] = ACTIONS(1440),
    [anon_sym___thread] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym___restrict__] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym__Noreturn] = ACTIONS(1440),
    [anon_sym_noreturn] = ACTIONS(1440),
    [sym_primitive_type] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_switch] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_do] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_goto] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_sizeof] = ACTIONS(1440),
    [anon_sym___alignof__] = ACTIONS(1440),
    [anon_sym___alignof] = ACTIONS(1440),
    [anon_sym__alignof] = ACTIONS(1440),
    [anon_sym_alignof] = ACTIONS(1440),
    [anon_sym__Alignof] = ACTIONS(1440),
    [anon_sym_offsetof] = ACTIONS(1440),
    [anon_sym__Generic] = ACTIONS(1440),
    [anon_sym_asm] = ACTIONS(1440),
    [anon_sym___asm__] = ACTIONS(1440),
    [sym_number_literal] = ACTIONS(1442),
    [anon_sym_L_SQUOTE] = ACTIONS(1442),
    [anon_sym_u_SQUOTE] = ACTIONS(1442),
    [anon_sym_U_SQUOTE] = ACTIONS(1442),
    [anon_sym_u8_SQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_L_DQUOTE] = ACTIONS(1442),
    [anon_sym_u_DQUOTE] = ACTIONS(1442),
    [anon_sym_U_DQUOTE] = ACTIONS(1442),
    [anon_sym_u8_DQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [anon_sym_NULL] = ACTIONS(1440),
    [anon_sym_nullptr] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1440),
    [anon_sym_acquire] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1444),
    [anon_sym_monitor] = ACTIONS(1440),
    [anon_sym_start] = ACTIONS(1440),
    [anon_sym_stop] = ACTIONS(1440),
  },
  [92] = {
    [sym_catch_clause] = STATE(91),
    [aux_sym_monitor_statement_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token2] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [aux_sym_preproc_else_token1] = ACTIONS(1446),
    [aux_sym_preproc_elif_token1] = ACTIONS(1446),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1446),
    [anon_sym_acquire] = ACTIONS(1446),
    [anon_sym_catch] = ACTIONS(1444),
    [anon_sym_monitor] = ACTIONS(1446),
    [anon_sym_start] = ACTIONS(1446),
    [anon_sym_stop] = ACTIONS(1446),
  },
  [93] = {
    [sym_catch_clause] = STATE(138),
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token2] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [aux_sym_preproc_else_token1] = ACTIONS(1450),
    [aux_sym_preproc_elif_token1] = ACTIONS(1450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_else] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1450),
    [anon_sym_acquire] = ACTIONS(1450),
    [anon_sym_catch] = ACTIONS(1444),
    [anon_sym_monitor] = ACTIONS(1450),
    [anon_sym_start] = ACTIONS(1450),
    [anon_sym_stop] = ACTIONS(1450),
  },
  [94] = {
    [sym_else_clause] = STATE(136),
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [aux_sym_preproc_else_token1] = ACTIONS(1454),
    [aux_sym_preproc_elif_token1] = ACTIONS(1454),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1454),
    [anon_sym_acquire] = ACTIONS(1454),
    [anon_sym_catch] = ACTIONS(1454),
    [anon_sym_monitor] = ACTIONS(1454),
    [anon_sym_start] = ACTIONS(1454),
    [anon_sym_stop] = ACTIONS(1454),
  },
  [95] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [96] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_include_token1] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token2] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [aux_sym_preproc_else_token1] = ACTIONS(1464),
    [aux_sym_preproc_elif_token1] = ACTIONS(1464),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_LPAREN2] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym___extension__] = ACTIONS(1464),
    [anon_sym_typedef] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym___cdecl] = ACTIONS(1464),
    [anon_sym___clrcall] = ACTIONS(1464),
    [anon_sym___stdcall] = ACTIONS(1464),
    [anon_sym___fastcall] = ACTIONS(1464),
    [anon_sym___thiscall] = ACTIONS(1464),
    [anon_sym___vectorcall] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym___inline] = ACTIONS(1464),
    [anon_sym___inline__] = ACTIONS(1464),
    [anon_sym___forceinline] = ACTIONS(1464),
    [anon_sym_thread_local] = ACTIONS(1464),
    [anon_sym___thread] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_constexpr] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym___restrict__] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym__Noreturn] = ACTIONS(1464),
    [anon_sym_noreturn] = ACTIONS(1464),
    [sym_primitive_type] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_switch] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_goto] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_sizeof] = ACTIONS(1464),
    [anon_sym___alignof__] = ACTIONS(1464),
    [anon_sym___alignof] = ACTIONS(1464),
    [anon_sym__alignof] = ACTIONS(1464),
    [anon_sym_alignof] = ACTIONS(1464),
    [anon_sym__Alignof] = ACTIONS(1464),
    [anon_sym_offsetof] = ACTIONS(1464),
    [anon_sym__Generic] = ACTIONS(1464),
    [anon_sym_asm] = ACTIONS(1464),
    [anon_sym___asm__] = ACTIONS(1464),
    [sym_number_literal] = ACTIONS(1466),
    [anon_sym_L_SQUOTE] = ACTIONS(1466),
    [anon_sym_u_SQUOTE] = ACTIONS(1466),
    [anon_sym_U_SQUOTE] = ACTIONS(1466),
    [anon_sym_u8_SQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_L_DQUOTE] = ACTIONS(1466),
    [anon_sym_u_DQUOTE] = ACTIONS(1466),
    [anon_sym_U_DQUOTE] = ACTIONS(1466),
    [anon_sym_u8_DQUOTE] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [anon_sym_NULL] = ACTIONS(1464),
    [anon_sym_nullptr] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1464),
    [anon_sym_acquire] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_monitor] = ACTIONS(1464),
    [anon_sym_start] = ACTIONS(1464),
    [anon_sym_stop] = ACTIONS(1464),
  },
  [97] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_include_token1] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token2] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [aux_sym_preproc_else_token1] = ACTIONS(1468),
    [aux_sym_preproc_elif_token1] = ACTIONS(1468),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_LPAREN2] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym___cdecl] = ACTIONS(1468),
    [anon_sym___clrcall] = ACTIONS(1468),
    [anon_sym___stdcall] = ACTIONS(1468),
    [anon_sym___fastcall] = ACTIONS(1468),
    [anon_sym___thiscall] = ACTIONS(1468),
    [anon_sym___vectorcall] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym___inline] = ACTIONS(1468),
    [anon_sym___inline__] = ACTIONS(1468),
    [anon_sym___forceinline] = ACTIONS(1468),
    [anon_sym_thread_local] = ACTIONS(1468),
    [anon_sym___thread] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_constexpr] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym___restrict__] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym__Noreturn] = ACTIONS(1468),
    [anon_sym_noreturn] = ACTIONS(1468),
    [sym_primitive_type] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_goto] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_sizeof] = ACTIONS(1468),
    [anon_sym___alignof__] = ACTIONS(1468),
    [anon_sym___alignof] = ACTIONS(1468),
    [anon_sym__alignof] = ACTIONS(1468),
    [anon_sym_alignof] = ACTIONS(1468),
    [anon_sym__Alignof] = ACTIONS(1468),
    [anon_sym_offsetof] = ACTIONS(1468),
    [anon_sym__Generic] = ACTIONS(1468),
    [anon_sym_asm] = ACTIONS(1468),
    [anon_sym___asm__] = ACTIONS(1468),
    [sym_number_literal] = ACTIONS(1470),
    [anon_sym_L_SQUOTE] = ACTIONS(1470),
    [anon_sym_u_SQUOTE] = ACTIONS(1470),
    [anon_sym_U_SQUOTE] = ACTIONS(1470),
    [anon_sym_u8_SQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_L_DQUOTE] = ACTIONS(1470),
    [anon_sym_u_DQUOTE] = ACTIONS(1470),
    [anon_sym_U_DQUOTE] = ACTIONS(1470),
    [anon_sym_u8_DQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [anon_sym_NULL] = ACTIONS(1468),
    [anon_sym_nullptr] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1468),
    [anon_sym_acquire] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_monitor] = ACTIONS(1468),
    [anon_sym_start] = ACTIONS(1468),
    [anon_sym_stop] = ACTIONS(1468),
  },
  [98] = {
    [sym_identifier] = ACTIONS(1472),
    [aux_sym_preproc_include_token1] = ACTIONS(1472),
    [aux_sym_preproc_def_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token2] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1472),
    [aux_sym_preproc_else_token1] = ACTIONS(1472),
    [aux_sym_preproc_elif_token1] = ACTIONS(1472),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1472),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1472),
    [sym_preproc_directive] = ACTIONS(1472),
    [anon_sym_LPAREN2] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [anon_sym___extension__] = ACTIONS(1472),
    [anon_sym_typedef] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym___attribute__] = ACTIONS(1472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1474),
    [anon_sym___declspec] = ACTIONS(1472),
    [anon_sym___cdecl] = ACTIONS(1472),
    [anon_sym___clrcall] = ACTIONS(1472),
    [anon_sym___stdcall] = ACTIONS(1472),
    [anon_sym___fastcall] = ACTIONS(1472),
    [anon_sym___thiscall] = ACTIONS(1472),
    [anon_sym___vectorcall] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_signed] = ACTIONS(1472),
    [anon_sym_unsigned] = ACTIONS(1472),
    [anon_sym_long] = ACTIONS(1472),
    [anon_sym_short] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_auto] = ACTIONS(1472),
    [anon_sym_register] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym___inline] = ACTIONS(1472),
    [anon_sym___inline__] = ACTIONS(1472),
    [anon_sym___forceinline] = ACTIONS(1472),
    [anon_sym_thread_local] = ACTIONS(1472),
    [anon_sym___thread] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_constexpr] = ACTIONS(1472),
    [anon_sym_volatile] = ACTIONS(1472),
    [anon_sym_restrict] = ACTIONS(1472),
    [anon_sym___restrict__] = ACTIONS(1472),
    [anon_sym__Atomic] = ACTIONS(1472),
    [anon_sym__Noreturn] = ACTIONS(1472),
    [anon_sym_noreturn] = ACTIONS(1472),
    [sym_primitive_type] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_struct] = ACTIONS(1472),
    [anon_sym_union] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_goto] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [anon_sym_sizeof] = ACTIONS(1472),
    [anon_sym___alignof__] = ACTIONS(1472),
    [anon_sym___alignof] = ACTIONS(1472),
    [anon_sym__alignof] = ACTIONS(1472),
    [anon_sym_alignof] = ACTIONS(1472),
    [anon_sym__Alignof] = ACTIONS(1472),
    [anon_sym_offsetof] = ACTIONS(1472),
    [anon_sym__Generic] = ACTIONS(1472),
    [anon_sym_asm] = ACTIONS(1472),
    [anon_sym___asm__] = ACTIONS(1472),
    [sym_number_literal] = ACTIONS(1474),
    [anon_sym_L_SQUOTE] = ACTIONS(1474),
    [anon_sym_u_SQUOTE] = ACTIONS(1474),
    [anon_sym_U_SQUOTE] = ACTIONS(1474),
    [anon_sym_u8_SQUOTE] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_L_DQUOTE] = ACTIONS(1474),
    [anon_sym_u_DQUOTE] = ACTIONS(1474),
    [anon_sym_U_DQUOTE] = ACTIONS(1474),
    [anon_sym_u8_DQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [anon_sym_NULL] = ACTIONS(1472),
    [anon_sym_nullptr] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1472),
    [anon_sym_acquire] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_monitor] = ACTIONS(1472),
    [anon_sym_start] = ACTIONS(1472),
    [anon_sym_stop] = ACTIONS(1472),
  },
  [99] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_include_token1] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token2] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [aux_sym_preproc_else_token1] = ACTIONS(1476),
    [aux_sym_preproc_elif_token1] = ACTIONS(1476),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_LPAREN2] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym___extension__] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym___cdecl] = ACTIONS(1476),
    [anon_sym___clrcall] = ACTIONS(1476),
    [anon_sym___stdcall] = ACTIONS(1476),
    [anon_sym___fastcall] = ACTIONS(1476),
    [anon_sym___thiscall] = ACTIONS(1476),
    [anon_sym___vectorcall] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym___inline] = ACTIONS(1476),
    [anon_sym___inline__] = ACTIONS(1476),
    [anon_sym___forceinline] = ACTIONS(1476),
    [anon_sym_thread_local] = ACTIONS(1476),
    [anon_sym___thread] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_constexpr] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym___restrict__] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym__Noreturn] = ACTIONS(1476),
    [anon_sym_noreturn] = ACTIONS(1476),
    [sym_primitive_type] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_switch] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_default] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_do] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_goto] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_sizeof] = ACTIONS(1476),
    [anon_sym___alignof__] = ACTIONS(1476),
    [anon_sym___alignof] = ACTIONS(1476),
    [anon_sym__alignof] = ACTIONS(1476),
    [anon_sym_alignof] = ACTIONS(1476),
    [anon_sym__Alignof] = ACTIONS(1476),
    [anon_sym_offsetof] = ACTIONS(1476),
    [anon_sym__Generic] = ACTIONS(1476),
    [anon_sym_asm] = ACTIONS(1476),
    [anon_sym___asm__] = ACTIONS(1476),
    [sym_number_literal] = ACTIONS(1478),
    [anon_sym_L_SQUOTE] = ACTIONS(1478),
    [anon_sym_u_SQUOTE] = ACTIONS(1478),
    [anon_sym_U_SQUOTE] = ACTIONS(1478),
    [anon_sym_u8_SQUOTE] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_L_DQUOTE] = ACTIONS(1478),
    [anon_sym_u_DQUOTE] = ACTIONS(1478),
    [anon_sym_U_DQUOTE] = ACTIONS(1478),
    [anon_sym_u8_DQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [anon_sym_NULL] = ACTIONS(1476),
    [anon_sym_nullptr] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1476),
    [anon_sym_acquire] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_monitor] = ACTIONS(1476),
    [anon_sym_start] = ACTIONS(1476),
    [anon_sym_stop] = ACTIONS(1476),
  },
  [100] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_include_token1] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token2] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [aux_sym_preproc_else_token1] = ACTIONS(1480),
    [aux_sym_preproc_elif_token1] = ACTIONS(1480),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_LPAREN2] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym___extension__] = ACTIONS(1480),
    [anon_sym_typedef] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym___cdecl] = ACTIONS(1480),
    [anon_sym___clrcall] = ACTIONS(1480),
    [anon_sym___stdcall] = ACTIONS(1480),
    [anon_sym___fastcall] = ACTIONS(1480),
    [anon_sym___thiscall] = ACTIONS(1480),
    [anon_sym___vectorcall] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym___inline] = ACTIONS(1480),
    [anon_sym___inline__] = ACTIONS(1480),
    [anon_sym___forceinline] = ACTIONS(1480),
    [anon_sym_thread_local] = ACTIONS(1480),
    [anon_sym___thread] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_constexpr] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym___restrict__] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym__Noreturn] = ACTIONS(1480),
    [anon_sym_noreturn] = ACTIONS(1480),
    [sym_primitive_type] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_switch] = ACTIONS(1480),
    [anon_sym_case] = ACTIONS(1480),
    [anon_sym_default] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_do] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_goto] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_sizeof] = ACTIONS(1480),
    [anon_sym___alignof__] = ACTIONS(1480),
    [anon_sym___alignof] = ACTIONS(1480),
    [anon_sym__alignof] = ACTIONS(1480),
    [anon_sym_alignof] = ACTIONS(1480),
    [anon_sym__Alignof] = ACTIONS(1480),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1480),
    [anon_sym_asm] = ACTIONS(1480),
    [anon_sym___asm__] = ACTIONS(1480),
    [sym_number_literal] = ACTIONS(1482),
    [anon_sym_L_SQUOTE] = ACTIONS(1482),
    [anon_sym_u_SQUOTE] = ACTIONS(1482),
    [anon_sym_U_SQUOTE] = ACTIONS(1482),
    [anon_sym_u8_SQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_L_DQUOTE] = ACTIONS(1482),
    [anon_sym_u_DQUOTE] = ACTIONS(1482),
    [anon_sym_U_DQUOTE] = ACTIONS(1482),
    [anon_sym_u8_DQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [anon_sym_NULL] = ACTIONS(1480),
    [anon_sym_nullptr] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1480),
    [anon_sym_acquire] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_monitor] = ACTIONS(1480),
    [anon_sym_start] = ACTIONS(1480),
    [anon_sym_stop] = ACTIONS(1480),
  },
  [101] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_include_token1] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token2] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [aux_sym_preproc_else_token1] = ACTIONS(1484),
    [aux_sym_preproc_elif_token1] = ACTIONS(1484),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_LPAREN2] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym___extension__] = ACTIONS(1484),
    [anon_sym_typedef] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym___cdecl] = ACTIONS(1484),
    [anon_sym___clrcall] = ACTIONS(1484),
    [anon_sym___stdcall] = ACTIONS(1484),
    [anon_sym___fastcall] = ACTIONS(1484),
    [anon_sym___thiscall] = ACTIONS(1484),
    [anon_sym___vectorcall] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym___inline] = ACTIONS(1484),
    [anon_sym___inline__] = ACTIONS(1484),
    [anon_sym___forceinline] = ACTIONS(1484),
    [anon_sym_thread_local] = ACTIONS(1484),
    [anon_sym___thread] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_constexpr] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym___restrict__] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym__Noreturn] = ACTIONS(1484),
    [anon_sym_noreturn] = ACTIONS(1484),
    [sym_primitive_type] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_goto] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_sizeof] = ACTIONS(1484),
    [anon_sym___alignof__] = ACTIONS(1484),
    [anon_sym___alignof] = ACTIONS(1484),
    [anon_sym__alignof] = ACTIONS(1484),
    [anon_sym_alignof] = ACTIONS(1484),
    [anon_sym__Alignof] = ACTIONS(1484),
    [anon_sym_offsetof] = ACTIONS(1484),
    [anon_sym__Generic] = ACTIONS(1484),
    [anon_sym_asm] = ACTIONS(1484),
    [anon_sym___asm__] = ACTIONS(1484),
    [sym_number_literal] = ACTIONS(1486),
    [anon_sym_L_SQUOTE] = ACTIONS(1486),
    [anon_sym_u_SQUOTE] = ACTIONS(1486),
    [anon_sym_U_SQUOTE] = ACTIONS(1486),
    [anon_sym_u8_SQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_L_DQUOTE] = ACTIONS(1486),
    [anon_sym_u_DQUOTE] = ACTIONS(1486),
    [anon_sym_U_DQUOTE] = ACTIONS(1486),
    [anon_sym_u8_DQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [anon_sym_NULL] = ACTIONS(1484),
    [anon_sym_nullptr] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1484),
    [anon_sym_acquire] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_monitor] = ACTIONS(1484),
    [anon_sym_start] = ACTIONS(1484),
    [anon_sym_stop] = ACTIONS(1484),
  },
  [102] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_include_token1] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token2] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [aux_sym_preproc_else_token1] = ACTIONS(1488),
    [aux_sym_preproc_elif_token1] = ACTIONS(1488),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_LPAREN2] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym___extension__] = ACTIONS(1488),
    [anon_sym_typedef] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym___cdecl] = ACTIONS(1488),
    [anon_sym___clrcall] = ACTIONS(1488),
    [anon_sym___stdcall] = ACTIONS(1488),
    [anon_sym___fastcall] = ACTIONS(1488),
    [anon_sym___thiscall] = ACTIONS(1488),
    [anon_sym___vectorcall] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym___inline] = ACTIONS(1488),
    [anon_sym___inline__] = ACTIONS(1488),
    [anon_sym___forceinline] = ACTIONS(1488),
    [anon_sym_thread_local] = ACTIONS(1488),
    [anon_sym___thread] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_constexpr] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym___restrict__] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym__Noreturn] = ACTIONS(1488),
    [anon_sym_noreturn] = ACTIONS(1488),
    [sym_primitive_type] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_goto] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_sizeof] = ACTIONS(1488),
    [anon_sym___alignof__] = ACTIONS(1488),
    [anon_sym___alignof] = ACTIONS(1488),
    [anon_sym__alignof] = ACTIONS(1488),
    [anon_sym_alignof] = ACTIONS(1488),
    [anon_sym__Alignof] = ACTIONS(1488),
    [anon_sym_offsetof] = ACTIONS(1488),
    [anon_sym__Generic] = ACTIONS(1488),
    [anon_sym_asm] = ACTIONS(1488),
    [anon_sym___asm__] = ACTIONS(1488),
    [sym_number_literal] = ACTIONS(1490),
    [anon_sym_L_SQUOTE] = ACTIONS(1490),
    [anon_sym_u_SQUOTE] = ACTIONS(1490),
    [anon_sym_U_SQUOTE] = ACTIONS(1490),
    [anon_sym_u8_SQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_L_DQUOTE] = ACTIONS(1490),
    [anon_sym_u_DQUOTE] = ACTIONS(1490),
    [anon_sym_U_DQUOTE] = ACTIONS(1490),
    [anon_sym_u8_DQUOTE] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [anon_sym_NULL] = ACTIONS(1488),
    [anon_sym_nullptr] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1488),
    [anon_sym_acquire] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_monitor] = ACTIONS(1488),
    [anon_sym_start] = ACTIONS(1488),
    [anon_sym_stop] = ACTIONS(1488),
  },
  [103] = {
    [sym_identifier] = ACTIONS(1492),
    [aux_sym_preproc_include_token1] = ACTIONS(1492),
    [aux_sym_preproc_def_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token2] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1492),
    [aux_sym_preproc_else_token1] = ACTIONS(1492),
    [aux_sym_preproc_elif_token1] = ACTIONS(1492),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1492),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1492),
    [sym_preproc_directive] = ACTIONS(1492),
    [anon_sym_LPAREN2] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym___extension__] = ACTIONS(1492),
    [anon_sym_typedef] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym___attribute__] = ACTIONS(1492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1494),
    [anon_sym___declspec] = ACTIONS(1492),
    [anon_sym___cdecl] = ACTIONS(1492),
    [anon_sym___clrcall] = ACTIONS(1492),
    [anon_sym___stdcall] = ACTIONS(1492),
    [anon_sym___fastcall] = ACTIONS(1492),
    [anon_sym___thiscall] = ACTIONS(1492),
    [anon_sym___vectorcall] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_signed] = ACTIONS(1492),
    [anon_sym_unsigned] = ACTIONS(1492),
    [anon_sym_long] = ACTIONS(1492),
    [anon_sym_short] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_auto] = ACTIONS(1492),
    [anon_sym_register] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym___inline] = ACTIONS(1492),
    [anon_sym___inline__] = ACTIONS(1492),
    [anon_sym___forceinline] = ACTIONS(1492),
    [anon_sym_thread_local] = ACTIONS(1492),
    [anon_sym___thread] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_constexpr] = ACTIONS(1492),
    [anon_sym_volatile] = ACTIONS(1492),
    [anon_sym_restrict] = ACTIONS(1492),
    [anon_sym___restrict__] = ACTIONS(1492),
    [anon_sym__Atomic] = ACTIONS(1492),
    [anon_sym__Noreturn] = ACTIONS(1492),
    [anon_sym_noreturn] = ACTIONS(1492),
    [sym_primitive_type] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_struct] = ACTIONS(1492),
    [anon_sym_union] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_goto] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_sizeof] = ACTIONS(1492),
    [anon_sym___alignof__] = ACTIONS(1492),
    [anon_sym___alignof] = ACTIONS(1492),
    [anon_sym__alignof] = ACTIONS(1492),
    [anon_sym_alignof] = ACTIONS(1492),
    [anon_sym__Alignof] = ACTIONS(1492),
    [anon_sym_offsetof] = ACTIONS(1492),
    [anon_sym__Generic] = ACTIONS(1492),
    [anon_sym_asm] = ACTIONS(1492),
    [anon_sym___asm__] = ACTIONS(1492),
    [sym_number_literal] = ACTIONS(1494),
    [anon_sym_L_SQUOTE] = ACTIONS(1494),
    [anon_sym_u_SQUOTE] = ACTIONS(1494),
    [anon_sym_U_SQUOTE] = ACTIONS(1494),
    [anon_sym_u8_SQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_L_DQUOTE] = ACTIONS(1494),
    [anon_sym_u_DQUOTE] = ACTIONS(1494),
    [anon_sym_U_DQUOTE] = ACTIONS(1494),
    [anon_sym_u8_DQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [anon_sym_NULL] = ACTIONS(1492),
    [anon_sym_nullptr] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1492),
    [anon_sym_acquire] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_monitor] = ACTIONS(1492),
    [anon_sym_start] = ACTIONS(1492),
    [anon_sym_stop] = ACTIONS(1492),
  },
  [104] = {
    [sym_identifier] = ACTIONS(1496),
    [aux_sym_preproc_include_token1] = ACTIONS(1496),
    [aux_sym_preproc_def_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token2] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1496),
    [aux_sym_preproc_else_token1] = ACTIONS(1496),
    [aux_sym_preproc_elif_token1] = ACTIONS(1496),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1496),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1496),
    [sym_preproc_directive] = ACTIONS(1496),
    [anon_sym_LPAREN2] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym___extension__] = ACTIONS(1496),
    [anon_sym_typedef] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym___attribute__] = ACTIONS(1496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1498),
    [anon_sym___declspec] = ACTIONS(1496),
    [anon_sym___cdecl] = ACTIONS(1496),
    [anon_sym___clrcall] = ACTIONS(1496),
    [anon_sym___stdcall] = ACTIONS(1496),
    [anon_sym___fastcall] = ACTIONS(1496),
    [anon_sym___thiscall] = ACTIONS(1496),
    [anon_sym___vectorcall] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_signed] = ACTIONS(1496),
    [anon_sym_unsigned] = ACTIONS(1496),
    [anon_sym_long] = ACTIONS(1496),
    [anon_sym_short] = ACTIONS(1496),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_auto] = ACTIONS(1496),
    [anon_sym_register] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym___inline] = ACTIONS(1496),
    [anon_sym___inline__] = ACTIONS(1496),
    [anon_sym___forceinline] = ACTIONS(1496),
    [anon_sym_thread_local] = ACTIONS(1496),
    [anon_sym___thread] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_constexpr] = ACTIONS(1496),
    [anon_sym_volatile] = ACTIONS(1496),
    [anon_sym_restrict] = ACTIONS(1496),
    [anon_sym___restrict__] = ACTIONS(1496),
    [anon_sym__Atomic] = ACTIONS(1496),
    [anon_sym__Noreturn] = ACTIONS(1496),
    [anon_sym_noreturn] = ACTIONS(1496),
    [sym_primitive_type] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_struct] = ACTIONS(1496),
    [anon_sym_union] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_goto] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_sizeof] = ACTIONS(1496),
    [anon_sym___alignof__] = ACTIONS(1496),
    [anon_sym___alignof] = ACTIONS(1496),
    [anon_sym__alignof] = ACTIONS(1496),
    [anon_sym_alignof] = ACTIONS(1496),
    [anon_sym__Alignof] = ACTIONS(1496),
    [anon_sym_offsetof] = ACTIONS(1496),
    [anon_sym__Generic] = ACTIONS(1496),
    [anon_sym_asm] = ACTIONS(1496),
    [anon_sym___asm__] = ACTIONS(1496),
    [sym_number_literal] = ACTIONS(1498),
    [anon_sym_L_SQUOTE] = ACTIONS(1498),
    [anon_sym_u_SQUOTE] = ACTIONS(1498),
    [anon_sym_U_SQUOTE] = ACTIONS(1498),
    [anon_sym_u8_SQUOTE] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_L_DQUOTE] = ACTIONS(1498),
    [anon_sym_u_DQUOTE] = ACTIONS(1498),
    [anon_sym_U_DQUOTE] = ACTIONS(1498),
    [anon_sym_u8_DQUOTE] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [anon_sym_NULL] = ACTIONS(1496),
    [anon_sym_nullptr] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1496),
    [anon_sym_acquire] = ACTIONS(1496),
    [anon_sym_catch] = ACTIONS(1496),
    [anon_sym_monitor] = ACTIONS(1496),
    [anon_sym_start] = ACTIONS(1496),
    [anon_sym_stop] = ACTIONS(1496),
  },
  [105] = {
    [sym_identifier] = ACTIONS(1500),
    [aux_sym_preproc_include_token1] = ACTIONS(1500),
    [aux_sym_preproc_def_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token2] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1500),
    [aux_sym_preproc_else_token1] = ACTIONS(1500),
    [aux_sym_preproc_elif_token1] = ACTIONS(1500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1500),
    [sym_preproc_directive] = ACTIONS(1500),
    [anon_sym_LPAREN2] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym___extension__] = ACTIONS(1500),
    [anon_sym_typedef] = ACTIONS(1500),
    [anon_sym_extern] = ACTIONS(1500),
    [anon_sym___attribute__] = ACTIONS(1500),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1502),
    [anon_sym___declspec] = ACTIONS(1500),
    [anon_sym___cdecl] = ACTIONS(1500),
    [anon_sym___clrcall] = ACTIONS(1500),
    [anon_sym___stdcall] = ACTIONS(1500),
    [anon_sym___fastcall] = ACTIONS(1500),
    [anon_sym___thiscall] = ACTIONS(1500),
    [anon_sym___vectorcall] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_signed] = ACTIONS(1500),
    [anon_sym_unsigned] = ACTIONS(1500),
    [anon_sym_long] = ACTIONS(1500),
    [anon_sym_short] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1500),
    [anon_sym_auto] = ACTIONS(1500),
    [anon_sym_register] = ACTIONS(1500),
    [anon_sym_inline] = ACTIONS(1500),
    [anon_sym___inline] = ACTIONS(1500),
    [anon_sym___inline__] = ACTIONS(1500),
    [anon_sym___forceinline] = ACTIONS(1500),
    [anon_sym_thread_local] = ACTIONS(1500),
    [anon_sym___thread] = ACTIONS(1500),
    [anon_sym_const] = ACTIONS(1500),
    [anon_sym_constexpr] = ACTIONS(1500),
    [anon_sym_volatile] = ACTIONS(1500),
    [anon_sym_restrict] = ACTIONS(1500),
    [anon_sym___restrict__] = ACTIONS(1500),
    [anon_sym__Atomic] = ACTIONS(1500),
    [anon_sym__Noreturn] = ACTIONS(1500),
    [anon_sym_noreturn] = ACTIONS(1500),
    [sym_primitive_type] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1500),
    [anon_sym_struct] = ACTIONS(1500),
    [anon_sym_union] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1500),
    [anon_sym_switch] = ACTIONS(1500),
    [anon_sym_case] = ACTIONS(1500),
    [anon_sym_default] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_do] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_break] = ACTIONS(1500),
    [anon_sym_continue] = ACTIONS(1500),
    [anon_sym_goto] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_sizeof] = ACTIONS(1500),
    [anon_sym___alignof__] = ACTIONS(1500),
    [anon_sym___alignof] = ACTIONS(1500),
    [anon_sym__alignof] = ACTIONS(1500),
    [anon_sym_alignof] = ACTIONS(1500),
    [anon_sym__Alignof] = ACTIONS(1500),
    [anon_sym_offsetof] = ACTIONS(1500),
    [anon_sym__Generic] = ACTIONS(1500),
    [anon_sym_asm] = ACTIONS(1500),
    [anon_sym___asm__] = ACTIONS(1500),
    [sym_number_literal] = ACTIONS(1502),
    [anon_sym_L_SQUOTE] = ACTIONS(1502),
    [anon_sym_u_SQUOTE] = ACTIONS(1502),
    [anon_sym_U_SQUOTE] = ACTIONS(1502),
    [anon_sym_u8_SQUOTE] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_L_DQUOTE] = ACTIONS(1502),
    [anon_sym_u_DQUOTE] = ACTIONS(1502),
    [anon_sym_U_DQUOTE] = ACTIONS(1502),
    [anon_sym_u8_DQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [anon_sym_NULL] = ACTIONS(1500),
    [anon_sym_nullptr] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1500),
    [anon_sym_acquire] = ACTIONS(1500),
    [anon_sym_catch] = ACTIONS(1500),
    [anon_sym_monitor] = ACTIONS(1500),
    [anon_sym_start] = ACTIONS(1500),
    [anon_sym_stop] = ACTIONS(1500),
  },
  [106] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [107] = {
    [sym_catch_clause] = STATE(109),
    [aux_sym_monitor_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_include_token1] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token2] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [aux_sym_preproc_else_token1] = ACTIONS(1440),
    [aux_sym_preproc_elif_token1] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym___extension__] = ACTIONS(1440),
    [anon_sym_typedef] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym___cdecl] = ACTIONS(1440),
    [anon_sym___clrcall] = ACTIONS(1440),
    [anon_sym___stdcall] = ACTIONS(1440),
    [anon_sym___fastcall] = ACTIONS(1440),
    [anon_sym___thiscall] = ACTIONS(1440),
    [anon_sym___vectorcall] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym___inline] = ACTIONS(1440),
    [anon_sym___inline__] = ACTIONS(1440),
    [anon_sym___forceinline] = ACTIONS(1440),
    [anon_sym_thread_local] = ACTIONS(1440),
    [anon_sym___thread] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym___restrict__] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym__Noreturn] = ACTIONS(1440),
    [anon_sym_noreturn] = ACTIONS(1440),
    [sym_primitive_type] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_switch] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_do] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_goto] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_sizeof] = ACTIONS(1440),
    [anon_sym___alignof__] = ACTIONS(1440),
    [anon_sym___alignof] = ACTIONS(1440),
    [anon_sym__alignof] = ACTIONS(1440),
    [anon_sym_alignof] = ACTIONS(1440),
    [anon_sym__Alignof] = ACTIONS(1440),
    [anon_sym_offsetof] = ACTIONS(1440),
    [anon_sym__Generic] = ACTIONS(1440),
    [anon_sym_asm] = ACTIONS(1440),
    [anon_sym___asm__] = ACTIONS(1440),
    [sym_number_literal] = ACTIONS(1442),
    [anon_sym_L_SQUOTE] = ACTIONS(1442),
    [anon_sym_u_SQUOTE] = ACTIONS(1442),
    [anon_sym_U_SQUOTE] = ACTIONS(1442),
    [anon_sym_u8_SQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_L_DQUOTE] = ACTIONS(1442),
    [anon_sym_u_DQUOTE] = ACTIONS(1442),
    [anon_sym_U_DQUOTE] = ACTIONS(1442),
    [anon_sym_u8_DQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [anon_sym_NULL] = ACTIONS(1440),
    [anon_sym_nullptr] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1440),
    [anon_sym_acquire] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1504),
    [anon_sym_monitor] = ACTIONS(1440),
    [anon_sym_start] = ACTIONS(1440),
    [anon_sym_stop] = ACTIONS(1440),
  },
  [108] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token2] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [aux_sym_preproc_else_token1] = ACTIONS(1506),
    [aux_sym_preproc_elif_token1] = ACTIONS(1506),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1506),
    [anon_sym_acquire] = ACTIONS(1506),
    [anon_sym_catch] = ACTIONS(1506),
    [anon_sym_monitor] = ACTIONS(1506),
    [anon_sym_start] = ACTIONS(1506),
    [anon_sym_stop] = ACTIONS(1506),
  },
  [109] = {
    [sym_catch_clause] = STATE(109),
    [aux_sym_monitor_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [aux_sym_preproc_else_token1] = ACTIONS(1433),
    [aux_sym_preproc_elif_token1] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_acquire] = ACTIONS(1433),
    [anon_sym_catch] = ACTIONS(1510),
    [anon_sym_monitor] = ACTIONS(1433),
    [anon_sym_start] = ACTIONS(1433),
    [anon_sym_stop] = ACTIONS(1433),
  },
  [110] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token2] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [aux_sym_preproc_else_token1] = ACTIONS(1513),
    [aux_sym_preproc_elif_token1] = ACTIONS(1513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1515),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1515),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_else] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1515),
    [anon_sym_L_SQUOTE] = ACTIONS(1515),
    [anon_sym_u_SQUOTE] = ACTIONS(1515),
    [anon_sym_U_SQUOTE] = ACTIONS(1515),
    [anon_sym_u8_SQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [anon_sym_L_DQUOTE] = ACTIONS(1515),
    [anon_sym_u_DQUOTE] = ACTIONS(1515),
    [anon_sym_U_DQUOTE] = ACTIONS(1515),
    [anon_sym_u8_DQUOTE] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1513),
    [anon_sym_acquire] = ACTIONS(1513),
    [anon_sym_catch] = ACTIONS(1513),
    [anon_sym_monitor] = ACTIONS(1513),
    [anon_sym_start] = ACTIONS(1513),
    [anon_sym_stop] = ACTIONS(1513),
  },
  [111] = {
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1517),
    [aux_sym_preproc_def_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token2] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1517),
    [aux_sym_preproc_else_token1] = ACTIONS(1517),
    [aux_sym_preproc_elif_token1] = ACTIONS(1517),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1517),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1517),
    [sym_preproc_directive] = ACTIONS(1517),
    [anon_sym_LPAREN2] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1517),
    [anon_sym_typedef] = ACTIONS(1517),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym___attribute__] = ACTIONS(1517),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1519),
    [anon_sym___declspec] = ACTIONS(1517),
    [anon_sym___cdecl] = ACTIONS(1517),
    [anon_sym___clrcall] = ACTIONS(1517),
    [anon_sym___stdcall] = ACTIONS(1517),
    [anon_sym___fastcall] = ACTIONS(1517),
    [anon_sym___thiscall] = ACTIONS(1517),
    [anon_sym___vectorcall] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_signed] = ACTIONS(1517),
    [anon_sym_unsigned] = ACTIONS(1517),
    [anon_sym_long] = ACTIONS(1517),
    [anon_sym_short] = ACTIONS(1517),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_auto] = ACTIONS(1517),
    [anon_sym_register] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1517),
    [anon_sym___inline] = ACTIONS(1517),
    [anon_sym___inline__] = ACTIONS(1517),
    [anon_sym___forceinline] = ACTIONS(1517),
    [anon_sym_thread_local] = ACTIONS(1517),
    [anon_sym___thread] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_constexpr] = ACTIONS(1517),
    [anon_sym_volatile] = ACTIONS(1517),
    [anon_sym_restrict] = ACTIONS(1517),
    [anon_sym___restrict__] = ACTIONS(1517),
    [anon_sym__Atomic] = ACTIONS(1517),
    [anon_sym__Noreturn] = ACTIONS(1517),
    [anon_sym_noreturn] = ACTIONS(1517),
    [sym_primitive_type] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [anon_sym_struct] = ACTIONS(1517),
    [anon_sym_union] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_goto] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1519),
    [anon_sym_sizeof] = ACTIONS(1517),
    [anon_sym___alignof__] = ACTIONS(1517),
    [anon_sym___alignof] = ACTIONS(1517),
    [anon_sym__alignof] = ACTIONS(1517),
    [anon_sym_alignof] = ACTIONS(1517),
    [anon_sym__Alignof] = ACTIONS(1517),
    [anon_sym_offsetof] = ACTIONS(1517),
    [anon_sym__Generic] = ACTIONS(1517),
    [anon_sym_asm] = ACTIONS(1517),
    [anon_sym___asm__] = ACTIONS(1517),
    [sym_number_literal] = ACTIONS(1519),
    [anon_sym_L_SQUOTE] = ACTIONS(1519),
    [anon_sym_u_SQUOTE] = ACTIONS(1519),
    [anon_sym_U_SQUOTE] = ACTIONS(1519),
    [anon_sym_u8_SQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_L_DQUOTE] = ACTIONS(1519),
    [anon_sym_u_DQUOTE] = ACTIONS(1519),
    [anon_sym_U_DQUOTE] = ACTIONS(1519),
    [anon_sym_u8_DQUOTE] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [anon_sym_NULL] = ACTIONS(1517),
    [anon_sym_nullptr] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1517),
    [anon_sym_acquire] = ACTIONS(1517),
    [anon_sym_catch] = ACTIONS(1517),
    [anon_sym_monitor] = ACTIONS(1517),
    [anon_sym_start] = ACTIONS(1517),
    [anon_sym_stop] = ACTIONS(1517),
  },
  [112] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [113] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [114] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [115] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [116] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [117] = {
    [sym_identifier] = ACTIONS(1521),
    [aux_sym_preproc_include_token1] = ACTIONS(1521),
    [aux_sym_preproc_def_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token2] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1521),
    [aux_sym_preproc_else_token1] = ACTIONS(1521),
    [aux_sym_preproc_elif_token1] = ACTIONS(1521),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1521),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1521),
    [sym_preproc_directive] = ACTIONS(1521),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1521),
    [anon_sym_typedef] = ACTIONS(1521),
    [anon_sym_extern] = ACTIONS(1521),
    [anon_sym___attribute__] = ACTIONS(1521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1523),
    [anon_sym___declspec] = ACTIONS(1521),
    [anon_sym___cdecl] = ACTIONS(1521),
    [anon_sym___clrcall] = ACTIONS(1521),
    [anon_sym___stdcall] = ACTIONS(1521),
    [anon_sym___fastcall] = ACTIONS(1521),
    [anon_sym___thiscall] = ACTIONS(1521),
    [anon_sym___vectorcall] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_signed] = ACTIONS(1521),
    [anon_sym_unsigned] = ACTIONS(1521),
    [anon_sym_long] = ACTIONS(1521),
    [anon_sym_short] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1521),
    [anon_sym_auto] = ACTIONS(1521),
    [anon_sym_register] = ACTIONS(1521),
    [anon_sym_inline] = ACTIONS(1521),
    [anon_sym___inline] = ACTIONS(1521),
    [anon_sym___inline__] = ACTIONS(1521),
    [anon_sym___forceinline] = ACTIONS(1521),
    [anon_sym_thread_local] = ACTIONS(1521),
    [anon_sym___thread] = ACTIONS(1521),
    [anon_sym_const] = ACTIONS(1521),
    [anon_sym_constexpr] = ACTIONS(1521),
    [anon_sym_volatile] = ACTIONS(1521),
    [anon_sym_restrict] = ACTIONS(1521),
    [anon_sym___restrict__] = ACTIONS(1521),
    [anon_sym__Atomic] = ACTIONS(1521),
    [anon_sym__Noreturn] = ACTIONS(1521),
    [anon_sym_noreturn] = ACTIONS(1521),
    [sym_primitive_type] = ACTIONS(1521),
    [anon_sym_enum] = ACTIONS(1521),
    [anon_sym_struct] = ACTIONS(1521),
    [anon_sym_union] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_do] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_return] = ACTIONS(1521),
    [anon_sym_break] = ACTIONS(1521),
    [anon_sym_continue] = ACTIONS(1521),
    [anon_sym_goto] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_sizeof] = ACTIONS(1521),
    [anon_sym___alignof__] = ACTIONS(1521),
    [anon_sym___alignof] = ACTIONS(1521),
    [anon_sym__alignof] = ACTIONS(1521),
    [anon_sym_alignof] = ACTIONS(1521),
    [anon_sym__Alignof] = ACTIONS(1521),
    [anon_sym_offsetof] = ACTIONS(1521),
    [anon_sym__Generic] = ACTIONS(1521),
    [anon_sym_asm] = ACTIONS(1521),
    [anon_sym___asm__] = ACTIONS(1521),
    [sym_number_literal] = ACTIONS(1523),
    [anon_sym_L_SQUOTE] = ACTIONS(1523),
    [anon_sym_u_SQUOTE] = ACTIONS(1523),
    [anon_sym_U_SQUOTE] = ACTIONS(1523),
    [anon_sym_u8_SQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_L_DQUOTE] = ACTIONS(1523),
    [anon_sym_u_DQUOTE] = ACTIONS(1523),
    [anon_sym_U_DQUOTE] = ACTIONS(1523),
    [anon_sym_u8_DQUOTE] = ACTIONS(1523),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [anon_sym_NULL] = ACTIONS(1521),
    [anon_sym_nullptr] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1521),
    [anon_sym_acquire] = ACTIONS(1521),
    [anon_sym_catch] = ACTIONS(1521),
    [anon_sym_monitor] = ACTIONS(1521),
    [anon_sym_start] = ACTIONS(1521),
    [anon_sym_stop] = ACTIONS(1521),
  },
  [118] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [119] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [120] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [121] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [122] = {
    [sym_identifier] = ACTIONS(1525),
    [aux_sym_preproc_include_token1] = ACTIONS(1525),
    [aux_sym_preproc_def_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token2] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1525),
    [aux_sym_preproc_else_token1] = ACTIONS(1525),
    [aux_sym_preproc_elif_token1] = ACTIONS(1525),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1525),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1525),
    [sym_preproc_directive] = ACTIONS(1525),
    [anon_sym_LPAREN2] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1525),
    [anon_sym_typedef] = ACTIONS(1525),
    [anon_sym_extern] = ACTIONS(1525),
    [anon_sym___attribute__] = ACTIONS(1525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1527),
    [anon_sym___declspec] = ACTIONS(1525),
    [anon_sym___cdecl] = ACTIONS(1525),
    [anon_sym___clrcall] = ACTIONS(1525),
    [anon_sym___stdcall] = ACTIONS(1525),
    [anon_sym___fastcall] = ACTIONS(1525),
    [anon_sym___thiscall] = ACTIONS(1525),
    [anon_sym___vectorcall] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_signed] = ACTIONS(1525),
    [anon_sym_unsigned] = ACTIONS(1525),
    [anon_sym_long] = ACTIONS(1525),
    [anon_sym_short] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1525),
    [anon_sym_auto] = ACTIONS(1525),
    [anon_sym_register] = ACTIONS(1525),
    [anon_sym_inline] = ACTIONS(1525),
    [anon_sym___inline] = ACTIONS(1525),
    [anon_sym___inline__] = ACTIONS(1525),
    [anon_sym___forceinline] = ACTIONS(1525),
    [anon_sym_thread_local] = ACTIONS(1525),
    [anon_sym___thread] = ACTIONS(1525),
    [anon_sym_const] = ACTIONS(1525),
    [anon_sym_constexpr] = ACTIONS(1525),
    [anon_sym_volatile] = ACTIONS(1525),
    [anon_sym_restrict] = ACTIONS(1525),
    [anon_sym___restrict__] = ACTIONS(1525),
    [anon_sym__Atomic] = ACTIONS(1525),
    [anon_sym__Noreturn] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [sym_primitive_type] = ACTIONS(1525),
    [anon_sym_enum] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1525),
    [anon_sym_union] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_do] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_return] = ACTIONS(1525),
    [anon_sym_break] = ACTIONS(1525),
    [anon_sym_continue] = ACTIONS(1525),
    [anon_sym_goto] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_sizeof] = ACTIONS(1525),
    [anon_sym___alignof__] = ACTIONS(1525),
    [anon_sym___alignof] = ACTIONS(1525),
    [anon_sym__alignof] = ACTIONS(1525),
    [anon_sym_alignof] = ACTIONS(1525),
    [anon_sym__Alignof] = ACTIONS(1525),
    [anon_sym_offsetof] = ACTIONS(1525),
    [anon_sym__Generic] = ACTIONS(1525),
    [anon_sym_asm] = ACTIONS(1525),
    [anon_sym___asm__] = ACTIONS(1525),
    [sym_number_literal] = ACTIONS(1527),
    [anon_sym_L_SQUOTE] = ACTIONS(1527),
    [anon_sym_u_SQUOTE] = ACTIONS(1527),
    [anon_sym_U_SQUOTE] = ACTIONS(1527),
    [anon_sym_u8_SQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [anon_sym_L_DQUOTE] = ACTIONS(1527),
    [anon_sym_u_DQUOTE] = ACTIONS(1527),
    [anon_sym_U_DQUOTE] = ACTIONS(1527),
    [anon_sym_u8_DQUOTE] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [anon_sym_NULL] = ACTIONS(1525),
    [anon_sym_nullptr] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1525),
    [anon_sym_acquire] = ACTIONS(1525),
    [anon_sym_catch] = ACTIONS(1525),
    [anon_sym_monitor] = ACTIONS(1525),
    [anon_sym_start] = ACTIONS(1525),
    [anon_sym_stop] = ACTIONS(1525),
  },
  [123] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [124] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [125] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [126] = {
    [sym_identifier] = ACTIONS(1529),
    [aux_sym_preproc_include_token1] = ACTIONS(1529),
    [aux_sym_preproc_def_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token2] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1529),
    [aux_sym_preproc_else_token1] = ACTIONS(1529),
    [aux_sym_preproc_elif_token1] = ACTIONS(1529),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1529),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1529),
    [sym_preproc_directive] = ACTIONS(1529),
    [anon_sym_LPAREN2] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1529),
    [anon_sym_typedef] = ACTIONS(1529),
    [anon_sym_extern] = ACTIONS(1529),
    [anon_sym___attribute__] = ACTIONS(1529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1531),
    [anon_sym___declspec] = ACTIONS(1529),
    [anon_sym___cdecl] = ACTIONS(1529),
    [anon_sym___clrcall] = ACTIONS(1529),
    [anon_sym___stdcall] = ACTIONS(1529),
    [anon_sym___fastcall] = ACTIONS(1529),
    [anon_sym___thiscall] = ACTIONS(1529),
    [anon_sym___vectorcall] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_signed] = ACTIONS(1529),
    [anon_sym_unsigned] = ACTIONS(1529),
    [anon_sym_long] = ACTIONS(1529),
    [anon_sym_short] = ACTIONS(1529),
    [anon_sym_static] = ACTIONS(1529),
    [anon_sym_auto] = ACTIONS(1529),
    [anon_sym_register] = ACTIONS(1529),
    [anon_sym_inline] = ACTIONS(1529),
    [anon_sym___inline] = ACTIONS(1529),
    [anon_sym___inline__] = ACTIONS(1529),
    [anon_sym___forceinline] = ACTIONS(1529),
    [anon_sym_thread_local] = ACTIONS(1529),
    [anon_sym___thread] = ACTIONS(1529),
    [anon_sym_const] = ACTIONS(1529),
    [anon_sym_constexpr] = ACTIONS(1529),
    [anon_sym_volatile] = ACTIONS(1529),
    [anon_sym_restrict] = ACTIONS(1529),
    [anon_sym___restrict__] = ACTIONS(1529),
    [anon_sym__Atomic] = ACTIONS(1529),
    [anon_sym__Noreturn] = ACTIONS(1529),
    [anon_sym_noreturn] = ACTIONS(1529),
    [sym_primitive_type] = ACTIONS(1529),
    [anon_sym_enum] = ACTIONS(1529),
    [anon_sym_struct] = ACTIONS(1529),
    [anon_sym_union] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(1529),
    [anon_sym_else] = ACTIONS(1529),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_case] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1529),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1529),
    [anon_sym_return] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(1529),
    [anon_sym_continue] = ACTIONS(1529),
    [anon_sym_goto] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym___alignof__] = ACTIONS(1529),
    [anon_sym___alignof] = ACTIONS(1529),
    [anon_sym__alignof] = ACTIONS(1529),
    [anon_sym_alignof] = ACTIONS(1529),
    [anon_sym__Alignof] = ACTIONS(1529),
    [anon_sym_offsetof] = ACTIONS(1529),
    [anon_sym__Generic] = ACTIONS(1529),
    [anon_sym_asm] = ACTIONS(1529),
    [anon_sym___asm__] = ACTIONS(1529),
    [sym_number_literal] = ACTIONS(1531),
    [anon_sym_L_SQUOTE] = ACTIONS(1531),
    [anon_sym_u_SQUOTE] = ACTIONS(1531),
    [anon_sym_U_SQUOTE] = ACTIONS(1531),
    [anon_sym_u8_SQUOTE] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_L_DQUOTE] = ACTIONS(1531),
    [anon_sym_u_DQUOTE] = ACTIONS(1531),
    [anon_sym_U_DQUOTE] = ACTIONS(1531),
    [anon_sym_u8_DQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [anon_sym_NULL] = ACTIONS(1529),
    [anon_sym_nullptr] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1529),
    [anon_sym_acquire] = ACTIONS(1529),
    [anon_sym_catch] = ACTIONS(1529),
    [anon_sym_monitor] = ACTIONS(1529),
    [anon_sym_start] = ACTIONS(1529),
    [anon_sym_stop] = ACTIONS(1529),
  },
  [127] = {
    [sym_identifier] = ACTIONS(1533),
    [aux_sym_preproc_include_token1] = ACTIONS(1533),
    [aux_sym_preproc_def_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token2] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1533),
    [aux_sym_preproc_else_token1] = ACTIONS(1533),
    [aux_sym_preproc_elif_token1] = ACTIONS(1533),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1533),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1533),
    [sym_preproc_directive] = ACTIONS(1533),
    [anon_sym_LPAREN2] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1533),
    [anon_sym_typedef] = ACTIONS(1533),
    [anon_sym_extern] = ACTIONS(1533),
    [anon_sym___attribute__] = ACTIONS(1533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1535),
    [anon_sym___declspec] = ACTIONS(1533),
    [anon_sym___cdecl] = ACTIONS(1533),
    [anon_sym___clrcall] = ACTIONS(1533),
    [anon_sym___stdcall] = ACTIONS(1533),
    [anon_sym___fastcall] = ACTIONS(1533),
    [anon_sym___thiscall] = ACTIONS(1533),
    [anon_sym___vectorcall] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_signed] = ACTIONS(1533),
    [anon_sym_unsigned] = ACTIONS(1533),
    [anon_sym_long] = ACTIONS(1533),
    [anon_sym_short] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_auto] = ACTIONS(1533),
    [anon_sym_register] = ACTIONS(1533),
    [anon_sym_inline] = ACTIONS(1533),
    [anon_sym___inline] = ACTIONS(1533),
    [anon_sym___inline__] = ACTIONS(1533),
    [anon_sym___forceinline] = ACTIONS(1533),
    [anon_sym_thread_local] = ACTIONS(1533),
    [anon_sym___thread] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_constexpr] = ACTIONS(1533),
    [anon_sym_volatile] = ACTIONS(1533),
    [anon_sym_restrict] = ACTIONS(1533),
    [anon_sym___restrict__] = ACTIONS(1533),
    [anon_sym__Atomic] = ACTIONS(1533),
    [anon_sym__Noreturn] = ACTIONS(1533),
    [anon_sym_noreturn] = ACTIONS(1533),
    [sym_primitive_type] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [anon_sym_struct] = ACTIONS(1533),
    [anon_sym_union] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_goto] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_sizeof] = ACTIONS(1533),
    [anon_sym___alignof__] = ACTIONS(1533),
    [anon_sym___alignof] = ACTIONS(1533),
    [anon_sym__alignof] = ACTIONS(1533),
    [anon_sym_alignof] = ACTIONS(1533),
    [anon_sym__Alignof] = ACTIONS(1533),
    [anon_sym_offsetof] = ACTIONS(1533),
    [anon_sym__Generic] = ACTIONS(1533),
    [anon_sym_asm] = ACTIONS(1533),
    [anon_sym___asm__] = ACTIONS(1533),
    [sym_number_literal] = ACTIONS(1535),
    [anon_sym_L_SQUOTE] = ACTIONS(1535),
    [anon_sym_u_SQUOTE] = ACTIONS(1535),
    [anon_sym_U_SQUOTE] = ACTIONS(1535),
    [anon_sym_u8_SQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [anon_sym_L_DQUOTE] = ACTIONS(1535),
    [anon_sym_u_DQUOTE] = ACTIONS(1535),
    [anon_sym_U_DQUOTE] = ACTIONS(1535),
    [anon_sym_u8_DQUOTE] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [anon_sym_NULL] = ACTIONS(1533),
    [anon_sym_nullptr] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1533),
    [anon_sym_acquire] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_monitor] = ACTIONS(1533),
    [anon_sym_start] = ACTIONS(1533),
    [anon_sym_stop] = ACTIONS(1533),
  },
  [128] = {
    [sym_identifier] = ACTIONS(1537),
    [aux_sym_preproc_include_token1] = ACTIONS(1537),
    [aux_sym_preproc_def_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token2] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1537),
    [aux_sym_preproc_else_token1] = ACTIONS(1537),
    [aux_sym_preproc_elif_token1] = ACTIONS(1537),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1537),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1537),
    [sym_preproc_directive] = ACTIONS(1537),
    [anon_sym_LPAREN2] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym___extension__] = ACTIONS(1537),
    [anon_sym_typedef] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(1537),
    [anon_sym___attribute__] = ACTIONS(1537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1539),
    [anon_sym___declspec] = ACTIONS(1537),
    [anon_sym___cdecl] = ACTIONS(1537),
    [anon_sym___clrcall] = ACTIONS(1537),
    [anon_sym___stdcall] = ACTIONS(1537),
    [anon_sym___fastcall] = ACTIONS(1537),
    [anon_sym___thiscall] = ACTIONS(1537),
    [anon_sym___vectorcall] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_signed] = ACTIONS(1537),
    [anon_sym_unsigned] = ACTIONS(1537),
    [anon_sym_long] = ACTIONS(1537),
    [anon_sym_short] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_auto] = ACTIONS(1537),
    [anon_sym_register] = ACTIONS(1537),
    [anon_sym_inline] = ACTIONS(1537),
    [anon_sym___inline] = ACTIONS(1537),
    [anon_sym___inline__] = ACTIONS(1537),
    [anon_sym___forceinline] = ACTIONS(1537),
    [anon_sym_thread_local] = ACTIONS(1537),
    [anon_sym___thread] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_constexpr] = ACTIONS(1537),
    [anon_sym_volatile] = ACTIONS(1537),
    [anon_sym_restrict] = ACTIONS(1537),
    [anon_sym___restrict__] = ACTIONS(1537),
    [anon_sym__Atomic] = ACTIONS(1537),
    [anon_sym__Noreturn] = ACTIONS(1537),
    [anon_sym_noreturn] = ACTIONS(1537),
    [sym_primitive_type] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [anon_sym_struct] = ACTIONS(1537),
    [anon_sym_union] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_goto] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_sizeof] = ACTIONS(1537),
    [anon_sym___alignof__] = ACTIONS(1537),
    [anon_sym___alignof] = ACTIONS(1537),
    [anon_sym__alignof] = ACTIONS(1537),
    [anon_sym_alignof] = ACTIONS(1537),
    [anon_sym__Alignof] = ACTIONS(1537),
    [anon_sym_offsetof] = ACTIONS(1537),
    [anon_sym__Generic] = ACTIONS(1537),
    [anon_sym_asm] = ACTIONS(1537),
    [anon_sym___asm__] = ACTIONS(1537),
    [sym_number_literal] = ACTIONS(1539),
    [anon_sym_L_SQUOTE] = ACTIONS(1539),
    [anon_sym_u_SQUOTE] = ACTIONS(1539),
    [anon_sym_U_SQUOTE] = ACTIONS(1539),
    [anon_sym_u8_SQUOTE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [anon_sym_L_DQUOTE] = ACTIONS(1539),
    [anon_sym_u_DQUOTE] = ACTIONS(1539),
    [anon_sym_U_DQUOTE] = ACTIONS(1539),
    [anon_sym_u8_DQUOTE] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1539),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [anon_sym_NULL] = ACTIONS(1537),
    [anon_sym_nullptr] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1537),
    [anon_sym_acquire] = ACTIONS(1537),
    [anon_sym_catch] = ACTIONS(1537),
    [anon_sym_monitor] = ACTIONS(1537),
    [anon_sym_start] = ACTIONS(1537),
    [anon_sym_stop] = ACTIONS(1537),
  },
  [129] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [130] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [131] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [132] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [133] = {
    [sym_identifier] = ACTIONS(1541),
    [aux_sym_preproc_include_token1] = ACTIONS(1541),
    [aux_sym_preproc_def_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token2] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1541),
    [aux_sym_preproc_else_token1] = ACTIONS(1541),
    [aux_sym_preproc_elif_token1] = ACTIONS(1541),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1541),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1541),
    [sym_preproc_directive] = ACTIONS(1541),
    [anon_sym_LPAREN2] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym___extension__] = ACTIONS(1541),
    [anon_sym_typedef] = ACTIONS(1541),
    [anon_sym_extern] = ACTIONS(1541),
    [anon_sym___attribute__] = ACTIONS(1541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1543),
    [anon_sym___declspec] = ACTIONS(1541),
    [anon_sym___cdecl] = ACTIONS(1541),
    [anon_sym___clrcall] = ACTIONS(1541),
    [anon_sym___stdcall] = ACTIONS(1541),
    [anon_sym___fastcall] = ACTIONS(1541),
    [anon_sym___thiscall] = ACTIONS(1541),
    [anon_sym___vectorcall] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_signed] = ACTIONS(1541),
    [anon_sym_unsigned] = ACTIONS(1541),
    [anon_sym_long] = ACTIONS(1541),
    [anon_sym_short] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_auto] = ACTIONS(1541),
    [anon_sym_register] = ACTIONS(1541),
    [anon_sym_inline] = ACTIONS(1541),
    [anon_sym___inline] = ACTIONS(1541),
    [anon_sym___inline__] = ACTIONS(1541),
    [anon_sym___forceinline] = ACTIONS(1541),
    [anon_sym_thread_local] = ACTIONS(1541),
    [anon_sym___thread] = ACTIONS(1541),
    [anon_sym_const] = ACTIONS(1541),
    [anon_sym_constexpr] = ACTIONS(1541),
    [anon_sym_volatile] = ACTIONS(1541),
    [anon_sym_restrict] = ACTIONS(1541),
    [anon_sym___restrict__] = ACTIONS(1541),
    [anon_sym__Atomic] = ACTIONS(1541),
    [anon_sym__Noreturn] = ACTIONS(1541),
    [anon_sym_noreturn] = ACTIONS(1541),
    [sym_primitive_type] = ACTIONS(1541),
    [anon_sym_enum] = ACTIONS(1541),
    [anon_sym_struct] = ACTIONS(1541),
    [anon_sym_union] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1541),
    [anon_sym_default] = ACTIONS(1541),
    [anon_sym_while] = ACTIONS(1541),
    [anon_sym_do] = ACTIONS(1541),
    [anon_sym_for] = ACTIONS(1541),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1541),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_goto] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1541),
    [anon_sym___alignof__] = ACTIONS(1541),
    [anon_sym___alignof] = ACTIONS(1541),
    [anon_sym__alignof] = ACTIONS(1541),
    [anon_sym_alignof] = ACTIONS(1541),
    [anon_sym__Alignof] = ACTIONS(1541),
    [anon_sym_offsetof] = ACTIONS(1541),
    [anon_sym__Generic] = ACTIONS(1541),
    [anon_sym_asm] = ACTIONS(1541),
    [anon_sym___asm__] = ACTIONS(1541),
    [sym_number_literal] = ACTIONS(1543),
    [anon_sym_L_SQUOTE] = ACTIONS(1543),
    [anon_sym_u_SQUOTE] = ACTIONS(1543),
    [anon_sym_U_SQUOTE] = ACTIONS(1543),
    [anon_sym_u8_SQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_L_DQUOTE] = ACTIONS(1543),
    [anon_sym_u_DQUOTE] = ACTIONS(1543),
    [anon_sym_U_DQUOTE] = ACTIONS(1543),
    [anon_sym_u8_DQUOTE] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [anon_sym_NULL] = ACTIONS(1541),
    [anon_sym_nullptr] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1541),
    [anon_sym_acquire] = ACTIONS(1541),
    [anon_sym_catch] = ACTIONS(1541),
    [anon_sym_monitor] = ACTIONS(1541),
    [anon_sym_start] = ACTIONS(1541),
    [anon_sym_stop] = ACTIONS(1541),
  },
  [134] = {
    [sym_identifier] = ACTIONS(1545),
    [aux_sym_preproc_include_token1] = ACTIONS(1545),
    [aux_sym_preproc_def_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token2] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1545),
    [aux_sym_preproc_else_token1] = ACTIONS(1545),
    [aux_sym_preproc_elif_token1] = ACTIONS(1545),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1545),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1545),
    [sym_preproc_directive] = ACTIONS(1545),
    [anon_sym_LPAREN2] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym___extension__] = ACTIONS(1545),
    [anon_sym_typedef] = ACTIONS(1545),
    [anon_sym_extern] = ACTIONS(1545),
    [anon_sym___attribute__] = ACTIONS(1545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1547),
    [anon_sym___declspec] = ACTIONS(1545),
    [anon_sym___cdecl] = ACTIONS(1545),
    [anon_sym___clrcall] = ACTIONS(1545),
    [anon_sym___stdcall] = ACTIONS(1545),
    [anon_sym___fastcall] = ACTIONS(1545),
    [anon_sym___thiscall] = ACTIONS(1545),
    [anon_sym___vectorcall] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_signed] = ACTIONS(1545),
    [anon_sym_unsigned] = ACTIONS(1545),
    [anon_sym_long] = ACTIONS(1545),
    [anon_sym_short] = ACTIONS(1545),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_auto] = ACTIONS(1545),
    [anon_sym_register] = ACTIONS(1545),
    [anon_sym_inline] = ACTIONS(1545),
    [anon_sym___inline] = ACTIONS(1545),
    [anon_sym___inline__] = ACTIONS(1545),
    [anon_sym___forceinline] = ACTIONS(1545),
    [anon_sym_thread_local] = ACTIONS(1545),
    [anon_sym___thread] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_constexpr] = ACTIONS(1545),
    [anon_sym_volatile] = ACTIONS(1545),
    [anon_sym_restrict] = ACTIONS(1545),
    [anon_sym___restrict__] = ACTIONS(1545),
    [anon_sym__Atomic] = ACTIONS(1545),
    [anon_sym__Noreturn] = ACTIONS(1545),
    [anon_sym_noreturn] = ACTIONS(1545),
    [sym_primitive_type] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [anon_sym_struct] = ACTIONS(1545),
    [anon_sym_union] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_sizeof] = ACTIONS(1545),
    [anon_sym___alignof__] = ACTIONS(1545),
    [anon_sym___alignof] = ACTIONS(1545),
    [anon_sym__alignof] = ACTIONS(1545),
    [anon_sym_alignof] = ACTIONS(1545),
    [anon_sym__Alignof] = ACTIONS(1545),
    [anon_sym_offsetof] = ACTIONS(1545),
    [anon_sym__Generic] = ACTIONS(1545),
    [anon_sym_asm] = ACTIONS(1545),
    [anon_sym___asm__] = ACTIONS(1545),
    [sym_number_literal] = ACTIONS(1547),
    [anon_sym_L_SQUOTE] = ACTIONS(1547),
    [anon_sym_u_SQUOTE] = ACTIONS(1547),
    [anon_sym_U_SQUOTE] = ACTIONS(1547),
    [anon_sym_u8_SQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [anon_sym_L_DQUOTE] = ACTIONS(1547),
    [anon_sym_u_DQUOTE] = ACTIONS(1547),
    [anon_sym_U_DQUOTE] = ACTIONS(1547),
    [anon_sym_u8_DQUOTE] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [anon_sym_NULL] = ACTIONS(1545),
    [anon_sym_nullptr] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1545),
    [anon_sym_acquire] = ACTIONS(1545),
    [anon_sym_catch] = ACTIONS(1545),
    [anon_sym_monitor] = ACTIONS(1545),
    [anon_sym_start] = ACTIONS(1545),
    [anon_sym_stop] = ACTIONS(1545),
  },
  [135] = {
    [sym_identifier] = ACTIONS(1549),
    [aux_sym_preproc_include_token1] = ACTIONS(1549),
    [aux_sym_preproc_def_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token2] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1549),
    [aux_sym_preproc_else_token1] = ACTIONS(1549),
    [aux_sym_preproc_elif_token1] = ACTIONS(1549),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1549),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1549),
    [sym_preproc_directive] = ACTIONS(1549),
    [anon_sym_LPAREN2] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym___extension__] = ACTIONS(1549),
    [anon_sym_typedef] = ACTIONS(1549),
    [anon_sym_extern] = ACTIONS(1549),
    [anon_sym___attribute__] = ACTIONS(1549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1551),
    [anon_sym___declspec] = ACTIONS(1549),
    [anon_sym___cdecl] = ACTIONS(1549),
    [anon_sym___clrcall] = ACTIONS(1549),
    [anon_sym___stdcall] = ACTIONS(1549),
    [anon_sym___fastcall] = ACTIONS(1549),
    [anon_sym___thiscall] = ACTIONS(1549),
    [anon_sym___vectorcall] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_signed] = ACTIONS(1549),
    [anon_sym_unsigned] = ACTIONS(1549),
    [anon_sym_long] = ACTIONS(1549),
    [anon_sym_short] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_auto] = ACTIONS(1549),
    [anon_sym_register] = ACTIONS(1549),
    [anon_sym_inline] = ACTIONS(1549),
    [anon_sym___inline] = ACTIONS(1549),
    [anon_sym___inline__] = ACTIONS(1549),
    [anon_sym___forceinline] = ACTIONS(1549),
    [anon_sym_thread_local] = ACTIONS(1549),
    [anon_sym___thread] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_constexpr] = ACTIONS(1549),
    [anon_sym_volatile] = ACTIONS(1549),
    [anon_sym_restrict] = ACTIONS(1549),
    [anon_sym___restrict__] = ACTIONS(1549),
    [anon_sym__Atomic] = ACTIONS(1549),
    [anon_sym__Noreturn] = ACTIONS(1549),
    [anon_sym_noreturn] = ACTIONS(1549),
    [sym_primitive_type] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [anon_sym_struct] = ACTIONS(1549),
    [anon_sym_union] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_goto] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1549),
    [anon_sym___alignof__] = ACTIONS(1549),
    [anon_sym___alignof] = ACTIONS(1549),
    [anon_sym__alignof] = ACTIONS(1549),
    [anon_sym_alignof] = ACTIONS(1549),
    [anon_sym__Alignof] = ACTIONS(1549),
    [anon_sym_offsetof] = ACTIONS(1549),
    [anon_sym__Generic] = ACTIONS(1549),
    [anon_sym_asm] = ACTIONS(1549),
    [anon_sym___asm__] = ACTIONS(1549),
    [sym_number_literal] = ACTIONS(1551),
    [anon_sym_L_SQUOTE] = ACTIONS(1551),
    [anon_sym_u_SQUOTE] = ACTIONS(1551),
    [anon_sym_U_SQUOTE] = ACTIONS(1551),
    [anon_sym_u8_SQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_L_DQUOTE] = ACTIONS(1551),
    [anon_sym_u_DQUOTE] = ACTIONS(1551),
    [anon_sym_U_DQUOTE] = ACTIONS(1551),
    [anon_sym_u8_DQUOTE] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [anon_sym_NULL] = ACTIONS(1549),
    [anon_sym_nullptr] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_acquire] = ACTIONS(1549),
    [anon_sym_catch] = ACTIONS(1549),
    [anon_sym_monitor] = ACTIONS(1549),
    [anon_sym_start] = ACTIONS(1549),
    [anon_sym_stop] = ACTIONS(1549),
  },
  [136] = {
    [sym_identifier] = ACTIONS(1553),
    [aux_sym_preproc_include_token1] = ACTIONS(1553),
    [aux_sym_preproc_def_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token2] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1553),
    [aux_sym_preproc_else_token1] = ACTIONS(1553),
    [aux_sym_preproc_elif_token1] = ACTIONS(1553),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1553),
    [sym_preproc_directive] = ACTIONS(1553),
    [anon_sym_LPAREN2] = ACTIONS(1555),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym___extension__] = ACTIONS(1553),
    [anon_sym_typedef] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1553),
    [anon_sym___attribute__] = ACTIONS(1553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1555),
    [anon_sym___declspec] = ACTIONS(1553),
    [anon_sym___cdecl] = ACTIONS(1553),
    [anon_sym___clrcall] = ACTIONS(1553),
    [anon_sym___stdcall] = ACTIONS(1553),
    [anon_sym___fastcall] = ACTIONS(1553),
    [anon_sym___thiscall] = ACTIONS(1553),
    [anon_sym___vectorcall] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_signed] = ACTIONS(1553),
    [anon_sym_unsigned] = ACTIONS(1553),
    [anon_sym_long] = ACTIONS(1553),
    [anon_sym_short] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_auto] = ACTIONS(1553),
    [anon_sym_register] = ACTIONS(1553),
    [anon_sym_inline] = ACTIONS(1553),
    [anon_sym___inline] = ACTIONS(1553),
    [anon_sym___inline__] = ACTIONS(1553),
    [anon_sym___forceinline] = ACTIONS(1553),
    [anon_sym_thread_local] = ACTIONS(1553),
    [anon_sym___thread] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_constexpr] = ACTIONS(1553),
    [anon_sym_volatile] = ACTIONS(1553),
    [anon_sym_restrict] = ACTIONS(1553),
    [anon_sym___restrict__] = ACTIONS(1553),
    [anon_sym__Atomic] = ACTIONS(1553),
    [anon_sym__Noreturn] = ACTIONS(1553),
    [anon_sym_noreturn] = ACTIONS(1553),
    [sym_primitive_type] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [anon_sym_struct] = ACTIONS(1553),
    [anon_sym_union] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_goto] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_sizeof] = ACTIONS(1553),
    [anon_sym___alignof__] = ACTIONS(1553),
    [anon_sym___alignof] = ACTIONS(1553),
    [anon_sym__alignof] = ACTIONS(1553),
    [anon_sym_alignof] = ACTIONS(1553),
    [anon_sym__Alignof] = ACTIONS(1553),
    [anon_sym_offsetof] = ACTIONS(1553),
    [anon_sym__Generic] = ACTIONS(1553),
    [anon_sym_asm] = ACTIONS(1553),
    [anon_sym___asm__] = ACTIONS(1553),
    [sym_number_literal] = ACTIONS(1555),
    [anon_sym_L_SQUOTE] = ACTIONS(1555),
    [anon_sym_u_SQUOTE] = ACTIONS(1555),
    [anon_sym_U_SQUOTE] = ACTIONS(1555),
    [anon_sym_u8_SQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [anon_sym_L_DQUOTE] = ACTIONS(1555),
    [anon_sym_u_DQUOTE] = ACTIONS(1555),
    [anon_sym_U_DQUOTE] = ACTIONS(1555),
    [anon_sym_u8_DQUOTE] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [anon_sym_NULL] = ACTIONS(1553),
    [anon_sym_nullptr] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_acquire] = ACTIONS(1553),
    [anon_sym_catch] = ACTIONS(1553),
    [anon_sym_monitor] = ACTIONS(1553),
    [anon_sym_start] = ACTIONS(1553),
    [anon_sym_stop] = ACTIONS(1553),
  },
  [137] = {
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_include_token1] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token2] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1557),
    [aux_sym_preproc_else_token1] = ACTIONS(1557),
    [aux_sym_preproc_elif_token1] = ACTIONS(1557),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1557),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1557),
    [sym_preproc_directive] = ACTIONS(1557),
    [anon_sym_LPAREN2] = ACTIONS(1559),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym___extension__] = ACTIONS(1557),
    [anon_sym_typedef] = ACTIONS(1557),
    [anon_sym_extern] = ACTIONS(1557),
    [anon_sym___attribute__] = ACTIONS(1557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1559),
    [anon_sym___declspec] = ACTIONS(1557),
    [anon_sym___cdecl] = ACTIONS(1557),
    [anon_sym___clrcall] = ACTIONS(1557),
    [anon_sym___stdcall] = ACTIONS(1557),
    [anon_sym___fastcall] = ACTIONS(1557),
    [anon_sym___thiscall] = ACTIONS(1557),
    [anon_sym___vectorcall] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_signed] = ACTIONS(1557),
    [anon_sym_unsigned] = ACTIONS(1557),
    [anon_sym_long] = ACTIONS(1557),
    [anon_sym_short] = ACTIONS(1557),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_auto] = ACTIONS(1557),
    [anon_sym_register] = ACTIONS(1557),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym___inline] = ACTIONS(1557),
    [anon_sym___inline__] = ACTIONS(1557),
    [anon_sym___forceinline] = ACTIONS(1557),
    [anon_sym_thread_local] = ACTIONS(1557),
    [anon_sym___thread] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_constexpr] = ACTIONS(1557),
    [anon_sym_volatile] = ACTIONS(1557),
    [anon_sym_restrict] = ACTIONS(1557),
    [anon_sym___restrict__] = ACTIONS(1557),
    [anon_sym__Atomic] = ACTIONS(1557),
    [anon_sym__Noreturn] = ACTIONS(1557),
    [anon_sym_noreturn] = ACTIONS(1557),
    [sym_primitive_type] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [anon_sym_struct] = ACTIONS(1557),
    [anon_sym_union] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_goto] = ACTIONS(1557),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_sizeof] = ACTIONS(1557),
    [anon_sym___alignof__] = ACTIONS(1557),
    [anon_sym___alignof] = ACTIONS(1557),
    [anon_sym__alignof] = ACTIONS(1557),
    [anon_sym_alignof] = ACTIONS(1557),
    [anon_sym__Alignof] = ACTIONS(1557),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1557),
    [anon_sym_asm] = ACTIONS(1557),
    [anon_sym___asm__] = ACTIONS(1557),
    [sym_number_literal] = ACTIONS(1559),
    [anon_sym_L_SQUOTE] = ACTIONS(1559),
    [anon_sym_u_SQUOTE] = ACTIONS(1559),
    [anon_sym_U_SQUOTE] = ACTIONS(1559),
    [anon_sym_u8_SQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [anon_sym_L_DQUOTE] = ACTIONS(1559),
    [anon_sym_u_DQUOTE] = ACTIONS(1559),
    [anon_sym_U_DQUOTE] = ACTIONS(1559),
    [anon_sym_u8_DQUOTE] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [anon_sym_NULL] = ACTIONS(1557),
    [anon_sym_nullptr] = ACTIONS(1557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_acquire] = ACTIONS(1557),
    [anon_sym_catch] = ACTIONS(1557),
    [anon_sym_monitor] = ACTIONS(1557),
    [anon_sym_start] = ACTIONS(1557),
    [anon_sym_stop] = ACTIONS(1557),
  },
  [138] = {
    [sym_identifier] = ACTIONS(1561),
    [aux_sym_preproc_include_token1] = ACTIONS(1561),
    [aux_sym_preproc_def_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1561),
    [aux_sym_preproc_else_token1] = ACTIONS(1561),
    [aux_sym_preproc_elif_token1] = ACTIONS(1561),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1561),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1561),
    [sym_preproc_directive] = ACTIONS(1561),
    [anon_sym_LPAREN2] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym___extension__] = ACTIONS(1561),
    [anon_sym_typedef] = ACTIONS(1561),
    [anon_sym_extern] = ACTIONS(1561),
    [anon_sym___attribute__] = ACTIONS(1561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1563),
    [anon_sym___declspec] = ACTIONS(1561),
    [anon_sym___cdecl] = ACTIONS(1561),
    [anon_sym___clrcall] = ACTIONS(1561),
    [anon_sym___stdcall] = ACTIONS(1561),
    [anon_sym___fastcall] = ACTIONS(1561),
    [anon_sym___thiscall] = ACTIONS(1561),
    [anon_sym___vectorcall] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_signed] = ACTIONS(1561),
    [anon_sym_unsigned] = ACTIONS(1561),
    [anon_sym_long] = ACTIONS(1561),
    [anon_sym_short] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_auto] = ACTIONS(1561),
    [anon_sym_register] = ACTIONS(1561),
    [anon_sym_inline] = ACTIONS(1561),
    [anon_sym___inline] = ACTIONS(1561),
    [anon_sym___inline__] = ACTIONS(1561),
    [anon_sym___forceinline] = ACTIONS(1561),
    [anon_sym_thread_local] = ACTIONS(1561),
    [anon_sym___thread] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_constexpr] = ACTIONS(1561),
    [anon_sym_volatile] = ACTIONS(1561),
    [anon_sym_restrict] = ACTIONS(1561),
    [anon_sym___restrict__] = ACTIONS(1561),
    [anon_sym__Atomic] = ACTIONS(1561),
    [anon_sym__Noreturn] = ACTIONS(1561),
    [anon_sym_noreturn] = ACTIONS(1561),
    [sym_primitive_type] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [anon_sym_struct] = ACTIONS(1561),
    [anon_sym_union] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_goto] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_sizeof] = ACTIONS(1561),
    [anon_sym___alignof__] = ACTIONS(1561),
    [anon_sym___alignof] = ACTIONS(1561),
    [anon_sym__alignof] = ACTIONS(1561),
    [anon_sym_alignof] = ACTIONS(1561),
    [anon_sym__Alignof] = ACTIONS(1561),
    [anon_sym_offsetof] = ACTIONS(1561),
    [anon_sym__Generic] = ACTIONS(1561),
    [anon_sym_asm] = ACTIONS(1561),
    [anon_sym___asm__] = ACTIONS(1561),
    [sym_number_literal] = ACTIONS(1563),
    [anon_sym_L_SQUOTE] = ACTIONS(1563),
    [anon_sym_u_SQUOTE] = ACTIONS(1563),
    [anon_sym_U_SQUOTE] = ACTIONS(1563),
    [anon_sym_u8_SQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [anon_sym_L_DQUOTE] = ACTIONS(1563),
    [anon_sym_u_DQUOTE] = ACTIONS(1563),
    [anon_sym_U_DQUOTE] = ACTIONS(1563),
    [anon_sym_u8_DQUOTE] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [anon_sym_NULL] = ACTIONS(1561),
    [anon_sym_nullptr] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_acquire] = ACTIONS(1561),
    [anon_sym_catch] = ACTIONS(1561),
    [anon_sym_monitor] = ACTIONS(1561),
    [anon_sym_start] = ACTIONS(1561),
    [anon_sym_stop] = ACTIONS(1561),
  },
  [139] = {
    [sym_catch_clause] = STATE(107),
    [aux_sym_monitor_statement_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token2] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [aux_sym_preproc_else_token1] = ACTIONS(1446),
    [aux_sym_preproc_elif_token1] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1446),
    [anon_sym_acquire] = ACTIONS(1446),
    [anon_sym_catch] = ACTIONS(1504),
    [anon_sym_monitor] = ACTIONS(1446),
    [anon_sym_start] = ACTIONS(1446),
    [anon_sym_stop] = ACTIONS(1446),
  },
  [140] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [141] = {
    [sym_identifier] = ACTIONS(1565),
    [aux_sym_preproc_include_token1] = ACTIONS(1565),
    [aux_sym_preproc_def_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token2] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1565),
    [aux_sym_preproc_elif_token1] = ACTIONS(1565),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1565),
    [sym_preproc_directive] = ACTIONS(1565),
    [anon_sym_LPAREN2] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1565),
    [anon_sym_typedef] = ACTIONS(1565),
    [anon_sym_extern] = ACTIONS(1565),
    [anon_sym___attribute__] = ACTIONS(1565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1567),
    [anon_sym___declspec] = ACTIONS(1565),
    [anon_sym___cdecl] = ACTIONS(1565),
    [anon_sym___clrcall] = ACTIONS(1565),
    [anon_sym___stdcall] = ACTIONS(1565),
    [anon_sym___fastcall] = ACTIONS(1565),
    [anon_sym___thiscall] = ACTIONS(1565),
    [anon_sym___vectorcall] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_signed] = ACTIONS(1565),
    [anon_sym_unsigned] = ACTIONS(1565),
    [anon_sym_long] = ACTIONS(1565),
    [anon_sym_short] = ACTIONS(1565),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_auto] = ACTIONS(1565),
    [anon_sym_register] = ACTIONS(1565),
    [anon_sym_inline] = ACTIONS(1565),
    [anon_sym___inline] = ACTIONS(1565),
    [anon_sym___inline__] = ACTIONS(1565),
    [anon_sym___forceinline] = ACTIONS(1565),
    [anon_sym_thread_local] = ACTIONS(1565),
    [anon_sym___thread] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_constexpr] = ACTIONS(1565),
    [anon_sym_volatile] = ACTIONS(1565),
    [anon_sym_restrict] = ACTIONS(1565),
    [anon_sym___restrict__] = ACTIONS(1565),
    [anon_sym__Atomic] = ACTIONS(1565),
    [anon_sym__Noreturn] = ACTIONS(1565),
    [anon_sym_noreturn] = ACTIONS(1565),
    [sym_primitive_type] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [anon_sym_struct] = ACTIONS(1565),
    [anon_sym_union] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_goto] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_sizeof] = ACTIONS(1565),
    [anon_sym___alignof__] = ACTIONS(1565),
    [anon_sym___alignof] = ACTIONS(1565),
    [anon_sym__alignof] = ACTIONS(1565),
    [anon_sym_alignof] = ACTIONS(1565),
    [anon_sym__Alignof] = ACTIONS(1565),
    [anon_sym_offsetof] = ACTIONS(1565),
    [anon_sym__Generic] = ACTIONS(1565),
    [anon_sym_asm] = ACTIONS(1565),
    [anon_sym___asm__] = ACTIONS(1565),
    [sym_number_literal] = ACTIONS(1567),
    [anon_sym_L_SQUOTE] = ACTIONS(1567),
    [anon_sym_u_SQUOTE] = ACTIONS(1567),
    [anon_sym_U_SQUOTE] = ACTIONS(1567),
    [anon_sym_u8_SQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [anon_sym_L_DQUOTE] = ACTIONS(1567),
    [anon_sym_u_DQUOTE] = ACTIONS(1567),
    [anon_sym_U_DQUOTE] = ACTIONS(1567),
    [anon_sym_u8_DQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [anon_sym_NULL] = ACTIONS(1565),
    [anon_sym_nullptr] = ACTIONS(1565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_acquire] = ACTIONS(1565),
    [anon_sym_catch] = ACTIONS(1565),
    [anon_sym_monitor] = ACTIONS(1565),
    [anon_sym_start] = ACTIONS(1565),
    [anon_sym_stop] = ACTIONS(1565),
  },
  [142] = {
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1569),
    [aux_sym_preproc_def_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token2] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1569),
    [aux_sym_preproc_else_token1] = ACTIONS(1569),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1569),
    [sym_preproc_directive] = ACTIONS(1569),
    [anon_sym_LPAREN2] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(1569),
    [anon_sym_typedef] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym___attribute__] = ACTIONS(1569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1571),
    [anon_sym___declspec] = ACTIONS(1569),
    [anon_sym___cdecl] = ACTIONS(1569),
    [anon_sym___clrcall] = ACTIONS(1569),
    [anon_sym___stdcall] = ACTIONS(1569),
    [anon_sym___fastcall] = ACTIONS(1569),
    [anon_sym___thiscall] = ACTIONS(1569),
    [anon_sym___vectorcall] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_signed] = ACTIONS(1569),
    [anon_sym_unsigned] = ACTIONS(1569),
    [anon_sym_long] = ACTIONS(1569),
    [anon_sym_short] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_auto] = ACTIONS(1569),
    [anon_sym_register] = ACTIONS(1569),
    [anon_sym_inline] = ACTIONS(1569),
    [anon_sym___inline] = ACTIONS(1569),
    [anon_sym___inline__] = ACTIONS(1569),
    [anon_sym___forceinline] = ACTIONS(1569),
    [anon_sym_thread_local] = ACTIONS(1569),
    [anon_sym___thread] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_constexpr] = ACTIONS(1569),
    [anon_sym_volatile] = ACTIONS(1569),
    [anon_sym_restrict] = ACTIONS(1569),
    [anon_sym___restrict__] = ACTIONS(1569),
    [anon_sym__Atomic] = ACTIONS(1569),
    [anon_sym__Noreturn] = ACTIONS(1569),
    [anon_sym_noreturn] = ACTIONS(1569),
    [sym_primitive_type] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_goto] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_sizeof] = ACTIONS(1569),
    [anon_sym___alignof__] = ACTIONS(1569),
    [anon_sym___alignof] = ACTIONS(1569),
    [anon_sym__alignof] = ACTIONS(1569),
    [anon_sym_alignof] = ACTIONS(1569),
    [anon_sym__Alignof] = ACTIONS(1569),
    [anon_sym_offsetof] = ACTIONS(1569),
    [anon_sym__Generic] = ACTIONS(1569),
    [anon_sym_asm] = ACTIONS(1569),
    [anon_sym___asm__] = ACTIONS(1569),
    [sym_number_literal] = ACTIONS(1571),
    [anon_sym_L_SQUOTE] = ACTIONS(1571),
    [anon_sym_u_SQUOTE] = ACTIONS(1571),
    [anon_sym_U_SQUOTE] = ACTIONS(1571),
    [anon_sym_u8_SQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [anon_sym_L_DQUOTE] = ACTIONS(1571),
    [anon_sym_u_DQUOTE] = ACTIONS(1571),
    [anon_sym_U_DQUOTE] = ACTIONS(1571),
    [anon_sym_u8_DQUOTE] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [anon_sym_NULL] = ACTIONS(1569),
    [anon_sym_nullptr] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1569),
    [anon_sym_acquire] = ACTIONS(1569),
    [anon_sym_catch] = ACTIONS(1569),
    [anon_sym_monitor] = ACTIONS(1569),
    [anon_sym_start] = ACTIONS(1569),
    [anon_sym_stop] = ACTIONS(1569),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1573),
    [aux_sym_preproc_include_token1] = ACTIONS(1573),
    [aux_sym_preproc_def_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token2] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1573),
    [aux_sym_preproc_else_token1] = ACTIONS(1573),
    [aux_sym_preproc_elif_token1] = ACTIONS(1573),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1573),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1573),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(1573),
    [anon_sym_typedef] = ACTIONS(1573),
    [anon_sym_extern] = ACTIONS(1573),
    [anon_sym___attribute__] = ACTIONS(1573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1575),
    [anon_sym___declspec] = ACTIONS(1573),
    [anon_sym___cdecl] = ACTIONS(1573),
    [anon_sym___clrcall] = ACTIONS(1573),
    [anon_sym___stdcall] = ACTIONS(1573),
    [anon_sym___fastcall] = ACTIONS(1573),
    [anon_sym___thiscall] = ACTIONS(1573),
    [anon_sym___vectorcall] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_signed] = ACTIONS(1573),
    [anon_sym_unsigned] = ACTIONS(1573),
    [anon_sym_long] = ACTIONS(1573),
    [anon_sym_short] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_auto] = ACTIONS(1573),
    [anon_sym_register] = ACTIONS(1573),
    [anon_sym_inline] = ACTIONS(1573),
    [anon_sym___inline] = ACTIONS(1573),
    [anon_sym___inline__] = ACTIONS(1573),
    [anon_sym___forceinline] = ACTIONS(1573),
    [anon_sym_thread_local] = ACTIONS(1573),
    [anon_sym___thread] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_constexpr] = ACTIONS(1573),
    [anon_sym_volatile] = ACTIONS(1573),
    [anon_sym_restrict] = ACTIONS(1573),
    [anon_sym___restrict__] = ACTIONS(1573),
    [anon_sym__Atomic] = ACTIONS(1573),
    [anon_sym__Noreturn] = ACTIONS(1573),
    [anon_sym_noreturn] = ACTIONS(1573),
    [sym_primitive_type] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1573),
    [anon_sym_union] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_goto] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_sizeof] = ACTIONS(1573),
    [anon_sym___alignof__] = ACTIONS(1573),
    [anon_sym___alignof] = ACTIONS(1573),
    [anon_sym__alignof] = ACTIONS(1573),
    [anon_sym_alignof] = ACTIONS(1573),
    [anon_sym__Alignof] = ACTIONS(1573),
    [anon_sym_offsetof] = ACTIONS(1573),
    [anon_sym__Generic] = ACTIONS(1573),
    [anon_sym_asm] = ACTIONS(1573),
    [anon_sym___asm__] = ACTIONS(1573),
    [sym_number_literal] = ACTIONS(1575),
    [anon_sym_L_SQUOTE] = ACTIONS(1575),
    [anon_sym_u_SQUOTE] = ACTIONS(1575),
    [anon_sym_U_SQUOTE] = ACTIONS(1575),
    [anon_sym_u8_SQUOTE] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [anon_sym_NULL] = ACTIONS(1573),
    [anon_sym_nullptr] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_acquire] = ACTIONS(1573),
    [anon_sym_catch] = ACTIONS(1573),
    [anon_sym_monitor] = ACTIONS(1573),
    [anon_sym_start] = ACTIONS(1573),
    [anon_sym_stop] = ACTIONS(1573),
  },
  [144] = {
    [sym_catch_clause] = STATE(147),
    [aux_sym_monitor_statement_repeat1] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(1448),
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1446),
    [anon_sym_until] = ACTIONS(1446),
    [anon_sym_acquire] = ACTIONS(1446),
    [anon_sym_catch] = ACTIONS(1577),
    [anon_sym_monitor] = ACTIONS(1446),
    [anon_sym_start] = ACTIONS(1446),
    [anon_sym_stop] = ACTIONS(1446),
  },
  [145] = {
    [sym_catch_clause] = STATE(215),
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token2] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [aux_sym_preproc_else_token1] = ACTIONS(1450),
    [aux_sym_preproc_elif_token1] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_else] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1450),
    [anon_sym_acquire] = ACTIONS(1450),
    [anon_sym_catch] = ACTIONS(1504),
    [anon_sym_monitor] = ACTIONS(1450),
    [anon_sym_start] = ACTIONS(1450),
    [anon_sym_stop] = ACTIONS(1450),
  },
  [146] = {
    [sym_else_clause] = STATE(216),
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [aux_sym_preproc_else_token1] = ACTIONS(1454),
    [aux_sym_preproc_elif_token1] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1579),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1454),
    [anon_sym_acquire] = ACTIONS(1454),
    [anon_sym_catch] = ACTIONS(1454),
    [anon_sym_monitor] = ACTIONS(1454),
    [anon_sym_start] = ACTIONS(1454),
    [anon_sym_stop] = ACTIONS(1454),
  },
  [147] = {
    [sym_catch_clause] = STATE(150),
    [aux_sym_monitor_statement_repeat1] = STATE(150),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_include_token1] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym___extension__] = ACTIONS(1440),
    [anon_sym_typedef] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym___cdecl] = ACTIONS(1440),
    [anon_sym___clrcall] = ACTIONS(1440),
    [anon_sym___stdcall] = ACTIONS(1440),
    [anon_sym___fastcall] = ACTIONS(1440),
    [anon_sym___thiscall] = ACTIONS(1440),
    [anon_sym___vectorcall] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym___inline] = ACTIONS(1440),
    [anon_sym___inline__] = ACTIONS(1440),
    [anon_sym___forceinline] = ACTIONS(1440),
    [anon_sym_thread_local] = ACTIONS(1440),
    [anon_sym___thread] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym___restrict__] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym__Noreturn] = ACTIONS(1440),
    [anon_sym_noreturn] = ACTIONS(1440),
    [sym_primitive_type] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_switch] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_do] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_goto] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_sizeof] = ACTIONS(1440),
    [anon_sym___alignof__] = ACTIONS(1440),
    [anon_sym___alignof] = ACTIONS(1440),
    [anon_sym__alignof] = ACTIONS(1440),
    [anon_sym_alignof] = ACTIONS(1440),
    [anon_sym__Alignof] = ACTIONS(1440),
    [anon_sym_offsetof] = ACTIONS(1440),
    [anon_sym__Generic] = ACTIONS(1440),
    [anon_sym_asm] = ACTIONS(1440),
    [anon_sym___asm__] = ACTIONS(1440),
    [sym_number_literal] = ACTIONS(1442),
    [anon_sym_L_SQUOTE] = ACTIONS(1442),
    [anon_sym_u_SQUOTE] = ACTIONS(1442),
    [anon_sym_U_SQUOTE] = ACTIONS(1442),
    [anon_sym_u8_SQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_L_DQUOTE] = ACTIONS(1442),
    [anon_sym_u_DQUOTE] = ACTIONS(1442),
    [anon_sym_U_DQUOTE] = ACTIONS(1442),
    [anon_sym_u8_DQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [anon_sym_NULL] = ACTIONS(1440),
    [anon_sym_nullptr] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1440),
    [anon_sym_until] = ACTIONS(1440),
    [anon_sym_acquire] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1577),
    [anon_sym_monitor] = ACTIONS(1440),
    [anon_sym_start] = ACTIONS(1440),
    [anon_sym_stop] = ACTIONS(1440),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1472),
    [aux_sym_preproc_include_token1] = ACTIONS(1472),
    [aux_sym_preproc_def_token1] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1474),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [aux_sym_preproc_if_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1472),
    [sym_preproc_directive] = ACTIONS(1472),
    [anon_sym_LPAREN2] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [anon_sym___extension__] = ACTIONS(1472),
    [anon_sym_typedef] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym___attribute__] = ACTIONS(1472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1474),
    [anon_sym___declspec] = ACTIONS(1472),
    [anon_sym___cdecl] = ACTIONS(1472),
    [anon_sym___clrcall] = ACTIONS(1472),
    [anon_sym___stdcall] = ACTIONS(1472),
    [anon_sym___fastcall] = ACTIONS(1472),
    [anon_sym___thiscall] = ACTIONS(1472),
    [anon_sym___vectorcall] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_signed] = ACTIONS(1472),
    [anon_sym_unsigned] = ACTIONS(1472),
    [anon_sym_long] = ACTIONS(1472),
    [anon_sym_short] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_auto] = ACTIONS(1472),
    [anon_sym_register] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym___inline] = ACTIONS(1472),
    [anon_sym___inline__] = ACTIONS(1472),
    [anon_sym___forceinline] = ACTIONS(1472),
    [anon_sym_thread_local] = ACTIONS(1472),
    [anon_sym___thread] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_constexpr] = ACTIONS(1472),
    [anon_sym_volatile] = ACTIONS(1472),
    [anon_sym_restrict] = ACTIONS(1472),
    [anon_sym___restrict__] = ACTIONS(1472),
    [anon_sym__Atomic] = ACTIONS(1472),
    [anon_sym__Noreturn] = ACTIONS(1472),
    [anon_sym_noreturn] = ACTIONS(1472),
    [sym_primitive_type] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_struct] = ACTIONS(1472),
    [anon_sym_union] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_goto] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [anon_sym_sizeof] = ACTIONS(1472),
    [anon_sym___alignof__] = ACTIONS(1472),
    [anon_sym___alignof] = ACTIONS(1472),
    [anon_sym__alignof] = ACTIONS(1472),
    [anon_sym_alignof] = ACTIONS(1472),
    [anon_sym__Alignof] = ACTIONS(1472),
    [anon_sym_offsetof] = ACTIONS(1472),
    [anon_sym__Generic] = ACTIONS(1472),
    [anon_sym_asm] = ACTIONS(1472),
    [anon_sym___asm__] = ACTIONS(1472),
    [sym_number_literal] = ACTIONS(1474),
    [anon_sym_L_SQUOTE] = ACTIONS(1474),
    [anon_sym_u_SQUOTE] = ACTIONS(1474),
    [anon_sym_U_SQUOTE] = ACTIONS(1474),
    [anon_sym_u8_SQUOTE] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_L_DQUOTE] = ACTIONS(1474),
    [anon_sym_u_DQUOTE] = ACTIONS(1474),
    [anon_sym_U_DQUOTE] = ACTIONS(1474),
    [anon_sym_u8_DQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [anon_sym_NULL] = ACTIONS(1472),
    [anon_sym_nullptr] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1472),
    [anon_sym_until] = ACTIONS(1472),
    [anon_sym_acquire] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_monitor] = ACTIONS(1472),
    [anon_sym_start] = ACTIONS(1472),
    [anon_sym_stop] = ACTIONS(1472),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(1575),
    [sym_identifier] = ACTIONS(1573),
    [aux_sym_preproc_include_token1] = ACTIONS(1573),
    [aux_sym_preproc_def_token1] = ACTIONS(1573),
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1575),
    [aux_sym_preproc_if_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1573),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(1573),
    [anon_sym_typedef] = ACTIONS(1573),
    [anon_sym_extern] = ACTIONS(1573),
    [anon_sym___attribute__] = ACTIONS(1573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1575),
    [anon_sym___declspec] = ACTIONS(1573),
    [anon_sym___cdecl] = ACTIONS(1573),
    [anon_sym___clrcall] = ACTIONS(1573),
    [anon_sym___stdcall] = ACTIONS(1573),
    [anon_sym___fastcall] = ACTIONS(1573),
    [anon_sym___thiscall] = ACTIONS(1573),
    [anon_sym___vectorcall] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_signed] = ACTIONS(1573),
    [anon_sym_unsigned] = ACTIONS(1573),
    [anon_sym_long] = ACTIONS(1573),
    [anon_sym_short] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_auto] = ACTIONS(1573),
    [anon_sym_register] = ACTIONS(1573),
    [anon_sym_inline] = ACTIONS(1573),
    [anon_sym___inline] = ACTIONS(1573),
    [anon_sym___inline__] = ACTIONS(1573),
    [anon_sym___forceinline] = ACTIONS(1573),
    [anon_sym_thread_local] = ACTIONS(1573),
    [anon_sym___thread] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_constexpr] = ACTIONS(1573),
    [anon_sym_volatile] = ACTIONS(1573),
    [anon_sym_restrict] = ACTIONS(1573),
    [anon_sym___restrict__] = ACTIONS(1573),
    [anon_sym__Atomic] = ACTIONS(1573),
    [anon_sym__Noreturn] = ACTIONS(1573),
    [anon_sym_noreturn] = ACTIONS(1573),
    [sym_primitive_type] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1573),
    [anon_sym_union] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_goto] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_sizeof] = ACTIONS(1573),
    [anon_sym___alignof__] = ACTIONS(1573),
    [anon_sym___alignof] = ACTIONS(1573),
    [anon_sym__alignof] = ACTIONS(1573),
    [anon_sym_alignof] = ACTIONS(1573),
    [anon_sym__Alignof] = ACTIONS(1573),
    [anon_sym_offsetof] = ACTIONS(1573),
    [anon_sym__Generic] = ACTIONS(1573),
    [anon_sym_asm] = ACTIONS(1573),
    [anon_sym___asm__] = ACTIONS(1573),
    [sym_number_literal] = ACTIONS(1575),
    [anon_sym_L_SQUOTE] = ACTIONS(1575),
    [anon_sym_u_SQUOTE] = ACTIONS(1575),
    [anon_sym_U_SQUOTE] = ACTIONS(1575),
    [anon_sym_u8_SQUOTE] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [anon_sym_NULL] = ACTIONS(1573),
    [anon_sym_nullptr] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1573),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_acquire] = ACTIONS(1573),
    [anon_sym_catch] = ACTIONS(1573),
    [anon_sym_monitor] = ACTIONS(1573),
    [anon_sym_start] = ACTIONS(1573),
    [anon_sym_stop] = ACTIONS(1573),
  },
  [150] = {
    [sym_catch_clause] = STATE(150),
    [aux_sym_monitor_statement_repeat1] = STATE(150),
    [ts_builtin_sym_end] = ACTIONS(1435),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_acquire] = ACTIONS(1433),
    [anon_sym_catch] = ACTIONS(1581),
    [anon_sym_monitor] = ACTIONS(1433),
    [anon_sym_start] = ACTIONS(1433),
    [anon_sym_stop] = ACTIONS(1433),
  },
  [151] = {
    [sym_identifier] = ACTIONS(1584),
    [aux_sym_preproc_include_token1] = ACTIONS(1584),
    [aux_sym_preproc_def_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token2] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1584),
    [aux_sym_preproc_else_token1] = ACTIONS(1584),
    [aux_sym_preproc_elif_token1] = ACTIONS(1584),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1584),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1584),
    [sym_preproc_directive] = ACTIONS(1584),
    [anon_sym_LPAREN2] = ACTIONS(1586),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym___extension__] = ACTIONS(1584),
    [anon_sym_typedef] = ACTIONS(1584),
    [anon_sym_extern] = ACTIONS(1584),
    [anon_sym___attribute__] = ACTIONS(1584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1586),
    [anon_sym___declspec] = ACTIONS(1584),
    [anon_sym___cdecl] = ACTIONS(1584),
    [anon_sym___clrcall] = ACTIONS(1584),
    [anon_sym___stdcall] = ACTIONS(1584),
    [anon_sym___fastcall] = ACTIONS(1584),
    [anon_sym___thiscall] = ACTIONS(1584),
    [anon_sym___vectorcall] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_signed] = ACTIONS(1584),
    [anon_sym_unsigned] = ACTIONS(1584),
    [anon_sym_long] = ACTIONS(1584),
    [anon_sym_short] = ACTIONS(1584),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_auto] = ACTIONS(1584),
    [anon_sym_register] = ACTIONS(1584),
    [anon_sym_inline] = ACTIONS(1584),
    [anon_sym___inline] = ACTIONS(1584),
    [anon_sym___inline__] = ACTIONS(1584),
    [anon_sym___forceinline] = ACTIONS(1584),
    [anon_sym_thread_local] = ACTIONS(1584),
    [anon_sym___thread] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_constexpr] = ACTIONS(1584),
    [anon_sym_volatile] = ACTIONS(1584),
    [anon_sym_restrict] = ACTIONS(1584),
    [anon_sym___restrict__] = ACTIONS(1584),
    [anon_sym__Atomic] = ACTIONS(1584),
    [anon_sym__Noreturn] = ACTIONS(1584),
    [anon_sym_noreturn] = ACTIONS(1584),
    [sym_primitive_type] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_goto] = ACTIONS(1584),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_sizeof] = ACTIONS(1584),
    [anon_sym___alignof__] = ACTIONS(1584),
    [anon_sym___alignof] = ACTIONS(1584),
    [anon_sym__alignof] = ACTIONS(1584),
    [anon_sym_alignof] = ACTIONS(1584),
    [anon_sym__Alignof] = ACTIONS(1584),
    [anon_sym_offsetof] = ACTIONS(1584),
    [anon_sym__Generic] = ACTIONS(1584),
    [anon_sym_asm] = ACTIONS(1584),
    [anon_sym___asm__] = ACTIONS(1584),
    [sym_number_literal] = ACTIONS(1586),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1586),
    [anon_sym_u_DQUOTE] = ACTIONS(1586),
    [anon_sym_U_DQUOTE] = ACTIONS(1586),
    [anon_sym_u8_DQUOTE] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [anon_sym_NULL] = ACTIONS(1584),
    [anon_sym_nullptr] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1584),
    [anon_sym_acquire] = ACTIONS(1584),
    [anon_sym_monitor] = ACTIONS(1584),
    [anon_sym_start] = ACTIONS(1584),
    [anon_sym_stop] = ACTIONS(1584),
  },
  [152] = {
    [sym_identifier] = ACTIONS(1573),
    [aux_sym_preproc_include_token1] = ACTIONS(1573),
    [aux_sym_preproc_def_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token2] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1573),
    [aux_sym_preproc_else_token1] = ACTIONS(1573),
    [aux_sym_preproc_elif_token1] = ACTIONS(1573),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(1573),
    [anon_sym_typedef] = ACTIONS(1573),
    [anon_sym_extern] = ACTIONS(1573),
    [anon_sym___attribute__] = ACTIONS(1573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1575),
    [anon_sym___declspec] = ACTIONS(1573),
    [anon_sym___cdecl] = ACTIONS(1573),
    [anon_sym___clrcall] = ACTIONS(1573),
    [anon_sym___stdcall] = ACTIONS(1573),
    [anon_sym___fastcall] = ACTIONS(1573),
    [anon_sym___thiscall] = ACTIONS(1573),
    [anon_sym___vectorcall] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_signed] = ACTIONS(1573),
    [anon_sym_unsigned] = ACTIONS(1573),
    [anon_sym_long] = ACTIONS(1573),
    [anon_sym_short] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_auto] = ACTIONS(1573),
    [anon_sym_register] = ACTIONS(1573),
    [anon_sym_inline] = ACTIONS(1573),
    [anon_sym___inline] = ACTIONS(1573),
    [anon_sym___inline__] = ACTIONS(1573),
    [anon_sym___forceinline] = ACTIONS(1573),
    [anon_sym_thread_local] = ACTIONS(1573),
    [anon_sym___thread] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_constexpr] = ACTIONS(1573),
    [anon_sym_volatile] = ACTIONS(1573),
    [anon_sym_restrict] = ACTIONS(1573),
    [anon_sym___restrict__] = ACTIONS(1573),
    [anon_sym__Atomic] = ACTIONS(1573),
    [anon_sym__Noreturn] = ACTIONS(1573),
    [anon_sym_noreturn] = ACTIONS(1573),
    [sym_primitive_type] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1573),
    [anon_sym_union] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_goto] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_sizeof] = ACTIONS(1573),
    [anon_sym___alignof__] = ACTIONS(1573),
    [anon_sym___alignof] = ACTIONS(1573),
    [anon_sym__alignof] = ACTIONS(1573),
    [anon_sym_alignof] = ACTIONS(1573),
    [anon_sym__Alignof] = ACTIONS(1573),
    [anon_sym_offsetof] = ACTIONS(1573),
    [anon_sym__Generic] = ACTIONS(1573),
    [anon_sym_asm] = ACTIONS(1573),
    [anon_sym___asm__] = ACTIONS(1573),
    [sym_number_literal] = ACTIONS(1575),
    [anon_sym_L_SQUOTE] = ACTIONS(1575),
    [anon_sym_u_SQUOTE] = ACTIONS(1575),
    [anon_sym_U_SQUOTE] = ACTIONS(1575),
    [anon_sym_u8_SQUOTE] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [anon_sym_NULL] = ACTIONS(1573),
    [anon_sym_nullptr] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_acquire] = ACTIONS(1573),
    [anon_sym_catch] = ACTIONS(1573),
    [anon_sym_monitor] = ACTIONS(1573),
    [anon_sym_start] = ACTIONS(1573),
    [anon_sym_stop] = ACTIONS(1573),
  },
  [153] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [154] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [155] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_include_token1] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token2] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [aux_sym_preproc_else_token1] = ACTIONS(1464),
    [aux_sym_preproc_elif_token1] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_LPAREN2] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym___extension__] = ACTIONS(1464),
    [anon_sym_typedef] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym___cdecl] = ACTIONS(1464),
    [anon_sym___clrcall] = ACTIONS(1464),
    [anon_sym___stdcall] = ACTIONS(1464),
    [anon_sym___fastcall] = ACTIONS(1464),
    [anon_sym___thiscall] = ACTIONS(1464),
    [anon_sym___vectorcall] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym___inline] = ACTIONS(1464),
    [anon_sym___inline__] = ACTIONS(1464),
    [anon_sym___forceinline] = ACTIONS(1464),
    [anon_sym_thread_local] = ACTIONS(1464),
    [anon_sym___thread] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_constexpr] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym___restrict__] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym__Noreturn] = ACTIONS(1464),
    [anon_sym_noreturn] = ACTIONS(1464),
    [sym_primitive_type] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_switch] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_goto] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_sizeof] = ACTIONS(1464),
    [anon_sym___alignof__] = ACTIONS(1464),
    [anon_sym___alignof] = ACTIONS(1464),
    [anon_sym__alignof] = ACTIONS(1464),
    [anon_sym_alignof] = ACTIONS(1464),
    [anon_sym__Alignof] = ACTIONS(1464),
    [anon_sym_offsetof] = ACTIONS(1464),
    [anon_sym__Generic] = ACTIONS(1464),
    [anon_sym_asm] = ACTIONS(1464),
    [anon_sym___asm__] = ACTIONS(1464),
    [sym_number_literal] = ACTIONS(1466),
    [anon_sym_L_SQUOTE] = ACTIONS(1466),
    [anon_sym_u_SQUOTE] = ACTIONS(1466),
    [anon_sym_U_SQUOTE] = ACTIONS(1466),
    [anon_sym_u8_SQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_L_DQUOTE] = ACTIONS(1466),
    [anon_sym_u_DQUOTE] = ACTIONS(1466),
    [anon_sym_U_DQUOTE] = ACTIONS(1466),
    [anon_sym_u8_DQUOTE] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [anon_sym_NULL] = ACTIONS(1464),
    [anon_sym_nullptr] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1464),
    [anon_sym_acquire] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_monitor] = ACTIONS(1464),
    [anon_sym_start] = ACTIONS(1464),
    [anon_sym_stop] = ACTIONS(1464),
  },
  [156] = {
    [sym_else_clause] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(1456),
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1454),
    [anon_sym_until] = ACTIONS(1454),
    [anon_sym_acquire] = ACTIONS(1454),
    [anon_sym_catch] = ACTIONS(1454),
    [anon_sym_monitor] = ACTIONS(1454),
    [anon_sym_start] = ACTIONS(1454),
    [anon_sym_stop] = ACTIONS(1454),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [158] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [163] = {
    [sym_catch_clause] = STATE(163),
    [aux_sym_monitor_statement_repeat1] = STATE(163),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_acquire] = ACTIONS(1433),
    [anon_sym_catch] = ACTIONS(1590),
    [anon_sym_monitor] = ACTIONS(1433),
    [anon_sym_start] = ACTIONS(1433),
    [anon_sym_stop] = ACTIONS(1433),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [165] = {
    [sym_identifier] = ACTIONS(1529),
    [aux_sym_preproc_include_token1] = ACTIONS(1529),
    [aux_sym_preproc_def_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token2] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1529),
    [aux_sym_preproc_else_token1] = ACTIONS(1529),
    [aux_sym_preproc_elif_token1] = ACTIONS(1529),
    [sym_preproc_directive] = ACTIONS(1529),
    [anon_sym_LPAREN2] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1529),
    [anon_sym_typedef] = ACTIONS(1529),
    [anon_sym_extern] = ACTIONS(1529),
    [anon_sym___attribute__] = ACTIONS(1529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1531),
    [anon_sym___declspec] = ACTIONS(1529),
    [anon_sym___cdecl] = ACTIONS(1529),
    [anon_sym___clrcall] = ACTIONS(1529),
    [anon_sym___stdcall] = ACTIONS(1529),
    [anon_sym___fastcall] = ACTIONS(1529),
    [anon_sym___thiscall] = ACTIONS(1529),
    [anon_sym___vectorcall] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_signed] = ACTIONS(1529),
    [anon_sym_unsigned] = ACTIONS(1529),
    [anon_sym_long] = ACTIONS(1529),
    [anon_sym_short] = ACTIONS(1529),
    [anon_sym_static] = ACTIONS(1529),
    [anon_sym_auto] = ACTIONS(1529),
    [anon_sym_register] = ACTIONS(1529),
    [anon_sym_inline] = ACTIONS(1529),
    [anon_sym___inline] = ACTIONS(1529),
    [anon_sym___inline__] = ACTIONS(1529),
    [anon_sym___forceinline] = ACTIONS(1529),
    [anon_sym_thread_local] = ACTIONS(1529),
    [anon_sym___thread] = ACTIONS(1529),
    [anon_sym_const] = ACTIONS(1529),
    [anon_sym_constexpr] = ACTIONS(1529),
    [anon_sym_volatile] = ACTIONS(1529),
    [anon_sym_restrict] = ACTIONS(1529),
    [anon_sym___restrict__] = ACTIONS(1529),
    [anon_sym__Atomic] = ACTIONS(1529),
    [anon_sym__Noreturn] = ACTIONS(1529),
    [anon_sym_noreturn] = ACTIONS(1529),
    [sym_primitive_type] = ACTIONS(1529),
    [anon_sym_enum] = ACTIONS(1529),
    [anon_sym_struct] = ACTIONS(1529),
    [anon_sym_union] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(1529),
    [anon_sym_else] = ACTIONS(1529),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_case] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1529),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1529),
    [anon_sym_return] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(1529),
    [anon_sym_continue] = ACTIONS(1529),
    [anon_sym_goto] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym___alignof__] = ACTIONS(1529),
    [anon_sym___alignof] = ACTIONS(1529),
    [anon_sym__alignof] = ACTIONS(1529),
    [anon_sym_alignof] = ACTIONS(1529),
    [anon_sym__Alignof] = ACTIONS(1529),
    [anon_sym_offsetof] = ACTIONS(1529),
    [anon_sym__Generic] = ACTIONS(1529),
    [anon_sym_asm] = ACTIONS(1529),
    [anon_sym___asm__] = ACTIONS(1529),
    [sym_number_literal] = ACTIONS(1531),
    [anon_sym_L_SQUOTE] = ACTIONS(1531),
    [anon_sym_u_SQUOTE] = ACTIONS(1531),
    [anon_sym_U_SQUOTE] = ACTIONS(1531),
    [anon_sym_u8_SQUOTE] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_L_DQUOTE] = ACTIONS(1531),
    [anon_sym_u_DQUOTE] = ACTIONS(1531),
    [anon_sym_U_DQUOTE] = ACTIONS(1531),
    [anon_sym_u8_DQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [anon_sym_NULL] = ACTIONS(1529),
    [anon_sym_nullptr] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1529),
    [anon_sym_acquire] = ACTIONS(1529),
    [anon_sym_catch] = ACTIONS(1529),
    [anon_sym_monitor] = ACTIONS(1529),
    [anon_sym_start] = ACTIONS(1529),
    [anon_sym_stop] = ACTIONS(1529),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1593),
    [aux_sym_preproc_include_token1] = ACTIONS(1593),
    [aux_sym_preproc_def_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token2] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1593),
    [aux_sym_preproc_else_token1] = ACTIONS(1593),
    [aux_sym_preproc_elif_token1] = ACTIONS(1593),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1593),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1593),
    [sym_preproc_directive] = ACTIONS(1593),
    [anon_sym_LPAREN2] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(1593),
    [anon_sym_extern] = ACTIONS(1593),
    [anon_sym___attribute__] = ACTIONS(1593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1595),
    [anon_sym___declspec] = ACTIONS(1593),
    [anon_sym___cdecl] = ACTIONS(1593),
    [anon_sym___clrcall] = ACTIONS(1593),
    [anon_sym___stdcall] = ACTIONS(1593),
    [anon_sym___fastcall] = ACTIONS(1593),
    [anon_sym___thiscall] = ACTIONS(1593),
    [anon_sym___vectorcall] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1595),
    [anon_sym_signed] = ACTIONS(1593),
    [anon_sym_unsigned] = ACTIONS(1593),
    [anon_sym_long] = ACTIONS(1593),
    [anon_sym_short] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_auto] = ACTIONS(1593),
    [anon_sym_register] = ACTIONS(1593),
    [anon_sym_inline] = ACTIONS(1593),
    [anon_sym___inline] = ACTIONS(1593),
    [anon_sym___inline__] = ACTIONS(1593),
    [anon_sym___forceinline] = ACTIONS(1593),
    [anon_sym_thread_local] = ACTIONS(1593),
    [anon_sym___thread] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_constexpr] = ACTIONS(1593),
    [anon_sym_volatile] = ACTIONS(1593),
    [anon_sym_restrict] = ACTIONS(1593),
    [anon_sym___restrict__] = ACTIONS(1593),
    [anon_sym__Atomic] = ACTIONS(1593),
    [anon_sym__Noreturn] = ACTIONS(1593),
    [anon_sym_noreturn] = ACTIONS(1593),
    [sym_primitive_type] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [anon_sym_struct] = ACTIONS(1593),
    [anon_sym_union] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_goto] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1595),
    [anon_sym_PLUS_PLUS] = ACTIONS(1595),
    [anon_sym_sizeof] = ACTIONS(1593),
    [anon_sym___alignof__] = ACTIONS(1593),
    [anon_sym___alignof] = ACTIONS(1593),
    [anon_sym__alignof] = ACTIONS(1593),
    [anon_sym_alignof] = ACTIONS(1593),
    [anon_sym__Alignof] = ACTIONS(1593),
    [anon_sym_offsetof] = ACTIONS(1593),
    [anon_sym__Generic] = ACTIONS(1593),
    [anon_sym_asm] = ACTIONS(1593),
    [anon_sym___asm__] = ACTIONS(1593),
    [sym_number_literal] = ACTIONS(1595),
    [anon_sym_L_SQUOTE] = ACTIONS(1595),
    [anon_sym_u_SQUOTE] = ACTIONS(1595),
    [anon_sym_U_SQUOTE] = ACTIONS(1595),
    [anon_sym_u8_SQUOTE] = ACTIONS(1595),
    [anon_sym_SQUOTE] = ACTIONS(1595),
    [anon_sym_L_DQUOTE] = ACTIONS(1595),
    [anon_sym_u_DQUOTE] = ACTIONS(1595),
    [anon_sym_U_DQUOTE] = ACTIONS(1595),
    [anon_sym_u8_DQUOTE] = ACTIONS(1595),
    [anon_sym_DQUOTE] = ACTIONS(1595),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [anon_sym_NULL] = ACTIONS(1593),
    [anon_sym_nullptr] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1593),
    [anon_sym_acquire] = ACTIONS(1593),
    [anon_sym_monitor] = ACTIONS(1593),
    [anon_sym_start] = ACTIONS(1593),
    [anon_sym_stop] = ACTIONS(1593),
  },
  [167] = {
    [sym_identifier] = ACTIONS(1597),
    [aux_sym_preproc_include_token1] = ACTIONS(1597),
    [aux_sym_preproc_def_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token2] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1597),
    [aux_sym_preproc_else_token1] = ACTIONS(1597),
    [aux_sym_preproc_elif_token1] = ACTIONS(1597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1597),
    [sym_preproc_directive] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym___extension__] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1597),
    [anon_sym_extern] = ACTIONS(1597),
    [anon_sym___attribute__] = ACTIONS(1597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1599),
    [anon_sym___declspec] = ACTIONS(1597),
    [anon_sym___cdecl] = ACTIONS(1597),
    [anon_sym___clrcall] = ACTIONS(1597),
    [anon_sym___stdcall] = ACTIONS(1597),
    [anon_sym___fastcall] = ACTIONS(1597),
    [anon_sym___thiscall] = ACTIONS(1597),
    [anon_sym___vectorcall] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_signed] = ACTIONS(1597),
    [anon_sym_unsigned] = ACTIONS(1597),
    [anon_sym_long] = ACTIONS(1597),
    [anon_sym_short] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_auto] = ACTIONS(1597),
    [anon_sym_register] = ACTIONS(1597),
    [anon_sym_inline] = ACTIONS(1597),
    [anon_sym___inline] = ACTIONS(1597),
    [anon_sym___inline__] = ACTIONS(1597),
    [anon_sym___forceinline] = ACTIONS(1597),
    [anon_sym_thread_local] = ACTIONS(1597),
    [anon_sym___thread] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(1597),
    [anon_sym_constexpr] = ACTIONS(1597),
    [anon_sym_volatile] = ACTIONS(1597),
    [anon_sym_restrict] = ACTIONS(1597),
    [anon_sym___restrict__] = ACTIONS(1597),
    [anon_sym__Atomic] = ACTIONS(1597),
    [anon_sym__Noreturn] = ACTIONS(1597),
    [anon_sym_noreturn] = ACTIONS(1597),
    [sym_primitive_type] = ACTIONS(1597),
    [anon_sym_enum] = ACTIONS(1597),
    [anon_sym_struct] = ACTIONS(1597),
    [anon_sym_union] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1597),
    [anon_sym_switch] = ACTIONS(1597),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1597),
    [anon_sym_while] = ACTIONS(1597),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_for] = ACTIONS(1597),
    [anon_sym_return] = ACTIONS(1597),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1597),
    [anon_sym_goto] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_sizeof] = ACTIONS(1597),
    [anon_sym___alignof__] = ACTIONS(1597),
    [anon_sym___alignof] = ACTIONS(1597),
    [anon_sym__alignof] = ACTIONS(1597),
    [anon_sym_alignof] = ACTIONS(1597),
    [anon_sym__Alignof] = ACTIONS(1597),
    [anon_sym_offsetof] = ACTIONS(1597),
    [anon_sym__Generic] = ACTIONS(1597),
    [anon_sym_asm] = ACTIONS(1597),
    [anon_sym___asm__] = ACTIONS(1597),
    [sym_number_literal] = ACTIONS(1599),
    [anon_sym_L_SQUOTE] = ACTIONS(1599),
    [anon_sym_u_SQUOTE] = ACTIONS(1599),
    [anon_sym_U_SQUOTE] = ACTIONS(1599),
    [anon_sym_u8_SQUOTE] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [anon_sym_L_DQUOTE] = ACTIONS(1599),
    [anon_sym_u_DQUOTE] = ACTIONS(1599),
    [anon_sym_U_DQUOTE] = ACTIONS(1599),
    [anon_sym_u8_DQUOTE] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [anon_sym_NULL] = ACTIONS(1597),
    [anon_sym_nullptr] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1597),
    [anon_sym_acquire] = ACTIONS(1597),
    [anon_sym_monitor] = ACTIONS(1597),
    [anon_sym_start] = ACTIONS(1597),
    [anon_sym_stop] = ACTIONS(1597),
  },
  [168] = {
    [sym_identifier] = ACTIONS(1601),
    [aux_sym_preproc_include_token1] = ACTIONS(1601),
    [aux_sym_preproc_def_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token2] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1601),
    [aux_sym_preproc_else_token1] = ACTIONS(1601),
    [aux_sym_preproc_elif_token1] = ACTIONS(1601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1601),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1601),
    [sym_preproc_directive] = ACTIONS(1601),
    [anon_sym_LPAREN2] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym___extension__] = ACTIONS(1601),
    [anon_sym_typedef] = ACTIONS(1601),
    [anon_sym_extern] = ACTIONS(1601),
    [anon_sym___attribute__] = ACTIONS(1601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1603),
    [anon_sym___declspec] = ACTIONS(1601),
    [anon_sym___cdecl] = ACTIONS(1601),
    [anon_sym___clrcall] = ACTIONS(1601),
    [anon_sym___stdcall] = ACTIONS(1601),
    [anon_sym___fastcall] = ACTIONS(1601),
    [anon_sym___thiscall] = ACTIONS(1601),
    [anon_sym___vectorcall] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_signed] = ACTIONS(1601),
    [anon_sym_unsigned] = ACTIONS(1601),
    [anon_sym_long] = ACTIONS(1601),
    [anon_sym_short] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1601),
    [anon_sym_auto] = ACTIONS(1601),
    [anon_sym_register] = ACTIONS(1601),
    [anon_sym_inline] = ACTIONS(1601),
    [anon_sym___inline] = ACTIONS(1601),
    [anon_sym___inline__] = ACTIONS(1601),
    [anon_sym___forceinline] = ACTIONS(1601),
    [anon_sym_thread_local] = ACTIONS(1601),
    [anon_sym___thread] = ACTIONS(1601),
    [anon_sym_const] = ACTIONS(1601),
    [anon_sym_constexpr] = ACTIONS(1601),
    [anon_sym_volatile] = ACTIONS(1601),
    [anon_sym_restrict] = ACTIONS(1601),
    [anon_sym___restrict__] = ACTIONS(1601),
    [anon_sym__Atomic] = ACTIONS(1601),
    [anon_sym__Noreturn] = ACTIONS(1601),
    [anon_sym_noreturn] = ACTIONS(1601),
    [sym_primitive_type] = ACTIONS(1601),
    [anon_sym_enum] = ACTIONS(1601),
    [anon_sym_struct] = ACTIONS(1601),
    [anon_sym_union] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_switch] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_while] = ACTIONS(1601),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1601),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1601),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_goto] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_sizeof] = ACTIONS(1601),
    [anon_sym___alignof__] = ACTIONS(1601),
    [anon_sym___alignof] = ACTIONS(1601),
    [anon_sym__alignof] = ACTIONS(1601),
    [anon_sym_alignof] = ACTIONS(1601),
    [anon_sym__Alignof] = ACTIONS(1601),
    [anon_sym_offsetof] = ACTIONS(1601),
    [anon_sym__Generic] = ACTIONS(1601),
    [anon_sym_asm] = ACTIONS(1601),
    [anon_sym___asm__] = ACTIONS(1601),
    [sym_number_literal] = ACTIONS(1603),
    [anon_sym_L_SQUOTE] = ACTIONS(1603),
    [anon_sym_u_SQUOTE] = ACTIONS(1603),
    [anon_sym_U_SQUOTE] = ACTIONS(1603),
    [anon_sym_u8_SQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [anon_sym_L_DQUOTE] = ACTIONS(1603),
    [anon_sym_u_DQUOTE] = ACTIONS(1603),
    [anon_sym_U_DQUOTE] = ACTIONS(1603),
    [anon_sym_u8_DQUOTE] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [anon_sym_NULL] = ACTIONS(1601),
    [anon_sym_nullptr] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1601),
    [anon_sym_acquire] = ACTIONS(1601),
    [anon_sym_monitor] = ACTIONS(1601),
    [anon_sym_start] = ACTIONS(1601),
    [anon_sym_stop] = ACTIONS(1601),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1605),
    [aux_sym_preproc_include_token1] = ACTIONS(1605),
    [aux_sym_preproc_def_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token2] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1605),
    [aux_sym_preproc_else_token1] = ACTIONS(1605),
    [aux_sym_preproc_elif_token1] = ACTIONS(1605),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1605),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1605),
    [sym_preproc_directive] = ACTIONS(1605),
    [anon_sym_LPAREN2] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym___extension__] = ACTIONS(1605),
    [anon_sym_typedef] = ACTIONS(1605),
    [anon_sym_extern] = ACTIONS(1605),
    [anon_sym___attribute__] = ACTIONS(1605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1607),
    [anon_sym___declspec] = ACTIONS(1605),
    [anon_sym___cdecl] = ACTIONS(1605),
    [anon_sym___clrcall] = ACTIONS(1605),
    [anon_sym___stdcall] = ACTIONS(1605),
    [anon_sym___fastcall] = ACTIONS(1605),
    [anon_sym___thiscall] = ACTIONS(1605),
    [anon_sym___vectorcall] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_signed] = ACTIONS(1605),
    [anon_sym_unsigned] = ACTIONS(1605),
    [anon_sym_long] = ACTIONS(1605),
    [anon_sym_short] = ACTIONS(1605),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_auto] = ACTIONS(1605),
    [anon_sym_register] = ACTIONS(1605),
    [anon_sym_inline] = ACTIONS(1605),
    [anon_sym___inline] = ACTIONS(1605),
    [anon_sym___inline__] = ACTIONS(1605),
    [anon_sym___forceinline] = ACTIONS(1605),
    [anon_sym_thread_local] = ACTIONS(1605),
    [anon_sym___thread] = ACTIONS(1605),
    [anon_sym_const] = ACTIONS(1605),
    [anon_sym_constexpr] = ACTIONS(1605),
    [anon_sym_volatile] = ACTIONS(1605),
    [anon_sym_restrict] = ACTIONS(1605),
    [anon_sym___restrict__] = ACTIONS(1605),
    [anon_sym__Atomic] = ACTIONS(1605),
    [anon_sym__Noreturn] = ACTIONS(1605),
    [anon_sym_noreturn] = ACTIONS(1605),
    [sym_primitive_type] = ACTIONS(1605),
    [anon_sym_enum] = ACTIONS(1605),
    [anon_sym_struct] = ACTIONS(1605),
    [anon_sym_union] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1605),
    [anon_sym_switch] = ACTIONS(1605),
    [anon_sym_case] = ACTIONS(1605),
    [anon_sym_default] = ACTIONS(1605),
    [anon_sym_while] = ACTIONS(1605),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_for] = ACTIONS(1605),
    [anon_sym_return] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1605),
    [anon_sym_goto] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_sizeof] = ACTIONS(1605),
    [anon_sym___alignof__] = ACTIONS(1605),
    [anon_sym___alignof] = ACTIONS(1605),
    [anon_sym__alignof] = ACTIONS(1605),
    [anon_sym_alignof] = ACTIONS(1605),
    [anon_sym__Alignof] = ACTIONS(1605),
    [anon_sym_offsetof] = ACTIONS(1605),
    [anon_sym__Generic] = ACTIONS(1605),
    [anon_sym_asm] = ACTIONS(1605),
    [anon_sym___asm__] = ACTIONS(1605),
    [sym_number_literal] = ACTIONS(1607),
    [anon_sym_L_SQUOTE] = ACTIONS(1607),
    [anon_sym_u_SQUOTE] = ACTIONS(1607),
    [anon_sym_U_SQUOTE] = ACTIONS(1607),
    [anon_sym_u8_SQUOTE] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [anon_sym_L_DQUOTE] = ACTIONS(1607),
    [anon_sym_u_DQUOTE] = ACTIONS(1607),
    [anon_sym_U_DQUOTE] = ACTIONS(1607),
    [anon_sym_u8_DQUOTE] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [anon_sym_NULL] = ACTIONS(1605),
    [anon_sym_nullptr] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1605),
    [anon_sym_acquire] = ACTIONS(1605),
    [anon_sym_monitor] = ACTIONS(1605),
    [anon_sym_start] = ACTIONS(1605),
    [anon_sym_stop] = ACTIONS(1605),
  },
  [170] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_include_token1] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token2] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [aux_sym_preproc_else_token1] = ACTIONS(1468),
    [aux_sym_preproc_elif_token1] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_LPAREN2] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym___cdecl] = ACTIONS(1468),
    [anon_sym___clrcall] = ACTIONS(1468),
    [anon_sym___stdcall] = ACTIONS(1468),
    [anon_sym___fastcall] = ACTIONS(1468),
    [anon_sym___thiscall] = ACTIONS(1468),
    [anon_sym___vectorcall] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym___inline] = ACTIONS(1468),
    [anon_sym___inline__] = ACTIONS(1468),
    [anon_sym___forceinline] = ACTIONS(1468),
    [anon_sym_thread_local] = ACTIONS(1468),
    [anon_sym___thread] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_constexpr] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym___restrict__] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym__Noreturn] = ACTIONS(1468),
    [anon_sym_noreturn] = ACTIONS(1468),
    [sym_primitive_type] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_goto] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_sizeof] = ACTIONS(1468),
    [anon_sym___alignof__] = ACTIONS(1468),
    [anon_sym___alignof] = ACTIONS(1468),
    [anon_sym__alignof] = ACTIONS(1468),
    [anon_sym_alignof] = ACTIONS(1468),
    [anon_sym__Alignof] = ACTIONS(1468),
    [anon_sym_offsetof] = ACTIONS(1468),
    [anon_sym__Generic] = ACTIONS(1468),
    [anon_sym_asm] = ACTIONS(1468),
    [anon_sym___asm__] = ACTIONS(1468),
    [sym_number_literal] = ACTIONS(1470),
    [anon_sym_L_SQUOTE] = ACTIONS(1470),
    [anon_sym_u_SQUOTE] = ACTIONS(1470),
    [anon_sym_U_SQUOTE] = ACTIONS(1470),
    [anon_sym_u8_SQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_L_DQUOTE] = ACTIONS(1470),
    [anon_sym_u_DQUOTE] = ACTIONS(1470),
    [anon_sym_U_DQUOTE] = ACTIONS(1470),
    [anon_sym_u8_DQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [anon_sym_NULL] = ACTIONS(1468),
    [anon_sym_nullptr] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1468),
    [anon_sym_acquire] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_monitor] = ACTIONS(1468),
    [anon_sym_start] = ACTIONS(1468),
    [anon_sym_stop] = ACTIONS(1468),
  },
  [171] = {
    [sym_catch_clause] = STATE(194),
    [aux_sym_monitor_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_include_token1] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym___extension__] = ACTIONS(1440),
    [anon_sym_typedef] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym___cdecl] = ACTIONS(1440),
    [anon_sym___clrcall] = ACTIONS(1440),
    [anon_sym___stdcall] = ACTIONS(1440),
    [anon_sym___fastcall] = ACTIONS(1440),
    [anon_sym___thiscall] = ACTIONS(1440),
    [anon_sym___vectorcall] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym___inline] = ACTIONS(1440),
    [anon_sym___inline__] = ACTIONS(1440),
    [anon_sym___forceinline] = ACTIONS(1440),
    [anon_sym_thread_local] = ACTIONS(1440),
    [anon_sym___thread] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym___restrict__] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym__Noreturn] = ACTIONS(1440),
    [anon_sym_noreturn] = ACTIONS(1440),
    [sym_primitive_type] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_switch] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_do] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_goto] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_sizeof] = ACTIONS(1440),
    [anon_sym___alignof__] = ACTIONS(1440),
    [anon_sym___alignof] = ACTIONS(1440),
    [anon_sym__alignof] = ACTIONS(1440),
    [anon_sym_alignof] = ACTIONS(1440),
    [anon_sym__Alignof] = ACTIONS(1440),
    [anon_sym_offsetof] = ACTIONS(1440),
    [anon_sym__Generic] = ACTIONS(1440),
    [anon_sym_asm] = ACTIONS(1440),
    [anon_sym___asm__] = ACTIONS(1440),
    [sym_number_literal] = ACTIONS(1442),
    [anon_sym_L_SQUOTE] = ACTIONS(1442),
    [anon_sym_u_SQUOTE] = ACTIONS(1442),
    [anon_sym_U_SQUOTE] = ACTIONS(1442),
    [anon_sym_u8_SQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_L_DQUOTE] = ACTIONS(1442),
    [anon_sym_u_DQUOTE] = ACTIONS(1442),
    [anon_sym_U_DQUOTE] = ACTIONS(1442),
    [anon_sym_u8_DQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [anon_sym_NULL] = ACTIONS(1440),
    [anon_sym_nullptr] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1440),
    [anon_sym_acquire] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1609),
    [anon_sym_monitor] = ACTIONS(1440),
    [anon_sym_start] = ACTIONS(1440),
    [anon_sym_stop] = ACTIONS(1440),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1611),
    [aux_sym_preproc_include_token1] = ACTIONS(1611),
    [aux_sym_preproc_def_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token2] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1611),
    [aux_sym_preproc_else_token1] = ACTIONS(1611),
    [aux_sym_preproc_elif_token1] = ACTIONS(1611),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1611),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1611),
    [sym_preproc_directive] = ACTIONS(1611),
    [anon_sym_LPAREN2] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym___extension__] = ACTIONS(1611),
    [anon_sym_typedef] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym___attribute__] = ACTIONS(1611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1613),
    [anon_sym___declspec] = ACTIONS(1611),
    [anon_sym___cdecl] = ACTIONS(1611),
    [anon_sym___clrcall] = ACTIONS(1611),
    [anon_sym___stdcall] = ACTIONS(1611),
    [anon_sym___fastcall] = ACTIONS(1611),
    [anon_sym___thiscall] = ACTIONS(1611),
    [anon_sym___vectorcall] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_signed] = ACTIONS(1611),
    [anon_sym_unsigned] = ACTIONS(1611),
    [anon_sym_long] = ACTIONS(1611),
    [anon_sym_short] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_auto] = ACTIONS(1611),
    [anon_sym_register] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym___inline] = ACTIONS(1611),
    [anon_sym___inline__] = ACTIONS(1611),
    [anon_sym___forceinline] = ACTIONS(1611),
    [anon_sym_thread_local] = ACTIONS(1611),
    [anon_sym___thread] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_constexpr] = ACTIONS(1611),
    [anon_sym_volatile] = ACTIONS(1611),
    [anon_sym_restrict] = ACTIONS(1611),
    [anon_sym___restrict__] = ACTIONS(1611),
    [anon_sym__Atomic] = ACTIONS(1611),
    [anon_sym__Noreturn] = ACTIONS(1611),
    [anon_sym_noreturn] = ACTIONS(1611),
    [sym_primitive_type] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_goto] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_sizeof] = ACTIONS(1611),
    [anon_sym___alignof__] = ACTIONS(1611),
    [anon_sym___alignof] = ACTIONS(1611),
    [anon_sym__alignof] = ACTIONS(1611),
    [anon_sym_alignof] = ACTIONS(1611),
    [anon_sym__Alignof] = ACTIONS(1611),
    [anon_sym_offsetof] = ACTIONS(1611),
    [anon_sym__Generic] = ACTIONS(1611),
    [anon_sym_asm] = ACTIONS(1611),
    [anon_sym___asm__] = ACTIONS(1611),
    [sym_number_literal] = ACTIONS(1613),
    [anon_sym_L_SQUOTE] = ACTIONS(1613),
    [anon_sym_u_SQUOTE] = ACTIONS(1613),
    [anon_sym_U_SQUOTE] = ACTIONS(1613),
    [anon_sym_u8_SQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_L_DQUOTE] = ACTIONS(1613),
    [anon_sym_u_DQUOTE] = ACTIONS(1613),
    [anon_sym_U_DQUOTE] = ACTIONS(1613),
    [anon_sym_u8_DQUOTE] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [sym_true] = ACTIONS(1611),
    [sym_false] = ACTIONS(1611),
    [anon_sym_NULL] = ACTIONS(1611),
    [anon_sym_nullptr] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1611),
    [anon_sym_acquire] = ACTIONS(1611),
    [anon_sym_monitor] = ACTIONS(1611),
    [anon_sym_start] = ACTIONS(1611),
    [anon_sym_stop] = ACTIONS(1611),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1549),
    [aux_sym_preproc_include_token1] = ACTIONS(1549),
    [aux_sym_preproc_def_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token2] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1549),
    [aux_sym_preproc_else_token1] = ACTIONS(1549),
    [aux_sym_preproc_elif_token1] = ACTIONS(1549),
    [sym_preproc_directive] = ACTIONS(1549),
    [anon_sym_LPAREN2] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym___extension__] = ACTIONS(1549),
    [anon_sym_typedef] = ACTIONS(1549),
    [anon_sym_extern] = ACTIONS(1549),
    [anon_sym___attribute__] = ACTIONS(1549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1551),
    [anon_sym___declspec] = ACTIONS(1549),
    [anon_sym___cdecl] = ACTIONS(1549),
    [anon_sym___clrcall] = ACTIONS(1549),
    [anon_sym___stdcall] = ACTIONS(1549),
    [anon_sym___fastcall] = ACTIONS(1549),
    [anon_sym___thiscall] = ACTIONS(1549),
    [anon_sym___vectorcall] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_signed] = ACTIONS(1549),
    [anon_sym_unsigned] = ACTIONS(1549),
    [anon_sym_long] = ACTIONS(1549),
    [anon_sym_short] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_auto] = ACTIONS(1549),
    [anon_sym_register] = ACTIONS(1549),
    [anon_sym_inline] = ACTIONS(1549),
    [anon_sym___inline] = ACTIONS(1549),
    [anon_sym___inline__] = ACTIONS(1549),
    [anon_sym___forceinline] = ACTIONS(1549),
    [anon_sym_thread_local] = ACTIONS(1549),
    [anon_sym___thread] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_constexpr] = ACTIONS(1549),
    [anon_sym_volatile] = ACTIONS(1549),
    [anon_sym_restrict] = ACTIONS(1549),
    [anon_sym___restrict__] = ACTIONS(1549),
    [anon_sym__Atomic] = ACTIONS(1549),
    [anon_sym__Noreturn] = ACTIONS(1549),
    [anon_sym_noreturn] = ACTIONS(1549),
    [sym_primitive_type] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [anon_sym_struct] = ACTIONS(1549),
    [anon_sym_union] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_goto] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1549),
    [anon_sym___alignof__] = ACTIONS(1549),
    [anon_sym___alignof] = ACTIONS(1549),
    [anon_sym__alignof] = ACTIONS(1549),
    [anon_sym_alignof] = ACTIONS(1549),
    [anon_sym__Alignof] = ACTIONS(1549),
    [anon_sym_offsetof] = ACTIONS(1549),
    [anon_sym__Generic] = ACTIONS(1549),
    [anon_sym_asm] = ACTIONS(1549),
    [anon_sym___asm__] = ACTIONS(1549),
    [sym_number_literal] = ACTIONS(1551),
    [anon_sym_L_SQUOTE] = ACTIONS(1551),
    [anon_sym_u_SQUOTE] = ACTIONS(1551),
    [anon_sym_U_SQUOTE] = ACTIONS(1551),
    [anon_sym_u8_SQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_L_DQUOTE] = ACTIONS(1551),
    [anon_sym_u_DQUOTE] = ACTIONS(1551),
    [anon_sym_U_DQUOTE] = ACTIONS(1551),
    [anon_sym_u8_DQUOTE] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [anon_sym_NULL] = ACTIONS(1549),
    [anon_sym_nullptr] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_acquire] = ACTIONS(1549),
    [anon_sym_catch] = ACTIONS(1549),
    [anon_sym_monitor] = ACTIONS(1549),
    [anon_sym_start] = ACTIONS(1549),
    [anon_sym_stop] = ACTIONS(1549),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1472),
    [aux_sym_preproc_include_token1] = ACTIONS(1472),
    [aux_sym_preproc_def_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token2] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1472),
    [aux_sym_preproc_else_token1] = ACTIONS(1472),
    [aux_sym_preproc_elif_token1] = ACTIONS(1472),
    [sym_preproc_directive] = ACTIONS(1472),
    [anon_sym_LPAREN2] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [anon_sym___extension__] = ACTIONS(1472),
    [anon_sym_typedef] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym___attribute__] = ACTIONS(1472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1474),
    [anon_sym___declspec] = ACTIONS(1472),
    [anon_sym___cdecl] = ACTIONS(1472),
    [anon_sym___clrcall] = ACTIONS(1472),
    [anon_sym___stdcall] = ACTIONS(1472),
    [anon_sym___fastcall] = ACTIONS(1472),
    [anon_sym___thiscall] = ACTIONS(1472),
    [anon_sym___vectorcall] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_signed] = ACTIONS(1472),
    [anon_sym_unsigned] = ACTIONS(1472),
    [anon_sym_long] = ACTIONS(1472),
    [anon_sym_short] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_auto] = ACTIONS(1472),
    [anon_sym_register] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym___inline] = ACTIONS(1472),
    [anon_sym___inline__] = ACTIONS(1472),
    [anon_sym___forceinline] = ACTIONS(1472),
    [anon_sym_thread_local] = ACTIONS(1472),
    [anon_sym___thread] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_constexpr] = ACTIONS(1472),
    [anon_sym_volatile] = ACTIONS(1472),
    [anon_sym_restrict] = ACTIONS(1472),
    [anon_sym___restrict__] = ACTIONS(1472),
    [anon_sym__Atomic] = ACTIONS(1472),
    [anon_sym__Noreturn] = ACTIONS(1472),
    [anon_sym_noreturn] = ACTIONS(1472),
    [sym_primitive_type] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_struct] = ACTIONS(1472),
    [anon_sym_union] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_goto] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [anon_sym_sizeof] = ACTIONS(1472),
    [anon_sym___alignof__] = ACTIONS(1472),
    [anon_sym___alignof] = ACTIONS(1472),
    [anon_sym__alignof] = ACTIONS(1472),
    [anon_sym_alignof] = ACTIONS(1472),
    [anon_sym__Alignof] = ACTIONS(1472),
    [anon_sym_offsetof] = ACTIONS(1472),
    [anon_sym__Generic] = ACTIONS(1472),
    [anon_sym_asm] = ACTIONS(1472),
    [anon_sym___asm__] = ACTIONS(1472),
    [sym_number_literal] = ACTIONS(1474),
    [anon_sym_L_SQUOTE] = ACTIONS(1474),
    [anon_sym_u_SQUOTE] = ACTIONS(1474),
    [anon_sym_U_SQUOTE] = ACTIONS(1474),
    [anon_sym_u8_SQUOTE] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_L_DQUOTE] = ACTIONS(1474),
    [anon_sym_u_DQUOTE] = ACTIONS(1474),
    [anon_sym_U_DQUOTE] = ACTIONS(1474),
    [anon_sym_u8_DQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [anon_sym_NULL] = ACTIONS(1472),
    [anon_sym_nullptr] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1472),
    [anon_sym_acquire] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_monitor] = ACTIONS(1472),
    [anon_sym_start] = ACTIONS(1472),
    [anon_sym_stop] = ACTIONS(1472),
  },
  [176] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_include_token1] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token2] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [aux_sym_preproc_else_token1] = ACTIONS(1476),
    [aux_sym_preproc_elif_token1] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_LPAREN2] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym___extension__] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym___cdecl] = ACTIONS(1476),
    [anon_sym___clrcall] = ACTIONS(1476),
    [anon_sym___stdcall] = ACTIONS(1476),
    [anon_sym___fastcall] = ACTIONS(1476),
    [anon_sym___thiscall] = ACTIONS(1476),
    [anon_sym___vectorcall] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym___inline] = ACTIONS(1476),
    [anon_sym___inline__] = ACTIONS(1476),
    [anon_sym___forceinline] = ACTIONS(1476),
    [anon_sym_thread_local] = ACTIONS(1476),
    [anon_sym___thread] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_constexpr] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym___restrict__] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym__Noreturn] = ACTIONS(1476),
    [anon_sym_noreturn] = ACTIONS(1476),
    [sym_primitive_type] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_switch] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_default] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_do] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_goto] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_sizeof] = ACTIONS(1476),
    [anon_sym___alignof__] = ACTIONS(1476),
    [anon_sym___alignof] = ACTIONS(1476),
    [anon_sym__alignof] = ACTIONS(1476),
    [anon_sym_alignof] = ACTIONS(1476),
    [anon_sym__Alignof] = ACTIONS(1476),
    [anon_sym_offsetof] = ACTIONS(1476),
    [anon_sym__Generic] = ACTIONS(1476),
    [anon_sym_asm] = ACTIONS(1476),
    [anon_sym___asm__] = ACTIONS(1476),
    [sym_number_literal] = ACTIONS(1478),
    [anon_sym_L_SQUOTE] = ACTIONS(1478),
    [anon_sym_u_SQUOTE] = ACTIONS(1478),
    [anon_sym_U_SQUOTE] = ACTIONS(1478),
    [anon_sym_u8_SQUOTE] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_L_DQUOTE] = ACTIONS(1478),
    [anon_sym_u_DQUOTE] = ACTIONS(1478),
    [anon_sym_U_DQUOTE] = ACTIONS(1478),
    [anon_sym_u8_DQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [anon_sym_NULL] = ACTIONS(1476),
    [anon_sym_nullptr] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1476),
    [anon_sym_acquire] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_monitor] = ACTIONS(1476),
    [anon_sym_start] = ACTIONS(1476),
    [anon_sym_stop] = ACTIONS(1476),
  },
  [177] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_include_token1] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token2] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [aux_sym_preproc_else_token1] = ACTIONS(1480),
    [aux_sym_preproc_elif_token1] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_LPAREN2] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym___extension__] = ACTIONS(1480),
    [anon_sym_typedef] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym___cdecl] = ACTIONS(1480),
    [anon_sym___clrcall] = ACTIONS(1480),
    [anon_sym___stdcall] = ACTIONS(1480),
    [anon_sym___fastcall] = ACTIONS(1480),
    [anon_sym___thiscall] = ACTIONS(1480),
    [anon_sym___vectorcall] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym___inline] = ACTIONS(1480),
    [anon_sym___inline__] = ACTIONS(1480),
    [anon_sym___forceinline] = ACTIONS(1480),
    [anon_sym_thread_local] = ACTIONS(1480),
    [anon_sym___thread] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_constexpr] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym___restrict__] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym__Noreturn] = ACTIONS(1480),
    [anon_sym_noreturn] = ACTIONS(1480),
    [sym_primitive_type] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_switch] = ACTIONS(1480),
    [anon_sym_case] = ACTIONS(1480),
    [anon_sym_default] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_do] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_goto] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_sizeof] = ACTIONS(1480),
    [anon_sym___alignof__] = ACTIONS(1480),
    [anon_sym___alignof] = ACTIONS(1480),
    [anon_sym__alignof] = ACTIONS(1480),
    [anon_sym_alignof] = ACTIONS(1480),
    [anon_sym__Alignof] = ACTIONS(1480),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1480),
    [anon_sym_asm] = ACTIONS(1480),
    [anon_sym___asm__] = ACTIONS(1480),
    [sym_number_literal] = ACTIONS(1482),
    [anon_sym_L_SQUOTE] = ACTIONS(1482),
    [anon_sym_u_SQUOTE] = ACTIONS(1482),
    [anon_sym_U_SQUOTE] = ACTIONS(1482),
    [anon_sym_u8_SQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_L_DQUOTE] = ACTIONS(1482),
    [anon_sym_u_DQUOTE] = ACTIONS(1482),
    [anon_sym_U_DQUOTE] = ACTIONS(1482),
    [anon_sym_u8_DQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [anon_sym_NULL] = ACTIONS(1480),
    [anon_sym_nullptr] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1480),
    [anon_sym_acquire] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_monitor] = ACTIONS(1480),
    [anon_sym_start] = ACTIONS(1480),
    [anon_sym_stop] = ACTIONS(1480),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1615),
    [aux_sym_preproc_include_token1] = ACTIONS(1615),
    [aux_sym_preproc_def_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token2] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1615),
    [aux_sym_preproc_else_token1] = ACTIONS(1615),
    [aux_sym_preproc_elif_token1] = ACTIONS(1615),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1615),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1615),
    [sym_preproc_directive] = ACTIONS(1615),
    [anon_sym_LPAREN2] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym___extension__] = ACTIONS(1615),
    [anon_sym_typedef] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym___attribute__] = ACTIONS(1615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1617),
    [anon_sym___declspec] = ACTIONS(1615),
    [anon_sym___cdecl] = ACTIONS(1615),
    [anon_sym___clrcall] = ACTIONS(1615),
    [anon_sym___stdcall] = ACTIONS(1615),
    [anon_sym___fastcall] = ACTIONS(1615),
    [anon_sym___thiscall] = ACTIONS(1615),
    [anon_sym___vectorcall] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_signed] = ACTIONS(1615),
    [anon_sym_unsigned] = ACTIONS(1615),
    [anon_sym_long] = ACTIONS(1615),
    [anon_sym_short] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_auto] = ACTIONS(1615),
    [anon_sym_register] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym___inline] = ACTIONS(1615),
    [anon_sym___inline__] = ACTIONS(1615),
    [anon_sym___forceinline] = ACTIONS(1615),
    [anon_sym_thread_local] = ACTIONS(1615),
    [anon_sym___thread] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_constexpr] = ACTIONS(1615),
    [anon_sym_volatile] = ACTIONS(1615),
    [anon_sym_restrict] = ACTIONS(1615),
    [anon_sym___restrict__] = ACTIONS(1615),
    [anon_sym__Atomic] = ACTIONS(1615),
    [anon_sym__Noreturn] = ACTIONS(1615),
    [anon_sym_noreturn] = ACTIONS(1615),
    [sym_primitive_type] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_goto] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_sizeof] = ACTIONS(1615),
    [anon_sym___alignof__] = ACTIONS(1615),
    [anon_sym___alignof] = ACTIONS(1615),
    [anon_sym__alignof] = ACTIONS(1615),
    [anon_sym_alignof] = ACTIONS(1615),
    [anon_sym__Alignof] = ACTIONS(1615),
    [anon_sym_offsetof] = ACTIONS(1615),
    [anon_sym__Generic] = ACTIONS(1615),
    [anon_sym_asm] = ACTIONS(1615),
    [anon_sym___asm__] = ACTIONS(1615),
    [sym_number_literal] = ACTIONS(1617),
    [anon_sym_L_SQUOTE] = ACTIONS(1617),
    [anon_sym_u_SQUOTE] = ACTIONS(1617),
    [anon_sym_U_SQUOTE] = ACTIONS(1617),
    [anon_sym_u8_SQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [anon_sym_L_DQUOTE] = ACTIONS(1617),
    [anon_sym_u_DQUOTE] = ACTIONS(1617),
    [anon_sym_U_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8_DQUOTE] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_true] = ACTIONS(1615),
    [sym_false] = ACTIONS(1615),
    [anon_sym_NULL] = ACTIONS(1615),
    [anon_sym_nullptr] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1615),
    [anon_sym_acquire] = ACTIONS(1615),
    [anon_sym_monitor] = ACTIONS(1615),
    [anon_sym_start] = ACTIONS(1615),
    [anon_sym_stop] = ACTIONS(1615),
  },
  [179] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_include_token1] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token2] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [aux_sym_preproc_else_token1] = ACTIONS(1484),
    [aux_sym_preproc_elif_token1] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_LPAREN2] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym___extension__] = ACTIONS(1484),
    [anon_sym_typedef] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym___cdecl] = ACTIONS(1484),
    [anon_sym___clrcall] = ACTIONS(1484),
    [anon_sym___stdcall] = ACTIONS(1484),
    [anon_sym___fastcall] = ACTIONS(1484),
    [anon_sym___thiscall] = ACTIONS(1484),
    [anon_sym___vectorcall] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym___inline] = ACTIONS(1484),
    [anon_sym___inline__] = ACTIONS(1484),
    [anon_sym___forceinline] = ACTIONS(1484),
    [anon_sym_thread_local] = ACTIONS(1484),
    [anon_sym___thread] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_constexpr] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym___restrict__] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym__Noreturn] = ACTIONS(1484),
    [anon_sym_noreturn] = ACTIONS(1484),
    [sym_primitive_type] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_goto] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_sizeof] = ACTIONS(1484),
    [anon_sym___alignof__] = ACTIONS(1484),
    [anon_sym___alignof] = ACTIONS(1484),
    [anon_sym__alignof] = ACTIONS(1484),
    [anon_sym_alignof] = ACTIONS(1484),
    [anon_sym__Alignof] = ACTIONS(1484),
    [anon_sym_offsetof] = ACTIONS(1484),
    [anon_sym__Generic] = ACTIONS(1484),
    [anon_sym_asm] = ACTIONS(1484),
    [anon_sym___asm__] = ACTIONS(1484),
    [sym_number_literal] = ACTIONS(1486),
    [anon_sym_L_SQUOTE] = ACTIONS(1486),
    [anon_sym_u_SQUOTE] = ACTIONS(1486),
    [anon_sym_U_SQUOTE] = ACTIONS(1486),
    [anon_sym_u8_SQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_L_DQUOTE] = ACTIONS(1486),
    [anon_sym_u_DQUOTE] = ACTIONS(1486),
    [anon_sym_U_DQUOTE] = ACTIONS(1486),
    [anon_sym_u8_DQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [anon_sym_NULL] = ACTIONS(1484),
    [anon_sym_nullptr] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1484),
    [anon_sym_acquire] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_monitor] = ACTIONS(1484),
    [anon_sym_start] = ACTIONS(1484),
    [anon_sym_stop] = ACTIONS(1484),
  },
  [180] = {
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_include_token1] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token2] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1557),
    [aux_sym_preproc_else_token1] = ACTIONS(1557),
    [aux_sym_preproc_elif_token1] = ACTIONS(1557),
    [sym_preproc_directive] = ACTIONS(1557),
    [anon_sym_LPAREN2] = ACTIONS(1559),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym___extension__] = ACTIONS(1557),
    [anon_sym_typedef] = ACTIONS(1557),
    [anon_sym_extern] = ACTIONS(1557),
    [anon_sym___attribute__] = ACTIONS(1557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1559),
    [anon_sym___declspec] = ACTIONS(1557),
    [anon_sym___cdecl] = ACTIONS(1557),
    [anon_sym___clrcall] = ACTIONS(1557),
    [anon_sym___stdcall] = ACTIONS(1557),
    [anon_sym___fastcall] = ACTIONS(1557),
    [anon_sym___thiscall] = ACTIONS(1557),
    [anon_sym___vectorcall] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_signed] = ACTIONS(1557),
    [anon_sym_unsigned] = ACTIONS(1557),
    [anon_sym_long] = ACTIONS(1557),
    [anon_sym_short] = ACTIONS(1557),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_auto] = ACTIONS(1557),
    [anon_sym_register] = ACTIONS(1557),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym___inline] = ACTIONS(1557),
    [anon_sym___inline__] = ACTIONS(1557),
    [anon_sym___forceinline] = ACTIONS(1557),
    [anon_sym_thread_local] = ACTIONS(1557),
    [anon_sym___thread] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_constexpr] = ACTIONS(1557),
    [anon_sym_volatile] = ACTIONS(1557),
    [anon_sym_restrict] = ACTIONS(1557),
    [anon_sym___restrict__] = ACTIONS(1557),
    [anon_sym__Atomic] = ACTIONS(1557),
    [anon_sym__Noreturn] = ACTIONS(1557),
    [anon_sym_noreturn] = ACTIONS(1557),
    [sym_primitive_type] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [anon_sym_struct] = ACTIONS(1557),
    [anon_sym_union] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_goto] = ACTIONS(1557),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_sizeof] = ACTIONS(1557),
    [anon_sym___alignof__] = ACTIONS(1557),
    [anon_sym___alignof] = ACTIONS(1557),
    [anon_sym__alignof] = ACTIONS(1557),
    [anon_sym_alignof] = ACTIONS(1557),
    [anon_sym__Alignof] = ACTIONS(1557),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1557),
    [anon_sym_asm] = ACTIONS(1557),
    [anon_sym___asm__] = ACTIONS(1557),
    [sym_number_literal] = ACTIONS(1559),
    [anon_sym_L_SQUOTE] = ACTIONS(1559),
    [anon_sym_u_SQUOTE] = ACTIONS(1559),
    [anon_sym_U_SQUOTE] = ACTIONS(1559),
    [anon_sym_u8_SQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [anon_sym_L_DQUOTE] = ACTIONS(1559),
    [anon_sym_u_DQUOTE] = ACTIONS(1559),
    [anon_sym_U_DQUOTE] = ACTIONS(1559),
    [anon_sym_u8_DQUOTE] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [anon_sym_NULL] = ACTIONS(1557),
    [anon_sym_nullptr] = ACTIONS(1557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_acquire] = ACTIONS(1557),
    [anon_sym_catch] = ACTIONS(1557),
    [anon_sym_monitor] = ACTIONS(1557),
    [anon_sym_start] = ACTIONS(1557),
    [anon_sym_stop] = ACTIONS(1557),
  },
  [181] = {
    [sym_identifier] = ACTIONS(1619),
    [aux_sym_preproc_include_token1] = ACTIONS(1619),
    [aux_sym_preproc_def_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token2] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1619),
    [aux_sym_preproc_else_token1] = ACTIONS(1619),
    [aux_sym_preproc_elif_token1] = ACTIONS(1619),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1619),
    [sym_preproc_directive] = ACTIONS(1619),
    [anon_sym_LPAREN2] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym___extension__] = ACTIONS(1619),
    [anon_sym_typedef] = ACTIONS(1619),
    [anon_sym_extern] = ACTIONS(1619),
    [anon_sym___attribute__] = ACTIONS(1619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1621),
    [anon_sym___declspec] = ACTIONS(1619),
    [anon_sym___cdecl] = ACTIONS(1619),
    [anon_sym___clrcall] = ACTIONS(1619),
    [anon_sym___stdcall] = ACTIONS(1619),
    [anon_sym___fastcall] = ACTIONS(1619),
    [anon_sym___thiscall] = ACTIONS(1619),
    [anon_sym___vectorcall] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_signed] = ACTIONS(1619),
    [anon_sym_unsigned] = ACTIONS(1619),
    [anon_sym_long] = ACTIONS(1619),
    [anon_sym_short] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_auto] = ACTIONS(1619),
    [anon_sym_register] = ACTIONS(1619),
    [anon_sym_inline] = ACTIONS(1619),
    [anon_sym___inline] = ACTIONS(1619),
    [anon_sym___inline__] = ACTIONS(1619),
    [anon_sym___forceinline] = ACTIONS(1619),
    [anon_sym_thread_local] = ACTIONS(1619),
    [anon_sym___thread] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_constexpr] = ACTIONS(1619),
    [anon_sym_volatile] = ACTIONS(1619),
    [anon_sym_restrict] = ACTIONS(1619),
    [anon_sym___restrict__] = ACTIONS(1619),
    [anon_sym__Atomic] = ACTIONS(1619),
    [anon_sym__Noreturn] = ACTIONS(1619),
    [anon_sym_noreturn] = ACTIONS(1619),
    [sym_primitive_type] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [anon_sym_struct] = ACTIONS(1619),
    [anon_sym_union] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_switch] = ACTIONS(1619),
    [anon_sym_case] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_goto] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_sizeof] = ACTIONS(1619),
    [anon_sym___alignof__] = ACTIONS(1619),
    [anon_sym___alignof] = ACTIONS(1619),
    [anon_sym__alignof] = ACTIONS(1619),
    [anon_sym_alignof] = ACTIONS(1619),
    [anon_sym__Alignof] = ACTIONS(1619),
    [anon_sym_offsetof] = ACTIONS(1619),
    [anon_sym__Generic] = ACTIONS(1619),
    [anon_sym_asm] = ACTIONS(1619),
    [anon_sym___asm__] = ACTIONS(1619),
    [sym_number_literal] = ACTIONS(1621),
    [anon_sym_L_SQUOTE] = ACTIONS(1621),
    [anon_sym_u_SQUOTE] = ACTIONS(1621),
    [anon_sym_U_SQUOTE] = ACTIONS(1621),
    [anon_sym_u8_SQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [anon_sym_L_DQUOTE] = ACTIONS(1621),
    [anon_sym_u_DQUOTE] = ACTIONS(1621),
    [anon_sym_U_DQUOTE] = ACTIONS(1621),
    [anon_sym_u8_DQUOTE] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [anon_sym_NULL] = ACTIONS(1619),
    [anon_sym_nullptr] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1619),
    [anon_sym_acquire] = ACTIONS(1619),
    [anon_sym_monitor] = ACTIONS(1619),
    [anon_sym_start] = ACTIONS(1619),
    [anon_sym_stop] = ACTIONS(1619),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1623),
    [aux_sym_preproc_include_token1] = ACTIONS(1623),
    [aux_sym_preproc_def_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token2] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1623),
    [aux_sym_preproc_else_token1] = ACTIONS(1623),
    [aux_sym_preproc_elif_token1] = ACTIONS(1623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1623),
    [sym_preproc_directive] = ACTIONS(1623),
    [anon_sym_LPAREN2] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym___extension__] = ACTIONS(1623),
    [anon_sym_typedef] = ACTIONS(1623),
    [anon_sym_extern] = ACTIONS(1623),
    [anon_sym___attribute__] = ACTIONS(1623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1625),
    [anon_sym___declspec] = ACTIONS(1623),
    [anon_sym___cdecl] = ACTIONS(1623),
    [anon_sym___clrcall] = ACTIONS(1623),
    [anon_sym___stdcall] = ACTIONS(1623),
    [anon_sym___fastcall] = ACTIONS(1623),
    [anon_sym___thiscall] = ACTIONS(1623),
    [anon_sym___vectorcall] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_signed] = ACTIONS(1623),
    [anon_sym_unsigned] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_auto] = ACTIONS(1623),
    [anon_sym_register] = ACTIONS(1623),
    [anon_sym_inline] = ACTIONS(1623),
    [anon_sym___inline] = ACTIONS(1623),
    [anon_sym___inline__] = ACTIONS(1623),
    [anon_sym___forceinline] = ACTIONS(1623),
    [anon_sym_thread_local] = ACTIONS(1623),
    [anon_sym___thread] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_constexpr] = ACTIONS(1623),
    [anon_sym_volatile] = ACTIONS(1623),
    [anon_sym_restrict] = ACTIONS(1623),
    [anon_sym___restrict__] = ACTIONS(1623),
    [anon_sym__Atomic] = ACTIONS(1623),
    [anon_sym__Noreturn] = ACTIONS(1623),
    [anon_sym_noreturn] = ACTIONS(1623),
    [sym_primitive_type] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [anon_sym_struct] = ACTIONS(1623),
    [anon_sym_union] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_goto] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_sizeof] = ACTIONS(1623),
    [anon_sym___alignof__] = ACTIONS(1623),
    [anon_sym___alignof] = ACTIONS(1623),
    [anon_sym__alignof] = ACTIONS(1623),
    [anon_sym_alignof] = ACTIONS(1623),
    [anon_sym__Alignof] = ACTIONS(1623),
    [anon_sym_offsetof] = ACTIONS(1623),
    [anon_sym__Generic] = ACTIONS(1623),
    [anon_sym_asm] = ACTIONS(1623),
    [anon_sym___asm__] = ACTIONS(1623),
    [sym_number_literal] = ACTIONS(1625),
    [anon_sym_L_SQUOTE] = ACTIONS(1625),
    [anon_sym_u_SQUOTE] = ACTIONS(1625),
    [anon_sym_U_SQUOTE] = ACTIONS(1625),
    [anon_sym_u8_SQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [anon_sym_L_DQUOTE] = ACTIONS(1625),
    [anon_sym_u_DQUOTE] = ACTIONS(1625),
    [anon_sym_U_DQUOTE] = ACTIONS(1625),
    [anon_sym_u8_DQUOTE] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [anon_sym_NULL] = ACTIONS(1623),
    [anon_sym_nullptr] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1623),
    [anon_sym_acquire] = ACTIONS(1623),
    [anon_sym_monitor] = ACTIONS(1623),
    [anon_sym_start] = ACTIONS(1623),
    [anon_sym_stop] = ACTIONS(1623),
  },
  [183] = {
    [sym_identifier] = ACTIONS(1565),
    [aux_sym_preproc_include_token1] = ACTIONS(1565),
    [aux_sym_preproc_def_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token2] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1565),
    [aux_sym_preproc_elif_token1] = ACTIONS(1565),
    [sym_preproc_directive] = ACTIONS(1565),
    [anon_sym_LPAREN2] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1565),
    [anon_sym_typedef] = ACTIONS(1565),
    [anon_sym_extern] = ACTIONS(1565),
    [anon_sym___attribute__] = ACTIONS(1565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1567),
    [anon_sym___declspec] = ACTIONS(1565),
    [anon_sym___cdecl] = ACTIONS(1565),
    [anon_sym___clrcall] = ACTIONS(1565),
    [anon_sym___stdcall] = ACTIONS(1565),
    [anon_sym___fastcall] = ACTIONS(1565),
    [anon_sym___thiscall] = ACTIONS(1565),
    [anon_sym___vectorcall] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_signed] = ACTIONS(1565),
    [anon_sym_unsigned] = ACTIONS(1565),
    [anon_sym_long] = ACTIONS(1565),
    [anon_sym_short] = ACTIONS(1565),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_auto] = ACTIONS(1565),
    [anon_sym_register] = ACTIONS(1565),
    [anon_sym_inline] = ACTIONS(1565),
    [anon_sym___inline] = ACTIONS(1565),
    [anon_sym___inline__] = ACTIONS(1565),
    [anon_sym___forceinline] = ACTIONS(1565),
    [anon_sym_thread_local] = ACTIONS(1565),
    [anon_sym___thread] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_constexpr] = ACTIONS(1565),
    [anon_sym_volatile] = ACTIONS(1565),
    [anon_sym_restrict] = ACTIONS(1565),
    [anon_sym___restrict__] = ACTIONS(1565),
    [anon_sym__Atomic] = ACTIONS(1565),
    [anon_sym__Noreturn] = ACTIONS(1565),
    [anon_sym_noreturn] = ACTIONS(1565),
    [sym_primitive_type] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [anon_sym_struct] = ACTIONS(1565),
    [anon_sym_union] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_goto] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_sizeof] = ACTIONS(1565),
    [anon_sym___alignof__] = ACTIONS(1565),
    [anon_sym___alignof] = ACTIONS(1565),
    [anon_sym__alignof] = ACTIONS(1565),
    [anon_sym_alignof] = ACTIONS(1565),
    [anon_sym__Alignof] = ACTIONS(1565),
    [anon_sym_offsetof] = ACTIONS(1565),
    [anon_sym__Generic] = ACTIONS(1565),
    [anon_sym_asm] = ACTIONS(1565),
    [anon_sym___asm__] = ACTIONS(1565),
    [sym_number_literal] = ACTIONS(1567),
    [anon_sym_L_SQUOTE] = ACTIONS(1567),
    [anon_sym_u_SQUOTE] = ACTIONS(1567),
    [anon_sym_U_SQUOTE] = ACTIONS(1567),
    [anon_sym_u8_SQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [anon_sym_L_DQUOTE] = ACTIONS(1567),
    [anon_sym_u_DQUOTE] = ACTIONS(1567),
    [anon_sym_U_DQUOTE] = ACTIONS(1567),
    [anon_sym_u8_DQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [anon_sym_NULL] = ACTIONS(1565),
    [anon_sym_nullptr] = ACTIONS(1565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_acquire] = ACTIONS(1565),
    [anon_sym_catch] = ACTIONS(1565),
    [anon_sym_monitor] = ACTIONS(1565),
    [anon_sym_start] = ACTIONS(1565),
    [anon_sym_stop] = ACTIONS(1565),
  },
  [184] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_include_token1] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token2] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [aux_sym_preproc_else_token1] = ACTIONS(1488),
    [aux_sym_preproc_elif_token1] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_LPAREN2] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym___extension__] = ACTIONS(1488),
    [anon_sym_typedef] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym___cdecl] = ACTIONS(1488),
    [anon_sym___clrcall] = ACTIONS(1488),
    [anon_sym___stdcall] = ACTIONS(1488),
    [anon_sym___fastcall] = ACTIONS(1488),
    [anon_sym___thiscall] = ACTIONS(1488),
    [anon_sym___vectorcall] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym___inline] = ACTIONS(1488),
    [anon_sym___inline__] = ACTIONS(1488),
    [anon_sym___forceinline] = ACTIONS(1488),
    [anon_sym_thread_local] = ACTIONS(1488),
    [anon_sym___thread] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_constexpr] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym___restrict__] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym__Noreturn] = ACTIONS(1488),
    [anon_sym_noreturn] = ACTIONS(1488),
    [sym_primitive_type] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_goto] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_sizeof] = ACTIONS(1488),
    [anon_sym___alignof__] = ACTIONS(1488),
    [anon_sym___alignof] = ACTIONS(1488),
    [anon_sym__alignof] = ACTIONS(1488),
    [anon_sym_alignof] = ACTIONS(1488),
    [anon_sym__Alignof] = ACTIONS(1488),
    [anon_sym_offsetof] = ACTIONS(1488),
    [anon_sym__Generic] = ACTIONS(1488),
    [anon_sym_asm] = ACTIONS(1488),
    [anon_sym___asm__] = ACTIONS(1488),
    [sym_number_literal] = ACTIONS(1490),
    [anon_sym_L_SQUOTE] = ACTIONS(1490),
    [anon_sym_u_SQUOTE] = ACTIONS(1490),
    [anon_sym_U_SQUOTE] = ACTIONS(1490),
    [anon_sym_u8_SQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_L_DQUOTE] = ACTIONS(1490),
    [anon_sym_u_DQUOTE] = ACTIONS(1490),
    [anon_sym_U_DQUOTE] = ACTIONS(1490),
    [anon_sym_u8_DQUOTE] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [anon_sym_NULL] = ACTIONS(1488),
    [anon_sym_nullptr] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1488),
    [anon_sym_acquire] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_monitor] = ACTIONS(1488),
    [anon_sym_start] = ACTIONS(1488),
    [anon_sym_stop] = ACTIONS(1488),
  },
  [185] = {
    [sym_identifier] = ACTIONS(1627),
    [aux_sym_preproc_include_token1] = ACTIONS(1627),
    [aux_sym_preproc_def_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token2] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1627),
    [aux_sym_preproc_else_token1] = ACTIONS(1627),
    [aux_sym_preproc_elif_token1] = ACTIONS(1627),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1627),
    [sym_preproc_directive] = ACTIONS(1627),
    [anon_sym_LPAREN2] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_typedef] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1627),
    [anon_sym___attribute__] = ACTIONS(1627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1629),
    [anon_sym___declspec] = ACTIONS(1627),
    [anon_sym___cdecl] = ACTIONS(1627),
    [anon_sym___clrcall] = ACTIONS(1627),
    [anon_sym___stdcall] = ACTIONS(1627),
    [anon_sym___fastcall] = ACTIONS(1627),
    [anon_sym___thiscall] = ACTIONS(1627),
    [anon_sym___vectorcall] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_signed] = ACTIONS(1627),
    [anon_sym_unsigned] = ACTIONS(1627),
    [anon_sym_long] = ACTIONS(1627),
    [anon_sym_short] = ACTIONS(1627),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_auto] = ACTIONS(1627),
    [anon_sym_register] = ACTIONS(1627),
    [anon_sym_inline] = ACTIONS(1627),
    [anon_sym___inline] = ACTIONS(1627),
    [anon_sym___inline__] = ACTIONS(1627),
    [anon_sym___forceinline] = ACTIONS(1627),
    [anon_sym_thread_local] = ACTIONS(1627),
    [anon_sym___thread] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [sym_primitive_type] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1627),
    [anon_sym_union] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_goto] = ACTIONS(1627),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_sizeof] = ACTIONS(1627),
    [anon_sym___alignof__] = ACTIONS(1627),
    [anon_sym___alignof] = ACTIONS(1627),
    [anon_sym__alignof] = ACTIONS(1627),
    [anon_sym_alignof] = ACTIONS(1627),
    [anon_sym__Alignof] = ACTIONS(1627),
    [anon_sym_offsetof] = ACTIONS(1627),
    [anon_sym__Generic] = ACTIONS(1627),
    [anon_sym_asm] = ACTIONS(1627),
    [anon_sym___asm__] = ACTIONS(1627),
    [sym_number_literal] = ACTIONS(1629),
    [anon_sym_L_SQUOTE] = ACTIONS(1629),
    [anon_sym_u_SQUOTE] = ACTIONS(1629),
    [anon_sym_U_SQUOTE] = ACTIONS(1629),
    [anon_sym_u8_SQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [anon_sym_L_DQUOTE] = ACTIONS(1629),
    [anon_sym_u_DQUOTE] = ACTIONS(1629),
    [anon_sym_U_DQUOTE] = ACTIONS(1629),
    [anon_sym_u8_DQUOTE] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [anon_sym_NULL] = ACTIONS(1627),
    [anon_sym_nullptr] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_acquire] = ACTIONS(1627),
    [anon_sym_monitor] = ACTIONS(1627),
    [anon_sym_start] = ACTIONS(1627),
    [anon_sym_stop] = ACTIONS(1627),
  },
  [186] = {
    [sym_catch_clause] = STATE(163),
    [aux_sym_monitor_statement_repeat1] = STATE(163),
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_include_token1] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token2] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym___extension__] = ACTIONS(1440),
    [anon_sym_typedef] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym___cdecl] = ACTIONS(1440),
    [anon_sym___clrcall] = ACTIONS(1440),
    [anon_sym___stdcall] = ACTIONS(1440),
    [anon_sym___fastcall] = ACTIONS(1440),
    [anon_sym___thiscall] = ACTIONS(1440),
    [anon_sym___vectorcall] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym___inline] = ACTIONS(1440),
    [anon_sym___inline__] = ACTIONS(1440),
    [anon_sym___forceinline] = ACTIONS(1440),
    [anon_sym_thread_local] = ACTIONS(1440),
    [anon_sym___thread] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym___restrict__] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym__Noreturn] = ACTIONS(1440),
    [anon_sym_noreturn] = ACTIONS(1440),
    [sym_primitive_type] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_switch] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_do] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_goto] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_sizeof] = ACTIONS(1440),
    [anon_sym___alignof__] = ACTIONS(1440),
    [anon_sym___alignof] = ACTIONS(1440),
    [anon_sym__alignof] = ACTIONS(1440),
    [anon_sym_alignof] = ACTIONS(1440),
    [anon_sym__Alignof] = ACTIONS(1440),
    [anon_sym_offsetof] = ACTIONS(1440),
    [anon_sym__Generic] = ACTIONS(1440),
    [anon_sym_asm] = ACTIONS(1440),
    [anon_sym___asm__] = ACTIONS(1440),
    [sym_number_literal] = ACTIONS(1442),
    [anon_sym_L_SQUOTE] = ACTIONS(1442),
    [anon_sym_u_SQUOTE] = ACTIONS(1442),
    [anon_sym_U_SQUOTE] = ACTIONS(1442),
    [anon_sym_u8_SQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_L_DQUOTE] = ACTIONS(1442),
    [anon_sym_u_DQUOTE] = ACTIONS(1442),
    [anon_sym_U_DQUOTE] = ACTIONS(1442),
    [anon_sym_u8_DQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [anon_sym_NULL] = ACTIONS(1440),
    [anon_sym_nullptr] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1440),
    [anon_sym_acquire] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1631),
    [anon_sym_monitor] = ACTIONS(1440),
    [anon_sym_start] = ACTIONS(1440),
    [anon_sym_stop] = ACTIONS(1440),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token2] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [aux_sym_preproc_else_token1] = ACTIONS(1506),
    [aux_sym_preproc_elif_token1] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1506),
    [anon_sym_acquire] = ACTIONS(1506),
    [anon_sym_catch] = ACTIONS(1506),
    [anon_sym_monitor] = ACTIONS(1506),
    [anon_sym_start] = ACTIONS(1506),
    [anon_sym_stop] = ACTIONS(1506),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1517),
    [aux_sym_preproc_def_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token2] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1517),
    [aux_sym_preproc_else_token1] = ACTIONS(1517),
    [aux_sym_preproc_elif_token1] = ACTIONS(1517),
    [sym_preproc_directive] = ACTIONS(1517),
    [anon_sym_LPAREN2] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1517),
    [anon_sym_typedef] = ACTIONS(1517),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym___attribute__] = ACTIONS(1517),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1519),
    [anon_sym___declspec] = ACTIONS(1517),
    [anon_sym___cdecl] = ACTIONS(1517),
    [anon_sym___clrcall] = ACTIONS(1517),
    [anon_sym___stdcall] = ACTIONS(1517),
    [anon_sym___fastcall] = ACTIONS(1517),
    [anon_sym___thiscall] = ACTIONS(1517),
    [anon_sym___vectorcall] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_signed] = ACTIONS(1517),
    [anon_sym_unsigned] = ACTIONS(1517),
    [anon_sym_long] = ACTIONS(1517),
    [anon_sym_short] = ACTIONS(1517),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_auto] = ACTIONS(1517),
    [anon_sym_register] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1517),
    [anon_sym___inline] = ACTIONS(1517),
    [anon_sym___inline__] = ACTIONS(1517),
    [anon_sym___forceinline] = ACTIONS(1517),
    [anon_sym_thread_local] = ACTIONS(1517),
    [anon_sym___thread] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_constexpr] = ACTIONS(1517),
    [anon_sym_volatile] = ACTIONS(1517),
    [anon_sym_restrict] = ACTIONS(1517),
    [anon_sym___restrict__] = ACTIONS(1517),
    [anon_sym__Atomic] = ACTIONS(1517),
    [anon_sym__Noreturn] = ACTIONS(1517),
    [anon_sym_noreturn] = ACTIONS(1517),
    [sym_primitive_type] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [anon_sym_struct] = ACTIONS(1517),
    [anon_sym_union] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_goto] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1519),
    [anon_sym_sizeof] = ACTIONS(1517),
    [anon_sym___alignof__] = ACTIONS(1517),
    [anon_sym___alignof] = ACTIONS(1517),
    [anon_sym__alignof] = ACTIONS(1517),
    [anon_sym_alignof] = ACTIONS(1517),
    [anon_sym__Alignof] = ACTIONS(1517),
    [anon_sym_offsetof] = ACTIONS(1517),
    [anon_sym__Generic] = ACTIONS(1517),
    [anon_sym_asm] = ACTIONS(1517),
    [anon_sym___asm__] = ACTIONS(1517),
    [sym_number_literal] = ACTIONS(1519),
    [anon_sym_L_SQUOTE] = ACTIONS(1519),
    [anon_sym_u_SQUOTE] = ACTIONS(1519),
    [anon_sym_U_SQUOTE] = ACTIONS(1519),
    [anon_sym_u8_SQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_L_DQUOTE] = ACTIONS(1519),
    [anon_sym_u_DQUOTE] = ACTIONS(1519),
    [anon_sym_U_DQUOTE] = ACTIONS(1519),
    [anon_sym_u8_DQUOTE] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [anon_sym_NULL] = ACTIONS(1517),
    [anon_sym_nullptr] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1517),
    [anon_sym_acquire] = ACTIONS(1517),
    [anon_sym_catch] = ACTIONS(1517),
    [anon_sym_monitor] = ACTIONS(1517),
    [anon_sym_start] = ACTIONS(1517),
    [anon_sym_stop] = ACTIONS(1517),
  },
  [189] = {
    [sym_identifier] = ACTIONS(1633),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token2] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [aux_sym_preproc_else_token1] = ACTIONS(1633),
    [aux_sym_preproc_elif_token1] = ACTIONS(1633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1633),
    [anon_sym_typedef] = ACTIONS(1633),
    [anon_sym_extern] = ACTIONS(1633),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1635),
    [anon_sym___declspec] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_signed] = ACTIONS(1633),
    [anon_sym_unsigned] = ACTIONS(1633),
    [anon_sym_long] = ACTIONS(1633),
    [anon_sym_short] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_auto] = ACTIONS(1633),
    [anon_sym_register] = ACTIONS(1633),
    [anon_sym_inline] = ACTIONS(1633),
    [anon_sym___inline] = ACTIONS(1633),
    [anon_sym___inline__] = ACTIONS(1633),
    [anon_sym___forceinline] = ACTIONS(1633),
    [anon_sym_thread_local] = ACTIONS(1633),
    [anon_sym___thread] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1633),
    [anon_sym_constexpr] = ACTIONS(1633),
    [anon_sym_volatile] = ACTIONS(1633),
    [anon_sym_restrict] = ACTIONS(1633),
    [anon_sym___restrict__] = ACTIONS(1633),
    [anon_sym__Atomic] = ACTIONS(1633),
    [anon_sym__Noreturn] = ACTIONS(1633),
    [anon_sym_noreturn] = ACTIONS(1633),
    [sym_primitive_type] = ACTIONS(1633),
    [anon_sym_enum] = ACTIONS(1633),
    [anon_sym_struct] = ACTIONS(1633),
    [anon_sym_union] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1633),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_for] = ACTIONS(1633),
    [anon_sym_return] = ACTIONS(1633),
    [anon_sym_break] = ACTIONS(1633),
    [anon_sym_continue] = ACTIONS(1633),
    [anon_sym_goto] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_sizeof] = ACTIONS(1633),
    [anon_sym___alignof__] = ACTIONS(1633),
    [anon_sym___alignof] = ACTIONS(1633),
    [anon_sym__alignof] = ACTIONS(1633),
    [anon_sym_alignof] = ACTIONS(1633),
    [anon_sym__Alignof] = ACTIONS(1633),
    [anon_sym_offsetof] = ACTIONS(1633),
    [anon_sym__Generic] = ACTIONS(1633),
    [anon_sym_asm] = ACTIONS(1633),
    [anon_sym___asm__] = ACTIONS(1633),
    [sym_number_literal] = ACTIONS(1635),
    [anon_sym_L_SQUOTE] = ACTIONS(1635),
    [anon_sym_u_SQUOTE] = ACTIONS(1635),
    [anon_sym_U_SQUOTE] = ACTIONS(1635),
    [anon_sym_u8_SQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_L_DQUOTE] = ACTIONS(1635),
    [anon_sym_u_DQUOTE] = ACTIONS(1635),
    [anon_sym_U_DQUOTE] = ACTIONS(1635),
    [anon_sym_u8_DQUOTE] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [anon_sym_NULL] = ACTIONS(1633),
    [anon_sym_nullptr] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1633),
    [anon_sym_acquire] = ACTIONS(1633),
    [anon_sym_monitor] = ACTIONS(1633),
    [anon_sym_start] = ACTIONS(1633),
    [anon_sym_stop] = ACTIONS(1633),
  },
  [190] = {
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1637),
    [aux_sym_preproc_def_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token2] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1637),
    [aux_sym_preproc_else_token1] = ACTIONS(1637),
    [aux_sym_preproc_elif_token1] = ACTIONS(1637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1637),
    [sym_preproc_directive] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1639),
    [anon_sym_BANG] = ACTIONS(1639),
    [anon_sym_TILDE] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1637),
    [anon_sym_extern] = ACTIONS(1637),
    [anon_sym___attribute__] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1639),
    [anon_sym___declspec] = ACTIONS(1637),
    [anon_sym___cdecl] = ACTIONS(1637),
    [anon_sym___clrcall] = ACTIONS(1637),
    [anon_sym___stdcall] = ACTIONS(1637),
    [anon_sym___fastcall] = ACTIONS(1637),
    [anon_sym___thiscall] = ACTIONS(1637),
    [anon_sym___vectorcall] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1637),
    [anon_sym_unsigned] = ACTIONS(1637),
    [anon_sym_long] = ACTIONS(1637),
    [anon_sym_short] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1637),
    [anon_sym_auto] = ACTIONS(1637),
    [anon_sym_register] = ACTIONS(1637),
    [anon_sym_inline] = ACTIONS(1637),
    [anon_sym___inline] = ACTIONS(1637),
    [anon_sym___inline__] = ACTIONS(1637),
    [anon_sym___forceinline] = ACTIONS(1637),
    [anon_sym_thread_local] = ACTIONS(1637),
    [anon_sym___thread] = ACTIONS(1637),
    [anon_sym_const] = ACTIONS(1637),
    [anon_sym_constexpr] = ACTIONS(1637),
    [anon_sym_volatile] = ACTIONS(1637),
    [anon_sym_restrict] = ACTIONS(1637),
    [anon_sym___restrict__] = ACTIONS(1637),
    [anon_sym__Atomic] = ACTIONS(1637),
    [anon_sym__Noreturn] = ACTIONS(1637),
    [anon_sym_noreturn] = ACTIONS(1637),
    [sym_primitive_type] = ACTIONS(1637),
    [anon_sym_enum] = ACTIONS(1637),
    [anon_sym_struct] = ACTIONS(1637),
    [anon_sym_union] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1637),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1637),
    [anon_sym_default] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1637),
    [anon_sym_do] = ACTIONS(1637),
    [anon_sym_for] = ACTIONS(1637),
    [anon_sym_return] = ACTIONS(1637),
    [anon_sym_break] = ACTIONS(1637),
    [anon_sym_continue] = ACTIONS(1637),
    [anon_sym_goto] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1637),
    [anon_sym___alignof__] = ACTIONS(1637),
    [anon_sym___alignof] = ACTIONS(1637),
    [anon_sym__alignof] = ACTIONS(1637),
    [anon_sym_alignof] = ACTIONS(1637),
    [anon_sym__Alignof] = ACTIONS(1637),
    [anon_sym_offsetof] = ACTIONS(1637),
    [anon_sym__Generic] = ACTIONS(1637),
    [anon_sym_asm] = ACTIONS(1637),
    [anon_sym___asm__] = ACTIONS(1637),
    [sym_number_literal] = ACTIONS(1639),
    [anon_sym_L_SQUOTE] = ACTIONS(1639),
    [anon_sym_u_SQUOTE] = ACTIONS(1639),
    [anon_sym_U_SQUOTE] = ACTIONS(1639),
    [anon_sym_u8_SQUOTE] = ACTIONS(1639),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [anon_sym_L_DQUOTE] = ACTIONS(1639),
    [anon_sym_u_DQUOTE] = ACTIONS(1639),
    [anon_sym_U_DQUOTE] = ACTIONS(1639),
    [anon_sym_u8_DQUOTE] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [anon_sym_NULL] = ACTIONS(1637),
    [anon_sym_nullptr] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1637),
    [anon_sym_acquire] = ACTIONS(1637),
    [anon_sym_monitor] = ACTIONS(1637),
    [anon_sym_start] = ACTIONS(1637),
    [anon_sym_stop] = ACTIONS(1637),
  },
  [191] = {
    [sym_catch_clause] = STATE(186),
    [aux_sym_monitor_statement_repeat1] = STATE(186),
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token2] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1446),
    [anon_sym_acquire] = ACTIONS(1446),
    [anon_sym_catch] = ACTIONS(1631),
    [anon_sym_monitor] = ACTIONS(1446),
    [anon_sym_start] = ACTIONS(1446),
    [anon_sym_stop] = ACTIONS(1446),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1500),
    [aux_sym_preproc_include_token1] = ACTIONS(1500),
    [aux_sym_preproc_def_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token2] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1500),
    [aux_sym_preproc_else_token1] = ACTIONS(1500),
    [aux_sym_preproc_elif_token1] = ACTIONS(1500),
    [sym_preproc_directive] = ACTIONS(1500),
    [anon_sym_LPAREN2] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym___extension__] = ACTIONS(1500),
    [anon_sym_typedef] = ACTIONS(1500),
    [anon_sym_extern] = ACTIONS(1500),
    [anon_sym___attribute__] = ACTIONS(1500),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1502),
    [anon_sym___declspec] = ACTIONS(1500),
    [anon_sym___cdecl] = ACTIONS(1500),
    [anon_sym___clrcall] = ACTIONS(1500),
    [anon_sym___stdcall] = ACTIONS(1500),
    [anon_sym___fastcall] = ACTIONS(1500),
    [anon_sym___thiscall] = ACTIONS(1500),
    [anon_sym___vectorcall] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_signed] = ACTIONS(1500),
    [anon_sym_unsigned] = ACTIONS(1500),
    [anon_sym_long] = ACTIONS(1500),
    [anon_sym_short] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1500),
    [anon_sym_auto] = ACTIONS(1500),
    [anon_sym_register] = ACTIONS(1500),
    [anon_sym_inline] = ACTIONS(1500),
    [anon_sym___inline] = ACTIONS(1500),
    [anon_sym___inline__] = ACTIONS(1500),
    [anon_sym___forceinline] = ACTIONS(1500),
    [anon_sym_thread_local] = ACTIONS(1500),
    [anon_sym___thread] = ACTIONS(1500),
    [anon_sym_const] = ACTIONS(1500),
    [anon_sym_constexpr] = ACTIONS(1500),
    [anon_sym_volatile] = ACTIONS(1500),
    [anon_sym_restrict] = ACTIONS(1500),
    [anon_sym___restrict__] = ACTIONS(1500),
    [anon_sym__Atomic] = ACTIONS(1500),
    [anon_sym__Noreturn] = ACTIONS(1500),
    [anon_sym_noreturn] = ACTIONS(1500),
    [sym_primitive_type] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1500),
    [anon_sym_struct] = ACTIONS(1500),
    [anon_sym_union] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1500),
    [anon_sym_switch] = ACTIONS(1500),
    [anon_sym_case] = ACTIONS(1500),
    [anon_sym_default] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_do] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_break] = ACTIONS(1500),
    [anon_sym_continue] = ACTIONS(1500),
    [anon_sym_goto] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_sizeof] = ACTIONS(1500),
    [anon_sym___alignof__] = ACTIONS(1500),
    [anon_sym___alignof] = ACTIONS(1500),
    [anon_sym__alignof] = ACTIONS(1500),
    [anon_sym_alignof] = ACTIONS(1500),
    [anon_sym__Alignof] = ACTIONS(1500),
    [anon_sym_offsetof] = ACTIONS(1500),
    [anon_sym__Generic] = ACTIONS(1500),
    [anon_sym_asm] = ACTIONS(1500),
    [anon_sym___asm__] = ACTIONS(1500),
    [sym_number_literal] = ACTIONS(1502),
    [anon_sym_L_SQUOTE] = ACTIONS(1502),
    [anon_sym_u_SQUOTE] = ACTIONS(1502),
    [anon_sym_U_SQUOTE] = ACTIONS(1502),
    [anon_sym_u8_SQUOTE] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_L_DQUOTE] = ACTIONS(1502),
    [anon_sym_u_DQUOTE] = ACTIONS(1502),
    [anon_sym_U_DQUOTE] = ACTIONS(1502),
    [anon_sym_u8_DQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [anon_sym_NULL] = ACTIONS(1500),
    [anon_sym_nullptr] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1500),
    [anon_sym_acquire] = ACTIONS(1500),
    [anon_sym_catch] = ACTIONS(1500),
    [anon_sym_monitor] = ACTIONS(1500),
    [anon_sym_start] = ACTIONS(1500),
    [anon_sym_stop] = ACTIONS(1500),
  },
  [193] = {
    [sym_identifier] = ACTIONS(1521),
    [aux_sym_preproc_include_token1] = ACTIONS(1521),
    [aux_sym_preproc_def_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token2] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1521),
    [aux_sym_preproc_else_token1] = ACTIONS(1521),
    [aux_sym_preproc_elif_token1] = ACTIONS(1521),
    [sym_preproc_directive] = ACTIONS(1521),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1521),
    [anon_sym_typedef] = ACTIONS(1521),
    [anon_sym_extern] = ACTIONS(1521),
    [anon_sym___attribute__] = ACTIONS(1521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1523),
    [anon_sym___declspec] = ACTIONS(1521),
    [anon_sym___cdecl] = ACTIONS(1521),
    [anon_sym___clrcall] = ACTIONS(1521),
    [anon_sym___stdcall] = ACTIONS(1521),
    [anon_sym___fastcall] = ACTIONS(1521),
    [anon_sym___thiscall] = ACTIONS(1521),
    [anon_sym___vectorcall] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_signed] = ACTIONS(1521),
    [anon_sym_unsigned] = ACTIONS(1521),
    [anon_sym_long] = ACTIONS(1521),
    [anon_sym_short] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1521),
    [anon_sym_auto] = ACTIONS(1521),
    [anon_sym_register] = ACTIONS(1521),
    [anon_sym_inline] = ACTIONS(1521),
    [anon_sym___inline] = ACTIONS(1521),
    [anon_sym___inline__] = ACTIONS(1521),
    [anon_sym___forceinline] = ACTIONS(1521),
    [anon_sym_thread_local] = ACTIONS(1521),
    [anon_sym___thread] = ACTIONS(1521),
    [anon_sym_const] = ACTIONS(1521),
    [anon_sym_constexpr] = ACTIONS(1521),
    [anon_sym_volatile] = ACTIONS(1521),
    [anon_sym_restrict] = ACTIONS(1521),
    [anon_sym___restrict__] = ACTIONS(1521),
    [anon_sym__Atomic] = ACTIONS(1521),
    [anon_sym__Noreturn] = ACTIONS(1521),
    [anon_sym_noreturn] = ACTIONS(1521),
    [sym_primitive_type] = ACTIONS(1521),
    [anon_sym_enum] = ACTIONS(1521),
    [anon_sym_struct] = ACTIONS(1521),
    [anon_sym_union] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_do] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_return] = ACTIONS(1521),
    [anon_sym_break] = ACTIONS(1521),
    [anon_sym_continue] = ACTIONS(1521),
    [anon_sym_goto] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_sizeof] = ACTIONS(1521),
    [anon_sym___alignof__] = ACTIONS(1521),
    [anon_sym___alignof] = ACTIONS(1521),
    [anon_sym__alignof] = ACTIONS(1521),
    [anon_sym_alignof] = ACTIONS(1521),
    [anon_sym__Alignof] = ACTIONS(1521),
    [anon_sym_offsetof] = ACTIONS(1521),
    [anon_sym__Generic] = ACTIONS(1521),
    [anon_sym_asm] = ACTIONS(1521),
    [anon_sym___asm__] = ACTIONS(1521),
    [sym_number_literal] = ACTIONS(1523),
    [anon_sym_L_SQUOTE] = ACTIONS(1523),
    [anon_sym_u_SQUOTE] = ACTIONS(1523),
    [anon_sym_U_SQUOTE] = ACTIONS(1523),
    [anon_sym_u8_SQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_L_DQUOTE] = ACTIONS(1523),
    [anon_sym_u_DQUOTE] = ACTIONS(1523),
    [anon_sym_U_DQUOTE] = ACTIONS(1523),
    [anon_sym_u8_DQUOTE] = ACTIONS(1523),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [anon_sym_NULL] = ACTIONS(1521),
    [anon_sym_nullptr] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1521),
    [anon_sym_acquire] = ACTIONS(1521),
    [anon_sym_catch] = ACTIONS(1521),
    [anon_sym_monitor] = ACTIONS(1521),
    [anon_sym_start] = ACTIONS(1521),
    [anon_sym_stop] = ACTIONS(1521),
  },
  [194] = {
    [sym_catch_clause] = STATE(194),
    [aux_sym_monitor_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_RBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_acquire] = ACTIONS(1433),
    [anon_sym_catch] = ACTIONS(1641),
    [anon_sym_monitor] = ACTIONS(1433),
    [anon_sym_start] = ACTIONS(1433),
    [anon_sym_stop] = ACTIONS(1433),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [196] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [197] = {
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1569),
    [aux_sym_preproc_def_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token2] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1569),
    [aux_sym_preproc_else_token1] = ACTIONS(1569),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [sym_preproc_directive] = ACTIONS(1569),
    [anon_sym_LPAREN2] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(1569),
    [anon_sym_typedef] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym___attribute__] = ACTIONS(1569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1571),
    [anon_sym___declspec] = ACTIONS(1569),
    [anon_sym___cdecl] = ACTIONS(1569),
    [anon_sym___clrcall] = ACTIONS(1569),
    [anon_sym___stdcall] = ACTIONS(1569),
    [anon_sym___fastcall] = ACTIONS(1569),
    [anon_sym___thiscall] = ACTIONS(1569),
    [anon_sym___vectorcall] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_signed] = ACTIONS(1569),
    [anon_sym_unsigned] = ACTIONS(1569),
    [anon_sym_long] = ACTIONS(1569),
    [anon_sym_short] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_auto] = ACTIONS(1569),
    [anon_sym_register] = ACTIONS(1569),
    [anon_sym_inline] = ACTIONS(1569),
    [anon_sym___inline] = ACTIONS(1569),
    [anon_sym___inline__] = ACTIONS(1569),
    [anon_sym___forceinline] = ACTIONS(1569),
    [anon_sym_thread_local] = ACTIONS(1569),
    [anon_sym___thread] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_constexpr] = ACTIONS(1569),
    [anon_sym_volatile] = ACTIONS(1569),
    [anon_sym_restrict] = ACTIONS(1569),
    [anon_sym___restrict__] = ACTIONS(1569),
    [anon_sym__Atomic] = ACTIONS(1569),
    [anon_sym__Noreturn] = ACTIONS(1569),
    [anon_sym_noreturn] = ACTIONS(1569),
    [sym_primitive_type] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_goto] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_sizeof] = ACTIONS(1569),
    [anon_sym___alignof__] = ACTIONS(1569),
    [anon_sym___alignof] = ACTIONS(1569),
    [anon_sym__alignof] = ACTIONS(1569),
    [anon_sym_alignof] = ACTIONS(1569),
    [anon_sym__Alignof] = ACTIONS(1569),
    [anon_sym_offsetof] = ACTIONS(1569),
    [anon_sym__Generic] = ACTIONS(1569),
    [anon_sym_asm] = ACTIONS(1569),
    [anon_sym___asm__] = ACTIONS(1569),
    [sym_number_literal] = ACTIONS(1571),
    [anon_sym_L_SQUOTE] = ACTIONS(1571),
    [anon_sym_u_SQUOTE] = ACTIONS(1571),
    [anon_sym_U_SQUOTE] = ACTIONS(1571),
    [anon_sym_u8_SQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [anon_sym_L_DQUOTE] = ACTIONS(1571),
    [anon_sym_u_DQUOTE] = ACTIONS(1571),
    [anon_sym_U_DQUOTE] = ACTIONS(1571),
    [anon_sym_u8_DQUOTE] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [anon_sym_NULL] = ACTIONS(1569),
    [anon_sym_nullptr] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1569),
    [anon_sym_acquire] = ACTIONS(1569),
    [anon_sym_catch] = ACTIONS(1569),
    [anon_sym_monitor] = ACTIONS(1569),
    [anon_sym_start] = ACTIONS(1569),
    [anon_sym_stop] = ACTIONS(1569),
  },
  [198] = {
    [sym_identifier] = ACTIONS(1644),
    [aux_sym_preproc_include_token1] = ACTIONS(1644),
    [aux_sym_preproc_def_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token2] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1644),
    [aux_sym_preproc_else_token1] = ACTIONS(1644),
    [aux_sym_preproc_elif_token1] = ACTIONS(1644),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1644),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_LPAREN2] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym___extension__] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym___attribute__] = ACTIONS(1644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1646),
    [anon_sym___declspec] = ACTIONS(1644),
    [anon_sym___cdecl] = ACTIONS(1644),
    [anon_sym___clrcall] = ACTIONS(1644),
    [anon_sym___stdcall] = ACTIONS(1644),
    [anon_sym___fastcall] = ACTIONS(1644),
    [anon_sym___thiscall] = ACTIONS(1644),
    [anon_sym___vectorcall] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_signed] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym___inline] = ACTIONS(1644),
    [anon_sym___inline__] = ACTIONS(1644),
    [anon_sym___forceinline] = ACTIONS(1644),
    [anon_sym_thread_local] = ACTIONS(1644),
    [anon_sym___thread] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_constexpr] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym___restrict__] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym__Noreturn] = ACTIONS(1644),
    [anon_sym_noreturn] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1646),
    [anon_sym_sizeof] = ACTIONS(1644),
    [anon_sym___alignof__] = ACTIONS(1644),
    [anon_sym___alignof] = ACTIONS(1644),
    [anon_sym__alignof] = ACTIONS(1644),
    [anon_sym_alignof] = ACTIONS(1644),
    [anon_sym__Alignof] = ACTIONS(1644),
    [anon_sym_offsetof] = ACTIONS(1644),
    [anon_sym__Generic] = ACTIONS(1644),
    [anon_sym_asm] = ACTIONS(1644),
    [anon_sym___asm__] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1646),
    [anon_sym_L_SQUOTE] = ACTIONS(1646),
    [anon_sym_u_SQUOTE] = ACTIONS(1646),
    [anon_sym_U_SQUOTE] = ACTIONS(1646),
    [anon_sym_u8_SQUOTE] = ACTIONS(1646),
    [anon_sym_SQUOTE] = ACTIONS(1646),
    [anon_sym_L_DQUOTE] = ACTIONS(1646),
    [anon_sym_u_DQUOTE] = ACTIONS(1646),
    [anon_sym_U_DQUOTE] = ACTIONS(1646),
    [anon_sym_u8_DQUOTE] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1646),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [anon_sym_NULL] = ACTIONS(1644),
    [anon_sym_nullptr] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1644),
    [anon_sym_acquire] = ACTIONS(1644),
    [anon_sym_monitor] = ACTIONS(1644),
    [anon_sym_start] = ACTIONS(1644),
    [anon_sym_stop] = ACTIONS(1644),
  },
  [199] = {
    [sym_identifier] = ACTIONS(1492),
    [aux_sym_preproc_include_token1] = ACTIONS(1492),
    [aux_sym_preproc_def_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token2] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1492),
    [aux_sym_preproc_else_token1] = ACTIONS(1492),
    [aux_sym_preproc_elif_token1] = ACTIONS(1492),
    [sym_preproc_directive] = ACTIONS(1492),
    [anon_sym_LPAREN2] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym___extension__] = ACTIONS(1492),
    [anon_sym_typedef] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym___attribute__] = ACTIONS(1492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1494),
    [anon_sym___declspec] = ACTIONS(1492),
    [anon_sym___cdecl] = ACTIONS(1492),
    [anon_sym___clrcall] = ACTIONS(1492),
    [anon_sym___stdcall] = ACTIONS(1492),
    [anon_sym___fastcall] = ACTIONS(1492),
    [anon_sym___thiscall] = ACTIONS(1492),
    [anon_sym___vectorcall] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_signed] = ACTIONS(1492),
    [anon_sym_unsigned] = ACTIONS(1492),
    [anon_sym_long] = ACTIONS(1492),
    [anon_sym_short] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_auto] = ACTIONS(1492),
    [anon_sym_register] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym___inline] = ACTIONS(1492),
    [anon_sym___inline__] = ACTIONS(1492),
    [anon_sym___forceinline] = ACTIONS(1492),
    [anon_sym_thread_local] = ACTIONS(1492),
    [anon_sym___thread] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_constexpr] = ACTIONS(1492),
    [anon_sym_volatile] = ACTIONS(1492),
    [anon_sym_restrict] = ACTIONS(1492),
    [anon_sym___restrict__] = ACTIONS(1492),
    [anon_sym__Atomic] = ACTIONS(1492),
    [anon_sym__Noreturn] = ACTIONS(1492),
    [anon_sym_noreturn] = ACTIONS(1492),
    [sym_primitive_type] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_struct] = ACTIONS(1492),
    [anon_sym_union] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_goto] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_sizeof] = ACTIONS(1492),
    [anon_sym___alignof__] = ACTIONS(1492),
    [anon_sym___alignof] = ACTIONS(1492),
    [anon_sym__alignof] = ACTIONS(1492),
    [anon_sym_alignof] = ACTIONS(1492),
    [anon_sym__Alignof] = ACTIONS(1492),
    [anon_sym_offsetof] = ACTIONS(1492),
    [anon_sym__Generic] = ACTIONS(1492),
    [anon_sym_asm] = ACTIONS(1492),
    [anon_sym___asm__] = ACTIONS(1492),
    [sym_number_literal] = ACTIONS(1494),
    [anon_sym_L_SQUOTE] = ACTIONS(1494),
    [anon_sym_u_SQUOTE] = ACTIONS(1494),
    [anon_sym_U_SQUOTE] = ACTIONS(1494),
    [anon_sym_u8_SQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_L_DQUOTE] = ACTIONS(1494),
    [anon_sym_u_DQUOTE] = ACTIONS(1494),
    [anon_sym_U_DQUOTE] = ACTIONS(1494),
    [anon_sym_u8_DQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [anon_sym_NULL] = ACTIONS(1492),
    [anon_sym_nullptr] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1492),
    [anon_sym_acquire] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_monitor] = ACTIONS(1492),
    [anon_sym_start] = ACTIONS(1492),
    [anon_sym_stop] = ACTIONS(1492),
  },
  [200] = {
    [sym_identifier] = ACTIONS(1545),
    [aux_sym_preproc_include_token1] = ACTIONS(1545),
    [aux_sym_preproc_def_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token2] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1545),
    [aux_sym_preproc_else_token1] = ACTIONS(1545),
    [aux_sym_preproc_elif_token1] = ACTIONS(1545),
    [sym_preproc_directive] = ACTIONS(1545),
    [anon_sym_LPAREN2] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym___extension__] = ACTIONS(1545),
    [anon_sym_typedef] = ACTIONS(1545),
    [anon_sym_extern] = ACTIONS(1545),
    [anon_sym___attribute__] = ACTIONS(1545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1547),
    [anon_sym___declspec] = ACTIONS(1545),
    [anon_sym___cdecl] = ACTIONS(1545),
    [anon_sym___clrcall] = ACTIONS(1545),
    [anon_sym___stdcall] = ACTIONS(1545),
    [anon_sym___fastcall] = ACTIONS(1545),
    [anon_sym___thiscall] = ACTIONS(1545),
    [anon_sym___vectorcall] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_signed] = ACTIONS(1545),
    [anon_sym_unsigned] = ACTIONS(1545),
    [anon_sym_long] = ACTIONS(1545),
    [anon_sym_short] = ACTIONS(1545),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_auto] = ACTIONS(1545),
    [anon_sym_register] = ACTIONS(1545),
    [anon_sym_inline] = ACTIONS(1545),
    [anon_sym___inline] = ACTIONS(1545),
    [anon_sym___inline__] = ACTIONS(1545),
    [anon_sym___forceinline] = ACTIONS(1545),
    [anon_sym_thread_local] = ACTIONS(1545),
    [anon_sym___thread] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_constexpr] = ACTIONS(1545),
    [anon_sym_volatile] = ACTIONS(1545),
    [anon_sym_restrict] = ACTIONS(1545),
    [anon_sym___restrict__] = ACTIONS(1545),
    [anon_sym__Atomic] = ACTIONS(1545),
    [anon_sym__Noreturn] = ACTIONS(1545),
    [anon_sym_noreturn] = ACTIONS(1545),
    [sym_primitive_type] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [anon_sym_struct] = ACTIONS(1545),
    [anon_sym_union] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_sizeof] = ACTIONS(1545),
    [anon_sym___alignof__] = ACTIONS(1545),
    [anon_sym___alignof] = ACTIONS(1545),
    [anon_sym__alignof] = ACTIONS(1545),
    [anon_sym_alignof] = ACTIONS(1545),
    [anon_sym__Alignof] = ACTIONS(1545),
    [anon_sym_offsetof] = ACTIONS(1545),
    [anon_sym__Generic] = ACTIONS(1545),
    [anon_sym_asm] = ACTIONS(1545),
    [anon_sym___asm__] = ACTIONS(1545),
    [sym_number_literal] = ACTIONS(1547),
    [anon_sym_L_SQUOTE] = ACTIONS(1547),
    [anon_sym_u_SQUOTE] = ACTIONS(1547),
    [anon_sym_U_SQUOTE] = ACTIONS(1547),
    [anon_sym_u8_SQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [anon_sym_L_DQUOTE] = ACTIONS(1547),
    [anon_sym_u_DQUOTE] = ACTIONS(1547),
    [anon_sym_U_DQUOTE] = ACTIONS(1547),
    [anon_sym_u8_DQUOTE] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [anon_sym_NULL] = ACTIONS(1545),
    [anon_sym_nullptr] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1545),
    [anon_sym_acquire] = ACTIONS(1545),
    [anon_sym_catch] = ACTIONS(1545),
    [anon_sym_monitor] = ACTIONS(1545),
    [anon_sym_start] = ACTIONS(1545),
    [anon_sym_stop] = ACTIONS(1545),
  },
  [201] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [202] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [203] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [204] = {
    [sym_catch_clause] = STATE(234),
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_else] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1450),
    [anon_sym_until] = ACTIONS(1450),
    [anon_sym_acquire] = ACTIONS(1450),
    [anon_sym_catch] = ACTIONS(1577),
    [anon_sym_monitor] = ACTIONS(1450),
    [anon_sym_start] = ACTIONS(1450),
    [anon_sym_stop] = ACTIONS(1450),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1648),
    [aux_sym_preproc_include_token1] = ACTIONS(1648),
    [aux_sym_preproc_def_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token2] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1648),
    [aux_sym_preproc_else_token1] = ACTIONS(1648),
    [aux_sym_preproc_elif_token1] = ACTIONS(1648),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1648),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1648),
    [sym_preproc_directive] = ACTIONS(1648),
    [anon_sym_LPAREN2] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym___extension__] = ACTIONS(1648),
    [anon_sym_typedef] = ACTIONS(1648),
    [anon_sym_extern] = ACTIONS(1648),
    [anon_sym___attribute__] = ACTIONS(1648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1650),
    [anon_sym___declspec] = ACTIONS(1648),
    [anon_sym___cdecl] = ACTIONS(1648),
    [anon_sym___clrcall] = ACTIONS(1648),
    [anon_sym___stdcall] = ACTIONS(1648),
    [anon_sym___fastcall] = ACTIONS(1648),
    [anon_sym___thiscall] = ACTIONS(1648),
    [anon_sym___vectorcall] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_signed] = ACTIONS(1648),
    [anon_sym_unsigned] = ACTIONS(1648),
    [anon_sym_long] = ACTIONS(1648),
    [anon_sym_short] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1648),
    [anon_sym_auto] = ACTIONS(1648),
    [anon_sym_register] = ACTIONS(1648),
    [anon_sym_inline] = ACTIONS(1648),
    [anon_sym___inline] = ACTIONS(1648),
    [anon_sym___inline__] = ACTIONS(1648),
    [anon_sym___forceinline] = ACTIONS(1648),
    [anon_sym_thread_local] = ACTIONS(1648),
    [anon_sym___thread] = ACTIONS(1648),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_constexpr] = ACTIONS(1648),
    [anon_sym_volatile] = ACTIONS(1648),
    [anon_sym_restrict] = ACTIONS(1648),
    [anon_sym___restrict__] = ACTIONS(1648),
    [anon_sym__Atomic] = ACTIONS(1648),
    [anon_sym__Noreturn] = ACTIONS(1648),
    [anon_sym_noreturn] = ACTIONS(1648),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1648),
    [anon_sym_struct] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_if] = ACTIONS(1648),
    [anon_sym_switch] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_while] = ACTIONS(1648),
    [anon_sym_do] = ACTIONS(1648),
    [anon_sym_for] = ACTIONS(1648),
    [anon_sym_return] = ACTIONS(1648),
    [anon_sym_break] = ACTIONS(1648),
    [anon_sym_continue] = ACTIONS(1648),
    [anon_sym_goto] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1650),
    [anon_sym_sizeof] = ACTIONS(1648),
    [anon_sym___alignof__] = ACTIONS(1648),
    [anon_sym___alignof] = ACTIONS(1648),
    [anon_sym__alignof] = ACTIONS(1648),
    [anon_sym_alignof] = ACTIONS(1648),
    [anon_sym__Alignof] = ACTIONS(1648),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1648),
    [anon_sym_asm] = ACTIONS(1648),
    [anon_sym___asm__] = ACTIONS(1648),
    [sym_number_literal] = ACTIONS(1650),
    [anon_sym_L_SQUOTE] = ACTIONS(1650),
    [anon_sym_u_SQUOTE] = ACTIONS(1650),
    [anon_sym_U_SQUOTE] = ACTIONS(1650),
    [anon_sym_u8_SQUOTE] = ACTIONS(1650),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [anon_sym_L_DQUOTE] = ACTIONS(1650),
    [anon_sym_u_DQUOTE] = ACTIONS(1650),
    [anon_sym_U_DQUOTE] = ACTIONS(1650),
    [anon_sym_u8_DQUOTE] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_true] = ACTIONS(1648),
    [sym_false] = ACTIONS(1648),
    [anon_sym_NULL] = ACTIONS(1648),
    [anon_sym_nullptr] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1648),
    [anon_sym_acquire] = ACTIONS(1648),
    [anon_sym_monitor] = ACTIONS(1648),
    [anon_sym_start] = ACTIONS(1648),
    [anon_sym_stop] = ACTIONS(1648),
  },
  [206] = {
    [sym_identifier] = ACTIONS(1652),
    [aux_sym_preproc_include_token1] = ACTIONS(1652),
    [aux_sym_preproc_def_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token2] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1652),
    [aux_sym_preproc_else_token1] = ACTIONS(1652),
    [aux_sym_preproc_elif_token1] = ACTIONS(1652),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1652),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1652),
    [sym_preproc_directive] = ACTIONS(1652),
    [anon_sym_LPAREN2] = ACTIONS(1654),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym___extension__] = ACTIONS(1652),
    [anon_sym_typedef] = ACTIONS(1652),
    [anon_sym_extern] = ACTIONS(1652),
    [anon_sym___attribute__] = ACTIONS(1652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1654),
    [anon_sym___declspec] = ACTIONS(1652),
    [anon_sym___cdecl] = ACTIONS(1652),
    [anon_sym___clrcall] = ACTIONS(1652),
    [anon_sym___stdcall] = ACTIONS(1652),
    [anon_sym___fastcall] = ACTIONS(1652),
    [anon_sym___thiscall] = ACTIONS(1652),
    [anon_sym___vectorcall] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_signed] = ACTIONS(1652),
    [anon_sym_unsigned] = ACTIONS(1652),
    [anon_sym_long] = ACTIONS(1652),
    [anon_sym_short] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_auto] = ACTIONS(1652),
    [anon_sym_register] = ACTIONS(1652),
    [anon_sym_inline] = ACTIONS(1652),
    [anon_sym___inline] = ACTIONS(1652),
    [anon_sym___inline__] = ACTIONS(1652),
    [anon_sym___forceinline] = ACTIONS(1652),
    [anon_sym_thread_local] = ACTIONS(1652),
    [anon_sym___thread] = ACTIONS(1652),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_constexpr] = ACTIONS(1652),
    [anon_sym_volatile] = ACTIONS(1652),
    [anon_sym_restrict] = ACTIONS(1652),
    [anon_sym___restrict__] = ACTIONS(1652),
    [anon_sym__Atomic] = ACTIONS(1652),
    [anon_sym__Noreturn] = ACTIONS(1652),
    [anon_sym_noreturn] = ACTIONS(1652),
    [sym_primitive_type] = ACTIONS(1652),
    [anon_sym_enum] = ACTIONS(1652),
    [anon_sym_struct] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_if] = ACTIONS(1652),
    [anon_sym_switch] = ACTIONS(1652),
    [anon_sym_case] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_while] = ACTIONS(1652),
    [anon_sym_do] = ACTIONS(1652),
    [anon_sym_for] = ACTIONS(1652),
    [anon_sym_return] = ACTIONS(1652),
    [anon_sym_break] = ACTIONS(1652),
    [anon_sym_continue] = ACTIONS(1652),
    [anon_sym_goto] = ACTIONS(1652),
    [anon_sym_DASH_DASH] = ACTIONS(1654),
    [anon_sym_PLUS_PLUS] = ACTIONS(1654),
    [anon_sym_sizeof] = ACTIONS(1652),
    [anon_sym___alignof__] = ACTIONS(1652),
    [anon_sym___alignof] = ACTIONS(1652),
    [anon_sym__alignof] = ACTIONS(1652),
    [anon_sym_alignof] = ACTIONS(1652),
    [anon_sym__Alignof] = ACTIONS(1652),
    [anon_sym_offsetof] = ACTIONS(1652),
    [anon_sym__Generic] = ACTIONS(1652),
    [anon_sym_asm] = ACTIONS(1652),
    [anon_sym___asm__] = ACTIONS(1652),
    [sym_number_literal] = ACTIONS(1654),
    [anon_sym_L_SQUOTE] = ACTIONS(1654),
    [anon_sym_u_SQUOTE] = ACTIONS(1654),
    [anon_sym_U_SQUOTE] = ACTIONS(1654),
    [anon_sym_u8_SQUOTE] = ACTIONS(1654),
    [anon_sym_SQUOTE] = ACTIONS(1654),
    [anon_sym_L_DQUOTE] = ACTIONS(1654),
    [anon_sym_u_DQUOTE] = ACTIONS(1654),
    [anon_sym_U_DQUOTE] = ACTIONS(1654),
    [anon_sym_u8_DQUOTE] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [sym_true] = ACTIONS(1652),
    [sym_false] = ACTIONS(1652),
    [anon_sym_NULL] = ACTIONS(1652),
    [anon_sym_nullptr] = ACTIONS(1652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1652),
    [anon_sym_acquire] = ACTIONS(1652),
    [anon_sym_monitor] = ACTIONS(1652),
    [anon_sym_start] = ACTIONS(1652),
    [anon_sym_stop] = ACTIONS(1652),
  },
  [207] = {
    [sym_identifier] = ACTIONS(1656),
    [aux_sym_preproc_include_token1] = ACTIONS(1656),
    [aux_sym_preproc_def_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token2] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1656),
    [aux_sym_preproc_else_token1] = ACTIONS(1656),
    [aux_sym_preproc_elif_token1] = ACTIONS(1656),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1656),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1656),
    [sym_preproc_directive] = ACTIONS(1656),
    [anon_sym_LPAREN2] = ACTIONS(1658),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_TILDE] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_SEMI] = ACTIONS(1658),
    [anon_sym___extension__] = ACTIONS(1656),
    [anon_sym_typedef] = ACTIONS(1656),
    [anon_sym_extern] = ACTIONS(1656),
    [anon_sym___attribute__] = ACTIONS(1656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1658),
    [anon_sym___declspec] = ACTIONS(1656),
    [anon_sym___cdecl] = ACTIONS(1656),
    [anon_sym___clrcall] = ACTIONS(1656),
    [anon_sym___stdcall] = ACTIONS(1656),
    [anon_sym___fastcall] = ACTIONS(1656),
    [anon_sym___thiscall] = ACTIONS(1656),
    [anon_sym___vectorcall] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1658),
    [anon_sym_signed] = ACTIONS(1656),
    [anon_sym_unsigned] = ACTIONS(1656),
    [anon_sym_long] = ACTIONS(1656),
    [anon_sym_short] = ACTIONS(1656),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_auto] = ACTIONS(1656),
    [anon_sym_register] = ACTIONS(1656),
    [anon_sym_inline] = ACTIONS(1656),
    [anon_sym___inline] = ACTIONS(1656),
    [anon_sym___inline__] = ACTIONS(1656),
    [anon_sym___forceinline] = ACTIONS(1656),
    [anon_sym_thread_local] = ACTIONS(1656),
    [anon_sym___thread] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_constexpr] = ACTIONS(1656),
    [anon_sym_volatile] = ACTIONS(1656),
    [anon_sym_restrict] = ACTIONS(1656),
    [anon_sym___restrict__] = ACTIONS(1656),
    [anon_sym__Atomic] = ACTIONS(1656),
    [anon_sym__Noreturn] = ACTIONS(1656),
    [anon_sym_noreturn] = ACTIONS(1656),
    [sym_primitive_type] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_struct] = ACTIONS(1656),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_goto] = ACTIONS(1656),
    [anon_sym_DASH_DASH] = ACTIONS(1658),
    [anon_sym_PLUS_PLUS] = ACTIONS(1658),
    [anon_sym_sizeof] = ACTIONS(1656),
    [anon_sym___alignof__] = ACTIONS(1656),
    [anon_sym___alignof] = ACTIONS(1656),
    [anon_sym__alignof] = ACTIONS(1656),
    [anon_sym_alignof] = ACTIONS(1656),
    [anon_sym__Alignof] = ACTIONS(1656),
    [anon_sym_offsetof] = ACTIONS(1656),
    [anon_sym__Generic] = ACTIONS(1656),
    [anon_sym_asm] = ACTIONS(1656),
    [anon_sym___asm__] = ACTIONS(1656),
    [sym_number_literal] = ACTIONS(1658),
    [anon_sym_L_SQUOTE] = ACTIONS(1658),
    [anon_sym_u_SQUOTE] = ACTIONS(1658),
    [anon_sym_U_SQUOTE] = ACTIONS(1658),
    [anon_sym_u8_SQUOTE] = ACTIONS(1658),
    [anon_sym_SQUOTE] = ACTIONS(1658),
    [anon_sym_L_DQUOTE] = ACTIONS(1658),
    [anon_sym_u_DQUOTE] = ACTIONS(1658),
    [anon_sym_U_DQUOTE] = ACTIONS(1658),
    [anon_sym_u8_DQUOTE] = ACTIONS(1658),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [anon_sym_NULL] = ACTIONS(1656),
    [anon_sym_nullptr] = ACTIONS(1656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1656),
    [anon_sym_acquire] = ACTIONS(1656),
    [anon_sym_monitor] = ACTIONS(1656),
    [anon_sym_start] = ACTIONS(1656),
    [anon_sym_stop] = ACTIONS(1656),
  },
  [208] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [209] = {
    [sym_identifier] = ACTIONS(1660),
    [aux_sym_preproc_include_token1] = ACTIONS(1660),
    [aux_sym_preproc_def_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token2] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1660),
    [aux_sym_preproc_else_token1] = ACTIONS(1660),
    [aux_sym_preproc_elif_token1] = ACTIONS(1660),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1660),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1660),
    [sym_preproc_directive] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_TILDE] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1660),
    [anon_sym_typedef] = ACTIONS(1660),
    [anon_sym_extern] = ACTIONS(1660),
    [anon_sym___attribute__] = ACTIONS(1660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1662),
    [anon_sym___declspec] = ACTIONS(1660),
    [anon_sym___cdecl] = ACTIONS(1660),
    [anon_sym___clrcall] = ACTIONS(1660),
    [anon_sym___stdcall] = ACTIONS(1660),
    [anon_sym___fastcall] = ACTIONS(1660),
    [anon_sym___thiscall] = ACTIONS(1660),
    [anon_sym___vectorcall] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_signed] = ACTIONS(1660),
    [anon_sym_unsigned] = ACTIONS(1660),
    [anon_sym_long] = ACTIONS(1660),
    [anon_sym_short] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_auto] = ACTIONS(1660),
    [anon_sym_register] = ACTIONS(1660),
    [anon_sym_inline] = ACTIONS(1660),
    [anon_sym___inline] = ACTIONS(1660),
    [anon_sym___inline__] = ACTIONS(1660),
    [anon_sym___forceinline] = ACTIONS(1660),
    [anon_sym_thread_local] = ACTIONS(1660),
    [anon_sym___thread] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1660),
    [anon_sym_constexpr] = ACTIONS(1660),
    [anon_sym_volatile] = ACTIONS(1660),
    [anon_sym_restrict] = ACTIONS(1660),
    [anon_sym___restrict__] = ACTIONS(1660),
    [anon_sym__Atomic] = ACTIONS(1660),
    [anon_sym__Noreturn] = ACTIONS(1660),
    [anon_sym_noreturn] = ACTIONS(1660),
    [sym_primitive_type] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1660),
    [anon_sym_struct] = ACTIONS(1660),
    [anon_sym_union] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1660),
    [anon_sym_switch] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1660),
    [anon_sym_default] = ACTIONS(1660),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_return] = ACTIONS(1660),
    [anon_sym_break] = ACTIONS(1660),
    [anon_sym_continue] = ACTIONS(1660),
    [anon_sym_goto] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1662),
    [anon_sym_sizeof] = ACTIONS(1660),
    [anon_sym___alignof__] = ACTIONS(1660),
    [anon_sym___alignof] = ACTIONS(1660),
    [anon_sym__alignof] = ACTIONS(1660),
    [anon_sym_alignof] = ACTIONS(1660),
    [anon_sym__Alignof] = ACTIONS(1660),
    [anon_sym_offsetof] = ACTIONS(1660),
    [anon_sym__Generic] = ACTIONS(1660),
    [anon_sym_asm] = ACTIONS(1660),
    [anon_sym___asm__] = ACTIONS(1660),
    [sym_number_literal] = ACTIONS(1662),
    [anon_sym_L_SQUOTE] = ACTIONS(1662),
    [anon_sym_u_SQUOTE] = ACTIONS(1662),
    [anon_sym_U_SQUOTE] = ACTIONS(1662),
    [anon_sym_u8_SQUOTE] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1662),
    [anon_sym_L_DQUOTE] = ACTIONS(1662),
    [anon_sym_u_DQUOTE] = ACTIONS(1662),
    [anon_sym_U_DQUOTE] = ACTIONS(1662),
    [anon_sym_u8_DQUOTE] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [sym_true] = ACTIONS(1660),
    [sym_false] = ACTIONS(1660),
    [anon_sym_NULL] = ACTIONS(1660),
    [anon_sym_nullptr] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1660),
    [anon_sym_acquire] = ACTIONS(1660),
    [anon_sym_monitor] = ACTIONS(1660),
    [anon_sym_start] = ACTIONS(1660),
    [anon_sym_stop] = ACTIONS(1660),
  },
  [210] = {
    [sym_identifier] = ACTIONS(1496),
    [aux_sym_preproc_include_token1] = ACTIONS(1496),
    [aux_sym_preproc_def_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token2] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1496),
    [aux_sym_preproc_else_token1] = ACTIONS(1496),
    [aux_sym_preproc_elif_token1] = ACTIONS(1496),
    [sym_preproc_directive] = ACTIONS(1496),
    [anon_sym_LPAREN2] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym___extension__] = ACTIONS(1496),
    [anon_sym_typedef] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym___attribute__] = ACTIONS(1496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1498),
    [anon_sym___declspec] = ACTIONS(1496),
    [anon_sym___cdecl] = ACTIONS(1496),
    [anon_sym___clrcall] = ACTIONS(1496),
    [anon_sym___stdcall] = ACTIONS(1496),
    [anon_sym___fastcall] = ACTIONS(1496),
    [anon_sym___thiscall] = ACTIONS(1496),
    [anon_sym___vectorcall] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_signed] = ACTIONS(1496),
    [anon_sym_unsigned] = ACTIONS(1496),
    [anon_sym_long] = ACTIONS(1496),
    [anon_sym_short] = ACTIONS(1496),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_auto] = ACTIONS(1496),
    [anon_sym_register] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym___inline] = ACTIONS(1496),
    [anon_sym___inline__] = ACTIONS(1496),
    [anon_sym___forceinline] = ACTIONS(1496),
    [anon_sym_thread_local] = ACTIONS(1496),
    [anon_sym___thread] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_constexpr] = ACTIONS(1496),
    [anon_sym_volatile] = ACTIONS(1496),
    [anon_sym_restrict] = ACTIONS(1496),
    [anon_sym___restrict__] = ACTIONS(1496),
    [anon_sym__Atomic] = ACTIONS(1496),
    [anon_sym__Noreturn] = ACTIONS(1496),
    [anon_sym_noreturn] = ACTIONS(1496),
    [sym_primitive_type] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_struct] = ACTIONS(1496),
    [anon_sym_union] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_goto] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_sizeof] = ACTIONS(1496),
    [anon_sym___alignof__] = ACTIONS(1496),
    [anon_sym___alignof] = ACTIONS(1496),
    [anon_sym__alignof] = ACTIONS(1496),
    [anon_sym_alignof] = ACTIONS(1496),
    [anon_sym__Alignof] = ACTIONS(1496),
    [anon_sym_offsetof] = ACTIONS(1496),
    [anon_sym__Generic] = ACTIONS(1496),
    [anon_sym_asm] = ACTIONS(1496),
    [anon_sym___asm__] = ACTIONS(1496),
    [sym_number_literal] = ACTIONS(1498),
    [anon_sym_L_SQUOTE] = ACTIONS(1498),
    [anon_sym_u_SQUOTE] = ACTIONS(1498),
    [anon_sym_U_SQUOTE] = ACTIONS(1498),
    [anon_sym_u8_SQUOTE] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_L_DQUOTE] = ACTIONS(1498),
    [anon_sym_u_DQUOTE] = ACTIONS(1498),
    [anon_sym_U_DQUOTE] = ACTIONS(1498),
    [anon_sym_u8_DQUOTE] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [anon_sym_NULL] = ACTIONS(1496),
    [anon_sym_nullptr] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1496),
    [anon_sym_acquire] = ACTIONS(1496),
    [anon_sym_catch] = ACTIONS(1496),
    [anon_sym_monitor] = ACTIONS(1496),
    [anon_sym_start] = ACTIONS(1496),
    [anon_sym_stop] = ACTIONS(1496),
  },
  [211] = {
    [sym_identifier] = ACTIONS(1541),
    [aux_sym_preproc_include_token1] = ACTIONS(1541),
    [aux_sym_preproc_def_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token2] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1541),
    [aux_sym_preproc_else_token1] = ACTIONS(1541),
    [aux_sym_preproc_elif_token1] = ACTIONS(1541),
    [sym_preproc_directive] = ACTIONS(1541),
    [anon_sym_LPAREN2] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym___extension__] = ACTIONS(1541),
    [anon_sym_typedef] = ACTIONS(1541),
    [anon_sym_extern] = ACTIONS(1541),
    [anon_sym___attribute__] = ACTIONS(1541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1543),
    [anon_sym___declspec] = ACTIONS(1541),
    [anon_sym___cdecl] = ACTIONS(1541),
    [anon_sym___clrcall] = ACTIONS(1541),
    [anon_sym___stdcall] = ACTIONS(1541),
    [anon_sym___fastcall] = ACTIONS(1541),
    [anon_sym___thiscall] = ACTIONS(1541),
    [anon_sym___vectorcall] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_signed] = ACTIONS(1541),
    [anon_sym_unsigned] = ACTIONS(1541),
    [anon_sym_long] = ACTIONS(1541),
    [anon_sym_short] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_auto] = ACTIONS(1541),
    [anon_sym_register] = ACTIONS(1541),
    [anon_sym_inline] = ACTIONS(1541),
    [anon_sym___inline] = ACTIONS(1541),
    [anon_sym___inline__] = ACTIONS(1541),
    [anon_sym___forceinline] = ACTIONS(1541),
    [anon_sym_thread_local] = ACTIONS(1541),
    [anon_sym___thread] = ACTIONS(1541),
    [anon_sym_const] = ACTIONS(1541),
    [anon_sym_constexpr] = ACTIONS(1541),
    [anon_sym_volatile] = ACTIONS(1541),
    [anon_sym_restrict] = ACTIONS(1541),
    [anon_sym___restrict__] = ACTIONS(1541),
    [anon_sym__Atomic] = ACTIONS(1541),
    [anon_sym__Noreturn] = ACTIONS(1541),
    [anon_sym_noreturn] = ACTIONS(1541),
    [sym_primitive_type] = ACTIONS(1541),
    [anon_sym_enum] = ACTIONS(1541),
    [anon_sym_struct] = ACTIONS(1541),
    [anon_sym_union] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1541),
    [anon_sym_default] = ACTIONS(1541),
    [anon_sym_while] = ACTIONS(1541),
    [anon_sym_do] = ACTIONS(1541),
    [anon_sym_for] = ACTIONS(1541),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1541),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_goto] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1541),
    [anon_sym___alignof__] = ACTIONS(1541),
    [anon_sym___alignof] = ACTIONS(1541),
    [anon_sym__alignof] = ACTIONS(1541),
    [anon_sym_alignof] = ACTIONS(1541),
    [anon_sym__Alignof] = ACTIONS(1541),
    [anon_sym_offsetof] = ACTIONS(1541),
    [anon_sym__Generic] = ACTIONS(1541),
    [anon_sym_asm] = ACTIONS(1541),
    [anon_sym___asm__] = ACTIONS(1541),
    [sym_number_literal] = ACTIONS(1543),
    [anon_sym_L_SQUOTE] = ACTIONS(1543),
    [anon_sym_u_SQUOTE] = ACTIONS(1543),
    [anon_sym_U_SQUOTE] = ACTIONS(1543),
    [anon_sym_u8_SQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_L_DQUOTE] = ACTIONS(1543),
    [anon_sym_u_DQUOTE] = ACTIONS(1543),
    [anon_sym_U_DQUOTE] = ACTIONS(1543),
    [anon_sym_u8_DQUOTE] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [anon_sym_NULL] = ACTIONS(1541),
    [anon_sym_nullptr] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1541),
    [anon_sym_acquire] = ACTIONS(1541),
    [anon_sym_catch] = ACTIONS(1541),
    [anon_sym_monitor] = ACTIONS(1541),
    [anon_sym_start] = ACTIONS(1541),
    [anon_sym_stop] = ACTIONS(1541),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1664),
    [aux_sym_preproc_include_token1] = ACTIONS(1664),
    [aux_sym_preproc_def_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token2] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1664),
    [aux_sym_preproc_else_token1] = ACTIONS(1664),
    [aux_sym_preproc_elif_token1] = ACTIONS(1664),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1664),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1664),
    [sym_preproc_directive] = ACTIONS(1664),
    [anon_sym_LPAREN2] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym___attribute__] = ACTIONS(1664),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1666),
    [anon_sym___declspec] = ACTIONS(1664),
    [anon_sym___cdecl] = ACTIONS(1664),
    [anon_sym___clrcall] = ACTIONS(1664),
    [anon_sym___stdcall] = ACTIONS(1664),
    [anon_sym___fastcall] = ACTIONS(1664),
    [anon_sym___thiscall] = ACTIONS(1664),
    [anon_sym___vectorcall] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_signed] = ACTIONS(1664),
    [anon_sym_unsigned] = ACTIONS(1664),
    [anon_sym_long] = ACTIONS(1664),
    [anon_sym_short] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_auto] = ACTIONS(1664),
    [anon_sym_register] = ACTIONS(1664),
    [anon_sym_inline] = ACTIONS(1664),
    [anon_sym___inline] = ACTIONS(1664),
    [anon_sym___inline__] = ACTIONS(1664),
    [anon_sym___forceinline] = ACTIONS(1664),
    [anon_sym_thread_local] = ACTIONS(1664),
    [anon_sym___thread] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_constexpr] = ACTIONS(1664),
    [anon_sym_volatile] = ACTIONS(1664),
    [anon_sym_restrict] = ACTIONS(1664),
    [anon_sym___restrict__] = ACTIONS(1664),
    [anon_sym__Atomic] = ACTIONS(1664),
    [anon_sym__Noreturn] = ACTIONS(1664),
    [anon_sym_noreturn] = ACTIONS(1664),
    [sym_primitive_type] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_switch] = ACTIONS(1664),
    [anon_sym_case] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_do] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_goto] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1666),
    [anon_sym_sizeof] = ACTIONS(1664),
    [anon_sym___alignof__] = ACTIONS(1664),
    [anon_sym___alignof] = ACTIONS(1664),
    [anon_sym__alignof] = ACTIONS(1664),
    [anon_sym_alignof] = ACTIONS(1664),
    [anon_sym__Alignof] = ACTIONS(1664),
    [anon_sym_offsetof] = ACTIONS(1664),
    [anon_sym__Generic] = ACTIONS(1664),
    [anon_sym_asm] = ACTIONS(1664),
    [anon_sym___asm__] = ACTIONS(1664),
    [sym_number_literal] = ACTIONS(1666),
    [anon_sym_L_SQUOTE] = ACTIONS(1666),
    [anon_sym_u_SQUOTE] = ACTIONS(1666),
    [anon_sym_U_SQUOTE] = ACTIONS(1666),
    [anon_sym_u8_SQUOTE] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1666),
    [anon_sym_L_DQUOTE] = ACTIONS(1666),
    [anon_sym_u_DQUOTE] = ACTIONS(1666),
    [anon_sym_U_DQUOTE] = ACTIONS(1666),
    [anon_sym_u8_DQUOTE] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1666),
    [sym_true] = ACTIONS(1664),
    [sym_false] = ACTIONS(1664),
    [anon_sym_NULL] = ACTIONS(1664),
    [anon_sym_nullptr] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1664),
    [anon_sym_acquire] = ACTIONS(1664),
    [anon_sym_monitor] = ACTIONS(1664),
    [anon_sym_start] = ACTIONS(1664),
    [anon_sym_stop] = ACTIONS(1664),
  },
  [213] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1537),
    [aux_sym_preproc_include_token1] = ACTIONS(1537),
    [aux_sym_preproc_def_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token2] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1537),
    [aux_sym_preproc_else_token1] = ACTIONS(1537),
    [aux_sym_preproc_elif_token1] = ACTIONS(1537),
    [sym_preproc_directive] = ACTIONS(1537),
    [anon_sym_LPAREN2] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym___extension__] = ACTIONS(1537),
    [anon_sym_typedef] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(1537),
    [anon_sym___attribute__] = ACTIONS(1537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1539),
    [anon_sym___declspec] = ACTIONS(1537),
    [anon_sym___cdecl] = ACTIONS(1537),
    [anon_sym___clrcall] = ACTIONS(1537),
    [anon_sym___stdcall] = ACTIONS(1537),
    [anon_sym___fastcall] = ACTIONS(1537),
    [anon_sym___thiscall] = ACTIONS(1537),
    [anon_sym___vectorcall] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_signed] = ACTIONS(1537),
    [anon_sym_unsigned] = ACTIONS(1537),
    [anon_sym_long] = ACTIONS(1537),
    [anon_sym_short] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_auto] = ACTIONS(1537),
    [anon_sym_register] = ACTIONS(1537),
    [anon_sym_inline] = ACTIONS(1537),
    [anon_sym___inline] = ACTIONS(1537),
    [anon_sym___inline__] = ACTIONS(1537),
    [anon_sym___forceinline] = ACTIONS(1537),
    [anon_sym_thread_local] = ACTIONS(1537),
    [anon_sym___thread] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_constexpr] = ACTIONS(1537),
    [anon_sym_volatile] = ACTIONS(1537),
    [anon_sym_restrict] = ACTIONS(1537),
    [anon_sym___restrict__] = ACTIONS(1537),
    [anon_sym__Atomic] = ACTIONS(1537),
    [anon_sym__Noreturn] = ACTIONS(1537),
    [anon_sym_noreturn] = ACTIONS(1537),
    [sym_primitive_type] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [anon_sym_struct] = ACTIONS(1537),
    [anon_sym_union] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_goto] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_sizeof] = ACTIONS(1537),
    [anon_sym___alignof__] = ACTIONS(1537),
    [anon_sym___alignof] = ACTIONS(1537),
    [anon_sym__alignof] = ACTIONS(1537),
    [anon_sym_alignof] = ACTIONS(1537),
    [anon_sym__Alignof] = ACTIONS(1537),
    [anon_sym_offsetof] = ACTIONS(1537),
    [anon_sym__Generic] = ACTIONS(1537),
    [anon_sym_asm] = ACTIONS(1537),
    [anon_sym___asm__] = ACTIONS(1537),
    [sym_number_literal] = ACTIONS(1539),
    [anon_sym_L_SQUOTE] = ACTIONS(1539),
    [anon_sym_u_SQUOTE] = ACTIONS(1539),
    [anon_sym_U_SQUOTE] = ACTIONS(1539),
    [anon_sym_u8_SQUOTE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [anon_sym_L_DQUOTE] = ACTIONS(1539),
    [anon_sym_u_DQUOTE] = ACTIONS(1539),
    [anon_sym_U_DQUOTE] = ACTIONS(1539),
    [anon_sym_u8_DQUOTE] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1539),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [anon_sym_NULL] = ACTIONS(1537),
    [anon_sym_nullptr] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1537),
    [anon_sym_acquire] = ACTIONS(1537),
    [anon_sym_catch] = ACTIONS(1537),
    [anon_sym_monitor] = ACTIONS(1537),
    [anon_sym_start] = ACTIONS(1537),
    [anon_sym_stop] = ACTIONS(1537),
  },
  [215] = {
    [sym_identifier] = ACTIONS(1561),
    [aux_sym_preproc_include_token1] = ACTIONS(1561),
    [aux_sym_preproc_def_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1561),
    [aux_sym_preproc_else_token1] = ACTIONS(1561),
    [aux_sym_preproc_elif_token1] = ACTIONS(1561),
    [sym_preproc_directive] = ACTIONS(1561),
    [anon_sym_LPAREN2] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym___extension__] = ACTIONS(1561),
    [anon_sym_typedef] = ACTIONS(1561),
    [anon_sym_extern] = ACTIONS(1561),
    [anon_sym___attribute__] = ACTIONS(1561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1563),
    [anon_sym___declspec] = ACTIONS(1561),
    [anon_sym___cdecl] = ACTIONS(1561),
    [anon_sym___clrcall] = ACTIONS(1561),
    [anon_sym___stdcall] = ACTIONS(1561),
    [anon_sym___fastcall] = ACTIONS(1561),
    [anon_sym___thiscall] = ACTIONS(1561),
    [anon_sym___vectorcall] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_signed] = ACTIONS(1561),
    [anon_sym_unsigned] = ACTIONS(1561),
    [anon_sym_long] = ACTIONS(1561),
    [anon_sym_short] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_auto] = ACTIONS(1561),
    [anon_sym_register] = ACTIONS(1561),
    [anon_sym_inline] = ACTIONS(1561),
    [anon_sym___inline] = ACTIONS(1561),
    [anon_sym___inline__] = ACTIONS(1561),
    [anon_sym___forceinline] = ACTIONS(1561),
    [anon_sym_thread_local] = ACTIONS(1561),
    [anon_sym___thread] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_constexpr] = ACTIONS(1561),
    [anon_sym_volatile] = ACTIONS(1561),
    [anon_sym_restrict] = ACTIONS(1561),
    [anon_sym___restrict__] = ACTIONS(1561),
    [anon_sym__Atomic] = ACTIONS(1561),
    [anon_sym__Noreturn] = ACTIONS(1561),
    [anon_sym_noreturn] = ACTIONS(1561),
    [sym_primitive_type] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [anon_sym_struct] = ACTIONS(1561),
    [anon_sym_union] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_goto] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_sizeof] = ACTIONS(1561),
    [anon_sym___alignof__] = ACTIONS(1561),
    [anon_sym___alignof] = ACTIONS(1561),
    [anon_sym__alignof] = ACTIONS(1561),
    [anon_sym_alignof] = ACTIONS(1561),
    [anon_sym__Alignof] = ACTIONS(1561),
    [anon_sym_offsetof] = ACTIONS(1561),
    [anon_sym__Generic] = ACTIONS(1561),
    [anon_sym_asm] = ACTIONS(1561),
    [anon_sym___asm__] = ACTIONS(1561),
    [sym_number_literal] = ACTIONS(1563),
    [anon_sym_L_SQUOTE] = ACTIONS(1563),
    [anon_sym_u_SQUOTE] = ACTIONS(1563),
    [anon_sym_U_SQUOTE] = ACTIONS(1563),
    [anon_sym_u8_SQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [anon_sym_L_DQUOTE] = ACTIONS(1563),
    [anon_sym_u_DQUOTE] = ACTIONS(1563),
    [anon_sym_U_DQUOTE] = ACTIONS(1563),
    [anon_sym_u8_DQUOTE] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [anon_sym_NULL] = ACTIONS(1561),
    [anon_sym_nullptr] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_acquire] = ACTIONS(1561),
    [anon_sym_catch] = ACTIONS(1561),
    [anon_sym_monitor] = ACTIONS(1561),
    [anon_sym_start] = ACTIONS(1561),
    [anon_sym_stop] = ACTIONS(1561),
  },
  [216] = {
    [sym_identifier] = ACTIONS(1553),
    [aux_sym_preproc_include_token1] = ACTIONS(1553),
    [aux_sym_preproc_def_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token2] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1553),
    [aux_sym_preproc_else_token1] = ACTIONS(1553),
    [aux_sym_preproc_elif_token1] = ACTIONS(1553),
    [sym_preproc_directive] = ACTIONS(1553),
    [anon_sym_LPAREN2] = ACTIONS(1555),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym___extension__] = ACTIONS(1553),
    [anon_sym_typedef] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1553),
    [anon_sym___attribute__] = ACTIONS(1553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1555),
    [anon_sym___declspec] = ACTIONS(1553),
    [anon_sym___cdecl] = ACTIONS(1553),
    [anon_sym___clrcall] = ACTIONS(1553),
    [anon_sym___stdcall] = ACTIONS(1553),
    [anon_sym___fastcall] = ACTIONS(1553),
    [anon_sym___thiscall] = ACTIONS(1553),
    [anon_sym___vectorcall] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_signed] = ACTIONS(1553),
    [anon_sym_unsigned] = ACTIONS(1553),
    [anon_sym_long] = ACTIONS(1553),
    [anon_sym_short] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_auto] = ACTIONS(1553),
    [anon_sym_register] = ACTIONS(1553),
    [anon_sym_inline] = ACTIONS(1553),
    [anon_sym___inline] = ACTIONS(1553),
    [anon_sym___inline__] = ACTIONS(1553),
    [anon_sym___forceinline] = ACTIONS(1553),
    [anon_sym_thread_local] = ACTIONS(1553),
    [anon_sym___thread] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_constexpr] = ACTIONS(1553),
    [anon_sym_volatile] = ACTIONS(1553),
    [anon_sym_restrict] = ACTIONS(1553),
    [anon_sym___restrict__] = ACTIONS(1553),
    [anon_sym__Atomic] = ACTIONS(1553),
    [anon_sym__Noreturn] = ACTIONS(1553),
    [anon_sym_noreturn] = ACTIONS(1553),
    [sym_primitive_type] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [anon_sym_struct] = ACTIONS(1553),
    [anon_sym_union] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_goto] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_sizeof] = ACTIONS(1553),
    [anon_sym___alignof__] = ACTIONS(1553),
    [anon_sym___alignof] = ACTIONS(1553),
    [anon_sym__alignof] = ACTIONS(1553),
    [anon_sym_alignof] = ACTIONS(1553),
    [anon_sym__Alignof] = ACTIONS(1553),
    [anon_sym_offsetof] = ACTIONS(1553),
    [anon_sym__Generic] = ACTIONS(1553),
    [anon_sym_asm] = ACTIONS(1553),
    [anon_sym___asm__] = ACTIONS(1553),
    [sym_number_literal] = ACTIONS(1555),
    [anon_sym_L_SQUOTE] = ACTIONS(1555),
    [anon_sym_u_SQUOTE] = ACTIONS(1555),
    [anon_sym_U_SQUOTE] = ACTIONS(1555),
    [anon_sym_u8_SQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [anon_sym_L_DQUOTE] = ACTIONS(1555),
    [anon_sym_u_DQUOTE] = ACTIONS(1555),
    [anon_sym_U_DQUOTE] = ACTIONS(1555),
    [anon_sym_u8_DQUOTE] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [anon_sym_NULL] = ACTIONS(1553),
    [anon_sym_nullptr] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_acquire] = ACTIONS(1553),
    [anon_sym_catch] = ACTIONS(1553),
    [anon_sym_monitor] = ACTIONS(1553),
    [anon_sym_start] = ACTIONS(1553),
    [anon_sym_stop] = ACTIONS(1553),
  },
  [217] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [218] = {
    [sym_catch_clause] = STATE(171),
    [aux_sym_monitor_statement_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1446),
    [anon_sym_acquire] = ACTIONS(1446),
    [anon_sym_catch] = ACTIONS(1609),
    [anon_sym_monitor] = ACTIONS(1446),
    [anon_sym_start] = ACTIONS(1446),
    [anon_sym_stop] = ACTIONS(1446),
  },
  [219] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [aux_sym_preproc_else_token1] = ACTIONS(1460),
    [aux_sym_preproc_elif_token1] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [220] = {
    [sym_identifier] = ACTIONS(1668),
    [aux_sym_preproc_include_token1] = ACTIONS(1668),
    [aux_sym_preproc_def_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token2] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1668),
    [aux_sym_preproc_else_token1] = ACTIONS(1668),
    [aux_sym_preproc_elif_token1] = ACTIONS(1668),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1668),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1668),
    [sym_preproc_directive] = ACTIONS(1668),
    [anon_sym_LPAREN2] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym___extension__] = ACTIONS(1668),
    [anon_sym_typedef] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym___attribute__] = ACTIONS(1668),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1670),
    [anon_sym___declspec] = ACTIONS(1668),
    [anon_sym___cdecl] = ACTIONS(1668),
    [anon_sym___clrcall] = ACTIONS(1668),
    [anon_sym___stdcall] = ACTIONS(1668),
    [anon_sym___fastcall] = ACTIONS(1668),
    [anon_sym___thiscall] = ACTIONS(1668),
    [anon_sym___vectorcall] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_signed] = ACTIONS(1668),
    [anon_sym_unsigned] = ACTIONS(1668),
    [anon_sym_long] = ACTIONS(1668),
    [anon_sym_short] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_auto] = ACTIONS(1668),
    [anon_sym_register] = ACTIONS(1668),
    [anon_sym_inline] = ACTIONS(1668),
    [anon_sym___inline] = ACTIONS(1668),
    [anon_sym___inline__] = ACTIONS(1668),
    [anon_sym___forceinline] = ACTIONS(1668),
    [anon_sym_thread_local] = ACTIONS(1668),
    [anon_sym___thread] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_constexpr] = ACTIONS(1668),
    [anon_sym_volatile] = ACTIONS(1668),
    [anon_sym_restrict] = ACTIONS(1668),
    [anon_sym___restrict__] = ACTIONS(1668),
    [anon_sym__Atomic] = ACTIONS(1668),
    [anon_sym__Noreturn] = ACTIONS(1668),
    [anon_sym_noreturn] = ACTIONS(1668),
    [sym_primitive_type] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_do] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_goto] = ACTIONS(1668),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_sizeof] = ACTIONS(1668),
    [anon_sym___alignof__] = ACTIONS(1668),
    [anon_sym___alignof] = ACTIONS(1668),
    [anon_sym__alignof] = ACTIONS(1668),
    [anon_sym_alignof] = ACTIONS(1668),
    [anon_sym__Alignof] = ACTIONS(1668),
    [anon_sym_offsetof] = ACTIONS(1668),
    [anon_sym__Generic] = ACTIONS(1668),
    [anon_sym_asm] = ACTIONS(1668),
    [anon_sym___asm__] = ACTIONS(1668),
    [sym_number_literal] = ACTIONS(1670),
    [anon_sym_L_SQUOTE] = ACTIONS(1670),
    [anon_sym_u_SQUOTE] = ACTIONS(1670),
    [anon_sym_U_SQUOTE] = ACTIONS(1670),
    [anon_sym_u8_SQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [anon_sym_L_DQUOTE] = ACTIONS(1670),
    [anon_sym_u_DQUOTE] = ACTIONS(1670),
    [anon_sym_U_DQUOTE] = ACTIONS(1670),
    [anon_sym_u8_DQUOTE] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [anon_sym_NULL] = ACTIONS(1668),
    [anon_sym_nullptr] = ACTIONS(1668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1668),
    [anon_sym_acquire] = ACTIONS(1668),
    [anon_sym_monitor] = ACTIONS(1668),
    [anon_sym_start] = ACTIONS(1668),
    [anon_sym_stop] = ACTIONS(1668),
  },
  [221] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token2] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [aux_sym_preproc_else_token1] = ACTIONS(1513),
    [aux_sym_preproc_elif_token1] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1515),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1515),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_else] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1515),
    [anon_sym_L_SQUOTE] = ACTIONS(1515),
    [anon_sym_u_SQUOTE] = ACTIONS(1515),
    [anon_sym_U_SQUOTE] = ACTIONS(1515),
    [anon_sym_u8_SQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [anon_sym_L_DQUOTE] = ACTIONS(1515),
    [anon_sym_u_DQUOTE] = ACTIONS(1515),
    [anon_sym_U_DQUOTE] = ACTIONS(1515),
    [anon_sym_u8_DQUOTE] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1513),
    [anon_sym_acquire] = ACTIONS(1513),
    [anon_sym_catch] = ACTIONS(1513),
    [anon_sym_monitor] = ACTIONS(1513),
    [anon_sym_start] = ACTIONS(1513),
    [anon_sym_stop] = ACTIONS(1513),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1672),
    [aux_sym_preproc_include_token1] = ACTIONS(1672),
    [aux_sym_preproc_def_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token2] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1672),
    [aux_sym_preproc_else_token1] = ACTIONS(1672),
    [aux_sym_preproc_elif_token1] = ACTIONS(1672),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1672),
    [sym_preproc_directive] = ACTIONS(1672),
    [anon_sym_LPAREN2] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_TILDE] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym___extension__] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym___attribute__] = ACTIONS(1672),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1674),
    [anon_sym___declspec] = ACTIONS(1672),
    [anon_sym___cdecl] = ACTIONS(1672),
    [anon_sym___clrcall] = ACTIONS(1672),
    [anon_sym___stdcall] = ACTIONS(1672),
    [anon_sym___fastcall] = ACTIONS(1672),
    [anon_sym___thiscall] = ACTIONS(1672),
    [anon_sym___vectorcall] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_signed] = ACTIONS(1672),
    [anon_sym_unsigned] = ACTIONS(1672),
    [anon_sym_long] = ACTIONS(1672),
    [anon_sym_short] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_auto] = ACTIONS(1672),
    [anon_sym_register] = ACTIONS(1672),
    [anon_sym_inline] = ACTIONS(1672),
    [anon_sym___inline] = ACTIONS(1672),
    [anon_sym___inline__] = ACTIONS(1672),
    [anon_sym___forceinline] = ACTIONS(1672),
    [anon_sym_thread_local] = ACTIONS(1672),
    [anon_sym___thread] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_constexpr] = ACTIONS(1672),
    [anon_sym_volatile] = ACTIONS(1672),
    [anon_sym_restrict] = ACTIONS(1672),
    [anon_sym___restrict__] = ACTIONS(1672),
    [anon_sym__Atomic] = ACTIONS(1672),
    [anon_sym__Noreturn] = ACTIONS(1672),
    [anon_sym_noreturn] = ACTIONS(1672),
    [sym_primitive_type] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_do] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_goto] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1674),
    [anon_sym_PLUS_PLUS] = ACTIONS(1674),
    [anon_sym_sizeof] = ACTIONS(1672),
    [anon_sym___alignof__] = ACTIONS(1672),
    [anon_sym___alignof] = ACTIONS(1672),
    [anon_sym__alignof] = ACTIONS(1672),
    [anon_sym_alignof] = ACTIONS(1672),
    [anon_sym__Alignof] = ACTIONS(1672),
    [anon_sym_offsetof] = ACTIONS(1672),
    [anon_sym__Generic] = ACTIONS(1672),
    [anon_sym_asm] = ACTIONS(1672),
    [anon_sym___asm__] = ACTIONS(1672),
    [sym_number_literal] = ACTIONS(1674),
    [anon_sym_L_SQUOTE] = ACTIONS(1674),
    [anon_sym_u_SQUOTE] = ACTIONS(1674),
    [anon_sym_U_SQUOTE] = ACTIONS(1674),
    [anon_sym_u8_SQUOTE] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1674),
    [anon_sym_L_DQUOTE] = ACTIONS(1674),
    [anon_sym_u_DQUOTE] = ACTIONS(1674),
    [anon_sym_U_DQUOTE] = ACTIONS(1674),
    [anon_sym_u8_DQUOTE] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(1674),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [anon_sym_NULL] = ACTIONS(1672),
    [anon_sym_nullptr] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1672),
    [anon_sym_acquire] = ACTIONS(1672),
    [anon_sym_monitor] = ACTIONS(1672),
    [anon_sym_start] = ACTIONS(1672),
    [anon_sym_stop] = ACTIONS(1672),
  },
  [223] = {
    [sym_identifier] = ACTIONS(1676),
    [aux_sym_preproc_include_token1] = ACTIONS(1676),
    [aux_sym_preproc_def_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token2] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1676),
    [aux_sym_preproc_else_token1] = ACTIONS(1676),
    [aux_sym_preproc_elif_token1] = ACTIONS(1676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1676),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1676),
    [sym_preproc_directive] = ACTIONS(1676),
    [anon_sym_LPAREN2] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym___extension__] = ACTIONS(1676),
    [anon_sym_typedef] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym___attribute__] = ACTIONS(1676),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1678),
    [anon_sym___declspec] = ACTIONS(1676),
    [anon_sym___cdecl] = ACTIONS(1676),
    [anon_sym___clrcall] = ACTIONS(1676),
    [anon_sym___stdcall] = ACTIONS(1676),
    [anon_sym___fastcall] = ACTIONS(1676),
    [anon_sym___thiscall] = ACTIONS(1676),
    [anon_sym___vectorcall] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_signed] = ACTIONS(1676),
    [anon_sym_unsigned] = ACTIONS(1676),
    [anon_sym_long] = ACTIONS(1676),
    [anon_sym_short] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_auto] = ACTIONS(1676),
    [anon_sym_register] = ACTIONS(1676),
    [anon_sym_inline] = ACTIONS(1676),
    [anon_sym___inline] = ACTIONS(1676),
    [anon_sym___inline__] = ACTIONS(1676),
    [anon_sym___forceinline] = ACTIONS(1676),
    [anon_sym_thread_local] = ACTIONS(1676),
    [anon_sym___thread] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_constexpr] = ACTIONS(1676),
    [anon_sym_volatile] = ACTIONS(1676),
    [anon_sym_restrict] = ACTIONS(1676),
    [anon_sym___restrict__] = ACTIONS(1676),
    [anon_sym__Atomic] = ACTIONS(1676),
    [anon_sym__Noreturn] = ACTIONS(1676),
    [anon_sym_noreturn] = ACTIONS(1676),
    [sym_primitive_type] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_switch] = ACTIONS(1676),
    [anon_sym_case] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_goto] = ACTIONS(1676),
    [anon_sym_DASH_DASH] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1678),
    [anon_sym_sizeof] = ACTIONS(1676),
    [anon_sym___alignof__] = ACTIONS(1676),
    [anon_sym___alignof] = ACTIONS(1676),
    [anon_sym__alignof] = ACTIONS(1676),
    [anon_sym_alignof] = ACTIONS(1676),
    [anon_sym__Alignof] = ACTIONS(1676),
    [anon_sym_offsetof] = ACTIONS(1676),
    [anon_sym__Generic] = ACTIONS(1676),
    [anon_sym_asm] = ACTIONS(1676),
    [anon_sym___asm__] = ACTIONS(1676),
    [sym_number_literal] = ACTIONS(1678),
    [anon_sym_L_SQUOTE] = ACTIONS(1678),
    [anon_sym_u_SQUOTE] = ACTIONS(1678),
    [anon_sym_U_SQUOTE] = ACTIONS(1678),
    [anon_sym_u8_SQUOTE] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1678),
    [anon_sym_L_DQUOTE] = ACTIONS(1678),
    [anon_sym_u_DQUOTE] = ACTIONS(1678),
    [anon_sym_U_DQUOTE] = ACTIONS(1678),
    [anon_sym_u8_DQUOTE] = ACTIONS(1678),
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [anon_sym_NULL] = ACTIONS(1676),
    [anon_sym_nullptr] = ACTIONS(1676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1676),
    [anon_sym_acquire] = ACTIONS(1676),
    [anon_sym_monitor] = ACTIONS(1676),
    [anon_sym_start] = ACTIONS(1676),
    [anon_sym_stop] = ACTIONS(1676),
  },
  [224] = {
    [sym_identifier] = ACTIONS(1680),
    [aux_sym_preproc_include_token1] = ACTIONS(1680),
    [aux_sym_preproc_def_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token2] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1680),
    [aux_sym_preproc_else_token1] = ACTIONS(1680),
    [aux_sym_preproc_elif_token1] = ACTIONS(1680),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1680),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1680),
    [sym_preproc_directive] = ACTIONS(1680),
    [anon_sym_LPAREN2] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_TILDE] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym___extension__] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym___attribute__] = ACTIONS(1680),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1682),
    [anon_sym___declspec] = ACTIONS(1680),
    [anon_sym___cdecl] = ACTIONS(1680),
    [anon_sym___clrcall] = ACTIONS(1680),
    [anon_sym___stdcall] = ACTIONS(1680),
    [anon_sym___fastcall] = ACTIONS(1680),
    [anon_sym___thiscall] = ACTIONS(1680),
    [anon_sym___vectorcall] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_signed] = ACTIONS(1680),
    [anon_sym_unsigned] = ACTIONS(1680),
    [anon_sym_long] = ACTIONS(1680),
    [anon_sym_short] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_auto] = ACTIONS(1680),
    [anon_sym_register] = ACTIONS(1680),
    [anon_sym_inline] = ACTIONS(1680),
    [anon_sym___inline] = ACTIONS(1680),
    [anon_sym___inline__] = ACTIONS(1680),
    [anon_sym___forceinline] = ACTIONS(1680),
    [anon_sym_thread_local] = ACTIONS(1680),
    [anon_sym___thread] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_constexpr] = ACTIONS(1680),
    [anon_sym_volatile] = ACTIONS(1680),
    [anon_sym_restrict] = ACTIONS(1680),
    [anon_sym___restrict__] = ACTIONS(1680),
    [anon_sym__Atomic] = ACTIONS(1680),
    [anon_sym__Noreturn] = ACTIONS(1680),
    [anon_sym_noreturn] = ACTIONS(1680),
    [sym_primitive_type] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_switch] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_do] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_goto] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1682),
    [anon_sym_sizeof] = ACTIONS(1680),
    [anon_sym___alignof__] = ACTIONS(1680),
    [anon_sym___alignof] = ACTIONS(1680),
    [anon_sym__alignof] = ACTIONS(1680),
    [anon_sym_alignof] = ACTIONS(1680),
    [anon_sym__Alignof] = ACTIONS(1680),
    [anon_sym_offsetof] = ACTIONS(1680),
    [anon_sym__Generic] = ACTIONS(1680),
    [anon_sym_asm] = ACTIONS(1680),
    [anon_sym___asm__] = ACTIONS(1680),
    [sym_number_literal] = ACTIONS(1682),
    [anon_sym_L_SQUOTE] = ACTIONS(1682),
    [anon_sym_u_SQUOTE] = ACTIONS(1682),
    [anon_sym_U_SQUOTE] = ACTIONS(1682),
    [anon_sym_u8_SQUOTE] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1682),
    [anon_sym_L_DQUOTE] = ACTIONS(1682),
    [anon_sym_u_DQUOTE] = ACTIONS(1682),
    [anon_sym_U_DQUOTE] = ACTIONS(1682),
    [anon_sym_u8_DQUOTE] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [anon_sym_NULL] = ACTIONS(1680),
    [anon_sym_nullptr] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1680),
    [anon_sym_acquire] = ACTIONS(1680),
    [anon_sym_monitor] = ACTIONS(1680),
    [anon_sym_start] = ACTIONS(1680),
    [anon_sym_stop] = ACTIONS(1680),
  },
  [225] = {
    [sym_identifier] = ACTIONS(1533),
    [aux_sym_preproc_include_token1] = ACTIONS(1533),
    [aux_sym_preproc_def_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token2] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1533),
    [aux_sym_preproc_else_token1] = ACTIONS(1533),
    [aux_sym_preproc_elif_token1] = ACTIONS(1533),
    [sym_preproc_directive] = ACTIONS(1533),
    [anon_sym_LPAREN2] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1533),
    [anon_sym_typedef] = ACTIONS(1533),
    [anon_sym_extern] = ACTIONS(1533),
    [anon_sym___attribute__] = ACTIONS(1533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1535),
    [anon_sym___declspec] = ACTIONS(1533),
    [anon_sym___cdecl] = ACTIONS(1533),
    [anon_sym___clrcall] = ACTIONS(1533),
    [anon_sym___stdcall] = ACTIONS(1533),
    [anon_sym___fastcall] = ACTIONS(1533),
    [anon_sym___thiscall] = ACTIONS(1533),
    [anon_sym___vectorcall] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_signed] = ACTIONS(1533),
    [anon_sym_unsigned] = ACTIONS(1533),
    [anon_sym_long] = ACTIONS(1533),
    [anon_sym_short] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_auto] = ACTIONS(1533),
    [anon_sym_register] = ACTIONS(1533),
    [anon_sym_inline] = ACTIONS(1533),
    [anon_sym___inline] = ACTIONS(1533),
    [anon_sym___inline__] = ACTIONS(1533),
    [anon_sym___forceinline] = ACTIONS(1533),
    [anon_sym_thread_local] = ACTIONS(1533),
    [anon_sym___thread] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_constexpr] = ACTIONS(1533),
    [anon_sym_volatile] = ACTIONS(1533),
    [anon_sym_restrict] = ACTIONS(1533),
    [anon_sym___restrict__] = ACTIONS(1533),
    [anon_sym__Atomic] = ACTIONS(1533),
    [anon_sym__Noreturn] = ACTIONS(1533),
    [anon_sym_noreturn] = ACTIONS(1533),
    [sym_primitive_type] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [anon_sym_struct] = ACTIONS(1533),
    [anon_sym_union] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_goto] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_sizeof] = ACTIONS(1533),
    [anon_sym___alignof__] = ACTIONS(1533),
    [anon_sym___alignof] = ACTIONS(1533),
    [anon_sym__alignof] = ACTIONS(1533),
    [anon_sym_alignof] = ACTIONS(1533),
    [anon_sym__Alignof] = ACTIONS(1533),
    [anon_sym_offsetof] = ACTIONS(1533),
    [anon_sym__Generic] = ACTIONS(1533),
    [anon_sym_asm] = ACTIONS(1533),
    [anon_sym___asm__] = ACTIONS(1533),
    [sym_number_literal] = ACTIONS(1535),
    [anon_sym_L_SQUOTE] = ACTIONS(1535),
    [anon_sym_u_SQUOTE] = ACTIONS(1535),
    [anon_sym_U_SQUOTE] = ACTIONS(1535),
    [anon_sym_u8_SQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [anon_sym_L_DQUOTE] = ACTIONS(1535),
    [anon_sym_u_DQUOTE] = ACTIONS(1535),
    [anon_sym_U_DQUOTE] = ACTIONS(1535),
    [anon_sym_u8_DQUOTE] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [anon_sym_NULL] = ACTIONS(1533),
    [anon_sym_nullptr] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1533),
    [anon_sym_acquire] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_monitor] = ACTIONS(1533),
    [anon_sym_start] = ACTIONS(1533),
    [anon_sym_stop] = ACTIONS(1533),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1684),
    [aux_sym_preproc_include_token1] = ACTIONS(1684),
    [aux_sym_preproc_def_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token2] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1684),
    [aux_sym_preproc_else_token1] = ACTIONS(1684),
    [aux_sym_preproc_elif_token1] = ACTIONS(1684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1684),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1684),
    [sym_preproc_directive] = ACTIONS(1684),
    [anon_sym_LPAREN2] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym___extension__] = ACTIONS(1684),
    [anon_sym_typedef] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym___attribute__] = ACTIONS(1684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1686),
    [anon_sym___declspec] = ACTIONS(1684),
    [anon_sym___cdecl] = ACTIONS(1684),
    [anon_sym___clrcall] = ACTIONS(1684),
    [anon_sym___stdcall] = ACTIONS(1684),
    [anon_sym___fastcall] = ACTIONS(1684),
    [anon_sym___thiscall] = ACTIONS(1684),
    [anon_sym___vectorcall] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_signed] = ACTIONS(1684),
    [anon_sym_unsigned] = ACTIONS(1684),
    [anon_sym_long] = ACTIONS(1684),
    [anon_sym_short] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_auto] = ACTIONS(1684),
    [anon_sym_register] = ACTIONS(1684),
    [anon_sym_inline] = ACTIONS(1684),
    [anon_sym___inline] = ACTIONS(1684),
    [anon_sym___inline__] = ACTIONS(1684),
    [anon_sym___forceinline] = ACTIONS(1684),
    [anon_sym_thread_local] = ACTIONS(1684),
    [anon_sym___thread] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_constexpr] = ACTIONS(1684),
    [anon_sym_volatile] = ACTIONS(1684),
    [anon_sym_restrict] = ACTIONS(1684),
    [anon_sym___restrict__] = ACTIONS(1684),
    [anon_sym__Atomic] = ACTIONS(1684),
    [anon_sym__Noreturn] = ACTIONS(1684),
    [anon_sym_noreturn] = ACTIONS(1684),
    [sym_primitive_type] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_do] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1684),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_sizeof] = ACTIONS(1684),
    [anon_sym___alignof__] = ACTIONS(1684),
    [anon_sym___alignof] = ACTIONS(1684),
    [anon_sym__alignof] = ACTIONS(1684),
    [anon_sym_alignof] = ACTIONS(1684),
    [anon_sym__Alignof] = ACTIONS(1684),
    [anon_sym_offsetof] = ACTIONS(1684),
    [anon_sym__Generic] = ACTIONS(1684),
    [anon_sym_asm] = ACTIONS(1684),
    [anon_sym___asm__] = ACTIONS(1684),
    [sym_number_literal] = ACTIONS(1686),
    [anon_sym_L_SQUOTE] = ACTIONS(1686),
    [anon_sym_u_SQUOTE] = ACTIONS(1686),
    [anon_sym_U_SQUOTE] = ACTIONS(1686),
    [anon_sym_u8_SQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [anon_sym_L_DQUOTE] = ACTIONS(1686),
    [anon_sym_u_DQUOTE] = ACTIONS(1686),
    [anon_sym_U_DQUOTE] = ACTIONS(1686),
    [anon_sym_u8_DQUOTE] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [anon_sym_NULL] = ACTIONS(1684),
    [anon_sym_nullptr] = ACTIONS(1684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1684),
    [anon_sym_acquire] = ACTIONS(1684),
    [anon_sym_monitor] = ACTIONS(1684),
    [anon_sym_start] = ACTIONS(1684),
    [anon_sym_stop] = ACTIONS(1684),
  },
  [227] = {
    [sym_identifier] = ACTIONS(1688),
    [aux_sym_preproc_include_token1] = ACTIONS(1688),
    [aux_sym_preproc_def_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token2] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1688),
    [aux_sym_preproc_else_token1] = ACTIONS(1688),
    [aux_sym_preproc_elif_token1] = ACTIONS(1688),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1688),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1688),
    [sym_preproc_directive] = ACTIONS(1688),
    [anon_sym_LPAREN2] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym___extension__] = ACTIONS(1688),
    [anon_sym_typedef] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym___attribute__] = ACTIONS(1688),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1690),
    [anon_sym___declspec] = ACTIONS(1688),
    [anon_sym___cdecl] = ACTIONS(1688),
    [anon_sym___clrcall] = ACTIONS(1688),
    [anon_sym___stdcall] = ACTIONS(1688),
    [anon_sym___fastcall] = ACTIONS(1688),
    [anon_sym___thiscall] = ACTIONS(1688),
    [anon_sym___vectorcall] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_signed] = ACTIONS(1688),
    [anon_sym_unsigned] = ACTIONS(1688),
    [anon_sym_long] = ACTIONS(1688),
    [anon_sym_short] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_auto] = ACTIONS(1688),
    [anon_sym_register] = ACTIONS(1688),
    [anon_sym_inline] = ACTIONS(1688),
    [anon_sym___inline] = ACTIONS(1688),
    [anon_sym___inline__] = ACTIONS(1688),
    [anon_sym___forceinline] = ACTIONS(1688),
    [anon_sym_thread_local] = ACTIONS(1688),
    [anon_sym___thread] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_constexpr] = ACTIONS(1688),
    [anon_sym_volatile] = ACTIONS(1688),
    [anon_sym_restrict] = ACTIONS(1688),
    [anon_sym___restrict__] = ACTIONS(1688),
    [anon_sym__Atomic] = ACTIONS(1688),
    [anon_sym__Noreturn] = ACTIONS(1688),
    [anon_sym_noreturn] = ACTIONS(1688),
    [sym_primitive_type] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_switch] = ACTIONS(1688),
    [anon_sym_case] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_do] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_goto] = ACTIONS(1688),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_sizeof] = ACTIONS(1688),
    [anon_sym___alignof__] = ACTIONS(1688),
    [anon_sym___alignof] = ACTIONS(1688),
    [anon_sym__alignof] = ACTIONS(1688),
    [anon_sym_alignof] = ACTIONS(1688),
    [anon_sym__Alignof] = ACTIONS(1688),
    [anon_sym_offsetof] = ACTIONS(1688),
    [anon_sym__Generic] = ACTIONS(1688),
    [anon_sym_asm] = ACTIONS(1688),
    [anon_sym___asm__] = ACTIONS(1688),
    [sym_number_literal] = ACTIONS(1690),
    [anon_sym_L_SQUOTE] = ACTIONS(1690),
    [anon_sym_u_SQUOTE] = ACTIONS(1690),
    [anon_sym_U_SQUOTE] = ACTIONS(1690),
    [anon_sym_u8_SQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [anon_sym_L_DQUOTE] = ACTIONS(1690),
    [anon_sym_u_DQUOTE] = ACTIONS(1690),
    [anon_sym_U_DQUOTE] = ACTIONS(1690),
    [anon_sym_u8_DQUOTE] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [anon_sym_NULL] = ACTIONS(1688),
    [anon_sym_nullptr] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1688),
    [anon_sym_acquire] = ACTIONS(1688),
    [anon_sym_monitor] = ACTIONS(1688),
    [anon_sym_start] = ACTIONS(1688),
    [anon_sym_stop] = ACTIONS(1688),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1692),
    [aux_sym_preproc_include_token1] = ACTIONS(1692),
    [aux_sym_preproc_def_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token2] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1692),
    [aux_sym_preproc_else_token1] = ACTIONS(1692),
    [aux_sym_preproc_elif_token1] = ACTIONS(1692),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1692),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1692),
    [sym_preproc_directive] = ACTIONS(1692),
    [anon_sym_LPAREN2] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_TILDE] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym___extension__] = ACTIONS(1692),
    [anon_sym_typedef] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym___attribute__] = ACTIONS(1692),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1694),
    [anon_sym___declspec] = ACTIONS(1692),
    [anon_sym___cdecl] = ACTIONS(1692),
    [anon_sym___clrcall] = ACTIONS(1692),
    [anon_sym___stdcall] = ACTIONS(1692),
    [anon_sym___fastcall] = ACTIONS(1692),
    [anon_sym___thiscall] = ACTIONS(1692),
    [anon_sym___vectorcall] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_signed] = ACTIONS(1692),
    [anon_sym_unsigned] = ACTIONS(1692),
    [anon_sym_long] = ACTIONS(1692),
    [anon_sym_short] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_auto] = ACTIONS(1692),
    [anon_sym_register] = ACTIONS(1692),
    [anon_sym_inline] = ACTIONS(1692),
    [anon_sym___inline] = ACTIONS(1692),
    [anon_sym___inline__] = ACTIONS(1692),
    [anon_sym___forceinline] = ACTIONS(1692),
    [anon_sym_thread_local] = ACTIONS(1692),
    [anon_sym___thread] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_constexpr] = ACTIONS(1692),
    [anon_sym_volatile] = ACTIONS(1692),
    [anon_sym_restrict] = ACTIONS(1692),
    [anon_sym___restrict__] = ACTIONS(1692),
    [anon_sym__Atomic] = ACTIONS(1692),
    [anon_sym__Noreturn] = ACTIONS(1692),
    [anon_sym_noreturn] = ACTIONS(1692),
    [sym_primitive_type] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_goto] = ACTIONS(1692),
    [anon_sym_DASH_DASH] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1694),
    [anon_sym_sizeof] = ACTIONS(1692),
    [anon_sym___alignof__] = ACTIONS(1692),
    [anon_sym___alignof] = ACTIONS(1692),
    [anon_sym__alignof] = ACTIONS(1692),
    [anon_sym_alignof] = ACTIONS(1692),
    [anon_sym__Alignof] = ACTIONS(1692),
    [anon_sym_offsetof] = ACTIONS(1692),
    [anon_sym__Generic] = ACTIONS(1692),
    [anon_sym_asm] = ACTIONS(1692),
    [anon_sym___asm__] = ACTIONS(1692),
    [sym_number_literal] = ACTIONS(1694),
    [anon_sym_L_SQUOTE] = ACTIONS(1694),
    [anon_sym_u_SQUOTE] = ACTIONS(1694),
    [anon_sym_U_SQUOTE] = ACTIONS(1694),
    [anon_sym_u8_SQUOTE] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1694),
    [anon_sym_L_DQUOTE] = ACTIONS(1694),
    [anon_sym_u_DQUOTE] = ACTIONS(1694),
    [anon_sym_U_DQUOTE] = ACTIONS(1694),
    [anon_sym_u8_DQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [anon_sym_NULL] = ACTIONS(1692),
    [anon_sym_nullptr] = ACTIONS(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1692),
    [anon_sym_acquire] = ACTIONS(1692),
    [anon_sym_monitor] = ACTIONS(1692),
    [anon_sym_start] = ACTIONS(1692),
    [anon_sym_stop] = ACTIONS(1692),
  },
  [229] = {
    [sym_identifier] = ACTIONS(1525),
    [aux_sym_preproc_include_token1] = ACTIONS(1525),
    [aux_sym_preproc_def_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token2] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1525),
    [aux_sym_preproc_else_token1] = ACTIONS(1525),
    [aux_sym_preproc_elif_token1] = ACTIONS(1525),
    [sym_preproc_directive] = ACTIONS(1525),
    [anon_sym_LPAREN2] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1525),
    [anon_sym_typedef] = ACTIONS(1525),
    [anon_sym_extern] = ACTIONS(1525),
    [anon_sym___attribute__] = ACTIONS(1525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1527),
    [anon_sym___declspec] = ACTIONS(1525),
    [anon_sym___cdecl] = ACTIONS(1525),
    [anon_sym___clrcall] = ACTIONS(1525),
    [anon_sym___stdcall] = ACTIONS(1525),
    [anon_sym___fastcall] = ACTIONS(1525),
    [anon_sym___thiscall] = ACTIONS(1525),
    [anon_sym___vectorcall] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_signed] = ACTIONS(1525),
    [anon_sym_unsigned] = ACTIONS(1525),
    [anon_sym_long] = ACTIONS(1525),
    [anon_sym_short] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1525),
    [anon_sym_auto] = ACTIONS(1525),
    [anon_sym_register] = ACTIONS(1525),
    [anon_sym_inline] = ACTIONS(1525),
    [anon_sym___inline] = ACTIONS(1525),
    [anon_sym___inline__] = ACTIONS(1525),
    [anon_sym___forceinline] = ACTIONS(1525),
    [anon_sym_thread_local] = ACTIONS(1525),
    [anon_sym___thread] = ACTIONS(1525),
    [anon_sym_const] = ACTIONS(1525),
    [anon_sym_constexpr] = ACTIONS(1525),
    [anon_sym_volatile] = ACTIONS(1525),
    [anon_sym_restrict] = ACTIONS(1525),
    [anon_sym___restrict__] = ACTIONS(1525),
    [anon_sym__Atomic] = ACTIONS(1525),
    [anon_sym__Noreturn] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [sym_primitive_type] = ACTIONS(1525),
    [anon_sym_enum] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1525),
    [anon_sym_union] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_do] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_return] = ACTIONS(1525),
    [anon_sym_break] = ACTIONS(1525),
    [anon_sym_continue] = ACTIONS(1525),
    [anon_sym_goto] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_sizeof] = ACTIONS(1525),
    [anon_sym___alignof__] = ACTIONS(1525),
    [anon_sym___alignof] = ACTIONS(1525),
    [anon_sym__alignof] = ACTIONS(1525),
    [anon_sym_alignof] = ACTIONS(1525),
    [anon_sym__Alignof] = ACTIONS(1525),
    [anon_sym_offsetof] = ACTIONS(1525),
    [anon_sym__Generic] = ACTIONS(1525),
    [anon_sym_asm] = ACTIONS(1525),
    [anon_sym___asm__] = ACTIONS(1525),
    [sym_number_literal] = ACTIONS(1527),
    [anon_sym_L_SQUOTE] = ACTIONS(1527),
    [anon_sym_u_SQUOTE] = ACTIONS(1527),
    [anon_sym_U_SQUOTE] = ACTIONS(1527),
    [anon_sym_u8_SQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [anon_sym_L_DQUOTE] = ACTIONS(1527),
    [anon_sym_u_DQUOTE] = ACTIONS(1527),
    [anon_sym_U_DQUOTE] = ACTIONS(1527),
    [anon_sym_u8_DQUOTE] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [anon_sym_NULL] = ACTIONS(1525),
    [anon_sym_nullptr] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1525),
    [anon_sym_acquire] = ACTIONS(1525),
    [anon_sym_catch] = ACTIONS(1525),
    [anon_sym_monitor] = ACTIONS(1525),
    [anon_sym_start] = ACTIONS(1525),
    [anon_sym_stop] = ACTIONS(1525),
  },
  [230] = {
    [sym_identifier] = ACTIONS(1696),
    [aux_sym_preproc_include_token1] = ACTIONS(1696),
    [aux_sym_preproc_def_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token2] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1696),
    [aux_sym_preproc_else_token1] = ACTIONS(1696),
    [aux_sym_preproc_elif_token1] = ACTIONS(1696),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1696),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1696),
    [sym_preproc_directive] = ACTIONS(1696),
    [anon_sym_LPAREN2] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym___extension__] = ACTIONS(1696),
    [anon_sym_typedef] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym___attribute__] = ACTIONS(1696),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1698),
    [anon_sym___declspec] = ACTIONS(1696),
    [anon_sym___cdecl] = ACTIONS(1696),
    [anon_sym___clrcall] = ACTIONS(1696),
    [anon_sym___stdcall] = ACTIONS(1696),
    [anon_sym___fastcall] = ACTIONS(1696),
    [anon_sym___thiscall] = ACTIONS(1696),
    [anon_sym___vectorcall] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_signed] = ACTIONS(1696),
    [anon_sym_unsigned] = ACTIONS(1696),
    [anon_sym_long] = ACTIONS(1696),
    [anon_sym_short] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_auto] = ACTIONS(1696),
    [anon_sym_register] = ACTIONS(1696),
    [anon_sym_inline] = ACTIONS(1696),
    [anon_sym___inline] = ACTIONS(1696),
    [anon_sym___inline__] = ACTIONS(1696),
    [anon_sym___forceinline] = ACTIONS(1696),
    [anon_sym_thread_local] = ACTIONS(1696),
    [anon_sym___thread] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_constexpr] = ACTIONS(1696),
    [anon_sym_volatile] = ACTIONS(1696),
    [anon_sym_restrict] = ACTIONS(1696),
    [anon_sym___restrict__] = ACTIONS(1696),
    [anon_sym__Atomic] = ACTIONS(1696),
    [anon_sym__Noreturn] = ACTIONS(1696),
    [anon_sym_noreturn] = ACTIONS(1696),
    [sym_primitive_type] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_switch] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_goto] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_sizeof] = ACTIONS(1696),
    [anon_sym___alignof__] = ACTIONS(1696),
    [anon_sym___alignof] = ACTIONS(1696),
    [anon_sym__alignof] = ACTIONS(1696),
    [anon_sym_alignof] = ACTIONS(1696),
    [anon_sym__Alignof] = ACTIONS(1696),
    [anon_sym_offsetof] = ACTIONS(1696),
    [anon_sym__Generic] = ACTIONS(1696),
    [anon_sym_asm] = ACTIONS(1696),
    [anon_sym___asm__] = ACTIONS(1696),
    [sym_number_literal] = ACTIONS(1698),
    [anon_sym_L_SQUOTE] = ACTIONS(1698),
    [anon_sym_u_SQUOTE] = ACTIONS(1698),
    [anon_sym_U_SQUOTE] = ACTIONS(1698),
    [anon_sym_u8_SQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [anon_sym_L_DQUOTE] = ACTIONS(1698),
    [anon_sym_u_DQUOTE] = ACTIONS(1698),
    [anon_sym_U_DQUOTE] = ACTIONS(1698),
    [anon_sym_u8_DQUOTE] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [anon_sym_NULL] = ACTIONS(1696),
    [anon_sym_nullptr] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1696),
    [anon_sym_acquire] = ACTIONS(1696),
    [anon_sym_monitor] = ACTIONS(1696),
    [anon_sym_start] = ACTIONS(1696),
    [anon_sym_stop] = ACTIONS(1696),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [232] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1563),
    [sym_identifier] = ACTIONS(1561),
    [aux_sym_preproc_include_token1] = ACTIONS(1561),
    [aux_sym_preproc_def_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1561),
    [sym_preproc_directive] = ACTIONS(1561),
    [anon_sym_LPAREN2] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym___extension__] = ACTIONS(1561),
    [anon_sym_typedef] = ACTIONS(1561),
    [anon_sym_extern] = ACTIONS(1561),
    [anon_sym___attribute__] = ACTIONS(1561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1563),
    [anon_sym___declspec] = ACTIONS(1561),
    [anon_sym___cdecl] = ACTIONS(1561),
    [anon_sym___clrcall] = ACTIONS(1561),
    [anon_sym___stdcall] = ACTIONS(1561),
    [anon_sym___fastcall] = ACTIONS(1561),
    [anon_sym___thiscall] = ACTIONS(1561),
    [anon_sym___vectorcall] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_signed] = ACTIONS(1561),
    [anon_sym_unsigned] = ACTIONS(1561),
    [anon_sym_long] = ACTIONS(1561),
    [anon_sym_short] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_auto] = ACTIONS(1561),
    [anon_sym_register] = ACTIONS(1561),
    [anon_sym_inline] = ACTIONS(1561),
    [anon_sym___inline] = ACTIONS(1561),
    [anon_sym___inline__] = ACTIONS(1561),
    [anon_sym___forceinline] = ACTIONS(1561),
    [anon_sym_thread_local] = ACTIONS(1561),
    [anon_sym___thread] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_constexpr] = ACTIONS(1561),
    [anon_sym_volatile] = ACTIONS(1561),
    [anon_sym_restrict] = ACTIONS(1561),
    [anon_sym___restrict__] = ACTIONS(1561),
    [anon_sym__Atomic] = ACTIONS(1561),
    [anon_sym__Noreturn] = ACTIONS(1561),
    [anon_sym_noreturn] = ACTIONS(1561),
    [sym_primitive_type] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [anon_sym_struct] = ACTIONS(1561),
    [anon_sym_union] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_goto] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_sizeof] = ACTIONS(1561),
    [anon_sym___alignof__] = ACTIONS(1561),
    [anon_sym___alignof] = ACTIONS(1561),
    [anon_sym__alignof] = ACTIONS(1561),
    [anon_sym_alignof] = ACTIONS(1561),
    [anon_sym__Alignof] = ACTIONS(1561),
    [anon_sym_offsetof] = ACTIONS(1561),
    [anon_sym__Generic] = ACTIONS(1561),
    [anon_sym_asm] = ACTIONS(1561),
    [anon_sym___asm__] = ACTIONS(1561),
    [sym_number_literal] = ACTIONS(1563),
    [anon_sym_L_SQUOTE] = ACTIONS(1563),
    [anon_sym_u_SQUOTE] = ACTIONS(1563),
    [anon_sym_U_SQUOTE] = ACTIONS(1563),
    [anon_sym_u8_SQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [anon_sym_L_DQUOTE] = ACTIONS(1563),
    [anon_sym_u_DQUOTE] = ACTIONS(1563),
    [anon_sym_U_DQUOTE] = ACTIONS(1563),
    [anon_sym_u8_DQUOTE] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [anon_sym_NULL] = ACTIONS(1561),
    [anon_sym_nullptr] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1561),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_acquire] = ACTIONS(1561),
    [anon_sym_catch] = ACTIONS(1561),
    [anon_sym_monitor] = ACTIONS(1561),
    [anon_sym_start] = ACTIONS(1561),
    [anon_sym_stop] = ACTIONS(1561),
  },
  [235] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [239] = {
    [sym_catch_clause] = STATE(412),
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_else] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1450),
    [anon_sym_acquire] = ACTIONS(1450),
    [anon_sym_catch] = ACTIONS(1609),
    [anon_sym_monitor] = ACTIONS(1450),
    [anon_sym_start] = ACTIONS(1450),
    [anon_sym_stop] = ACTIONS(1450),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(1547),
    [sym_identifier] = ACTIONS(1545),
    [aux_sym_preproc_include_token1] = ACTIONS(1545),
    [aux_sym_preproc_def_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1545),
    [sym_preproc_directive] = ACTIONS(1545),
    [anon_sym_LPAREN2] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym___extension__] = ACTIONS(1545),
    [anon_sym_typedef] = ACTIONS(1545),
    [anon_sym_extern] = ACTIONS(1545),
    [anon_sym___attribute__] = ACTIONS(1545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1547),
    [anon_sym___declspec] = ACTIONS(1545),
    [anon_sym___cdecl] = ACTIONS(1545),
    [anon_sym___clrcall] = ACTIONS(1545),
    [anon_sym___stdcall] = ACTIONS(1545),
    [anon_sym___fastcall] = ACTIONS(1545),
    [anon_sym___thiscall] = ACTIONS(1545),
    [anon_sym___vectorcall] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_signed] = ACTIONS(1545),
    [anon_sym_unsigned] = ACTIONS(1545),
    [anon_sym_long] = ACTIONS(1545),
    [anon_sym_short] = ACTIONS(1545),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_auto] = ACTIONS(1545),
    [anon_sym_register] = ACTIONS(1545),
    [anon_sym_inline] = ACTIONS(1545),
    [anon_sym___inline] = ACTIONS(1545),
    [anon_sym___inline__] = ACTIONS(1545),
    [anon_sym___forceinline] = ACTIONS(1545),
    [anon_sym_thread_local] = ACTIONS(1545),
    [anon_sym___thread] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_constexpr] = ACTIONS(1545),
    [anon_sym_volatile] = ACTIONS(1545),
    [anon_sym_restrict] = ACTIONS(1545),
    [anon_sym___restrict__] = ACTIONS(1545),
    [anon_sym__Atomic] = ACTIONS(1545),
    [anon_sym__Noreturn] = ACTIONS(1545),
    [anon_sym_noreturn] = ACTIONS(1545),
    [sym_primitive_type] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [anon_sym_struct] = ACTIONS(1545),
    [anon_sym_union] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_sizeof] = ACTIONS(1545),
    [anon_sym___alignof__] = ACTIONS(1545),
    [anon_sym___alignof] = ACTIONS(1545),
    [anon_sym__alignof] = ACTIONS(1545),
    [anon_sym_alignof] = ACTIONS(1545),
    [anon_sym__Alignof] = ACTIONS(1545),
    [anon_sym_offsetof] = ACTIONS(1545),
    [anon_sym__Generic] = ACTIONS(1545),
    [anon_sym_asm] = ACTIONS(1545),
    [anon_sym___asm__] = ACTIONS(1545),
    [sym_number_literal] = ACTIONS(1547),
    [anon_sym_L_SQUOTE] = ACTIONS(1547),
    [anon_sym_u_SQUOTE] = ACTIONS(1547),
    [anon_sym_U_SQUOTE] = ACTIONS(1547),
    [anon_sym_u8_SQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [anon_sym_L_DQUOTE] = ACTIONS(1547),
    [anon_sym_u_DQUOTE] = ACTIONS(1547),
    [anon_sym_U_DQUOTE] = ACTIONS(1547),
    [anon_sym_u8_DQUOTE] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [anon_sym_NULL] = ACTIONS(1545),
    [anon_sym_nullptr] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1545),
    [anon_sym_until] = ACTIONS(1545),
    [anon_sym_acquire] = ACTIONS(1545),
    [anon_sym_catch] = ACTIONS(1545),
    [anon_sym_monitor] = ACTIONS(1545),
    [anon_sym_start] = ACTIONS(1545),
    [anon_sym_stop] = ACTIONS(1545),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(1543),
    [sym_identifier] = ACTIONS(1541),
    [aux_sym_preproc_include_token1] = ACTIONS(1541),
    [aux_sym_preproc_def_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1541),
    [sym_preproc_directive] = ACTIONS(1541),
    [anon_sym_LPAREN2] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym___extension__] = ACTIONS(1541),
    [anon_sym_typedef] = ACTIONS(1541),
    [anon_sym_extern] = ACTIONS(1541),
    [anon_sym___attribute__] = ACTIONS(1541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1543),
    [anon_sym___declspec] = ACTIONS(1541),
    [anon_sym___cdecl] = ACTIONS(1541),
    [anon_sym___clrcall] = ACTIONS(1541),
    [anon_sym___stdcall] = ACTIONS(1541),
    [anon_sym___fastcall] = ACTIONS(1541),
    [anon_sym___thiscall] = ACTIONS(1541),
    [anon_sym___vectorcall] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_signed] = ACTIONS(1541),
    [anon_sym_unsigned] = ACTIONS(1541),
    [anon_sym_long] = ACTIONS(1541),
    [anon_sym_short] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_auto] = ACTIONS(1541),
    [anon_sym_register] = ACTIONS(1541),
    [anon_sym_inline] = ACTIONS(1541),
    [anon_sym___inline] = ACTIONS(1541),
    [anon_sym___inline__] = ACTIONS(1541),
    [anon_sym___forceinline] = ACTIONS(1541),
    [anon_sym_thread_local] = ACTIONS(1541),
    [anon_sym___thread] = ACTIONS(1541),
    [anon_sym_const] = ACTIONS(1541),
    [anon_sym_constexpr] = ACTIONS(1541),
    [anon_sym_volatile] = ACTIONS(1541),
    [anon_sym_restrict] = ACTIONS(1541),
    [anon_sym___restrict__] = ACTIONS(1541),
    [anon_sym__Atomic] = ACTIONS(1541),
    [anon_sym__Noreturn] = ACTIONS(1541),
    [anon_sym_noreturn] = ACTIONS(1541),
    [sym_primitive_type] = ACTIONS(1541),
    [anon_sym_enum] = ACTIONS(1541),
    [anon_sym_struct] = ACTIONS(1541),
    [anon_sym_union] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1541),
    [anon_sym_default] = ACTIONS(1541),
    [anon_sym_while] = ACTIONS(1541),
    [anon_sym_do] = ACTIONS(1541),
    [anon_sym_for] = ACTIONS(1541),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1541),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_goto] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1541),
    [anon_sym___alignof__] = ACTIONS(1541),
    [anon_sym___alignof] = ACTIONS(1541),
    [anon_sym__alignof] = ACTIONS(1541),
    [anon_sym_alignof] = ACTIONS(1541),
    [anon_sym__Alignof] = ACTIONS(1541),
    [anon_sym_offsetof] = ACTIONS(1541),
    [anon_sym__Generic] = ACTIONS(1541),
    [anon_sym_asm] = ACTIONS(1541),
    [anon_sym___asm__] = ACTIONS(1541),
    [sym_number_literal] = ACTIONS(1543),
    [anon_sym_L_SQUOTE] = ACTIONS(1543),
    [anon_sym_u_SQUOTE] = ACTIONS(1543),
    [anon_sym_U_SQUOTE] = ACTIONS(1543),
    [anon_sym_u8_SQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_L_DQUOTE] = ACTIONS(1543),
    [anon_sym_u_DQUOTE] = ACTIONS(1543),
    [anon_sym_U_DQUOTE] = ACTIONS(1543),
    [anon_sym_u8_DQUOTE] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [anon_sym_NULL] = ACTIONS(1541),
    [anon_sym_nullptr] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1541),
    [anon_sym_until] = ACTIONS(1541),
    [anon_sym_acquire] = ACTIONS(1541),
    [anon_sym_catch] = ACTIONS(1541),
    [anon_sym_monitor] = ACTIONS(1541),
    [anon_sym_start] = ACTIONS(1541),
    [anon_sym_stop] = ACTIONS(1541),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1492),
    [aux_sym_preproc_include_token1] = ACTIONS(1492),
    [aux_sym_preproc_def_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1492),
    [sym_preproc_directive] = ACTIONS(1492),
    [anon_sym_LPAREN2] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym___extension__] = ACTIONS(1492),
    [anon_sym_typedef] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym___attribute__] = ACTIONS(1492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1494),
    [anon_sym___declspec] = ACTIONS(1492),
    [anon_sym___cdecl] = ACTIONS(1492),
    [anon_sym___clrcall] = ACTIONS(1492),
    [anon_sym___stdcall] = ACTIONS(1492),
    [anon_sym___fastcall] = ACTIONS(1492),
    [anon_sym___thiscall] = ACTIONS(1492),
    [anon_sym___vectorcall] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_signed] = ACTIONS(1492),
    [anon_sym_unsigned] = ACTIONS(1492),
    [anon_sym_long] = ACTIONS(1492),
    [anon_sym_short] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_auto] = ACTIONS(1492),
    [anon_sym_register] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym___inline] = ACTIONS(1492),
    [anon_sym___inline__] = ACTIONS(1492),
    [anon_sym___forceinline] = ACTIONS(1492),
    [anon_sym_thread_local] = ACTIONS(1492),
    [anon_sym___thread] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_constexpr] = ACTIONS(1492),
    [anon_sym_volatile] = ACTIONS(1492),
    [anon_sym_restrict] = ACTIONS(1492),
    [anon_sym___restrict__] = ACTIONS(1492),
    [anon_sym__Atomic] = ACTIONS(1492),
    [anon_sym__Noreturn] = ACTIONS(1492),
    [anon_sym_noreturn] = ACTIONS(1492),
    [sym_primitive_type] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_struct] = ACTIONS(1492),
    [anon_sym_union] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_goto] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_sizeof] = ACTIONS(1492),
    [anon_sym___alignof__] = ACTIONS(1492),
    [anon_sym___alignof] = ACTIONS(1492),
    [anon_sym__alignof] = ACTIONS(1492),
    [anon_sym_alignof] = ACTIONS(1492),
    [anon_sym__Alignof] = ACTIONS(1492),
    [anon_sym_offsetof] = ACTIONS(1492),
    [anon_sym__Generic] = ACTIONS(1492),
    [anon_sym_asm] = ACTIONS(1492),
    [anon_sym___asm__] = ACTIONS(1492),
    [sym_number_literal] = ACTIONS(1494),
    [anon_sym_L_SQUOTE] = ACTIONS(1494),
    [anon_sym_u_SQUOTE] = ACTIONS(1494),
    [anon_sym_U_SQUOTE] = ACTIONS(1494),
    [anon_sym_u8_SQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_L_DQUOTE] = ACTIONS(1494),
    [anon_sym_u_DQUOTE] = ACTIONS(1494),
    [anon_sym_U_DQUOTE] = ACTIONS(1494),
    [anon_sym_u8_DQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [anon_sym_NULL] = ACTIONS(1492),
    [anon_sym_nullptr] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1492),
    [anon_sym_until] = ACTIONS(1492),
    [anon_sym_acquire] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_monitor] = ACTIONS(1492),
    [anon_sym_start] = ACTIONS(1492),
    [anon_sym_stop] = ACTIONS(1492),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1549),
    [aux_sym_preproc_include_token1] = ACTIONS(1549),
    [aux_sym_preproc_def_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1549),
    [sym_preproc_directive] = ACTIONS(1549),
    [anon_sym_LPAREN2] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym___extension__] = ACTIONS(1549),
    [anon_sym_typedef] = ACTIONS(1549),
    [anon_sym_extern] = ACTIONS(1549),
    [anon_sym___attribute__] = ACTIONS(1549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1551),
    [anon_sym___declspec] = ACTIONS(1549),
    [anon_sym___cdecl] = ACTIONS(1549),
    [anon_sym___clrcall] = ACTIONS(1549),
    [anon_sym___stdcall] = ACTIONS(1549),
    [anon_sym___fastcall] = ACTIONS(1549),
    [anon_sym___thiscall] = ACTIONS(1549),
    [anon_sym___vectorcall] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_signed] = ACTIONS(1549),
    [anon_sym_unsigned] = ACTIONS(1549),
    [anon_sym_long] = ACTIONS(1549),
    [anon_sym_short] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_auto] = ACTIONS(1549),
    [anon_sym_register] = ACTIONS(1549),
    [anon_sym_inline] = ACTIONS(1549),
    [anon_sym___inline] = ACTIONS(1549),
    [anon_sym___inline__] = ACTIONS(1549),
    [anon_sym___forceinline] = ACTIONS(1549),
    [anon_sym_thread_local] = ACTIONS(1549),
    [anon_sym___thread] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_constexpr] = ACTIONS(1549),
    [anon_sym_volatile] = ACTIONS(1549),
    [anon_sym_restrict] = ACTIONS(1549),
    [anon_sym___restrict__] = ACTIONS(1549),
    [anon_sym__Atomic] = ACTIONS(1549),
    [anon_sym__Noreturn] = ACTIONS(1549),
    [anon_sym_noreturn] = ACTIONS(1549),
    [sym_primitive_type] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [anon_sym_struct] = ACTIONS(1549),
    [anon_sym_union] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_goto] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1549),
    [anon_sym___alignof__] = ACTIONS(1549),
    [anon_sym___alignof] = ACTIONS(1549),
    [anon_sym__alignof] = ACTIONS(1549),
    [anon_sym_alignof] = ACTIONS(1549),
    [anon_sym__Alignof] = ACTIONS(1549),
    [anon_sym_offsetof] = ACTIONS(1549),
    [anon_sym__Generic] = ACTIONS(1549),
    [anon_sym_asm] = ACTIONS(1549),
    [anon_sym___asm__] = ACTIONS(1549),
    [sym_number_literal] = ACTIONS(1551),
    [anon_sym_L_SQUOTE] = ACTIONS(1551),
    [anon_sym_u_SQUOTE] = ACTIONS(1551),
    [anon_sym_U_SQUOTE] = ACTIONS(1551),
    [anon_sym_u8_SQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_L_DQUOTE] = ACTIONS(1551),
    [anon_sym_u_DQUOTE] = ACTIONS(1551),
    [anon_sym_U_DQUOTE] = ACTIONS(1551),
    [anon_sym_u8_DQUOTE] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [anon_sym_NULL] = ACTIONS(1549),
    [anon_sym_nullptr] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1549),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_acquire] = ACTIONS(1549),
    [anon_sym_catch] = ACTIONS(1549),
    [anon_sym_monitor] = ACTIONS(1549),
    [anon_sym_start] = ACTIONS(1549),
    [anon_sym_stop] = ACTIONS(1549),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1515),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1515),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_else] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1515),
    [anon_sym_L_SQUOTE] = ACTIONS(1515),
    [anon_sym_u_SQUOTE] = ACTIONS(1515),
    [anon_sym_U_SQUOTE] = ACTIONS(1515),
    [anon_sym_u8_SQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [anon_sym_L_DQUOTE] = ACTIONS(1515),
    [anon_sym_u_DQUOTE] = ACTIONS(1515),
    [anon_sym_U_DQUOTE] = ACTIONS(1515),
    [anon_sym_u8_DQUOTE] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1513),
    [anon_sym_until] = ACTIONS(1513),
    [anon_sym_acquire] = ACTIONS(1513),
    [anon_sym_catch] = ACTIONS(1513),
    [anon_sym_monitor] = ACTIONS(1513),
    [anon_sym_start] = ACTIONS(1513),
    [anon_sym_stop] = ACTIONS(1513),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_include_token1] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_LPAREN2] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym___extension__] = ACTIONS(1488),
    [anon_sym_typedef] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym___cdecl] = ACTIONS(1488),
    [anon_sym___clrcall] = ACTIONS(1488),
    [anon_sym___stdcall] = ACTIONS(1488),
    [anon_sym___fastcall] = ACTIONS(1488),
    [anon_sym___thiscall] = ACTIONS(1488),
    [anon_sym___vectorcall] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym___inline] = ACTIONS(1488),
    [anon_sym___inline__] = ACTIONS(1488),
    [anon_sym___forceinline] = ACTIONS(1488),
    [anon_sym_thread_local] = ACTIONS(1488),
    [anon_sym___thread] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_constexpr] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym___restrict__] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym__Noreturn] = ACTIONS(1488),
    [anon_sym_noreturn] = ACTIONS(1488),
    [sym_primitive_type] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_goto] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_sizeof] = ACTIONS(1488),
    [anon_sym___alignof__] = ACTIONS(1488),
    [anon_sym___alignof] = ACTIONS(1488),
    [anon_sym__alignof] = ACTIONS(1488),
    [anon_sym_alignof] = ACTIONS(1488),
    [anon_sym__Alignof] = ACTIONS(1488),
    [anon_sym_offsetof] = ACTIONS(1488),
    [anon_sym__Generic] = ACTIONS(1488),
    [anon_sym_asm] = ACTIONS(1488),
    [anon_sym___asm__] = ACTIONS(1488),
    [sym_number_literal] = ACTIONS(1490),
    [anon_sym_L_SQUOTE] = ACTIONS(1490),
    [anon_sym_u_SQUOTE] = ACTIONS(1490),
    [anon_sym_U_SQUOTE] = ACTIONS(1490),
    [anon_sym_u8_SQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_L_DQUOTE] = ACTIONS(1490),
    [anon_sym_u_DQUOTE] = ACTIONS(1490),
    [anon_sym_U_DQUOTE] = ACTIONS(1490),
    [anon_sym_u8_DQUOTE] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [anon_sym_NULL] = ACTIONS(1488),
    [anon_sym_nullptr] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1488),
    [anon_sym_until] = ACTIONS(1488),
    [anon_sym_acquire] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_monitor] = ACTIONS(1488),
    [anon_sym_start] = ACTIONS(1488),
    [anon_sym_stop] = ACTIONS(1488),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_include_token1] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_LPAREN2] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym___extension__] = ACTIONS(1480),
    [anon_sym_typedef] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym___cdecl] = ACTIONS(1480),
    [anon_sym___clrcall] = ACTIONS(1480),
    [anon_sym___stdcall] = ACTIONS(1480),
    [anon_sym___fastcall] = ACTIONS(1480),
    [anon_sym___thiscall] = ACTIONS(1480),
    [anon_sym___vectorcall] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym___inline] = ACTIONS(1480),
    [anon_sym___inline__] = ACTIONS(1480),
    [anon_sym___forceinline] = ACTIONS(1480),
    [anon_sym_thread_local] = ACTIONS(1480),
    [anon_sym___thread] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_constexpr] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym___restrict__] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym__Noreturn] = ACTIONS(1480),
    [anon_sym_noreturn] = ACTIONS(1480),
    [sym_primitive_type] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_switch] = ACTIONS(1480),
    [anon_sym_case] = ACTIONS(1480),
    [anon_sym_default] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_do] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_goto] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_sizeof] = ACTIONS(1480),
    [anon_sym___alignof__] = ACTIONS(1480),
    [anon_sym___alignof] = ACTIONS(1480),
    [anon_sym__alignof] = ACTIONS(1480),
    [anon_sym_alignof] = ACTIONS(1480),
    [anon_sym__Alignof] = ACTIONS(1480),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1480),
    [anon_sym_asm] = ACTIONS(1480),
    [anon_sym___asm__] = ACTIONS(1480),
    [sym_number_literal] = ACTIONS(1482),
    [anon_sym_L_SQUOTE] = ACTIONS(1482),
    [anon_sym_u_SQUOTE] = ACTIONS(1482),
    [anon_sym_U_SQUOTE] = ACTIONS(1482),
    [anon_sym_u8_SQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_L_DQUOTE] = ACTIONS(1482),
    [anon_sym_u_DQUOTE] = ACTIONS(1482),
    [anon_sym_U_DQUOTE] = ACTIONS(1482),
    [anon_sym_u8_DQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [anon_sym_NULL] = ACTIONS(1480),
    [anon_sym_nullptr] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1480),
    [anon_sym_until] = ACTIONS(1480),
    [anon_sym_acquire] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_monitor] = ACTIONS(1480),
    [anon_sym_start] = ACTIONS(1480),
    [anon_sym_stop] = ACTIONS(1480),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1559),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_include_token1] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1557),
    [sym_preproc_directive] = ACTIONS(1557),
    [anon_sym_LPAREN2] = ACTIONS(1559),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym___extension__] = ACTIONS(1557),
    [anon_sym_typedef] = ACTIONS(1557),
    [anon_sym_extern] = ACTIONS(1557),
    [anon_sym___attribute__] = ACTIONS(1557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1559),
    [anon_sym___declspec] = ACTIONS(1557),
    [anon_sym___cdecl] = ACTIONS(1557),
    [anon_sym___clrcall] = ACTIONS(1557),
    [anon_sym___stdcall] = ACTIONS(1557),
    [anon_sym___fastcall] = ACTIONS(1557),
    [anon_sym___thiscall] = ACTIONS(1557),
    [anon_sym___vectorcall] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_signed] = ACTIONS(1557),
    [anon_sym_unsigned] = ACTIONS(1557),
    [anon_sym_long] = ACTIONS(1557),
    [anon_sym_short] = ACTIONS(1557),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_auto] = ACTIONS(1557),
    [anon_sym_register] = ACTIONS(1557),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym___inline] = ACTIONS(1557),
    [anon_sym___inline__] = ACTIONS(1557),
    [anon_sym___forceinline] = ACTIONS(1557),
    [anon_sym_thread_local] = ACTIONS(1557),
    [anon_sym___thread] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_constexpr] = ACTIONS(1557),
    [anon_sym_volatile] = ACTIONS(1557),
    [anon_sym_restrict] = ACTIONS(1557),
    [anon_sym___restrict__] = ACTIONS(1557),
    [anon_sym__Atomic] = ACTIONS(1557),
    [anon_sym__Noreturn] = ACTIONS(1557),
    [anon_sym_noreturn] = ACTIONS(1557),
    [sym_primitive_type] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [anon_sym_struct] = ACTIONS(1557),
    [anon_sym_union] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_goto] = ACTIONS(1557),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_sizeof] = ACTIONS(1557),
    [anon_sym___alignof__] = ACTIONS(1557),
    [anon_sym___alignof] = ACTIONS(1557),
    [anon_sym__alignof] = ACTIONS(1557),
    [anon_sym_alignof] = ACTIONS(1557),
    [anon_sym__Alignof] = ACTIONS(1557),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1557),
    [anon_sym_asm] = ACTIONS(1557),
    [anon_sym___asm__] = ACTIONS(1557),
    [sym_number_literal] = ACTIONS(1559),
    [anon_sym_L_SQUOTE] = ACTIONS(1559),
    [anon_sym_u_SQUOTE] = ACTIONS(1559),
    [anon_sym_U_SQUOTE] = ACTIONS(1559),
    [anon_sym_u8_SQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [anon_sym_L_DQUOTE] = ACTIONS(1559),
    [anon_sym_u_DQUOTE] = ACTIONS(1559),
    [anon_sym_U_DQUOTE] = ACTIONS(1559),
    [anon_sym_u8_DQUOTE] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [anon_sym_NULL] = ACTIONS(1557),
    [anon_sym_nullptr] = ACTIONS(1557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1557),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_acquire] = ACTIONS(1557),
    [anon_sym_catch] = ACTIONS(1557),
    [anon_sym_monitor] = ACTIONS(1557),
    [anon_sym_start] = ACTIONS(1557),
    [anon_sym_stop] = ACTIONS(1557),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_include_token1] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_LPAREN2] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym___extension__] = ACTIONS(1484),
    [anon_sym_typedef] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym___cdecl] = ACTIONS(1484),
    [anon_sym___clrcall] = ACTIONS(1484),
    [anon_sym___stdcall] = ACTIONS(1484),
    [anon_sym___fastcall] = ACTIONS(1484),
    [anon_sym___thiscall] = ACTIONS(1484),
    [anon_sym___vectorcall] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym___inline] = ACTIONS(1484),
    [anon_sym___inline__] = ACTIONS(1484),
    [anon_sym___forceinline] = ACTIONS(1484),
    [anon_sym_thread_local] = ACTIONS(1484),
    [anon_sym___thread] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_constexpr] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym___restrict__] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym__Noreturn] = ACTIONS(1484),
    [anon_sym_noreturn] = ACTIONS(1484),
    [sym_primitive_type] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_goto] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_sizeof] = ACTIONS(1484),
    [anon_sym___alignof__] = ACTIONS(1484),
    [anon_sym___alignof] = ACTIONS(1484),
    [anon_sym__alignof] = ACTIONS(1484),
    [anon_sym_alignof] = ACTIONS(1484),
    [anon_sym__Alignof] = ACTIONS(1484),
    [anon_sym_offsetof] = ACTIONS(1484),
    [anon_sym__Generic] = ACTIONS(1484),
    [anon_sym_asm] = ACTIONS(1484),
    [anon_sym___asm__] = ACTIONS(1484),
    [sym_number_literal] = ACTIONS(1486),
    [anon_sym_L_SQUOTE] = ACTIONS(1486),
    [anon_sym_u_SQUOTE] = ACTIONS(1486),
    [anon_sym_U_SQUOTE] = ACTIONS(1486),
    [anon_sym_u8_SQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_L_DQUOTE] = ACTIONS(1486),
    [anon_sym_u_DQUOTE] = ACTIONS(1486),
    [anon_sym_U_DQUOTE] = ACTIONS(1486),
    [anon_sym_u8_DQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [anon_sym_NULL] = ACTIONS(1484),
    [anon_sym_nullptr] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1484),
    [anon_sym_until] = ACTIONS(1484),
    [anon_sym_acquire] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_monitor] = ACTIONS(1484),
    [anon_sym_start] = ACTIONS(1484),
    [anon_sym_stop] = ACTIONS(1484),
  },
  [252] = {
    [sym_else_clause] = STATE(428),
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1700),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1454),
    [anon_sym_acquire] = ACTIONS(1454),
    [anon_sym_catch] = ACTIONS(1454),
    [anon_sym_monitor] = ACTIONS(1454),
    [anon_sym_start] = ACTIONS(1454),
    [anon_sym_stop] = ACTIONS(1454),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_include_token1] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_LPAREN2] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym___cdecl] = ACTIONS(1468),
    [anon_sym___clrcall] = ACTIONS(1468),
    [anon_sym___stdcall] = ACTIONS(1468),
    [anon_sym___fastcall] = ACTIONS(1468),
    [anon_sym___thiscall] = ACTIONS(1468),
    [anon_sym___vectorcall] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym___inline] = ACTIONS(1468),
    [anon_sym___inline__] = ACTIONS(1468),
    [anon_sym___forceinline] = ACTIONS(1468),
    [anon_sym_thread_local] = ACTIONS(1468),
    [anon_sym___thread] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_constexpr] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym___restrict__] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym__Noreturn] = ACTIONS(1468),
    [anon_sym_noreturn] = ACTIONS(1468),
    [sym_primitive_type] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_goto] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_sizeof] = ACTIONS(1468),
    [anon_sym___alignof__] = ACTIONS(1468),
    [anon_sym___alignof] = ACTIONS(1468),
    [anon_sym__alignof] = ACTIONS(1468),
    [anon_sym_alignof] = ACTIONS(1468),
    [anon_sym__Alignof] = ACTIONS(1468),
    [anon_sym_offsetof] = ACTIONS(1468),
    [anon_sym__Generic] = ACTIONS(1468),
    [anon_sym_asm] = ACTIONS(1468),
    [anon_sym___asm__] = ACTIONS(1468),
    [sym_number_literal] = ACTIONS(1470),
    [anon_sym_L_SQUOTE] = ACTIONS(1470),
    [anon_sym_u_SQUOTE] = ACTIONS(1470),
    [anon_sym_U_SQUOTE] = ACTIONS(1470),
    [anon_sym_u8_SQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_L_DQUOTE] = ACTIONS(1470),
    [anon_sym_u_DQUOTE] = ACTIONS(1470),
    [anon_sym_U_DQUOTE] = ACTIONS(1470),
    [anon_sym_u8_DQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [anon_sym_NULL] = ACTIONS(1468),
    [anon_sym_nullptr] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1468),
    [anon_sym_until] = ACTIONS(1468),
    [anon_sym_acquire] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_monitor] = ACTIONS(1468),
    [anon_sym_start] = ACTIONS(1468),
    [anon_sym_stop] = ACTIONS(1468),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_identifier] = ACTIONS(1500),
    [aux_sym_preproc_include_token1] = ACTIONS(1500),
    [aux_sym_preproc_def_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1500),
    [sym_preproc_directive] = ACTIONS(1500),
    [anon_sym_LPAREN2] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym___extension__] = ACTIONS(1500),
    [anon_sym_typedef] = ACTIONS(1500),
    [anon_sym_extern] = ACTIONS(1500),
    [anon_sym___attribute__] = ACTIONS(1500),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1502),
    [anon_sym___declspec] = ACTIONS(1500),
    [anon_sym___cdecl] = ACTIONS(1500),
    [anon_sym___clrcall] = ACTIONS(1500),
    [anon_sym___stdcall] = ACTIONS(1500),
    [anon_sym___fastcall] = ACTIONS(1500),
    [anon_sym___thiscall] = ACTIONS(1500),
    [anon_sym___vectorcall] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_signed] = ACTIONS(1500),
    [anon_sym_unsigned] = ACTIONS(1500),
    [anon_sym_long] = ACTIONS(1500),
    [anon_sym_short] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1500),
    [anon_sym_auto] = ACTIONS(1500),
    [anon_sym_register] = ACTIONS(1500),
    [anon_sym_inline] = ACTIONS(1500),
    [anon_sym___inline] = ACTIONS(1500),
    [anon_sym___inline__] = ACTIONS(1500),
    [anon_sym___forceinline] = ACTIONS(1500),
    [anon_sym_thread_local] = ACTIONS(1500),
    [anon_sym___thread] = ACTIONS(1500),
    [anon_sym_const] = ACTIONS(1500),
    [anon_sym_constexpr] = ACTIONS(1500),
    [anon_sym_volatile] = ACTIONS(1500),
    [anon_sym_restrict] = ACTIONS(1500),
    [anon_sym___restrict__] = ACTIONS(1500),
    [anon_sym__Atomic] = ACTIONS(1500),
    [anon_sym__Noreturn] = ACTIONS(1500),
    [anon_sym_noreturn] = ACTIONS(1500),
    [sym_primitive_type] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1500),
    [anon_sym_struct] = ACTIONS(1500),
    [anon_sym_union] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1500),
    [anon_sym_switch] = ACTIONS(1500),
    [anon_sym_case] = ACTIONS(1500),
    [anon_sym_default] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_do] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_break] = ACTIONS(1500),
    [anon_sym_continue] = ACTIONS(1500),
    [anon_sym_goto] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_sizeof] = ACTIONS(1500),
    [anon_sym___alignof__] = ACTIONS(1500),
    [anon_sym___alignof] = ACTIONS(1500),
    [anon_sym__alignof] = ACTIONS(1500),
    [anon_sym_alignof] = ACTIONS(1500),
    [anon_sym__Alignof] = ACTIONS(1500),
    [anon_sym_offsetof] = ACTIONS(1500),
    [anon_sym__Generic] = ACTIONS(1500),
    [anon_sym_asm] = ACTIONS(1500),
    [anon_sym___asm__] = ACTIONS(1500),
    [sym_number_literal] = ACTIONS(1502),
    [anon_sym_L_SQUOTE] = ACTIONS(1502),
    [anon_sym_u_SQUOTE] = ACTIONS(1502),
    [anon_sym_U_SQUOTE] = ACTIONS(1502),
    [anon_sym_u8_SQUOTE] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_L_DQUOTE] = ACTIONS(1502),
    [anon_sym_u_DQUOTE] = ACTIONS(1502),
    [anon_sym_U_DQUOTE] = ACTIONS(1502),
    [anon_sym_u8_DQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [anon_sym_NULL] = ACTIONS(1500),
    [anon_sym_nullptr] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1500),
    [anon_sym_until] = ACTIONS(1500),
    [anon_sym_acquire] = ACTIONS(1500),
    [anon_sym_catch] = ACTIONS(1500),
    [anon_sym_monitor] = ACTIONS(1500),
    [anon_sym_start] = ACTIONS(1500),
    [anon_sym_stop] = ACTIONS(1500),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [258] = {
    [sym_else_clause] = STATE(448),
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1702),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1454),
    [anon_sym_acquire] = ACTIONS(1454),
    [anon_sym_catch] = ACTIONS(1454),
    [anon_sym_monitor] = ACTIONS(1454),
    [anon_sym_start] = ACTIONS(1454),
    [anon_sym_stop] = ACTIONS(1454),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(1555),
    [sym_identifier] = ACTIONS(1553),
    [aux_sym_preproc_include_token1] = ACTIONS(1553),
    [aux_sym_preproc_def_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1553),
    [sym_preproc_directive] = ACTIONS(1553),
    [anon_sym_LPAREN2] = ACTIONS(1555),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym___extension__] = ACTIONS(1553),
    [anon_sym_typedef] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1553),
    [anon_sym___attribute__] = ACTIONS(1553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1555),
    [anon_sym___declspec] = ACTIONS(1553),
    [anon_sym___cdecl] = ACTIONS(1553),
    [anon_sym___clrcall] = ACTIONS(1553),
    [anon_sym___stdcall] = ACTIONS(1553),
    [anon_sym___fastcall] = ACTIONS(1553),
    [anon_sym___thiscall] = ACTIONS(1553),
    [anon_sym___vectorcall] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_signed] = ACTIONS(1553),
    [anon_sym_unsigned] = ACTIONS(1553),
    [anon_sym_long] = ACTIONS(1553),
    [anon_sym_short] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_auto] = ACTIONS(1553),
    [anon_sym_register] = ACTIONS(1553),
    [anon_sym_inline] = ACTIONS(1553),
    [anon_sym___inline] = ACTIONS(1553),
    [anon_sym___inline__] = ACTIONS(1553),
    [anon_sym___forceinline] = ACTIONS(1553),
    [anon_sym_thread_local] = ACTIONS(1553),
    [anon_sym___thread] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_constexpr] = ACTIONS(1553),
    [anon_sym_volatile] = ACTIONS(1553),
    [anon_sym_restrict] = ACTIONS(1553),
    [anon_sym___restrict__] = ACTIONS(1553),
    [anon_sym__Atomic] = ACTIONS(1553),
    [anon_sym__Noreturn] = ACTIONS(1553),
    [anon_sym_noreturn] = ACTIONS(1553),
    [sym_primitive_type] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [anon_sym_struct] = ACTIONS(1553),
    [anon_sym_union] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_goto] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_sizeof] = ACTIONS(1553),
    [anon_sym___alignof__] = ACTIONS(1553),
    [anon_sym___alignof] = ACTIONS(1553),
    [anon_sym__alignof] = ACTIONS(1553),
    [anon_sym_alignof] = ACTIONS(1553),
    [anon_sym__Alignof] = ACTIONS(1553),
    [anon_sym_offsetof] = ACTIONS(1553),
    [anon_sym__Generic] = ACTIONS(1553),
    [anon_sym_asm] = ACTIONS(1553),
    [anon_sym___asm__] = ACTIONS(1553),
    [sym_number_literal] = ACTIONS(1555),
    [anon_sym_L_SQUOTE] = ACTIONS(1555),
    [anon_sym_u_SQUOTE] = ACTIONS(1555),
    [anon_sym_U_SQUOTE] = ACTIONS(1555),
    [anon_sym_u8_SQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [anon_sym_L_DQUOTE] = ACTIONS(1555),
    [anon_sym_u_DQUOTE] = ACTIONS(1555),
    [anon_sym_U_DQUOTE] = ACTIONS(1555),
    [anon_sym_u8_DQUOTE] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [anon_sym_NULL] = ACTIONS(1553),
    [anon_sym_nullptr] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1553),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_acquire] = ACTIONS(1553),
    [anon_sym_catch] = ACTIONS(1553),
    [anon_sym_monitor] = ACTIONS(1553),
    [anon_sym_start] = ACTIONS(1553),
    [anon_sym_stop] = ACTIONS(1553),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1521),
    [aux_sym_preproc_include_token1] = ACTIONS(1521),
    [aux_sym_preproc_def_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1521),
    [sym_preproc_directive] = ACTIONS(1521),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1521),
    [anon_sym_typedef] = ACTIONS(1521),
    [anon_sym_extern] = ACTIONS(1521),
    [anon_sym___attribute__] = ACTIONS(1521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1523),
    [anon_sym___declspec] = ACTIONS(1521),
    [anon_sym___cdecl] = ACTIONS(1521),
    [anon_sym___clrcall] = ACTIONS(1521),
    [anon_sym___stdcall] = ACTIONS(1521),
    [anon_sym___fastcall] = ACTIONS(1521),
    [anon_sym___thiscall] = ACTIONS(1521),
    [anon_sym___vectorcall] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_signed] = ACTIONS(1521),
    [anon_sym_unsigned] = ACTIONS(1521),
    [anon_sym_long] = ACTIONS(1521),
    [anon_sym_short] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1521),
    [anon_sym_auto] = ACTIONS(1521),
    [anon_sym_register] = ACTIONS(1521),
    [anon_sym_inline] = ACTIONS(1521),
    [anon_sym___inline] = ACTIONS(1521),
    [anon_sym___inline__] = ACTIONS(1521),
    [anon_sym___forceinline] = ACTIONS(1521),
    [anon_sym_thread_local] = ACTIONS(1521),
    [anon_sym___thread] = ACTIONS(1521),
    [anon_sym_const] = ACTIONS(1521),
    [anon_sym_constexpr] = ACTIONS(1521),
    [anon_sym_volatile] = ACTIONS(1521),
    [anon_sym_restrict] = ACTIONS(1521),
    [anon_sym___restrict__] = ACTIONS(1521),
    [anon_sym__Atomic] = ACTIONS(1521),
    [anon_sym__Noreturn] = ACTIONS(1521),
    [anon_sym_noreturn] = ACTIONS(1521),
    [sym_primitive_type] = ACTIONS(1521),
    [anon_sym_enum] = ACTIONS(1521),
    [anon_sym_struct] = ACTIONS(1521),
    [anon_sym_union] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_do] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_return] = ACTIONS(1521),
    [anon_sym_break] = ACTIONS(1521),
    [anon_sym_continue] = ACTIONS(1521),
    [anon_sym_goto] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_sizeof] = ACTIONS(1521),
    [anon_sym___alignof__] = ACTIONS(1521),
    [anon_sym___alignof] = ACTIONS(1521),
    [anon_sym__alignof] = ACTIONS(1521),
    [anon_sym_alignof] = ACTIONS(1521),
    [anon_sym__Alignof] = ACTIONS(1521),
    [anon_sym_offsetof] = ACTIONS(1521),
    [anon_sym__Generic] = ACTIONS(1521),
    [anon_sym_asm] = ACTIONS(1521),
    [anon_sym___asm__] = ACTIONS(1521),
    [sym_number_literal] = ACTIONS(1523),
    [anon_sym_L_SQUOTE] = ACTIONS(1523),
    [anon_sym_u_SQUOTE] = ACTIONS(1523),
    [anon_sym_U_SQUOTE] = ACTIONS(1523),
    [anon_sym_u8_SQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_L_DQUOTE] = ACTIONS(1523),
    [anon_sym_u_DQUOTE] = ACTIONS(1523),
    [anon_sym_U_DQUOTE] = ACTIONS(1523),
    [anon_sym_u8_DQUOTE] = ACTIONS(1523),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [anon_sym_NULL] = ACTIONS(1521),
    [anon_sym_nullptr] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1521),
    [anon_sym_until] = ACTIONS(1521),
    [anon_sym_acquire] = ACTIONS(1521),
    [anon_sym_catch] = ACTIONS(1521),
    [anon_sym_monitor] = ACTIONS(1521),
    [anon_sym_start] = ACTIONS(1521),
    [anon_sym_stop] = ACTIONS(1521),
  },
  [261] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [262] = {
    [sym_catch_clause] = STATE(446),
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token2] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_else] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1450),
    [anon_sym_acquire] = ACTIONS(1450),
    [anon_sym_catch] = ACTIONS(1631),
    [anon_sym_monitor] = ACTIONS(1450),
    [anon_sym_start] = ACTIONS(1450),
    [anon_sym_stop] = ACTIONS(1450),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_include_token1] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_LPAREN2] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym___extension__] = ACTIONS(1464),
    [anon_sym_typedef] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym___cdecl] = ACTIONS(1464),
    [anon_sym___clrcall] = ACTIONS(1464),
    [anon_sym___stdcall] = ACTIONS(1464),
    [anon_sym___fastcall] = ACTIONS(1464),
    [anon_sym___thiscall] = ACTIONS(1464),
    [anon_sym___vectorcall] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym___inline] = ACTIONS(1464),
    [anon_sym___inline__] = ACTIONS(1464),
    [anon_sym___forceinline] = ACTIONS(1464),
    [anon_sym_thread_local] = ACTIONS(1464),
    [anon_sym___thread] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_constexpr] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym___restrict__] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym__Noreturn] = ACTIONS(1464),
    [anon_sym_noreturn] = ACTIONS(1464),
    [sym_primitive_type] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_switch] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_goto] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_sizeof] = ACTIONS(1464),
    [anon_sym___alignof__] = ACTIONS(1464),
    [anon_sym___alignof] = ACTIONS(1464),
    [anon_sym__alignof] = ACTIONS(1464),
    [anon_sym_alignof] = ACTIONS(1464),
    [anon_sym__Alignof] = ACTIONS(1464),
    [anon_sym_offsetof] = ACTIONS(1464),
    [anon_sym__Generic] = ACTIONS(1464),
    [anon_sym_asm] = ACTIONS(1464),
    [anon_sym___asm__] = ACTIONS(1464),
    [sym_number_literal] = ACTIONS(1466),
    [anon_sym_L_SQUOTE] = ACTIONS(1466),
    [anon_sym_u_SQUOTE] = ACTIONS(1466),
    [anon_sym_U_SQUOTE] = ACTIONS(1466),
    [anon_sym_u8_SQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_L_DQUOTE] = ACTIONS(1466),
    [anon_sym_u_DQUOTE] = ACTIONS(1466),
    [anon_sym_U_DQUOTE] = ACTIONS(1466),
    [anon_sym_u8_DQUOTE] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [anon_sym_NULL] = ACTIONS(1464),
    [anon_sym_nullptr] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1464),
    [anon_sym_until] = ACTIONS(1464),
    [anon_sym_acquire] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_monitor] = ACTIONS(1464),
    [anon_sym_start] = ACTIONS(1464),
    [anon_sym_stop] = ACTIONS(1464),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1517),
    [aux_sym_preproc_def_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1517),
    [sym_preproc_directive] = ACTIONS(1517),
    [anon_sym_LPAREN2] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1517),
    [anon_sym_typedef] = ACTIONS(1517),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym___attribute__] = ACTIONS(1517),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1519),
    [anon_sym___declspec] = ACTIONS(1517),
    [anon_sym___cdecl] = ACTIONS(1517),
    [anon_sym___clrcall] = ACTIONS(1517),
    [anon_sym___stdcall] = ACTIONS(1517),
    [anon_sym___fastcall] = ACTIONS(1517),
    [anon_sym___thiscall] = ACTIONS(1517),
    [anon_sym___vectorcall] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_signed] = ACTIONS(1517),
    [anon_sym_unsigned] = ACTIONS(1517),
    [anon_sym_long] = ACTIONS(1517),
    [anon_sym_short] = ACTIONS(1517),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_auto] = ACTIONS(1517),
    [anon_sym_register] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1517),
    [anon_sym___inline] = ACTIONS(1517),
    [anon_sym___inline__] = ACTIONS(1517),
    [anon_sym___forceinline] = ACTIONS(1517),
    [anon_sym_thread_local] = ACTIONS(1517),
    [anon_sym___thread] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_constexpr] = ACTIONS(1517),
    [anon_sym_volatile] = ACTIONS(1517),
    [anon_sym_restrict] = ACTIONS(1517),
    [anon_sym___restrict__] = ACTIONS(1517),
    [anon_sym__Atomic] = ACTIONS(1517),
    [anon_sym__Noreturn] = ACTIONS(1517),
    [anon_sym_noreturn] = ACTIONS(1517),
    [sym_primitive_type] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [anon_sym_struct] = ACTIONS(1517),
    [anon_sym_union] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_goto] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1519),
    [anon_sym_sizeof] = ACTIONS(1517),
    [anon_sym___alignof__] = ACTIONS(1517),
    [anon_sym___alignof] = ACTIONS(1517),
    [anon_sym__alignof] = ACTIONS(1517),
    [anon_sym_alignof] = ACTIONS(1517),
    [anon_sym__Alignof] = ACTIONS(1517),
    [anon_sym_offsetof] = ACTIONS(1517),
    [anon_sym__Generic] = ACTIONS(1517),
    [anon_sym_asm] = ACTIONS(1517),
    [anon_sym___asm__] = ACTIONS(1517),
    [sym_number_literal] = ACTIONS(1519),
    [anon_sym_L_SQUOTE] = ACTIONS(1519),
    [anon_sym_u_SQUOTE] = ACTIONS(1519),
    [anon_sym_U_SQUOTE] = ACTIONS(1519),
    [anon_sym_u8_SQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_L_DQUOTE] = ACTIONS(1519),
    [anon_sym_u_DQUOTE] = ACTIONS(1519),
    [anon_sym_U_DQUOTE] = ACTIONS(1519),
    [anon_sym_u8_DQUOTE] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [anon_sym_NULL] = ACTIONS(1517),
    [anon_sym_nullptr] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1517),
    [anon_sym_until] = ACTIONS(1517),
    [anon_sym_acquire] = ACTIONS(1517),
    [anon_sym_catch] = ACTIONS(1517),
    [anon_sym_monitor] = ACTIONS(1517),
    [anon_sym_start] = ACTIONS(1517),
    [anon_sym_stop] = ACTIONS(1517),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(1529),
    [aux_sym_preproc_include_token1] = ACTIONS(1529),
    [aux_sym_preproc_def_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1529),
    [sym_preproc_directive] = ACTIONS(1529),
    [anon_sym_LPAREN2] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1529),
    [anon_sym_typedef] = ACTIONS(1529),
    [anon_sym_extern] = ACTIONS(1529),
    [anon_sym___attribute__] = ACTIONS(1529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1531),
    [anon_sym___declspec] = ACTIONS(1529),
    [anon_sym___cdecl] = ACTIONS(1529),
    [anon_sym___clrcall] = ACTIONS(1529),
    [anon_sym___stdcall] = ACTIONS(1529),
    [anon_sym___fastcall] = ACTIONS(1529),
    [anon_sym___thiscall] = ACTIONS(1529),
    [anon_sym___vectorcall] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_signed] = ACTIONS(1529),
    [anon_sym_unsigned] = ACTIONS(1529),
    [anon_sym_long] = ACTIONS(1529),
    [anon_sym_short] = ACTIONS(1529),
    [anon_sym_static] = ACTIONS(1529),
    [anon_sym_auto] = ACTIONS(1529),
    [anon_sym_register] = ACTIONS(1529),
    [anon_sym_inline] = ACTIONS(1529),
    [anon_sym___inline] = ACTIONS(1529),
    [anon_sym___inline__] = ACTIONS(1529),
    [anon_sym___forceinline] = ACTIONS(1529),
    [anon_sym_thread_local] = ACTIONS(1529),
    [anon_sym___thread] = ACTIONS(1529),
    [anon_sym_const] = ACTIONS(1529),
    [anon_sym_constexpr] = ACTIONS(1529),
    [anon_sym_volatile] = ACTIONS(1529),
    [anon_sym_restrict] = ACTIONS(1529),
    [anon_sym___restrict__] = ACTIONS(1529),
    [anon_sym__Atomic] = ACTIONS(1529),
    [anon_sym__Noreturn] = ACTIONS(1529),
    [anon_sym_noreturn] = ACTIONS(1529),
    [sym_primitive_type] = ACTIONS(1529),
    [anon_sym_enum] = ACTIONS(1529),
    [anon_sym_struct] = ACTIONS(1529),
    [anon_sym_union] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(1529),
    [anon_sym_else] = ACTIONS(1529),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_case] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1529),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1529),
    [anon_sym_return] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(1529),
    [anon_sym_continue] = ACTIONS(1529),
    [anon_sym_goto] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym___alignof__] = ACTIONS(1529),
    [anon_sym___alignof] = ACTIONS(1529),
    [anon_sym__alignof] = ACTIONS(1529),
    [anon_sym_alignof] = ACTIONS(1529),
    [anon_sym__Alignof] = ACTIONS(1529),
    [anon_sym_offsetof] = ACTIONS(1529),
    [anon_sym__Generic] = ACTIONS(1529),
    [anon_sym_asm] = ACTIONS(1529),
    [anon_sym___asm__] = ACTIONS(1529),
    [sym_number_literal] = ACTIONS(1531),
    [anon_sym_L_SQUOTE] = ACTIONS(1531),
    [anon_sym_u_SQUOTE] = ACTIONS(1531),
    [anon_sym_U_SQUOTE] = ACTIONS(1531),
    [anon_sym_u8_SQUOTE] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_L_DQUOTE] = ACTIONS(1531),
    [anon_sym_u_DQUOTE] = ACTIONS(1531),
    [anon_sym_U_DQUOTE] = ACTIONS(1531),
    [anon_sym_u8_DQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [anon_sym_NULL] = ACTIONS(1529),
    [anon_sym_nullptr] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1529),
    [anon_sym_until] = ACTIONS(1529),
    [anon_sym_acquire] = ACTIONS(1529),
    [anon_sym_catch] = ACTIONS(1529),
    [anon_sym_monitor] = ACTIONS(1529),
    [anon_sym_start] = ACTIONS(1529),
    [anon_sym_stop] = ACTIONS(1529),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1460),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(1535),
    [sym_identifier] = ACTIONS(1533),
    [aux_sym_preproc_include_token1] = ACTIONS(1533),
    [aux_sym_preproc_def_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1533),
    [sym_preproc_directive] = ACTIONS(1533),
    [anon_sym_LPAREN2] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1533),
    [anon_sym_typedef] = ACTIONS(1533),
    [anon_sym_extern] = ACTIONS(1533),
    [anon_sym___attribute__] = ACTIONS(1533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1535),
    [anon_sym___declspec] = ACTIONS(1533),
    [anon_sym___cdecl] = ACTIONS(1533),
    [anon_sym___clrcall] = ACTIONS(1533),
    [anon_sym___stdcall] = ACTIONS(1533),
    [anon_sym___fastcall] = ACTIONS(1533),
    [anon_sym___thiscall] = ACTIONS(1533),
    [anon_sym___vectorcall] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_signed] = ACTIONS(1533),
    [anon_sym_unsigned] = ACTIONS(1533),
    [anon_sym_long] = ACTIONS(1533),
    [anon_sym_short] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_auto] = ACTIONS(1533),
    [anon_sym_register] = ACTIONS(1533),
    [anon_sym_inline] = ACTIONS(1533),
    [anon_sym___inline] = ACTIONS(1533),
    [anon_sym___inline__] = ACTIONS(1533),
    [anon_sym___forceinline] = ACTIONS(1533),
    [anon_sym_thread_local] = ACTIONS(1533),
    [anon_sym___thread] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_constexpr] = ACTIONS(1533),
    [anon_sym_volatile] = ACTIONS(1533),
    [anon_sym_restrict] = ACTIONS(1533),
    [anon_sym___restrict__] = ACTIONS(1533),
    [anon_sym__Atomic] = ACTIONS(1533),
    [anon_sym__Noreturn] = ACTIONS(1533),
    [anon_sym_noreturn] = ACTIONS(1533),
    [sym_primitive_type] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [anon_sym_struct] = ACTIONS(1533),
    [anon_sym_union] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_goto] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_sizeof] = ACTIONS(1533),
    [anon_sym___alignof__] = ACTIONS(1533),
    [anon_sym___alignof] = ACTIONS(1533),
    [anon_sym__alignof] = ACTIONS(1533),
    [anon_sym_alignof] = ACTIONS(1533),
    [anon_sym__Alignof] = ACTIONS(1533),
    [anon_sym_offsetof] = ACTIONS(1533),
    [anon_sym__Generic] = ACTIONS(1533),
    [anon_sym_asm] = ACTIONS(1533),
    [anon_sym___asm__] = ACTIONS(1533),
    [sym_number_literal] = ACTIONS(1535),
    [anon_sym_L_SQUOTE] = ACTIONS(1535),
    [anon_sym_u_SQUOTE] = ACTIONS(1535),
    [anon_sym_U_SQUOTE] = ACTIONS(1535),
    [anon_sym_u8_SQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [anon_sym_L_DQUOTE] = ACTIONS(1535),
    [anon_sym_u_DQUOTE] = ACTIONS(1535),
    [anon_sym_U_DQUOTE] = ACTIONS(1535),
    [anon_sym_u8_DQUOTE] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [anon_sym_NULL] = ACTIONS(1533),
    [anon_sym_nullptr] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1533),
    [anon_sym_until] = ACTIONS(1533),
    [anon_sym_acquire] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_monitor] = ACTIONS(1533),
    [anon_sym_start] = ACTIONS(1533),
    [anon_sym_stop] = ACTIONS(1533),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(1527),
    [sym_identifier] = ACTIONS(1525),
    [aux_sym_preproc_include_token1] = ACTIONS(1525),
    [aux_sym_preproc_def_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1525),
    [sym_preproc_directive] = ACTIONS(1525),
    [anon_sym_LPAREN2] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1525),
    [anon_sym_typedef] = ACTIONS(1525),
    [anon_sym_extern] = ACTIONS(1525),
    [anon_sym___attribute__] = ACTIONS(1525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1527),
    [anon_sym___declspec] = ACTIONS(1525),
    [anon_sym___cdecl] = ACTIONS(1525),
    [anon_sym___clrcall] = ACTIONS(1525),
    [anon_sym___stdcall] = ACTIONS(1525),
    [anon_sym___fastcall] = ACTIONS(1525),
    [anon_sym___thiscall] = ACTIONS(1525),
    [anon_sym___vectorcall] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_signed] = ACTIONS(1525),
    [anon_sym_unsigned] = ACTIONS(1525),
    [anon_sym_long] = ACTIONS(1525),
    [anon_sym_short] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1525),
    [anon_sym_auto] = ACTIONS(1525),
    [anon_sym_register] = ACTIONS(1525),
    [anon_sym_inline] = ACTIONS(1525),
    [anon_sym___inline] = ACTIONS(1525),
    [anon_sym___inline__] = ACTIONS(1525),
    [anon_sym___forceinline] = ACTIONS(1525),
    [anon_sym_thread_local] = ACTIONS(1525),
    [anon_sym___thread] = ACTIONS(1525),
    [anon_sym_const] = ACTIONS(1525),
    [anon_sym_constexpr] = ACTIONS(1525),
    [anon_sym_volatile] = ACTIONS(1525),
    [anon_sym_restrict] = ACTIONS(1525),
    [anon_sym___restrict__] = ACTIONS(1525),
    [anon_sym__Atomic] = ACTIONS(1525),
    [anon_sym__Noreturn] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [sym_primitive_type] = ACTIONS(1525),
    [anon_sym_enum] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1525),
    [anon_sym_union] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_do] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_return] = ACTIONS(1525),
    [anon_sym_break] = ACTIONS(1525),
    [anon_sym_continue] = ACTIONS(1525),
    [anon_sym_goto] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_sizeof] = ACTIONS(1525),
    [anon_sym___alignof__] = ACTIONS(1525),
    [anon_sym___alignof] = ACTIONS(1525),
    [anon_sym__alignof] = ACTIONS(1525),
    [anon_sym_alignof] = ACTIONS(1525),
    [anon_sym__Alignof] = ACTIONS(1525),
    [anon_sym_offsetof] = ACTIONS(1525),
    [anon_sym__Generic] = ACTIONS(1525),
    [anon_sym_asm] = ACTIONS(1525),
    [anon_sym___asm__] = ACTIONS(1525),
    [sym_number_literal] = ACTIONS(1527),
    [anon_sym_L_SQUOTE] = ACTIONS(1527),
    [anon_sym_u_SQUOTE] = ACTIONS(1527),
    [anon_sym_U_SQUOTE] = ACTIONS(1527),
    [anon_sym_u8_SQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [anon_sym_L_DQUOTE] = ACTIONS(1527),
    [anon_sym_u_DQUOTE] = ACTIONS(1527),
    [anon_sym_U_DQUOTE] = ACTIONS(1527),
    [anon_sym_u8_DQUOTE] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [anon_sym_NULL] = ACTIONS(1525),
    [anon_sym_nullptr] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1525),
    [anon_sym_until] = ACTIONS(1525),
    [anon_sym_acquire] = ACTIONS(1525),
    [anon_sym_catch] = ACTIONS(1525),
    [anon_sym_monitor] = ACTIONS(1525),
    [anon_sym_start] = ACTIONS(1525),
    [anon_sym_stop] = ACTIONS(1525),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(1508),
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1506),
    [anon_sym_until] = ACTIONS(1506),
    [anon_sym_acquire] = ACTIONS(1506),
    [anon_sym_catch] = ACTIONS(1506),
    [anon_sym_monitor] = ACTIONS(1506),
    [anon_sym_start] = ACTIONS(1506),
    [anon_sym_stop] = ACTIONS(1506),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1571),
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1569),
    [aux_sym_preproc_def_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1569),
    [sym_preproc_directive] = ACTIONS(1569),
    [anon_sym_LPAREN2] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(1569),
    [anon_sym_typedef] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym___attribute__] = ACTIONS(1569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1571),
    [anon_sym___declspec] = ACTIONS(1569),
    [anon_sym___cdecl] = ACTIONS(1569),
    [anon_sym___clrcall] = ACTIONS(1569),
    [anon_sym___stdcall] = ACTIONS(1569),
    [anon_sym___fastcall] = ACTIONS(1569),
    [anon_sym___thiscall] = ACTIONS(1569),
    [anon_sym___vectorcall] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_signed] = ACTIONS(1569),
    [anon_sym_unsigned] = ACTIONS(1569),
    [anon_sym_long] = ACTIONS(1569),
    [anon_sym_short] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_auto] = ACTIONS(1569),
    [anon_sym_register] = ACTIONS(1569),
    [anon_sym_inline] = ACTIONS(1569),
    [anon_sym___inline] = ACTIONS(1569),
    [anon_sym___inline__] = ACTIONS(1569),
    [anon_sym___forceinline] = ACTIONS(1569),
    [anon_sym_thread_local] = ACTIONS(1569),
    [anon_sym___thread] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_constexpr] = ACTIONS(1569),
    [anon_sym_volatile] = ACTIONS(1569),
    [anon_sym_restrict] = ACTIONS(1569),
    [anon_sym___restrict__] = ACTIONS(1569),
    [anon_sym__Atomic] = ACTIONS(1569),
    [anon_sym__Noreturn] = ACTIONS(1569),
    [anon_sym_noreturn] = ACTIONS(1569),
    [sym_primitive_type] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_goto] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_sizeof] = ACTIONS(1569),
    [anon_sym___alignof__] = ACTIONS(1569),
    [anon_sym___alignof] = ACTIONS(1569),
    [anon_sym__alignof] = ACTIONS(1569),
    [anon_sym_alignof] = ACTIONS(1569),
    [anon_sym__Alignof] = ACTIONS(1569),
    [anon_sym_offsetof] = ACTIONS(1569),
    [anon_sym__Generic] = ACTIONS(1569),
    [anon_sym_asm] = ACTIONS(1569),
    [anon_sym___asm__] = ACTIONS(1569),
    [sym_number_literal] = ACTIONS(1571),
    [anon_sym_L_SQUOTE] = ACTIONS(1571),
    [anon_sym_u_SQUOTE] = ACTIONS(1571),
    [anon_sym_U_SQUOTE] = ACTIONS(1571),
    [anon_sym_u8_SQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [anon_sym_L_DQUOTE] = ACTIONS(1571),
    [anon_sym_u_DQUOTE] = ACTIONS(1571),
    [anon_sym_U_DQUOTE] = ACTIONS(1571),
    [anon_sym_u8_DQUOTE] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [anon_sym_NULL] = ACTIONS(1569),
    [anon_sym_nullptr] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1569),
    [anon_sym_until] = ACTIONS(1569),
    [anon_sym_acquire] = ACTIONS(1569),
    [anon_sym_catch] = ACTIONS(1569),
    [anon_sym_monitor] = ACTIONS(1569),
    [anon_sym_start] = ACTIONS(1569),
    [anon_sym_stop] = ACTIONS(1569),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1567),
    [sym_identifier] = ACTIONS(1565),
    [aux_sym_preproc_include_token1] = ACTIONS(1565),
    [aux_sym_preproc_def_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [sym_preproc_directive] = ACTIONS(1565),
    [anon_sym_LPAREN2] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1565),
    [anon_sym_typedef] = ACTIONS(1565),
    [anon_sym_extern] = ACTIONS(1565),
    [anon_sym___attribute__] = ACTIONS(1565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1567),
    [anon_sym___declspec] = ACTIONS(1565),
    [anon_sym___cdecl] = ACTIONS(1565),
    [anon_sym___clrcall] = ACTIONS(1565),
    [anon_sym___stdcall] = ACTIONS(1565),
    [anon_sym___fastcall] = ACTIONS(1565),
    [anon_sym___thiscall] = ACTIONS(1565),
    [anon_sym___vectorcall] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_signed] = ACTIONS(1565),
    [anon_sym_unsigned] = ACTIONS(1565),
    [anon_sym_long] = ACTIONS(1565),
    [anon_sym_short] = ACTIONS(1565),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_auto] = ACTIONS(1565),
    [anon_sym_register] = ACTIONS(1565),
    [anon_sym_inline] = ACTIONS(1565),
    [anon_sym___inline] = ACTIONS(1565),
    [anon_sym___inline__] = ACTIONS(1565),
    [anon_sym___forceinline] = ACTIONS(1565),
    [anon_sym_thread_local] = ACTIONS(1565),
    [anon_sym___thread] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_constexpr] = ACTIONS(1565),
    [anon_sym_volatile] = ACTIONS(1565),
    [anon_sym_restrict] = ACTIONS(1565),
    [anon_sym___restrict__] = ACTIONS(1565),
    [anon_sym__Atomic] = ACTIONS(1565),
    [anon_sym__Noreturn] = ACTIONS(1565),
    [anon_sym_noreturn] = ACTIONS(1565),
    [sym_primitive_type] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [anon_sym_struct] = ACTIONS(1565),
    [anon_sym_union] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_goto] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_sizeof] = ACTIONS(1565),
    [anon_sym___alignof__] = ACTIONS(1565),
    [anon_sym___alignof] = ACTIONS(1565),
    [anon_sym__alignof] = ACTIONS(1565),
    [anon_sym_alignof] = ACTIONS(1565),
    [anon_sym__Alignof] = ACTIONS(1565),
    [anon_sym_offsetof] = ACTIONS(1565),
    [anon_sym__Generic] = ACTIONS(1565),
    [anon_sym_asm] = ACTIONS(1565),
    [anon_sym___asm__] = ACTIONS(1565),
    [sym_number_literal] = ACTIONS(1567),
    [anon_sym_L_SQUOTE] = ACTIONS(1567),
    [anon_sym_u_SQUOTE] = ACTIONS(1567),
    [anon_sym_U_SQUOTE] = ACTIONS(1567),
    [anon_sym_u8_SQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [anon_sym_L_DQUOTE] = ACTIONS(1567),
    [anon_sym_u_DQUOTE] = ACTIONS(1567),
    [anon_sym_U_DQUOTE] = ACTIONS(1567),
    [anon_sym_u8_DQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [anon_sym_NULL] = ACTIONS(1565),
    [anon_sym_nullptr] = ACTIONS(1565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1565),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_acquire] = ACTIONS(1565),
    [anon_sym_catch] = ACTIONS(1565),
    [anon_sym_monitor] = ACTIONS(1565),
    [anon_sym_start] = ACTIONS(1565),
    [anon_sym_stop] = ACTIONS(1565),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_include_token1] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_LPAREN2] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym___extension__] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym___cdecl] = ACTIONS(1476),
    [anon_sym___clrcall] = ACTIONS(1476),
    [anon_sym___stdcall] = ACTIONS(1476),
    [anon_sym___fastcall] = ACTIONS(1476),
    [anon_sym___thiscall] = ACTIONS(1476),
    [anon_sym___vectorcall] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym___inline] = ACTIONS(1476),
    [anon_sym___inline__] = ACTIONS(1476),
    [anon_sym___forceinline] = ACTIONS(1476),
    [anon_sym_thread_local] = ACTIONS(1476),
    [anon_sym___thread] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_constexpr] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym___restrict__] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym__Noreturn] = ACTIONS(1476),
    [anon_sym_noreturn] = ACTIONS(1476),
    [sym_primitive_type] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_switch] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_default] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_do] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_goto] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_sizeof] = ACTIONS(1476),
    [anon_sym___alignof__] = ACTIONS(1476),
    [anon_sym___alignof] = ACTIONS(1476),
    [anon_sym__alignof] = ACTIONS(1476),
    [anon_sym_alignof] = ACTIONS(1476),
    [anon_sym__Alignof] = ACTIONS(1476),
    [anon_sym_offsetof] = ACTIONS(1476),
    [anon_sym__Generic] = ACTIONS(1476),
    [anon_sym_asm] = ACTIONS(1476),
    [anon_sym___asm__] = ACTIONS(1476),
    [sym_number_literal] = ACTIONS(1478),
    [anon_sym_L_SQUOTE] = ACTIONS(1478),
    [anon_sym_u_SQUOTE] = ACTIONS(1478),
    [anon_sym_U_SQUOTE] = ACTIONS(1478),
    [anon_sym_u8_SQUOTE] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_L_DQUOTE] = ACTIONS(1478),
    [anon_sym_u_DQUOTE] = ACTIONS(1478),
    [anon_sym_U_DQUOTE] = ACTIONS(1478),
    [anon_sym_u8_DQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [anon_sym_NULL] = ACTIONS(1476),
    [anon_sym_nullptr] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1476),
    [anon_sym_until] = ACTIONS(1476),
    [anon_sym_acquire] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_monitor] = ACTIONS(1476),
    [anon_sym_start] = ACTIONS(1476),
    [anon_sym_stop] = ACTIONS(1476),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1498),
    [sym_identifier] = ACTIONS(1496),
    [aux_sym_preproc_include_token1] = ACTIONS(1496),
    [aux_sym_preproc_def_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1496),
    [sym_preproc_directive] = ACTIONS(1496),
    [anon_sym_LPAREN2] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym___extension__] = ACTIONS(1496),
    [anon_sym_typedef] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym___attribute__] = ACTIONS(1496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1498),
    [anon_sym___declspec] = ACTIONS(1496),
    [anon_sym___cdecl] = ACTIONS(1496),
    [anon_sym___clrcall] = ACTIONS(1496),
    [anon_sym___stdcall] = ACTIONS(1496),
    [anon_sym___fastcall] = ACTIONS(1496),
    [anon_sym___thiscall] = ACTIONS(1496),
    [anon_sym___vectorcall] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_signed] = ACTIONS(1496),
    [anon_sym_unsigned] = ACTIONS(1496),
    [anon_sym_long] = ACTIONS(1496),
    [anon_sym_short] = ACTIONS(1496),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_auto] = ACTIONS(1496),
    [anon_sym_register] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym___inline] = ACTIONS(1496),
    [anon_sym___inline__] = ACTIONS(1496),
    [anon_sym___forceinline] = ACTIONS(1496),
    [anon_sym_thread_local] = ACTIONS(1496),
    [anon_sym___thread] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_constexpr] = ACTIONS(1496),
    [anon_sym_volatile] = ACTIONS(1496),
    [anon_sym_restrict] = ACTIONS(1496),
    [anon_sym___restrict__] = ACTIONS(1496),
    [anon_sym__Atomic] = ACTIONS(1496),
    [anon_sym__Noreturn] = ACTIONS(1496),
    [anon_sym_noreturn] = ACTIONS(1496),
    [sym_primitive_type] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_struct] = ACTIONS(1496),
    [anon_sym_union] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_goto] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_sizeof] = ACTIONS(1496),
    [anon_sym___alignof__] = ACTIONS(1496),
    [anon_sym___alignof] = ACTIONS(1496),
    [anon_sym__alignof] = ACTIONS(1496),
    [anon_sym_alignof] = ACTIONS(1496),
    [anon_sym__Alignof] = ACTIONS(1496),
    [anon_sym_offsetof] = ACTIONS(1496),
    [anon_sym__Generic] = ACTIONS(1496),
    [anon_sym_asm] = ACTIONS(1496),
    [anon_sym___asm__] = ACTIONS(1496),
    [sym_number_literal] = ACTIONS(1498),
    [anon_sym_L_SQUOTE] = ACTIONS(1498),
    [anon_sym_u_SQUOTE] = ACTIONS(1498),
    [anon_sym_U_SQUOTE] = ACTIONS(1498),
    [anon_sym_u8_SQUOTE] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_L_DQUOTE] = ACTIONS(1498),
    [anon_sym_u_DQUOTE] = ACTIONS(1498),
    [anon_sym_U_DQUOTE] = ACTIONS(1498),
    [anon_sym_u8_DQUOTE] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [anon_sym_NULL] = ACTIONS(1496),
    [anon_sym_nullptr] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1496),
    [anon_sym_until] = ACTIONS(1496),
    [anon_sym_acquire] = ACTIONS(1496),
    [anon_sym_catch] = ACTIONS(1496),
    [anon_sym_monitor] = ACTIONS(1496),
    [anon_sym_start] = ACTIONS(1496),
    [anon_sym_stop] = ACTIONS(1496),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1537),
    [aux_sym_preproc_include_token1] = ACTIONS(1537),
    [aux_sym_preproc_def_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1537),
    [sym_preproc_directive] = ACTIONS(1537),
    [anon_sym_LPAREN2] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym___extension__] = ACTIONS(1537),
    [anon_sym_typedef] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(1537),
    [anon_sym___attribute__] = ACTIONS(1537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1539),
    [anon_sym___declspec] = ACTIONS(1537),
    [anon_sym___cdecl] = ACTIONS(1537),
    [anon_sym___clrcall] = ACTIONS(1537),
    [anon_sym___stdcall] = ACTIONS(1537),
    [anon_sym___fastcall] = ACTIONS(1537),
    [anon_sym___thiscall] = ACTIONS(1537),
    [anon_sym___vectorcall] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_signed] = ACTIONS(1537),
    [anon_sym_unsigned] = ACTIONS(1537),
    [anon_sym_long] = ACTIONS(1537),
    [anon_sym_short] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_auto] = ACTIONS(1537),
    [anon_sym_register] = ACTIONS(1537),
    [anon_sym_inline] = ACTIONS(1537),
    [anon_sym___inline] = ACTIONS(1537),
    [anon_sym___inline__] = ACTIONS(1537),
    [anon_sym___forceinline] = ACTIONS(1537),
    [anon_sym_thread_local] = ACTIONS(1537),
    [anon_sym___thread] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_constexpr] = ACTIONS(1537),
    [anon_sym_volatile] = ACTIONS(1537),
    [anon_sym_restrict] = ACTIONS(1537),
    [anon_sym___restrict__] = ACTIONS(1537),
    [anon_sym__Atomic] = ACTIONS(1537),
    [anon_sym__Noreturn] = ACTIONS(1537),
    [anon_sym_noreturn] = ACTIONS(1537),
    [sym_primitive_type] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [anon_sym_struct] = ACTIONS(1537),
    [anon_sym_union] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_goto] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_sizeof] = ACTIONS(1537),
    [anon_sym___alignof__] = ACTIONS(1537),
    [anon_sym___alignof] = ACTIONS(1537),
    [anon_sym__alignof] = ACTIONS(1537),
    [anon_sym_alignof] = ACTIONS(1537),
    [anon_sym__Alignof] = ACTIONS(1537),
    [anon_sym_offsetof] = ACTIONS(1537),
    [anon_sym__Generic] = ACTIONS(1537),
    [anon_sym_asm] = ACTIONS(1537),
    [anon_sym___asm__] = ACTIONS(1537),
    [sym_number_literal] = ACTIONS(1539),
    [anon_sym_L_SQUOTE] = ACTIONS(1539),
    [anon_sym_u_SQUOTE] = ACTIONS(1539),
    [anon_sym_U_SQUOTE] = ACTIONS(1539),
    [anon_sym_u8_SQUOTE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [anon_sym_L_DQUOTE] = ACTIONS(1539),
    [anon_sym_u_DQUOTE] = ACTIONS(1539),
    [anon_sym_U_DQUOTE] = ACTIONS(1539),
    [anon_sym_u8_DQUOTE] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1539),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [anon_sym_NULL] = ACTIONS(1537),
    [anon_sym_nullptr] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1537),
    [anon_sym_until] = ACTIONS(1537),
    [anon_sym_acquire] = ACTIONS(1537),
    [anon_sym_catch] = ACTIONS(1537),
    [anon_sym_monitor] = ACTIONS(1537),
    [anon_sym_start] = ACTIONS(1537),
    [anon_sym_stop] = ACTIONS(1537),
  },
  [279] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(208),
    [sym_attributed_statement] = STATE(164),
    [sym_labeled_statement] = STATE(202),
    [sym_expression_statement] = STATE(196),
    [sym_if_statement] = STATE(195),
    [sym_switch_statement] = STATE(173),
    [sym_case_statement] = STATE(162),
    [sym_while_statement] = STATE(161),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(159),
    [sym_return_statement] = STATE(158),
    [sym_break_statement] = STATE(157),
    [sym_continue_statement] = STATE(154),
    [sym_goto_statement] = STATE(153),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(213),
    [sym_acquire_statement] = STATE(201),
    [sym_monitor_statement] = STATE(203),
    [sym_start_statement] = STATE(217),
    [sym_stop_statement] = STATE(219),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1537),
    [aux_sym_preproc_include_token1] = ACTIONS(1537),
    [aux_sym_preproc_def_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token2] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1537),
    [sym_preproc_directive] = ACTIONS(1537),
    [anon_sym_LPAREN2] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym___extension__] = ACTIONS(1537),
    [anon_sym_typedef] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(1537),
    [anon_sym___attribute__] = ACTIONS(1537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1539),
    [anon_sym___declspec] = ACTIONS(1537),
    [anon_sym___cdecl] = ACTIONS(1537),
    [anon_sym___clrcall] = ACTIONS(1537),
    [anon_sym___stdcall] = ACTIONS(1537),
    [anon_sym___fastcall] = ACTIONS(1537),
    [anon_sym___thiscall] = ACTIONS(1537),
    [anon_sym___vectorcall] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_signed] = ACTIONS(1537),
    [anon_sym_unsigned] = ACTIONS(1537),
    [anon_sym_long] = ACTIONS(1537),
    [anon_sym_short] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_auto] = ACTIONS(1537),
    [anon_sym_register] = ACTIONS(1537),
    [anon_sym_inline] = ACTIONS(1537),
    [anon_sym___inline] = ACTIONS(1537),
    [anon_sym___inline__] = ACTIONS(1537),
    [anon_sym___forceinline] = ACTIONS(1537),
    [anon_sym_thread_local] = ACTIONS(1537),
    [anon_sym___thread] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_constexpr] = ACTIONS(1537),
    [anon_sym_volatile] = ACTIONS(1537),
    [anon_sym_restrict] = ACTIONS(1537),
    [anon_sym___restrict__] = ACTIONS(1537),
    [anon_sym__Atomic] = ACTIONS(1537),
    [anon_sym__Noreturn] = ACTIONS(1537),
    [anon_sym_noreturn] = ACTIONS(1537),
    [sym_primitive_type] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [anon_sym_struct] = ACTIONS(1537),
    [anon_sym_union] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_goto] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_sizeof] = ACTIONS(1537),
    [anon_sym___alignof__] = ACTIONS(1537),
    [anon_sym___alignof] = ACTIONS(1537),
    [anon_sym__alignof] = ACTIONS(1537),
    [anon_sym_alignof] = ACTIONS(1537),
    [anon_sym__Alignof] = ACTIONS(1537),
    [anon_sym_offsetof] = ACTIONS(1537),
    [anon_sym__Generic] = ACTIONS(1537),
    [anon_sym_asm] = ACTIONS(1537),
    [anon_sym___asm__] = ACTIONS(1537),
    [sym_number_literal] = ACTIONS(1539),
    [anon_sym_L_SQUOTE] = ACTIONS(1539),
    [anon_sym_u_SQUOTE] = ACTIONS(1539),
    [anon_sym_U_SQUOTE] = ACTIONS(1539),
    [anon_sym_u8_SQUOTE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [anon_sym_L_DQUOTE] = ACTIONS(1539),
    [anon_sym_u_DQUOTE] = ACTIONS(1539),
    [anon_sym_U_DQUOTE] = ACTIONS(1539),
    [anon_sym_u8_DQUOTE] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1539),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [anon_sym_NULL] = ACTIONS(1537),
    [anon_sym_nullptr] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1537),
    [anon_sym_acquire] = ACTIONS(1537),
    [anon_sym_catch] = ACTIONS(1537),
    [anon_sym_monitor] = ACTIONS(1537),
    [anon_sym_start] = ACTIONS(1537),
    [anon_sym_stop] = ACTIONS(1537),
  },
  [281] = {
    [sym_identifier] = ACTIONS(1549),
    [aux_sym_preproc_include_token1] = ACTIONS(1549),
    [aux_sym_preproc_def_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token2] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1549),
    [sym_preproc_directive] = ACTIONS(1549),
    [anon_sym_LPAREN2] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym___extension__] = ACTIONS(1549),
    [anon_sym_typedef] = ACTIONS(1549),
    [anon_sym_extern] = ACTIONS(1549),
    [anon_sym___attribute__] = ACTIONS(1549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1551),
    [anon_sym___declspec] = ACTIONS(1549),
    [anon_sym___cdecl] = ACTIONS(1549),
    [anon_sym___clrcall] = ACTIONS(1549),
    [anon_sym___stdcall] = ACTIONS(1549),
    [anon_sym___fastcall] = ACTIONS(1549),
    [anon_sym___thiscall] = ACTIONS(1549),
    [anon_sym___vectorcall] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_signed] = ACTIONS(1549),
    [anon_sym_unsigned] = ACTIONS(1549),
    [anon_sym_long] = ACTIONS(1549),
    [anon_sym_short] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_auto] = ACTIONS(1549),
    [anon_sym_register] = ACTIONS(1549),
    [anon_sym_inline] = ACTIONS(1549),
    [anon_sym___inline] = ACTIONS(1549),
    [anon_sym___inline__] = ACTIONS(1549),
    [anon_sym___forceinline] = ACTIONS(1549),
    [anon_sym_thread_local] = ACTIONS(1549),
    [anon_sym___thread] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_constexpr] = ACTIONS(1549),
    [anon_sym_volatile] = ACTIONS(1549),
    [anon_sym_restrict] = ACTIONS(1549),
    [anon_sym___restrict__] = ACTIONS(1549),
    [anon_sym__Atomic] = ACTIONS(1549),
    [anon_sym__Noreturn] = ACTIONS(1549),
    [anon_sym_noreturn] = ACTIONS(1549),
    [sym_primitive_type] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [anon_sym_struct] = ACTIONS(1549),
    [anon_sym_union] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_goto] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1549),
    [anon_sym___alignof__] = ACTIONS(1549),
    [anon_sym___alignof] = ACTIONS(1549),
    [anon_sym__alignof] = ACTIONS(1549),
    [anon_sym_alignof] = ACTIONS(1549),
    [anon_sym__Alignof] = ACTIONS(1549),
    [anon_sym_offsetof] = ACTIONS(1549),
    [anon_sym__Generic] = ACTIONS(1549),
    [anon_sym_asm] = ACTIONS(1549),
    [anon_sym___asm__] = ACTIONS(1549),
    [sym_number_literal] = ACTIONS(1551),
    [anon_sym_L_SQUOTE] = ACTIONS(1551),
    [anon_sym_u_SQUOTE] = ACTIONS(1551),
    [anon_sym_U_SQUOTE] = ACTIONS(1551),
    [anon_sym_u8_SQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_L_DQUOTE] = ACTIONS(1551),
    [anon_sym_u_DQUOTE] = ACTIONS(1551),
    [anon_sym_U_DQUOTE] = ACTIONS(1551),
    [anon_sym_u8_DQUOTE] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [anon_sym_NULL] = ACTIONS(1549),
    [anon_sym_nullptr] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_acquire] = ACTIONS(1549),
    [anon_sym_catch] = ACTIONS(1549),
    [anon_sym_monitor] = ACTIONS(1549),
    [anon_sym_start] = ACTIONS(1549),
    [anon_sym_stop] = ACTIONS(1549),
  },
  [282] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [283] = {
    [sym_attribute_declaration] = STATE(392),
    [sym_compound_statement] = STATE(165),
    [sym_attributed_statement] = STATE(165),
    [sym_labeled_statement] = STATE(165),
    [sym_expression_statement] = STATE(165),
    [sym_if_statement] = STATE(165),
    [sym_switch_statement] = STATE(165),
    [sym_case_statement] = STATE(165),
    [sym_while_statement] = STATE(165),
    [sym_do_statement] = STATE(165),
    [sym_for_statement] = STATE(165),
    [sym_return_statement] = STATE(165),
    [sym_break_statement] = STATE(165),
    [sym_continue_statement] = STATE(165),
    [sym_goto_statement] = STATE(165),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(165),
    [sym_acquire_statement] = STATE(165),
    [sym_monitor_statement] = STATE(165),
    [sym_start_statement] = STATE(165),
    [sym_stop_statement] = STATE(165),
    [aux_sym_attributed_declarator_repeat1] = STATE(392),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [284] = {
    [sym_attribute_declaration] = STATE(379),
    [sym_compound_statement] = STATE(268),
    [sym_attributed_statement] = STATE(268),
    [sym_labeled_statement] = STATE(268),
    [sym_expression_statement] = STATE(268),
    [sym_if_statement] = STATE(268),
    [sym_switch_statement] = STATE(268),
    [sym_case_statement] = STATE(268),
    [sym_while_statement] = STATE(268),
    [sym_do_statement] = STATE(268),
    [sym_for_statement] = STATE(268),
    [sym_return_statement] = STATE(268),
    [sym_break_statement] = STATE(268),
    [sym_continue_statement] = STATE(268),
    [sym_goto_statement] = STATE(268),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(268),
    [sym_acquire_statement] = STATE(268),
    [sym_monitor_statement] = STATE(268),
    [sym_start_statement] = STATE(268),
    [sym_stop_statement] = STATE(268),
    [aux_sym_attributed_declarator_repeat1] = STATE(379),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1517),
    [aux_sym_preproc_def_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token2] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1517),
    [sym_preproc_directive] = ACTIONS(1517),
    [anon_sym_LPAREN2] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1517),
    [anon_sym_typedef] = ACTIONS(1517),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym___attribute__] = ACTIONS(1517),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1519),
    [anon_sym___declspec] = ACTIONS(1517),
    [anon_sym___cdecl] = ACTIONS(1517),
    [anon_sym___clrcall] = ACTIONS(1517),
    [anon_sym___stdcall] = ACTIONS(1517),
    [anon_sym___fastcall] = ACTIONS(1517),
    [anon_sym___thiscall] = ACTIONS(1517),
    [anon_sym___vectorcall] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_signed] = ACTIONS(1517),
    [anon_sym_unsigned] = ACTIONS(1517),
    [anon_sym_long] = ACTIONS(1517),
    [anon_sym_short] = ACTIONS(1517),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_auto] = ACTIONS(1517),
    [anon_sym_register] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1517),
    [anon_sym___inline] = ACTIONS(1517),
    [anon_sym___inline__] = ACTIONS(1517),
    [anon_sym___forceinline] = ACTIONS(1517),
    [anon_sym_thread_local] = ACTIONS(1517),
    [anon_sym___thread] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_constexpr] = ACTIONS(1517),
    [anon_sym_volatile] = ACTIONS(1517),
    [anon_sym_restrict] = ACTIONS(1517),
    [anon_sym___restrict__] = ACTIONS(1517),
    [anon_sym__Atomic] = ACTIONS(1517),
    [anon_sym__Noreturn] = ACTIONS(1517),
    [anon_sym_noreturn] = ACTIONS(1517),
    [sym_primitive_type] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [anon_sym_struct] = ACTIONS(1517),
    [anon_sym_union] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_goto] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1519),
    [anon_sym_sizeof] = ACTIONS(1517),
    [anon_sym___alignof__] = ACTIONS(1517),
    [anon_sym___alignof] = ACTIONS(1517),
    [anon_sym__alignof] = ACTIONS(1517),
    [anon_sym_alignof] = ACTIONS(1517),
    [anon_sym__Alignof] = ACTIONS(1517),
    [anon_sym_offsetof] = ACTIONS(1517),
    [anon_sym__Generic] = ACTIONS(1517),
    [anon_sym_asm] = ACTIONS(1517),
    [anon_sym___asm__] = ACTIONS(1517),
    [sym_number_literal] = ACTIONS(1519),
    [anon_sym_L_SQUOTE] = ACTIONS(1519),
    [anon_sym_u_SQUOTE] = ACTIONS(1519),
    [anon_sym_U_SQUOTE] = ACTIONS(1519),
    [anon_sym_u8_SQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_L_DQUOTE] = ACTIONS(1519),
    [anon_sym_u_DQUOTE] = ACTIONS(1519),
    [anon_sym_U_DQUOTE] = ACTIONS(1519),
    [anon_sym_u8_DQUOTE] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [anon_sym_NULL] = ACTIONS(1517),
    [anon_sym_nullptr] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1517),
    [anon_sym_acquire] = ACTIONS(1517),
    [anon_sym_catch] = ACTIONS(1517),
    [anon_sym_monitor] = ACTIONS(1517),
    [anon_sym_start] = ACTIONS(1517),
    [anon_sym_stop] = ACTIONS(1517),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_include_token1] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token2] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1557),
    [sym_preproc_directive] = ACTIONS(1557),
    [anon_sym_LPAREN2] = ACTIONS(1559),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym___extension__] = ACTIONS(1557),
    [anon_sym_typedef] = ACTIONS(1557),
    [anon_sym_extern] = ACTIONS(1557),
    [anon_sym___attribute__] = ACTIONS(1557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1559),
    [anon_sym___declspec] = ACTIONS(1557),
    [anon_sym___cdecl] = ACTIONS(1557),
    [anon_sym___clrcall] = ACTIONS(1557),
    [anon_sym___stdcall] = ACTIONS(1557),
    [anon_sym___fastcall] = ACTIONS(1557),
    [anon_sym___thiscall] = ACTIONS(1557),
    [anon_sym___vectorcall] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_signed] = ACTIONS(1557),
    [anon_sym_unsigned] = ACTIONS(1557),
    [anon_sym_long] = ACTIONS(1557),
    [anon_sym_short] = ACTIONS(1557),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_auto] = ACTIONS(1557),
    [anon_sym_register] = ACTIONS(1557),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym___inline] = ACTIONS(1557),
    [anon_sym___inline__] = ACTIONS(1557),
    [anon_sym___forceinline] = ACTIONS(1557),
    [anon_sym_thread_local] = ACTIONS(1557),
    [anon_sym___thread] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_constexpr] = ACTIONS(1557),
    [anon_sym_volatile] = ACTIONS(1557),
    [anon_sym_restrict] = ACTIONS(1557),
    [anon_sym___restrict__] = ACTIONS(1557),
    [anon_sym__Atomic] = ACTIONS(1557),
    [anon_sym__Noreturn] = ACTIONS(1557),
    [anon_sym_noreturn] = ACTIONS(1557),
    [sym_primitive_type] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [anon_sym_struct] = ACTIONS(1557),
    [anon_sym_union] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_goto] = ACTIONS(1557),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_sizeof] = ACTIONS(1557),
    [anon_sym___alignof__] = ACTIONS(1557),
    [anon_sym___alignof] = ACTIONS(1557),
    [anon_sym__alignof] = ACTIONS(1557),
    [anon_sym_alignof] = ACTIONS(1557),
    [anon_sym__Alignof] = ACTIONS(1557),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1557),
    [anon_sym_asm] = ACTIONS(1557),
    [anon_sym___asm__] = ACTIONS(1557),
    [sym_number_literal] = ACTIONS(1559),
    [anon_sym_L_SQUOTE] = ACTIONS(1559),
    [anon_sym_u_SQUOTE] = ACTIONS(1559),
    [anon_sym_U_SQUOTE] = ACTIONS(1559),
    [anon_sym_u8_SQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [anon_sym_L_DQUOTE] = ACTIONS(1559),
    [anon_sym_u_DQUOTE] = ACTIONS(1559),
    [anon_sym_U_DQUOTE] = ACTIONS(1559),
    [anon_sym_u8_DQUOTE] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [anon_sym_NULL] = ACTIONS(1557),
    [anon_sym_nullptr] = ACTIONS(1557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_acquire] = ACTIONS(1557),
    [anon_sym_catch] = ACTIONS(1557),
    [anon_sym_monitor] = ACTIONS(1557),
    [anon_sym_start] = ACTIONS(1557),
    [anon_sym_stop] = ACTIONS(1557),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [289] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(1946),
    [sym_attributed_statement] = STATE(1946),
    [sym_labeled_statement] = STATE(1946),
    [sym_expression_statement] = STATE(1946),
    [sym_if_statement] = STATE(1946),
    [sym_switch_statement] = STATE(1946),
    [sym_case_statement] = STATE(1946),
    [sym_while_statement] = STATE(1946),
    [sym_do_statement] = STATE(1946),
    [sym_for_statement] = STATE(1946),
    [sym_return_statement] = STATE(1946),
    [sym_break_statement] = STATE(1946),
    [sym_continue_statement] = STATE(1946),
    [sym_goto_statement] = STATE(1946),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(1946),
    [sym_acquire_statement] = STATE(1946),
    [sym_monitor_statement] = STATE(1946),
    [sym_start_statement] = STATE(1946),
    [sym_stop_statement] = STATE(1946),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_include_token1] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_LPAREN2] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym___cdecl] = ACTIONS(1468),
    [anon_sym___clrcall] = ACTIONS(1468),
    [anon_sym___stdcall] = ACTIONS(1468),
    [anon_sym___fastcall] = ACTIONS(1468),
    [anon_sym___thiscall] = ACTIONS(1468),
    [anon_sym___vectorcall] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym___inline] = ACTIONS(1468),
    [anon_sym___inline__] = ACTIONS(1468),
    [anon_sym___forceinline] = ACTIONS(1468),
    [anon_sym_thread_local] = ACTIONS(1468),
    [anon_sym___thread] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_constexpr] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym___restrict__] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym__Noreturn] = ACTIONS(1468),
    [anon_sym_noreturn] = ACTIONS(1468),
    [sym_primitive_type] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_goto] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_sizeof] = ACTIONS(1468),
    [anon_sym___alignof__] = ACTIONS(1468),
    [anon_sym___alignof] = ACTIONS(1468),
    [anon_sym__alignof] = ACTIONS(1468),
    [anon_sym_alignof] = ACTIONS(1468),
    [anon_sym__Alignof] = ACTIONS(1468),
    [anon_sym_offsetof] = ACTIONS(1468),
    [anon_sym__Generic] = ACTIONS(1468),
    [anon_sym_asm] = ACTIONS(1468),
    [anon_sym___asm__] = ACTIONS(1468),
    [sym_number_literal] = ACTIONS(1470),
    [anon_sym_L_SQUOTE] = ACTIONS(1470),
    [anon_sym_u_SQUOTE] = ACTIONS(1470),
    [anon_sym_U_SQUOTE] = ACTIONS(1470),
    [anon_sym_u8_SQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_L_DQUOTE] = ACTIONS(1470),
    [anon_sym_u_DQUOTE] = ACTIONS(1470),
    [anon_sym_U_DQUOTE] = ACTIONS(1470),
    [anon_sym_u8_DQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [anon_sym_NULL] = ACTIONS(1468),
    [anon_sym_nullptr] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1468),
    [anon_sym_acquire] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_monitor] = ACTIONS(1468),
    [anon_sym_start] = ACTIONS(1468),
    [anon_sym_stop] = ACTIONS(1468),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1573),
    [aux_sym_preproc_include_token1] = ACTIONS(1573),
    [aux_sym_preproc_def_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token2] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1573),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(1573),
    [anon_sym_typedef] = ACTIONS(1573),
    [anon_sym_extern] = ACTIONS(1573),
    [anon_sym___attribute__] = ACTIONS(1573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1575),
    [anon_sym___declspec] = ACTIONS(1573),
    [anon_sym___cdecl] = ACTIONS(1573),
    [anon_sym___clrcall] = ACTIONS(1573),
    [anon_sym___stdcall] = ACTIONS(1573),
    [anon_sym___fastcall] = ACTIONS(1573),
    [anon_sym___thiscall] = ACTIONS(1573),
    [anon_sym___vectorcall] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_signed] = ACTIONS(1573),
    [anon_sym_unsigned] = ACTIONS(1573),
    [anon_sym_long] = ACTIONS(1573),
    [anon_sym_short] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_auto] = ACTIONS(1573),
    [anon_sym_register] = ACTIONS(1573),
    [anon_sym_inline] = ACTIONS(1573),
    [anon_sym___inline] = ACTIONS(1573),
    [anon_sym___inline__] = ACTIONS(1573),
    [anon_sym___forceinline] = ACTIONS(1573),
    [anon_sym_thread_local] = ACTIONS(1573),
    [anon_sym___thread] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_constexpr] = ACTIONS(1573),
    [anon_sym_volatile] = ACTIONS(1573),
    [anon_sym_restrict] = ACTIONS(1573),
    [anon_sym___restrict__] = ACTIONS(1573),
    [anon_sym__Atomic] = ACTIONS(1573),
    [anon_sym__Noreturn] = ACTIONS(1573),
    [anon_sym_noreturn] = ACTIONS(1573),
    [sym_primitive_type] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1573),
    [anon_sym_union] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_goto] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_sizeof] = ACTIONS(1573),
    [anon_sym___alignof__] = ACTIONS(1573),
    [anon_sym___alignof] = ACTIONS(1573),
    [anon_sym__alignof] = ACTIONS(1573),
    [anon_sym_alignof] = ACTIONS(1573),
    [anon_sym__Alignof] = ACTIONS(1573),
    [anon_sym_offsetof] = ACTIONS(1573),
    [anon_sym__Generic] = ACTIONS(1573),
    [anon_sym_asm] = ACTIONS(1573),
    [anon_sym___asm__] = ACTIONS(1573),
    [sym_number_literal] = ACTIONS(1575),
    [anon_sym_L_SQUOTE] = ACTIONS(1575),
    [anon_sym_u_SQUOTE] = ACTIONS(1575),
    [anon_sym_U_SQUOTE] = ACTIONS(1575),
    [anon_sym_u8_SQUOTE] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [anon_sym_NULL] = ACTIONS(1573),
    [anon_sym_nullptr] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_acquire] = ACTIONS(1573),
    [anon_sym_catch] = ACTIONS(1573),
    [anon_sym_monitor] = ACTIONS(1573),
    [anon_sym_start] = ACTIONS(1573),
    [anon_sym_stop] = ACTIONS(1573),
  },
  [293] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(311),
    [sym_attributed_statement] = STATE(317),
    [sym_labeled_statement] = STATE(320),
    [sym_expression_statement] = STATE(333),
    [sym_if_statement] = STATE(359),
    [sym_switch_statement] = STATE(374),
    [sym_case_statement] = STATE(282),
    [sym_while_statement] = STATE(286),
    [sym_do_statement] = STATE(288),
    [sym_for_statement] = STATE(290),
    [sym_return_statement] = STATE(299),
    [sym_break_statement] = STATE(300),
    [sym_continue_statement] = STATE(301),
    [sym_goto_statement] = STATE(305),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(310),
    [sym_acquire_statement] = STATE(312),
    [sym_monitor_statement] = STATE(316),
    [sym_start_statement] = STATE(321),
    [sym_stop_statement] = STATE(325),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [294] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(338),
    [sym_attributed_statement] = STATE(338),
    [sym_labeled_statement] = STATE(338),
    [sym_expression_statement] = STATE(338),
    [sym_if_statement] = STATE(338),
    [sym_switch_statement] = STATE(338),
    [sym_case_statement] = STATE(338),
    [sym_while_statement] = STATE(338),
    [sym_do_statement] = STATE(338),
    [sym_for_statement] = STATE(338),
    [sym_return_statement] = STATE(338),
    [sym_break_statement] = STATE(338),
    [sym_continue_statement] = STATE(338),
    [sym_goto_statement] = STATE(338),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(338),
    [sym_acquire_statement] = STATE(338),
    [sym_monitor_statement] = STATE(338),
    [sym_start_statement] = STATE(338),
    [sym_stop_statement] = STATE(338),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [295] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(105),
    [sym_attributed_statement] = STATE(105),
    [sym_labeled_statement] = STATE(105),
    [sym_expression_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_switch_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_do_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_return_statement] = STATE(105),
    [sym_break_statement] = STATE(105),
    [sym_continue_statement] = STATE(105),
    [sym_goto_statement] = STATE(105),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(105),
    [sym_acquire_statement] = STATE(105),
    [sym_monitor_statement] = STATE(105),
    [sym_start_statement] = STATE(105),
    [sym_stop_statement] = STATE(105),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [296] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(117),
    [sym_attributed_statement] = STATE(117),
    [sym_labeled_statement] = STATE(117),
    [sym_expression_statement] = STATE(117),
    [sym_if_statement] = STATE(117),
    [sym_switch_statement] = STATE(117),
    [sym_case_statement] = STATE(117),
    [sym_while_statement] = STATE(117),
    [sym_do_statement] = STATE(117),
    [sym_for_statement] = STATE(117),
    [sym_return_statement] = STATE(117),
    [sym_break_statement] = STATE(117),
    [sym_continue_statement] = STATE(117),
    [sym_goto_statement] = STATE(117),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(117),
    [sym_acquire_statement] = STATE(117),
    [sym_monitor_statement] = STATE(117),
    [sym_start_statement] = STATE(117),
    [sym_stop_statement] = STATE(117),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [297] = {
    [sym_attribute_declaration] = STATE(313),
    [sym_compound_statement] = STATE(306),
    [sym_attributed_statement] = STATE(306),
    [sym_labeled_statement] = STATE(306),
    [sym_expression_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_switch_statement] = STATE(306),
    [sym_case_statement] = STATE(306),
    [sym_while_statement] = STATE(306),
    [sym_do_statement] = STATE(306),
    [sym_for_statement] = STATE(306),
    [sym_return_statement] = STATE(306),
    [sym_break_statement] = STATE(306),
    [sym_continue_statement] = STATE(306),
    [sym_goto_statement] = STATE(306),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(306),
    [sym_acquire_statement] = STATE(306),
    [sym_monitor_statement] = STATE(306),
    [sym_start_statement] = STATE(306),
    [sym_stop_statement] = STATE(306),
    [aux_sym_attributed_declarator_repeat1] = STATE(313),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [298] = {
    [sym_identifier] = ACTIONS(1611),
    [aux_sym_preproc_include_token1] = ACTIONS(1611),
    [aux_sym_preproc_def_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token2] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1611),
    [aux_sym_preproc_else_token1] = ACTIONS(1611),
    [aux_sym_preproc_elif_token1] = ACTIONS(1611),
    [sym_preproc_directive] = ACTIONS(1611),
    [anon_sym_LPAREN2] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym___extension__] = ACTIONS(1611),
    [anon_sym_typedef] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym___attribute__] = ACTIONS(1611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1613),
    [anon_sym___declspec] = ACTIONS(1611),
    [anon_sym___cdecl] = ACTIONS(1611),
    [anon_sym___clrcall] = ACTIONS(1611),
    [anon_sym___stdcall] = ACTIONS(1611),
    [anon_sym___fastcall] = ACTIONS(1611),
    [anon_sym___thiscall] = ACTIONS(1611),
    [anon_sym___vectorcall] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_signed] = ACTIONS(1611),
    [anon_sym_unsigned] = ACTIONS(1611),
    [anon_sym_long] = ACTIONS(1611),
    [anon_sym_short] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_auto] = ACTIONS(1611),
    [anon_sym_register] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym___inline] = ACTIONS(1611),
    [anon_sym___inline__] = ACTIONS(1611),
    [anon_sym___forceinline] = ACTIONS(1611),
    [anon_sym_thread_local] = ACTIONS(1611),
    [anon_sym___thread] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_constexpr] = ACTIONS(1611),
    [anon_sym_volatile] = ACTIONS(1611),
    [anon_sym_restrict] = ACTIONS(1611),
    [anon_sym___restrict__] = ACTIONS(1611),
    [anon_sym__Atomic] = ACTIONS(1611),
    [anon_sym__Noreturn] = ACTIONS(1611),
    [anon_sym_noreturn] = ACTIONS(1611),
    [sym_primitive_type] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_goto] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_sizeof] = ACTIONS(1611),
    [anon_sym___alignof__] = ACTIONS(1611),
    [anon_sym___alignof] = ACTIONS(1611),
    [anon_sym__alignof] = ACTIONS(1611),
    [anon_sym_alignof] = ACTIONS(1611),
    [anon_sym__Alignof] = ACTIONS(1611),
    [anon_sym_offsetof] = ACTIONS(1611),
    [anon_sym__Generic] = ACTIONS(1611),
    [anon_sym_asm] = ACTIONS(1611),
    [anon_sym___asm__] = ACTIONS(1611),
    [sym_number_literal] = ACTIONS(1613),
    [anon_sym_L_SQUOTE] = ACTIONS(1613),
    [anon_sym_u_SQUOTE] = ACTIONS(1613),
    [anon_sym_U_SQUOTE] = ACTIONS(1613),
    [anon_sym_u8_SQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_L_DQUOTE] = ACTIONS(1613),
    [anon_sym_u_DQUOTE] = ACTIONS(1613),
    [anon_sym_U_DQUOTE] = ACTIONS(1613),
    [anon_sym_u8_DQUOTE] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [sym_true] = ACTIONS(1611),
    [sym_false] = ACTIONS(1611),
    [anon_sym_NULL] = ACTIONS(1611),
    [anon_sym_nullptr] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1611),
    [anon_sym_acquire] = ACTIONS(1611),
    [anon_sym_monitor] = ACTIONS(1611),
    [anon_sym_start] = ACTIONS(1611),
    [anon_sym_stop] = ACTIONS(1611),
  },
  [299] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [300] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [301] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [302] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(93),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_case_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(93),
    [sym_acquire_statement] = STATE(93),
    [sym_monitor_statement] = STATE(93),
    [sym_start_statement] = STATE(93),
    [sym_stop_statement] = STATE(93),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [303] = {
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1569),
    [aux_sym_preproc_def_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token2] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1569),
    [sym_preproc_directive] = ACTIONS(1569),
    [anon_sym_LPAREN2] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(1569),
    [anon_sym_typedef] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym___attribute__] = ACTIONS(1569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1571),
    [anon_sym___declspec] = ACTIONS(1569),
    [anon_sym___cdecl] = ACTIONS(1569),
    [anon_sym___clrcall] = ACTIONS(1569),
    [anon_sym___stdcall] = ACTIONS(1569),
    [anon_sym___fastcall] = ACTIONS(1569),
    [anon_sym___thiscall] = ACTIONS(1569),
    [anon_sym___vectorcall] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_signed] = ACTIONS(1569),
    [anon_sym_unsigned] = ACTIONS(1569),
    [anon_sym_long] = ACTIONS(1569),
    [anon_sym_short] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_auto] = ACTIONS(1569),
    [anon_sym_register] = ACTIONS(1569),
    [anon_sym_inline] = ACTIONS(1569),
    [anon_sym___inline] = ACTIONS(1569),
    [anon_sym___inline__] = ACTIONS(1569),
    [anon_sym___forceinline] = ACTIONS(1569),
    [anon_sym_thread_local] = ACTIONS(1569),
    [anon_sym___thread] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_constexpr] = ACTIONS(1569),
    [anon_sym_volatile] = ACTIONS(1569),
    [anon_sym_restrict] = ACTIONS(1569),
    [anon_sym___restrict__] = ACTIONS(1569),
    [anon_sym__Atomic] = ACTIONS(1569),
    [anon_sym__Noreturn] = ACTIONS(1569),
    [anon_sym_noreturn] = ACTIONS(1569),
    [sym_primitive_type] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_goto] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_sizeof] = ACTIONS(1569),
    [anon_sym___alignof__] = ACTIONS(1569),
    [anon_sym___alignof] = ACTIONS(1569),
    [anon_sym__alignof] = ACTIONS(1569),
    [anon_sym_alignof] = ACTIONS(1569),
    [anon_sym__Alignof] = ACTIONS(1569),
    [anon_sym_offsetof] = ACTIONS(1569),
    [anon_sym__Generic] = ACTIONS(1569),
    [anon_sym_asm] = ACTIONS(1569),
    [anon_sym___asm__] = ACTIONS(1569),
    [sym_number_literal] = ACTIONS(1571),
    [anon_sym_L_SQUOTE] = ACTIONS(1571),
    [anon_sym_u_SQUOTE] = ACTIONS(1571),
    [anon_sym_U_SQUOTE] = ACTIONS(1571),
    [anon_sym_u8_SQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [anon_sym_L_DQUOTE] = ACTIONS(1571),
    [anon_sym_u_DQUOTE] = ACTIONS(1571),
    [anon_sym_U_DQUOTE] = ACTIONS(1571),
    [anon_sym_u8_DQUOTE] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [anon_sym_NULL] = ACTIONS(1569),
    [anon_sym_nullptr] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1569),
    [anon_sym_acquire] = ACTIONS(1569),
    [anon_sym_catch] = ACTIONS(1569),
    [anon_sym_monitor] = ACTIONS(1569),
    [anon_sym_start] = ACTIONS(1569),
    [anon_sym_stop] = ACTIONS(1569),
  },
  [304] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(92),
    [sym_attributed_statement] = STATE(92),
    [sym_labeled_statement] = STATE(92),
    [sym_expression_statement] = STATE(92),
    [sym_if_statement] = STATE(92),
    [sym_switch_statement] = STATE(92),
    [sym_case_statement] = STATE(92),
    [sym_while_statement] = STATE(92),
    [sym_do_statement] = STATE(92),
    [sym_for_statement] = STATE(92),
    [sym_return_statement] = STATE(92),
    [sym_break_statement] = STATE(92),
    [sym_continue_statement] = STATE(92),
    [sym_goto_statement] = STATE(92),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(92),
    [sym_acquire_statement] = STATE(92),
    [sym_monitor_statement] = STATE(92),
    [sym_start_statement] = STATE(92),
    [sym_stop_statement] = STATE(92),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [305] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [306] = {
    [sym_identifier] = ACTIONS(1529),
    [aux_sym_preproc_include_token1] = ACTIONS(1529),
    [aux_sym_preproc_def_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token2] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1529),
    [sym_preproc_directive] = ACTIONS(1529),
    [anon_sym_LPAREN2] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1529),
    [anon_sym_typedef] = ACTIONS(1529),
    [anon_sym_extern] = ACTIONS(1529),
    [anon_sym___attribute__] = ACTIONS(1529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1531),
    [anon_sym___declspec] = ACTIONS(1529),
    [anon_sym___cdecl] = ACTIONS(1529),
    [anon_sym___clrcall] = ACTIONS(1529),
    [anon_sym___stdcall] = ACTIONS(1529),
    [anon_sym___fastcall] = ACTIONS(1529),
    [anon_sym___thiscall] = ACTIONS(1529),
    [anon_sym___vectorcall] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_signed] = ACTIONS(1529),
    [anon_sym_unsigned] = ACTIONS(1529),
    [anon_sym_long] = ACTIONS(1529),
    [anon_sym_short] = ACTIONS(1529),
    [anon_sym_static] = ACTIONS(1529),
    [anon_sym_auto] = ACTIONS(1529),
    [anon_sym_register] = ACTIONS(1529),
    [anon_sym_inline] = ACTIONS(1529),
    [anon_sym___inline] = ACTIONS(1529),
    [anon_sym___inline__] = ACTIONS(1529),
    [anon_sym___forceinline] = ACTIONS(1529),
    [anon_sym_thread_local] = ACTIONS(1529),
    [anon_sym___thread] = ACTIONS(1529),
    [anon_sym_const] = ACTIONS(1529),
    [anon_sym_constexpr] = ACTIONS(1529),
    [anon_sym_volatile] = ACTIONS(1529),
    [anon_sym_restrict] = ACTIONS(1529),
    [anon_sym___restrict__] = ACTIONS(1529),
    [anon_sym__Atomic] = ACTIONS(1529),
    [anon_sym__Noreturn] = ACTIONS(1529),
    [anon_sym_noreturn] = ACTIONS(1529),
    [sym_primitive_type] = ACTIONS(1529),
    [anon_sym_enum] = ACTIONS(1529),
    [anon_sym_struct] = ACTIONS(1529),
    [anon_sym_union] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(1529),
    [anon_sym_else] = ACTIONS(1529),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_case] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1529),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1529),
    [anon_sym_return] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(1529),
    [anon_sym_continue] = ACTIONS(1529),
    [anon_sym_goto] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym___alignof__] = ACTIONS(1529),
    [anon_sym___alignof] = ACTIONS(1529),
    [anon_sym__alignof] = ACTIONS(1529),
    [anon_sym_alignof] = ACTIONS(1529),
    [anon_sym__Alignof] = ACTIONS(1529),
    [anon_sym_offsetof] = ACTIONS(1529),
    [anon_sym__Generic] = ACTIONS(1529),
    [anon_sym_asm] = ACTIONS(1529),
    [anon_sym___asm__] = ACTIONS(1529),
    [sym_number_literal] = ACTIONS(1531),
    [anon_sym_L_SQUOTE] = ACTIONS(1531),
    [anon_sym_u_SQUOTE] = ACTIONS(1531),
    [anon_sym_U_SQUOTE] = ACTIONS(1531),
    [anon_sym_u8_SQUOTE] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_L_DQUOTE] = ACTIONS(1531),
    [anon_sym_u_DQUOTE] = ACTIONS(1531),
    [anon_sym_U_DQUOTE] = ACTIONS(1531),
    [anon_sym_u8_DQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [anon_sym_NULL] = ACTIONS(1529),
    [anon_sym_nullptr] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1529),
    [anon_sym_acquire] = ACTIONS(1529),
    [anon_sym_catch] = ACTIONS(1529),
    [anon_sym_monitor] = ACTIONS(1529),
    [anon_sym_start] = ACTIONS(1529),
    [anon_sym_stop] = ACTIONS(1529),
  },
  [307] = {
    [sym_identifier] = ACTIONS(1525),
    [aux_sym_preproc_include_token1] = ACTIONS(1525),
    [aux_sym_preproc_def_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token2] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1525),
    [sym_preproc_directive] = ACTIONS(1525),
    [anon_sym_LPAREN2] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1525),
    [anon_sym_typedef] = ACTIONS(1525),
    [anon_sym_extern] = ACTIONS(1525),
    [anon_sym___attribute__] = ACTIONS(1525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1527),
    [anon_sym___declspec] = ACTIONS(1525),
    [anon_sym___cdecl] = ACTIONS(1525),
    [anon_sym___clrcall] = ACTIONS(1525),
    [anon_sym___stdcall] = ACTIONS(1525),
    [anon_sym___fastcall] = ACTIONS(1525),
    [anon_sym___thiscall] = ACTIONS(1525),
    [anon_sym___vectorcall] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_signed] = ACTIONS(1525),
    [anon_sym_unsigned] = ACTIONS(1525),
    [anon_sym_long] = ACTIONS(1525),
    [anon_sym_short] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1525),
    [anon_sym_auto] = ACTIONS(1525),
    [anon_sym_register] = ACTIONS(1525),
    [anon_sym_inline] = ACTIONS(1525),
    [anon_sym___inline] = ACTIONS(1525),
    [anon_sym___inline__] = ACTIONS(1525),
    [anon_sym___forceinline] = ACTIONS(1525),
    [anon_sym_thread_local] = ACTIONS(1525),
    [anon_sym___thread] = ACTIONS(1525),
    [anon_sym_const] = ACTIONS(1525),
    [anon_sym_constexpr] = ACTIONS(1525),
    [anon_sym_volatile] = ACTIONS(1525),
    [anon_sym_restrict] = ACTIONS(1525),
    [anon_sym___restrict__] = ACTIONS(1525),
    [anon_sym__Atomic] = ACTIONS(1525),
    [anon_sym__Noreturn] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [sym_primitive_type] = ACTIONS(1525),
    [anon_sym_enum] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1525),
    [anon_sym_union] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_do] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_return] = ACTIONS(1525),
    [anon_sym_break] = ACTIONS(1525),
    [anon_sym_continue] = ACTIONS(1525),
    [anon_sym_goto] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_sizeof] = ACTIONS(1525),
    [anon_sym___alignof__] = ACTIONS(1525),
    [anon_sym___alignof] = ACTIONS(1525),
    [anon_sym__alignof] = ACTIONS(1525),
    [anon_sym_alignof] = ACTIONS(1525),
    [anon_sym__Alignof] = ACTIONS(1525),
    [anon_sym_offsetof] = ACTIONS(1525),
    [anon_sym__Generic] = ACTIONS(1525),
    [anon_sym_asm] = ACTIONS(1525),
    [anon_sym___asm__] = ACTIONS(1525),
    [sym_number_literal] = ACTIONS(1527),
    [anon_sym_L_SQUOTE] = ACTIONS(1527),
    [anon_sym_u_SQUOTE] = ACTIONS(1527),
    [anon_sym_U_SQUOTE] = ACTIONS(1527),
    [anon_sym_u8_SQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [anon_sym_L_DQUOTE] = ACTIONS(1527),
    [anon_sym_u_DQUOTE] = ACTIONS(1527),
    [anon_sym_U_DQUOTE] = ACTIONS(1527),
    [anon_sym_u8_DQUOTE] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [anon_sym_NULL] = ACTIONS(1525),
    [anon_sym_nullptr] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1525),
    [anon_sym_acquire] = ACTIONS(1525),
    [anon_sym_catch] = ACTIONS(1525),
    [anon_sym_monitor] = ACTIONS(1525),
    [anon_sym_start] = ACTIONS(1525),
    [anon_sym_stop] = ACTIONS(1525),
  },
  [308] = {
    [sym_identifier] = ACTIONS(1573),
    [aux_sym_preproc_include_token1] = ACTIONS(1573),
    [aux_sym_preproc_def_token1] = ACTIONS(1573),
    [aux_sym_preproc_if_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1573),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(1573),
    [anon_sym_typedef] = ACTIONS(1573),
    [anon_sym_extern] = ACTIONS(1573),
    [anon_sym___attribute__] = ACTIONS(1573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1575),
    [anon_sym___declspec] = ACTIONS(1573),
    [anon_sym___cdecl] = ACTIONS(1573),
    [anon_sym___clrcall] = ACTIONS(1573),
    [anon_sym___stdcall] = ACTIONS(1573),
    [anon_sym___fastcall] = ACTIONS(1573),
    [anon_sym___thiscall] = ACTIONS(1573),
    [anon_sym___vectorcall] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_signed] = ACTIONS(1573),
    [anon_sym_unsigned] = ACTIONS(1573),
    [anon_sym_long] = ACTIONS(1573),
    [anon_sym_short] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_auto] = ACTIONS(1573),
    [anon_sym_register] = ACTIONS(1573),
    [anon_sym_inline] = ACTIONS(1573),
    [anon_sym___inline] = ACTIONS(1573),
    [anon_sym___inline__] = ACTIONS(1573),
    [anon_sym___forceinline] = ACTIONS(1573),
    [anon_sym_thread_local] = ACTIONS(1573),
    [anon_sym___thread] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_constexpr] = ACTIONS(1573),
    [anon_sym_volatile] = ACTIONS(1573),
    [anon_sym_restrict] = ACTIONS(1573),
    [anon_sym___restrict__] = ACTIONS(1573),
    [anon_sym__Atomic] = ACTIONS(1573),
    [anon_sym__Noreturn] = ACTIONS(1573),
    [anon_sym_noreturn] = ACTIONS(1573),
    [sym_primitive_type] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1573),
    [anon_sym_union] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_goto] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_sizeof] = ACTIONS(1573),
    [anon_sym___alignof__] = ACTIONS(1573),
    [anon_sym___alignof] = ACTIONS(1573),
    [anon_sym__alignof] = ACTIONS(1573),
    [anon_sym_alignof] = ACTIONS(1573),
    [anon_sym__Alignof] = ACTIONS(1573),
    [anon_sym_offsetof] = ACTIONS(1573),
    [anon_sym__Generic] = ACTIONS(1573),
    [anon_sym_asm] = ACTIONS(1573),
    [anon_sym___asm__] = ACTIONS(1573),
    [sym_number_literal] = ACTIONS(1575),
    [anon_sym_L_SQUOTE] = ACTIONS(1575),
    [anon_sym_u_SQUOTE] = ACTIONS(1575),
    [anon_sym_U_SQUOTE] = ACTIONS(1575),
    [anon_sym_u8_SQUOTE] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [anon_sym_L_DQUOTE] = ACTIONS(1575),
    [anon_sym_u_DQUOTE] = ACTIONS(1575),
    [anon_sym_U_DQUOTE] = ACTIONS(1575),
    [anon_sym_u8_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [anon_sym_NULL] = ACTIONS(1573),
    [anon_sym_nullptr] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_acquire] = ACTIONS(1573),
    [anon_sym_catch] = ACTIONS(1573),
    [anon_sym_monitor] = ACTIONS(1573),
    [anon_sym_start] = ACTIONS(1573),
    [anon_sym_stop] = ACTIONS(1573),
  },
  [309] = {
    [sym_identifier] = ACTIONS(1688),
    [aux_sym_preproc_include_token1] = ACTIONS(1688),
    [aux_sym_preproc_def_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token2] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1688),
    [aux_sym_preproc_else_token1] = ACTIONS(1688),
    [aux_sym_preproc_elif_token1] = ACTIONS(1688),
    [sym_preproc_directive] = ACTIONS(1688),
    [anon_sym_LPAREN2] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym___extension__] = ACTIONS(1688),
    [anon_sym_typedef] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym___attribute__] = ACTIONS(1688),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1690),
    [anon_sym___declspec] = ACTIONS(1688),
    [anon_sym___cdecl] = ACTIONS(1688),
    [anon_sym___clrcall] = ACTIONS(1688),
    [anon_sym___stdcall] = ACTIONS(1688),
    [anon_sym___fastcall] = ACTIONS(1688),
    [anon_sym___thiscall] = ACTIONS(1688),
    [anon_sym___vectorcall] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_signed] = ACTIONS(1688),
    [anon_sym_unsigned] = ACTIONS(1688),
    [anon_sym_long] = ACTIONS(1688),
    [anon_sym_short] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_auto] = ACTIONS(1688),
    [anon_sym_register] = ACTIONS(1688),
    [anon_sym_inline] = ACTIONS(1688),
    [anon_sym___inline] = ACTIONS(1688),
    [anon_sym___inline__] = ACTIONS(1688),
    [anon_sym___forceinline] = ACTIONS(1688),
    [anon_sym_thread_local] = ACTIONS(1688),
    [anon_sym___thread] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_constexpr] = ACTIONS(1688),
    [anon_sym_volatile] = ACTIONS(1688),
    [anon_sym_restrict] = ACTIONS(1688),
    [anon_sym___restrict__] = ACTIONS(1688),
    [anon_sym__Atomic] = ACTIONS(1688),
    [anon_sym__Noreturn] = ACTIONS(1688),
    [anon_sym_noreturn] = ACTIONS(1688),
    [sym_primitive_type] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_switch] = ACTIONS(1688),
    [anon_sym_case] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_do] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_goto] = ACTIONS(1688),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_sizeof] = ACTIONS(1688),
    [anon_sym___alignof__] = ACTIONS(1688),
    [anon_sym___alignof] = ACTIONS(1688),
    [anon_sym__alignof] = ACTIONS(1688),
    [anon_sym_alignof] = ACTIONS(1688),
    [anon_sym__Alignof] = ACTIONS(1688),
    [anon_sym_offsetof] = ACTIONS(1688),
    [anon_sym__Generic] = ACTIONS(1688),
    [anon_sym_asm] = ACTIONS(1688),
    [anon_sym___asm__] = ACTIONS(1688),
    [sym_number_literal] = ACTIONS(1690),
    [anon_sym_L_SQUOTE] = ACTIONS(1690),
    [anon_sym_u_SQUOTE] = ACTIONS(1690),
    [anon_sym_U_SQUOTE] = ACTIONS(1690),
    [anon_sym_u8_SQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [anon_sym_L_DQUOTE] = ACTIONS(1690),
    [anon_sym_u_DQUOTE] = ACTIONS(1690),
    [anon_sym_U_DQUOTE] = ACTIONS(1690),
    [anon_sym_u8_DQUOTE] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [anon_sym_NULL] = ACTIONS(1688),
    [anon_sym_nullptr] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1688),
    [anon_sym_acquire] = ACTIONS(1688),
    [anon_sym_monitor] = ACTIONS(1688),
    [anon_sym_start] = ACTIONS(1688),
    [anon_sym_stop] = ACTIONS(1688),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [311] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [313] = {
    [sym_attribute_declaration] = STATE(313),
    [sym_compound_statement] = STATE(306),
    [sym_attributed_statement] = STATE(306),
    [sym_labeled_statement] = STATE(306),
    [sym_expression_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_switch_statement] = STATE(306),
    [sym_case_statement] = STATE(306),
    [sym_while_statement] = STATE(306),
    [sym_do_statement] = STATE(306),
    [sym_for_statement] = STATE(306),
    [sym_return_statement] = STATE(306),
    [sym_break_statement] = STATE(306),
    [sym_continue_statement] = STATE(306),
    [sym_goto_statement] = STATE(306),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(306),
    [sym_acquire_statement] = STATE(306),
    [sym_monitor_statement] = STATE(306),
    [sym_start_statement] = STATE(306),
    [sym_stop_statement] = STATE(306),
    [aux_sym_attributed_declarator_repeat1] = STATE(313),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1741),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_switch] = ACTIONS(1747),
    [anon_sym_case] = ACTIONS(1750),
    [anon_sym_default] = ACTIONS(1753),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_do] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(1762),
    [anon_sym_return] = ACTIONS(1765),
    [anon_sym_break] = ACTIONS(1768),
    [anon_sym_continue] = ACTIONS(1771),
    [anon_sym_goto] = ACTIONS(1774),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_sizeof] = ACTIONS(1780),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1786),
    [anon_sym__Generic] = ACTIONS(1789),
    [anon_sym_asm] = ACTIONS(1792),
    [anon_sym___asm__] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1795),
    [anon_sym_L_SQUOTE] = ACTIONS(1798),
    [anon_sym_u_SQUOTE] = ACTIONS(1798),
    [anon_sym_U_SQUOTE] = ACTIONS(1798),
    [anon_sym_u8_SQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_L_DQUOTE] = ACTIONS(1801),
    [anon_sym_u_DQUOTE] = ACTIONS(1801),
    [anon_sym_U_DQUOTE] = ACTIONS(1801),
    [anon_sym_u8_DQUOTE] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [anon_sym_NULL] = ACTIONS(1807),
    [anon_sym_nullptr] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1810),
    [anon_sym_acquire] = ACTIONS(1813),
    [anon_sym_monitor] = ACTIONS(1816),
    [anon_sym_start] = ACTIONS(1819),
    [anon_sym_stop] = ACTIONS(1822),
  },
  [314] = {
    [sym_identifier] = ACTIONS(1565),
    [aux_sym_preproc_include_token1] = ACTIONS(1565),
    [aux_sym_preproc_def_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token2] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [sym_preproc_directive] = ACTIONS(1565),
    [anon_sym_LPAREN2] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1565),
    [anon_sym_typedef] = ACTIONS(1565),
    [anon_sym_extern] = ACTIONS(1565),
    [anon_sym___attribute__] = ACTIONS(1565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1567),
    [anon_sym___declspec] = ACTIONS(1565),
    [anon_sym___cdecl] = ACTIONS(1565),
    [anon_sym___clrcall] = ACTIONS(1565),
    [anon_sym___stdcall] = ACTIONS(1565),
    [anon_sym___fastcall] = ACTIONS(1565),
    [anon_sym___thiscall] = ACTIONS(1565),
    [anon_sym___vectorcall] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_signed] = ACTIONS(1565),
    [anon_sym_unsigned] = ACTIONS(1565),
    [anon_sym_long] = ACTIONS(1565),
    [anon_sym_short] = ACTIONS(1565),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_auto] = ACTIONS(1565),
    [anon_sym_register] = ACTIONS(1565),
    [anon_sym_inline] = ACTIONS(1565),
    [anon_sym___inline] = ACTIONS(1565),
    [anon_sym___inline__] = ACTIONS(1565),
    [anon_sym___forceinline] = ACTIONS(1565),
    [anon_sym_thread_local] = ACTIONS(1565),
    [anon_sym___thread] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_constexpr] = ACTIONS(1565),
    [anon_sym_volatile] = ACTIONS(1565),
    [anon_sym_restrict] = ACTIONS(1565),
    [anon_sym___restrict__] = ACTIONS(1565),
    [anon_sym__Atomic] = ACTIONS(1565),
    [anon_sym__Noreturn] = ACTIONS(1565),
    [anon_sym_noreturn] = ACTIONS(1565),
    [sym_primitive_type] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [anon_sym_struct] = ACTIONS(1565),
    [anon_sym_union] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_goto] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_sizeof] = ACTIONS(1565),
    [anon_sym___alignof__] = ACTIONS(1565),
    [anon_sym___alignof] = ACTIONS(1565),
    [anon_sym__alignof] = ACTIONS(1565),
    [anon_sym_alignof] = ACTIONS(1565),
    [anon_sym__Alignof] = ACTIONS(1565),
    [anon_sym_offsetof] = ACTIONS(1565),
    [anon_sym__Generic] = ACTIONS(1565),
    [anon_sym_asm] = ACTIONS(1565),
    [anon_sym___asm__] = ACTIONS(1565),
    [sym_number_literal] = ACTIONS(1567),
    [anon_sym_L_SQUOTE] = ACTIONS(1567),
    [anon_sym_u_SQUOTE] = ACTIONS(1567),
    [anon_sym_U_SQUOTE] = ACTIONS(1567),
    [anon_sym_u8_SQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [anon_sym_L_DQUOTE] = ACTIONS(1567),
    [anon_sym_u_DQUOTE] = ACTIONS(1567),
    [anon_sym_U_DQUOTE] = ACTIONS(1567),
    [anon_sym_u8_DQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [anon_sym_NULL] = ACTIONS(1565),
    [anon_sym_nullptr] = ACTIONS(1565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_acquire] = ACTIONS(1565),
    [anon_sym_catch] = ACTIONS(1565),
    [anon_sym_monitor] = ACTIONS(1565),
    [anon_sym_start] = ACTIONS(1565),
    [anon_sym_stop] = ACTIONS(1565),
  },
  [315] = {
    [sym_identifier] = ACTIONS(1593),
    [aux_sym_preproc_include_token1] = ACTIONS(1593),
    [aux_sym_preproc_def_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token2] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1593),
    [aux_sym_preproc_else_token1] = ACTIONS(1593),
    [aux_sym_preproc_elif_token1] = ACTIONS(1593),
    [sym_preproc_directive] = ACTIONS(1593),
    [anon_sym_LPAREN2] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(1593),
    [anon_sym_extern] = ACTIONS(1593),
    [anon_sym___attribute__] = ACTIONS(1593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1595),
    [anon_sym___declspec] = ACTIONS(1593),
    [anon_sym___cdecl] = ACTIONS(1593),
    [anon_sym___clrcall] = ACTIONS(1593),
    [anon_sym___stdcall] = ACTIONS(1593),
    [anon_sym___fastcall] = ACTIONS(1593),
    [anon_sym___thiscall] = ACTIONS(1593),
    [anon_sym___vectorcall] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1595),
    [anon_sym_signed] = ACTIONS(1593),
    [anon_sym_unsigned] = ACTIONS(1593),
    [anon_sym_long] = ACTIONS(1593),
    [anon_sym_short] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_auto] = ACTIONS(1593),
    [anon_sym_register] = ACTIONS(1593),
    [anon_sym_inline] = ACTIONS(1593),
    [anon_sym___inline] = ACTIONS(1593),
    [anon_sym___inline__] = ACTIONS(1593),
    [anon_sym___forceinline] = ACTIONS(1593),
    [anon_sym_thread_local] = ACTIONS(1593),
    [anon_sym___thread] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_constexpr] = ACTIONS(1593),
    [anon_sym_volatile] = ACTIONS(1593),
    [anon_sym_restrict] = ACTIONS(1593),
    [anon_sym___restrict__] = ACTIONS(1593),
    [anon_sym__Atomic] = ACTIONS(1593),
    [anon_sym__Noreturn] = ACTIONS(1593),
    [anon_sym_noreturn] = ACTIONS(1593),
    [sym_primitive_type] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [anon_sym_struct] = ACTIONS(1593),
    [anon_sym_union] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_goto] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1595),
    [anon_sym_PLUS_PLUS] = ACTIONS(1595),
    [anon_sym_sizeof] = ACTIONS(1593),
    [anon_sym___alignof__] = ACTIONS(1593),
    [anon_sym___alignof] = ACTIONS(1593),
    [anon_sym__alignof] = ACTIONS(1593),
    [anon_sym_alignof] = ACTIONS(1593),
    [anon_sym__Alignof] = ACTIONS(1593),
    [anon_sym_offsetof] = ACTIONS(1593),
    [anon_sym__Generic] = ACTIONS(1593),
    [anon_sym_asm] = ACTIONS(1593),
    [anon_sym___asm__] = ACTIONS(1593),
    [sym_number_literal] = ACTIONS(1595),
    [anon_sym_L_SQUOTE] = ACTIONS(1595),
    [anon_sym_u_SQUOTE] = ACTIONS(1595),
    [anon_sym_U_SQUOTE] = ACTIONS(1595),
    [anon_sym_u8_SQUOTE] = ACTIONS(1595),
    [anon_sym_SQUOTE] = ACTIONS(1595),
    [anon_sym_L_DQUOTE] = ACTIONS(1595),
    [anon_sym_u_DQUOTE] = ACTIONS(1595),
    [anon_sym_U_DQUOTE] = ACTIONS(1595),
    [anon_sym_u8_DQUOTE] = ACTIONS(1595),
    [anon_sym_DQUOTE] = ACTIONS(1595),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [anon_sym_NULL] = ACTIONS(1593),
    [anon_sym_nullptr] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1593),
    [anon_sym_acquire] = ACTIONS(1593),
    [anon_sym_monitor] = ACTIONS(1593),
    [anon_sym_start] = ACTIONS(1593),
    [anon_sym_stop] = ACTIONS(1593),
  },
  [316] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [317] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [318] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(252),
    [sym_attributed_statement] = STATE(252),
    [sym_labeled_statement] = STATE(252),
    [sym_expression_statement] = STATE(252),
    [sym_if_statement] = STATE(252),
    [sym_switch_statement] = STATE(252),
    [sym_case_statement] = STATE(252),
    [sym_while_statement] = STATE(252),
    [sym_do_statement] = STATE(252),
    [sym_for_statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_break_statement] = STATE(252),
    [sym_continue_statement] = STATE(252),
    [sym_goto_statement] = STATE(252),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(252),
    [sym_acquire_statement] = STATE(252),
    [sym_monitor_statement] = STATE(252),
    [sym_start_statement] = STATE(252),
    [sym_stop_statement] = STATE(252),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [319] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(191),
    [sym_attributed_statement] = STATE(191),
    [sym_labeled_statement] = STATE(191),
    [sym_expression_statement] = STATE(191),
    [sym_if_statement] = STATE(191),
    [sym_switch_statement] = STATE(191),
    [sym_case_statement] = STATE(191),
    [sym_while_statement] = STATE(191),
    [sym_do_statement] = STATE(191),
    [sym_for_statement] = STATE(191),
    [sym_return_statement] = STATE(191),
    [sym_break_statement] = STATE(191),
    [sym_continue_statement] = STATE(191),
    [sym_goto_statement] = STATE(191),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(191),
    [sym_acquire_statement] = STATE(191),
    [sym_monitor_statement] = STATE(191),
    [sym_start_statement] = STATE(191),
    [sym_stop_statement] = STATE(191),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [320] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [321] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [322] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(262),
    [sym_attributed_statement] = STATE(262),
    [sym_labeled_statement] = STATE(262),
    [sym_expression_statement] = STATE(262),
    [sym_if_statement] = STATE(262),
    [sym_switch_statement] = STATE(262),
    [sym_case_statement] = STATE(262),
    [sym_while_statement] = STATE(262),
    [sym_do_statement] = STATE(262),
    [sym_for_statement] = STATE(262),
    [sym_return_statement] = STATE(262),
    [sym_break_statement] = STATE(262),
    [sym_continue_statement] = STATE(262),
    [sym_goto_statement] = STATE(262),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(262),
    [sym_acquire_statement] = STATE(262),
    [sym_monitor_statement] = STATE(262),
    [sym_start_statement] = STATE(262),
    [sym_stop_statement] = STATE(262),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [323] = {
    [sym_attribute_declaration] = STATE(323),
    [sym_compound_statement] = STATE(126),
    [sym_attributed_statement] = STATE(126),
    [sym_labeled_statement] = STATE(126),
    [sym_expression_statement] = STATE(126),
    [sym_if_statement] = STATE(126),
    [sym_switch_statement] = STATE(126),
    [sym_case_statement] = STATE(126),
    [sym_while_statement] = STATE(126),
    [sym_do_statement] = STATE(126),
    [sym_for_statement] = STATE(126),
    [sym_return_statement] = STATE(126),
    [sym_break_statement] = STATE(126),
    [sym_continue_statement] = STATE(126),
    [sym_goto_statement] = STATE(126),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(126),
    [sym_acquire_statement] = STATE(126),
    [sym_monitor_statement] = STATE(126),
    [sym_start_statement] = STATE(126),
    [sym_stop_statement] = STATE(126),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1827),
    [anon_sym_LPAREN2] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1833),
    [anon_sym_if] = ACTIONS(1836),
    [anon_sym_switch] = ACTIONS(1839),
    [anon_sym_case] = ACTIONS(1842),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1848),
    [anon_sym_do] = ACTIONS(1851),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1857),
    [anon_sym_break] = ACTIONS(1860),
    [anon_sym_continue] = ACTIONS(1863),
    [anon_sym_goto] = ACTIONS(1866),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_sizeof] = ACTIONS(1780),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1786),
    [anon_sym__Generic] = ACTIONS(1789),
    [anon_sym_asm] = ACTIONS(1792),
    [anon_sym___asm__] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1795),
    [anon_sym_L_SQUOTE] = ACTIONS(1798),
    [anon_sym_u_SQUOTE] = ACTIONS(1798),
    [anon_sym_U_SQUOTE] = ACTIONS(1798),
    [anon_sym_u8_SQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_L_DQUOTE] = ACTIONS(1801),
    [anon_sym_u_DQUOTE] = ACTIONS(1801),
    [anon_sym_U_DQUOTE] = ACTIONS(1801),
    [anon_sym_u8_DQUOTE] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [anon_sym_NULL] = ACTIONS(1807),
    [anon_sym_nullptr] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1869),
    [anon_sym_acquire] = ACTIONS(1872),
    [anon_sym_monitor] = ACTIONS(1875),
    [anon_sym_start] = ACTIONS(1878),
    [anon_sym_stop] = ACTIONS(1881),
  },
  [324] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(434),
    [sym_attributed_statement] = STATE(434),
    [sym_labeled_statement] = STATE(434),
    [sym_expression_statement] = STATE(434),
    [sym_if_statement] = STATE(434),
    [sym_switch_statement] = STATE(434),
    [sym_case_statement] = STATE(434),
    [sym_while_statement] = STATE(434),
    [sym_do_statement] = STATE(434),
    [sym_for_statement] = STATE(434),
    [sym_return_statement] = STATE(434),
    [sym_break_statement] = STATE(434),
    [sym_continue_statement] = STATE(434),
    [sym_goto_statement] = STATE(434),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(434),
    [sym_acquire_statement] = STATE(434),
    [sym_monitor_statement] = STATE(434),
    [sym_start_statement] = STATE(434),
    [sym_stop_statement] = STATE(434),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [325] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [326] = {
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_include_token1] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1557),
    [aux_sym_preproc_if_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1557),
    [sym_preproc_directive] = ACTIONS(1557),
    [anon_sym_LPAREN2] = ACTIONS(1559),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym___extension__] = ACTIONS(1557),
    [anon_sym_typedef] = ACTIONS(1557),
    [anon_sym_extern] = ACTIONS(1557),
    [anon_sym___attribute__] = ACTIONS(1557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1559),
    [anon_sym___declspec] = ACTIONS(1557),
    [anon_sym___cdecl] = ACTIONS(1557),
    [anon_sym___clrcall] = ACTIONS(1557),
    [anon_sym___stdcall] = ACTIONS(1557),
    [anon_sym___fastcall] = ACTIONS(1557),
    [anon_sym___thiscall] = ACTIONS(1557),
    [anon_sym___vectorcall] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_signed] = ACTIONS(1557),
    [anon_sym_unsigned] = ACTIONS(1557),
    [anon_sym_long] = ACTIONS(1557),
    [anon_sym_short] = ACTIONS(1557),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_auto] = ACTIONS(1557),
    [anon_sym_register] = ACTIONS(1557),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym___inline] = ACTIONS(1557),
    [anon_sym___inline__] = ACTIONS(1557),
    [anon_sym___forceinline] = ACTIONS(1557),
    [anon_sym_thread_local] = ACTIONS(1557),
    [anon_sym___thread] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_constexpr] = ACTIONS(1557),
    [anon_sym_volatile] = ACTIONS(1557),
    [anon_sym_restrict] = ACTIONS(1557),
    [anon_sym___restrict__] = ACTIONS(1557),
    [anon_sym__Atomic] = ACTIONS(1557),
    [anon_sym__Noreturn] = ACTIONS(1557),
    [anon_sym_noreturn] = ACTIONS(1557),
    [sym_primitive_type] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [anon_sym_struct] = ACTIONS(1557),
    [anon_sym_union] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_goto] = ACTIONS(1557),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_sizeof] = ACTIONS(1557),
    [anon_sym___alignof__] = ACTIONS(1557),
    [anon_sym___alignof] = ACTIONS(1557),
    [anon_sym__alignof] = ACTIONS(1557),
    [anon_sym_alignof] = ACTIONS(1557),
    [anon_sym__Alignof] = ACTIONS(1557),
    [anon_sym_offsetof] = ACTIONS(1557),
    [anon_sym__Generic] = ACTIONS(1557),
    [anon_sym_asm] = ACTIONS(1557),
    [anon_sym___asm__] = ACTIONS(1557),
    [sym_number_literal] = ACTIONS(1559),
    [anon_sym_L_SQUOTE] = ACTIONS(1559),
    [anon_sym_u_SQUOTE] = ACTIONS(1559),
    [anon_sym_U_SQUOTE] = ACTIONS(1559),
    [anon_sym_u8_SQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [anon_sym_L_DQUOTE] = ACTIONS(1559),
    [anon_sym_u_DQUOTE] = ACTIONS(1559),
    [anon_sym_U_DQUOTE] = ACTIONS(1559),
    [anon_sym_u8_DQUOTE] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [anon_sym_NULL] = ACTIONS(1557),
    [anon_sym_nullptr] = ACTIONS(1557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_acquire] = ACTIONS(1557),
    [anon_sym_catch] = ACTIONS(1557),
    [anon_sym_monitor] = ACTIONS(1557),
    [anon_sym_start] = ACTIONS(1557),
    [anon_sym_stop] = ACTIONS(1557),
  },
  [327] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(443),
    [sym_attributed_statement] = STATE(443),
    [sym_labeled_statement] = STATE(443),
    [sym_expression_statement] = STATE(443),
    [sym_if_statement] = STATE(443),
    [sym_switch_statement] = STATE(443),
    [sym_case_statement] = STATE(443),
    [sym_while_statement] = STATE(443),
    [sym_do_statement] = STATE(443),
    [sym_for_statement] = STATE(443),
    [sym_return_statement] = STATE(443),
    [sym_break_statement] = STATE(443),
    [sym_continue_statement] = STATE(443),
    [sym_goto_statement] = STATE(443),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(443),
    [sym_acquire_statement] = STATE(443),
    [sym_monitor_statement] = STATE(443),
    [sym_start_statement] = STATE(443),
    [sym_stop_statement] = STATE(443),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [328] = {
    [sym_identifier] = ACTIONS(1492),
    [aux_sym_preproc_include_token1] = ACTIONS(1492),
    [aux_sym_preproc_def_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1492),
    [sym_preproc_directive] = ACTIONS(1492),
    [anon_sym_LPAREN2] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym___extension__] = ACTIONS(1492),
    [anon_sym_typedef] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym___attribute__] = ACTIONS(1492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1494),
    [anon_sym___declspec] = ACTIONS(1492),
    [anon_sym___cdecl] = ACTIONS(1492),
    [anon_sym___clrcall] = ACTIONS(1492),
    [anon_sym___stdcall] = ACTIONS(1492),
    [anon_sym___fastcall] = ACTIONS(1492),
    [anon_sym___thiscall] = ACTIONS(1492),
    [anon_sym___vectorcall] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [anon_sym_signed] = ACTIONS(1492),
    [anon_sym_unsigned] = ACTIONS(1492),
    [anon_sym_long] = ACTIONS(1492),
    [anon_sym_short] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_auto] = ACTIONS(1492),
    [anon_sym_register] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym___inline] = ACTIONS(1492),
    [anon_sym___inline__] = ACTIONS(1492),
    [anon_sym___forceinline] = ACTIONS(1492),
    [anon_sym_thread_local] = ACTIONS(1492),
    [anon_sym___thread] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_constexpr] = ACTIONS(1492),
    [anon_sym_volatile] = ACTIONS(1492),
    [anon_sym_restrict] = ACTIONS(1492),
    [anon_sym___restrict__] = ACTIONS(1492),
    [anon_sym__Atomic] = ACTIONS(1492),
    [anon_sym__Noreturn] = ACTIONS(1492),
    [anon_sym_noreturn] = ACTIONS(1492),
    [sym_primitive_type] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_struct] = ACTIONS(1492),
    [anon_sym_union] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_goto] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_sizeof] = ACTIONS(1492),
    [anon_sym___alignof__] = ACTIONS(1492),
    [anon_sym___alignof] = ACTIONS(1492),
    [anon_sym__alignof] = ACTIONS(1492),
    [anon_sym_alignof] = ACTIONS(1492),
    [anon_sym__Alignof] = ACTIONS(1492),
    [anon_sym_offsetof] = ACTIONS(1492),
    [anon_sym__Generic] = ACTIONS(1492),
    [anon_sym_asm] = ACTIONS(1492),
    [anon_sym___asm__] = ACTIONS(1492),
    [sym_number_literal] = ACTIONS(1494),
    [anon_sym_L_SQUOTE] = ACTIONS(1494),
    [anon_sym_u_SQUOTE] = ACTIONS(1494),
    [anon_sym_U_SQUOTE] = ACTIONS(1494),
    [anon_sym_u8_SQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_L_DQUOTE] = ACTIONS(1494),
    [anon_sym_u_DQUOTE] = ACTIONS(1494),
    [anon_sym_U_DQUOTE] = ACTIONS(1494),
    [anon_sym_u8_DQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [anon_sym_NULL] = ACTIONS(1492),
    [anon_sym_nullptr] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1492),
    [anon_sym_acquire] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_monitor] = ACTIONS(1492),
    [anon_sym_start] = ACTIONS(1492),
    [anon_sym_stop] = ACTIONS(1492),
  },
  [329] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(438),
    [sym_attributed_statement] = STATE(438),
    [sym_labeled_statement] = STATE(438),
    [sym_expression_statement] = STATE(438),
    [sym_if_statement] = STATE(438),
    [sym_switch_statement] = STATE(438),
    [sym_case_statement] = STATE(438),
    [sym_while_statement] = STATE(438),
    [sym_do_statement] = STATE(438),
    [sym_for_statement] = STATE(438),
    [sym_return_statement] = STATE(438),
    [sym_break_statement] = STATE(438),
    [sym_continue_statement] = STATE(438),
    [sym_goto_statement] = STATE(438),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(438),
    [sym_acquire_statement] = STATE(438),
    [sym_monitor_statement] = STATE(438),
    [sym_start_statement] = STATE(438),
    [sym_stop_statement] = STATE(438),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [330] = {
    [sym_identifier] = ACTIONS(1496),
    [aux_sym_preproc_include_token1] = ACTIONS(1496),
    [aux_sym_preproc_def_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1496),
    [sym_preproc_directive] = ACTIONS(1496),
    [anon_sym_LPAREN2] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym___extension__] = ACTIONS(1496),
    [anon_sym_typedef] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym___attribute__] = ACTIONS(1496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1498),
    [anon_sym___declspec] = ACTIONS(1496),
    [anon_sym___cdecl] = ACTIONS(1496),
    [anon_sym___clrcall] = ACTIONS(1496),
    [anon_sym___stdcall] = ACTIONS(1496),
    [anon_sym___fastcall] = ACTIONS(1496),
    [anon_sym___thiscall] = ACTIONS(1496),
    [anon_sym___vectorcall] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [anon_sym_signed] = ACTIONS(1496),
    [anon_sym_unsigned] = ACTIONS(1496),
    [anon_sym_long] = ACTIONS(1496),
    [anon_sym_short] = ACTIONS(1496),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_auto] = ACTIONS(1496),
    [anon_sym_register] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym___inline] = ACTIONS(1496),
    [anon_sym___inline__] = ACTIONS(1496),
    [anon_sym___forceinline] = ACTIONS(1496),
    [anon_sym_thread_local] = ACTIONS(1496),
    [anon_sym___thread] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_constexpr] = ACTIONS(1496),
    [anon_sym_volatile] = ACTIONS(1496),
    [anon_sym_restrict] = ACTIONS(1496),
    [anon_sym___restrict__] = ACTIONS(1496),
    [anon_sym__Atomic] = ACTIONS(1496),
    [anon_sym__Noreturn] = ACTIONS(1496),
    [anon_sym_noreturn] = ACTIONS(1496),
    [sym_primitive_type] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_struct] = ACTIONS(1496),
    [anon_sym_union] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_goto] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_sizeof] = ACTIONS(1496),
    [anon_sym___alignof__] = ACTIONS(1496),
    [anon_sym___alignof] = ACTIONS(1496),
    [anon_sym__alignof] = ACTIONS(1496),
    [anon_sym_alignof] = ACTIONS(1496),
    [anon_sym__Alignof] = ACTIONS(1496),
    [anon_sym_offsetof] = ACTIONS(1496),
    [anon_sym__Generic] = ACTIONS(1496),
    [anon_sym_asm] = ACTIONS(1496),
    [anon_sym___asm__] = ACTIONS(1496),
    [sym_number_literal] = ACTIONS(1498),
    [anon_sym_L_SQUOTE] = ACTIONS(1498),
    [anon_sym_u_SQUOTE] = ACTIONS(1498),
    [anon_sym_U_SQUOTE] = ACTIONS(1498),
    [anon_sym_u8_SQUOTE] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_L_DQUOTE] = ACTIONS(1498),
    [anon_sym_u_DQUOTE] = ACTIONS(1498),
    [anon_sym_U_DQUOTE] = ACTIONS(1498),
    [anon_sym_u8_DQUOTE] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [anon_sym_NULL] = ACTIONS(1496),
    [anon_sym_nullptr] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1496),
    [anon_sym_acquire] = ACTIONS(1496),
    [anon_sym_catch] = ACTIONS(1496),
    [anon_sym_monitor] = ACTIONS(1496),
    [anon_sym_start] = ACTIONS(1496),
    [anon_sym_stop] = ACTIONS(1496),
  },
  [331] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(100),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_case_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(100),
    [sym_acquire_statement] = STATE(100),
    [sym_monitor_statement] = STATE(100),
    [sym_start_statement] = STATE(100),
    [sym_stop_statement] = STATE(100),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [332] = {
    [sym_identifier] = ACTIONS(1549),
    [aux_sym_preproc_include_token1] = ACTIONS(1549),
    [aux_sym_preproc_def_token1] = ACTIONS(1549),
    [aux_sym_preproc_if_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1549),
    [sym_preproc_directive] = ACTIONS(1549),
    [anon_sym_LPAREN2] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym___extension__] = ACTIONS(1549),
    [anon_sym_typedef] = ACTIONS(1549),
    [anon_sym_extern] = ACTIONS(1549),
    [anon_sym___attribute__] = ACTIONS(1549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1551),
    [anon_sym___declspec] = ACTIONS(1549),
    [anon_sym___cdecl] = ACTIONS(1549),
    [anon_sym___clrcall] = ACTIONS(1549),
    [anon_sym___stdcall] = ACTIONS(1549),
    [anon_sym___fastcall] = ACTIONS(1549),
    [anon_sym___thiscall] = ACTIONS(1549),
    [anon_sym___vectorcall] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_signed] = ACTIONS(1549),
    [anon_sym_unsigned] = ACTIONS(1549),
    [anon_sym_long] = ACTIONS(1549),
    [anon_sym_short] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_auto] = ACTIONS(1549),
    [anon_sym_register] = ACTIONS(1549),
    [anon_sym_inline] = ACTIONS(1549),
    [anon_sym___inline] = ACTIONS(1549),
    [anon_sym___inline__] = ACTIONS(1549),
    [anon_sym___forceinline] = ACTIONS(1549),
    [anon_sym_thread_local] = ACTIONS(1549),
    [anon_sym___thread] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_constexpr] = ACTIONS(1549),
    [anon_sym_volatile] = ACTIONS(1549),
    [anon_sym_restrict] = ACTIONS(1549),
    [anon_sym___restrict__] = ACTIONS(1549),
    [anon_sym__Atomic] = ACTIONS(1549),
    [anon_sym__Noreturn] = ACTIONS(1549),
    [anon_sym_noreturn] = ACTIONS(1549),
    [sym_primitive_type] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [anon_sym_struct] = ACTIONS(1549),
    [anon_sym_union] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_goto] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1549),
    [anon_sym___alignof__] = ACTIONS(1549),
    [anon_sym___alignof] = ACTIONS(1549),
    [anon_sym__alignof] = ACTIONS(1549),
    [anon_sym_alignof] = ACTIONS(1549),
    [anon_sym__Alignof] = ACTIONS(1549),
    [anon_sym_offsetof] = ACTIONS(1549),
    [anon_sym__Generic] = ACTIONS(1549),
    [anon_sym_asm] = ACTIONS(1549),
    [anon_sym___asm__] = ACTIONS(1549),
    [sym_number_literal] = ACTIONS(1551),
    [anon_sym_L_SQUOTE] = ACTIONS(1551),
    [anon_sym_u_SQUOTE] = ACTIONS(1551),
    [anon_sym_U_SQUOTE] = ACTIONS(1551),
    [anon_sym_u8_SQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_L_DQUOTE] = ACTIONS(1551),
    [anon_sym_u_DQUOTE] = ACTIONS(1551),
    [anon_sym_U_DQUOTE] = ACTIONS(1551),
    [anon_sym_u8_DQUOTE] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [anon_sym_NULL] = ACTIONS(1549),
    [anon_sym_nullptr] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_acquire] = ACTIONS(1549),
    [anon_sym_catch] = ACTIONS(1549),
    [anon_sym_monitor] = ACTIONS(1549),
    [anon_sym_start] = ACTIONS(1549),
    [anon_sym_stop] = ACTIONS(1549),
  },
  [333] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [334] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(430),
    [sym_attributed_statement] = STATE(430),
    [sym_labeled_statement] = STATE(430),
    [sym_expression_statement] = STATE(430),
    [sym_if_statement] = STATE(430),
    [sym_switch_statement] = STATE(430),
    [sym_case_statement] = STATE(430),
    [sym_while_statement] = STATE(430),
    [sym_do_statement] = STATE(430),
    [sym_for_statement] = STATE(430),
    [sym_return_statement] = STATE(430),
    [sym_break_statement] = STATE(430),
    [sym_continue_statement] = STATE(430),
    [sym_goto_statement] = STATE(430),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(430),
    [sym_acquire_statement] = STATE(430),
    [sym_monitor_statement] = STATE(430),
    [sym_start_statement] = STATE(430),
    [sym_stop_statement] = STATE(430),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [335] = {
    [sym_identifier] = ACTIONS(1545),
    [aux_sym_preproc_include_token1] = ACTIONS(1545),
    [aux_sym_preproc_def_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1545),
    [sym_preproc_directive] = ACTIONS(1545),
    [anon_sym_LPAREN2] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym___extension__] = ACTIONS(1545),
    [anon_sym_typedef] = ACTIONS(1545),
    [anon_sym_extern] = ACTIONS(1545),
    [anon_sym___attribute__] = ACTIONS(1545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1547),
    [anon_sym___declspec] = ACTIONS(1545),
    [anon_sym___cdecl] = ACTIONS(1545),
    [anon_sym___clrcall] = ACTIONS(1545),
    [anon_sym___stdcall] = ACTIONS(1545),
    [anon_sym___fastcall] = ACTIONS(1545),
    [anon_sym___thiscall] = ACTIONS(1545),
    [anon_sym___vectorcall] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1547),
    [anon_sym_signed] = ACTIONS(1545),
    [anon_sym_unsigned] = ACTIONS(1545),
    [anon_sym_long] = ACTIONS(1545),
    [anon_sym_short] = ACTIONS(1545),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_auto] = ACTIONS(1545),
    [anon_sym_register] = ACTIONS(1545),
    [anon_sym_inline] = ACTIONS(1545),
    [anon_sym___inline] = ACTIONS(1545),
    [anon_sym___inline__] = ACTIONS(1545),
    [anon_sym___forceinline] = ACTIONS(1545),
    [anon_sym_thread_local] = ACTIONS(1545),
    [anon_sym___thread] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_constexpr] = ACTIONS(1545),
    [anon_sym_volatile] = ACTIONS(1545),
    [anon_sym_restrict] = ACTIONS(1545),
    [anon_sym___restrict__] = ACTIONS(1545),
    [anon_sym__Atomic] = ACTIONS(1545),
    [anon_sym__Noreturn] = ACTIONS(1545),
    [anon_sym_noreturn] = ACTIONS(1545),
    [sym_primitive_type] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [anon_sym_struct] = ACTIONS(1545),
    [anon_sym_union] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_sizeof] = ACTIONS(1545),
    [anon_sym___alignof__] = ACTIONS(1545),
    [anon_sym___alignof] = ACTIONS(1545),
    [anon_sym__alignof] = ACTIONS(1545),
    [anon_sym_alignof] = ACTIONS(1545),
    [anon_sym__Alignof] = ACTIONS(1545),
    [anon_sym_offsetof] = ACTIONS(1545),
    [anon_sym__Generic] = ACTIONS(1545),
    [anon_sym_asm] = ACTIONS(1545),
    [anon_sym___asm__] = ACTIONS(1545),
    [sym_number_literal] = ACTIONS(1547),
    [anon_sym_L_SQUOTE] = ACTIONS(1547),
    [anon_sym_u_SQUOTE] = ACTIONS(1547),
    [anon_sym_U_SQUOTE] = ACTIONS(1547),
    [anon_sym_u8_SQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [anon_sym_L_DQUOTE] = ACTIONS(1547),
    [anon_sym_u_DQUOTE] = ACTIONS(1547),
    [anon_sym_U_DQUOTE] = ACTIONS(1547),
    [anon_sym_u8_DQUOTE] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [anon_sym_NULL] = ACTIONS(1545),
    [anon_sym_nullptr] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1545),
    [anon_sym_acquire] = ACTIONS(1545),
    [anon_sym_catch] = ACTIONS(1545),
    [anon_sym_monitor] = ACTIONS(1545),
    [anon_sym_start] = ACTIONS(1545),
    [anon_sym_stop] = ACTIONS(1545),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1601),
    [aux_sym_preproc_include_token1] = ACTIONS(1601),
    [aux_sym_preproc_def_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token2] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1601),
    [aux_sym_preproc_else_token1] = ACTIONS(1601),
    [aux_sym_preproc_elif_token1] = ACTIONS(1601),
    [sym_preproc_directive] = ACTIONS(1601),
    [anon_sym_LPAREN2] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym___extension__] = ACTIONS(1601),
    [anon_sym_typedef] = ACTIONS(1601),
    [anon_sym_extern] = ACTIONS(1601),
    [anon_sym___attribute__] = ACTIONS(1601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1603),
    [anon_sym___declspec] = ACTIONS(1601),
    [anon_sym___cdecl] = ACTIONS(1601),
    [anon_sym___clrcall] = ACTIONS(1601),
    [anon_sym___stdcall] = ACTIONS(1601),
    [anon_sym___fastcall] = ACTIONS(1601),
    [anon_sym___thiscall] = ACTIONS(1601),
    [anon_sym___vectorcall] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_signed] = ACTIONS(1601),
    [anon_sym_unsigned] = ACTIONS(1601),
    [anon_sym_long] = ACTIONS(1601),
    [anon_sym_short] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1601),
    [anon_sym_auto] = ACTIONS(1601),
    [anon_sym_register] = ACTIONS(1601),
    [anon_sym_inline] = ACTIONS(1601),
    [anon_sym___inline] = ACTIONS(1601),
    [anon_sym___inline__] = ACTIONS(1601),
    [anon_sym___forceinline] = ACTIONS(1601),
    [anon_sym_thread_local] = ACTIONS(1601),
    [anon_sym___thread] = ACTIONS(1601),
    [anon_sym_const] = ACTIONS(1601),
    [anon_sym_constexpr] = ACTIONS(1601),
    [anon_sym_volatile] = ACTIONS(1601),
    [anon_sym_restrict] = ACTIONS(1601),
    [anon_sym___restrict__] = ACTIONS(1601),
    [anon_sym__Atomic] = ACTIONS(1601),
    [anon_sym__Noreturn] = ACTIONS(1601),
    [anon_sym_noreturn] = ACTIONS(1601),
    [sym_primitive_type] = ACTIONS(1601),
    [anon_sym_enum] = ACTIONS(1601),
    [anon_sym_struct] = ACTIONS(1601),
    [anon_sym_union] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_switch] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_while] = ACTIONS(1601),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1601),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1601),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_goto] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_sizeof] = ACTIONS(1601),
    [anon_sym___alignof__] = ACTIONS(1601),
    [anon_sym___alignof] = ACTIONS(1601),
    [anon_sym__alignof] = ACTIONS(1601),
    [anon_sym_alignof] = ACTIONS(1601),
    [anon_sym__Alignof] = ACTIONS(1601),
    [anon_sym_offsetof] = ACTIONS(1601),
    [anon_sym__Generic] = ACTIONS(1601),
    [anon_sym_asm] = ACTIONS(1601),
    [anon_sym___asm__] = ACTIONS(1601),
    [sym_number_literal] = ACTIONS(1603),
    [anon_sym_L_SQUOTE] = ACTIONS(1603),
    [anon_sym_u_SQUOTE] = ACTIONS(1603),
    [anon_sym_U_SQUOTE] = ACTIONS(1603),
    [anon_sym_u8_SQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [anon_sym_L_DQUOTE] = ACTIONS(1603),
    [anon_sym_u_DQUOTE] = ACTIONS(1603),
    [anon_sym_U_DQUOTE] = ACTIONS(1603),
    [anon_sym_u8_DQUOTE] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [anon_sym_NULL] = ACTIONS(1601),
    [anon_sym_nullptr] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1601),
    [anon_sym_acquire] = ACTIONS(1601),
    [anon_sym_monitor] = ACTIONS(1601),
    [anon_sym_start] = ACTIONS(1601),
    [anon_sym_stop] = ACTIONS(1601),
  },
  [337] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1515),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1515),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_else] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1515),
    [anon_sym_L_SQUOTE] = ACTIONS(1515),
    [anon_sym_u_SQUOTE] = ACTIONS(1515),
    [anon_sym_U_SQUOTE] = ACTIONS(1515),
    [anon_sym_u8_SQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [anon_sym_L_DQUOTE] = ACTIONS(1515),
    [anon_sym_u_DQUOTE] = ACTIONS(1515),
    [anon_sym_U_DQUOTE] = ACTIONS(1515),
    [anon_sym_u8_DQUOTE] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1513),
    [anon_sym_acquire] = ACTIONS(1513),
    [anon_sym_catch] = ACTIONS(1513),
    [anon_sym_monitor] = ACTIONS(1513),
    [anon_sym_start] = ACTIONS(1513),
    [anon_sym_stop] = ACTIONS(1513),
  },
  [338] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token2] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1506),
    [anon_sym_acquire] = ACTIONS(1506),
    [anon_sym_catch] = ACTIONS(1506),
    [anon_sym_monitor] = ACTIONS(1506),
    [anon_sym_start] = ACTIONS(1506),
    [anon_sym_stop] = ACTIONS(1506),
  },
  [339] = {
    [sym_attribute_declaration] = STATE(297),
    [sym_compound_statement] = STATE(258),
    [sym_attributed_statement] = STATE(258),
    [sym_labeled_statement] = STATE(258),
    [sym_expression_statement] = STATE(258),
    [sym_if_statement] = STATE(258),
    [sym_switch_statement] = STATE(258),
    [sym_case_statement] = STATE(258),
    [sym_while_statement] = STATE(258),
    [sym_do_statement] = STATE(258),
    [sym_for_statement] = STATE(258),
    [sym_return_statement] = STATE(258),
    [sym_break_statement] = STATE(258),
    [sym_continue_statement] = STATE(258),
    [sym_goto_statement] = STATE(258),
    [sym__expression] = STATE(1101),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1750),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(258),
    [sym_acquire_statement] = STATE(258),
    [sym_monitor_statement] = STATE(258),
    [sym_start_statement] = STATE(258),
    [sym_stop_statement] = STATE(258),
    [aux_sym_attributed_declarator_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_acquire] = ACTIONS(811),
    [anon_sym_monitor] = ACTIONS(813),
    [anon_sym_start] = ACTIONS(815),
    [anon_sym_stop] = ACTIONS(817),
  },
  [340] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [341] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [342] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [343] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [344] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [346] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [347] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [348] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [349] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token2] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1515),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1515),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_else] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1515),
    [anon_sym_L_SQUOTE] = ACTIONS(1515),
    [anon_sym_u_SQUOTE] = ACTIONS(1515),
    [anon_sym_U_SQUOTE] = ACTIONS(1515),
    [anon_sym_u8_SQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [anon_sym_L_DQUOTE] = ACTIONS(1515),
    [anon_sym_u_DQUOTE] = ACTIONS(1515),
    [anon_sym_U_DQUOTE] = ACTIONS(1515),
    [anon_sym_u8_DQUOTE] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1513),
    [anon_sym_acquire] = ACTIONS(1513),
    [anon_sym_catch] = ACTIONS(1513),
    [anon_sym_monitor] = ACTIONS(1513),
    [anon_sym_start] = ACTIONS(1513),
    [anon_sym_stop] = ACTIONS(1513),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [355] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [356] = {
    [sym_identifier] = ACTIONS(1615),
    [aux_sym_preproc_include_token1] = ACTIONS(1615),
    [aux_sym_preproc_def_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token2] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1615),
    [aux_sym_preproc_else_token1] = ACTIONS(1615),
    [aux_sym_preproc_elif_token1] = ACTIONS(1615),
    [sym_preproc_directive] = ACTIONS(1615),
    [anon_sym_LPAREN2] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym___extension__] = ACTIONS(1615),
    [anon_sym_typedef] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym___attribute__] = ACTIONS(1615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1617),
    [anon_sym___declspec] = ACTIONS(1615),
    [anon_sym___cdecl] = ACTIONS(1615),
    [anon_sym___clrcall] = ACTIONS(1615),
    [anon_sym___stdcall] = ACTIONS(1615),
    [anon_sym___fastcall] = ACTIONS(1615),
    [anon_sym___thiscall] = ACTIONS(1615),
    [anon_sym___vectorcall] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_signed] = ACTIONS(1615),
    [anon_sym_unsigned] = ACTIONS(1615),
    [anon_sym_long] = ACTIONS(1615),
    [anon_sym_short] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_auto] = ACTIONS(1615),
    [anon_sym_register] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym___inline] = ACTIONS(1615),
    [anon_sym___inline__] = ACTIONS(1615),
    [anon_sym___forceinline] = ACTIONS(1615),
    [anon_sym_thread_local] = ACTIONS(1615),
    [anon_sym___thread] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_constexpr] = ACTIONS(1615),
    [anon_sym_volatile] = ACTIONS(1615),
    [anon_sym_restrict] = ACTIONS(1615),
    [anon_sym___restrict__] = ACTIONS(1615),
    [anon_sym__Atomic] = ACTIONS(1615),
    [anon_sym__Noreturn] = ACTIONS(1615),
    [anon_sym_noreturn] = ACTIONS(1615),
    [sym_primitive_type] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_goto] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_sizeof] = ACTIONS(1615),
    [anon_sym___alignof__] = ACTIONS(1615),
    [anon_sym___alignof] = ACTIONS(1615),
    [anon_sym__alignof] = ACTIONS(1615),
    [anon_sym_alignof] = ACTIONS(1615),
    [anon_sym__Alignof] = ACTIONS(1615),
    [anon_sym_offsetof] = ACTIONS(1615),
    [anon_sym__Generic] = ACTIONS(1615),
    [anon_sym_asm] = ACTIONS(1615),
    [anon_sym___asm__] = ACTIONS(1615),
    [sym_number_literal] = ACTIONS(1617),
    [anon_sym_L_SQUOTE] = ACTIONS(1617),
    [anon_sym_u_SQUOTE] = ACTIONS(1617),
    [anon_sym_U_SQUOTE] = ACTIONS(1617),
    [anon_sym_u8_SQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [anon_sym_L_DQUOTE] = ACTIONS(1617),
    [anon_sym_u_DQUOTE] = ACTIONS(1617),
    [anon_sym_U_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8_DQUOTE] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_true] = ACTIONS(1615),
    [sym_false] = ACTIONS(1615),
    [anon_sym_NULL] = ACTIONS(1615),
    [anon_sym_nullptr] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1615),
    [anon_sym_acquire] = ACTIONS(1615),
    [anon_sym_monitor] = ACTIONS(1615),
    [anon_sym_start] = ACTIONS(1615),
    [anon_sym_stop] = ACTIONS(1615),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [358] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [360] = {
    [sym_identifier] = ACTIONS(1644),
    [aux_sym_preproc_include_token1] = ACTIONS(1644),
    [aux_sym_preproc_def_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token2] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1644),
    [aux_sym_preproc_else_token1] = ACTIONS(1644),
    [aux_sym_preproc_elif_token1] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_LPAREN2] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym___extension__] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym___attribute__] = ACTIONS(1644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1646),
    [anon_sym___declspec] = ACTIONS(1644),
    [anon_sym___cdecl] = ACTIONS(1644),
    [anon_sym___clrcall] = ACTIONS(1644),
    [anon_sym___stdcall] = ACTIONS(1644),
    [anon_sym___fastcall] = ACTIONS(1644),
    [anon_sym___thiscall] = ACTIONS(1644),
    [anon_sym___vectorcall] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_signed] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym___inline] = ACTIONS(1644),
    [anon_sym___inline__] = ACTIONS(1644),
    [anon_sym___forceinline] = ACTIONS(1644),
    [anon_sym_thread_local] = ACTIONS(1644),
    [anon_sym___thread] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_constexpr] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym___restrict__] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym__Noreturn] = ACTIONS(1644),
    [anon_sym_noreturn] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1646),
    [anon_sym_sizeof] = ACTIONS(1644),
    [anon_sym___alignof__] = ACTIONS(1644),
    [anon_sym___alignof] = ACTIONS(1644),
    [anon_sym__alignof] = ACTIONS(1644),
    [anon_sym_alignof] = ACTIONS(1644),
    [anon_sym__Alignof] = ACTIONS(1644),
    [anon_sym_offsetof] = ACTIONS(1644),
    [anon_sym__Generic] = ACTIONS(1644),
    [anon_sym_asm] = ACTIONS(1644),
    [anon_sym___asm__] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1646),
    [anon_sym_L_SQUOTE] = ACTIONS(1646),
    [anon_sym_u_SQUOTE] = ACTIONS(1646),
    [anon_sym_U_SQUOTE] = ACTIONS(1646),
    [anon_sym_u8_SQUOTE] = ACTIONS(1646),
    [anon_sym_SQUOTE] = ACTIONS(1646),
    [anon_sym_L_DQUOTE] = ACTIONS(1646),
    [anon_sym_u_DQUOTE] = ACTIONS(1646),
    [anon_sym_U_DQUOTE] = ACTIONS(1646),
    [anon_sym_u8_DQUOTE] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1646),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [anon_sym_NULL] = ACTIONS(1644),
    [anon_sym_nullptr] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1644),
    [anon_sym_acquire] = ACTIONS(1644),
    [anon_sym_monitor] = ACTIONS(1644),
    [anon_sym_start] = ACTIONS(1644),
    [anon_sym_stop] = ACTIONS(1644),
  },
  [361] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(456),
    [sym_attributed_statement] = STATE(456),
    [sym_labeled_statement] = STATE(456),
    [sym_expression_statement] = STATE(456),
    [sym_if_statement] = STATE(456),
    [sym_switch_statement] = STATE(456),
    [sym_case_statement] = STATE(456),
    [sym_while_statement] = STATE(456),
    [sym_do_statement] = STATE(456),
    [sym_for_statement] = STATE(456),
    [sym_return_statement] = STATE(456),
    [sym_break_statement] = STATE(456),
    [sym_continue_statement] = STATE(456),
    [sym_goto_statement] = STATE(456),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(456),
    [sym_acquire_statement] = STATE(456),
    [sym_monitor_statement] = STATE(456),
    [sym_start_statement] = STATE(456),
    [sym_stop_statement] = STATE(456),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [362] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(457),
    [sym_attributed_statement] = STATE(457),
    [sym_labeled_statement] = STATE(457),
    [sym_expression_statement] = STATE(457),
    [sym_if_statement] = STATE(457),
    [sym_switch_statement] = STATE(457),
    [sym_case_statement] = STATE(457),
    [sym_while_statement] = STATE(457),
    [sym_do_statement] = STATE(457),
    [sym_for_statement] = STATE(457),
    [sym_return_statement] = STATE(457),
    [sym_break_statement] = STATE(457),
    [sym_continue_statement] = STATE(457),
    [sym_goto_statement] = STATE(457),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(457),
    [sym_acquire_statement] = STATE(457),
    [sym_monitor_statement] = STATE(457),
    [sym_start_statement] = STATE(457),
    [sym_stop_statement] = STATE(457),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [363] = {
    [sym_attribute_declaration] = STATE(323),
    [sym_compound_statement] = STATE(126),
    [sym_attributed_statement] = STATE(126),
    [sym_labeled_statement] = STATE(126),
    [sym_expression_statement] = STATE(126),
    [sym_if_statement] = STATE(126),
    [sym_switch_statement] = STATE(126),
    [sym_case_statement] = STATE(126),
    [sym_while_statement] = STATE(126),
    [sym_do_statement] = STATE(126),
    [sym_for_statement] = STATE(126),
    [sym_return_statement] = STATE(126),
    [sym_break_statement] = STATE(126),
    [sym_continue_statement] = STATE(126),
    [sym_goto_statement] = STATE(126),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(126),
    [sym_acquire_statement] = STATE(126),
    [sym_monitor_statement] = STATE(126),
    [sym_start_statement] = STATE(126),
    [sym_stop_statement] = STATE(126),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [364] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [365] = {
    [sym_identifier] = ACTIONS(1652),
    [aux_sym_preproc_include_token1] = ACTIONS(1652),
    [aux_sym_preproc_def_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token2] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1652),
    [aux_sym_preproc_else_token1] = ACTIONS(1652),
    [aux_sym_preproc_elif_token1] = ACTIONS(1652),
    [sym_preproc_directive] = ACTIONS(1652),
    [anon_sym_LPAREN2] = ACTIONS(1654),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym___extension__] = ACTIONS(1652),
    [anon_sym_typedef] = ACTIONS(1652),
    [anon_sym_extern] = ACTIONS(1652),
    [anon_sym___attribute__] = ACTIONS(1652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1654),
    [anon_sym___declspec] = ACTIONS(1652),
    [anon_sym___cdecl] = ACTIONS(1652),
    [anon_sym___clrcall] = ACTIONS(1652),
    [anon_sym___stdcall] = ACTIONS(1652),
    [anon_sym___fastcall] = ACTIONS(1652),
    [anon_sym___thiscall] = ACTIONS(1652),
    [anon_sym___vectorcall] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_signed] = ACTIONS(1652),
    [anon_sym_unsigned] = ACTIONS(1652),
    [anon_sym_long] = ACTIONS(1652),
    [anon_sym_short] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_auto] = ACTIONS(1652),
    [anon_sym_register] = ACTIONS(1652),
    [anon_sym_inline] = ACTIONS(1652),
    [anon_sym___inline] = ACTIONS(1652),
    [anon_sym___inline__] = ACTIONS(1652),
    [anon_sym___forceinline] = ACTIONS(1652),
    [anon_sym_thread_local] = ACTIONS(1652),
    [anon_sym___thread] = ACTIONS(1652),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_constexpr] = ACTIONS(1652),
    [anon_sym_volatile] = ACTIONS(1652),
    [anon_sym_restrict] = ACTIONS(1652),
    [anon_sym___restrict__] = ACTIONS(1652),
    [anon_sym__Atomic] = ACTIONS(1652),
    [anon_sym__Noreturn] = ACTIONS(1652),
    [anon_sym_noreturn] = ACTIONS(1652),
    [sym_primitive_type] = ACTIONS(1652),
    [anon_sym_enum] = ACTIONS(1652),
    [anon_sym_struct] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_if] = ACTIONS(1652),
    [anon_sym_switch] = ACTIONS(1652),
    [anon_sym_case] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_while] = ACTIONS(1652),
    [anon_sym_do] = ACTIONS(1652),
    [anon_sym_for] = ACTIONS(1652),
    [anon_sym_return] = ACTIONS(1652),
    [anon_sym_break] = ACTIONS(1652),
    [anon_sym_continue] = ACTIONS(1652),
    [anon_sym_goto] = ACTIONS(1652),
    [anon_sym_DASH_DASH] = ACTIONS(1654),
    [anon_sym_PLUS_PLUS] = ACTIONS(1654),
    [anon_sym_sizeof] = ACTIONS(1652),
    [anon_sym___alignof__] = ACTIONS(1652),
    [anon_sym___alignof] = ACTIONS(1652),
    [anon_sym__alignof] = ACTIONS(1652),
    [anon_sym_alignof] = ACTIONS(1652),
    [anon_sym__Alignof] = ACTIONS(1652),
    [anon_sym_offsetof] = ACTIONS(1652),
    [anon_sym__Generic] = ACTIONS(1652),
    [anon_sym_asm] = ACTIONS(1652),
    [anon_sym___asm__] = ACTIONS(1652),
    [sym_number_literal] = ACTIONS(1654),
    [anon_sym_L_SQUOTE] = ACTIONS(1654),
    [anon_sym_u_SQUOTE] = ACTIONS(1654),
    [anon_sym_U_SQUOTE] = ACTIONS(1654),
    [anon_sym_u8_SQUOTE] = ACTIONS(1654),
    [anon_sym_SQUOTE] = ACTIONS(1654),
    [anon_sym_L_DQUOTE] = ACTIONS(1654),
    [anon_sym_u_DQUOTE] = ACTIONS(1654),
    [anon_sym_U_DQUOTE] = ACTIONS(1654),
    [anon_sym_u8_DQUOTE] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [sym_true] = ACTIONS(1652),
    [sym_false] = ACTIONS(1652),
    [anon_sym_NULL] = ACTIONS(1652),
    [anon_sym_nullptr] = ACTIONS(1652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1652),
    [anon_sym_acquire] = ACTIONS(1652),
    [anon_sym_monitor] = ACTIONS(1652),
    [anon_sym_start] = ACTIONS(1652),
    [anon_sym_stop] = ACTIONS(1652),
  },
  [366] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(239),
    [sym_attributed_statement] = STATE(239),
    [sym_labeled_statement] = STATE(239),
    [sym_expression_statement] = STATE(239),
    [sym_if_statement] = STATE(239),
    [sym_switch_statement] = STATE(239),
    [sym_case_statement] = STATE(239),
    [sym_while_statement] = STATE(239),
    [sym_do_statement] = STATE(239),
    [sym_for_statement] = STATE(239),
    [sym_return_statement] = STATE(239),
    [sym_break_statement] = STATE(239),
    [sym_continue_statement] = STATE(239),
    [sym_goto_statement] = STATE(239),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(239),
    [sym_acquire_statement] = STATE(239),
    [sym_monitor_statement] = STATE(239),
    [sym_start_statement] = STATE(239),
    [sym_stop_statement] = STATE(239),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [367] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(218),
    [sym_attributed_statement] = STATE(218),
    [sym_labeled_statement] = STATE(218),
    [sym_expression_statement] = STATE(218),
    [sym_if_statement] = STATE(218),
    [sym_switch_statement] = STATE(218),
    [sym_case_statement] = STATE(218),
    [sym_while_statement] = STATE(218),
    [sym_do_statement] = STATE(218),
    [sym_for_statement] = STATE(218),
    [sym_return_statement] = STATE(218),
    [sym_break_statement] = STATE(218),
    [sym_continue_statement] = STATE(218),
    [sym_goto_statement] = STATE(218),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(218),
    [sym_acquire_statement] = STATE(218),
    [sym_monitor_statement] = STATE(218),
    [sym_start_statement] = STATE(218),
    [sym_stop_statement] = STATE(218),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [368] = {
    [sym_identifier] = ACTIONS(1541),
    [aux_sym_preproc_include_token1] = ACTIONS(1541),
    [aux_sym_preproc_def_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1541),
    [sym_preproc_directive] = ACTIONS(1541),
    [anon_sym_LPAREN2] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym___extension__] = ACTIONS(1541),
    [anon_sym_typedef] = ACTIONS(1541),
    [anon_sym_extern] = ACTIONS(1541),
    [anon_sym___attribute__] = ACTIONS(1541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1543),
    [anon_sym___declspec] = ACTIONS(1541),
    [anon_sym___cdecl] = ACTIONS(1541),
    [anon_sym___clrcall] = ACTIONS(1541),
    [anon_sym___stdcall] = ACTIONS(1541),
    [anon_sym___fastcall] = ACTIONS(1541),
    [anon_sym___thiscall] = ACTIONS(1541),
    [anon_sym___vectorcall] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_RBRACE] = ACTIONS(1543),
    [anon_sym_signed] = ACTIONS(1541),
    [anon_sym_unsigned] = ACTIONS(1541),
    [anon_sym_long] = ACTIONS(1541),
    [anon_sym_short] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_auto] = ACTIONS(1541),
    [anon_sym_register] = ACTIONS(1541),
    [anon_sym_inline] = ACTIONS(1541),
    [anon_sym___inline] = ACTIONS(1541),
    [anon_sym___inline__] = ACTIONS(1541),
    [anon_sym___forceinline] = ACTIONS(1541),
    [anon_sym_thread_local] = ACTIONS(1541),
    [anon_sym___thread] = ACTIONS(1541),
    [anon_sym_const] = ACTIONS(1541),
    [anon_sym_constexpr] = ACTIONS(1541),
    [anon_sym_volatile] = ACTIONS(1541),
    [anon_sym_restrict] = ACTIONS(1541),
    [anon_sym___restrict__] = ACTIONS(1541),
    [anon_sym__Atomic] = ACTIONS(1541),
    [anon_sym__Noreturn] = ACTIONS(1541),
    [anon_sym_noreturn] = ACTIONS(1541),
    [sym_primitive_type] = ACTIONS(1541),
    [anon_sym_enum] = ACTIONS(1541),
    [anon_sym_struct] = ACTIONS(1541),
    [anon_sym_union] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1541),
    [anon_sym_default] = ACTIONS(1541),
    [anon_sym_while] = ACTIONS(1541),
    [anon_sym_do] = ACTIONS(1541),
    [anon_sym_for] = ACTIONS(1541),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1541),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_goto] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1541),
    [anon_sym___alignof__] = ACTIONS(1541),
    [anon_sym___alignof] = ACTIONS(1541),
    [anon_sym__alignof] = ACTIONS(1541),
    [anon_sym_alignof] = ACTIONS(1541),
    [anon_sym__Alignof] = ACTIONS(1541),
    [anon_sym_offsetof] = ACTIONS(1541),
    [anon_sym__Generic] = ACTIONS(1541),
    [anon_sym_asm] = ACTIONS(1541),
    [anon_sym___asm__] = ACTIONS(1541),
    [sym_number_literal] = ACTIONS(1543),
    [anon_sym_L_SQUOTE] = ACTIONS(1543),
    [anon_sym_u_SQUOTE] = ACTIONS(1543),
    [anon_sym_U_SQUOTE] = ACTIONS(1543),
    [anon_sym_u8_SQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_L_DQUOTE] = ACTIONS(1543),
    [anon_sym_u_DQUOTE] = ACTIONS(1543),
    [anon_sym_U_DQUOTE] = ACTIONS(1543),
    [anon_sym_u8_DQUOTE] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [anon_sym_NULL] = ACTIONS(1541),
    [anon_sym_nullptr] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1541),
    [anon_sym_acquire] = ACTIONS(1541),
    [anon_sym_catch] = ACTIONS(1541),
    [anon_sym_monitor] = ACTIONS(1541),
    [anon_sym_start] = ACTIONS(1541),
    [anon_sym_stop] = ACTIONS(1541),
  },
  [369] = {
    [sym_identifier] = ACTIONS(1537),
    [aux_sym_preproc_include_token1] = ACTIONS(1537),
    [aux_sym_preproc_def_token1] = ACTIONS(1537),
    [aux_sym_preproc_if_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1537),
    [sym_preproc_directive] = ACTIONS(1537),
    [anon_sym_LPAREN2] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym___extension__] = ACTIONS(1537),
    [anon_sym_typedef] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(1537),
    [anon_sym___attribute__] = ACTIONS(1537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1539),
    [anon_sym___declspec] = ACTIONS(1537),
    [anon_sym___cdecl] = ACTIONS(1537),
    [anon_sym___clrcall] = ACTIONS(1537),
    [anon_sym___stdcall] = ACTIONS(1537),
    [anon_sym___fastcall] = ACTIONS(1537),
    [anon_sym___thiscall] = ACTIONS(1537),
    [anon_sym___vectorcall] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_signed] = ACTIONS(1537),
    [anon_sym_unsigned] = ACTIONS(1537),
    [anon_sym_long] = ACTIONS(1537),
    [anon_sym_short] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_auto] = ACTIONS(1537),
    [anon_sym_register] = ACTIONS(1537),
    [anon_sym_inline] = ACTIONS(1537),
    [anon_sym___inline] = ACTIONS(1537),
    [anon_sym___inline__] = ACTIONS(1537),
    [anon_sym___forceinline] = ACTIONS(1537),
    [anon_sym_thread_local] = ACTIONS(1537),
    [anon_sym___thread] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_constexpr] = ACTIONS(1537),
    [anon_sym_volatile] = ACTIONS(1537),
    [anon_sym_restrict] = ACTIONS(1537),
    [anon_sym___restrict__] = ACTIONS(1537),
    [anon_sym__Atomic] = ACTIONS(1537),
    [anon_sym__Noreturn] = ACTIONS(1537),
    [anon_sym_noreturn] = ACTIONS(1537),
    [sym_primitive_type] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [anon_sym_struct] = ACTIONS(1537),
    [anon_sym_union] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_goto] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_sizeof] = ACTIONS(1537),
    [anon_sym___alignof__] = ACTIONS(1537),
    [anon_sym___alignof] = ACTIONS(1537),
    [anon_sym__alignof] = ACTIONS(1537),
    [anon_sym_alignof] = ACTIONS(1537),
    [anon_sym__Alignof] = ACTIONS(1537),
    [anon_sym_offsetof] = ACTIONS(1537),
    [anon_sym__Generic] = ACTIONS(1537),
    [anon_sym_asm] = ACTIONS(1537),
    [anon_sym___asm__] = ACTIONS(1537),
    [sym_number_literal] = ACTIONS(1539),
    [anon_sym_L_SQUOTE] = ACTIONS(1539),
    [anon_sym_u_SQUOTE] = ACTIONS(1539),
    [anon_sym_U_SQUOTE] = ACTIONS(1539),
    [anon_sym_u8_SQUOTE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [anon_sym_L_DQUOTE] = ACTIONS(1539),
    [anon_sym_u_DQUOTE] = ACTIONS(1539),
    [anon_sym_U_DQUOTE] = ACTIONS(1539),
    [anon_sym_u8_DQUOTE] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1539),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [anon_sym_NULL] = ACTIONS(1537),
    [anon_sym_nullptr] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1537),
    [anon_sym_acquire] = ACTIONS(1537),
    [anon_sym_catch] = ACTIONS(1537),
    [anon_sym_monitor] = ACTIONS(1537),
    [anon_sym_start] = ACTIONS(1537),
    [anon_sym_stop] = ACTIONS(1537),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1623),
    [aux_sym_preproc_include_token1] = ACTIONS(1623),
    [aux_sym_preproc_def_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token2] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1623),
    [aux_sym_preproc_else_token1] = ACTIONS(1623),
    [aux_sym_preproc_elif_token1] = ACTIONS(1623),
    [sym_preproc_directive] = ACTIONS(1623),
    [anon_sym_LPAREN2] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym___extension__] = ACTIONS(1623),
    [anon_sym_typedef] = ACTIONS(1623),
    [anon_sym_extern] = ACTIONS(1623),
    [anon_sym___attribute__] = ACTIONS(1623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1625),
    [anon_sym___declspec] = ACTIONS(1623),
    [anon_sym___cdecl] = ACTIONS(1623),
    [anon_sym___clrcall] = ACTIONS(1623),
    [anon_sym___stdcall] = ACTIONS(1623),
    [anon_sym___fastcall] = ACTIONS(1623),
    [anon_sym___thiscall] = ACTIONS(1623),
    [anon_sym___vectorcall] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_signed] = ACTIONS(1623),
    [anon_sym_unsigned] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_auto] = ACTIONS(1623),
    [anon_sym_register] = ACTIONS(1623),
    [anon_sym_inline] = ACTIONS(1623),
    [anon_sym___inline] = ACTIONS(1623),
    [anon_sym___inline__] = ACTIONS(1623),
    [anon_sym___forceinline] = ACTIONS(1623),
    [anon_sym_thread_local] = ACTIONS(1623),
    [anon_sym___thread] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_constexpr] = ACTIONS(1623),
    [anon_sym_volatile] = ACTIONS(1623),
    [anon_sym_restrict] = ACTIONS(1623),
    [anon_sym___restrict__] = ACTIONS(1623),
    [anon_sym__Atomic] = ACTIONS(1623),
    [anon_sym__Noreturn] = ACTIONS(1623),
    [anon_sym_noreturn] = ACTIONS(1623),
    [sym_primitive_type] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [anon_sym_struct] = ACTIONS(1623),
    [anon_sym_union] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_goto] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_sizeof] = ACTIONS(1623),
    [anon_sym___alignof__] = ACTIONS(1623),
    [anon_sym___alignof] = ACTIONS(1623),
    [anon_sym__alignof] = ACTIONS(1623),
    [anon_sym_alignof] = ACTIONS(1623),
    [anon_sym__Alignof] = ACTIONS(1623),
    [anon_sym_offsetof] = ACTIONS(1623),
    [anon_sym__Generic] = ACTIONS(1623),
    [anon_sym_asm] = ACTIONS(1623),
    [anon_sym___asm__] = ACTIONS(1623),
    [sym_number_literal] = ACTIONS(1625),
    [anon_sym_L_SQUOTE] = ACTIONS(1625),
    [anon_sym_u_SQUOTE] = ACTIONS(1625),
    [anon_sym_U_SQUOTE] = ACTIONS(1625),
    [anon_sym_u8_SQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [anon_sym_L_DQUOTE] = ACTIONS(1625),
    [anon_sym_u_DQUOTE] = ACTIONS(1625),
    [anon_sym_U_DQUOTE] = ACTIONS(1625),
    [anon_sym_u8_DQUOTE] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [anon_sym_NULL] = ACTIONS(1623),
    [anon_sym_nullptr] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1623),
    [anon_sym_acquire] = ACTIONS(1623),
    [anon_sym_monitor] = ACTIONS(1623),
    [anon_sym_start] = ACTIONS(1623),
    [anon_sym_stop] = ACTIONS(1623),
  },
  [371] = {
    [sym_identifier] = ACTIONS(1541),
    [aux_sym_preproc_include_token1] = ACTIONS(1541),
    [aux_sym_preproc_def_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token1] = ACTIONS(1541),
    [aux_sym_preproc_if_token2] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1541),
    [sym_preproc_directive] = ACTIONS(1541),
    [anon_sym_LPAREN2] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym___extension__] = ACTIONS(1541),
    [anon_sym_typedef] = ACTIONS(1541),
    [anon_sym_extern] = ACTIONS(1541),
    [anon_sym___attribute__] = ACTIONS(1541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1543),
    [anon_sym___declspec] = ACTIONS(1541),
    [anon_sym___cdecl] = ACTIONS(1541),
    [anon_sym___clrcall] = ACTIONS(1541),
    [anon_sym___stdcall] = ACTIONS(1541),
    [anon_sym___fastcall] = ACTIONS(1541),
    [anon_sym___thiscall] = ACTIONS(1541),
    [anon_sym___vectorcall] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_signed] = ACTIONS(1541),
    [anon_sym_unsigned] = ACTIONS(1541),
    [anon_sym_long] = ACTIONS(1541),
    [anon_sym_short] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_auto] = ACTIONS(1541),
    [anon_sym_register] = ACTIONS(1541),
    [anon_sym_inline] = ACTIONS(1541),
    [anon_sym___inline] = ACTIONS(1541),
    [anon_sym___inline__] = ACTIONS(1541),
    [anon_sym___forceinline] = ACTIONS(1541),
    [anon_sym_thread_local] = ACTIONS(1541),
    [anon_sym___thread] = ACTIONS(1541),
    [anon_sym_const] = ACTIONS(1541),
    [anon_sym_constexpr] = ACTIONS(1541),
    [anon_sym_volatile] = ACTIONS(1541),
    [anon_sym_restrict] = ACTIONS(1541),
    [anon_sym___restrict__] = ACTIONS(1541),
    [anon_sym__Atomic] = ACTIONS(1541),
    [anon_sym__Noreturn] = ACTIONS(1541),
    [anon_sym_noreturn] = ACTIONS(1541),
    [sym_primitive_type] = ACTIONS(1541),
    [anon_sym_enum] = ACTIONS(1541),
    [anon_sym_struct] = ACTIONS(1541),
    [anon_sym_union] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1541),
    [anon_sym_default] = ACTIONS(1541),
    [anon_sym_while] = ACTIONS(1541),
    [anon_sym_do] = ACTIONS(1541),
    [anon_sym_for] = ACTIONS(1541),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1541),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_goto] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1541),
    [anon_sym___alignof__] = ACTIONS(1541),
    [anon_sym___alignof] = ACTIONS(1541),
    [anon_sym__alignof] = ACTIONS(1541),
    [anon_sym_alignof] = ACTIONS(1541),
    [anon_sym__Alignof] = ACTIONS(1541),
    [anon_sym_offsetof] = ACTIONS(1541),
    [anon_sym__Generic] = ACTIONS(1541),
    [anon_sym_asm] = ACTIONS(1541),
    [anon_sym___asm__] = ACTIONS(1541),
    [sym_number_literal] = ACTIONS(1543),
    [anon_sym_L_SQUOTE] = ACTIONS(1543),
    [anon_sym_u_SQUOTE] = ACTIONS(1543),
    [anon_sym_U_SQUOTE] = ACTIONS(1543),
    [anon_sym_u8_SQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_L_DQUOTE] = ACTIONS(1543),
    [anon_sym_u_DQUOTE] = ACTIONS(1543),
    [anon_sym_U_DQUOTE] = ACTIONS(1543),
    [anon_sym_u8_DQUOTE] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [anon_sym_NULL] = ACTIONS(1541),
    [anon_sym_nullptr] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1541),
    [anon_sym_acquire] = ACTIONS(1541),
    [anon_sym_catch] = ACTIONS(1541),
    [anon_sym_monitor] = ACTIONS(1541),
    [anon_sym_start] = ACTIONS(1541),
    [anon_sym_stop] = ACTIONS(1541),
  },
  [372] = {
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1637),
    [aux_sym_preproc_def_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token2] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1637),
    [aux_sym_preproc_else_token1] = ACTIONS(1637),
    [aux_sym_preproc_elif_token1] = ACTIONS(1637),
    [sym_preproc_directive] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1639),
    [anon_sym_BANG] = ACTIONS(1639),
    [anon_sym_TILDE] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1637),
    [anon_sym_extern] = ACTIONS(1637),
    [anon_sym___attribute__] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1639),
    [anon_sym___declspec] = ACTIONS(1637),
    [anon_sym___cdecl] = ACTIONS(1637),
    [anon_sym___clrcall] = ACTIONS(1637),
    [anon_sym___stdcall] = ACTIONS(1637),
    [anon_sym___fastcall] = ACTIONS(1637),
    [anon_sym___thiscall] = ACTIONS(1637),
    [anon_sym___vectorcall] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1637),
    [anon_sym_unsigned] = ACTIONS(1637),
    [anon_sym_long] = ACTIONS(1637),
    [anon_sym_short] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1637),
    [anon_sym_auto] = ACTIONS(1637),
    [anon_sym_register] = ACTIONS(1637),
    [anon_sym_inline] = ACTIONS(1637),
    [anon_sym___inline] = ACTIONS(1637),
    [anon_sym___inline__] = ACTIONS(1637),
    [anon_sym___forceinline] = ACTIONS(1637),
    [anon_sym_thread_local] = ACTIONS(1637),
    [anon_sym___thread] = ACTIONS(1637),
    [anon_sym_const] = ACTIONS(1637),
    [anon_sym_constexpr] = ACTIONS(1637),
    [anon_sym_volatile] = ACTIONS(1637),
    [anon_sym_restrict] = ACTIONS(1637),
    [anon_sym___restrict__] = ACTIONS(1637),
    [anon_sym__Atomic] = ACTIONS(1637),
    [anon_sym__Noreturn] = ACTIONS(1637),
    [anon_sym_noreturn] = ACTIONS(1637),
    [sym_primitive_type] = ACTIONS(1637),
    [anon_sym_enum] = ACTIONS(1637),
    [anon_sym_struct] = ACTIONS(1637),
    [anon_sym_union] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1637),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1637),
    [anon_sym_default] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1637),
    [anon_sym_do] = ACTIONS(1637),
    [anon_sym_for] = ACTIONS(1637),
    [anon_sym_return] = ACTIONS(1637),
    [anon_sym_break] = ACTIONS(1637),
    [anon_sym_continue] = ACTIONS(1637),
    [anon_sym_goto] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1637),
    [anon_sym___alignof__] = ACTIONS(1637),
    [anon_sym___alignof] = ACTIONS(1637),
    [anon_sym__alignof] = ACTIONS(1637),
    [anon_sym_alignof] = ACTIONS(1637),
    [anon_sym__Alignof] = ACTIONS(1637),
    [anon_sym_offsetof] = ACTIONS(1637),
    [anon_sym__Generic] = ACTIONS(1637),
    [anon_sym_asm] = ACTIONS(1637),
    [anon_sym___asm__] = ACTIONS(1637),
    [sym_number_literal] = ACTIONS(1639),
    [anon_sym_L_SQUOTE] = ACTIONS(1639),
    [anon_sym_u_SQUOTE] = ACTIONS(1639),
    [anon_sym_U_SQUOTE] = ACTIONS(1639),
    [anon_sym_u8_SQUOTE] = ACTIONS(1639),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [anon_sym_L_DQUOTE] = ACTIONS(1639),
    [anon_sym_u_DQUOTE] = ACTIONS(1639),
    [anon_sym_U_DQUOTE] = ACTIONS(1639),
    [anon_sym_u8_DQUOTE] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [anon_sym_NULL] = ACTIONS(1637),
    [anon_sym_nullptr] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1637),
    [anon_sym_acquire] = ACTIONS(1637),
    [anon_sym_monitor] = ACTIONS(1637),
    [anon_sym_start] = ACTIONS(1637),
    [anon_sym_stop] = ACTIONS(1637),
  },
  [373] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [374] = {
    [sym_identifier] = ACTIONS(1460),
    [aux_sym_preproc_include_token1] = ACTIONS(1460),
    [aux_sym_preproc_def_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token1] = ACTIONS(1460),
    [aux_sym_preproc_if_token2] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1460),
    [sym_preproc_directive] = ACTIONS(1460),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym___extension__] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___cdecl] = ACTIONS(1460),
    [anon_sym___clrcall] = ACTIONS(1460),
    [anon_sym___stdcall] = ACTIONS(1460),
    [anon_sym___fastcall] = ACTIONS(1460),
    [anon_sym___thiscall] = ACTIONS(1460),
    [anon_sym___vectorcall] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym___inline] = ACTIONS(1460),
    [anon_sym___inline__] = ACTIONS(1460),
    [anon_sym___forceinline] = ACTIONS(1460),
    [anon_sym_thread_local] = ACTIONS(1460),
    [anon_sym___thread] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_constexpr] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym___restrict__] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym__Noreturn] = ACTIONS(1460),
    [anon_sym_noreturn] = ACTIONS(1460),
    [sym_primitive_type] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_goto] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_sizeof] = ACTIONS(1460),
    [anon_sym___alignof__] = ACTIONS(1460),
    [anon_sym___alignof] = ACTIONS(1460),
    [anon_sym__alignof] = ACTIONS(1460),
    [anon_sym_alignof] = ACTIONS(1460),
    [anon_sym__Alignof] = ACTIONS(1460),
    [anon_sym_offsetof] = ACTIONS(1460),
    [anon_sym__Generic] = ACTIONS(1460),
    [anon_sym_asm] = ACTIONS(1460),
    [anon_sym___asm__] = ACTIONS(1460),
    [sym_number_literal] = ACTIONS(1462),
    [anon_sym_L_SQUOTE] = ACTIONS(1462),
    [anon_sym_u_SQUOTE] = ACTIONS(1462),
    [anon_sym_U_SQUOTE] = ACTIONS(1462),
    [anon_sym_u8_SQUOTE] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_L_DQUOTE] = ACTIONS(1462),
    [anon_sym_u_DQUOTE] = ACTIONS(1462),
    [anon_sym_U_DQUOTE] = ACTIONS(1462),
    [anon_sym_u8_DQUOTE] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [anon_sym_NULL] = ACTIONS(1460),
    [anon_sym_nullptr] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1460),
    [anon_sym_acquire] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_monitor] = ACTIONS(1460),
    [anon_sym_start] = ACTIONS(1460),
    [anon_sym_stop] = ACTIONS(1460),
  },
  [375] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(187),
    [sym_attributed_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_expression_statement] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_switch_statement] = STATE(187),
    [sym_case_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_do_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym_return_statement] = STATE(187),
    [sym_break_statement] = STATE(187),
    [sym_continue_statement] = STATE(187),
    [sym_goto_statement] = STATE(187),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(187),
    [sym_acquire_statement] = STATE(187),
    [sym_monitor_statement] = STATE(187),
    [sym_start_statement] = STATE(187),
    [sym_stop_statement] = STATE(187),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [376] = {
    [sym_identifier] = ACTIONS(1696),
    [aux_sym_preproc_include_token1] = ACTIONS(1696),
    [aux_sym_preproc_def_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token2] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1696),
    [aux_sym_preproc_else_token1] = ACTIONS(1696),
    [aux_sym_preproc_elif_token1] = ACTIONS(1696),
    [sym_preproc_directive] = ACTIONS(1696),
    [anon_sym_LPAREN2] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym___extension__] = ACTIONS(1696),
    [anon_sym_typedef] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym___attribute__] = ACTIONS(1696),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1698),
    [anon_sym___declspec] = ACTIONS(1696),
    [anon_sym___cdecl] = ACTIONS(1696),
    [anon_sym___clrcall] = ACTIONS(1696),
    [anon_sym___stdcall] = ACTIONS(1696),
    [anon_sym___fastcall] = ACTIONS(1696),
    [anon_sym___thiscall] = ACTIONS(1696),
    [anon_sym___vectorcall] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_signed] = ACTIONS(1696),
    [anon_sym_unsigned] = ACTIONS(1696),
    [anon_sym_long] = ACTIONS(1696),
    [anon_sym_short] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_auto] = ACTIONS(1696),
    [anon_sym_register] = ACTIONS(1696),
    [anon_sym_inline] = ACTIONS(1696),
    [anon_sym___inline] = ACTIONS(1696),
    [anon_sym___inline__] = ACTIONS(1696),
    [anon_sym___forceinline] = ACTIONS(1696),
    [anon_sym_thread_local] = ACTIONS(1696),
    [anon_sym___thread] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_constexpr] = ACTIONS(1696),
    [anon_sym_volatile] = ACTIONS(1696),
    [anon_sym_restrict] = ACTIONS(1696),
    [anon_sym___restrict__] = ACTIONS(1696),
    [anon_sym__Atomic] = ACTIONS(1696),
    [anon_sym__Noreturn] = ACTIONS(1696),
    [anon_sym_noreturn] = ACTIONS(1696),
    [sym_primitive_type] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_switch] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_goto] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_sizeof] = ACTIONS(1696),
    [anon_sym___alignof__] = ACTIONS(1696),
    [anon_sym___alignof] = ACTIONS(1696),
    [anon_sym__alignof] = ACTIONS(1696),
    [anon_sym_alignof] = ACTIONS(1696),
    [anon_sym__Alignof] = ACTIONS(1696),
    [anon_sym_offsetof] = ACTIONS(1696),
    [anon_sym__Generic] = ACTIONS(1696),
    [anon_sym_asm] = ACTIONS(1696),
    [anon_sym___asm__] = ACTIONS(1696),
    [sym_number_literal] = ACTIONS(1698),
    [anon_sym_L_SQUOTE] = ACTIONS(1698),
    [anon_sym_u_SQUOTE] = ACTIONS(1698),
    [anon_sym_U_SQUOTE] = ACTIONS(1698),
    [anon_sym_u8_SQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [anon_sym_L_DQUOTE] = ACTIONS(1698),
    [anon_sym_u_DQUOTE] = ACTIONS(1698),
    [anon_sym_U_DQUOTE] = ACTIONS(1698),
    [anon_sym_u8_DQUOTE] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [anon_sym_NULL] = ACTIONS(1696),
    [anon_sym_nullptr] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1696),
    [anon_sym_acquire] = ACTIONS(1696),
    [anon_sym_monitor] = ACTIONS(1696),
    [anon_sym_start] = ACTIONS(1696),
    [anon_sym_stop] = ACTIONS(1696),
  },
  [377] = {
    [sym_identifier] = ACTIONS(1496),
    [aux_sym_preproc_include_token1] = ACTIONS(1496),
    [aux_sym_preproc_def_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token1] = ACTIONS(1496),
    [aux_sym_preproc_if_token2] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1496),
    [sym_preproc_directive] = ACTIONS(1496),
    [anon_sym_LPAREN2] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym___extension__] = ACTIONS(1496),
    [anon_sym_typedef] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym___attribute__] = ACTIONS(1496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1498),
    [anon_sym___declspec] = ACTIONS(1496),
    [anon_sym___cdecl] = ACTIONS(1496),
    [anon_sym___clrcall] = ACTIONS(1496),
    [anon_sym___stdcall] = ACTIONS(1496),
    [anon_sym___fastcall] = ACTIONS(1496),
    [anon_sym___thiscall] = ACTIONS(1496),
    [anon_sym___vectorcall] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_signed] = ACTIONS(1496),
    [anon_sym_unsigned] = ACTIONS(1496),
    [anon_sym_long] = ACTIONS(1496),
    [anon_sym_short] = ACTIONS(1496),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_auto] = ACTIONS(1496),
    [anon_sym_register] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym___inline] = ACTIONS(1496),
    [anon_sym___inline__] = ACTIONS(1496),
    [anon_sym___forceinline] = ACTIONS(1496),
    [anon_sym_thread_local] = ACTIONS(1496),
    [anon_sym___thread] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_constexpr] = ACTIONS(1496),
    [anon_sym_volatile] = ACTIONS(1496),
    [anon_sym_restrict] = ACTIONS(1496),
    [anon_sym___restrict__] = ACTIONS(1496),
    [anon_sym__Atomic] = ACTIONS(1496),
    [anon_sym__Noreturn] = ACTIONS(1496),
    [anon_sym_noreturn] = ACTIONS(1496),
    [sym_primitive_type] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_struct] = ACTIONS(1496),
    [anon_sym_union] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_goto] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_sizeof] = ACTIONS(1496),
    [anon_sym___alignof__] = ACTIONS(1496),
    [anon_sym___alignof] = ACTIONS(1496),
    [anon_sym__alignof] = ACTIONS(1496),
    [anon_sym_alignof] = ACTIONS(1496),
    [anon_sym__Alignof] = ACTIONS(1496),
    [anon_sym_offsetof] = ACTIONS(1496),
    [anon_sym__Generic] = ACTIONS(1496),
    [anon_sym_asm] = ACTIONS(1496),
    [anon_sym___asm__] = ACTIONS(1496),
    [sym_number_literal] = ACTIONS(1498),
    [anon_sym_L_SQUOTE] = ACTIONS(1498),
    [anon_sym_u_SQUOTE] = ACTIONS(1498),
    [anon_sym_U_SQUOTE] = ACTIONS(1498),
    [anon_sym_u8_SQUOTE] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_L_DQUOTE] = ACTIONS(1498),
    [anon_sym_u_DQUOTE] = ACTIONS(1498),
    [anon_sym_U_DQUOTE] = ACTIONS(1498),
    [anon_sym_u8_DQUOTE] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [anon_sym_NULL] = ACTIONS(1496),
    [anon_sym_nullptr] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1496),
    [anon_sym_acquire] = ACTIONS(1496),
    [anon_sym_catch] = ACTIONS(1496),
    [anon_sym_monitor] = ACTIONS(1496),
    [anon_sym_start] = ACTIONS(1496),
    [anon_sym_stop] = ACTIONS(1496),
  },
  [378] = {
    [sym_identifier] = ACTIONS(1680),
    [aux_sym_preproc_include_token1] = ACTIONS(1680),
    [aux_sym_preproc_def_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token2] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1680),
    [aux_sym_preproc_else_token1] = ACTIONS(1680),
    [aux_sym_preproc_elif_token1] = ACTIONS(1680),
    [sym_preproc_directive] = ACTIONS(1680),
    [anon_sym_LPAREN2] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_TILDE] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym___extension__] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym___attribute__] = ACTIONS(1680),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1682),
    [anon_sym___declspec] = ACTIONS(1680),
    [anon_sym___cdecl] = ACTIONS(1680),
    [anon_sym___clrcall] = ACTIONS(1680),
    [anon_sym___stdcall] = ACTIONS(1680),
    [anon_sym___fastcall] = ACTIONS(1680),
    [anon_sym___thiscall] = ACTIONS(1680),
    [anon_sym___vectorcall] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_signed] = ACTIONS(1680),
    [anon_sym_unsigned] = ACTIONS(1680),
    [anon_sym_long] = ACTIONS(1680),
    [anon_sym_short] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_auto] = ACTIONS(1680),
    [anon_sym_register] = ACTIONS(1680),
    [anon_sym_inline] = ACTIONS(1680),
    [anon_sym___inline] = ACTIONS(1680),
    [anon_sym___inline__] = ACTIONS(1680),
    [anon_sym___forceinline] = ACTIONS(1680),
    [anon_sym_thread_local] = ACTIONS(1680),
    [anon_sym___thread] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_constexpr] = ACTIONS(1680),
    [anon_sym_volatile] = ACTIONS(1680),
    [anon_sym_restrict] = ACTIONS(1680),
    [anon_sym___restrict__] = ACTIONS(1680),
    [anon_sym__Atomic] = ACTIONS(1680),
    [anon_sym__Noreturn] = ACTIONS(1680),
    [anon_sym_noreturn] = ACTIONS(1680),
    [sym_primitive_type] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_switch] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_do] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_goto] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1682),
    [anon_sym_sizeof] = ACTIONS(1680),
    [anon_sym___alignof__] = ACTIONS(1680),
    [anon_sym___alignof] = ACTIONS(1680),
    [anon_sym__alignof] = ACTIONS(1680),
    [anon_sym_alignof] = ACTIONS(1680),
    [anon_sym__Alignof] = ACTIONS(1680),
    [anon_sym_offsetof] = ACTIONS(1680),
    [anon_sym__Generic] = ACTIONS(1680),
    [anon_sym_asm] = ACTIONS(1680),
    [anon_sym___asm__] = ACTIONS(1680),
    [sym_number_literal] = ACTIONS(1682),
    [anon_sym_L_SQUOTE] = ACTIONS(1682),
    [anon_sym_u_SQUOTE] = ACTIONS(1682),
    [anon_sym_U_SQUOTE] = ACTIONS(1682),
    [anon_sym_u8_SQUOTE] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1682),
    [anon_sym_L_DQUOTE] = ACTIONS(1682),
    [anon_sym_u_DQUOTE] = ACTIONS(1682),
    [anon_sym_U_DQUOTE] = ACTIONS(1682),
    [anon_sym_u8_DQUOTE] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [anon_sym_NULL] = ACTIONS(1680),
    [anon_sym_nullptr] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1680),
    [anon_sym_acquire] = ACTIONS(1680),
    [anon_sym_monitor] = ACTIONS(1680),
    [anon_sym_start] = ACTIONS(1680),
    [anon_sym_stop] = ACTIONS(1680),
  },
  [379] = {
    [sym_attribute_declaration] = STATE(379),
    [sym_compound_statement] = STATE(268),
    [sym_attributed_statement] = STATE(268),
    [sym_labeled_statement] = STATE(268),
    [sym_expression_statement] = STATE(268),
    [sym_if_statement] = STATE(268),
    [sym_switch_statement] = STATE(268),
    [sym_case_statement] = STATE(268),
    [sym_while_statement] = STATE(268),
    [sym_do_statement] = STATE(268),
    [sym_for_statement] = STATE(268),
    [sym_return_statement] = STATE(268),
    [sym_break_statement] = STATE(268),
    [sym_continue_statement] = STATE(268),
    [sym_goto_statement] = STATE(268),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(268),
    [sym_acquire_statement] = STATE(268),
    [sym_monitor_statement] = STATE(268),
    [sym_start_statement] = STATE(268),
    [sym_stop_statement] = STATE(268),
    [aux_sym_attributed_declarator_repeat1] = STATE(379),
    [sym_identifier] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1896),
    [anon_sym_case] = ACTIONS(1899),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1908),
    [anon_sym_for] = ACTIONS(1911),
    [anon_sym_return] = ACTIONS(1914),
    [anon_sym_break] = ACTIONS(1917),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_goto] = ACTIONS(1923),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_sizeof] = ACTIONS(1780),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1786),
    [anon_sym__Generic] = ACTIONS(1789),
    [anon_sym_asm] = ACTIONS(1792),
    [anon_sym___asm__] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1795),
    [anon_sym_L_SQUOTE] = ACTIONS(1798),
    [anon_sym_u_SQUOTE] = ACTIONS(1798),
    [anon_sym_U_SQUOTE] = ACTIONS(1798),
    [anon_sym_u8_SQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_L_DQUOTE] = ACTIONS(1801),
    [anon_sym_u_DQUOTE] = ACTIONS(1801),
    [anon_sym_U_DQUOTE] = ACTIONS(1801),
    [anon_sym_u8_DQUOTE] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [anon_sym_NULL] = ACTIONS(1807),
    [anon_sym_nullptr] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1926),
    [anon_sym_acquire] = ACTIONS(1929),
    [anon_sym_monitor] = ACTIONS(1932),
    [anon_sym_start] = ACTIONS(1935),
    [anon_sym_stop] = ACTIONS(1938),
  },
  [380] = {
    [sym_identifier] = ACTIONS(1676),
    [aux_sym_preproc_include_token1] = ACTIONS(1676),
    [aux_sym_preproc_def_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token2] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1676),
    [aux_sym_preproc_else_token1] = ACTIONS(1676),
    [aux_sym_preproc_elif_token1] = ACTIONS(1676),
    [sym_preproc_directive] = ACTIONS(1676),
    [anon_sym_LPAREN2] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym___extension__] = ACTIONS(1676),
    [anon_sym_typedef] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym___attribute__] = ACTIONS(1676),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1678),
    [anon_sym___declspec] = ACTIONS(1676),
    [anon_sym___cdecl] = ACTIONS(1676),
    [anon_sym___clrcall] = ACTIONS(1676),
    [anon_sym___stdcall] = ACTIONS(1676),
    [anon_sym___fastcall] = ACTIONS(1676),
    [anon_sym___thiscall] = ACTIONS(1676),
    [anon_sym___vectorcall] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_signed] = ACTIONS(1676),
    [anon_sym_unsigned] = ACTIONS(1676),
    [anon_sym_long] = ACTIONS(1676),
    [anon_sym_short] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_auto] = ACTIONS(1676),
    [anon_sym_register] = ACTIONS(1676),
    [anon_sym_inline] = ACTIONS(1676),
    [anon_sym___inline] = ACTIONS(1676),
    [anon_sym___inline__] = ACTIONS(1676),
    [anon_sym___forceinline] = ACTIONS(1676),
    [anon_sym_thread_local] = ACTIONS(1676),
    [anon_sym___thread] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_constexpr] = ACTIONS(1676),
    [anon_sym_volatile] = ACTIONS(1676),
    [anon_sym_restrict] = ACTIONS(1676),
    [anon_sym___restrict__] = ACTIONS(1676),
    [anon_sym__Atomic] = ACTIONS(1676),
    [anon_sym__Noreturn] = ACTIONS(1676),
    [anon_sym_noreturn] = ACTIONS(1676),
    [sym_primitive_type] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_switch] = ACTIONS(1676),
    [anon_sym_case] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_goto] = ACTIONS(1676),
    [anon_sym_DASH_DASH] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1678),
    [anon_sym_sizeof] = ACTIONS(1676),
    [anon_sym___alignof__] = ACTIONS(1676),
    [anon_sym___alignof] = ACTIONS(1676),
    [anon_sym__alignof] = ACTIONS(1676),
    [anon_sym_alignof] = ACTIONS(1676),
    [anon_sym__Alignof] = ACTIONS(1676),
    [anon_sym_offsetof] = ACTIONS(1676),
    [anon_sym__Generic] = ACTIONS(1676),
    [anon_sym_asm] = ACTIONS(1676),
    [anon_sym___asm__] = ACTIONS(1676),
    [sym_number_literal] = ACTIONS(1678),
    [anon_sym_L_SQUOTE] = ACTIONS(1678),
    [anon_sym_u_SQUOTE] = ACTIONS(1678),
    [anon_sym_U_SQUOTE] = ACTIONS(1678),
    [anon_sym_u8_SQUOTE] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1678),
    [anon_sym_L_DQUOTE] = ACTIONS(1678),
    [anon_sym_u_DQUOTE] = ACTIONS(1678),
    [anon_sym_U_DQUOTE] = ACTIONS(1678),
    [anon_sym_u8_DQUOTE] = ACTIONS(1678),
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [anon_sym_NULL] = ACTIONS(1676),
    [anon_sym_nullptr] = ACTIONS(1676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1676),
    [anon_sym_acquire] = ACTIONS(1676),
    [anon_sym_monitor] = ACTIONS(1676),
    [anon_sym_start] = ACTIONS(1676),
    [anon_sym_stop] = ACTIONS(1676),
  },
  [381] = {
    [sym_identifier] = ACTIONS(1672),
    [aux_sym_preproc_include_token1] = ACTIONS(1672),
    [aux_sym_preproc_def_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token2] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1672),
    [aux_sym_preproc_else_token1] = ACTIONS(1672),
    [aux_sym_preproc_elif_token1] = ACTIONS(1672),
    [sym_preproc_directive] = ACTIONS(1672),
    [anon_sym_LPAREN2] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_TILDE] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym___extension__] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym___attribute__] = ACTIONS(1672),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1674),
    [anon_sym___declspec] = ACTIONS(1672),
    [anon_sym___cdecl] = ACTIONS(1672),
    [anon_sym___clrcall] = ACTIONS(1672),
    [anon_sym___stdcall] = ACTIONS(1672),
    [anon_sym___fastcall] = ACTIONS(1672),
    [anon_sym___thiscall] = ACTIONS(1672),
    [anon_sym___vectorcall] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_signed] = ACTIONS(1672),
    [anon_sym_unsigned] = ACTIONS(1672),
    [anon_sym_long] = ACTIONS(1672),
    [anon_sym_short] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_auto] = ACTIONS(1672),
    [anon_sym_register] = ACTIONS(1672),
    [anon_sym_inline] = ACTIONS(1672),
    [anon_sym___inline] = ACTIONS(1672),
    [anon_sym___inline__] = ACTIONS(1672),
    [anon_sym___forceinline] = ACTIONS(1672),
    [anon_sym_thread_local] = ACTIONS(1672),
    [anon_sym___thread] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_constexpr] = ACTIONS(1672),
    [anon_sym_volatile] = ACTIONS(1672),
    [anon_sym_restrict] = ACTIONS(1672),
    [anon_sym___restrict__] = ACTIONS(1672),
    [anon_sym__Atomic] = ACTIONS(1672),
    [anon_sym__Noreturn] = ACTIONS(1672),
    [anon_sym_noreturn] = ACTIONS(1672),
    [sym_primitive_type] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_do] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_goto] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1674),
    [anon_sym_PLUS_PLUS] = ACTIONS(1674),
    [anon_sym_sizeof] = ACTIONS(1672),
    [anon_sym___alignof__] = ACTIONS(1672),
    [anon_sym___alignof] = ACTIONS(1672),
    [anon_sym__alignof] = ACTIONS(1672),
    [anon_sym_alignof] = ACTIONS(1672),
    [anon_sym__Alignof] = ACTIONS(1672),
    [anon_sym_offsetof] = ACTIONS(1672),
    [anon_sym__Generic] = ACTIONS(1672),
    [anon_sym_asm] = ACTIONS(1672),
    [anon_sym___asm__] = ACTIONS(1672),
    [sym_number_literal] = ACTIONS(1674),
    [anon_sym_L_SQUOTE] = ACTIONS(1674),
    [anon_sym_u_SQUOTE] = ACTIONS(1674),
    [anon_sym_U_SQUOTE] = ACTIONS(1674),
    [anon_sym_u8_SQUOTE] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1674),
    [anon_sym_L_DQUOTE] = ACTIONS(1674),
    [anon_sym_u_DQUOTE] = ACTIONS(1674),
    [anon_sym_U_DQUOTE] = ACTIONS(1674),
    [anon_sym_u8_DQUOTE] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(1674),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [anon_sym_NULL] = ACTIONS(1672),
    [anon_sym_nullptr] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1672),
    [anon_sym_acquire] = ACTIONS(1672),
    [anon_sym_monitor] = ACTIONS(1672),
    [anon_sym_start] = ACTIONS(1672),
    [anon_sym_stop] = ACTIONS(1672),
  },
  [382] = {
    [sym_identifier] = ACTIONS(1668),
    [aux_sym_preproc_include_token1] = ACTIONS(1668),
    [aux_sym_preproc_def_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token2] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1668),
    [aux_sym_preproc_else_token1] = ACTIONS(1668),
    [aux_sym_preproc_elif_token1] = ACTIONS(1668),
    [sym_preproc_directive] = ACTIONS(1668),
    [anon_sym_LPAREN2] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym___extension__] = ACTIONS(1668),
    [anon_sym_typedef] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym___attribute__] = ACTIONS(1668),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1670),
    [anon_sym___declspec] = ACTIONS(1668),
    [anon_sym___cdecl] = ACTIONS(1668),
    [anon_sym___clrcall] = ACTIONS(1668),
    [anon_sym___stdcall] = ACTIONS(1668),
    [anon_sym___fastcall] = ACTIONS(1668),
    [anon_sym___thiscall] = ACTIONS(1668),
    [anon_sym___vectorcall] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_signed] = ACTIONS(1668),
    [anon_sym_unsigned] = ACTIONS(1668),
    [anon_sym_long] = ACTIONS(1668),
    [anon_sym_short] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_auto] = ACTIONS(1668),
    [anon_sym_register] = ACTIONS(1668),
    [anon_sym_inline] = ACTIONS(1668),
    [anon_sym___inline] = ACTIONS(1668),
    [anon_sym___inline__] = ACTIONS(1668),
    [anon_sym___forceinline] = ACTIONS(1668),
    [anon_sym_thread_local] = ACTIONS(1668),
    [anon_sym___thread] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_constexpr] = ACTIONS(1668),
    [anon_sym_volatile] = ACTIONS(1668),
    [anon_sym_restrict] = ACTIONS(1668),
    [anon_sym___restrict__] = ACTIONS(1668),
    [anon_sym__Atomic] = ACTIONS(1668),
    [anon_sym__Noreturn] = ACTIONS(1668),
    [anon_sym_noreturn] = ACTIONS(1668),
    [sym_primitive_type] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_do] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_goto] = ACTIONS(1668),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_sizeof] = ACTIONS(1668),
    [anon_sym___alignof__] = ACTIONS(1668),
    [anon_sym___alignof] = ACTIONS(1668),
    [anon_sym__alignof] = ACTIONS(1668),
    [anon_sym_alignof] = ACTIONS(1668),
    [anon_sym__Alignof] = ACTIONS(1668),
    [anon_sym_offsetof] = ACTIONS(1668),
    [anon_sym__Generic] = ACTIONS(1668),
    [anon_sym_asm] = ACTIONS(1668),
    [anon_sym___asm__] = ACTIONS(1668),
    [sym_number_literal] = ACTIONS(1670),
    [anon_sym_L_SQUOTE] = ACTIONS(1670),
    [anon_sym_u_SQUOTE] = ACTIONS(1670),
    [anon_sym_U_SQUOTE] = ACTIONS(1670),
    [anon_sym_u8_SQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [anon_sym_L_DQUOTE] = ACTIONS(1670),
    [anon_sym_u_DQUOTE] = ACTIONS(1670),
    [anon_sym_U_DQUOTE] = ACTIONS(1670),
    [anon_sym_u8_DQUOTE] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [anon_sym_NULL] = ACTIONS(1668),
    [anon_sym_nullptr] = ACTIONS(1668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1668),
    [anon_sym_acquire] = ACTIONS(1668),
    [anon_sym_monitor] = ACTIONS(1668),
    [anon_sym_start] = ACTIONS(1668),
    [anon_sym_stop] = ACTIONS(1668),
  },
  [383] = {
    [sym_identifier] = ACTIONS(1525),
    [aux_sym_preproc_include_token1] = ACTIONS(1525),
    [aux_sym_preproc_def_token1] = ACTIONS(1525),
    [aux_sym_preproc_if_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1525),
    [sym_preproc_directive] = ACTIONS(1525),
    [anon_sym_LPAREN2] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1525),
    [anon_sym_typedef] = ACTIONS(1525),
    [anon_sym_extern] = ACTIONS(1525),
    [anon_sym___attribute__] = ACTIONS(1525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1527),
    [anon_sym___declspec] = ACTIONS(1525),
    [anon_sym___cdecl] = ACTIONS(1525),
    [anon_sym___clrcall] = ACTIONS(1525),
    [anon_sym___stdcall] = ACTIONS(1525),
    [anon_sym___fastcall] = ACTIONS(1525),
    [anon_sym___thiscall] = ACTIONS(1525),
    [anon_sym___vectorcall] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_signed] = ACTIONS(1525),
    [anon_sym_unsigned] = ACTIONS(1525),
    [anon_sym_long] = ACTIONS(1525),
    [anon_sym_short] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1525),
    [anon_sym_auto] = ACTIONS(1525),
    [anon_sym_register] = ACTIONS(1525),
    [anon_sym_inline] = ACTIONS(1525),
    [anon_sym___inline] = ACTIONS(1525),
    [anon_sym___inline__] = ACTIONS(1525),
    [anon_sym___forceinline] = ACTIONS(1525),
    [anon_sym_thread_local] = ACTIONS(1525),
    [anon_sym___thread] = ACTIONS(1525),
    [anon_sym_const] = ACTIONS(1525),
    [anon_sym_constexpr] = ACTIONS(1525),
    [anon_sym_volatile] = ACTIONS(1525),
    [anon_sym_restrict] = ACTIONS(1525),
    [anon_sym___restrict__] = ACTIONS(1525),
    [anon_sym__Atomic] = ACTIONS(1525),
    [anon_sym__Noreturn] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [sym_primitive_type] = ACTIONS(1525),
    [anon_sym_enum] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1525),
    [anon_sym_union] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_do] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_return] = ACTIONS(1525),
    [anon_sym_break] = ACTIONS(1525),
    [anon_sym_continue] = ACTIONS(1525),
    [anon_sym_goto] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_sizeof] = ACTIONS(1525),
    [anon_sym___alignof__] = ACTIONS(1525),
    [anon_sym___alignof] = ACTIONS(1525),
    [anon_sym__alignof] = ACTIONS(1525),
    [anon_sym_alignof] = ACTIONS(1525),
    [anon_sym__Alignof] = ACTIONS(1525),
    [anon_sym_offsetof] = ACTIONS(1525),
    [anon_sym__Generic] = ACTIONS(1525),
    [anon_sym_asm] = ACTIONS(1525),
    [anon_sym___asm__] = ACTIONS(1525),
    [sym_number_literal] = ACTIONS(1527),
    [anon_sym_L_SQUOTE] = ACTIONS(1527),
    [anon_sym_u_SQUOTE] = ACTIONS(1527),
    [anon_sym_U_SQUOTE] = ACTIONS(1527),
    [anon_sym_u8_SQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [anon_sym_L_DQUOTE] = ACTIONS(1527),
    [anon_sym_u_DQUOTE] = ACTIONS(1527),
    [anon_sym_U_DQUOTE] = ACTIONS(1527),
    [anon_sym_u8_DQUOTE] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [anon_sym_NULL] = ACTIONS(1525),
    [anon_sym_nullptr] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1525),
    [anon_sym_acquire] = ACTIONS(1525),
    [anon_sym_catch] = ACTIONS(1525),
    [anon_sym_monitor] = ACTIONS(1525),
    [anon_sym_start] = ACTIONS(1525),
    [anon_sym_stop] = ACTIONS(1525),
  },
  [384] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1506),
    [anon_sym_acquire] = ACTIONS(1506),
    [anon_sym_catch] = ACTIONS(1506),
    [anon_sym_monitor] = ACTIONS(1506),
    [anon_sym_start] = ACTIONS(1506),
    [anon_sym_stop] = ACTIONS(1506),
  },
  [385] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(1831),
    [sym_attributed_statement] = STATE(1831),
    [sym_labeled_statement] = STATE(1831),
    [sym_expression_statement] = STATE(1831),
    [sym_if_statement] = STATE(1831),
    [sym_switch_statement] = STATE(1831),
    [sym_case_statement] = STATE(1831),
    [sym_while_statement] = STATE(1831),
    [sym_do_statement] = STATE(1831),
    [sym_for_statement] = STATE(1831),
    [sym_return_statement] = STATE(1831),
    [sym_break_statement] = STATE(1831),
    [sym_continue_statement] = STATE(1831),
    [sym_goto_statement] = STATE(1831),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(1831),
    [sym_acquire_statement] = STATE(1831),
    [sym_monitor_statement] = STATE(1831),
    [sym_start_statement] = STATE(1831),
    [sym_stop_statement] = STATE(1831),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [386] = {
    [sym_identifier] = ACTIONS(1597),
    [aux_sym_preproc_include_token1] = ACTIONS(1597),
    [aux_sym_preproc_def_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token2] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1597),
    [aux_sym_preproc_else_token1] = ACTIONS(1597),
    [aux_sym_preproc_elif_token1] = ACTIONS(1597),
    [sym_preproc_directive] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym___extension__] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1597),
    [anon_sym_extern] = ACTIONS(1597),
    [anon_sym___attribute__] = ACTIONS(1597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1599),
    [anon_sym___declspec] = ACTIONS(1597),
    [anon_sym___cdecl] = ACTIONS(1597),
    [anon_sym___clrcall] = ACTIONS(1597),
    [anon_sym___stdcall] = ACTIONS(1597),
    [anon_sym___fastcall] = ACTIONS(1597),
    [anon_sym___thiscall] = ACTIONS(1597),
    [anon_sym___vectorcall] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_signed] = ACTIONS(1597),
    [anon_sym_unsigned] = ACTIONS(1597),
    [anon_sym_long] = ACTIONS(1597),
    [anon_sym_short] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_auto] = ACTIONS(1597),
    [anon_sym_register] = ACTIONS(1597),
    [anon_sym_inline] = ACTIONS(1597),
    [anon_sym___inline] = ACTIONS(1597),
    [anon_sym___inline__] = ACTIONS(1597),
    [anon_sym___forceinline] = ACTIONS(1597),
    [anon_sym_thread_local] = ACTIONS(1597),
    [anon_sym___thread] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(1597),
    [anon_sym_constexpr] = ACTIONS(1597),
    [anon_sym_volatile] = ACTIONS(1597),
    [anon_sym_restrict] = ACTIONS(1597),
    [anon_sym___restrict__] = ACTIONS(1597),
    [anon_sym__Atomic] = ACTIONS(1597),
    [anon_sym__Noreturn] = ACTIONS(1597),
    [anon_sym_noreturn] = ACTIONS(1597),
    [sym_primitive_type] = ACTIONS(1597),
    [anon_sym_enum] = ACTIONS(1597),
    [anon_sym_struct] = ACTIONS(1597),
    [anon_sym_union] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1597),
    [anon_sym_switch] = ACTIONS(1597),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1597),
    [anon_sym_while] = ACTIONS(1597),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_for] = ACTIONS(1597),
    [anon_sym_return] = ACTIONS(1597),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1597),
    [anon_sym_goto] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_sizeof] = ACTIONS(1597),
    [anon_sym___alignof__] = ACTIONS(1597),
    [anon_sym___alignof] = ACTIONS(1597),
    [anon_sym__alignof] = ACTIONS(1597),
    [anon_sym_alignof] = ACTIONS(1597),
    [anon_sym__Alignof] = ACTIONS(1597),
    [anon_sym_offsetof] = ACTIONS(1597),
    [anon_sym__Generic] = ACTIONS(1597),
    [anon_sym_asm] = ACTIONS(1597),
    [anon_sym___asm__] = ACTIONS(1597),
    [sym_number_literal] = ACTIONS(1599),
    [anon_sym_L_SQUOTE] = ACTIONS(1599),
    [anon_sym_u_SQUOTE] = ACTIONS(1599),
    [anon_sym_U_SQUOTE] = ACTIONS(1599),
    [anon_sym_u8_SQUOTE] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [anon_sym_L_DQUOTE] = ACTIONS(1599),
    [anon_sym_u_DQUOTE] = ACTIONS(1599),
    [anon_sym_U_DQUOTE] = ACTIONS(1599),
    [anon_sym_u8_DQUOTE] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [anon_sym_NULL] = ACTIONS(1597),
    [anon_sym_nullptr] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1597),
    [anon_sym_acquire] = ACTIONS(1597),
    [anon_sym_monitor] = ACTIONS(1597),
    [anon_sym_start] = ACTIONS(1597),
    [anon_sym_stop] = ACTIONS(1597),
  },
  [387] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(94),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_case_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(94),
    [sym_acquire_statement] = STATE(94),
    [sym_monitor_statement] = STATE(94),
    [sym_start_statement] = STATE(94),
    [sym_stop_statement] = STATE(94),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [388] = {
    [sym_identifier] = ACTIONS(1492),
    [aux_sym_preproc_include_token1] = ACTIONS(1492),
    [aux_sym_preproc_def_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token1] = ACTIONS(1492),
    [aux_sym_preproc_if_token2] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1492),
    [sym_preproc_directive] = ACTIONS(1492),
    [anon_sym_LPAREN2] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym___extension__] = ACTIONS(1492),
    [anon_sym_typedef] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym___attribute__] = ACTIONS(1492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1494),
    [anon_sym___declspec] = ACTIONS(1492),
    [anon_sym___cdecl] = ACTIONS(1492),
    [anon_sym___clrcall] = ACTIONS(1492),
    [anon_sym___stdcall] = ACTIONS(1492),
    [anon_sym___fastcall] = ACTIONS(1492),
    [anon_sym___thiscall] = ACTIONS(1492),
    [anon_sym___vectorcall] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_signed] = ACTIONS(1492),
    [anon_sym_unsigned] = ACTIONS(1492),
    [anon_sym_long] = ACTIONS(1492),
    [anon_sym_short] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_auto] = ACTIONS(1492),
    [anon_sym_register] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym___inline] = ACTIONS(1492),
    [anon_sym___inline__] = ACTIONS(1492),
    [anon_sym___forceinline] = ACTIONS(1492),
    [anon_sym_thread_local] = ACTIONS(1492),
    [anon_sym___thread] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_constexpr] = ACTIONS(1492),
    [anon_sym_volatile] = ACTIONS(1492),
    [anon_sym_restrict] = ACTIONS(1492),
    [anon_sym___restrict__] = ACTIONS(1492),
    [anon_sym__Atomic] = ACTIONS(1492),
    [anon_sym__Noreturn] = ACTIONS(1492),
    [anon_sym_noreturn] = ACTIONS(1492),
    [sym_primitive_type] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_struct] = ACTIONS(1492),
    [anon_sym_union] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_goto] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_sizeof] = ACTIONS(1492),
    [anon_sym___alignof__] = ACTIONS(1492),
    [anon_sym___alignof] = ACTIONS(1492),
    [anon_sym__alignof] = ACTIONS(1492),
    [anon_sym_alignof] = ACTIONS(1492),
    [anon_sym__Alignof] = ACTIONS(1492),
    [anon_sym_offsetof] = ACTIONS(1492),
    [anon_sym__Generic] = ACTIONS(1492),
    [anon_sym_asm] = ACTIONS(1492),
    [anon_sym___asm__] = ACTIONS(1492),
    [sym_number_literal] = ACTIONS(1494),
    [anon_sym_L_SQUOTE] = ACTIONS(1494),
    [anon_sym_u_SQUOTE] = ACTIONS(1494),
    [anon_sym_U_SQUOTE] = ACTIONS(1494),
    [anon_sym_u8_SQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_L_DQUOTE] = ACTIONS(1494),
    [anon_sym_u_DQUOTE] = ACTIONS(1494),
    [anon_sym_U_DQUOTE] = ACTIONS(1494),
    [anon_sym_u8_DQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [anon_sym_NULL] = ACTIONS(1492),
    [anon_sym_nullptr] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1492),
    [anon_sym_acquire] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_monitor] = ACTIONS(1492),
    [anon_sym_start] = ACTIONS(1492),
    [anon_sym_stop] = ACTIONS(1492),
  },
  [389] = {
    [sym_identifier] = ACTIONS(1565),
    [aux_sym_preproc_include_token1] = ACTIONS(1565),
    [aux_sym_preproc_def_token1] = ACTIONS(1565),
    [aux_sym_preproc_if_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [sym_preproc_directive] = ACTIONS(1565),
    [anon_sym_LPAREN2] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1565),
    [anon_sym_typedef] = ACTIONS(1565),
    [anon_sym_extern] = ACTIONS(1565),
    [anon_sym___attribute__] = ACTIONS(1565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1567),
    [anon_sym___declspec] = ACTIONS(1565),
    [anon_sym___cdecl] = ACTIONS(1565),
    [anon_sym___clrcall] = ACTIONS(1565),
    [anon_sym___stdcall] = ACTIONS(1565),
    [anon_sym___fastcall] = ACTIONS(1565),
    [anon_sym___thiscall] = ACTIONS(1565),
    [anon_sym___vectorcall] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_signed] = ACTIONS(1565),
    [anon_sym_unsigned] = ACTIONS(1565),
    [anon_sym_long] = ACTIONS(1565),
    [anon_sym_short] = ACTIONS(1565),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_auto] = ACTIONS(1565),
    [anon_sym_register] = ACTIONS(1565),
    [anon_sym_inline] = ACTIONS(1565),
    [anon_sym___inline] = ACTIONS(1565),
    [anon_sym___inline__] = ACTIONS(1565),
    [anon_sym___forceinline] = ACTIONS(1565),
    [anon_sym_thread_local] = ACTIONS(1565),
    [anon_sym___thread] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_constexpr] = ACTIONS(1565),
    [anon_sym_volatile] = ACTIONS(1565),
    [anon_sym_restrict] = ACTIONS(1565),
    [anon_sym___restrict__] = ACTIONS(1565),
    [anon_sym__Atomic] = ACTIONS(1565),
    [anon_sym__Noreturn] = ACTIONS(1565),
    [anon_sym_noreturn] = ACTIONS(1565),
    [sym_primitive_type] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [anon_sym_struct] = ACTIONS(1565),
    [anon_sym_union] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_goto] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_sizeof] = ACTIONS(1565),
    [anon_sym___alignof__] = ACTIONS(1565),
    [anon_sym___alignof] = ACTIONS(1565),
    [anon_sym__alignof] = ACTIONS(1565),
    [anon_sym_alignof] = ACTIONS(1565),
    [anon_sym__Alignof] = ACTIONS(1565),
    [anon_sym_offsetof] = ACTIONS(1565),
    [anon_sym__Generic] = ACTIONS(1565),
    [anon_sym_asm] = ACTIONS(1565),
    [anon_sym___asm__] = ACTIONS(1565),
    [sym_number_literal] = ACTIONS(1567),
    [anon_sym_L_SQUOTE] = ACTIONS(1567),
    [anon_sym_u_SQUOTE] = ACTIONS(1567),
    [anon_sym_U_SQUOTE] = ACTIONS(1567),
    [anon_sym_u8_SQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [anon_sym_L_DQUOTE] = ACTIONS(1567),
    [anon_sym_u_DQUOTE] = ACTIONS(1567),
    [anon_sym_U_DQUOTE] = ACTIONS(1567),
    [anon_sym_u8_DQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [anon_sym_NULL] = ACTIONS(1565),
    [anon_sym_nullptr] = ACTIONS(1565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_acquire] = ACTIONS(1565),
    [anon_sym_catch] = ACTIONS(1565),
    [anon_sym_monitor] = ACTIONS(1565),
    [anon_sym_start] = ACTIONS(1565),
    [anon_sym_stop] = ACTIONS(1565),
  },
  [390] = {
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1517),
    [aux_sym_preproc_def_token1] = ACTIONS(1517),
    [aux_sym_preproc_if_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1517),
    [sym_preproc_directive] = ACTIONS(1517),
    [anon_sym_LPAREN2] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1517),
    [anon_sym_typedef] = ACTIONS(1517),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym___attribute__] = ACTIONS(1517),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1519),
    [anon_sym___declspec] = ACTIONS(1517),
    [anon_sym___cdecl] = ACTIONS(1517),
    [anon_sym___clrcall] = ACTIONS(1517),
    [anon_sym___stdcall] = ACTIONS(1517),
    [anon_sym___fastcall] = ACTIONS(1517),
    [anon_sym___thiscall] = ACTIONS(1517),
    [anon_sym___vectorcall] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_signed] = ACTIONS(1517),
    [anon_sym_unsigned] = ACTIONS(1517),
    [anon_sym_long] = ACTIONS(1517),
    [anon_sym_short] = ACTIONS(1517),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_auto] = ACTIONS(1517),
    [anon_sym_register] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1517),
    [anon_sym___inline] = ACTIONS(1517),
    [anon_sym___inline__] = ACTIONS(1517),
    [anon_sym___forceinline] = ACTIONS(1517),
    [anon_sym_thread_local] = ACTIONS(1517),
    [anon_sym___thread] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_constexpr] = ACTIONS(1517),
    [anon_sym_volatile] = ACTIONS(1517),
    [anon_sym_restrict] = ACTIONS(1517),
    [anon_sym___restrict__] = ACTIONS(1517),
    [anon_sym__Atomic] = ACTIONS(1517),
    [anon_sym__Noreturn] = ACTIONS(1517),
    [anon_sym_noreturn] = ACTIONS(1517),
    [sym_primitive_type] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [anon_sym_struct] = ACTIONS(1517),
    [anon_sym_union] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_goto] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1519),
    [anon_sym_sizeof] = ACTIONS(1517),
    [anon_sym___alignof__] = ACTIONS(1517),
    [anon_sym___alignof] = ACTIONS(1517),
    [anon_sym__alignof] = ACTIONS(1517),
    [anon_sym_alignof] = ACTIONS(1517),
    [anon_sym__Alignof] = ACTIONS(1517),
    [anon_sym_offsetof] = ACTIONS(1517),
    [anon_sym__Generic] = ACTIONS(1517),
    [anon_sym_asm] = ACTIONS(1517),
    [anon_sym___asm__] = ACTIONS(1517),
    [sym_number_literal] = ACTIONS(1519),
    [anon_sym_L_SQUOTE] = ACTIONS(1519),
    [anon_sym_u_SQUOTE] = ACTIONS(1519),
    [anon_sym_U_SQUOTE] = ACTIONS(1519),
    [anon_sym_u8_SQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_L_DQUOTE] = ACTIONS(1519),
    [anon_sym_u_DQUOTE] = ACTIONS(1519),
    [anon_sym_U_DQUOTE] = ACTIONS(1519),
    [anon_sym_u8_DQUOTE] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [anon_sym_NULL] = ACTIONS(1517),
    [anon_sym_nullptr] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1517),
    [anon_sym_acquire] = ACTIONS(1517),
    [anon_sym_catch] = ACTIONS(1517),
    [anon_sym_monitor] = ACTIONS(1517),
    [anon_sym_start] = ACTIONS(1517),
    [anon_sym_stop] = ACTIONS(1517),
  },
  [391] = {
    [sym_identifier] = ACTIONS(1529),
    [aux_sym_preproc_include_token1] = ACTIONS(1529),
    [aux_sym_preproc_def_token1] = ACTIONS(1529),
    [aux_sym_preproc_if_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1529),
    [sym_preproc_directive] = ACTIONS(1529),
    [anon_sym_LPAREN2] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1529),
    [anon_sym_typedef] = ACTIONS(1529),
    [anon_sym_extern] = ACTIONS(1529),
    [anon_sym___attribute__] = ACTIONS(1529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1531),
    [anon_sym___declspec] = ACTIONS(1529),
    [anon_sym___cdecl] = ACTIONS(1529),
    [anon_sym___clrcall] = ACTIONS(1529),
    [anon_sym___stdcall] = ACTIONS(1529),
    [anon_sym___fastcall] = ACTIONS(1529),
    [anon_sym___thiscall] = ACTIONS(1529),
    [anon_sym___vectorcall] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_signed] = ACTIONS(1529),
    [anon_sym_unsigned] = ACTIONS(1529),
    [anon_sym_long] = ACTIONS(1529),
    [anon_sym_short] = ACTIONS(1529),
    [anon_sym_static] = ACTIONS(1529),
    [anon_sym_auto] = ACTIONS(1529),
    [anon_sym_register] = ACTIONS(1529),
    [anon_sym_inline] = ACTIONS(1529),
    [anon_sym___inline] = ACTIONS(1529),
    [anon_sym___inline__] = ACTIONS(1529),
    [anon_sym___forceinline] = ACTIONS(1529),
    [anon_sym_thread_local] = ACTIONS(1529),
    [anon_sym___thread] = ACTIONS(1529),
    [anon_sym_const] = ACTIONS(1529),
    [anon_sym_constexpr] = ACTIONS(1529),
    [anon_sym_volatile] = ACTIONS(1529),
    [anon_sym_restrict] = ACTIONS(1529),
    [anon_sym___restrict__] = ACTIONS(1529),
    [anon_sym__Atomic] = ACTIONS(1529),
    [anon_sym__Noreturn] = ACTIONS(1529),
    [anon_sym_noreturn] = ACTIONS(1529),
    [sym_primitive_type] = ACTIONS(1529),
    [anon_sym_enum] = ACTIONS(1529),
    [anon_sym_struct] = ACTIONS(1529),
    [anon_sym_union] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(1529),
    [anon_sym_else] = ACTIONS(1529),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_case] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1529),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1529),
    [anon_sym_return] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(1529),
    [anon_sym_continue] = ACTIONS(1529),
    [anon_sym_goto] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym___alignof__] = ACTIONS(1529),
    [anon_sym___alignof] = ACTIONS(1529),
    [anon_sym__alignof] = ACTIONS(1529),
    [anon_sym_alignof] = ACTIONS(1529),
    [anon_sym__Alignof] = ACTIONS(1529),
    [anon_sym_offsetof] = ACTIONS(1529),
    [anon_sym__Generic] = ACTIONS(1529),
    [anon_sym_asm] = ACTIONS(1529),
    [anon_sym___asm__] = ACTIONS(1529),
    [sym_number_literal] = ACTIONS(1531),
    [anon_sym_L_SQUOTE] = ACTIONS(1531),
    [anon_sym_u_SQUOTE] = ACTIONS(1531),
    [anon_sym_U_SQUOTE] = ACTIONS(1531),
    [anon_sym_u8_SQUOTE] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_L_DQUOTE] = ACTIONS(1531),
    [anon_sym_u_DQUOTE] = ACTIONS(1531),
    [anon_sym_U_DQUOTE] = ACTIONS(1531),
    [anon_sym_u8_DQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [anon_sym_NULL] = ACTIONS(1529),
    [anon_sym_nullptr] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1529),
    [anon_sym_acquire] = ACTIONS(1529),
    [anon_sym_catch] = ACTIONS(1529),
    [anon_sym_monitor] = ACTIONS(1529),
    [anon_sym_start] = ACTIONS(1529),
    [anon_sym_stop] = ACTIONS(1529),
  },
  [392] = {
    [sym_attribute_declaration] = STATE(392),
    [sym_compound_statement] = STATE(165),
    [sym_attributed_statement] = STATE(165),
    [sym_labeled_statement] = STATE(165),
    [sym_expression_statement] = STATE(165),
    [sym_if_statement] = STATE(165),
    [sym_switch_statement] = STATE(165),
    [sym_case_statement] = STATE(165),
    [sym_while_statement] = STATE(165),
    [sym_do_statement] = STATE(165),
    [sym_for_statement] = STATE(165),
    [sym_return_statement] = STATE(165),
    [sym_break_statement] = STATE(165),
    [sym_continue_statement] = STATE(165),
    [sym_goto_statement] = STATE(165),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(165),
    [sym_acquire_statement] = STATE(165),
    [sym_monitor_statement] = STATE(165),
    [sym_start_statement] = STATE(165),
    [sym_stop_statement] = STATE(165),
    [aux_sym_attributed_declarator_repeat1] = STATE(392),
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_LPAREN2] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1956),
    [anon_sym_default] = ACTIONS(1959),
    [anon_sym_while] = ACTIONS(1962),
    [anon_sym_do] = ACTIONS(1965),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1974),
    [anon_sym_continue] = ACTIONS(1977),
    [anon_sym_goto] = ACTIONS(1980),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_sizeof] = ACTIONS(1780),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1786),
    [anon_sym__Generic] = ACTIONS(1789),
    [anon_sym_asm] = ACTIONS(1792),
    [anon_sym___asm__] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1795),
    [anon_sym_L_SQUOTE] = ACTIONS(1798),
    [anon_sym_u_SQUOTE] = ACTIONS(1798),
    [anon_sym_U_SQUOTE] = ACTIONS(1798),
    [anon_sym_u8_SQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_L_DQUOTE] = ACTIONS(1801),
    [anon_sym_u_DQUOTE] = ACTIONS(1801),
    [anon_sym_U_DQUOTE] = ACTIONS(1801),
    [anon_sym_u8_DQUOTE] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [anon_sym_NULL] = ACTIONS(1807),
    [anon_sym_nullptr] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1983),
    [anon_sym_acquire] = ACTIONS(1986),
    [anon_sym_monitor] = ACTIONS(1989),
    [anon_sym_start] = ACTIONS(1992),
    [anon_sym_stop] = ACTIONS(1995),
  },
  [393] = {
    [sym_attribute_declaration] = STATE(393),
    [sym_compound_statement] = STATE(391),
    [sym_attributed_statement] = STATE(391),
    [sym_labeled_statement] = STATE(391),
    [sym_expression_statement] = STATE(391),
    [sym_if_statement] = STATE(391),
    [sym_switch_statement] = STATE(391),
    [sym_case_statement] = STATE(391),
    [sym_while_statement] = STATE(391),
    [sym_do_statement] = STATE(391),
    [sym_for_statement] = STATE(391),
    [sym_return_statement] = STATE(391),
    [sym_break_statement] = STATE(391),
    [sym_continue_statement] = STATE(391),
    [sym_goto_statement] = STATE(391),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(391),
    [sym_acquire_statement] = STATE(391),
    [sym_monitor_statement] = STATE(391),
    [sym_start_statement] = STATE(391),
    [sym_stop_statement] = STATE(391),
    [aux_sym_attributed_declarator_repeat1] = STATE(393),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_LPAREN2] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2007),
    [anon_sym_switch] = ACTIONS(2010),
    [anon_sym_case] = ACTIONS(2013),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2022),
    [anon_sym_for] = ACTIONS(2025),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2034),
    [anon_sym_goto] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_sizeof] = ACTIONS(1780),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1786),
    [anon_sym__Generic] = ACTIONS(1789),
    [anon_sym_asm] = ACTIONS(1792),
    [anon_sym___asm__] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1795),
    [anon_sym_L_SQUOTE] = ACTIONS(1798),
    [anon_sym_u_SQUOTE] = ACTIONS(1798),
    [anon_sym_U_SQUOTE] = ACTIONS(1798),
    [anon_sym_u8_SQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_L_DQUOTE] = ACTIONS(1801),
    [anon_sym_u_DQUOTE] = ACTIONS(1801),
    [anon_sym_U_DQUOTE] = ACTIONS(1801),
    [anon_sym_u8_DQUOTE] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [anon_sym_NULL] = ACTIONS(1807),
    [anon_sym_nullptr] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(2040),
    [anon_sym_acquire] = ACTIONS(2043),
    [anon_sym_monitor] = ACTIONS(2046),
    [anon_sym_start] = ACTIONS(2049),
    [anon_sym_stop] = ACTIONS(2052),
  },
  [394] = {
    [sym_identifier] = ACTIONS(1605),
    [aux_sym_preproc_include_token1] = ACTIONS(1605),
    [aux_sym_preproc_def_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token2] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1605),
    [aux_sym_preproc_else_token1] = ACTIONS(1605),
    [aux_sym_preproc_elif_token1] = ACTIONS(1605),
    [sym_preproc_directive] = ACTIONS(1605),
    [anon_sym_LPAREN2] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym___extension__] = ACTIONS(1605),
    [anon_sym_typedef] = ACTIONS(1605),
    [anon_sym_extern] = ACTIONS(1605),
    [anon_sym___attribute__] = ACTIONS(1605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1607),
    [anon_sym___declspec] = ACTIONS(1605),
    [anon_sym___cdecl] = ACTIONS(1605),
    [anon_sym___clrcall] = ACTIONS(1605),
    [anon_sym___stdcall] = ACTIONS(1605),
    [anon_sym___fastcall] = ACTIONS(1605),
    [anon_sym___thiscall] = ACTIONS(1605),
    [anon_sym___vectorcall] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_signed] = ACTIONS(1605),
    [anon_sym_unsigned] = ACTIONS(1605),
    [anon_sym_long] = ACTIONS(1605),
    [anon_sym_short] = ACTIONS(1605),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_auto] = ACTIONS(1605),
    [anon_sym_register] = ACTIONS(1605),
    [anon_sym_inline] = ACTIONS(1605),
    [anon_sym___inline] = ACTIONS(1605),
    [anon_sym___inline__] = ACTIONS(1605),
    [anon_sym___forceinline] = ACTIONS(1605),
    [anon_sym_thread_local] = ACTIONS(1605),
    [anon_sym___thread] = ACTIONS(1605),
    [anon_sym_const] = ACTIONS(1605),
    [anon_sym_constexpr] = ACTIONS(1605),
    [anon_sym_volatile] = ACTIONS(1605),
    [anon_sym_restrict] = ACTIONS(1605),
    [anon_sym___restrict__] = ACTIONS(1605),
    [anon_sym__Atomic] = ACTIONS(1605),
    [anon_sym__Noreturn] = ACTIONS(1605),
    [anon_sym_noreturn] = ACTIONS(1605),
    [sym_primitive_type] = ACTIONS(1605),
    [anon_sym_enum] = ACTIONS(1605),
    [anon_sym_struct] = ACTIONS(1605),
    [anon_sym_union] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1605),
    [anon_sym_switch] = ACTIONS(1605),
    [anon_sym_case] = ACTIONS(1605),
    [anon_sym_default] = ACTIONS(1605),
    [anon_sym_while] = ACTIONS(1605),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_for] = ACTIONS(1605),
    [anon_sym_return] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1605),
    [anon_sym_goto] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_sizeof] = ACTIONS(1605),
    [anon_sym___alignof__] = ACTIONS(1605),
    [anon_sym___alignof] = ACTIONS(1605),
    [anon_sym__alignof] = ACTIONS(1605),
    [anon_sym_alignof] = ACTIONS(1605),
    [anon_sym__Alignof] = ACTIONS(1605),
    [anon_sym_offsetof] = ACTIONS(1605),
    [anon_sym__Generic] = ACTIONS(1605),
    [anon_sym_asm] = ACTIONS(1605),
    [anon_sym___asm__] = ACTIONS(1605),
    [sym_number_literal] = ACTIONS(1607),
    [anon_sym_L_SQUOTE] = ACTIONS(1607),
    [anon_sym_u_SQUOTE] = ACTIONS(1607),
    [anon_sym_U_SQUOTE] = ACTIONS(1607),
    [anon_sym_u8_SQUOTE] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [anon_sym_L_DQUOTE] = ACTIONS(1607),
    [anon_sym_u_DQUOTE] = ACTIONS(1607),
    [anon_sym_U_DQUOTE] = ACTIONS(1607),
    [anon_sym_u8_DQUOTE] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [anon_sym_NULL] = ACTIONS(1605),
    [anon_sym_nullptr] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1605),
    [anon_sym_acquire] = ACTIONS(1605),
    [anon_sym_monitor] = ACTIONS(1605),
    [anon_sym_start] = ACTIONS(1605),
    [anon_sym_stop] = ACTIONS(1605),
  },
  [395] = {
    [sym_attribute_declaration] = STATE(393),
    [sym_compound_statement] = STATE(391),
    [sym_attributed_statement] = STATE(391),
    [sym_labeled_statement] = STATE(391),
    [sym_expression_statement] = STATE(391),
    [sym_if_statement] = STATE(391),
    [sym_switch_statement] = STATE(391),
    [sym_case_statement] = STATE(391),
    [sym_while_statement] = STATE(391),
    [sym_do_statement] = STATE(391),
    [sym_for_statement] = STATE(391),
    [sym_return_statement] = STATE(391),
    [sym_break_statement] = STATE(391),
    [sym_continue_statement] = STATE(391),
    [sym_goto_statement] = STATE(391),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(391),
    [sym_acquire_statement] = STATE(391),
    [sym_monitor_statement] = STATE(391),
    [sym_start_statement] = STATE(391),
    [sym_stop_statement] = STATE(391),
    [aux_sym_attributed_declarator_repeat1] = STATE(393),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1569),
    [aux_sym_preproc_def_token1] = ACTIONS(1569),
    [aux_sym_preproc_if_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1569),
    [sym_preproc_directive] = ACTIONS(1569),
    [anon_sym_LPAREN2] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(1569),
    [anon_sym_typedef] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym___attribute__] = ACTIONS(1569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1571),
    [anon_sym___declspec] = ACTIONS(1569),
    [anon_sym___cdecl] = ACTIONS(1569),
    [anon_sym___clrcall] = ACTIONS(1569),
    [anon_sym___stdcall] = ACTIONS(1569),
    [anon_sym___fastcall] = ACTIONS(1569),
    [anon_sym___thiscall] = ACTIONS(1569),
    [anon_sym___vectorcall] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_signed] = ACTIONS(1569),
    [anon_sym_unsigned] = ACTIONS(1569),
    [anon_sym_long] = ACTIONS(1569),
    [anon_sym_short] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_auto] = ACTIONS(1569),
    [anon_sym_register] = ACTIONS(1569),
    [anon_sym_inline] = ACTIONS(1569),
    [anon_sym___inline] = ACTIONS(1569),
    [anon_sym___inline__] = ACTIONS(1569),
    [anon_sym___forceinline] = ACTIONS(1569),
    [anon_sym_thread_local] = ACTIONS(1569),
    [anon_sym___thread] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_constexpr] = ACTIONS(1569),
    [anon_sym_volatile] = ACTIONS(1569),
    [anon_sym_restrict] = ACTIONS(1569),
    [anon_sym___restrict__] = ACTIONS(1569),
    [anon_sym__Atomic] = ACTIONS(1569),
    [anon_sym__Noreturn] = ACTIONS(1569),
    [anon_sym_noreturn] = ACTIONS(1569),
    [sym_primitive_type] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_goto] = ACTIONS(1569),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_sizeof] = ACTIONS(1569),
    [anon_sym___alignof__] = ACTIONS(1569),
    [anon_sym___alignof] = ACTIONS(1569),
    [anon_sym__alignof] = ACTIONS(1569),
    [anon_sym_alignof] = ACTIONS(1569),
    [anon_sym__Alignof] = ACTIONS(1569),
    [anon_sym_offsetof] = ACTIONS(1569),
    [anon_sym__Generic] = ACTIONS(1569),
    [anon_sym_asm] = ACTIONS(1569),
    [anon_sym___asm__] = ACTIONS(1569),
    [sym_number_literal] = ACTIONS(1571),
    [anon_sym_L_SQUOTE] = ACTIONS(1571),
    [anon_sym_u_SQUOTE] = ACTIONS(1571),
    [anon_sym_U_SQUOTE] = ACTIONS(1571),
    [anon_sym_u8_SQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [anon_sym_L_DQUOTE] = ACTIONS(1571),
    [anon_sym_u_DQUOTE] = ACTIONS(1571),
    [anon_sym_U_DQUOTE] = ACTIONS(1571),
    [anon_sym_u8_DQUOTE] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [anon_sym_NULL] = ACTIONS(1569),
    [anon_sym_nullptr] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1569),
    [anon_sym_acquire] = ACTIONS(1569),
    [anon_sym_catch] = ACTIONS(1569),
    [anon_sym_monitor] = ACTIONS(1569),
    [anon_sym_start] = ACTIONS(1569),
    [anon_sym_stop] = ACTIONS(1569),
  },
  [397] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(139),
    [sym_attributed_statement] = STATE(139),
    [sym_labeled_statement] = STATE(139),
    [sym_expression_statement] = STATE(139),
    [sym_if_statement] = STATE(139),
    [sym_switch_statement] = STATE(139),
    [sym_case_statement] = STATE(139),
    [sym_while_statement] = STATE(139),
    [sym_do_statement] = STATE(139),
    [sym_for_statement] = STATE(139),
    [sym_return_statement] = STATE(139),
    [sym_break_statement] = STATE(139),
    [sym_continue_statement] = STATE(139),
    [sym_goto_statement] = STATE(139),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(139),
    [sym_acquire_statement] = STATE(139),
    [sym_monitor_statement] = STATE(139),
    [sym_start_statement] = STATE(139),
    [sym_stop_statement] = STATE(139),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [398] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(108),
    [sym_attributed_statement] = STATE(108),
    [sym_labeled_statement] = STATE(108),
    [sym_expression_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_switch_statement] = STATE(108),
    [sym_case_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym_return_statement] = STATE(108),
    [sym_break_statement] = STATE(108),
    [sym_continue_statement] = STATE(108),
    [sym_goto_statement] = STATE(108),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(108),
    [sym_acquire_statement] = STATE(108),
    [sym_monitor_statement] = STATE(108),
    [sym_start_statement] = STATE(108),
    [sym_stop_statement] = STATE(108),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [399] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(145),
    [sym_attributed_statement] = STATE(145),
    [sym_labeled_statement] = STATE(145),
    [sym_expression_statement] = STATE(145),
    [sym_if_statement] = STATE(145),
    [sym_switch_statement] = STATE(145),
    [sym_case_statement] = STATE(145),
    [sym_while_statement] = STATE(145),
    [sym_do_statement] = STATE(145),
    [sym_for_statement] = STATE(145),
    [sym_return_statement] = STATE(145),
    [sym_break_statement] = STATE(145),
    [sym_continue_statement] = STATE(145),
    [sym_goto_statement] = STATE(145),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(145),
    [sym_acquire_statement] = STATE(145),
    [sym_monitor_statement] = STATE(145),
    [sym_start_statement] = STATE(145),
    [sym_stop_statement] = STATE(145),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [400] = {
    [sym_attribute_declaration] = STATE(363),
    [sym_compound_statement] = STATE(106),
    [sym_attributed_statement] = STATE(123),
    [sym_labeled_statement] = STATE(140),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(132),
    [sym_switch_statement] = STATE(131),
    [sym_case_statement] = STATE(130),
    [sym_while_statement] = STATE(129),
    [sym_do_statement] = STATE(125),
    [sym_for_statement] = STATE(124),
    [sym_return_statement] = STATE(121),
    [sym_break_statement] = STATE(120),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(118),
    [sym__expression] = STATE(1073),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1789),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(116),
    [sym_acquire_statement] = STATE(115),
    [sym_monitor_statement] = STATE(114),
    [sym_start_statement] = STATE(113),
    [sym_stop_statement] = STATE(112),
    [aux_sym_attributed_declarator_repeat1] = STATE(363),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(151),
    [anon_sym_do] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_goto] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(169),
    [anon_sym_acquire] = ACTIONS(171),
    [anon_sym_monitor] = ACTIONS(173),
    [anon_sym_start] = ACTIONS(175),
    [anon_sym_stop] = ACTIONS(177),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1648),
    [aux_sym_preproc_include_token1] = ACTIONS(1648),
    [aux_sym_preproc_def_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token2] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1648),
    [aux_sym_preproc_else_token1] = ACTIONS(1648),
    [aux_sym_preproc_elif_token1] = ACTIONS(1648),
    [sym_preproc_directive] = ACTIONS(1648),
    [anon_sym_LPAREN2] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym___extension__] = ACTIONS(1648),
    [anon_sym_typedef] = ACTIONS(1648),
    [anon_sym_extern] = ACTIONS(1648),
    [anon_sym___attribute__] = ACTIONS(1648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1650),
    [anon_sym___declspec] = ACTIONS(1648),
    [anon_sym___cdecl] = ACTIONS(1648),
    [anon_sym___clrcall] = ACTIONS(1648),
    [anon_sym___stdcall] = ACTIONS(1648),
    [anon_sym___fastcall] = ACTIONS(1648),
    [anon_sym___thiscall] = ACTIONS(1648),
    [anon_sym___vectorcall] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_signed] = ACTIONS(1648),
    [anon_sym_unsigned] = ACTIONS(1648),
    [anon_sym_long] = ACTIONS(1648),
    [anon_sym_short] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1648),
    [anon_sym_auto] = ACTIONS(1648),
    [anon_sym_register] = ACTIONS(1648),
    [anon_sym_inline] = ACTIONS(1648),
    [anon_sym___inline] = ACTIONS(1648),
    [anon_sym___inline__] = ACTIONS(1648),
    [anon_sym___forceinline] = ACTIONS(1648),
    [anon_sym_thread_local] = ACTIONS(1648),
    [anon_sym___thread] = ACTIONS(1648),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_constexpr] = ACTIONS(1648),
    [anon_sym_volatile] = ACTIONS(1648),
    [anon_sym_restrict] = ACTIONS(1648),
    [anon_sym___restrict__] = ACTIONS(1648),
    [anon_sym__Atomic] = ACTIONS(1648),
    [anon_sym__Noreturn] = ACTIONS(1648),
    [anon_sym_noreturn] = ACTIONS(1648),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1648),
    [anon_sym_struct] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_if] = ACTIONS(1648),
    [anon_sym_switch] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_while] = ACTIONS(1648),
    [anon_sym_do] = ACTIONS(1648),
    [anon_sym_for] = ACTIONS(1648),
    [anon_sym_return] = ACTIONS(1648),
    [anon_sym_break] = ACTIONS(1648),
    [anon_sym_continue] = ACTIONS(1648),
    [anon_sym_goto] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1650),
    [anon_sym_sizeof] = ACTIONS(1648),
    [anon_sym___alignof__] = ACTIONS(1648),
    [anon_sym___alignof] = ACTIONS(1648),
    [anon_sym__alignof] = ACTIONS(1648),
    [anon_sym_alignof] = ACTIONS(1648),
    [anon_sym__Alignof] = ACTIONS(1648),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1648),
    [anon_sym_asm] = ACTIONS(1648),
    [anon_sym___asm__] = ACTIONS(1648),
    [sym_number_literal] = ACTIONS(1650),
    [anon_sym_L_SQUOTE] = ACTIONS(1650),
    [anon_sym_u_SQUOTE] = ACTIONS(1650),
    [anon_sym_U_SQUOTE] = ACTIONS(1650),
    [anon_sym_u8_SQUOTE] = ACTIONS(1650),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [anon_sym_L_DQUOTE] = ACTIONS(1650),
    [anon_sym_u_DQUOTE] = ACTIONS(1650),
    [anon_sym_U_DQUOTE] = ACTIONS(1650),
    [anon_sym_u8_DQUOTE] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_true] = ACTIONS(1648),
    [sym_false] = ACTIONS(1648),
    [anon_sym_NULL] = ACTIONS(1648),
    [anon_sym_nullptr] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1648),
    [anon_sym_acquire] = ACTIONS(1648),
    [anon_sym_monitor] = ACTIONS(1648),
    [anon_sym_start] = ACTIONS(1648),
    [anon_sym_stop] = ACTIONS(1648),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1664),
    [aux_sym_preproc_include_token1] = ACTIONS(1664),
    [aux_sym_preproc_def_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token2] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1664),
    [aux_sym_preproc_else_token1] = ACTIONS(1664),
    [aux_sym_preproc_elif_token1] = ACTIONS(1664),
    [sym_preproc_directive] = ACTIONS(1664),
    [anon_sym_LPAREN2] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym___attribute__] = ACTIONS(1664),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1666),
    [anon_sym___declspec] = ACTIONS(1664),
    [anon_sym___cdecl] = ACTIONS(1664),
    [anon_sym___clrcall] = ACTIONS(1664),
    [anon_sym___stdcall] = ACTIONS(1664),
    [anon_sym___fastcall] = ACTIONS(1664),
    [anon_sym___thiscall] = ACTIONS(1664),
    [anon_sym___vectorcall] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_signed] = ACTIONS(1664),
    [anon_sym_unsigned] = ACTIONS(1664),
    [anon_sym_long] = ACTIONS(1664),
    [anon_sym_short] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_auto] = ACTIONS(1664),
    [anon_sym_register] = ACTIONS(1664),
    [anon_sym_inline] = ACTIONS(1664),
    [anon_sym___inline] = ACTIONS(1664),
    [anon_sym___inline__] = ACTIONS(1664),
    [anon_sym___forceinline] = ACTIONS(1664),
    [anon_sym_thread_local] = ACTIONS(1664),
    [anon_sym___thread] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_constexpr] = ACTIONS(1664),
    [anon_sym_volatile] = ACTIONS(1664),
    [anon_sym_restrict] = ACTIONS(1664),
    [anon_sym___restrict__] = ACTIONS(1664),
    [anon_sym__Atomic] = ACTIONS(1664),
    [anon_sym__Noreturn] = ACTIONS(1664),
    [anon_sym_noreturn] = ACTIONS(1664),
    [sym_primitive_type] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_switch] = ACTIONS(1664),
    [anon_sym_case] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_do] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_goto] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1666),
    [anon_sym_sizeof] = ACTIONS(1664),
    [anon_sym___alignof__] = ACTIONS(1664),
    [anon_sym___alignof] = ACTIONS(1664),
    [anon_sym__alignof] = ACTIONS(1664),
    [anon_sym_alignof] = ACTIONS(1664),
    [anon_sym__Alignof] = ACTIONS(1664),
    [anon_sym_offsetof] = ACTIONS(1664),
    [anon_sym__Generic] = ACTIONS(1664),
    [anon_sym_asm] = ACTIONS(1664),
    [anon_sym___asm__] = ACTIONS(1664),
    [sym_number_literal] = ACTIONS(1666),
    [anon_sym_L_SQUOTE] = ACTIONS(1666),
    [anon_sym_u_SQUOTE] = ACTIONS(1666),
    [anon_sym_U_SQUOTE] = ACTIONS(1666),
    [anon_sym_u8_SQUOTE] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1666),
    [anon_sym_L_DQUOTE] = ACTIONS(1666),
    [anon_sym_u_DQUOTE] = ACTIONS(1666),
    [anon_sym_U_DQUOTE] = ACTIONS(1666),
    [anon_sym_u8_DQUOTE] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1666),
    [sym_true] = ACTIONS(1664),
    [sym_false] = ACTIONS(1664),
    [anon_sym_NULL] = ACTIONS(1664),
    [anon_sym_nullptr] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1664),
    [anon_sym_acquire] = ACTIONS(1664),
    [anon_sym_monitor] = ACTIONS(1664),
    [anon_sym_start] = ACTIONS(1664),
    [anon_sym_stop] = ACTIONS(1664),
  },
  [403] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(193),
    [sym_attributed_statement] = STATE(193),
    [sym_labeled_statement] = STATE(193),
    [sym_expression_statement] = STATE(193),
    [sym_if_statement] = STATE(193),
    [sym_switch_statement] = STATE(193),
    [sym_case_statement] = STATE(193),
    [sym_while_statement] = STATE(193),
    [sym_do_statement] = STATE(193),
    [sym_for_statement] = STATE(193),
    [sym_return_statement] = STATE(193),
    [sym_break_statement] = STATE(193),
    [sym_continue_statement] = STATE(193),
    [sym_goto_statement] = STATE(193),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(193),
    [sym_acquire_statement] = STATE(193),
    [sym_monitor_statement] = STATE(193),
    [sym_start_statement] = STATE(193),
    [sym_stop_statement] = STATE(193),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [404] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_include_token1] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token2] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_LPAREN2] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym___cdecl] = ACTIONS(1468),
    [anon_sym___clrcall] = ACTIONS(1468),
    [anon_sym___stdcall] = ACTIONS(1468),
    [anon_sym___fastcall] = ACTIONS(1468),
    [anon_sym___thiscall] = ACTIONS(1468),
    [anon_sym___vectorcall] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym___inline] = ACTIONS(1468),
    [anon_sym___inline__] = ACTIONS(1468),
    [anon_sym___forceinline] = ACTIONS(1468),
    [anon_sym_thread_local] = ACTIONS(1468),
    [anon_sym___thread] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_constexpr] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym___restrict__] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym__Noreturn] = ACTIONS(1468),
    [anon_sym_noreturn] = ACTIONS(1468),
    [sym_primitive_type] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_goto] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_sizeof] = ACTIONS(1468),
    [anon_sym___alignof__] = ACTIONS(1468),
    [anon_sym___alignof] = ACTIONS(1468),
    [anon_sym__alignof] = ACTIONS(1468),
    [anon_sym_alignof] = ACTIONS(1468),
    [anon_sym__Alignof] = ACTIONS(1468),
    [anon_sym_offsetof] = ACTIONS(1468),
    [anon_sym__Generic] = ACTIONS(1468),
    [anon_sym_asm] = ACTIONS(1468),
    [anon_sym___asm__] = ACTIONS(1468),
    [sym_number_literal] = ACTIONS(1470),
    [anon_sym_L_SQUOTE] = ACTIONS(1470),
    [anon_sym_u_SQUOTE] = ACTIONS(1470),
    [anon_sym_U_SQUOTE] = ACTIONS(1470),
    [anon_sym_u8_SQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_L_DQUOTE] = ACTIONS(1470),
    [anon_sym_u_DQUOTE] = ACTIONS(1470),
    [anon_sym_U_DQUOTE] = ACTIONS(1470),
    [anon_sym_u8_DQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [anon_sym_NULL] = ACTIONS(1468),
    [anon_sym_nullptr] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1468),
    [anon_sym_acquire] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_monitor] = ACTIONS(1468),
    [anon_sym_start] = ACTIONS(1468),
    [anon_sym_stop] = ACTIONS(1468),
  },
  [405] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(192),
    [sym_attributed_statement] = STATE(192),
    [sym_labeled_statement] = STATE(192),
    [sym_expression_statement] = STATE(192),
    [sym_if_statement] = STATE(192),
    [sym_switch_statement] = STATE(192),
    [sym_case_statement] = STATE(192),
    [sym_while_statement] = STATE(192),
    [sym_do_statement] = STATE(192),
    [sym_for_statement] = STATE(192),
    [sym_return_statement] = STATE(192),
    [sym_break_statement] = STATE(192),
    [sym_continue_statement] = STATE(192),
    [sym_goto_statement] = STATE(192),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(192),
    [sym_acquire_statement] = STATE(192),
    [sym_monitor_statement] = STATE(192),
    [sym_start_statement] = STATE(192),
    [sym_stop_statement] = STATE(192),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [406] = {
    [sym_identifier] = ACTIONS(1584),
    [aux_sym_preproc_include_token1] = ACTIONS(1584),
    [aux_sym_preproc_def_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token2] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1584),
    [aux_sym_preproc_else_token1] = ACTIONS(1584),
    [aux_sym_preproc_elif_token1] = ACTIONS(1584),
    [sym_preproc_directive] = ACTIONS(1584),
    [anon_sym_LPAREN2] = ACTIONS(1586),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym___extension__] = ACTIONS(1584),
    [anon_sym_typedef] = ACTIONS(1584),
    [anon_sym_extern] = ACTIONS(1584),
    [anon_sym___attribute__] = ACTIONS(1584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1586),
    [anon_sym___declspec] = ACTIONS(1584),
    [anon_sym___cdecl] = ACTIONS(1584),
    [anon_sym___clrcall] = ACTIONS(1584),
    [anon_sym___stdcall] = ACTIONS(1584),
    [anon_sym___fastcall] = ACTIONS(1584),
    [anon_sym___thiscall] = ACTIONS(1584),
    [anon_sym___vectorcall] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_signed] = ACTIONS(1584),
    [anon_sym_unsigned] = ACTIONS(1584),
    [anon_sym_long] = ACTIONS(1584),
    [anon_sym_short] = ACTIONS(1584),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_auto] = ACTIONS(1584),
    [anon_sym_register] = ACTIONS(1584),
    [anon_sym_inline] = ACTIONS(1584),
    [anon_sym___inline] = ACTIONS(1584),
    [anon_sym___inline__] = ACTIONS(1584),
    [anon_sym___forceinline] = ACTIONS(1584),
    [anon_sym_thread_local] = ACTIONS(1584),
    [anon_sym___thread] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_constexpr] = ACTIONS(1584),
    [anon_sym_volatile] = ACTIONS(1584),
    [anon_sym_restrict] = ACTIONS(1584),
    [anon_sym___restrict__] = ACTIONS(1584),
    [anon_sym__Atomic] = ACTIONS(1584),
    [anon_sym__Noreturn] = ACTIONS(1584),
    [anon_sym_noreturn] = ACTIONS(1584),
    [sym_primitive_type] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_goto] = ACTIONS(1584),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_sizeof] = ACTIONS(1584),
    [anon_sym___alignof__] = ACTIONS(1584),
    [anon_sym___alignof] = ACTIONS(1584),
    [anon_sym__alignof] = ACTIONS(1584),
    [anon_sym_alignof] = ACTIONS(1584),
    [anon_sym__Alignof] = ACTIONS(1584),
    [anon_sym_offsetof] = ACTIONS(1584),
    [anon_sym__Generic] = ACTIONS(1584),
    [anon_sym_asm] = ACTIONS(1584),
    [anon_sym___asm__] = ACTIONS(1584),
    [sym_number_literal] = ACTIONS(1586),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1586),
    [anon_sym_u_DQUOTE] = ACTIONS(1586),
    [anon_sym_U_DQUOTE] = ACTIONS(1586),
    [anon_sym_u8_DQUOTE] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [anon_sym_NULL] = ACTIONS(1584),
    [anon_sym_nullptr] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1584),
    [anon_sym_acquire] = ACTIONS(1584),
    [anon_sym_monitor] = ACTIONS(1584),
    [anon_sym_start] = ACTIONS(1584),
    [anon_sym_stop] = ACTIONS(1584),
  },
  [407] = {
    [sym_identifier] = ACTIONS(1472),
    [aux_sym_preproc_include_token1] = ACTIONS(1472),
    [aux_sym_preproc_def_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token2] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1472),
    [sym_preproc_directive] = ACTIONS(1472),
    [anon_sym_LPAREN2] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [anon_sym___extension__] = ACTIONS(1472),
    [anon_sym_typedef] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym___attribute__] = ACTIONS(1472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1474),
    [anon_sym___declspec] = ACTIONS(1472),
    [anon_sym___cdecl] = ACTIONS(1472),
    [anon_sym___clrcall] = ACTIONS(1472),
    [anon_sym___stdcall] = ACTIONS(1472),
    [anon_sym___fastcall] = ACTIONS(1472),
    [anon_sym___thiscall] = ACTIONS(1472),
    [anon_sym___vectorcall] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_signed] = ACTIONS(1472),
    [anon_sym_unsigned] = ACTIONS(1472),
    [anon_sym_long] = ACTIONS(1472),
    [anon_sym_short] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_auto] = ACTIONS(1472),
    [anon_sym_register] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym___inline] = ACTIONS(1472),
    [anon_sym___inline__] = ACTIONS(1472),
    [anon_sym___forceinline] = ACTIONS(1472),
    [anon_sym_thread_local] = ACTIONS(1472),
    [anon_sym___thread] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_constexpr] = ACTIONS(1472),
    [anon_sym_volatile] = ACTIONS(1472),
    [anon_sym_restrict] = ACTIONS(1472),
    [anon_sym___restrict__] = ACTIONS(1472),
    [anon_sym__Atomic] = ACTIONS(1472),
    [anon_sym__Noreturn] = ACTIONS(1472),
    [anon_sym_noreturn] = ACTIONS(1472),
    [sym_primitive_type] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_struct] = ACTIONS(1472),
    [anon_sym_union] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_goto] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [anon_sym_sizeof] = ACTIONS(1472),
    [anon_sym___alignof__] = ACTIONS(1472),
    [anon_sym___alignof] = ACTIONS(1472),
    [anon_sym__alignof] = ACTIONS(1472),
    [anon_sym_alignof] = ACTIONS(1472),
    [anon_sym__Alignof] = ACTIONS(1472),
    [anon_sym_offsetof] = ACTIONS(1472),
    [anon_sym__Generic] = ACTIONS(1472),
    [anon_sym_asm] = ACTIONS(1472),
    [anon_sym___asm__] = ACTIONS(1472),
    [sym_number_literal] = ACTIONS(1474),
    [anon_sym_L_SQUOTE] = ACTIONS(1474),
    [anon_sym_u_SQUOTE] = ACTIONS(1474),
    [anon_sym_U_SQUOTE] = ACTIONS(1474),
    [anon_sym_u8_SQUOTE] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_L_DQUOTE] = ACTIONS(1474),
    [anon_sym_u_DQUOTE] = ACTIONS(1474),
    [anon_sym_U_DQUOTE] = ACTIONS(1474),
    [anon_sym_u8_DQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [anon_sym_NULL] = ACTIONS(1472),
    [anon_sym_nullptr] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1472),
    [anon_sym_acquire] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_monitor] = ACTIONS(1472),
    [anon_sym_start] = ACTIONS(1472),
    [anon_sym_stop] = ACTIONS(1472),
  },
  [408] = {
    [sym_identifier] = ACTIONS(1660),
    [aux_sym_preproc_include_token1] = ACTIONS(1660),
    [aux_sym_preproc_def_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token2] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1660),
    [aux_sym_preproc_else_token1] = ACTIONS(1660),
    [aux_sym_preproc_elif_token1] = ACTIONS(1660),
    [sym_preproc_directive] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_TILDE] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1660),
    [anon_sym_typedef] = ACTIONS(1660),
    [anon_sym_extern] = ACTIONS(1660),
    [anon_sym___attribute__] = ACTIONS(1660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1662),
    [anon_sym___declspec] = ACTIONS(1660),
    [anon_sym___cdecl] = ACTIONS(1660),
    [anon_sym___clrcall] = ACTIONS(1660),
    [anon_sym___stdcall] = ACTIONS(1660),
    [anon_sym___fastcall] = ACTIONS(1660),
    [anon_sym___thiscall] = ACTIONS(1660),
    [anon_sym___vectorcall] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_signed] = ACTIONS(1660),
    [anon_sym_unsigned] = ACTIONS(1660),
    [anon_sym_long] = ACTIONS(1660),
    [anon_sym_short] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_auto] = ACTIONS(1660),
    [anon_sym_register] = ACTIONS(1660),
    [anon_sym_inline] = ACTIONS(1660),
    [anon_sym___inline] = ACTIONS(1660),
    [anon_sym___inline__] = ACTIONS(1660),
    [anon_sym___forceinline] = ACTIONS(1660),
    [anon_sym_thread_local] = ACTIONS(1660),
    [anon_sym___thread] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1660),
    [anon_sym_constexpr] = ACTIONS(1660),
    [anon_sym_volatile] = ACTIONS(1660),
    [anon_sym_restrict] = ACTIONS(1660),
    [anon_sym___restrict__] = ACTIONS(1660),
    [anon_sym__Atomic] = ACTIONS(1660),
    [anon_sym__Noreturn] = ACTIONS(1660),
    [anon_sym_noreturn] = ACTIONS(1660),
    [sym_primitive_type] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1660),
    [anon_sym_struct] = ACTIONS(1660),
    [anon_sym_union] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1660),
    [anon_sym_switch] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1660),
    [anon_sym_default] = ACTIONS(1660),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_return] = ACTIONS(1660),
    [anon_sym_break] = ACTIONS(1660),
    [anon_sym_continue] = ACTIONS(1660),
    [anon_sym_goto] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1662),
    [anon_sym_sizeof] = ACTIONS(1660),
    [anon_sym___alignof__] = ACTIONS(1660),
    [anon_sym___alignof] = ACTIONS(1660),
    [anon_sym__alignof] = ACTIONS(1660),
    [anon_sym_alignof] = ACTIONS(1660),
    [anon_sym__Alignof] = ACTIONS(1660),
    [anon_sym_offsetof] = ACTIONS(1660),
    [anon_sym__Generic] = ACTIONS(1660),
    [anon_sym_asm] = ACTIONS(1660),
    [anon_sym___asm__] = ACTIONS(1660),
    [sym_number_literal] = ACTIONS(1662),
    [anon_sym_L_SQUOTE] = ACTIONS(1662),
    [anon_sym_u_SQUOTE] = ACTIONS(1662),
    [anon_sym_U_SQUOTE] = ACTIONS(1662),
    [anon_sym_u8_SQUOTE] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1662),
    [anon_sym_L_DQUOTE] = ACTIONS(1662),
    [anon_sym_u_DQUOTE] = ACTIONS(1662),
    [anon_sym_U_DQUOTE] = ACTIONS(1662),
    [anon_sym_u8_DQUOTE] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [sym_true] = ACTIONS(1660),
    [sym_false] = ACTIONS(1660),
    [anon_sym_NULL] = ACTIONS(1660),
    [anon_sym_nullptr] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1660),
    [anon_sym_acquire] = ACTIONS(1660),
    [anon_sym_monitor] = ACTIONS(1660),
    [anon_sym_start] = ACTIONS(1660),
    [anon_sym_stop] = ACTIONS(1660),
  },
  [409] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_include_token1] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token2] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_LPAREN2] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym___extension__] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym___cdecl] = ACTIONS(1476),
    [anon_sym___clrcall] = ACTIONS(1476),
    [anon_sym___stdcall] = ACTIONS(1476),
    [anon_sym___fastcall] = ACTIONS(1476),
    [anon_sym___thiscall] = ACTIONS(1476),
    [anon_sym___vectorcall] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym___inline] = ACTIONS(1476),
    [anon_sym___inline__] = ACTIONS(1476),
    [anon_sym___forceinline] = ACTIONS(1476),
    [anon_sym_thread_local] = ACTIONS(1476),
    [anon_sym___thread] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_constexpr] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym___restrict__] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym__Noreturn] = ACTIONS(1476),
    [anon_sym_noreturn] = ACTIONS(1476),
    [sym_primitive_type] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_switch] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_default] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_do] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_goto] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_sizeof] = ACTIONS(1476),
    [anon_sym___alignof__] = ACTIONS(1476),
    [anon_sym___alignof] = ACTIONS(1476),
    [anon_sym__alignof] = ACTIONS(1476),
    [anon_sym_alignof] = ACTIONS(1476),
    [anon_sym__Alignof] = ACTIONS(1476),
    [anon_sym_offsetof] = ACTIONS(1476),
    [anon_sym__Generic] = ACTIONS(1476),
    [anon_sym_asm] = ACTIONS(1476),
    [anon_sym___asm__] = ACTIONS(1476),
    [sym_number_literal] = ACTIONS(1478),
    [anon_sym_L_SQUOTE] = ACTIONS(1478),
    [anon_sym_u_SQUOTE] = ACTIONS(1478),
    [anon_sym_U_SQUOTE] = ACTIONS(1478),
    [anon_sym_u8_SQUOTE] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_L_DQUOTE] = ACTIONS(1478),
    [anon_sym_u_DQUOTE] = ACTIONS(1478),
    [anon_sym_U_DQUOTE] = ACTIONS(1478),
    [anon_sym_u8_DQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [anon_sym_NULL] = ACTIONS(1476),
    [anon_sym_nullptr] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1476),
    [anon_sym_acquire] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_monitor] = ACTIONS(1476),
    [anon_sym_start] = ACTIONS(1476),
    [anon_sym_stop] = ACTIONS(1476),
  },
  [410] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(554),
    [sym_attributed_statement] = STATE(554),
    [sym_labeled_statement] = STATE(554),
    [sym_expression_statement] = STATE(554),
    [sym_if_statement] = STATE(554),
    [sym_switch_statement] = STATE(554),
    [sym_case_statement] = STATE(554),
    [sym_while_statement] = STATE(554),
    [sym_do_statement] = STATE(554),
    [sym_for_statement] = STATE(554),
    [sym_return_statement] = STATE(554),
    [sym_break_statement] = STATE(554),
    [sym_continue_statement] = STATE(554),
    [sym_goto_statement] = STATE(554),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(554),
    [sym_acquire_statement] = STATE(554),
    [sym_monitor_statement] = STATE(554),
    [sym_start_statement] = STATE(554),
    [sym_stop_statement] = STATE(554),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [411] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(249),
    [sym_attributed_statement] = STATE(249),
    [sym_labeled_statement] = STATE(249),
    [sym_expression_statement] = STATE(249),
    [sym_if_statement] = STATE(249),
    [sym_switch_statement] = STATE(249),
    [sym_case_statement] = STATE(249),
    [sym_while_statement] = STATE(249),
    [sym_do_statement] = STATE(249),
    [sym_for_statement] = STATE(249),
    [sym_return_statement] = STATE(249),
    [sym_break_statement] = STATE(249),
    [sym_continue_statement] = STATE(249),
    [sym_goto_statement] = STATE(249),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(249),
    [sym_acquire_statement] = STATE(249),
    [sym_monitor_statement] = STATE(249),
    [sym_start_statement] = STATE(249),
    [sym_stop_statement] = STATE(249),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [412] = {
    [sym_identifier] = ACTIONS(1561),
    [aux_sym_preproc_include_token1] = ACTIONS(1561),
    [aux_sym_preproc_def_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1561),
    [sym_preproc_directive] = ACTIONS(1561),
    [anon_sym_LPAREN2] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym___extension__] = ACTIONS(1561),
    [anon_sym_typedef] = ACTIONS(1561),
    [anon_sym_extern] = ACTIONS(1561),
    [anon_sym___attribute__] = ACTIONS(1561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1563),
    [anon_sym___declspec] = ACTIONS(1561),
    [anon_sym___cdecl] = ACTIONS(1561),
    [anon_sym___clrcall] = ACTIONS(1561),
    [anon_sym___stdcall] = ACTIONS(1561),
    [anon_sym___fastcall] = ACTIONS(1561),
    [anon_sym___thiscall] = ACTIONS(1561),
    [anon_sym___vectorcall] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_RBRACE] = ACTIONS(1563),
    [anon_sym_signed] = ACTIONS(1561),
    [anon_sym_unsigned] = ACTIONS(1561),
    [anon_sym_long] = ACTIONS(1561),
    [anon_sym_short] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_auto] = ACTIONS(1561),
    [anon_sym_register] = ACTIONS(1561),
    [anon_sym_inline] = ACTIONS(1561),
    [anon_sym___inline] = ACTIONS(1561),
    [anon_sym___inline__] = ACTIONS(1561),
    [anon_sym___forceinline] = ACTIONS(1561),
    [anon_sym_thread_local] = ACTIONS(1561),
    [anon_sym___thread] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_constexpr] = ACTIONS(1561),
    [anon_sym_volatile] = ACTIONS(1561),
    [anon_sym_restrict] = ACTIONS(1561),
    [anon_sym___restrict__] = ACTIONS(1561),
    [anon_sym__Atomic] = ACTIONS(1561),
    [anon_sym__Noreturn] = ACTIONS(1561),
    [anon_sym_noreturn] = ACTIONS(1561),
    [sym_primitive_type] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [anon_sym_struct] = ACTIONS(1561),
    [anon_sym_union] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_goto] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_sizeof] = ACTIONS(1561),
    [anon_sym___alignof__] = ACTIONS(1561),
    [anon_sym___alignof] = ACTIONS(1561),
    [anon_sym__alignof] = ACTIONS(1561),
    [anon_sym_alignof] = ACTIONS(1561),
    [anon_sym__Alignof] = ACTIONS(1561),
    [anon_sym_offsetof] = ACTIONS(1561),
    [anon_sym__Generic] = ACTIONS(1561),
    [anon_sym_asm] = ACTIONS(1561),
    [anon_sym___asm__] = ACTIONS(1561),
    [sym_number_literal] = ACTIONS(1563),
    [anon_sym_L_SQUOTE] = ACTIONS(1563),
    [anon_sym_u_SQUOTE] = ACTIONS(1563),
    [anon_sym_U_SQUOTE] = ACTIONS(1563),
    [anon_sym_u8_SQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [anon_sym_L_DQUOTE] = ACTIONS(1563),
    [anon_sym_u_DQUOTE] = ACTIONS(1563),
    [anon_sym_U_DQUOTE] = ACTIONS(1563),
    [anon_sym_u8_DQUOTE] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [anon_sym_NULL] = ACTIONS(1561),
    [anon_sym_nullptr] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_acquire] = ACTIONS(1561),
    [anon_sym_catch] = ACTIONS(1561),
    [anon_sym_monitor] = ACTIONS(1561),
    [anon_sym_start] = ACTIONS(1561),
    [anon_sym_stop] = ACTIONS(1561),
  },
  [413] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(177),
    [sym_acquire_statement] = STATE(177),
    [sym_monitor_statement] = STATE(177),
    [sym_start_statement] = STATE(177),
    [sym_stop_statement] = STATE(177),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [414] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(256),
    [sym_attributed_statement] = STATE(256),
    [sym_labeled_statement] = STATE(256),
    [sym_expression_statement] = STATE(256),
    [sym_if_statement] = STATE(256),
    [sym_switch_statement] = STATE(256),
    [sym_case_statement] = STATE(256),
    [sym_while_statement] = STATE(256),
    [sym_do_statement] = STATE(256),
    [sym_for_statement] = STATE(256),
    [sym_return_statement] = STATE(256),
    [sym_break_statement] = STATE(256),
    [sym_continue_statement] = STATE(256),
    [sym_goto_statement] = STATE(256),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(256),
    [sym_acquire_statement] = STATE(256),
    [sym_monitor_statement] = STATE(256),
    [sym_start_statement] = STATE(256),
    [sym_stop_statement] = STATE(256),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [415] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(260),
    [sym_attributed_statement] = STATE(260),
    [sym_labeled_statement] = STATE(260),
    [sym_expression_statement] = STATE(260),
    [sym_if_statement] = STATE(260),
    [sym_switch_statement] = STATE(260),
    [sym_case_statement] = STATE(260),
    [sym_while_statement] = STATE(260),
    [sym_do_statement] = STATE(260),
    [sym_for_statement] = STATE(260),
    [sym_return_statement] = STATE(260),
    [sym_break_statement] = STATE(260),
    [sym_continue_statement] = STATE(260),
    [sym_goto_statement] = STATE(260),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(260),
    [sym_acquire_statement] = STATE(260),
    [sym_monitor_statement] = STATE(260),
    [sym_start_statement] = STATE(260),
    [sym_stop_statement] = STATE(260),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [416] = {
    [sym_attribute_declaration] = STATE(283),
    [sym_compound_statement] = STATE(146),
    [sym_attributed_statement] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_case_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym__expression] = STATE(1103),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1943),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(146),
    [sym_acquire_statement] = STATE(146),
    [sym_monitor_statement] = STATE(146),
    [sym_start_statement] = STATE(146),
    [sym_stop_statement] = STATE(146),
    [aux_sym_attributed_declarator_repeat1] = STATE(283),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_switch] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(231),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(239),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(243),
    [anon_sym_acquire] = ACTIONS(245),
    [anon_sym_monitor] = ACTIONS(247),
    [anon_sym_start] = ACTIONS(249),
    [anon_sym_stop] = ACTIONS(251),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1472),
    [aux_sym_preproc_include_token1] = ACTIONS(1472),
    [aux_sym_preproc_def_token1] = ACTIONS(1472),
    [aux_sym_preproc_if_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1472),
    [sym_preproc_directive] = ACTIONS(1472),
    [anon_sym_LPAREN2] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [anon_sym___extension__] = ACTIONS(1472),
    [anon_sym_typedef] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym___attribute__] = ACTIONS(1472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1474),
    [anon_sym___declspec] = ACTIONS(1472),
    [anon_sym___cdecl] = ACTIONS(1472),
    [anon_sym___clrcall] = ACTIONS(1472),
    [anon_sym___stdcall] = ACTIONS(1472),
    [anon_sym___fastcall] = ACTIONS(1472),
    [anon_sym___thiscall] = ACTIONS(1472),
    [anon_sym___vectorcall] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_RBRACE] = ACTIONS(1474),
    [anon_sym_signed] = ACTIONS(1472),
    [anon_sym_unsigned] = ACTIONS(1472),
    [anon_sym_long] = ACTIONS(1472),
    [anon_sym_short] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_auto] = ACTIONS(1472),
    [anon_sym_register] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym___inline] = ACTIONS(1472),
    [anon_sym___inline__] = ACTIONS(1472),
    [anon_sym___forceinline] = ACTIONS(1472),
    [anon_sym_thread_local] = ACTIONS(1472),
    [anon_sym___thread] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_constexpr] = ACTIONS(1472),
    [anon_sym_volatile] = ACTIONS(1472),
    [anon_sym_restrict] = ACTIONS(1472),
    [anon_sym___restrict__] = ACTIONS(1472),
    [anon_sym__Atomic] = ACTIONS(1472),
    [anon_sym__Noreturn] = ACTIONS(1472),
    [anon_sym_noreturn] = ACTIONS(1472),
    [sym_primitive_type] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_struct] = ACTIONS(1472),
    [anon_sym_union] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_goto] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [anon_sym_sizeof] = ACTIONS(1472),
    [anon_sym___alignof__] = ACTIONS(1472),
    [anon_sym___alignof] = ACTIONS(1472),
    [anon_sym__alignof] = ACTIONS(1472),
    [anon_sym_alignof] = ACTIONS(1472),
    [anon_sym__Alignof] = ACTIONS(1472),
    [anon_sym_offsetof] = ACTIONS(1472),
    [anon_sym__Generic] = ACTIONS(1472),
    [anon_sym_asm] = ACTIONS(1472),
    [anon_sym___asm__] = ACTIONS(1472),
    [sym_number_literal] = ACTIONS(1474),
    [anon_sym_L_SQUOTE] = ACTIONS(1474),
    [anon_sym_u_SQUOTE] = ACTIONS(1474),
    [anon_sym_U_SQUOTE] = ACTIONS(1474),
    [anon_sym_u8_SQUOTE] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_L_DQUOTE] = ACTIONS(1474),
    [anon_sym_u_DQUOTE] = ACTIONS(1474),
    [anon_sym_U_DQUOTE] = ACTIONS(1474),
    [anon_sym_u8_DQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [anon_sym_NULL] = ACTIONS(1472),
    [anon_sym_nullptr] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1472),
    [anon_sym_acquire] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_monitor] = ACTIONS(1472),
    [anon_sym_start] = ACTIONS(1472),
    [anon_sym_stop] = ACTIONS(1472),
  },
  [418] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(373),
    [sym_attributed_statement] = STATE(364),
    [sym_labeled_statement] = STATE(358),
    [sym_expression_statement] = STATE(357),
    [sym_if_statement] = STATE(355),
    [sym_switch_statement] = STATE(354),
    [sym_case_statement] = STATE(353),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(350),
    [sym_for_statement] = STATE(349),
    [sym_return_statement] = STATE(348),
    [sym_break_statement] = STATE(347),
    [sym_continue_statement] = STATE(346),
    [sym_goto_statement] = STATE(345),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(344),
    [sym_acquire_statement] = STATE(343),
    [sym_monitor_statement] = STATE(342),
    [sym_start_statement] = STATE(341),
    [sym_stop_statement] = STATE(340),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [419] = {
    [sym_identifier] = ACTIONS(1656),
    [aux_sym_preproc_include_token1] = ACTIONS(1656),
    [aux_sym_preproc_def_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token2] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1656),
    [aux_sym_preproc_else_token1] = ACTIONS(1656),
    [aux_sym_preproc_elif_token1] = ACTIONS(1656),
    [sym_preproc_directive] = ACTIONS(1656),
    [anon_sym_LPAREN2] = ACTIONS(1658),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_TILDE] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_SEMI] = ACTIONS(1658),
    [anon_sym___extension__] = ACTIONS(1656),
    [anon_sym_typedef] = ACTIONS(1656),
    [anon_sym_extern] = ACTIONS(1656),
    [anon_sym___attribute__] = ACTIONS(1656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1658),
    [anon_sym___declspec] = ACTIONS(1656),
    [anon_sym___cdecl] = ACTIONS(1656),
    [anon_sym___clrcall] = ACTIONS(1656),
    [anon_sym___stdcall] = ACTIONS(1656),
    [anon_sym___fastcall] = ACTIONS(1656),
    [anon_sym___thiscall] = ACTIONS(1656),
    [anon_sym___vectorcall] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1658),
    [anon_sym_signed] = ACTIONS(1656),
    [anon_sym_unsigned] = ACTIONS(1656),
    [anon_sym_long] = ACTIONS(1656),
    [anon_sym_short] = ACTIONS(1656),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_auto] = ACTIONS(1656),
    [anon_sym_register] = ACTIONS(1656),
    [anon_sym_inline] = ACTIONS(1656),
    [anon_sym___inline] = ACTIONS(1656),
    [anon_sym___inline__] = ACTIONS(1656),
    [anon_sym___forceinline] = ACTIONS(1656),
    [anon_sym_thread_local] = ACTIONS(1656),
    [anon_sym___thread] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_constexpr] = ACTIONS(1656),
    [anon_sym_volatile] = ACTIONS(1656),
    [anon_sym_restrict] = ACTIONS(1656),
    [anon_sym___restrict__] = ACTIONS(1656),
    [anon_sym__Atomic] = ACTIONS(1656),
    [anon_sym__Noreturn] = ACTIONS(1656),
    [anon_sym_noreturn] = ACTIONS(1656),
    [sym_primitive_type] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_struct] = ACTIONS(1656),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_goto] = ACTIONS(1656),
    [anon_sym_DASH_DASH] = ACTIONS(1658),
    [anon_sym_PLUS_PLUS] = ACTIONS(1658),
    [anon_sym_sizeof] = ACTIONS(1656),
    [anon_sym___alignof__] = ACTIONS(1656),
    [anon_sym___alignof] = ACTIONS(1656),
    [anon_sym__alignof] = ACTIONS(1656),
    [anon_sym_alignof] = ACTIONS(1656),
    [anon_sym__Alignof] = ACTIONS(1656),
    [anon_sym_offsetof] = ACTIONS(1656),
    [anon_sym__Generic] = ACTIONS(1656),
    [anon_sym_asm] = ACTIONS(1656),
    [anon_sym___asm__] = ACTIONS(1656),
    [sym_number_literal] = ACTIONS(1658),
    [anon_sym_L_SQUOTE] = ACTIONS(1658),
    [anon_sym_u_SQUOTE] = ACTIONS(1658),
    [anon_sym_U_SQUOTE] = ACTIONS(1658),
    [anon_sym_u8_SQUOTE] = ACTIONS(1658),
    [anon_sym_SQUOTE] = ACTIONS(1658),
    [anon_sym_L_DQUOTE] = ACTIONS(1658),
    [anon_sym_u_DQUOTE] = ACTIONS(1658),
    [anon_sym_U_DQUOTE] = ACTIONS(1658),
    [anon_sym_u8_DQUOTE] = ACTIONS(1658),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [anon_sym_NULL] = ACTIONS(1656),
    [anon_sym_nullptr] = ACTIONS(1656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1656),
    [anon_sym_acquire] = ACTIONS(1656),
    [anon_sym_monitor] = ACTIONS(1656),
    [anon_sym_start] = ACTIONS(1656),
    [anon_sym_stop] = ACTIONS(1656),
  },
  [420] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(204),
    [sym_acquire_statement] = STATE(204),
    [sym_monitor_statement] = STATE(204),
    [sym_start_statement] = STATE(204),
    [sym_stop_statement] = STATE(204),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [421] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(1937),
    [sym_attributed_statement] = STATE(1937),
    [sym_labeled_statement] = STATE(1937),
    [sym_expression_statement] = STATE(1937),
    [sym_if_statement] = STATE(1937),
    [sym_switch_statement] = STATE(1937),
    [sym_case_statement] = STATE(1937),
    [sym_while_statement] = STATE(1937),
    [sym_do_statement] = STATE(1937),
    [sym_for_statement] = STATE(1937),
    [sym_return_statement] = STATE(1937),
    [sym_break_statement] = STATE(1937),
    [sym_continue_statement] = STATE(1937),
    [sym_goto_statement] = STATE(1937),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(1937),
    [sym_acquire_statement] = STATE(1937),
    [sym_monitor_statement] = STATE(1937),
    [sym_start_statement] = STATE(1937),
    [sym_stop_statement] = STATE(1937),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [422] = {
    [sym_identifier] = ACTIONS(1633),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token2] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [aux_sym_preproc_else_token1] = ACTIONS(1633),
    [aux_sym_preproc_elif_token1] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1633),
    [anon_sym_typedef] = ACTIONS(1633),
    [anon_sym_extern] = ACTIONS(1633),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1635),
    [anon_sym___declspec] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_signed] = ACTIONS(1633),
    [anon_sym_unsigned] = ACTIONS(1633),
    [anon_sym_long] = ACTIONS(1633),
    [anon_sym_short] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_auto] = ACTIONS(1633),
    [anon_sym_register] = ACTIONS(1633),
    [anon_sym_inline] = ACTIONS(1633),
    [anon_sym___inline] = ACTIONS(1633),
    [anon_sym___inline__] = ACTIONS(1633),
    [anon_sym___forceinline] = ACTIONS(1633),
    [anon_sym_thread_local] = ACTIONS(1633),
    [anon_sym___thread] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1633),
    [anon_sym_constexpr] = ACTIONS(1633),
    [anon_sym_volatile] = ACTIONS(1633),
    [anon_sym_restrict] = ACTIONS(1633),
    [anon_sym___restrict__] = ACTIONS(1633),
    [anon_sym__Atomic] = ACTIONS(1633),
    [anon_sym__Noreturn] = ACTIONS(1633),
    [anon_sym_noreturn] = ACTIONS(1633),
    [sym_primitive_type] = ACTIONS(1633),
    [anon_sym_enum] = ACTIONS(1633),
    [anon_sym_struct] = ACTIONS(1633),
    [anon_sym_union] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1633),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_for] = ACTIONS(1633),
    [anon_sym_return] = ACTIONS(1633),
    [anon_sym_break] = ACTIONS(1633),
    [anon_sym_continue] = ACTIONS(1633),
    [anon_sym_goto] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_sizeof] = ACTIONS(1633),
    [anon_sym___alignof__] = ACTIONS(1633),
    [anon_sym___alignof] = ACTIONS(1633),
    [anon_sym__alignof] = ACTIONS(1633),
    [anon_sym_alignof] = ACTIONS(1633),
    [anon_sym__Alignof] = ACTIONS(1633),
    [anon_sym_offsetof] = ACTIONS(1633),
    [anon_sym__Generic] = ACTIONS(1633),
    [anon_sym_asm] = ACTIONS(1633),
    [anon_sym___asm__] = ACTIONS(1633),
    [sym_number_literal] = ACTIONS(1635),
    [anon_sym_L_SQUOTE] = ACTIONS(1635),
    [anon_sym_u_SQUOTE] = ACTIONS(1635),
    [anon_sym_U_SQUOTE] = ACTIONS(1635),
    [anon_sym_u8_SQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_L_DQUOTE] = ACTIONS(1635),
    [anon_sym_u_DQUOTE] = ACTIONS(1635),
    [anon_sym_U_DQUOTE] = ACTIONS(1635),
    [anon_sym_u8_DQUOTE] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [anon_sym_NULL] = ACTIONS(1633),
    [anon_sym_nullptr] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1633),
    [anon_sym_acquire] = ACTIONS(1633),
    [anon_sym_monitor] = ACTIONS(1633),
    [anon_sym_start] = ACTIONS(1633),
    [anon_sym_stop] = ACTIONS(1633),
  },
  [423] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(144),
    [sym_attributed_statement] = STATE(144),
    [sym_labeled_statement] = STATE(144),
    [sym_expression_statement] = STATE(144),
    [sym_if_statement] = STATE(144),
    [sym_switch_statement] = STATE(144),
    [sym_case_statement] = STATE(144),
    [sym_while_statement] = STATE(144),
    [sym_do_statement] = STATE(144),
    [sym_for_statement] = STATE(144),
    [sym_return_statement] = STATE(144),
    [sym_break_statement] = STATE(144),
    [sym_continue_statement] = STATE(144),
    [sym_goto_statement] = STATE(144),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(144),
    [sym_acquire_statement] = STATE(144),
    [sym_monitor_statement] = STATE(144),
    [sym_start_statement] = STATE(144),
    [sym_stop_statement] = STATE(144),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [424] = {
    [sym_attribute_declaration] = STATE(431),
    [sym_compound_statement] = STATE(268),
    [sym_attributed_statement] = STATE(268),
    [sym_labeled_statement] = STATE(268),
    [sym_expression_statement] = STATE(268),
    [sym_if_statement] = STATE(268),
    [sym_switch_statement] = STATE(268),
    [sym_case_statement] = STATE(268),
    [sym_while_statement] = STATE(268),
    [sym_do_statement] = STATE(268),
    [sym_for_statement] = STATE(268),
    [sym_return_statement] = STATE(268),
    [sym_break_statement] = STATE(268),
    [sym_continue_statement] = STATE(268),
    [sym_goto_statement] = STATE(268),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(268),
    [sym_acquire_statement] = STATE(268),
    [sym_monitor_statement] = STATE(268),
    [sym_start_statement] = STATE(268),
    [sym_stop_statement] = STATE(268),
    [aux_sym_attributed_declarator_repeat1] = STATE(431),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [425] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(1928),
    [sym_attributed_statement] = STATE(1928),
    [sym_labeled_statement] = STATE(1928),
    [sym_expression_statement] = STATE(1928),
    [sym_if_statement] = STATE(1928),
    [sym_switch_statement] = STATE(1928),
    [sym_case_statement] = STATE(1928),
    [sym_while_statement] = STATE(1928),
    [sym_do_statement] = STATE(1928),
    [sym_for_statement] = STATE(1928),
    [sym_return_statement] = STATE(1928),
    [sym_break_statement] = STATE(1928),
    [sym_continue_statement] = STATE(1928),
    [sym_goto_statement] = STATE(1928),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(1928),
    [sym_acquire_statement] = STATE(1928),
    [sym_monitor_statement] = STATE(1928),
    [sym_start_statement] = STATE(1928),
    [sym_stop_statement] = STATE(1928),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [426] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(1915),
    [sym_attributed_statement] = STATE(1915),
    [sym_labeled_statement] = STATE(1915),
    [sym_expression_statement] = STATE(1915),
    [sym_if_statement] = STATE(1915),
    [sym_switch_statement] = STATE(1915),
    [sym_case_statement] = STATE(1915),
    [sym_while_statement] = STATE(1915),
    [sym_do_statement] = STATE(1915),
    [sym_for_statement] = STATE(1915),
    [sym_return_statement] = STATE(1915),
    [sym_break_statement] = STATE(1915),
    [sym_continue_statement] = STATE(1915),
    [sym_goto_statement] = STATE(1915),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(1915),
    [sym_acquire_statement] = STATE(1915),
    [sym_monitor_statement] = STATE(1915),
    [sym_start_statement] = STATE(1915),
    [sym_stop_statement] = STATE(1915),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [427] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_include_token1] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_LPAREN2] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym___extension__] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym___cdecl] = ACTIONS(1476),
    [anon_sym___clrcall] = ACTIONS(1476),
    [anon_sym___stdcall] = ACTIONS(1476),
    [anon_sym___fastcall] = ACTIONS(1476),
    [anon_sym___thiscall] = ACTIONS(1476),
    [anon_sym___vectorcall] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym___inline] = ACTIONS(1476),
    [anon_sym___inline__] = ACTIONS(1476),
    [anon_sym___forceinline] = ACTIONS(1476),
    [anon_sym_thread_local] = ACTIONS(1476),
    [anon_sym___thread] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_constexpr] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym___restrict__] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym__Noreturn] = ACTIONS(1476),
    [anon_sym_noreturn] = ACTIONS(1476),
    [sym_primitive_type] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_switch] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_default] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_do] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_goto] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_sizeof] = ACTIONS(1476),
    [anon_sym___alignof__] = ACTIONS(1476),
    [anon_sym___alignof] = ACTIONS(1476),
    [anon_sym__alignof] = ACTIONS(1476),
    [anon_sym_alignof] = ACTIONS(1476),
    [anon_sym__Alignof] = ACTIONS(1476),
    [anon_sym_offsetof] = ACTIONS(1476),
    [anon_sym__Generic] = ACTIONS(1476),
    [anon_sym_asm] = ACTIONS(1476),
    [anon_sym___asm__] = ACTIONS(1476),
    [sym_number_literal] = ACTIONS(1478),
    [anon_sym_L_SQUOTE] = ACTIONS(1478),
    [anon_sym_u_SQUOTE] = ACTIONS(1478),
    [anon_sym_U_SQUOTE] = ACTIONS(1478),
    [anon_sym_u8_SQUOTE] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_L_DQUOTE] = ACTIONS(1478),
    [anon_sym_u_DQUOTE] = ACTIONS(1478),
    [anon_sym_U_DQUOTE] = ACTIONS(1478),
    [anon_sym_u8_DQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [anon_sym_NULL] = ACTIONS(1476),
    [anon_sym_nullptr] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1476),
    [anon_sym_acquire] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_monitor] = ACTIONS(1476),
    [anon_sym_start] = ACTIONS(1476),
    [anon_sym_stop] = ACTIONS(1476),
  },
  [428] = {
    [sym_identifier] = ACTIONS(1553),
    [aux_sym_preproc_include_token1] = ACTIONS(1553),
    [aux_sym_preproc_def_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1553),
    [sym_preproc_directive] = ACTIONS(1553),
    [anon_sym_LPAREN2] = ACTIONS(1555),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym___extension__] = ACTIONS(1553),
    [anon_sym_typedef] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1553),
    [anon_sym___attribute__] = ACTIONS(1553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1555),
    [anon_sym___declspec] = ACTIONS(1553),
    [anon_sym___cdecl] = ACTIONS(1553),
    [anon_sym___clrcall] = ACTIONS(1553),
    [anon_sym___stdcall] = ACTIONS(1553),
    [anon_sym___fastcall] = ACTIONS(1553),
    [anon_sym___thiscall] = ACTIONS(1553),
    [anon_sym___vectorcall] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_RBRACE] = ACTIONS(1555),
    [anon_sym_signed] = ACTIONS(1553),
    [anon_sym_unsigned] = ACTIONS(1553),
    [anon_sym_long] = ACTIONS(1553),
    [anon_sym_short] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_auto] = ACTIONS(1553),
    [anon_sym_register] = ACTIONS(1553),
    [anon_sym_inline] = ACTIONS(1553),
    [anon_sym___inline] = ACTIONS(1553),
    [anon_sym___inline__] = ACTIONS(1553),
    [anon_sym___forceinline] = ACTIONS(1553),
    [anon_sym_thread_local] = ACTIONS(1553),
    [anon_sym___thread] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_constexpr] = ACTIONS(1553),
    [anon_sym_volatile] = ACTIONS(1553),
    [anon_sym_restrict] = ACTIONS(1553),
    [anon_sym___restrict__] = ACTIONS(1553),
    [anon_sym__Atomic] = ACTIONS(1553),
    [anon_sym__Noreturn] = ACTIONS(1553),
    [anon_sym_noreturn] = ACTIONS(1553),
    [sym_primitive_type] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [anon_sym_struct] = ACTIONS(1553),
    [anon_sym_union] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_goto] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_sizeof] = ACTIONS(1553),
    [anon_sym___alignof__] = ACTIONS(1553),
    [anon_sym___alignof] = ACTIONS(1553),
    [anon_sym__alignof] = ACTIONS(1553),
    [anon_sym_alignof] = ACTIONS(1553),
    [anon_sym__Alignof] = ACTIONS(1553),
    [anon_sym_offsetof] = ACTIONS(1553),
    [anon_sym__Generic] = ACTIONS(1553),
    [anon_sym_asm] = ACTIONS(1553),
    [anon_sym___asm__] = ACTIONS(1553),
    [sym_number_literal] = ACTIONS(1555),
    [anon_sym_L_SQUOTE] = ACTIONS(1555),
    [anon_sym_u_SQUOTE] = ACTIONS(1555),
    [anon_sym_U_SQUOTE] = ACTIONS(1555),
    [anon_sym_u8_SQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [anon_sym_L_DQUOTE] = ACTIONS(1555),
    [anon_sym_u_DQUOTE] = ACTIONS(1555),
    [anon_sym_U_DQUOTE] = ACTIONS(1555),
    [anon_sym_u8_DQUOTE] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [anon_sym_NULL] = ACTIONS(1553),
    [anon_sym_nullptr] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_acquire] = ACTIONS(1553),
    [anon_sym_catch] = ACTIONS(1553),
    [anon_sym_monitor] = ACTIONS(1553),
    [anon_sym_start] = ACTIONS(1553),
    [anon_sym_stop] = ACTIONS(1553),
  },
  [429] = {
    [sym_attribute_declaration] = STATE(395),
    [sym_compound_statement] = STATE(384),
    [sym_attributed_statement] = STATE(384),
    [sym_labeled_statement] = STATE(384),
    [sym_expression_statement] = STATE(384),
    [sym_if_statement] = STATE(384),
    [sym_switch_statement] = STATE(384),
    [sym_case_statement] = STATE(384),
    [sym_while_statement] = STATE(384),
    [sym_do_statement] = STATE(384),
    [sym_for_statement] = STATE(384),
    [sym_return_statement] = STATE(384),
    [sym_break_statement] = STATE(384),
    [sym_continue_statement] = STATE(384),
    [sym_goto_statement] = STATE(384),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(384),
    [sym_acquire_statement] = STATE(384),
    [sym_monitor_statement] = STATE(384),
    [sym_start_statement] = STATE(384),
    [sym_stop_statement] = STATE(384),
    [aux_sym_attributed_declarator_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(545),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(561),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_goto] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_monitor] = ACTIONS(571),
    [anon_sym_start] = ACTIONS(573),
    [anon_sym_stop] = ACTIONS(575),
  },
  [430] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_include_token1] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token2] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_LPAREN2] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym___extension__] = ACTIONS(1480),
    [anon_sym_typedef] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym___cdecl] = ACTIONS(1480),
    [anon_sym___clrcall] = ACTIONS(1480),
    [anon_sym___stdcall] = ACTIONS(1480),
    [anon_sym___fastcall] = ACTIONS(1480),
    [anon_sym___thiscall] = ACTIONS(1480),
    [anon_sym___vectorcall] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym___inline] = ACTIONS(1480),
    [anon_sym___inline__] = ACTIONS(1480),
    [anon_sym___forceinline] = ACTIONS(1480),
    [anon_sym_thread_local] = ACTIONS(1480),
    [anon_sym___thread] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_constexpr] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym___restrict__] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym__Noreturn] = ACTIONS(1480),
    [anon_sym_noreturn] = ACTIONS(1480),
    [sym_primitive_type] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_switch] = ACTIONS(1480),
    [anon_sym_case] = ACTIONS(1480),
    [anon_sym_default] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_do] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_goto] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_sizeof] = ACTIONS(1480),
    [anon_sym___alignof__] = ACTIONS(1480),
    [anon_sym___alignof] = ACTIONS(1480),
    [anon_sym__alignof] = ACTIONS(1480),
    [anon_sym_alignof] = ACTIONS(1480),
    [anon_sym__Alignof] = ACTIONS(1480),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1480),
    [anon_sym_asm] = ACTIONS(1480),
    [anon_sym___asm__] = ACTIONS(1480),
    [sym_number_literal] = ACTIONS(1482),
    [anon_sym_L_SQUOTE] = ACTIONS(1482),
    [anon_sym_u_SQUOTE] = ACTIONS(1482),
    [anon_sym_U_SQUOTE] = ACTIONS(1482),
    [anon_sym_u8_SQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_L_DQUOTE] = ACTIONS(1482),
    [anon_sym_u_DQUOTE] = ACTIONS(1482),
    [anon_sym_U_DQUOTE] = ACTIONS(1482),
    [anon_sym_u8_DQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [anon_sym_NULL] = ACTIONS(1480),
    [anon_sym_nullptr] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1480),
    [anon_sym_acquire] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_monitor] = ACTIONS(1480),
    [anon_sym_start] = ACTIONS(1480),
    [anon_sym_stop] = ACTIONS(1480),
  },
  [431] = {
    [sym_attribute_declaration] = STATE(431),
    [sym_compound_statement] = STATE(268),
    [sym_attributed_statement] = STATE(268),
    [sym_labeled_statement] = STATE(268),
    [sym_expression_statement] = STATE(268),
    [sym_if_statement] = STATE(268),
    [sym_switch_statement] = STATE(268),
    [sym_case_statement] = STATE(268),
    [sym_while_statement] = STATE(268),
    [sym_do_statement] = STATE(268),
    [sym_for_statement] = STATE(268),
    [sym_return_statement] = STATE(268),
    [sym_break_statement] = STATE(268),
    [sym_continue_statement] = STATE(268),
    [sym_goto_statement] = STATE(268),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(268),
    [sym_acquire_statement] = STATE(268),
    [sym_monitor_statement] = STATE(268),
    [sym_start_statement] = STATE(268),
    [sym_stop_statement] = STATE(268),
    [aux_sym_attributed_declarator_repeat1] = STATE(431),
    [sym_identifier] = ACTIONS(2055),
    [anon_sym_LPAREN2] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(2058),
    [anon_sym_switch] = ACTIONS(1896),
    [anon_sym_case] = ACTIONS(2061),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(1908),
    [anon_sym_for] = ACTIONS(2070),
    [anon_sym_return] = ACTIONS(1914),
    [anon_sym_break] = ACTIONS(1917),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_goto] = ACTIONS(1923),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_sizeof] = ACTIONS(1780),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1786),
    [anon_sym__Generic] = ACTIONS(1789),
    [anon_sym_asm] = ACTIONS(1792),
    [anon_sym___asm__] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1795),
    [anon_sym_L_SQUOTE] = ACTIONS(1798),
    [anon_sym_u_SQUOTE] = ACTIONS(1798),
    [anon_sym_U_SQUOTE] = ACTIONS(1798),
    [anon_sym_u8_SQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_L_DQUOTE] = ACTIONS(1801),
    [anon_sym_u_DQUOTE] = ACTIONS(1801),
    [anon_sym_U_DQUOTE] = ACTIONS(1801),
    [anon_sym_u8_DQUOTE] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [anon_sym_NULL] = ACTIONS(1807),
    [anon_sym_nullptr] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(2073),
    [anon_sym_acquire] = ACTIONS(2076),
    [anon_sym_monitor] = ACTIONS(2079),
    [anon_sym_start] = ACTIONS(1935),
    [anon_sym_stop] = ACTIONS(1938),
  },
  [432] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(156),
    [sym_attributed_statement] = STATE(156),
    [sym_labeled_statement] = STATE(156),
    [sym_expression_statement] = STATE(156),
    [sym_if_statement] = STATE(156),
    [sym_switch_statement] = STATE(156),
    [sym_case_statement] = STATE(156),
    [sym_while_statement] = STATE(156),
    [sym_do_statement] = STATE(156),
    [sym_for_statement] = STATE(156),
    [sym_return_statement] = STATE(156),
    [sym_break_statement] = STATE(156),
    [sym_continue_statement] = STATE(156),
    [sym_goto_statement] = STATE(156),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(156),
    [sym_acquire_statement] = STATE(156),
    [sym_monitor_statement] = STATE(156),
    [sym_start_statement] = STATE(156),
    [sym_stop_statement] = STATE(156),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [433] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(249),
    [sym_attributed_statement] = STATE(249),
    [sym_labeled_statement] = STATE(249),
    [sym_expression_statement] = STATE(249),
    [sym_if_statement] = STATE(249),
    [sym_switch_statement] = STATE(249),
    [sym_case_statement] = STATE(249),
    [sym_while_statement] = STATE(249),
    [sym_do_statement] = STATE(249),
    [sym_for_statement] = STATE(249),
    [sym_return_statement] = STATE(249),
    [sym_break_statement] = STATE(249),
    [sym_continue_statement] = STATE(249),
    [sym_goto_statement] = STATE(249),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(249),
    [sym_acquire_statement] = STATE(249),
    [sym_monitor_statement] = STATE(249),
    [sym_start_statement] = STATE(249),
    [sym_stop_statement] = STATE(249),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_include_token1] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_LPAREN2] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym___extension__] = ACTIONS(1480),
    [anon_sym_typedef] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym___cdecl] = ACTIONS(1480),
    [anon_sym___clrcall] = ACTIONS(1480),
    [anon_sym___stdcall] = ACTIONS(1480),
    [anon_sym___fastcall] = ACTIONS(1480),
    [anon_sym___thiscall] = ACTIONS(1480),
    [anon_sym___vectorcall] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym___inline] = ACTIONS(1480),
    [anon_sym___inline__] = ACTIONS(1480),
    [anon_sym___forceinline] = ACTIONS(1480),
    [anon_sym_thread_local] = ACTIONS(1480),
    [anon_sym___thread] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_constexpr] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym___restrict__] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym__Noreturn] = ACTIONS(1480),
    [anon_sym_noreturn] = ACTIONS(1480),
    [sym_primitive_type] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_switch] = ACTIONS(1480),
    [anon_sym_case] = ACTIONS(1480),
    [anon_sym_default] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_do] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_goto] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_sizeof] = ACTIONS(1480),
    [anon_sym___alignof__] = ACTIONS(1480),
    [anon_sym___alignof] = ACTIONS(1480),
    [anon_sym__alignof] = ACTIONS(1480),
    [anon_sym_alignof] = ACTIONS(1480),
    [anon_sym__Alignof] = ACTIONS(1480),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1480),
    [anon_sym_asm] = ACTIONS(1480),
    [anon_sym___asm__] = ACTIONS(1480),
    [sym_number_literal] = ACTIONS(1482),
    [anon_sym_L_SQUOTE] = ACTIONS(1482),
    [anon_sym_u_SQUOTE] = ACTIONS(1482),
    [anon_sym_U_SQUOTE] = ACTIONS(1482),
    [anon_sym_u8_SQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_L_DQUOTE] = ACTIONS(1482),
    [anon_sym_u_DQUOTE] = ACTIONS(1482),
    [anon_sym_U_DQUOTE] = ACTIONS(1482),
    [anon_sym_u8_DQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [anon_sym_NULL] = ACTIONS(1480),
    [anon_sym_nullptr] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1480),
    [anon_sym_acquire] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_monitor] = ACTIONS(1480),
    [anon_sym_start] = ACTIONS(1480),
    [anon_sym_stop] = ACTIONS(1480),
  },
  [435] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_include_token1] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token2] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_LPAREN2] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym___extension__] = ACTIONS(1484),
    [anon_sym_typedef] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym___cdecl] = ACTIONS(1484),
    [anon_sym___clrcall] = ACTIONS(1484),
    [anon_sym___stdcall] = ACTIONS(1484),
    [anon_sym___fastcall] = ACTIONS(1484),
    [anon_sym___thiscall] = ACTIONS(1484),
    [anon_sym___vectorcall] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym___inline] = ACTIONS(1484),
    [anon_sym___inline__] = ACTIONS(1484),
    [anon_sym___forceinline] = ACTIONS(1484),
    [anon_sym_thread_local] = ACTIONS(1484),
    [anon_sym___thread] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_constexpr] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym___restrict__] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym__Noreturn] = ACTIONS(1484),
    [anon_sym_noreturn] = ACTIONS(1484),
    [sym_primitive_type] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_goto] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_sizeof] = ACTIONS(1484),
    [anon_sym___alignof__] = ACTIONS(1484),
    [anon_sym___alignof] = ACTIONS(1484),
    [anon_sym__alignof] = ACTIONS(1484),
    [anon_sym_alignof] = ACTIONS(1484),
    [anon_sym__Alignof] = ACTIONS(1484),
    [anon_sym_offsetof] = ACTIONS(1484),
    [anon_sym__Generic] = ACTIONS(1484),
    [anon_sym_asm] = ACTIONS(1484),
    [anon_sym___asm__] = ACTIONS(1484),
    [sym_number_literal] = ACTIONS(1486),
    [anon_sym_L_SQUOTE] = ACTIONS(1486),
    [anon_sym_u_SQUOTE] = ACTIONS(1486),
    [anon_sym_U_SQUOTE] = ACTIONS(1486),
    [anon_sym_u8_SQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_L_DQUOTE] = ACTIONS(1486),
    [anon_sym_u_DQUOTE] = ACTIONS(1486),
    [anon_sym_U_DQUOTE] = ACTIONS(1486),
    [anon_sym_u8_DQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [anon_sym_NULL] = ACTIONS(1484),
    [anon_sym_nullptr] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1484),
    [anon_sym_acquire] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_monitor] = ACTIONS(1484),
    [anon_sym_start] = ACTIONS(1484),
    [anon_sym_stop] = ACTIONS(1484),
  },
  [436] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_include_token1] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token2] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_LPAREN2] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym___extension__] = ACTIONS(1488),
    [anon_sym_typedef] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym___cdecl] = ACTIONS(1488),
    [anon_sym___clrcall] = ACTIONS(1488),
    [anon_sym___stdcall] = ACTIONS(1488),
    [anon_sym___fastcall] = ACTIONS(1488),
    [anon_sym___thiscall] = ACTIONS(1488),
    [anon_sym___vectorcall] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym___inline] = ACTIONS(1488),
    [anon_sym___inline__] = ACTIONS(1488),
    [anon_sym___forceinline] = ACTIONS(1488),
    [anon_sym_thread_local] = ACTIONS(1488),
    [anon_sym___thread] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_constexpr] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym___restrict__] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym__Noreturn] = ACTIONS(1488),
    [anon_sym_noreturn] = ACTIONS(1488),
    [sym_primitive_type] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_goto] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_sizeof] = ACTIONS(1488),
    [anon_sym___alignof__] = ACTIONS(1488),
    [anon_sym___alignof] = ACTIONS(1488),
    [anon_sym__alignof] = ACTIONS(1488),
    [anon_sym_alignof] = ACTIONS(1488),
    [anon_sym__Alignof] = ACTIONS(1488),
    [anon_sym_offsetof] = ACTIONS(1488),
    [anon_sym__Generic] = ACTIONS(1488),
    [anon_sym_asm] = ACTIONS(1488),
    [anon_sym___asm__] = ACTIONS(1488),
    [sym_number_literal] = ACTIONS(1490),
    [anon_sym_L_SQUOTE] = ACTIONS(1490),
    [anon_sym_u_SQUOTE] = ACTIONS(1490),
    [anon_sym_U_SQUOTE] = ACTIONS(1490),
    [anon_sym_u8_SQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_L_DQUOTE] = ACTIONS(1490),
    [anon_sym_u_DQUOTE] = ACTIONS(1490),
    [anon_sym_U_DQUOTE] = ACTIONS(1490),
    [anon_sym_u8_DQUOTE] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [anon_sym_NULL] = ACTIONS(1488),
    [anon_sym_nullptr] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1488),
    [anon_sym_acquire] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_monitor] = ACTIONS(1488),
    [anon_sym_start] = ACTIONS(1488),
    [anon_sym_stop] = ACTIONS(1488),
  },
  [437] = {
    [sym_identifier] = ACTIONS(1533),
    [aux_sym_preproc_include_token1] = ACTIONS(1533),
    [aux_sym_preproc_def_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1533),
    [sym_preproc_directive] = ACTIONS(1533),
    [anon_sym_LPAREN2] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1533),
    [anon_sym_typedef] = ACTIONS(1533),
    [anon_sym_extern] = ACTIONS(1533),
    [anon_sym___attribute__] = ACTIONS(1533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1535),
    [anon_sym___declspec] = ACTIONS(1533),
    [anon_sym___cdecl] = ACTIONS(1533),
    [anon_sym___clrcall] = ACTIONS(1533),
    [anon_sym___stdcall] = ACTIONS(1533),
    [anon_sym___fastcall] = ACTIONS(1533),
    [anon_sym___thiscall] = ACTIONS(1533),
    [anon_sym___vectorcall] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_signed] = ACTIONS(1533),
    [anon_sym_unsigned] = ACTIONS(1533),
    [anon_sym_long] = ACTIONS(1533),
    [anon_sym_short] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_auto] = ACTIONS(1533),
    [anon_sym_register] = ACTIONS(1533),
    [anon_sym_inline] = ACTIONS(1533),
    [anon_sym___inline] = ACTIONS(1533),
    [anon_sym___inline__] = ACTIONS(1533),
    [anon_sym___forceinline] = ACTIONS(1533),
    [anon_sym_thread_local] = ACTIONS(1533),
    [anon_sym___thread] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_constexpr] = ACTIONS(1533),
    [anon_sym_volatile] = ACTIONS(1533),
    [anon_sym_restrict] = ACTIONS(1533),
    [anon_sym___restrict__] = ACTIONS(1533),
    [anon_sym__Atomic] = ACTIONS(1533),
    [anon_sym__Noreturn] = ACTIONS(1533),
    [anon_sym_noreturn] = ACTIONS(1533),
    [sym_primitive_type] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [anon_sym_struct] = ACTIONS(1533),
    [anon_sym_union] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_goto] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_sizeof] = ACTIONS(1533),
    [anon_sym___alignof__] = ACTIONS(1533),
    [anon_sym___alignof] = ACTIONS(1533),
    [anon_sym__alignof] = ACTIONS(1533),
    [anon_sym_alignof] = ACTIONS(1533),
    [anon_sym__Alignof] = ACTIONS(1533),
    [anon_sym_offsetof] = ACTIONS(1533),
    [anon_sym__Generic] = ACTIONS(1533),
    [anon_sym_asm] = ACTIONS(1533),
    [anon_sym___asm__] = ACTIONS(1533),
    [sym_number_literal] = ACTIONS(1535),
    [anon_sym_L_SQUOTE] = ACTIONS(1535),
    [anon_sym_u_SQUOTE] = ACTIONS(1535),
    [anon_sym_U_SQUOTE] = ACTIONS(1535),
    [anon_sym_u8_SQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [anon_sym_L_DQUOTE] = ACTIONS(1535),
    [anon_sym_u_DQUOTE] = ACTIONS(1535),
    [anon_sym_U_DQUOTE] = ACTIONS(1535),
    [anon_sym_u8_DQUOTE] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [anon_sym_NULL] = ACTIONS(1533),
    [anon_sym_nullptr] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1533),
    [anon_sym_acquire] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_monitor] = ACTIONS(1533),
    [anon_sym_start] = ACTIONS(1533),
    [anon_sym_stop] = ACTIONS(1533),
  },
  [438] = {
    [sym_identifier] = ACTIONS(1500),
    [aux_sym_preproc_include_token1] = ACTIONS(1500),
    [aux_sym_preproc_def_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token2] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1500),
    [sym_preproc_directive] = ACTIONS(1500),
    [anon_sym_LPAREN2] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym___extension__] = ACTIONS(1500),
    [anon_sym_typedef] = ACTIONS(1500),
    [anon_sym_extern] = ACTIONS(1500),
    [anon_sym___attribute__] = ACTIONS(1500),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1502),
    [anon_sym___declspec] = ACTIONS(1500),
    [anon_sym___cdecl] = ACTIONS(1500),
    [anon_sym___clrcall] = ACTIONS(1500),
    [anon_sym___stdcall] = ACTIONS(1500),
    [anon_sym___fastcall] = ACTIONS(1500),
    [anon_sym___thiscall] = ACTIONS(1500),
    [anon_sym___vectorcall] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_signed] = ACTIONS(1500),
    [anon_sym_unsigned] = ACTIONS(1500),
    [anon_sym_long] = ACTIONS(1500),
    [anon_sym_short] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1500),
    [anon_sym_auto] = ACTIONS(1500),
    [anon_sym_register] = ACTIONS(1500),
    [anon_sym_inline] = ACTIONS(1500),
    [anon_sym___inline] = ACTIONS(1500),
    [anon_sym___inline__] = ACTIONS(1500),
    [anon_sym___forceinline] = ACTIONS(1500),
    [anon_sym_thread_local] = ACTIONS(1500),
    [anon_sym___thread] = ACTIONS(1500),
    [anon_sym_const] = ACTIONS(1500),
    [anon_sym_constexpr] = ACTIONS(1500),
    [anon_sym_volatile] = ACTIONS(1500),
    [anon_sym_restrict] = ACTIONS(1500),
    [anon_sym___restrict__] = ACTIONS(1500),
    [anon_sym__Atomic] = ACTIONS(1500),
    [anon_sym__Noreturn] = ACTIONS(1500),
    [anon_sym_noreturn] = ACTIONS(1500),
    [sym_primitive_type] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1500),
    [anon_sym_struct] = ACTIONS(1500),
    [anon_sym_union] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1500),
    [anon_sym_switch] = ACTIONS(1500),
    [anon_sym_case] = ACTIONS(1500),
    [anon_sym_default] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_do] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_break] = ACTIONS(1500),
    [anon_sym_continue] = ACTIONS(1500),
    [anon_sym_goto] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_sizeof] = ACTIONS(1500),
    [anon_sym___alignof__] = ACTIONS(1500),
    [anon_sym___alignof] = ACTIONS(1500),
    [anon_sym__alignof] = ACTIONS(1500),
    [anon_sym_alignof] = ACTIONS(1500),
    [anon_sym__Alignof] = ACTIONS(1500),
    [anon_sym_offsetof] = ACTIONS(1500),
    [anon_sym__Generic] = ACTIONS(1500),
    [anon_sym_asm] = ACTIONS(1500),
    [anon_sym___asm__] = ACTIONS(1500),
    [sym_number_literal] = ACTIONS(1502),
    [anon_sym_L_SQUOTE] = ACTIONS(1502),
    [anon_sym_u_SQUOTE] = ACTIONS(1502),
    [anon_sym_U_SQUOTE] = ACTIONS(1502),
    [anon_sym_u8_SQUOTE] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_L_DQUOTE] = ACTIONS(1502),
    [anon_sym_u_DQUOTE] = ACTIONS(1502),
    [anon_sym_U_DQUOTE] = ACTIONS(1502),
    [anon_sym_u8_DQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [anon_sym_NULL] = ACTIONS(1500),
    [anon_sym_nullptr] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1500),
    [anon_sym_acquire] = ACTIONS(1500),
    [anon_sym_catch] = ACTIONS(1500),
    [anon_sym_monitor] = ACTIONS(1500),
    [anon_sym_start] = ACTIONS(1500),
    [anon_sym_stop] = ACTIONS(1500),
  },
  [439] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_include_token1] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_LPAREN2] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym___extension__] = ACTIONS(1484),
    [anon_sym_typedef] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym___cdecl] = ACTIONS(1484),
    [anon_sym___clrcall] = ACTIONS(1484),
    [anon_sym___stdcall] = ACTIONS(1484),
    [anon_sym___fastcall] = ACTIONS(1484),
    [anon_sym___thiscall] = ACTIONS(1484),
    [anon_sym___vectorcall] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym___inline] = ACTIONS(1484),
    [anon_sym___inline__] = ACTIONS(1484),
    [anon_sym___forceinline] = ACTIONS(1484),
    [anon_sym_thread_local] = ACTIONS(1484),
    [anon_sym___thread] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_constexpr] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym___restrict__] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym__Noreturn] = ACTIONS(1484),
    [anon_sym_noreturn] = ACTIONS(1484),
    [sym_primitive_type] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_goto] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_sizeof] = ACTIONS(1484),
    [anon_sym___alignof__] = ACTIONS(1484),
    [anon_sym___alignof] = ACTIONS(1484),
    [anon_sym__alignof] = ACTIONS(1484),
    [anon_sym_alignof] = ACTIONS(1484),
    [anon_sym__Alignof] = ACTIONS(1484),
    [anon_sym_offsetof] = ACTIONS(1484),
    [anon_sym__Generic] = ACTIONS(1484),
    [anon_sym_asm] = ACTIONS(1484),
    [anon_sym___asm__] = ACTIONS(1484),
    [sym_number_literal] = ACTIONS(1486),
    [anon_sym_L_SQUOTE] = ACTIONS(1486),
    [anon_sym_u_SQUOTE] = ACTIONS(1486),
    [anon_sym_U_SQUOTE] = ACTIONS(1486),
    [anon_sym_u8_SQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_L_DQUOTE] = ACTIONS(1486),
    [anon_sym_u_DQUOTE] = ACTIONS(1486),
    [anon_sym_U_DQUOTE] = ACTIONS(1486),
    [anon_sym_u8_DQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [anon_sym_NULL] = ACTIONS(1484),
    [anon_sym_nullptr] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1484),
    [anon_sym_acquire] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_monitor] = ACTIONS(1484),
    [anon_sym_start] = ACTIONS(1484),
    [anon_sym_stop] = ACTIONS(1484),
  },
  [440] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_include_token1] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_LPAREN2] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym___extension__] = ACTIONS(1488),
    [anon_sym_typedef] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym___cdecl] = ACTIONS(1488),
    [anon_sym___clrcall] = ACTIONS(1488),
    [anon_sym___stdcall] = ACTIONS(1488),
    [anon_sym___fastcall] = ACTIONS(1488),
    [anon_sym___thiscall] = ACTIONS(1488),
    [anon_sym___vectorcall] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym___inline] = ACTIONS(1488),
    [anon_sym___inline__] = ACTIONS(1488),
    [anon_sym___forceinline] = ACTIONS(1488),
    [anon_sym_thread_local] = ACTIONS(1488),
    [anon_sym___thread] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_constexpr] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym___restrict__] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym__Noreturn] = ACTIONS(1488),
    [anon_sym_noreturn] = ACTIONS(1488),
    [sym_primitive_type] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_goto] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_sizeof] = ACTIONS(1488),
    [anon_sym___alignof__] = ACTIONS(1488),
    [anon_sym___alignof] = ACTIONS(1488),
    [anon_sym__alignof] = ACTIONS(1488),
    [anon_sym_alignof] = ACTIONS(1488),
    [anon_sym__Alignof] = ACTIONS(1488),
    [anon_sym_offsetof] = ACTIONS(1488),
    [anon_sym__Generic] = ACTIONS(1488),
    [anon_sym_asm] = ACTIONS(1488),
    [anon_sym___asm__] = ACTIONS(1488),
    [sym_number_literal] = ACTIONS(1490),
    [anon_sym_L_SQUOTE] = ACTIONS(1490),
    [anon_sym_u_SQUOTE] = ACTIONS(1490),
    [anon_sym_U_SQUOTE] = ACTIONS(1490),
    [anon_sym_u8_SQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_L_DQUOTE] = ACTIONS(1490),
    [anon_sym_u_DQUOTE] = ACTIONS(1490),
    [anon_sym_U_DQUOTE] = ACTIONS(1490),
    [anon_sym_u8_DQUOTE] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [anon_sym_NULL] = ACTIONS(1488),
    [anon_sym_nullptr] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1488),
    [anon_sym_acquire] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_monitor] = ACTIONS(1488),
    [anon_sym_start] = ACTIONS(1488),
    [anon_sym_stop] = ACTIONS(1488),
  },
  [441] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(270),
    [sym_attributed_statement] = STATE(269),
    [sym_labeled_statement] = STATE(266),
    [sym_expression_statement] = STATE(265),
    [sym_if_statement] = STATE(264),
    [sym_switch_statement] = STATE(261),
    [sym_case_statement] = STATE(257),
    [sym_while_statement] = STATE(255),
    [sym_do_statement] = STATE(231),
    [sym_for_statement] = STATE(254),
    [sym_return_statement] = STATE(233),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(243),
    [sym_goto_statement] = STATE(232),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(238),
    [sym_acquire_statement] = STATE(236),
    [sym_monitor_statement] = STATE(237),
    [sym_start_statement] = STATE(240),
    [sym_stop_statement] = STATE(242),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [442] = {
    [sym_identifier] = ACTIONS(1545),
    [aux_sym_preproc_include_token1] = ACTIONS(1545),
    [aux_sym_preproc_def_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token1] = ACTIONS(1545),
    [aux_sym_preproc_if_token2] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1545),
    [sym_preproc_directive] = ACTIONS(1545),
    [anon_sym_LPAREN2] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym___extension__] = ACTIONS(1545),
    [anon_sym_typedef] = ACTIONS(1545),
    [anon_sym_extern] = ACTIONS(1545),
    [anon_sym___attribute__] = ACTIONS(1545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1547),
    [anon_sym___declspec] = ACTIONS(1545),
    [anon_sym___cdecl] = ACTIONS(1545),
    [anon_sym___clrcall] = ACTIONS(1545),
    [anon_sym___stdcall] = ACTIONS(1545),
    [anon_sym___fastcall] = ACTIONS(1545),
    [anon_sym___thiscall] = ACTIONS(1545),
    [anon_sym___vectorcall] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_signed] = ACTIONS(1545),
    [anon_sym_unsigned] = ACTIONS(1545),
    [anon_sym_long] = ACTIONS(1545),
    [anon_sym_short] = ACTIONS(1545),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_auto] = ACTIONS(1545),
    [anon_sym_register] = ACTIONS(1545),
    [anon_sym_inline] = ACTIONS(1545),
    [anon_sym___inline] = ACTIONS(1545),
    [anon_sym___inline__] = ACTIONS(1545),
    [anon_sym___forceinline] = ACTIONS(1545),
    [anon_sym_thread_local] = ACTIONS(1545),
    [anon_sym___thread] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_constexpr] = ACTIONS(1545),
    [anon_sym_volatile] = ACTIONS(1545),
    [anon_sym_restrict] = ACTIONS(1545),
    [anon_sym___restrict__] = ACTIONS(1545),
    [anon_sym__Atomic] = ACTIONS(1545),
    [anon_sym__Noreturn] = ACTIONS(1545),
    [anon_sym_noreturn] = ACTIONS(1545),
    [sym_primitive_type] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [anon_sym_struct] = ACTIONS(1545),
    [anon_sym_union] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_sizeof] = ACTIONS(1545),
    [anon_sym___alignof__] = ACTIONS(1545),
    [anon_sym___alignof] = ACTIONS(1545),
    [anon_sym__alignof] = ACTIONS(1545),
    [anon_sym_alignof] = ACTIONS(1545),
    [anon_sym__Alignof] = ACTIONS(1545),
    [anon_sym_offsetof] = ACTIONS(1545),
    [anon_sym__Generic] = ACTIONS(1545),
    [anon_sym_asm] = ACTIONS(1545),
    [anon_sym___asm__] = ACTIONS(1545),
    [sym_number_literal] = ACTIONS(1547),
    [anon_sym_L_SQUOTE] = ACTIONS(1547),
    [anon_sym_u_SQUOTE] = ACTIONS(1547),
    [anon_sym_U_SQUOTE] = ACTIONS(1547),
    [anon_sym_u8_SQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [anon_sym_L_DQUOTE] = ACTIONS(1547),
    [anon_sym_u_DQUOTE] = ACTIONS(1547),
    [anon_sym_U_DQUOTE] = ACTIONS(1547),
    [anon_sym_u8_DQUOTE] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [anon_sym_NULL] = ACTIONS(1545),
    [anon_sym_nullptr] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1545),
    [anon_sym_acquire] = ACTIONS(1545),
    [anon_sym_catch] = ACTIONS(1545),
    [anon_sym_monitor] = ACTIONS(1545),
    [anon_sym_start] = ACTIONS(1545),
    [anon_sym_stop] = ACTIONS(1545),
  },
  [443] = {
    [sym_identifier] = ACTIONS(1521),
    [aux_sym_preproc_include_token1] = ACTIONS(1521),
    [aux_sym_preproc_def_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token2] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1521),
    [sym_preproc_directive] = ACTIONS(1521),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1521),
    [anon_sym_typedef] = ACTIONS(1521),
    [anon_sym_extern] = ACTIONS(1521),
    [anon_sym___attribute__] = ACTIONS(1521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1523),
    [anon_sym___declspec] = ACTIONS(1521),
    [anon_sym___cdecl] = ACTIONS(1521),
    [anon_sym___clrcall] = ACTIONS(1521),
    [anon_sym___stdcall] = ACTIONS(1521),
    [anon_sym___fastcall] = ACTIONS(1521),
    [anon_sym___thiscall] = ACTIONS(1521),
    [anon_sym___vectorcall] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_signed] = ACTIONS(1521),
    [anon_sym_unsigned] = ACTIONS(1521),
    [anon_sym_long] = ACTIONS(1521),
    [anon_sym_short] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1521),
    [anon_sym_auto] = ACTIONS(1521),
    [anon_sym_register] = ACTIONS(1521),
    [anon_sym_inline] = ACTIONS(1521),
    [anon_sym___inline] = ACTIONS(1521),
    [anon_sym___inline__] = ACTIONS(1521),
    [anon_sym___forceinline] = ACTIONS(1521),
    [anon_sym_thread_local] = ACTIONS(1521),
    [anon_sym___thread] = ACTIONS(1521),
    [anon_sym_const] = ACTIONS(1521),
    [anon_sym_constexpr] = ACTIONS(1521),
    [anon_sym_volatile] = ACTIONS(1521),
    [anon_sym_restrict] = ACTIONS(1521),
    [anon_sym___restrict__] = ACTIONS(1521),
    [anon_sym__Atomic] = ACTIONS(1521),
    [anon_sym__Noreturn] = ACTIONS(1521),
    [anon_sym_noreturn] = ACTIONS(1521),
    [sym_primitive_type] = ACTIONS(1521),
    [anon_sym_enum] = ACTIONS(1521),
    [anon_sym_struct] = ACTIONS(1521),
    [anon_sym_union] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_do] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_return] = ACTIONS(1521),
    [anon_sym_break] = ACTIONS(1521),
    [anon_sym_continue] = ACTIONS(1521),
    [anon_sym_goto] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_sizeof] = ACTIONS(1521),
    [anon_sym___alignof__] = ACTIONS(1521),
    [anon_sym___alignof] = ACTIONS(1521),
    [anon_sym__alignof] = ACTIONS(1521),
    [anon_sym_alignof] = ACTIONS(1521),
    [anon_sym__Alignof] = ACTIONS(1521),
    [anon_sym_offsetof] = ACTIONS(1521),
    [anon_sym__Generic] = ACTIONS(1521),
    [anon_sym_asm] = ACTIONS(1521),
    [anon_sym___asm__] = ACTIONS(1521),
    [sym_number_literal] = ACTIONS(1523),
    [anon_sym_L_SQUOTE] = ACTIONS(1523),
    [anon_sym_u_SQUOTE] = ACTIONS(1523),
    [anon_sym_U_SQUOTE] = ACTIONS(1523),
    [anon_sym_u8_SQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_L_DQUOTE] = ACTIONS(1523),
    [anon_sym_u_DQUOTE] = ACTIONS(1523),
    [anon_sym_U_DQUOTE] = ACTIONS(1523),
    [anon_sym_u8_DQUOTE] = ACTIONS(1523),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [anon_sym_NULL] = ACTIONS(1521),
    [anon_sym_nullptr] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1521),
    [anon_sym_acquire] = ACTIONS(1521),
    [anon_sym_catch] = ACTIONS(1521),
    [anon_sym_monitor] = ACTIONS(1521),
    [anon_sym_start] = ACTIONS(1521),
    [anon_sym_stop] = ACTIONS(1521),
  },
  [444] = {
    [sym_attribute_declaration] = STATE(424),
    [sym_compound_statement] = STATE(273),
    [sym_attributed_statement] = STATE(273),
    [sym_labeled_statement] = STATE(273),
    [sym_expression_statement] = STATE(273),
    [sym_if_statement] = STATE(273),
    [sym_switch_statement] = STATE(273),
    [sym_case_statement] = STATE(273),
    [sym_while_statement] = STATE(273),
    [sym_do_statement] = STATE(273),
    [sym_for_statement] = STATE(273),
    [sym_return_statement] = STATE(273),
    [sym_break_statement] = STATE(273),
    [sym_continue_statement] = STATE(273),
    [sym_goto_statement] = STATE(273),
    [sym__expression] = STATE(1112),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1860),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(273),
    [sym_acquire_statement] = STATE(273),
    [sym_monitor_statement] = STATE(273),
    [sym_start_statement] = STATE(273),
    [sym_stop_statement] = STATE(273),
    [aux_sym_attributed_declarator_repeat1] = STATE(424),
    [sym_identifier] = ACTIONS(1710),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1714),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1421),
    [anon_sym_acquire] = ACTIONS(1423),
    [anon_sym_monitor] = ACTIONS(1425),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [445] = {
    [sym_identifier] = ACTIONS(1627),
    [aux_sym_preproc_include_token1] = ACTIONS(1627),
    [aux_sym_preproc_def_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token2] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1627),
    [aux_sym_preproc_else_token1] = ACTIONS(1627),
    [aux_sym_preproc_elif_token1] = ACTIONS(1627),
    [sym_preproc_directive] = ACTIONS(1627),
    [anon_sym_LPAREN2] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_typedef] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1627),
    [anon_sym___attribute__] = ACTIONS(1627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1629),
    [anon_sym___declspec] = ACTIONS(1627),
    [anon_sym___cdecl] = ACTIONS(1627),
    [anon_sym___clrcall] = ACTIONS(1627),
    [anon_sym___stdcall] = ACTIONS(1627),
    [anon_sym___fastcall] = ACTIONS(1627),
    [anon_sym___thiscall] = ACTIONS(1627),
    [anon_sym___vectorcall] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_signed] = ACTIONS(1627),
    [anon_sym_unsigned] = ACTIONS(1627),
    [anon_sym_long] = ACTIONS(1627),
    [anon_sym_short] = ACTIONS(1627),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_auto] = ACTIONS(1627),
    [anon_sym_register] = ACTIONS(1627),
    [anon_sym_inline] = ACTIONS(1627),
    [anon_sym___inline] = ACTIONS(1627),
    [anon_sym___inline__] = ACTIONS(1627),
    [anon_sym___forceinline] = ACTIONS(1627),
    [anon_sym_thread_local] = ACTIONS(1627),
    [anon_sym___thread] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [sym_primitive_type] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1627),
    [anon_sym_union] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_goto] = ACTIONS(1627),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_sizeof] = ACTIONS(1627),
    [anon_sym___alignof__] = ACTIONS(1627),
    [anon_sym___alignof] = ACTIONS(1627),
    [anon_sym__alignof] = ACTIONS(1627),
    [anon_sym_alignof] = ACTIONS(1627),
    [anon_sym__Alignof] = ACTIONS(1627),
    [anon_sym_offsetof] = ACTIONS(1627),
    [anon_sym__Generic] = ACTIONS(1627),
    [anon_sym_asm] = ACTIONS(1627),
    [anon_sym___asm__] = ACTIONS(1627),
    [sym_number_literal] = ACTIONS(1629),
    [anon_sym_L_SQUOTE] = ACTIONS(1629),
    [anon_sym_u_SQUOTE] = ACTIONS(1629),
    [anon_sym_U_SQUOTE] = ACTIONS(1629),
    [anon_sym_u8_SQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [anon_sym_L_DQUOTE] = ACTIONS(1629),
    [anon_sym_u_DQUOTE] = ACTIONS(1629),
    [anon_sym_U_DQUOTE] = ACTIONS(1629),
    [anon_sym_u8_DQUOTE] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [anon_sym_NULL] = ACTIONS(1627),
    [anon_sym_nullptr] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_acquire] = ACTIONS(1627),
    [anon_sym_monitor] = ACTIONS(1627),
    [anon_sym_start] = ACTIONS(1627),
    [anon_sym_stop] = ACTIONS(1627),
  },
  [446] = {
    [sym_identifier] = ACTIONS(1561),
    [aux_sym_preproc_include_token1] = ACTIONS(1561),
    [aux_sym_preproc_def_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1561),
    [sym_preproc_directive] = ACTIONS(1561),
    [anon_sym_LPAREN2] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym___extension__] = ACTIONS(1561),
    [anon_sym_typedef] = ACTIONS(1561),
    [anon_sym_extern] = ACTIONS(1561),
    [anon_sym___attribute__] = ACTIONS(1561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1563),
    [anon_sym___declspec] = ACTIONS(1561),
    [anon_sym___cdecl] = ACTIONS(1561),
    [anon_sym___clrcall] = ACTIONS(1561),
    [anon_sym___stdcall] = ACTIONS(1561),
    [anon_sym___fastcall] = ACTIONS(1561),
    [anon_sym___thiscall] = ACTIONS(1561),
    [anon_sym___vectorcall] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_signed] = ACTIONS(1561),
    [anon_sym_unsigned] = ACTIONS(1561),
    [anon_sym_long] = ACTIONS(1561),
    [anon_sym_short] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_auto] = ACTIONS(1561),
    [anon_sym_register] = ACTIONS(1561),
    [anon_sym_inline] = ACTIONS(1561),
    [anon_sym___inline] = ACTIONS(1561),
    [anon_sym___inline__] = ACTIONS(1561),
    [anon_sym___forceinline] = ACTIONS(1561),
    [anon_sym_thread_local] = ACTIONS(1561),
    [anon_sym___thread] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_constexpr] = ACTIONS(1561),
    [anon_sym_volatile] = ACTIONS(1561),
    [anon_sym_restrict] = ACTIONS(1561),
    [anon_sym___restrict__] = ACTIONS(1561),
    [anon_sym__Atomic] = ACTIONS(1561),
    [anon_sym__Noreturn] = ACTIONS(1561),
    [anon_sym_noreturn] = ACTIONS(1561),
    [sym_primitive_type] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [anon_sym_struct] = ACTIONS(1561),
    [anon_sym_union] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_goto] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_sizeof] = ACTIONS(1561),
    [anon_sym___alignof__] = ACTIONS(1561),
    [anon_sym___alignof] = ACTIONS(1561),
    [anon_sym__alignof] = ACTIONS(1561),
    [anon_sym_alignof] = ACTIONS(1561),
    [anon_sym__Alignof] = ACTIONS(1561),
    [anon_sym_offsetof] = ACTIONS(1561),
    [anon_sym__Generic] = ACTIONS(1561),
    [anon_sym_asm] = ACTIONS(1561),
    [anon_sym___asm__] = ACTIONS(1561),
    [sym_number_literal] = ACTIONS(1563),
    [anon_sym_L_SQUOTE] = ACTIONS(1563),
    [anon_sym_u_SQUOTE] = ACTIONS(1563),
    [anon_sym_U_SQUOTE] = ACTIONS(1563),
    [anon_sym_u8_SQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [anon_sym_L_DQUOTE] = ACTIONS(1563),
    [anon_sym_u_DQUOTE] = ACTIONS(1563),
    [anon_sym_U_DQUOTE] = ACTIONS(1563),
    [anon_sym_u8_DQUOTE] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [anon_sym_NULL] = ACTIONS(1561),
    [anon_sym_nullptr] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_acquire] = ACTIONS(1561),
    [anon_sym_catch] = ACTIONS(1561),
    [anon_sym_monitor] = ACTIONS(1561),
    [anon_sym_start] = ACTIONS(1561),
    [anon_sym_stop] = ACTIONS(1561),
  },
  [447] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_include_token1] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token2] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_LPAREN2] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym___extension__] = ACTIONS(1464),
    [anon_sym_typedef] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym___cdecl] = ACTIONS(1464),
    [anon_sym___clrcall] = ACTIONS(1464),
    [anon_sym___stdcall] = ACTIONS(1464),
    [anon_sym___fastcall] = ACTIONS(1464),
    [anon_sym___thiscall] = ACTIONS(1464),
    [anon_sym___vectorcall] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym___inline] = ACTIONS(1464),
    [anon_sym___inline__] = ACTIONS(1464),
    [anon_sym___forceinline] = ACTIONS(1464),
    [anon_sym_thread_local] = ACTIONS(1464),
    [anon_sym___thread] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_constexpr] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym___restrict__] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym__Noreturn] = ACTIONS(1464),
    [anon_sym_noreturn] = ACTIONS(1464),
    [sym_primitive_type] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_switch] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_goto] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_sizeof] = ACTIONS(1464),
    [anon_sym___alignof__] = ACTIONS(1464),
    [anon_sym___alignof] = ACTIONS(1464),
    [anon_sym__alignof] = ACTIONS(1464),
    [anon_sym_alignof] = ACTIONS(1464),
    [anon_sym__Alignof] = ACTIONS(1464),
    [anon_sym_offsetof] = ACTIONS(1464),
    [anon_sym__Generic] = ACTIONS(1464),
    [anon_sym_asm] = ACTIONS(1464),
    [anon_sym___asm__] = ACTIONS(1464),
    [sym_number_literal] = ACTIONS(1466),
    [anon_sym_L_SQUOTE] = ACTIONS(1466),
    [anon_sym_u_SQUOTE] = ACTIONS(1466),
    [anon_sym_U_SQUOTE] = ACTIONS(1466),
    [anon_sym_u8_SQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_L_DQUOTE] = ACTIONS(1466),
    [anon_sym_u_DQUOTE] = ACTIONS(1466),
    [anon_sym_U_DQUOTE] = ACTIONS(1466),
    [anon_sym_u8_DQUOTE] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [anon_sym_NULL] = ACTIONS(1464),
    [anon_sym_nullptr] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1464),
    [anon_sym_acquire] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_monitor] = ACTIONS(1464),
    [anon_sym_start] = ACTIONS(1464),
    [anon_sym_stop] = ACTIONS(1464),
  },
  [448] = {
    [sym_identifier] = ACTIONS(1553),
    [aux_sym_preproc_include_token1] = ACTIONS(1553),
    [aux_sym_preproc_def_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token2] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1553),
    [sym_preproc_directive] = ACTIONS(1553),
    [anon_sym_LPAREN2] = ACTIONS(1555),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym___extension__] = ACTIONS(1553),
    [anon_sym_typedef] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1553),
    [anon_sym___attribute__] = ACTIONS(1553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1555),
    [anon_sym___declspec] = ACTIONS(1553),
    [anon_sym___cdecl] = ACTIONS(1553),
    [anon_sym___clrcall] = ACTIONS(1553),
    [anon_sym___stdcall] = ACTIONS(1553),
    [anon_sym___fastcall] = ACTIONS(1553),
    [anon_sym___thiscall] = ACTIONS(1553),
    [anon_sym___vectorcall] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_signed] = ACTIONS(1553),
    [anon_sym_unsigned] = ACTIONS(1553),
    [anon_sym_long] = ACTIONS(1553),
    [anon_sym_short] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_auto] = ACTIONS(1553),
    [anon_sym_register] = ACTIONS(1553),
    [anon_sym_inline] = ACTIONS(1553),
    [anon_sym___inline] = ACTIONS(1553),
    [anon_sym___inline__] = ACTIONS(1553),
    [anon_sym___forceinline] = ACTIONS(1553),
    [anon_sym_thread_local] = ACTIONS(1553),
    [anon_sym___thread] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_constexpr] = ACTIONS(1553),
    [anon_sym_volatile] = ACTIONS(1553),
    [anon_sym_restrict] = ACTIONS(1553),
    [anon_sym___restrict__] = ACTIONS(1553),
    [anon_sym__Atomic] = ACTIONS(1553),
    [anon_sym__Noreturn] = ACTIONS(1553),
    [anon_sym_noreturn] = ACTIONS(1553),
    [sym_primitive_type] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [anon_sym_struct] = ACTIONS(1553),
    [anon_sym_union] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_goto] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_sizeof] = ACTIONS(1553),
    [anon_sym___alignof__] = ACTIONS(1553),
    [anon_sym___alignof] = ACTIONS(1553),
    [anon_sym__alignof] = ACTIONS(1553),
    [anon_sym_alignof] = ACTIONS(1553),
    [anon_sym__Alignof] = ACTIONS(1553),
    [anon_sym_offsetof] = ACTIONS(1553),
    [anon_sym__Generic] = ACTIONS(1553),
    [anon_sym_asm] = ACTIONS(1553),
    [anon_sym___asm__] = ACTIONS(1553),
    [sym_number_literal] = ACTIONS(1555),
    [anon_sym_L_SQUOTE] = ACTIONS(1555),
    [anon_sym_u_SQUOTE] = ACTIONS(1555),
    [anon_sym_U_SQUOTE] = ACTIONS(1555),
    [anon_sym_u8_SQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [anon_sym_L_DQUOTE] = ACTIONS(1555),
    [anon_sym_u_DQUOTE] = ACTIONS(1555),
    [anon_sym_U_DQUOTE] = ACTIONS(1555),
    [anon_sym_u8_DQUOTE] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [anon_sym_NULL] = ACTIONS(1553),
    [anon_sym_nullptr] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_acquire] = ACTIONS(1553),
    [anon_sym_catch] = ACTIONS(1553),
    [anon_sym_monitor] = ACTIONS(1553),
    [anon_sym_start] = ACTIONS(1553),
    [anon_sym_stop] = ACTIONS(1553),
  },
  [449] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(270),
    [sym_attributed_statement] = STATE(269),
    [sym_labeled_statement] = STATE(266),
    [sym_expression_statement] = STATE(265),
    [sym_if_statement] = STATE(264),
    [sym_switch_statement] = STATE(261),
    [sym_case_statement] = STATE(257),
    [sym_while_statement] = STATE(255),
    [sym_do_statement] = STATE(231),
    [sym_for_statement] = STATE(254),
    [sym_return_statement] = STATE(233),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(243),
    [sym_goto_statement] = STATE(232),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(238),
    [sym_acquire_statement] = STATE(236),
    [sym_monitor_statement] = STATE(237),
    [sym_start_statement] = STATE(240),
    [sym_stop_statement] = STATE(242),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [450] = {
    [sym_identifier] = ACTIONS(1533),
    [aux_sym_preproc_include_token1] = ACTIONS(1533),
    [aux_sym_preproc_def_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token1] = ACTIONS(1533),
    [aux_sym_preproc_if_token2] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1533),
    [sym_preproc_directive] = ACTIONS(1533),
    [anon_sym_LPAREN2] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1533),
    [anon_sym_typedef] = ACTIONS(1533),
    [anon_sym_extern] = ACTIONS(1533),
    [anon_sym___attribute__] = ACTIONS(1533),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1535),
    [anon_sym___declspec] = ACTIONS(1533),
    [anon_sym___cdecl] = ACTIONS(1533),
    [anon_sym___clrcall] = ACTIONS(1533),
    [anon_sym___stdcall] = ACTIONS(1533),
    [anon_sym___fastcall] = ACTIONS(1533),
    [anon_sym___thiscall] = ACTIONS(1533),
    [anon_sym___vectorcall] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_signed] = ACTIONS(1533),
    [anon_sym_unsigned] = ACTIONS(1533),
    [anon_sym_long] = ACTIONS(1533),
    [anon_sym_short] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_auto] = ACTIONS(1533),
    [anon_sym_register] = ACTIONS(1533),
    [anon_sym_inline] = ACTIONS(1533),
    [anon_sym___inline] = ACTIONS(1533),
    [anon_sym___inline__] = ACTIONS(1533),
    [anon_sym___forceinline] = ACTIONS(1533),
    [anon_sym_thread_local] = ACTIONS(1533),
    [anon_sym___thread] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_constexpr] = ACTIONS(1533),
    [anon_sym_volatile] = ACTIONS(1533),
    [anon_sym_restrict] = ACTIONS(1533),
    [anon_sym___restrict__] = ACTIONS(1533),
    [anon_sym__Atomic] = ACTIONS(1533),
    [anon_sym__Noreturn] = ACTIONS(1533),
    [anon_sym_noreturn] = ACTIONS(1533),
    [sym_primitive_type] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [anon_sym_struct] = ACTIONS(1533),
    [anon_sym_union] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_goto] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_sizeof] = ACTIONS(1533),
    [anon_sym___alignof__] = ACTIONS(1533),
    [anon_sym___alignof] = ACTIONS(1533),
    [anon_sym__alignof] = ACTIONS(1533),
    [anon_sym_alignof] = ACTIONS(1533),
    [anon_sym__Alignof] = ACTIONS(1533),
    [anon_sym_offsetof] = ACTIONS(1533),
    [anon_sym__Generic] = ACTIONS(1533),
    [anon_sym_asm] = ACTIONS(1533),
    [anon_sym___asm__] = ACTIONS(1533),
    [sym_number_literal] = ACTIONS(1535),
    [anon_sym_L_SQUOTE] = ACTIONS(1535),
    [anon_sym_u_SQUOTE] = ACTIONS(1535),
    [anon_sym_U_SQUOTE] = ACTIONS(1535),
    [anon_sym_u8_SQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [anon_sym_L_DQUOTE] = ACTIONS(1535),
    [anon_sym_u_DQUOTE] = ACTIONS(1535),
    [anon_sym_U_DQUOTE] = ACTIONS(1535),
    [anon_sym_u8_DQUOTE] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [anon_sym_NULL] = ACTIONS(1533),
    [anon_sym_nullptr] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1533),
    [anon_sym_acquire] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_monitor] = ACTIONS(1533),
    [anon_sym_start] = ACTIONS(1533),
    [anon_sym_stop] = ACTIONS(1533),
  },
  [451] = {
    [sym_identifier] = ACTIONS(1684),
    [aux_sym_preproc_include_token1] = ACTIONS(1684),
    [aux_sym_preproc_def_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token2] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1684),
    [aux_sym_preproc_else_token1] = ACTIONS(1684),
    [aux_sym_preproc_elif_token1] = ACTIONS(1684),
    [sym_preproc_directive] = ACTIONS(1684),
    [anon_sym_LPAREN2] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym___extension__] = ACTIONS(1684),
    [anon_sym_typedef] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym___attribute__] = ACTIONS(1684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1686),
    [anon_sym___declspec] = ACTIONS(1684),
    [anon_sym___cdecl] = ACTIONS(1684),
    [anon_sym___clrcall] = ACTIONS(1684),
    [anon_sym___stdcall] = ACTIONS(1684),
    [anon_sym___fastcall] = ACTIONS(1684),
    [anon_sym___thiscall] = ACTIONS(1684),
    [anon_sym___vectorcall] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_signed] = ACTIONS(1684),
    [anon_sym_unsigned] = ACTIONS(1684),
    [anon_sym_long] = ACTIONS(1684),
    [anon_sym_short] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_auto] = ACTIONS(1684),
    [anon_sym_register] = ACTIONS(1684),
    [anon_sym_inline] = ACTIONS(1684),
    [anon_sym___inline] = ACTIONS(1684),
    [anon_sym___inline__] = ACTIONS(1684),
    [anon_sym___forceinline] = ACTIONS(1684),
    [anon_sym_thread_local] = ACTIONS(1684),
    [anon_sym___thread] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_constexpr] = ACTIONS(1684),
    [anon_sym_volatile] = ACTIONS(1684),
    [anon_sym_restrict] = ACTIONS(1684),
    [anon_sym___restrict__] = ACTIONS(1684),
    [anon_sym__Atomic] = ACTIONS(1684),
    [anon_sym__Noreturn] = ACTIONS(1684),
    [anon_sym_noreturn] = ACTIONS(1684),
    [sym_primitive_type] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_do] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1684),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_sizeof] = ACTIONS(1684),
    [anon_sym___alignof__] = ACTIONS(1684),
    [anon_sym___alignof] = ACTIONS(1684),
    [anon_sym__alignof] = ACTIONS(1684),
    [anon_sym_alignof] = ACTIONS(1684),
    [anon_sym__Alignof] = ACTIONS(1684),
    [anon_sym_offsetof] = ACTIONS(1684),
    [anon_sym__Generic] = ACTIONS(1684),
    [anon_sym_asm] = ACTIONS(1684),
    [anon_sym___asm__] = ACTIONS(1684),
    [sym_number_literal] = ACTIONS(1686),
    [anon_sym_L_SQUOTE] = ACTIONS(1686),
    [anon_sym_u_SQUOTE] = ACTIONS(1686),
    [anon_sym_U_SQUOTE] = ACTIONS(1686),
    [anon_sym_u8_SQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [anon_sym_L_DQUOTE] = ACTIONS(1686),
    [anon_sym_u_DQUOTE] = ACTIONS(1686),
    [anon_sym_U_DQUOTE] = ACTIONS(1686),
    [anon_sym_u8_DQUOTE] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [anon_sym_NULL] = ACTIONS(1684),
    [anon_sym_nullptr] = ACTIONS(1684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1684),
    [anon_sym_acquire] = ACTIONS(1684),
    [anon_sym_monitor] = ACTIONS(1684),
    [anon_sym_start] = ACTIONS(1684),
    [anon_sym_stop] = ACTIONS(1684),
  },
  [452] = {
    [sym_identifier] = ACTIONS(1692),
    [aux_sym_preproc_include_token1] = ACTIONS(1692),
    [aux_sym_preproc_def_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token2] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1692),
    [aux_sym_preproc_else_token1] = ACTIONS(1692),
    [aux_sym_preproc_elif_token1] = ACTIONS(1692),
    [sym_preproc_directive] = ACTIONS(1692),
    [anon_sym_LPAREN2] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_TILDE] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym___extension__] = ACTIONS(1692),
    [anon_sym_typedef] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym___attribute__] = ACTIONS(1692),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1694),
    [anon_sym___declspec] = ACTIONS(1692),
    [anon_sym___cdecl] = ACTIONS(1692),
    [anon_sym___clrcall] = ACTIONS(1692),
    [anon_sym___stdcall] = ACTIONS(1692),
    [anon_sym___fastcall] = ACTIONS(1692),
    [anon_sym___thiscall] = ACTIONS(1692),
    [anon_sym___vectorcall] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_signed] = ACTIONS(1692),
    [anon_sym_unsigned] = ACTIONS(1692),
    [anon_sym_long] = ACTIONS(1692),
    [anon_sym_short] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_auto] = ACTIONS(1692),
    [anon_sym_register] = ACTIONS(1692),
    [anon_sym_inline] = ACTIONS(1692),
    [anon_sym___inline] = ACTIONS(1692),
    [anon_sym___inline__] = ACTIONS(1692),
    [anon_sym___forceinline] = ACTIONS(1692),
    [anon_sym_thread_local] = ACTIONS(1692),
    [anon_sym___thread] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_constexpr] = ACTIONS(1692),
    [anon_sym_volatile] = ACTIONS(1692),
    [anon_sym_restrict] = ACTIONS(1692),
    [anon_sym___restrict__] = ACTIONS(1692),
    [anon_sym__Atomic] = ACTIONS(1692),
    [anon_sym__Noreturn] = ACTIONS(1692),
    [anon_sym_noreturn] = ACTIONS(1692),
    [sym_primitive_type] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_goto] = ACTIONS(1692),
    [anon_sym_DASH_DASH] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1694),
    [anon_sym_sizeof] = ACTIONS(1692),
    [anon_sym___alignof__] = ACTIONS(1692),
    [anon_sym___alignof] = ACTIONS(1692),
    [anon_sym__alignof] = ACTIONS(1692),
    [anon_sym_alignof] = ACTIONS(1692),
    [anon_sym__Alignof] = ACTIONS(1692),
    [anon_sym_offsetof] = ACTIONS(1692),
    [anon_sym__Generic] = ACTIONS(1692),
    [anon_sym_asm] = ACTIONS(1692),
    [anon_sym___asm__] = ACTIONS(1692),
    [sym_number_literal] = ACTIONS(1694),
    [anon_sym_L_SQUOTE] = ACTIONS(1694),
    [anon_sym_u_SQUOTE] = ACTIONS(1694),
    [anon_sym_U_SQUOTE] = ACTIONS(1694),
    [anon_sym_u8_SQUOTE] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1694),
    [anon_sym_L_DQUOTE] = ACTIONS(1694),
    [anon_sym_u_DQUOTE] = ACTIONS(1694),
    [anon_sym_U_DQUOTE] = ACTIONS(1694),
    [anon_sym_u8_DQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [anon_sym_NULL] = ACTIONS(1692),
    [anon_sym_nullptr] = ACTIONS(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1692),
    [anon_sym_acquire] = ACTIONS(1692),
    [anon_sym_monitor] = ACTIONS(1692),
    [anon_sym_start] = ACTIONS(1692),
    [anon_sym_stop] = ACTIONS(1692),
  },
  [453] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(144),
    [sym_attributed_statement] = STATE(144),
    [sym_labeled_statement] = STATE(144),
    [sym_expression_statement] = STATE(144),
    [sym_if_statement] = STATE(144),
    [sym_switch_statement] = STATE(144),
    [sym_case_statement] = STATE(144),
    [sym_while_statement] = STATE(144),
    [sym_do_statement] = STATE(144),
    [sym_for_statement] = STATE(144),
    [sym_return_statement] = STATE(144),
    [sym_break_statement] = STATE(144),
    [sym_continue_statement] = STATE(144),
    [sym_goto_statement] = STATE(144),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(144),
    [sym_acquire_statement] = STATE(144),
    [sym_monitor_statement] = STATE(144),
    [sym_start_statement] = STATE(144),
    [sym_stop_statement] = STATE(144),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [454] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(204),
    [sym_acquire_statement] = STATE(204),
    [sym_monitor_statement] = STATE(204),
    [sym_start_statement] = STATE(204),
    [sym_stop_statement] = STATE(204),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [455] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(260),
    [sym_attributed_statement] = STATE(260),
    [sym_labeled_statement] = STATE(260),
    [sym_expression_statement] = STATE(260),
    [sym_if_statement] = STATE(260),
    [sym_switch_statement] = STATE(260),
    [sym_case_statement] = STATE(260),
    [sym_while_statement] = STATE(260),
    [sym_do_statement] = STATE(260),
    [sym_for_statement] = STATE(260),
    [sym_return_statement] = STATE(260),
    [sym_break_statement] = STATE(260),
    [sym_continue_statement] = STATE(260),
    [sym_goto_statement] = STATE(260),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(260),
    [sym_acquire_statement] = STATE(260),
    [sym_monitor_statement] = STATE(260),
    [sym_start_statement] = STATE(260),
    [sym_stop_statement] = STATE(260),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [456] = {
    [sym_identifier] = ACTIONS(1500),
    [aux_sym_preproc_include_token1] = ACTIONS(1500),
    [aux_sym_preproc_def_token1] = ACTIONS(1500),
    [aux_sym_preproc_if_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1500),
    [sym_preproc_directive] = ACTIONS(1500),
    [anon_sym_LPAREN2] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym___extension__] = ACTIONS(1500),
    [anon_sym_typedef] = ACTIONS(1500),
    [anon_sym_extern] = ACTIONS(1500),
    [anon_sym___attribute__] = ACTIONS(1500),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1502),
    [anon_sym___declspec] = ACTIONS(1500),
    [anon_sym___cdecl] = ACTIONS(1500),
    [anon_sym___clrcall] = ACTIONS(1500),
    [anon_sym___stdcall] = ACTIONS(1500),
    [anon_sym___fastcall] = ACTIONS(1500),
    [anon_sym___thiscall] = ACTIONS(1500),
    [anon_sym___vectorcall] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [anon_sym_signed] = ACTIONS(1500),
    [anon_sym_unsigned] = ACTIONS(1500),
    [anon_sym_long] = ACTIONS(1500),
    [anon_sym_short] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1500),
    [anon_sym_auto] = ACTIONS(1500),
    [anon_sym_register] = ACTIONS(1500),
    [anon_sym_inline] = ACTIONS(1500),
    [anon_sym___inline] = ACTIONS(1500),
    [anon_sym___inline__] = ACTIONS(1500),
    [anon_sym___forceinline] = ACTIONS(1500),
    [anon_sym_thread_local] = ACTIONS(1500),
    [anon_sym___thread] = ACTIONS(1500),
    [anon_sym_const] = ACTIONS(1500),
    [anon_sym_constexpr] = ACTIONS(1500),
    [anon_sym_volatile] = ACTIONS(1500),
    [anon_sym_restrict] = ACTIONS(1500),
    [anon_sym___restrict__] = ACTIONS(1500),
    [anon_sym__Atomic] = ACTIONS(1500),
    [anon_sym__Noreturn] = ACTIONS(1500),
    [anon_sym_noreturn] = ACTIONS(1500),
    [sym_primitive_type] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1500),
    [anon_sym_struct] = ACTIONS(1500),
    [anon_sym_union] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1500),
    [anon_sym_switch] = ACTIONS(1500),
    [anon_sym_case] = ACTIONS(1500),
    [anon_sym_default] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_do] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_break] = ACTIONS(1500),
    [anon_sym_continue] = ACTIONS(1500),
    [anon_sym_goto] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_sizeof] = ACTIONS(1500),
    [anon_sym___alignof__] = ACTIONS(1500),
    [anon_sym___alignof] = ACTIONS(1500),
    [anon_sym__alignof] = ACTIONS(1500),
    [anon_sym_alignof] = ACTIONS(1500),
    [anon_sym__Alignof] = ACTIONS(1500),
    [anon_sym_offsetof] = ACTIONS(1500),
    [anon_sym__Generic] = ACTIONS(1500),
    [anon_sym_asm] = ACTIONS(1500),
    [anon_sym___asm__] = ACTIONS(1500),
    [sym_number_literal] = ACTIONS(1502),
    [anon_sym_L_SQUOTE] = ACTIONS(1502),
    [anon_sym_u_SQUOTE] = ACTIONS(1502),
    [anon_sym_U_SQUOTE] = ACTIONS(1502),
    [anon_sym_u8_SQUOTE] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_L_DQUOTE] = ACTIONS(1502),
    [anon_sym_u_DQUOTE] = ACTIONS(1502),
    [anon_sym_U_DQUOTE] = ACTIONS(1502),
    [anon_sym_u8_DQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [anon_sym_NULL] = ACTIONS(1500),
    [anon_sym_nullptr] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1500),
    [anon_sym_acquire] = ACTIONS(1500),
    [anon_sym_catch] = ACTIONS(1500),
    [anon_sym_monitor] = ACTIONS(1500),
    [anon_sym_start] = ACTIONS(1500),
    [anon_sym_stop] = ACTIONS(1500),
  },
  [457] = {
    [sym_identifier] = ACTIONS(1521),
    [aux_sym_preproc_include_token1] = ACTIONS(1521),
    [aux_sym_preproc_def_token1] = ACTIONS(1521),
    [aux_sym_preproc_if_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1521),
    [sym_preproc_directive] = ACTIONS(1521),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1521),
    [anon_sym_typedef] = ACTIONS(1521),
    [anon_sym_extern] = ACTIONS(1521),
    [anon_sym___attribute__] = ACTIONS(1521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1523),
    [anon_sym___declspec] = ACTIONS(1521),
    [anon_sym___cdecl] = ACTIONS(1521),
    [anon_sym___clrcall] = ACTIONS(1521),
    [anon_sym___stdcall] = ACTIONS(1521),
    [anon_sym___fastcall] = ACTIONS(1521),
    [anon_sym___thiscall] = ACTIONS(1521),
    [anon_sym___vectorcall] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_RBRACE] = ACTIONS(1523),
    [anon_sym_signed] = ACTIONS(1521),
    [anon_sym_unsigned] = ACTIONS(1521),
    [anon_sym_long] = ACTIONS(1521),
    [anon_sym_short] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1521),
    [anon_sym_auto] = ACTIONS(1521),
    [anon_sym_register] = ACTIONS(1521),
    [anon_sym_inline] = ACTIONS(1521),
    [anon_sym___inline] = ACTIONS(1521),
    [anon_sym___inline__] = ACTIONS(1521),
    [anon_sym___forceinline] = ACTIONS(1521),
    [anon_sym_thread_local] = ACTIONS(1521),
    [anon_sym___thread] = ACTIONS(1521),
    [anon_sym_const] = ACTIONS(1521),
    [anon_sym_constexpr] = ACTIONS(1521),
    [anon_sym_volatile] = ACTIONS(1521),
    [anon_sym_restrict] = ACTIONS(1521),
    [anon_sym___restrict__] = ACTIONS(1521),
    [anon_sym__Atomic] = ACTIONS(1521),
    [anon_sym__Noreturn] = ACTIONS(1521),
    [anon_sym_noreturn] = ACTIONS(1521),
    [sym_primitive_type] = ACTIONS(1521),
    [anon_sym_enum] = ACTIONS(1521),
    [anon_sym_struct] = ACTIONS(1521),
    [anon_sym_union] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_do] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_return] = ACTIONS(1521),
    [anon_sym_break] = ACTIONS(1521),
    [anon_sym_continue] = ACTIONS(1521),
    [anon_sym_goto] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1523),
    [anon_sym_sizeof] = ACTIONS(1521),
    [anon_sym___alignof__] = ACTIONS(1521),
    [anon_sym___alignof] = ACTIONS(1521),
    [anon_sym__alignof] = ACTIONS(1521),
    [anon_sym_alignof] = ACTIONS(1521),
    [anon_sym__Alignof] = ACTIONS(1521),
    [anon_sym_offsetof] = ACTIONS(1521),
    [anon_sym__Generic] = ACTIONS(1521),
    [anon_sym_asm] = ACTIONS(1521),
    [anon_sym___asm__] = ACTIONS(1521),
    [sym_number_literal] = ACTIONS(1523),
    [anon_sym_L_SQUOTE] = ACTIONS(1523),
    [anon_sym_u_SQUOTE] = ACTIONS(1523),
    [anon_sym_U_SQUOTE] = ACTIONS(1523),
    [anon_sym_u8_SQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_L_DQUOTE] = ACTIONS(1523),
    [anon_sym_u_DQUOTE] = ACTIONS(1523),
    [anon_sym_U_DQUOTE] = ACTIONS(1523),
    [anon_sym_u8_DQUOTE] = ACTIONS(1523),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [anon_sym_NULL] = ACTIONS(1521),
    [anon_sym_nullptr] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1521),
    [anon_sym_acquire] = ACTIONS(1521),
    [anon_sym_catch] = ACTIONS(1521),
    [anon_sym_monitor] = ACTIONS(1521),
    [anon_sym_start] = ACTIONS(1521),
    [anon_sym_stop] = ACTIONS(1521),
  },
  [458] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(273),
    [sym_attributed_statement] = STATE(273),
    [sym_labeled_statement] = STATE(273),
    [sym_expression_statement] = STATE(273),
    [sym_if_statement] = STATE(273),
    [sym_switch_statement] = STATE(273),
    [sym_case_statement] = STATE(273),
    [sym_while_statement] = STATE(273),
    [sym_do_statement] = STATE(273),
    [sym_for_statement] = STATE(273),
    [sym_return_statement] = STATE(273),
    [sym_break_statement] = STATE(273),
    [sym_continue_statement] = STATE(273),
    [sym_goto_statement] = STATE(273),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(273),
    [sym_acquire_statement] = STATE(273),
    [sym_monitor_statement] = STATE(273),
    [sym_start_statement] = STATE(273),
    [sym_stop_statement] = STATE(273),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [459] = {
    [sym_identifier] = ACTIONS(1619),
    [aux_sym_preproc_include_token1] = ACTIONS(1619),
    [aux_sym_preproc_def_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token2] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1619),
    [aux_sym_preproc_else_token1] = ACTIONS(1619),
    [aux_sym_preproc_elif_token1] = ACTIONS(1619),
    [sym_preproc_directive] = ACTIONS(1619),
    [anon_sym_LPAREN2] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym___extension__] = ACTIONS(1619),
    [anon_sym_typedef] = ACTIONS(1619),
    [anon_sym_extern] = ACTIONS(1619),
    [anon_sym___attribute__] = ACTIONS(1619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1621),
    [anon_sym___declspec] = ACTIONS(1619),
    [anon_sym___cdecl] = ACTIONS(1619),
    [anon_sym___clrcall] = ACTIONS(1619),
    [anon_sym___stdcall] = ACTIONS(1619),
    [anon_sym___fastcall] = ACTIONS(1619),
    [anon_sym___thiscall] = ACTIONS(1619),
    [anon_sym___vectorcall] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_signed] = ACTIONS(1619),
    [anon_sym_unsigned] = ACTIONS(1619),
    [anon_sym_long] = ACTIONS(1619),
    [anon_sym_short] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_auto] = ACTIONS(1619),
    [anon_sym_register] = ACTIONS(1619),
    [anon_sym_inline] = ACTIONS(1619),
    [anon_sym___inline] = ACTIONS(1619),
    [anon_sym___inline__] = ACTIONS(1619),
    [anon_sym___forceinline] = ACTIONS(1619),
    [anon_sym_thread_local] = ACTIONS(1619),
    [anon_sym___thread] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_constexpr] = ACTIONS(1619),
    [anon_sym_volatile] = ACTIONS(1619),
    [anon_sym_restrict] = ACTIONS(1619),
    [anon_sym___restrict__] = ACTIONS(1619),
    [anon_sym__Atomic] = ACTIONS(1619),
    [anon_sym__Noreturn] = ACTIONS(1619),
    [anon_sym_noreturn] = ACTIONS(1619),
    [sym_primitive_type] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [anon_sym_struct] = ACTIONS(1619),
    [anon_sym_union] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_switch] = ACTIONS(1619),
    [anon_sym_case] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_goto] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_sizeof] = ACTIONS(1619),
    [anon_sym___alignof__] = ACTIONS(1619),
    [anon_sym___alignof] = ACTIONS(1619),
    [anon_sym__alignof] = ACTIONS(1619),
    [anon_sym_alignof] = ACTIONS(1619),
    [anon_sym__Alignof] = ACTIONS(1619),
    [anon_sym_offsetof] = ACTIONS(1619),
    [anon_sym__Generic] = ACTIONS(1619),
    [anon_sym_asm] = ACTIONS(1619),
    [anon_sym___asm__] = ACTIONS(1619),
    [sym_number_literal] = ACTIONS(1621),
    [anon_sym_L_SQUOTE] = ACTIONS(1621),
    [anon_sym_u_SQUOTE] = ACTIONS(1621),
    [anon_sym_U_SQUOTE] = ACTIONS(1621),
    [anon_sym_u8_SQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [anon_sym_L_DQUOTE] = ACTIONS(1621),
    [anon_sym_u_DQUOTE] = ACTIONS(1621),
    [anon_sym_U_DQUOTE] = ACTIONS(1621),
    [anon_sym_u8_DQUOTE] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [anon_sym_NULL] = ACTIONS(1619),
    [anon_sym_nullptr] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1619),
    [anon_sym_acquire] = ACTIONS(1619),
    [anon_sym_monitor] = ACTIONS(1619),
    [anon_sym_start] = ACTIONS(1619),
    [anon_sym_stop] = ACTIONS(1619),
  },
  [460] = {
    [sym_attribute_declaration] = STATE(284),
    [sym_compound_statement] = STATE(256),
    [sym_attributed_statement] = STATE(256),
    [sym_labeled_statement] = STATE(256),
    [sym_expression_statement] = STATE(256),
    [sym_if_statement] = STATE(256),
    [sym_switch_statement] = STATE(256),
    [sym_case_statement] = STATE(256),
    [sym_while_statement] = STATE(256),
    [sym_do_statement] = STATE(256),
    [sym_for_statement] = STATE(256),
    [sym_return_statement] = STATE(256),
    [sym_break_statement] = STATE(256),
    [sym_continue_statement] = STATE(256),
    [sym_goto_statement] = STATE(256),
    [sym__expression] = STATE(1089),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1817),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_until_statement] = STATE(256),
    [sym_acquire_statement] = STATE(256),
    [sym_monitor_statement] = STATE(256),
    [sym_start_statement] = STATE(256),
    [sym_stop_statement] = STATE(256),
    [aux_sym_attributed_declarator_repeat1] = STATE(284),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_acquire] = ACTIONS(105),
    [anon_sym_monitor] = ACTIONS(107),
    [anon_sym_start] = ACTIONS(109),
    [anon_sym_stop] = ACTIONS(111),
  },
  [461] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_include_token1] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_LPAREN2] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym___extension__] = ACTIONS(1464),
    [anon_sym_typedef] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym___cdecl] = ACTIONS(1464),
    [anon_sym___clrcall] = ACTIONS(1464),
    [anon_sym___stdcall] = ACTIONS(1464),
    [anon_sym___fastcall] = ACTIONS(1464),
    [anon_sym___thiscall] = ACTIONS(1464),
    [anon_sym___vectorcall] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym___inline] = ACTIONS(1464),
    [anon_sym___inline__] = ACTIONS(1464),
    [anon_sym___forceinline] = ACTIONS(1464),
    [anon_sym_thread_local] = ACTIONS(1464),
    [anon_sym___thread] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_constexpr] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym___restrict__] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym__Noreturn] = ACTIONS(1464),
    [anon_sym_noreturn] = ACTIONS(1464),
    [sym_primitive_type] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_switch] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_goto] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_sizeof] = ACTIONS(1464),
    [anon_sym___alignof__] = ACTIONS(1464),
    [anon_sym___alignof] = ACTIONS(1464),
    [anon_sym__alignof] = ACTIONS(1464),
    [anon_sym_alignof] = ACTIONS(1464),
    [anon_sym__Alignof] = ACTIONS(1464),
    [anon_sym_offsetof] = ACTIONS(1464),
    [anon_sym__Generic] = ACTIONS(1464),
    [anon_sym_asm] = ACTIONS(1464),
    [anon_sym___asm__] = ACTIONS(1464),
    [sym_number_literal] = ACTIONS(1466),
    [anon_sym_L_SQUOTE] = ACTIONS(1466),
    [anon_sym_u_SQUOTE] = ACTIONS(1466),
    [anon_sym_U_SQUOTE] = ACTIONS(1466),
    [anon_sym_u8_SQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_L_DQUOTE] = ACTIONS(1466),
    [anon_sym_u_DQUOTE] = ACTIONS(1466),
    [anon_sym_U_DQUOTE] = ACTIONS(1466),
    [anon_sym_u8_DQUOTE] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [anon_sym_NULL] = ACTIONS(1464),
    [anon_sym_nullptr] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1464),
    [anon_sym_acquire] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_monitor] = ACTIONS(1464),
    [anon_sym_start] = ACTIONS(1464),
    [anon_sym_stop] = ACTIONS(1464),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1690),
    [sym_identifier] = ACTIONS(1688),
    [aux_sym_preproc_include_token1] = ACTIONS(1688),
    [aux_sym_preproc_def_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1688),
    [sym_preproc_directive] = ACTIONS(1688),
    [anon_sym_LPAREN2] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym___extension__] = ACTIONS(1688),
    [anon_sym_typedef] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym___attribute__] = ACTIONS(1688),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1690),
    [anon_sym___declspec] = ACTIONS(1688),
    [anon_sym___cdecl] = ACTIONS(1688),
    [anon_sym___clrcall] = ACTIONS(1688),
    [anon_sym___stdcall] = ACTIONS(1688),
    [anon_sym___fastcall] = ACTIONS(1688),
    [anon_sym___thiscall] = ACTIONS(1688),
    [anon_sym___vectorcall] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_signed] = ACTIONS(1688),
    [anon_sym_unsigned] = ACTIONS(1688),
    [anon_sym_long] = ACTIONS(1688),
    [anon_sym_short] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_auto] = ACTIONS(1688),
    [anon_sym_register] = ACTIONS(1688),
    [anon_sym_inline] = ACTIONS(1688),
    [anon_sym___inline] = ACTIONS(1688),
    [anon_sym___inline__] = ACTIONS(1688),
    [anon_sym___forceinline] = ACTIONS(1688),
    [anon_sym_thread_local] = ACTIONS(1688),
    [anon_sym___thread] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_constexpr] = ACTIONS(1688),
    [anon_sym_volatile] = ACTIONS(1688),
    [anon_sym_restrict] = ACTIONS(1688),
    [anon_sym___restrict__] = ACTIONS(1688),
    [anon_sym__Atomic] = ACTIONS(1688),
    [anon_sym__Noreturn] = ACTIONS(1688),
    [anon_sym_noreturn] = ACTIONS(1688),
    [sym_primitive_type] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_switch] = ACTIONS(1688),
    [anon_sym_case] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_do] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_goto] = ACTIONS(1688),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_sizeof] = ACTIONS(1688),
    [anon_sym___alignof__] = ACTIONS(1688),
    [anon_sym___alignof] = ACTIONS(1688),
    [anon_sym__alignof] = ACTIONS(1688),
    [anon_sym_alignof] = ACTIONS(1688),
    [anon_sym__Alignof] = ACTIONS(1688),
    [anon_sym_offsetof] = ACTIONS(1688),
    [anon_sym__Generic] = ACTIONS(1688),
    [anon_sym_asm] = ACTIONS(1688),
    [anon_sym___asm__] = ACTIONS(1688),
    [sym_number_literal] = ACTIONS(1690),
    [anon_sym_L_SQUOTE] = ACTIONS(1690),
    [anon_sym_u_SQUOTE] = ACTIONS(1690),
    [anon_sym_U_SQUOTE] = ACTIONS(1690),
    [anon_sym_u8_SQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [anon_sym_L_DQUOTE] = ACTIONS(1690),
    [anon_sym_u_DQUOTE] = ACTIONS(1690),
    [anon_sym_U_DQUOTE] = ACTIONS(1690),
    [anon_sym_u8_DQUOTE] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [anon_sym_NULL] = ACTIONS(1688),
    [anon_sym_nullptr] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1688),
    [anon_sym_until] = ACTIONS(1688),
    [anon_sym_acquire] = ACTIONS(1688),
    [anon_sym_monitor] = ACTIONS(1688),
    [anon_sym_start] = ACTIONS(1688),
    [anon_sym_stop] = ACTIONS(1688),
  },
  [463] = {
    [sym_identifier] = ACTIONS(1623),
    [aux_sym_preproc_include_token1] = ACTIONS(1623),
    [aux_sym_preproc_def_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1623),
    [sym_preproc_directive] = ACTIONS(1623),
    [anon_sym_LPAREN2] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym___extension__] = ACTIONS(1623),
    [anon_sym_typedef] = ACTIONS(1623),
    [anon_sym_extern] = ACTIONS(1623),
    [anon_sym___attribute__] = ACTIONS(1623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1625),
    [anon_sym___declspec] = ACTIONS(1623),
    [anon_sym___cdecl] = ACTIONS(1623),
    [anon_sym___clrcall] = ACTIONS(1623),
    [anon_sym___stdcall] = ACTIONS(1623),
    [anon_sym___fastcall] = ACTIONS(1623),
    [anon_sym___thiscall] = ACTIONS(1623),
    [anon_sym___vectorcall] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_signed] = ACTIONS(1623),
    [anon_sym_unsigned] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_auto] = ACTIONS(1623),
    [anon_sym_register] = ACTIONS(1623),
    [anon_sym_inline] = ACTIONS(1623),
    [anon_sym___inline] = ACTIONS(1623),
    [anon_sym___inline__] = ACTIONS(1623),
    [anon_sym___forceinline] = ACTIONS(1623),
    [anon_sym_thread_local] = ACTIONS(1623),
    [anon_sym___thread] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_constexpr] = ACTIONS(1623),
    [anon_sym_volatile] = ACTIONS(1623),
    [anon_sym_restrict] = ACTIONS(1623),
    [anon_sym___restrict__] = ACTIONS(1623),
    [anon_sym__Atomic] = ACTIONS(1623),
    [anon_sym__Noreturn] = ACTIONS(1623),
    [anon_sym_noreturn] = ACTIONS(1623),
    [sym_primitive_type] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [anon_sym_struct] = ACTIONS(1623),
    [anon_sym_union] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_goto] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_sizeof] = ACTIONS(1623),
    [anon_sym___alignof__] = ACTIONS(1623),
    [anon_sym___alignof] = ACTIONS(1623),
    [anon_sym__alignof] = ACTIONS(1623),
    [anon_sym_alignof] = ACTIONS(1623),
    [anon_sym__Alignof] = ACTIONS(1623),
    [anon_sym_offsetof] = ACTIONS(1623),
    [anon_sym__Generic] = ACTIONS(1623),
    [anon_sym_asm] = ACTIONS(1623),
    [anon_sym___asm__] = ACTIONS(1623),
    [sym_number_literal] = ACTIONS(1625),
    [anon_sym_L_SQUOTE] = ACTIONS(1625),
    [anon_sym_u_SQUOTE] = ACTIONS(1625),
    [anon_sym_U_SQUOTE] = ACTIONS(1625),
    [anon_sym_u8_SQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [anon_sym_L_DQUOTE] = ACTIONS(1625),
    [anon_sym_u_DQUOTE] = ACTIONS(1625),
    [anon_sym_U_DQUOTE] = ACTIONS(1625),
    [anon_sym_u8_DQUOTE] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [anon_sym_NULL] = ACTIONS(1623),
    [anon_sym_nullptr] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1623),
    [anon_sym_acquire] = ACTIONS(1623),
    [anon_sym_monitor] = ACTIONS(1623),
    [anon_sym_start] = ACTIONS(1623),
    [anon_sym_stop] = ACTIONS(1623),
  },
  [464] = {
    [sym_identifier] = ACTIONS(1672),
    [aux_sym_preproc_include_token1] = ACTIONS(1672),
    [aux_sym_preproc_def_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token2] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1672),
    [sym_preproc_directive] = ACTIONS(1672),
    [anon_sym_LPAREN2] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_TILDE] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym___extension__] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym___attribute__] = ACTIONS(1672),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1674),
    [anon_sym___declspec] = ACTIONS(1672),
    [anon_sym___cdecl] = ACTIONS(1672),
    [anon_sym___clrcall] = ACTIONS(1672),
    [anon_sym___stdcall] = ACTIONS(1672),
    [anon_sym___fastcall] = ACTIONS(1672),
    [anon_sym___thiscall] = ACTIONS(1672),
    [anon_sym___vectorcall] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_signed] = ACTIONS(1672),
    [anon_sym_unsigned] = ACTIONS(1672),
    [anon_sym_long] = ACTIONS(1672),
    [anon_sym_short] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_auto] = ACTIONS(1672),
    [anon_sym_register] = ACTIONS(1672),
    [anon_sym_inline] = ACTIONS(1672),
    [anon_sym___inline] = ACTIONS(1672),
    [anon_sym___inline__] = ACTIONS(1672),
    [anon_sym___forceinline] = ACTIONS(1672),
    [anon_sym_thread_local] = ACTIONS(1672),
    [anon_sym___thread] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_constexpr] = ACTIONS(1672),
    [anon_sym_volatile] = ACTIONS(1672),
    [anon_sym_restrict] = ACTIONS(1672),
    [anon_sym___restrict__] = ACTIONS(1672),
    [anon_sym__Atomic] = ACTIONS(1672),
    [anon_sym__Noreturn] = ACTIONS(1672),
    [anon_sym_noreturn] = ACTIONS(1672),
    [sym_primitive_type] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_do] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_goto] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1674),
    [anon_sym_PLUS_PLUS] = ACTIONS(1674),
    [anon_sym_sizeof] = ACTIONS(1672),
    [anon_sym___alignof__] = ACTIONS(1672),
    [anon_sym___alignof] = ACTIONS(1672),
    [anon_sym__alignof] = ACTIONS(1672),
    [anon_sym_alignof] = ACTIONS(1672),
    [anon_sym__Alignof] = ACTIONS(1672),
    [anon_sym_offsetof] = ACTIONS(1672),
    [anon_sym__Generic] = ACTIONS(1672),
    [anon_sym_asm] = ACTIONS(1672),
    [anon_sym___asm__] = ACTIONS(1672),
    [sym_number_literal] = ACTIONS(1674),
    [anon_sym_L_SQUOTE] = ACTIONS(1674),
    [anon_sym_u_SQUOTE] = ACTIONS(1674),
    [anon_sym_U_SQUOTE] = ACTIONS(1674),
    [anon_sym_u8_SQUOTE] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1674),
    [anon_sym_L_DQUOTE] = ACTIONS(1674),
    [anon_sym_u_DQUOTE] = ACTIONS(1674),
    [anon_sym_U_DQUOTE] = ACTIONS(1674),
    [anon_sym_u8_DQUOTE] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(1674),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [anon_sym_NULL] = ACTIONS(1672),
    [anon_sym_nullptr] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1672),
    [anon_sym_acquire] = ACTIONS(1672),
    [anon_sym_monitor] = ACTIONS(1672),
    [anon_sym_start] = ACTIONS(1672),
    [anon_sym_stop] = ACTIONS(1672),
  },
  [465] = {
    [sym_identifier] = ACTIONS(1676),
    [aux_sym_preproc_include_token1] = ACTIONS(1676),
    [aux_sym_preproc_def_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token2] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1676),
    [sym_preproc_directive] = ACTIONS(1676),
    [anon_sym_LPAREN2] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym___extension__] = ACTIONS(1676),
    [anon_sym_typedef] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym___attribute__] = ACTIONS(1676),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1678),
    [anon_sym___declspec] = ACTIONS(1676),
    [anon_sym___cdecl] = ACTIONS(1676),
    [anon_sym___clrcall] = ACTIONS(1676),
    [anon_sym___stdcall] = ACTIONS(1676),
    [anon_sym___fastcall] = ACTIONS(1676),
    [anon_sym___thiscall] = ACTIONS(1676),
    [anon_sym___vectorcall] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_signed] = ACTIONS(1676),
    [anon_sym_unsigned] = ACTIONS(1676),
    [anon_sym_long] = ACTIONS(1676),
    [anon_sym_short] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_auto] = ACTIONS(1676),
    [anon_sym_register] = ACTIONS(1676),
    [anon_sym_inline] = ACTIONS(1676),
    [anon_sym___inline] = ACTIONS(1676),
    [anon_sym___inline__] = ACTIONS(1676),
    [anon_sym___forceinline] = ACTIONS(1676),
    [anon_sym_thread_local] = ACTIONS(1676),
    [anon_sym___thread] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_constexpr] = ACTIONS(1676),
    [anon_sym_volatile] = ACTIONS(1676),
    [anon_sym_restrict] = ACTIONS(1676),
    [anon_sym___restrict__] = ACTIONS(1676),
    [anon_sym__Atomic] = ACTIONS(1676),
    [anon_sym__Noreturn] = ACTIONS(1676),
    [anon_sym_noreturn] = ACTIONS(1676),
    [sym_primitive_type] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_switch] = ACTIONS(1676),
    [anon_sym_case] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_goto] = ACTIONS(1676),
    [anon_sym_DASH_DASH] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1678),
    [anon_sym_sizeof] = ACTIONS(1676),
    [anon_sym___alignof__] = ACTIONS(1676),
    [anon_sym___alignof] = ACTIONS(1676),
    [anon_sym__alignof] = ACTIONS(1676),
    [anon_sym_alignof] = ACTIONS(1676),
    [anon_sym__Alignof] = ACTIONS(1676),
    [anon_sym_offsetof] = ACTIONS(1676),
    [anon_sym__Generic] = ACTIONS(1676),
    [anon_sym_asm] = ACTIONS(1676),
    [anon_sym___asm__] = ACTIONS(1676),
    [sym_number_literal] = ACTIONS(1678),
    [anon_sym_L_SQUOTE] = ACTIONS(1678),
    [anon_sym_u_SQUOTE] = ACTIONS(1678),
    [anon_sym_U_SQUOTE] = ACTIONS(1678),
    [anon_sym_u8_SQUOTE] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1678),
    [anon_sym_L_DQUOTE] = ACTIONS(1678),
    [anon_sym_u_DQUOTE] = ACTIONS(1678),
    [anon_sym_U_DQUOTE] = ACTIONS(1678),
    [anon_sym_u8_DQUOTE] = ACTIONS(1678),
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [anon_sym_NULL] = ACTIONS(1676),
    [anon_sym_nullptr] = ACTIONS(1676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1676),
    [anon_sym_acquire] = ACTIONS(1676),
    [anon_sym_monitor] = ACTIONS(1676),
    [anon_sym_start] = ACTIONS(1676),
    [anon_sym_stop] = ACTIONS(1676),
  },
  [466] = {
    [sym_identifier] = ACTIONS(1680),
    [aux_sym_preproc_include_token1] = ACTIONS(1680),
    [aux_sym_preproc_def_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1680),
    [sym_preproc_directive] = ACTIONS(1680),
    [anon_sym_LPAREN2] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_TILDE] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym___extension__] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym___attribute__] = ACTIONS(1680),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1682),
    [anon_sym___declspec] = ACTIONS(1680),
    [anon_sym___cdecl] = ACTIONS(1680),
    [anon_sym___clrcall] = ACTIONS(1680),
    [anon_sym___stdcall] = ACTIONS(1680),
    [anon_sym___fastcall] = ACTIONS(1680),
    [anon_sym___thiscall] = ACTIONS(1680),
    [anon_sym___vectorcall] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [anon_sym_signed] = ACTIONS(1680),
    [anon_sym_unsigned] = ACTIONS(1680),
    [anon_sym_long] = ACTIONS(1680),
    [anon_sym_short] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_auto] = ACTIONS(1680),
    [anon_sym_register] = ACTIONS(1680),
    [anon_sym_inline] = ACTIONS(1680),
    [anon_sym___inline] = ACTIONS(1680),
    [anon_sym___inline__] = ACTIONS(1680),
    [anon_sym___forceinline] = ACTIONS(1680),
    [anon_sym_thread_local] = ACTIONS(1680),
    [anon_sym___thread] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_constexpr] = ACTIONS(1680),
    [anon_sym_volatile] = ACTIONS(1680),
    [anon_sym_restrict] = ACTIONS(1680),
    [anon_sym___restrict__] = ACTIONS(1680),
    [anon_sym__Atomic] = ACTIONS(1680),
    [anon_sym__Noreturn] = ACTIONS(1680),
    [anon_sym_noreturn] = ACTIONS(1680),
    [sym_primitive_type] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_switch] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_do] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_goto] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1682),
    [anon_sym_sizeof] = ACTIONS(1680),
    [anon_sym___alignof__] = ACTIONS(1680),
    [anon_sym___alignof] = ACTIONS(1680),
    [anon_sym__alignof] = ACTIONS(1680),
    [anon_sym_alignof] = ACTIONS(1680),
    [anon_sym__Alignof] = ACTIONS(1680),
    [anon_sym_offsetof] = ACTIONS(1680),
    [anon_sym__Generic] = ACTIONS(1680),
    [anon_sym_asm] = ACTIONS(1680),
    [anon_sym___asm__] = ACTIONS(1680),
    [sym_number_literal] = ACTIONS(1682),
    [anon_sym_L_SQUOTE] = ACTIONS(1682),
    [anon_sym_u_SQUOTE] = ACTIONS(1682),
    [anon_sym_U_SQUOTE] = ACTIONS(1682),
    [anon_sym_u8_SQUOTE] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1682),
    [anon_sym_L_DQUOTE] = ACTIONS(1682),
    [anon_sym_u_DQUOTE] = ACTIONS(1682),
    [anon_sym_U_DQUOTE] = ACTIONS(1682),
    [anon_sym_u8_DQUOTE] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [anon_sym_NULL] = ACTIONS(1680),
    [anon_sym_nullptr] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1680),
    [anon_sym_acquire] = ACTIONS(1680),
    [anon_sym_monitor] = ACTIONS(1680),
    [anon_sym_start] = ACTIONS(1680),
    [anon_sym_stop] = ACTIONS(1680),
  },
  [467] = {
    [sym_identifier] = ACTIONS(1680),
    [aux_sym_preproc_include_token1] = ACTIONS(1680),
    [aux_sym_preproc_def_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token2] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1680),
    [sym_preproc_directive] = ACTIONS(1680),
    [anon_sym_LPAREN2] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_TILDE] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym___extension__] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym___attribute__] = ACTIONS(1680),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1682),
    [anon_sym___declspec] = ACTIONS(1680),
    [anon_sym___cdecl] = ACTIONS(1680),
    [anon_sym___clrcall] = ACTIONS(1680),
    [anon_sym___stdcall] = ACTIONS(1680),
    [anon_sym___fastcall] = ACTIONS(1680),
    [anon_sym___thiscall] = ACTIONS(1680),
    [anon_sym___vectorcall] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_signed] = ACTIONS(1680),
    [anon_sym_unsigned] = ACTIONS(1680),
    [anon_sym_long] = ACTIONS(1680),
    [anon_sym_short] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_auto] = ACTIONS(1680),
    [anon_sym_register] = ACTIONS(1680),
    [anon_sym_inline] = ACTIONS(1680),
    [anon_sym___inline] = ACTIONS(1680),
    [anon_sym___inline__] = ACTIONS(1680),
    [anon_sym___forceinline] = ACTIONS(1680),
    [anon_sym_thread_local] = ACTIONS(1680),
    [anon_sym___thread] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_constexpr] = ACTIONS(1680),
    [anon_sym_volatile] = ACTIONS(1680),
    [anon_sym_restrict] = ACTIONS(1680),
    [anon_sym___restrict__] = ACTIONS(1680),
    [anon_sym__Atomic] = ACTIONS(1680),
    [anon_sym__Noreturn] = ACTIONS(1680),
    [anon_sym_noreturn] = ACTIONS(1680),
    [sym_primitive_type] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_switch] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_do] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_goto] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1682),
    [anon_sym_sizeof] = ACTIONS(1680),
    [anon_sym___alignof__] = ACTIONS(1680),
    [anon_sym___alignof] = ACTIONS(1680),
    [anon_sym__alignof] = ACTIONS(1680),
    [anon_sym_alignof] = ACTIONS(1680),
    [anon_sym__Alignof] = ACTIONS(1680),
    [anon_sym_offsetof] = ACTIONS(1680),
    [anon_sym__Generic] = ACTIONS(1680),
    [anon_sym_asm] = ACTIONS(1680),
    [anon_sym___asm__] = ACTIONS(1680),
    [sym_number_literal] = ACTIONS(1682),
    [anon_sym_L_SQUOTE] = ACTIONS(1682),
    [anon_sym_u_SQUOTE] = ACTIONS(1682),
    [anon_sym_U_SQUOTE] = ACTIONS(1682),
    [anon_sym_u8_SQUOTE] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1682),
    [anon_sym_L_DQUOTE] = ACTIONS(1682),
    [anon_sym_u_DQUOTE] = ACTIONS(1682),
    [anon_sym_U_DQUOTE] = ACTIONS(1682),
    [anon_sym_u8_DQUOTE] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [anon_sym_NULL] = ACTIONS(1680),
    [anon_sym_nullptr] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1680),
    [anon_sym_acquire] = ACTIONS(1680),
    [anon_sym_monitor] = ACTIONS(1680),
    [anon_sym_start] = ACTIONS(1680),
    [anon_sym_stop] = ACTIONS(1680),
  },
  [468] = {
    [sym_identifier] = ACTIONS(1684),
    [aux_sym_preproc_include_token1] = ACTIONS(1684),
    [aux_sym_preproc_def_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1684),
    [sym_preproc_directive] = ACTIONS(1684),
    [anon_sym_LPAREN2] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym___extension__] = ACTIONS(1684),
    [anon_sym_typedef] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym___attribute__] = ACTIONS(1684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1686),
    [anon_sym___declspec] = ACTIONS(1684),
    [anon_sym___cdecl] = ACTIONS(1684),
    [anon_sym___clrcall] = ACTIONS(1684),
    [anon_sym___stdcall] = ACTIONS(1684),
    [anon_sym___fastcall] = ACTIONS(1684),
    [anon_sym___thiscall] = ACTIONS(1684),
    [anon_sym___vectorcall] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_signed] = ACTIONS(1684),
    [anon_sym_unsigned] = ACTIONS(1684),
    [anon_sym_long] = ACTIONS(1684),
    [anon_sym_short] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_auto] = ACTIONS(1684),
    [anon_sym_register] = ACTIONS(1684),
    [anon_sym_inline] = ACTIONS(1684),
    [anon_sym___inline] = ACTIONS(1684),
    [anon_sym___inline__] = ACTIONS(1684),
    [anon_sym___forceinline] = ACTIONS(1684),
    [anon_sym_thread_local] = ACTIONS(1684),
    [anon_sym___thread] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_constexpr] = ACTIONS(1684),
    [anon_sym_volatile] = ACTIONS(1684),
    [anon_sym_restrict] = ACTIONS(1684),
    [anon_sym___restrict__] = ACTIONS(1684),
    [anon_sym__Atomic] = ACTIONS(1684),
    [anon_sym__Noreturn] = ACTIONS(1684),
    [anon_sym_noreturn] = ACTIONS(1684),
    [sym_primitive_type] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_do] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1684),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_sizeof] = ACTIONS(1684),
    [anon_sym___alignof__] = ACTIONS(1684),
    [anon_sym___alignof] = ACTIONS(1684),
    [anon_sym__alignof] = ACTIONS(1684),
    [anon_sym_alignof] = ACTIONS(1684),
    [anon_sym__Alignof] = ACTIONS(1684),
    [anon_sym_offsetof] = ACTIONS(1684),
    [anon_sym__Generic] = ACTIONS(1684),
    [anon_sym_asm] = ACTIONS(1684),
    [anon_sym___asm__] = ACTIONS(1684),
    [sym_number_literal] = ACTIONS(1686),
    [anon_sym_L_SQUOTE] = ACTIONS(1686),
    [anon_sym_u_SQUOTE] = ACTIONS(1686),
    [anon_sym_U_SQUOTE] = ACTIONS(1686),
    [anon_sym_u8_SQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [anon_sym_L_DQUOTE] = ACTIONS(1686),
    [anon_sym_u_DQUOTE] = ACTIONS(1686),
    [anon_sym_U_DQUOTE] = ACTIONS(1686),
    [anon_sym_u8_DQUOTE] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [anon_sym_NULL] = ACTIONS(1684),
    [anon_sym_nullptr] = ACTIONS(1684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1684),
    [anon_sym_acquire] = ACTIONS(1684),
    [anon_sym_monitor] = ACTIONS(1684),
    [anon_sym_start] = ACTIONS(1684),
    [anon_sym_stop] = ACTIONS(1684),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(1650),
    [sym_identifier] = ACTIONS(1648),
    [aux_sym_preproc_include_token1] = ACTIONS(1648),
    [aux_sym_preproc_def_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1648),
    [sym_preproc_directive] = ACTIONS(1648),
    [anon_sym_LPAREN2] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym___extension__] = ACTIONS(1648),
    [anon_sym_typedef] = ACTIONS(1648),
    [anon_sym_extern] = ACTIONS(1648),
    [anon_sym___attribute__] = ACTIONS(1648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1650),
    [anon_sym___declspec] = ACTIONS(1648),
    [anon_sym___cdecl] = ACTIONS(1648),
    [anon_sym___clrcall] = ACTIONS(1648),
    [anon_sym___stdcall] = ACTIONS(1648),
    [anon_sym___fastcall] = ACTIONS(1648),
    [anon_sym___thiscall] = ACTIONS(1648),
    [anon_sym___vectorcall] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_signed] = ACTIONS(1648),
    [anon_sym_unsigned] = ACTIONS(1648),
    [anon_sym_long] = ACTIONS(1648),
    [anon_sym_short] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1648),
    [anon_sym_auto] = ACTIONS(1648),
    [anon_sym_register] = ACTIONS(1648),
    [anon_sym_inline] = ACTIONS(1648),
    [anon_sym___inline] = ACTIONS(1648),
    [anon_sym___inline__] = ACTIONS(1648),
    [anon_sym___forceinline] = ACTIONS(1648),
    [anon_sym_thread_local] = ACTIONS(1648),
    [anon_sym___thread] = ACTIONS(1648),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_constexpr] = ACTIONS(1648),
    [anon_sym_volatile] = ACTIONS(1648),
    [anon_sym_restrict] = ACTIONS(1648),
    [anon_sym___restrict__] = ACTIONS(1648),
    [anon_sym__Atomic] = ACTIONS(1648),
    [anon_sym__Noreturn] = ACTIONS(1648),
    [anon_sym_noreturn] = ACTIONS(1648),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1648),
    [anon_sym_struct] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_if] = ACTIONS(1648),
    [anon_sym_switch] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_while] = ACTIONS(1648),
    [anon_sym_do] = ACTIONS(1648),
    [anon_sym_for] = ACTIONS(1648),
    [anon_sym_return] = ACTIONS(1648),
    [anon_sym_break] = ACTIONS(1648),
    [anon_sym_continue] = ACTIONS(1648),
    [anon_sym_goto] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1650),
    [anon_sym_sizeof] = ACTIONS(1648),
    [anon_sym___alignof__] = ACTIONS(1648),
    [anon_sym___alignof] = ACTIONS(1648),
    [anon_sym__alignof] = ACTIONS(1648),
    [anon_sym_alignof] = ACTIONS(1648),
    [anon_sym__Alignof] = ACTIONS(1648),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1648),
    [anon_sym_asm] = ACTIONS(1648),
    [anon_sym___asm__] = ACTIONS(1648),
    [sym_number_literal] = ACTIONS(1650),
    [anon_sym_L_SQUOTE] = ACTIONS(1650),
    [anon_sym_u_SQUOTE] = ACTIONS(1650),
    [anon_sym_U_SQUOTE] = ACTIONS(1650),
    [anon_sym_u8_SQUOTE] = ACTIONS(1650),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [anon_sym_L_DQUOTE] = ACTIONS(1650),
    [anon_sym_u_DQUOTE] = ACTIONS(1650),
    [anon_sym_U_DQUOTE] = ACTIONS(1650),
    [anon_sym_u8_DQUOTE] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_true] = ACTIONS(1648),
    [sym_false] = ACTIONS(1648),
    [anon_sym_NULL] = ACTIONS(1648),
    [anon_sym_nullptr] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1648),
    [anon_sym_until] = ACTIONS(1648),
    [anon_sym_acquire] = ACTIONS(1648),
    [anon_sym_monitor] = ACTIONS(1648),
    [anon_sym_start] = ACTIONS(1648),
    [anon_sym_stop] = ACTIONS(1648),
  },
  [470] = {
    [sym_identifier] = ACTIONS(1692),
    [aux_sym_preproc_include_token1] = ACTIONS(1692),
    [aux_sym_preproc_def_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1692),
    [sym_preproc_directive] = ACTIONS(1692),
    [anon_sym_LPAREN2] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_TILDE] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym___extension__] = ACTIONS(1692),
    [anon_sym_typedef] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym___attribute__] = ACTIONS(1692),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1694),
    [anon_sym___declspec] = ACTIONS(1692),
    [anon_sym___cdecl] = ACTIONS(1692),
    [anon_sym___clrcall] = ACTIONS(1692),
    [anon_sym___stdcall] = ACTIONS(1692),
    [anon_sym___fastcall] = ACTIONS(1692),
    [anon_sym___thiscall] = ACTIONS(1692),
    [anon_sym___vectorcall] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_signed] = ACTIONS(1692),
    [anon_sym_unsigned] = ACTIONS(1692),
    [anon_sym_long] = ACTIONS(1692),
    [anon_sym_short] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_auto] = ACTIONS(1692),
    [anon_sym_register] = ACTIONS(1692),
    [anon_sym_inline] = ACTIONS(1692),
    [anon_sym___inline] = ACTIONS(1692),
    [anon_sym___inline__] = ACTIONS(1692),
    [anon_sym___forceinline] = ACTIONS(1692),
    [anon_sym_thread_local] = ACTIONS(1692),
    [anon_sym___thread] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_constexpr] = ACTIONS(1692),
    [anon_sym_volatile] = ACTIONS(1692),
    [anon_sym_restrict] = ACTIONS(1692),
    [anon_sym___restrict__] = ACTIONS(1692),
    [anon_sym__Atomic] = ACTIONS(1692),
    [anon_sym__Noreturn] = ACTIONS(1692),
    [anon_sym_noreturn] = ACTIONS(1692),
    [sym_primitive_type] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_goto] = ACTIONS(1692),
    [anon_sym_DASH_DASH] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1694),
    [anon_sym_sizeof] = ACTIONS(1692),
    [anon_sym___alignof__] = ACTIONS(1692),
    [anon_sym___alignof] = ACTIONS(1692),
    [anon_sym__alignof] = ACTIONS(1692),
    [anon_sym_alignof] = ACTIONS(1692),
    [anon_sym__Alignof] = ACTIONS(1692),
    [anon_sym_offsetof] = ACTIONS(1692),
    [anon_sym__Generic] = ACTIONS(1692),
    [anon_sym_asm] = ACTIONS(1692),
    [anon_sym___asm__] = ACTIONS(1692),
    [sym_number_literal] = ACTIONS(1694),
    [anon_sym_L_SQUOTE] = ACTIONS(1694),
    [anon_sym_u_SQUOTE] = ACTIONS(1694),
    [anon_sym_U_SQUOTE] = ACTIONS(1694),
    [anon_sym_u8_SQUOTE] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1694),
    [anon_sym_L_DQUOTE] = ACTIONS(1694),
    [anon_sym_u_DQUOTE] = ACTIONS(1694),
    [anon_sym_U_DQUOTE] = ACTIONS(1694),
    [anon_sym_u8_DQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [anon_sym_NULL] = ACTIONS(1692),
    [anon_sym_nullptr] = ACTIONS(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1692),
    [anon_sym_acquire] = ACTIONS(1692),
    [anon_sym_monitor] = ACTIONS(1692),
    [anon_sym_start] = ACTIONS(1692),
    [anon_sym_stop] = ACTIONS(1692),
  },
  [471] = {
    [sym_identifier] = ACTIONS(1696),
    [aux_sym_preproc_include_token1] = ACTIONS(1696),
    [aux_sym_preproc_def_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token2] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1696),
    [sym_preproc_directive] = ACTIONS(1696),
    [anon_sym_LPAREN2] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym___extension__] = ACTIONS(1696),
    [anon_sym_typedef] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym___attribute__] = ACTIONS(1696),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1698),
    [anon_sym___declspec] = ACTIONS(1696),
    [anon_sym___cdecl] = ACTIONS(1696),
    [anon_sym___clrcall] = ACTIONS(1696),
    [anon_sym___stdcall] = ACTIONS(1696),
    [anon_sym___fastcall] = ACTIONS(1696),
    [anon_sym___thiscall] = ACTIONS(1696),
    [anon_sym___vectorcall] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_signed] = ACTIONS(1696),
    [anon_sym_unsigned] = ACTIONS(1696),
    [anon_sym_long] = ACTIONS(1696),
    [anon_sym_short] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_auto] = ACTIONS(1696),
    [anon_sym_register] = ACTIONS(1696),
    [anon_sym_inline] = ACTIONS(1696),
    [anon_sym___inline] = ACTIONS(1696),
    [anon_sym___inline__] = ACTIONS(1696),
    [anon_sym___forceinline] = ACTIONS(1696),
    [anon_sym_thread_local] = ACTIONS(1696),
    [anon_sym___thread] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_constexpr] = ACTIONS(1696),
    [anon_sym_volatile] = ACTIONS(1696),
    [anon_sym_restrict] = ACTIONS(1696),
    [anon_sym___restrict__] = ACTIONS(1696),
    [anon_sym__Atomic] = ACTIONS(1696),
    [anon_sym__Noreturn] = ACTIONS(1696),
    [anon_sym_noreturn] = ACTIONS(1696),
    [sym_primitive_type] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_switch] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_goto] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_sizeof] = ACTIONS(1696),
    [anon_sym___alignof__] = ACTIONS(1696),
    [anon_sym___alignof] = ACTIONS(1696),
    [anon_sym__alignof] = ACTIONS(1696),
    [anon_sym_alignof] = ACTIONS(1696),
    [anon_sym__Alignof] = ACTIONS(1696),
    [anon_sym_offsetof] = ACTIONS(1696),
    [anon_sym__Generic] = ACTIONS(1696),
    [anon_sym_asm] = ACTIONS(1696),
    [anon_sym___asm__] = ACTIONS(1696),
    [sym_number_literal] = ACTIONS(1698),
    [anon_sym_L_SQUOTE] = ACTIONS(1698),
    [anon_sym_u_SQUOTE] = ACTIONS(1698),
    [anon_sym_U_SQUOTE] = ACTIONS(1698),
    [anon_sym_u8_SQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [anon_sym_L_DQUOTE] = ACTIONS(1698),
    [anon_sym_u_DQUOTE] = ACTIONS(1698),
    [anon_sym_U_DQUOTE] = ACTIONS(1698),
    [anon_sym_u8_DQUOTE] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [anon_sym_NULL] = ACTIONS(1696),
    [anon_sym_nullptr] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1696),
    [anon_sym_acquire] = ACTIONS(1696),
    [anon_sym_monitor] = ACTIONS(1696),
    [anon_sym_start] = ACTIONS(1696),
    [anon_sym_stop] = ACTIONS(1696),
  },
  [472] = {
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1637),
    [aux_sym_preproc_def_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token2] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1637),
    [sym_preproc_directive] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1639),
    [anon_sym_BANG] = ACTIONS(1639),
    [anon_sym_TILDE] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1637),
    [anon_sym_extern] = ACTIONS(1637),
    [anon_sym___attribute__] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1639),
    [anon_sym___declspec] = ACTIONS(1637),
    [anon_sym___cdecl] = ACTIONS(1637),
    [anon_sym___clrcall] = ACTIONS(1637),
    [anon_sym___stdcall] = ACTIONS(1637),
    [anon_sym___fastcall] = ACTIONS(1637),
    [anon_sym___thiscall] = ACTIONS(1637),
    [anon_sym___vectorcall] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1637),
    [anon_sym_unsigned] = ACTIONS(1637),
    [anon_sym_long] = ACTIONS(1637),
    [anon_sym_short] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1637),
    [anon_sym_auto] = ACTIONS(1637),
    [anon_sym_register] = ACTIONS(1637),
    [anon_sym_inline] = ACTIONS(1637),
    [anon_sym___inline] = ACTIONS(1637),
    [anon_sym___inline__] = ACTIONS(1637),
    [anon_sym___forceinline] = ACTIONS(1637),
    [anon_sym_thread_local] = ACTIONS(1637),
    [anon_sym___thread] = ACTIONS(1637),
    [anon_sym_const] = ACTIONS(1637),
    [anon_sym_constexpr] = ACTIONS(1637),
    [anon_sym_volatile] = ACTIONS(1637),
    [anon_sym_restrict] = ACTIONS(1637),
    [anon_sym___restrict__] = ACTIONS(1637),
    [anon_sym__Atomic] = ACTIONS(1637),
    [anon_sym__Noreturn] = ACTIONS(1637),
    [anon_sym_noreturn] = ACTIONS(1637),
    [sym_primitive_type] = ACTIONS(1637),
    [anon_sym_enum] = ACTIONS(1637),
    [anon_sym_struct] = ACTIONS(1637),
    [anon_sym_union] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1637),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1637),
    [anon_sym_default] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1637),
    [anon_sym_do] = ACTIONS(1637),
    [anon_sym_for] = ACTIONS(1637),
    [anon_sym_return] = ACTIONS(1637),
    [anon_sym_break] = ACTIONS(1637),
    [anon_sym_continue] = ACTIONS(1637),
    [anon_sym_goto] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1637),
    [anon_sym___alignof__] = ACTIONS(1637),
    [anon_sym___alignof] = ACTIONS(1637),
    [anon_sym__alignof] = ACTIONS(1637),
    [anon_sym_alignof] = ACTIONS(1637),
    [anon_sym__Alignof] = ACTIONS(1637),
    [anon_sym_offsetof] = ACTIONS(1637),
    [anon_sym__Generic] = ACTIONS(1637),
    [anon_sym_asm] = ACTIONS(1637),
    [anon_sym___asm__] = ACTIONS(1637),
    [sym_number_literal] = ACTIONS(1639),
    [anon_sym_L_SQUOTE] = ACTIONS(1639),
    [anon_sym_u_SQUOTE] = ACTIONS(1639),
    [anon_sym_U_SQUOTE] = ACTIONS(1639),
    [anon_sym_u8_SQUOTE] = ACTIONS(1639),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [anon_sym_L_DQUOTE] = ACTIONS(1639),
    [anon_sym_u_DQUOTE] = ACTIONS(1639),
    [anon_sym_U_DQUOTE] = ACTIONS(1639),
    [anon_sym_u8_DQUOTE] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [anon_sym_NULL] = ACTIONS(1637),
    [anon_sym_nullptr] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1637),
    [anon_sym_acquire] = ACTIONS(1637),
    [anon_sym_monitor] = ACTIONS(1637),
    [anon_sym_start] = ACTIONS(1637),
    [anon_sym_stop] = ACTIONS(1637),
  },
  [473] = {
    [sym_identifier] = ACTIONS(1696),
    [aux_sym_preproc_include_token1] = ACTIONS(1696),
    [aux_sym_preproc_def_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1696),
    [sym_preproc_directive] = ACTIONS(1696),
    [anon_sym_LPAREN2] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym___extension__] = ACTIONS(1696),
    [anon_sym_typedef] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym___attribute__] = ACTIONS(1696),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1698),
    [anon_sym___declspec] = ACTIONS(1696),
    [anon_sym___cdecl] = ACTIONS(1696),
    [anon_sym___clrcall] = ACTIONS(1696),
    [anon_sym___stdcall] = ACTIONS(1696),
    [anon_sym___fastcall] = ACTIONS(1696),
    [anon_sym___thiscall] = ACTIONS(1696),
    [anon_sym___vectorcall] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_signed] = ACTIONS(1696),
    [anon_sym_unsigned] = ACTIONS(1696),
    [anon_sym_long] = ACTIONS(1696),
    [anon_sym_short] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_auto] = ACTIONS(1696),
    [anon_sym_register] = ACTIONS(1696),
    [anon_sym_inline] = ACTIONS(1696),
    [anon_sym___inline] = ACTIONS(1696),
    [anon_sym___inline__] = ACTIONS(1696),
    [anon_sym___forceinline] = ACTIONS(1696),
    [anon_sym_thread_local] = ACTIONS(1696),
    [anon_sym___thread] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_constexpr] = ACTIONS(1696),
    [anon_sym_volatile] = ACTIONS(1696),
    [anon_sym_restrict] = ACTIONS(1696),
    [anon_sym___restrict__] = ACTIONS(1696),
    [anon_sym__Atomic] = ACTIONS(1696),
    [anon_sym__Noreturn] = ACTIONS(1696),
    [anon_sym_noreturn] = ACTIONS(1696),
    [sym_primitive_type] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_switch] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_goto] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_sizeof] = ACTIONS(1696),
    [anon_sym___alignof__] = ACTIONS(1696),
    [anon_sym___alignof] = ACTIONS(1696),
    [anon_sym__alignof] = ACTIONS(1696),
    [anon_sym_alignof] = ACTIONS(1696),
    [anon_sym__Alignof] = ACTIONS(1696),
    [anon_sym_offsetof] = ACTIONS(1696),
    [anon_sym__Generic] = ACTIONS(1696),
    [anon_sym_asm] = ACTIONS(1696),
    [anon_sym___asm__] = ACTIONS(1696),
    [sym_number_literal] = ACTIONS(1698),
    [anon_sym_L_SQUOTE] = ACTIONS(1698),
    [anon_sym_u_SQUOTE] = ACTIONS(1698),
    [anon_sym_U_SQUOTE] = ACTIONS(1698),
    [anon_sym_u8_SQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [anon_sym_L_DQUOTE] = ACTIONS(1698),
    [anon_sym_u_DQUOTE] = ACTIONS(1698),
    [anon_sym_U_DQUOTE] = ACTIONS(1698),
    [anon_sym_u8_DQUOTE] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [anon_sym_NULL] = ACTIONS(1696),
    [anon_sym_nullptr] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1696),
    [anon_sym_acquire] = ACTIONS(1696),
    [anon_sym_monitor] = ACTIONS(1696),
    [anon_sym_start] = ACTIONS(1696),
    [anon_sym_stop] = ACTIONS(1696),
  },
  [474] = {
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1637),
    [aux_sym_preproc_def_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1637),
    [sym_preproc_directive] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1639),
    [anon_sym_BANG] = ACTIONS(1639),
    [anon_sym_TILDE] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1637),
    [anon_sym_extern] = ACTIONS(1637),
    [anon_sym___attribute__] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1639),
    [anon_sym___declspec] = ACTIONS(1637),
    [anon_sym___cdecl] = ACTIONS(1637),
    [anon_sym___clrcall] = ACTIONS(1637),
    [anon_sym___stdcall] = ACTIONS(1637),
    [anon_sym___fastcall] = ACTIONS(1637),
    [anon_sym___thiscall] = ACTIONS(1637),
    [anon_sym___vectorcall] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_RBRACE] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1637),
    [anon_sym_unsigned] = ACTIONS(1637),
    [anon_sym_long] = ACTIONS(1637),
    [anon_sym_short] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1637),
    [anon_sym_auto] = ACTIONS(1637),
    [anon_sym_register] = ACTIONS(1637),
    [anon_sym_inline] = ACTIONS(1637),
    [anon_sym___inline] = ACTIONS(1637),
    [anon_sym___inline__] = ACTIONS(1637),
    [anon_sym___forceinline] = ACTIONS(1637),
    [anon_sym_thread_local] = ACTIONS(1637),
    [anon_sym___thread] = ACTIONS(1637),
    [anon_sym_const] = ACTIONS(1637),
    [anon_sym_constexpr] = ACTIONS(1637),
    [anon_sym_volatile] = ACTIONS(1637),
    [anon_sym_restrict] = ACTIONS(1637),
    [anon_sym___restrict__] = ACTIONS(1637),
    [anon_sym__Atomic] = ACTIONS(1637),
    [anon_sym__Noreturn] = ACTIONS(1637),
    [anon_sym_noreturn] = ACTIONS(1637),
    [sym_primitive_type] = ACTIONS(1637),
    [anon_sym_enum] = ACTIONS(1637),
    [anon_sym_struct] = ACTIONS(1637),
    [anon_sym_union] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1637),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1637),
    [anon_sym_default] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1637),
    [anon_sym_do] = ACTIONS(1637),
    [anon_sym_for] = ACTIONS(1637),
    [anon_sym_return] = ACTIONS(1637),
    [anon_sym_break] = ACTIONS(1637),
    [anon_sym_continue] = ACTIONS(1637),
    [anon_sym_goto] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1637),
    [anon_sym___alignof__] = ACTIONS(1637),
    [anon_sym___alignof] = ACTIONS(1637),
    [anon_sym__alignof] = ACTIONS(1637),
    [anon_sym_alignof] = ACTIONS(1637),
    [anon_sym__Alignof] = ACTIONS(1637),
    [anon_sym_offsetof] = ACTIONS(1637),
    [anon_sym__Generic] = ACTIONS(1637),
    [anon_sym_asm] = ACTIONS(1637),
    [anon_sym___asm__] = ACTIONS(1637),
    [sym_number_literal] = ACTIONS(1639),
    [anon_sym_L_SQUOTE] = ACTIONS(1639),
    [anon_sym_u_SQUOTE] = ACTIONS(1639),
    [anon_sym_U_SQUOTE] = ACTIONS(1639),
    [anon_sym_u8_SQUOTE] = ACTIONS(1639),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [anon_sym_L_DQUOTE] = ACTIONS(1639),
    [anon_sym_u_DQUOTE] = ACTIONS(1639),
    [anon_sym_U_DQUOTE] = ACTIONS(1639),
    [anon_sym_u8_DQUOTE] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [anon_sym_NULL] = ACTIONS(1637),
    [anon_sym_nullptr] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1637),
    [anon_sym_acquire] = ACTIONS(1637),
    [anon_sym_monitor] = ACTIONS(1637),
    [anon_sym_start] = ACTIONS(1637),
    [anon_sym_stop] = ACTIONS(1637),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(1613),
    [sym_identifier] = ACTIONS(1611),
    [aux_sym_preproc_include_token1] = ACTIONS(1611),
    [aux_sym_preproc_def_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1611),
    [sym_preproc_directive] = ACTIONS(1611),
    [anon_sym_LPAREN2] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym___extension__] = ACTIONS(1611),
    [anon_sym_typedef] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym___attribute__] = ACTIONS(1611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1613),
    [anon_sym___declspec] = ACTIONS(1611),
    [anon_sym___cdecl] = ACTIONS(1611),
    [anon_sym___clrcall] = ACTIONS(1611),
    [anon_sym___stdcall] = ACTIONS(1611),
    [anon_sym___fastcall] = ACTIONS(1611),
    [anon_sym___thiscall] = ACTIONS(1611),
    [anon_sym___vectorcall] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_signed] = ACTIONS(1611),
    [anon_sym_unsigned] = ACTIONS(1611),
    [anon_sym_long] = ACTIONS(1611),
    [anon_sym_short] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_auto] = ACTIONS(1611),
    [anon_sym_register] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym___inline] = ACTIONS(1611),
    [anon_sym___inline__] = ACTIONS(1611),
    [anon_sym___forceinline] = ACTIONS(1611),
    [anon_sym_thread_local] = ACTIONS(1611),
    [anon_sym___thread] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_constexpr] = ACTIONS(1611),
    [anon_sym_volatile] = ACTIONS(1611),
    [anon_sym_restrict] = ACTIONS(1611),
    [anon_sym___restrict__] = ACTIONS(1611),
    [anon_sym__Atomic] = ACTIONS(1611),
    [anon_sym__Noreturn] = ACTIONS(1611),
    [anon_sym_noreturn] = ACTIONS(1611),
    [sym_primitive_type] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_goto] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_sizeof] = ACTIONS(1611),
    [anon_sym___alignof__] = ACTIONS(1611),
    [anon_sym___alignof] = ACTIONS(1611),
    [anon_sym__alignof] = ACTIONS(1611),
    [anon_sym_alignof] = ACTIONS(1611),
    [anon_sym__Alignof] = ACTIONS(1611),
    [anon_sym_offsetof] = ACTIONS(1611),
    [anon_sym__Generic] = ACTIONS(1611),
    [anon_sym_asm] = ACTIONS(1611),
    [anon_sym___asm__] = ACTIONS(1611),
    [sym_number_literal] = ACTIONS(1613),
    [anon_sym_L_SQUOTE] = ACTIONS(1613),
    [anon_sym_u_SQUOTE] = ACTIONS(1613),
    [anon_sym_U_SQUOTE] = ACTIONS(1613),
    [anon_sym_u8_SQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_L_DQUOTE] = ACTIONS(1613),
    [anon_sym_u_DQUOTE] = ACTIONS(1613),
    [anon_sym_U_DQUOTE] = ACTIONS(1613),
    [anon_sym_u8_DQUOTE] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [sym_true] = ACTIONS(1611),
    [sym_false] = ACTIONS(1611),
    [anon_sym_NULL] = ACTIONS(1611),
    [anon_sym_nullptr] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1611),
    [anon_sym_until] = ACTIONS(1611),
    [anon_sym_acquire] = ACTIONS(1611),
    [anon_sym_monitor] = ACTIONS(1611),
    [anon_sym_start] = ACTIONS(1611),
    [anon_sym_stop] = ACTIONS(1611),
  },
  [476] = {
    [sym_identifier] = ACTIONS(1644),
    [aux_sym_preproc_include_token1] = ACTIONS(1644),
    [aux_sym_preproc_def_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_LPAREN2] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym___extension__] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym___attribute__] = ACTIONS(1644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1646),
    [anon_sym___declspec] = ACTIONS(1644),
    [anon_sym___cdecl] = ACTIONS(1644),
    [anon_sym___clrcall] = ACTIONS(1644),
    [anon_sym___stdcall] = ACTIONS(1644),
    [anon_sym___fastcall] = ACTIONS(1644),
    [anon_sym___thiscall] = ACTIONS(1644),
    [anon_sym___vectorcall] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [anon_sym_signed] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym___inline] = ACTIONS(1644),
    [anon_sym___inline__] = ACTIONS(1644),
    [anon_sym___forceinline] = ACTIONS(1644),
    [anon_sym_thread_local] = ACTIONS(1644),
    [anon_sym___thread] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_constexpr] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym___restrict__] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym__Noreturn] = ACTIONS(1644),
    [anon_sym_noreturn] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1646),
    [anon_sym_sizeof] = ACTIONS(1644),
    [anon_sym___alignof__] = ACTIONS(1644),
    [anon_sym___alignof] = ACTIONS(1644),
    [anon_sym__alignof] = ACTIONS(1644),
    [anon_sym_alignof] = ACTIONS(1644),
    [anon_sym__Alignof] = ACTIONS(1644),
    [anon_sym_offsetof] = ACTIONS(1644),
    [anon_sym__Generic] = ACTIONS(1644),
    [anon_sym_asm] = ACTIONS(1644),
    [anon_sym___asm__] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1646),
    [anon_sym_L_SQUOTE] = ACTIONS(1646),
    [anon_sym_u_SQUOTE] = ACTIONS(1646),
    [anon_sym_U_SQUOTE] = ACTIONS(1646),
    [anon_sym_u8_SQUOTE] = ACTIONS(1646),
    [anon_sym_SQUOTE] = ACTIONS(1646),
    [anon_sym_L_DQUOTE] = ACTIONS(1646),
    [anon_sym_u_DQUOTE] = ACTIONS(1646),
    [anon_sym_U_DQUOTE] = ACTIONS(1646),
    [anon_sym_u8_DQUOTE] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1646),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [anon_sym_NULL] = ACTIONS(1644),
    [anon_sym_nullptr] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1644),
    [anon_sym_acquire] = ACTIONS(1644),
    [anon_sym_monitor] = ACTIONS(1644),
    [anon_sym_start] = ACTIONS(1644),
    [anon_sym_stop] = ACTIONS(1644),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(1607),
    [sym_identifier] = ACTIONS(1605),
    [aux_sym_preproc_include_token1] = ACTIONS(1605),
    [aux_sym_preproc_def_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1605),
    [sym_preproc_directive] = ACTIONS(1605),
    [anon_sym_LPAREN2] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym___extension__] = ACTIONS(1605),
    [anon_sym_typedef] = ACTIONS(1605),
    [anon_sym_extern] = ACTIONS(1605),
    [anon_sym___attribute__] = ACTIONS(1605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1607),
    [anon_sym___declspec] = ACTIONS(1605),
    [anon_sym___cdecl] = ACTIONS(1605),
    [anon_sym___clrcall] = ACTIONS(1605),
    [anon_sym___stdcall] = ACTIONS(1605),
    [anon_sym___fastcall] = ACTIONS(1605),
    [anon_sym___thiscall] = ACTIONS(1605),
    [anon_sym___vectorcall] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_signed] = ACTIONS(1605),
    [anon_sym_unsigned] = ACTIONS(1605),
    [anon_sym_long] = ACTIONS(1605),
    [anon_sym_short] = ACTIONS(1605),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_auto] = ACTIONS(1605),
    [anon_sym_register] = ACTIONS(1605),
    [anon_sym_inline] = ACTIONS(1605),
    [anon_sym___inline] = ACTIONS(1605),
    [anon_sym___inline__] = ACTIONS(1605),
    [anon_sym___forceinline] = ACTIONS(1605),
    [anon_sym_thread_local] = ACTIONS(1605),
    [anon_sym___thread] = ACTIONS(1605),
    [anon_sym_const] = ACTIONS(1605),
    [anon_sym_constexpr] = ACTIONS(1605),
    [anon_sym_volatile] = ACTIONS(1605),
    [anon_sym_restrict] = ACTIONS(1605),
    [anon_sym___restrict__] = ACTIONS(1605),
    [anon_sym__Atomic] = ACTIONS(1605),
    [anon_sym__Noreturn] = ACTIONS(1605),
    [anon_sym_noreturn] = ACTIONS(1605),
    [sym_primitive_type] = ACTIONS(1605),
    [anon_sym_enum] = ACTIONS(1605),
    [anon_sym_struct] = ACTIONS(1605),
    [anon_sym_union] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1605),
    [anon_sym_switch] = ACTIONS(1605),
    [anon_sym_case] = ACTIONS(1605),
    [anon_sym_default] = ACTIONS(1605),
    [anon_sym_while] = ACTIONS(1605),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_for] = ACTIONS(1605),
    [anon_sym_return] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1605),
    [anon_sym_goto] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_sizeof] = ACTIONS(1605),
    [anon_sym___alignof__] = ACTIONS(1605),
    [anon_sym___alignof] = ACTIONS(1605),
    [anon_sym__alignof] = ACTIONS(1605),
    [anon_sym_alignof] = ACTIONS(1605),
    [anon_sym__Alignof] = ACTIONS(1605),
    [anon_sym_offsetof] = ACTIONS(1605),
    [anon_sym__Generic] = ACTIONS(1605),
    [anon_sym_asm] = ACTIONS(1605),
    [anon_sym___asm__] = ACTIONS(1605),
    [sym_number_literal] = ACTIONS(1607),
    [anon_sym_L_SQUOTE] = ACTIONS(1607),
    [anon_sym_u_SQUOTE] = ACTIONS(1607),
    [anon_sym_U_SQUOTE] = ACTIONS(1607),
    [anon_sym_u8_SQUOTE] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [anon_sym_L_DQUOTE] = ACTIONS(1607),
    [anon_sym_u_DQUOTE] = ACTIONS(1607),
    [anon_sym_U_DQUOTE] = ACTIONS(1607),
    [anon_sym_u8_DQUOTE] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [anon_sym_NULL] = ACTIONS(1605),
    [anon_sym_nullptr] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1605),
    [anon_sym_until] = ACTIONS(1605),
    [anon_sym_acquire] = ACTIONS(1605),
    [anon_sym_monitor] = ACTIONS(1605),
    [anon_sym_start] = ACTIONS(1605),
    [anon_sym_stop] = ACTIONS(1605),
  },
  [478] = {
    [sym_identifier] = ACTIONS(1660),
    [aux_sym_preproc_include_token1] = ACTIONS(1660),
    [aux_sym_preproc_def_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1660),
    [sym_preproc_directive] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_TILDE] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1660),
    [anon_sym_typedef] = ACTIONS(1660),
    [anon_sym_extern] = ACTIONS(1660),
    [anon_sym___attribute__] = ACTIONS(1660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1662),
    [anon_sym___declspec] = ACTIONS(1660),
    [anon_sym___cdecl] = ACTIONS(1660),
    [anon_sym___clrcall] = ACTIONS(1660),
    [anon_sym___stdcall] = ACTIONS(1660),
    [anon_sym___fastcall] = ACTIONS(1660),
    [anon_sym___thiscall] = ACTIONS(1660),
    [anon_sym___vectorcall] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_signed] = ACTIONS(1660),
    [anon_sym_unsigned] = ACTIONS(1660),
    [anon_sym_long] = ACTIONS(1660),
    [anon_sym_short] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_auto] = ACTIONS(1660),
    [anon_sym_register] = ACTIONS(1660),
    [anon_sym_inline] = ACTIONS(1660),
    [anon_sym___inline] = ACTIONS(1660),
    [anon_sym___inline__] = ACTIONS(1660),
    [anon_sym___forceinline] = ACTIONS(1660),
    [anon_sym_thread_local] = ACTIONS(1660),
    [anon_sym___thread] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1660),
    [anon_sym_constexpr] = ACTIONS(1660),
    [anon_sym_volatile] = ACTIONS(1660),
    [anon_sym_restrict] = ACTIONS(1660),
    [anon_sym___restrict__] = ACTIONS(1660),
    [anon_sym__Atomic] = ACTIONS(1660),
    [anon_sym__Noreturn] = ACTIONS(1660),
    [anon_sym_noreturn] = ACTIONS(1660),
    [sym_primitive_type] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1660),
    [anon_sym_struct] = ACTIONS(1660),
    [anon_sym_union] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1660),
    [anon_sym_switch] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1660),
    [anon_sym_default] = ACTIONS(1660),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_return] = ACTIONS(1660),
    [anon_sym_break] = ACTIONS(1660),
    [anon_sym_continue] = ACTIONS(1660),
    [anon_sym_goto] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1662),
    [anon_sym_sizeof] = ACTIONS(1660),
    [anon_sym___alignof__] = ACTIONS(1660),
    [anon_sym___alignof] = ACTIONS(1660),
    [anon_sym__alignof] = ACTIONS(1660),
    [anon_sym_alignof] = ACTIONS(1660),
    [anon_sym__Alignof] = ACTIONS(1660),
    [anon_sym_offsetof] = ACTIONS(1660),
    [anon_sym__Generic] = ACTIONS(1660),
    [anon_sym_asm] = ACTIONS(1660),
    [anon_sym___asm__] = ACTIONS(1660),
    [sym_number_literal] = ACTIONS(1662),
    [anon_sym_L_SQUOTE] = ACTIONS(1662),
    [anon_sym_u_SQUOTE] = ACTIONS(1662),
    [anon_sym_U_SQUOTE] = ACTIONS(1662),
    [anon_sym_u8_SQUOTE] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1662),
    [anon_sym_L_DQUOTE] = ACTIONS(1662),
    [anon_sym_u_DQUOTE] = ACTIONS(1662),
    [anon_sym_U_DQUOTE] = ACTIONS(1662),
    [anon_sym_u8_DQUOTE] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [sym_true] = ACTIONS(1660),
    [sym_false] = ACTIONS(1660),
    [anon_sym_NULL] = ACTIONS(1660),
    [anon_sym_nullptr] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1660),
    [anon_sym_acquire] = ACTIONS(1660),
    [anon_sym_monitor] = ACTIONS(1660),
    [anon_sym_start] = ACTIONS(1660),
    [anon_sym_stop] = ACTIONS(1660),
  },
  [479] = {
    [sym_identifier] = ACTIONS(1652),
    [aux_sym_preproc_include_token1] = ACTIONS(1652),
    [aux_sym_preproc_def_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token2] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1652),
    [sym_preproc_directive] = ACTIONS(1652),
    [anon_sym_LPAREN2] = ACTIONS(1654),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym___extension__] = ACTIONS(1652),
    [anon_sym_typedef] = ACTIONS(1652),
    [anon_sym_extern] = ACTIONS(1652),
    [anon_sym___attribute__] = ACTIONS(1652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1654),
    [anon_sym___declspec] = ACTIONS(1652),
    [anon_sym___cdecl] = ACTIONS(1652),
    [anon_sym___clrcall] = ACTIONS(1652),
    [anon_sym___stdcall] = ACTIONS(1652),
    [anon_sym___fastcall] = ACTIONS(1652),
    [anon_sym___thiscall] = ACTIONS(1652),
    [anon_sym___vectorcall] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_signed] = ACTIONS(1652),
    [anon_sym_unsigned] = ACTIONS(1652),
    [anon_sym_long] = ACTIONS(1652),
    [anon_sym_short] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_auto] = ACTIONS(1652),
    [anon_sym_register] = ACTIONS(1652),
    [anon_sym_inline] = ACTIONS(1652),
    [anon_sym___inline] = ACTIONS(1652),
    [anon_sym___inline__] = ACTIONS(1652),
    [anon_sym___forceinline] = ACTIONS(1652),
    [anon_sym_thread_local] = ACTIONS(1652),
    [anon_sym___thread] = ACTIONS(1652),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_constexpr] = ACTIONS(1652),
    [anon_sym_volatile] = ACTIONS(1652),
    [anon_sym_restrict] = ACTIONS(1652),
    [anon_sym___restrict__] = ACTIONS(1652),
    [anon_sym__Atomic] = ACTIONS(1652),
    [anon_sym__Noreturn] = ACTIONS(1652),
    [anon_sym_noreturn] = ACTIONS(1652),
    [sym_primitive_type] = ACTIONS(1652),
    [anon_sym_enum] = ACTIONS(1652),
    [anon_sym_struct] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_if] = ACTIONS(1652),
    [anon_sym_switch] = ACTIONS(1652),
    [anon_sym_case] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_while] = ACTIONS(1652),
    [anon_sym_do] = ACTIONS(1652),
    [anon_sym_for] = ACTIONS(1652),
    [anon_sym_return] = ACTIONS(1652),
    [anon_sym_break] = ACTIONS(1652),
    [anon_sym_continue] = ACTIONS(1652),
    [anon_sym_goto] = ACTIONS(1652),
    [anon_sym_DASH_DASH] = ACTIONS(1654),
    [anon_sym_PLUS_PLUS] = ACTIONS(1654),
    [anon_sym_sizeof] = ACTIONS(1652),
    [anon_sym___alignof__] = ACTIONS(1652),
    [anon_sym___alignof] = ACTIONS(1652),
    [anon_sym__alignof] = ACTIONS(1652),
    [anon_sym_alignof] = ACTIONS(1652),
    [anon_sym__Alignof] = ACTIONS(1652),
    [anon_sym_offsetof] = ACTIONS(1652),
    [anon_sym__Generic] = ACTIONS(1652),
    [anon_sym_asm] = ACTIONS(1652),
    [anon_sym___asm__] = ACTIONS(1652),
    [sym_number_literal] = ACTIONS(1654),
    [anon_sym_L_SQUOTE] = ACTIONS(1654),
    [anon_sym_u_SQUOTE] = ACTIONS(1654),
    [anon_sym_U_SQUOTE] = ACTIONS(1654),
    [anon_sym_u8_SQUOTE] = ACTIONS(1654),
    [anon_sym_SQUOTE] = ACTIONS(1654),
    [anon_sym_L_DQUOTE] = ACTIONS(1654),
    [anon_sym_u_DQUOTE] = ACTIONS(1654),
    [anon_sym_U_DQUOTE] = ACTIONS(1654),
    [anon_sym_u8_DQUOTE] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [sym_true] = ACTIONS(1652),
    [sym_false] = ACTIONS(1652),
    [anon_sym_NULL] = ACTIONS(1652),
    [anon_sym_nullptr] = ACTIONS(1652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1652),
    [anon_sym_acquire] = ACTIONS(1652),
    [anon_sym_monitor] = ACTIONS(1652),
    [anon_sym_start] = ACTIONS(1652),
    [anon_sym_stop] = ACTIONS(1652),
  },
  [480] = {
    [sym_identifier] = ACTIONS(1660),
    [aux_sym_preproc_include_token1] = ACTIONS(1660),
    [aux_sym_preproc_def_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token2] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1660),
    [sym_preproc_directive] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_TILDE] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1660),
    [anon_sym_typedef] = ACTIONS(1660),
    [anon_sym_extern] = ACTIONS(1660),
    [anon_sym___attribute__] = ACTIONS(1660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1662),
    [anon_sym___declspec] = ACTIONS(1660),
    [anon_sym___cdecl] = ACTIONS(1660),
    [anon_sym___clrcall] = ACTIONS(1660),
    [anon_sym___stdcall] = ACTIONS(1660),
    [anon_sym___fastcall] = ACTIONS(1660),
    [anon_sym___thiscall] = ACTIONS(1660),
    [anon_sym___vectorcall] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_signed] = ACTIONS(1660),
    [anon_sym_unsigned] = ACTIONS(1660),
    [anon_sym_long] = ACTIONS(1660),
    [anon_sym_short] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_auto] = ACTIONS(1660),
    [anon_sym_register] = ACTIONS(1660),
    [anon_sym_inline] = ACTIONS(1660),
    [anon_sym___inline] = ACTIONS(1660),
    [anon_sym___inline__] = ACTIONS(1660),
    [anon_sym___forceinline] = ACTIONS(1660),
    [anon_sym_thread_local] = ACTIONS(1660),
    [anon_sym___thread] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1660),
    [anon_sym_constexpr] = ACTIONS(1660),
    [anon_sym_volatile] = ACTIONS(1660),
    [anon_sym_restrict] = ACTIONS(1660),
    [anon_sym___restrict__] = ACTIONS(1660),
    [anon_sym__Atomic] = ACTIONS(1660),
    [anon_sym__Noreturn] = ACTIONS(1660),
    [anon_sym_noreturn] = ACTIONS(1660),
    [sym_primitive_type] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1660),
    [anon_sym_struct] = ACTIONS(1660),
    [anon_sym_union] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1660),
    [anon_sym_switch] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1660),
    [anon_sym_default] = ACTIONS(1660),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_return] = ACTIONS(1660),
    [anon_sym_break] = ACTIONS(1660),
    [anon_sym_continue] = ACTIONS(1660),
    [anon_sym_goto] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1662),
    [anon_sym_sizeof] = ACTIONS(1660),
    [anon_sym___alignof__] = ACTIONS(1660),
    [anon_sym___alignof] = ACTIONS(1660),
    [anon_sym__alignof] = ACTIONS(1660),
    [anon_sym_alignof] = ACTIONS(1660),
    [anon_sym__Alignof] = ACTIONS(1660),
    [anon_sym_offsetof] = ACTIONS(1660),
    [anon_sym__Generic] = ACTIONS(1660),
    [anon_sym_asm] = ACTIONS(1660),
    [anon_sym___asm__] = ACTIONS(1660),
    [sym_number_literal] = ACTIONS(1662),
    [anon_sym_L_SQUOTE] = ACTIONS(1662),
    [anon_sym_u_SQUOTE] = ACTIONS(1662),
    [anon_sym_U_SQUOTE] = ACTIONS(1662),
    [anon_sym_u8_SQUOTE] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1662),
    [anon_sym_L_DQUOTE] = ACTIONS(1662),
    [anon_sym_u_DQUOTE] = ACTIONS(1662),
    [anon_sym_U_DQUOTE] = ACTIONS(1662),
    [anon_sym_u8_DQUOTE] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [sym_true] = ACTIONS(1660),
    [sym_false] = ACTIONS(1660),
    [anon_sym_NULL] = ACTIONS(1660),
    [anon_sym_nullptr] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1660),
    [anon_sym_acquire] = ACTIONS(1660),
    [anon_sym_monitor] = ACTIONS(1660),
    [anon_sym_start] = ACTIONS(1660),
    [anon_sym_stop] = ACTIONS(1660),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1601),
    [aux_sym_preproc_include_token1] = ACTIONS(1601),
    [aux_sym_preproc_def_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1601),
    [sym_preproc_directive] = ACTIONS(1601),
    [anon_sym_LPAREN2] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym___extension__] = ACTIONS(1601),
    [anon_sym_typedef] = ACTIONS(1601),
    [anon_sym_extern] = ACTIONS(1601),
    [anon_sym___attribute__] = ACTIONS(1601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1603),
    [anon_sym___declspec] = ACTIONS(1601),
    [anon_sym___cdecl] = ACTIONS(1601),
    [anon_sym___clrcall] = ACTIONS(1601),
    [anon_sym___stdcall] = ACTIONS(1601),
    [anon_sym___fastcall] = ACTIONS(1601),
    [anon_sym___thiscall] = ACTIONS(1601),
    [anon_sym___vectorcall] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_signed] = ACTIONS(1601),
    [anon_sym_unsigned] = ACTIONS(1601),
    [anon_sym_long] = ACTIONS(1601),
    [anon_sym_short] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1601),
    [anon_sym_auto] = ACTIONS(1601),
    [anon_sym_register] = ACTIONS(1601),
    [anon_sym_inline] = ACTIONS(1601),
    [anon_sym___inline] = ACTIONS(1601),
    [anon_sym___inline__] = ACTIONS(1601),
    [anon_sym___forceinline] = ACTIONS(1601),
    [anon_sym_thread_local] = ACTIONS(1601),
    [anon_sym___thread] = ACTIONS(1601),
    [anon_sym_const] = ACTIONS(1601),
    [anon_sym_constexpr] = ACTIONS(1601),
    [anon_sym_volatile] = ACTIONS(1601),
    [anon_sym_restrict] = ACTIONS(1601),
    [anon_sym___restrict__] = ACTIONS(1601),
    [anon_sym__Atomic] = ACTIONS(1601),
    [anon_sym__Noreturn] = ACTIONS(1601),
    [anon_sym_noreturn] = ACTIONS(1601),
    [sym_primitive_type] = ACTIONS(1601),
    [anon_sym_enum] = ACTIONS(1601),
    [anon_sym_struct] = ACTIONS(1601),
    [anon_sym_union] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_switch] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_while] = ACTIONS(1601),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1601),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1601),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_goto] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_sizeof] = ACTIONS(1601),
    [anon_sym___alignof__] = ACTIONS(1601),
    [anon_sym___alignof] = ACTIONS(1601),
    [anon_sym__alignof] = ACTIONS(1601),
    [anon_sym_alignof] = ACTIONS(1601),
    [anon_sym__Alignof] = ACTIONS(1601),
    [anon_sym_offsetof] = ACTIONS(1601),
    [anon_sym__Generic] = ACTIONS(1601),
    [anon_sym_asm] = ACTIONS(1601),
    [anon_sym___asm__] = ACTIONS(1601),
    [sym_number_literal] = ACTIONS(1603),
    [anon_sym_L_SQUOTE] = ACTIONS(1603),
    [anon_sym_u_SQUOTE] = ACTIONS(1603),
    [anon_sym_U_SQUOTE] = ACTIONS(1603),
    [anon_sym_u8_SQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [anon_sym_L_DQUOTE] = ACTIONS(1603),
    [anon_sym_u_DQUOTE] = ACTIONS(1603),
    [anon_sym_U_DQUOTE] = ACTIONS(1603),
    [anon_sym_u8_DQUOTE] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [anon_sym_NULL] = ACTIONS(1601),
    [anon_sym_nullptr] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1601),
    [anon_sym_until] = ACTIONS(1601),
    [anon_sym_acquire] = ACTIONS(1601),
    [anon_sym_monitor] = ACTIONS(1601),
    [anon_sym_start] = ACTIONS(1601),
    [anon_sym_stop] = ACTIONS(1601),
  },
  [482] = {
    [sym_identifier] = ACTIONS(1676),
    [aux_sym_preproc_include_token1] = ACTIONS(1676),
    [aux_sym_preproc_def_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1676),
    [sym_preproc_directive] = ACTIONS(1676),
    [anon_sym_LPAREN2] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym___extension__] = ACTIONS(1676),
    [anon_sym_typedef] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym___attribute__] = ACTIONS(1676),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1678),
    [anon_sym___declspec] = ACTIONS(1676),
    [anon_sym___cdecl] = ACTIONS(1676),
    [anon_sym___clrcall] = ACTIONS(1676),
    [anon_sym___stdcall] = ACTIONS(1676),
    [anon_sym___fastcall] = ACTIONS(1676),
    [anon_sym___thiscall] = ACTIONS(1676),
    [anon_sym___vectorcall] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_RBRACE] = ACTIONS(1678),
    [anon_sym_signed] = ACTIONS(1676),
    [anon_sym_unsigned] = ACTIONS(1676),
    [anon_sym_long] = ACTIONS(1676),
    [anon_sym_short] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_auto] = ACTIONS(1676),
    [anon_sym_register] = ACTIONS(1676),
    [anon_sym_inline] = ACTIONS(1676),
    [anon_sym___inline] = ACTIONS(1676),
    [anon_sym___inline__] = ACTIONS(1676),
    [anon_sym___forceinline] = ACTIONS(1676),
    [anon_sym_thread_local] = ACTIONS(1676),
    [anon_sym___thread] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_constexpr] = ACTIONS(1676),
    [anon_sym_volatile] = ACTIONS(1676),
    [anon_sym_restrict] = ACTIONS(1676),
    [anon_sym___restrict__] = ACTIONS(1676),
    [anon_sym__Atomic] = ACTIONS(1676),
    [anon_sym__Noreturn] = ACTIONS(1676),
    [anon_sym_noreturn] = ACTIONS(1676),
    [sym_primitive_type] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_switch] = ACTIONS(1676),
    [anon_sym_case] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_goto] = ACTIONS(1676),
    [anon_sym_DASH_DASH] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1678),
    [anon_sym_sizeof] = ACTIONS(1676),
    [anon_sym___alignof__] = ACTIONS(1676),
    [anon_sym___alignof] = ACTIONS(1676),
    [anon_sym__alignof] = ACTIONS(1676),
    [anon_sym_alignof] = ACTIONS(1676),
    [anon_sym__Alignof] = ACTIONS(1676),
    [anon_sym_offsetof] = ACTIONS(1676),
    [anon_sym__Generic] = ACTIONS(1676),
    [anon_sym_asm] = ACTIONS(1676),
    [anon_sym___asm__] = ACTIONS(1676),
    [sym_number_literal] = ACTIONS(1678),
    [anon_sym_L_SQUOTE] = ACTIONS(1678),
    [anon_sym_u_SQUOTE] = ACTIONS(1678),
    [anon_sym_U_SQUOTE] = ACTIONS(1678),
    [anon_sym_u8_SQUOTE] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1678),
    [anon_sym_L_DQUOTE] = ACTIONS(1678),
    [anon_sym_u_DQUOTE] = ACTIONS(1678),
    [anon_sym_U_DQUOTE] = ACTIONS(1678),
    [anon_sym_u8_DQUOTE] = ACTIONS(1678),
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [anon_sym_NULL] = ACTIONS(1676),
    [anon_sym_nullptr] = ACTIONS(1676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1676),
    [anon_sym_acquire] = ACTIONS(1676),
    [anon_sym_monitor] = ACTIONS(1676),
    [anon_sym_start] = ACTIONS(1676),
    [anon_sym_stop] = ACTIONS(1676),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [aux_sym_preproc_include_token1] = ACTIONS(2084),
    [aux_sym_preproc_def_token1] = ACTIONS(2084),
    [aux_sym_preproc_if_token1] = ACTIONS(2084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2084),
    [sym_preproc_directive] = ACTIONS(2084),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2082),
    [anon_sym___extension__] = ACTIONS(2084),
    [anon_sym_typedef] = ACTIONS(2084),
    [anon_sym_extern] = ACTIONS(2084),
    [anon_sym___attribute__] = ACTIONS(2084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2084),
    [anon_sym___cdecl] = ACTIONS(2084),
    [anon_sym___clrcall] = ACTIONS(2084),
    [anon_sym___stdcall] = ACTIONS(2084),
    [anon_sym___fastcall] = ACTIONS(2084),
    [anon_sym___thiscall] = ACTIONS(2084),
    [anon_sym___vectorcall] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_signed] = ACTIONS(2084),
    [anon_sym_unsigned] = ACTIONS(2084),
    [anon_sym_long] = ACTIONS(2084),
    [anon_sym_short] = ACTIONS(2084),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_auto] = ACTIONS(2084),
    [anon_sym_register] = ACTIONS(2084),
    [anon_sym_inline] = ACTIONS(2084),
    [anon_sym___inline] = ACTIONS(2084),
    [anon_sym___inline__] = ACTIONS(2084),
    [anon_sym___forceinline] = ACTIONS(2084),
    [anon_sym_thread_local] = ACTIONS(2084),
    [anon_sym___thread] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_constexpr] = ACTIONS(2084),
    [anon_sym_volatile] = ACTIONS(2084),
    [anon_sym_restrict] = ACTIONS(2084),
    [anon_sym___restrict__] = ACTIONS(2084),
    [anon_sym__Atomic] = ACTIONS(2084),
    [anon_sym__Noreturn] = ACTIONS(2084),
    [anon_sym_noreturn] = ACTIONS(2084),
    [sym_primitive_type] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
    [anon_sym_struct] = ACTIONS(2084),
    [anon_sym_union] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_goto] = ACTIONS(2084),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_sizeof] = ACTIONS(2084),
    [anon_sym___alignof__] = ACTIONS(2084),
    [anon_sym___alignof] = ACTIONS(2084),
    [anon_sym__alignof] = ACTIONS(2084),
    [anon_sym_alignof] = ACTIONS(2084),
    [anon_sym__Alignof] = ACTIONS(2084),
    [anon_sym_offsetof] = ACTIONS(2084),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2084),
    [anon_sym___asm__] = ACTIONS(2084),
    [sym_number_literal] = ACTIONS(2082),
    [anon_sym_L_SQUOTE] = ACTIONS(2082),
    [anon_sym_u_SQUOTE] = ACTIONS(2082),
    [anon_sym_U_SQUOTE] = ACTIONS(2082),
    [anon_sym_u8_SQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [anon_sym_L_DQUOTE] = ACTIONS(2082),
    [anon_sym_u_DQUOTE] = ACTIONS(2082),
    [anon_sym_U_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8_DQUOTE] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [anon_sym_NULL] = ACTIONS(2084),
    [anon_sym_nullptr] = ACTIONS(2084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(2084),
    [anon_sym_until] = ACTIONS(2084),
    [anon_sym_acquire] = ACTIONS(2084),
    [anon_sym_monitor] = ACTIONS(2084),
    [anon_sym_start] = ACTIONS(2084),
    [anon_sym_stop] = ACTIONS(2084),
  },
  [484] = {
    [sym_identifier] = ACTIONS(1672),
    [aux_sym_preproc_include_token1] = ACTIONS(1672),
    [aux_sym_preproc_def_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1672),
    [sym_preproc_directive] = ACTIONS(1672),
    [anon_sym_LPAREN2] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_TILDE] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym___extension__] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym___attribute__] = ACTIONS(1672),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1674),
    [anon_sym___declspec] = ACTIONS(1672),
    [anon_sym___cdecl] = ACTIONS(1672),
    [anon_sym___clrcall] = ACTIONS(1672),
    [anon_sym___stdcall] = ACTIONS(1672),
    [anon_sym___fastcall] = ACTIONS(1672),
    [anon_sym___thiscall] = ACTIONS(1672),
    [anon_sym___vectorcall] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_RBRACE] = ACTIONS(1674),
    [anon_sym_signed] = ACTIONS(1672),
    [anon_sym_unsigned] = ACTIONS(1672),
    [anon_sym_long] = ACTIONS(1672),
    [anon_sym_short] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_auto] = ACTIONS(1672),
    [anon_sym_register] = ACTIONS(1672),
    [anon_sym_inline] = ACTIONS(1672),
    [anon_sym___inline] = ACTIONS(1672),
    [anon_sym___inline__] = ACTIONS(1672),
    [anon_sym___forceinline] = ACTIONS(1672),
    [anon_sym_thread_local] = ACTIONS(1672),
    [anon_sym___thread] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_constexpr] = ACTIONS(1672),
    [anon_sym_volatile] = ACTIONS(1672),
    [anon_sym_restrict] = ACTIONS(1672),
    [anon_sym___restrict__] = ACTIONS(1672),
    [anon_sym__Atomic] = ACTIONS(1672),
    [anon_sym__Noreturn] = ACTIONS(1672),
    [anon_sym_noreturn] = ACTIONS(1672),
    [sym_primitive_type] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_do] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_goto] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1674),
    [anon_sym_PLUS_PLUS] = ACTIONS(1674),
    [anon_sym_sizeof] = ACTIONS(1672),
    [anon_sym___alignof__] = ACTIONS(1672),
    [anon_sym___alignof] = ACTIONS(1672),
    [anon_sym__alignof] = ACTIONS(1672),
    [anon_sym_alignof] = ACTIONS(1672),
    [anon_sym__Alignof] = ACTIONS(1672),
    [anon_sym_offsetof] = ACTIONS(1672),
    [anon_sym__Generic] = ACTIONS(1672),
    [anon_sym_asm] = ACTIONS(1672),
    [anon_sym___asm__] = ACTIONS(1672),
    [sym_number_literal] = ACTIONS(1674),
    [anon_sym_L_SQUOTE] = ACTIONS(1674),
    [anon_sym_u_SQUOTE] = ACTIONS(1674),
    [anon_sym_U_SQUOTE] = ACTIONS(1674),
    [anon_sym_u8_SQUOTE] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1674),
    [anon_sym_L_DQUOTE] = ACTIONS(1674),
    [anon_sym_u_DQUOTE] = ACTIONS(1674),
    [anon_sym_U_DQUOTE] = ACTIONS(1674),
    [anon_sym_u8_DQUOTE] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(1674),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [anon_sym_NULL] = ACTIONS(1672),
    [anon_sym_nullptr] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1672),
    [anon_sym_acquire] = ACTIONS(1672),
    [anon_sym_monitor] = ACTIONS(1672),
    [anon_sym_start] = ACTIONS(1672),
    [anon_sym_stop] = ACTIONS(1672),
  },
  [485] = {
    [sym_identifier] = ACTIONS(1615),
    [aux_sym_preproc_include_token1] = ACTIONS(1615),
    [aux_sym_preproc_def_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token2] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1615),
    [sym_preproc_directive] = ACTIONS(1615),
    [anon_sym_LPAREN2] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym___extension__] = ACTIONS(1615),
    [anon_sym_typedef] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym___attribute__] = ACTIONS(1615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1617),
    [anon_sym___declspec] = ACTIONS(1615),
    [anon_sym___cdecl] = ACTIONS(1615),
    [anon_sym___clrcall] = ACTIONS(1615),
    [anon_sym___stdcall] = ACTIONS(1615),
    [anon_sym___fastcall] = ACTIONS(1615),
    [anon_sym___thiscall] = ACTIONS(1615),
    [anon_sym___vectorcall] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_signed] = ACTIONS(1615),
    [anon_sym_unsigned] = ACTIONS(1615),
    [anon_sym_long] = ACTIONS(1615),
    [anon_sym_short] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_auto] = ACTIONS(1615),
    [anon_sym_register] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym___inline] = ACTIONS(1615),
    [anon_sym___inline__] = ACTIONS(1615),
    [anon_sym___forceinline] = ACTIONS(1615),
    [anon_sym_thread_local] = ACTIONS(1615),
    [anon_sym___thread] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_constexpr] = ACTIONS(1615),
    [anon_sym_volatile] = ACTIONS(1615),
    [anon_sym_restrict] = ACTIONS(1615),
    [anon_sym___restrict__] = ACTIONS(1615),
    [anon_sym__Atomic] = ACTIONS(1615),
    [anon_sym__Noreturn] = ACTIONS(1615),
    [anon_sym_noreturn] = ACTIONS(1615),
    [sym_primitive_type] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_goto] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_sizeof] = ACTIONS(1615),
    [anon_sym___alignof__] = ACTIONS(1615),
    [anon_sym___alignof] = ACTIONS(1615),
    [anon_sym__alignof] = ACTIONS(1615),
    [anon_sym_alignof] = ACTIONS(1615),
    [anon_sym__Alignof] = ACTIONS(1615),
    [anon_sym_offsetof] = ACTIONS(1615),
    [anon_sym__Generic] = ACTIONS(1615),
    [anon_sym_asm] = ACTIONS(1615),
    [anon_sym___asm__] = ACTIONS(1615),
    [sym_number_literal] = ACTIONS(1617),
    [anon_sym_L_SQUOTE] = ACTIONS(1617),
    [anon_sym_u_SQUOTE] = ACTIONS(1617),
    [anon_sym_U_SQUOTE] = ACTIONS(1617),
    [anon_sym_u8_SQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [anon_sym_L_DQUOTE] = ACTIONS(1617),
    [anon_sym_u_DQUOTE] = ACTIONS(1617),
    [anon_sym_U_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8_DQUOTE] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_true] = ACTIONS(1615),
    [sym_false] = ACTIONS(1615),
    [anon_sym_NULL] = ACTIONS(1615),
    [anon_sym_nullptr] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1615),
    [anon_sym_acquire] = ACTIONS(1615),
    [anon_sym_monitor] = ACTIONS(1615),
    [anon_sym_start] = ACTIONS(1615),
    [anon_sym_stop] = ACTIONS(1615),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [aux_sym_preproc_include_token1] = ACTIONS(2088),
    [aux_sym_preproc_def_token1] = ACTIONS(2088),
    [aux_sym_preproc_if_token1] = ACTIONS(2088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2088),
    [sym_preproc_directive] = ACTIONS(2088),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_TILDE] = ACTIONS(2086),
    [anon_sym_DASH] = ACTIONS(2088),
    [anon_sym_PLUS] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(2086),
    [anon_sym_AMP] = ACTIONS(2086),
    [anon_sym___extension__] = ACTIONS(2088),
    [anon_sym_typedef] = ACTIONS(2088),
    [anon_sym_extern] = ACTIONS(2088),
    [anon_sym___attribute__] = ACTIONS(2088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2086),
    [anon_sym___declspec] = ACTIONS(2088),
    [anon_sym___cdecl] = ACTIONS(2088),
    [anon_sym___clrcall] = ACTIONS(2088),
    [anon_sym___stdcall] = ACTIONS(2088),
    [anon_sym___fastcall] = ACTIONS(2088),
    [anon_sym___thiscall] = ACTIONS(2088),
    [anon_sym___vectorcall] = ACTIONS(2088),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_signed] = ACTIONS(2088),
    [anon_sym_unsigned] = ACTIONS(2088),
    [anon_sym_long] = ACTIONS(2088),
    [anon_sym_short] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_auto] = ACTIONS(2088),
    [anon_sym_register] = ACTIONS(2088),
    [anon_sym_inline] = ACTIONS(2088),
    [anon_sym___inline] = ACTIONS(2088),
    [anon_sym___inline__] = ACTIONS(2088),
    [anon_sym___forceinline] = ACTIONS(2088),
    [anon_sym_thread_local] = ACTIONS(2088),
    [anon_sym___thread] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_constexpr] = ACTIONS(2088),
    [anon_sym_volatile] = ACTIONS(2088),
    [anon_sym_restrict] = ACTIONS(2088),
    [anon_sym___restrict__] = ACTIONS(2088),
    [anon_sym__Atomic] = ACTIONS(2088),
    [anon_sym__Noreturn] = ACTIONS(2088),
    [anon_sym_noreturn] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
    [anon_sym_struct] = ACTIONS(2088),
    [anon_sym_union] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_switch] = ACTIONS(2088),
    [anon_sym_case] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_do] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_goto] = ACTIONS(2088),
    [anon_sym_DASH_DASH] = ACTIONS(2086),
    [anon_sym_PLUS_PLUS] = ACTIONS(2086),
    [anon_sym_sizeof] = ACTIONS(2088),
    [anon_sym___alignof__] = ACTIONS(2088),
    [anon_sym___alignof] = ACTIONS(2088),
    [anon_sym__alignof] = ACTIONS(2088),
    [anon_sym_alignof] = ACTIONS(2088),
    [anon_sym__Alignof] = ACTIONS(2088),
    [anon_sym_offsetof] = ACTIONS(2088),
    [anon_sym__Generic] = ACTIONS(2088),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [sym_number_literal] = ACTIONS(2086),
    [anon_sym_L_SQUOTE] = ACTIONS(2086),
    [anon_sym_u_SQUOTE] = ACTIONS(2086),
    [anon_sym_U_SQUOTE] = ACTIONS(2086),
    [anon_sym_u8_SQUOTE] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2086),
    [anon_sym_L_DQUOTE] = ACTIONS(2086),
    [anon_sym_u_DQUOTE] = ACTIONS(2086),
    [anon_sym_U_DQUOTE] = ACTIONS(2086),
    [anon_sym_u8_DQUOTE] = ACTIONS(2086),
    [anon_sym_DQUOTE] = ACTIONS(2086),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [anon_sym_NULL] = ACTIONS(2088),
    [anon_sym_nullptr] = ACTIONS(2088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(2088),
    [anon_sym_until] = ACTIONS(2088),
    [anon_sym_acquire] = ACTIONS(2088),
    [anon_sym_monitor] = ACTIONS(2088),
    [anon_sym_start] = ACTIONS(2088),
    [anon_sym_stop] = ACTIONS(2088),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1646),
    [sym_identifier] = ACTIONS(1644),
    [aux_sym_preproc_include_token1] = ACTIONS(1644),
    [aux_sym_preproc_def_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_LPAREN2] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1646),
    [anon_sym___extension__] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym___attribute__] = ACTIONS(1644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1646),
    [anon_sym___declspec] = ACTIONS(1644),
    [anon_sym___cdecl] = ACTIONS(1644),
    [anon_sym___clrcall] = ACTIONS(1644),
    [anon_sym___stdcall] = ACTIONS(1644),
    [anon_sym___fastcall] = ACTIONS(1644),
    [anon_sym___thiscall] = ACTIONS(1644),
    [anon_sym___vectorcall] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_signed] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym___inline] = ACTIONS(1644),
    [anon_sym___inline__] = ACTIONS(1644),
    [anon_sym___forceinline] = ACTIONS(1644),
    [anon_sym_thread_local] = ACTIONS(1644),
    [anon_sym___thread] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_constexpr] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym___restrict__] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym__Noreturn] = ACTIONS(1644),
    [anon_sym_noreturn] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1646),
    [anon_sym_sizeof] = ACTIONS(1644),
    [anon_sym___alignof__] = ACTIONS(1644),
    [anon_sym___alignof] = ACTIONS(1644),
    [anon_sym__alignof] = ACTIONS(1644),
    [anon_sym_alignof] = ACTIONS(1644),
    [anon_sym__Alignof] = ACTIONS(1644),
    [anon_sym_offsetof] = ACTIONS(1644),
    [anon_sym__Generic] = ACTIONS(1644),
    [anon_sym_asm] = ACTIONS(1644),
    [anon_sym___asm__] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1646),
    [anon_sym_L_SQUOTE] = ACTIONS(1646),
    [anon_sym_u_SQUOTE] = ACTIONS(1646),
    [anon_sym_U_SQUOTE] = ACTIONS(1646),
    [anon_sym_u8_SQUOTE] = ACTIONS(1646),
    [anon_sym_SQUOTE] = ACTIONS(1646),
    [anon_sym_L_DQUOTE] = ACTIONS(1646),
    [anon_sym_u_DQUOTE] = ACTIONS(1646),
    [anon_sym_U_DQUOTE] = ACTIONS(1646),
    [anon_sym_u8_DQUOTE] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1646),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [anon_sym_NULL] = ACTIONS(1644),
    [anon_sym_nullptr] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1644),
    [anon_sym_until] = ACTIONS(1644),
    [anon_sym_acquire] = ACTIONS(1644),
    [anon_sym_monitor] = ACTIONS(1644),
    [anon_sym_start] = ACTIONS(1644),
    [anon_sym_stop] = ACTIONS(1644),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1666),
    [sym_identifier] = ACTIONS(1664),
    [aux_sym_preproc_include_token1] = ACTIONS(1664),
    [aux_sym_preproc_def_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1664),
    [sym_preproc_directive] = ACTIONS(1664),
    [anon_sym_LPAREN2] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym___attribute__] = ACTIONS(1664),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1666),
    [anon_sym___declspec] = ACTIONS(1664),
    [anon_sym___cdecl] = ACTIONS(1664),
    [anon_sym___clrcall] = ACTIONS(1664),
    [anon_sym___stdcall] = ACTIONS(1664),
    [anon_sym___fastcall] = ACTIONS(1664),
    [anon_sym___thiscall] = ACTIONS(1664),
    [anon_sym___vectorcall] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_signed] = ACTIONS(1664),
    [anon_sym_unsigned] = ACTIONS(1664),
    [anon_sym_long] = ACTIONS(1664),
    [anon_sym_short] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_auto] = ACTIONS(1664),
    [anon_sym_register] = ACTIONS(1664),
    [anon_sym_inline] = ACTIONS(1664),
    [anon_sym___inline] = ACTIONS(1664),
    [anon_sym___inline__] = ACTIONS(1664),
    [anon_sym___forceinline] = ACTIONS(1664),
    [anon_sym_thread_local] = ACTIONS(1664),
    [anon_sym___thread] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_constexpr] = ACTIONS(1664),
    [anon_sym_volatile] = ACTIONS(1664),
    [anon_sym_restrict] = ACTIONS(1664),
    [anon_sym___restrict__] = ACTIONS(1664),
    [anon_sym__Atomic] = ACTIONS(1664),
    [anon_sym__Noreturn] = ACTIONS(1664),
    [anon_sym_noreturn] = ACTIONS(1664),
    [sym_primitive_type] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_switch] = ACTIONS(1664),
    [anon_sym_case] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_do] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_goto] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1666),
    [anon_sym_sizeof] = ACTIONS(1664),
    [anon_sym___alignof__] = ACTIONS(1664),
    [anon_sym___alignof] = ACTIONS(1664),
    [anon_sym__alignof] = ACTIONS(1664),
    [anon_sym_alignof] = ACTIONS(1664),
    [anon_sym__Alignof] = ACTIONS(1664),
    [anon_sym_offsetof] = ACTIONS(1664),
    [anon_sym__Generic] = ACTIONS(1664),
    [anon_sym_asm] = ACTIONS(1664),
    [anon_sym___asm__] = ACTIONS(1664),
    [sym_number_literal] = ACTIONS(1666),
    [anon_sym_L_SQUOTE] = ACTIONS(1666),
    [anon_sym_u_SQUOTE] = ACTIONS(1666),
    [anon_sym_U_SQUOTE] = ACTIONS(1666),
    [anon_sym_u8_SQUOTE] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1666),
    [anon_sym_L_DQUOTE] = ACTIONS(1666),
    [anon_sym_u_DQUOTE] = ACTIONS(1666),
    [anon_sym_U_DQUOTE] = ACTIONS(1666),
    [anon_sym_u8_DQUOTE] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1666),
    [sym_true] = ACTIONS(1664),
    [sym_false] = ACTIONS(1664),
    [anon_sym_NULL] = ACTIONS(1664),
    [anon_sym_nullptr] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1664),
    [anon_sym_until] = ACTIONS(1664),
    [anon_sym_acquire] = ACTIONS(1664),
    [anon_sym_monitor] = ACTIONS(1664),
    [anon_sym_start] = ACTIONS(1664),
    [anon_sym_stop] = ACTIONS(1664),
  },
  [489] = {
    [sym_identifier] = ACTIONS(1668),
    [aux_sym_preproc_include_token1] = ACTIONS(1668),
    [aux_sym_preproc_def_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1668),
    [sym_preproc_directive] = ACTIONS(1668),
    [anon_sym_LPAREN2] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym___extension__] = ACTIONS(1668),
    [anon_sym_typedef] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym___attribute__] = ACTIONS(1668),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1670),
    [anon_sym___declspec] = ACTIONS(1668),
    [anon_sym___cdecl] = ACTIONS(1668),
    [anon_sym___clrcall] = ACTIONS(1668),
    [anon_sym___stdcall] = ACTIONS(1668),
    [anon_sym___fastcall] = ACTIONS(1668),
    [anon_sym___thiscall] = ACTIONS(1668),
    [anon_sym___vectorcall] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_signed] = ACTIONS(1668),
    [anon_sym_unsigned] = ACTIONS(1668),
    [anon_sym_long] = ACTIONS(1668),
    [anon_sym_short] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_auto] = ACTIONS(1668),
    [anon_sym_register] = ACTIONS(1668),
    [anon_sym_inline] = ACTIONS(1668),
    [anon_sym___inline] = ACTIONS(1668),
    [anon_sym___inline__] = ACTIONS(1668),
    [anon_sym___forceinline] = ACTIONS(1668),
    [anon_sym_thread_local] = ACTIONS(1668),
    [anon_sym___thread] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_constexpr] = ACTIONS(1668),
    [anon_sym_volatile] = ACTIONS(1668),
    [anon_sym_restrict] = ACTIONS(1668),
    [anon_sym___restrict__] = ACTIONS(1668),
    [anon_sym__Atomic] = ACTIONS(1668),
    [anon_sym__Noreturn] = ACTIONS(1668),
    [anon_sym_noreturn] = ACTIONS(1668),
    [sym_primitive_type] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_do] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_goto] = ACTIONS(1668),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_sizeof] = ACTIONS(1668),
    [anon_sym___alignof__] = ACTIONS(1668),
    [anon_sym___alignof] = ACTIONS(1668),
    [anon_sym__alignof] = ACTIONS(1668),
    [anon_sym_alignof] = ACTIONS(1668),
    [anon_sym__Alignof] = ACTIONS(1668),
    [anon_sym_offsetof] = ACTIONS(1668),
    [anon_sym__Generic] = ACTIONS(1668),
    [anon_sym_asm] = ACTIONS(1668),
    [anon_sym___asm__] = ACTIONS(1668),
    [sym_number_literal] = ACTIONS(1670),
    [anon_sym_L_SQUOTE] = ACTIONS(1670),
    [anon_sym_u_SQUOTE] = ACTIONS(1670),
    [anon_sym_U_SQUOTE] = ACTIONS(1670),
    [anon_sym_u8_SQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [anon_sym_L_DQUOTE] = ACTIONS(1670),
    [anon_sym_u_DQUOTE] = ACTIONS(1670),
    [anon_sym_U_DQUOTE] = ACTIONS(1670),
    [anon_sym_u8_DQUOTE] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [anon_sym_NULL] = ACTIONS(1668),
    [anon_sym_nullptr] = ACTIONS(1668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1668),
    [anon_sym_acquire] = ACTIONS(1668),
    [anon_sym_monitor] = ACTIONS(1668),
    [anon_sym_start] = ACTIONS(1668),
    [anon_sym_stop] = ACTIONS(1668),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(1639),
    [sym_identifier] = ACTIONS(1637),
    [aux_sym_preproc_include_token1] = ACTIONS(1637),
    [aux_sym_preproc_def_token1] = ACTIONS(1637),
    [aux_sym_preproc_if_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1637),
    [sym_preproc_directive] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1639),
    [anon_sym_BANG] = ACTIONS(1639),
    [anon_sym_TILDE] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1637),
    [anon_sym_extern] = ACTIONS(1637),
    [anon_sym___attribute__] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1639),
    [anon_sym___declspec] = ACTIONS(1637),
    [anon_sym___cdecl] = ACTIONS(1637),
    [anon_sym___clrcall] = ACTIONS(1637),
    [anon_sym___stdcall] = ACTIONS(1637),
    [anon_sym___fastcall] = ACTIONS(1637),
    [anon_sym___thiscall] = ACTIONS(1637),
    [anon_sym___vectorcall] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1637),
    [anon_sym_unsigned] = ACTIONS(1637),
    [anon_sym_long] = ACTIONS(1637),
    [anon_sym_short] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1637),
    [anon_sym_auto] = ACTIONS(1637),
    [anon_sym_register] = ACTIONS(1637),
    [anon_sym_inline] = ACTIONS(1637),
    [anon_sym___inline] = ACTIONS(1637),
    [anon_sym___inline__] = ACTIONS(1637),
    [anon_sym___forceinline] = ACTIONS(1637),
    [anon_sym_thread_local] = ACTIONS(1637),
    [anon_sym___thread] = ACTIONS(1637),
    [anon_sym_const] = ACTIONS(1637),
    [anon_sym_constexpr] = ACTIONS(1637),
    [anon_sym_volatile] = ACTIONS(1637),
    [anon_sym_restrict] = ACTIONS(1637),
    [anon_sym___restrict__] = ACTIONS(1637),
    [anon_sym__Atomic] = ACTIONS(1637),
    [anon_sym__Noreturn] = ACTIONS(1637),
    [anon_sym_noreturn] = ACTIONS(1637),
    [sym_primitive_type] = ACTIONS(1637),
    [anon_sym_enum] = ACTIONS(1637),
    [anon_sym_struct] = ACTIONS(1637),
    [anon_sym_union] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(1637),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1637),
    [anon_sym_default] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1637),
    [anon_sym_do] = ACTIONS(1637),
    [anon_sym_for] = ACTIONS(1637),
    [anon_sym_return] = ACTIONS(1637),
    [anon_sym_break] = ACTIONS(1637),
    [anon_sym_continue] = ACTIONS(1637),
    [anon_sym_goto] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1637),
    [anon_sym___alignof__] = ACTIONS(1637),
    [anon_sym___alignof] = ACTIONS(1637),
    [anon_sym__alignof] = ACTIONS(1637),
    [anon_sym_alignof] = ACTIONS(1637),
    [anon_sym__Alignof] = ACTIONS(1637),
    [anon_sym_offsetof] = ACTIONS(1637),
    [anon_sym__Generic] = ACTIONS(1637),
    [anon_sym_asm] = ACTIONS(1637),
    [anon_sym___asm__] = ACTIONS(1637),
    [sym_number_literal] = ACTIONS(1639),
    [anon_sym_L_SQUOTE] = ACTIONS(1639),
    [anon_sym_u_SQUOTE] = ACTIONS(1639),
    [anon_sym_U_SQUOTE] = ACTIONS(1639),
    [anon_sym_u8_SQUOTE] = ACTIONS(1639),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [anon_sym_L_DQUOTE] = ACTIONS(1639),
    [anon_sym_u_DQUOTE] = ACTIONS(1639),
    [anon_sym_U_DQUOTE] = ACTIONS(1639),
    [anon_sym_u8_DQUOTE] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [anon_sym_NULL] = ACTIONS(1637),
    [anon_sym_nullptr] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1637),
    [anon_sym_until] = ACTIONS(1637),
    [anon_sym_acquire] = ACTIONS(1637),
    [anon_sym_monitor] = ACTIONS(1637),
    [anon_sym_start] = ACTIONS(1637),
    [anon_sym_stop] = ACTIONS(1637),
  },
  [491] = {
    [sym_identifier] = ACTIONS(1648),
    [aux_sym_preproc_include_token1] = ACTIONS(1648),
    [aux_sym_preproc_def_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1648),
    [sym_preproc_directive] = ACTIONS(1648),
    [anon_sym_LPAREN2] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym___extension__] = ACTIONS(1648),
    [anon_sym_typedef] = ACTIONS(1648),
    [anon_sym_extern] = ACTIONS(1648),
    [anon_sym___attribute__] = ACTIONS(1648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1650),
    [anon_sym___declspec] = ACTIONS(1648),
    [anon_sym___cdecl] = ACTIONS(1648),
    [anon_sym___clrcall] = ACTIONS(1648),
    [anon_sym___stdcall] = ACTIONS(1648),
    [anon_sym___fastcall] = ACTIONS(1648),
    [anon_sym___thiscall] = ACTIONS(1648),
    [anon_sym___vectorcall] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_RBRACE] = ACTIONS(1650),
    [anon_sym_signed] = ACTIONS(1648),
    [anon_sym_unsigned] = ACTIONS(1648),
    [anon_sym_long] = ACTIONS(1648),
    [anon_sym_short] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1648),
    [anon_sym_auto] = ACTIONS(1648),
    [anon_sym_register] = ACTIONS(1648),
    [anon_sym_inline] = ACTIONS(1648),
    [anon_sym___inline] = ACTIONS(1648),
    [anon_sym___inline__] = ACTIONS(1648),
    [anon_sym___forceinline] = ACTIONS(1648),
    [anon_sym_thread_local] = ACTIONS(1648),
    [anon_sym___thread] = ACTIONS(1648),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_constexpr] = ACTIONS(1648),
    [anon_sym_volatile] = ACTIONS(1648),
    [anon_sym_restrict] = ACTIONS(1648),
    [anon_sym___restrict__] = ACTIONS(1648),
    [anon_sym__Atomic] = ACTIONS(1648),
    [anon_sym__Noreturn] = ACTIONS(1648),
    [anon_sym_noreturn] = ACTIONS(1648),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1648),
    [anon_sym_struct] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_if] = ACTIONS(1648),
    [anon_sym_switch] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_while] = ACTIONS(1648),
    [anon_sym_do] = ACTIONS(1648),
    [anon_sym_for] = ACTIONS(1648),
    [anon_sym_return] = ACTIONS(1648),
    [anon_sym_break] = ACTIONS(1648),
    [anon_sym_continue] = ACTIONS(1648),
    [anon_sym_goto] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1650),
    [anon_sym_sizeof] = ACTIONS(1648),
    [anon_sym___alignof__] = ACTIONS(1648),
    [anon_sym___alignof] = ACTIONS(1648),
    [anon_sym__alignof] = ACTIONS(1648),
    [anon_sym_alignof] = ACTIONS(1648),
    [anon_sym__Alignof] = ACTIONS(1648),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1648),
    [anon_sym_asm] = ACTIONS(1648),
    [anon_sym___asm__] = ACTIONS(1648),
    [sym_number_literal] = ACTIONS(1650),
    [anon_sym_L_SQUOTE] = ACTIONS(1650),
    [anon_sym_u_SQUOTE] = ACTIONS(1650),
    [anon_sym_U_SQUOTE] = ACTIONS(1650),
    [anon_sym_u8_SQUOTE] = ACTIONS(1650),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [anon_sym_L_DQUOTE] = ACTIONS(1650),
    [anon_sym_u_DQUOTE] = ACTIONS(1650),
    [anon_sym_U_DQUOTE] = ACTIONS(1650),
    [anon_sym_u8_DQUOTE] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_true] = ACTIONS(1648),
    [sym_false] = ACTIONS(1648),
    [anon_sym_NULL] = ACTIONS(1648),
    [anon_sym_nullptr] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1648),
    [anon_sym_acquire] = ACTIONS(1648),
    [anon_sym_monitor] = ACTIONS(1648),
    [anon_sym_start] = ACTIONS(1648),
    [anon_sym_stop] = ACTIONS(1648),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1696),
    [aux_sym_preproc_include_token1] = ACTIONS(1696),
    [aux_sym_preproc_def_token1] = ACTIONS(1696),
    [aux_sym_preproc_if_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1696),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1696),
    [sym_preproc_directive] = ACTIONS(1696),
    [anon_sym_LPAREN2] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym___extension__] = ACTIONS(1696),
    [anon_sym_typedef] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym___attribute__] = ACTIONS(1696),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1698),
    [anon_sym___declspec] = ACTIONS(1696),
    [anon_sym___cdecl] = ACTIONS(1696),
    [anon_sym___clrcall] = ACTIONS(1696),
    [anon_sym___stdcall] = ACTIONS(1696),
    [anon_sym___fastcall] = ACTIONS(1696),
    [anon_sym___thiscall] = ACTIONS(1696),
    [anon_sym___vectorcall] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_signed] = ACTIONS(1696),
    [anon_sym_unsigned] = ACTIONS(1696),
    [anon_sym_long] = ACTIONS(1696),
    [anon_sym_short] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_auto] = ACTIONS(1696),
    [anon_sym_register] = ACTIONS(1696),
    [anon_sym_inline] = ACTIONS(1696),
    [anon_sym___inline] = ACTIONS(1696),
    [anon_sym___inline__] = ACTIONS(1696),
    [anon_sym___forceinline] = ACTIONS(1696),
    [anon_sym_thread_local] = ACTIONS(1696),
    [anon_sym___thread] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_constexpr] = ACTIONS(1696),
    [anon_sym_volatile] = ACTIONS(1696),
    [anon_sym_restrict] = ACTIONS(1696),
    [anon_sym___restrict__] = ACTIONS(1696),
    [anon_sym__Atomic] = ACTIONS(1696),
    [anon_sym__Noreturn] = ACTIONS(1696),
    [anon_sym_noreturn] = ACTIONS(1696),
    [sym_primitive_type] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_switch] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_goto] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_sizeof] = ACTIONS(1696),
    [anon_sym___alignof__] = ACTIONS(1696),
    [anon_sym___alignof] = ACTIONS(1696),
    [anon_sym__alignof] = ACTIONS(1696),
    [anon_sym_alignof] = ACTIONS(1696),
    [anon_sym__Alignof] = ACTIONS(1696),
    [anon_sym_offsetof] = ACTIONS(1696),
    [anon_sym__Generic] = ACTIONS(1696),
    [anon_sym_asm] = ACTIONS(1696),
    [anon_sym___asm__] = ACTIONS(1696),
    [sym_number_literal] = ACTIONS(1698),
    [anon_sym_L_SQUOTE] = ACTIONS(1698),
    [anon_sym_u_SQUOTE] = ACTIONS(1698),
    [anon_sym_U_SQUOTE] = ACTIONS(1698),
    [anon_sym_u8_SQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [anon_sym_L_DQUOTE] = ACTIONS(1698),
    [anon_sym_u_DQUOTE] = ACTIONS(1698),
    [anon_sym_U_DQUOTE] = ACTIONS(1698),
    [anon_sym_u8_DQUOTE] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [anon_sym_NULL] = ACTIONS(1696),
    [anon_sym_nullptr] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1696),
    [anon_sym_until] = ACTIONS(1696),
    [anon_sym_acquire] = ACTIONS(1696),
    [anon_sym_monitor] = ACTIONS(1696),
    [anon_sym_start] = ACTIONS(1696),
    [anon_sym_stop] = ACTIONS(1696),
  },
  [493] = {
    [sym_identifier] = ACTIONS(1688),
    [aux_sym_preproc_include_token1] = ACTIONS(1688),
    [aux_sym_preproc_def_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token2] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1688),
    [sym_preproc_directive] = ACTIONS(1688),
    [anon_sym_LPAREN2] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym___extension__] = ACTIONS(1688),
    [anon_sym_typedef] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym___attribute__] = ACTIONS(1688),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1690),
    [anon_sym___declspec] = ACTIONS(1688),
    [anon_sym___cdecl] = ACTIONS(1688),
    [anon_sym___clrcall] = ACTIONS(1688),
    [anon_sym___stdcall] = ACTIONS(1688),
    [anon_sym___fastcall] = ACTIONS(1688),
    [anon_sym___thiscall] = ACTIONS(1688),
    [anon_sym___vectorcall] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_signed] = ACTIONS(1688),
    [anon_sym_unsigned] = ACTIONS(1688),
    [anon_sym_long] = ACTIONS(1688),
    [anon_sym_short] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_auto] = ACTIONS(1688),
    [anon_sym_register] = ACTIONS(1688),
    [anon_sym_inline] = ACTIONS(1688),
    [anon_sym___inline] = ACTIONS(1688),
    [anon_sym___inline__] = ACTIONS(1688),
    [anon_sym___forceinline] = ACTIONS(1688),
    [anon_sym_thread_local] = ACTIONS(1688),
    [anon_sym___thread] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_constexpr] = ACTIONS(1688),
    [anon_sym_volatile] = ACTIONS(1688),
    [anon_sym_restrict] = ACTIONS(1688),
    [anon_sym___restrict__] = ACTIONS(1688),
    [anon_sym__Atomic] = ACTIONS(1688),
    [anon_sym__Noreturn] = ACTIONS(1688),
    [anon_sym_noreturn] = ACTIONS(1688),
    [sym_primitive_type] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_switch] = ACTIONS(1688),
    [anon_sym_case] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_do] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_goto] = ACTIONS(1688),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_sizeof] = ACTIONS(1688),
    [anon_sym___alignof__] = ACTIONS(1688),
    [anon_sym___alignof] = ACTIONS(1688),
    [anon_sym__alignof] = ACTIONS(1688),
    [anon_sym_alignof] = ACTIONS(1688),
    [anon_sym__Alignof] = ACTIONS(1688),
    [anon_sym_offsetof] = ACTIONS(1688),
    [anon_sym__Generic] = ACTIONS(1688),
    [anon_sym_asm] = ACTIONS(1688),
    [anon_sym___asm__] = ACTIONS(1688),
    [sym_number_literal] = ACTIONS(1690),
    [anon_sym_L_SQUOTE] = ACTIONS(1690),
    [anon_sym_u_SQUOTE] = ACTIONS(1690),
    [anon_sym_U_SQUOTE] = ACTIONS(1690),
    [anon_sym_u8_SQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [anon_sym_L_DQUOTE] = ACTIONS(1690),
    [anon_sym_u_DQUOTE] = ACTIONS(1690),
    [anon_sym_U_DQUOTE] = ACTIONS(1690),
    [anon_sym_u8_DQUOTE] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [anon_sym_NULL] = ACTIONS(1688),
    [anon_sym_nullptr] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1688),
    [anon_sym_acquire] = ACTIONS(1688),
    [anon_sym_monitor] = ACTIONS(1688),
    [anon_sym_start] = ACTIONS(1688),
    [anon_sym_stop] = ACTIONS(1688),
  },
  [494] = {
    [sym_identifier] = ACTIONS(1584),
    [aux_sym_preproc_include_token1] = ACTIONS(1584),
    [aux_sym_preproc_def_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token2] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1584),
    [sym_preproc_directive] = ACTIONS(1584),
    [anon_sym_LPAREN2] = ACTIONS(1586),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym___extension__] = ACTIONS(1584),
    [anon_sym_typedef] = ACTIONS(1584),
    [anon_sym_extern] = ACTIONS(1584),
    [anon_sym___attribute__] = ACTIONS(1584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1586),
    [anon_sym___declspec] = ACTIONS(1584),
    [anon_sym___cdecl] = ACTIONS(1584),
    [anon_sym___clrcall] = ACTIONS(1584),
    [anon_sym___stdcall] = ACTIONS(1584),
    [anon_sym___fastcall] = ACTIONS(1584),
    [anon_sym___thiscall] = ACTIONS(1584),
    [anon_sym___vectorcall] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_signed] = ACTIONS(1584),
    [anon_sym_unsigned] = ACTIONS(1584),
    [anon_sym_long] = ACTIONS(1584),
    [anon_sym_short] = ACTIONS(1584),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_auto] = ACTIONS(1584),
    [anon_sym_register] = ACTIONS(1584),
    [anon_sym_inline] = ACTIONS(1584),
    [anon_sym___inline] = ACTIONS(1584),
    [anon_sym___inline__] = ACTIONS(1584),
    [anon_sym___forceinline] = ACTIONS(1584),
    [anon_sym_thread_local] = ACTIONS(1584),
    [anon_sym___thread] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_constexpr] = ACTIONS(1584),
    [anon_sym_volatile] = ACTIONS(1584),
    [anon_sym_restrict] = ACTIONS(1584),
    [anon_sym___restrict__] = ACTIONS(1584),
    [anon_sym__Atomic] = ACTIONS(1584),
    [anon_sym__Noreturn] = ACTIONS(1584),
    [anon_sym_noreturn] = ACTIONS(1584),
    [sym_primitive_type] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_goto] = ACTIONS(1584),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_sizeof] = ACTIONS(1584),
    [anon_sym___alignof__] = ACTIONS(1584),
    [anon_sym___alignof] = ACTIONS(1584),
    [anon_sym__alignof] = ACTIONS(1584),
    [anon_sym_alignof] = ACTIONS(1584),
    [anon_sym__Alignof] = ACTIONS(1584),
    [anon_sym_offsetof] = ACTIONS(1584),
    [anon_sym__Generic] = ACTIONS(1584),
    [anon_sym_asm] = ACTIONS(1584),
    [anon_sym___asm__] = ACTIONS(1584),
    [sym_number_literal] = ACTIONS(1586),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1586),
    [anon_sym_u_DQUOTE] = ACTIONS(1586),
    [anon_sym_U_DQUOTE] = ACTIONS(1586),
    [anon_sym_u8_DQUOTE] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [anon_sym_NULL] = ACTIONS(1584),
    [anon_sym_nullptr] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1584),
    [anon_sym_acquire] = ACTIONS(1584),
    [anon_sym_monitor] = ACTIONS(1584),
    [anon_sym_start] = ACTIONS(1584),
    [anon_sym_stop] = ACTIONS(1584),
  },
  [495] = {
    [sym_identifier] = ACTIONS(1684),
    [aux_sym_preproc_include_token1] = ACTIONS(1684),
    [aux_sym_preproc_def_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token2] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1684),
    [sym_preproc_directive] = ACTIONS(1684),
    [anon_sym_LPAREN2] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym___extension__] = ACTIONS(1684),
    [anon_sym_typedef] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym___attribute__] = ACTIONS(1684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1686),
    [anon_sym___declspec] = ACTIONS(1684),
    [anon_sym___cdecl] = ACTIONS(1684),
    [anon_sym___clrcall] = ACTIONS(1684),
    [anon_sym___stdcall] = ACTIONS(1684),
    [anon_sym___fastcall] = ACTIONS(1684),
    [anon_sym___thiscall] = ACTIONS(1684),
    [anon_sym___vectorcall] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_signed] = ACTIONS(1684),
    [anon_sym_unsigned] = ACTIONS(1684),
    [anon_sym_long] = ACTIONS(1684),
    [anon_sym_short] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_auto] = ACTIONS(1684),
    [anon_sym_register] = ACTIONS(1684),
    [anon_sym_inline] = ACTIONS(1684),
    [anon_sym___inline] = ACTIONS(1684),
    [anon_sym___inline__] = ACTIONS(1684),
    [anon_sym___forceinline] = ACTIONS(1684),
    [anon_sym_thread_local] = ACTIONS(1684),
    [anon_sym___thread] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_constexpr] = ACTIONS(1684),
    [anon_sym_volatile] = ACTIONS(1684),
    [anon_sym_restrict] = ACTIONS(1684),
    [anon_sym___restrict__] = ACTIONS(1684),
    [anon_sym__Atomic] = ACTIONS(1684),
    [anon_sym__Noreturn] = ACTIONS(1684),
    [anon_sym_noreturn] = ACTIONS(1684),
    [sym_primitive_type] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_do] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1684),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_sizeof] = ACTIONS(1684),
    [anon_sym___alignof__] = ACTIONS(1684),
    [anon_sym___alignof] = ACTIONS(1684),
    [anon_sym__alignof] = ACTIONS(1684),
    [anon_sym_alignof] = ACTIONS(1684),
    [anon_sym__Alignof] = ACTIONS(1684),
    [anon_sym_offsetof] = ACTIONS(1684),
    [anon_sym__Generic] = ACTIONS(1684),
    [anon_sym_asm] = ACTIONS(1684),
    [anon_sym___asm__] = ACTIONS(1684),
    [sym_number_literal] = ACTIONS(1686),
    [anon_sym_L_SQUOTE] = ACTIONS(1686),
    [anon_sym_u_SQUOTE] = ACTIONS(1686),
    [anon_sym_U_SQUOTE] = ACTIONS(1686),
    [anon_sym_u8_SQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [anon_sym_L_DQUOTE] = ACTIONS(1686),
    [anon_sym_u_DQUOTE] = ACTIONS(1686),
    [anon_sym_U_DQUOTE] = ACTIONS(1686),
    [anon_sym_u8_DQUOTE] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [anon_sym_NULL] = ACTIONS(1684),
    [anon_sym_nullptr] = ACTIONS(1684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1684),
    [anon_sym_acquire] = ACTIONS(1684),
    [anon_sym_monitor] = ACTIONS(1684),
    [anon_sym_start] = ACTIONS(1684),
    [anon_sym_stop] = ACTIONS(1684),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1615),
    [aux_sym_preproc_include_token1] = ACTIONS(1615),
    [aux_sym_preproc_def_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1615),
    [sym_preproc_directive] = ACTIONS(1615),
    [anon_sym_LPAREN2] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym___extension__] = ACTIONS(1615),
    [anon_sym_typedef] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym___attribute__] = ACTIONS(1615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1617),
    [anon_sym___declspec] = ACTIONS(1615),
    [anon_sym___cdecl] = ACTIONS(1615),
    [anon_sym___clrcall] = ACTIONS(1615),
    [anon_sym___stdcall] = ACTIONS(1615),
    [anon_sym___fastcall] = ACTIONS(1615),
    [anon_sym___thiscall] = ACTIONS(1615),
    [anon_sym___vectorcall] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_signed] = ACTIONS(1615),
    [anon_sym_unsigned] = ACTIONS(1615),
    [anon_sym_long] = ACTIONS(1615),
    [anon_sym_short] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_auto] = ACTIONS(1615),
    [anon_sym_register] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym___inline] = ACTIONS(1615),
    [anon_sym___inline__] = ACTIONS(1615),
    [anon_sym___forceinline] = ACTIONS(1615),
    [anon_sym_thread_local] = ACTIONS(1615),
    [anon_sym___thread] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_constexpr] = ACTIONS(1615),
    [anon_sym_volatile] = ACTIONS(1615),
    [anon_sym_restrict] = ACTIONS(1615),
    [anon_sym___restrict__] = ACTIONS(1615),
    [anon_sym__Atomic] = ACTIONS(1615),
    [anon_sym__Noreturn] = ACTIONS(1615),
    [anon_sym_noreturn] = ACTIONS(1615),
    [sym_primitive_type] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_goto] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_sizeof] = ACTIONS(1615),
    [anon_sym___alignof__] = ACTIONS(1615),
    [anon_sym___alignof] = ACTIONS(1615),
    [anon_sym__alignof] = ACTIONS(1615),
    [anon_sym_alignof] = ACTIONS(1615),
    [anon_sym__Alignof] = ACTIONS(1615),
    [anon_sym_offsetof] = ACTIONS(1615),
    [anon_sym__Generic] = ACTIONS(1615),
    [anon_sym_asm] = ACTIONS(1615),
    [anon_sym___asm__] = ACTIONS(1615),
    [sym_number_literal] = ACTIONS(1617),
    [anon_sym_L_SQUOTE] = ACTIONS(1617),
    [anon_sym_u_SQUOTE] = ACTIONS(1617),
    [anon_sym_U_SQUOTE] = ACTIONS(1617),
    [anon_sym_u8_SQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [anon_sym_L_DQUOTE] = ACTIONS(1617),
    [anon_sym_u_DQUOTE] = ACTIONS(1617),
    [anon_sym_U_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8_DQUOTE] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_true] = ACTIONS(1615),
    [sym_false] = ACTIONS(1615),
    [anon_sym_NULL] = ACTIONS(1615),
    [anon_sym_nullptr] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1615),
    [anon_sym_until] = ACTIONS(1615),
    [anon_sym_acquire] = ACTIONS(1615),
    [anon_sym_monitor] = ACTIONS(1615),
    [anon_sym_start] = ACTIONS(1615),
    [anon_sym_stop] = ACTIONS(1615),
  },
  [497] = {
    [sym_identifier] = ACTIONS(1692),
    [aux_sym_preproc_include_token1] = ACTIONS(1692),
    [aux_sym_preproc_def_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token2] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1692),
    [sym_preproc_directive] = ACTIONS(1692),
    [anon_sym_LPAREN2] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_TILDE] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym___extension__] = ACTIONS(1692),
    [anon_sym_typedef] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym___attribute__] = ACTIONS(1692),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1694),
    [anon_sym___declspec] = ACTIONS(1692),
    [anon_sym___cdecl] = ACTIONS(1692),
    [anon_sym___clrcall] = ACTIONS(1692),
    [anon_sym___stdcall] = ACTIONS(1692),
    [anon_sym___fastcall] = ACTIONS(1692),
    [anon_sym___thiscall] = ACTIONS(1692),
    [anon_sym___vectorcall] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_signed] = ACTIONS(1692),
    [anon_sym_unsigned] = ACTIONS(1692),
    [anon_sym_long] = ACTIONS(1692),
    [anon_sym_short] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_auto] = ACTIONS(1692),
    [anon_sym_register] = ACTIONS(1692),
    [anon_sym_inline] = ACTIONS(1692),
    [anon_sym___inline] = ACTIONS(1692),
    [anon_sym___inline__] = ACTIONS(1692),
    [anon_sym___forceinline] = ACTIONS(1692),
    [anon_sym_thread_local] = ACTIONS(1692),
    [anon_sym___thread] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_constexpr] = ACTIONS(1692),
    [anon_sym_volatile] = ACTIONS(1692),
    [anon_sym_restrict] = ACTIONS(1692),
    [anon_sym___restrict__] = ACTIONS(1692),
    [anon_sym__Atomic] = ACTIONS(1692),
    [anon_sym__Noreturn] = ACTIONS(1692),
    [anon_sym_noreturn] = ACTIONS(1692),
    [sym_primitive_type] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_goto] = ACTIONS(1692),
    [anon_sym_DASH_DASH] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1694),
    [anon_sym_sizeof] = ACTIONS(1692),
    [anon_sym___alignof__] = ACTIONS(1692),
    [anon_sym___alignof] = ACTIONS(1692),
    [anon_sym__alignof] = ACTIONS(1692),
    [anon_sym_alignof] = ACTIONS(1692),
    [anon_sym__Alignof] = ACTIONS(1692),
    [anon_sym_offsetof] = ACTIONS(1692),
    [anon_sym__Generic] = ACTIONS(1692),
    [anon_sym_asm] = ACTIONS(1692),
    [anon_sym___asm__] = ACTIONS(1692),
    [sym_number_literal] = ACTIONS(1694),
    [anon_sym_L_SQUOTE] = ACTIONS(1694),
    [anon_sym_u_SQUOTE] = ACTIONS(1694),
    [anon_sym_U_SQUOTE] = ACTIONS(1694),
    [anon_sym_u8_SQUOTE] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1694),
    [anon_sym_L_DQUOTE] = ACTIONS(1694),
    [anon_sym_u_DQUOTE] = ACTIONS(1694),
    [anon_sym_U_DQUOTE] = ACTIONS(1694),
    [anon_sym_u8_DQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [anon_sym_NULL] = ACTIONS(1692),
    [anon_sym_nullptr] = ACTIONS(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1692),
    [anon_sym_acquire] = ACTIONS(1692),
    [anon_sym_monitor] = ACTIONS(1692),
    [anon_sym_start] = ACTIONS(1692),
    [anon_sym_stop] = ACTIONS(1692),
  },
  [498] = {
    [sym_identifier] = ACTIONS(1656),
    [aux_sym_preproc_include_token1] = ACTIONS(1656),
    [aux_sym_preproc_def_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token2] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1656),
    [sym_preproc_directive] = ACTIONS(1656),
    [anon_sym_LPAREN2] = ACTIONS(1658),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_TILDE] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_SEMI] = ACTIONS(1658),
    [anon_sym___extension__] = ACTIONS(1656),
    [anon_sym_typedef] = ACTIONS(1656),
    [anon_sym_extern] = ACTIONS(1656),
    [anon_sym___attribute__] = ACTIONS(1656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1658),
    [anon_sym___declspec] = ACTIONS(1656),
    [anon_sym___cdecl] = ACTIONS(1656),
    [anon_sym___clrcall] = ACTIONS(1656),
    [anon_sym___stdcall] = ACTIONS(1656),
    [anon_sym___fastcall] = ACTIONS(1656),
    [anon_sym___thiscall] = ACTIONS(1656),
    [anon_sym___vectorcall] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1658),
    [anon_sym_signed] = ACTIONS(1656),
    [anon_sym_unsigned] = ACTIONS(1656),
    [anon_sym_long] = ACTIONS(1656),
    [anon_sym_short] = ACTIONS(1656),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_auto] = ACTIONS(1656),
    [anon_sym_register] = ACTIONS(1656),
    [anon_sym_inline] = ACTIONS(1656),
    [anon_sym___inline] = ACTIONS(1656),
    [anon_sym___inline__] = ACTIONS(1656),
    [anon_sym___forceinline] = ACTIONS(1656),
    [anon_sym_thread_local] = ACTIONS(1656),
    [anon_sym___thread] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_constexpr] = ACTIONS(1656),
    [anon_sym_volatile] = ACTIONS(1656),
    [anon_sym_restrict] = ACTIONS(1656),
    [anon_sym___restrict__] = ACTIONS(1656),
    [anon_sym__Atomic] = ACTIONS(1656),
    [anon_sym__Noreturn] = ACTIONS(1656),
    [anon_sym_noreturn] = ACTIONS(1656),
    [sym_primitive_type] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_struct] = ACTIONS(1656),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_goto] = ACTIONS(1656),
    [anon_sym_DASH_DASH] = ACTIONS(1658),
    [anon_sym_PLUS_PLUS] = ACTIONS(1658),
    [anon_sym_sizeof] = ACTIONS(1656),
    [anon_sym___alignof__] = ACTIONS(1656),
    [anon_sym___alignof] = ACTIONS(1656),
    [anon_sym__alignof] = ACTIONS(1656),
    [anon_sym_alignof] = ACTIONS(1656),
    [anon_sym__Alignof] = ACTIONS(1656),
    [anon_sym_offsetof] = ACTIONS(1656),
    [anon_sym__Generic] = ACTIONS(1656),
    [anon_sym_asm] = ACTIONS(1656),
    [anon_sym___asm__] = ACTIONS(1656),
    [sym_number_literal] = ACTIONS(1658),
    [anon_sym_L_SQUOTE] = ACTIONS(1658),
    [anon_sym_u_SQUOTE] = ACTIONS(1658),
    [anon_sym_U_SQUOTE] = ACTIONS(1658),
    [anon_sym_u8_SQUOTE] = ACTIONS(1658),
    [anon_sym_SQUOTE] = ACTIONS(1658),
    [anon_sym_L_DQUOTE] = ACTIONS(1658),
    [anon_sym_u_DQUOTE] = ACTIONS(1658),
    [anon_sym_U_DQUOTE] = ACTIONS(1658),
    [anon_sym_u8_DQUOTE] = ACTIONS(1658),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [anon_sym_NULL] = ACTIONS(1656),
    [anon_sym_nullptr] = ACTIONS(1656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1656),
    [anon_sym_acquire] = ACTIONS(1656),
    [anon_sym_monitor] = ACTIONS(1656),
    [anon_sym_start] = ACTIONS(1656),
    [anon_sym_stop] = ACTIONS(1656),
  },
  [499] = {
    [sym_identifier] = ACTIONS(1605),
    [aux_sym_preproc_include_token1] = ACTIONS(1605),
    [aux_sym_preproc_def_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token2] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1605),
    [sym_preproc_directive] = ACTIONS(1605),
    [anon_sym_LPAREN2] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym___extension__] = ACTIONS(1605),
    [anon_sym_typedef] = ACTIONS(1605),
    [anon_sym_extern] = ACTIONS(1605),
    [anon_sym___attribute__] = ACTIONS(1605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1607),
    [anon_sym___declspec] = ACTIONS(1605),
    [anon_sym___cdecl] = ACTIONS(1605),
    [anon_sym___clrcall] = ACTIONS(1605),
    [anon_sym___stdcall] = ACTIONS(1605),
    [anon_sym___fastcall] = ACTIONS(1605),
    [anon_sym___thiscall] = ACTIONS(1605),
    [anon_sym___vectorcall] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_signed] = ACTIONS(1605),
    [anon_sym_unsigned] = ACTIONS(1605),
    [anon_sym_long] = ACTIONS(1605),
    [anon_sym_short] = ACTIONS(1605),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_auto] = ACTIONS(1605),
    [anon_sym_register] = ACTIONS(1605),
    [anon_sym_inline] = ACTIONS(1605),
    [anon_sym___inline] = ACTIONS(1605),
    [anon_sym___inline__] = ACTIONS(1605),
    [anon_sym___forceinline] = ACTIONS(1605),
    [anon_sym_thread_local] = ACTIONS(1605),
    [anon_sym___thread] = ACTIONS(1605),
    [anon_sym_const] = ACTIONS(1605),
    [anon_sym_constexpr] = ACTIONS(1605),
    [anon_sym_volatile] = ACTIONS(1605),
    [anon_sym_restrict] = ACTIONS(1605),
    [anon_sym___restrict__] = ACTIONS(1605),
    [anon_sym__Atomic] = ACTIONS(1605),
    [anon_sym__Noreturn] = ACTIONS(1605),
    [anon_sym_noreturn] = ACTIONS(1605),
    [sym_primitive_type] = ACTIONS(1605),
    [anon_sym_enum] = ACTIONS(1605),
    [anon_sym_struct] = ACTIONS(1605),
    [anon_sym_union] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1605),
    [anon_sym_switch] = ACTIONS(1605),
    [anon_sym_case] = ACTIONS(1605),
    [anon_sym_default] = ACTIONS(1605),
    [anon_sym_while] = ACTIONS(1605),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_for] = ACTIONS(1605),
    [anon_sym_return] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1605),
    [anon_sym_goto] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_sizeof] = ACTIONS(1605),
    [anon_sym___alignof__] = ACTIONS(1605),
    [anon_sym___alignof] = ACTIONS(1605),
    [anon_sym__alignof] = ACTIONS(1605),
    [anon_sym_alignof] = ACTIONS(1605),
    [anon_sym__Alignof] = ACTIONS(1605),
    [anon_sym_offsetof] = ACTIONS(1605),
    [anon_sym__Generic] = ACTIONS(1605),
    [anon_sym_asm] = ACTIONS(1605),
    [anon_sym___asm__] = ACTIONS(1605),
    [sym_number_literal] = ACTIONS(1607),
    [anon_sym_L_SQUOTE] = ACTIONS(1607),
    [anon_sym_u_SQUOTE] = ACTIONS(1607),
    [anon_sym_U_SQUOTE] = ACTIONS(1607),
    [anon_sym_u8_SQUOTE] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [anon_sym_L_DQUOTE] = ACTIONS(1607),
    [anon_sym_u_DQUOTE] = ACTIONS(1607),
    [anon_sym_U_DQUOTE] = ACTIONS(1607),
    [anon_sym_u8_DQUOTE] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [anon_sym_NULL] = ACTIONS(1605),
    [anon_sym_nullptr] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1605),
    [anon_sym_acquire] = ACTIONS(1605),
    [anon_sym_monitor] = ACTIONS(1605),
    [anon_sym_start] = ACTIONS(1605),
    [anon_sym_stop] = ACTIONS(1605),
  },
  [500] = {
    [sym_identifier] = ACTIONS(1664),
    [aux_sym_preproc_include_token1] = ACTIONS(1664),
    [aux_sym_preproc_def_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1664),
    [sym_preproc_directive] = ACTIONS(1664),
    [anon_sym_LPAREN2] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym___attribute__] = ACTIONS(1664),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1666),
    [anon_sym___declspec] = ACTIONS(1664),
    [anon_sym___cdecl] = ACTIONS(1664),
    [anon_sym___clrcall] = ACTIONS(1664),
    [anon_sym___stdcall] = ACTIONS(1664),
    [anon_sym___fastcall] = ACTIONS(1664),
    [anon_sym___thiscall] = ACTIONS(1664),
    [anon_sym___vectorcall] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_signed] = ACTIONS(1664),
    [anon_sym_unsigned] = ACTIONS(1664),
    [anon_sym_long] = ACTIONS(1664),
    [anon_sym_short] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_auto] = ACTIONS(1664),
    [anon_sym_register] = ACTIONS(1664),
    [anon_sym_inline] = ACTIONS(1664),
    [anon_sym___inline] = ACTIONS(1664),
    [anon_sym___inline__] = ACTIONS(1664),
    [anon_sym___forceinline] = ACTIONS(1664),
    [anon_sym_thread_local] = ACTIONS(1664),
    [anon_sym___thread] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_constexpr] = ACTIONS(1664),
    [anon_sym_volatile] = ACTIONS(1664),
    [anon_sym_restrict] = ACTIONS(1664),
    [anon_sym___restrict__] = ACTIONS(1664),
    [anon_sym__Atomic] = ACTIONS(1664),
    [anon_sym__Noreturn] = ACTIONS(1664),
    [anon_sym_noreturn] = ACTIONS(1664),
    [sym_primitive_type] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_switch] = ACTIONS(1664),
    [anon_sym_case] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_do] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_goto] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1666),
    [anon_sym_sizeof] = ACTIONS(1664),
    [anon_sym___alignof__] = ACTIONS(1664),
    [anon_sym___alignof] = ACTIONS(1664),
    [anon_sym__alignof] = ACTIONS(1664),
    [anon_sym_alignof] = ACTIONS(1664),
    [anon_sym__Alignof] = ACTIONS(1664),
    [anon_sym_offsetof] = ACTIONS(1664),
    [anon_sym__Generic] = ACTIONS(1664),
    [anon_sym_asm] = ACTIONS(1664),
    [anon_sym___asm__] = ACTIONS(1664),
    [sym_number_literal] = ACTIONS(1666),
    [anon_sym_L_SQUOTE] = ACTIONS(1666),
    [anon_sym_u_SQUOTE] = ACTIONS(1666),
    [anon_sym_U_SQUOTE] = ACTIONS(1666),
    [anon_sym_u8_SQUOTE] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1666),
    [anon_sym_L_DQUOTE] = ACTIONS(1666),
    [anon_sym_u_DQUOTE] = ACTIONS(1666),
    [anon_sym_U_DQUOTE] = ACTIONS(1666),
    [anon_sym_u8_DQUOTE] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1666),
    [sym_true] = ACTIONS(1664),
    [sym_false] = ACTIONS(1664),
    [anon_sym_NULL] = ACTIONS(1664),
    [anon_sym_nullptr] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1664),
    [anon_sym_acquire] = ACTIONS(1664),
    [anon_sym_monitor] = ACTIONS(1664),
    [anon_sym_start] = ACTIONS(1664),
    [anon_sym_stop] = ACTIONS(1664),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1670),
    [sym_identifier] = ACTIONS(1668),
    [aux_sym_preproc_include_token1] = ACTIONS(1668),
    [aux_sym_preproc_def_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1668),
    [sym_preproc_directive] = ACTIONS(1668),
    [anon_sym_LPAREN2] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym___extension__] = ACTIONS(1668),
    [anon_sym_typedef] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym___attribute__] = ACTIONS(1668),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1670),
    [anon_sym___declspec] = ACTIONS(1668),
    [anon_sym___cdecl] = ACTIONS(1668),
    [anon_sym___clrcall] = ACTIONS(1668),
    [anon_sym___stdcall] = ACTIONS(1668),
    [anon_sym___fastcall] = ACTIONS(1668),
    [anon_sym___thiscall] = ACTIONS(1668),
    [anon_sym___vectorcall] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_signed] = ACTIONS(1668),
    [anon_sym_unsigned] = ACTIONS(1668),
    [anon_sym_long] = ACTIONS(1668),
    [anon_sym_short] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_auto] = ACTIONS(1668),
    [anon_sym_register] = ACTIONS(1668),
    [anon_sym_inline] = ACTIONS(1668),
    [anon_sym___inline] = ACTIONS(1668),
    [anon_sym___inline__] = ACTIONS(1668),
    [anon_sym___forceinline] = ACTIONS(1668),
    [anon_sym_thread_local] = ACTIONS(1668),
    [anon_sym___thread] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_constexpr] = ACTIONS(1668),
    [anon_sym_volatile] = ACTIONS(1668),
    [anon_sym_restrict] = ACTIONS(1668),
    [anon_sym___restrict__] = ACTIONS(1668),
    [anon_sym__Atomic] = ACTIONS(1668),
    [anon_sym__Noreturn] = ACTIONS(1668),
    [anon_sym_noreturn] = ACTIONS(1668),
    [sym_primitive_type] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_do] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_goto] = ACTIONS(1668),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_sizeof] = ACTIONS(1668),
    [anon_sym___alignof__] = ACTIONS(1668),
    [anon_sym___alignof] = ACTIONS(1668),
    [anon_sym__alignof] = ACTIONS(1668),
    [anon_sym_alignof] = ACTIONS(1668),
    [anon_sym__Alignof] = ACTIONS(1668),
    [anon_sym_offsetof] = ACTIONS(1668),
    [anon_sym__Generic] = ACTIONS(1668),
    [anon_sym_asm] = ACTIONS(1668),
    [anon_sym___asm__] = ACTIONS(1668),
    [sym_number_literal] = ACTIONS(1670),
    [anon_sym_L_SQUOTE] = ACTIONS(1670),
    [anon_sym_u_SQUOTE] = ACTIONS(1670),
    [anon_sym_U_SQUOTE] = ACTIONS(1670),
    [anon_sym_u8_SQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [anon_sym_L_DQUOTE] = ACTIONS(1670),
    [anon_sym_u_DQUOTE] = ACTIONS(1670),
    [anon_sym_U_DQUOTE] = ACTIONS(1670),
    [anon_sym_u8_DQUOTE] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [anon_sym_NULL] = ACTIONS(1668),
    [anon_sym_nullptr] = ACTIONS(1668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1668),
    [anon_sym_until] = ACTIONS(1668),
    [anon_sym_acquire] = ACTIONS(1668),
    [anon_sym_monitor] = ACTIONS(1668),
    [anon_sym_start] = ACTIONS(1668),
    [anon_sym_stop] = ACTIONS(1668),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1694),
    [sym_identifier] = ACTIONS(1692),
    [aux_sym_preproc_include_token1] = ACTIONS(1692),
    [aux_sym_preproc_def_token1] = ACTIONS(1692),
    [aux_sym_preproc_if_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1692),
    [sym_preproc_directive] = ACTIONS(1692),
    [anon_sym_LPAREN2] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_TILDE] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym___extension__] = ACTIONS(1692),
    [anon_sym_typedef] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym___attribute__] = ACTIONS(1692),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1694),
    [anon_sym___declspec] = ACTIONS(1692),
    [anon_sym___cdecl] = ACTIONS(1692),
    [anon_sym___clrcall] = ACTIONS(1692),
    [anon_sym___stdcall] = ACTIONS(1692),
    [anon_sym___fastcall] = ACTIONS(1692),
    [anon_sym___thiscall] = ACTIONS(1692),
    [anon_sym___vectorcall] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_signed] = ACTIONS(1692),
    [anon_sym_unsigned] = ACTIONS(1692),
    [anon_sym_long] = ACTIONS(1692),
    [anon_sym_short] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_auto] = ACTIONS(1692),
    [anon_sym_register] = ACTIONS(1692),
    [anon_sym_inline] = ACTIONS(1692),
    [anon_sym___inline] = ACTIONS(1692),
    [anon_sym___inline__] = ACTIONS(1692),
    [anon_sym___forceinline] = ACTIONS(1692),
    [anon_sym_thread_local] = ACTIONS(1692),
    [anon_sym___thread] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_constexpr] = ACTIONS(1692),
    [anon_sym_volatile] = ACTIONS(1692),
    [anon_sym_restrict] = ACTIONS(1692),
    [anon_sym___restrict__] = ACTIONS(1692),
    [anon_sym__Atomic] = ACTIONS(1692),
    [anon_sym__Noreturn] = ACTIONS(1692),
    [anon_sym_noreturn] = ACTIONS(1692),
    [sym_primitive_type] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_goto] = ACTIONS(1692),
    [anon_sym_DASH_DASH] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1694),
    [anon_sym_sizeof] = ACTIONS(1692),
    [anon_sym___alignof__] = ACTIONS(1692),
    [anon_sym___alignof] = ACTIONS(1692),
    [anon_sym__alignof] = ACTIONS(1692),
    [anon_sym_alignof] = ACTIONS(1692),
    [anon_sym__Alignof] = ACTIONS(1692),
    [anon_sym_offsetof] = ACTIONS(1692),
    [anon_sym__Generic] = ACTIONS(1692),
    [anon_sym_asm] = ACTIONS(1692),
    [anon_sym___asm__] = ACTIONS(1692),
    [sym_number_literal] = ACTIONS(1694),
    [anon_sym_L_SQUOTE] = ACTIONS(1694),
    [anon_sym_u_SQUOTE] = ACTIONS(1694),
    [anon_sym_U_SQUOTE] = ACTIONS(1694),
    [anon_sym_u8_SQUOTE] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1694),
    [anon_sym_L_DQUOTE] = ACTIONS(1694),
    [anon_sym_u_DQUOTE] = ACTIONS(1694),
    [anon_sym_U_DQUOTE] = ACTIONS(1694),
    [anon_sym_u8_DQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [anon_sym_NULL] = ACTIONS(1692),
    [anon_sym_nullptr] = ACTIONS(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1692),
    [anon_sym_until] = ACTIONS(1692),
    [anon_sym_acquire] = ACTIONS(1692),
    [anon_sym_monitor] = ACTIONS(1692),
    [anon_sym_start] = ACTIONS(1692),
    [anon_sym_stop] = ACTIONS(1692),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1684),
    [aux_sym_preproc_include_token1] = ACTIONS(1684),
    [aux_sym_preproc_def_token1] = ACTIONS(1684),
    [aux_sym_preproc_if_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1684),
    [sym_preproc_directive] = ACTIONS(1684),
    [anon_sym_LPAREN2] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym___extension__] = ACTIONS(1684),
    [anon_sym_typedef] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym___attribute__] = ACTIONS(1684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1686),
    [anon_sym___declspec] = ACTIONS(1684),
    [anon_sym___cdecl] = ACTIONS(1684),
    [anon_sym___clrcall] = ACTIONS(1684),
    [anon_sym___stdcall] = ACTIONS(1684),
    [anon_sym___fastcall] = ACTIONS(1684),
    [anon_sym___thiscall] = ACTIONS(1684),
    [anon_sym___vectorcall] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_signed] = ACTIONS(1684),
    [anon_sym_unsigned] = ACTIONS(1684),
    [anon_sym_long] = ACTIONS(1684),
    [anon_sym_short] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_auto] = ACTIONS(1684),
    [anon_sym_register] = ACTIONS(1684),
    [anon_sym_inline] = ACTIONS(1684),
    [anon_sym___inline] = ACTIONS(1684),
    [anon_sym___inline__] = ACTIONS(1684),
    [anon_sym___forceinline] = ACTIONS(1684),
    [anon_sym_thread_local] = ACTIONS(1684),
    [anon_sym___thread] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_constexpr] = ACTIONS(1684),
    [anon_sym_volatile] = ACTIONS(1684),
    [anon_sym_restrict] = ACTIONS(1684),
    [anon_sym___restrict__] = ACTIONS(1684),
    [anon_sym__Atomic] = ACTIONS(1684),
    [anon_sym__Noreturn] = ACTIONS(1684),
    [anon_sym_noreturn] = ACTIONS(1684),
    [sym_primitive_type] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_do] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1684),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_sizeof] = ACTIONS(1684),
    [anon_sym___alignof__] = ACTIONS(1684),
    [anon_sym___alignof] = ACTIONS(1684),
    [anon_sym__alignof] = ACTIONS(1684),
    [anon_sym_alignof] = ACTIONS(1684),
    [anon_sym__Alignof] = ACTIONS(1684),
    [anon_sym_offsetof] = ACTIONS(1684),
    [anon_sym__Generic] = ACTIONS(1684),
    [anon_sym_asm] = ACTIONS(1684),
    [anon_sym___asm__] = ACTIONS(1684),
    [sym_number_literal] = ACTIONS(1686),
    [anon_sym_L_SQUOTE] = ACTIONS(1686),
    [anon_sym_u_SQUOTE] = ACTIONS(1686),
    [anon_sym_U_SQUOTE] = ACTIONS(1686),
    [anon_sym_u8_SQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [anon_sym_L_DQUOTE] = ACTIONS(1686),
    [anon_sym_u_DQUOTE] = ACTIONS(1686),
    [anon_sym_U_DQUOTE] = ACTIONS(1686),
    [anon_sym_u8_DQUOTE] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [anon_sym_NULL] = ACTIONS(1684),
    [anon_sym_nullptr] = ACTIONS(1684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1684),
    [anon_sym_until] = ACTIONS(1684),
    [anon_sym_acquire] = ACTIONS(1684),
    [anon_sym_monitor] = ACTIONS(1684),
    [anon_sym_start] = ACTIONS(1684),
    [anon_sym_stop] = ACTIONS(1684),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1680),
    [aux_sym_preproc_include_token1] = ACTIONS(1680),
    [aux_sym_preproc_def_token1] = ACTIONS(1680),
    [aux_sym_preproc_if_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1680),
    [sym_preproc_directive] = ACTIONS(1680),
    [anon_sym_LPAREN2] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_TILDE] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym___extension__] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym___attribute__] = ACTIONS(1680),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1682),
    [anon_sym___declspec] = ACTIONS(1680),
    [anon_sym___cdecl] = ACTIONS(1680),
    [anon_sym___clrcall] = ACTIONS(1680),
    [anon_sym___stdcall] = ACTIONS(1680),
    [anon_sym___fastcall] = ACTIONS(1680),
    [anon_sym___thiscall] = ACTIONS(1680),
    [anon_sym___vectorcall] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_signed] = ACTIONS(1680),
    [anon_sym_unsigned] = ACTIONS(1680),
    [anon_sym_long] = ACTIONS(1680),
    [anon_sym_short] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_auto] = ACTIONS(1680),
    [anon_sym_register] = ACTIONS(1680),
    [anon_sym_inline] = ACTIONS(1680),
    [anon_sym___inline] = ACTIONS(1680),
    [anon_sym___inline__] = ACTIONS(1680),
    [anon_sym___forceinline] = ACTIONS(1680),
    [anon_sym_thread_local] = ACTIONS(1680),
    [anon_sym___thread] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_constexpr] = ACTIONS(1680),
    [anon_sym_volatile] = ACTIONS(1680),
    [anon_sym_restrict] = ACTIONS(1680),
    [anon_sym___restrict__] = ACTIONS(1680),
    [anon_sym__Atomic] = ACTIONS(1680),
    [anon_sym__Noreturn] = ACTIONS(1680),
    [anon_sym_noreturn] = ACTIONS(1680),
    [sym_primitive_type] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_switch] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_do] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_goto] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1682),
    [anon_sym_sizeof] = ACTIONS(1680),
    [anon_sym___alignof__] = ACTIONS(1680),
    [anon_sym___alignof] = ACTIONS(1680),
    [anon_sym__alignof] = ACTIONS(1680),
    [anon_sym_alignof] = ACTIONS(1680),
    [anon_sym__Alignof] = ACTIONS(1680),
    [anon_sym_offsetof] = ACTIONS(1680),
    [anon_sym__Generic] = ACTIONS(1680),
    [anon_sym_asm] = ACTIONS(1680),
    [anon_sym___asm__] = ACTIONS(1680),
    [sym_number_literal] = ACTIONS(1682),
    [anon_sym_L_SQUOTE] = ACTIONS(1682),
    [anon_sym_u_SQUOTE] = ACTIONS(1682),
    [anon_sym_U_SQUOTE] = ACTIONS(1682),
    [anon_sym_u8_SQUOTE] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1682),
    [anon_sym_L_DQUOTE] = ACTIONS(1682),
    [anon_sym_u_DQUOTE] = ACTIONS(1682),
    [anon_sym_U_DQUOTE] = ACTIONS(1682),
    [anon_sym_u8_DQUOTE] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [anon_sym_NULL] = ACTIONS(1680),
    [anon_sym_nullptr] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1680),
    [anon_sym_until] = ACTIONS(1680),
    [anon_sym_acquire] = ACTIONS(1680),
    [anon_sym_monitor] = ACTIONS(1680),
    [anon_sym_start] = ACTIONS(1680),
    [anon_sym_stop] = ACTIONS(1680),
  },
  [505] = {
    [sym_identifier] = ACTIONS(1664),
    [aux_sym_preproc_include_token1] = ACTIONS(1664),
    [aux_sym_preproc_def_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token1] = ACTIONS(1664),
    [aux_sym_preproc_if_token2] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1664),
    [sym_preproc_directive] = ACTIONS(1664),
    [anon_sym_LPAREN2] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym___attribute__] = ACTIONS(1664),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1666),
    [anon_sym___declspec] = ACTIONS(1664),
    [anon_sym___cdecl] = ACTIONS(1664),
    [anon_sym___clrcall] = ACTIONS(1664),
    [anon_sym___stdcall] = ACTIONS(1664),
    [anon_sym___fastcall] = ACTIONS(1664),
    [anon_sym___thiscall] = ACTIONS(1664),
    [anon_sym___vectorcall] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_signed] = ACTIONS(1664),
    [anon_sym_unsigned] = ACTIONS(1664),
    [anon_sym_long] = ACTIONS(1664),
    [anon_sym_short] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_auto] = ACTIONS(1664),
    [anon_sym_register] = ACTIONS(1664),
    [anon_sym_inline] = ACTIONS(1664),
    [anon_sym___inline] = ACTIONS(1664),
    [anon_sym___inline__] = ACTIONS(1664),
    [anon_sym___forceinline] = ACTIONS(1664),
    [anon_sym_thread_local] = ACTIONS(1664),
    [anon_sym___thread] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_constexpr] = ACTIONS(1664),
    [anon_sym_volatile] = ACTIONS(1664),
    [anon_sym_restrict] = ACTIONS(1664),
    [anon_sym___restrict__] = ACTIONS(1664),
    [anon_sym__Atomic] = ACTIONS(1664),
    [anon_sym__Noreturn] = ACTIONS(1664),
    [anon_sym_noreturn] = ACTIONS(1664),
    [sym_primitive_type] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_switch] = ACTIONS(1664),
    [anon_sym_case] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_do] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_goto] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1666),
    [anon_sym_sizeof] = ACTIONS(1664),
    [anon_sym___alignof__] = ACTIONS(1664),
    [anon_sym___alignof] = ACTIONS(1664),
    [anon_sym__alignof] = ACTIONS(1664),
    [anon_sym_alignof] = ACTIONS(1664),
    [anon_sym__Alignof] = ACTIONS(1664),
    [anon_sym_offsetof] = ACTIONS(1664),
    [anon_sym__Generic] = ACTIONS(1664),
    [anon_sym_asm] = ACTIONS(1664),
    [anon_sym___asm__] = ACTIONS(1664),
    [sym_number_literal] = ACTIONS(1666),
    [anon_sym_L_SQUOTE] = ACTIONS(1666),
    [anon_sym_u_SQUOTE] = ACTIONS(1666),
    [anon_sym_U_SQUOTE] = ACTIONS(1666),
    [anon_sym_u8_SQUOTE] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1666),
    [anon_sym_L_DQUOTE] = ACTIONS(1666),
    [anon_sym_u_DQUOTE] = ACTIONS(1666),
    [anon_sym_U_DQUOTE] = ACTIONS(1666),
    [anon_sym_u8_DQUOTE] = ACTIONS(1666),
    [anon_sym_DQUOTE] = ACTIONS(1666),
    [sym_true] = ACTIONS(1664),
    [sym_false] = ACTIONS(1664),
    [anon_sym_NULL] = ACTIONS(1664),
    [anon_sym_nullptr] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1664),
    [anon_sym_acquire] = ACTIONS(1664),
    [anon_sym_monitor] = ACTIONS(1664),
    [anon_sym_start] = ACTIONS(1664),
    [anon_sym_stop] = ACTIONS(1664),
  },
  [506] = {
    [sym_identifier] = ACTIONS(1633),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token2] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1633),
    [anon_sym_typedef] = ACTIONS(1633),
    [anon_sym_extern] = ACTIONS(1633),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1635),
    [anon_sym___declspec] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_signed] = ACTIONS(1633),
    [anon_sym_unsigned] = ACTIONS(1633),
    [anon_sym_long] = ACTIONS(1633),
    [anon_sym_short] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_auto] = ACTIONS(1633),
    [anon_sym_register] = ACTIONS(1633),
    [anon_sym_inline] = ACTIONS(1633),
    [anon_sym___inline] = ACTIONS(1633),
    [anon_sym___inline__] = ACTIONS(1633),
    [anon_sym___forceinline] = ACTIONS(1633),
    [anon_sym_thread_local] = ACTIONS(1633),
    [anon_sym___thread] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1633),
    [anon_sym_constexpr] = ACTIONS(1633),
    [anon_sym_volatile] = ACTIONS(1633),
    [anon_sym_restrict] = ACTIONS(1633),
    [anon_sym___restrict__] = ACTIONS(1633),
    [anon_sym__Atomic] = ACTIONS(1633),
    [anon_sym__Noreturn] = ACTIONS(1633),
    [anon_sym_noreturn] = ACTIONS(1633),
    [sym_primitive_type] = ACTIONS(1633),
    [anon_sym_enum] = ACTIONS(1633),
    [anon_sym_struct] = ACTIONS(1633),
    [anon_sym_union] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1633),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_for] = ACTIONS(1633),
    [anon_sym_return] = ACTIONS(1633),
    [anon_sym_break] = ACTIONS(1633),
    [anon_sym_continue] = ACTIONS(1633),
    [anon_sym_goto] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_sizeof] = ACTIONS(1633),
    [anon_sym___alignof__] = ACTIONS(1633),
    [anon_sym___alignof] = ACTIONS(1633),
    [anon_sym__alignof] = ACTIONS(1633),
    [anon_sym_alignof] = ACTIONS(1633),
    [anon_sym__Alignof] = ACTIONS(1633),
    [anon_sym_offsetof] = ACTIONS(1633),
    [anon_sym__Generic] = ACTIONS(1633),
    [anon_sym_asm] = ACTIONS(1633),
    [anon_sym___asm__] = ACTIONS(1633),
    [sym_number_literal] = ACTIONS(1635),
    [anon_sym_L_SQUOTE] = ACTIONS(1635),
    [anon_sym_u_SQUOTE] = ACTIONS(1635),
    [anon_sym_U_SQUOTE] = ACTIONS(1635),
    [anon_sym_u8_SQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_L_DQUOTE] = ACTIONS(1635),
    [anon_sym_u_DQUOTE] = ACTIONS(1635),
    [anon_sym_U_DQUOTE] = ACTIONS(1635),
    [anon_sym_u8_DQUOTE] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [anon_sym_NULL] = ACTIONS(1633),
    [anon_sym_nullptr] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1633),
    [anon_sym_acquire] = ACTIONS(1633),
    [anon_sym_monitor] = ACTIONS(1633),
    [anon_sym_start] = ACTIONS(1633),
    [anon_sym_stop] = ACTIONS(1633),
  },
  [507] = {
    [sym_identifier] = ACTIONS(1648),
    [aux_sym_preproc_include_token1] = ACTIONS(1648),
    [aux_sym_preproc_def_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token1] = ACTIONS(1648),
    [aux_sym_preproc_if_token2] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1648),
    [sym_preproc_directive] = ACTIONS(1648),
    [anon_sym_LPAREN2] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym___extension__] = ACTIONS(1648),
    [anon_sym_typedef] = ACTIONS(1648),
    [anon_sym_extern] = ACTIONS(1648),
    [anon_sym___attribute__] = ACTIONS(1648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1650),
    [anon_sym___declspec] = ACTIONS(1648),
    [anon_sym___cdecl] = ACTIONS(1648),
    [anon_sym___clrcall] = ACTIONS(1648),
    [anon_sym___stdcall] = ACTIONS(1648),
    [anon_sym___fastcall] = ACTIONS(1648),
    [anon_sym___thiscall] = ACTIONS(1648),
    [anon_sym___vectorcall] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_signed] = ACTIONS(1648),
    [anon_sym_unsigned] = ACTIONS(1648),
    [anon_sym_long] = ACTIONS(1648),
    [anon_sym_short] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1648),
    [anon_sym_auto] = ACTIONS(1648),
    [anon_sym_register] = ACTIONS(1648),
    [anon_sym_inline] = ACTIONS(1648),
    [anon_sym___inline] = ACTIONS(1648),
    [anon_sym___inline__] = ACTIONS(1648),
    [anon_sym___forceinline] = ACTIONS(1648),
    [anon_sym_thread_local] = ACTIONS(1648),
    [anon_sym___thread] = ACTIONS(1648),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_constexpr] = ACTIONS(1648),
    [anon_sym_volatile] = ACTIONS(1648),
    [anon_sym_restrict] = ACTIONS(1648),
    [anon_sym___restrict__] = ACTIONS(1648),
    [anon_sym__Atomic] = ACTIONS(1648),
    [anon_sym__Noreturn] = ACTIONS(1648),
    [anon_sym_noreturn] = ACTIONS(1648),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1648),
    [anon_sym_struct] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_if] = ACTIONS(1648),
    [anon_sym_switch] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_while] = ACTIONS(1648),
    [anon_sym_do] = ACTIONS(1648),
    [anon_sym_for] = ACTIONS(1648),
    [anon_sym_return] = ACTIONS(1648),
    [anon_sym_break] = ACTIONS(1648),
    [anon_sym_continue] = ACTIONS(1648),
    [anon_sym_goto] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1650),
    [anon_sym_sizeof] = ACTIONS(1648),
    [anon_sym___alignof__] = ACTIONS(1648),
    [anon_sym___alignof] = ACTIONS(1648),
    [anon_sym__alignof] = ACTIONS(1648),
    [anon_sym_alignof] = ACTIONS(1648),
    [anon_sym__Alignof] = ACTIONS(1648),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1648),
    [anon_sym_asm] = ACTIONS(1648),
    [anon_sym___asm__] = ACTIONS(1648),
    [sym_number_literal] = ACTIONS(1650),
    [anon_sym_L_SQUOTE] = ACTIONS(1650),
    [anon_sym_u_SQUOTE] = ACTIONS(1650),
    [anon_sym_U_SQUOTE] = ACTIONS(1650),
    [anon_sym_u8_SQUOTE] = ACTIONS(1650),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [anon_sym_L_DQUOTE] = ACTIONS(1650),
    [anon_sym_u_DQUOTE] = ACTIONS(1650),
    [anon_sym_U_DQUOTE] = ACTIONS(1650),
    [anon_sym_u8_DQUOTE] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [sym_true] = ACTIONS(1648),
    [sym_false] = ACTIONS(1648),
    [anon_sym_NULL] = ACTIONS(1648),
    [anon_sym_nullptr] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1648),
    [anon_sym_acquire] = ACTIONS(1648),
    [anon_sym_monitor] = ACTIONS(1648),
    [anon_sym_start] = ACTIONS(1648),
    [anon_sym_stop] = ACTIONS(1648),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1662),
    [sym_identifier] = ACTIONS(1660),
    [aux_sym_preproc_include_token1] = ACTIONS(1660),
    [aux_sym_preproc_def_token1] = ACTIONS(1660),
    [aux_sym_preproc_if_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1660),
    [sym_preproc_directive] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_TILDE] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1660),
    [anon_sym_typedef] = ACTIONS(1660),
    [anon_sym_extern] = ACTIONS(1660),
    [anon_sym___attribute__] = ACTIONS(1660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1662),
    [anon_sym___declspec] = ACTIONS(1660),
    [anon_sym___cdecl] = ACTIONS(1660),
    [anon_sym___clrcall] = ACTIONS(1660),
    [anon_sym___stdcall] = ACTIONS(1660),
    [anon_sym___fastcall] = ACTIONS(1660),
    [anon_sym___thiscall] = ACTIONS(1660),
    [anon_sym___vectorcall] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_signed] = ACTIONS(1660),
    [anon_sym_unsigned] = ACTIONS(1660),
    [anon_sym_long] = ACTIONS(1660),
    [anon_sym_short] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_auto] = ACTIONS(1660),
    [anon_sym_register] = ACTIONS(1660),
    [anon_sym_inline] = ACTIONS(1660),
    [anon_sym___inline] = ACTIONS(1660),
    [anon_sym___inline__] = ACTIONS(1660),
    [anon_sym___forceinline] = ACTIONS(1660),
    [anon_sym_thread_local] = ACTIONS(1660),
    [anon_sym___thread] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1660),
    [anon_sym_constexpr] = ACTIONS(1660),
    [anon_sym_volatile] = ACTIONS(1660),
    [anon_sym_restrict] = ACTIONS(1660),
    [anon_sym___restrict__] = ACTIONS(1660),
    [anon_sym__Atomic] = ACTIONS(1660),
    [anon_sym__Noreturn] = ACTIONS(1660),
    [anon_sym_noreturn] = ACTIONS(1660),
    [sym_primitive_type] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1660),
    [anon_sym_struct] = ACTIONS(1660),
    [anon_sym_union] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1660),
    [anon_sym_switch] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1660),
    [anon_sym_default] = ACTIONS(1660),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_return] = ACTIONS(1660),
    [anon_sym_break] = ACTIONS(1660),
    [anon_sym_continue] = ACTIONS(1660),
    [anon_sym_goto] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1662),
    [anon_sym_sizeof] = ACTIONS(1660),
    [anon_sym___alignof__] = ACTIONS(1660),
    [anon_sym___alignof] = ACTIONS(1660),
    [anon_sym__alignof] = ACTIONS(1660),
    [anon_sym_alignof] = ACTIONS(1660),
    [anon_sym__Alignof] = ACTIONS(1660),
    [anon_sym_offsetof] = ACTIONS(1660),
    [anon_sym__Generic] = ACTIONS(1660),
    [anon_sym_asm] = ACTIONS(1660),
    [anon_sym___asm__] = ACTIONS(1660),
    [sym_number_literal] = ACTIONS(1662),
    [anon_sym_L_SQUOTE] = ACTIONS(1662),
    [anon_sym_u_SQUOTE] = ACTIONS(1662),
    [anon_sym_U_SQUOTE] = ACTIONS(1662),
    [anon_sym_u8_SQUOTE] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1662),
    [anon_sym_L_DQUOTE] = ACTIONS(1662),
    [anon_sym_u_DQUOTE] = ACTIONS(1662),
    [anon_sym_U_DQUOTE] = ACTIONS(1662),
    [anon_sym_u8_DQUOTE] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [sym_true] = ACTIONS(1660),
    [sym_false] = ACTIONS(1660),
    [anon_sym_NULL] = ACTIONS(1660),
    [anon_sym_nullptr] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1660),
    [anon_sym_until] = ACTIONS(1660),
    [anon_sym_acquire] = ACTIONS(1660),
    [anon_sym_monitor] = ACTIONS(1660),
    [anon_sym_start] = ACTIONS(1660),
    [anon_sym_stop] = ACTIONS(1660),
  },
  [509] = {
    [sym_identifier] = ACTIONS(1597),
    [aux_sym_preproc_include_token1] = ACTIONS(1597),
    [aux_sym_preproc_def_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token2] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1597),
    [sym_preproc_directive] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym___extension__] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1597),
    [anon_sym_extern] = ACTIONS(1597),
    [anon_sym___attribute__] = ACTIONS(1597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1599),
    [anon_sym___declspec] = ACTIONS(1597),
    [anon_sym___cdecl] = ACTIONS(1597),
    [anon_sym___clrcall] = ACTIONS(1597),
    [anon_sym___stdcall] = ACTIONS(1597),
    [anon_sym___fastcall] = ACTIONS(1597),
    [anon_sym___thiscall] = ACTIONS(1597),
    [anon_sym___vectorcall] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_signed] = ACTIONS(1597),
    [anon_sym_unsigned] = ACTIONS(1597),
    [anon_sym_long] = ACTIONS(1597),
    [anon_sym_short] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_auto] = ACTIONS(1597),
    [anon_sym_register] = ACTIONS(1597),
    [anon_sym_inline] = ACTIONS(1597),
    [anon_sym___inline] = ACTIONS(1597),
    [anon_sym___inline__] = ACTIONS(1597),
    [anon_sym___forceinline] = ACTIONS(1597),
    [anon_sym_thread_local] = ACTIONS(1597),
    [anon_sym___thread] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(1597),
    [anon_sym_constexpr] = ACTIONS(1597),
    [anon_sym_volatile] = ACTIONS(1597),
    [anon_sym_restrict] = ACTIONS(1597),
    [anon_sym___restrict__] = ACTIONS(1597),
    [anon_sym__Atomic] = ACTIONS(1597),
    [anon_sym__Noreturn] = ACTIONS(1597),
    [anon_sym_noreturn] = ACTIONS(1597),
    [sym_primitive_type] = ACTIONS(1597),
    [anon_sym_enum] = ACTIONS(1597),
    [anon_sym_struct] = ACTIONS(1597),
    [anon_sym_union] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1597),
    [anon_sym_switch] = ACTIONS(1597),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1597),
    [anon_sym_while] = ACTIONS(1597),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_for] = ACTIONS(1597),
    [anon_sym_return] = ACTIONS(1597),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1597),
    [anon_sym_goto] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_sizeof] = ACTIONS(1597),
    [anon_sym___alignof__] = ACTIONS(1597),
    [anon_sym___alignof] = ACTIONS(1597),
    [anon_sym__alignof] = ACTIONS(1597),
    [anon_sym_alignof] = ACTIONS(1597),
    [anon_sym__Alignof] = ACTIONS(1597),
    [anon_sym_offsetof] = ACTIONS(1597),
    [anon_sym__Generic] = ACTIONS(1597),
    [anon_sym_asm] = ACTIONS(1597),
    [anon_sym___asm__] = ACTIONS(1597),
    [sym_number_literal] = ACTIONS(1599),
    [anon_sym_L_SQUOTE] = ACTIONS(1599),
    [anon_sym_u_SQUOTE] = ACTIONS(1599),
    [anon_sym_U_SQUOTE] = ACTIONS(1599),
    [anon_sym_u8_SQUOTE] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [anon_sym_L_DQUOTE] = ACTIONS(1599),
    [anon_sym_u_DQUOTE] = ACTIONS(1599),
    [anon_sym_U_DQUOTE] = ACTIONS(1599),
    [anon_sym_u8_DQUOTE] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [anon_sym_NULL] = ACTIONS(1597),
    [anon_sym_nullptr] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1597),
    [anon_sym_acquire] = ACTIONS(1597),
    [anon_sym_monitor] = ACTIONS(1597),
    [anon_sym_start] = ACTIONS(1597),
    [anon_sym_stop] = ACTIONS(1597),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1658),
    [sym_identifier] = ACTIONS(1656),
    [aux_sym_preproc_include_token1] = ACTIONS(1656),
    [aux_sym_preproc_def_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1656),
    [sym_preproc_directive] = ACTIONS(1656),
    [anon_sym_LPAREN2] = ACTIONS(1658),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_TILDE] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym___extension__] = ACTIONS(1656),
    [anon_sym_typedef] = ACTIONS(1656),
    [anon_sym_extern] = ACTIONS(1656),
    [anon_sym___attribute__] = ACTIONS(1656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1658),
    [anon_sym___declspec] = ACTIONS(1656),
    [anon_sym___cdecl] = ACTIONS(1656),
    [anon_sym___clrcall] = ACTIONS(1656),
    [anon_sym___stdcall] = ACTIONS(1656),
    [anon_sym___fastcall] = ACTIONS(1656),
    [anon_sym___thiscall] = ACTIONS(1656),
    [anon_sym___vectorcall] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1658),
    [anon_sym_signed] = ACTIONS(1656),
    [anon_sym_unsigned] = ACTIONS(1656),
    [anon_sym_long] = ACTIONS(1656),
    [anon_sym_short] = ACTIONS(1656),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_auto] = ACTIONS(1656),
    [anon_sym_register] = ACTIONS(1656),
    [anon_sym_inline] = ACTIONS(1656),
    [anon_sym___inline] = ACTIONS(1656),
    [anon_sym___inline__] = ACTIONS(1656),
    [anon_sym___forceinline] = ACTIONS(1656),
    [anon_sym_thread_local] = ACTIONS(1656),
    [anon_sym___thread] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_constexpr] = ACTIONS(1656),
    [anon_sym_volatile] = ACTIONS(1656),
    [anon_sym_restrict] = ACTIONS(1656),
    [anon_sym___restrict__] = ACTIONS(1656),
    [anon_sym__Atomic] = ACTIONS(1656),
    [anon_sym__Noreturn] = ACTIONS(1656),
    [anon_sym_noreturn] = ACTIONS(1656),
    [sym_primitive_type] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_struct] = ACTIONS(1656),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_goto] = ACTIONS(1656),
    [anon_sym_DASH_DASH] = ACTIONS(1658),
    [anon_sym_PLUS_PLUS] = ACTIONS(1658),
    [anon_sym_sizeof] = ACTIONS(1656),
    [anon_sym___alignof__] = ACTIONS(1656),
    [anon_sym___alignof] = ACTIONS(1656),
    [anon_sym__alignof] = ACTIONS(1656),
    [anon_sym_alignof] = ACTIONS(1656),
    [anon_sym__Alignof] = ACTIONS(1656),
    [anon_sym_offsetof] = ACTIONS(1656),
    [anon_sym__Generic] = ACTIONS(1656),
    [anon_sym_asm] = ACTIONS(1656),
    [anon_sym___asm__] = ACTIONS(1656),
    [sym_number_literal] = ACTIONS(1658),
    [anon_sym_L_SQUOTE] = ACTIONS(1658),
    [anon_sym_u_SQUOTE] = ACTIONS(1658),
    [anon_sym_U_SQUOTE] = ACTIONS(1658),
    [anon_sym_u8_SQUOTE] = ACTIONS(1658),
    [anon_sym_SQUOTE] = ACTIONS(1658),
    [anon_sym_L_DQUOTE] = ACTIONS(1658),
    [anon_sym_u_DQUOTE] = ACTIONS(1658),
    [anon_sym_U_DQUOTE] = ACTIONS(1658),
    [anon_sym_u8_DQUOTE] = ACTIONS(1658),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [anon_sym_NULL] = ACTIONS(1656),
    [anon_sym_nullptr] = ACTIONS(1656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1656),
    [anon_sym_until] = ACTIONS(1656),
    [anon_sym_acquire] = ACTIONS(1656),
    [anon_sym_monitor] = ACTIONS(1656),
    [anon_sym_start] = ACTIONS(1656),
    [anon_sym_stop] = ACTIONS(1656),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1635),
    [sym_identifier] = ACTIONS(1633),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1633),
    [anon_sym_typedef] = ACTIONS(1633),
    [anon_sym_extern] = ACTIONS(1633),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1635),
    [anon_sym___declspec] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_signed] = ACTIONS(1633),
    [anon_sym_unsigned] = ACTIONS(1633),
    [anon_sym_long] = ACTIONS(1633),
    [anon_sym_short] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_auto] = ACTIONS(1633),
    [anon_sym_register] = ACTIONS(1633),
    [anon_sym_inline] = ACTIONS(1633),
    [anon_sym___inline] = ACTIONS(1633),
    [anon_sym___inline__] = ACTIONS(1633),
    [anon_sym___forceinline] = ACTIONS(1633),
    [anon_sym_thread_local] = ACTIONS(1633),
    [anon_sym___thread] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1633),
    [anon_sym_constexpr] = ACTIONS(1633),
    [anon_sym_volatile] = ACTIONS(1633),
    [anon_sym_restrict] = ACTIONS(1633),
    [anon_sym___restrict__] = ACTIONS(1633),
    [anon_sym__Atomic] = ACTIONS(1633),
    [anon_sym__Noreturn] = ACTIONS(1633),
    [anon_sym_noreturn] = ACTIONS(1633),
    [sym_primitive_type] = ACTIONS(1633),
    [anon_sym_enum] = ACTIONS(1633),
    [anon_sym_struct] = ACTIONS(1633),
    [anon_sym_union] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1633),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_for] = ACTIONS(1633),
    [anon_sym_return] = ACTIONS(1633),
    [anon_sym_break] = ACTIONS(1633),
    [anon_sym_continue] = ACTIONS(1633),
    [anon_sym_goto] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_sizeof] = ACTIONS(1633),
    [anon_sym___alignof__] = ACTIONS(1633),
    [anon_sym___alignof] = ACTIONS(1633),
    [anon_sym__alignof] = ACTIONS(1633),
    [anon_sym_alignof] = ACTIONS(1633),
    [anon_sym__Alignof] = ACTIONS(1633),
    [anon_sym_offsetof] = ACTIONS(1633),
    [anon_sym__Generic] = ACTIONS(1633),
    [anon_sym_asm] = ACTIONS(1633),
    [anon_sym___asm__] = ACTIONS(1633),
    [sym_number_literal] = ACTIONS(1635),
    [anon_sym_L_SQUOTE] = ACTIONS(1635),
    [anon_sym_u_SQUOTE] = ACTIONS(1635),
    [anon_sym_U_SQUOTE] = ACTIONS(1635),
    [anon_sym_u8_SQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_L_DQUOTE] = ACTIONS(1635),
    [anon_sym_u_DQUOTE] = ACTIONS(1635),
    [anon_sym_U_DQUOTE] = ACTIONS(1635),
    [anon_sym_u8_DQUOTE] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [anon_sym_NULL] = ACTIONS(1633),
    [anon_sym_nullptr] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1633),
    [anon_sym_until] = ACTIONS(1633),
    [anon_sym_acquire] = ACTIONS(1633),
    [anon_sym_monitor] = ACTIONS(1633),
    [anon_sym_start] = ACTIONS(1633),
    [anon_sym_stop] = ACTIONS(1633),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1597),
    [aux_sym_preproc_include_token1] = ACTIONS(1597),
    [aux_sym_preproc_def_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1597),
    [sym_preproc_directive] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym___extension__] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1597),
    [anon_sym_extern] = ACTIONS(1597),
    [anon_sym___attribute__] = ACTIONS(1597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1599),
    [anon_sym___declspec] = ACTIONS(1597),
    [anon_sym___cdecl] = ACTIONS(1597),
    [anon_sym___clrcall] = ACTIONS(1597),
    [anon_sym___stdcall] = ACTIONS(1597),
    [anon_sym___fastcall] = ACTIONS(1597),
    [anon_sym___thiscall] = ACTIONS(1597),
    [anon_sym___vectorcall] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_signed] = ACTIONS(1597),
    [anon_sym_unsigned] = ACTIONS(1597),
    [anon_sym_long] = ACTIONS(1597),
    [anon_sym_short] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_auto] = ACTIONS(1597),
    [anon_sym_register] = ACTIONS(1597),
    [anon_sym_inline] = ACTIONS(1597),
    [anon_sym___inline] = ACTIONS(1597),
    [anon_sym___inline__] = ACTIONS(1597),
    [anon_sym___forceinline] = ACTIONS(1597),
    [anon_sym_thread_local] = ACTIONS(1597),
    [anon_sym___thread] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(1597),
    [anon_sym_constexpr] = ACTIONS(1597),
    [anon_sym_volatile] = ACTIONS(1597),
    [anon_sym_restrict] = ACTIONS(1597),
    [anon_sym___restrict__] = ACTIONS(1597),
    [anon_sym__Atomic] = ACTIONS(1597),
    [anon_sym__Noreturn] = ACTIONS(1597),
    [anon_sym_noreturn] = ACTIONS(1597),
    [sym_primitive_type] = ACTIONS(1597),
    [anon_sym_enum] = ACTIONS(1597),
    [anon_sym_struct] = ACTIONS(1597),
    [anon_sym_union] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1597),
    [anon_sym_switch] = ACTIONS(1597),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1597),
    [anon_sym_while] = ACTIONS(1597),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_for] = ACTIONS(1597),
    [anon_sym_return] = ACTIONS(1597),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1597),
    [anon_sym_goto] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_sizeof] = ACTIONS(1597),
    [anon_sym___alignof__] = ACTIONS(1597),
    [anon_sym___alignof] = ACTIONS(1597),
    [anon_sym__alignof] = ACTIONS(1597),
    [anon_sym_alignof] = ACTIONS(1597),
    [anon_sym__Alignof] = ACTIONS(1597),
    [anon_sym_offsetof] = ACTIONS(1597),
    [anon_sym__Generic] = ACTIONS(1597),
    [anon_sym_asm] = ACTIONS(1597),
    [anon_sym___asm__] = ACTIONS(1597),
    [sym_number_literal] = ACTIONS(1599),
    [anon_sym_L_SQUOTE] = ACTIONS(1599),
    [anon_sym_u_SQUOTE] = ACTIONS(1599),
    [anon_sym_U_SQUOTE] = ACTIONS(1599),
    [anon_sym_u8_SQUOTE] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [anon_sym_L_DQUOTE] = ACTIONS(1599),
    [anon_sym_u_DQUOTE] = ACTIONS(1599),
    [anon_sym_U_DQUOTE] = ACTIONS(1599),
    [anon_sym_u8_DQUOTE] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [anon_sym_NULL] = ACTIONS(1597),
    [anon_sym_nullptr] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1597),
    [anon_sym_until] = ACTIONS(1597),
    [anon_sym_acquire] = ACTIONS(1597),
    [anon_sym_monitor] = ACTIONS(1597),
    [anon_sym_start] = ACTIONS(1597),
    [anon_sym_stop] = ACTIONS(1597),
  },
  [513] = {
    [sym_identifier] = ACTIONS(1611),
    [aux_sym_preproc_include_token1] = ACTIONS(1611),
    [aux_sym_preproc_def_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1611),
    [sym_preproc_directive] = ACTIONS(1611),
    [anon_sym_LPAREN2] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym___extension__] = ACTIONS(1611),
    [anon_sym_typedef] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym___attribute__] = ACTIONS(1611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1613),
    [anon_sym___declspec] = ACTIONS(1611),
    [anon_sym___cdecl] = ACTIONS(1611),
    [anon_sym___clrcall] = ACTIONS(1611),
    [anon_sym___stdcall] = ACTIONS(1611),
    [anon_sym___fastcall] = ACTIONS(1611),
    [anon_sym___thiscall] = ACTIONS(1611),
    [anon_sym___vectorcall] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [anon_sym_signed] = ACTIONS(1611),
    [anon_sym_unsigned] = ACTIONS(1611),
    [anon_sym_long] = ACTIONS(1611),
    [anon_sym_short] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_auto] = ACTIONS(1611),
    [anon_sym_register] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym___inline] = ACTIONS(1611),
    [anon_sym___inline__] = ACTIONS(1611),
    [anon_sym___forceinline] = ACTIONS(1611),
    [anon_sym_thread_local] = ACTIONS(1611),
    [anon_sym___thread] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_constexpr] = ACTIONS(1611),
    [anon_sym_volatile] = ACTIONS(1611),
    [anon_sym_restrict] = ACTIONS(1611),
    [anon_sym___restrict__] = ACTIONS(1611),
    [anon_sym__Atomic] = ACTIONS(1611),
    [anon_sym__Noreturn] = ACTIONS(1611),
    [anon_sym_noreturn] = ACTIONS(1611),
    [sym_primitive_type] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_goto] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_sizeof] = ACTIONS(1611),
    [anon_sym___alignof__] = ACTIONS(1611),
    [anon_sym___alignof] = ACTIONS(1611),
    [anon_sym__alignof] = ACTIONS(1611),
    [anon_sym_alignof] = ACTIONS(1611),
    [anon_sym__Alignof] = ACTIONS(1611),
    [anon_sym_offsetof] = ACTIONS(1611),
    [anon_sym__Generic] = ACTIONS(1611),
    [anon_sym_asm] = ACTIONS(1611),
    [anon_sym___asm__] = ACTIONS(1611),
    [sym_number_literal] = ACTIONS(1613),
    [anon_sym_L_SQUOTE] = ACTIONS(1613),
    [anon_sym_u_SQUOTE] = ACTIONS(1613),
    [anon_sym_U_SQUOTE] = ACTIONS(1613),
    [anon_sym_u8_SQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_L_DQUOTE] = ACTIONS(1613),
    [anon_sym_u_DQUOTE] = ACTIONS(1613),
    [anon_sym_U_DQUOTE] = ACTIONS(1613),
    [anon_sym_u8_DQUOTE] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [sym_true] = ACTIONS(1611),
    [sym_false] = ACTIONS(1611),
    [anon_sym_NULL] = ACTIONS(1611),
    [anon_sym_nullptr] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1611),
    [anon_sym_acquire] = ACTIONS(1611),
    [anon_sym_monitor] = ACTIONS(1611),
    [anon_sym_start] = ACTIONS(1611),
    [anon_sym_stop] = ACTIONS(1611),
  },
  [514] = {
    [sym_identifier] = ACTIONS(1656),
    [aux_sym_preproc_include_token1] = ACTIONS(1656),
    [aux_sym_preproc_def_token1] = ACTIONS(1656),
    [aux_sym_preproc_if_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1656),
    [sym_preproc_directive] = ACTIONS(1656),
    [anon_sym_LPAREN2] = ACTIONS(1658),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_TILDE] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_SEMI] = ACTIONS(1658),
    [anon_sym___extension__] = ACTIONS(1656),
    [anon_sym_typedef] = ACTIONS(1656),
    [anon_sym_extern] = ACTIONS(1656),
    [anon_sym___attribute__] = ACTIONS(1656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1658),
    [anon_sym___declspec] = ACTIONS(1656),
    [anon_sym___cdecl] = ACTIONS(1656),
    [anon_sym___clrcall] = ACTIONS(1656),
    [anon_sym___stdcall] = ACTIONS(1656),
    [anon_sym___fastcall] = ACTIONS(1656),
    [anon_sym___thiscall] = ACTIONS(1656),
    [anon_sym___vectorcall] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1658),
    [anon_sym_RBRACE] = ACTIONS(1658),
    [anon_sym_signed] = ACTIONS(1656),
    [anon_sym_unsigned] = ACTIONS(1656),
    [anon_sym_long] = ACTIONS(1656),
    [anon_sym_short] = ACTIONS(1656),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_auto] = ACTIONS(1656),
    [anon_sym_register] = ACTIONS(1656),
    [anon_sym_inline] = ACTIONS(1656),
    [anon_sym___inline] = ACTIONS(1656),
    [anon_sym___inline__] = ACTIONS(1656),
    [anon_sym___forceinline] = ACTIONS(1656),
    [anon_sym_thread_local] = ACTIONS(1656),
    [anon_sym___thread] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_constexpr] = ACTIONS(1656),
    [anon_sym_volatile] = ACTIONS(1656),
    [anon_sym_restrict] = ACTIONS(1656),
    [anon_sym___restrict__] = ACTIONS(1656),
    [anon_sym__Atomic] = ACTIONS(1656),
    [anon_sym__Noreturn] = ACTIONS(1656),
    [anon_sym_noreturn] = ACTIONS(1656),
    [sym_primitive_type] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_struct] = ACTIONS(1656),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_goto] = ACTIONS(1656),
    [anon_sym_DASH_DASH] = ACTIONS(1658),
    [anon_sym_PLUS_PLUS] = ACTIONS(1658),
    [anon_sym_sizeof] = ACTIONS(1656),
    [anon_sym___alignof__] = ACTIONS(1656),
    [anon_sym___alignof] = ACTIONS(1656),
    [anon_sym__alignof] = ACTIONS(1656),
    [anon_sym_alignof] = ACTIONS(1656),
    [anon_sym__Alignof] = ACTIONS(1656),
    [anon_sym_offsetof] = ACTIONS(1656),
    [anon_sym__Generic] = ACTIONS(1656),
    [anon_sym_asm] = ACTIONS(1656),
    [anon_sym___asm__] = ACTIONS(1656),
    [sym_number_literal] = ACTIONS(1658),
    [anon_sym_L_SQUOTE] = ACTIONS(1658),
    [anon_sym_u_SQUOTE] = ACTIONS(1658),
    [anon_sym_U_SQUOTE] = ACTIONS(1658),
    [anon_sym_u8_SQUOTE] = ACTIONS(1658),
    [anon_sym_SQUOTE] = ACTIONS(1658),
    [anon_sym_L_DQUOTE] = ACTIONS(1658),
    [anon_sym_u_DQUOTE] = ACTIONS(1658),
    [anon_sym_U_DQUOTE] = ACTIONS(1658),
    [anon_sym_u8_DQUOTE] = ACTIONS(1658),
    [anon_sym_DQUOTE] = ACTIONS(1658),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [anon_sym_NULL] = ACTIONS(1656),
    [anon_sym_nullptr] = ACTIONS(1656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1656),
    [anon_sym_acquire] = ACTIONS(1656),
    [anon_sym_monitor] = ACTIONS(1656),
    [anon_sym_start] = ACTIONS(1656),
    [anon_sym_stop] = ACTIONS(1656),
  },
  [515] = {
    [sym_identifier] = ACTIONS(1593),
    [aux_sym_preproc_include_token1] = ACTIONS(1593),
    [aux_sym_preproc_def_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token2] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1593),
    [sym_preproc_directive] = ACTIONS(1593),
    [anon_sym_LPAREN2] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(1593),
    [anon_sym_extern] = ACTIONS(1593),
    [anon_sym___attribute__] = ACTIONS(1593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1595),
    [anon_sym___declspec] = ACTIONS(1593),
    [anon_sym___cdecl] = ACTIONS(1593),
    [anon_sym___clrcall] = ACTIONS(1593),
    [anon_sym___stdcall] = ACTIONS(1593),
    [anon_sym___fastcall] = ACTIONS(1593),
    [anon_sym___thiscall] = ACTIONS(1593),
    [anon_sym___vectorcall] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1595),
    [anon_sym_signed] = ACTIONS(1593),
    [anon_sym_unsigned] = ACTIONS(1593),
    [anon_sym_long] = ACTIONS(1593),
    [anon_sym_short] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_auto] = ACTIONS(1593),
    [anon_sym_register] = ACTIONS(1593),
    [anon_sym_inline] = ACTIONS(1593),
    [anon_sym___inline] = ACTIONS(1593),
    [anon_sym___inline__] = ACTIONS(1593),
    [anon_sym___forceinline] = ACTIONS(1593),
    [anon_sym_thread_local] = ACTIONS(1593),
    [anon_sym___thread] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_constexpr] = ACTIONS(1593),
    [anon_sym_volatile] = ACTIONS(1593),
    [anon_sym_restrict] = ACTIONS(1593),
    [anon_sym___restrict__] = ACTIONS(1593),
    [anon_sym__Atomic] = ACTIONS(1593),
    [anon_sym__Noreturn] = ACTIONS(1593),
    [anon_sym_noreturn] = ACTIONS(1593),
    [sym_primitive_type] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [anon_sym_struct] = ACTIONS(1593),
    [anon_sym_union] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_goto] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1595),
    [anon_sym_PLUS_PLUS] = ACTIONS(1595),
    [anon_sym_sizeof] = ACTIONS(1593),
    [anon_sym___alignof__] = ACTIONS(1593),
    [anon_sym___alignof] = ACTIONS(1593),
    [anon_sym__alignof] = ACTIONS(1593),
    [anon_sym_alignof] = ACTIONS(1593),
    [anon_sym__Alignof] = ACTIONS(1593),
    [anon_sym_offsetof] = ACTIONS(1593),
    [anon_sym__Generic] = ACTIONS(1593),
    [anon_sym_asm] = ACTIONS(1593),
    [anon_sym___asm__] = ACTIONS(1593),
    [sym_number_literal] = ACTIONS(1595),
    [anon_sym_L_SQUOTE] = ACTIONS(1595),
    [anon_sym_u_SQUOTE] = ACTIONS(1595),
    [anon_sym_U_SQUOTE] = ACTIONS(1595),
    [anon_sym_u8_SQUOTE] = ACTIONS(1595),
    [anon_sym_SQUOTE] = ACTIONS(1595),
    [anon_sym_L_DQUOTE] = ACTIONS(1595),
    [anon_sym_u_DQUOTE] = ACTIONS(1595),
    [anon_sym_U_DQUOTE] = ACTIONS(1595),
    [anon_sym_u8_DQUOTE] = ACTIONS(1595),
    [anon_sym_DQUOTE] = ACTIONS(1595),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [anon_sym_NULL] = ACTIONS(1593),
    [anon_sym_nullptr] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1593),
    [anon_sym_acquire] = ACTIONS(1593),
    [anon_sym_monitor] = ACTIONS(1593),
    [anon_sym_start] = ACTIONS(1593),
    [anon_sym_stop] = ACTIONS(1593),
  },
  [516] = {
    [sym_identifier] = ACTIONS(1688),
    [aux_sym_preproc_include_token1] = ACTIONS(1688),
    [aux_sym_preproc_def_token1] = ACTIONS(1688),
    [aux_sym_preproc_if_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1688),
    [sym_preproc_directive] = ACTIONS(1688),
    [anon_sym_LPAREN2] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym___extension__] = ACTIONS(1688),
    [anon_sym_typedef] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym___attribute__] = ACTIONS(1688),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1690),
    [anon_sym___declspec] = ACTIONS(1688),
    [anon_sym___cdecl] = ACTIONS(1688),
    [anon_sym___clrcall] = ACTIONS(1688),
    [anon_sym___stdcall] = ACTIONS(1688),
    [anon_sym___fastcall] = ACTIONS(1688),
    [anon_sym___thiscall] = ACTIONS(1688),
    [anon_sym___vectorcall] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_signed] = ACTIONS(1688),
    [anon_sym_unsigned] = ACTIONS(1688),
    [anon_sym_long] = ACTIONS(1688),
    [anon_sym_short] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_auto] = ACTIONS(1688),
    [anon_sym_register] = ACTIONS(1688),
    [anon_sym_inline] = ACTIONS(1688),
    [anon_sym___inline] = ACTIONS(1688),
    [anon_sym___inline__] = ACTIONS(1688),
    [anon_sym___forceinline] = ACTIONS(1688),
    [anon_sym_thread_local] = ACTIONS(1688),
    [anon_sym___thread] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_constexpr] = ACTIONS(1688),
    [anon_sym_volatile] = ACTIONS(1688),
    [anon_sym_restrict] = ACTIONS(1688),
    [anon_sym___restrict__] = ACTIONS(1688),
    [anon_sym__Atomic] = ACTIONS(1688),
    [anon_sym__Noreturn] = ACTIONS(1688),
    [anon_sym_noreturn] = ACTIONS(1688),
    [sym_primitive_type] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_switch] = ACTIONS(1688),
    [anon_sym_case] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_do] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_goto] = ACTIONS(1688),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_sizeof] = ACTIONS(1688),
    [anon_sym___alignof__] = ACTIONS(1688),
    [anon_sym___alignof] = ACTIONS(1688),
    [anon_sym__alignof] = ACTIONS(1688),
    [anon_sym_alignof] = ACTIONS(1688),
    [anon_sym__Alignof] = ACTIONS(1688),
    [anon_sym_offsetof] = ACTIONS(1688),
    [anon_sym__Generic] = ACTIONS(1688),
    [anon_sym_asm] = ACTIONS(1688),
    [anon_sym___asm__] = ACTIONS(1688),
    [sym_number_literal] = ACTIONS(1690),
    [anon_sym_L_SQUOTE] = ACTIONS(1690),
    [anon_sym_u_SQUOTE] = ACTIONS(1690),
    [anon_sym_U_SQUOTE] = ACTIONS(1690),
    [anon_sym_u8_SQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [anon_sym_L_DQUOTE] = ACTIONS(1690),
    [anon_sym_u_DQUOTE] = ACTIONS(1690),
    [anon_sym_U_DQUOTE] = ACTIONS(1690),
    [anon_sym_u8_DQUOTE] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [anon_sym_NULL] = ACTIONS(1688),
    [anon_sym_nullptr] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1688),
    [anon_sym_acquire] = ACTIONS(1688),
    [anon_sym_monitor] = ACTIONS(1688),
    [anon_sym_start] = ACTIONS(1688),
    [anon_sym_stop] = ACTIONS(1688),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1652),
    [aux_sym_preproc_include_token1] = ACTIONS(1652),
    [aux_sym_preproc_def_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1652),
    [sym_preproc_directive] = ACTIONS(1652),
    [anon_sym_LPAREN2] = ACTIONS(1654),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1654),
    [anon_sym___extension__] = ACTIONS(1652),
    [anon_sym_typedef] = ACTIONS(1652),
    [anon_sym_extern] = ACTIONS(1652),
    [anon_sym___attribute__] = ACTIONS(1652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1654),
    [anon_sym___declspec] = ACTIONS(1652),
    [anon_sym___cdecl] = ACTIONS(1652),
    [anon_sym___clrcall] = ACTIONS(1652),
    [anon_sym___stdcall] = ACTIONS(1652),
    [anon_sym___fastcall] = ACTIONS(1652),
    [anon_sym___thiscall] = ACTIONS(1652),
    [anon_sym___vectorcall] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_signed] = ACTIONS(1652),
    [anon_sym_unsigned] = ACTIONS(1652),
    [anon_sym_long] = ACTIONS(1652),
    [anon_sym_short] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_auto] = ACTIONS(1652),
    [anon_sym_register] = ACTIONS(1652),
    [anon_sym_inline] = ACTIONS(1652),
    [anon_sym___inline] = ACTIONS(1652),
    [anon_sym___inline__] = ACTIONS(1652),
    [anon_sym___forceinline] = ACTIONS(1652),
    [anon_sym_thread_local] = ACTIONS(1652),
    [anon_sym___thread] = ACTIONS(1652),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_constexpr] = ACTIONS(1652),
    [anon_sym_volatile] = ACTIONS(1652),
    [anon_sym_restrict] = ACTIONS(1652),
    [anon_sym___restrict__] = ACTIONS(1652),
    [anon_sym__Atomic] = ACTIONS(1652),
    [anon_sym__Noreturn] = ACTIONS(1652),
    [anon_sym_noreturn] = ACTIONS(1652),
    [sym_primitive_type] = ACTIONS(1652),
    [anon_sym_enum] = ACTIONS(1652),
    [anon_sym_struct] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_if] = ACTIONS(1652),
    [anon_sym_switch] = ACTIONS(1652),
    [anon_sym_case] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_while] = ACTIONS(1652),
    [anon_sym_do] = ACTIONS(1652),
    [anon_sym_for] = ACTIONS(1652),
    [anon_sym_return] = ACTIONS(1652),
    [anon_sym_break] = ACTIONS(1652),
    [anon_sym_continue] = ACTIONS(1652),
    [anon_sym_goto] = ACTIONS(1652),
    [anon_sym_DASH_DASH] = ACTIONS(1654),
    [anon_sym_PLUS_PLUS] = ACTIONS(1654),
    [anon_sym_sizeof] = ACTIONS(1652),
    [anon_sym___alignof__] = ACTIONS(1652),
    [anon_sym___alignof] = ACTIONS(1652),
    [anon_sym__alignof] = ACTIONS(1652),
    [anon_sym_alignof] = ACTIONS(1652),
    [anon_sym__Alignof] = ACTIONS(1652),
    [anon_sym_offsetof] = ACTIONS(1652),
    [anon_sym__Generic] = ACTIONS(1652),
    [anon_sym_asm] = ACTIONS(1652),
    [anon_sym___asm__] = ACTIONS(1652),
    [sym_number_literal] = ACTIONS(1654),
    [anon_sym_L_SQUOTE] = ACTIONS(1654),
    [anon_sym_u_SQUOTE] = ACTIONS(1654),
    [anon_sym_U_SQUOTE] = ACTIONS(1654),
    [anon_sym_u8_SQUOTE] = ACTIONS(1654),
    [anon_sym_SQUOTE] = ACTIONS(1654),
    [anon_sym_L_DQUOTE] = ACTIONS(1654),
    [anon_sym_u_DQUOTE] = ACTIONS(1654),
    [anon_sym_U_DQUOTE] = ACTIONS(1654),
    [anon_sym_u8_DQUOTE] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [sym_true] = ACTIONS(1652),
    [sym_false] = ACTIONS(1652),
    [anon_sym_NULL] = ACTIONS(1652),
    [anon_sym_nullptr] = ACTIONS(1652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1652),
    [anon_sym_until] = ACTIONS(1652),
    [anon_sym_acquire] = ACTIONS(1652),
    [anon_sym_monitor] = ACTIONS(1652),
    [anon_sym_start] = ACTIONS(1652),
    [anon_sym_stop] = ACTIONS(1652),
  },
  [518] = {
    [sym_identifier] = ACTIONS(1605),
    [aux_sym_preproc_include_token1] = ACTIONS(1605),
    [aux_sym_preproc_def_token1] = ACTIONS(1605),
    [aux_sym_preproc_if_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1605),
    [sym_preproc_directive] = ACTIONS(1605),
    [anon_sym_LPAREN2] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym___extension__] = ACTIONS(1605),
    [anon_sym_typedef] = ACTIONS(1605),
    [anon_sym_extern] = ACTIONS(1605),
    [anon_sym___attribute__] = ACTIONS(1605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1607),
    [anon_sym___declspec] = ACTIONS(1605),
    [anon_sym___cdecl] = ACTIONS(1605),
    [anon_sym___clrcall] = ACTIONS(1605),
    [anon_sym___stdcall] = ACTIONS(1605),
    [anon_sym___fastcall] = ACTIONS(1605),
    [anon_sym___thiscall] = ACTIONS(1605),
    [anon_sym___vectorcall] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_RBRACE] = ACTIONS(1607),
    [anon_sym_signed] = ACTIONS(1605),
    [anon_sym_unsigned] = ACTIONS(1605),
    [anon_sym_long] = ACTIONS(1605),
    [anon_sym_short] = ACTIONS(1605),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_auto] = ACTIONS(1605),
    [anon_sym_register] = ACTIONS(1605),
    [anon_sym_inline] = ACTIONS(1605),
    [anon_sym___inline] = ACTIONS(1605),
    [anon_sym___inline__] = ACTIONS(1605),
    [anon_sym___forceinline] = ACTIONS(1605),
    [anon_sym_thread_local] = ACTIONS(1605),
    [anon_sym___thread] = ACTIONS(1605),
    [anon_sym_const] = ACTIONS(1605),
    [anon_sym_constexpr] = ACTIONS(1605),
    [anon_sym_volatile] = ACTIONS(1605),
    [anon_sym_restrict] = ACTIONS(1605),
    [anon_sym___restrict__] = ACTIONS(1605),
    [anon_sym__Atomic] = ACTIONS(1605),
    [anon_sym__Noreturn] = ACTIONS(1605),
    [anon_sym_noreturn] = ACTIONS(1605),
    [sym_primitive_type] = ACTIONS(1605),
    [anon_sym_enum] = ACTIONS(1605),
    [anon_sym_struct] = ACTIONS(1605),
    [anon_sym_union] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1605),
    [anon_sym_switch] = ACTIONS(1605),
    [anon_sym_case] = ACTIONS(1605),
    [anon_sym_default] = ACTIONS(1605),
    [anon_sym_while] = ACTIONS(1605),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_for] = ACTIONS(1605),
    [anon_sym_return] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1605),
    [anon_sym_goto] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_sizeof] = ACTIONS(1605),
    [anon_sym___alignof__] = ACTIONS(1605),
    [anon_sym___alignof] = ACTIONS(1605),
    [anon_sym__alignof] = ACTIONS(1605),
    [anon_sym_alignof] = ACTIONS(1605),
    [anon_sym__Alignof] = ACTIONS(1605),
    [anon_sym_offsetof] = ACTIONS(1605),
    [anon_sym__Generic] = ACTIONS(1605),
    [anon_sym_asm] = ACTIONS(1605),
    [anon_sym___asm__] = ACTIONS(1605),
    [sym_number_literal] = ACTIONS(1607),
    [anon_sym_L_SQUOTE] = ACTIONS(1607),
    [anon_sym_u_SQUOTE] = ACTIONS(1607),
    [anon_sym_U_SQUOTE] = ACTIONS(1607),
    [anon_sym_u8_SQUOTE] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [anon_sym_L_DQUOTE] = ACTIONS(1607),
    [anon_sym_u_DQUOTE] = ACTIONS(1607),
    [anon_sym_U_DQUOTE] = ACTIONS(1607),
    [anon_sym_u8_DQUOTE] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [anon_sym_NULL] = ACTIONS(1605),
    [anon_sym_nullptr] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1605),
    [anon_sym_acquire] = ACTIONS(1605),
    [anon_sym_monitor] = ACTIONS(1605),
    [anon_sym_start] = ACTIONS(1605),
    [anon_sym_stop] = ACTIONS(1605),
  },
  [519] = {
    [sym_identifier] = ACTIONS(1633),
    [aux_sym_preproc_include_token1] = ACTIONS(1633),
    [aux_sym_preproc_def_token1] = ACTIONS(1633),
    [aux_sym_preproc_if_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1633),
    [sym_preproc_directive] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1633),
    [anon_sym_typedef] = ACTIONS(1633),
    [anon_sym_extern] = ACTIONS(1633),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1635),
    [anon_sym___declspec] = ACTIONS(1633),
    [anon_sym___cdecl] = ACTIONS(1633),
    [anon_sym___clrcall] = ACTIONS(1633),
    [anon_sym___stdcall] = ACTIONS(1633),
    [anon_sym___fastcall] = ACTIONS(1633),
    [anon_sym___thiscall] = ACTIONS(1633),
    [anon_sym___vectorcall] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_signed] = ACTIONS(1633),
    [anon_sym_unsigned] = ACTIONS(1633),
    [anon_sym_long] = ACTIONS(1633),
    [anon_sym_short] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_auto] = ACTIONS(1633),
    [anon_sym_register] = ACTIONS(1633),
    [anon_sym_inline] = ACTIONS(1633),
    [anon_sym___inline] = ACTIONS(1633),
    [anon_sym___inline__] = ACTIONS(1633),
    [anon_sym___forceinline] = ACTIONS(1633),
    [anon_sym_thread_local] = ACTIONS(1633),
    [anon_sym___thread] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1633),
    [anon_sym_constexpr] = ACTIONS(1633),
    [anon_sym_volatile] = ACTIONS(1633),
    [anon_sym_restrict] = ACTIONS(1633),
    [anon_sym___restrict__] = ACTIONS(1633),
    [anon_sym__Atomic] = ACTIONS(1633),
    [anon_sym__Noreturn] = ACTIONS(1633),
    [anon_sym_noreturn] = ACTIONS(1633),
    [sym_primitive_type] = ACTIONS(1633),
    [anon_sym_enum] = ACTIONS(1633),
    [anon_sym_struct] = ACTIONS(1633),
    [anon_sym_union] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1633),
    [anon_sym_switch] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1633),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_for] = ACTIONS(1633),
    [anon_sym_return] = ACTIONS(1633),
    [anon_sym_break] = ACTIONS(1633),
    [anon_sym_continue] = ACTIONS(1633),
    [anon_sym_goto] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_sizeof] = ACTIONS(1633),
    [anon_sym___alignof__] = ACTIONS(1633),
    [anon_sym___alignof] = ACTIONS(1633),
    [anon_sym__alignof] = ACTIONS(1633),
    [anon_sym_alignof] = ACTIONS(1633),
    [anon_sym__Alignof] = ACTIONS(1633),
    [anon_sym_offsetof] = ACTIONS(1633),
    [anon_sym__Generic] = ACTIONS(1633),
    [anon_sym_asm] = ACTIONS(1633),
    [anon_sym___asm__] = ACTIONS(1633),
    [sym_number_literal] = ACTIONS(1635),
    [anon_sym_L_SQUOTE] = ACTIONS(1635),
    [anon_sym_u_SQUOTE] = ACTIONS(1635),
    [anon_sym_U_SQUOTE] = ACTIONS(1635),
    [anon_sym_u8_SQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_L_DQUOTE] = ACTIONS(1635),
    [anon_sym_u_DQUOTE] = ACTIONS(1635),
    [anon_sym_U_DQUOTE] = ACTIONS(1635),
    [anon_sym_u8_DQUOTE] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [anon_sym_NULL] = ACTIONS(1633),
    [anon_sym_nullptr] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1633),
    [anon_sym_acquire] = ACTIONS(1633),
    [anon_sym_monitor] = ACTIONS(1633),
    [anon_sym_start] = ACTIONS(1633),
    [anon_sym_stop] = ACTIONS(1633),
  },
  [520] = {
    [sym_identifier] = ACTIONS(1601),
    [aux_sym_preproc_include_token1] = ACTIONS(1601),
    [aux_sym_preproc_def_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1601),
    [sym_preproc_directive] = ACTIONS(1601),
    [anon_sym_LPAREN2] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym___extension__] = ACTIONS(1601),
    [anon_sym_typedef] = ACTIONS(1601),
    [anon_sym_extern] = ACTIONS(1601),
    [anon_sym___attribute__] = ACTIONS(1601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1603),
    [anon_sym___declspec] = ACTIONS(1601),
    [anon_sym___cdecl] = ACTIONS(1601),
    [anon_sym___clrcall] = ACTIONS(1601),
    [anon_sym___stdcall] = ACTIONS(1601),
    [anon_sym___fastcall] = ACTIONS(1601),
    [anon_sym___thiscall] = ACTIONS(1601),
    [anon_sym___vectorcall] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_signed] = ACTIONS(1601),
    [anon_sym_unsigned] = ACTIONS(1601),
    [anon_sym_long] = ACTIONS(1601),
    [anon_sym_short] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1601),
    [anon_sym_auto] = ACTIONS(1601),
    [anon_sym_register] = ACTIONS(1601),
    [anon_sym_inline] = ACTIONS(1601),
    [anon_sym___inline] = ACTIONS(1601),
    [anon_sym___inline__] = ACTIONS(1601),
    [anon_sym___forceinline] = ACTIONS(1601),
    [anon_sym_thread_local] = ACTIONS(1601),
    [anon_sym___thread] = ACTIONS(1601),
    [anon_sym_const] = ACTIONS(1601),
    [anon_sym_constexpr] = ACTIONS(1601),
    [anon_sym_volatile] = ACTIONS(1601),
    [anon_sym_restrict] = ACTIONS(1601),
    [anon_sym___restrict__] = ACTIONS(1601),
    [anon_sym__Atomic] = ACTIONS(1601),
    [anon_sym__Noreturn] = ACTIONS(1601),
    [anon_sym_noreturn] = ACTIONS(1601),
    [sym_primitive_type] = ACTIONS(1601),
    [anon_sym_enum] = ACTIONS(1601),
    [anon_sym_struct] = ACTIONS(1601),
    [anon_sym_union] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_switch] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_while] = ACTIONS(1601),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1601),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1601),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_goto] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_sizeof] = ACTIONS(1601),
    [anon_sym___alignof__] = ACTIONS(1601),
    [anon_sym___alignof] = ACTIONS(1601),
    [anon_sym__alignof] = ACTIONS(1601),
    [anon_sym_alignof] = ACTIONS(1601),
    [anon_sym__Alignof] = ACTIONS(1601),
    [anon_sym_offsetof] = ACTIONS(1601),
    [anon_sym__Generic] = ACTIONS(1601),
    [anon_sym_asm] = ACTIONS(1601),
    [anon_sym___asm__] = ACTIONS(1601),
    [sym_number_literal] = ACTIONS(1603),
    [anon_sym_L_SQUOTE] = ACTIONS(1603),
    [anon_sym_u_SQUOTE] = ACTIONS(1603),
    [anon_sym_U_SQUOTE] = ACTIONS(1603),
    [anon_sym_u8_SQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [anon_sym_L_DQUOTE] = ACTIONS(1603),
    [anon_sym_u_DQUOTE] = ACTIONS(1603),
    [anon_sym_U_DQUOTE] = ACTIONS(1603),
    [anon_sym_u8_DQUOTE] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [anon_sym_NULL] = ACTIONS(1601),
    [anon_sym_nullptr] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1601),
    [anon_sym_acquire] = ACTIONS(1601),
    [anon_sym_monitor] = ACTIONS(1601),
    [anon_sym_start] = ACTIONS(1601),
    [anon_sym_stop] = ACTIONS(1601),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [aux_sym_preproc_include_token1] = ACTIONS(2092),
    [aux_sym_preproc_def_token1] = ACTIONS(2092),
    [aux_sym_preproc_if_token1] = ACTIONS(2092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2092),
    [sym_preproc_directive] = ACTIONS(2092),
    [anon_sym_LPAREN2] = ACTIONS(2090),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_TILDE] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(2092),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(2090),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym___extension__] = ACTIONS(2092),
    [anon_sym_typedef] = ACTIONS(2092),
    [anon_sym_extern] = ACTIONS(2092),
    [anon_sym___attribute__] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2090),
    [anon_sym___declspec] = ACTIONS(2092),
    [anon_sym___cdecl] = ACTIONS(2092),
    [anon_sym___clrcall] = ACTIONS(2092),
    [anon_sym___stdcall] = ACTIONS(2092),
    [anon_sym___fastcall] = ACTIONS(2092),
    [anon_sym___thiscall] = ACTIONS(2092),
    [anon_sym___vectorcall] = ACTIONS(2092),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_signed] = ACTIONS(2092),
    [anon_sym_unsigned] = ACTIONS(2092),
    [anon_sym_long] = ACTIONS(2092),
    [anon_sym_short] = ACTIONS(2092),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_auto] = ACTIONS(2092),
    [anon_sym_register] = ACTIONS(2092),
    [anon_sym_inline] = ACTIONS(2092),
    [anon_sym___inline] = ACTIONS(2092),
    [anon_sym___inline__] = ACTIONS(2092),
    [anon_sym___forceinline] = ACTIONS(2092),
    [anon_sym_thread_local] = ACTIONS(2092),
    [anon_sym___thread] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_constexpr] = ACTIONS(2092),
    [anon_sym_volatile] = ACTIONS(2092),
    [anon_sym_restrict] = ACTIONS(2092),
    [anon_sym___restrict__] = ACTIONS(2092),
    [anon_sym__Atomic] = ACTIONS(2092),
    [anon_sym__Noreturn] = ACTIONS(2092),
    [anon_sym_noreturn] = ACTIONS(2092),
    [sym_primitive_type] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
    [anon_sym_struct] = ACTIONS(2092),
    [anon_sym_union] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(2092),
    [anon_sym_case] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_do] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_goto] = ACTIONS(2092),
    [anon_sym_DASH_DASH] = ACTIONS(2090),
    [anon_sym_PLUS_PLUS] = ACTIONS(2090),
    [anon_sym_sizeof] = ACTIONS(2092),
    [anon_sym___alignof__] = ACTIONS(2092),
    [anon_sym___alignof] = ACTIONS(2092),
    [anon_sym__alignof] = ACTIONS(2092),
    [anon_sym_alignof] = ACTIONS(2092),
    [anon_sym__Alignof] = ACTIONS(2092),
    [anon_sym_offsetof] = ACTIONS(2092),
    [anon_sym__Generic] = ACTIONS(2092),
    [anon_sym_asm] = ACTIONS(2092),
    [anon_sym___asm__] = ACTIONS(2092),
    [sym_number_literal] = ACTIONS(2090),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2090),
    [anon_sym_u_DQUOTE] = ACTIONS(2090),
    [anon_sym_U_DQUOTE] = ACTIONS(2090),
    [anon_sym_u8_DQUOTE] = ACTIONS(2090),
    [anon_sym_DQUOTE] = ACTIONS(2090),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [anon_sym_NULL] = ACTIONS(2092),
    [anon_sym_nullptr] = ACTIONS(2092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(2092),
    [anon_sym_until] = ACTIONS(2092),
    [anon_sym_acquire] = ACTIONS(2092),
    [anon_sym_monitor] = ACTIONS(2092),
    [anon_sym_start] = ACTIONS(2092),
    [anon_sym_stop] = ACTIONS(2092),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1678),
    [sym_identifier] = ACTIONS(1676),
    [aux_sym_preproc_include_token1] = ACTIONS(1676),
    [aux_sym_preproc_def_token1] = ACTIONS(1676),
    [aux_sym_preproc_if_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1676),
    [sym_preproc_directive] = ACTIONS(1676),
    [anon_sym_LPAREN2] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym___extension__] = ACTIONS(1676),
    [anon_sym_typedef] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym___attribute__] = ACTIONS(1676),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1678),
    [anon_sym___declspec] = ACTIONS(1676),
    [anon_sym___cdecl] = ACTIONS(1676),
    [anon_sym___clrcall] = ACTIONS(1676),
    [anon_sym___stdcall] = ACTIONS(1676),
    [anon_sym___fastcall] = ACTIONS(1676),
    [anon_sym___thiscall] = ACTIONS(1676),
    [anon_sym___vectorcall] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_signed] = ACTIONS(1676),
    [anon_sym_unsigned] = ACTIONS(1676),
    [anon_sym_long] = ACTIONS(1676),
    [anon_sym_short] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_auto] = ACTIONS(1676),
    [anon_sym_register] = ACTIONS(1676),
    [anon_sym_inline] = ACTIONS(1676),
    [anon_sym___inline] = ACTIONS(1676),
    [anon_sym___inline__] = ACTIONS(1676),
    [anon_sym___forceinline] = ACTIONS(1676),
    [anon_sym_thread_local] = ACTIONS(1676),
    [anon_sym___thread] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_constexpr] = ACTIONS(1676),
    [anon_sym_volatile] = ACTIONS(1676),
    [anon_sym_restrict] = ACTIONS(1676),
    [anon_sym___restrict__] = ACTIONS(1676),
    [anon_sym__Atomic] = ACTIONS(1676),
    [anon_sym__Noreturn] = ACTIONS(1676),
    [anon_sym_noreturn] = ACTIONS(1676),
    [sym_primitive_type] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_switch] = ACTIONS(1676),
    [anon_sym_case] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_goto] = ACTIONS(1676),
    [anon_sym_DASH_DASH] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1678),
    [anon_sym_sizeof] = ACTIONS(1676),
    [anon_sym___alignof__] = ACTIONS(1676),
    [anon_sym___alignof] = ACTIONS(1676),
    [anon_sym__alignof] = ACTIONS(1676),
    [anon_sym_alignof] = ACTIONS(1676),
    [anon_sym__Alignof] = ACTIONS(1676),
    [anon_sym_offsetof] = ACTIONS(1676),
    [anon_sym__Generic] = ACTIONS(1676),
    [anon_sym_asm] = ACTIONS(1676),
    [anon_sym___asm__] = ACTIONS(1676),
    [sym_number_literal] = ACTIONS(1678),
    [anon_sym_L_SQUOTE] = ACTIONS(1678),
    [anon_sym_u_SQUOTE] = ACTIONS(1678),
    [anon_sym_U_SQUOTE] = ACTIONS(1678),
    [anon_sym_u8_SQUOTE] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1678),
    [anon_sym_L_DQUOTE] = ACTIONS(1678),
    [anon_sym_u_DQUOTE] = ACTIONS(1678),
    [anon_sym_U_DQUOTE] = ACTIONS(1678),
    [anon_sym_u8_DQUOTE] = ACTIONS(1678),
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [anon_sym_NULL] = ACTIONS(1676),
    [anon_sym_nullptr] = ACTIONS(1676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1676),
    [anon_sym_until] = ACTIONS(1676),
    [anon_sym_acquire] = ACTIONS(1676),
    [anon_sym_monitor] = ACTIONS(1676),
    [anon_sym_start] = ACTIONS(1676),
    [anon_sym_stop] = ACTIONS(1676),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1672),
    [aux_sym_preproc_include_token1] = ACTIONS(1672),
    [aux_sym_preproc_def_token1] = ACTIONS(1672),
    [aux_sym_preproc_if_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1672),
    [sym_preproc_directive] = ACTIONS(1672),
    [anon_sym_LPAREN2] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_TILDE] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym___extension__] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym___attribute__] = ACTIONS(1672),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1674),
    [anon_sym___declspec] = ACTIONS(1672),
    [anon_sym___cdecl] = ACTIONS(1672),
    [anon_sym___clrcall] = ACTIONS(1672),
    [anon_sym___stdcall] = ACTIONS(1672),
    [anon_sym___fastcall] = ACTIONS(1672),
    [anon_sym___thiscall] = ACTIONS(1672),
    [anon_sym___vectorcall] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_signed] = ACTIONS(1672),
    [anon_sym_unsigned] = ACTIONS(1672),
    [anon_sym_long] = ACTIONS(1672),
    [anon_sym_short] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_auto] = ACTIONS(1672),
    [anon_sym_register] = ACTIONS(1672),
    [anon_sym_inline] = ACTIONS(1672),
    [anon_sym___inline] = ACTIONS(1672),
    [anon_sym___inline__] = ACTIONS(1672),
    [anon_sym___forceinline] = ACTIONS(1672),
    [anon_sym_thread_local] = ACTIONS(1672),
    [anon_sym___thread] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_constexpr] = ACTIONS(1672),
    [anon_sym_volatile] = ACTIONS(1672),
    [anon_sym_restrict] = ACTIONS(1672),
    [anon_sym___restrict__] = ACTIONS(1672),
    [anon_sym__Atomic] = ACTIONS(1672),
    [anon_sym__Noreturn] = ACTIONS(1672),
    [anon_sym_noreturn] = ACTIONS(1672),
    [sym_primitive_type] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_do] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_goto] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1674),
    [anon_sym_PLUS_PLUS] = ACTIONS(1674),
    [anon_sym_sizeof] = ACTIONS(1672),
    [anon_sym___alignof__] = ACTIONS(1672),
    [anon_sym___alignof] = ACTIONS(1672),
    [anon_sym__alignof] = ACTIONS(1672),
    [anon_sym_alignof] = ACTIONS(1672),
    [anon_sym__Alignof] = ACTIONS(1672),
    [anon_sym_offsetof] = ACTIONS(1672),
    [anon_sym__Generic] = ACTIONS(1672),
    [anon_sym_asm] = ACTIONS(1672),
    [anon_sym___asm__] = ACTIONS(1672),
    [sym_number_literal] = ACTIONS(1674),
    [anon_sym_L_SQUOTE] = ACTIONS(1674),
    [anon_sym_u_SQUOTE] = ACTIONS(1674),
    [anon_sym_U_SQUOTE] = ACTIONS(1674),
    [anon_sym_u8_SQUOTE] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1674),
    [anon_sym_L_DQUOTE] = ACTIONS(1674),
    [anon_sym_u_DQUOTE] = ACTIONS(1674),
    [anon_sym_U_DQUOTE] = ACTIONS(1674),
    [anon_sym_u8_DQUOTE] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(1674),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [anon_sym_NULL] = ACTIONS(1672),
    [anon_sym_nullptr] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1672),
    [anon_sym_until] = ACTIONS(1672),
    [anon_sym_acquire] = ACTIONS(1672),
    [anon_sym_monitor] = ACTIONS(1672),
    [anon_sym_start] = ACTIONS(1672),
    [anon_sym_stop] = ACTIONS(1672),
  },
  [524] = {
    [sym_identifier] = ACTIONS(1627),
    [aux_sym_preproc_include_token1] = ACTIONS(1627),
    [aux_sym_preproc_def_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token2] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1627),
    [sym_preproc_directive] = ACTIONS(1627),
    [anon_sym_LPAREN2] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_typedef] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1627),
    [anon_sym___attribute__] = ACTIONS(1627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1629),
    [anon_sym___declspec] = ACTIONS(1627),
    [anon_sym___cdecl] = ACTIONS(1627),
    [anon_sym___clrcall] = ACTIONS(1627),
    [anon_sym___stdcall] = ACTIONS(1627),
    [anon_sym___fastcall] = ACTIONS(1627),
    [anon_sym___thiscall] = ACTIONS(1627),
    [anon_sym___vectorcall] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_signed] = ACTIONS(1627),
    [anon_sym_unsigned] = ACTIONS(1627),
    [anon_sym_long] = ACTIONS(1627),
    [anon_sym_short] = ACTIONS(1627),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_auto] = ACTIONS(1627),
    [anon_sym_register] = ACTIONS(1627),
    [anon_sym_inline] = ACTIONS(1627),
    [anon_sym___inline] = ACTIONS(1627),
    [anon_sym___inline__] = ACTIONS(1627),
    [anon_sym___forceinline] = ACTIONS(1627),
    [anon_sym_thread_local] = ACTIONS(1627),
    [anon_sym___thread] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [sym_primitive_type] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1627),
    [anon_sym_union] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_goto] = ACTIONS(1627),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_sizeof] = ACTIONS(1627),
    [anon_sym___alignof__] = ACTIONS(1627),
    [anon_sym___alignof] = ACTIONS(1627),
    [anon_sym__alignof] = ACTIONS(1627),
    [anon_sym_alignof] = ACTIONS(1627),
    [anon_sym__Alignof] = ACTIONS(1627),
    [anon_sym_offsetof] = ACTIONS(1627),
    [anon_sym__Generic] = ACTIONS(1627),
    [anon_sym_asm] = ACTIONS(1627),
    [anon_sym___asm__] = ACTIONS(1627),
    [sym_number_literal] = ACTIONS(1629),
    [anon_sym_L_SQUOTE] = ACTIONS(1629),
    [anon_sym_u_SQUOTE] = ACTIONS(1629),
    [anon_sym_U_SQUOTE] = ACTIONS(1629),
    [anon_sym_u8_SQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [anon_sym_L_DQUOTE] = ACTIONS(1629),
    [anon_sym_u_DQUOTE] = ACTIONS(1629),
    [anon_sym_U_DQUOTE] = ACTIONS(1629),
    [anon_sym_u8_DQUOTE] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [anon_sym_NULL] = ACTIONS(1627),
    [anon_sym_nullptr] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_acquire] = ACTIONS(1627),
    [anon_sym_monitor] = ACTIONS(1627),
    [anon_sym_start] = ACTIONS(1627),
    [anon_sym_stop] = ACTIONS(1627),
  },
  [525] = {
    [sym_identifier] = ACTIONS(1584),
    [aux_sym_preproc_include_token1] = ACTIONS(1584),
    [aux_sym_preproc_def_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1584),
    [sym_preproc_directive] = ACTIONS(1584),
    [anon_sym_LPAREN2] = ACTIONS(1586),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym___extension__] = ACTIONS(1584),
    [anon_sym_typedef] = ACTIONS(1584),
    [anon_sym_extern] = ACTIONS(1584),
    [anon_sym___attribute__] = ACTIONS(1584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1586),
    [anon_sym___declspec] = ACTIONS(1584),
    [anon_sym___cdecl] = ACTIONS(1584),
    [anon_sym___clrcall] = ACTIONS(1584),
    [anon_sym___stdcall] = ACTIONS(1584),
    [anon_sym___fastcall] = ACTIONS(1584),
    [anon_sym___thiscall] = ACTIONS(1584),
    [anon_sym___vectorcall] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_signed] = ACTIONS(1584),
    [anon_sym_unsigned] = ACTIONS(1584),
    [anon_sym_long] = ACTIONS(1584),
    [anon_sym_short] = ACTIONS(1584),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_auto] = ACTIONS(1584),
    [anon_sym_register] = ACTIONS(1584),
    [anon_sym_inline] = ACTIONS(1584),
    [anon_sym___inline] = ACTIONS(1584),
    [anon_sym___inline__] = ACTIONS(1584),
    [anon_sym___forceinline] = ACTIONS(1584),
    [anon_sym_thread_local] = ACTIONS(1584),
    [anon_sym___thread] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_constexpr] = ACTIONS(1584),
    [anon_sym_volatile] = ACTIONS(1584),
    [anon_sym_restrict] = ACTIONS(1584),
    [anon_sym___restrict__] = ACTIONS(1584),
    [anon_sym__Atomic] = ACTIONS(1584),
    [anon_sym__Noreturn] = ACTIONS(1584),
    [anon_sym_noreturn] = ACTIONS(1584),
    [sym_primitive_type] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_goto] = ACTIONS(1584),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_sizeof] = ACTIONS(1584),
    [anon_sym___alignof__] = ACTIONS(1584),
    [anon_sym___alignof] = ACTIONS(1584),
    [anon_sym__alignof] = ACTIONS(1584),
    [anon_sym_alignof] = ACTIONS(1584),
    [anon_sym__Alignof] = ACTIONS(1584),
    [anon_sym_offsetof] = ACTIONS(1584),
    [anon_sym__Generic] = ACTIONS(1584),
    [anon_sym_asm] = ACTIONS(1584),
    [anon_sym___asm__] = ACTIONS(1584),
    [sym_number_literal] = ACTIONS(1586),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1586),
    [anon_sym_u_DQUOTE] = ACTIONS(1586),
    [anon_sym_U_DQUOTE] = ACTIONS(1586),
    [anon_sym_u8_DQUOTE] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [anon_sym_NULL] = ACTIONS(1584),
    [anon_sym_nullptr] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1584),
    [anon_sym_acquire] = ACTIONS(1584),
    [anon_sym_monitor] = ACTIONS(1584),
    [anon_sym_start] = ACTIONS(1584),
    [anon_sym_stop] = ACTIONS(1584),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1584),
    [aux_sym_preproc_include_token1] = ACTIONS(1584),
    [aux_sym_preproc_def_token1] = ACTIONS(1584),
    [aux_sym_preproc_if_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1584),
    [sym_preproc_directive] = ACTIONS(1584),
    [anon_sym_LPAREN2] = ACTIONS(1586),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym___extension__] = ACTIONS(1584),
    [anon_sym_typedef] = ACTIONS(1584),
    [anon_sym_extern] = ACTIONS(1584),
    [anon_sym___attribute__] = ACTIONS(1584),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1586),
    [anon_sym___declspec] = ACTIONS(1584),
    [anon_sym___cdecl] = ACTIONS(1584),
    [anon_sym___clrcall] = ACTIONS(1584),
    [anon_sym___stdcall] = ACTIONS(1584),
    [anon_sym___fastcall] = ACTIONS(1584),
    [anon_sym___thiscall] = ACTIONS(1584),
    [anon_sym___vectorcall] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_signed] = ACTIONS(1584),
    [anon_sym_unsigned] = ACTIONS(1584),
    [anon_sym_long] = ACTIONS(1584),
    [anon_sym_short] = ACTIONS(1584),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_auto] = ACTIONS(1584),
    [anon_sym_register] = ACTIONS(1584),
    [anon_sym_inline] = ACTIONS(1584),
    [anon_sym___inline] = ACTIONS(1584),
    [anon_sym___inline__] = ACTIONS(1584),
    [anon_sym___forceinline] = ACTIONS(1584),
    [anon_sym_thread_local] = ACTIONS(1584),
    [anon_sym___thread] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_constexpr] = ACTIONS(1584),
    [anon_sym_volatile] = ACTIONS(1584),
    [anon_sym_restrict] = ACTIONS(1584),
    [anon_sym___restrict__] = ACTIONS(1584),
    [anon_sym__Atomic] = ACTIONS(1584),
    [anon_sym__Noreturn] = ACTIONS(1584),
    [anon_sym_noreturn] = ACTIONS(1584),
    [sym_primitive_type] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_struct] = ACTIONS(1584),
    [anon_sym_union] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_goto] = ACTIONS(1584),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_sizeof] = ACTIONS(1584),
    [anon_sym___alignof__] = ACTIONS(1584),
    [anon_sym___alignof] = ACTIONS(1584),
    [anon_sym__alignof] = ACTIONS(1584),
    [anon_sym_alignof] = ACTIONS(1584),
    [anon_sym__Alignof] = ACTIONS(1584),
    [anon_sym_offsetof] = ACTIONS(1584),
    [anon_sym__Generic] = ACTIONS(1584),
    [anon_sym_asm] = ACTIONS(1584),
    [anon_sym___asm__] = ACTIONS(1584),
    [sym_number_literal] = ACTIONS(1586),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1586),
    [anon_sym_u_DQUOTE] = ACTIONS(1586),
    [anon_sym_U_DQUOTE] = ACTIONS(1586),
    [anon_sym_u8_DQUOTE] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [anon_sym_NULL] = ACTIONS(1584),
    [anon_sym_nullptr] = ACTIONS(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1584),
    [anon_sym_until] = ACTIONS(1584),
    [anon_sym_acquire] = ACTIONS(1584),
    [anon_sym_monitor] = ACTIONS(1584),
    [anon_sym_start] = ACTIONS(1584),
    [anon_sym_stop] = ACTIONS(1584),
  },
  [527] = {
    [sym_identifier] = ACTIONS(1615),
    [aux_sym_preproc_include_token1] = ACTIONS(1615),
    [aux_sym_preproc_def_token1] = ACTIONS(1615),
    [aux_sym_preproc_if_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1615),
    [sym_preproc_directive] = ACTIONS(1615),
    [anon_sym_LPAREN2] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym___extension__] = ACTIONS(1615),
    [anon_sym_typedef] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym___attribute__] = ACTIONS(1615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1617),
    [anon_sym___declspec] = ACTIONS(1615),
    [anon_sym___cdecl] = ACTIONS(1615),
    [anon_sym___clrcall] = ACTIONS(1615),
    [anon_sym___stdcall] = ACTIONS(1615),
    [anon_sym___fastcall] = ACTIONS(1615),
    [anon_sym___thiscall] = ACTIONS(1615),
    [anon_sym___vectorcall] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_signed] = ACTIONS(1615),
    [anon_sym_unsigned] = ACTIONS(1615),
    [anon_sym_long] = ACTIONS(1615),
    [anon_sym_short] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_auto] = ACTIONS(1615),
    [anon_sym_register] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym___inline] = ACTIONS(1615),
    [anon_sym___inline__] = ACTIONS(1615),
    [anon_sym___forceinline] = ACTIONS(1615),
    [anon_sym_thread_local] = ACTIONS(1615),
    [anon_sym___thread] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_constexpr] = ACTIONS(1615),
    [anon_sym_volatile] = ACTIONS(1615),
    [anon_sym_restrict] = ACTIONS(1615),
    [anon_sym___restrict__] = ACTIONS(1615),
    [anon_sym__Atomic] = ACTIONS(1615),
    [anon_sym__Noreturn] = ACTIONS(1615),
    [anon_sym_noreturn] = ACTIONS(1615),
    [sym_primitive_type] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_goto] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_sizeof] = ACTIONS(1615),
    [anon_sym___alignof__] = ACTIONS(1615),
    [anon_sym___alignof] = ACTIONS(1615),
    [anon_sym__alignof] = ACTIONS(1615),
    [anon_sym_alignof] = ACTIONS(1615),
    [anon_sym__Alignof] = ACTIONS(1615),
    [anon_sym_offsetof] = ACTIONS(1615),
    [anon_sym__Generic] = ACTIONS(1615),
    [anon_sym_asm] = ACTIONS(1615),
    [anon_sym___asm__] = ACTIONS(1615),
    [sym_number_literal] = ACTIONS(1617),
    [anon_sym_L_SQUOTE] = ACTIONS(1617),
    [anon_sym_u_SQUOTE] = ACTIONS(1617),
    [anon_sym_U_SQUOTE] = ACTIONS(1617),
    [anon_sym_u8_SQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [anon_sym_L_DQUOTE] = ACTIONS(1617),
    [anon_sym_u_DQUOTE] = ACTIONS(1617),
    [anon_sym_U_DQUOTE] = ACTIONS(1617),
    [anon_sym_u8_DQUOTE] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_true] = ACTIONS(1615),
    [sym_false] = ACTIONS(1615),
    [anon_sym_NULL] = ACTIONS(1615),
    [anon_sym_nullptr] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1615),
    [anon_sym_acquire] = ACTIONS(1615),
    [anon_sym_monitor] = ACTIONS(1615),
    [anon_sym_start] = ACTIONS(1615),
    [anon_sym_stop] = ACTIONS(1615),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1629),
    [sym_identifier] = ACTIONS(1627),
    [aux_sym_preproc_include_token1] = ACTIONS(1627),
    [aux_sym_preproc_def_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1627),
    [sym_preproc_directive] = ACTIONS(1627),
    [anon_sym_LPAREN2] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_typedef] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1627),
    [anon_sym___attribute__] = ACTIONS(1627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1629),
    [anon_sym___declspec] = ACTIONS(1627),
    [anon_sym___cdecl] = ACTIONS(1627),
    [anon_sym___clrcall] = ACTIONS(1627),
    [anon_sym___stdcall] = ACTIONS(1627),
    [anon_sym___fastcall] = ACTIONS(1627),
    [anon_sym___thiscall] = ACTIONS(1627),
    [anon_sym___vectorcall] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_signed] = ACTIONS(1627),
    [anon_sym_unsigned] = ACTIONS(1627),
    [anon_sym_long] = ACTIONS(1627),
    [anon_sym_short] = ACTIONS(1627),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_auto] = ACTIONS(1627),
    [anon_sym_register] = ACTIONS(1627),
    [anon_sym_inline] = ACTIONS(1627),
    [anon_sym___inline] = ACTIONS(1627),
    [anon_sym___inline__] = ACTIONS(1627),
    [anon_sym___forceinline] = ACTIONS(1627),
    [anon_sym_thread_local] = ACTIONS(1627),
    [anon_sym___thread] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [sym_primitive_type] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1627),
    [anon_sym_union] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_goto] = ACTIONS(1627),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_sizeof] = ACTIONS(1627),
    [anon_sym___alignof__] = ACTIONS(1627),
    [anon_sym___alignof] = ACTIONS(1627),
    [anon_sym__alignof] = ACTIONS(1627),
    [anon_sym_alignof] = ACTIONS(1627),
    [anon_sym__Alignof] = ACTIONS(1627),
    [anon_sym_offsetof] = ACTIONS(1627),
    [anon_sym__Generic] = ACTIONS(1627),
    [anon_sym_asm] = ACTIONS(1627),
    [anon_sym___asm__] = ACTIONS(1627),
    [sym_number_literal] = ACTIONS(1629),
    [anon_sym_L_SQUOTE] = ACTIONS(1629),
    [anon_sym_u_SQUOTE] = ACTIONS(1629),
    [anon_sym_U_SQUOTE] = ACTIONS(1629),
    [anon_sym_u8_SQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [anon_sym_L_DQUOTE] = ACTIONS(1629),
    [anon_sym_u_DQUOTE] = ACTIONS(1629),
    [anon_sym_U_DQUOTE] = ACTIONS(1629),
    [anon_sym_u8_DQUOTE] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [anon_sym_NULL] = ACTIONS(1627),
    [anon_sym_nullptr] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_acquire] = ACTIONS(1627),
    [anon_sym_monitor] = ACTIONS(1627),
    [anon_sym_start] = ACTIONS(1627),
    [anon_sym_stop] = ACTIONS(1627),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1625),
    [sym_identifier] = ACTIONS(1623),
    [aux_sym_preproc_include_token1] = ACTIONS(1623),
    [aux_sym_preproc_def_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1623),
    [sym_preproc_directive] = ACTIONS(1623),
    [anon_sym_LPAREN2] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym___extension__] = ACTIONS(1623),
    [anon_sym_typedef] = ACTIONS(1623),
    [anon_sym_extern] = ACTIONS(1623),
    [anon_sym___attribute__] = ACTIONS(1623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1625),
    [anon_sym___declspec] = ACTIONS(1623),
    [anon_sym___cdecl] = ACTIONS(1623),
    [anon_sym___clrcall] = ACTIONS(1623),
    [anon_sym___stdcall] = ACTIONS(1623),
    [anon_sym___fastcall] = ACTIONS(1623),
    [anon_sym___thiscall] = ACTIONS(1623),
    [anon_sym___vectorcall] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_signed] = ACTIONS(1623),
    [anon_sym_unsigned] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_auto] = ACTIONS(1623),
    [anon_sym_register] = ACTIONS(1623),
    [anon_sym_inline] = ACTIONS(1623),
    [anon_sym___inline] = ACTIONS(1623),
    [anon_sym___inline__] = ACTIONS(1623),
    [anon_sym___forceinline] = ACTIONS(1623),
    [anon_sym_thread_local] = ACTIONS(1623),
    [anon_sym___thread] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_constexpr] = ACTIONS(1623),
    [anon_sym_volatile] = ACTIONS(1623),
    [anon_sym_restrict] = ACTIONS(1623),
    [anon_sym___restrict__] = ACTIONS(1623),
    [anon_sym__Atomic] = ACTIONS(1623),
    [anon_sym__Noreturn] = ACTIONS(1623),
    [anon_sym_noreturn] = ACTIONS(1623),
    [sym_primitive_type] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [anon_sym_struct] = ACTIONS(1623),
    [anon_sym_union] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_goto] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_sizeof] = ACTIONS(1623),
    [anon_sym___alignof__] = ACTIONS(1623),
    [anon_sym___alignof] = ACTIONS(1623),
    [anon_sym__alignof] = ACTIONS(1623),
    [anon_sym_alignof] = ACTIONS(1623),
    [anon_sym__Alignof] = ACTIONS(1623),
    [anon_sym_offsetof] = ACTIONS(1623),
    [anon_sym__Generic] = ACTIONS(1623),
    [anon_sym_asm] = ACTIONS(1623),
    [anon_sym___asm__] = ACTIONS(1623),
    [sym_number_literal] = ACTIONS(1625),
    [anon_sym_L_SQUOTE] = ACTIONS(1625),
    [anon_sym_u_SQUOTE] = ACTIONS(1625),
    [anon_sym_U_SQUOTE] = ACTIONS(1625),
    [anon_sym_u8_SQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [anon_sym_L_DQUOTE] = ACTIONS(1625),
    [anon_sym_u_DQUOTE] = ACTIONS(1625),
    [anon_sym_U_DQUOTE] = ACTIONS(1625),
    [anon_sym_u8_DQUOTE] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [anon_sym_NULL] = ACTIONS(1623),
    [anon_sym_nullptr] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1623),
    [anon_sym_until] = ACTIONS(1623),
    [anon_sym_acquire] = ACTIONS(1623),
    [anon_sym_monitor] = ACTIONS(1623),
    [anon_sym_start] = ACTIONS(1623),
    [anon_sym_stop] = ACTIONS(1623),
  },
  [530] = {
    [sym_identifier] = ACTIONS(1644),
    [aux_sym_preproc_include_token1] = ACTIONS(1644),
    [aux_sym_preproc_def_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token1] = ACTIONS(1644),
    [aux_sym_preproc_if_token2] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_LPAREN2] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym___extension__] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym___attribute__] = ACTIONS(1644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1646),
    [anon_sym___declspec] = ACTIONS(1644),
    [anon_sym___cdecl] = ACTIONS(1644),
    [anon_sym___clrcall] = ACTIONS(1644),
    [anon_sym___stdcall] = ACTIONS(1644),
    [anon_sym___fastcall] = ACTIONS(1644),
    [anon_sym___thiscall] = ACTIONS(1644),
    [anon_sym___vectorcall] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_signed] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym___inline] = ACTIONS(1644),
    [anon_sym___inline__] = ACTIONS(1644),
    [anon_sym___forceinline] = ACTIONS(1644),
    [anon_sym_thread_local] = ACTIONS(1644),
    [anon_sym___thread] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_constexpr] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym___restrict__] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym__Noreturn] = ACTIONS(1644),
    [anon_sym_noreturn] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1646),
    [anon_sym_sizeof] = ACTIONS(1644),
    [anon_sym___alignof__] = ACTIONS(1644),
    [anon_sym___alignof] = ACTIONS(1644),
    [anon_sym__alignof] = ACTIONS(1644),
    [anon_sym_alignof] = ACTIONS(1644),
    [anon_sym__Alignof] = ACTIONS(1644),
    [anon_sym_offsetof] = ACTIONS(1644),
    [anon_sym__Generic] = ACTIONS(1644),
    [anon_sym_asm] = ACTIONS(1644),
    [anon_sym___asm__] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1646),
    [anon_sym_L_SQUOTE] = ACTIONS(1646),
    [anon_sym_u_SQUOTE] = ACTIONS(1646),
    [anon_sym_U_SQUOTE] = ACTIONS(1646),
    [anon_sym_u8_SQUOTE] = ACTIONS(1646),
    [anon_sym_SQUOTE] = ACTIONS(1646),
    [anon_sym_L_DQUOTE] = ACTIONS(1646),
    [anon_sym_u_DQUOTE] = ACTIONS(1646),
    [anon_sym_U_DQUOTE] = ACTIONS(1646),
    [anon_sym_u8_DQUOTE] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1646),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [anon_sym_NULL] = ACTIONS(1644),
    [anon_sym_nullptr] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1644),
    [anon_sym_acquire] = ACTIONS(1644),
    [anon_sym_monitor] = ACTIONS(1644),
    [anon_sym_start] = ACTIONS(1644),
    [anon_sym_stop] = ACTIONS(1644),
  },
  [531] = {
    [sym_identifier] = ACTIONS(1593),
    [aux_sym_preproc_include_token1] = ACTIONS(1593),
    [aux_sym_preproc_def_token1] = ACTIONS(1593),
    [aux_sym_preproc_if_token1] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1593),
    [sym_preproc_directive] = ACTIONS(1593),
    [anon_sym_LPAREN2] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(1593),
    [anon_sym_extern] = ACTIONS(1593),
    [anon_sym___attribute__] = ACTIONS(1593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1595),
    [anon_sym___declspec] = ACTIONS(1593),
    [anon_sym___cdecl] = ACTIONS(1593),
    [anon_sym___clrcall] = ACTIONS(1593),
    [anon_sym___stdcall] = ACTIONS(1593),
    [anon_sym___fastcall] = ACTIONS(1593),
    [anon_sym___thiscall] = ACTIONS(1593),
    [anon_sym___vectorcall] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1595),
    [anon_sym_RBRACE] = ACTIONS(1595),
    [anon_sym_signed] = ACTIONS(1593),
    [anon_sym_unsigned] = ACTIONS(1593),
    [anon_sym_long] = ACTIONS(1593),
    [anon_sym_short] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_auto] = ACTIONS(1593),
    [anon_sym_register] = ACTIONS(1593),
    [anon_sym_inline] = ACTIONS(1593),
    [anon_sym___inline] = ACTIONS(1593),
    [anon_sym___inline__] = ACTIONS(1593),
    [anon_sym___forceinline] = ACTIONS(1593),
    [anon_sym_thread_local] = ACTIONS(1593),
    [anon_sym___thread] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_constexpr] = ACTIONS(1593),
    [anon_sym_volatile] = ACTIONS(1593),
    [anon_sym_restrict] = ACTIONS(1593),
    [anon_sym___restrict__] = ACTIONS(1593),
    [anon_sym__Atomic] = ACTIONS(1593),
    [anon_sym__Noreturn] = ACTIONS(1593),
    [anon_sym_noreturn] = ACTIONS(1593),
    [sym_primitive_type] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [anon_sym_struct] = ACTIONS(1593),
    [anon_sym_union] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_goto] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1595),
    [anon_sym_PLUS_PLUS] = ACTIONS(1595),
    [anon_sym_sizeof] = ACTIONS(1593),
    [anon_sym___alignof__] = ACTIONS(1593),
    [anon_sym___alignof] = ACTIONS(1593),
    [anon_sym__alignof] = ACTIONS(1593),
    [anon_sym_alignof] = ACTIONS(1593),
    [anon_sym__Alignof] = ACTIONS(1593),
    [anon_sym_offsetof] = ACTIONS(1593),
    [anon_sym__Generic] = ACTIONS(1593),
    [anon_sym_asm] = ACTIONS(1593),
    [anon_sym___asm__] = ACTIONS(1593),
    [sym_number_literal] = ACTIONS(1595),
    [anon_sym_L_SQUOTE] = ACTIONS(1595),
    [anon_sym_u_SQUOTE] = ACTIONS(1595),
    [anon_sym_U_SQUOTE] = ACTIONS(1595),
    [anon_sym_u8_SQUOTE] = ACTIONS(1595),
    [anon_sym_SQUOTE] = ACTIONS(1595),
    [anon_sym_L_DQUOTE] = ACTIONS(1595),
    [anon_sym_u_DQUOTE] = ACTIONS(1595),
    [anon_sym_U_DQUOTE] = ACTIONS(1595),
    [anon_sym_u8_DQUOTE] = ACTIONS(1595),
    [anon_sym_DQUOTE] = ACTIONS(1595),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [anon_sym_NULL] = ACTIONS(1593),
    [anon_sym_nullptr] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1593),
    [anon_sym_acquire] = ACTIONS(1593),
    [anon_sym_monitor] = ACTIONS(1593),
    [anon_sym_start] = ACTIONS(1593),
    [anon_sym_stop] = ACTIONS(1593),
  },
  [532] = {
    [sym_identifier] = ACTIONS(1619),
    [aux_sym_preproc_include_token1] = ACTIONS(1619),
    [aux_sym_preproc_def_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token2] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1619),
    [sym_preproc_directive] = ACTIONS(1619),
    [anon_sym_LPAREN2] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym___extension__] = ACTIONS(1619),
    [anon_sym_typedef] = ACTIONS(1619),
    [anon_sym_extern] = ACTIONS(1619),
    [anon_sym___attribute__] = ACTIONS(1619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1621),
    [anon_sym___declspec] = ACTIONS(1619),
    [anon_sym___cdecl] = ACTIONS(1619),
    [anon_sym___clrcall] = ACTIONS(1619),
    [anon_sym___stdcall] = ACTIONS(1619),
    [anon_sym___fastcall] = ACTIONS(1619),
    [anon_sym___thiscall] = ACTIONS(1619),
    [anon_sym___vectorcall] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_signed] = ACTIONS(1619),
    [anon_sym_unsigned] = ACTIONS(1619),
    [anon_sym_long] = ACTIONS(1619),
    [anon_sym_short] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_auto] = ACTIONS(1619),
    [anon_sym_register] = ACTIONS(1619),
    [anon_sym_inline] = ACTIONS(1619),
    [anon_sym___inline] = ACTIONS(1619),
    [anon_sym___inline__] = ACTIONS(1619),
    [anon_sym___forceinline] = ACTIONS(1619),
    [anon_sym_thread_local] = ACTIONS(1619),
    [anon_sym___thread] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_constexpr] = ACTIONS(1619),
    [anon_sym_volatile] = ACTIONS(1619),
    [anon_sym_restrict] = ACTIONS(1619),
    [anon_sym___restrict__] = ACTIONS(1619),
    [anon_sym__Atomic] = ACTIONS(1619),
    [anon_sym__Noreturn] = ACTIONS(1619),
    [anon_sym_noreturn] = ACTIONS(1619),
    [sym_primitive_type] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [anon_sym_struct] = ACTIONS(1619),
    [anon_sym_union] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_switch] = ACTIONS(1619),
    [anon_sym_case] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_goto] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_sizeof] = ACTIONS(1619),
    [anon_sym___alignof__] = ACTIONS(1619),
    [anon_sym___alignof] = ACTIONS(1619),
    [anon_sym__alignof] = ACTIONS(1619),
    [anon_sym_alignof] = ACTIONS(1619),
    [anon_sym__Alignof] = ACTIONS(1619),
    [anon_sym_offsetof] = ACTIONS(1619),
    [anon_sym__Generic] = ACTIONS(1619),
    [anon_sym_asm] = ACTIONS(1619),
    [anon_sym___asm__] = ACTIONS(1619),
    [sym_number_literal] = ACTIONS(1621),
    [anon_sym_L_SQUOTE] = ACTIONS(1621),
    [anon_sym_u_SQUOTE] = ACTIONS(1621),
    [anon_sym_U_SQUOTE] = ACTIONS(1621),
    [anon_sym_u8_SQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [anon_sym_L_DQUOTE] = ACTIONS(1621),
    [anon_sym_u_DQUOTE] = ACTIONS(1621),
    [anon_sym_U_DQUOTE] = ACTIONS(1621),
    [anon_sym_u8_DQUOTE] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [anon_sym_NULL] = ACTIONS(1619),
    [anon_sym_nullptr] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1619),
    [anon_sym_acquire] = ACTIONS(1619),
    [anon_sym_monitor] = ACTIONS(1619),
    [anon_sym_start] = ACTIONS(1619),
    [anon_sym_stop] = ACTIONS(1619),
  },
  [533] = {
    [sym_identifier] = ACTIONS(1627),
    [aux_sym_preproc_include_token1] = ACTIONS(1627),
    [aux_sym_preproc_def_token1] = ACTIONS(1627),
    [aux_sym_preproc_if_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1627),
    [sym_preproc_directive] = ACTIONS(1627),
    [anon_sym_LPAREN2] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_typedef] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1627),
    [anon_sym___attribute__] = ACTIONS(1627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1629),
    [anon_sym___declspec] = ACTIONS(1627),
    [anon_sym___cdecl] = ACTIONS(1627),
    [anon_sym___clrcall] = ACTIONS(1627),
    [anon_sym___stdcall] = ACTIONS(1627),
    [anon_sym___fastcall] = ACTIONS(1627),
    [anon_sym___thiscall] = ACTIONS(1627),
    [anon_sym___vectorcall] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1629),
    [anon_sym_signed] = ACTIONS(1627),
    [anon_sym_unsigned] = ACTIONS(1627),
    [anon_sym_long] = ACTIONS(1627),
    [anon_sym_short] = ACTIONS(1627),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_auto] = ACTIONS(1627),
    [anon_sym_register] = ACTIONS(1627),
    [anon_sym_inline] = ACTIONS(1627),
    [anon_sym___inline] = ACTIONS(1627),
    [anon_sym___inline__] = ACTIONS(1627),
    [anon_sym___forceinline] = ACTIONS(1627),
    [anon_sym_thread_local] = ACTIONS(1627),
    [anon_sym___thread] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [sym_primitive_type] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1627),
    [anon_sym_union] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_goto] = ACTIONS(1627),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_sizeof] = ACTIONS(1627),
    [anon_sym___alignof__] = ACTIONS(1627),
    [anon_sym___alignof] = ACTIONS(1627),
    [anon_sym__alignof] = ACTIONS(1627),
    [anon_sym_alignof] = ACTIONS(1627),
    [anon_sym__Alignof] = ACTIONS(1627),
    [anon_sym_offsetof] = ACTIONS(1627),
    [anon_sym__Generic] = ACTIONS(1627),
    [anon_sym_asm] = ACTIONS(1627),
    [anon_sym___asm__] = ACTIONS(1627),
    [sym_number_literal] = ACTIONS(1629),
    [anon_sym_L_SQUOTE] = ACTIONS(1629),
    [anon_sym_u_SQUOTE] = ACTIONS(1629),
    [anon_sym_U_SQUOTE] = ACTIONS(1629),
    [anon_sym_u8_SQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [anon_sym_L_DQUOTE] = ACTIONS(1629),
    [anon_sym_u_DQUOTE] = ACTIONS(1629),
    [anon_sym_U_DQUOTE] = ACTIONS(1629),
    [anon_sym_u8_DQUOTE] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [anon_sym_NULL] = ACTIONS(1627),
    [anon_sym_nullptr] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_acquire] = ACTIONS(1627),
    [anon_sym_monitor] = ACTIONS(1627),
    [anon_sym_start] = ACTIONS(1627),
    [anon_sym_stop] = ACTIONS(1627),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1619),
    [aux_sym_preproc_include_token1] = ACTIONS(1619),
    [aux_sym_preproc_def_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1619),
    [sym_preproc_directive] = ACTIONS(1619),
    [anon_sym_LPAREN2] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym___extension__] = ACTIONS(1619),
    [anon_sym_typedef] = ACTIONS(1619),
    [anon_sym_extern] = ACTIONS(1619),
    [anon_sym___attribute__] = ACTIONS(1619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1621),
    [anon_sym___declspec] = ACTIONS(1619),
    [anon_sym___cdecl] = ACTIONS(1619),
    [anon_sym___clrcall] = ACTIONS(1619),
    [anon_sym___stdcall] = ACTIONS(1619),
    [anon_sym___fastcall] = ACTIONS(1619),
    [anon_sym___thiscall] = ACTIONS(1619),
    [anon_sym___vectorcall] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_signed] = ACTIONS(1619),
    [anon_sym_unsigned] = ACTIONS(1619),
    [anon_sym_long] = ACTIONS(1619),
    [anon_sym_short] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_auto] = ACTIONS(1619),
    [anon_sym_register] = ACTIONS(1619),
    [anon_sym_inline] = ACTIONS(1619),
    [anon_sym___inline] = ACTIONS(1619),
    [anon_sym___inline__] = ACTIONS(1619),
    [anon_sym___forceinline] = ACTIONS(1619),
    [anon_sym_thread_local] = ACTIONS(1619),
    [anon_sym___thread] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_constexpr] = ACTIONS(1619),
    [anon_sym_volatile] = ACTIONS(1619),
    [anon_sym_restrict] = ACTIONS(1619),
    [anon_sym___restrict__] = ACTIONS(1619),
    [anon_sym__Atomic] = ACTIONS(1619),
    [anon_sym__Noreturn] = ACTIONS(1619),
    [anon_sym_noreturn] = ACTIONS(1619),
    [sym_primitive_type] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [anon_sym_struct] = ACTIONS(1619),
    [anon_sym_union] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_switch] = ACTIONS(1619),
    [anon_sym_case] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_goto] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_sizeof] = ACTIONS(1619),
    [anon_sym___alignof__] = ACTIONS(1619),
    [anon_sym___alignof] = ACTIONS(1619),
    [anon_sym__alignof] = ACTIONS(1619),
    [anon_sym_alignof] = ACTIONS(1619),
    [anon_sym__Alignof] = ACTIONS(1619),
    [anon_sym_offsetof] = ACTIONS(1619),
    [anon_sym__Generic] = ACTIONS(1619),
    [anon_sym_asm] = ACTIONS(1619),
    [anon_sym___asm__] = ACTIONS(1619),
    [sym_number_literal] = ACTIONS(1621),
    [anon_sym_L_SQUOTE] = ACTIONS(1621),
    [anon_sym_u_SQUOTE] = ACTIONS(1621),
    [anon_sym_U_SQUOTE] = ACTIONS(1621),
    [anon_sym_u8_SQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [anon_sym_L_DQUOTE] = ACTIONS(1621),
    [anon_sym_u_DQUOTE] = ACTIONS(1621),
    [anon_sym_U_DQUOTE] = ACTIONS(1621),
    [anon_sym_u8_DQUOTE] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [anon_sym_NULL] = ACTIONS(1619),
    [anon_sym_nullptr] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_task] = ACTIONS(1619),
    [anon_sym_until] = ACTIONS(1619),
    [anon_sym_acquire] = ACTIONS(1619),
    [anon_sym_monitor] = ACTIONS(1619),
    [anon_sym_start] = ACTIONS(1619),
    [anon_sym_stop] = ACTIONS(1619),
  },
  [535] = {
    [sym_identifier] = ACTIONS(1623),
    [aux_sym_preproc_include_token1] = ACTIONS(1623),
    [aux_sym_preproc_def_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token1] = ACTIONS(1623),
    [aux_sym_preproc_if_token2] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1623),
    [sym_preproc_directive] = ACTIONS(1623),
    [anon_sym_LPAREN2] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym___extension__] = ACTIONS(1623),
    [anon_sym_typedef] = ACTIONS(1623),
    [anon_sym_extern] = ACTIONS(1623),
    [anon_sym___attribute__] = ACTIONS(1623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1625),
    [anon_sym___declspec] = ACTIONS(1623),
    [anon_sym___cdecl] = ACTIONS(1623),
    [anon_sym___clrcall] = ACTIONS(1623),
    [anon_sym___stdcall] = ACTIONS(1623),
    [anon_sym___fastcall] = ACTIONS(1623),
    [anon_sym___thiscall] = ACTIONS(1623),
    [anon_sym___vectorcall] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_signed] = ACTIONS(1623),
    [anon_sym_unsigned] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_auto] = ACTIONS(1623),
    [anon_sym_register] = ACTIONS(1623),
    [anon_sym_inline] = ACTIONS(1623),
    [anon_sym___inline] = ACTIONS(1623),
    [anon_sym___inline__] = ACTIONS(1623),
    [anon_sym___forceinline] = ACTIONS(1623),
    [anon_sym_thread_local] = ACTIONS(1623),
    [anon_sym___thread] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_constexpr] = ACTIONS(1623),
    [anon_sym_volatile] = ACTIONS(1623),
    [anon_sym_restrict] = ACTIONS(1623),
    [anon_sym___restrict__] = ACTIONS(1623),
    [anon_sym__Atomic] = ACTIONS(1623),
    [anon_sym__Noreturn] = ACTIONS(1623),
    [anon_sym_noreturn] = ACTIONS(1623),
    [sym_primitive_type] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [anon_sym_struct] = ACTIONS(1623),
    [anon_sym_union] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_goto] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_sizeof] = ACTIONS(1623),
    [anon_sym___alignof__] = ACTIONS(1623),
    [anon_sym___alignof] = ACTIONS(1623),
    [anon_sym__alignof] = ACTIONS(1623),
    [anon_sym_alignof] = ACTIONS(1623),
    [anon_sym__Alignof] = ACTIONS(1623),
    [anon_sym_offsetof] = ACTIONS(1623),
    [anon_sym__Generic] = ACTIONS(1623),
    [anon_sym_asm] = ACTIONS(1623),
    [anon_sym___asm__] = ACTIONS(1623),
    [sym_number_literal] = ACTIONS(1625),
    [anon_sym_L_SQUOTE] = ACTIONS(1625),
    [anon_sym_u_SQUOTE] = ACTIONS(1625),
    [anon_sym_U_SQUOTE] = ACTIONS(1625),
    [anon_sym_u8_SQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [anon_sym_L_DQUOTE] = ACTIONS(1625),
    [anon_sym_u_DQUOTE] = ACTIONS(1625),
    [anon_sym_U_DQUOTE] = ACTIONS(1625),
    [anon_sym_u8_DQUOTE] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [anon_sym_NULL] = ACTIONS(1623),
    [anon_sym_nullptr] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1623),
    [anon_sym_acquire] = ACTIONS(1623),
    [anon_sym_monitor] = ACTIONS(1623),
    [anon_sym_start] = ACTIONS(1623),
    [anon_sym_stop] = ACTIONS(1623),
  },
  [536] = {
    [sym_identifier] = ACTIONS(1668),
    [aux_sym_preproc_include_token1] = ACTIONS(1668),
    [aux_sym_preproc_def_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token1] = ACTIONS(1668),
    [aux_sym_preproc_if_token2] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1668),
    [sym_preproc_directive] = ACTIONS(1668),
    [anon_sym_LPAREN2] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym___extension__] = ACTIONS(1668),
    [anon_sym_typedef] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym___attribute__] = ACTIONS(1668),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1670),
    [anon_sym___declspec] = ACTIONS(1668),
    [anon_sym___cdecl] = ACTIONS(1668),
    [anon_sym___clrcall] = ACTIONS(1668),
    [anon_sym___stdcall] = ACTIONS(1668),
    [anon_sym___fastcall] = ACTIONS(1668),
    [anon_sym___thiscall] = ACTIONS(1668),
    [anon_sym___vectorcall] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_signed] = ACTIONS(1668),
    [anon_sym_unsigned] = ACTIONS(1668),
    [anon_sym_long] = ACTIONS(1668),
    [anon_sym_short] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_auto] = ACTIONS(1668),
    [anon_sym_register] = ACTIONS(1668),
    [anon_sym_inline] = ACTIONS(1668),
    [anon_sym___inline] = ACTIONS(1668),
    [anon_sym___inline__] = ACTIONS(1668),
    [anon_sym___forceinline] = ACTIONS(1668),
    [anon_sym_thread_local] = ACTIONS(1668),
    [anon_sym___thread] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_constexpr] = ACTIONS(1668),
    [anon_sym_volatile] = ACTIONS(1668),
    [anon_sym_restrict] = ACTIONS(1668),
    [anon_sym___restrict__] = ACTIONS(1668),
    [anon_sym__Atomic] = ACTIONS(1668),
    [anon_sym__Noreturn] = ACTIONS(1668),
    [anon_sym_noreturn] = ACTIONS(1668),
    [sym_primitive_type] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_switch] = ACTIONS(1668),
    [anon_sym_case] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_do] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_goto] = ACTIONS(1668),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_sizeof] = ACTIONS(1668),
    [anon_sym___alignof__] = ACTIONS(1668),
    [anon_sym___alignof] = ACTIONS(1668),
    [anon_sym__alignof] = ACTIONS(1668),
    [anon_sym_alignof] = ACTIONS(1668),
    [anon_sym__Alignof] = ACTIONS(1668),
    [anon_sym_offsetof] = ACTIONS(1668),
    [anon_sym__Generic] = ACTIONS(1668),
    [anon_sym_asm] = ACTIONS(1668),
    [anon_sym___asm__] = ACTIONS(1668),
    [sym_number_literal] = ACTIONS(1670),
    [anon_sym_L_SQUOTE] = ACTIONS(1670),
    [anon_sym_u_SQUOTE] = ACTIONS(1670),
    [anon_sym_U_SQUOTE] = ACTIONS(1670),
    [anon_sym_u8_SQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [anon_sym_L_DQUOTE] = ACTIONS(1670),
    [anon_sym_u_DQUOTE] = ACTIONS(1670),
    [anon_sym_U_DQUOTE] = ACTIONS(1670),
    [anon_sym_u8_DQUOTE] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [anon_sym_NULL] = ACTIONS(1668),
    [anon_sym_nullptr] = ACTIONS(1668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1668),
    [anon_sym_acquire] = ACTIONS(1668),
    [anon_sym_monitor] = ACTIONS(1668),
    [anon_sym_start] = ACTIONS(1668),
    [anon_sym_stop] = ACTIONS(1668),
  },
  [537] = {
    [sym_identifier] = ACTIONS(1601),
    [aux_sym_preproc_include_token1] = ACTIONS(1601),
    [aux_sym_preproc_def_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token1] = ACTIONS(1601),
    [aux_sym_preproc_if_token2] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1601),
    [sym_preproc_directive] = ACTIONS(1601),
    [anon_sym_LPAREN2] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym___extension__] = ACTIONS(1601),
    [anon_sym_typedef] = ACTIONS(1601),
    [anon_sym_extern] = ACTIONS(1601),
    [anon_sym___attribute__] = ACTIONS(1601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1603),
    [anon_sym___declspec] = ACTIONS(1601),
    [anon_sym___cdecl] = ACTIONS(1601),
    [anon_sym___clrcall] = ACTIONS(1601),
    [anon_sym___stdcall] = ACTIONS(1601),
    [anon_sym___fastcall] = ACTIONS(1601),
    [anon_sym___thiscall] = ACTIONS(1601),
    [anon_sym___vectorcall] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_signed] = ACTIONS(1601),
    [anon_sym_unsigned] = ACTIONS(1601),
    [anon_sym_long] = ACTIONS(1601),
    [anon_sym_short] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1601),
    [anon_sym_auto] = ACTIONS(1601),
    [anon_sym_register] = ACTIONS(1601),
    [anon_sym_inline] = ACTIONS(1601),
    [anon_sym___inline] = ACTIONS(1601),
    [anon_sym___inline__] = ACTIONS(1601),
    [anon_sym___forceinline] = ACTIONS(1601),
    [anon_sym_thread_local] = ACTIONS(1601),
    [anon_sym___thread] = ACTIONS(1601),
    [anon_sym_const] = ACTIONS(1601),
    [anon_sym_constexpr] = ACTIONS(1601),
    [anon_sym_volatile] = ACTIONS(1601),
    [anon_sym_restrict] = ACTIONS(1601),
    [anon_sym___restrict__] = ACTIONS(1601),
    [anon_sym__Atomic] = ACTIONS(1601),
    [anon_sym__Noreturn] = ACTIONS(1601),
    [anon_sym_noreturn] = ACTIONS(1601),
    [sym_primitive_type] = ACTIONS(1601),
    [anon_sym_enum] = ACTIONS(1601),
    [anon_sym_struct] = ACTIONS(1601),
    [anon_sym_union] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_switch] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_while] = ACTIONS(1601),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1601),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1601),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_goto] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_sizeof] = ACTIONS(1601),
    [anon_sym___alignof__] = ACTIONS(1601),
    [anon_sym___alignof] = ACTIONS(1601),
    [anon_sym__alignof] = ACTIONS(1601),
    [anon_sym_alignof] = ACTIONS(1601),
    [anon_sym__Alignof] = ACTIONS(1601),
    [anon_sym_offsetof] = ACTIONS(1601),
    [anon_sym__Generic] = ACTIONS(1601),
    [anon_sym_asm] = ACTIONS(1601),
    [anon_sym___asm__] = ACTIONS(1601),
    [sym_number_literal] = ACTIONS(1603),
    [anon_sym_L_SQUOTE] = ACTIONS(1603),
    [anon_sym_u_SQUOTE] = ACTIONS(1603),
    [anon_sym_U_SQUOTE] = ACTIONS(1603),
    [anon_sym_u8_SQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [anon_sym_L_DQUOTE] = ACTIONS(1603),
    [anon_sym_u_DQUOTE] = ACTIONS(1603),
    [anon_sym_U_DQUOTE] = ACTIONS(1603),
    [anon_sym_u8_DQUOTE] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [anon_sym_NULL] = ACTIONS(1601),
    [anon_sym_nullptr] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1601),
    [anon_sym_acquire] = ACTIONS(1601),
    [anon_sym_monitor] = ACTIONS(1601),
    [anon_sym_start] = ACTIONS(1601),
    [anon_sym_stop] = ACTIONS(1601),
  },
  [538] = {
    [sym_identifier] = ACTIONS(1619),
    [aux_sym_preproc_include_token1] = ACTIONS(1619),
    [aux_sym_preproc_def_token1] = ACTIONS(1619),
    [aux_sym_preproc_if_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1619),
    [sym_preproc_directive] = ACTIONS(1619),
    [anon_sym_LPAREN2] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym___extension__] = ACTIONS(1619),
    [anon_sym_typedef] = ACTIONS(1619),
    [anon_sym_extern] = ACTIONS(1619),
    [anon_sym___attribute__] = ACTIONS(1619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1621),
    [anon_sym___declspec] = ACTIONS(1619),
    [anon_sym___cdecl] = ACTIONS(1619),
    [anon_sym___clrcall] = ACTIONS(1619),
    [anon_sym___stdcall] = ACTIONS(1619),
    [anon_sym___fastcall] = ACTIONS(1619),
    [anon_sym___thiscall] = ACTIONS(1619),
    [anon_sym___vectorcall] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_signed] = ACTIONS(1619),
    [anon_sym_unsigned] = ACTIONS(1619),
    [anon_sym_long] = ACTIONS(1619),
    [anon_sym_short] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_auto] = ACTIONS(1619),
    [anon_sym_register] = ACTIONS(1619),
    [anon_sym_inline] = ACTIONS(1619),
    [anon_sym___inline] = ACTIONS(1619),
    [anon_sym___inline__] = ACTIONS(1619),
    [anon_sym___forceinline] = ACTIONS(1619),
    [anon_sym_thread_local] = ACTIONS(1619),
    [anon_sym___thread] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_constexpr] = ACTIONS(1619),
    [anon_sym_volatile] = ACTIONS(1619),
    [anon_sym_restrict] = ACTIONS(1619),
    [anon_sym___restrict__] = ACTIONS(1619),
    [anon_sym__Atomic] = ACTIONS(1619),
    [anon_sym__Noreturn] = ACTIONS(1619),
    [anon_sym_noreturn] = ACTIONS(1619),
    [sym_primitive_type] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [anon_sym_struct] = ACTIONS(1619),
    [anon_sym_union] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_switch] = ACTIONS(1619),
    [anon_sym_case] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_goto] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_sizeof] = ACTIONS(1619),
    [anon_sym___alignof__] = ACTIONS(1619),
    [anon_sym___alignof] = ACTIONS(1619),
    [anon_sym__alignof] = ACTIONS(1619),
    [anon_sym_alignof] = ACTIONS(1619),
    [anon_sym__Alignof] = ACTIONS(1619),
    [anon_sym_offsetof] = ACTIONS(1619),
    [anon_sym__Generic] = ACTIONS(1619),
    [anon_sym_asm] = ACTIONS(1619),
    [anon_sym___asm__] = ACTIONS(1619),
    [sym_number_literal] = ACTIONS(1621),
    [anon_sym_L_SQUOTE] = ACTIONS(1621),
    [anon_sym_u_SQUOTE] = ACTIONS(1621),
    [anon_sym_U_SQUOTE] = ACTIONS(1621),
    [anon_sym_u8_SQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [anon_sym_L_DQUOTE] = ACTIONS(1621),
    [anon_sym_u_DQUOTE] = ACTIONS(1621),
    [anon_sym_U_DQUOTE] = ACTIONS(1621),
    [anon_sym_u8_DQUOTE] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [anon_sym_NULL] = ACTIONS(1619),
    [anon_sym_nullptr] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1619),
    [anon_sym_acquire] = ACTIONS(1619),
    [anon_sym_monitor] = ACTIONS(1619),
    [anon_sym_start] = ACTIONS(1619),
    [anon_sym_stop] = ACTIONS(1619),
  },
  [539] = {
    [sym_identifier] = ACTIONS(1597),
    [aux_sym_preproc_include_token1] = ACTIONS(1597),
    [aux_sym_preproc_def_token1] = ACTIONS(1597),
    [aux_sym_preproc_if_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1597),
    [sym_preproc_directive] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym___extension__] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1597),
    [anon_sym_extern] = ACTIONS(1597),
    [anon_sym___attribute__] = ACTIONS(1597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1599),
    [anon_sym___declspec] = ACTIONS(1597),
    [anon_sym___cdecl] = ACTIONS(1597),
    [anon_sym___clrcall] = ACTIONS(1597),
    [anon_sym___stdcall] = ACTIONS(1597),
    [anon_sym___fastcall] = ACTIONS(1597),
    [anon_sym___thiscall] = ACTIONS(1597),
    [anon_sym___vectorcall] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_signed] = ACTIONS(1597),
    [anon_sym_unsigned] = ACTIONS(1597),
    [anon_sym_long] = ACTIONS(1597),
    [anon_sym_short] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_auto] = ACTIONS(1597),
    [anon_sym_register] = ACTIONS(1597),
    [anon_sym_inline] = ACTIONS(1597),
    [anon_sym___inline] = ACTIONS(1597),
    [anon_sym___inline__] = ACTIONS(1597),
    [anon_sym___forceinline] = ACTIONS(1597),
    [anon_sym_thread_local] = ACTIONS(1597),
    [anon_sym___thread] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(1597),
    [anon_sym_constexpr] = ACTIONS(1597),
    [anon_sym_volatile] = ACTIONS(1597),
    [anon_sym_restrict] = ACTIONS(1597),
    [anon_sym___restrict__] = ACTIONS(1597),
    [anon_sym__Atomic] = ACTIONS(1597),
    [anon_sym__Noreturn] = ACTIONS(1597),
    [anon_sym_noreturn] = ACTIONS(1597),
    [sym_primitive_type] = ACTIONS(1597),
    [anon_sym_enum] = ACTIONS(1597),
    [anon_sym_struct] = ACTIONS(1597),
    [anon_sym_union] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1597),
    [anon_sym_switch] = ACTIONS(1597),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1597),
    [anon_sym_while] = ACTIONS(1597),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_for] = ACTIONS(1597),
    [anon_sym_return] = ACTIONS(1597),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1597),
    [anon_sym_goto] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_sizeof] = ACTIONS(1597),
    [anon_sym___alignof__] = ACTIONS(1597),
    [anon_sym___alignof] = ACTIONS(1597),
    [anon_sym__alignof] = ACTIONS(1597),
    [anon_sym_alignof] = ACTIONS(1597),
    [anon_sym__Alignof] = ACTIONS(1597),
    [anon_sym_offsetof] = ACTIONS(1597),
    [anon_sym__Generic] = ACTIONS(1597),
    [anon_sym_asm] = ACTIONS(1597),
    [anon_sym___asm__] = ACTIONS(1597),
    [sym_number_literal] = ACTIONS(1599),
    [anon_sym_L_SQUOTE] = ACTIONS(1599),
    [anon_sym_u_SQUOTE] = ACTIONS(1599),
    [anon_sym_U_SQUOTE] = ACTIONS(1599),
    [anon_sym_u8_SQUOTE] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [anon_sym_L_DQUOTE] = ACTIONS(1599),
    [anon_sym_u_DQUOTE] = ACTIONS(1599),
    [anon_sym_U_DQUOTE] = ACTIONS(1599),
    [anon_sym_u8_DQUOTE] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [anon_sym_NULL] = ACTIONS(1597),
    [anon_sym_nullptr] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1597),
    [anon_sym_acquire] = ACTIONS(1597),
    [anon_sym_monitor] = ACTIONS(1597),
    [anon_sym_start] = ACTIONS(1597),
    [anon_sym_stop] = ACTIONS(1597),
  },
  [540] = {
    [sym_identifier] = ACTIONS(1611),
    [aux_sym_preproc_include_token1] = ACTIONS(1611),
    [aux_sym_preproc_def_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token1] = ACTIONS(1611),
    [aux_sym_preproc_if_token2] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1611),
    [sym_preproc_directive] = ACTIONS(1611),
    [anon_sym_LPAREN2] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym___extension__] = ACTIONS(1611),
    [anon_sym_typedef] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym___attribute__] = ACTIONS(1611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1613),
    [anon_sym___declspec] = ACTIONS(1611),
    [anon_sym___cdecl] = ACTIONS(1611),
    [anon_sym___clrcall] = ACTIONS(1611),
    [anon_sym___stdcall] = ACTIONS(1611),
    [anon_sym___fastcall] = ACTIONS(1611),
    [anon_sym___thiscall] = ACTIONS(1611),
    [anon_sym___vectorcall] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_signed] = ACTIONS(1611),
    [anon_sym_unsigned] = ACTIONS(1611),
    [anon_sym_long] = ACTIONS(1611),
    [anon_sym_short] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_auto] = ACTIONS(1611),
    [anon_sym_register] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym___inline] = ACTIONS(1611),
    [anon_sym___inline__] = ACTIONS(1611),
    [anon_sym___forceinline] = ACTIONS(1611),
    [anon_sym_thread_local] = ACTIONS(1611),
    [anon_sym___thread] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_constexpr] = ACTIONS(1611),
    [anon_sym_volatile] = ACTIONS(1611),
    [anon_sym_restrict] = ACTIONS(1611),
    [anon_sym___restrict__] = ACTIONS(1611),
    [anon_sym__Atomic] = ACTIONS(1611),
    [anon_sym__Noreturn] = ACTIONS(1611),
    [anon_sym_noreturn] = ACTIONS(1611),
    [sym_primitive_type] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_goto] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_sizeof] = ACTIONS(1611),
    [anon_sym___alignof__] = ACTIONS(1611),
    [anon_sym___alignof] = ACTIONS(1611),
    [anon_sym__alignof] = ACTIONS(1611),
    [anon_sym_alignof] = ACTIONS(1611),
    [anon_sym__Alignof] = ACTIONS(1611),
    [anon_sym_offsetof] = ACTIONS(1611),
    [anon_sym__Generic] = ACTIONS(1611),
    [anon_sym_asm] = ACTIONS(1611),
    [anon_sym___asm__] = ACTIONS(1611),
    [sym_number_literal] = ACTIONS(1613),
    [anon_sym_L_SQUOTE] = ACTIONS(1613),
    [anon_sym_u_SQUOTE] = ACTIONS(1613),
    [anon_sym_U_SQUOTE] = ACTIONS(1613),
    [anon_sym_u8_SQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_L_DQUOTE] = ACTIONS(1613),
    [anon_sym_u_DQUOTE] = ACTIONS(1613),
    [anon_sym_U_DQUOTE] = ACTIONS(1613),
    [anon_sym_u8_DQUOTE] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [sym_true] = ACTIONS(1611),
    [sym_false] = ACTIONS(1611),
    [anon_sym_NULL] = ACTIONS(1611),
    [anon_sym_nullptr] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1611),
    [anon_sym_acquire] = ACTIONS(1611),
    [anon_sym_monitor] = ACTIONS(1611),
    [anon_sym_start] = ACTIONS(1611),
    [anon_sym_stop] = ACTIONS(1611),
  },
  [541] = {
    [sym_identifier] = ACTIONS(1652),
    [aux_sym_preproc_include_token1] = ACTIONS(1652),
    [aux_sym_preproc_def_token1] = ACTIONS(1652),
    [aux_sym_preproc_if_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1652),
    [sym_preproc_directive] = ACTIONS(1652),
    [anon_sym_LPAREN2] = ACTIONS(1654),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_TILDE] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym___extension__] = ACTIONS(1652),
    [anon_sym_typedef] = ACTIONS(1652),
    [anon_sym_extern] = ACTIONS(1652),
    [anon_sym___attribute__] = ACTIONS(1652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1654),
    [anon_sym___declspec] = ACTIONS(1652),
    [anon_sym___cdecl] = ACTIONS(1652),
    [anon_sym___clrcall] = ACTIONS(1652),
    [anon_sym___stdcall] = ACTIONS(1652),
    [anon_sym___fastcall] = ACTIONS(1652),
    [anon_sym___thiscall] = ACTIONS(1652),
    [anon_sym___vectorcall] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [anon_sym_signed] = ACTIONS(1652),
    [anon_sym_unsigned] = ACTIONS(1652),
    [anon_sym_long] = ACTIONS(1652),
    [anon_sym_short] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_auto] = ACTIONS(1652),
    [anon_sym_register] = ACTIONS(1652),
    [anon_sym_inline] = ACTIONS(1652),
    [anon_sym___inline] = ACTIONS(1652),
    [anon_sym___inline__] = ACTIONS(1652),
    [anon_sym___forceinline] = ACTIONS(1652),
    [anon_sym_thread_local] = ACTIONS(1652),
    [anon_sym___thread] = ACTIONS(1652),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_constexpr] = ACTIONS(1652),
    [anon_sym_volatile] = ACTIONS(1652),
    [anon_sym_restrict] = ACTIONS(1652),
    [anon_sym___restrict__] = ACTIONS(1652),
    [anon_sym__Atomic] = ACTIONS(1652),
    [anon_sym__Noreturn] = ACTIONS(1652),
    [anon_sym_noreturn] = ACTIONS(1652),
    [sym_primitive_type] = ACTIONS(1652),
    [anon_sym_enum] = ACTIONS(1652),
    [anon_sym_struct] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_if] = ACTIONS(1652),
    [anon_sym_switch] = ACTIONS(1652),
    [anon_sym_case] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_while] = ACTIONS(1652),
    [anon_sym_do] = ACTIONS(1652),
    [anon_sym_for] = ACTIONS(1652),
    [anon_sym_return] = ACTIONS(1652),
    [anon_sym_break] = ACTIONS(1652),
    [anon_sym_continue] = ACTIONS(1652),
    [anon_sym_goto] = ACTIONS(1652),
    [anon_sym_DASH_DASH] = ACTIONS(1654),
    [anon_sym_PLUS_PLUS] = ACTIONS(1654),
    [anon_sym_sizeof] = ACTIONS(1652),
    [anon_sym___alignof__] = ACTIONS(1652),
    [anon_sym___alignof] = ACTIONS(1652),
    [anon_sym__alignof] = ACTIONS(1652),
    [anon_sym_alignof] = ACTIONS(1652),
    [anon_sym__Alignof] = ACTIONS(1652),
    [anon_sym_offsetof] = ACTIONS(1652),
    [anon_sym__Generic] = ACTIONS(1652),
    [anon_sym_asm] = ACTIONS(1652),
    [anon_sym___asm__] = ACTIONS(1652),
    [sym_number_literal] = ACTIONS(1654),
    [anon_sym_L_SQUOTE] = ACTIONS(1654),
    [anon_sym_u_SQUOTE] = ACTIONS(1654),
    [anon_sym_U_SQUOTE] = ACTIONS(1654),
    [anon_sym_u8_SQUOTE] = ACTIONS(1654),
    [anon_sym_SQUOTE] = ACTIONS(1654),
    [anon_sym_L_DQUOTE] = ACTIONS(1654),
    [anon_sym_u_DQUOTE] = ACTIONS(1654),
    [anon_sym_U_DQUOTE] = ACTIONS(1654),
    [anon_sym_u8_DQUOTE] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [sym_true] = ACTIONS(1652),
    [sym_false] = ACTIONS(1652),
    [anon_sym_NULL] = ACTIONS(1652),
    [anon_sym_nullptr] = ACTIONS(1652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1652),
    [anon_sym_acquire] = ACTIONS(1652),
    [anon_sym_monitor] = ACTIONS(1652),
    [anon_sym_start] = ACTIONS(1652),
    [anon_sym_stop] = ACTIONS(1652),
  },
  [542] = {
    [sym__expression] = STATE(812),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(821),
    [sym_call_expression] = STATE(821),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(821),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(821),
    [sym_initializer_list] = STATE(816),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_identifier] = ACTIONS(2094),
    [anon_sym_COMMA] = ACTIONS(2096),
    [anon_sym_RPAREN] = ACTIONS(2096),
    [anon_sym_LPAREN2] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2102),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(2104),
    [anon_sym_SLASH] = ACTIONS(2106),
    [anon_sym_PERCENT] = ACTIONS(2106),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_CARET] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2104),
    [anon_sym_EQ_EQ] = ACTIONS(2096),
    [anon_sym_BANG_EQ] = ACTIONS(2096),
    [anon_sym_GT] = ACTIONS(2106),
    [anon_sym_GT_EQ] = ACTIONS(2096),
    [anon_sym_LT_EQ] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_LT_LT] = ACTIONS(2106),
    [anon_sym_GT_GT] = ACTIONS(2106),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym___attribute__] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_EQ] = ACTIONS(2106),
    [anon_sym_COLON] = ACTIONS(2096),
    [anon_sym_QMARK] = ACTIONS(2096),
    [anon_sym_STAR_EQ] = ACTIONS(2096),
    [anon_sym_SLASH_EQ] = ACTIONS(2096),
    [anon_sym_PERCENT_EQ] = ACTIONS(2096),
    [anon_sym_PLUS_EQ] = ACTIONS(2096),
    [anon_sym_DASH_EQ] = ACTIONS(2096),
    [anon_sym_LT_LT_EQ] = ACTIONS(2096),
    [anon_sym_GT_GT_EQ] = ACTIONS(2096),
    [anon_sym_AMP_EQ] = ACTIONS(2096),
    [anon_sym_CARET_EQ] = ACTIONS(2096),
    [anon_sym_PIPE_EQ] = ACTIONS(2096),
    [anon_sym_DASH_DASH] = ACTIONS(2110),
    [anon_sym_PLUS_PLUS] = ACTIONS(2110),
    [anon_sym_sizeof] = ACTIONS(2112),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2106),
    [anon_sym_DASH_GT] = ACTIONS(2096),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym__expression] = STATE(899),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(821),
    [sym_call_expression] = STATE(821),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(821),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(821),
    [sym_initializer_list] = STATE(816),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_identifier] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2114),
    [anon_sym_BANG] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_PLUS] = ACTIONS(2116),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_SLASH] = ACTIONS(2106),
    [anon_sym_PERCENT] = ACTIONS(2106),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_CARET] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2120),
    [anon_sym_EQ_EQ] = ACTIONS(2096),
    [anon_sym_BANG_EQ] = ACTIONS(2096),
    [anon_sym_GT] = ACTIONS(2106),
    [anon_sym_GT_EQ] = ACTIONS(2096),
    [anon_sym_LT_EQ] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_LT_LT] = ACTIONS(2106),
    [anon_sym_GT_GT] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_RBRACK] = ACTIONS(2096),
    [anon_sym_EQ] = ACTIONS(2106),
    [anon_sym_QMARK] = ACTIONS(2096),
    [anon_sym_STAR_EQ] = ACTIONS(2096),
    [anon_sym_SLASH_EQ] = ACTIONS(2096),
    [anon_sym_PERCENT_EQ] = ACTIONS(2096),
    [anon_sym_PLUS_EQ] = ACTIONS(2096),
    [anon_sym_DASH_EQ] = ACTIONS(2096),
    [anon_sym_LT_LT_EQ] = ACTIONS(2096),
    [anon_sym_GT_GT_EQ] = ACTIONS(2096),
    [anon_sym_AMP_EQ] = ACTIONS(2096),
    [anon_sym_CARET_EQ] = ACTIONS(2096),
    [anon_sym_PIPE_EQ] = ACTIONS(2096),
    [anon_sym_DASH_DASH] = ACTIONS(2122),
    [anon_sym_PLUS_PLUS] = ACTIONS(2122),
    [anon_sym_sizeof] = ACTIONS(2124),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2106),
    [anon_sym_DASH_GT] = ACTIONS(2096),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_COMMA] = ACTIONS(2128),
    [anon_sym_RPAREN] = ACTIONS(2128),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_auto] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_COLON] = ACTIONS(2128),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_goto] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2128),
    [anon_sym_sizeof] = ACTIONS(2126),
    [anon_sym___alignof__] = ACTIONS(2126),
    [anon_sym___alignof] = ACTIONS(2126),
    [anon_sym__alignof] = ACTIONS(2126),
    [anon_sym_alignof] = ACTIONS(2126),
    [anon_sym__Alignof] = ACTIONS(2126),
    [anon_sym_offsetof] = ACTIONS(2126),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2126),
    [anon_sym___asm__] = ACTIONS(2126),
    [sym_number_literal] = ACTIONS(2128),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2128),
    [anon_sym_u_DQUOTE] = ACTIONS(2128),
    [anon_sym_U_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8_DQUOTE] = ACTIONS(2128),
    [anon_sym_DQUOTE] = ACTIONS(2128),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [anon_sym_NULL] = ACTIONS(2126),
    [anon_sym_nullptr] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(2126),
    [anon_sym_acquire] = ACTIONS(2126),
    [anon_sym_monitor] = ACTIONS(2126),
    [anon_sym_start] = ACTIONS(2126),
    [anon_sym_stop] = ACTIONS(2126),
  },
  [545] = {
    [sym_identifier] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2132),
    [anon_sym_RPAREN] = ACTIONS(2132),
    [anon_sym_LPAREN2] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2130),
    [anon_sym_PLUS] = ACTIONS(2130),
    [anon_sym_STAR] = ACTIONS(2132),
    [anon_sym_AMP] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2132),
    [anon_sym___extension__] = ACTIONS(2130),
    [anon_sym_extern] = ACTIONS(2130),
    [anon_sym___attribute__] = ACTIONS(2130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2132),
    [anon_sym___declspec] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2132),
    [anon_sym_signed] = ACTIONS(2130),
    [anon_sym_unsigned] = ACTIONS(2130),
    [anon_sym_long] = ACTIONS(2130),
    [anon_sym_short] = ACTIONS(2130),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2132),
    [anon_sym_static] = ACTIONS(2130),
    [anon_sym_auto] = ACTIONS(2130),
    [anon_sym_register] = ACTIONS(2130),
    [anon_sym_inline] = ACTIONS(2130),
    [anon_sym___inline] = ACTIONS(2130),
    [anon_sym___inline__] = ACTIONS(2130),
    [anon_sym___forceinline] = ACTIONS(2130),
    [anon_sym_thread_local] = ACTIONS(2130),
    [anon_sym___thread] = ACTIONS(2130),
    [anon_sym_const] = ACTIONS(2130),
    [anon_sym_constexpr] = ACTIONS(2130),
    [anon_sym_volatile] = ACTIONS(2130),
    [anon_sym_restrict] = ACTIONS(2130),
    [anon_sym___restrict__] = ACTIONS(2130),
    [anon_sym__Atomic] = ACTIONS(2130),
    [anon_sym__Noreturn] = ACTIONS(2130),
    [anon_sym_noreturn] = ACTIONS(2130),
    [sym_primitive_type] = ACTIONS(2130),
    [anon_sym_enum] = ACTIONS(2130),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_struct] = ACTIONS(2130),
    [anon_sym_union] = ACTIONS(2130),
    [anon_sym_if] = ACTIONS(2130),
    [anon_sym_switch] = ACTIONS(2130),
    [anon_sym_case] = ACTIONS(2130),
    [anon_sym_default] = ACTIONS(2130),
    [anon_sym_while] = ACTIONS(2130),
    [anon_sym_do] = ACTIONS(2130),
    [anon_sym_for] = ACTIONS(2130),
    [anon_sym_return] = ACTIONS(2130),
    [anon_sym_break] = ACTIONS(2130),
    [anon_sym_continue] = ACTIONS(2130),
    [anon_sym_goto] = ACTIONS(2130),
    [anon_sym_DASH_DASH] = ACTIONS(2132),
    [anon_sym_PLUS_PLUS] = ACTIONS(2132),
    [anon_sym_sizeof] = ACTIONS(2130),
    [anon_sym___alignof__] = ACTIONS(2130),
    [anon_sym___alignof] = ACTIONS(2130),
    [anon_sym__alignof] = ACTIONS(2130),
    [anon_sym_alignof] = ACTIONS(2130),
    [anon_sym__Alignof] = ACTIONS(2130),
    [anon_sym_offsetof] = ACTIONS(2130),
    [anon_sym__Generic] = ACTIONS(2130),
    [anon_sym_asm] = ACTIONS(2130),
    [anon_sym___asm__] = ACTIONS(2130),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2132),
    [anon_sym_u_SQUOTE] = ACTIONS(2132),
    [anon_sym_U_SQUOTE] = ACTIONS(2132),
    [anon_sym_u8_SQUOTE] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym_L_DQUOTE] = ACTIONS(2132),
    [anon_sym_u_DQUOTE] = ACTIONS(2132),
    [anon_sym_U_DQUOTE] = ACTIONS(2132),
    [anon_sym_u8_DQUOTE] = ACTIONS(2132),
    [anon_sym_DQUOTE] = ACTIONS(2132),
    [sym_true] = ACTIONS(2130),
    [sym_false] = ACTIONS(2130),
    [anon_sym_NULL] = ACTIONS(2130),
    [anon_sym_nullptr] = ACTIONS(2130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(2130),
    [anon_sym_acquire] = ACTIONS(2130),
    [anon_sym_monitor] = ACTIONS(2130),
    [anon_sym_start] = ACTIONS(2130),
    [anon_sym_stop] = ACTIONS(2130),
  },
  [546] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1833),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1769),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1854),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1783),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1912),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1899),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [sym_type_qualifier] = STATE(1146),
    [sym__type_specifier] = STATE(1182),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__expression] = STATE(1099),
    [sym__expression_not_binary] = STATE(821),
    [sym_comma_expression] = STATE(1904),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_type_descriptor] = STATE(1802),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__type_definition_type_repeat1] = STATE(1146),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2136),
    [anon_sym_unsigned] = ACTIONS(2136),
    [anon_sym_long] = ACTIONS(2136),
    [anon_sym_short] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [sym_else_clause] = STATE(259),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(2140),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(1454),
    [anon_sym_acquire] = ACTIONS(1454),
    [anon_sym_catch] = ACTIONS(1454),
    [anon_sym_monitor] = ACTIONS(1454),
    [anon_sym_start] = ACTIONS(1454),
    [anon_sym_stop] = ACTIONS(1454),
  },
  [555] = {
    [sym__expression] = STATE(812),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_initializer_list] = STATE(816),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2096),
    [anon_sym_RPAREN] = ACTIONS(2096),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(2106),
    [anon_sym_PERCENT] = ACTIONS(2096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_CARET] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2104),
    [anon_sym_EQ_EQ] = ACTIONS(2096),
    [anon_sym_BANG_EQ] = ACTIONS(2096),
    [anon_sym_GT] = ACTIONS(2106),
    [anon_sym_GT_EQ] = ACTIONS(2096),
    [anon_sym_LT_EQ] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_LT_LT] = ACTIONS(2096),
    [anon_sym_GT_GT] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym___attribute__] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_COLON] = ACTIONS(2096),
    [anon_sym_QMARK] = ACTIONS(2096),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2106),
    [anon_sym_DASH_GT] = ACTIONS(2096),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2151),
    [anon_sym_extern] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2151),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2153),
    [anon_sym___declspec] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2151),
    [anon_sym_unsigned] = ACTIONS(2151),
    [anon_sym_long] = ACTIONS(2151),
    [anon_sym_short] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_auto] = ACTIONS(2151),
    [anon_sym_register] = ACTIONS(2151),
    [anon_sym_inline] = ACTIONS(2151),
    [anon_sym___inline] = ACTIONS(2151),
    [anon_sym___inline__] = ACTIONS(2151),
    [anon_sym___forceinline] = ACTIONS(2151),
    [anon_sym_thread_local] = ACTIONS(2151),
    [anon_sym___thread] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_constexpr] = ACTIONS(2151),
    [anon_sym_volatile] = ACTIONS(2151),
    [anon_sym_restrict] = ACTIONS(2151),
    [anon_sym___restrict__] = ACTIONS(2151),
    [anon_sym__Atomic] = ACTIONS(2151),
    [anon_sym__Noreturn] = ACTIONS(2151),
    [anon_sym_noreturn] = ACTIONS(2151),
    [sym_primitive_type] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [anon_sym_struct] = ACTIONS(2151),
    [anon_sym_union] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_goto] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_sizeof] = ACTIONS(2149),
    [anon_sym___alignof__] = ACTIONS(2149),
    [anon_sym___alignof] = ACTIONS(2149),
    [anon_sym__alignof] = ACTIONS(2149),
    [anon_sym_alignof] = ACTIONS(2149),
    [anon_sym__Alignof] = ACTIONS(2149),
    [anon_sym_offsetof] = ACTIONS(2149),
    [anon_sym__Generic] = ACTIONS(2149),
    [anon_sym_asm] = ACTIONS(2149),
    [anon_sym___asm__] = ACTIONS(2149),
    [sym_number_literal] = ACTIONS(2147),
    [anon_sym_L_SQUOTE] = ACTIONS(2147),
    [anon_sym_u_SQUOTE] = ACTIONS(2147),
    [anon_sym_U_SQUOTE] = ACTIONS(2147),
    [anon_sym_u8_SQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_L_DQUOTE] = ACTIONS(2147),
    [anon_sym_u_DQUOTE] = ACTIONS(2147),
    [anon_sym_U_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8_DQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [anon_sym_NULL] = ACTIONS(2149),
    [anon_sym_nullptr] = ACTIONS(2149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(2149),
    [anon_sym_acquire] = ACTIONS(2149),
    [anon_sym_monitor] = ACTIONS(2149),
    [anon_sym_start] = ACTIONS(2149),
    [anon_sym_stop] = ACTIONS(2149),
  },
  [557] = {
    [sym__expression] = STATE(899),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_initializer_list] = STATE(816),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_SLASH] = ACTIONS(2106),
    [anon_sym_PERCENT] = ACTIONS(2096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_CARET] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2120),
    [anon_sym_EQ_EQ] = ACTIONS(2096),
    [anon_sym_BANG_EQ] = ACTIONS(2096),
    [anon_sym_GT] = ACTIONS(2106),
    [anon_sym_GT_EQ] = ACTIONS(2096),
    [anon_sym_LT_EQ] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_LT_LT] = ACTIONS(2096),
    [anon_sym_GT_GT] = ACTIONS(2096),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_RBRACK] = ACTIONS(2096),
    [anon_sym_QMARK] = ACTIONS(2096),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2106),
    [anon_sym_DASH_GT] = ACTIONS(2096),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [sym_type_qualifier] = STATE(788),
    [sym__expression] = STATE(1162),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(788),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [sym_type_qualifier] = STATE(788),
    [sym__expression] = STATE(1153),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(788),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [sym_type_qualifier] = STATE(564),
    [sym__expression] = STATE(1154),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(564),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2180),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_type_qualifier] = STATE(565),
    [sym__expression] = STATE(1126),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(565),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [sym_type_qualifier] = STATE(559),
    [sym__expression] = STATE(1149),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(559),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [563] = {
    [sym_type_qualifier] = STATE(788),
    [sym__expression] = STATE(1144),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(788),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_type_qualifier] = STATE(788),
    [sym__expression] = STATE(1164),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(788),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_type_qualifier] = STATE(788),
    [sym__expression] = STATE(1156),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(788),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_type_qualifier] = STATE(563),
    [sym__expression] = STATE(1133),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_type_qualifier] = STATE(558),
    [sym__expression] = STATE(1122),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(938),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym__type_definition_type_repeat1] = STATE(558),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [571] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2238),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [572] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [573] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [574] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [577] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2238),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [578] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [sym_string_literal] = STATE(749),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_PERCENT] = ACTIONS(2220),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_CARET] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2220),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(2220),
    [anon_sym_GT_GT] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym___attribute__] = ACTIONS(2212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2212),
    [anon_sym___based] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_auto] = ACTIONS(2212),
    [anon_sym_register] = ACTIONS(2212),
    [anon_sym_inline] = ACTIONS(2212),
    [anon_sym___inline] = ACTIONS(2212),
    [anon_sym___inline__] = ACTIONS(2212),
    [anon_sym___forceinline] = ACTIONS(2212),
    [anon_sym_thread_local] = ACTIONS(2212),
    [anon_sym___thread] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_constexpr] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_restrict] = ACTIONS(2212),
    [anon_sym___restrict__] = ACTIONS(2212),
    [anon_sym__Atomic] = ACTIONS(2212),
    [anon_sym__Noreturn] = ACTIONS(2212),
    [anon_sym_noreturn] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2234),
    [anon_sym_SLASH_EQ] = ACTIONS(2234),
    [anon_sym_PERCENT_EQ] = ACTIONS(2234),
    [anon_sym_PLUS_EQ] = ACTIONS(2234),
    [anon_sym_DASH_EQ] = ACTIONS(2234),
    [anon_sym_LT_LT_EQ] = ACTIONS(2234),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2234),
    [anon_sym_CARET_EQ] = ACTIONS(2234),
    [anon_sym_PIPE_EQ] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [580] = {
    [sym__expression] = STATE(1066),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_initializer_list] = STATE(1573),
    [sym_initializer_pair] = STATE(1573),
    [sym_subscript_designator] = STATE(1433),
    [sym_field_designator] = STATE(1433),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym_initializer_pair_repeat1] = STATE(1433),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [581] = {
    [sym_preproc_def] = STATE(599),
    [sym_preproc_function_def] = STATE(599),
    [sym_preproc_call] = STATE(599),
    [sym_preproc_elifdef] = STATE(1880),
    [sym_preproc_if_in_field_declaration_list] = STATE(599),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(599),
    [sym_preproc_else_in_field_declaration_list] = STATE(1880),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1880),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(599),
    [sym_field_declaration] = STATE(599),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(599),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [sym_preproc_def] = STATE(584),
    [sym_preproc_function_def] = STATE(584),
    [sym_preproc_call] = STATE(584),
    [sym_preproc_elifdef] = STATE(1735),
    [sym_preproc_if_in_field_declaration_list] = STATE(584),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(584),
    [sym_preproc_else_in_field_declaration_list] = STATE(1735),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1735),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(584),
    [sym_field_declaration] = STATE(584),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(584),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [sym_preproc_def] = STATE(581),
    [sym_preproc_function_def] = STATE(581),
    [sym_preproc_call] = STATE(581),
    [sym_preproc_elifdef] = STATE(1791),
    [sym_preproc_if_in_field_declaration_list] = STATE(581),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(581),
    [sym_preproc_else_in_field_declaration_list] = STATE(1791),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1791),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(581),
    [sym_field_declaration] = STATE(581),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(581),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [584] = {
    [sym_preproc_def] = STATE(599),
    [sym_preproc_function_def] = STATE(599),
    [sym_preproc_call] = STATE(599),
    [sym_preproc_elifdef] = STATE(1810),
    [sym_preproc_if_in_field_declaration_list] = STATE(599),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(599),
    [sym_preproc_else_in_field_declaration_list] = STATE(1810),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1810),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(599),
    [sym_field_declaration] = STATE(599),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(599),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [585] = {
    [sym__expression] = STATE(1105),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_initializer_list] = STATE(1626),
    [sym_initializer_pair] = STATE(1626),
    [sym_subscript_designator] = STATE(1433),
    [sym_field_designator] = STATE(1433),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym_initializer_pair_repeat1] = STATE(1433),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [586] = {
    [sym_preproc_def] = STATE(588),
    [sym_preproc_function_def] = STATE(588),
    [sym_preproc_call] = STATE(588),
    [sym_preproc_elifdef] = STATE(1760),
    [sym_preproc_if_in_field_declaration_list] = STATE(588),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(588),
    [sym_preproc_else_in_field_declaration_list] = STATE(1760),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1760),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(588),
    [sym_field_declaration] = STATE(588),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(588),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1222),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_ms_based_modifier] = STATE(1813),
    [sym__declarator] = STATE(1422),
    [sym__abstract_declarator] = STATE(1488),
    [sym_parenthesized_declarator] = STATE(1384),
    [sym_abstract_parenthesized_declarator] = STATE(1452),
    [sym_attributed_declarator] = STATE(1384),
    [sym_pointer_declarator] = STATE(1384),
    [sym_abstract_pointer_declarator] = STATE(1452),
    [sym_function_declarator] = STATE(1384),
    [sym_abstract_function_declarator] = STATE(1452),
    [sym_array_declarator] = STATE(1384),
    [sym_abstract_array_declarator] = STATE(1452),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym_variadic_parameter] = STATE(1555),
    [sym_parameter_list] = STATE(1453),
    [sym_parameter_declaration] = STATE(1555),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___based] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [sym_preproc_def] = STATE(599),
    [sym_preproc_function_def] = STATE(599),
    [sym_preproc_call] = STATE(599),
    [sym_preproc_elifdef] = STATE(1745),
    [sym_preproc_if_in_field_declaration_list] = STATE(599),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(599),
    [sym_preproc_else_in_field_declaration_list] = STATE(1745),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1745),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(599),
    [sym_field_declaration] = STATE(599),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(599),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2294),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [sym_preproc_def] = STATE(591),
    [sym_preproc_function_def] = STATE(591),
    [sym_preproc_call] = STATE(591),
    [sym_preproc_elifdef] = STATE(1893),
    [sym_preproc_if_in_field_declaration_list] = STATE(591),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(591),
    [sym_preproc_else_in_field_declaration_list] = STATE(1893),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1893),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(591),
    [sym_field_declaration] = STATE(591),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(591),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [590] = {
    [sym__expression] = STATE(1105),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_initializer_list] = STATE(1626),
    [sym_initializer_pair] = STATE(1626),
    [sym_subscript_designator] = STATE(1433),
    [sym_field_designator] = STATE(1433),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym_initializer_pair_repeat1] = STATE(1433),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [591] = {
    [sym_preproc_def] = STATE(599),
    [sym_preproc_function_def] = STATE(599),
    [sym_preproc_call] = STATE(599),
    [sym_preproc_elifdef] = STATE(1903),
    [sym_preproc_if_in_field_declaration_list] = STATE(599),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(599),
    [sym_preproc_else_in_field_declaration_list] = STATE(1903),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1903),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(599),
    [sym_field_declaration] = STATE(599),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(599),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2256),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [592] = {
    [sym__expression] = STATE(1105),
    [sym__expression_not_binary] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(852),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_update_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_alignof_expression] = STATE(821),
    [sym_offsetof_expression] = STATE(821),
    [sym_generic_expression] = STATE(821),
    [sym_subscript_expression] = STATE(852),
    [sym_call_expression] = STATE(852),
    [sym_gnu_asm_expression] = STATE(821),
    [sym_field_expression] = STATE(852),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(852),
    [sym_initializer_list] = STATE(1626),
    [sym_initializer_pair] = STATE(1626),
    [sym_subscript_designator] = STATE(1433),
    [sym_field_designator] = STATE(1433),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(779),
    [sym_null] = STATE(821),
    [aux_sym_initializer_pair_repeat1] = STATE(1433),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2252),
    [sym_number_literal] = ACTIONS(165),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(167),
    [sym_false] = ACTIONS(167),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [593] = {
    [sym_preproc_def] = STATE(605),
    [sym_preproc_function_def] = STATE(605),
    [sym_preproc_call] = STATE(605),
    [sym_preproc_if_in_field_declaration_list] = STATE(605),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(605),
    [sym_preproc_else_in_field_declaration_list] = STATE(1909),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1909),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(605),
    [sym_field_declaration] = STATE(605),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [sym_preproc_def] = STATE(605),
    [sym_preproc_function_def] = STATE(605),
    [sym_preproc_call] = STATE(605),
    [sym_preproc_if_in_field_declaration_list] = STATE(605),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(605),
    [sym_preproc_else_in_field_declaration_list] = STATE(1738),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1738),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(605),
    [sym_field_declaration] = STATE(605),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [595] = {
    [sym_preproc_def] = STATE(605),
    [sym_preproc_function_def] = STATE(605),
    [sym_preproc_call] = STATE(605),
    [sym_preproc_if_in_field_declaration_list] = STATE(605),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(605),
    [sym_preproc_else_in_field_declaration_list] = STATE(1931),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1931),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(605),
    [sym_field_declaration] = STATE(605),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [sym_preproc_def] = STATE(593),
    [sym_preproc_function_def] = STATE(593),
    [sym_preproc_call] = STATE(593),
    [sym_preproc_if_in_field_declaration_list] = STATE(593),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(593),
    [sym_preproc_else_in_field_declaration_list] = STATE(1897),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1897),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(593),
    [sym_field_declaration] = STATE(593),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(593),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [597] = {
    [sym_preproc_def] = STATE(595),
    [sym_preproc_function_def] = STATE(595),
    [sym_preproc_call] = STATE(595),
    [sym_preproc_if_in_field_declaration_list] = STATE(595),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(595),
    [sym_preproc_else_in_field_declaration_list] = STATE(1923),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1923),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(595),
    [sym_field_declaration] = STATE(595),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(595),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [598] = {
    [sym_preproc_def] = STATE(594),
    [sym_preproc_function_def] = STATE(594),
    [sym_preproc_call] = STATE(594),
    [sym_preproc_if_in_field_declaration_list] = STATE(594),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(594),
    [sym_preproc_else_in_field_declaration_list] = STATE(1751),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1751),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(594),
    [sym_field_declaration] = STATE(594),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(594),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [sym_preproc_def] = STATE(599),
    [sym_preproc_function_def] = STATE(599),
    [sym_preproc_call] = STATE(599),
    [sym_preproc_if_in_field_declaration_list] = STATE(599),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(599),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1310),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(599),
    [sym_field_declaration] = STATE(599),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(599),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2322),
    [aux_sym_preproc_def_token1] = ACTIONS(2325),
    [aux_sym_preproc_if_token1] = ACTIONS(2328),
    [aux_sym_preproc_if_token2] = ACTIONS(2331),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2333),
    [aux_sym_preproc_else_token1] = ACTIONS(2331),
    [aux_sym_preproc_elif_token1] = ACTIONS(2331),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2331),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2331),
    [sym_preproc_directive] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2339),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2348),
    [anon_sym___declspec] = ACTIONS(2351),
    [anon_sym_signed] = ACTIONS(2354),
    [anon_sym_unsigned] = ACTIONS(2354),
    [anon_sym_long] = ACTIONS(2354),
    [anon_sym_short] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_auto] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2339),
    [anon_sym_constexpr] = ACTIONS(2339),
    [anon_sym_volatile] = ACTIONS(2339),
    [anon_sym_restrict] = ACTIONS(2339),
    [anon_sym___restrict__] = ACTIONS(2339),
    [anon_sym__Atomic] = ACTIONS(2339),
    [anon_sym__Noreturn] = ACTIONS(2339),
    [anon_sym_noreturn] = ACTIONS(2339),
    [sym_primitive_type] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2360),
    [anon_sym_struct] = ACTIONS(2363),
    [anon_sym_union] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
  },
  [600] = {
    [sym_preproc_def] = STATE(602),
    [sym_preproc_function_def] = STATE(602),
    [sym_preproc_call] = STATE(602),
    [sym_preproc_if_in_field_declaration_list] = STATE(602),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(602),
    [sym_preproc_else_in_field_declaration_list] = STATE(1818),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1818),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(602),
    [sym_field_declaration] = STATE(602),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(602),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [601] = {
    [sym_preproc_def] = STATE(603),
    [sym_preproc_function_def] = STATE(603),
    [sym_preproc_call] = STATE(603),
    [sym_preproc_if_in_field_declaration_list] = STATE(603),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(603),
    [sym_preproc_else_in_field_declaration_list] = STATE(1879),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1879),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(603),
    [sym_field_declaration] = STATE(603),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(603),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [602] = {
    [sym_preproc_def] = STATE(605),
    [sym_preproc_function_def] = STATE(605),
    [sym_preproc_call] = STATE(605),
    [sym_preproc_if_in_field_declaration_list] = STATE(605),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(605),
    [sym_preproc_else_in_field_declaration_list] = STATE(1803),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1803),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(605),
    [sym_field_declaration] = STATE(605),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [603] = {
    [sym_preproc_def] = STATE(605),
    [sym_preproc_function_def] = STATE(605),
    [sym_preproc_call] = STATE(605),
    [sym_preproc_if_in_field_declaration_list] = STATE(605),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(605),
    [sym_preproc_else_in_field_declaration_list] = STATE(1906),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1906),
    [sym__declaration_modifiers] = STATE(803),
    [sym__declaration_specifiers] = STATE(1317),
    [sym_attribute_specifier] = STATE(803),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(803),
    [sym_storage_class_specifier] = STATE(803),
    [sym_type_qualifier] = STATE(803),
    [sym__type_specifier] = STATE(971),
    [sym_sized_type_specifier] = STATE(1006),
    [sym_enum_specifier] = STATE(1006),
    [sym_struct_specifier] = STATE(1006),
    [sym_union_specifier] = STATE(1006),
    [sym__field_declaration_list_item] = STATE(605),
    [sym_field_declaration] = STATE(605),
    [sym_macro_type_specifier] = STATE(1006),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(803),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1005),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2377), 1,
      anon_sym_RPAREN,
    ACTIONS(2379), 1,
      anon_sym___extension__,
    STATE(779), 1,
      sym_string_literal,
    STATE(1063), 1,
      sym__expression,
    STATE(1572), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [114] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 1,
      sym_identifier,
    ACTIONS(2345), 1,
      anon_sym___attribute__,
    ACTIONS(2348), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2351), 1,
      anon_sym___declspec,
    ACTIONS(2357), 1,
      sym_primitive_type,
    ACTIONS(2360), 1,
      anon_sym_enum,
    ACTIONS(2363), 1,
      anon_sym_struct,
    ACTIONS(2366), 1,
      anon_sym_union,
    ACTIONS(2381), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2384), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2390), 1,
      sym_preproc_directive,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1317), 1,
      sym__declaration_specifiers,
    ACTIONS(2387), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(2331), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    ACTIONS(2354), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(605), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(2339), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2342), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [224] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2393), 1,
      anon_sym_RPAREN,
    ACTIONS(2395), 1,
      anon_sym___extension__,
    STATE(779), 1,
      sym_string_literal,
    STATE(1069), 1,
      sym__expression,
    STATE(1600), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [338] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2397), 1,
      anon_sym___extension__,
    STATE(779), 1,
      sym_string_literal,
    STATE(1096), 1,
      sym__expression,
    STATE(1645), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [449] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2399), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1082), 1,
      sym__expression,
    STATE(1710), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [557] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2401), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1088), 1,
      sym__expression,
    STATE(1725), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [665] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2403), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1102), 1,
      sym__expression,
    STATE(1728), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [773] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2405), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2407), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2411), 1,
      sym_preproc_directive,
    ACTIONS(2413), 1,
      anon_sym_RBRACE,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1314), 1,
      sym__declaration_specifiers,
    ACTIONS(2409), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(629), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [881] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(816), 1,
      sym_initializer_list,
    STATE(899), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [989] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(812), 1,
      sym__expression,
    STATE(816), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1097] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(816), 1,
      sym_initializer_list,
    STATE(899), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1203] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2415), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2417), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2419), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(2423), 1,
      sym_preproc_directive,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1318), 1,
      sym__declaration_specifiers,
    ACTIONS(2421), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(627), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [1311] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2425), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1097), 1,
      sym__expression,
    STATE(1797), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1419] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 1,
      sym_identifier,
    ACTIONS(2331), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(2345), 1,
      anon_sym___attribute__,
    ACTIONS(2348), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2351), 1,
      anon_sym___declspec,
    ACTIONS(2357), 1,
      sym_primitive_type,
    ACTIONS(2360), 1,
      anon_sym_enum,
    ACTIONS(2363), 1,
      anon_sym_struct,
    ACTIONS(2366), 1,
      anon_sym_union,
    ACTIONS(2427), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2430), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2436), 1,
      sym_preproc_directive,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1318), 1,
      sym__declaration_specifiers,
    ACTIONS(2433), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(2354), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(617), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(2339), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2342), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [1527] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2439), 1,
      anon_sym_RPAREN,
    STATE(779), 1,
      sym_string_literal,
    STATE(1083), 1,
      sym__expression,
    STATE(1908), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1635] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1100), 1,
      sym__expression,
    STATE(1706), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1743] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2441), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1076), 1,
      sym__expression,
    STATE(1737), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1851] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2443), 1,
      anon_sym_RPAREN,
    STATE(779), 1,
      sym_string_literal,
    STATE(1116), 1,
      sym__expression,
    STATE(1881), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1959] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_RPAREN,
    STATE(779), 1,
      sym_string_literal,
    STATE(1113), 1,
      sym__expression,
    STATE(1882), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2067] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2447), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1091), 1,
      sym__expression,
    STATE(1807), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2175] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2449), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1095), 1,
      sym__expression,
    STATE(1920), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2283] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(812), 1,
      sym__expression,
    STATE(816), 1,
      sym_initializer_list,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2389] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2451), 1,
      anon_sym_RPAREN,
    STATE(779), 1,
      sym_string_literal,
    STATE(1107), 1,
      sym__expression,
    STATE(1887), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2497] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2415), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2417), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2423), 1,
      sym_preproc_directive,
    ACTIONS(2453), 1,
      aux_sym_preproc_if_token2,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1318), 1,
      sym__declaration_specifiers,
    ACTIONS(2421), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(617), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [2605] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2455), 1,
      anon_sym_RPAREN,
    STATE(779), 1,
      sym_string_literal,
    STATE(1092), 1,
      sym__expression,
    STATE(1806), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2713] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2405), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2407), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2411), 1,
      sym_preproc_directive,
    ACTIONS(2457), 1,
      anon_sym_RBRACE,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1314), 1,
      sym__declaration_specifiers,
    ACTIONS(2409), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(633), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [2821] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2459), 1,
      anon_sym_RPAREN,
    STATE(779), 1,
      sym_string_literal,
    STATE(1093), 1,
      sym__expression,
    STATE(1805), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2929] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1094), 1,
      sym__expression,
    STATE(1625), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3037] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2461), 1,
      anon_sym_SEMI,
    STATE(779), 1,
      sym_string_literal,
    STATE(1115), 1,
      sym__expression,
    STATE(1830), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3145] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 1,
      sym_identifier,
    ACTIONS(2345), 1,
      anon_sym___attribute__,
    ACTIONS(2348), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2351), 1,
      anon_sym___declspec,
    ACTIONS(2357), 1,
      sym_primitive_type,
    ACTIONS(2360), 1,
      anon_sym_enum,
    ACTIONS(2363), 1,
      anon_sym_struct,
    ACTIONS(2366), 1,
      anon_sym_union,
    ACTIONS(2463), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2466), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2472), 1,
      sym_preproc_directive,
    ACTIONS(2475), 1,
      anon_sym_RBRACE,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1314), 1,
      sym__declaration_specifiers,
    ACTIONS(2469), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(2354), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(633), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(2339), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2342), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [3253] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2477), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3356] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2479), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3459] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2481), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3562] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2483), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3665] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2485), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3768] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2487), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3871] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1099), 1,
      sym__expression,
    STATE(1904), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3976] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2489), 1,
      anon_sym_COLON,
    STATE(779), 1,
      sym_string_literal,
    STATE(1140), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4081] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1087), 1,
      sym__expression,
    STATE(1822), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4186] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2491), 1,
      anon_sym_COLON,
    STATE(779), 1,
      sym_string_literal,
    STATE(1165), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4291] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2493), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4394] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2495), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4497] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
    ACTIONS(2292), 1,
      anon_sym_LBRACK,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1222), 1,
      sym__declaration_specifiers,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1488), 1,
      sym__abstract_declarator,
    STATE(1555), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [4610] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2501), 1,
      anon_sym_COLON,
    STATE(779), 1,
      sym_string_literal,
    STATE(1141), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4715] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1068), 1,
      sym__expression,
    STATE(1656), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4820] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2503), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4923] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2505), 1,
      anon_sym_COLON,
    STATE(779), 1,
      sym_string_literal,
    STATE(1119), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5028] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2507), 1,
      anon_sym_RBRACK,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5131] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(815), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5231] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2509), 1,
      anon_sym_LPAREN2,
    STATE(779), 1,
      sym_string_literal,
    STATE(1047), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5333] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1129), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5435] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(824), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5535] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5637] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1142), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5739] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1042), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5841] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1121), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5943] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1136), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6045] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1137), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6147] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1147), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6249] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1041), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6351] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(902), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6453] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    ACTIONS(2511), 1,
      anon_sym_LPAREN2,
    STATE(779), 1,
      sym_string_literal,
    STATE(849), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6553] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(823), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6653] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1157), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6755] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1163), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6857] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(851), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6957] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(915), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7057] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1106), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7159] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    ACTIONS(2513), 1,
      anon_sym_LPAREN2,
    STATE(779), 1,
      sym_string_literal,
    STATE(1159), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7261] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(905), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7361] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    ACTIONS(2515), 1,
      anon_sym_LPAREN2,
    STATE(779), 1,
      sym_string_literal,
    STATE(911), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7461] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(919), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7561] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(902), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7661] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1135), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7763] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(848), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7863] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(906), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7963] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(842), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8063] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1161), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8165] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1027), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8267] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(919), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8369] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(904), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8469] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(901), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8569] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(900), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8669] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(903), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8769] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(913), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8869] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(914), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8969] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(846), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9069] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(834), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9169] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(851), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9271] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(836), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9371] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(837), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9471] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(917), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9571] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(918), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9671] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(908), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9771] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1072), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9873] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(823), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9975] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1109), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10077] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(828), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10177] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1032), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10279] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(848), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10381] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1033), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10483] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(838), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10583] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1067), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10685] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1048), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10787] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1045), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10889] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1043), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10991] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1125), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11093] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(833), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11193] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1039), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11295] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1037), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11397] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1118), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11499] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(839), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11599] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1035), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11701] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1139), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11803] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2098), 1,
      anon_sym_LPAREN2,
    ACTIONS(2112), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(841), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2100), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2102), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2110), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11903] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1148), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12005] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1145), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12107] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1132), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12209] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1064), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12311] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1152), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12413] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1151), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12515] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_LPAREN2,
    ACTIONS(2124), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(907), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2116), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2118), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2122), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(821), 21,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12615] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1040), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12717] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1065), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12819] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1134), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12921] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13023] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2142), 1,
      sym_identifier,
    STATE(779), 1,
      sym_string_literal,
    STATE(1074), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(852), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13125] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1120), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13227] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1143), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1123), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13431] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1124), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13533] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1117), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13635] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1127), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13737] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(915), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13839] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(165), 1,
      sym_number_literal,
    ACTIONS(2156), 1,
      sym_identifier,
    ACTIONS(2158), 1,
      anon_sym_LPAREN2,
    ACTIONS(2168), 1,
      anon_sym_sizeof,
    STATE(779), 1,
      sym_string_literal,
    STATE(1128), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(167), 2,
      sym_true,
      sym_false,
    ACTIONS(2160), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2162), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2164), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2166), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(938), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(821), 16,
      sym__expression_not_binary,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13941] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2517), 1,
      anon_sym_LBRACE,
    STATE(797), 1,
      sym_ms_call_modifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1342), 1,
      sym__declaration_specifiers,
    STATE(298), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [14042] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2519), 1,
      anon_sym_LBRACE,
    STATE(799), 1,
      sym_ms_call_modifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1340), 1,
      sym__declaration_specifiers,
    STATE(475), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [14143] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2521), 1,
      anon_sym_LBRACE,
    STATE(795), 1,
      sym_ms_call_modifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1336), 1,
      sym__declaration_specifiers,
    STATE(172), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [14244] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2523), 1,
      anon_sym_LBRACE,
    STATE(798), 1,
      sym_ms_call_modifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1328), 1,
      sym__declaration_specifiers,
    STATE(540), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [14345] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2525), 1,
      anon_sym_LBRACE,
    STATE(794), 1,
      sym_ms_call_modifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1346), 1,
      sym__declaration_specifiers,
    STATE(513), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [14446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2130), 33,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_until,
      anon_sym_acquire,
      anon_sym_monitor,
      anon_sym_start,
      anon_sym_stop,
  [14508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2126), 33,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_until,
      anon_sym_acquire,
      anon_sym_monitor,
      anon_sym_start,
      anon_sym_stop,
  [14570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2527), 33,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_until,
      anon_sym_acquire,
      anon_sym_monitor,
      anon_sym_start,
      anon_sym_stop,
  [14632] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 1,
      anon_sym_const,
    ACTIONS(2216), 1,
      anon_sym_LPAREN2,
    ACTIONS(2222), 1,
      anon_sym_STAR,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(2225), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2228), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 12,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_identifier,
    STATE(750), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2535), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
    ACTIONS(2533), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      sym_identifier,
    STATE(748), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2541), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
    ACTIONS(2539), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      sym_identifier,
    STATE(750), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2550), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2548), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
    ACTIONS(2546), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14906] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(422), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(753), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [14998] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(209), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15090] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(402), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15182] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(408), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15274] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(478), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15366] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(506), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(765), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15458] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1222), 1,
      sym__declaration_specifiers,
    STATE(1555), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15550] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(376), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(754), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15642] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2553), 1,
      sym_identifier,
    ACTIONS(2555), 1,
      anon_sym_RPAREN,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1222), 1,
      sym__declaration_specifiers,
    STATE(1480), 1,
      sym_variadic_parameter,
    STATE(1555), 1,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15736] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(519), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(766), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15828] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(480), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [15920] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(230), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(752), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16012] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(471), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(761), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16104] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(492), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(772), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16196] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(505), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16288] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(500), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16380] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(189), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(770), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16472] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(488), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16564] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(473), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(755), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16656] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(212), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16748] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(511), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(768), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16840] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(508), 1,
      sym_compound_statement,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2559), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [16989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2563), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [17046] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2565), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1222), 1,
      sym__declaration_specifiers,
    STATE(1627), 1,
      sym_variadic_parameter,
    STATE(1635), 1,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2220), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2214), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17198] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1222), 1,
      sym__declaration_specifiers,
    STATE(1635), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17287] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 1,
      sym_identifier,
    ACTIONS(2576), 1,
      anon_sym___attribute__,
    ACTIONS(2579), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2582), 1,
      anon_sym___declspec,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    ACTIONS(2590), 1,
      sym_primitive_type,
    ACTIONS(2593), 1,
      anon_sym_enum,
    ACTIONS(2596), 1,
      anon_sym_struct,
    ACTIONS(2599), 1,
      anon_sym_union,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1331), 1,
      sym__declaration_specifiers,
    STATE(778), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(2587), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2570), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2573), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2220), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2214), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2602), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2606), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2610), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2614), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2618), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2622), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2626), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(788), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2634), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2630), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(2632), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [17945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2637), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [18000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2641), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [18055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(2645), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [18110] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1358), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18192] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1348), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18274] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1369), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18356] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1359), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18438] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1351), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18520] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1371), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18602] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1368), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18684] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1367), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18766] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1347), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18848] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(971), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1350), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(803), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18930] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 1,
      anon_sym___attribute__,
    ACTIONS(2662), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2665), 1,
      anon_sym___declspec,
    ACTIONS(2651), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(802), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2653), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2656), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(2649), 11,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [18995] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(933), 1,
      sym__type_specifier,
    STATE(1005), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(802), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [19074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19137] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2240), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19200] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2244), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2232), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2668), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [19379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2242), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19442] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2236), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2529), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19557] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2676), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2672), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2684), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2690), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2688), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19720] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_CARET,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    ACTIONS(2716), 1,
      anon_sym_EQ,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2692), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2720), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2724), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
  [19907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2728), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2732), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2736), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2740), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2744), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20162] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2750), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2748), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20223] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2752), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2756), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2760), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2764), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20441] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2752), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2768), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2772), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2776), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2780), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20712] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_CARET,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    ACTIONS(2786), 1,
      anon_sym_EQ,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2784), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20797] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2752), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20868] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 1,
      anon_sym_EQ,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2790), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 14,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [20927] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2752), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21000] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2752), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21075] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2704), 1,
      anon_sym_CARET,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2754), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21152] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_CARET,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    ACTIONS(2754), 1,
      anon_sym_EQ,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21231] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_CARET,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    ACTIONS(2794), 1,
      anon_sym_EQ,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2792), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21316] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_CARET,
    ACTIONS(2706), 1,
      anon_sym_AMP,
    ACTIONS(2754), 1,
      anon_sym_EQ,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2710), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2712), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2752), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2796), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2800), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2804), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2810), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2808), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2814), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2812), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2752), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21786] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2818), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2816), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2820), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21904] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2826), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2824), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [21963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_EQ,
    ACTIONS(2234), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [22017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1644), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1597), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1605), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1692), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2828), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2832), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2836), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1684), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2840), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1584), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2844), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2848), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2852), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2856), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2860), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2864), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2868), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2872), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22899] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LPAREN2,
    ACTIONS(2288), 1,
      anon_sym_STAR,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1327), 1,
      sym__declarator,
    STATE(1440), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(2878), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1052), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1056), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [22978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2848), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23025] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym___attribute__,
    ACTIONS(2893), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2896), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(2888), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(2886), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1644), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2828), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1597), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    STATE(981), 1,
      sym_field_declaration_list,
    STATE(992), 1,
      sym_attribute_specifier,
    ACTIONS(2900), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2898), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [23274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1605), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    STATE(966), 1,
      sym_field_declaration_list,
    STATE(986), 1,
      sym_attribute_specifier,
    ACTIONS(2906), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2904), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [23376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1692), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1684), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1584), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    STATE(923), 1,
      sym_field_declaration_list,
    STATE(1015), 1,
      sym_attribute_specifier,
    ACTIONS(2910), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2908), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [23572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2832), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2668), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2868), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2836), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2840), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2864), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2914), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2912), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym___attribute__,
    ACTIONS(2923), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2926), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(2918), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(2916), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2872), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2860), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2856), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2844), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24142] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    STATE(934), 1,
      sym_field_declaration_list,
    STATE(1001), 1,
      sym_attribute_specifier,
    ACTIONS(2930), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2928), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [24197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2852), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    STATE(947), 1,
      sym_field_declaration_list,
    STATE(1008), 1,
      sym_attribute_specifier,
    ACTIONS(2934), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2932), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [24299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2676), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2672), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24355] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2752), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24421] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2752), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24483] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2826), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2824), 20,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [24537] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2752), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24605] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2752), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2810), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2808), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24721] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2716), 1,
      anon_sym_EQ,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2960), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2692), 11,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24801] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2786), 1,
      anon_sym_EQ,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2960), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2784), 11,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24881] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2754), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2752), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2130), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2126), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25031] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2818), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2816), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2962), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25139] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2754), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25209] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25281] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2752), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2557), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25383] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_EQ,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25457] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_EQ,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2752), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25533] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2750), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2748), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2561), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25635] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2794), 1,
      anon_sym_EQ,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2960), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2938), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2944), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2940), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2792), 11,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(740), 1,
      sym_string_literal,
    ACTIONS(2966), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2962), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1000), 1,
      sym_attribute_specifier,
    ACTIONS(2970), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2968), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [25813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(924), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2976), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2974), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2972), 25,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [25862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2848), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1692), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1597), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(739), 1,
      sym_string_literal,
    ACTIONS(2966), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2962), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2844), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(742), 1,
      sym_string_literal,
    ACTIONS(2966), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2962), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2820), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [26185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1584), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26230] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2979), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(2981), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(959), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(984), 1,
      sym_attribute_specifier,
    ACTIONS(2985), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2983), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [26336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1644), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2756), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [26426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1605), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 1,
      anon_sym_EQ,
    ACTIONS(2790), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2220), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2214), 14,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [26520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2836), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2832), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2864), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2848), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1007), 1,
      sym_attribute_specifier,
    ACTIONS(2989), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2987), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [26749] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2991), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(2993), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(802), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2828), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2828), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1004), 1,
      sym_attribute_specifier,
    ACTIONS(2997), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2995), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [26945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2852), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2856), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2728), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1003), 1,
      sym_attribute_specifier,
    ACTIONS(3001), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2999), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [27129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2832), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2840), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2860), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2872), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1684), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2836), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2872), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3003), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(3005), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(802), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [27501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2840), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2852), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2856), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2860), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2868), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1584), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1009), 1,
      sym_attribute_specifier,
    ACTIONS(3009), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3007), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [27820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(743), 1,
      sym_string_literal,
    ACTIONS(2966), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2962), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1684), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2780), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1692), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3011), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(3013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(944), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1605), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1597), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1644), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2868), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1010), 1,
      sym_attribute_specifier,
    ACTIONS(3017), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3015), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(741), 1,
      sym_string_literal,
    ACTIONS(2966), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2962), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2864), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(994), 1,
      sym_attribute_specifier,
    ACTIONS(3021), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3019), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(985), 1,
      sym_attribute_specifier,
    ACTIONS(3025), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3023), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1013), 1,
      sym_attribute_specifier,
    ACTIONS(3029), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3027), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2844), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3031), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3037), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3035), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3039), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3045), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3043), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3047), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3051), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3055), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3061), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3059), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3063), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [28972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3067), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3071), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3075), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1466), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [29148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3079), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3083), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3087), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2228), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2212), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3094), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3098), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3102), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3108), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3106), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3110), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 1,
      sym_identifier,
    ACTIONS(3123), 1,
      sym_primitive_type,
    STATE(924), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3121), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3117), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3119), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [29598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3125), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3131), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3129), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3133), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3139), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3137), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3143), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3141), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3147), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3145), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3151), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3149), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3153), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3159), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3157), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3161), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [30038] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1380), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1150), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [30107] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1375), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1016), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [30176] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1375), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [30245] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1385), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1018), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1158), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [30314] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3175), 1,
      anon_sym_SEMI,
    ACTIONS(3011), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(3013), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(944), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [30370] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3177), 1,
      anon_sym_SEMI,
    ACTIONS(3011), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(3013), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(944), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [30426] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3179), 1,
      anon_sym_SEMI,
    ACTIONS(3011), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(3013), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(944), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [30482] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3181), 1,
      anon_sym_SEMI,
    ACTIONS(3011), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(3013), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(944), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [30538] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1431), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_SEMI,
    ACTIONS(3011), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(3013), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(944), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [30594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3189), 1,
      anon_sym___attribute__,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(3194), 1,
      anon_sym_COLON,
    STATE(987), 1,
      sym_attribute_specifier,
    STATE(1050), 1,
      sym_enumerator_list,
    ACTIONS(3187), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3185), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [30646] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(3200), 1,
      anon_sym___attribute__,
    STATE(993), 1,
      sym_attribute_specifier,
    STATE(1049), 1,
      sym_enumerator_list,
    ACTIONS(3198), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3196), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [30695] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2792), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [30769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3229), 1,
      anon_sym_typedef,
    ACTIONS(2668), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3231), 1,
      anon_sym_typedef,
    ACTIONS(2668), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3233), 1,
      anon_sym_typedef,
    ACTIONS(2668), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2916), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30935] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2754), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2752), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [30989] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3237), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31099] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2752), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3241), 1,
      anon_sym_typedef,
    ACTIONS(2668), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31197] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2752), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3245), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3243), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31295] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31357] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2692), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [31431] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2784), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [31505] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31569] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1464), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31675] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3247), 1,
      anon_sym_typedef,
    ACTIONS(2668), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31785] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2818), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2816), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31843] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [31911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 1,
      anon_sym___attribute__,
    STATE(1012), 1,
      sym_attribute_specifier,
    ACTIONS(3251), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3249), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [31954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3260), 1,
      anon_sym___attribute__,
    STATE(991), 1,
      sym_attribute_specifier,
    ACTIONS(3258), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3256), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [31997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3263), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32036] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LPAREN2,
    ACTIONS(2288), 1,
      anon_sym_STAR,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1341), 1,
      sym__declarator,
    STATE(1434), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(3267), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3273), 1,
      anon_sym___attribute__,
    STATE(998), 1,
      sym_attribute_specifier,
    ACTIONS(3271), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3269), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [32142] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1365), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1058), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1188), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32202] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1341), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1059), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32262] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1341), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32322] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1360), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1062), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1186), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32382] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1366), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1183), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32442] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1330), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1189), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32502] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN2,
    ACTIONS(3286), 1,
      anon_sym_COMMA,
    ACTIONS(3289), 1,
      anon_sym_RPAREN,
    STATE(1542), 1,
      aux_sym__old_style_parameter_list_repeat1,
    ACTIONS(2228), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2212), 24,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [32548] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1327), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1056), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1190), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32608] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1365), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    ACTIONS(2882), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1188), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2880), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32668] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3294), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    STATE(1586), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [32743] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3296), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    STATE(1577), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [32818] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3298), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    STATE(1551), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [32893] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3300), 1,
      anon_sym_COMMA,
    ACTIONS(3302), 1,
      anon_sym_RBRACE,
    STATE(813), 1,
      sym_argument_list,
    STATE(1570), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [32968] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3304), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    STATE(1599), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [33043] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3310), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33116] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3312), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    STATE(1593), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [33191] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_LPAREN2,
    ACTIONS(3321), 1,
      anon_sym_LBRACK,
    ACTIONS(2228), 2,
      anon_sym_COMMA,
      anon_sym_STAR,
    ACTIONS(3314), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2212), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [33234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2228), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3324), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2212), 24,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [33275] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3327), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [33346] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3329), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [33418] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3331), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33488] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1182), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1840), 1,
      sym_type_descriptor,
    STATE(1146), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33544] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3333), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [33616] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1299), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33672] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1300), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33728] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1295), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33784] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1292), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33840] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1293), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33896] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3337), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [33968] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3339), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34040] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1297), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34096] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(3341), 1,
      anon_sym_enum,
    STATE(1182), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1933), 1,
      sym_type_descriptor,
    STATE(1166), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34152] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1298), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34208] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3343), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34280] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3345), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34352] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3347), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34424] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(3341), 1,
      anon_sym_enum,
    STATE(1182), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1812), 1,
      sym_type_descriptor,
    STATE(1166), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34480] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3349), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34552] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3351), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34624] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3353), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34696] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3355), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [34766] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3357), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34838] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3359), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [34908] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3361), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [34980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1302), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35036] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3363), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35108] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3365), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35178] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3367), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35250] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3369), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35322] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3371), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35394] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1301), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35450] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3373), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35520] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3375), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35590] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35662] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1182), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1869), 1,
      sym_type_descriptor,
    STATE(1146), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35718] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3379), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35788] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1182), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1842), 1,
      sym_type_descriptor,
    STATE(1146), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35844] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3381), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35916] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [35988] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3385), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36060] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1256), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1296), 1,
      sym__type_definition_type,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36116] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3387), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36188] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3308), 1,
      anon_sym_COMMA,
    ACTIONS(3389), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36260] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [36323] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3415), 1,
      anon_sym_RBRACK,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36392] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3419), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36461] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [36518] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3421), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36587] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36656] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_PIPE,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [36717] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_PIPE,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [36780] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3423), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36849] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [36918] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [36983] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2754), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2752), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [37032] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3425), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37101] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2752), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [37154] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1380), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37207] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2792), 1,
      anon_sym_RBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37276] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37345] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2754), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2752), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [37396] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3427), 1,
      anon_sym_COMMA,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37465] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3429), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37534] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3431), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37603] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1208), 1,
      sym__type_specifier,
    STATE(1287), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3335), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37656] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    ACTIONS(3433), 1,
      anon_sym_RBRACK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37725] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3435), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37794] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3437), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37863] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3439), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37932] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2754), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2752), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [37991] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38060] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2692), 1,
      anon_sym_RBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38129] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2138), 1,
      anon_sym_enum,
    ACTIONS(2254), 1,
      sym_identifier,
    STATE(1178), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [38182] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3441), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38251] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2784), 1,
      anon_sym_RBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38320] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38389] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1382), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [38442] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3443), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38511] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3445), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38580] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38649] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38718] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38787] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2477), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38856] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3449), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38925] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1375), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [38978] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2818), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2816), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [39031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2632), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3451), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2630), 10,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39070] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3454), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39139] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39208] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3456), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39277] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_RBRACK,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      anon_sym_LPAREN2,
    ACTIONS(3395), 1,
      anon_sym_SLASH,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_CARET,
    ACTIONS(3401), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3417), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3391), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3403), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3407), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3409), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39346] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39415] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2254), 1,
      sym_identifier,
    ACTIONS(3341), 1,
      anon_sym_enum,
    STATE(1178), 1,
      sym__type_specifier,
    STATE(1184), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1006), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [39468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    STATE(993), 1,
      sym_attribute_specifier,
    STATE(1172), 1,
      sym_enumerator_list,
    ACTIONS(3198), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3196), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39510] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(2678), 1,
      anon_sym_LBRACK,
    ACTIONS(3207), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3213), 1,
      anon_sym_PIPE,
    ACTIONS(3215), 1,
      anon_sym_CARET,
    ACTIONS(3217), 1,
      anon_sym_AMP,
    ACTIONS(3227), 1,
      anon_sym_QMARK,
    STATE(813), 1,
      sym_argument_list,
    ACTIONS(2680), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2682), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3203), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3205), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3219), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3221), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3225), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_SEMI,
    ACTIONS(2742), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2740), 18,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [39612] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1179), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(3464), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3469), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1170), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3466), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3462), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39654] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(3472), 1,
      anon_sym_COLON,
    STATE(987), 1,
      sym_attribute_specifier,
    STATE(1174), 1,
      sym_enumerator_list,
    ACTIONS(3187), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(3185), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1012), 1,
      sym_attribute_specifier,
    ACTIONS(3251), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3249), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(998), 1,
      sym_attribute_specifier,
    ACTIONS(3271), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3269), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(991), 1,
      sym_attribute_specifier,
    ACTIONS(3258), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3256), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39806] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1434), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3267), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3474), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [39853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3476), 21,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [39884] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1441), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3480), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3474), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [39931] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1442), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1180), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3482), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3474), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [39978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3484), 21,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [40009] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1436), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3488), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3474), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40056] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1440), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1175), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2878), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3474), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40103] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2497), 1,
      anon_sym_LPAREN2,
    ACTIONS(2499), 1,
      anon_sym_STAR,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1435), 1,
      sym__abstract_declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1177), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3490), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3474), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40150] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1361), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40194] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 1,
      sym_primitive_type,
    ACTIONS(3492), 1,
      sym_identifier,
    STATE(924), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3121), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3117), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3119), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3496), 1,
      anon_sym_LPAREN2,
    STATE(1204), 1,
      sym_preproc_argument_list,
    ACTIONS(3498), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3494), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40266] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1365), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1330), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40354] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1366), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40398] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1326), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40442] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1341), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40486] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      anon_sym_RPAREN,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    STATE(1585), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40541] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    STATE(1584), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40596] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3530), 1,
      anon_sym_RPAREN,
    STATE(1579), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3544), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1192), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [40694] = 5,
    ACTIONS(3494), 1,
      anon_sym_LF,
    ACTIONS(3548), 1,
      anon_sym_LPAREN2,
    ACTIONS(3550), 1,
      sym_comment,
    STATE(1275), 1,
      sym_preproc_argument_list,
    ACTIONS(3498), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40727] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3552), 1,
      anon_sym_RPAREN,
    ACTIONS(3554), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1193), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [40770] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3556), 1,
      anon_sym_RPAREN,
    ACTIONS(3558), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1191), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [40813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3560), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3574), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1283), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [40881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3580), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3578), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3584), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3582), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3586), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2772), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3590), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3596), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3594), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [41053] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3598), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1213), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3600), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1259), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1205), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3602), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [41165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3608), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3606), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3608), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3606), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [41235] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3608), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3606), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [41275] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3608), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3606), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [41317] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3608), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3606), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [41361] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3608), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3606), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [41407] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3606), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [41453] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3606), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [41501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3606), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3608), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3606), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3610), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41589] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1160), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3614), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [41621] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3618), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1279), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41661] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LPAREN2,
    ACTIONS(2288), 1,
      anon_sym_STAR,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1414), 1,
      sym__declarator,
    STATE(1453), 1,
      sym_parameter_list,
    STATE(1458), 1,
      sym__abstract_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    ACTIONS(3620), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1452), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [41709] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3622), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1209), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41749] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3624), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1210), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3626), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1211), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41829] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3628), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1212), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41869] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3630), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1253), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3632), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1214), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41949] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3634), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1215), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [41989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3636), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1216), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42029] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3638), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1217), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3640), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1218), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3642), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3646), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42165] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3650), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1271), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42205] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3652), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1260), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42245] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3654), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1278), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42285] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3656), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1261), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42325] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3658), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1289), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3660), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1290), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42405] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3662), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1277), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42445] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3664), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1274), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42485] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3666), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1276), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42525] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3668), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1272), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42565] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3670), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1267), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42605] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3672), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1270), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3674), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1268), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42685] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3676), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1264), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3678), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1265), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3680), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1266), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42805] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3682), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1263), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42845] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3684), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1233), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42885] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3686), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42935] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3688), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1269), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [42975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3690), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1282), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [43015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1220), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3692), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43047] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym_identifier,
    ACTIONS(3536), 1,
      anon_sym_LPAREN2,
    ACTIONS(3538), 1,
      anon_sym_defined,
    ACTIONS(3696), 1,
      sym_number_literal,
    ACTIONS(3540), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3546), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1286), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [43087] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      sym_identifier,
    ACTIONS(3566), 1,
      anon_sym_LPAREN2,
    ACTIONS(3568), 1,
      anon_sym_defined,
    ACTIONS(3698), 1,
      sym_number_literal,
    ACTIONS(3570), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3576), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1291), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [43127] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LF,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43172] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43217] = 6,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3608), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43250] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_LF,
    ACTIONS(3612), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43277] = 4,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3608), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43306] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3724), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43351] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3608), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43378] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3726), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43423] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3728), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43468] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3730), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43513] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43558] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3608), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43603] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3734), 1,
      anon_sym_RPAREN,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43652] = 11,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3608), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43695] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3578), 1,
      anon_sym_LF,
    ACTIONS(3580), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43722] = 10,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3608), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43763] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3590), 1,
      anon_sym_LF,
    ACTIONS(3592), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43790] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3736), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43835] = 9,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3608), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43874] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3608), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43905] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3738), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [43950] = 3,
    ACTIONS(2772), 1,
      anon_sym_LF,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(2774), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43977] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LF,
    ACTIONS(3588), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44004] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3740), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [44049] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3642), 1,
      anon_sym_LF,
    ACTIONS(3644), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44076] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3560), 1,
      anon_sym_LF,
    ACTIONS(3562), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44103] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_LF,
    ACTIONS(3648), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44130] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3742), 1,
      anon_sym_RPAREN,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      sym_primitive_type,
    STATE(924), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3117), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3744), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3119), 10,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44214] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_LF,
    ACTIONS(3584), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44241] = 7,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3608), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [44276] = 8,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3608), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [44313] = 12,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3708), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 1,
      anon_sym_PIPE,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    ACTIONS(3714), 1,
      anon_sym_AMP,
    ACTIONS(3750), 1,
      anon_sym_LF,
    ACTIONS(3702), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3716), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3718), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [44358] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1468), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44399] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1477), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44440] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_const,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(3754), 1,
      anon_sym_COLON,
    STATE(987), 1,
      sym_attribute_specifier,
    STATE(1174), 1,
      sym_enumerator_list,
    ACTIONS(3187), 11,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44475] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1487), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44516] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1478), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44557] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1491), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1497), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44639] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1499), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44680] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1510), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44721] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1501), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44762] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1383), 1,
      sym__type_declarator,
    STATE(1489), 1,
      sym__type_definition_declarators,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44803] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    STATE(474), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [44851] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1427), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [44889] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    STATE(372), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [44937] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    STATE(190), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [44985] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    STATE(490), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3173), 1,
      sym_primitive_type,
    STATE(1394), 1,
      sym__type_declarator,
    STATE(1726), 1,
      sym_ms_based_modifier,
    ACTIONS(3171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1426), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [45071] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    STATE(472), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45119] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    ACTIONS(3769), 1,
      anon_sym_SEMI,
    STATE(1354), 1,
      sym__field_declarator,
    STATE(1595), 1,
      sym__field_declaration_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1774), 1,
      sym_attribute_specifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [45160] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(190), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45205] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(472), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45250] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(474), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45295] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    ACTIONS(3773), 1,
      anon_sym_SEMI,
    STATE(1354), 1,
      sym__field_declarator,
    STATE(1554), 1,
      sym__field_declaration_declarator,
    STATE(1721), 1,
      sym_attribute_specifier,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [45336] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(490), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45381] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(372), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45426] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    ACTIONS(3775), 1,
      anon_sym_SEMI,
    STATE(1354), 1,
      sym__field_declarator,
    STATE(1578), 1,
      sym__field_declaration_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1868), 1,
      sym_attribute_specifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [45467] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    ACTIONS(3777), 1,
      anon_sym_SEMI,
    STATE(1354), 1,
      sym__field_declarator,
    STATE(1545), 1,
      sym__field_declaration_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1845), 1,
      sym_attribute_specifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [45508] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(764), 1,
      sym__old_style_function_declarator,
    STATE(1307), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1814), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45546] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(763), 1,
      sym__old_style_function_declarator,
    STATE(1309), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1740), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(769), 1,
      sym__old_style_function_declarator,
    STATE(1303), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1792), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45622] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(762), 1,
      sym__old_style_function_declarator,
    STATE(1306), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1844), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(3781), 1,
      anon_sym_LBRACK,
    STATE(1334), 1,
      sym_gnu_asm_expression,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1329), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3779), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [45690] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(758), 1,
      sym__old_style_function_declarator,
    STATE(1305), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1733), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3788), 1,
      anon_sym_LBRACK,
    STATE(1325), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3783), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [45754] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3790), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [45783] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3792), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [45812] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1312), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1740), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(3796), 1,
      anon_sym_LBRACK,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3794), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [45872] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3798), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [45901] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1711), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [45936] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1592), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym__declaration_declarator_repeat1,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [45975] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1792), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(3796), 1,
      anon_sym_LBRACK,
    STATE(1343), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3794), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [46035] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1814), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46070] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1311), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1844), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46105] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1844), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46140] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1733), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46175] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1740), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46210] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1315), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1814), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46245] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3800), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [46274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1316), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1733), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(3804), 1,
      anon_sym_LBRACK,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3802), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [46334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1332), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1894), 1,
      sym__declaration_declarator,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym___attribute__,
    ACTIONS(3811), 1,
      anon_sym_LBRACK,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3806), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [46394] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1313), 1,
      sym__declarator,
    STATE(1533), 1,
      sym_init_declarator,
    STATE(1792), 1,
      sym__declaration_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46429] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(756), 1,
      sym__old_style_function_declarator,
    STATE(1397), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(767), 1,
      sym__old_style_function_declarator,
    STATE(1387), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 1,
      anon_sym_LBRACK,
    ACTIONS(2888), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [46513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(771), 1,
      sym__old_style_function_declarator,
    STATE(1386), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(751), 1,
      sym__old_style_function_declarator,
    STATE(1392), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46577] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1651), 1,
      sym_gnu_asm_expression,
    ACTIONS(3767), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3813), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [46611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2918), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [46631] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    ACTIONS(3821), 1,
      anon_sym_COLON,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1476), 1,
      sym_bitfield_clause,
    STATE(1508), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(3817), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [46667] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1352), 1,
      sym__declarator,
    STATE(1699), 1,
      sym_init_declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LBRACK,
    ACTIONS(3823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [46719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    STATE(1325), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3827), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [46743] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(760), 1,
      sym__old_style_function_declarator,
    STATE(1399), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46775] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1416), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [46804] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3831), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [46831] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3833), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [46858] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    ACTIONS(3821), 1,
      anon_sym_COLON,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1588), 1,
      sym_bitfield_clause,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3835), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [46889] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1362), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [46918] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(3276), 1,
      sym_identifier,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1431), 1,
      sym__field_declarator,
    STATE(1722), 1,
      sym_ms_based_modifier,
    STATE(1409), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [46947] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3837), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [46974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3839), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [47001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1413), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47030] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1417), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47059] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1407), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47088] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1422), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym___based,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3282), 1,
      anon_sym_LPAREN2,
    ACTIONS(3284), 1,
      anon_sym_STAR,
    STATE(1402), 1,
      sym__declarator,
    STATE(1813), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3843), 1,
      anon_sym_LBRACK,
    STATE(1325), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3841), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [47168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_LBRACK,
    ACTIONS(3845), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [47186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_LBRACK,
    ACTIONS(3849), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [47204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3853), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [47230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [47248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [47266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3867), 1,
      anon_sym_LBRACK,
    STATE(1517), 1,
      sym_gnu_asm_output_operand,
    STATE(1819), 1,
      sym_string_literal,
    ACTIONS(3865), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47290] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_LBRACK,
    STATE(1466), 1,
      sym_gnu_asm_input_operand,
    STATE(1892), 1,
      sym_string_literal,
    ACTIONS(3869), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47314] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3873), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [47340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LBRACK,
    ACTIONS(3875), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [47358] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3879), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [47384] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    ACTIONS(3881), 1,
      anon_sym_COMMA,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1511), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(3883), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACK,
    ACTIONS(3885), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [47432] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3889), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [47458] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    STATE(510), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47487] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    STATE(207), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3893), 1,
      anon_sym_LBRACK,
    STATE(1325), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3891), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [47537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 1,
      sym_identifier,
    ACTIONS(3899), 1,
      sym_system_lib_string,
    STATE(1827), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3897), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym_identifier,
    ACTIONS(3903), 1,
      sym_system_lib_string,
    STATE(1763), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3897), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 1,
      sym_identifier,
    ACTIONS(3907), 1,
      sym_system_lib_string,
    STATE(1956), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3897), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47600] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    STATE(419), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3911), 1,
      sym_system_lib_string,
    STATE(1765), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3897), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47650] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3913), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [47675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 1,
      anon_sym_RPAREN,
    ACTIONS(3917), 1,
      anon_sym_COLON,
    STATE(749), 1,
      sym_string_literal,
    STATE(1520), 1,
      sym_gnu_asm_output_operand_list,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      sym_identifier,
    ACTIONS(3921), 1,
      sym_system_lib_string,
    STATE(1914), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3897), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47719] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    STATE(498), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_COLON,
    ACTIONS(3923), 1,
      anon_sym_RPAREN,
    STATE(749), 1,
      sym_string_literal,
    STATE(1534), 1,
      sym_gnu_asm_output_operand_list,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47771] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(3759), 1,
      anon_sym_LPAREN2,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    STATE(514), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym__old_style_parameter_list,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_LBRACK,
    ACTIONS(3925), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [47816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3931), 1,
      anon_sym_LBRACK,
    ACTIONS(3929), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [47832] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(419), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 1,
      anon_sym_LBRACK,
    ACTIONS(3933), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [47874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_LBRACK,
    STATE(1603), 1,
      sym_gnu_asm_input_operand,
    STATE(1892), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 1,
      sym_identifier,
    STATE(1395), 1,
      sym_string_literal,
    STATE(1546), 1,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1486), 1,
      sym_string_literal,
    ACTIONS(3939), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [47932] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(514), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [47958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_LBRACK,
    ACTIONS(3941), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [47974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3945), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [47990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [48006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3867), 1,
      anon_sym_LBRACK,
    STATE(1589), 1,
      sym_gnu_asm_output_operand,
    STATE(1819), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [48026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3955), 1,
      anon_sym_LBRACK,
    ACTIONS(3953), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [48042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(510), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48068] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1323), 1,
      sym_parameter_list,
    ACTIONS(3957), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3961), 1,
      anon_sym_LBRACK,
    ACTIONS(3959), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [48108] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(207), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48134] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(498), 1,
      sym_compound_statement,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 1,
      sym_identifier,
    STATE(1398), 1,
      sym_string_literal,
    STATE(1519), 1,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [48180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3965), 1,
      anon_sym_LBRACK,
    ACTIONS(3963), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3969), 1,
      anon_sym_LBRACK,
    ACTIONS(3967), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(3971), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3975), 1,
      anon_sym_RPAREN,
    STATE(1323), 1,
      sym_parameter_list,
    STATE(1357), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 1,
      anon_sym_LBRACK,
    ACTIONS(3977), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3985), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3855), 1,
      anon_sym_LBRACK,
    ACTIONS(3993), 1,
      anon_sym_RPAREN,
    STATE(1428), 1,
      sym_parameter_list,
    STATE(1388), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48346] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    ACTIONS(3999), 1,
      sym_identifier,
    STATE(980), 1,
      sym_field_declaration_list,
    STATE(1450), 1,
      sym_attribute_specifier,
    STATE(1544), 1,
      sym_ms_declspec_modifier,
  [48371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_LBRACK,
    ACTIONS(4001), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [48386] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(3819), 1,
      anon_sym_LBRACK,
    ACTIONS(4005), 1,
      anon_sym_RPAREN,
    STATE(1408), 1,
      sym_parameter_list,
    STATE(1372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [48409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(749), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [48423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_LBRACK,
    ACTIONS(4007), 1,
      anon_sym_EQ,
    ACTIONS(4009), 1,
      anon_sym_DOT,
    STATE(1438), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [48441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(4011), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(4015), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(4017), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 1,
      anon_sym_LPAREN2,
    STATE(1445), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4021), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [48511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      anon_sym_EQ,
    ACTIONS(4028), 1,
      anon_sym_DOT,
    STATE(1438), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [48529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_LPAREN2,
    STATE(1439), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4033), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [48545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(4036), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(4038), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(4040), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1927), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [48613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1552), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [48627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LPAREN2,
    STATE(1439), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4021), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [48643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1942), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [48657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4044), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    ACTIONS(4048), 1,
      anon_sym_COLON_COLON,
    STATE(1704), 1,
      sym_argument_list,
    ACTIONS(4046), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [48685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4050), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    ACTIONS(4052), 1,
      sym_identifier,
    STATE(976), 1,
      sym_field_declaration_list,
    STATE(1527), 1,
      sym_ms_declspec_modifier,
  [48715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4058), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4060), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4062), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    ACTIONS(4064), 1,
      sym_identifier,
    STATE(979), 1,
      sym_field_declaration_list,
    STATE(1535), 1,
      sym_ms_declspec_modifier,
  [48789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4066), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    STATE(1454), 1,
      sym_parameter_list,
    ACTIONS(3957), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4068), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4070), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4072), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4074), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [48861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    STATE(1463), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4079), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [48875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4081), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [48889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4083), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [48903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(1485), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4087), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4089), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [48931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4091), 1,
      anon_sym_SEMI,
    STATE(1493), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [48945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_COMMA,
    STATE(1490), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4095), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [48959] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4097), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4101), 1,
      sym_preproc_arg,
    STATE(1689), 1,
      sym_preproc_params,
  [48975] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4103), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4105), 1,
      sym_preproc_arg,
    STATE(1691), 1,
      sym_preproc_params,
  [48991] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4107), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4109), 1,
      sym_preproc_arg,
    STATE(1694), 1,
      sym_preproc_params,
  [49007] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4111), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4113), 1,
      sym_preproc_arg,
    STATE(1697), 1,
      sym_preproc_params,
  [49023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 1,
      anon_sym_COMMA,
    STATE(1474), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4118), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [49037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4120), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1481), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4122), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [49065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4124), 1,
      anon_sym_SEMI,
    STATE(1465), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4126), 1,
      anon_sym_SEMI,
    STATE(1509), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4128), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4130), 1,
      anon_sym_COMMA,
    ACTIONS(4132), 1,
      anon_sym_RPAREN,
    STATE(1531), 1,
      aux_sym_parameter_list_repeat1,
    STATE(1542), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [49123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1474), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4134), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [49137] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4136), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4138), 1,
      sym_preproc_arg,
    STATE(1703), 1,
      sym_preproc_params,
  [49153] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DQUOTE,
    ACTIONS(4142), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4145), 1,
      sym_escape_sequence,
    STATE(1483), 1,
      aux_sym_string_literal_repeat1,
  [49169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 1,
      anon_sym_COMMA,
    STATE(1494), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4150), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(1503), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4152), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 1,
      anon_sym_COMMA,
    STATE(1484), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4154), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4156), 1,
      anon_sym_SEMI,
    STATE(1505), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    ACTIONS(4158), 1,
      anon_sym_RPAREN,
    STATE(1454), 1,
      sym_parameter_list,
  [49241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4160), 1,
      anon_sym_SEMI,
    STATE(1496), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 1,
      anon_sym_COMMA,
    STATE(1490), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4165), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4167), 1,
      anon_sym_SEMI,
    STATE(1475), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49283] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4169), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4171), 1,
      sym_preproc_arg,
    STATE(1670), 1,
      sym_preproc_params,
  [49299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4173), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4175), 1,
      anon_sym_COMMA,
    STATE(1494), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4178), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      sym_identifier,
    ACTIONS(4182), 1,
      anon_sym_COMMA,
    ACTIONS(4184), 1,
      anon_sym_RBRACE,
    STATE(1522), 1,
      sym_enumerator,
  [49343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4186), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4188), 1,
      anon_sym_SEMI,
    STATE(1467), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4190), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4192), 1,
      anon_sym_SEMI,
    STATE(1464), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49399] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4196), 1,
      sym_preproc_arg,
    STATE(1634), 1,
      sym_preproc_params,
  [49415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4198), 1,
      anon_sym_SEMI,
    STATE(1479), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49429] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4200), 1,
      anon_sym_DQUOTE,
    ACTIONS(4202), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4204), 1,
      sym_escape_sequence,
    STATE(1483), 1,
      aux_sym_string_literal_repeat1,
  [49445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4206), 1,
      anon_sym_COMMA,
    STATE(1503), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4209), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49459] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4211), 1,
      anon_sym_DQUOTE,
    ACTIONS(4213), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4215), 1,
      sym_escape_sequence,
    STATE(1506), 1,
      aux_sym_string_literal_repeat1,
  [49475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4217), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49489] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4202), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4204), 1,
      sym_escape_sequence,
    ACTIONS(4219), 1,
      anon_sym_DQUOTE,
    STATE(1483), 1,
      aux_sym_string_literal_repeat1,
  [49505] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4221), 1,
      anon_sym_DQUOTE,
    ACTIONS(4223), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4225), 1,
      sym_escape_sequence,
    STATE(1514), 1,
      aux_sym_string_literal_repeat1,
  [49521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1474), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4227), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [49535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4229), 1,
      anon_sym_SEMI,
    STATE(1345), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4231), 1,
      anon_sym_SEMI,
    STATE(1498), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [49563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 1,
      anon_sym_COMMA,
    STATE(1463), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4233), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [49577] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_DQUOTE,
    ACTIONS(4237), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4239), 1,
      sym_escape_sequence,
    STATE(1502), 1,
      aux_sym_string_literal_repeat1,
  [49593] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4241), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4243), 1,
      sym_preproc_arg,
    STATE(1676), 1,
      sym_preproc_params,
  [49609] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4202), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4204), 1,
      sym_escape_sequence,
    ACTIONS(4245), 1,
      anon_sym_DQUOTE,
    STATE(1483), 1,
      aux_sym_string_literal_repeat1,
  [49625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [49635] = 5,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LPAREN,
    ACTIONS(4249), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4251), 1,
      sym_preproc_arg,
    STATE(1652), 1,
      sym_preproc_params,
  [49651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_COMMA,
    STATE(1469), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4253), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [49665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    STATE(1678), 1,
      sym_argument_list,
    ACTIONS(4255), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [49679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_COLON,
    ACTIONS(3923), 1,
      anon_sym_RPAREN,
    STATE(1534), 1,
      sym_gnu_asm_output_operand_list,
  [49692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
    ACTIONS(4259), 1,
      anon_sym_COLON,
    STATE(1529), 1,
      sym_gnu_asm_input_operand_list,
  [49705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4263), 1,
      anon_sym_EQ,
    ACTIONS(4261), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4267), 1,
      anon_sym_RBRACE,
    STATE(1541), 1,
      aux_sym_enumerator_list_repeat1,
  [49729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4269), 1,
      anon_sym_COMMA,
    ACTIONS(4272), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1523), 1,
      aux_sym_attribute_declaration_repeat1,
  [49742] = 4,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4274), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4276), 1,
      anon_sym_LPAREN2,
    STATE(1808), 1,
      sym_preproc_argument_list,
  [49755] = 4,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_LPAREN2,
    ACTIONS(4278), 1,
      aux_sym_preproc_include_token2,
    STATE(1808), 1,
      sym_preproc_argument_list,
  [49768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    ACTIONS(4282), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1566), 1,
      aux_sym_attribute_declaration_repeat1,
  [49781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    ACTIONS(4284), 1,
      sym_identifier,
    STATE(951), 1,
      sym_field_declaration_list,
  [49794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    ACTIONS(4286), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1559), 1,
      aux_sym_attribute_declaration_repeat1,
  [49807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4288), 1,
      anon_sym_RPAREN,
    ACTIONS(4290), 1,
      anon_sym_COLON,
    STATE(1580), 1,
      sym_gnu_asm_clobber_list,
  [49820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 1,
      anon_sym_COMMA,
    ACTIONS(4294), 1,
      anon_sym_RPAREN,
    STATE(1558), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [49833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4298), 1,
      anon_sym_RPAREN,
    STATE(1564), 1,
      aux_sym_parameter_list_repeat1,
  [49846] = 4,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_LPAREN2,
    ACTIONS(4300), 1,
      aux_sym_preproc_include_token2,
    STATE(1808), 1,
      sym_preproc_argument_list,
  [49859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_SEMI,
    STATE(1596), 1,
      aux_sym__declaration_declarator_repeat1,
  [49872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_COLON,
    ACTIONS(4302), 1,
      anon_sym_RPAREN,
    STATE(1581), 1,
      sym_gnu_asm_input_operand_list,
  [49885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    ACTIONS(4304), 1,
      sym_identifier,
    STATE(943), 1,
      sym_field_declaration_list,
  [49898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 1,
      anon_sym_RPAREN,
    ACTIONS(4306), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [49909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      sym_identifier,
    ACTIONS(4310), 1,
      anon_sym_RBRACE,
    STATE(1677), 1,
      sym_enumerator,
  [49922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    ACTIONS(4312), 1,
      anon_sym_LPAREN2,
    STATE(221), 1,
      sym_compound_statement,
  [49935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(4314), 1,
      sym_identifier,
    STATE(1173), 1,
      sym_enumerator_list,
  [49948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4316), 1,
      sym_identifier,
    STATE(1629), 1,
      sym_variadic_parameter,
  [49961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4310), 1,
      anon_sym_RBRACE,
    ACTIONS(4318), 1,
      anon_sym_COMMA,
    STATE(1550), 1,
      aux_sym_enumerator_list_repeat1,
  [49974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4320), 1,
      anon_sym_COMMA,
    ACTIONS(4322), 1,
      anon_sym_RPAREN,
    STATE(1583), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [49987] = 4,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_LPAREN2,
    ACTIONS(4324), 1,
      aux_sym_preproc_include_token2,
    STATE(1808), 1,
      sym_preproc_argument_list,
  [50000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      anon_sym_LBRACE,
    ACTIONS(4326), 1,
      sym_identifier,
    STATE(976), 1,
      sym_field_declaration_list,
  [50013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4328), 1,
      anon_sym_SEMI,
    STATE(1823), 1,
      sym_attribute_specifier,
  [50026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 1,
      anon_sym_RPAREN,
    ACTIONS(3917), 1,
      anon_sym_COLON,
    STATE(1520), 1,
      sym_gnu_asm_output_operand_list,
  [50039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4330), 1,
      anon_sym_COMMA,
    ACTIONS(4333), 1,
      anon_sym_RPAREN,
    STATE(1547), 1,
      aux_sym_generic_expression_repeat1,
  [50052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(4335), 1,
      sym_identifier,
    STATE(1173), 1,
      sym_enumerator_list,
  [50065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4337), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_COMMA,
    ACTIONS(4342), 1,
      anon_sym_RBRACE,
    STATE(1550), 1,
      aux_sym_enumerator_list_repeat1,
  [50087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RPAREN,
    STATE(1553), 1,
      aux_sym_argument_list_repeat1,
  [50100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_RPAREN,
    ACTIONS(4348), 1,
      anon_sym_COMMA,
    STATE(1553), 1,
      aux_sym_argument_list_repeat1,
  [50122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4351), 1,
      anon_sym_SEMI,
    STATE(1798), 1,
      sym_attribute_specifier,
  [50135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4353), 1,
      anon_sym_RPAREN,
    STATE(1531), 1,
      aux_sym_parameter_list_repeat1,
  [50148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      sym_identifier,
    ACTIONS(4355), 1,
      anon_sym_RBRACE,
    STATE(1677), 1,
      sym_enumerator,
  [50161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      anon_sym_LPAREN2,
    STATE(352), 1,
      sym_compound_statement,
  [50174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 1,
      anon_sym_COMMA,
    ACTIONS(4359), 1,
      anon_sym_RPAREN,
    STATE(1569), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [50187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    ACTIONS(4361), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1523), 1,
      aux_sym_attribute_declaration_repeat1,
  [50200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3686), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      anon_sym_COMMA,
    STATE(1560), 1,
      aux_sym_preproc_argument_list_repeat1,
  [50213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    ACTIONS(4366), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1562), 1,
      aux_sym_attribute_declaration_repeat1,
  [50226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    ACTIONS(4368), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1523), 1,
      aux_sym_attribute_declaration_repeat1,
  [50239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4370), 1,
      anon_sym_COMMA,
    ACTIONS(4373), 1,
      anon_sym_RPAREN,
    STATE(1563), 1,
      aux_sym_preproc_params_repeat1,
  [50252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4375), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_RPAREN,
    STATE(1564), 1,
      aux_sym_parameter_list_repeat1,
  [50265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4380), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    ACTIONS(4382), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1523), 1,
      aux_sym_attribute_declaration_repeat1,
  [50287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(4384), 1,
      anon_sym_LPAREN2,
    STATE(247), 1,
      sym_compound_statement,
  [50300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4386), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [50309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4388), 1,
      anon_sym_COMMA,
    ACTIONS(4391), 1,
      anon_sym_RPAREN,
    STATE(1569), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [50322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_RBRACE,
    ACTIONS(4393), 1,
      anon_sym_COMMA,
    STATE(1576), 1,
      aux_sym_initializer_list_repeat1,
  [50335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4395), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3294), 1,
      anon_sym_RPAREN,
    STATE(1586), 1,
      aux_sym_argument_list_repeat1,
  [50357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_COMMA,
    ACTIONS(3302), 1,
      anon_sym_RBRACE,
    STATE(1570), 1,
      aux_sym_initializer_list_repeat1,
  [50370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(4397), 1,
      anon_sym_SEMI,
    STATE(1575), 1,
      aux_sym__declaration_declarator_repeat1,
  [50383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4399), 1,
      anon_sym_COMMA,
    ACTIONS(4402), 1,
      anon_sym_SEMI,
    STATE(1575), 1,
      aux_sym__declaration_declarator_repeat1,
  [50396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3373), 1,
      anon_sym_RBRACE,
    ACTIONS(4404), 1,
      anon_sym_COMMA,
    STATE(1576), 1,
      aux_sym_initializer_list_repeat1,
  [50409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(4407), 1,
      anon_sym_RPAREN,
    STATE(1553), 1,
      aux_sym_argument_list_repeat1,
  [50422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4409), 1,
      anon_sym_SEMI,
    STATE(1895), 1,
      sym_attribute_specifier,
  [50435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(4411), 1,
      anon_sym_RPAREN,
    STATE(1560), 1,
      aux_sym_preproc_argument_list_repeat1,
  [50448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 1,
      anon_sym_RPAREN,
    ACTIONS(4415), 1,
      anon_sym_COLON,
    STATE(1916), 1,
      sym_gnu_asm_goto_list,
  [50461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 1,
      anon_sym_COLON,
    ACTIONS(4417), 1,
      anon_sym_RPAREN,
    STATE(1598), 1,
      sym_gnu_asm_clobber_list,
  [50474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(4419), 1,
      anon_sym_LPAREN2,
    STATE(110), 1,
      sym_compound_statement,
  [50487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_COMMA,
    ACTIONS(4424), 1,
      anon_sym_RPAREN,
    STATE(1583), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [50500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(4426), 1,
      anon_sym_RPAREN,
    STATE(1560), 1,
      aux_sym_preproc_argument_list_repeat1,
  [50513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(4428), 1,
      anon_sym_RPAREN,
    STATE(1560), 1,
      aux_sym_preproc_argument_list_repeat1,
  [50526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3296), 1,
      anon_sym_RPAREN,
    STATE(1553), 1,
      aux_sym_argument_list_repeat1,
  [50539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4430), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [50548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [50557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_COMMA,
    ACTIONS(4438), 1,
      anon_sym_RPAREN,
    STATE(1563), 1,
      aux_sym_preproc_params_repeat1,
  [50579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    ACTIONS(4440), 1,
      anon_sym_LPAREN2,
    STATE(337), 1,
      sym_compound_statement,
  [50592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(4442), 1,
      anon_sym_SEMI,
    STATE(1574), 1,
      aux_sym__declaration_declarator_repeat1,
  [50605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3298), 1,
      anon_sym_RPAREN,
    STATE(1553), 1,
      aux_sym_argument_list_repeat1,
  [50618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(4444), 1,
      anon_sym_SEMI,
    STATE(1575), 1,
      aux_sym__declaration_declarator_repeat1,
  [50631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym___attribute__,
    ACTIONS(4446), 1,
      anon_sym_SEMI,
    STATE(1759), 1,
      sym_attribute_specifier,
  [50644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    ACTIONS(4444), 1,
      anon_sym_SEMI,
    STATE(1575), 1,
      aux_sym__declaration_declarator_repeat1,
  [50657] = 4,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_LPAREN2,
    ACTIONS(4448), 1,
      aux_sym_preproc_include_token2,
    STATE(1808), 1,
      sym_preproc_argument_list,
  [50670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_COLON,
    ACTIONS(4450), 1,
      anon_sym_RPAREN,
    STATE(1930), 1,
      sym_gnu_asm_goto_list,
  [50683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 1,
      anon_sym_COMMA,
    ACTIONS(4452), 1,
      anon_sym_RPAREN,
    STATE(1547), 1,
      aux_sym_generic_expression_repeat1,
  [50696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    ACTIONS(3312), 1,
      anon_sym_RPAREN,
    STATE(1593), 1,
      aux_sym_argument_list_repeat1,
  [50709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4454), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_COMMA,
    ACTIONS(4456), 1,
      anon_sym_RPAREN,
    STATE(1590), 1,
      aux_sym_preproc_params_repeat1,
  [50731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4458), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [50740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_LBRACE,
    ACTIONS(4460), 1,
      sym_identifier,
    STATE(1053), 1,
      sym_enumerator_list,
  [50753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(296), 1,
      sym_parenthesized_expression,
  [50763] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4464), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4466), 1,
      sym_preproc_arg,
  [50773] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4468), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4470), 1,
      sym_preproc_arg,
  [50783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      sym_identifier,
    STATE(1561), 1,
      sym_attribute,
  [50793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [50801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(415), 1,
      sym_parenthesized_expression,
  [50811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(432), 1,
      sym_parenthesized_expression,
  [50821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1666), 1,
      sym_parenthesized_expression,
  [50831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(433), 1,
      sym_parenthesized_expression,
  [50841] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4478), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4480), 1,
      sym_preproc_arg,
  [50851] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4482), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [50859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(455), 1,
      sym_parenthesized_expression,
  [50869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(454), 1,
      sym_parenthesized_expression,
  [50879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    STATE(176), 1,
      sym_compound_statement,
  [50889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(453), 1,
      sym_parenthesized_expression,
  [50899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(245), 1,
      sym_compound_statement,
  [50909] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4484), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4486), 1,
      sym_preproc_arg,
  [50919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    STATE(103), 1,
      sym_compound_statement,
  [50929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 1,
      sym_identifier,
    ACTIONS(4490), 1,
      anon_sym_RPAREN,
  [50939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4492), 1,
      sym_identifier,
    ACTIONS(4494), 1,
      anon_sym_LPAREN2,
  [50949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3373), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [50973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1724), 1,
      sym_parenthesized_expression,
  [50983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4424), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [50991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1693), 1,
      sym_parenthesized_expression,
  [51001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    STATE(1715), 1,
      sym_argument_list,
  [51011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      sym_identifier,
    STATE(1677), 1,
      sym_enumerator,
  [51021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1843), 1,
      sym_parenthesized_expression,
  [51031] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4499), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4501), 1,
      sym_preproc_arg,
  [51041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51049] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4503), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4505), 1,
      sym_preproc_arg,
  [51059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(483), 1,
      sym_compound_statement,
  [51069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(319), 1,
      sym_parenthesized_expression,
  [51079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(322), 1,
      sym_parenthesized_expression,
  [51089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(327), 1,
      sym_parenthesized_expression,
  [51099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(334), 1,
      sym_parenthesized_expression,
  [51117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1618), 1,
      sym_parenthesized_expression,
  [51127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(339), 1,
      sym_parenthesized_expression,
  [51137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51145] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4507), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4509), 1,
      sym_preproc_arg,
  [51155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4511), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(318), 1,
      sym_parenthesized_expression,
  [51173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1876), 1,
      sym_parenthesized_expression,
  [51183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(324), 1,
      sym_parenthesized_expression,
  [51193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [51201] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4515), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4517), 1,
      sym_preproc_arg,
  [51211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(362), 1,
      sym_parenthesized_expression,
  [51221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(366), 1,
      sym_parenthesized_expression,
  [51231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(367), 1,
      sym_parenthesized_expression,
  [51241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [51249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(397), 1,
      sym_parenthesized_expression,
  [51259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(399), 1,
      sym_parenthesized_expression,
  [51269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(403), 1,
      sym_parenthesized_expression,
  [51279] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4519), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [51287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(413), 1,
      sym_parenthesized_expression,
  [51297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1675), 1,
      sym_parenthesized_expression,
  [51307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(416), 1,
      sym_parenthesized_expression,
  [51317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      sym_identifier,
    STATE(1528), 1,
      sym_attribute,
  [51327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4521), 1,
      sym_identifier,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
  [51337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(276), 1,
      sym_compound_statement,
  [51347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_LPAREN2,
    STATE(1637), 1,
      sym_parameter_list,
  [51357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN2,
    STATE(1886), 1,
      sym_argument_list,
  [51367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    STATE(427), 1,
      sym_compound_statement,
  [51377] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4525), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4527), 1,
      sym_preproc_arg,
  [51387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1773), 1,
      sym_parenthesized_expression,
  [51397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_LBRACE,
    STATE(199), 1,
      sym_compound_statement,
  [51407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1723), 1,
      sym_parenthesized_expression,
  [51417] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4529), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4531), 1,
      sym_preproc_arg,
  [51427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    STATE(99), 1,
      sym_compound_statement,
  [51437] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4533), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4535), 1,
      sym_preproc_arg,
  [51447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4342), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [51455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4537), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [51463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(304), 1,
      sym_parenthesized_expression,
  [51473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(302), 1,
      sym_parenthesized_expression,
  [51483] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4539), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4541), 1,
      sym_preproc_arg,
  [51493] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4543), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [51501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(331), 1,
      sym_parenthesized_expression,
  [51511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [51519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LPAREN2,
    STATE(1669), 1,
      sym_parenthesized_expression,
  [51529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(387), 1,
      sym_parenthesized_expression,
  [51539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [51547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      sym_identifier,
    STATE(1526), 1,
      sym_attribute,
  [51557] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4547), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4549), 1,
      sym_preproc_arg,
  [51567] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4551), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4553), 1,
      sym_preproc_arg,
  [51577] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4555), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4557), 1,
      sym_preproc_arg,
  [51587] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4559), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4561), 1,
      sym_preproc_arg,
  [51597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(409), 1,
      sym_compound_statement,
  [51607] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4563), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4565), 1,
      sym_preproc_arg,
  [51617] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4567), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4569), 1,
      sym_preproc_arg,
  [51627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(423), 1,
      sym_parenthesized_expression,
  [51637] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4571), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4573), 1,
      sym_preproc_arg,
  [51647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(411), 1,
      sym_parenthesized_expression,
  [51657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [51665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(420), 1,
      sym_parenthesized_expression,
  [51675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      sym_identifier,
    STATE(1687), 1,
      sym_attribute,
  [51685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(388), 1,
      sym_compound_statement,
  [51695] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4575), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4577), 1,
      sym_preproc_arg,
  [51705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [51713] = 3,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4581), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4583), 1,
      sym_preproc_arg,
  [51723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [51731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_LPAREN2,
    STATE(410), 1,
      sym_parenthesized_expression,
  [51741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_compound_statement,
  [51751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_RBRACE,
  [51758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 1,
      anon_sym_SEMI,
  [51765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_SEMI,
  [51772] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4587), 1,
      aux_sym_preproc_include_token2,
  [51779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 1,
      aux_sym_preproc_if_token2,
  [51786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
  [51793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
  [51800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      anon_sym_SEMI,
  [51807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4597), 1,
      anon_sym_COLON,
  [51814] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4599), 1,
      aux_sym_preproc_include_token2,
  [51821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      aux_sym_preproc_if_token2,
  [51828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4603), 1,
      aux_sym_preproc_if_token2,
  [51835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 1,
      anon_sym_SEMI,
  [51842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 1,
      anon_sym_STAR,
  [51849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      anon_sym_SEMI,
  [51856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4611), 1,
      anon_sym_SEMI,
  [51863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_SEMI,
  [51870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4613), 1,
      anon_sym_STAR,
  [51877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      aux_sym_preproc_if_token2,
  [51884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_SEMI,
  [51891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4617), 1,
      sym_identifier,
  [51898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_COLON,
  [51905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4621), 1,
      sym_identifier,
  [51912] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4623), 1,
      aux_sym_preproc_include_token2,
  [51919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_SEMI,
  [51926] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4627), 1,
      aux_sym_preproc_include_token2,
  [51933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      aux_sym_preproc_if_token2,
  [51940] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4631), 1,
      aux_sym_preproc_include_token2,
  [51947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_SEMI,
  [51954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      aux_sym_preproc_if_token2,
  [51961] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4635), 1,
      aux_sym_preproc_include_token2,
  [51968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 1,
      anon_sym_SEMI,
  [51975] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4639), 1,
      aux_sym_preproc_include_token2,
  [51982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4641), 1,
      anon_sym_RPAREN,
  [51989] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4643), 1,
      aux_sym_preproc_include_token2,
  [51996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4645), 1,
      aux_sym_preproc_if_token2,
  [52003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4647), 1,
      aux_sym_preproc_if_token2,
  [52010] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4649), 1,
      aux_sym_preproc_include_token2,
  [52017] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4651), 1,
      aux_sym_preproc_include_token2,
  [52024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4653), 1,
      sym_identifier,
  [52031] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4655), 1,
      aux_sym_preproc_include_token2,
  [52038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_SEMI,
  [52045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4657), 1,
      aux_sym_preproc_if_token2,
  [52052] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4659), 1,
      aux_sym_preproc_include_token2,
  [52059] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4661), 1,
      aux_sym_preproc_include_token2,
  [52066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4663), 1,
      sym_identifier,
  [52073] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4665), 1,
      aux_sym_preproc_include_token2,
  [52080] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3582), 1,
      aux_sym_preproc_include_token2,
  [52087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4667), 1,
      sym_identifier,
  [52094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4669), 1,
      sym_identifier,
  [52101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_SEMI,
  [52108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4673), 1,
      aux_sym_preproc_if_token2,
  [52115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4675), 1,
      sym_identifier,
  [52122] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4677), 1,
      aux_sym_preproc_include_token2,
  [52129] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4278), 1,
      aux_sym_preproc_include_token2,
  [52136] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4679), 1,
      aux_sym_preproc_include_token2,
  [52143] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4274), 1,
      aux_sym_preproc_include_token2,
  [52150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4681), 1,
      sym_identifier,
  [52157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4683), 1,
      sym_identifier,
  [52164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4685), 1,
      aux_sym_preproc_if_token2,
  [52171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4687), 1,
      anon_sym_RPAREN,
  [52178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4689), 1,
      sym_identifier,
  [52185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 1,
      sym_identifier,
  [52192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 1,
      aux_sym_preproc_if_token2,
  [52199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 1,
      anon_sym_SEMI,
  [52206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4697), 1,
      anon_sym_SEMI,
  [52213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 1,
      aux_sym_preproc_if_token2,
  [52220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4701), 1,
      aux_sym_preproc_if_token2,
  [52227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 1,
      anon_sym_RPAREN,
  [52234] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4705), 1,
      aux_sym_preproc_include_token2,
  [52241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 1,
      aux_sym_preproc_if_token2,
  [52248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4709), 1,
      sym_identifier,
  [52255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_RBRACE,
  [52262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 1,
      sym_identifier,
  [52269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4713), 1,
      anon_sym_RPAREN,
  [52276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 1,
      anon_sym_RPAREN,
  [52283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4717), 1,
      sym_primitive_type,
  [52290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_SEMI,
  [52297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 1,
      anon_sym_SEMI,
  [52304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 1,
      aux_sym_preproc_if_token2,
  [52311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3329), 1,
      anon_sym_SEMI,
  [52318] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4725), 1,
      aux_sym_preproc_include_token2,
  [52325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 1,
      aux_sym_preproc_if_token2,
  [52332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 1,
      anon_sym_SEMI,
  [52339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 1,
      anon_sym_SQUOTE,
  [52346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_SEMI,
  [52353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 1,
      sym_identifier,
  [52360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      sym_identifier,
  [52367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 1,
      anon_sym_SEMI,
  [52374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_SEMI,
  [52381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 1,
      sym_identifier,
  [52388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4743), 1,
      anon_sym_COLON,
  [52395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4745), 1,
      anon_sym_RPAREN,
  [52402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_RPAREN,
  [52409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_if_token2,
  [52416] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4751), 1,
      aux_sym_preproc_include_token2,
  [52423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      anon_sym_RPAREN,
  [52430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3351), 1,
      anon_sym_RPAREN,
  [52437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_SEMI,
  [52444] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3590), 1,
      aux_sym_preproc_include_token2,
  [52451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 1,
      sym_identifier,
  [52458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4755), 1,
      aux_sym_preproc_if_token2,
  [52465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4757), 1,
      anon_sym_RPAREN,
  [52472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4759), 1,
      anon_sym_COLON,
  [52479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_STAR,
  [52486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_SEMI,
  [52493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4765), 1,
      aux_sym_preproc_if_token2,
  [52500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4767), 1,
      anon_sym_RPAREN,
  [52507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_SEMI,
  [52514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4769), 1,
      aux_sym_preproc_if_token2,
  [52521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_LPAREN2,
  [52528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4773), 1,
      anon_sym_SQUOTE,
  [52535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4775), 1,
      anon_sym_RPAREN,
  [52542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_RPAREN,
  [52549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_SEMI,
  [52556] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4779), 1,
      aux_sym_preproc_include_token2,
  [52563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4781), 1,
      anon_sym_SEMI,
  [52570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_SEMI,
  [52577] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4300), 1,
      aux_sym_preproc_include_token2,
  [52584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4783), 1,
      sym_identifier,
  [52591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4785), 1,
      sym_identifier,
  [52598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_SEMI,
  [52605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_while,
  [52612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4789), 1,
      anon_sym_RPAREN,
  [52619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4791), 1,
      anon_sym_RPAREN,
  [52626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 1,
      anon_sym_SEMI,
  [52633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_SEMI,
  [52640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_SEMI,
  [52647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      sym_identifier,
  [52654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4801), 1,
      aux_sym_preproc_if_token2,
  [52661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4803), 1,
      sym_identifier,
  [52668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_RPAREN,
  [52675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_SQUOTE,
  [52682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4809), 1,
      anon_sym_COMMA,
  [52689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4811), 1,
      anon_sym_SEMI,
  [52696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4813), 1,
      anon_sym_SEMI,
  [52703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 1,
      anon_sym_SEMI,
  [52710] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4817), 1,
      aux_sym_preproc_include_token2,
  [52717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 1,
      anon_sym_SEMI,
  [52724] = 2,
    ACTIONS(2559), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3550), 1,
      sym_comment,
  [52731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 1,
      aux_sym_preproc_if_token2,
  [52738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4823), 1,
      sym_identifier,
  [52745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4825), 1,
      anon_sym_RPAREN,
  [52752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4827), 1,
      anon_sym_RPAREN,
  [52759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_COLON,
  [52766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
  [52773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 1,
      aux_sym_preproc_if_token2,
  [52780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4835), 1,
      aux_sym_preproc_if_token2,
  [52787] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3578), 1,
      aux_sym_preproc_include_token2,
  [52794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 1,
      sym_identifier,
  [52801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4839), 1,
      sym_identifier,
  [52808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_SEMI,
  [52815] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4841), 1,
      aux_sym_preproc_include_token2,
  [52822] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4843), 1,
      aux_sym_preproc_include_token2,
  [52829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4845), 1,
      sym_identifier,
  [52836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      aux_sym_preproc_if_token2,
  [52843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4849), 1,
      sym_identifier,
  [52850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      aux_sym_preproc_if_token2,
  [52857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4853), 1,
      aux_sym_preproc_if_token2,
  [52864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      anon_sym_SEMI,
  [52871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_RPAREN,
  [52878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      sym_primitive_type,
  [52885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      aux_sym_preproc_if_token2,
  [52892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      aux_sym_preproc_if_token2,
  [52899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4865), 1,
      aux_sym_preproc_if_token2,
  [52906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      sym_identifier,
  [52913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4869), 1,
      sym_identifier,
  [52920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_SEMI,
  [52927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 1,
      anon_sym_RPAREN,
  [52934] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4875), 1,
      aux_sym_preproc_include_token2,
  [52941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      aux_sym_preproc_if_token2,
  [52948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4879), 1,
      aux_sym_preproc_if_token2,
  [52955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_RPAREN,
  [52962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_RPAREN,
  [52969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4881), 1,
      sym_identifier,
  [52976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4883), 1,
      sym_identifier,
  [52983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      aux_sym_preproc_if_token2,
  [52990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_STAR,
  [52997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_RPAREN,
  [53004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4889), 1,
      sym_identifier,
  [53011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4891), 1,
      anon_sym_RBRACK,
  [53018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4893), 1,
      sym_identifier,
  [53025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      sym_identifier,
  [53032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_LPAREN2,
  [53039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 1,
      aux_sym_preproc_if_token2,
  [53046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_SEMI,
  [53053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 1,
      anon_sym_SEMI,
  [53060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      aux_sym_preproc_if_token2,
  [53067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4907), 1,
      aux_sym_preproc_if_token2,
  [53074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      sym_identifier,
  [53081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4911), 1,
      anon_sym_RPAREN,
  [53088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 1,
      sym_identifier,
  [53095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4915), 1,
      sym_identifier,
  [53102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 1,
      sym_identifier,
  [53109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4919), 1,
      aux_sym_preproc_if_token2,
  [53116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 1,
      anon_sym_RPAREN,
  [53123] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4921), 1,
      aux_sym_preproc_include_token2,
  [53130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4923), 1,
      aux_sym_preproc_if_token2,
  [53137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 1,
      anon_sym_LPAREN2,
  [53144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_RPAREN,
  [53151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 1,
      aux_sym_preproc_if_token2,
  [53158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 1,
      anon_sym_RPAREN,
  [53165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4931), 1,
      anon_sym_RBRACK,
  [53172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 1,
      anon_sym_RPAREN,
  [53179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4935), 1,
      anon_sym_SEMI,
  [53186] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4448), 1,
      aux_sym_preproc_include_token2,
  [53193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 1,
      anon_sym_while,
  [53200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_RPAREN,
  [53207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 1,
      ts_builtin_sym_end,
  [53214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4943), 1,
      sym_identifier,
  [53221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      sym_identifier,
  [53228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_SEMI,
  [53235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 1,
      anon_sym_COLON,
  [53242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 1,
      anon_sym_SEMI,
  [53249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 1,
      aux_sym_preproc_if_token2,
  [53256] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(3586), 1,
      aux_sym_preproc_include_token2,
  [53263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_LPAREN2,
  [53270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 1,
      sym_identifier,
  [53277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 1,
      anon_sym_LPAREN2,
  [53284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 1,
      anon_sym_while,
  [53291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4961), 1,
      anon_sym_SEMI,
  [53298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4963), 1,
      anon_sym_RPAREN,
  [53305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 1,
      aux_sym_preproc_if_token2,
  [53312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 1,
      anon_sym_LPAREN2,
  [53319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 1,
      anon_sym_COLON,
  [53326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4971), 1,
      anon_sym_LPAREN2,
  [53333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 1,
      anon_sym_LPAREN2,
  [53340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 1,
      sym_identifier,
  [53347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 1,
      anon_sym_while,
  [53354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4979), 1,
      anon_sym_SEMI,
  [53361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 1,
      anon_sym_SEMI,
  [53368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4983), 1,
      sym_identifier,
  [53375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 1,
      anon_sym_LPAREN2,
  [53382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LPAREN2,
  [53389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3371), 1,
      anon_sym_SEMI,
  [53396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_COLON,
  [53403] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4991), 1,
      aux_sym_preproc_include_token2,
  [53410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 1,
      anon_sym_while,
  [53417] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4995), 1,
      aux_sym_preproc_include_token2,
  [53424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 1,
      sym_identifier,
  [53431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 1,
      anon_sym_RPAREN,
  [53438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 1,
      sym_identifier,
  [53445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 1,
      anon_sym_LPAREN2,
  [53452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN2,
  [53459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 1,
      sym_identifier,
  [53466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5009), 1,
      anon_sym_LPAREN2,
  [53473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_LPAREN2,
  [53480] = 2,
    ACTIONS(3550), 1,
      sym_comment,
    ACTIONS(4324), 1,
      aux_sym_preproc_include_token2,
  [53487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      sym_identifier,
  [53494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 1,
      anon_sym_LPAREN2,
  [53501] = 2,
    ACTIONS(2563), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3550), 1,
      sym_comment,
  [53508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(604)] = 0,
  [SMALL_STATE(605)] = 114,
  [SMALL_STATE(606)] = 224,
  [SMALL_STATE(607)] = 338,
  [SMALL_STATE(608)] = 449,
  [SMALL_STATE(609)] = 557,
  [SMALL_STATE(610)] = 665,
  [SMALL_STATE(611)] = 773,
  [SMALL_STATE(612)] = 881,
  [SMALL_STATE(613)] = 989,
  [SMALL_STATE(614)] = 1097,
  [SMALL_STATE(615)] = 1203,
  [SMALL_STATE(616)] = 1311,
  [SMALL_STATE(617)] = 1419,
  [SMALL_STATE(618)] = 1527,
  [SMALL_STATE(619)] = 1635,
  [SMALL_STATE(620)] = 1743,
  [SMALL_STATE(621)] = 1851,
  [SMALL_STATE(622)] = 1959,
  [SMALL_STATE(623)] = 2067,
  [SMALL_STATE(624)] = 2175,
  [SMALL_STATE(625)] = 2283,
  [SMALL_STATE(626)] = 2389,
  [SMALL_STATE(627)] = 2497,
  [SMALL_STATE(628)] = 2605,
  [SMALL_STATE(629)] = 2713,
  [SMALL_STATE(630)] = 2821,
  [SMALL_STATE(631)] = 2929,
  [SMALL_STATE(632)] = 3037,
  [SMALL_STATE(633)] = 3145,
  [SMALL_STATE(634)] = 3253,
  [SMALL_STATE(635)] = 3356,
  [SMALL_STATE(636)] = 3459,
  [SMALL_STATE(637)] = 3562,
  [SMALL_STATE(638)] = 3665,
  [SMALL_STATE(639)] = 3768,
  [SMALL_STATE(640)] = 3871,
  [SMALL_STATE(641)] = 3976,
  [SMALL_STATE(642)] = 4081,
  [SMALL_STATE(643)] = 4186,
  [SMALL_STATE(644)] = 4291,
  [SMALL_STATE(645)] = 4394,
  [SMALL_STATE(646)] = 4497,
  [SMALL_STATE(647)] = 4610,
  [SMALL_STATE(648)] = 4715,
  [SMALL_STATE(649)] = 4820,
  [SMALL_STATE(650)] = 4923,
  [SMALL_STATE(651)] = 5028,
  [SMALL_STATE(652)] = 5131,
  [SMALL_STATE(653)] = 5231,
  [SMALL_STATE(654)] = 5333,
  [SMALL_STATE(655)] = 5435,
  [SMALL_STATE(656)] = 5535,
  [SMALL_STATE(657)] = 5637,
  [SMALL_STATE(658)] = 5739,
  [SMALL_STATE(659)] = 5841,
  [SMALL_STATE(660)] = 5943,
  [SMALL_STATE(661)] = 6045,
  [SMALL_STATE(662)] = 6147,
  [SMALL_STATE(663)] = 6249,
  [SMALL_STATE(664)] = 6351,
  [SMALL_STATE(665)] = 6453,
  [SMALL_STATE(666)] = 6553,
  [SMALL_STATE(667)] = 6653,
  [SMALL_STATE(668)] = 6755,
  [SMALL_STATE(669)] = 6857,
  [SMALL_STATE(670)] = 6957,
  [SMALL_STATE(671)] = 7057,
  [SMALL_STATE(672)] = 7159,
  [SMALL_STATE(673)] = 7261,
  [SMALL_STATE(674)] = 7361,
  [SMALL_STATE(675)] = 7461,
  [SMALL_STATE(676)] = 7561,
  [SMALL_STATE(677)] = 7661,
  [SMALL_STATE(678)] = 7763,
  [SMALL_STATE(679)] = 7863,
  [SMALL_STATE(680)] = 7963,
  [SMALL_STATE(681)] = 8063,
  [SMALL_STATE(682)] = 8165,
  [SMALL_STATE(683)] = 8267,
  [SMALL_STATE(684)] = 8369,
  [SMALL_STATE(685)] = 8469,
  [SMALL_STATE(686)] = 8569,
  [SMALL_STATE(687)] = 8669,
  [SMALL_STATE(688)] = 8769,
  [SMALL_STATE(689)] = 8869,
  [SMALL_STATE(690)] = 8969,
  [SMALL_STATE(691)] = 9069,
  [SMALL_STATE(692)] = 9169,
  [SMALL_STATE(693)] = 9271,
  [SMALL_STATE(694)] = 9371,
  [SMALL_STATE(695)] = 9471,
  [SMALL_STATE(696)] = 9571,
  [SMALL_STATE(697)] = 9671,
  [SMALL_STATE(698)] = 9771,
  [SMALL_STATE(699)] = 9873,
  [SMALL_STATE(700)] = 9975,
  [SMALL_STATE(701)] = 10077,
  [SMALL_STATE(702)] = 10177,
  [SMALL_STATE(703)] = 10279,
  [SMALL_STATE(704)] = 10381,
  [SMALL_STATE(705)] = 10483,
  [SMALL_STATE(706)] = 10583,
  [SMALL_STATE(707)] = 10685,
  [SMALL_STATE(708)] = 10787,
  [SMALL_STATE(709)] = 10889,
  [SMALL_STATE(710)] = 10991,
  [SMALL_STATE(711)] = 11093,
  [SMALL_STATE(712)] = 11193,
  [SMALL_STATE(713)] = 11295,
  [SMALL_STATE(714)] = 11397,
  [SMALL_STATE(715)] = 11499,
  [SMALL_STATE(716)] = 11599,
  [SMALL_STATE(717)] = 11701,
  [SMALL_STATE(718)] = 11803,
  [SMALL_STATE(719)] = 11903,
  [SMALL_STATE(720)] = 12005,
  [SMALL_STATE(721)] = 12107,
  [SMALL_STATE(722)] = 12209,
  [SMALL_STATE(723)] = 12311,
  [SMALL_STATE(724)] = 12413,
  [SMALL_STATE(725)] = 12515,
  [SMALL_STATE(726)] = 12615,
  [SMALL_STATE(727)] = 12717,
  [SMALL_STATE(728)] = 12819,
  [SMALL_STATE(729)] = 12921,
  [SMALL_STATE(730)] = 13023,
  [SMALL_STATE(731)] = 13125,
  [SMALL_STATE(732)] = 13227,
  [SMALL_STATE(733)] = 13329,
  [SMALL_STATE(734)] = 13431,
  [SMALL_STATE(735)] = 13533,
  [SMALL_STATE(736)] = 13635,
  [SMALL_STATE(737)] = 13737,
  [SMALL_STATE(738)] = 13839,
  [SMALL_STATE(739)] = 13941,
  [SMALL_STATE(740)] = 14042,
  [SMALL_STATE(741)] = 14143,
  [SMALL_STATE(742)] = 14244,
  [SMALL_STATE(743)] = 14345,
  [SMALL_STATE(744)] = 14446,
  [SMALL_STATE(745)] = 14508,
  [SMALL_STATE(746)] = 14570,
  [SMALL_STATE(747)] = 14632,
  [SMALL_STATE(748)] = 14711,
  [SMALL_STATE(749)] = 14776,
  [SMALL_STATE(750)] = 14841,
  [SMALL_STATE(751)] = 14906,
  [SMALL_STATE(752)] = 14998,
  [SMALL_STATE(753)] = 15090,
  [SMALL_STATE(754)] = 15182,
  [SMALL_STATE(755)] = 15274,
  [SMALL_STATE(756)] = 15366,
  [SMALL_STATE(757)] = 15458,
  [SMALL_STATE(758)] = 15550,
  [SMALL_STATE(759)] = 15642,
  [SMALL_STATE(760)] = 15736,
  [SMALL_STATE(761)] = 15828,
  [SMALL_STATE(762)] = 15920,
  [SMALL_STATE(763)] = 16012,
  [SMALL_STATE(764)] = 16104,
  [SMALL_STATE(765)] = 16196,
  [SMALL_STATE(766)] = 16288,
  [SMALL_STATE(767)] = 16380,
  [SMALL_STATE(768)] = 16472,
  [SMALL_STATE(769)] = 16564,
  [SMALL_STATE(770)] = 16656,
  [SMALL_STATE(771)] = 16748,
  [SMALL_STATE(772)] = 16840,
  [SMALL_STATE(773)] = 16932,
  [SMALL_STATE(774)] = 16989,
  [SMALL_STATE(775)] = 17046,
  [SMALL_STATE(776)] = 17137,
  [SMALL_STATE(777)] = 17198,
  [SMALL_STATE(778)] = 17287,
  [SMALL_STATE(779)] = 17376,
  [SMALL_STATE(780)] = 17437,
  [SMALL_STATE(781)] = 17501,
  [SMALL_STATE(782)] = 17556,
  [SMALL_STATE(783)] = 17611,
  [SMALL_STATE(784)] = 17666,
  [SMALL_STATE(785)] = 17721,
  [SMALL_STATE(786)] = 17776,
  [SMALL_STATE(787)] = 17831,
  [SMALL_STATE(788)] = 17886,
  [SMALL_STATE(789)] = 17945,
  [SMALL_STATE(790)] = 18000,
  [SMALL_STATE(791)] = 18055,
  [SMALL_STATE(792)] = 18110,
  [SMALL_STATE(793)] = 18192,
  [SMALL_STATE(794)] = 18274,
  [SMALL_STATE(795)] = 18356,
  [SMALL_STATE(796)] = 18438,
  [SMALL_STATE(797)] = 18520,
  [SMALL_STATE(798)] = 18602,
  [SMALL_STATE(799)] = 18684,
  [SMALL_STATE(800)] = 18766,
  [SMALL_STATE(801)] = 18848,
  [SMALL_STATE(802)] = 18930,
  [SMALL_STATE(803)] = 18995,
  [SMALL_STATE(804)] = 19074,
  [SMALL_STATE(805)] = 19137,
  [SMALL_STATE(806)] = 19200,
  [SMALL_STATE(807)] = 19263,
  [SMALL_STATE(808)] = 19326,
  [SMALL_STATE(809)] = 19379,
  [SMALL_STATE(810)] = 19442,
  [SMALL_STATE(811)] = 19505,
  [SMALL_STATE(812)] = 19557,
  [SMALL_STATE(813)] = 19618,
  [SMALL_STATE(814)] = 19669,
  [SMALL_STATE(815)] = 19720,
  [SMALL_STATE(816)] = 19805,
  [SMALL_STATE(817)] = 19856,
  [SMALL_STATE(818)] = 19907,
  [SMALL_STATE(819)] = 19958,
  [SMALL_STATE(820)] = 20009,
  [SMALL_STATE(821)] = 20060,
  [SMALL_STATE(822)] = 20111,
  [SMALL_STATE(823)] = 20162,
  [SMALL_STATE(824)] = 20223,
  [SMALL_STATE(825)] = 20288,
  [SMALL_STATE(826)] = 20339,
  [SMALL_STATE(827)] = 20390,
  [SMALL_STATE(828)] = 20441,
  [SMALL_STATE(829)] = 20508,
  [SMALL_STATE(830)] = 20559,
  [SMALL_STATE(831)] = 20610,
  [SMALL_STATE(832)] = 20661,
  [SMALL_STATE(833)] = 20712,
  [SMALL_STATE(834)] = 20797,
  [SMALL_STATE(835)] = 20868,
  [SMALL_STATE(836)] = 20927,
  [SMALL_STATE(837)] = 21000,
  [SMALL_STATE(838)] = 21075,
  [SMALL_STATE(839)] = 21152,
  [SMALL_STATE(840)] = 21231,
  [SMALL_STATE(841)] = 21316,
  [SMALL_STATE(842)] = 21397,
  [SMALL_STATE(843)] = 21460,
  [SMALL_STATE(844)] = 21511,
  [SMALL_STATE(845)] = 21562,
  [SMALL_STATE(846)] = 21613,
  [SMALL_STATE(847)] = 21674,
  [SMALL_STATE(848)] = 21725,
  [SMALL_STATE(849)] = 21786,
  [SMALL_STATE(850)] = 21853,
  [SMALL_STATE(851)] = 21904,
  [SMALL_STATE(852)] = 21963,
  [SMALL_STATE(853)] = 22017,
  [SMALL_STATE(854)] = 22066,
  [SMALL_STATE(855)] = 22115,
  [SMALL_STATE(856)] = 22164,
  [SMALL_STATE(857)] = 22213,
  [SMALL_STATE(858)] = 22262,
  [SMALL_STATE(859)] = 22311,
  [SMALL_STATE(860)] = 22360,
  [SMALL_STATE(861)] = 22409,
  [SMALL_STATE(862)] = 22458,
  [SMALL_STATE(863)] = 22507,
  [SMALL_STATE(864)] = 22556,
  [SMALL_STATE(865)] = 22605,
  [SMALL_STATE(866)] = 22654,
  [SMALL_STATE(867)] = 22703,
  [SMALL_STATE(868)] = 22752,
  [SMALL_STATE(869)] = 22801,
  [SMALL_STATE(870)] = 22850,
  [SMALL_STATE(871)] = 22899,
  [SMALL_STATE(872)] = 22978,
  [SMALL_STATE(873)] = 23025,
  [SMALL_STATE(874)] = 23078,
  [SMALL_STATE(875)] = 23125,
  [SMALL_STATE(876)] = 23172,
  [SMALL_STATE(877)] = 23219,
  [SMALL_STATE(878)] = 23274,
  [SMALL_STATE(879)] = 23321,
  [SMALL_STATE(880)] = 23376,
  [SMALL_STATE(881)] = 23423,
  [SMALL_STATE(882)] = 23470,
  [SMALL_STATE(883)] = 23517,
  [SMALL_STATE(884)] = 23572,
  [SMALL_STATE(885)] = 23619,
  [SMALL_STATE(886)] = 23666,
  [SMALL_STATE(887)] = 23713,
  [SMALL_STATE(888)] = 23760,
  [SMALL_STATE(889)] = 23807,
  [SMALL_STATE(890)] = 23854,
  [SMALL_STATE(891)] = 23901,
  [SMALL_STATE(892)] = 23954,
  [SMALL_STATE(893)] = 24001,
  [SMALL_STATE(894)] = 24048,
  [SMALL_STATE(895)] = 24095,
  [SMALL_STATE(896)] = 24142,
  [SMALL_STATE(897)] = 24197,
  [SMALL_STATE(898)] = 24244,
  [SMALL_STATE(899)] = 24299,
  [SMALL_STATE(900)] = 24355,
  [SMALL_STATE(901)] = 24421,
  [SMALL_STATE(902)] = 24483,
  [SMALL_STATE(903)] = 24537,
  [SMALL_STATE(904)] = 24605,
  [SMALL_STATE(905)] = 24665,
  [SMALL_STATE(906)] = 24721,
  [SMALL_STATE(907)] = 24801,
  [SMALL_STATE(908)] = 24881,
  [SMALL_STATE(909)] = 24939,
  [SMALL_STATE(910)] = 24985,
  [SMALL_STATE(911)] = 25031,
  [SMALL_STATE(912)] = 25093,
  [SMALL_STATE(913)] = 25139,
  [SMALL_STATE(914)] = 25209,
  [SMALL_STATE(915)] = 25281,
  [SMALL_STATE(916)] = 25337,
  [SMALL_STATE(917)] = 25383,
  [SMALL_STATE(918)] = 25457,
  [SMALL_STATE(919)] = 25533,
  [SMALL_STATE(920)] = 25589,
  [SMALL_STATE(921)] = 25635,
  [SMALL_STATE(922)] = 25715,
  [SMALL_STATE(923)] = 25764,
  [SMALL_STATE(924)] = 25813,
  [SMALL_STATE(925)] = 25862,
  [SMALL_STATE(926)] = 25907,
  [SMALL_STATE(927)] = 25952,
  [SMALL_STATE(928)] = 25997,
  [SMALL_STATE(929)] = 26046,
  [SMALL_STATE(930)] = 26091,
  [SMALL_STATE(931)] = 26140,
  [SMALL_STATE(932)] = 26185,
  [SMALL_STATE(933)] = 26230,
  [SMALL_STATE(934)] = 26287,
  [SMALL_STATE(935)] = 26336,
  [SMALL_STATE(936)] = 26381,
  [SMALL_STATE(937)] = 26426,
  [SMALL_STATE(938)] = 26471,
  [SMALL_STATE(939)] = 26520,
  [SMALL_STATE(940)] = 26565,
  [SMALL_STATE(941)] = 26610,
  [SMALL_STATE(942)] = 26655,
  [SMALL_STATE(943)] = 26700,
  [SMALL_STATE(944)] = 26749,
  [SMALL_STATE(945)] = 26806,
  [SMALL_STATE(946)] = 26851,
  [SMALL_STATE(947)] = 26896,
  [SMALL_STATE(948)] = 26945,
  [SMALL_STATE(949)] = 26990,
  [SMALL_STATE(950)] = 27035,
  [SMALL_STATE(951)] = 27080,
  [SMALL_STATE(952)] = 27129,
  [SMALL_STATE(953)] = 27174,
  [SMALL_STATE(954)] = 27219,
  [SMALL_STATE(955)] = 27264,
  [SMALL_STATE(956)] = 27309,
  [SMALL_STATE(957)] = 27354,
  [SMALL_STATE(958)] = 27399,
  [SMALL_STATE(959)] = 27444,
  [SMALL_STATE(960)] = 27501,
  [SMALL_STATE(961)] = 27546,
  [SMALL_STATE(962)] = 27591,
  [SMALL_STATE(963)] = 27636,
  [SMALL_STATE(964)] = 27681,
  [SMALL_STATE(965)] = 27726,
  [SMALL_STATE(966)] = 27771,
  [SMALL_STATE(967)] = 27820,
  [SMALL_STATE(968)] = 27869,
  [SMALL_STATE(969)] = 27914,
  [SMALL_STATE(970)] = 27959,
  [SMALL_STATE(971)] = 28004,
  [SMALL_STATE(972)] = 28061,
  [SMALL_STATE(973)] = 28106,
  [SMALL_STATE(974)] = 28151,
  [SMALL_STATE(975)] = 28196,
  [SMALL_STATE(976)] = 28241,
  [SMALL_STATE(977)] = 28290,
  [SMALL_STATE(978)] = 28339,
  [SMALL_STATE(979)] = 28384,
  [SMALL_STATE(980)] = 28433,
  [SMALL_STATE(981)] = 28482,
  [SMALL_STATE(982)] = 28531,
  [SMALL_STATE(983)] = 28576,
  [SMALL_STATE(984)] = 28620,
  [SMALL_STATE(985)] = 28664,
  [SMALL_STATE(986)] = 28708,
  [SMALL_STATE(987)] = 28752,
  [SMALL_STATE(988)] = 28796,
  [SMALL_STATE(989)] = 28840,
  [SMALL_STATE(990)] = 28884,
  [SMALL_STATE(991)] = 28928,
  [SMALL_STATE(992)] = 28972,
  [SMALL_STATE(993)] = 29016,
  [SMALL_STATE(994)] = 29060,
  [SMALL_STATE(995)] = 29104,
  [SMALL_STATE(996)] = 29148,
  [SMALL_STATE(997)] = 29192,
  [SMALL_STATE(998)] = 29236,
  [SMALL_STATE(999)] = 29280,
  [SMALL_STATE(1000)] = 29326,
  [SMALL_STATE(1001)] = 29370,
  [SMALL_STATE(1002)] = 29414,
  [SMALL_STATE(1003)] = 29458,
  [SMALL_STATE(1004)] = 29502,
  [SMALL_STATE(1005)] = 29546,
  [SMALL_STATE(1006)] = 29598,
  [SMALL_STATE(1007)] = 29642,
  [SMALL_STATE(1008)] = 29686,
  [SMALL_STATE(1009)] = 29730,
  [SMALL_STATE(1010)] = 29774,
  [SMALL_STATE(1011)] = 29818,
  [SMALL_STATE(1012)] = 29862,
  [SMALL_STATE(1013)] = 29906,
  [SMALL_STATE(1014)] = 29950,
  [SMALL_STATE(1015)] = 29994,
  [SMALL_STATE(1016)] = 30038,
  [SMALL_STATE(1017)] = 30107,
  [SMALL_STATE(1018)] = 30176,
  [SMALL_STATE(1019)] = 30245,
  [SMALL_STATE(1020)] = 30314,
  [SMALL_STATE(1021)] = 30370,
  [SMALL_STATE(1022)] = 30426,
  [SMALL_STATE(1023)] = 30482,
  [SMALL_STATE(1024)] = 30538,
  [SMALL_STATE(1025)] = 30594,
  [SMALL_STATE(1026)] = 30646,
  [SMALL_STATE(1027)] = 30695,
  [SMALL_STATE(1028)] = 30769,
  [SMALL_STATE(1029)] = 30811,
  [SMALL_STATE(1030)] = 30853,
  [SMALL_STATE(1031)] = 30895,
  [SMALL_STATE(1032)] = 30935,
  [SMALL_STATE(1033)] = 30989,
  [SMALL_STATE(1034)] = 31059,
  [SMALL_STATE(1035)] = 31099,
  [SMALL_STATE(1036)] = 31155,
  [SMALL_STATE(1037)] = 31197,
  [SMALL_STATE(1038)] = 31255,
  [SMALL_STATE(1039)] = 31295,
  [SMALL_STATE(1040)] = 31357,
  [SMALL_STATE(1041)] = 31431,
  [SMALL_STATE(1042)] = 31505,
  [SMALL_STATE(1043)] = 31569,
  [SMALL_STATE(1044)] = 31635,
  [SMALL_STATE(1045)] = 31675,
  [SMALL_STATE(1046)] = 31743,
  [SMALL_STATE(1047)] = 31785,
  [SMALL_STATE(1048)] = 31843,
  [SMALL_STATE(1049)] = 31911,
  [SMALL_STATE(1050)] = 31954,
  [SMALL_STATE(1051)] = 31997,
  [SMALL_STATE(1052)] = 32036,
  [SMALL_STATE(1053)] = 32099,
  [SMALL_STATE(1054)] = 32142,
  [SMALL_STATE(1055)] = 32202,
  [SMALL_STATE(1056)] = 32262,
  [SMALL_STATE(1057)] = 32322,
  [SMALL_STATE(1058)] = 32382,
  [SMALL_STATE(1059)] = 32442,
  [SMALL_STATE(1060)] = 32502,
  [SMALL_STATE(1061)] = 32548,
  [SMALL_STATE(1062)] = 32608,
  [SMALL_STATE(1063)] = 32668,
  [SMALL_STATE(1064)] = 32743,
  [SMALL_STATE(1065)] = 32818,
  [SMALL_STATE(1066)] = 32893,
  [SMALL_STATE(1067)] = 32968,
  [SMALL_STATE(1068)] = 33043,
  [SMALL_STATE(1069)] = 33116,
  [SMALL_STATE(1070)] = 33191,
  [SMALL_STATE(1071)] = 33234,
  [SMALL_STATE(1072)] = 33275,
  [SMALL_STATE(1073)] = 33346,
  [SMALL_STATE(1074)] = 33418,
  [SMALL_STATE(1075)] = 33488,
  [SMALL_STATE(1076)] = 33544,
  [SMALL_STATE(1077)] = 33616,
  [SMALL_STATE(1078)] = 33672,
  [SMALL_STATE(1079)] = 33728,
  [SMALL_STATE(1080)] = 33784,
  [SMALL_STATE(1081)] = 33840,
  [SMALL_STATE(1082)] = 33896,
  [SMALL_STATE(1083)] = 33968,
  [SMALL_STATE(1084)] = 34040,
  [SMALL_STATE(1085)] = 34096,
  [SMALL_STATE(1086)] = 34152,
  [SMALL_STATE(1087)] = 34208,
  [SMALL_STATE(1088)] = 34280,
  [SMALL_STATE(1089)] = 34352,
  [SMALL_STATE(1090)] = 34424,
  [SMALL_STATE(1091)] = 34480,
  [SMALL_STATE(1092)] = 34552,
  [SMALL_STATE(1093)] = 34624,
  [SMALL_STATE(1094)] = 34696,
  [SMALL_STATE(1095)] = 34766,
  [SMALL_STATE(1096)] = 34838,
  [SMALL_STATE(1097)] = 34908,
  [SMALL_STATE(1098)] = 34980,
  [SMALL_STATE(1099)] = 35036,
  [SMALL_STATE(1100)] = 35108,
  [SMALL_STATE(1101)] = 35178,
  [SMALL_STATE(1102)] = 35250,
  [SMALL_STATE(1103)] = 35322,
  [SMALL_STATE(1104)] = 35394,
  [SMALL_STATE(1105)] = 35450,
  [SMALL_STATE(1106)] = 35520,
  [SMALL_STATE(1107)] = 35590,
  [SMALL_STATE(1108)] = 35662,
  [SMALL_STATE(1109)] = 35718,
  [SMALL_STATE(1110)] = 35788,
  [SMALL_STATE(1111)] = 35844,
  [SMALL_STATE(1112)] = 35916,
  [SMALL_STATE(1113)] = 35988,
  [SMALL_STATE(1114)] = 36060,
  [SMALL_STATE(1115)] = 36116,
  [SMALL_STATE(1116)] = 36188,
  [SMALL_STATE(1117)] = 36260,
  [SMALL_STATE(1118)] = 36323,
  [SMALL_STATE(1119)] = 36392,
  [SMALL_STATE(1120)] = 36461,
  [SMALL_STATE(1121)] = 36518,
  [SMALL_STATE(1122)] = 36587,
  [SMALL_STATE(1123)] = 36656,
  [SMALL_STATE(1124)] = 36717,
  [SMALL_STATE(1125)] = 36780,
  [SMALL_STATE(1126)] = 36849,
  [SMALL_STATE(1127)] = 36918,
  [SMALL_STATE(1128)] = 36983,
  [SMALL_STATE(1129)] = 37032,
  [SMALL_STATE(1130)] = 37101,
  [SMALL_STATE(1131)] = 37154,
  [SMALL_STATE(1132)] = 37207,
  [SMALL_STATE(1133)] = 37276,
  [SMALL_STATE(1134)] = 37345,
  [SMALL_STATE(1135)] = 37396,
  [SMALL_STATE(1136)] = 37465,
  [SMALL_STATE(1137)] = 37534,
  [SMALL_STATE(1138)] = 37603,
  [SMALL_STATE(1139)] = 37656,
  [SMALL_STATE(1140)] = 37725,
  [SMALL_STATE(1141)] = 37794,
  [SMALL_STATE(1142)] = 37863,
  [SMALL_STATE(1143)] = 37932,
  [SMALL_STATE(1144)] = 37991,
  [SMALL_STATE(1145)] = 38060,
  [SMALL_STATE(1146)] = 38129,
  [SMALL_STATE(1147)] = 38182,
  [SMALL_STATE(1148)] = 38251,
  [SMALL_STATE(1149)] = 38320,
  [SMALL_STATE(1150)] = 38389,
  [SMALL_STATE(1151)] = 38442,
  [SMALL_STATE(1152)] = 38511,
  [SMALL_STATE(1153)] = 38580,
  [SMALL_STATE(1154)] = 38649,
  [SMALL_STATE(1155)] = 38718,
  [SMALL_STATE(1156)] = 38787,
  [SMALL_STATE(1157)] = 38856,
  [SMALL_STATE(1158)] = 38925,
  [SMALL_STATE(1159)] = 38978,
  [SMALL_STATE(1160)] = 39031,
  [SMALL_STATE(1161)] = 39070,
  [SMALL_STATE(1162)] = 39139,
  [SMALL_STATE(1163)] = 39208,
  [SMALL_STATE(1164)] = 39277,
  [SMALL_STATE(1165)] = 39346,
  [SMALL_STATE(1166)] = 39415,
  [SMALL_STATE(1167)] = 39468,
  [SMALL_STATE(1168)] = 39510,
  [SMALL_STATE(1169)] = 39576,
  [SMALL_STATE(1170)] = 39612,
  [SMALL_STATE(1171)] = 39654,
  [SMALL_STATE(1172)] = 39698,
  [SMALL_STATE(1173)] = 39734,
  [SMALL_STATE(1174)] = 39770,
  [SMALL_STATE(1175)] = 39806,
  [SMALL_STATE(1176)] = 39853,
  [SMALL_STATE(1177)] = 39884,
  [SMALL_STATE(1178)] = 39931,
  [SMALL_STATE(1179)] = 39978,
  [SMALL_STATE(1180)] = 40009,
  [SMALL_STATE(1181)] = 40056,
  [SMALL_STATE(1182)] = 40103,
  [SMALL_STATE(1183)] = 40150,
  [SMALL_STATE(1184)] = 40194,
  [SMALL_STATE(1185)] = 40232,
  [SMALL_STATE(1186)] = 40266,
  [SMALL_STATE(1187)] = 40310,
  [SMALL_STATE(1188)] = 40354,
  [SMALL_STATE(1189)] = 40398,
  [SMALL_STATE(1190)] = 40442,
  [SMALL_STATE(1191)] = 40486,
  [SMALL_STATE(1192)] = 40541,
  [SMALL_STATE(1193)] = 40596,
  [SMALL_STATE(1194)] = 40651,
  [SMALL_STATE(1195)] = 40694,
  [SMALL_STATE(1196)] = 40727,
  [SMALL_STATE(1197)] = 40770,
  [SMALL_STATE(1198)] = 40813,
  [SMALL_STATE(1199)] = 40841,
  [SMALL_STATE(1200)] = 40881,
  [SMALL_STATE(1201)] = 40909,
  [SMALL_STATE(1202)] = 40937,
  [SMALL_STATE(1203)] = 40965,
  [SMALL_STATE(1204)] = 40993,
  [SMALL_STATE(1205)] = 41021,
  [SMALL_STATE(1206)] = 41053,
  [SMALL_STATE(1207)] = 41093,
  [SMALL_STATE(1208)] = 41133,
  [SMALL_STATE(1209)] = 41165,
  [SMALL_STATE(1210)] = 41199,
  [SMALL_STATE(1211)] = 41235,
  [SMALL_STATE(1212)] = 41275,
  [SMALL_STATE(1213)] = 41317,
  [SMALL_STATE(1214)] = 41361,
  [SMALL_STATE(1215)] = 41407,
  [SMALL_STATE(1216)] = 41453,
  [SMALL_STATE(1217)] = 41501,
  [SMALL_STATE(1218)] = 41529,
  [SMALL_STATE(1219)] = 41561,
  [SMALL_STATE(1220)] = 41589,
  [SMALL_STATE(1221)] = 41621,
  [SMALL_STATE(1222)] = 41661,
  [SMALL_STATE(1223)] = 41709,
  [SMALL_STATE(1224)] = 41749,
  [SMALL_STATE(1225)] = 41789,
  [SMALL_STATE(1226)] = 41829,
  [SMALL_STATE(1227)] = 41869,
  [SMALL_STATE(1228)] = 41909,
  [SMALL_STATE(1229)] = 41949,
  [SMALL_STATE(1230)] = 41989,
  [SMALL_STATE(1231)] = 42029,
  [SMALL_STATE(1232)] = 42069,
  [SMALL_STATE(1233)] = 42109,
  [SMALL_STATE(1234)] = 42137,
  [SMALL_STATE(1235)] = 42165,
  [SMALL_STATE(1236)] = 42205,
  [SMALL_STATE(1237)] = 42245,
  [SMALL_STATE(1238)] = 42285,
  [SMALL_STATE(1239)] = 42325,
  [SMALL_STATE(1240)] = 42365,
  [SMALL_STATE(1241)] = 42405,
  [SMALL_STATE(1242)] = 42445,
  [SMALL_STATE(1243)] = 42485,
  [SMALL_STATE(1244)] = 42525,
  [SMALL_STATE(1245)] = 42565,
  [SMALL_STATE(1246)] = 42605,
  [SMALL_STATE(1247)] = 42645,
  [SMALL_STATE(1248)] = 42685,
  [SMALL_STATE(1249)] = 42725,
  [SMALL_STATE(1250)] = 42765,
  [SMALL_STATE(1251)] = 42805,
  [SMALL_STATE(1252)] = 42845,
  [SMALL_STATE(1253)] = 42885,
  [SMALL_STATE(1254)] = 42935,
  [SMALL_STATE(1255)] = 42975,
  [SMALL_STATE(1256)] = 43015,
  [SMALL_STATE(1257)] = 43047,
  [SMALL_STATE(1258)] = 43087,
  [SMALL_STATE(1259)] = 43127,
  [SMALL_STATE(1260)] = 43172,
  [SMALL_STATE(1261)] = 43217,
  [SMALL_STATE(1262)] = 43250,
  [SMALL_STATE(1263)] = 43277,
  [SMALL_STATE(1264)] = 43306,
  [SMALL_STATE(1265)] = 43351,
  [SMALL_STATE(1266)] = 43378,
  [SMALL_STATE(1267)] = 43423,
  [SMALL_STATE(1268)] = 43468,
  [SMALL_STATE(1269)] = 43513,
  [SMALL_STATE(1270)] = 43558,
  [SMALL_STATE(1271)] = 43603,
  [SMALL_STATE(1272)] = 43652,
  [SMALL_STATE(1273)] = 43695,
  [SMALL_STATE(1274)] = 43722,
  [SMALL_STATE(1275)] = 43763,
  [SMALL_STATE(1276)] = 43790,
  [SMALL_STATE(1277)] = 43835,
  [SMALL_STATE(1278)] = 43874,
  [SMALL_STATE(1279)] = 43905,
  [SMALL_STATE(1280)] = 43950,
  [SMALL_STATE(1281)] = 43977,
  [SMALL_STATE(1282)] = 44004,
  [SMALL_STATE(1283)] = 44049,
  [SMALL_STATE(1284)] = 44076,
  [SMALL_STATE(1285)] = 44103,
  [SMALL_STATE(1286)] = 44130,
  [SMALL_STATE(1287)] = 44179,
  [SMALL_STATE(1288)] = 44214,
  [SMALL_STATE(1289)] = 44241,
  [SMALL_STATE(1290)] = 44276,
  [SMALL_STATE(1291)] = 44313,
  [SMALL_STATE(1292)] = 44358,
  [SMALL_STATE(1293)] = 44399,
  [SMALL_STATE(1294)] = 44440,
  [SMALL_STATE(1295)] = 44475,
  [SMALL_STATE(1296)] = 44516,
  [SMALL_STATE(1297)] = 44557,
  [SMALL_STATE(1298)] = 44598,
  [SMALL_STATE(1299)] = 44639,
  [SMALL_STATE(1300)] = 44680,
  [SMALL_STATE(1301)] = 44721,
  [SMALL_STATE(1302)] = 44762,
  [SMALL_STATE(1303)] = 44803,
  [SMALL_STATE(1304)] = 44851,
  [SMALL_STATE(1305)] = 44889,
  [SMALL_STATE(1306)] = 44937,
  [SMALL_STATE(1307)] = 44985,
  [SMALL_STATE(1308)] = 45033,
  [SMALL_STATE(1309)] = 45071,
  [SMALL_STATE(1310)] = 45119,
  [SMALL_STATE(1311)] = 45160,
  [SMALL_STATE(1312)] = 45205,
  [SMALL_STATE(1313)] = 45250,
  [SMALL_STATE(1314)] = 45295,
  [SMALL_STATE(1315)] = 45336,
  [SMALL_STATE(1316)] = 45381,
  [SMALL_STATE(1317)] = 45426,
  [SMALL_STATE(1318)] = 45467,
  [SMALL_STATE(1319)] = 45508,
  [SMALL_STATE(1320)] = 45546,
  [SMALL_STATE(1321)] = 45584,
  [SMALL_STATE(1322)] = 45622,
  [SMALL_STATE(1323)] = 45660,
  [SMALL_STATE(1324)] = 45690,
  [SMALL_STATE(1325)] = 45728,
  [SMALL_STATE(1326)] = 45754,
  [SMALL_STATE(1327)] = 45783,
  [SMALL_STATE(1328)] = 45812,
  [SMALL_STATE(1329)] = 45847,
  [SMALL_STATE(1330)] = 45872,
  [SMALL_STATE(1331)] = 45901,
  [SMALL_STATE(1332)] = 45936,
  [SMALL_STATE(1333)] = 45975,
  [SMALL_STATE(1334)] = 46010,
  [SMALL_STATE(1335)] = 46035,
  [SMALL_STATE(1336)] = 46070,
  [SMALL_STATE(1337)] = 46105,
  [SMALL_STATE(1338)] = 46140,
  [SMALL_STATE(1339)] = 46175,
  [SMALL_STATE(1340)] = 46210,
  [SMALL_STATE(1341)] = 46245,
  [SMALL_STATE(1342)] = 46274,
  [SMALL_STATE(1343)] = 46309,
  [SMALL_STATE(1344)] = 46334,
  [SMALL_STATE(1345)] = 46369,
  [SMALL_STATE(1346)] = 46394,
  [SMALL_STATE(1347)] = 46429,
  [SMALL_STATE(1348)] = 46461,
  [SMALL_STATE(1349)] = 46493,
  [SMALL_STATE(1350)] = 46513,
  [SMALL_STATE(1351)] = 46545,
  [SMALL_STATE(1352)] = 46577,
  [SMALL_STATE(1353)] = 46611,
  [SMALL_STATE(1354)] = 46631,
  [SMALL_STATE(1355)] = 46667,
  [SMALL_STATE(1356)] = 46699,
  [SMALL_STATE(1357)] = 46719,
  [SMALL_STATE(1358)] = 46743,
  [SMALL_STATE(1359)] = 46775,
  [SMALL_STATE(1360)] = 46804,
  [SMALL_STATE(1361)] = 46831,
  [SMALL_STATE(1362)] = 46858,
  [SMALL_STATE(1363)] = 46889,
  [SMALL_STATE(1364)] = 46918,
  [SMALL_STATE(1365)] = 46947,
  [SMALL_STATE(1366)] = 46974,
  [SMALL_STATE(1367)] = 47001,
  [SMALL_STATE(1368)] = 47030,
  [SMALL_STATE(1369)] = 47059,
  [SMALL_STATE(1370)] = 47088,
  [SMALL_STATE(1371)] = 47117,
  [SMALL_STATE(1372)] = 47146,
  [SMALL_STATE(1373)] = 47168,
  [SMALL_STATE(1374)] = 47186,
  [SMALL_STATE(1375)] = 47204,
  [SMALL_STATE(1376)] = 47230,
  [SMALL_STATE(1377)] = 47248,
  [SMALL_STATE(1378)] = 47266,
  [SMALL_STATE(1379)] = 47290,
  [SMALL_STATE(1380)] = 47314,
  [SMALL_STATE(1381)] = 47340,
  [SMALL_STATE(1382)] = 47358,
  [SMALL_STATE(1383)] = 47384,
  [SMALL_STATE(1384)] = 47414,
  [SMALL_STATE(1385)] = 47432,
  [SMALL_STATE(1386)] = 47458,
  [SMALL_STATE(1387)] = 47487,
  [SMALL_STATE(1388)] = 47516,
  [SMALL_STATE(1389)] = 47537,
  [SMALL_STATE(1390)] = 47558,
  [SMALL_STATE(1391)] = 47579,
  [SMALL_STATE(1392)] = 47600,
  [SMALL_STATE(1393)] = 47629,
  [SMALL_STATE(1394)] = 47650,
  [SMALL_STATE(1395)] = 47675,
  [SMALL_STATE(1396)] = 47698,
  [SMALL_STATE(1397)] = 47719,
  [SMALL_STATE(1398)] = 47748,
  [SMALL_STATE(1399)] = 47771,
  [SMALL_STATE(1400)] = 47800,
  [SMALL_STATE(1401)] = 47816,
  [SMALL_STATE(1402)] = 47832,
  [SMALL_STATE(1403)] = 47858,
  [SMALL_STATE(1404)] = 47874,
  [SMALL_STATE(1405)] = 47894,
  [SMALL_STATE(1406)] = 47914,
  [SMALL_STATE(1407)] = 47932,
  [SMALL_STATE(1408)] = 47958,
  [SMALL_STATE(1409)] = 47974,
  [SMALL_STATE(1410)] = 47990,
  [SMALL_STATE(1411)] = 48006,
  [SMALL_STATE(1412)] = 48026,
  [SMALL_STATE(1413)] = 48042,
  [SMALL_STATE(1414)] = 48068,
  [SMALL_STATE(1415)] = 48092,
  [SMALL_STATE(1416)] = 48108,
  [SMALL_STATE(1417)] = 48134,
  [SMALL_STATE(1418)] = 48160,
  [SMALL_STATE(1419)] = 48180,
  [SMALL_STATE(1420)] = 48195,
  [SMALL_STATE(1421)] = 48210,
  [SMALL_STATE(1422)] = 48225,
  [SMALL_STATE(1423)] = 48248,
  [SMALL_STATE(1424)] = 48263,
  [SMALL_STATE(1425)] = 48278,
  [SMALL_STATE(1426)] = 48293,
  [SMALL_STATE(1427)] = 48308,
  [SMALL_STATE(1428)] = 48331,
  [SMALL_STATE(1429)] = 48346,
  [SMALL_STATE(1430)] = 48371,
  [SMALL_STATE(1431)] = 48386,
  [SMALL_STATE(1432)] = 48409,
  [SMALL_STATE(1433)] = 48423,
  [SMALL_STATE(1434)] = 48441,
  [SMALL_STATE(1435)] = 48459,
  [SMALL_STATE(1436)] = 48477,
  [SMALL_STATE(1437)] = 48495,
  [SMALL_STATE(1438)] = 48511,
  [SMALL_STATE(1439)] = 48529,
  [SMALL_STATE(1440)] = 48545,
  [SMALL_STATE(1441)] = 48563,
  [SMALL_STATE(1442)] = 48581,
  [SMALL_STATE(1443)] = 48599,
  [SMALL_STATE(1444)] = 48613,
  [SMALL_STATE(1445)] = 48627,
  [SMALL_STATE(1446)] = 48643,
  [SMALL_STATE(1447)] = 48657,
  [SMALL_STATE(1448)] = 48668,
  [SMALL_STATE(1449)] = 48685,
  [SMALL_STATE(1450)] = 48696,
  [SMALL_STATE(1451)] = 48715,
  [SMALL_STATE(1452)] = 48726,
  [SMALL_STATE(1453)] = 48737,
  [SMALL_STATE(1454)] = 48748,
  [SMALL_STATE(1455)] = 48759,
  [SMALL_STATE(1456)] = 48770,
  [SMALL_STATE(1457)] = 48789,
  [SMALL_STATE(1458)] = 48800,
  [SMALL_STATE(1459)] = 48817,
  [SMALL_STATE(1460)] = 48828,
  [SMALL_STATE(1461)] = 48839,
  [SMALL_STATE(1462)] = 48850,
  [SMALL_STATE(1463)] = 48861,
  [SMALL_STATE(1464)] = 48875,
  [SMALL_STATE(1465)] = 48889,
  [SMALL_STATE(1466)] = 48903,
  [SMALL_STATE(1467)] = 48917,
  [SMALL_STATE(1468)] = 48931,
  [SMALL_STATE(1469)] = 48945,
  [SMALL_STATE(1470)] = 48959,
  [SMALL_STATE(1471)] = 48975,
  [SMALL_STATE(1472)] = 48991,
  [SMALL_STATE(1473)] = 49007,
  [SMALL_STATE(1474)] = 49023,
  [SMALL_STATE(1475)] = 49037,
  [SMALL_STATE(1476)] = 49051,
  [SMALL_STATE(1477)] = 49065,
  [SMALL_STATE(1478)] = 49079,
  [SMALL_STATE(1479)] = 49093,
  [SMALL_STATE(1480)] = 49107,
  [SMALL_STATE(1481)] = 49123,
  [SMALL_STATE(1482)] = 49137,
  [SMALL_STATE(1483)] = 49153,
  [SMALL_STATE(1484)] = 49169,
  [SMALL_STATE(1485)] = 49183,
  [SMALL_STATE(1486)] = 49197,
  [SMALL_STATE(1487)] = 49211,
  [SMALL_STATE(1488)] = 49225,
  [SMALL_STATE(1489)] = 49241,
  [SMALL_STATE(1490)] = 49255,
  [SMALL_STATE(1491)] = 49269,
  [SMALL_STATE(1492)] = 49283,
  [SMALL_STATE(1493)] = 49299,
  [SMALL_STATE(1494)] = 49313,
  [SMALL_STATE(1495)] = 49327,
  [SMALL_STATE(1496)] = 49343,
  [SMALL_STATE(1497)] = 49357,
  [SMALL_STATE(1498)] = 49371,
  [SMALL_STATE(1499)] = 49385,
  [SMALL_STATE(1500)] = 49399,
  [SMALL_STATE(1501)] = 49415,
  [SMALL_STATE(1502)] = 49429,
  [SMALL_STATE(1503)] = 49445,
  [SMALL_STATE(1504)] = 49459,
  [SMALL_STATE(1505)] = 49475,
  [SMALL_STATE(1506)] = 49489,
  [SMALL_STATE(1507)] = 49505,
  [SMALL_STATE(1508)] = 49521,
  [SMALL_STATE(1509)] = 49535,
  [SMALL_STATE(1510)] = 49549,
  [SMALL_STATE(1511)] = 49563,
  [SMALL_STATE(1512)] = 49577,
  [SMALL_STATE(1513)] = 49593,
  [SMALL_STATE(1514)] = 49609,
  [SMALL_STATE(1515)] = 49625,
  [SMALL_STATE(1516)] = 49635,
  [SMALL_STATE(1517)] = 49651,
  [SMALL_STATE(1518)] = 49665,
  [SMALL_STATE(1519)] = 49679,
  [SMALL_STATE(1520)] = 49692,
  [SMALL_STATE(1521)] = 49705,
  [SMALL_STATE(1522)] = 49716,
  [SMALL_STATE(1523)] = 49729,
  [SMALL_STATE(1524)] = 49742,
  [SMALL_STATE(1525)] = 49755,
  [SMALL_STATE(1526)] = 49768,
  [SMALL_STATE(1527)] = 49781,
  [SMALL_STATE(1528)] = 49794,
  [SMALL_STATE(1529)] = 49807,
  [SMALL_STATE(1530)] = 49820,
  [SMALL_STATE(1531)] = 49833,
  [SMALL_STATE(1532)] = 49846,
  [SMALL_STATE(1533)] = 49859,
  [SMALL_STATE(1534)] = 49872,
  [SMALL_STATE(1535)] = 49885,
  [SMALL_STATE(1536)] = 49898,
  [SMALL_STATE(1537)] = 49909,
  [SMALL_STATE(1538)] = 49922,
  [SMALL_STATE(1539)] = 49935,
  [SMALL_STATE(1540)] = 49948,
  [SMALL_STATE(1541)] = 49961,
  [SMALL_STATE(1542)] = 49974,
  [SMALL_STATE(1543)] = 49987,
  [SMALL_STATE(1544)] = 50000,
  [SMALL_STATE(1545)] = 50013,
  [SMALL_STATE(1546)] = 50026,
  [SMALL_STATE(1547)] = 50039,
  [SMALL_STATE(1548)] = 50052,
  [SMALL_STATE(1549)] = 50065,
  [SMALL_STATE(1550)] = 50074,
  [SMALL_STATE(1551)] = 50087,
  [SMALL_STATE(1552)] = 50100,
  [SMALL_STATE(1553)] = 50109,
  [SMALL_STATE(1554)] = 50122,
  [SMALL_STATE(1555)] = 50135,
  [SMALL_STATE(1556)] = 50148,
  [SMALL_STATE(1557)] = 50161,
  [SMALL_STATE(1558)] = 50174,
  [SMALL_STATE(1559)] = 50187,
  [SMALL_STATE(1560)] = 50200,
  [SMALL_STATE(1561)] = 50213,
  [SMALL_STATE(1562)] = 50226,
  [SMALL_STATE(1563)] = 50239,
  [SMALL_STATE(1564)] = 50252,
  [SMALL_STATE(1565)] = 50265,
  [SMALL_STATE(1566)] = 50274,
  [SMALL_STATE(1567)] = 50287,
  [SMALL_STATE(1568)] = 50300,
  [SMALL_STATE(1569)] = 50309,
  [SMALL_STATE(1570)] = 50322,
  [SMALL_STATE(1571)] = 50335,
  [SMALL_STATE(1572)] = 50344,
  [SMALL_STATE(1573)] = 50357,
  [SMALL_STATE(1574)] = 50370,
  [SMALL_STATE(1575)] = 50383,
  [SMALL_STATE(1576)] = 50396,
  [SMALL_STATE(1577)] = 50409,
  [SMALL_STATE(1578)] = 50422,
  [SMALL_STATE(1579)] = 50435,
  [SMALL_STATE(1580)] = 50448,
  [SMALL_STATE(1581)] = 50461,
  [SMALL_STATE(1582)] = 50474,
  [SMALL_STATE(1583)] = 50487,
  [SMALL_STATE(1584)] = 50500,
  [SMALL_STATE(1585)] = 50513,
  [SMALL_STATE(1586)] = 50526,
  [SMALL_STATE(1587)] = 50539,
  [SMALL_STATE(1588)] = 50548,
  [SMALL_STATE(1589)] = 50557,
  [SMALL_STATE(1590)] = 50566,
  [SMALL_STATE(1591)] = 50579,
  [SMALL_STATE(1592)] = 50592,
  [SMALL_STATE(1593)] = 50605,
  [SMALL_STATE(1594)] = 50618,
  [SMALL_STATE(1595)] = 50631,
  [SMALL_STATE(1596)] = 50644,
  [SMALL_STATE(1597)] = 50657,
  [SMALL_STATE(1598)] = 50670,
  [SMALL_STATE(1599)] = 50683,
  [SMALL_STATE(1600)] = 50696,
  [SMALL_STATE(1601)] = 50709,
  [SMALL_STATE(1602)] = 50718,
  [SMALL_STATE(1603)] = 50731,
  [SMALL_STATE(1604)] = 50740,
  [SMALL_STATE(1605)] = 50753,
  [SMALL_STATE(1606)] = 50763,
  [SMALL_STATE(1607)] = 50773,
  [SMALL_STATE(1608)] = 50783,
  [SMALL_STATE(1609)] = 50793,
  [SMALL_STATE(1610)] = 50801,
  [SMALL_STATE(1611)] = 50811,
  [SMALL_STATE(1612)] = 50821,
  [SMALL_STATE(1613)] = 50831,
  [SMALL_STATE(1614)] = 50841,
  [SMALL_STATE(1615)] = 50851,
  [SMALL_STATE(1616)] = 50859,
  [SMALL_STATE(1617)] = 50869,
  [SMALL_STATE(1618)] = 50879,
  [SMALL_STATE(1619)] = 50889,
  [SMALL_STATE(1620)] = 50899,
  [SMALL_STATE(1621)] = 50909,
  [SMALL_STATE(1622)] = 50919,
  [SMALL_STATE(1623)] = 50929,
  [SMALL_STATE(1624)] = 50939,
  [SMALL_STATE(1625)] = 50949,
  [SMALL_STATE(1626)] = 50957,
  [SMALL_STATE(1627)] = 50965,
  [SMALL_STATE(1628)] = 50973,
  [SMALL_STATE(1629)] = 50983,
  [SMALL_STATE(1630)] = 50991,
  [SMALL_STATE(1631)] = 51001,
  [SMALL_STATE(1632)] = 51011,
  [SMALL_STATE(1633)] = 51021,
  [SMALL_STATE(1634)] = 51031,
  [SMALL_STATE(1635)] = 51041,
  [SMALL_STATE(1636)] = 51049,
  [SMALL_STATE(1637)] = 51059,
  [SMALL_STATE(1638)] = 51069,
  [SMALL_STATE(1639)] = 51079,
  [SMALL_STATE(1640)] = 51089,
  [SMALL_STATE(1641)] = 51099,
  [SMALL_STATE(1642)] = 51107,
  [SMALL_STATE(1643)] = 51117,
  [SMALL_STATE(1644)] = 51127,
  [SMALL_STATE(1645)] = 51137,
  [SMALL_STATE(1646)] = 51145,
  [SMALL_STATE(1647)] = 51155,
  [SMALL_STATE(1648)] = 51163,
  [SMALL_STATE(1649)] = 51173,
  [SMALL_STATE(1650)] = 51183,
  [SMALL_STATE(1651)] = 51193,
  [SMALL_STATE(1652)] = 51201,
  [SMALL_STATE(1653)] = 51211,
  [SMALL_STATE(1654)] = 51221,
  [SMALL_STATE(1655)] = 51231,
  [SMALL_STATE(1656)] = 51241,
  [SMALL_STATE(1657)] = 51249,
  [SMALL_STATE(1658)] = 51259,
  [SMALL_STATE(1659)] = 51269,
  [SMALL_STATE(1660)] = 51279,
  [SMALL_STATE(1661)] = 51287,
  [SMALL_STATE(1662)] = 51297,
  [SMALL_STATE(1663)] = 51307,
  [SMALL_STATE(1664)] = 51317,
  [SMALL_STATE(1665)] = 51327,
  [SMALL_STATE(1666)] = 51337,
  [SMALL_STATE(1667)] = 51347,
  [SMALL_STATE(1668)] = 51357,
  [SMALL_STATE(1669)] = 51367,
  [SMALL_STATE(1670)] = 51377,
  [SMALL_STATE(1671)] = 51387,
  [SMALL_STATE(1672)] = 51397,
  [SMALL_STATE(1673)] = 51407,
  [SMALL_STATE(1674)] = 51417,
  [SMALL_STATE(1675)] = 51427,
  [SMALL_STATE(1676)] = 51437,
  [SMALL_STATE(1677)] = 51447,
  [SMALL_STATE(1678)] = 51455,
  [SMALL_STATE(1679)] = 51463,
  [SMALL_STATE(1680)] = 51473,
  [SMALL_STATE(1681)] = 51483,
  [SMALL_STATE(1682)] = 51493,
  [SMALL_STATE(1683)] = 51501,
  [SMALL_STATE(1684)] = 51511,
  [SMALL_STATE(1685)] = 51519,
  [SMALL_STATE(1686)] = 51529,
  [SMALL_STATE(1687)] = 51539,
  [SMALL_STATE(1688)] = 51547,
  [SMALL_STATE(1689)] = 51557,
  [SMALL_STATE(1690)] = 51567,
  [SMALL_STATE(1691)] = 51577,
  [SMALL_STATE(1692)] = 51587,
  [SMALL_STATE(1693)] = 51597,
  [SMALL_STATE(1694)] = 51607,
  [SMALL_STATE(1695)] = 51617,
  [SMALL_STATE(1696)] = 51627,
  [SMALL_STATE(1697)] = 51637,
  [SMALL_STATE(1698)] = 51647,
  [SMALL_STATE(1699)] = 51657,
  [SMALL_STATE(1700)] = 51665,
  [SMALL_STATE(1701)] = 51675,
  [SMALL_STATE(1702)] = 51685,
  [SMALL_STATE(1703)] = 51695,
  [SMALL_STATE(1704)] = 51705,
  [SMALL_STATE(1705)] = 51713,
  [SMALL_STATE(1706)] = 51723,
  [SMALL_STATE(1707)] = 51731,
  [SMALL_STATE(1708)] = 51741,
  [SMALL_STATE(1709)] = 51751,
  [SMALL_STATE(1710)] = 51758,
  [SMALL_STATE(1711)] = 51765,
  [SMALL_STATE(1712)] = 51772,
  [SMALL_STATE(1713)] = 51779,
  [SMALL_STATE(1714)] = 51786,
  [SMALL_STATE(1715)] = 51793,
  [SMALL_STATE(1716)] = 51800,
  [SMALL_STATE(1717)] = 51807,
  [SMALL_STATE(1718)] = 51814,
  [SMALL_STATE(1719)] = 51821,
  [SMALL_STATE(1720)] = 51828,
  [SMALL_STATE(1721)] = 51835,
  [SMALL_STATE(1722)] = 51842,
  [SMALL_STATE(1723)] = 51849,
  [SMALL_STATE(1724)] = 51856,
  [SMALL_STATE(1725)] = 51863,
  [SMALL_STATE(1726)] = 51870,
  [SMALL_STATE(1727)] = 51877,
  [SMALL_STATE(1728)] = 51884,
  [SMALL_STATE(1729)] = 51891,
  [SMALL_STATE(1730)] = 51898,
  [SMALL_STATE(1731)] = 51905,
  [SMALL_STATE(1732)] = 51912,
  [SMALL_STATE(1733)] = 51919,
  [SMALL_STATE(1734)] = 51926,
  [SMALL_STATE(1735)] = 51933,
  [SMALL_STATE(1736)] = 51940,
  [SMALL_STATE(1737)] = 51947,
  [SMALL_STATE(1738)] = 51954,
  [SMALL_STATE(1739)] = 51961,
  [SMALL_STATE(1740)] = 51968,
  [SMALL_STATE(1741)] = 51975,
  [SMALL_STATE(1742)] = 51982,
  [SMALL_STATE(1743)] = 51989,
  [SMALL_STATE(1744)] = 51996,
  [SMALL_STATE(1745)] = 52003,
  [SMALL_STATE(1746)] = 52010,
  [SMALL_STATE(1747)] = 52017,
  [SMALL_STATE(1748)] = 52024,
  [SMALL_STATE(1749)] = 52031,
  [SMALL_STATE(1750)] = 52038,
  [SMALL_STATE(1751)] = 52045,
  [SMALL_STATE(1752)] = 52052,
  [SMALL_STATE(1753)] = 52059,
  [SMALL_STATE(1754)] = 52066,
  [SMALL_STATE(1755)] = 52073,
  [SMALL_STATE(1756)] = 52080,
  [SMALL_STATE(1757)] = 52087,
  [SMALL_STATE(1758)] = 52094,
  [SMALL_STATE(1759)] = 52101,
  [SMALL_STATE(1760)] = 52108,
  [SMALL_STATE(1761)] = 52115,
  [SMALL_STATE(1762)] = 52122,
  [SMALL_STATE(1763)] = 52129,
  [SMALL_STATE(1764)] = 52136,
  [SMALL_STATE(1765)] = 52143,
  [SMALL_STATE(1766)] = 52150,
  [SMALL_STATE(1767)] = 52157,
  [SMALL_STATE(1768)] = 52164,
  [SMALL_STATE(1769)] = 52171,
  [SMALL_STATE(1770)] = 52178,
  [SMALL_STATE(1771)] = 52185,
  [SMALL_STATE(1772)] = 52192,
  [SMALL_STATE(1773)] = 52199,
  [SMALL_STATE(1774)] = 52206,
  [SMALL_STATE(1775)] = 52213,
  [SMALL_STATE(1776)] = 52220,
  [SMALL_STATE(1777)] = 52227,
  [SMALL_STATE(1778)] = 52234,
  [SMALL_STATE(1779)] = 52241,
  [SMALL_STATE(1780)] = 52248,
  [SMALL_STATE(1781)] = 52255,
  [SMALL_STATE(1782)] = 52262,
  [SMALL_STATE(1783)] = 52269,
  [SMALL_STATE(1784)] = 52276,
  [SMALL_STATE(1785)] = 52283,
  [SMALL_STATE(1786)] = 52290,
  [SMALL_STATE(1787)] = 52297,
  [SMALL_STATE(1788)] = 52304,
  [SMALL_STATE(1789)] = 52311,
  [SMALL_STATE(1790)] = 52318,
  [SMALL_STATE(1791)] = 52325,
  [SMALL_STATE(1792)] = 52332,
  [SMALL_STATE(1793)] = 52339,
  [SMALL_STATE(1794)] = 52346,
  [SMALL_STATE(1795)] = 52353,
  [SMALL_STATE(1796)] = 52360,
  [SMALL_STATE(1797)] = 52367,
  [SMALL_STATE(1798)] = 52374,
  [SMALL_STATE(1799)] = 52381,
  [SMALL_STATE(1800)] = 52388,
  [SMALL_STATE(1801)] = 52395,
  [SMALL_STATE(1802)] = 52402,
  [SMALL_STATE(1803)] = 52409,
  [SMALL_STATE(1804)] = 52416,
  [SMALL_STATE(1805)] = 52423,
  [SMALL_STATE(1806)] = 52430,
  [SMALL_STATE(1807)] = 52437,
  [SMALL_STATE(1808)] = 52444,
  [SMALL_STATE(1809)] = 52451,
  [SMALL_STATE(1810)] = 52458,
  [SMALL_STATE(1811)] = 52465,
  [SMALL_STATE(1812)] = 52472,
  [SMALL_STATE(1813)] = 52479,
  [SMALL_STATE(1814)] = 52486,
  [SMALL_STATE(1815)] = 52493,
  [SMALL_STATE(1816)] = 52500,
  [SMALL_STATE(1817)] = 52507,
  [SMALL_STATE(1818)] = 52514,
  [SMALL_STATE(1819)] = 52521,
  [SMALL_STATE(1820)] = 52528,
  [SMALL_STATE(1821)] = 52535,
  [SMALL_STATE(1822)] = 52542,
  [SMALL_STATE(1823)] = 52549,
  [SMALL_STATE(1824)] = 52556,
  [SMALL_STATE(1825)] = 52563,
  [SMALL_STATE(1826)] = 52570,
  [SMALL_STATE(1827)] = 52577,
  [SMALL_STATE(1828)] = 52584,
  [SMALL_STATE(1829)] = 52591,
  [SMALL_STATE(1830)] = 52598,
  [SMALL_STATE(1831)] = 52605,
  [SMALL_STATE(1832)] = 52612,
  [SMALL_STATE(1833)] = 52619,
  [SMALL_STATE(1834)] = 52626,
  [SMALL_STATE(1835)] = 52633,
  [SMALL_STATE(1836)] = 52640,
  [SMALL_STATE(1837)] = 52647,
  [SMALL_STATE(1838)] = 52654,
  [SMALL_STATE(1839)] = 52661,
  [SMALL_STATE(1840)] = 52668,
  [SMALL_STATE(1841)] = 52675,
  [SMALL_STATE(1842)] = 52682,
  [SMALL_STATE(1843)] = 52689,
  [SMALL_STATE(1844)] = 52696,
  [SMALL_STATE(1845)] = 52703,
  [SMALL_STATE(1846)] = 52710,
  [SMALL_STATE(1847)] = 52717,
  [SMALL_STATE(1848)] = 52724,
  [SMALL_STATE(1849)] = 52731,
  [SMALL_STATE(1850)] = 52738,
  [SMALL_STATE(1851)] = 52745,
  [SMALL_STATE(1852)] = 52752,
  [SMALL_STATE(1853)] = 52759,
  [SMALL_STATE(1854)] = 52766,
  [SMALL_STATE(1855)] = 52773,
  [SMALL_STATE(1856)] = 52780,
  [SMALL_STATE(1857)] = 52787,
  [SMALL_STATE(1858)] = 52794,
  [SMALL_STATE(1859)] = 52801,
  [SMALL_STATE(1860)] = 52808,
  [SMALL_STATE(1861)] = 52815,
  [SMALL_STATE(1862)] = 52822,
  [SMALL_STATE(1863)] = 52829,
  [SMALL_STATE(1864)] = 52836,
  [SMALL_STATE(1865)] = 52843,
  [SMALL_STATE(1866)] = 52850,
  [SMALL_STATE(1867)] = 52857,
  [SMALL_STATE(1868)] = 52864,
  [SMALL_STATE(1869)] = 52871,
  [SMALL_STATE(1870)] = 52878,
  [SMALL_STATE(1871)] = 52885,
  [SMALL_STATE(1872)] = 52892,
  [SMALL_STATE(1873)] = 52899,
  [SMALL_STATE(1874)] = 52906,
  [SMALL_STATE(1875)] = 52913,
  [SMALL_STATE(1876)] = 52920,
  [SMALL_STATE(1877)] = 52927,
  [SMALL_STATE(1878)] = 52934,
  [SMALL_STATE(1879)] = 52941,
  [SMALL_STATE(1880)] = 52948,
  [SMALL_STATE(1881)] = 52955,
  [SMALL_STATE(1882)] = 52962,
  [SMALL_STATE(1883)] = 52969,
  [SMALL_STATE(1884)] = 52976,
  [SMALL_STATE(1885)] = 52983,
  [SMALL_STATE(1886)] = 52990,
  [SMALL_STATE(1887)] = 52997,
  [SMALL_STATE(1888)] = 53004,
  [SMALL_STATE(1889)] = 53011,
  [SMALL_STATE(1890)] = 53018,
  [SMALL_STATE(1891)] = 53025,
  [SMALL_STATE(1892)] = 53032,
  [SMALL_STATE(1893)] = 53039,
  [SMALL_STATE(1894)] = 53046,
  [SMALL_STATE(1895)] = 53053,
  [SMALL_STATE(1896)] = 53060,
  [SMALL_STATE(1897)] = 53067,
  [SMALL_STATE(1898)] = 53074,
  [SMALL_STATE(1899)] = 53081,
  [SMALL_STATE(1900)] = 53088,
  [SMALL_STATE(1901)] = 53095,
  [SMALL_STATE(1902)] = 53102,
  [SMALL_STATE(1903)] = 53109,
  [SMALL_STATE(1904)] = 53116,
  [SMALL_STATE(1905)] = 53123,
  [SMALL_STATE(1906)] = 53130,
  [SMALL_STATE(1907)] = 53137,
  [SMALL_STATE(1908)] = 53144,
  [SMALL_STATE(1909)] = 53151,
  [SMALL_STATE(1910)] = 53158,
  [SMALL_STATE(1911)] = 53165,
  [SMALL_STATE(1912)] = 53172,
  [SMALL_STATE(1913)] = 53179,
  [SMALL_STATE(1914)] = 53186,
  [SMALL_STATE(1915)] = 53193,
  [SMALL_STATE(1916)] = 53200,
  [SMALL_STATE(1917)] = 53207,
  [SMALL_STATE(1918)] = 53214,
  [SMALL_STATE(1919)] = 53221,
  [SMALL_STATE(1920)] = 53228,
  [SMALL_STATE(1921)] = 53235,
  [SMALL_STATE(1922)] = 53242,
  [SMALL_STATE(1923)] = 53249,
  [SMALL_STATE(1924)] = 53256,
  [SMALL_STATE(1925)] = 53263,
  [SMALL_STATE(1926)] = 53270,
  [SMALL_STATE(1927)] = 53277,
  [SMALL_STATE(1928)] = 53284,
  [SMALL_STATE(1929)] = 53291,
  [SMALL_STATE(1930)] = 53298,
  [SMALL_STATE(1931)] = 53305,
  [SMALL_STATE(1932)] = 53312,
  [SMALL_STATE(1933)] = 53319,
  [SMALL_STATE(1934)] = 53326,
  [SMALL_STATE(1935)] = 53333,
  [SMALL_STATE(1936)] = 53340,
  [SMALL_STATE(1937)] = 53347,
  [SMALL_STATE(1938)] = 53354,
  [SMALL_STATE(1939)] = 53361,
  [SMALL_STATE(1940)] = 53368,
  [SMALL_STATE(1941)] = 53375,
  [SMALL_STATE(1942)] = 53382,
  [SMALL_STATE(1943)] = 53389,
  [SMALL_STATE(1944)] = 53396,
  [SMALL_STATE(1945)] = 53403,
  [SMALL_STATE(1946)] = 53410,
  [SMALL_STATE(1947)] = 53417,
  [SMALL_STATE(1948)] = 53424,
  [SMALL_STATE(1949)] = 53431,
  [SMALL_STATE(1950)] = 53438,
  [SMALL_STATE(1951)] = 53445,
  [SMALL_STATE(1952)] = 53452,
  [SMALL_STATE(1953)] = 53459,
  [SMALL_STATE(1954)] = 53466,
  [SMALL_STATE(1955)] = 53473,
  [SMALL_STATE(1956)] = 53480,
  [SMALL_STATE(1957)] = 53487,
  [SMALL_STATE(1958)] = 53494,
  [SMALL_STATE(1959)] = 53501,
  [SMALL_STATE(1960)] = 53508,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, .production_id = 42),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, .production_id = 17),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, .production_id = 42),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(568),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1390),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1828),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1254),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1829),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1606),
  [287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(552),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(692),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(692),
  [296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(690),
  [299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(142),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1030),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1084),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(977),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1954),
  [314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1608),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1951),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1051),
  [323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(38),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1005),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(912),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(885),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1006),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1604),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1429),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1456),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1686),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1662),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(660),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1921),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1683),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(425),
  [365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1952),
  [368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(608),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1716),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1714),
  [377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1837),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(699),
  [383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(653),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1935),
  [389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1934),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1932),
  [395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1437),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(821),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1615),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1507),
  [407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(821),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(844),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1605),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1680),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1679),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1748),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1754),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, .production_id = 17),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(569),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1391),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1883),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1248),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1859),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1674),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(197),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1028),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1080),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(928),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(49),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1663),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1643),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(657),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1800),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1661),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(421),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1955),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(624),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1922),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1929),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1865),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1659),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1658),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1657),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1950),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1953),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(575),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1389),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1757),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1255),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1758),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1646),
  [595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(396),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1029),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1098),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(967),
  [607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(48),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1648),
  [615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1685),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(667),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1853),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1650),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(426),
  [630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1907),
  [633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(616),
  [636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1835),
  [639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1847),
  [642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1766),
  [645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1653),
  [648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1654),
  [651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1655),
  [654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1839),
  [657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1731),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1),
  [668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(577),
  [671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1393),
  [674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1898),
  [677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1243),
  [680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1884),
  [683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1705),
  [686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(303),
  [689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1046),
  [692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1078),
  [695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(930),
  [698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(43),
  [701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1644),
  [704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1630),
  [707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(656),
  [710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1730),
  [713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1642),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(289),
  [719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1958),
  [722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(620),
  [725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1787),
  [728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1786),
  [731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1888),
  [734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1640),
  [737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1639),
  [740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1638),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1771),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1770),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(578),
  [842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1396),
  [845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1960),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1221),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1957),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1607),
  [857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(552),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(692),
  [863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(692),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(690),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1036),
  [872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1114),
  [875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(922),
  [878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1954),
  [881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1608),
  [884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1951),
  [887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1051),
  [890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(44),
  [893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1005),
  [896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(912),
  [899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(885),
  [902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1006),
  [905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1604),
  [908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1429),
  [911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1456),
  [914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1611),
  [917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1612),
  [920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(659),
  [923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1944),
  [926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1613),
  [929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(385),
  [932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1941),
  [935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(632),
  [938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1939),
  [941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1938),
  [944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1936),
  [947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(699),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(653),
  [953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1935),
  [956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1934),
  [959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1932),
  [962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1437),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1169),
  [968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1615),
  [971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1507),
  [974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1169),
  [977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(844),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1926),
  [983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1616),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1617),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1619),
  [992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1919),
  [995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1918),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(570),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(552),
  [1008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(692),
  [1011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(692),
  [1014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(690),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(142),
  [1020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1030),
  [1023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1084),
  [1026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(912),
  [1029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1954),
  [1032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1608),
  [1035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1951),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(38),
  [1041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1005),
  [1044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(885),
  [1047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1006),
  [1050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1604),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1429),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1456),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1686),
  [1062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1662),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1683),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(425),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1952),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(608),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1716),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1714),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1837),
  [1086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(699),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(653),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1935),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1934),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1932),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1437),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(821),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1615),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1507),
  [1113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(821),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(844),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1605),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1680),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1679),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1748),
  [1131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1754),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [1138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 9),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 9),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [1144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(573),
  [1147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(197),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1028),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1080),
  [1156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(49),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1663),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1643),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1661),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(421),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1955),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(624),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1922),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1929),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1865),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1659),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1658),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1657),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1950),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1953),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 9),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(572),
  [1218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(274),
  [1221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1036),
  [1224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1114),
  [1227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(44),
  [1230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1611),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1612),
  [1236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1613),
  [1239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(385),
  [1242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1941),
  [1245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(632),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1939),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1938),
  [1254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1936),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1616),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1617),
  [1263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1619),
  [1266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1919),
  [1269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1918),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 9),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(571),
  [1279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(303),
  [1282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1046),
  [1285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1078),
  [1288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(43),
  [1291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1644),
  [1294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1630),
  [1297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1642),
  [1300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(289),
  [1303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1958),
  [1306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(620),
  [1309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1787),
  [1312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1786),
  [1315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1888),
  [1318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1640),
  [1321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1639),
  [1324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1638),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1771),
  [1330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1770),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(576),
  [1338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(396),
  [1341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1029),
  [1344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1098),
  [1347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(48),
  [1350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1648),
  [1353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1685),
  [1356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1650),
  [1359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(426),
  [1362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1907),
  [1365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(616),
  [1368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1835),
  [1371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1847),
  [1374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1766),
  [1377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1653),
  [1380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1654),
  [1383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1655),
  [1386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1839),
  [1389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1731),
  [1392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(574),
  [1395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1707),
  [1398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1698),
  [1401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1925),
  [1404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1610),
  [1407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1700),
  [1410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1696),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_monitor_statement_repeat1, 2),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_monitor_statement_repeat1, 2),
  [1437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_monitor_statement_repeat1, 2), SHIFT_REPEAT(1582),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_monitor_statement, 4, .production_id = 31),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_monitor_statement, 4, .production_id = 31),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_monitor_statement, 3, .production_id = 31),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_monitor_statement, 3, .production_id = 31),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_acquire_statement, 3, .production_id = 31),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_acquire_statement, 3, .production_id = 31),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 26),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 26),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 85),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 85),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, .production_id = 33),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, .production_id = 33),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 27),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 27),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 27),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 27),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, .production_id = 28),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, .production_id = 28),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 119),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 119),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, .production_id = 77),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, .production_id = 77),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 30),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 30),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [1510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_monitor_statement_repeat1, 2), SHIFT_REPEAT(1538),
  [1513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 8),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 8),
  [1517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 77),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 77),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until_statement, 3, .production_id = 27),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until_statement, 3, .production_id = 27),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 81),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 81),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, .production_id = 49),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, .production_id = 49),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stop_statement, 2, .production_id = 10),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 2, .production_id = 10),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_statement, 2, .production_id = 10),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_statement, 2, .production_id = 10),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 56),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 56),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_acquire_statement, 4, .production_id = 31),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_acquire_statement, 4, .production_id = 31),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 49),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 49),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [1581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_monitor_statement_repeat1, 2), SHIFT_REPEAT(1567),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, .production_id = 71),
  [1586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, .production_id = 71),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_monitor_statement_repeat1, 2), SHIFT_REPEAT(1557),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 1, .production_id = 2),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 1, .production_id = 2),
  [1597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, .production_id = 17),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, .production_id = 17),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 17),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 17),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, .production_id = 18),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, .production_id = 18),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, .production_id = 22),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, .production_id = 22),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 73),
  [1621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 73),
  [1623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 42),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 42),
  [1627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 72),
  [1629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 72),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 68),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 68),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 34),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 34),
  [1641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_monitor_statement_repeat1, 2), SHIFT_REPEAT(1591),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, .production_id = 4),
  [1646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, .production_id = 4),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, .production_id = 94),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, .production_id = 94),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, .production_id = 16),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, .production_id = 16),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 67),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 67),
  [1660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 66),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 66),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 5, .production_id = 92),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 5, .production_id = 92),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 17),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 17),
  [1676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 43),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 43),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, .production_id = 42),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, .production_id = 42),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, .production_id = 41),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, .production_id = 41),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, .production_id = 40),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, .production_id = 40),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 3, .production_id = 38),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 3, .production_id = 38),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [1720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(804),
  [1723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(552),
  [1726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(692),
  [1729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(692),
  [1732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(690),
  [1735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(303),
  [1738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1688),
  [1741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(43),
  [1744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1644),
  [1747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1630),
  [1750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(656),
  [1753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1730),
  [1756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1642),
  [1759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(289),
  [1762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1958),
  [1765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(620),
  [1768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1787),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1786),
  [1774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1888),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(699),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(653),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1935),
  [1786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1934),
  [1789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1932),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1437),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(821),
  [1798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1615),
  [1801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1507),
  [1804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(821),
  [1807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(844),
  [1810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1640),
  [1813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1639),
  [1816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1638),
  [1819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1771),
  [1822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1770),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(807),
  [1830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(142),
  [1833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(38),
  [1836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1686),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1662),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(660),
  [1845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1921),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1683),
  [1851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(425),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1952),
  [1857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(608),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1716),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1714),
  [1866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1837),
  [1869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1605),
  [1872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1680),
  [1875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1679),
  [1878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1748),
  [1881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1754),
  [1884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(805),
  [1887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(274),
  [1890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(44),
  [1893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1611),
  [1896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1612),
  [1899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(659),
  [1902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1944),
  [1905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1613),
  [1908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(385),
  [1911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1941),
  [1914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(632),
  [1917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1939),
  [1920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1938),
  [1923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1936),
  [1926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1616),
  [1929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1617),
  [1932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1619),
  [1935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1919),
  [1938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1918),
  [1941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(810),
  [1944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(197),
  [1947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(49),
  [1950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1663),
  [1953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1643),
  [1956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(657),
  [1959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1800),
  [1962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1661),
  [1965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(421),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1955),
  [1971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(624),
  [1974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1922),
  [1977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1929),
  [1980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1865),
  [1983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1659),
  [1986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1658),
  [1989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1657),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1950),
  [1995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1953),
  [1998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(806),
  [2001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(396),
  [2004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(48),
  [2007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1648),
  [2010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1685),
  [2013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(667),
  [2016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1853),
  [2019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1650),
  [2022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(426),
  [2025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1907),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(616),
  [2031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1835),
  [2034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1847),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1766),
  [2040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1653),
  [2043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1654),
  [2046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1655),
  [2049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1839),
  [2052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1731),
  [2055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(809),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1707),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(668),
  [2064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1717),
  [2067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1698),
  [2070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1925),
  [2073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1610),
  [2076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1700),
  [2079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1696),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_task_definition, 4, .production_id = 61),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_task_definition, 4, .production_id = 61),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 1, .production_id = 2),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 1, .production_id = 2),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, .production_id = 58),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [2106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, .production_id = 58),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4),
  [2132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_not_binary, 1),
  [2216] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1), SHIFT(1108),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_not_binary, 1),
  [2222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [2225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 42),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [2318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .production_id = 42),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [2322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(999),
  [2325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1900),
  [2328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1258),
  [2331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1799),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1695),
  [2339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(885),
  [2342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(912),
  [2345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1954),
  [2348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1664),
  [2351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1951),
  [2354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1005),
  [2357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1006),
  [2360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1604),
  [2363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1429),
  [2366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1456),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [2381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1901),
  [2384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1250),
  [2387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1850),
  [2390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1692),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [2419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1902),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1247),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1875),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1690),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 101),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 42),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 84),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 57),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, .production_id = 57),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1858),
  [2466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1207),
  [2469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1767),
  [2472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1621),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3),
  [2535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [2541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(750),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1507),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [2561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [2567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(999),
  [2570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(885),
  [2573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(912),
  [2576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1954),
  [2579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1664),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1951),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2),
  [2587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1005),
  [2590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1006),
  [2593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1604),
  [2596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1429),
  [2599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1456),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 87),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 87),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 104),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 104),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 105),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 105),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 113),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 113),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, .production_id = 59),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, .production_id = 59),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 112),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 112),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 117),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 117),
  [2630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2),
  [2634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(808),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 118),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 118),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, .production_id = 122),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, .production_id = 122),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 88),
  [2647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 88),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [2653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(885),
  [2656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(912),
  [2659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1954),
  [2662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1664),
  [2665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1951),
  [2668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 47),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 47),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 13),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 13),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8),
  [2690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8),
  [2692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 70),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [2716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 70),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 47),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 47),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4),
  [2728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [2730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2),
  [2734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, .production_id = 102),
  [2738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, .production_id = 102),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [2742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [2744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5),
  [2746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5),
  [2748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [2750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 29),
  [2754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 29),
  [2756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [2758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [2760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 12),
  [2762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 12),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 69),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 69),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [2774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9),
  [2778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [2782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 93),
  [2786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 93),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 29),
  [2794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 29),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, .production_id = 58),
  [2798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, .production_id = 58),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1),
  [2802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1),
  [2804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3),
  [2806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3),
  [2808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, .production_id = 5),
  [2810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, .production_id = 5),
  [2812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 39),
  [2814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 39),
  [2816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, .production_id = 9),
  [2818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, .production_id = 9),
  [2820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [2822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [2826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 42),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 42),
  [2832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 43),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 43),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 17),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 17),
  [2840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 33),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 33),
  [2844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 33),
  [2846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 33),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 44),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 44),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 72),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 72),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 42),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 42),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 73),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 73),
  [2864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 17),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 17),
  [2868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 94),
  [2870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 94),
  [2872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 44),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 44),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 2),
  [2888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [2890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_list, 2), REDUCE(sym__old_style_parameter_list, 2),
  [2893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2), REDUCE(sym__old_style_parameter_list, 2),
  [2896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [2898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 7),
  [2900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 7),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 7),
  [2906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 7),
  [2908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 24),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 24),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4),
  [2914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4),
  [2916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 3),
  [2918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [2920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_list, 3), REDUCE(sym__old_style_parameter_list, 3),
  [2923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 3), REDUCE(sym__old_style_parameter_list, 3),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [2928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 54),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 54),
  [2932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 24),
  [2934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 24),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 53),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 53),
  [2972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [2974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [2976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(924),
  [2979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 14),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 14),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 80),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 80),
  [2987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 25),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 25),
  [2991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 3),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 3),
  [2995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 53),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 53),
  [2999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 55),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 55),
  [3003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 14),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 14),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 23),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 23),
  [3011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 3),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 3),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 25),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 25),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 8),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 8),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 8),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 8),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 23),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 23),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 14),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 14),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 6, .production_id = 80),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 6, .production_id = 80),
  [3039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 8),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 8),
  [3043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 7),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 7),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 7),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 7),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 23),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 23),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 7),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 7),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 51),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 51),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 8),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 8),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 15),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 15),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 60),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 60),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 8),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 8),
  [3091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1108),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 53),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 53),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 54),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 54),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 55),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 55),
  [3110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 5, .production_id = 53),
  [3112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 5, .production_id = 53),
  [3114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(996),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [3123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [3125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 25),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 25),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 24),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 24),
  [3137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 23),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 23),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 25),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 25),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [3149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, .production_id = 79),
  [3151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, .production_id = 79),
  [3153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 23),
  [3155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 23),
  [3157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 5),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 5),
  [3161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 24),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 24),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [3189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 7), SHIFT(1954),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 51),
  [3198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 51),
  [3200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 51), SHIFT(1954),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [3235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_parameter_list, 3),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 4),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_parameter_list, 4),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [3243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_declarator, 2, .production_id = 35),
  [3245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_declarator, 2, .production_id = 35),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 79),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 79),
  [3253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 79), SHIFT(1954),
  [3256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 23),
  [3258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 23),
  [3260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 23), SHIFT(1954),
  [3263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 8),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 8),
  [3273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 8), SHIFT(1954),
  [3276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1540),
  [3289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1031),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, .production_id = 46),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [3317] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1108),
  [3321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [3324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(aux_sym__old_style_parameter_list_repeat1, 2),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, .production_id = 109),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 83),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 82),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 108),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, .production_id = 63),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [3375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 100),
  [3379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, .production_id = 78),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 99),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 98),
  [3391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(885),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [3464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [3466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(1179),
  [3469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(1176),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 3),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 14),
  [3484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 14),
  [3490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, .production_id = 3),
  [3492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [3494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [3518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4),
  [3580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2),
  [3588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 13),
  [3592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 13),
  [3594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, .production_id = 14),
  [3596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, .production_id = 14),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, .production_id = 14),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, .production_id = 14),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 29),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 29),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [3612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [3614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, .production_id = 3),
  [3616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, .production_id = 3),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [3620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 44),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [3642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 5),
  [3644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 5),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2),
  [3648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [3686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [3692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, .production_id = 3),
  [3694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, .production_id = 3),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [3744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(924),
  [3747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(983),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [3754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 7), SHIFT(1785),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1, .production_id = 11),
  [3763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, .production_id = 35),
  [3781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, .production_id = 35),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [3785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(1608),
  [3788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [3790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, .dynamic_precedence = 1, .production_id = 106),
  [3792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [3794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, .production_id = 35),
  [3796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, .production_id = 35),
  [3798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [3800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 62),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 4, .production_id = 35),
  [3804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 4, .production_id = 35),
  [3806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [3808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(1954),
  [3811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_declarator_repeat1, 2, .production_id = 32),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [3817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 1, .production_id = 11),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [3825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [3827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2),
  [3829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, .dynamic_precedence = 1, .production_id = 106),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, .production_id = 32),
  [3837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1, .production_id = 62),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [3841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2),
  [3843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 11),
  [3847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 11),
  [3849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 91),
  [3851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 91),
  [3853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1, .production_id = 62),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [3857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [3859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, .production_id = 107),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, .production_id = 107),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [3875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, .production_id = 11),
  [3877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, .production_id = 11),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, .dynamic_precedence = 1, .production_id = 106),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, .production_id = 11),
  [3885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1),
  [3887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1),
  [3889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [3891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2),
  [3893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 32),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, .production_id = 52),
  [3927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, .production_id = 52),
  [3929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 91),
  [3931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 91),
  [3933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, .production_id = 107),
  [3935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, .production_id = 107),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1),
  [3941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, .production_id = 35),
  [3943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, .production_id = 35),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 11),
  [3951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 11),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, .production_id = 11),
  [3955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, .production_id = 11),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 74),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, .production_id = 107),
  [3965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, .production_id = 107),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, .production_id = 11),
  [3969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, .production_id = 11),
  [3971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [3973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 91),
  [3979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 91),
  [3981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [3983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 11),
  [3987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 11),
  [3989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1),
  [3991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [3995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, .production_id = 35),
  [3997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, .production_id = 35),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 21),
  [4003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 21),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 62),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 19),
  [4017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, .production_id = 76),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(714),
  [4026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [4028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1782),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2),
  [4033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2), SHIFT_REPEAT(1515),
  [4036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [4038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 45),
  [4040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 48),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [4044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3),
  [4046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 6),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [4050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 11),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 75),
  [4056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, .production_id = 20),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, .production_id = 35),
  [4062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3),
  [4068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 95),
  [4070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 91),
  [4072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 11),
  [4074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, .production_id = 107),
  [4076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 65), SHIFT_REPEAT(1308),
  [4079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 65),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, .production_id = 86),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, .production_id = 103),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [4115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, .production_id = 65), SHIFT_REPEAT(1363),
  [4118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, .production_id = 65),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, .production_id = 11),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [4134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 3, .production_id = 97),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [4140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [4142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1483),
  [4145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1483),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, .production_id = 115),
  [4152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, .production_id = 103),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, .production_id = 111),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 110), SHIFT_REPEAT(1411),
  [4165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 110),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [4171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [4175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 120), SHIFT_REPEAT(1444),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 120),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [4206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 110), SHIFT_REPEAT(1404),
  [4209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 110),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [4227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, .production_id = 37),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, .production_id = 37),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [4247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [4253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, .production_id = 86),
  [4255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 50),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, .production_id = 6),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2), SHIFT_REPEAT(1701),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [4294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, .production_id = 116),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [4330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2), SHIFT_REPEAT(1085),
  [4333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, .production_id = 114),
  [4339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1632),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 111),
  [4348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(607),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [4359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, .production_id = 121),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2), SHIFT_REPEAT(1227),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [4370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(1684),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [4375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(777),
  [4378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, .production_id = 124),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [4386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, .production_id = 96),
  [4388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 123), SHIFT_REPEAT(1948),
  [4391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 123),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, .production_id = 124),
  [4397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 3, .production_id = 64),
  [4399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_declarator_repeat1, 2, .production_id = 65), SHIFT_REPEAT(1355),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_declarator_repeat1, 2, .production_id = 65),
  [4404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(592),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__old_style_parameter_list_repeat1, 2), SHIFT_REPEAT(1540),
  [4424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__old_style_parameter_list_repeat1, 2),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3),
  [4432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 3, .production_id = 32),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 86),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 2, .production_id = 36),
  [4444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 2, .production_id = 37),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, .production_id = 114),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [4458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 86),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [4474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 116),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2),
  [4480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [4490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), REDUCE(aux_sym__old_style_parameter_list_repeat1, 2),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [4501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [4503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4),
  [4505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [4511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1),
  [4513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_declarator_repeat1, 3, .production_id = 90),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [4519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [4527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [4537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, .production_id = 50),
  [4539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3),
  [4541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3),
  [4543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [4549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [4579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 6),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [4583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, .production_id = 43),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, .production_id = 72),
  [4863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, .production_id = 73),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, .production_id = 94),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [4941] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 72),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [4965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, .production_id = 94),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_nqc(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
