#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2467
#define LARGE_STATE_COUNT 550
#define SYMBOL_COUNT 372
#define ALIAS_COUNT 0
#define TOKEN_COUNT 181
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 37
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 239

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_COLON = 3,
  anon_sym_COMMA = 4,
  aux_sym_asmBody_token1 = 5,
  aux_sym_asmBody_token2 = 6,
  aux_sym_asmBody_token3 = 7,
  anon_sym_LBRACK = 8,
  anon_sym_RBRACK = 9,
  anon_sym_LPAREN = 10,
  anon_sym_RPAREN = 11,
  aux_sym_type_token1 = 12,
  aux_sym_type_token2 = 13,
  aux_sym_type_token3 = 14,
  aux_sym__literalString_token1 = 15,
  anon_sym_POUND = 16,
  aux_sym__literalInt_token1 = 17,
  aux_sym__literalInt_token2 = 18,
  aux_sym__literalFloat_token1 = 19,
  anon_sym_DOT_DOT = 20,
  sym_kProgram = 21,
  sym_kLibrary = 22,
  sym_kUnit = 23,
  sym_kUses = 24,
  sym_kInterface = 25,
  sym_kImplementation = 26,
  sym_kInitialization = 27,
  sym_kFinalization = 28,
  anon_sym_DOT = 29,
  sym_kBegin = 30,
  sym_kEnd = 31,
  sym_kAsm = 32,
  sym_kVar = 33,
  sym_kThreadvar = 34,
  sym_kConst = 35,
  sym_kConstref = 36,
  sym_kResourcestring = 37,
  sym_kOut = 38,
  sym_kType = 39,
  sym_kLabel = 40,
  sym_kExports = 41,
  sym_kAbsolute = 42,
  sym_kProperty = 43,
  sym_kRead = 44,
  sym_kWrite = 45,
  sym_kImplements = 46,
  sym_kDefault = 47,
  sym_kNodefault = 48,
  sym_kStored = 49,
  sym_kIndex = 50,
  sym_kClass = 51,
  sym_kObject = 52,
  sym_kRecord = 53,
  sym_kObjcclass = 54,
  sym_kObjccategory = 55,
  sym_kObjcprotocol = 56,
  sym_kArray = 57,
  sym_kFile = 58,
  sym_kString = 59,
  sym_kSet = 60,
  sym_kOf = 61,
  sym_kHelper = 62,
  sym_kPacked = 63,
  sym_kGeneric = 64,
  sym_kSpecialize = 65,
  sym_kLt = 66,
  sym_kEq = 67,
  sym_kNeq = 68,
  sym_kGt = 69,
  sym_kLte = 70,
  sym_kGte = 71,
  sym_kAdd = 72,
  sym_kSub = 73,
  sym_kMul = 74,
  sym_kFdiv = 75,
  sym_kAt = 76,
  sym_kHat = 77,
  sym_kAssign = 78,
  sym_kAssignAdd = 79,
  sym_kAssignSub = 80,
  sym_kAssignMul = 81,
  sym_kAssignDiv = 82,
  sym_kOr = 83,
  sym_kXor = 84,
  sym_kDiv = 85,
  sym_kMod = 86,
  sym_kAnd = 87,
  sym_kShl = 88,
  sym_kShr = 89,
  sym_kNot = 90,
  sym_kIs = 91,
  sym_kAs = 92,
  sym_kIn = 93,
  sym_kFor = 94,
  sym_kTo = 95,
  sym_kDownto = 96,
  sym_kIf = 97,
  sym_kThen = 98,
  sym_kElse = 99,
  sym_kDo = 100,
  sym_kWhile = 101,
  sym_kRepeat = 102,
  sym_kUntil = 103,
  sym_kTry = 104,
  sym_kExcept = 105,
  sym_kFinally = 106,
  sym_kRaise = 107,
  sym_kOn = 108,
  sym_kCase = 109,
  sym_kWith = 110,
  sym_kGoto = 111,
  sym_kFunction = 112,
  sym_kProcedure = 113,
  sym_kConstructor = 114,
  sym_kDestructor = 115,
  sym_kOperator = 116,
  sym_kReference = 117,
  sym_kPublished = 118,
  sym_kPublic = 119,
  sym_kProtected = 120,
  sym_kPrivate = 121,
  sym_kStrict = 122,
  sym_kRequired = 123,
  sym_kOptional = 124,
  sym_kForward = 125,
  sym_kStatic = 126,
  sym_kVirtual = 127,
  sym_kAbstract = 128,
  sym_kSealed = 129,
  sym_kDynamic = 130,
  sym_kOverride = 131,
  sym_kOverload = 132,
  sym_kReintroduce = 133,
  sym_kInherited = 134,
  sym_kInline = 135,
  sym_kStdcall = 136,
  sym_kCdecl = 137,
  sym_kCppdecl = 138,
  sym_kPascal = 139,
  sym_kRegister = 140,
  sym_kMwpascal = 141,
  sym_kExternal = 142,
  sym_kName = 143,
  sym_kMessage = 144,
  sym_kDeprecated = 145,
  sym_kExperimental = 146,
  sym_kPlatform = 147,
  sym_kUnimplemented = 148,
  sym_kCvar = 149,
  sym_kExport = 150,
  sym_kFar = 151,
  sym_kNear = 152,
  sym_kSafecall = 153,
  sym_kAssembler = 154,
  sym_kNostackframe = 155,
  sym_kInterrupt = 156,
  sym_kNoreturn = 157,
  sym_kIocheck = 158,
  sym_kLocal = 159,
  sym_kHardfloat = 160,
  sym_kSoftfloat = 161,
  sym_kMs_abi_default = 162,
  sym_kMs_abi_cdecl = 163,
  sym_kSaveregisters = 164,
  sym_kSysv_abi_default = 165,
  sym_kSysv_abi_cdecl = 166,
  sym_kVectorcall = 167,
  sym_kVarargs = 168,
  sym_kWinapi = 169,
  sym_kAlias = 170,
  sym_kDelayed = 171,
  sym_kNil = 172,
  sym_kTrue = 173,
  sym_kFalse = 174,
  sym_kIfdef = 175,
  sym_kIfndef = 176,
  sym_kEndif = 177,
  sym__space = 178,
  sym_pp = 179,
  sym_comment = 180,
  sym_root = 181,
  sym_program = 182,
  sym_library = 183,
  sym_unit = 184,
  sym_interface = 185,
  sym_implementation = 186,
  sym_initialization = 187,
  sym_finalization = 188,
  sym_moduleName = 189,
  sym_if = 190,
  sym_ifElse = 191,
  sym_while = 192,
  sym_repeat = 193,
  sym_for = 194,
  sym_foreach = 195,
  sym_exceptionHandler = 196,
  sym_exceptionElse = 197,
  sym_try = 198,
  sym_caseCase = 199,
  sym_case = 200,
  sym_block = 201,
  sym_asm = 202,
  sym_with = 203,
  sym_raise = 204,
  sym_statement = 205,
  sym_goto = 206,
  sym__statement = 207,
  sym_ifTr = 208,
  sym_ifElseTr = 209,
  sym_whileTr = 210,
  sym_repeatTr = 211,
  sym_forTr = 212,
  sym_foreachTr = 213,
  sym_exceptionHandlerTr = 214,
  sym__exceptionHandlersTr = 215,
  sym_tryTr = 216,
  sym_caseCaseTr = 217,
  sym_caseTr = 218,
  sym_blockTr = 219,
  sym_asmTr = 220,
  sym_withTr = 221,
  sym_raiseTr = 222,
  sym_statementTr = 223,
  sym_gotoTr = 224,
  sym__statementTr = 225,
  sym_assignment = 226,
  sym_varAssignDef = 227,
  sym_varDef = 228,
  sym_label = 229,
  sym_caseLabel = 230,
  sym__statementsTr = 231,
  sym_statementsTr = 232,
  sym_asmBody = 233,
  sym__expr = 234,
  sym__ref = 235,
  sym_lambda = 236,
  sym_inherited = 237,
  sym_exprDot = 238,
  sym_exprDeref = 239,
  sym_exprAs = 240,
  sym_exprTpl = 241,
  sym_exprSubscript = 242,
  sym_exprCall = 243,
  sym_legacyFormat = 244,
  sym_exprArgs = 245,
  sym_exprBinary = 246,
  sym_exprUnary = 247,
  sym_exprParens = 248,
  sym_exprBrackets = 249,
  sym_type = 250,
  sym_typeref = 251,
  sym__typeref = 252,
  sym_typerefDot = 253,
  sym_typerefTpl = 254,
  sym_typerefPtr = 255,
  sym_typerefArgs = 256,
  sym_genericDot = 257,
  sym_genericTpl = 258,
  sym__genericName = 259,
  sym_genericArgs = 260,
  sym_genericArg = 261,
  sym__literal = 262,
  sym_literalString = 263,
  sym__literalString = 264,
  sym_literalChar = 265,
  sym_literalNumber = 266,
  sym__literalInt = 267,
  sym__literalFloat = 268,
  sym_range = 269,
  aux_sym__definitions = 270,
  sym__definition = 271,
  sym_defProc = 272,
  sym_declProcFwd = 273,
  sym__visibility = 274,
  aux_sym__declarations = 275,
  aux_sym__classDeclarations = 276,
  sym_defaultValue = 277,
  sym_declUses = 278,
  sym_declExports = 279,
  sym_declTypes = 280,
  sym_declVars = 281,
  sym_declConsts = 282,
  sym_declType = 283,
  sym_declProc = 284,
  sym_declVar = 285,
  sym_declConst = 286,
  sym_declLabels = 287,
  sym_declLabel = 288,
  sym_declExport = 289,
  sym_declEnum = 290,
  sym_declEnumValue = 291,
  sym_declSet = 292,
  sym_declArray = 293,
  sym_declFile = 294,
  sym_declString = 295,
  sym_declProcRef = 296,
  sym_declMetaClass = 297,
  sym_declClass = 298,
  sym_declIntf = 299,
  sym_declHelper = 300,
  sym_guid = 301,
  sym__declClass = 302,
  sym_declSection = 303,
  aux_sym__declFields = 304,
  sym_declField = 305,
  sym_declProp = 306,
  sym_declPropArgs = 307,
  sym_declVariant = 308,
  sym_declVariantClause = 309,
  sym_declVariantField = 310,
  sym__declProc = 311,
  sym__declOperator = 312,
  sym_operatorDot = 313,
  sym__operatorName = 314,
  sym_operatorName = 315,
  sym_declArgs = 316,
  sym_declArg = 317,
  sym__procAttribute = 318,
  sym__procAttributeNoExt = 319,
  sym_procAttribute = 320,
  sym_rttiAttributes = 321,
  sym_procExternal = 322,
  sym__initializer = 323,
  sym_recInitializer = 324,
  sym_recInitializerField = 325,
  sym_arrInitializer = 326,
  sym_kEndDot = 327,
  sym_kDot = 328,
  aux_sym_unit_repeat1 = 329,
  aux_sym_moduleName_repeat1 = 330,
  aux_sym_exceptionElse_repeat1 = 331,
  aux_sym__exceptionHandlers_repeat1 = 332,
  aux_sym_case_repeat1 = 333,
  aux_sym_with_repeat1 = 334,
  aux_sym_caseLabel_repeat1 = 335,
  aux_sym__statementsTr_repeat1 = 336,
  aux_sym_asmBody_repeat1 = 337,
  aux_sym_exprTpl_repeat1 = 338,
  aux_sym_legacyFormat_repeat1 = 339,
  aux_sym_exprArgs_repeat1 = 340,
  aux_sym_type_repeat1 = 341,
  aux_sym_typerefArgs_repeat1 = 342,
  aux_sym_genericArgs_repeat1 = 343,
  aux_sym_genericArg_repeat1 = 344,
  aux_sym_literalString_repeat1 = 345,
  aux_sym_defProc_repeat1 = 346,
  aux_sym_declProcFwd_repeat1 = 347,
  aux_sym_declUses_repeat1 = 348,
  aux_sym_declExports_repeat1 = 349,
  aux_sym_declTypes_repeat1 = 350,
  aux_sym_declVars_repeat1 = 351,
  aux_sym_declConsts_repeat1 = 352,
  aux_sym_declVar_repeat1 = 353,
  aux_sym_declLabels_repeat1 = 354,
  aux_sym_declExport_repeat1 = 355,
  aux_sym_declEnum_repeat1 = 356,
  aux_sym_declArray_repeat1 = 357,
  aux_sym_declClass_repeat1 = 358,
  aux_sym__declClass_repeat1 = 359,
  aux_sym_declProp_repeat1 = 360,
  aux_sym_declProp_repeat2 = 361,
  aux_sym_declPropArgs_repeat1 = 362,
  aux_sym_declVariant_repeat1 = 363,
  aux_sym_declVariantClause_repeat1 = 364,
  aux_sym__declProc_repeat1 = 365,
  aux_sym__procAttribute_repeat1 = 366,
  aux_sym__procAttributeNoExt_repeat1 = 367,
  aux_sym_rttiAttributes_repeat1 = 368,
  aux_sym_rttiAttributes_repeat2 = 369,
  aux_sym_recInitializer_repeat1 = 370,
  aux_sym_arrInitializer_repeat1 = 371,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA] = ",",
  [aux_sym_asmBody_token1] = "asmBody_token1",
  [aux_sym_asmBody_token2] = "asmBody_token2",
  [aux_sym_asmBody_token3] = "asmBody_token3",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [aux_sym_type_token1] = "pp",
  [aux_sym_type_token2] = "pp",
  [aux_sym_type_token3] = "pp",
  [aux_sym__literalString_token1] = "_literalString_token1",
  [anon_sym_POUND] = "#",
  [aux_sym__literalInt_token1] = "_literalInt_token1",
  [aux_sym__literalInt_token2] = "_literalInt_token2",
  [aux_sym__literalFloat_token1] = "_literalFloat_token1",
  [anon_sym_DOT_DOT] = "..",
  [sym_kProgram] = "kProgram",
  [sym_kLibrary] = "kLibrary",
  [sym_kUnit] = "kUnit",
  [sym_kUses] = "kUses",
  [sym_kInterface] = "kInterface",
  [sym_kImplementation] = "kImplementation",
  [sym_kInitialization] = "kInitialization",
  [sym_kFinalization] = "kFinalization",
  [anon_sym_DOT] = ".",
  [sym_kBegin] = "kBegin",
  [sym_kEnd] = "kEnd",
  [sym_kAsm] = "kAsm",
  [sym_kVar] = "kVar",
  [sym_kThreadvar] = "kThreadvar",
  [sym_kConst] = "kConst",
  [sym_kConstref] = "kConstref",
  [sym_kResourcestring] = "kResourcestring",
  [sym_kOut] = "kOut",
  [sym_kType] = "kType",
  [sym_kLabel] = "kLabel",
  [sym_kExports] = "kExports",
  [sym_kAbsolute] = "kAbsolute",
  [sym_kProperty] = "kProperty",
  [sym_kRead] = "kRead",
  [sym_kWrite] = "kWrite",
  [sym_kImplements] = "kImplements",
  [sym_kDefault] = "kDefault",
  [sym_kNodefault] = "kNodefault",
  [sym_kStored] = "kStored",
  [sym_kIndex] = "kIndex",
  [sym_kClass] = "kClass",
  [sym_kObject] = "kObject",
  [sym_kRecord] = "kRecord",
  [sym_kObjcclass] = "kObjcclass",
  [sym_kObjccategory] = "kObjccategory",
  [sym_kObjcprotocol] = "kObjcprotocol",
  [sym_kArray] = "kArray",
  [sym_kFile] = "kFile",
  [sym_kString] = "kString",
  [sym_kSet] = "kSet",
  [sym_kOf] = "kOf",
  [sym_kHelper] = "kHelper",
  [sym_kPacked] = "kPacked",
  [sym_kGeneric] = "kGeneric",
  [sym_kSpecialize] = "kSpecialize",
  [sym_kLt] = "kLt",
  [sym_kEq] = "kEq",
  [sym_kNeq] = "kNeq",
  [sym_kGt] = "kGt",
  [sym_kLte] = "kLte",
  [sym_kGte] = "kGte",
  [sym_kAdd] = "kAdd",
  [sym_kSub] = "kSub",
  [sym_kMul] = "kMul",
  [sym_kFdiv] = "kFdiv",
  [sym_kAt] = "kAt",
  [sym_kHat] = "kHat",
  [sym_kAssign] = "kAssign",
  [sym_kAssignAdd] = "kAssignAdd",
  [sym_kAssignSub] = "kAssignSub",
  [sym_kAssignMul] = "kAssignMul",
  [sym_kAssignDiv] = "kAssignDiv",
  [sym_kOr] = "kOr",
  [sym_kXor] = "kXor",
  [sym_kDiv] = "kDiv",
  [sym_kMod] = "kMod",
  [sym_kAnd] = "kAnd",
  [sym_kShl] = "kShl",
  [sym_kShr] = "kShr",
  [sym_kNot] = "kNot",
  [sym_kIs] = "kIs",
  [sym_kAs] = "kAs",
  [sym_kIn] = "kIn",
  [sym_kFor] = "kFor",
  [sym_kTo] = "kTo",
  [sym_kDownto] = "kDownto",
  [sym_kIf] = "kIf",
  [sym_kThen] = "kThen",
  [sym_kElse] = "kElse",
  [sym_kDo] = "kDo",
  [sym_kWhile] = "kWhile",
  [sym_kRepeat] = "kRepeat",
  [sym_kUntil] = "kUntil",
  [sym_kTry] = "kTry",
  [sym_kExcept] = "kExcept",
  [sym_kFinally] = "kFinally",
  [sym_kRaise] = "kRaise",
  [sym_kOn] = "kOn",
  [sym_kCase] = "kCase",
  [sym_kWith] = "kWith",
  [sym_kGoto] = "kGoto",
  [sym_kFunction] = "kFunction",
  [sym_kProcedure] = "kProcedure",
  [sym_kConstructor] = "kConstructor",
  [sym_kDestructor] = "kDestructor",
  [sym_kOperator] = "kOperator",
  [sym_kReference] = "kReference",
  [sym_kPublished] = "kPublished",
  [sym_kPublic] = "kPublic",
  [sym_kProtected] = "kProtected",
  [sym_kPrivate] = "kPrivate",
  [sym_kStrict] = "kStrict",
  [sym_kRequired] = "kRequired",
  [sym_kOptional] = "kOptional",
  [sym_kForward] = "kForward",
  [sym_kStatic] = "kStatic",
  [sym_kVirtual] = "kVirtual",
  [sym_kAbstract] = "kAbstract",
  [sym_kSealed] = "kSealed",
  [sym_kDynamic] = "kDynamic",
  [sym_kOverride] = "kOverride",
  [sym_kOverload] = "kOverload",
  [sym_kReintroduce] = "kReintroduce",
  [sym_kInherited] = "kInherited",
  [sym_kInline] = "kInline",
  [sym_kStdcall] = "kStdcall",
  [sym_kCdecl] = "kCdecl",
  [sym_kCppdecl] = "kCppdecl",
  [sym_kPascal] = "kPascal",
  [sym_kRegister] = "kRegister",
  [sym_kMwpascal] = "kMwpascal",
  [sym_kExternal] = "kExternal",
  [sym_kName] = "kName",
  [sym_kMessage] = "kMessage",
  [sym_kDeprecated] = "kDeprecated",
  [sym_kExperimental] = "kExperimental",
  [sym_kPlatform] = "kPlatform",
  [sym_kUnimplemented] = "kUnimplemented",
  [sym_kCvar] = "kCvar",
  [sym_kExport] = "kExport",
  [sym_kFar] = "kFar",
  [sym_kNear] = "kNear",
  [sym_kSafecall] = "kSafecall",
  [sym_kAssembler] = "kAssembler",
  [sym_kNostackframe] = "kNostackframe",
  [sym_kInterrupt] = "kInterrupt",
  [sym_kNoreturn] = "kNoreturn",
  [sym_kIocheck] = "kIocheck",
  [sym_kLocal] = "kLocal",
  [sym_kHardfloat] = "kHardfloat",
  [sym_kSoftfloat] = "kSoftfloat",
  [sym_kMs_abi_default] = "kMs_abi_default",
  [sym_kMs_abi_cdecl] = "kMs_abi_cdecl",
  [sym_kSaveregisters] = "kSaveregisters",
  [sym_kSysv_abi_default] = "kSysv_abi_default",
  [sym_kSysv_abi_cdecl] = "kSysv_abi_cdecl",
  [sym_kVectorcall] = "kVectorcall",
  [sym_kVarargs] = "kVarargs",
  [sym_kWinapi] = "kWinapi",
  [sym_kAlias] = "kAlias",
  [sym_kDelayed] = "kDelayed",
  [sym_kNil] = "kNil",
  [sym_kTrue] = "kTrue",
  [sym_kFalse] = "kFalse",
  [sym_kIfdef] = "kIfdef",
  [sym_kIfndef] = "kIfndef",
  [sym_kEndif] = "kEndif",
  [sym__space] = "_space",
  [sym_pp] = "pp",
  [sym_comment] = "comment",
  [sym_root] = "root",
  [sym_program] = "program",
  [sym_library] = "library",
  [sym_unit] = "unit",
  [sym_interface] = "interface",
  [sym_implementation] = "implementation",
  [sym_initialization] = "initialization",
  [sym_finalization] = "finalization",
  [sym_moduleName] = "moduleName",
  [sym_if] = "if",
  [sym_ifElse] = "ifElse",
  [sym_while] = "while",
  [sym_repeat] = "repeat",
  [sym_for] = "for",
  [sym_foreach] = "foreach",
  [sym_exceptionHandler] = "exceptionHandler",
  [sym_exceptionElse] = "exceptionElse",
  [sym_try] = "try",
  [sym_caseCase] = "caseCase",
  [sym_case] = "case",
  [sym_block] = "block",
  [sym_asm] = "asm",
  [sym_with] = "with",
  [sym_raise] = "raise",
  [sym_statement] = "statement",
  [sym_goto] = "goto",
  [sym__statement] = "_statement",
  [sym_ifTr] = "if",
  [sym_ifElseTr] = "ifElse",
  [sym_whileTr] = "while",
  [sym_repeatTr] = "repeat",
  [sym_forTr] = "for",
  [sym_foreachTr] = "foreach",
  [sym_exceptionHandlerTr] = "exceptionHandler",
  [sym__exceptionHandlersTr] = "_exceptionHandlersTr",
  [sym_tryTr] = "try",
  [sym_caseCaseTr] = "caseCase",
  [sym_caseTr] = "case",
  [sym_blockTr] = "blockTr",
  [sym_asmTr] = "asm",
  [sym_withTr] = "with",
  [sym_raiseTr] = "raise",
  [sym_statementTr] = "statement",
  [sym_gotoTr] = "goto",
  [sym__statementTr] = "_statementTr",
  [sym_assignment] = "assignment",
  [sym_varAssignDef] = "varAssignDef",
  [sym_varDef] = "varDef",
  [sym_label] = "label",
  [sym_caseLabel] = "caseLabel",
  [sym__statementsTr] = "_statementsTr",
  [sym_statementsTr] = "statements",
  [sym_asmBody] = "asmBody",
  [sym__expr] = "_expr",
  [sym__ref] = "_ref",
  [sym_lambda] = "lambda",
  [sym_inherited] = "inherited",
  [sym_exprDot] = "exprDot",
  [sym_exprDeref] = "exprUnary",
  [sym_exprAs] = "exprBinary",
  [sym_exprTpl] = "exprTpl",
  [sym_exprSubscript] = "exprSubscript",
  [sym_exprCall] = "exprCall",
  [sym_legacyFormat] = "legacyFormat",
  [sym_exprArgs] = "exprArgs",
  [sym_exprBinary] = "exprBinary",
  [sym_exprUnary] = "exprUnary",
  [sym_exprParens] = "exprParens",
  [sym_exprBrackets] = "exprBrackets",
  [sym_type] = "type",
  [sym_typeref] = "typeref",
  [sym__typeref] = "_typeref",
  [sym_typerefDot] = "typerefDot",
  [sym_typerefTpl] = "typerefTpl",
  [sym_typerefPtr] = "typerefPtr",
  [sym_typerefArgs] = "typerefArgs",
  [sym_genericDot] = "genericDot",
  [sym_genericTpl] = "genericTpl",
  [sym__genericName] = "_genericName",
  [sym_genericArgs] = "genericArgs",
  [sym_genericArg] = "genericArg",
  [sym__literal] = "_literal",
  [sym_literalString] = "literalString",
  [sym__literalString] = "_literalString",
  [sym_literalChar] = "literalChar",
  [sym_literalNumber] = "literalNumber",
  [sym__literalInt] = "_literalInt",
  [sym__literalFloat] = "_literalFloat",
  [sym_range] = "range",
  [aux_sym__definitions] = "_definitions",
  [sym__definition] = "_definition",
  [sym_defProc] = "defProc",
  [sym_declProcFwd] = "declProc",
  [sym__visibility] = "_visibility",
  [aux_sym__declarations] = "_declarations",
  [aux_sym__classDeclarations] = "_classDeclarations",
  [sym_defaultValue] = "defaultValue",
  [sym_declUses] = "declUses",
  [sym_declExports] = "declExports",
  [sym_declTypes] = "declTypes",
  [sym_declVars] = "declVars",
  [sym_declConsts] = "declConsts",
  [sym_declType] = "declType",
  [sym_declProc] = "declProc",
  [sym_declVar] = "declVar",
  [sym_declConst] = "declConst",
  [sym_declLabels] = "declLabels",
  [sym_declLabel] = "declLabel",
  [sym_declExport] = "declExport",
  [sym_declEnum] = "declEnum",
  [sym_declEnumValue] = "declEnumValue",
  [sym_declSet] = "declSet",
  [sym_declArray] = "declArray",
  [sym_declFile] = "declFile",
  [sym_declString] = "declString",
  [sym_declProcRef] = "declProcRef",
  [sym_declMetaClass] = "declMetaClass",
  [sym_declClass] = "declClass",
  [sym_declIntf] = "declIntf",
  [sym_declHelper] = "declHelper",
  [sym_guid] = "guid",
  [sym__declClass] = "_declClass",
  [sym_declSection] = "declSection",
  [aux_sym__declFields] = "_declFields",
  [sym_declField] = "declField",
  [sym_declProp] = "declProp",
  [sym_declPropArgs] = "declPropArgs",
  [sym_declVariant] = "declVariant",
  [sym_declVariantClause] = "declVariantClause",
  [sym_declVariantField] = "declField",
  [sym__declProc] = "_declProc",
  [sym__declOperator] = "_declOperator",
  [sym_operatorDot] = "genericDot",
  [sym__operatorName] = "_operatorName",
  [sym_operatorName] = "operatorName",
  [sym_declArgs] = "declArgs",
  [sym_declArg] = "declArg",
  [sym__procAttribute] = "_procAttribute",
  [sym__procAttributeNoExt] = "_procAttributeNoExt",
  [sym_procAttribute] = "procAttribute",
  [sym_rttiAttributes] = "rttiAttributes",
  [sym_procExternal] = "procExternal",
  [sym__initializer] = "_initializer",
  [sym_recInitializer] = "recInitializer",
  [sym_recInitializerField] = "recInitializerField",
  [sym_arrInitializer] = "arrInitializer",
  [sym_kEndDot] = "kEndDot",
  [sym_kDot] = "kDot",
  [aux_sym_unit_repeat1] = "unit_repeat1",
  [aux_sym_moduleName_repeat1] = "moduleName_repeat1",
  [aux_sym_exceptionElse_repeat1] = "exceptionElse_repeat1",
  [aux_sym__exceptionHandlers_repeat1] = "_exceptionHandlers_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_with_repeat1] = "with_repeat1",
  [aux_sym_caseLabel_repeat1] = "caseLabel_repeat1",
  [aux_sym__statementsTr_repeat1] = "_statementsTr_repeat1",
  [aux_sym_asmBody_repeat1] = "asmBody_repeat1",
  [aux_sym_exprTpl_repeat1] = "exprTpl_repeat1",
  [aux_sym_legacyFormat_repeat1] = "legacyFormat_repeat1",
  [aux_sym_exprArgs_repeat1] = "exprArgs_repeat1",
  [aux_sym_type_repeat1] = "type_repeat1",
  [aux_sym_typerefArgs_repeat1] = "typerefArgs_repeat1",
  [aux_sym_genericArgs_repeat1] = "genericArgs_repeat1",
  [aux_sym_genericArg_repeat1] = "genericArg_repeat1",
  [aux_sym_literalString_repeat1] = "literalString_repeat1",
  [aux_sym_defProc_repeat1] = "defProc_repeat1",
  [aux_sym_declProcFwd_repeat1] = "declProcFwd_repeat1",
  [aux_sym_declUses_repeat1] = "declUses_repeat1",
  [aux_sym_declExports_repeat1] = "declExports_repeat1",
  [aux_sym_declTypes_repeat1] = "declTypes_repeat1",
  [aux_sym_declVars_repeat1] = "declVars_repeat1",
  [aux_sym_declConsts_repeat1] = "declConsts_repeat1",
  [aux_sym_declVar_repeat1] = "declVar_repeat1",
  [aux_sym_declLabels_repeat1] = "declLabels_repeat1",
  [aux_sym_declExport_repeat1] = "declExport_repeat1",
  [aux_sym_declEnum_repeat1] = "declEnum_repeat1",
  [aux_sym_declArray_repeat1] = "declArray_repeat1",
  [aux_sym_declClass_repeat1] = "declClass_repeat1",
  [aux_sym__declClass_repeat1] = "_declClass_repeat1",
  [aux_sym_declProp_repeat1] = "declProp_repeat1",
  [aux_sym_declProp_repeat2] = "declProp_repeat2",
  [aux_sym_declPropArgs_repeat1] = "declPropArgs_repeat1",
  [aux_sym_declVariant_repeat1] = "declVariant_repeat1",
  [aux_sym_declVariantClause_repeat1] = "declVariantClause_repeat1",
  [aux_sym__declProc_repeat1] = "_declProc_repeat1",
  [aux_sym__procAttribute_repeat1] = "_procAttribute_repeat1",
  [aux_sym__procAttributeNoExt_repeat1] = "_procAttributeNoExt_repeat1",
  [aux_sym_rttiAttributes_repeat1] = "rttiAttributes_repeat1",
  [aux_sym_rttiAttributes_repeat2] = "rttiAttributes_repeat2",
  [aux_sym_recInitializer_repeat1] = "recInitializer_repeat1",
  [aux_sym_arrInitializer_repeat1] = "arrInitializer_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_asmBody_token1] = aux_sym_asmBody_token1,
  [aux_sym_asmBody_token2] = aux_sym_asmBody_token2,
  [aux_sym_asmBody_token3] = aux_sym_asmBody_token3,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_type_token1] = sym_pp,
  [aux_sym_type_token2] = sym_pp,
  [aux_sym_type_token3] = sym_pp,
  [aux_sym__literalString_token1] = aux_sym__literalString_token1,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym__literalInt_token1] = aux_sym__literalInt_token1,
  [aux_sym__literalInt_token2] = aux_sym__literalInt_token2,
  [aux_sym__literalFloat_token1] = aux_sym__literalFloat_token1,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [sym_kProgram] = sym_kProgram,
  [sym_kLibrary] = sym_kLibrary,
  [sym_kUnit] = sym_kUnit,
  [sym_kUses] = sym_kUses,
  [sym_kInterface] = sym_kInterface,
  [sym_kImplementation] = sym_kImplementation,
  [sym_kInitialization] = sym_kInitialization,
  [sym_kFinalization] = sym_kFinalization,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_kBegin] = sym_kBegin,
  [sym_kEnd] = sym_kEnd,
  [sym_kAsm] = sym_kAsm,
  [sym_kVar] = sym_kVar,
  [sym_kThreadvar] = sym_kThreadvar,
  [sym_kConst] = sym_kConst,
  [sym_kConstref] = sym_kConstref,
  [sym_kResourcestring] = sym_kResourcestring,
  [sym_kOut] = sym_kOut,
  [sym_kType] = sym_kType,
  [sym_kLabel] = sym_kLabel,
  [sym_kExports] = sym_kExports,
  [sym_kAbsolute] = sym_kAbsolute,
  [sym_kProperty] = sym_kProperty,
  [sym_kRead] = sym_kRead,
  [sym_kWrite] = sym_kWrite,
  [sym_kImplements] = sym_kImplements,
  [sym_kDefault] = sym_kDefault,
  [sym_kNodefault] = sym_kNodefault,
  [sym_kStored] = sym_kStored,
  [sym_kIndex] = sym_kIndex,
  [sym_kClass] = sym_kClass,
  [sym_kObject] = sym_kObject,
  [sym_kRecord] = sym_kRecord,
  [sym_kObjcclass] = sym_kObjcclass,
  [sym_kObjccategory] = sym_kObjccategory,
  [sym_kObjcprotocol] = sym_kObjcprotocol,
  [sym_kArray] = sym_kArray,
  [sym_kFile] = sym_kFile,
  [sym_kString] = sym_kString,
  [sym_kSet] = sym_kSet,
  [sym_kOf] = sym_kOf,
  [sym_kHelper] = sym_kHelper,
  [sym_kPacked] = sym_kPacked,
  [sym_kGeneric] = sym_kGeneric,
  [sym_kSpecialize] = sym_kSpecialize,
  [sym_kLt] = sym_kLt,
  [sym_kEq] = sym_kEq,
  [sym_kNeq] = sym_kNeq,
  [sym_kGt] = sym_kGt,
  [sym_kLte] = sym_kLte,
  [sym_kGte] = sym_kGte,
  [sym_kAdd] = sym_kAdd,
  [sym_kSub] = sym_kSub,
  [sym_kMul] = sym_kMul,
  [sym_kFdiv] = sym_kFdiv,
  [sym_kAt] = sym_kAt,
  [sym_kHat] = sym_kHat,
  [sym_kAssign] = sym_kAssign,
  [sym_kAssignAdd] = sym_kAssignAdd,
  [sym_kAssignSub] = sym_kAssignSub,
  [sym_kAssignMul] = sym_kAssignMul,
  [sym_kAssignDiv] = sym_kAssignDiv,
  [sym_kOr] = sym_kOr,
  [sym_kXor] = sym_kXor,
  [sym_kDiv] = sym_kDiv,
  [sym_kMod] = sym_kMod,
  [sym_kAnd] = sym_kAnd,
  [sym_kShl] = sym_kShl,
  [sym_kShr] = sym_kShr,
  [sym_kNot] = sym_kNot,
  [sym_kIs] = sym_kIs,
  [sym_kAs] = sym_kAs,
  [sym_kIn] = sym_kIn,
  [sym_kFor] = sym_kFor,
  [sym_kTo] = sym_kTo,
  [sym_kDownto] = sym_kDownto,
  [sym_kIf] = sym_kIf,
  [sym_kThen] = sym_kThen,
  [sym_kElse] = sym_kElse,
  [sym_kDo] = sym_kDo,
  [sym_kWhile] = sym_kWhile,
  [sym_kRepeat] = sym_kRepeat,
  [sym_kUntil] = sym_kUntil,
  [sym_kTry] = sym_kTry,
  [sym_kExcept] = sym_kExcept,
  [sym_kFinally] = sym_kFinally,
  [sym_kRaise] = sym_kRaise,
  [sym_kOn] = sym_kOn,
  [sym_kCase] = sym_kCase,
  [sym_kWith] = sym_kWith,
  [sym_kGoto] = sym_kGoto,
  [sym_kFunction] = sym_kFunction,
  [sym_kProcedure] = sym_kProcedure,
  [sym_kConstructor] = sym_kConstructor,
  [sym_kDestructor] = sym_kDestructor,
  [sym_kOperator] = sym_kOperator,
  [sym_kReference] = sym_kReference,
  [sym_kPublished] = sym_kPublished,
  [sym_kPublic] = sym_kPublic,
  [sym_kProtected] = sym_kProtected,
  [sym_kPrivate] = sym_kPrivate,
  [sym_kStrict] = sym_kStrict,
  [sym_kRequired] = sym_kRequired,
  [sym_kOptional] = sym_kOptional,
  [sym_kForward] = sym_kForward,
  [sym_kStatic] = sym_kStatic,
  [sym_kVirtual] = sym_kVirtual,
  [sym_kAbstract] = sym_kAbstract,
  [sym_kSealed] = sym_kSealed,
  [sym_kDynamic] = sym_kDynamic,
  [sym_kOverride] = sym_kOverride,
  [sym_kOverload] = sym_kOverload,
  [sym_kReintroduce] = sym_kReintroduce,
  [sym_kInherited] = sym_kInherited,
  [sym_kInline] = sym_kInline,
  [sym_kStdcall] = sym_kStdcall,
  [sym_kCdecl] = sym_kCdecl,
  [sym_kCppdecl] = sym_kCppdecl,
  [sym_kPascal] = sym_kPascal,
  [sym_kRegister] = sym_kRegister,
  [sym_kMwpascal] = sym_kMwpascal,
  [sym_kExternal] = sym_kExternal,
  [sym_kName] = sym_kName,
  [sym_kMessage] = sym_kMessage,
  [sym_kDeprecated] = sym_kDeprecated,
  [sym_kExperimental] = sym_kExperimental,
  [sym_kPlatform] = sym_kPlatform,
  [sym_kUnimplemented] = sym_kUnimplemented,
  [sym_kCvar] = sym_kCvar,
  [sym_kExport] = sym_kExport,
  [sym_kFar] = sym_kFar,
  [sym_kNear] = sym_kNear,
  [sym_kSafecall] = sym_kSafecall,
  [sym_kAssembler] = sym_kAssembler,
  [sym_kNostackframe] = sym_kNostackframe,
  [sym_kInterrupt] = sym_kInterrupt,
  [sym_kNoreturn] = sym_kNoreturn,
  [sym_kIocheck] = sym_kIocheck,
  [sym_kLocal] = sym_kLocal,
  [sym_kHardfloat] = sym_kHardfloat,
  [sym_kSoftfloat] = sym_kSoftfloat,
  [sym_kMs_abi_default] = sym_kMs_abi_default,
  [sym_kMs_abi_cdecl] = sym_kMs_abi_cdecl,
  [sym_kSaveregisters] = sym_kSaveregisters,
  [sym_kSysv_abi_default] = sym_kSysv_abi_default,
  [sym_kSysv_abi_cdecl] = sym_kSysv_abi_cdecl,
  [sym_kVectorcall] = sym_kVectorcall,
  [sym_kVarargs] = sym_kVarargs,
  [sym_kWinapi] = sym_kWinapi,
  [sym_kAlias] = sym_kAlias,
  [sym_kDelayed] = sym_kDelayed,
  [sym_kNil] = sym_kNil,
  [sym_kTrue] = sym_kTrue,
  [sym_kFalse] = sym_kFalse,
  [sym_kIfdef] = sym_kIfdef,
  [sym_kIfndef] = sym_kIfndef,
  [sym_kEndif] = sym_kEndif,
  [sym__space] = sym__space,
  [sym_pp] = sym_pp,
  [sym_comment] = sym_comment,
  [sym_root] = sym_root,
  [sym_program] = sym_program,
  [sym_library] = sym_library,
  [sym_unit] = sym_unit,
  [sym_interface] = sym_interface,
  [sym_implementation] = sym_implementation,
  [sym_initialization] = sym_initialization,
  [sym_finalization] = sym_finalization,
  [sym_moduleName] = sym_moduleName,
  [sym_if] = sym_if,
  [sym_ifElse] = sym_ifElse,
  [sym_while] = sym_while,
  [sym_repeat] = sym_repeat,
  [sym_for] = sym_for,
  [sym_foreach] = sym_foreach,
  [sym_exceptionHandler] = sym_exceptionHandler,
  [sym_exceptionElse] = sym_exceptionElse,
  [sym_try] = sym_try,
  [sym_caseCase] = sym_caseCase,
  [sym_case] = sym_case,
  [sym_block] = sym_block,
  [sym_asm] = sym_asm,
  [sym_with] = sym_with,
  [sym_raise] = sym_raise,
  [sym_statement] = sym_statement,
  [sym_goto] = sym_goto,
  [sym__statement] = sym__statement,
  [sym_ifTr] = sym_if,
  [sym_ifElseTr] = sym_ifElse,
  [sym_whileTr] = sym_while,
  [sym_repeatTr] = sym_repeat,
  [sym_forTr] = sym_for,
  [sym_foreachTr] = sym_foreach,
  [sym_exceptionHandlerTr] = sym_exceptionHandler,
  [sym__exceptionHandlersTr] = sym__exceptionHandlersTr,
  [sym_tryTr] = sym_try,
  [sym_caseCaseTr] = sym_caseCase,
  [sym_caseTr] = sym_case,
  [sym_blockTr] = sym_blockTr,
  [sym_asmTr] = sym_asm,
  [sym_withTr] = sym_with,
  [sym_raiseTr] = sym_raise,
  [sym_statementTr] = sym_statement,
  [sym_gotoTr] = sym_goto,
  [sym__statementTr] = sym__statementTr,
  [sym_assignment] = sym_assignment,
  [sym_varAssignDef] = sym_varAssignDef,
  [sym_varDef] = sym_varDef,
  [sym_label] = sym_label,
  [sym_caseLabel] = sym_caseLabel,
  [sym__statementsTr] = sym__statementsTr,
  [sym_statementsTr] = sym_statementsTr,
  [sym_asmBody] = sym_asmBody,
  [sym__expr] = sym__expr,
  [sym__ref] = sym__ref,
  [sym_lambda] = sym_lambda,
  [sym_inherited] = sym_inherited,
  [sym_exprDot] = sym_exprDot,
  [sym_exprDeref] = sym_exprUnary,
  [sym_exprAs] = sym_exprBinary,
  [sym_exprTpl] = sym_exprTpl,
  [sym_exprSubscript] = sym_exprSubscript,
  [sym_exprCall] = sym_exprCall,
  [sym_legacyFormat] = sym_legacyFormat,
  [sym_exprArgs] = sym_exprArgs,
  [sym_exprBinary] = sym_exprBinary,
  [sym_exprUnary] = sym_exprUnary,
  [sym_exprParens] = sym_exprParens,
  [sym_exprBrackets] = sym_exprBrackets,
  [sym_type] = sym_type,
  [sym_typeref] = sym_typeref,
  [sym__typeref] = sym__typeref,
  [sym_typerefDot] = sym_typerefDot,
  [sym_typerefTpl] = sym_typerefTpl,
  [sym_typerefPtr] = sym_typerefPtr,
  [sym_typerefArgs] = sym_typerefArgs,
  [sym_genericDot] = sym_genericDot,
  [sym_genericTpl] = sym_genericTpl,
  [sym__genericName] = sym__genericName,
  [sym_genericArgs] = sym_genericArgs,
  [sym_genericArg] = sym_genericArg,
  [sym__literal] = sym__literal,
  [sym_literalString] = sym_literalString,
  [sym__literalString] = sym__literalString,
  [sym_literalChar] = sym_literalChar,
  [sym_literalNumber] = sym_literalNumber,
  [sym__literalInt] = sym__literalInt,
  [sym__literalFloat] = sym__literalFloat,
  [sym_range] = sym_range,
  [aux_sym__definitions] = aux_sym__definitions,
  [sym__definition] = sym__definition,
  [sym_defProc] = sym_defProc,
  [sym_declProcFwd] = sym_declProc,
  [sym__visibility] = sym__visibility,
  [aux_sym__declarations] = aux_sym__declarations,
  [aux_sym__classDeclarations] = aux_sym__classDeclarations,
  [sym_defaultValue] = sym_defaultValue,
  [sym_declUses] = sym_declUses,
  [sym_declExports] = sym_declExports,
  [sym_declTypes] = sym_declTypes,
  [sym_declVars] = sym_declVars,
  [sym_declConsts] = sym_declConsts,
  [sym_declType] = sym_declType,
  [sym_declProc] = sym_declProc,
  [sym_declVar] = sym_declVar,
  [sym_declConst] = sym_declConst,
  [sym_declLabels] = sym_declLabels,
  [sym_declLabel] = sym_declLabel,
  [sym_declExport] = sym_declExport,
  [sym_declEnum] = sym_declEnum,
  [sym_declEnumValue] = sym_declEnumValue,
  [sym_declSet] = sym_declSet,
  [sym_declArray] = sym_declArray,
  [sym_declFile] = sym_declFile,
  [sym_declString] = sym_declString,
  [sym_declProcRef] = sym_declProcRef,
  [sym_declMetaClass] = sym_declMetaClass,
  [sym_declClass] = sym_declClass,
  [sym_declIntf] = sym_declIntf,
  [sym_declHelper] = sym_declHelper,
  [sym_guid] = sym_guid,
  [sym__declClass] = sym__declClass,
  [sym_declSection] = sym_declSection,
  [aux_sym__declFields] = aux_sym__declFields,
  [sym_declField] = sym_declField,
  [sym_declProp] = sym_declProp,
  [sym_declPropArgs] = sym_declPropArgs,
  [sym_declVariant] = sym_declVariant,
  [sym_declVariantClause] = sym_declVariantClause,
  [sym_declVariantField] = sym_declField,
  [sym__declProc] = sym__declProc,
  [sym__declOperator] = sym__declOperator,
  [sym_operatorDot] = sym_genericDot,
  [sym__operatorName] = sym__operatorName,
  [sym_operatorName] = sym_operatorName,
  [sym_declArgs] = sym_declArgs,
  [sym_declArg] = sym_declArg,
  [sym__procAttribute] = sym__procAttribute,
  [sym__procAttributeNoExt] = sym__procAttributeNoExt,
  [sym_procAttribute] = sym_procAttribute,
  [sym_rttiAttributes] = sym_rttiAttributes,
  [sym_procExternal] = sym_procExternal,
  [sym__initializer] = sym__initializer,
  [sym_recInitializer] = sym_recInitializer,
  [sym_recInitializerField] = sym_recInitializerField,
  [sym_arrInitializer] = sym_arrInitializer,
  [sym_kEndDot] = sym_kEndDot,
  [sym_kDot] = sym_kDot,
  [aux_sym_unit_repeat1] = aux_sym_unit_repeat1,
  [aux_sym_moduleName_repeat1] = aux_sym_moduleName_repeat1,
  [aux_sym_exceptionElse_repeat1] = aux_sym_exceptionElse_repeat1,
  [aux_sym__exceptionHandlers_repeat1] = aux_sym__exceptionHandlers_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_with_repeat1] = aux_sym_with_repeat1,
  [aux_sym_caseLabel_repeat1] = aux_sym_caseLabel_repeat1,
  [aux_sym__statementsTr_repeat1] = aux_sym__statementsTr_repeat1,
  [aux_sym_asmBody_repeat1] = aux_sym_asmBody_repeat1,
  [aux_sym_exprTpl_repeat1] = aux_sym_exprTpl_repeat1,
  [aux_sym_legacyFormat_repeat1] = aux_sym_legacyFormat_repeat1,
  [aux_sym_exprArgs_repeat1] = aux_sym_exprArgs_repeat1,
  [aux_sym_type_repeat1] = aux_sym_type_repeat1,
  [aux_sym_typerefArgs_repeat1] = aux_sym_typerefArgs_repeat1,
  [aux_sym_genericArgs_repeat1] = aux_sym_genericArgs_repeat1,
  [aux_sym_genericArg_repeat1] = aux_sym_genericArg_repeat1,
  [aux_sym_literalString_repeat1] = aux_sym_literalString_repeat1,
  [aux_sym_defProc_repeat1] = aux_sym_defProc_repeat1,
  [aux_sym_declProcFwd_repeat1] = aux_sym_declProcFwd_repeat1,
  [aux_sym_declUses_repeat1] = aux_sym_declUses_repeat1,
  [aux_sym_declExports_repeat1] = aux_sym_declExports_repeat1,
  [aux_sym_declTypes_repeat1] = aux_sym_declTypes_repeat1,
  [aux_sym_declVars_repeat1] = aux_sym_declVars_repeat1,
  [aux_sym_declConsts_repeat1] = aux_sym_declConsts_repeat1,
  [aux_sym_declVar_repeat1] = aux_sym_declVar_repeat1,
  [aux_sym_declLabels_repeat1] = aux_sym_declLabels_repeat1,
  [aux_sym_declExport_repeat1] = aux_sym_declExport_repeat1,
  [aux_sym_declEnum_repeat1] = aux_sym_declEnum_repeat1,
  [aux_sym_declArray_repeat1] = aux_sym_declArray_repeat1,
  [aux_sym_declClass_repeat1] = aux_sym_declClass_repeat1,
  [aux_sym__declClass_repeat1] = aux_sym__declClass_repeat1,
  [aux_sym_declProp_repeat1] = aux_sym_declProp_repeat1,
  [aux_sym_declProp_repeat2] = aux_sym_declProp_repeat2,
  [aux_sym_declPropArgs_repeat1] = aux_sym_declPropArgs_repeat1,
  [aux_sym_declVariant_repeat1] = aux_sym_declVariant_repeat1,
  [aux_sym_declVariantClause_repeat1] = aux_sym_declVariantClause_repeat1,
  [aux_sym__declProc_repeat1] = aux_sym__declProc_repeat1,
  [aux_sym__procAttribute_repeat1] = aux_sym__procAttribute_repeat1,
  [aux_sym__procAttributeNoExt_repeat1] = aux_sym__procAttributeNoExt_repeat1,
  [aux_sym_rttiAttributes_repeat1] = aux_sym_rttiAttributes_repeat1,
  [aux_sym_rttiAttributes_repeat2] = aux_sym_rttiAttributes_repeat2,
  [aux_sym_recInitializer_repeat1] = aux_sym_recInitializer_repeat1,
  [aux_sym_arrInitializer_repeat1] = aux_sym_arrInitializer_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_asmBody_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asmBody_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asmBody_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_type_token2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_type_token3] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__literalString_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__literalInt_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literalInt_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literalFloat_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_kProgram] = {
    .visible = true,
    .named = true,
  },
  [sym_kLibrary] = {
    .visible = true,
    .named = true,
  },
  [sym_kUnit] = {
    .visible = true,
    .named = true,
  },
  [sym_kUses] = {
    .visible = true,
    .named = true,
  },
  [sym_kInterface] = {
    .visible = true,
    .named = true,
  },
  [sym_kImplementation] = {
    .visible = true,
    .named = true,
  },
  [sym_kInitialization] = {
    .visible = true,
    .named = true,
  },
  [sym_kFinalization] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_kBegin] = {
    .visible = true,
    .named = true,
  },
  [sym_kEnd] = {
    .visible = true,
    .named = true,
  },
  [sym_kAsm] = {
    .visible = true,
    .named = true,
  },
  [sym_kVar] = {
    .visible = true,
    .named = true,
  },
  [sym_kThreadvar] = {
    .visible = true,
    .named = true,
  },
  [sym_kConst] = {
    .visible = true,
    .named = true,
  },
  [sym_kConstref] = {
    .visible = true,
    .named = true,
  },
  [sym_kResourcestring] = {
    .visible = true,
    .named = true,
  },
  [sym_kOut] = {
    .visible = true,
    .named = true,
  },
  [sym_kType] = {
    .visible = true,
    .named = true,
  },
  [sym_kLabel] = {
    .visible = true,
    .named = true,
  },
  [sym_kExports] = {
    .visible = true,
    .named = true,
  },
  [sym_kAbsolute] = {
    .visible = true,
    .named = true,
  },
  [sym_kProperty] = {
    .visible = true,
    .named = true,
  },
  [sym_kRead] = {
    .visible = true,
    .named = true,
  },
  [sym_kWrite] = {
    .visible = true,
    .named = true,
  },
  [sym_kImplements] = {
    .visible = true,
    .named = true,
  },
  [sym_kDefault] = {
    .visible = true,
    .named = true,
  },
  [sym_kNodefault] = {
    .visible = true,
    .named = true,
  },
  [sym_kStored] = {
    .visible = true,
    .named = true,
  },
  [sym_kIndex] = {
    .visible = true,
    .named = true,
  },
  [sym_kClass] = {
    .visible = true,
    .named = true,
  },
  [sym_kObject] = {
    .visible = true,
    .named = true,
  },
  [sym_kRecord] = {
    .visible = true,
    .named = true,
  },
  [sym_kObjcclass] = {
    .visible = true,
    .named = true,
  },
  [sym_kObjccategory] = {
    .visible = true,
    .named = true,
  },
  [sym_kObjcprotocol] = {
    .visible = true,
    .named = true,
  },
  [sym_kArray] = {
    .visible = true,
    .named = true,
  },
  [sym_kFile] = {
    .visible = true,
    .named = true,
  },
  [sym_kString] = {
    .visible = true,
    .named = true,
  },
  [sym_kSet] = {
    .visible = true,
    .named = true,
  },
  [sym_kOf] = {
    .visible = true,
    .named = true,
  },
  [sym_kHelper] = {
    .visible = true,
    .named = true,
  },
  [sym_kPacked] = {
    .visible = true,
    .named = true,
  },
  [sym_kGeneric] = {
    .visible = true,
    .named = true,
  },
  [sym_kSpecialize] = {
    .visible = true,
    .named = true,
  },
  [sym_kLt] = {
    .visible = true,
    .named = true,
  },
  [sym_kEq] = {
    .visible = true,
    .named = true,
  },
  [sym_kNeq] = {
    .visible = true,
    .named = true,
  },
  [sym_kGt] = {
    .visible = true,
    .named = true,
  },
  [sym_kLte] = {
    .visible = true,
    .named = true,
  },
  [sym_kGte] = {
    .visible = true,
    .named = true,
  },
  [sym_kAdd] = {
    .visible = true,
    .named = true,
  },
  [sym_kSub] = {
    .visible = true,
    .named = true,
  },
  [sym_kMul] = {
    .visible = true,
    .named = true,
  },
  [sym_kFdiv] = {
    .visible = true,
    .named = true,
  },
  [sym_kAt] = {
    .visible = true,
    .named = true,
  },
  [sym_kHat] = {
    .visible = true,
    .named = true,
  },
  [sym_kAssign] = {
    .visible = true,
    .named = true,
  },
  [sym_kAssignAdd] = {
    .visible = true,
    .named = true,
  },
  [sym_kAssignSub] = {
    .visible = true,
    .named = true,
  },
  [sym_kAssignMul] = {
    .visible = true,
    .named = true,
  },
  [sym_kAssignDiv] = {
    .visible = true,
    .named = true,
  },
  [sym_kOr] = {
    .visible = true,
    .named = true,
  },
  [sym_kXor] = {
    .visible = true,
    .named = true,
  },
  [sym_kDiv] = {
    .visible = true,
    .named = true,
  },
  [sym_kMod] = {
    .visible = true,
    .named = true,
  },
  [sym_kAnd] = {
    .visible = true,
    .named = true,
  },
  [sym_kShl] = {
    .visible = true,
    .named = true,
  },
  [sym_kShr] = {
    .visible = true,
    .named = true,
  },
  [sym_kNot] = {
    .visible = true,
    .named = true,
  },
  [sym_kIs] = {
    .visible = true,
    .named = true,
  },
  [sym_kAs] = {
    .visible = true,
    .named = true,
  },
  [sym_kIn] = {
    .visible = true,
    .named = true,
  },
  [sym_kFor] = {
    .visible = true,
    .named = true,
  },
  [sym_kTo] = {
    .visible = true,
    .named = true,
  },
  [sym_kDownto] = {
    .visible = true,
    .named = true,
  },
  [sym_kIf] = {
    .visible = true,
    .named = true,
  },
  [sym_kThen] = {
    .visible = true,
    .named = true,
  },
  [sym_kElse] = {
    .visible = true,
    .named = true,
  },
  [sym_kDo] = {
    .visible = true,
    .named = true,
  },
  [sym_kWhile] = {
    .visible = true,
    .named = true,
  },
  [sym_kRepeat] = {
    .visible = true,
    .named = true,
  },
  [sym_kUntil] = {
    .visible = true,
    .named = true,
  },
  [sym_kTry] = {
    .visible = true,
    .named = true,
  },
  [sym_kExcept] = {
    .visible = true,
    .named = true,
  },
  [sym_kFinally] = {
    .visible = true,
    .named = true,
  },
  [sym_kRaise] = {
    .visible = true,
    .named = true,
  },
  [sym_kOn] = {
    .visible = true,
    .named = true,
  },
  [sym_kCase] = {
    .visible = true,
    .named = true,
  },
  [sym_kWith] = {
    .visible = true,
    .named = true,
  },
  [sym_kGoto] = {
    .visible = true,
    .named = true,
  },
  [sym_kFunction] = {
    .visible = true,
    .named = true,
  },
  [sym_kProcedure] = {
    .visible = true,
    .named = true,
  },
  [sym_kConstructor] = {
    .visible = true,
    .named = true,
  },
  [sym_kDestructor] = {
    .visible = true,
    .named = true,
  },
  [sym_kOperator] = {
    .visible = true,
    .named = true,
  },
  [sym_kReference] = {
    .visible = true,
    .named = true,
  },
  [sym_kPublished] = {
    .visible = true,
    .named = true,
  },
  [sym_kPublic] = {
    .visible = true,
    .named = true,
  },
  [sym_kProtected] = {
    .visible = true,
    .named = true,
  },
  [sym_kPrivate] = {
    .visible = true,
    .named = true,
  },
  [sym_kStrict] = {
    .visible = true,
    .named = true,
  },
  [sym_kRequired] = {
    .visible = true,
    .named = true,
  },
  [sym_kOptional] = {
    .visible = true,
    .named = true,
  },
  [sym_kForward] = {
    .visible = true,
    .named = true,
  },
  [sym_kStatic] = {
    .visible = true,
    .named = true,
  },
  [sym_kVirtual] = {
    .visible = true,
    .named = true,
  },
  [sym_kAbstract] = {
    .visible = true,
    .named = true,
  },
  [sym_kSealed] = {
    .visible = true,
    .named = true,
  },
  [sym_kDynamic] = {
    .visible = true,
    .named = true,
  },
  [sym_kOverride] = {
    .visible = true,
    .named = true,
  },
  [sym_kOverload] = {
    .visible = true,
    .named = true,
  },
  [sym_kReintroduce] = {
    .visible = true,
    .named = true,
  },
  [sym_kInherited] = {
    .visible = true,
    .named = true,
  },
  [sym_kInline] = {
    .visible = true,
    .named = true,
  },
  [sym_kStdcall] = {
    .visible = true,
    .named = true,
  },
  [sym_kCdecl] = {
    .visible = true,
    .named = true,
  },
  [sym_kCppdecl] = {
    .visible = true,
    .named = true,
  },
  [sym_kPascal] = {
    .visible = true,
    .named = true,
  },
  [sym_kRegister] = {
    .visible = true,
    .named = true,
  },
  [sym_kMwpascal] = {
    .visible = true,
    .named = true,
  },
  [sym_kExternal] = {
    .visible = true,
    .named = true,
  },
  [sym_kName] = {
    .visible = true,
    .named = true,
  },
  [sym_kMessage] = {
    .visible = true,
    .named = true,
  },
  [sym_kDeprecated] = {
    .visible = true,
    .named = true,
  },
  [sym_kExperimental] = {
    .visible = true,
    .named = true,
  },
  [sym_kPlatform] = {
    .visible = true,
    .named = true,
  },
  [sym_kUnimplemented] = {
    .visible = true,
    .named = true,
  },
  [sym_kCvar] = {
    .visible = true,
    .named = true,
  },
  [sym_kExport] = {
    .visible = true,
    .named = true,
  },
  [sym_kFar] = {
    .visible = true,
    .named = true,
  },
  [sym_kNear] = {
    .visible = true,
    .named = true,
  },
  [sym_kSafecall] = {
    .visible = true,
    .named = true,
  },
  [sym_kAssembler] = {
    .visible = true,
    .named = true,
  },
  [sym_kNostackframe] = {
    .visible = true,
    .named = true,
  },
  [sym_kInterrupt] = {
    .visible = true,
    .named = true,
  },
  [sym_kNoreturn] = {
    .visible = true,
    .named = true,
  },
  [sym_kIocheck] = {
    .visible = true,
    .named = true,
  },
  [sym_kLocal] = {
    .visible = true,
    .named = true,
  },
  [sym_kHardfloat] = {
    .visible = true,
    .named = true,
  },
  [sym_kSoftfloat] = {
    .visible = true,
    .named = true,
  },
  [sym_kMs_abi_default] = {
    .visible = true,
    .named = true,
  },
  [sym_kMs_abi_cdecl] = {
    .visible = true,
    .named = true,
  },
  [sym_kSaveregisters] = {
    .visible = true,
    .named = true,
  },
  [sym_kSysv_abi_default] = {
    .visible = true,
    .named = true,
  },
  [sym_kSysv_abi_cdecl] = {
    .visible = true,
    .named = true,
  },
  [sym_kVectorcall] = {
    .visible = true,
    .named = true,
  },
  [sym_kVarargs] = {
    .visible = true,
    .named = true,
  },
  [sym_kWinapi] = {
    .visible = true,
    .named = true,
  },
  [sym_kAlias] = {
    .visible = true,
    .named = true,
  },
  [sym_kDelayed] = {
    .visible = true,
    .named = true,
  },
  [sym_kNil] = {
    .visible = true,
    .named = true,
  },
  [sym_kTrue] = {
    .visible = true,
    .named = true,
  },
  [sym_kFalse] = {
    .visible = true,
    .named = true,
  },
  [sym_kIfdef] = {
    .visible = true,
    .named = true,
  },
  [sym_kIfndef] = {
    .visible = true,
    .named = true,
  },
  [sym_kEndif] = {
    .visible = true,
    .named = true,
  },
  [sym__space] = {
    .visible = false,
    .named = true,
  },
  [sym_pp] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_root] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_library] = {
    .visible = true,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_interface] = {
    .visible = true,
    .named = true,
  },
  [sym_implementation] = {
    .visible = true,
    .named = true,
  },
  [sym_initialization] = {
    .visible = true,
    .named = true,
  },
  [sym_finalization] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleName] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_ifElse] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptionHandler] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptionElse] = {
    .visible = true,
    .named = true,
  },
  [sym_try] = {
    .visible = true,
    .named = true,
  },
  [sym_caseCase] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_with] = {
    .visible = true,
    .named = true,
  },
  [sym_raise] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_ifTr] = {
    .visible = true,
    .named = true,
  },
  [sym_ifElseTr] = {
    .visible = true,
    .named = true,
  },
  [sym_whileTr] = {
    .visible = true,
    .named = true,
  },
  [sym_repeatTr] = {
    .visible = true,
    .named = true,
  },
  [sym_forTr] = {
    .visible = true,
    .named = true,
  },
  [sym_foreachTr] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptionHandlerTr] = {
    .visible = true,
    .named = true,
  },
  [sym__exceptionHandlersTr] = {
    .visible = false,
    .named = true,
  },
  [sym_tryTr] = {
    .visible = true,
    .named = true,
  },
  [sym_caseCaseTr] = {
    .visible = true,
    .named = true,
  },
  [sym_caseTr] = {
    .visible = true,
    .named = true,
  },
  [sym_blockTr] = {
    .visible = true,
    .named = true,
  },
  [sym_asmTr] = {
    .visible = true,
    .named = true,
  },
  [sym_withTr] = {
    .visible = true,
    .named = true,
  },
  [sym_raiseTr] = {
    .visible = true,
    .named = true,
  },
  [sym_statementTr] = {
    .visible = true,
    .named = true,
  },
  [sym_gotoTr] = {
    .visible = true,
    .named = true,
  },
  [sym__statementTr] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_varAssignDef] = {
    .visible = true,
    .named = true,
  },
  [sym_varDef] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_caseLabel] = {
    .visible = true,
    .named = true,
  },
  [sym__statementsTr] = {
    .visible = false,
    .named = true,
  },
  [sym_statementsTr] = {
    .visible = true,
    .named = true,
  },
  [sym_asmBody] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
  },
  [sym__ref] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_inherited] = {
    .visible = true,
    .named = true,
  },
  [sym_exprDot] = {
    .visible = true,
    .named = true,
  },
  [sym_exprDeref] = {
    .visible = true,
    .named = true,
  },
  [sym_exprAs] = {
    .visible = true,
    .named = true,
  },
  [sym_exprTpl] = {
    .visible = true,
    .named = true,
  },
  [sym_exprSubscript] = {
    .visible = true,
    .named = true,
  },
  [sym_exprCall] = {
    .visible = true,
    .named = true,
  },
  [sym_legacyFormat] = {
    .visible = true,
    .named = true,
  },
  [sym_exprArgs] = {
    .visible = true,
    .named = true,
  },
  [sym_exprBinary] = {
    .visible = true,
    .named = true,
  },
  [sym_exprUnary] = {
    .visible = true,
    .named = true,
  },
  [sym_exprParens] = {
    .visible = true,
    .named = true,
  },
  [sym_exprBrackets] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_typeref] = {
    .visible = true,
    .named = true,
  },
  [sym__typeref] = {
    .visible = false,
    .named = true,
  },
  [sym_typerefDot] = {
    .visible = true,
    .named = true,
  },
  [sym_typerefTpl] = {
    .visible = true,
    .named = true,
  },
  [sym_typerefPtr] = {
    .visible = true,
    .named = true,
  },
  [sym_typerefArgs] = {
    .visible = true,
    .named = true,
  },
  [sym_genericDot] = {
    .visible = true,
    .named = true,
  },
  [sym_genericTpl] = {
    .visible = true,
    .named = true,
  },
  [sym__genericName] = {
    .visible = false,
    .named = true,
  },
  [sym_genericArgs] = {
    .visible = true,
    .named = true,
  },
  [sym_genericArg] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_literalString] = {
    .visible = true,
    .named = true,
  },
  [sym__literalString] = {
    .visible = false,
    .named = true,
  },
  [sym_literalChar] = {
    .visible = true,
    .named = true,
  },
  [sym_literalNumber] = {
    .visible = true,
    .named = true,
  },
  [sym__literalInt] = {
    .visible = false,
    .named = true,
  },
  [sym__literalFloat] = {
    .visible = false,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__definitions] = {
    .visible = false,
    .named = false,
  },
  [sym__definition] = {
    .visible = false,
    .named = true,
  },
  [sym_defProc] = {
    .visible = true,
    .named = true,
  },
  [sym_declProcFwd] = {
    .visible = true,
    .named = true,
  },
  [sym__visibility] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__declarations] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__classDeclarations] = {
    .visible = false,
    .named = false,
  },
  [sym_defaultValue] = {
    .visible = true,
    .named = true,
  },
  [sym_declUses] = {
    .visible = true,
    .named = true,
  },
  [sym_declExports] = {
    .visible = true,
    .named = true,
  },
  [sym_declTypes] = {
    .visible = true,
    .named = true,
  },
  [sym_declVars] = {
    .visible = true,
    .named = true,
  },
  [sym_declConsts] = {
    .visible = true,
    .named = true,
  },
  [sym_declType] = {
    .visible = true,
    .named = true,
  },
  [sym_declProc] = {
    .visible = true,
    .named = true,
  },
  [sym_declVar] = {
    .visible = true,
    .named = true,
  },
  [sym_declConst] = {
    .visible = true,
    .named = true,
  },
  [sym_declLabels] = {
    .visible = true,
    .named = true,
  },
  [sym_declLabel] = {
    .visible = true,
    .named = true,
  },
  [sym_declExport] = {
    .visible = true,
    .named = true,
  },
  [sym_declEnum] = {
    .visible = true,
    .named = true,
  },
  [sym_declEnumValue] = {
    .visible = true,
    .named = true,
  },
  [sym_declSet] = {
    .visible = true,
    .named = true,
  },
  [sym_declArray] = {
    .visible = true,
    .named = true,
  },
  [sym_declFile] = {
    .visible = true,
    .named = true,
  },
  [sym_declString] = {
    .visible = true,
    .named = true,
  },
  [sym_declProcRef] = {
    .visible = true,
    .named = true,
  },
  [sym_declMetaClass] = {
    .visible = true,
    .named = true,
  },
  [sym_declClass] = {
    .visible = true,
    .named = true,
  },
  [sym_declIntf] = {
    .visible = true,
    .named = true,
  },
  [sym_declHelper] = {
    .visible = true,
    .named = true,
  },
  [sym_guid] = {
    .visible = true,
    .named = true,
  },
  [sym__declClass] = {
    .visible = false,
    .named = true,
  },
  [sym_declSection] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__declFields] = {
    .visible = false,
    .named = false,
  },
  [sym_declField] = {
    .visible = true,
    .named = true,
  },
  [sym_declProp] = {
    .visible = true,
    .named = true,
  },
  [sym_declPropArgs] = {
    .visible = true,
    .named = true,
  },
  [sym_declVariant] = {
    .visible = true,
    .named = true,
  },
  [sym_declVariantClause] = {
    .visible = true,
    .named = true,
  },
  [sym_declVariantField] = {
    .visible = true,
    .named = true,
  },
  [sym__declProc] = {
    .visible = false,
    .named = true,
  },
  [sym__declOperator] = {
    .visible = false,
    .named = true,
  },
  [sym_operatorDot] = {
    .visible = true,
    .named = true,
  },
  [sym__operatorName] = {
    .visible = false,
    .named = true,
  },
  [sym_operatorName] = {
    .visible = true,
    .named = true,
  },
  [sym_declArgs] = {
    .visible = true,
    .named = true,
  },
  [sym_declArg] = {
    .visible = true,
    .named = true,
  },
  [sym__procAttribute] = {
    .visible = false,
    .named = true,
  },
  [sym__procAttributeNoExt] = {
    .visible = false,
    .named = true,
  },
  [sym_procAttribute] = {
    .visible = true,
    .named = true,
  },
  [sym_rttiAttributes] = {
    .visible = true,
    .named = true,
  },
  [sym_procExternal] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_recInitializer] = {
    .visible = true,
    .named = true,
  },
  [sym_recInitializerField] = {
    .visible = true,
    .named = true,
  },
  [sym_arrInitializer] = {
    .visible = true,
    .named = true,
  },
  [sym_kEndDot] = {
    .visible = true,
    .named = true,
  },
  [sym_kDot] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_moduleName_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptionElse_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exceptionHandlers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_caseLabel_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statementsTr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asmBody_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exprTpl_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_legacyFormat_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exprArgs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_typerefArgs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_genericArgs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_genericArg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literalString_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_defProc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declProcFwd_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declUses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declExports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declTypes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declVars_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declConsts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declVar_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declLabels_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declExport_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declEnum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declArray_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declClass_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declClass_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declProp_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declProp_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declPropArgs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declVariant_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declVariantClause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declProc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__procAttribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__procAttributeNoExt_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rttiAttributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rttiAttributes_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_recInitializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arrInitializer_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field__dummy = 1,
  field_args = 2,
  field_assign = 3,
  field_attribute = 4,
  field_body = 5,
  field_condition = 6,
  field_defaultValue = 7,
  field_else = 8,
  field_end = 9,
  field_entity = 10,
  field_except = 11,
  field_exception = 12,
  field_finally = 13,
  field_getter = 14,
  field_guid = 15,
  field_header = 16,
  field_implements = 17,
  field_index = 18,
  field_iterable = 19,
  field_iterator = 20,
  field_label = 21,
  field_lhs = 22,
  field_local = 23,
  field_name = 24,
  field_operand = 25,
  field_operator = 26,
  field_parent = 27,
  field_resultName = 28,
  field_rhs = 29,
  field_setter = 30,
  field_start = 31,
  field_stored = 32,
  field_then = 33,
  field_try = 34,
  field_type = 35,
  field_value = 36,
  field_variable = 37,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field__dummy] = "_dummy",
  [field_args] = "args",
  [field_assign] = "assign",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_defaultValue] = "defaultValue",
  [field_else] = "else",
  [field_end] = "end",
  [field_entity] = "entity",
  [field_except] = "except",
  [field_exception] = "exception",
  [field_finally] = "finally",
  [field_getter] = "getter",
  [field_guid] = "guid",
  [field_header] = "header",
  [field_implements] = "implements",
  [field_index] = "index",
  [field_iterable] = "iterable",
  [field_iterator] = "iterator",
  [field_label] = "label",
  [field_lhs] = "lhs",
  [field_local] = "local",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parent] = "parent",
  [field_resultName] = "resultName",
  [field_rhs] = "rhs",
  [field_setter] = "setter",
  [field_start] = "start",
  [field_stored] = "stored",
  [field_then] = "then",
  [field_try] = "try",
  [field_type] = "type",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 5},
  [2] = {.index = 5, .length = 6},
  [6] = {.index = 11, .length = 1},
  [7] = {.index = 12, .length = 5},
  [8] = {.index = 17, .length = 6},
  [9] = {.index = 23, .length = 2},
  [10] = {.index = 25, .length = 1},
  [11] = {.index = 25, .length = 1},
  [12] = {.index = 26, .length = 2},
  [13] = {.index = 28, .length = 1},
  [14] = {.index = 29, .length = 1},
  [15] = {.index = 30, .length = 2},
  [16] = {.index = 30, .length = 2},
  [17] = {.index = 32, .length = 1},
  [18] = {.index = 33, .length = 6},
  [19] = {.index = 39, .length = 2},
  [20] = {.index = 39, .length = 2},
  [21] = {.index = 41, .length = 2},
  [22] = {.index = 41, .length = 2},
  [23] = {.index = 43, .length = 3},
  [24] = {.index = 46, .length = 1},
  [25] = {.index = 47, .length = 1},
  [26] = {.index = 48, .length = 1},
  [27] = {.index = 49, .length = 1},
  [28] = {.index = 50, .length = 1},
  [29] = {.index = 51, .length = 1},
  [30] = {.index = 52, .length = 2},
  [31] = {.index = 54, .length = 2},
  [32] = {.index = 56, .length = 1},
  [33] = {.index = 57, .length = 2},
  [34] = {.index = 59, .length = 2},
  [35] = {.index = 61, .length = 2},
  [36] = {.index = 63, .length = 3},
  [37] = {.index = 63, .length = 3},
  [38] = {.index = 66, .length = 6},
  [39] = {.index = 72, .length = 1},
  [40] = {.index = 73, .length = 2},
  [41] = {.index = 75, .length = 1},
  [42] = {.index = 76, .length = 2},
  [43] = {.index = 76, .length = 2},
  [44] = {.index = 78, .length = 3},
  [45] = {.index = 78, .length = 3},
  [46] = {.index = 81, .length = 2},
  [48] = {.index = 83, .length = 1},
  [49] = {.index = 84, .length = 2},
  [50] = {.index = 86, .length = 2},
  [51] = {.index = 88, .length = 2},
  [52] = {.index = 90, .length = 2},
  [53] = {.index = 92, .length = 2},
  [54] = {.index = 94, .length = 2},
  [55] = {.index = 96, .length = 2},
  [56] = {.index = 98, .length = 1},
  [57] = {.index = 99, .length = 2},
  [58] = {.index = 101, .length = 2},
  [59] = {.index = 103, .length = 1},
  [60] = {.index = 104, .length = 2},
  [61] = {.index = 106, .length = 1},
  [62] = {.index = 107, .length = 3},
  [63] = {.index = 110, .length = 2},
  [64] = {.index = 112, .length = 2},
  [65] = {.index = 114, .length = 1},
  [66] = {.index = 115, .length = 2},
  [67] = {.index = 117, .length = 2},
  [68] = {.index = 119, .length = 2},
  [69] = {.index = 121, .length = 1},
  [70] = {.index = 122, .length = 2},
  [71] = {.index = 124, .length = 3},
  [72] = {.index = 127, .length = 3},
  [73] = {.index = 130, .length = 3},
  [74] = {.index = 133, .length = 2},
  [75] = {.index = 133, .length = 2},
  [76] = {.index = 135, .length = 3},
  [77] = {.index = 135, .length = 3},
  [78] = {.index = 138, .length = 2},
  [79] = {.index = 140, .length = 3},
  [80] = {.index = 140, .length = 3},
  [81] = {.index = 143, .length = 3},
  [83] = {.index = 146, .length = 2},
  [84] = {.index = 148, .length = 2},
  [85] = {.index = 150, .length = 2},
  [86] = {.index = 152, .length = 3},
  [87] = {.index = 155, .length = 3},
  [88] = {.index = 158, .length = 2},
  [89] = {.index = 160, .length = 3},
  [90] = {.index = 163, .length = 2},
  [91] = {.index = 165, .length = 1},
  [92] = {.index = 166, .length = 3},
  [93] = {.index = 169, .length = 3},
  [94] = {.index = 172, .length = 3},
  [95] = {.index = 175, .length = 3},
  [96] = {.index = 178, .length = 3},
  [97] = {.index = 181, .length = 3},
  [98] = {.index = 184, .length = 2},
  [99] = {.index = 186, .length = 3},
  [100] = {.index = 189, .length = 1},
  [101] = {.index = 190, .length = 2},
  [102] = {.index = 192, .length = 3},
  [103] = {.index = 195, .length = 3},
  [104] = {.index = 198, .length = 3},
  [105] = {.index = 201, .length = 2},
  [106] = {.index = 203, .length = 2},
  [107] = {.index = 205, .length = 2},
  [108] = {.index = 207, .length = 3},
  [109] = {.index = 210, .length = 3},
  [110] = {.index = 213, .length = 3},
  [111] = {.index = 216, .length = 4},
  [112] = {.index = 220, .length = 3},
  [113] = {.index = 223, .length = 4},
  [114] = {.index = 227, .length = 4},
  [115] = {.index = 223, .length = 4},
  [116] = {.index = 231, .length = 3},
  [117] = {.index = 231, .length = 3},
  [118] = {.index = 234, .length = 1},
  [119] = {.index = 235, .length = 4},
  [120] = {.index = 235, .length = 4},
  [121] = {.index = 239, .length = 3},
  [122] = {.index = 242, .length = 3},
  [123] = {.index = 245, .length = 3},
  [124] = {.index = 248, .length = 2},
  [125] = {.index = 250, .length = 2},
  [126] = {.index = 252, .length = 1},
  [127] = {.index = 253, .length = 4},
  [128] = {.index = 257, .length = 3},
  [129] = {.index = 260, .length = 3},
  [130] = {.index = 263, .length = 4},
  [131] = {.index = 267, .length = 4},
  [132] = {.index = 271, .length = 2},
  [133] = {.index = 273, .length = 3},
  [134] = {.index = 276, .length = 4},
  [135] = {.index = 280, .length = 4},
  [136] = {.index = 284, .length = 3},
  [137] = {.index = 287, .length = 3},
  [138] = {.index = 290, .length = 4},
  [139] = {.index = 294, .length = 2},
  [140] = {.index = 296, .length = 3},
  [141] = {.index = 299, .length = 3},
  [142] = {.index = 302, .length = 3},
  [143] = {.index = 305, .length = 4},
  [144] = {.index = 309, .length = 3},
  [145] = {.index = 312, .length = 2},
  [146] = {.index = 314, .length = 3},
  [147] = {.index = 317, .length = 3},
  [148] = {.index = 320, .length = 3},
  [149] = {.index = 323, .length = 4},
  [150] = {.index = 327, .length = 4},
  [151] = {.index = 331, .length = 4},
  [152] = {.index = 335, .length = 4},
  [153] = {.index = 339, .length = 4},
  [154] = {.index = 343, .length = 4},
  [155] = {.index = 347, .length = 5},
  [156] = {.index = 347, .length = 5},
  [157] = {.index = 352, .length = 2},
  [158] = {.index = 354, .length = 3},
  [159] = {.index = 357, .length = 1},
  [160] = {.index = 358, .length = 3},
  [161] = {.index = 361, .length = 4},
  [162] = {.index = 365, .length = 4},
  [163] = {.index = 369, .length = 4},
  [164] = {.index = 373, .length = 5},
  [165] = {.index = 378, .length = 4},
  [166] = {.index = 382, .length = 5},
  [167] = {.index = 387, .length = 4},
  [168] = {.index = 391, .length = 4},
  [169] = {.index = 395, .length = 1},
  [170] = {.index = 396, .length = 3},
  [171] = {.index = 399, .length = 3},
  [172] = {.index = 402, .length = 2},
  [173] = {.index = 404, .length = 3},
  [174] = {.index = 407, .length = 4},
  [175] = {.index = 411, .length = 4},
  [176] = {.index = 415, .length = 4},
  [177] = {.index = 419, .length = 4},
  [178] = {.index = 423, .length = 4},
  [179] = {.index = 427, .length = 4},
  [180] = {.index = 431, .length = 3},
  [181] = {.index = 434, .length = 3},
  [182] = {.index = 437, .length = 3},
  [183] = {.index = 440, .length = 4},
  [184] = {.index = 444, .length = 5},
  [185] = {.index = 449, .length = 5},
  [186] = {.index = 454, .length = 5},
  [187] = {.index = 459, .length = 5},
  [188] = {.index = 464, .length = 1},
  [189] = {.index = 465, .length = 4},
  [190] = {.index = 469, .length = 2},
  [191] = {.index = 471, .length = 3},
  [192] = {.index = 474, .length = 5},
  [193] = {.index = 479, .length = 4},
  [194] = {.index = 483, .length = 5},
  [195] = {.index = 488, .length = 4},
  [196] = {.index = 492, .length = 2},
  [197] = {.index = 494, .length = 4},
  [198] = {.index = 498, .length = 3},
  [199] = {.index = 501, .length = 4},
  [200] = {.index = 505, .length = 5},
  [201] = {.index = 510, .length = 5},
  [202] = {.index = 515, .length = 5},
  [203] = {.index = 520, .length = 5},
  [204] = {.index = 525, .length = 4},
  [205] = {.index = 529, .length = 4},
  [206] = {.index = 533, .length = 4},
  [207] = {.index = 537, .length = 6},
  [208] = {.index = 543, .length = 2},
  [209] = {.index = 545, .length = 2},
  [210] = {.index = 547, .length = 2},
  [211] = {.index = 549, .length = 2},
  [212] = {.index = 551, .length = 2},
  [213] = {.index = 553, .length = 2},
  [214] = {.index = 555, .length = 8},
  [215] = {.index = 563, .length = 12},
  [216] = {.index = 575, .length = 4},
  [217] = {.index = 579, .length = 3},
  [218] = {.index = 582, .length = 3},
  [219] = {.index = 585, .length = 5},
  [220] = {.index = 590, .length = 4},
  [221] = {.index = 594, .length = 2},
  [222] = {.index = 596, .length = 6},
  [223] = {.index = 602, .length = 5},
  [224] = {.index = 607, .length = 3},
  [225] = {.index = 610, .length = 9},
  [226] = {.index = 619, .length = 9},
  [227] = {.index = 628, .length = 8},
  [228] = {.index = 636, .length = 4},
  [229] = {.index = 640, .length = 3},
  [230] = {.index = 643, .length = 10},
  [231] = {.index = 653, .length = 9},
  [232] = {.index = 662, .length = 9},
  [233] = {.index = 671, .length = 8},
  [234] = {.index = 679, .length = 4},
  [235] = {.index = 683, .length = 10},
  [236] = {.index = 693, .length = 9},
  [237] = {.index = 702, .length = 9},
  [238] = {.index = 711, .length = 10},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_args, 0, .inherited = true},
    {field_assign, 0, .inherited = true},
    {field_attribute, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [5] =
    {field_args, 0, .inherited = true},
    {field_assign, 0, .inherited = true},
    {field_attribute, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_resultName, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [11] =
    {field_name, 0},
  [12] =
    {field_args, 1, .inherited = true},
    {field_assign, 1, .inherited = true},
    {field_attribute, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [17] =
    {field_args, 1, .inherited = true},
    {field_assign, 1, .inherited = true},
    {field_attribute, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_resultName, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [23] =
    {field_operand, 1},
    {field_operator, 0},
  [25] =
    {field_body, 1},
  [26] =
    {field_operand, 0},
    {field_operator, 1},
  [28] =
    {field_exception, 1},
  [29] =
    {field_name, 1},
  [30] =
    {field_body, 1},
    {field_header, 0},
  [32] =
    {field_attribute, 0, .inherited = true},
  [33] =
    {field_args, 0, .inherited = true},
    {field_assign, 0, .inherited = true},
    {field_attribute, 0, .inherited = true},
    {field_attribute, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [39] =
    {field_body, 2},
    {field_local, 1},
  [41] =
    {field_args, 1},
    {field_body, 2},
  [43] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [46] =
    {field_entity, 0},
  [47] =
    {field_condition, 1},
  [48] =
    {field_condition, 2},
  [49] =
    {field_except, 1},
  [50] =
    {field_finally, 1},
  [51] =
    {field_entity, 1},
  [52] =
    {field_entity, 0, .inherited = true},
    {field_entity, 1, .inherited = true},
  [54] =
    {field_defaultValue, 1},
    {field_name, 0},
  [56] =
    {field_name, 2},
  [57] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
  [59] =
    {field_assign, 2},
    {field_name, 1},
  [61] =
    {field_args, 2},
    {field_name, 1},
  [63] =
    {field_body, 2},
    {field_header, 0},
    {field_local, 1},
  [66] =
    {field_args, 0, .inherited = true},
    {field_assign, 0, .inherited = true},
    {field_attribute, 0, .inherited = true},
    {field_attribute, 3, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [72] =
    {field_attribute, 0},
  [73] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [75] =
    {field__dummy, 0},
  [76] =
    {field_body, 3},
    {field_type, 2},
  [78] =
    {field_args, 1},
    {field_body, 3},
    {field_local, 2},
  [81] =
    {field_args, 2},
    {field_entity, 0},
  [83] =
    {field_type, 3},
  [84] =
    {field_condition, 1},
    {field_then, 3},
  [86] =
    {field_body, 3},
    {field_condition, 1},
  [88] =
    {field_body, 1},
    {field_condition, 3},
  [90] =
    {field_except, 1},
    {field_except, 2},
  [92] =
    {field_finally, 1},
    {field_finally, 2},
  [94] =
    {field_except, 2},
    {field_try, 1},
  [96] =
    {field_finally, 2},
    {field_try, 1},
  [98] =
    {field_label, 0},
  [99] =
    {field_body, 3},
    {field_entity, 1},
  [101] =
    {field_entity, 1, .inherited = true},
    {field_entity, 2},
  [103] =
    {field_args, 1},
  [104] =
    {field_name, 0},
    {field_type, 2},
  [106] =
    {field_value, 0},
  [107] =
    {field_attribute, 3, .inherited = true},
    {field_defaultValue, 1},
    {field_name, 0},
  [110] =
    {field_defaultValue, 2},
    {field_name, 1},
  [112] =
    {field_name, 0},
    {field_name, 1},
  [114] =
    {field_guid, 1},
  [115] =
    {field_attribute, 4, .inherited = true},
    {field_name, 2},
  [117] =
    {field_assign, 3},
    {field_name, 2},
  [119] =
    {field_args, 3},
    {field_name, 2},
  [121] =
    {field_name, 3},
  [122] =
    {field_name, 1},
    {field_type, 3},
  [124] =
    {field_assign, 2},
    {field_attribute, 4, .inherited = true},
    {field_name, 1},
  [127] =
    {field_args, 2},
    {field_attribute, 4, .inherited = true},
    {field_name, 1},
  [130] =
    {field_args, 2},
    {field_assign, 3},
    {field_name, 1},
  [133] =
    {field_body, 2},
    {field_header, 0},
  [135] =
    {field_body, 4},
    {field_local, 3},
    {field_type, 2},
  [138] =
    {field_name, 1},
    {field_name, 2},
  [140] =
    {field_args, 1},
    {field_body, 4},
    {field_type, 3},
  [143] =
    {field_args, 2},
    {field_args, 3},
    {field_entity, 0},
  [146] =
    {field_end, 3},
    {field_start, 1},
  [148] =
    {field_iterable, 3},
    {field_iterator, 1},
  [150] =
    {field_condition, 1},
    {field_else, 4},
  [152] =
    {field_except, 2},
    {field_except, 3},
    {field_try, 1},
  [155] =
    {field_finally, 2},
    {field_finally, 3},
    {field_try, 1},
  [158] =
    {field_body, 1},
    {field_label, 0},
  [160] =
    {field_body, 4},
    {field_entity, 1, .inherited = true},
    {field_entity, 2},
  [163] =
    {field_name, 0},
    {field_value, 1},
  [165] =
    {field_type, 2},
  [166] =
    {field_attribute, 4, .inherited = true},
    {field_name, 0},
    {field_type, 2},
  [169] =
    {field_defaultValue, 3},
    {field_name, 0},
    {field_type, 2},
  [172] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 3},
  [175] =
    {field_attribute, 4, .inherited = true},
    {field_defaultValue, 2},
    {field_name, 1},
  [178] =
    {field_name, 0},
    {field_type, 1},
    {field_type, 2},
  [181] =
    {field_defaultValue, 2},
    {field_name, 0},
    {field_name, 1},
  [184] =
    {field_parent, 1},
    {field_parent, 2},
  [186] =
    {field_name, 0},
    {field_type, 2},
    {field_type, 3},
  [189] =
    {field_guid, 2},
  [190] =
    {field_name, 2},
    {field_type, 4},
  [192] =
    {field_assign, 3},
    {field_attribute, 5, .inherited = true},
    {field_name, 2},
  [195] =
    {field_args, 3},
    {field_attribute, 5, .inherited = true},
    {field_name, 2},
  [198] =
    {field_args, 3},
    {field_assign, 4},
    {field_name, 2},
  [201] =
    {field_attribute, 5, .inherited = true},
    {field_name, 3},
  [203] =
    {field_assign, 4},
    {field_name, 3},
  [205] =
    {field_args, 4},
    {field_name, 3},
  [207] =
    {field_attribute, 5, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [210] =
    {field_assign, 4},
    {field_name, 1},
    {field_type, 3},
  [213] =
    {field_args, 2},
    {field_name, 1},
    {field_type, 4},
  [216] =
    {field_args, 2},
    {field_assign, 3},
    {field_attribute, 5, .inherited = true},
    {field_name, 1},
  [220] =
    {field_name, 1},
    {field_resultName, 2},
    {field_type, 4},
  [223] =
    {field_body, 2},
    {field_body, 4, .inherited = true},
    {field_header, 0},
    {field_local, 4, .inherited = true},
  [227] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
    {field_local, 0, .inherited = true},
    {field_local, 1, .inherited = true},
  [231] =
    {field_body, 3},
    {field_header, 0},
    {field_local, 2},
  [234] =
    {field_attribute, 1},
  [235] =
    {field_args, 1},
    {field_body, 5},
    {field_local, 4},
    {field_type, 3},
  [239] =
    {field_body, 5},
    {field_end, 3},
    {field_start, 1},
  [242] =
    {field_body, 5},
    {field_iterable, 3},
    {field_iterator, 1},
  [245] =
    {field_condition, 1},
    {field_else, 5},
    {field_then, 3},
  [248] =
    {field_body, 3},
    {field_exception, 1},
  [250] =
    {field_args, 1},
    {field_type, 3},
  [252] =
    {field_args, 3},
  [253] =
    {field_attribute, 5, .inherited = true},
    {field_defaultValue, 3},
    {field_name, 0},
    {field_type, 2},
  [257] =
    {field_defaultValue, 4},
    {field_name, 1},
    {field_type, 3},
  [260] =
    {field_name, 1},
    {field_name, 2},
    {field_type, 4},
  [263] =
    {field_attribute, 5, .inherited = true},
    {field_name, 0},
    {field_name, 1},
    {field_type, 3},
  [267] =
    {field_defaultValue, 4},
    {field_name, 0},
    {field_name, 1},
    {field_type, 3},
  [271] =
    {field_name, 0},
    {field_value, 2},
  [273] =
    {field_name, 1},
    {field_type, 3},
    {field_type, 4},
  [276] =
    {field_defaultValue, 3},
    {field_name, 0},
    {field_type, 1},
    {field_type, 2},
  [280] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_type, 3},
  [284] =
    {field_guid, 3},
    {field_parent, 1},
    {field_parent, 2},
  [287] =
    {field_parent, 1},
    {field_parent, 2},
    {field_parent, 3},
  [290] =
    {field_attribute, 5, .inherited = true},
    {field_name, 0},
    {field_type, 2},
    {field_type, 3},
  [294] =
    {field_parent, 2},
    {field_parent, 3},
  [296] =
    {field_attribute, 6, .inherited = true},
    {field_name, 2},
    {field_type, 4},
  [299] =
    {field_assign, 5},
    {field_name, 2},
    {field_type, 4},
  [302] =
    {field_args, 3},
    {field_name, 2},
    {field_type, 5},
  [305] =
    {field_args, 3},
    {field_assign, 4},
    {field_attribute, 6, .inherited = true},
    {field_name, 2},
  [309] =
    {field_name, 2},
    {field_resultName, 3},
    {field_type, 5},
  [312] =
    {field_name, 3},
    {field_type, 5},
  [314] =
    {field_assign, 4},
    {field_attribute, 6, .inherited = true},
    {field_name, 3},
  [317] =
    {field_args, 4},
    {field_attribute, 6, .inherited = true},
    {field_name, 3},
  [320] =
    {field_args, 4},
    {field_assign, 5},
    {field_name, 3},
  [323] =
    {field_assign, 4},
    {field_attribute, 6, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [327] =
    {field_args, 2},
    {field_attribute, 6, .inherited = true},
    {field_name, 1},
    {field_type, 4},
  [331] =
    {field_args, 2},
    {field_assign, 5},
    {field_name, 1},
    {field_type, 4},
  [335] =
    {field_attribute, 6, .inherited = true},
    {field_name, 1},
    {field_resultName, 2},
    {field_type, 4},
  [339] =
    {field_assign, 5},
    {field_name, 1},
    {field_resultName, 2},
    {field_type, 4},
  [343] =
    {field_args, 2},
    {field_name, 1},
    {field_resultName, 3},
    {field_type, 5},
  [347] =
    {field_body, 3},
    {field_body, 5, .inherited = true},
    {field_header, 0},
    {field_local, 2},
    {field_local, 5, .inherited = true},
  [352] =
    {field_attribute, 1, .inherited = true},
    {field_attribute, 2},
  [354] =
    {field_exception, 3},
    {field_variable, 1},
    {field_variable, 2},
  [357] =
    {field_type, 4},
  [358] =
    {field_attribute, 6, .inherited = true},
    {field_name, 0},
    {field_type, 2},
  [361] =
    {field_attribute, 6, .inherited = true},
    {field_defaultValue, 4},
    {field_name, 1},
    {field_type, 3},
  [365] =
    {field_attribute, 6, .inherited = true},
    {field_name, 1},
    {field_name, 2},
    {field_type, 4},
  [369] =
    {field_defaultValue, 5},
    {field_name, 1},
    {field_name, 2},
    {field_type, 4},
  [373] =
    {field_attribute, 6, .inherited = true},
    {field_defaultValue, 4},
    {field_name, 0},
    {field_name, 1},
    {field_type, 3},
  [378] =
    {field_attribute, 6, .inherited = true},
    {field_name, 1},
    {field_type, 3},
    {field_type, 4},
  [382] =
    {field_defaultValue, 4},
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_type, 3},
  [387] =
    {field_guid, 4},
    {field_parent, 1},
    {field_parent, 2},
    {field_parent, 3},
  [391] =
    {field_parent, 1},
    {field_parent, 2},
    {field_parent, 3},
    {field_parent, 4},
  [395] =
    {field_type, 1},
  [396] =
    {field_parent, 2},
    {field_parent, 3},
    {field_parent, 4},
  [399] =
    {field_guid, 4},
    {field_parent, 2},
    {field_parent, 3},
  [402] =
    {field_parent, 3},
    {field_parent, 4},
  [404] =
    {field_name, 2},
    {field_type, 4},
    {field_type, 5},
  [407] =
    {field_assign, 5},
    {field_attribute, 7, .inherited = true},
    {field_name, 2},
    {field_type, 4},
  [411] =
    {field_args, 3},
    {field_attribute, 7, .inherited = true},
    {field_name, 2},
    {field_type, 5},
  [415] =
    {field_args, 3},
    {field_assign, 6},
    {field_name, 2},
    {field_type, 5},
  [419] =
    {field_attribute, 7, .inherited = true},
    {field_name, 2},
    {field_resultName, 3},
    {field_type, 5},
  [423] =
    {field_assign, 6},
    {field_name, 2},
    {field_resultName, 3},
    {field_type, 5},
  [427] =
    {field_args, 3},
    {field_name, 2},
    {field_resultName, 4},
    {field_type, 6},
  [431] =
    {field_attribute, 7, .inherited = true},
    {field_name, 3},
    {field_type, 5},
  [434] =
    {field_assign, 6},
    {field_name, 3},
    {field_type, 5},
  [437] =
    {field_args, 4},
    {field_name, 3},
    {field_type, 6},
  [440] =
    {field_args, 4},
    {field_assign, 5},
    {field_attribute, 7, .inherited = true},
    {field_name, 3},
  [444] =
    {field_args, 2},
    {field_assign, 5},
    {field_attribute, 7, .inherited = true},
    {field_name, 1},
    {field_type, 4},
  [449] =
    {field_assign, 5},
    {field_attribute, 7, .inherited = true},
    {field_name, 1},
    {field_resultName, 2},
    {field_type, 4},
  [454] =
    {field_args, 2},
    {field_attribute, 7, .inherited = true},
    {field_name, 1},
    {field_resultName, 3},
    {field_type, 5},
  [459] =
    {field_args, 2},
    {field_assign, 6},
    {field_name, 1},
    {field_resultName, 3},
    {field_type, 5},
  [464] =
    {field_implements, 0},
  [465] =
    {field_body, 5},
    {field_exception, 3},
    {field_variable, 1},
    {field_variable, 2},
  [469] =
    {field_args, 3},
    {field_type, 5},
  [471] =
    {field_attribute, 7, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [474] =
    {field_attribute, 7, .inherited = true},
    {field_defaultValue, 5},
    {field_name, 1},
    {field_name, 2},
    {field_type, 4},
  [479] =
    {field_attribute, 7, .inherited = true},
    {field_name, 0},
    {field_name, 1},
    {field_type, 3},
  [483] =
    {field_guid, 5},
    {field_parent, 1},
    {field_parent, 2},
    {field_parent, 3},
    {field_parent, 4},
  [488] =
    {field_parent, 2},
    {field_parent, 3},
    {field_parent, 4},
    {field_parent, 5},
  [492] =
    {field_parent, 4},
    {field_parent, 5},
  [494] =
    {field_guid, 5},
    {field_parent, 2},
    {field_parent, 3},
    {field_parent, 4},
  [498] =
    {field_parent, 3},
    {field_parent, 4},
    {field_parent, 5},
  [501] =
    {field_attribute, 7, .inherited = true},
    {field_name, 2},
    {field_type, 4},
    {field_type, 5},
  [505] =
    {field_args, 3},
    {field_assign, 6},
    {field_attribute, 8, .inherited = true},
    {field_name, 2},
    {field_type, 5},
  [510] =
    {field_assign, 6},
    {field_attribute, 8, .inherited = true},
    {field_name, 2},
    {field_resultName, 3},
    {field_type, 5},
  [515] =
    {field_args, 3},
    {field_attribute, 8, .inherited = true},
    {field_name, 2},
    {field_resultName, 4},
    {field_type, 6},
  [520] =
    {field_args, 3},
    {field_assign, 7},
    {field_name, 2},
    {field_resultName, 4},
    {field_type, 6},
  [525] =
    {field_assign, 6},
    {field_attribute, 8, .inherited = true},
    {field_name, 3},
    {field_type, 5},
  [529] =
    {field_args, 4},
    {field_attribute, 8, .inherited = true},
    {field_name, 3},
    {field_type, 6},
  [533] =
    {field_args, 4},
    {field_assign, 7},
    {field_name, 3},
    {field_type, 6},
  [537] =
    {field_args, 2},
    {field_assign, 6},
    {field_attribute, 8, .inherited = true},
    {field_name, 1},
    {field_resultName, 3},
    {field_type, 5},
  [543] =
    {field_getter, 0},
    {field_getter, 1},
  [545] =
    {field_setter, 0},
    {field_setter, 1},
  [547] =
    {field_implements, 0},
    {field_implements, 1},
  [549] =
    {field_defaultValue, 0},
    {field_defaultValue, 1},
  [551] =
    {field_stored, 0},
    {field_stored, 1},
  [553] =
    {field_index, 0},
    {field_index, 1},
  [555] =
    {field_defaultValue, 4, .inherited = true},
    {field_getter, 4, .inherited = true},
    {field_implements, 4, .inherited = true},
    {field_index, 4, .inherited = true},
    {field_name, 1},
    {field_setter, 4, .inherited = true},
    {field_stored, 4, .inherited = true},
    {field_type, 3},
  [563] =
    {field_defaultValue, 0, .inherited = true},
    {field_defaultValue, 1, .inherited = true},
    {field_getter, 0, .inherited = true},
    {field_getter, 1, .inherited = true},
    {field_implements, 0, .inherited = true},
    {field_implements, 1, .inherited = true},
    {field_index, 0, .inherited = true},
    {field_index, 1, .inherited = true},
    {field_setter, 0, .inherited = true},
    {field_setter, 1, .inherited = true},
    {field_stored, 0, .inherited = true},
    {field_stored, 1, .inherited = true},
  [575] =
    {field_attribute, 8, .inherited = true},
    {field_name, 1},
    {field_name, 2},
    {field_type, 4},
  [579] =
    {field_name, 1},
    {field_name, 2},
    {field_type, 3},
  [582] =
    {field_parent, 4},
    {field_parent, 5},
    {field_parent, 6},
  [585] =
    {field_guid, 6},
    {field_parent, 2},
    {field_parent, 3},
    {field_parent, 4},
    {field_parent, 5},
  [590] =
    {field_parent, 3},
    {field_parent, 4},
    {field_parent, 5},
    {field_parent, 6},
  [594] =
    {field_parent, 5},
    {field_parent, 6},
  [596] =
    {field_args, 3},
    {field_assign, 7},
    {field_attribute, 9, .inherited = true},
    {field_name, 2},
    {field_resultName, 4},
    {field_type, 6},
  [602] =
    {field_args, 4},
    {field_assign, 7},
    {field_attribute, 9, .inherited = true},
    {field_name, 3},
    {field_type, 6},
  [607] =
    {field_implements, 0},
    {field_implements, 1},
    {field_implements, 2},
  [610] =
    {field_attribute, 6, .inherited = true},
    {field_defaultValue, 4, .inherited = true},
    {field_getter, 4, .inherited = true},
    {field_implements, 4, .inherited = true},
    {field_index, 4, .inherited = true},
    {field_name, 1},
    {field_setter, 4, .inherited = true},
    {field_stored, 4, .inherited = true},
    {field_type, 3},
  [619] =
    {field_args, 2},
    {field_defaultValue, 5, .inherited = true},
    {field_getter, 5, .inherited = true},
    {field_implements, 5, .inherited = true},
    {field_index, 5, .inherited = true},
    {field_name, 1},
    {field_setter, 5, .inherited = true},
    {field_stored, 5, .inherited = true},
    {field_type, 4},
  [628] =
    {field_defaultValue, 5, .inherited = true},
    {field_getter, 5, .inherited = true},
    {field_implements, 5, .inherited = true},
    {field_index, 5, .inherited = true},
    {field_name, 2},
    {field_setter, 5, .inherited = true},
    {field_stored, 5, .inherited = true},
    {field_type, 4},
  [636] =
    {field_parent, 4},
    {field_parent, 5},
    {field_parent, 6},
    {field_parent, 7},
  [640] =
    {field_parent, 5},
    {field_parent, 6},
    {field_parent, 7},
  [643] =
    {field_args, 2},
    {field_attribute, 7, .inherited = true},
    {field_defaultValue, 5, .inherited = true},
    {field_getter, 5, .inherited = true},
    {field_implements, 5, .inherited = true},
    {field_index, 5, .inherited = true},
    {field_name, 1},
    {field_setter, 5, .inherited = true},
    {field_stored, 5, .inherited = true},
    {field_type, 4},
  [653] =
    {field_attribute, 7, .inherited = true},
    {field_defaultValue, 5, .inherited = true},
    {field_getter, 5, .inherited = true},
    {field_implements, 5, .inherited = true},
    {field_index, 5, .inherited = true},
    {field_name, 2},
    {field_setter, 5, .inherited = true},
    {field_stored, 5, .inherited = true},
    {field_type, 4},
  [662] =
    {field_args, 3},
    {field_defaultValue, 6, .inherited = true},
    {field_getter, 6, .inherited = true},
    {field_implements, 6, .inherited = true},
    {field_index, 6, .inherited = true},
    {field_name, 2},
    {field_setter, 6, .inherited = true},
    {field_stored, 6, .inherited = true},
    {field_type, 5},
  [671] =
    {field_defaultValue, 6, .inherited = true},
    {field_getter, 6, .inherited = true},
    {field_implements, 6, .inherited = true},
    {field_index, 6, .inherited = true},
    {field_name, 3},
    {field_setter, 6, .inherited = true},
    {field_stored, 6, .inherited = true},
    {field_type, 5},
  [679] =
    {field_parent, 5},
    {field_parent, 6},
    {field_parent, 7},
    {field_parent, 8},
  [683] =
    {field_args, 3},
    {field_attribute, 8, .inherited = true},
    {field_defaultValue, 6, .inherited = true},
    {field_getter, 6, .inherited = true},
    {field_implements, 6, .inherited = true},
    {field_index, 6, .inherited = true},
    {field_name, 2},
    {field_setter, 6, .inherited = true},
    {field_stored, 6, .inherited = true},
    {field_type, 5},
  [693] =
    {field_attribute, 8, .inherited = true},
    {field_defaultValue, 6, .inherited = true},
    {field_getter, 6, .inherited = true},
    {field_implements, 6, .inherited = true},
    {field_index, 6, .inherited = true},
    {field_name, 3},
    {field_setter, 6, .inherited = true},
    {field_stored, 6, .inherited = true},
    {field_type, 5},
  [702] =
    {field_args, 4},
    {field_defaultValue, 7, .inherited = true},
    {field_getter, 7, .inherited = true},
    {field_implements, 7, .inherited = true},
    {field_index, 7, .inherited = true},
    {field_name, 3},
    {field_setter, 7, .inherited = true},
    {field_stored, 7, .inherited = true},
    {field_type, 6},
  [711] =
    {field_args, 4},
    {field_attribute, 9, .inherited = true},
    {field_defaultValue, 7, .inherited = true},
    {field_getter, 7, .inherited = true},
    {field_implements, 7, .inherited = true},
    {field_index, 7, .inherited = true},
    {field_name, 3},
    {field_setter, 7, .inherited = true},
    {field_stored, 7, .inherited = true},
    {field_type, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = sym_identifier,
  },
  [4] = {
    [0] = sym_if,
  },
  [5] = {
    [0] = sym_block,
  },
  [10] = {
    [1] = sym_block,
  },
  [15] = {
    [1] = sym_block,
  },
  [19] = {
    [2] = sym_block,
  },
  [21] = {
    [2] = sym_block,
  },
  [36] = {
    [2] = sym_block,
  },
  [42] = {
    [3] = sym_block,
  },
  [44] = {
    [3] = sym_block,
  },
  [47] = {
    [3] = sym_block,
  },
  [74] = {
    [2] = sym_block,
  },
  [76] = {
    [4] = sym_block,
  },
  [79] = {
    [4] = sym_block,
  },
  [82] = {
    [4] = sym_block,
  },
  [113] = {
    [2] = sym_block,
  },
  [116] = {
    [3] = sym_block,
  },
  [119] = {
    [5] = sym_block,
  },
  [155] = {
    [3] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_if, 2,
    sym_if,
    sym_if,
  sym_blockTr, 2,
    sym_blockTr,
    sym_block,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 12,
  [19] = 19,
  [20] = 20,
  [21] = 10,
  [22] = 13,
  [23] = 16,
  [24] = 14,
  [25] = 15,
  [26] = 26,
  [27] = 20,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 17,
  [36] = 36,
  [37] = 9,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 40,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 40,
  [49] = 40,
  [50] = 40,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 54,
  [57] = 57,
  [58] = 58,
  [59] = 58,
  [60] = 60,
  [61] = 58,
  [62] = 58,
  [63] = 60,
  [64] = 58,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 58,
  [91] = 58,
  [92] = 92,
  [93] = 60,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 67,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 84,
  [128] = 80,
  [129] = 71,
  [130] = 86,
  [131] = 131,
  [132] = 58,
  [133] = 73,
  [134] = 134,
  [135] = 135,
  [136] = 75,
  [137] = 76,
  [138] = 77,
  [139] = 139,
  [140] = 65,
  [141] = 81,
  [142] = 142,
  [143] = 58,
  [144] = 144,
  [145] = 145,
  [146] = 60,
  [147] = 83,
  [148] = 89,
  [149] = 78,
  [150] = 74,
  [151] = 87,
  [152] = 68,
  [153] = 88,
  [154] = 69,
  [155] = 70,
  [156] = 72,
  [157] = 82,
  [158] = 79,
  [159] = 85,
  [160] = 66,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 107,
  [223] = 96,
  [224] = 95,
  [225] = 225,
  [226] = 114,
  [227] = 113,
  [228] = 97,
  [229] = 102,
  [230] = 101,
  [231] = 108,
  [232] = 100,
  [233] = 233,
  [234] = 99,
  [235] = 122,
  [236] = 117,
  [237] = 118,
  [238] = 116,
  [239] = 105,
  [240] = 111,
  [241] = 109,
  [242] = 104,
  [243] = 243,
  [244] = 103,
  [245] = 121,
  [246] = 185,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 251,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 275,
  [278] = 274,
  [279] = 279,
  [280] = 269,
  [281] = 189,
  [282] = 268,
  [283] = 267,
  [284] = 191,
  [285] = 279,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 266,
  [291] = 192,
  [292] = 165,
  [293] = 205,
  [294] = 264,
  [295] = 263,
  [296] = 258,
  [297] = 183,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 181,
  [305] = 173,
  [306] = 166,
  [307] = 256,
  [308] = 198,
  [309] = 182,
  [310] = 180,
  [311] = 214,
  [312] = 312,
  [313] = 255,
  [314] = 221,
  [315] = 220,
  [316] = 219,
  [317] = 218,
  [318] = 318,
  [319] = 216,
  [320] = 213,
  [321] = 252,
  [322] = 211,
  [323] = 247,
  [324] = 204,
  [325] = 203,
  [326] = 197,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 196,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 248,
  [339] = 178,
  [340] = 193,
  [341] = 167,
  [342] = 168,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 344,
  [348] = 343,
  [349] = 346,
  [350] = 345,
  [351] = 169,
  [352] = 170,
  [353] = 171,
  [354] = 172,
  [355] = 249,
  [356] = 174,
  [357] = 175,
  [358] = 177,
  [359] = 334,
  [360] = 333,
  [361] = 331,
  [362] = 329,
  [363] = 328,
  [364] = 327,
  [365] = 206,
  [366] = 207,
  [367] = 208,
  [368] = 303,
  [369] = 337,
  [370] = 336,
  [371] = 335,
  [372] = 332,
  [373] = 302,
  [374] = 301,
  [375] = 300,
  [376] = 299,
  [377] = 298,
  [378] = 209,
  [379] = 210,
  [380] = 318,
  [381] = 212,
  [382] = 215,
  [383] = 250,
  [384] = 217,
  [385] = 253,
  [386] = 289,
  [387] = 254,
  [388] = 288,
  [389] = 287,
  [390] = 286,
  [391] = 195,
  [392] = 276,
  [393] = 273,
  [394] = 272,
  [395] = 259,
  [396] = 271,
  [397] = 201,
  [398] = 260,
  [399] = 312,
  [400] = 261,
  [401] = 200,
  [402] = 262,
  [403] = 199,
  [404] = 265,
  [405] = 257,
  [406] = 187,
  [407] = 112,
  [408] = 190,
  [409] = 184,
  [410] = 221,
  [411] = 183,
  [412] = 181,
  [413] = 173,
  [414] = 220,
  [415] = 219,
  [416] = 218,
  [417] = 186,
  [418] = 192,
  [419] = 110,
  [420] = 191,
  [421] = 165,
  [422] = 205,
  [423] = 200,
  [424] = 216,
  [425] = 213,
  [426] = 211,
  [427] = 199,
  [428] = 204,
  [429] = 180,
  [430] = 430,
  [431] = 431,
  [432] = 168,
  [433] = 201,
  [434] = 166,
  [435] = 167,
  [436] = 193,
  [437] = 437,
  [438] = 203,
  [439] = 106,
  [440] = 185,
  [441] = 197,
  [442] = 202,
  [443] = 443,
  [444] = 196,
  [445] = 177,
  [446] = 178,
  [447] = 187,
  [448] = 175,
  [449] = 174,
  [450] = 206,
  [451] = 188,
  [452] = 120,
  [453] = 207,
  [454] = 208,
  [455] = 195,
  [456] = 194,
  [457] = 457,
  [458] = 169,
  [459] = 170,
  [460] = 171,
  [461] = 189,
  [462] = 209,
  [463] = 210,
  [464] = 214,
  [465] = 172,
  [466] = 212,
  [467] = 182,
  [468] = 98,
  [469] = 215,
  [470] = 217,
  [471] = 198,
  [472] = 243,
  [473] = 473,
  [474] = 331,
  [475] = 289,
  [476] = 288,
  [477] = 287,
  [478] = 286,
  [479] = 318,
  [480] = 337,
  [481] = 312,
  [482] = 457,
  [483] = 336,
  [484] = 298,
  [485] = 299,
  [486] = 430,
  [487] = 300,
  [488] = 301,
  [489] = 302,
  [490] = 276,
  [491] = 273,
  [492] = 431,
  [493] = 272,
  [494] = 437,
  [495] = 443,
  [496] = 271,
  [497] = 303,
  [498] = 257,
  [499] = 335,
  [500] = 332,
  [501] = 334,
  [502] = 333,
  [503] = 343,
  [504] = 504,
  [505] = 329,
  [506] = 344,
  [507] = 265,
  [508] = 328,
  [509] = 346,
  [510] = 345,
  [511] = 327,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 60,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 457,
  [522] = 522,
  [523] = 431,
  [524] = 524,
  [525] = 525,
  [526] = 443,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 58,
  [532] = 504,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 437,
  [537] = 537,
  [538] = 430,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 58,
  [545] = 545,
  [546] = 546,
  [547] = 58,
  [548] = 60,
  [549] = 58,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 559,
  [564] = 558,
  [565] = 561,
  [566] = 562,
  [567] = 176,
  [568] = 555,
  [569] = 556,
  [570] = 559,
  [571] = 556,
  [572] = 555,
  [573] = 558,
  [574] = 554,
  [575] = 554,
  [576] = 560,
  [577] = 561,
  [578] = 562,
  [579] = 179,
  [580] = 560,
  [581] = 556,
  [582] = 555,
  [583] = 179,
  [584] = 558,
  [585] = 554,
  [586] = 559,
  [587] = 561,
  [588] = 562,
  [589] = 560,
  [590] = 176,
  [591] = 591,
  [592] = 592,
  [593] = 591,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 602,
  [605] = 605,
  [606] = 597,
  [607] = 599,
  [608] = 601,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 609,
  [613] = 613,
  [614] = 614,
  [615] = 614,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 614,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 622,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 622,
  [630] = 630,
  [631] = 631,
  [632] = 555,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 558,
  [638] = 638,
  [639] = 556,
  [640] = 554,
  [641] = 560,
  [642] = 561,
  [643] = 562,
  [644] = 176,
  [645] = 559,
  [646] = 179,
  [647] = 647,
  [648] = 648,
  [649] = 631,
  [650] = 592,
  [651] = 651,
  [652] = 652,
  [653] = 561,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 654,
  [661] = 651,
  [662] = 657,
  [663] = 559,
  [664] = 560,
  [665] = 665,
  [666] = 554,
  [667] = 667,
  [668] = 562,
  [669] = 669,
  [670] = 659,
  [671] = 179,
  [672] = 672,
  [673] = 558,
  [674] = 176,
  [675] = 652,
  [676] = 676,
  [677] = 669,
  [678] = 654,
  [679] = 679,
  [680] = 652,
  [681] = 598,
  [682] = 654,
  [683] = 683,
  [684] = 652,
  [685] = 652,
  [686] = 556,
  [687] = 591,
  [688] = 654,
  [689] = 591,
  [690] = 555,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 697,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 697,
  [721] = 704,
  [722] = 601,
  [723] = 599,
  [724] = 697,
  [725] = 704,
  [726] = 726,
  [727] = 727,
  [728] = 697,
  [729] = 704,
  [730] = 730,
  [731] = 731,
  [732] = 597,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 735,
  [737] = 694,
  [738] = 738,
  [739] = 704,
  [740] = 225,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 758,
  [760] = 760,
  [761] = 758,
  [762] = 762,
  [763] = 758,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 758,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 762,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 762,
  [783] = 233,
  [784] = 758,
  [785] = 762,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 780,
  [790] = 762,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 762,
  [797] = 797,
  [798] = 798,
  [799] = 792,
  [800] = 762,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 762,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 815,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 810,
  [831] = 831,
  [832] = 823,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 822,
  [838] = 824,
  [839] = 829,
  [840] = 829,
  [841] = 827,
  [842] = 829,
  [843] = 831,
  [844] = 810,
  [845] = 828,
  [846] = 828,
  [847] = 810,
  [848] = 827,
  [849] = 829,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 831,
  [856] = 856,
  [857] = 820,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 850,
  [863] = 863,
  [864] = 828,
  [865] = 810,
  [866] = 866,
  [867] = 858,
  [868] = 868,
  [869] = 833,
  [870] = 810,
  [871] = 828,
  [872] = 820,
  [873] = 873,
  [874] = 829,
  [875] = 850,
  [876] = 876,
  [877] = 860,
  [878] = 853,
  [879] = 879,
  [880] = 834,
  [881] = 820,
  [882] = 853,
  [883] = 863,
  [884] = 884,
  [885] = 827,
  [886] = 828,
  [887] = 810,
  [888] = 831,
  [889] = 820,
  [890] = 829,
  [891] = 831,
  [892] = 829,
  [893] = 826,
  [894] = 868,
  [895] = 873,
  [896] = 817,
  [897] = 853,
  [898] = 831,
  [899] = 853,
  [900] = 853,
  [901] = 828,
  [902] = 827,
  [903] = 828,
  [904] = 827,
  [905] = 821,
  [906] = 810,
  [907] = 233,
  [908] = 225,
  [909] = 601,
  [910] = 599,
  [911] = 911,
  [912] = 597,
  [913] = 913,
  [914] = 473,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 917,
  [919] = 919,
  [920] = 915,
  [921] = 915,
  [922] = 598,
  [923] = 591,
  [924] = 528,
  [925] = 915,
  [926] = 915,
  [927] = 927,
  [928] = 915,
  [929] = 592,
  [930] = 597,
  [931] = 524,
  [932] = 512,
  [933] = 540,
  [934] = 599,
  [935] = 935,
  [936] = 541,
  [937] = 546,
  [938] = 517,
  [939] = 519,
  [940] = 545,
  [941] = 941,
  [942] = 942,
  [943] = 601,
  [944] = 522,
  [945] = 530,
  [946] = 525,
  [947] = 529,
  [948] = 942,
  [949] = 514,
  [950] = 515,
  [951] = 518,
  [952] = 535,
  [953] = 520,
  [954] = 542,
  [955] = 543,
  [956] = 533,
  [957] = 957,
  [958] = 537,
  [959] = 959,
  [960] = 539,
  [961] = 527,
  [962] = 504,
  [963] = 473,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 935,
  [969] = 941,
  [970] = 970,
  [971] = 971,
  [972] = 591,
  [973] = 973,
  [974] = 974,
  [975] = 528,
  [976] = 976,
  [977] = 971,
  [978] = 971,
  [979] = 598,
  [980] = 971,
  [981] = 592,
  [982] = 971,
  [983] = 919,
  [984] = 984,
  [985] = 971,
  [986] = 529,
  [987] = 514,
  [988] = 539,
  [989] = 524,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 543,
  [994] = 542,
  [995] = 535,
  [996] = 996,
  [997] = 525,
  [998] = 522,
  [999] = 999,
  [1000] = 1000,
  [1001] = 601,
  [1002] = 537,
  [1003] = 512,
  [1004] = 540,
  [1005] = 599,
  [1006] = 597,
  [1007] = 541,
  [1008] = 546,
  [1009] = 517,
  [1010] = 1000,
  [1011] = 519,
  [1012] = 545,
  [1013] = 1013,
  [1014] = 996,
  [1015] = 996,
  [1016] = 1016,
  [1017] = 996,
  [1018] = 530,
  [1019] = 1000,
  [1020] = 992,
  [1021] = 991,
  [1022] = 1022,
  [1023] = 1016,
  [1024] = 515,
  [1025] = 1025,
  [1026] = 518,
  [1027] = 527,
  [1028] = 520,
  [1029] = 974,
  [1030] = 1000,
  [1031] = 1025,
  [1032] = 533,
  [1033] = 504,
  [1034] = 992,
  [1035] = 1025,
  [1036] = 991,
  [1037] = 992,
  [1038] = 1000,
  [1039] = 991,
  [1040] = 991,
  [1041] = 992,
  [1042] = 996,
  [1043] = 1016,
  [1044] = 1025,
  [1045] = 1045,
  [1046] = 1016,
  [1047] = 1016,
  [1048] = 1048,
  [1049] = 991,
  [1050] = 1025,
  [1051] = 992,
  [1052] = 1000,
  [1053] = 996,
  [1054] = 1016,
  [1055] = 1025,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 233,
  [1070] = 225,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 233,
  [1079] = 1079,
  [1080] = 1068,
  [1081] = 225,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1077,
  [1085] = 1085,
  [1086] = 1075,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1074,
  [1090] = 1090,
  [1091] = 473,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1082,
  [1102] = 1088,
  [1103] = 1103,
  [1104] = 1083,
  [1105] = 1087,
  [1106] = 598,
  [1107] = 528,
  [1108] = 1108,
  [1109] = 473,
  [1110] = 1108,
  [1111] = 1111,
  [1112] = 592,
  [1113] = 1108,
  [1114] = 591,
  [1115] = 1115,
  [1116] = 1085,
  [1117] = 1117,
  [1118] = 1115,
  [1119] = 1115,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 520,
  [1123] = 514,
  [1124] = 518,
  [1125] = 515,
  [1126] = 1126,
  [1127] = 1098,
  [1128] = 1094,
  [1129] = 1092,
  [1130] = 530,
  [1131] = 533,
  [1132] = 1095,
  [1133] = 592,
  [1134] = 591,
  [1135] = 1135,
  [1136] = 598,
  [1137] = 545,
  [1138] = 1096,
  [1139] = 528,
  [1140] = 519,
  [1141] = 1126,
  [1142] = 517,
  [1143] = 1143,
  [1144] = 546,
  [1145] = 541,
  [1146] = 597,
  [1147] = 599,
  [1148] = 1148,
  [1149] = 540,
  [1150] = 512,
  [1151] = 537,
  [1152] = 601,
  [1153] = 1153,
  [1154] = 1143,
  [1155] = 522,
  [1156] = 525,
  [1157] = 529,
  [1158] = 535,
  [1159] = 542,
  [1160] = 543,
  [1161] = 1161,
  [1162] = 524,
  [1163] = 539,
  [1164] = 1121,
  [1165] = 527,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 524,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1135,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1170,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 543,
  [1196] = 1167,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1168,
  [1206] = 1180,
  [1207] = 1207,
  [1208] = 1176,
  [1209] = 1209,
  [1210] = 1194,
  [1211] = 1211,
  [1212] = 1175,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 542,
  [1217] = 535,
  [1218] = 1202,
  [1219] = 1169,
  [1220] = 1220,
  [1221] = 1199,
  [1222] = 1179,
  [1223] = 1153,
  [1224] = 1161,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1203,
  [1228] = 1171,
  [1229] = 1229,
  [1230] = 1193,
  [1231] = 1204,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1166,
  [1235] = 1193,
  [1236] = 1236,
  [1237] = 1187,
  [1238] = 533,
  [1239] = 1239,
  [1240] = 520,
  [1241] = 1186,
  [1242] = 529,
  [1243] = 1229,
  [1244] = 525,
  [1245] = 518,
  [1246] = 1179,
  [1247] = 1247,
  [1248] = 504,
  [1249] = 1187,
  [1250] = 515,
  [1251] = 1251,
  [1252] = 514,
  [1253] = 530,
  [1254] = 1254,
  [1255] = 1190,
  [1256] = 1232,
  [1257] = 1189,
  [1258] = 545,
  [1259] = 1183,
  [1260] = 1186,
  [1261] = 519,
  [1262] = 517,
  [1263] = 527,
  [1264] = 1254,
  [1265] = 1185,
  [1266] = 1236,
  [1267] = 546,
  [1268] = 1233,
  [1269] = 539,
  [1270] = 1251,
  [1271] = 541,
  [1272] = 1207,
  [1273] = 597,
  [1274] = 599,
  [1275] = 540,
  [1276] = 1171,
  [1277] = 512,
  [1278] = 537,
  [1279] = 601,
  [1280] = 1226,
  [1281] = 1229,
  [1282] = 522,
  [1283] = 1204,
  [1284] = 1168,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1285,
  [1291] = 1291,
  [1292] = 1291,
  [1293] = 1293,
  [1294] = 1287,
  [1295] = 1289,
  [1296] = 1293,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1308,
  [1313] = 1313,
  [1314] = 1310,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1320,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1321,
  [1330] = 1317,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1320,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1321,
  [1341] = 1339,
  [1342] = 1342,
  [1343] = 1321,
  [1344] = 1320,
  [1345] = 1320,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1321,
  [1354] = 1347,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1166,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1360,
  [1367] = 1363,
  [1368] = 1368,
  [1369] = 1358,
  [1370] = 1370,
  [1371] = 1364,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1377,
  [1379] = 1374,
  [1380] = 1380,
  [1381] = 601,
  [1382] = 1382,
  [1383] = 601,
  [1384] = 1375,
  [1385] = 1372,
  [1386] = 1380,
  [1387] = 1375,
  [1388] = 1377,
  [1389] = 1389,
  [1390] = 601,
  [1391] = 601,
  [1392] = 1375,
  [1393] = 1393,
  [1394] = 1382,
  [1395] = 1377,
  [1396] = 1396,
  [1397] = 1375,
  [1398] = 1398,
  [1399] = 601,
  [1400] = 1400,
  [1401] = 1377,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1377,
  [1406] = 1406,
  [1407] = 1309,
  [1408] = 1305,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1415,
  [1417] = 1415,
  [1418] = 1415,
  [1419] = 1402,
  [1420] = 1415,
  [1421] = 1415,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1100,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1090,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1099,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1499,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1494,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1536,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1547,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1550,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1544,
  [1557] = 1544,
  [1558] = 1558,
  [1559] = 1534,
  [1560] = 1534,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1558,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1561,
  [1572] = 1568,
  [1573] = 1569,
  [1574] = 1574,
  [1575] = 1563,
  [1576] = 1553,
  [1577] = 1533,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1579,
  [1581] = 1574,
  [1582] = 1532,
  [1583] = 1561,
  [1584] = 1567,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1596,
  [1601] = 1599,
  [1602] = 1592,
  [1603] = 1603,
  [1604] = 1598,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1592,
  [1611] = 1611,
  [1612] = 1603,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1589,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1596,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1609,
  [1628] = 1597,
  [1629] = 1624,
  [1630] = 1621,
  [1631] = 1607,
  [1632] = 1588,
  [1633] = 1589,
  [1634] = 1599,
  [1635] = 1597,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1609,
  [1639] = 1597,
  [1640] = 1598,
  [1641] = 1597,
  [1642] = 1607,
  [1643] = 1599,
  [1644] = 1599,
  [1645] = 1645,
  [1646] = 1594,
  [1647] = 1593,
  [1648] = 1605,
  [1649] = 1626,
  [1650] = 1599,
  [1651] = 1606,
  [1652] = 1597,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1654,
  [1657] = 1654,
  [1658] = 1654,
  [1659] = 1654,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1669,
  [1671] = 1671,
  [1672] = 1666,
  [1673] = 550,
  [1674] = 551,
  [1675] = 1667,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 553,
  [1679] = 1679,
  [1680] = 552,
  [1681] = 1447,
  [1682] = 1668,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1446,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 557,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1671,
  [1697] = 1694,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1665,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1677,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1694,
  [1715] = 1715,
  [1716] = 1713,
  [1717] = 1713,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1706,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1066,
  [1732] = 1449,
  [1733] = 1733,
  [1734] = 1728,
  [1735] = 1730,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1737,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1067,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1739,
  [1756] = 1726,
  [1757] = 1757,
  [1758] = 1753,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1747,
  [1762] = 1762,
  [1763] = 1729,
  [1764] = 1754,
  [1765] = 1729,
  [1766] = 1766,
  [1767] = 1743,
  [1768] = 1766,
  [1769] = 1769,
  [1770] = 1737,
  [1771] = 1730,
  [1772] = 1450,
  [1773] = 1754,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1736,
  [1779] = 1061,
  [1780] = 1743,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1753,
  [1785] = 1750,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1787,
  [1789] = 1747,
  [1790] = 1724,
  [1791] = 1791,
  [1792] = 1739,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1760,
  [1796] = 1746,
  [1797] = 1744,
  [1798] = 1787,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1802,
  [1806] = 1802,
  [1807] = 1804,
  [1808] = 1808,
  [1809] = 1803,
  [1810] = 1801,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1799,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1454,
  [1823] = 1453,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1817,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1804,
  [1830] = 1830,
  [1831] = 1800,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1803,
  [1835] = 1835,
  [1836] = 1458,
  [1837] = 1812,
  [1838] = 1811,
  [1839] = 1839,
  [1840] = 1821,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1825,
  [1844] = 1825,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1816,
  [1848] = 1818,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1845,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1820,
  [1861] = 1833,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1841,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1742,
  [1874] = 1811,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1866,
  [1879] = 1879,
  [1880] = 1451,
  [1881] = 1881,
  [1882] = 1814,
  [1883] = 1799,
  [1884] = 1816,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1857,
  [1888] = 1812,
  [1889] = 1889,
  [1890] = 1825,
  [1891] = 1891,
  [1892] = 1800,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1891,
  [1897] = 1825,
  [1898] = 1898,
  [1899] = 1899,
  [1900] = 1817,
  [1901] = 1852,
  [1902] = 1801,
  [1903] = 1814,
  [1904] = 1904,
  [1905] = 1819,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1879,
  [1909] = 1909,
  [1910] = 1820,
  [1911] = 1833,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1455,
  [1915] = 1459,
  [1916] = 1794,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1818,
  [1920] = 1920,
  [1921] = 1462,
  [1922] = 1922,
  [1923] = 1460,
  [1924] = 1924,
  [1925] = 1478,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1926,
  [1941] = 1941,
  [1942] = 1461,
  [1943] = 1482,
  [1944] = 1479,
  [1945] = 1473,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1947,
  [1949] = 1938,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1933,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1477,
  [1963] = 1963,
  [1964] = 1470,
  [1965] = 1965,
  [1966] = 1465,
  [1967] = 1464,
  [1968] = 1968,
  [1969] = 1469,
  [1970] = 1468,
  [1971] = 1471,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1920,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1982,
  [1996] = 1996,
  [1997] = 1993,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 2002,
  [2003] = 1974,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 1931,
  [2012] = 2012,
  [2013] = 1929,
  [2014] = 2014,
  [2015] = 1472,
  [2016] = 1993,
  [2017] = 1474,
  [2018] = 1476,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 1974,
  [2023] = 1979,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 1999,
  [2029] = 1475,
  [2030] = 2001,
  [2031] = 1467,
  [2032] = 1974,
  [2033] = 1463,
  [2034] = 1466,
  [2035] = 1986,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 1993,
  [2040] = 1977,
  [2041] = 2036,
  [2042] = 2042,
  [2043] = 1480,
  [2044] = 1961,
  [2045] = 1481,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 1929,
  [2056] = 1922,
  [2057] = 2047,
  [2058] = 2058,
  [2059] = 1937,
  [2060] = 2060,
  [2061] = 2061,
  [2062] = 1955,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 1927,
  [2068] = 2050,
  [2069] = 2069,
  [2070] = 1994,
  [2071] = 2053,
  [2072] = 2072,
  [2073] = 1993,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 1974,
  [2080] = 2058,
  [2081] = 2058,
  [2082] = 1955,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2038,
  [2088] = 2088,
  [2089] = 1960,
  [2090] = 2090,
  [2091] = 1979,
  [2092] = 2092,
  [2093] = 1959,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2064,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2130,
  [2146] = 2146,
  [2147] = 2139,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2149,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2111,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2183,
  [2185] = 2181,
  [2186] = 2180,
  [2187] = 2153,
  [2188] = 2178,
  [2189] = 2150,
  [2190] = 2176,
  [2191] = 2191,
  [2192] = 2110,
  [2193] = 2149,
  [2194] = 2139,
  [2195] = 2130,
  [2196] = 2142,
  [2197] = 2141,
  [2198] = 2198,
  [2199] = 2102,
  [2200] = 2103,
  [2201] = 2104,
  [2202] = 2202,
  [2203] = 2105,
  [2204] = 2204,
  [2205] = 2106,
  [2206] = 2107,
  [2207] = 2113,
  [2208] = 2114,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2142,
  [2212] = 2141,
  [2213] = 2213,
  [2214] = 2144,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2150,
  [2220] = 2170,
  [2221] = 2168,
  [2222] = 2157,
  [2223] = 2109,
  [2224] = 2165,
  [2225] = 2225,
  [2226] = 2100,
  [2227] = 2162,
  [2228] = 2163,
  [2229] = 2229,
  [2230] = 2153,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2156,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2163,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2144,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2162,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2157,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2162,
  [2253] = 2163,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2157,
  [2257] = 2155,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2198,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2215,
  [2271] = 2216,
  [2272] = 2191,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2138,
  [2277] = 2144,
  [2278] = 2278,
  [2279] = 2136,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2140,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2144,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2170,
  [2292] = 2292,
  [2293] = 2168,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2202,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2165,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2225,
  [2309] = 2159,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2161,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2303,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2302,
  [2327] = 2231,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2234,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2124,
  [2348] = 2348,
  [2349] = 2182,
  [2350] = 2166,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2113,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2133,
  [2363] = 2167,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2129,
  [2378] = 2378,
  [2379] = 2176,
  [2380] = 2128,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2163,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2171,
  [2390] = 2162,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2120,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2107,
  [2397] = 2119,
  [2398] = 2118,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2287,
  [2404] = 2204,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2249,
  [2408] = 2408,
  [2409] = 2178,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2180,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2181,
  [2419] = 2364,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2106,
  [2423] = 2183,
  [2424] = 2300,
  [2425] = 2266,
  [2426] = 2317,
  [2427] = 2173,
  [2428] = 2428,
  [2429] = 2400,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2105,
  [2434] = 2295,
  [2435] = 2255,
  [2436] = 2175,
  [2437] = 2336,
  [2438] = 2177,
  [2439] = 2417,
  [2440] = 2440,
  [2441] = 2258,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 2364,
  [2445] = 2445,
  [2446] = 2300,
  [2447] = 2157,
  [2448] = 2317,
  [2449] = 2400,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2103,
  [2453] = 2453,
  [2454] = 2101,
  [2455] = 2104,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2112,
  [2459] = 2459,
  [2460] = 2155,
  [2461] = 2102,
  [2462] = 2121,
  [2463] = 2337,
  [2464] = 2299,
  [2465] = 2114,
  [2466] = 2466,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(41);
      if (lookahead == '#') ADVANCE(59);
      if (lookahead == '&') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(11);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(45);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(44);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(71);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(76);
      if (lookahead == '@') ADVANCE(89);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == ']') ADVANCE(52);
      if (lookahead == '^') ADVANCE(90);
      if (lookahead == '{') ADVANCE(3);
      if (lookahead == '$' ||
          lookahead == '%') ADVANCE(48);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 1:
      if (lookahead == '#') ADVANCE(59);
      if (lookahead == '$') ADVANCE(37);
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '\'') ADVANCE(11);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '+') ADVANCE(80);
      if (lookahead == ',') ADVANCE(45);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(43);
      if (lookahead == '<') ADVANCE(72);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(76);
      if (lookahead == '@') ADVANCE(89);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == ']') ADVANCE(52);
      if (lookahead == '^') ADVANCE(90);
      if (lookahead == '{') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 2:
      if (lookahead == '#') ADVANCE(59);
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '\'') ADVANCE(11);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(45);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(44);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(72);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(76);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == ']') ADVANCE(52);
      if (lookahead == '^') ADVANCE(90);
      if (lookahead == '{') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 3:
      if (lookahead == '$') ADVANCE(23);
      if (lookahead == '}') ADVANCE(100);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == '$') ADVANCE(37);
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '(') ADVANCE(13);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '+') ADVANCE(19);
      if (lookahead == ',') ADVANCE(45);
      if (lookahead == '-') ADVANCE(20);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == ':') ADVANCE(44);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(70);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(75);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == ']') ADVANCE(52);
      if (lookahead == '{') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 5:
      if (lookahead == '$') ADVANCE(27);
      if (lookahead == '}') ADVANCE(100);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == '$') ADVANCE(30);
      if (lookahead == '}') ADVANCE(100);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 7:
      if (lookahead == '$') ADVANCE(24);
      if (lookahead == '}') ADVANCE(100);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == '&') ADVANCE(49);
      if (lookahead == '(') ADVANCE(14);
      if (lookahead == ')') ADVANCE(50);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '{') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '<') ||
          lookahead == '>' ||
          lookahead == '[' ||
          lookahead == ']') ADVANCE(48);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 9:
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(43);
      if (lookahead == '<') ADVANCE(70);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '{') ADVANCE(7);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 10:
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '^') ADVANCE(90);
      if (lookahead == '{') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 11:
      if (lookahead == '\'') ADVANCE(58);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 13:
      if (lookahead == '*') ADVANCE(15);
      END_STATE();
    case 14:
      if (lookahead == '*') ADVANCE(15);
      if (lookahead != 0) ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == '*') ADVANCE(12);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '/') ADVANCE(101);
      END_STATE();
    case 17:
      if (lookahead == '/') ADVANCE(101);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      END_STATE();
    case 21:
      if (lookahead == '}') ADVANCE(100);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 22:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(32);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 23:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(26);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 24:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 25:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(33);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 26:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(31);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 27:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(26);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 28:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(29);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(22);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 29:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(25);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == '}') ADVANCE(99);
      if (lookahead != 0) ADVANCE(30);
      END_STATE();
    case 31:
      if (lookahead == '}') ADVANCE(55);
      if (lookahead != 0) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '}') ADVANCE(57);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == '}') ADVANCE(56);
      if (lookahead != 0) ADVANCE(33);
      END_STATE();
    case 34:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 38:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 39:
      if (eof) ADVANCE(41);
      if (lookahead == '#') ADVANCE(59);
      if (lookahead == '$') ADVANCE(37);
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '\'') ADVANCE(11);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(79);
      if (lookahead == ',') ADVANCE(45);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(44);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(72);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(76);
      if (lookahead == '@') ADVANCE(89);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == ']') ADVANCE(52);
      if (lookahead == '^') ADVANCE(90);
      if (lookahead == '{') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 40:
      if (eof) ADVANCE(41);
      if (lookahead == '#') ADVANCE(59);
      if (lookahead == '&') ADVANCE(38);
      if (lookahead == '\'') ADVANCE(11);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(45);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(44);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(72);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(76);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == ']') ADVANCE(52);
      if (lookahead == '^') ADVANCE(90);
      if (lookahead == '{') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_asmBody_token1);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_asmBody_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_asmBody_token2);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_asmBody_token2);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_asmBody_token3);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(15);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_type_token1);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_type_token2);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_type_token3);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym__literalString_token1);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym__literalInt_token1);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == 'e') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym__literalInt_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym__literalInt_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym__literalFloat_token1);
      if (lookahead == 'e') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym__literalFloat_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(65);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_kLt);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_kLt);
      if (lookahead == '=') ADVANCE(77);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_kLt);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_kEq);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_kNeq);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_kGt);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_kGt);
      if (lookahead == '=') ADVANCE(78);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_kLte);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_kGte);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_kAdd);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '=') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_kAdd);
      if (lookahead == '.') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_kAdd);
      if (lookahead == '=') ADVANCE(92);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_kSub);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '=') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_kSub);
      if (lookahead == '.') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_kSub);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_kMul);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_kMul);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_kFdiv);
      if (lookahead == '/') ADVANCE(101);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_kFdiv);
      if (lookahead == '/') ADVANCE(101);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_kAt);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_kHat);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_kAssign);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_kAssignAdd);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_kAssignSub);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_kAssignMul);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_kAssignDiv);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym__space);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_pp);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(101);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(2);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(3);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(4);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(5);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(6);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(7);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(8);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(9);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(10);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(11);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(12);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(13);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(14);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(15);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(16);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(17);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(18);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(19);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(20);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(21);
      END_STATE();
    case 1:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(22);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(23);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(24);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(25);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(26);
      END_STATE();
    case 2:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(28);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(29);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(30);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(31);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(32);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(33);
      END_STATE();
    case 4:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(34);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(35);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(36);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(37);
      END_STATE();
    case 5:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(38);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(39);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(40);
      END_STATE();
    case 6:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(41);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(42);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(43);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 7:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 8:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(47);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 9:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(51);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(52);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(53);
      END_STATE();
    case 10:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(54);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(55);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 11:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(57);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(58);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(60);
      END_STATE();
    case 12:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(62);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(63);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(64);
      END_STATE();
    case 13:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(65);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(66);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(67);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(68);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(69);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(70);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(71);
      END_STATE();
    case 14:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(72);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(73);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(74);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(75);
      END_STATE();
    case 15:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(76);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 16:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(78);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(79);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(80);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(82);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(83);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(84);
      END_STATE();
    case 17:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(85);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(86);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(87);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(88);
      END_STATE();
    case 18:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(89);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(90);
      END_STATE();
    case 19:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(91);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(92);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(93);
      END_STATE();
    case 20:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(94);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(95);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 21:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 22:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(98);
      END_STATE();
    case 23:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 24:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      END_STATE();
    case 25:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_kAs);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(102);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(103);
      END_STATE();
    case 27:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(104);
      END_STATE();
    case 28:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(105);
      END_STATE();
    case 29:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 30:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 31:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(108);
      END_STATE();
    case 32:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(109);
      END_STATE();
    case 33:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(110);
      END_STATE();
    case 34:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(111);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(112);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(113);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(114);
      END_STATE();
    case 35:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(115);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_kDo);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(116);
      END_STATE();
    case 37:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 38:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(118);
      END_STATE();
    case 39:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(119);
      END_STATE();
    case 40:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(120);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(121);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(122);
      END_STATE();
    case 41:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(123);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 42:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(125);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 43:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(127);
      END_STATE();
    case 44:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 45:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 46:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(130);
      END_STATE();
    case 47:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 48:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_kIf);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(133);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(134);
      END_STATE();
    case 50:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(135);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_kIn);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(136);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(137);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(138);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(139);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(140);
      END_STATE();
    case 52:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_kIs);
      END_STATE();
    case 54:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(142);
      END_STATE();
    case 55:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(143);
      END_STATE();
    case 56:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(144);
      END_STATE();
    case 57:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(145);
      END_STATE();
    case 58:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(146);
      END_STATE();
    case 59:
      if (lookahead == '_') ADVANCE(147);
      END_STATE();
    case 60:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 61:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(149);
      END_STATE();
    case 62:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 63:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 64:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(152);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(153);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(154);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(155);
      END_STATE();
    case 65:
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(156);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_kOf);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_kOn);
      END_STATE();
    case 68:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(157);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(158);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_kOr);
      END_STATE();
    case 70:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(159);
      END_STATE();
    case 71:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 72:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(161);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(162);
      END_STATE();
    case 73:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 74:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(164);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 75:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(166);
      END_STATE();
    case 76:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(167);
      END_STATE();
    case 77:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(168);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(169);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(170);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(171);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(172);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(173);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(174);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(176);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(177);
      END_STATE();
    case 79:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(178);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(179);
      END_STATE();
    case 80:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(180);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(181);
      END_STATE();
    case 81:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(182);
      END_STATE();
    case 82:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 83:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(184);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(185);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(186);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 84:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(188);
      END_STATE();
    case 85:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(189);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_kTo);
      END_STATE();
    case 87:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(191);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(192);
      END_STATE();
    case 88:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(193);
      END_STATE();
    case 89:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(194);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(195);
      END_STATE();
    case 90:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 91:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 92:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(198);
      END_STATE();
    case 93:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 94:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 95:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(201);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 97:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 98:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(205);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(206);
      END_STATE();
    case 99:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_kAnd);
      END_STATE();
    case 101:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(208);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_kAsm);
      END_STATE();
    case 103:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 104:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(210);
      END_STATE();
    case 105:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(211);
      END_STATE();
    case 106:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(212);
      END_STATE();
    case 107:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(213);
      END_STATE();
    case 108:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(214);
      END_STATE();
    case 109:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(215);
      END_STATE();
    case 110:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 111:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 112:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(218);
      END_STATE();
    case 113:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 114:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(220);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_kDiv);
      END_STATE();
    case 116:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(221);
      END_STATE();
    case 117:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(222);
      END_STATE();
    case 118:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_kEnd);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 120:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(225);
      END_STATE();
    case 121:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(226);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(227);
      END_STATE();
    case 122:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 123:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(229);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_kFar);
      END_STATE();
    case 125:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 126:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(231);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_kFor);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(232);
      END_STATE();
    case 128:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(233);
      END_STATE();
    case 129:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 130:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(235);
      END_STATE();
    case 131:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 132:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(237);
      END_STATE();
    case 133:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 134:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(239);
      END_STATE();
    case 135:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 136:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 137:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 138:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(243);
      END_STATE();
    case 139:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 140:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 141:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(246);
      END_STATE();
    case 142:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(247);
      END_STATE();
    case 143:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 144:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(249);
      END_STATE();
    case 145:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(250);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_kMod);
      END_STATE();
    case 147:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(251);
      END_STATE();
    case 148:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 149:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 150:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(254);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_kNil);
      END_STATE();
    case 152:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 153:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 154:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(257);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_kNot);
      END_STATE();
    case 156:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(258);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(259);
      END_STATE();
    case 157:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(260);
      END_STATE();
    case 158:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_kOut);
      END_STATE();
    case 160:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(262);
      END_STATE();
    case 161:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(263);
      END_STATE();
    case 162:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(264);
      END_STATE();
    case 163:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(265);
      END_STATE();
    case 164:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(266);
      END_STATE();
    case 165:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(267);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(268);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(269);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(270);
      END_STATE();
    case 166:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 167:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(272);
      END_STATE();
    case 168:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(273);
      END_STATE();
    case 169:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(274);
      END_STATE();
    case 170:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 171:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 172:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 173:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 174:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(279);
      END_STATE();
    case 175:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(280);
      END_STATE();
    case 176:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 177:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 178:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_kSet);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_kShl);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_kShr);
      END_STATE();
    case 182:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(284);
      END_STATE();
    case 183:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 184:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(286);
      END_STATE();
    case 185:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(287);
      END_STATE();
    case 186:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 187:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(289);
      END_STATE();
    case 188:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(290);
      END_STATE();
    case 189:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(291);
      END_STATE();
    case 190:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 191:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_kTry);
      END_STATE();
    case 193:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 194:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(295);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(296);
      END_STATE();
    case 195:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 196:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(298);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_kVar);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(299);
      END_STATE();
    case 198:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(300);
      END_STATE();
    case 199:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(301);
      END_STATE();
    case 200:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(302);
      END_STATE();
    case 201:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(303);
      END_STATE();
    case 202:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(304);
      END_STATE();
    case 203:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(305);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_kXor);
      END_STATE();
    case 205:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(306);
      END_STATE();
    case 206:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(307);
      END_STATE();
    case 207:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(308);
      END_STATE();
    case 208:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(309);
      END_STATE();
    case 209:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(310);
      END_STATE();
    case 210:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(311);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_kCase);
      END_STATE();
    case 212:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(312);
      END_STATE();
    case 213:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(313);
      END_STATE();
    case 214:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(314);
      END_STATE();
    case 215:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_kCvar);
      END_STATE();
    case 217:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(316);
      END_STATE();
    case 218:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(317);
      END_STATE();
    case 219:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 220:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(319);
      END_STATE();
    case 221:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(320);
      END_STATE();
    case 222:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(321);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_kElse);
      END_STATE();
    case 224:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(322);
      END_STATE();
    case 225:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(323);
      END_STATE();
    case 226:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 227:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(325);
      END_STATE();
    case 228:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(326);
      END_STATE();
    case 229:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_kFile);
      END_STATE();
    case 231:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(328);
      END_STATE();
    case 232:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(329);
      END_STATE();
    case 233:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(330);
      END_STATE();
    case 234:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(331);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_kGoto);
      END_STATE();
    case 236:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(332);
      END_STATE();
    case 237:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 238:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(334);
      END_STATE();
    case 239:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 240:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 241:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(337);
      END_STATE();
    case 242:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 243:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(339);
      END_STATE();
    case 244:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(340);
      END_STATE();
    case 245:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(341);
      END_STATE();
    case 246:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(342);
      END_STATE();
    case 247:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(343);
      END_STATE();
    case 248:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(344);
      END_STATE();
    case 249:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(345);
      END_STATE();
    case 250:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(346);
      END_STATE();
    case 251:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(347);
      END_STATE();
    case 252:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(348);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_kName);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_kNear);
      END_STATE();
    case 255:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(349);
      END_STATE();
    case 256:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(350);
      END_STATE();
    case 257:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(351);
      END_STATE();
    case 258:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(352);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(353);
      END_STATE();
    case 259:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(354);
      END_STATE();
    case 260:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(355);
      END_STATE();
    case 261:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(356);
      END_STATE();
    case 262:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(357);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(358);
      END_STATE();
    case 263:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(359);
      END_STATE();
    case 264:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(360);
      END_STATE();
    case 265:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(361);
      END_STATE();
    case 266:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(362);
      END_STATE();
    case 267:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 268:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(364);
      END_STATE();
    case 269:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(365);
      END_STATE();
    case 270:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 271:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(367);
      END_STATE();
    case 272:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_kRead);
      END_STATE();
    case 274:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(369);
      END_STATE();
    case 275:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 276:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(371);
      END_STATE();
    case 277:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(372);
      END_STATE();
    case 278:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(373);
      END_STATE();
    case 279:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 280:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(375);
      END_STATE();
    case 281:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(376);
      END_STATE();
    case 282:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(377);
      END_STATE();
    case 283:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(378);
      END_STATE();
    case 284:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(379);
      END_STATE();
    case 285:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 286:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(381);
      END_STATE();
    case 287:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(382);
      END_STATE();
    case 288:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(383);
      END_STATE();
    case 289:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(384);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(385);
      END_STATE();
    case 290:
      if (lookahead == '_') ADVANCE(386);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_kThen);
      END_STATE();
    case 292:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(387);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_kTrue);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_kType);
      END_STATE();
    case 295:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(388);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_kUnit);
      END_STATE();
    case 297:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(389);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_kUses);
      END_STATE();
    case 299:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 300:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(391);
      END_STATE();
    case 301:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(392);
      END_STATE();
    case 302:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(393);
      END_STATE();
    case 303:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(394);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_kWith);
      END_STATE();
    case 305:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 306:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(396);
      END_STATE();
    case 307:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(397);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_kAlias);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_kArray);
      END_STATE();
    case 310:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(398);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_kBegin);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_kCdecl);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_kClass);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_kConst);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(399);
      END_STATE();
    case 315:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(400);
      END_STATE();
    case 316:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(401);
      END_STATE();
    case 317:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(402);
      END_STATE();
    case 318:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(403);
      END_STATE();
    case 319:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(404);
      END_STATE();
    case 320:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(405);
      END_STATE();
    case 321:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(406);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_kEndif);
      END_STATE();
    case 323:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(407);
      END_STATE();
    case 324:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(408);
      END_STATE();
    case 325:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(409);
      END_STATE();
    case 326:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(410);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_kFalse);
      END_STATE();
    case 328:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(411);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(412);
      END_STATE();
    case 329:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 330:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(414);
      END_STATE();
    case 331:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(415);
      END_STATE();
    case 332:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(416);
      END_STATE();
    case 333:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(417);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_kIfdef);
      END_STATE();
    case 335:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(418);
      END_STATE();
    case 336:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(419);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_kIndex);
      END_STATE();
    case 338:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(420);
      END_STATE();
    case 339:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(421);
      END_STATE();
    case 340:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 341:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(423);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(424);
      END_STATE();
    case 342:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(425);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_kLabel);
      END_STATE();
    case 344:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(426);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_kLocal);
      END_STATE();
    case 346:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(427);
      END_STATE();
    case 347:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(428);
      END_STATE();
    case 348:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(429);
      END_STATE();
    case 349:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 350:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(431);
      END_STATE();
    case 351:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(432);
      END_STATE();
    case 352:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(433);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(434);
      END_STATE();
    case 353:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(435);
      END_STATE();
    case 354:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(436);
      END_STATE();
    case 355:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(437);
      END_STATE();
    case 356:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(438);
      END_STATE();
    case 357:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(439);
      END_STATE();
    case 358:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(440);
      END_STATE();
    case 359:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(441);
      END_STATE();
    case 360:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(442);
      END_STATE();
    case 361:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(443);
      END_STATE();
    case 362:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(444);
      END_STATE();
    case 363:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(445);
      END_STATE();
    case 364:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(446);
      END_STATE();
    case 365:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(447);
      END_STATE();
    case 366:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(448);
      END_STATE();
    case 367:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(449);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(450);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_kRaise);
      END_STATE();
    case 369:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(451);
      END_STATE();
    case 370:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(452);
      END_STATE();
    case 371:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(453);
      END_STATE();
    case 372:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(454);
      END_STATE();
    case 373:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(455);
      END_STATE();
    case 374:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(456);
      END_STATE();
    case 375:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(457);
      END_STATE();
    case 376:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(458);
      END_STATE();
    case 377:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_kSealed);
      END_STATE();
    case 379:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(460);
      END_STATE();
    case 380:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(461);
      END_STATE();
    case 381:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(462);
      END_STATE();
    case 382:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(463);
      END_STATE();
    case 383:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(464);
      END_STATE();
    case 384:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(465);
      END_STATE();
    case 385:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(466);
      END_STATE();
    case 386:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(467);
      END_STATE();
    case 387:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(468);
      END_STATE();
    case 388:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(469);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_kUntil);
      END_STATE();
    case 390:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(470);
      END_STATE();
    case 391:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(471);
      END_STATE();
    case 392:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(472);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_kWhile);
      END_STATE();
    case 394:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(473);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_kWrite);
      END_STATE();
    case 396:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(474);
      END_STATE();
    case 397:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(475);
      END_STATE();
    case 398:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(476);
      END_STATE();
    case 399:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(477);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(478);
      END_STATE();
    case 400:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(479);
      END_STATE();
    case 401:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(480);
      END_STATE();
    case 402:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(481);
      END_STATE();
    case 403:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(482);
      END_STATE();
    case 404:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(483);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_kDownto);
      END_STATE();
    case 406:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(484);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_kExcept);
      END_STATE();
    case 408:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(485);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_kExport);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(486);
      END_STATE();
    case 410:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(487);
      END_STATE();
    case 411:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(488);
      END_STATE();
    case 412:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(489);
      END_STATE();
    case 413:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(490);
      END_STATE();
    case 414:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(491);
      END_STATE();
    case 415:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(492);
      END_STATE();
    case 416:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(493);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_kHelper);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_kIfndef);
      END_STATE();
    case 419:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(494);
      END_STATE();
    case 420:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(495);
      END_STATE();
    case 421:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym_kInline);
      END_STATE();
    case 423:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(497);
      END_STATE();
    case 424:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(498);
      END_STATE();
    case 425:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(499);
      END_STATE();
    case 426:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(500);
      END_STATE();
    case 427:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 428:
      if (lookahead == '_') ADVANCE(502);
      END_STATE();
    case 429:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 430:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(504);
      END_STATE();
    case 431:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(505);
      END_STATE();
    case 432:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(506);
      END_STATE();
    case 433:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(507);
      END_STATE();
    case 434:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(508);
      END_STATE();
    case 435:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(509);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym_kObject);
      END_STATE();
    case 437:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(510);
      END_STATE();
    case 438:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(511);
      END_STATE();
    case 439:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(512);
      END_STATE();
    case 440:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(513);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym_kPacked);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym_kPascal);
      END_STATE();
    case 443:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(514);
      END_STATE();
    case 444:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 445:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(516);
      END_STATE();
    case 446:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(517);
      END_STATE();
    case 447:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(518);
      END_STATE();
    case 448:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(519);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym_kPublic);
      END_STATE();
    case 450:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(520);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym_kRecord);
      END_STATE();
    case 452:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(521);
      END_STATE();
    case 453:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(522);
      END_STATE();
    case 454:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(523);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym_kRepeat);
      END_STATE();
    case 456:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(524);
      END_STATE();
    case 457:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(525);
      END_STATE();
    case 458:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(526);
      END_STATE();
    case 459:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(527);
      END_STATE();
    case 460:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(528);
      END_STATE();
    case 461:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(529);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(sym_kStatic);
      END_STATE();
    case 463:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(530);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(sym_kStored);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(sym_kStrict);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(sym_kString);
      END_STATE();
    case 467:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(531);
      END_STATE();
    case 468:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(532);
      END_STATE();
    case 469:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(533);
      END_STATE();
    case 470:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(534);
      END_STATE();
    case 471:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(535);
      END_STATE();
    case 472:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(536);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(sym_kWinapi);
      END_STATE();
    case 474:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(537);
      END_STATE();
    case 475:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(538);
      END_STATE();
    case 476:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(539);
      END_STATE();
    case 477:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(540);
      END_STATE();
    case 478:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(541);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_kCppdecl);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_kDefault);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(sym_kDelayed);
      END_STATE();
    case 482:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(542);
      END_STATE();
    case 483:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(543);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_kDynamic);
      END_STATE();
    case 485:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(sym_kExports);
      END_STATE();
    case 487:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(545);
      END_STATE();
    case 488:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(546);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(sym_kFinally);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(sym_kForward);
      END_STATE();
    case 491:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(547);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_kGeneric);
      END_STATE();
    case 493:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(548);
      END_STATE();
    case 494:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(549);
      END_STATE();
    case 495:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 496:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(551);
      END_STATE();
    case 497:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(552);
      END_STATE();
    case 498:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(553);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_kIocheck);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_kLibrary);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_kMessage);
      END_STATE();
    case 502:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(554);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(555);
      END_STATE();
    case 503:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(556);
      END_STATE();
    case 504:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(557);
      END_STATE();
    case 505:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(558);
      END_STATE();
    case 506:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(559);
      END_STATE();
    case 507:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(560);
      END_STATE();
    case 508:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(561);
      END_STATE();
    case 509:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(562);
      END_STATE();
    case 510:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(563);
      END_STATE();
    case 511:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(564);
      END_STATE();
    case 512:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(565);
      END_STATE();
    case 513:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(566);
      END_STATE();
    case 514:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(567);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_kPrivate);
      END_STATE();
    case 516:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(568);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_kProgram);
      END_STATE();
    case 518:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(569);
      END_STATE();
    case 519:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(570);
      END_STATE();
    case 520:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(571);
      END_STATE();
    case 521:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(572);
      END_STATE();
    case 522:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(573);
      END_STATE();
    case 523:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(574);
      END_STATE();
    case 524:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(575);
      END_STATE();
    case 525:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(576);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(sym_kSafecall);
      END_STATE();
    case 527:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(577);
      END_STATE();
    case 528:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(578);
      END_STATE();
    case 529:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(579);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_kStdcall);
      END_STATE();
    case 531:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(580);
      END_STATE();
    case 532:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(581);
      END_STATE();
    case 533:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(582);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_kVarargs);
      END_STATE();
    case 535:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(583);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_kVirtual);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_kAbsolute);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_kAbstract);
      END_STATE();
    case 539:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(584);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_kConstref);
      END_STATE();
    case 541:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(585);
      END_STATE();
    case 542:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(586);
      END_STATE();
    case 543:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(587);
      END_STATE();
    case 544:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(588);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_kExternal);
      END_STATE();
    case 546:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(589);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_kFunction);
      END_STATE();
    case 548:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(590);
      END_STATE();
    case 549:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(591);
      END_STATE();
    case 550:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(592);
      END_STATE();
    case 551:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(593);
      END_STATE();
    case 552:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(594);
      END_STATE();
    case 553:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(595);
      END_STATE();
    case 554:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(596);
      END_STATE();
    case 555:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(597);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_kMwpascal);
      END_STATE();
    case 557:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(598);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_kNoreturn);
      END_STATE();
    case 559:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 560:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(600);
      END_STATE();
    case 561:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(601);
      END_STATE();
    case 562:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(602);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_kOperator);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_kOptional);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_kOverload);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_kOverride);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_kPlatform);
      END_STATE();
    case 568:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(603);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_kProperty);
      END_STATE();
    case 570:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(604);
      END_STATE();
    case 571:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(605);
      END_STATE();
    case 572:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(606);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_kRegister);
      END_STATE();
    case 574:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(607);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_kRequired);
      END_STATE();
    case 576:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(608);
      END_STATE();
    case 577:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(609);
      END_STATE();
    case 578:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(610);
      END_STATE();
    case 579:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(611);
      END_STATE();
    case 580:
      if (lookahead == '_') ADVANCE(612);
      END_STATE();
    case 581:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(613);
      END_STATE();
    case 582:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(614);
      END_STATE();
    case 583:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(615);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_kAssembler);
      END_STATE();
    case 585:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(616);
      END_STATE();
    case 586:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(617);
      END_STATE();
    case 587:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(618);
      END_STATE();
    case 588:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(619);
      END_STATE();
    case 589:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(620);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_kHardfloat);
      END_STATE();
    case 591:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(621);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(622);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_kInherited);
      END_STATE();
    case 593:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(623);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_kInterface);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_kInterrupt);
      END_STATE();
    case 596:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(624);
      END_STATE();
    case 597:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(625);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_kNodefault);
      END_STATE();
    case 599:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(626);
      END_STATE();
    case 600:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(627);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_kObjcclass);
      END_STATE();
    case 602:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(628);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_kProcedure);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_kProtected);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_kPublished);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_kReference);
      END_STATE();
    case 607:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(629);
      END_STATE();
    case 608:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(630);
      END_STATE();
    case 609:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(631);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_kSoftfloat);
      END_STATE();
    case 611:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(632);
      END_STATE();
    case 612:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(633);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(634);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_kThreadvar);
      END_STATE();
    case 614:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(635);
      END_STATE();
    case 615:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(636);
      END_STATE();
    case 616:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(637);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_kDeprecated);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_kDestructor);
      END_STATE();
    case 619:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(638);
      END_STATE();
    case 620:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(639);
      END_STATE();
    case 621:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(640);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_kImplements);
      END_STATE();
    case 623:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(641);
      END_STATE();
    case 624:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(642);
      END_STATE();
    case 625:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(643);
      END_STATE();
    case 626:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(644);
      END_STATE();
    case 627:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(645);
      END_STATE();
    case 628:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(646);
      END_STATE();
    case 629:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(647);
      END_STATE();
    case 630:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 631:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(649);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_kSpecialize);
      END_STATE();
    case 633:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(650);
      END_STATE();
    case 634:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(651);
      END_STATE();
    case 635:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(652);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_kVectorcall);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_kConstructor);
      END_STATE();
    case 638:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(653);
      END_STATE();
    case 639:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(654);
      END_STATE();
    case 640:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(655);
      END_STATE();
    case 641:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(656);
      END_STATE();
    case 642:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(657);
      END_STATE();
    case 643:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(658);
      END_STATE();
    case 644:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(659);
      END_STATE();
    case 645:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(660);
      END_STATE();
    case 646:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(661);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_kReintroduce);
      END_STATE();
    case 648:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(662);
      END_STATE();
    case 649:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(663);
      END_STATE();
    case 650:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(664);
      END_STATE();
    case 651:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(665);
      END_STATE();
    case 652:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(666);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_kExperimental);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_kFinalization);
      END_STATE();
    case 655:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(667);
      END_STATE();
    case 656:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(668);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_kMs_abi_cdecl);
      END_STATE();
    case 658:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(669);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_kNostackframe);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_kObjccategory);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_kObjcprotocol);
      END_STATE();
    case 662:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(670);
      END_STATE();
    case 663:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(671);
      END_STATE();
    case 664:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(672);
      END_STATE();
    case 665:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(673);
      END_STATE();
    case 666:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(674);
      END_STATE();
    case 667:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(675);
      END_STATE();
    case 668:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(676);
      END_STATE();
    case 669:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(677);
      END_STATE();
    case 670:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(678);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_kSaveregisters);
      END_STATE();
    case 672:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(679);
      END_STATE();
    case 673:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(680);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_kUnimplemented);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_kImplementation);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_kInitialization);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_kMs_abi_default);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_kResourcestring);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_kSysv_abi_cdecl);
      END_STATE();
    case 680:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(681);
      END_STATE();
    case 681:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(682);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_kSysv_abi_default);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 39},
  [2] = {.lex_state = 39},
  [3] = {.lex_state = 39},
  [4] = {.lex_state = 39},
  [5] = {.lex_state = 39},
  [6] = {.lex_state = 39},
  [7] = {.lex_state = 39},
  [8] = {.lex_state = 39},
  [9] = {.lex_state = 39},
  [10] = {.lex_state = 39},
  [11] = {.lex_state = 39},
  [12] = {.lex_state = 39},
  [13] = {.lex_state = 39},
  [14] = {.lex_state = 39},
  [15] = {.lex_state = 39},
  [16] = {.lex_state = 39},
  [17] = {.lex_state = 39},
  [18] = {.lex_state = 39},
  [19] = {.lex_state = 39},
  [20] = {.lex_state = 39},
  [21] = {.lex_state = 39},
  [22] = {.lex_state = 39},
  [23] = {.lex_state = 39},
  [24] = {.lex_state = 39},
  [25] = {.lex_state = 39},
  [26] = {.lex_state = 39},
  [27] = {.lex_state = 39},
  [28] = {.lex_state = 39},
  [29] = {.lex_state = 39},
  [30] = {.lex_state = 39},
  [31] = {.lex_state = 39},
  [32] = {.lex_state = 39},
  [33] = {.lex_state = 39},
  [34] = {.lex_state = 39},
  [35] = {.lex_state = 39},
  [36] = {.lex_state = 39},
  [37] = {.lex_state = 39},
  [38] = {.lex_state = 39},
  [39] = {.lex_state = 39},
  [40] = {.lex_state = 39},
  [41] = {.lex_state = 39},
  [42] = {.lex_state = 39},
  [43] = {.lex_state = 39},
  [44] = {.lex_state = 39},
  [45] = {.lex_state = 39},
  [46] = {.lex_state = 39},
  [47] = {.lex_state = 39},
  [48] = {.lex_state = 39},
  [49] = {.lex_state = 39},
  [50] = {.lex_state = 39},
  [51] = {.lex_state = 39},
  [52] = {.lex_state = 39},
  [53] = {.lex_state = 39},
  [54] = {.lex_state = 39},
  [55] = {.lex_state = 39},
  [56] = {.lex_state = 39},
  [57] = {.lex_state = 39},
  [58] = {.lex_state = 39},
  [59] = {.lex_state = 39},
  [60] = {.lex_state = 39},
  [61] = {.lex_state = 39},
  [62] = {.lex_state = 39},
  [63] = {.lex_state = 39},
  [64] = {.lex_state = 39},
  [65] = {.lex_state = 39},
  [66] = {.lex_state = 39},
  [67] = {.lex_state = 39},
  [68] = {.lex_state = 39},
  [69] = {.lex_state = 39},
  [70] = {.lex_state = 39},
  [71] = {.lex_state = 39},
  [72] = {.lex_state = 39},
  [73] = {.lex_state = 39},
  [74] = {.lex_state = 39},
  [75] = {.lex_state = 39},
  [76] = {.lex_state = 39},
  [77] = {.lex_state = 39},
  [78] = {.lex_state = 39},
  [79] = {.lex_state = 39},
  [80] = {.lex_state = 39},
  [81] = {.lex_state = 39},
  [82] = {.lex_state = 39},
  [83] = {.lex_state = 39},
  [84] = {.lex_state = 39},
  [85] = {.lex_state = 39},
  [86] = {.lex_state = 39},
  [87] = {.lex_state = 39},
  [88] = {.lex_state = 39},
  [89] = {.lex_state = 39},
  [90] = {.lex_state = 39},
  [91] = {.lex_state = 39},
  [92] = {.lex_state = 39},
  [93] = {.lex_state = 39},
  [94] = {.lex_state = 39},
  [95] = {.lex_state = 39},
  [96] = {.lex_state = 39},
  [97] = {.lex_state = 39},
  [98] = {.lex_state = 39},
  [99] = {.lex_state = 39},
  [100] = {.lex_state = 39},
  [101] = {.lex_state = 39},
  [102] = {.lex_state = 39},
  [103] = {.lex_state = 39},
  [104] = {.lex_state = 39},
  [105] = {.lex_state = 39},
  [106] = {.lex_state = 39},
  [107] = {.lex_state = 39},
  [108] = {.lex_state = 39},
  [109] = {.lex_state = 39},
  [110] = {.lex_state = 39},
  [111] = {.lex_state = 39},
  [112] = {.lex_state = 39},
  [113] = {.lex_state = 39},
  [114] = {.lex_state = 39},
  [115] = {.lex_state = 39},
  [116] = {.lex_state = 39},
  [117] = {.lex_state = 39},
  [118] = {.lex_state = 39},
  [119] = {.lex_state = 39},
  [120] = {.lex_state = 39},
  [121] = {.lex_state = 39},
  [122] = {.lex_state = 39},
  [123] = {.lex_state = 39},
  [124] = {.lex_state = 39},
  [125] = {.lex_state = 39},
  [126] = {.lex_state = 39},
  [127] = {.lex_state = 39},
  [128] = {.lex_state = 39},
  [129] = {.lex_state = 39},
  [130] = {.lex_state = 39},
  [131] = {.lex_state = 39},
  [132] = {.lex_state = 39},
  [133] = {.lex_state = 39},
  [134] = {.lex_state = 39},
  [135] = {.lex_state = 39},
  [136] = {.lex_state = 39},
  [137] = {.lex_state = 39},
  [138] = {.lex_state = 39},
  [139] = {.lex_state = 39},
  [140] = {.lex_state = 39},
  [141] = {.lex_state = 39},
  [142] = {.lex_state = 39},
  [143] = {.lex_state = 39},
  [144] = {.lex_state = 39},
  [145] = {.lex_state = 39},
  [146] = {.lex_state = 39},
  [147] = {.lex_state = 39},
  [148] = {.lex_state = 39},
  [149] = {.lex_state = 39},
  [150] = {.lex_state = 39},
  [151] = {.lex_state = 39},
  [152] = {.lex_state = 39},
  [153] = {.lex_state = 39},
  [154] = {.lex_state = 39},
  [155] = {.lex_state = 39},
  [156] = {.lex_state = 39},
  [157] = {.lex_state = 39},
  [158] = {.lex_state = 39},
  [159] = {.lex_state = 39},
  [160] = {.lex_state = 39},
  [161] = {.lex_state = 39},
  [162] = {.lex_state = 39},
  [163] = {.lex_state = 39},
  [164] = {.lex_state = 39},
  [165] = {.lex_state = 39},
  [166] = {.lex_state = 39},
  [167] = {.lex_state = 39},
  [168] = {.lex_state = 39},
  [169] = {.lex_state = 39},
  [170] = {.lex_state = 39},
  [171] = {.lex_state = 39},
  [172] = {.lex_state = 39},
  [173] = {.lex_state = 39},
  [174] = {.lex_state = 39},
  [175] = {.lex_state = 39},
  [176] = {.lex_state = 40},
  [177] = {.lex_state = 39},
  [178] = {.lex_state = 39},
  [179] = {.lex_state = 40},
  [180] = {.lex_state = 39},
  [181] = {.lex_state = 39},
  [182] = {.lex_state = 39},
  [183] = {.lex_state = 39},
  [184] = {.lex_state = 39},
  [185] = {.lex_state = 39},
  [186] = {.lex_state = 39},
  [187] = {.lex_state = 39},
  [188] = {.lex_state = 39},
  [189] = {.lex_state = 39},
  [190] = {.lex_state = 39},
  [191] = {.lex_state = 39},
  [192] = {.lex_state = 39},
  [193] = {.lex_state = 39},
  [194] = {.lex_state = 39},
  [195] = {.lex_state = 39},
  [196] = {.lex_state = 39},
  [197] = {.lex_state = 39},
  [198] = {.lex_state = 39},
  [199] = {.lex_state = 39},
  [200] = {.lex_state = 39},
  [201] = {.lex_state = 39},
  [202] = {.lex_state = 39},
  [203] = {.lex_state = 39},
  [204] = {.lex_state = 39},
  [205] = {.lex_state = 39},
  [206] = {.lex_state = 39},
  [207] = {.lex_state = 39},
  [208] = {.lex_state = 39},
  [209] = {.lex_state = 39},
  [210] = {.lex_state = 39},
  [211] = {.lex_state = 39},
  [212] = {.lex_state = 39},
  [213] = {.lex_state = 39},
  [214] = {.lex_state = 39},
  [215] = {.lex_state = 39},
  [216] = {.lex_state = 39},
  [217] = {.lex_state = 39},
  [218] = {.lex_state = 39},
  [219] = {.lex_state = 39},
  [220] = {.lex_state = 39},
  [221] = {.lex_state = 39},
  [222] = {.lex_state = 39},
  [223] = {.lex_state = 39},
  [224] = {.lex_state = 39},
  [225] = {.lex_state = 40},
  [226] = {.lex_state = 39},
  [227] = {.lex_state = 39},
  [228] = {.lex_state = 39},
  [229] = {.lex_state = 39},
  [230] = {.lex_state = 39},
  [231] = {.lex_state = 39},
  [232] = {.lex_state = 39},
  [233] = {.lex_state = 40},
  [234] = {.lex_state = 39},
  [235] = {.lex_state = 39},
  [236] = {.lex_state = 39},
  [237] = {.lex_state = 39},
  [238] = {.lex_state = 39},
  [239] = {.lex_state = 39},
  [240] = {.lex_state = 39},
  [241] = {.lex_state = 39},
  [242] = {.lex_state = 39},
  [243] = {.lex_state = 39},
  [244] = {.lex_state = 39},
  [245] = {.lex_state = 39},
  [246] = {.lex_state = 39},
  [247] = {.lex_state = 39},
  [248] = {.lex_state = 39},
  [249] = {.lex_state = 39},
  [250] = {.lex_state = 39},
  [251] = {.lex_state = 39},
  [252] = {.lex_state = 39},
  [253] = {.lex_state = 39},
  [254] = {.lex_state = 39},
  [255] = {.lex_state = 39},
  [256] = {.lex_state = 39},
  [257] = {.lex_state = 39},
  [258] = {.lex_state = 39},
  [259] = {.lex_state = 39},
  [260] = {.lex_state = 39},
  [261] = {.lex_state = 39},
  [262] = {.lex_state = 39},
  [263] = {.lex_state = 39},
  [264] = {.lex_state = 39},
  [265] = {.lex_state = 39},
  [266] = {.lex_state = 39},
  [267] = {.lex_state = 39},
  [268] = {.lex_state = 39},
  [269] = {.lex_state = 39},
  [270] = {.lex_state = 39},
  [271] = {.lex_state = 39},
  [272] = {.lex_state = 39},
  [273] = {.lex_state = 39},
  [274] = {.lex_state = 39},
  [275] = {.lex_state = 39},
  [276] = {.lex_state = 39},
  [277] = {.lex_state = 39},
  [278] = {.lex_state = 39},
  [279] = {.lex_state = 39},
  [280] = {.lex_state = 39},
  [281] = {.lex_state = 39},
  [282] = {.lex_state = 39},
  [283] = {.lex_state = 39},
  [284] = {.lex_state = 39},
  [285] = {.lex_state = 39},
  [286] = {.lex_state = 39},
  [287] = {.lex_state = 39},
  [288] = {.lex_state = 39},
  [289] = {.lex_state = 39},
  [290] = {.lex_state = 39},
  [291] = {.lex_state = 39},
  [292] = {.lex_state = 39},
  [293] = {.lex_state = 39},
  [294] = {.lex_state = 39},
  [295] = {.lex_state = 39},
  [296] = {.lex_state = 39},
  [297] = {.lex_state = 39},
  [298] = {.lex_state = 39},
  [299] = {.lex_state = 39},
  [300] = {.lex_state = 39},
  [301] = {.lex_state = 39},
  [302] = {.lex_state = 39},
  [303] = {.lex_state = 39},
  [304] = {.lex_state = 39},
  [305] = {.lex_state = 39},
  [306] = {.lex_state = 39},
  [307] = {.lex_state = 39},
  [308] = {.lex_state = 39},
  [309] = {.lex_state = 39},
  [310] = {.lex_state = 39},
  [311] = {.lex_state = 39},
  [312] = {.lex_state = 39},
  [313] = {.lex_state = 39},
  [314] = {.lex_state = 39},
  [315] = {.lex_state = 39},
  [316] = {.lex_state = 39},
  [317] = {.lex_state = 39},
  [318] = {.lex_state = 39},
  [319] = {.lex_state = 39},
  [320] = {.lex_state = 39},
  [321] = {.lex_state = 39},
  [322] = {.lex_state = 39},
  [323] = {.lex_state = 39},
  [324] = {.lex_state = 39},
  [325] = {.lex_state = 39},
  [326] = {.lex_state = 39},
  [327] = {.lex_state = 39},
  [328] = {.lex_state = 39},
  [329] = {.lex_state = 39},
  [330] = {.lex_state = 39},
  [331] = {.lex_state = 39},
  [332] = {.lex_state = 39},
  [333] = {.lex_state = 39},
  [334] = {.lex_state = 39},
  [335] = {.lex_state = 39},
  [336] = {.lex_state = 39},
  [337] = {.lex_state = 39},
  [338] = {.lex_state = 39},
  [339] = {.lex_state = 39},
  [340] = {.lex_state = 39},
  [341] = {.lex_state = 39},
  [342] = {.lex_state = 39},
  [343] = {.lex_state = 39},
  [344] = {.lex_state = 39},
  [345] = {.lex_state = 39},
  [346] = {.lex_state = 39},
  [347] = {.lex_state = 39},
  [348] = {.lex_state = 39},
  [349] = {.lex_state = 39},
  [350] = {.lex_state = 39},
  [351] = {.lex_state = 39},
  [352] = {.lex_state = 39},
  [353] = {.lex_state = 39},
  [354] = {.lex_state = 39},
  [355] = {.lex_state = 39},
  [356] = {.lex_state = 39},
  [357] = {.lex_state = 39},
  [358] = {.lex_state = 39},
  [359] = {.lex_state = 39},
  [360] = {.lex_state = 39},
  [361] = {.lex_state = 39},
  [362] = {.lex_state = 39},
  [363] = {.lex_state = 39},
  [364] = {.lex_state = 39},
  [365] = {.lex_state = 39},
  [366] = {.lex_state = 39},
  [367] = {.lex_state = 39},
  [368] = {.lex_state = 39},
  [369] = {.lex_state = 39},
  [370] = {.lex_state = 39},
  [371] = {.lex_state = 39},
  [372] = {.lex_state = 39},
  [373] = {.lex_state = 39},
  [374] = {.lex_state = 39},
  [375] = {.lex_state = 39},
  [376] = {.lex_state = 39},
  [377] = {.lex_state = 39},
  [378] = {.lex_state = 39},
  [379] = {.lex_state = 39},
  [380] = {.lex_state = 39},
  [381] = {.lex_state = 39},
  [382] = {.lex_state = 39},
  [383] = {.lex_state = 39},
  [384] = {.lex_state = 39},
  [385] = {.lex_state = 39},
  [386] = {.lex_state = 39},
  [387] = {.lex_state = 39},
  [388] = {.lex_state = 39},
  [389] = {.lex_state = 39},
  [390] = {.lex_state = 39},
  [391] = {.lex_state = 39},
  [392] = {.lex_state = 39},
  [393] = {.lex_state = 39},
  [394] = {.lex_state = 39},
  [395] = {.lex_state = 39},
  [396] = {.lex_state = 39},
  [397] = {.lex_state = 39},
  [398] = {.lex_state = 39},
  [399] = {.lex_state = 39},
  [400] = {.lex_state = 39},
  [401] = {.lex_state = 39},
  [402] = {.lex_state = 39},
  [403] = {.lex_state = 39},
  [404] = {.lex_state = 39},
  [405] = {.lex_state = 39},
  [406] = {.lex_state = 39},
  [407] = {.lex_state = 39},
  [408] = {.lex_state = 39},
  [409] = {.lex_state = 39},
  [410] = {.lex_state = 10},
  [411] = {.lex_state = 10},
  [412] = {.lex_state = 10},
  [413] = {.lex_state = 10},
  [414] = {.lex_state = 10},
  [415] = {.lex_state = 10},
  [416] = {.lex_state = 10},
  [417] = {.lex_state = 39},
  [418] = {.lex_state = 10},
  [419] = {.lex_state = 39},
  [420] = {.lex_state = 10},
  [421] = {.lex_state = 10},
  [422] = {.lex_state = 10},
  [423] = {.lex_state = 10},
  [424] = {.lex_state = 10},
  [425] = {.lex_state = 10},
  [426] = {.lex_state = 10},
  [427] = {.lex_state = 10},
  [428] = {.lex_state = 10},
  [429] = {.lex_state = 10},
  [430] = {.lex_state = 39},
  [431] = {.lex_state = 39},
  [432] = {.lex_state = 10},
  [433] = {.lex_state = 10},
  [434] = {.lex_state = 10},
  [435] = {.lex_state = 10},
  [436] = {.lex_state = 10},
  [437] = {.lex_state = 39},
  [438] = {.lex_state = 10},
  [439] = {.lex_state = 39},
  [440] = {.lex_state = 10},
  [441] = {.lex_state = 10},
  [442] = {.lex_state = 39},
  [443] = {.lex_state = 39},
  [444] = {.lex_state = 10},
  [445] = {.lex_state = 10},
  [446] = {.lex_state = 10},
  [447] = {.lex_state = 10},
  [448] = {.lex_state = 10},
  [449] = {.lex_state = 10},
  [450] = {.lex_state = 10},
  [451] = {.lex_state = 39},
  [452] = {.lex_state = 39},
  [453] = {.lex_state = 10},
  [454] = {.lex_state = 10},
  [455] = {.lex_state = 10},
  [456] = {.lex_state = 39},
  [457] = {.lex_state = 39},
  [458] = {.lex_state = 10},
  [459] = {.lex_state = 10},
  [460] = {.lex_state = 10},
  [461] = {.lex_state = 10},
  [462] = {.lex_state = 10},
  [463] = {.lex_state = 10},
  [464] = {.lex_state = 10},
  [465] = {.lex_state = 10},
  [466] = {.lex_state = 10},
  [467] = {.lex_state = 10},
  [468] = {.lex_state = 39},
  [469] = {.lex_state = 10},
  [470] = {.lex_state = 10},
  [471] = {.lex_state = 10},
  [472] = {.lex_state = 39},
  [473] = {.lex_state = 40},
  [474] = {.lex_state = 10},
  [475] = {.lex_state = 10},
  [476] = {.lex_state = 10},
  [477] = {.lex_state = 10},
  [478] = {.lex_state = 10},
  [479] = {.lex_state = 10},
  [480] = {.lex_state = 10},
  [481] = {.lex_state = 10},
  [482] = {.lex_state = 39},
  [483] = {.lex_state = 10},
  [484] = {.lex_state = 10},
  [485] = {.lex_state = 10},
  [486] = {.lex_state = 39},
  [487] = {.lex_state = 10},
  [488] = {.lex_state = 10},
  [489] = {.lex_state = 10},
  [490] = {.lex_state = 10},
  [491] = {.lex_state = 10},
  [492] = {.lex_state = 39},
  [493] = {.lex_state = 10},
  [494] = {.lex_state = 39},
  [495] = {.lex_state = 39},
  [496] = {.lex_state = 10},
  [497] = {.lex_state = 10},
  [498] = {.lex_state = 10},
  [499] = {.lex_state = 10},
  [500] = {.lex_state = 10},
  [501] = {.lex_state = 10},
  [502] = {.lex_state = 10},
  [503] = {.lex_state = 10},
  [504] = {.lex_state = 2},
  [505] = {.lex_state = 10},
  [506] = {.lex_state = 10},
  [507] = {.lex_state = 10},
  [508] = {.lex_state = 10},
  [509] = {.lex_state = 10},
  [510] = {.lex_state = 10},
  [511] = {.lex_state = 10},
  [512] = {.lex_state = 40},
  [513] = {.lex_state = 40},
  [514] = {.lex_state = 40},
  [515] = {.lex_state = 40},
  [516] = {.lex_state = 1},
  [517] = {.lex_state = 40},
  [518] = {.lex_state = 40},
  [519] = {.lex_state = 40},
  [520] = {.lex_state = 40},
  [521] = {.lex_state = 10},
  [522] = {.lex_state = 40},
  [523] = {.lex_state = 10},
  [524] = {.lex_state = 40},
  [525] = {.lex_state = 40},
  [526] = {.lex_state = 10},
  [527] = {.lex_state = 40},
  [528] = {.lex_state = 40},
  [529] = {.lex_state = 40},
  [530] = {.lex_state = 40},
  [531] = {.lex_state = 1},
  [532] = {.lex_state = 40},
  [533] = {.lex_state = 40},
  [534] = {.lex_state = 40},
  [535] = {.lex_state = 40},
  [536] = {.lex_state = 10},
  [537] = {.lex_state = 40},
  [538] = {.lex_state = 10},
  [539] = {.lex_state = 40},
  [540] = {.lex_state = 40},
  [541] = {.lex_state = 40},
  [542] = {.lex_state = 40},
  [543] = {.lex_state = 40},
  [544] = {.lex_state = 1},
  [545] = {.lex_state = 40},
  [546] = {.lex_state = 40},
  [547] = {.lex_state = 39},
  [548] = {.lex_state = 39},
  [549] = {.lex_state = 39},
  [550] = {.lex_state = 4},
  [551] = {.lex_state = 4},
  [552] = {.lex_state = 4},
  [553] = {.lex_state = 4},
  [554] = {.lex_state = 40},
  [555] = {.lex_state = 40},
  [556] = {.lex_state = 40},
  [557] = {.lex_state = 4},
  [558] = {.lex_state = 40},
  [559] = {.lex_state = 40},
  [560] = {.lex_state = 40},
  [561] = {.lex_state = 40},
  [562] = {.lex_state = 40},
  [563] = {.lex_state = 40},
  [564] = {.lex_state = 40},
  [565] = {.lex_state = 40},
  [566] = {.lex_state = 40},
  [567] = {.lex_state = 40},
  [568] = {.lex_state = 40},
  [569] = {.lex_state = 40},
  [570] = {.lex_state = 40},
  [571] = {.lex_state = 40},
  [572] = {.lex_state = 40},
  [573] = {.lex_state = 40},
  [574] = {.lex_state = 40},
  [575] = {.lex_state = 40},
  [576] = {.lex_state = 40},
  [577] = {.lex_state = 40},
  [578] = {.lex_state = 40},
  [579] = {.lex_state = 40},
  [580] = {.lex_state = 40},
  [581] = {.lex_state = 40},
  [582] = {.lex_state = 40},
  [583] = {.lex_state = 40},
  [584] = {.lex_state = 40},
  [585] = {.lex_state = 40},
  [586] = {.lex_state = 40},
  [587] = {.lex_state = 40},
  [588] = {.lex_state = 40},
  [589] = {.lex_state = 40},
  [590] = {.lex_state = 40},
  [591] = {.lex_state = 40},
  [592] = {.lex_state = 40},
  [593] = {.lex_state = 40},
  [594] = {.lex_state = 39},
  [595] = {.lex_state = 39},
  [596] = {.lex_state = 39},
  [597] = {.lex_state = 40},
  [598] = {.lex_state = 40},
  [599] = {.lex_state = 40},
  [600] = {.lex_state = 39},
  [601] = {.lex_state = 40},
  [602] = {.lex_state = 39},
  [603] = {.lex_state = 39},
  [604] = {.lex_state = 39},
  [605] = {.lex_state = 39},
  [606] = {.lex_state = 40},
  [607] = {.lex_state = 40},
  [608] = {.lex_state = 40},
  [609] = {.lex_state = 39},
  [610] = {.lex_state = 39},
  [611] = {.lex_state = 39},
  [612] = {.lex_state = 39},
  [613] = {.lex_state = 39},
  [614] = {.lex_state = 39},
  [615] = {.lex_state = 39},
  [616] = {.lex_state = 39},
  [617] = {.lex_state = 39},
  [618] = {.lex_state = 39},
  [619] = {.lex_state = 39},
  [620] = {.lex_state = 39},
  [621] = {.lex_state = 39},
  [622] = {.lex_state = 39},
  [623] = {.lex_state = 39},
  [624] = {.lex_state = 39},
  [625] = {.lex_state = 39},
  [626] = {.lex_state = 39},
  [627] = {.lex_state = 39},
  [628] = {.lex_state = 39},
  [629] = {.lex_state = 39},
  [630] = {.lex_state = 39},
  [631] = {.lex_state = 39},
  [632] = {.lex_state = 2},
  [633] = {.lex_state = 39},
  [634] = {.lex_state = 39},
  [635] = {.lex_state = 39},
  [636] = {.lex_state = 39},
  [637] = {.lex_state = 2},
  [638] = {.lex_state = 39},
  [639] = {.lex_state = 2},
  [640] = {.lex_state = 2},
  [641] = {.lex_state = 2},
  [642] = {.lex_state = 2},
  [643] = {.lex_state = 2},
  [644] = {.lex_state = 2},
  [645] = {.lex_state = 2},
  [646] = {.lex_state = 2},
  [647] = {.lex_state = 39},
  [648] = {.lex_state = 39},
  [649] = {.lex_state = 39},
  [650] = {.lex_state = 40},
  [651] = {.lex_state = 39},
  [652] = {.lex_state = 39},
  [653] = {.lex_state = 40},
  [654] = {.lex_state = 39},
  [655] = {.lex_state = 39},
  [656] = {.lex_state = 39},
  [657] = {.lex_state = 39},
  [658] = {.lex_state = 39},
  [659] = {.lex_state = 39},
  [660] = {.lex_state = 39},
  [661] = {.lex_state = 39},
  [662] = {.lex_state = 39},
  [663] = {.lex_state = 40},
  [664] = {.lex_state = 40},
  [665] = {.lex_state = 39},
  [666] = {.lex_state = 40},
  [667] = {.lex_state = 39},
  [668] = {.lex_state = 40},
  [669] = {.lex_state = 39},
  [670] = {.lex_state = 39},
  [671] = {.lex_state = 40},
  [672] = {.lex_state = 39},
  [673] = {.lex_state = 40},
  [674] = {.lex_state = 40},
  [675] = {.lex_state = 39},
  [676] = {.lex_state = 39},
  [677] = {.lex_state = 39},
  [678] = {.lex_state = 39},
  [679] = {.lex_state = 39},
  [680] = {.lex_state = 39},
  [681] = {.lex_state = 40},
  [682] = {.lex_state = 39},
  [683] = {.lex_state = 39},
  [684] = {.lex_state = 39},
  [685] = {.lex_state = 39},
  [686] = {.lex_state = 40},
  [687] = {.lex_state = 40},
  [688] = {.lex_state = 39},
  [689] = {.lex_state = 40},
  [690] = {.lex_state = 40},
  [691] = {.lex_state = 39},
  [692] = {.lex_state = 39},
  [693] = {.lex_state = 39},
  [694] = {.lex_state = 39},
  [695] = {.lex_state = 39},
  [696] = {.lex_state = 39},
  [697] = {.lex_state = 39},
  [698] = {.lex_state = 39},
  [699] = {.lex_state = 39},
  [700] = {.lex_state = 39},
  [701] = {.lex_state = 39},
  [702] = {.lex_state = 39},
  [703] = {.lex_state = 39},
  [704] = {.lex_state = 39},
  [705] = {.lex_state = 39},
  [706] = {.lex_state = 39},
  [707] = {.lex_state = 39},
  [708] = {.lex_state = 39},
  [709] = {.lex_state = 39},
  [710] = {.lex_state = 39},
  [711] = {.lex_state = 39},
  [712] = {.lex_state = 39},
  [713] = {.lex_state = 39},
  [714] = {.lex_state = 39},
  [715] = {.lex_state = 39},
  [716] = {.lex_state = 39},
  [717] = {.lex_state = 39},
  [718] = {.lex_state = 39},
  [719] = {.lex_state = 39},
  [720] = {.lex_state = 39},
  [721] = {.lex_state = 39},
  [722] = {.lex_state = 40},
  [723] = {.lex_state = 40},
  [724] = {.lex_state = 39},
  [725] = {.lex_state = 39},
  [726] = {.lex_state = 39},
  [727] = {.lex_state = 39},
  [728] = {.lex_state = 39},
  [729] = {.lex_state = 39},
  [730] = {.lex_state = 39},
  [731] = {.lex_state = 39},
  [732] = {.lex_state = 40},
  [733] = {.lex_state = 39},
  [734] = {.lex_state = 39},
  [735] = {.lex_state = 39},
  [736] = {.lex_state = 39},
  [737] = {.lex_state = 39},
  [738] = {.lex_state = 39},
  [739] = {.lex_state = 39},
  [740] = {.lex_state = 40},
  [741] = {.lex_state = 39},
  [742] = {.lex_state = 39},
  [743] = {.lex_state = 39},
  [744] = {.lex_state = 39},
  [745] = {.lex_state = 39},
  [746] = {.lex_state = 39},
  [747] = {.lex_state = 39},
  [748] = {.lex_state = 39},
  [749] = {.lex_state = 39},
  [750] = {.lex_state = 39},
  [751] = {.lex_state = 39},
  [752] = {.lex_state = 39},
  [753] = {.lex_state = 39},
  [754] = {.lex_state = 39},
  [755] = {.lex_state = 39},
  [756] = {.lex_state = 39},
  [757] = {.lex_state = 39},
  [758] = {.lex_state = 39},
  [759] = {.lex_state = 39},
  [760] = {.lex_state = 39},
  [761] = {.lex_state = 39},
  [762] = {.lex_state = 39},
  [763] = {.lex_state = 39},
  [764] = {.lex_state = 39},
  [765] = {.lex_state = 39},
  [766] = {.lex_state = 39},
  [767] = {.lex_state = 39},
  [768] = {.lex_state = 39},
  [769] = {.lex_state = 39},
  [770] = {.lex_state = 39},
  [771] = {.lex_state = 39},
  [772] = {.lex_state = 39},
  [773] = {.lex_state = 39},
  [774] = {.lex_state = 39},
  [775] = {.lex_state = 39},
  [776] = {.lex_state = 39},
  [777] = {.lex_state = 39},
  [778] = {.lex_state = 39},
  [779] = {.lex_state = 39},
  [780] = {.lex_state = 39},
  [781] = {.lex_state = 39},
  [782] = {.lex_state = 39},
  [783] = {.lex_state = 40},
  [784] = {.lex_state = 39},
  [785] = {.lex_state = 39},
  [786] = {.lex_state = 39},
  [787] = {.lex_state = 39},
  [788] = {.lex_state = 39},
  [789] = {.lex_state = 39},
  [790] = {.lex_state = 39},
  [791] = {.lex_state = 39},
  [792] = {.lex_state = 39},
  [793] = {.lex_state = 39},
  [794] = {.lex_state = 39},
  [795] = {.lex_state = 39},
  [796] = {.lex_state = 39},
  [797] = {.lex_state = 39},
  [798] = {.lex_state = 39},
  [799] = {.lex_state = 39},
  [800] = {.lex_state = 39},
  [801] = {.lex_state = 39},
  [802] = {.lex_state = 39},
  [803] = {.lex_state = 39},
  [804] = {.lex_state = 39},
  [805] = {.lex_state = 39},
  [806] = {.lex_state = 39},
  [807] = {.lex_state = 39},
  [808] = {.lex_state = 39},
  [809] = {.lex_state = 39},
  [810] = {.lex_state = 39},
  [811] = {.lex_state = 39},
  [812] = {.lex_state = 39},
  [813] = {.lex_state = 39},
  [814] = {.lex_state = 39},
  [815] = {.lex_state = 39},
  [816] = {.lex_state = 39},
  [817] = {.lex_state = 39},
  [818] = {.lex_state = 39},
  [819] = {.lex_state = 39},
  [820] = {.lex_state = 39},
  [821] = {.lex_state = 39},
  [822] = {.lex_state = 39},
  [823] = {.lex_state = 39},
  [824] = {.lex_state = 39},
  [825] = {.lex_state = 39},
  [826] = {.lex_state = 39},
  [827] = {.lex_state = 39},
  [828] = {.lex_state = 39},
  [829] = {.lex_state = 39},
  [830] = {.lex_state = 39},
  [831] = {.lex_state = 39},
  [832] = {.lex_state = 39},
  [833] = {.lex_state = 39},
  [834] = {.lex_state = 39},
  [835] = {.lex_state = 39},
  [836] = {.lex_state = 39},
  [837] = {.lex_state = 39},
  [838] = {.lex_state = 39},
  [839] = {.lex_state = 39},
  [840] = {.lex_state = 39},
  [841] = {.lex_state = 39},
  [842] = {.lex_state = 39},
  [843] = {.lex_state = 39},
  [844] = {.lex_state = 39},
  [845] = {.lex_state = 39},
  [846] = {.lex_state = 39},
  [847] = {.lex_state = 39},
  [848] = {.lex_state = 39},
  [849] = {.lex_state = 39},
  [850] = {.lex_state = 39},
  [851] = {.lex_state = 39},
  [852] = {.lex_state = 39},
  [853] = {.lex_state = 39},
  [854] = {.lex_state = 39},
  [855] = {.lex_state = 39},
  [856] = {.lex_state = 39},
  [857] = {.lex_state = 39},
  [858] = {.lex_state = 39},
  [859] = {.lex_state = 39},
  [860] = {.lex_state = 39},
  [861] = {.lex_state = 39},
  [862] = {.lex_state = 39},
  [863] = {.lex_state = 39},
  [864] = {.lex_state = 39},
  [865] = {.lex_state = 39},
  [866] = {.lex_state = 39},
  [867] = {.lex_state = 39},
  [868] = {.lex_state = 39},
  [869] = {.lex_state = 39},
  [870] = {.lex_state = 39},
  [871] = {.lex_state = 39},
  [872] = {.lex_state = 39},
  [873] = {.lex_state = 39},
  [874] = {.lex_state = 39},
  [875] = {.lex_state = 39},
  [876] = {.lex_state = 39},
  [877] = {.lex_state = 39},
  [878] = {.lex_state = 39},
  [879] = {.lex_state = 39},
  [880] = {.lex_state = 39},
  [881] = {.lex_state = 39},
  [882] = {.lex_state = 39},
  [883] = {.lex_state = 39},
  [884] = {.lex_state = 39},
  [885] = {.lex_state = 39},
  [886] = {.lex_state = 39},
  [887] = {.lex_state = 39},
  [888] = {.lex_state = 39},
  [889] = {.lex_state = 39},
  [890] = {.lex_state = 39},
  [891] = {.lex_state = 39},
  [892] = {.lex_state = 39},
  [893] = {.lex_state = 39},
  [894] = {.lex_state = 39},
  [895] = {.lex_state = 39},
  [896] = {.lex_state = 39},
  [897] = {.lex_state = 39},
  [898] = {.lex_state = 39},
  [899] = {.lex_state = 39},
  [900] = {.lex_state = 39},
  [901] = {.lex_state = 39},
  [902] = {.lex_state = 39},
  [903] = {.lex_state = 39},
  [904] = {.lex_state = 39},
  [905] = {.lex_state = 39},
  [906] = {.lex_state = 39},
  [907] = {.lex_state = 40},
  [908] = {.lex_state = 40},
  [909] = {.lex_state = 40},
  [910] = {.lex_state = 40},
  [911] = {.lex_state = 39},
  [912] = {.lex_state = 40},
  [913] = {.lex_state = 39},
  [914] = {.lex_state = 40},
  [915] = {.lex_state = 39},
  [916] = {.lex_state = 39},
  [917] = {.lex_state = 39},
  [918] = {.lex_state = 39},
  [919] = {.lex_state = 39},
  [920] = {.lex_state = 39},
  [921] = {.lex_state = 39},
  [922] = {.lex_state = 40},
  [923] = {.lex_state = 40},
  [924] = {.lex_state = 40},
  [925] = {.lex_state = 39},
  [926] = {.lex_state = 39},
  [927] = {.lex_state = 39},
  [928] = {.lex_state = 39},
  [929] = {.lex_state = 40},
  [930] = {.lex_state = 40},
  [931] = {.lex_state = 40},
  [932] = {.lex_state = 40},
  [933] = {.lex_state = 40},
  [934] = {.lex_state = 40},
  [935] = {.lex_state = 10},
  [936] = {.lex_state = 40},
  [937] = {.lex_state = 40},
  [938] = {.lex_state = 40},
  [939] = {.lex_state = 40},
  [940] = {.lex_state = 40},
  [941] = {.lex_state = 10},
  [942] = {.lex_state = 10},
  [943] = {.lex_state = 40},
  [944] = {.lex_state = 40},
  [945] = {.lex_state = 40},
  [946] = {.lex_state = 40},
  [947] = {.lex_state = 40},
  [948] = {.lex_state = 10},
  [949] = {.lex_state = 40},
  [950] = {.lex_state = 40},
  [951] = {.lex_state = 40},
  [952] = {.lex_state = 40},
  [953] = {.lex_state = 40},
  [954] = {.lex_state = 40},
  [955] = {.lex_state = 40},
  [956] = {.lex_state = 40},
  [957] = {.lex_state = 39},
  [958] = {.lex_state = 40},
  [959] = {.lex_state = 39},
  [960] = {.lex_state = 40},
  [961] = {.lex_state = 40},
  [962] = {.lex_state = 40},
  [963] = {.lex_state = 40},
  [964] = {.lex_state = 39},
  [965] = {.lex_state = 39},
  [966] = {.lex_state = 39},
  [967] = {.lex_state = 39},
  [968] = {.lex_state = 10},
  [969] = {.lex_state = 10},
  [970] = {.lex_state = 39},
  [971] = {.lex_state = 39},
  [972] = {.lex_state = 40},
  [973] = {.lex_state = 39},
  [974] = {.lex_state = 40},
  [975] = {.lex_state = 40},
  [976] = {.lex_state = 10},
  [977] = {.lex_state = 39},
  [978] = {.lex_state = 39},
  [979] = {.lex_state = 40},
  [980] = {.lex_state = 39},
  [981] = {.lex_state = 40},
  [982] = {.lex_state = 39},
  [983] = {.lex_state = 39},
  [984] = {.lex_state = 39},
  [985] = {.lex_state = 39},
  [986] = {.lex_state = 40},
  [987] = {.lex_state = 40},
  [988] = {.lex_state = 40},
  [989] = {.lex_state = 40},
  [990] = {.lex_state = 39},
  [991] = {.lex_state = 39},
  [992] = {.lex_state = 39},
  [993] = {.lex_state = 40},
  [994] = {.lex_state = 40},
  [995] = {.lex_state = 40},
  [996] = {.lex_state = 39},
  [997] = {.lex_state = 40},
  [998] = {.lex_state = 40},
  [999] = {.lex_state = 39},
  [1000] = {.lex_state = 39},
  [1001] = {.lex_state = 40},
  [1002] = {.lex_state = 40},
  [1003] = {.lex_state = 40},
  [1004] = {.lex_state = 40},
  [1005] = {.lex_state = 40},
  [1006] = {.lex_state = 40},
  [1007] = {.lex_state = 40},
  [1008] = {.lex_state = 40},
  [1009] = {.lex_state = 40},
  [1010] = {.lex_state = 39},
  [1011] = {.lex_state = 40},
  [1012] = {.lex_state = 40},
  [1013] = {.lex_state = 39},
  [1014] = {.lex_state = 39},
  [1015] = {.lex_state = 39},
  [1016] = {.lex_state = 39},
  [1017] = {.lex_state = 39},
  [1018] = {.lex_state = 40},
  [1019] = {.lex_state = 39},
  [1020] = {.lex_state = 39},
  [1021] = {.lex_state = 39},
  [1022] = {.lex_state = 39},
  [1023] = {.lex_state = 39},
  [1024] = {.lex_state = 40},
  [1025] = {.lex_state = 39},
  [1026] = {.lex_state = 40},
  [1027] = {.lex_state = 40},
  [1028] = {.lex_state = 40},
  [1029] = {.lex_state = 40},
  [1030] = {.lex_state = 39},
  [1031] = {.lex_state = 39},
  [1032] = {.lex_state = 40},
  [1033] = {.lex_state = 40},
  [1034] = {.lex_state = 39},
  [1035] = {.lex_state = 39},
  [1036] = {.lex_state = 39},
  [1037] = {.lex_state = 39},
  [1038] = {.lex_state = 39},
  [1039] = {.lex_state = 39},
  [1040] = {.lex_state = 39},
  [1041] = {.lex_state = 39},
  [1042] = {.lex_state = 39},
  [1043] = {.lex_state = 39},
  [1044] = {.lex_state = 39},
  [1045] = {.lex_state = 39},
  [1046] = {.lex_state = 39},
  [1047] = {.lex_state = 39},
  [1048] = {.lex_state = 39},
  [1049] = {.lex_state = 39},
  [1050] = {.lex_state = 39},
  [1051] = {.lex_state = 39},
  [1052] = {.lex_state = 39},
  [1053] = {.lex_state = 39},
  [1054] = {.lex_state = 39},
  [1055] = {.lex_state = 39},
  [1056] = {.lex_state = 39},
  [1057] = {.lex_state = 39},
  [1058] = {.lex_state = 39},
  [1059] = {.lex_state = 39},
  [1060] = {.lex_state = 39},
  [1061] = {.lex_state = 39},
  [1062] = {.lex_state = 39},
  [1063] = {.lex_state = 39},
  [1064] = {.lex_state = 39},
  [1065] = {.lex_state = 39},
  [1066] = {.lex_state = 39},
  [1067] = {.lex_state = 39},
  [1068] = {.lex_state = 40},
  [1069] = {.lex_state = 2},
  [1070] = {.lex_state = 2},
  [1071] = {.lex_state = 39},
  [1072] = {.lex_state = 39},
  [1073] = {.lex_state = 39},
  [1074] = {.lex_state = 39},
  [1075] = {.lex_state = 39},
  [1076] = {.lex_state = 39},
  [1077] = {.lex_state = 39},
  [1078] = {.lex_state = 40},
  [1079] = {.lex_state = 39},
  [1080] = {.lex_state = 40},
  [1081] = {.lex_state = 40},
  [1082] = {.lex_state = 39},
  [1083] = {.lex_state = 39},
  [1084] = {.lex_state = 39},
  [1085] = {.lex_state = 39},
  [1086] = {.lex_state = 39},
  [1087] = {.lex_state = 39},
  [1088] = {.lex_state = 39},
  [1089] = {.lex_state = 39},
  [1090] = {.lex_state = 39},
  [1091] = {.lex_state = 2},
  [1092] = {.lex_state = 39},
  [1093] = {.lex_state = 40},
  [1094] = {.lex_state = 39},
  [1095] = {.lex_state = 39},
  [1096] = {.lex_state = 39},
  [1097] = {.lex_state = 40},
  [1098] = {.lex_state = 39},
  [1099] = {.lex_state = 39},
  [1100] = {.lex_state = 39},
  [1101] = {.lex_state = 39},
  [1102] = {.lex_state = 39},
  [1103] = {.lex_state = 40},
  [1104] = {.lex_state = 39},
  [1105] = {.lex_state = 39},
  [1106] = {.lex_state = 2},
  [1107] = {.lex_state = 2},
  [1108] = {.lex_state = 40},
  [1109] = {.lex_state = 40},
  [1110] = {.lex_state = 40},
  [1111] = {.lex_state = 39},
  [1112] = {.lex_state = 2},
  [1113] = {.lex_state = 40},
  [1114] = {.lex_state = 2},
  [1115] = {.lex_state = 40},
  [1116] = {.lex_state = 39},
  [1117] = {.lex_state = 40},
  [1118] = {.lex_state = 40},
  [1119] = {.lex_state = 40},
  [1120] = {.lex_state = 40},
  [1121] = {.lex_state = 10},
  [1122] = {.lex_state = 2},
  [1123] = {.lex_state = 2},
  [1124] = {.lex_state = 2},
  [1125] = {.lex_state = 2},
  [1126] = {.lex_state = 10},
  [1127] = {.lex_state = 39},
  [1128] = {.lex_state = 39},
  [1129] = {.lex_state = 39},
  [1130] = {.lex_state = 2},
  [1131] = {.lex_state = 2},
  [1132] = {.lex_state = 39},
  [1133] = {.lex_state = 40},
  [1134] = {.lex_state = 40},
  [1135] = {.lex_state = 40},
  [1136] = {.lex_state = 40},
  [1137] = {.lex_state = 2},
  [1138] = {.lex_state = 39},
  [1139] = {.lex_state = 40},
  [1140] = {.lex_state = 2},
  [1141] = {.lex_state = 10},
  [1142] = {.lex_state = 2},
  [1143] = {.lex_state = 10},
  [1144] = {.lex_state = 2},
  [1145] = {.lex_state = 2},
  [1146] = {.lex_state = 2},
  [1147] = {.lex_state = 2},
  [1148] = {.lex_state = 40},
  [1149] = {.lex_state = 2},
  [1150] = {.lex_state = 2},
  [1151] = {.lex_state = 2},
  [1152] = {.lex_state = 2},
  [1153] = {.lex_state = 40},
  [1154] = {.lex_state = 10},
  [1155] = {.lex_state = 2},
  [1156] = {.lex_state = 2},
  [1157] = {.lex_state = 2},
  [1158] = {.lex_state = 2},
  [1159] = {.lex_state = 2},
  [1160] = {.lex_state = 2},
  [1161] = {.lex_state = 40},
  [1162] = {.lex_state = 2},
  [1163] = {.lex_state = 2},
  [1164] = {.lex_state = 10},
  [1165] = {.lex_state = 2},
  [1166] = {.lex_state = 40},
  [1167] = {.lex_state = 40},
  [1168] = {.lex_state = 10},
  [1169] = {.lex_state = 10},
  [1170] = {.lex_state = 10},
  [1171] = {.lex_state = 10},
  [1172] = {.lex_state = 10},
  [1173] = {.lex_state = 10},
  [1174] = {.lex_state = 40},
  [1175] = {.lex_state = 10},
  [1176] = {.lex_state = 10},
  [1177] = {.lex_state = 10},
  [1178] = {.lex_state = 40},
  [1179] = {.lex_state = 10},
  [1180] = {.lex_state = 10},
  [1181] = {.lex_state = 10},
  [1182] = {.lex_state = 40},
  [1183] = {.lex_state = 10},
  [1184] = {.lex_state = 40},
  [1185] = {.lex_state = 10},
  [1186] = {.lex_state = 10},
  [1187] = {.lex_state = 10},
  [1188] = {.lex_state = 40},
  [1189] = {.lex_state = 10},
  [1190] = {.lex_state = 10},
  [1191] = {.lex_state = 10},
  [1192] = {.lex_state = 10},
  [1193] = {.lex_state = 10},
  [1194] = {.lex_state = 10},
  [1195] = {.lex_state = 40},
  [1196] = {.lex_state = 40},
  [1197] = {.lex_state = 40},
  [1198] = {.lex_state = 40},
  [1199] = {.lex_state = 10},
  [1200] = {.lex_state = 40},
  [1201] = {.lex_state = 10},
  [1202] = {.lex_state = 10},
  [1203] = {.lex_state = 10},
  [1204] = {.lex_state = 10},
  [1205] = {.lex_state = 10},
  [1206] = {.lex_state = 10},
  [1207] = {.lex_state = 10},
  [1208] = {.lex_state = 10},
  [1209] = {.lex_state = 40},
  [1210] = {.lex_state = 10},
  [1211] = {.lex_state = 40},
  [1212] = {.lex_state = 10},
  [1213] = {.lex_state = 10},
  [1214] = {.lex_state = 10},
  [1215] = {.lex_state = 10},
  [1216] = {.lex_state = 40},
  [1217] = {.lex_state = 40},
  [1218] = {.lex_state = 10},
  [1219] = {.lex_state = 10},
  [1220] = {.lex_state = 40},
  [1221] = {.lex_state = 10},
  [1222] = {.lex_state = 10},
  [1223] = {.lex_state = 40},
  [1224] = {.lex_state = 40},
  [1225] = {.lex_state = 10},
  [1226] = {.lex_state = 10},
  [1227] = {.lex_state = 10},
  [1228] = {.lex_state = 10},
  [1229] = {.lex_state = 10},
  [1230] = {.lex_state = 10},
  [1231] = {.lex_state = 10},
  [1232] = {.lex_state = 10},
  [1233] = {.lex_state = 10},
  [1234] = {.lex_state = 40},
  [1235] = {.lex_state = 10},
  [1236] = {.lex_state = 10},
  [1237] = {.lex_state = 10},
  [1238] = {.lex_state = 40},
  [1239] = {.lex_state = 40},
  [1240] = {.lex_state = 40},
  [1241] = {.lex_state = 10},
  [1242] = {.lex_state = 40},
  [1243] = {.lex_state = 10},
  [1244] = {.lex_state = 40},
  [1245] = {.lex_state = 40},
  [1246] = {.lex_state = 10},
  [1247] = {.lex_state = 40},
  [1248] = {.lex_state = 40},
  [1249] = {.lex_state = 10},
  [1250] = {.lex_state = 40},
  [1251] = {.lex_state = 10},
  [1252] = {.lex_state = 40},
  [1253] = {.lex_state = 40},
  [1254] = {.lex_state = 10},
  [1255] = {.lex_state = 10},
  [1256] = {.lex_state = 10},
  [1257] = {.lex_state = 10},
  [1258] = {.lex_state = 40},
  [1259] = {.lex_state = 10},
  [1260] = {.lex_state = 10},
  [1261] = {.lex_state = 40},
  [1262] = {.lex_state = 40},
  [1263] = {.lex_state = 40},
  [1264] = {.lex_state = 10},
  [1265] = {.lex_state = 10},
  [1266] = {.lex_state = 10},
  [1267] = {.lex_state = 40},
  [1268] = {.lex_state = 10},
  [1269] = {.lex_state = 40},
  [1270] = {.lex_state = 10},
  [1271] = {.lex_state = 40},
  [1272] = {.lex_state = 10},
  [1273] = {.lex_state = 40},
  [1274] = {.lex_state = 40},
  [1275] = {.lex_state = 40},
  [1276] = {.lex_state = 10},
  [1277] = {.lex_state = 40},
  [1278] = {.lex_state = 40},
  [1279] = {.lex_state = 40},
  [1280] = {.lex_state = 10},
  [1281] = {.lex_state = 10},
  [1282] = {.lex_state = 40},
  [1283] = {.lex_state = 10},
  [1284] = {.lex_state = 10},
  [1285] = {.lex_state = 40},
  [1286] = {.lex_state = 40},
  [1287] = {.lex_state = 40},
  [1288] = {.lex_state = 40},
  [1289] = {.lex_state = 40},
  [1290] = {.lex_state = 40},
  [1291] = {.lex_state = 40},
  [1292] = {.lex_state = 40},
  [1293] = {.lex_state = 40},
  [1294] = {.lex_state = 40},
  [1295] = {.lex_state = 40},
  [1296] = {.lex_state = 40},
  [1297] = {.lex_state = 40},
  [1298] = {.lex_state = 39},
  [1299] = {.lex_state = 39},
  [1300] = {.lex_state = 39},
  [1301] = {.lex_state = 39},
  [1302] = {.lex_state = 39},
  [1303] = {.lex_state = 39},
  [1304] = {.lex_state = 40},
  [1305] = {.lex_state = 39},
  [1306] = {.lex_state = 39},
  [1307] = {.lex_state = 39},
  [1308] = {.lex_state = 39},
  [1309] = {.lex_state = 40},
  [1310] = {.lex_state = 40},
  [1311] = {.lex_state = 39},
  [1312] = {.lex_state = 39},
  [1313] = {.lex_state = 39},
  [1314] = {.lex_state = 40},
  [1315] = {.lex_state = 40},
  [1316] = {.lex_state = 39},
  [1317] = {.lex_state = 2},
  [1318] = {.lex_state = 39},
  [1319] = {.lex_state = 39},
  [1320] = {.lex_state = 2},
  [1321] = {.lex_state = 2},
  [1322] = {.lex_state = 39},
  [1323] = {.lex_state = 2},
  [1324] = {.lex_state = 39},
  [1325] = {.lex_state = 39},
  [1326] = {.lex_state = 39},
  [1327] = {.lex_state = 40},
  [1328] = {.lex_state = 40},
  [1329] = {.lex_state = 2},
  [1330] = {.lex_state = 2},
  [1331] = {.lex_state = 39},
  [1332] = {.lex_state = 39},
  [1333] = {.lex_state = 39},
  [1334] = {.lex_state = 39},
  [1335] = {.lex_state = 39},
  [1336] = {.lex_state = 39},
  [1337] = {.lex_state = 2},
  [1338] = {.lex_state = 39},
  [1339] = {.lex_state = 2},
  [1340] = {.lex_state = 2},
  [1341] = {.lex_state = 2},
  [1342] = {.lex_state = 39},
  [1343] = {.lex_state = 2},
  [1344] = {.lex_state = 2},
  [1345] = {.lex_state = 2},
  [1346] = {.lex_state = 40},
  [1347] = {.lex_state = 2},
  [1348] = {.lex_state = 39},
  [1349] = {.lex_state = 39},
  [1350] = {.lex_state = 2},
  [1351] = {.lex_state = 2},
  [1352] = {.lex_state = 39},
  [1353] = {.lex_state = 2},
  [1354] = {.lex_state = 2},
  [1355] = {.lex_state = 39},
  [1356] = {.lex_state = 40},
  [1357] = {.lex_state = 39},
  [1358] = {.lex_state = 40},
  [1359] = {.lex_state = 39},
  [1360] = {.lex_state = 40},
  [1361] = {.lex_state = 40},
  [1362] = {.lex_state = 40},
  [1363] = {.lex_state = 40},
  [1364] = {.lex_state = 40},
  [1365] = {.lex_state = 2},
  [1366] = {.lex_state = 40},
  [1367] = {.lex_state = 40},
  [1368] = {.lex_state = 40},
  [1369] = {.lex_state = 40},
  [1370] = {.lex_state = 2},
  [1371] = {.lex_state = 40},
  [1372] = {.lex_state = 40},
  [1373] = {.lex_state = 40},
  [1374] = {.lex_state = 40},
  [1375] = {.lex_state = 40},
  [1376] = {.lex_state = 40},
  [1377] = {.lex_state = 40},
  [1378] = {.lex_state = 40},
  [1379] = {.lex_state = 40},
  [1380] = {.lex_state = 40},
  [1381] = {.lex_state = 40},
  [1382] = {.lex_state = 40},
  [1383] = {.lex_state = 40},
  [1384] = {.lex_state = 40},
  [1385] = {.lex_state = 40},
  [1386] = {.lex_state = 40},
  [1387] = {.lex_state = 40},
  [1388] = {.lex_state = 40},
  [1389] = {.lex_state = 39},
  [1390] = {.lex_state = 40},
  [1391] = {.lex_state = 40},
  [1392] = {.lex_state = 40},
  [1393] = {.lex_state = 40},
  [1394] = {.lex_state = 40},
  [1395] = {.lex_state = 40},
  [1396] = {.lex_state = 40},
  [1397] = {.lex_state = 40},
  [1398] = {.lex_state = 39},
  [1399] = {.lex_state = 40},
  [1400] = {.lex_state = 40},
  [1401] = {.lex_state = 40},
  [1402] = {.lex_state = 40},
  [1403] = {.lex_state = 40},
  [1404] = {.lex_state = 39},
  [1405] = {.lex_state = 40},
  [1406] = {.lex_state = 40},
  [1407] = {.lex_state = 40},
  [1408] = {.lex_state = 10},
  [1409] = {.lex_state = 40},
  [1410] = {.lex_state = 39},
  [1411] = {.lex_state = 40},
  [1412] = {.lex_state = 40},
  [1413] = {.lex_state = 40},
  [1414] = {.lex_state = 39},
  [1415] = {.lex_state = 40},
  [1416] = {.lex_state = 40},
  [1417] = {.lex_state = 40},
  [1418] = {.lex_state = 40},
  [1419] = {.lex_state = 39},
  [1420] = {.lex_state = 40},
  [1421] = {.lex_state = 40},
  [1422] = {.lex_state = 40},
  [1423] = {.lex_state = 40},
  [1424] = {.lex_state = 39},
  [1425] = {.lex_state = 39},
  [1426] = {.lex_state = 39},
  [1427] = {.lex_state = 39},
  [1428] = {.lex_state = 39},
  [1429] = {.lex_state = 39},
  [1430] = {.lex_state = 39},
  [1431] = {.lex_state = 10},
  [1432] = {.lex_state = 39},
  [1433] = {.lex_state = 39},
  [1434] = {.lex_state = 40},
  [1435] = {.lex_state = 39},
  [1436] = {.lex_state = 39},
  [1437] = {.lex_state = 39},
  [1438] = {.lex_state = 10},
  [1439] = {.lex_state = 40},
  [1440] = {.lex_state = 39},
  [1441] = {.lex_state = 39},
  [1442] = {.lex_state = 39},
  [1443] = {.lex_state = 10},
  [1444] = {.lex_state = 39},
  [1445] = {.lex_state = 39},
  [1446] = {.lex_state = 39},
  [1447] = {.lex_state = 39},
  [1448] = {.lex_state = 39},
  [1449] = {.lex_state = 39},
  [1450] = {.lex_state = 39},
  [1451] = {.lex_state = 39},
  [1452] = {.lex_state = 39},
  [1453] = {.lex_state = 39},
  [1454] = {.lex_state = 39},
  [1455] = {.lex_state = 39},
  [1456] = {.lex_state = 39},
  [1457] = {.lex_state = 39},
  [1458] = {.lex_state = 39},
  [1459] = {.lex_state = 39},
  [1460] = {.lex_state = 39},
  [1461] = {.lex_state = 39},
  [1462] = {.lex_state = 39},
  [1463] = {.lex_state = 39},
  [1464] = {.lex_state = 39},
  [1465] = {.lex_state = 39},
  [1466] = {.lex_state = 39},
  [1467] = {.lex_state = 39},
  [1468] = {.lex_state = 39},
  [1469] = {.lex_state = 39},
  [1470] = {.lex_state = 39},
  [1471] = {.lex_state = 39},
  [1472] = {.lex_state = 39},
  [1473] = {.lex_state = 39},
  [1474] = {.lex_state = 39},
  [1475] = {.lex_state = 39},
  [1476] = {.lex_state = 39},
  [1477] = {.lex_state = 39},
  [1478] = {.lex_state = 39},
  [1479] = {.lex_state = 39},
  [1480] = {.lex_state = 39},
  [1481] = {.lex_state = 39},
  [1482] = {.lex_state = 39},
  [1483] = {.lex_state = 39},
  [1484] = {.lex_state = 39},
  [1485] = {.lex_state = 39},
  [1486] = {.lex_state = 39},
  [1487] = {.lex_state = 40},
  [1488] = {.lex_state = 39},
  [1489] = {.lex_state = 39},
  [1490] = {.lex_state = 39},
  [1491] = {.lex_state = 39},
  [1492] = {.lex_state = 39},
  [1493] = {.lex_state = 39},
  [1494] = {.lex_state = 39},
  [1495] = {.lex_state = 39},
  [1496] = {.lex_state = 39},
  [1497] = {.lex_state = 39},
  [1498] = {.lex_state = 39},
  [1499] = {.lex_state = 39},
  [1500] = {.lex_state = 39},
  [1501] = {.lex_state = 39},
  [1502] = {.lex_state = 39},
  [1503] = {.lex_state = 39},
  [1504] = {.lex_state = 39},
  [1505] = {.lex_state = 39},
  [1506] = {.lex_state = 39},
  [1507] = {.lex_state = 40},
  [1508] = {.lex_state = 39},
  [1509] = {.lex_state = 39},
  [1510] = {.lex_state = 39},
  [1511] = {.lex_state = 39},
  [1512] = {.lex_state = 39},
  [1513] = {.lex_state = 39},
  [1514] = {.lex_state = 39},
  [1515] = {.lex_state = 39},
  [1516] = {.lex_state = 39},
  [1517] = {.lex_state = 39},
  [1518] = {.lex_state = 39},
  [1519] = {.lex_state = 39},
  [1520] = {.lex_state = 39},
  [1521] = {.lex_state = 39},
  [1522] = {.lex_state = 39},
  [1523] = {.lex_state = 39},
  [1524] = {.lex_state = 39},
  [1525] = {.lex_state = 39},
  [1526] = {.lex_state = 39},
  [1527] = {.lex_state = 39},
  [1528] = {.lex_state = 39},
  [1529] = {.lex_state = 39},
  [1530] = {.lex_state = 39},
  [1531] = {.lex_state = 39},
  [1532] = {.lex_state = 39},
  [1533] = {.lex_state = 39},
  [1534] = {.lex_state = 40},
  [1535] = {.lex_state = 39},
  [1536] = {.lex_state = 39},
  [1537] = {.lex_state = 39},
  [1538] = {.lex_state = 39},
  [1539] = {.lex_state = 39},
  [1540] = {.lex_state = 39},
  [1541] = {.lex_state = 39},
  [1542] = {.lex_state = 39},
  [1543] = {.lex_state = 39},
  [1544] = {.lex_state = 40},
  [1545] = {.lex_state = 39},
  [1546] = {.lex_state = 39},
  [1547] = {.lex_state = 39},
  [1548] = {.lex_state = 39},
  [1549] = {.lex_state = 39},
  [1550] = {.lex_state = 39},
  [1551] = {.lex_state = 39},
  [1552] = {.lex_state = 39},
  [1553] = {.lex_state = 39},
  [1554] = {.lex_state = 39},
  [1555] = {.lex_state = 39},
  [1556] = {.lex_state = 40},
  [1557] = {.lex_state = 40},
  [1558] = {.lex_state = 39},
  [1559] = {.lex_state = 40},
  [1560] = {.lex_state = 40},
  [1561] = {.lex_state = 40},
  [1562] = {.lex_state = 39},
  [1563] = {.lex_state = 39},
  [1564] = {.lex_state = 39},
  [1565] = {.lex_state = 39},
  [1566] = {.lex_state = 39},
  [1567] = {.lex_state = 39},
  [1568] = {.lex_state = 39},
  [1569] = {.lex_state = 39},
  [1570] = {.lex_state = 39},
  [1571] = {.lex_state = 40},
  [1572] = {.lex_state = 39},
  [1573] = {.lex_state = 39},
  [1574] = {.lex_state = 39},
  [1575] = {.lex_state = 39},
  [1576] = {.lex_state = 39},
  [1577] = {.lex_state = 39},
  [1578] = {.lex_state = 39},
  [1579] = {.lex_state = 39},
  [1580] = {.lex_state = 39},
  [1581] = {.lex_state = 39},
  [1582] = {.lex_state = 39},
  [1583] = {.lex_state = 40},
  [1584] = {.lex_state = 39},
  [1585] = {.lex_state = 39},
  [1586] = {.lex_state = 39},
  [1587] = {.lex_state = 39},
  [1588] = {.lex_state = 39},
  [1589] = {.lex_state = 39},
  [1590] = {.lex_state = 39},
  [1591] = {.lex_state = 39},
  [1592] = {.lex_state = 39},
  [1593] = {.lex_state = 39},
  [1594] = {.lex_state = 39},
  [1595] = {.lex_state = 39},
  [1596] = {.lex_state = 39},
  [1597] = {.lex_state = 39},
  [1598] = {.lex_state = 39},
  [1599] = {.lex_state = 39},
  [1600] = {.lex_state = 39},
  [1601] = {.lex_state = 39},
  [1602] = {.lex_state = 39},
  [1603] = {.lex_state = 39},
  [1604] = {.lex_state = 39},
  [1605] = {.lex_state = 39},
  [1606] = {.lex_state = 39},
  [1607] = {.lex_state = 39},
  [1608] = {.lex_state = 39},
  [1609] = {.lex_state = 39},
  [1610] = {.lex_state = 39},
  [1611] = {.lex_state = 40},
  [1612] = {.lex_state = 39},
  [1613] = {.lex_state = 39},
  [1614] = {.lex_state = 39},
  [1615] = {.lex_state = 39},
  [1616] = {.lex_state = 39},
  [1617] = {.lex_state = 39},
  [1618] = {.lex_state = 39},
  [1619] = {.lex_state = 39},
  [1620] = {.lex_state = 39},
  [1621] = {.lex_state = 39},
  [1622] = {.lex_state = 39},
  [1623] = {.lex_state = 39},
  [1624] = {.lex_state = 39},
  [1625] = {.lex_state = 39},
  [1626] = {.lex_state = 39},
  [1627] = {.lex_state = 39},
  [1628] = {.lex_state = 39},
  [1629] = {.lex_state = 39},
  [1630] = {.lex_state = 39},
  [1631] = {.lex_state = 39},
  [1632] = {.lex_state = 39},
  [1633] = {.lex_state = 39},
  [1634] = {.lex_state = 39},
  [1635] = {.lex_state = 39},
  [1636] = {.lex_state = 39},
  [1637] = {.lex_state = 39},
  [1638] = {.lex_state = 39},
  [1639] = {.lex_state = 39},
  [1640] = {.lex_state = 39},
  [1641] = {.lex_state = 39},
  [1642] = {.lex_state = 39},
  [1643] = {.lex_state = 39},
  [1644] = {.lex_state = 39},
  [1645] = {.lex_state = 39},
  [1646] = {.lex_state = 39},
  [1647] = {.lex_state = 39},
  [1648] = {.lex_state = 39},
  [1649] = {.lex_state = 39},
  [1650] = {.lex_state = 39},
  [1651] = {.lex_state = 39},
  [1652] = {.lex_state = 39},
  [1653] = {.lex_state = 39},
  [1654] = {.lex_state = 8},
  [1655] = {.lex_state = 39},
  [1656] = {.lex_state = 8},
  [1657] = {.lex_state = 8},
  [1658] = {.lex_state = 8},
  [1659] = {.lex_state = 8},
  [1660] = {.lex_state = 39},
  [1661] = {.lex_state = 8},
  [1662] = {.lex_state = 8},
  [1663] = {.lex_state = 39},
  [1664] = {.lex_state = 39},
  [1665] = {.lex_state = 4},
  [1666] = {.lex_state = 39},
  [1667] = {.lex_state = 39},
  [1668] = {.lex_state = 39},
  [1669] = {.lex_state = 39},
  [1670] = {.lex_state = 39},
  [1671] = {.lex_state = 4},
  [1672] = {.lex_state = 39},
  [1673] = {.lex_state = 9},
  [1674] = {.lex_state = 9},
  [1675] = {.lex_state = 39},
  [1676] = {.lex_state = 39},
  [1677] = {.lex_state = 39},
  [1678] = {.lex_state = 9},
  [1679] = {.lex_state = 40},
  [1680] = {.lex_state = 9},
  [1681] = {.lex_state = 9},
  [1682] = {.lex_state = 39},
  [1683] = {.lex_state = 39},
  [1684] = {.lex_state = 8},
  [1685] = {.lex_state = 39},
  [1686] = {.lex_state = 9},
  [1687] = {.lex_state = 8},
  [1688] = {.lex_state = 39},
  [1689] = {.lex_state = 39},
  [1690] = {.lex_state = 39},
  [1691] = {.lex_state = 9},
  [1692] = {.lex_state = 39},
  [1693] = {.lex_state = 39},
  [1694] = {.lex_state = 39},
  [1695] = {.lex_state = 39},
  [1696] = {.lex_state = 39},
  [1697] = {.lex_state = 39},
  [1698] = {.lex_state = 39},
  [1699] = {.lex_state = 39},
  [1700] = {.lex_state = 4},
  [1701] = {.lex_state = 39},
  [1702] = {.lex_state = 39},
  [1703] = {.lex_state = 39},
  [1704] = {.lex_state = 4},
  [1705] = {.lex_state = 39},
  [1706] = {.lex_state = 39},
  [1707] = {.lex_state = 4},
  [1708] = {.lex_state = 39},
  [1709] = {.lex_state = 4},
  [1710] = {.lex_state = 39},
  [1711] = {.lex_state = 4},
  [1712] = {.lex_state = 39},
  [1713] = {.lex_state = 39},
  [1714] = {.lex_state = 39},
  [1715] = {.lex_state = 39},
  [1716] = {.lex_state = 39},
  [1717] = {.lex_state = 39},
  [1718] = {.lex_state = 39},
  [1719] = {.lex_state = 39},
  [1720] = {.lex_state = 4},
  [1721] = {.lex_state = 39},
  [1722] = {.lex_state = 4},
  [1723] = {.lex_state = 39},
  [1724] = {.lex_state = 40},
  [1725] = {.lex_state = 39},
  [1726] = {.lex_state = 39},
  [1727] = {.lex_state = 39},
  [1728] = {.lex_state = 39},
  [1729] = {.lex_state = 39},
  [1730] = {.lex_state = 39},
  [1731] = {.lex_state = 9},
  [1732] = {.lex_state = 9},
  [1733] = {.lex_state = 40},
  [1734] = {.lex_state = 39},
  [1735] = {.lex_state = 39},
  [1736] = {.lex_state = 39},
  [1737] = {.lex_state = 39},
  [1738] = {.lex_state = 40},
  [1739] = {.lex_state = 39},
  [1740] = {.lex_state = 40},
  [1741] = {.lex_state = 40},
  [1742] = {.lex_state = 4},
  [1743] = {.lex_state = 39},
  [1744] = {.lex_state = 39},
  [1745] = {.lex_state = 39},
  [1746] = {.lex_state = 39},
  [1747] = {.lex_state = 39},
  [1748] = {.lex_state = 39},
  [1749] = {.lex_state = 39},
  [1750] = {.lex_state = 40},
  [1751] = {.lex_state = 39},
  [1752] = {.lex_state = 9},
  [1753] = {.lex_state = 39},
  [1754] = {.lex_state = 39},
  [1755] = {.lex_state = 39},
  [1756] = {.lex_state = 39},
  [1757] = {.lex_state = 39},
  [1758] = {.lex_state = 39},
  [1759] = {.lex_state = 39},
  [1760] = {.lex_state = 40},
  [1761] = {.lex_state = 39},
  [1762] = {.lex_state = 39},
  [1763] = {.lex_state = 39},
  [1764] = {.lex_state = 39},
  [1765] = {.lex_state = 39},
  [1766] = {.lex_state = 39},
  [1767] = {.lex_state = 39},
  [1768] = {.lex_state = 39},
  [1769] = {.lex_state = 39},
  [1770] = {.lex_state = 39},
  [1771] = {.lex_state = 39},
  [1772] = {.lex_state = 9},
  [1773] = {.lex_state = 39},
  [1774] = {.lex_state = 39},
  [1775] = {.lex_state = 39},
  [1776] = {.lex_state = 40},
  [1777] = {.lex_state = 39},
  [1778] = {.lex_state = 39},
  [1779] = {.lex_state = 9},
  [1780] = {.lex_state = 39},
  [1781] = {.lex_state = 39},
  [1782] = {.lex_state = 39},
  [1783] = {.lex_state = 39},
  [1784] = {.lex_state = 39},
  [1785] = {.lex_state = 40},
  [1786] = {.lex_state = 39},
  [1787] = {.lex_state = 39},
  [1788] = {.lex_state = 39},
  [1789] = {.lex_state = 39},
  [1790] = {.lex_state = 40},
  [1791] = {.lex_state = 39},
  [1792] = {.lex_state = 39},
  [1793] = {.lex_state = 40},
  [1794] = {.lex_state = 4},
  [1795] = {.lex_state = 40},
  [1796] = {.lex_state = 39},
  [1797] = {.lex_state = 39},
  [1798] = {.lex_state = 39},
  [1799] = {.lex_state = 39},
  [1800] = {.lex_state = 39},
  [1801] = {.lex_state = 39},
  [1802] = {.lex_state = 39},
  [1803] = {.lex_state = 39},
  [1804] = {.lex_state = 39},
  [1805] = {.lex_state = 39},
  [1806] = {.lex_state = 39},
  [1807] = {.lex_state = 39},
  [1808] = {.lex_state = 39},
  [1809] = {.lex_state = 39},
  [1810] = {.lex_state = 39},
  [1811] = {.lex_state = 39},
  [1812] = {.lex_state = 39},
  [1813] = {.lex_state = 39},
  [1814] = {.lex_state = 39},
  [1815] = {.lex_state = 39},
  [1816] = {.lex_state = 39},
  [1817] = {.lex_state = 39},
  [1818] = {.lex_state = 39},
  [1819] = {.lex_state = 39},
  [1820] = {.lex_state = 39},
  [1821] = {.lex_state = 9},
  [1822] = {.lex_state = 9},
  [1823] = {.lex_state = 9},
  [1824] = {.lex_state = 39},
  [1825] = {.lex_state = 4},
  [1826] = {.lex_state = 39},
  [1827] = {.lex_state = 9},
  [1828] = {.lex_state = 39},
  [1829] = {.lex_state = 39},
  [1830] = {.lex_state = 39},
  [1831] = {.lex_state = 39},
  [1832] = {.lex_state = 39},
  [1833] = {.lex_state = 39},
  [1834] = {.lex_state = 39},
  [1835] = {.lex_state = 39},
  [1836] = {.lex_state = 9},
  [1837] = {.lex_state = 39},
  [1838] = {.lex_state = 39},
  [1839] = {.lex_state = 39},
  [1840] = {.lex_state = 9},
  [1841] = {.lex_state = 39},
  [1842] = {.lex_state = 39},
  [1843] = {.lex_state = 4},
  [1844] = {.lex_state = 4},
  [1845] = {.lex_state = 9},
  [1846] = {.lex_state = 39},
  [1847] = {.lex_state = 39},
  [1848] = {.lex_state = 39},
  [1849] = {.lex_state = 39},
  [1850] = {.lex_state = 39},
  [1851] = {.lex_state = 39},
  [1852] = {.lex_state = 39},
  [1853] = {.lex_state = 9},
  [1854] = {.lex_state = 39},
  [1855] = {.lex_state = 39},
  [1856] = {.lex_state = 39},
  [1857] = {.lex_state = 39},
  [1858] = {.lex_state = 39},
  [1859] = {.lex_state = 9},
  [1860] = {.lex_state = 39},
  [1861] = {.lex_state = 39},
  [1862] = {.lex_state = 39},
  [1863] = {.lex_state = 39},
  [1864] = {.lex_state = 39},
  [1865] = {.lex_state = 9},
  [1866] = {.lex_state = 39},
  [1867] = {.lex_state = 9},
  [1868] = {.lex_state = 9},
  [1869] = {.lex_state = 39},
  [1870] = {.lex_state = 39},
  [1871] = {.lex_state = 39},
  [1872] = {.lex_state = 9},
  [1873] = {.lex_state = 39},
  [1874] = {.lex_state = 39},
  [1875] = {.lex_state = 9},
  [1876] = {.lex_state = 39},
  [1877] = {.lex_state = 39},
  [1878] = {.lex_state = 39},
  [1879] = {.lex_state = 39},
  [1880] = {.lex_state = 9},
  [1881] = {.lex_state = 39},
  [1882] = {.lex_state = 39},
  [1883] = {.lex_state = 39},
  [1884] = {.lex_state = 39},
  [1885] = {.lex_state = 39},
  [1886] = {.lex_state = 39},
  [1887] = {.lex_state = 39},
  [1888] = {.lex_state = 39},
  [1889] = {.lex_state = 39},
  [1890] = {.lex_state = 4},
  [1891] = {.lex_state = 39},
  [1892] = {.lex_state = 39},
  [1893] = {.lex_state = 39},
  [1894] = {.lex_state = 39},
  [1895] = {.lex_state = 39},
  [1896] = {.lex_state = 39},
  [1897] = {.lex_state = 4},
  [1898] = {.lex_state = 39},
  [1899] = {.lex_state = 39},
  [1900] = {.lex_state = 39},
  [1901] = {.lex_state = 39},
  [1902] = {.lex_state = 39},
  [1903] = {.lex_state = 39},
  [1904] = {.lex_state = 39},
  [1905] = {.lex_state = 39},
  [1906] = {.lex_state = 39},
  [1907] = {.lex_state = 9},
  [1908] = {.lex_state = 39},
  [1909] = {.lex_state = 9},
  [1910] = {.lex_state = 39},
  [1911] = {.lex_state = 39},
  [1912] = {.lex_state = 9},
  [1913] = {.lex_state = 39},
  [1914] = {.lex_state = 9},
  [1915] = {.lex_state = 9},
  [1916] = {.lex_state = 39},
  [1917] = {.lex_state = 39},
  [1918] = {.lex_state = 39},
  [1919] = {.lex_state = 39},
  [1920] = {.lex_state = 39},
  [1921] = {.lex_state = 9},
  [1922] = {.lex_state = 39},
  [1923] = {.lex_state = 9},
  [1924] = {.lex_state = 39},
  [1925] = {.lex_state = 9},
  [1926] = {.lex_state = 39},
  [1927] = {.lex_state = 39},
  [1928] = {.lex_state = 39},
  [1929] = {.lex_state = 39},
  [1930] = {.lex_state = 39},
  [1931] = {.lex_state = 39},
  [1932] = {.lex_state = 39},
  [1933] = {.lex_state = 39},
  [1934] = {.lex_state = 39},
  [1935] = {.lex_state = 39},
  [1936] = {.lex_state = 39},
  [1937] = {.lex_state = 39},
  [1938] = {.lex_state = 39},
  [1939] = {.lex_state = 39},
  [1940] = {.lex_state = 39},
  [1941] = {.lex_state = 39},
  [1942] = {.lex_state = 9},
  [1943] = {.lex_state = 9},
  [1944] = {.lex_state = 9},
  [1945] = {.lex_state = 9},
  [1946] = {.lex_state = 39},
  [1947] = {.lex_state = 39},
  [1948] = {.lex_state = 39},
  [1949] = {.lex_state = 39},
  [1950] = {.lex_state = 39},
  [1951] = {.lex_state = 4},
  [1952] = {.lex_state = 39},
  [1953] = {.lex_state = 39},
  [1954] = {.lex_state = 4},
  [1955] = {.lex_state = 39},
  [1956] = {.lex_state = 39},
  [1957] = {.lex_state = 39},
  [1958] = {.lex_state = 39},
  [1959] = {.lex_state = 39},
  [1960] = {.lex_state = 39},
  [1961] = {.lex_state = 39},
  [1962] = {.lex_state = 9},
  [1963] = {.lex_state = 39},
  [1964] = {.lex_state = 9},
  [1965] = {.lex_state = 39},
  [1966] = {.lex_state = 9},
  [1967] = {.lex_state = 9},
  [1968] = {.lex_state = 39},
  [1969] = {.lex_state = 9},
  [1970] = {.lex_state = 9},
  [1971] = {.lex_state = 9},
  [1972] = {.lex_state = 9},
  [1973] = {.lex_state = 39},
  [1974] = {.lex_state = 39},
  [1975] = {.lex_state = 39},
  [1976] = {.lex_state = 39},
  [1977] = {.lex_state = 39},
  [1978] = {.lex_state = 39},
  [1979] = {.lex_state = 39},
  [1980] = {.lex_state = 39},
  [1981] = {.lex_state = 39},
  [1982] = {.lex_state = 39},
  [1983] = {.lex_state = 39},
  [1984] = {.lex_state = 39},
  [1985] = {.lex_state = 39},
  [1986] = {.lex_state = 39},
  [1987] = {.lex_state = 39},
  [1988] = {.lex_state = 39},
  [1989] = {.lex_state = 39},
  [1990] = {.lex_state = 39},
  [1991] = {.lex_state = 39},
  [1992] = {.lex_state = 4},
  [1993] = {.lex_state = 39},
  [1994] = {.lex_state = 39},
  [1995] = {.lex_state = 39},
  [1996] = {.lex_state = 39},
  [1997] = {.lex_state = 39},
  [1998] = {.lex_state = 39},
  [1999] = {.lex_state = 39},
  [2000] = {.lex_state = 39},
  [2001] = {.lex_state = 39},
  [2002] = {.lex_state = 40},
  [2003] = {.lex_state = 39},
  [2004] = {.lex_state = 39},
  [2005] = {.lex_state = 39},
  [2006] = {.lex_state = 39},
  [2007] = {.lex_state = 40},
  [2008] = {.lex_state = 39},
  [2009] = {.lex_state = 39},
  [2010] = {.lex_state = 40},
  [2011] = {.lex_state = 39},
  [2012] = {.lex_state = 39},
  [2013] = {.lex_state = 39},
  [2014] = {.lex_state = 40},
  [2015] = {.lex_state = 9},
  [2016] = {.lex_state = 39},
  [2017] = {.lex_state = 9},
  [2018] = {.lex_state = 9},
  [2019] = {.lex_state = 39},
  [2020] = {.lex_state = 39},
  [2021] = {.lex_state = 39},
  [2022] = {.lex_state = 39},
  [2023] = {.lex_state = 39},
  [2024] = {.lex_state = 9},
  [2025] = {.lex_state = 39},
  [2026] = {.lex_state = 39},
  [2027] = {.lex_state = 9},
  [2028] = {.lex_state = 39},
  [2029] = {.lex_state = 9},
  [2030] = {.lex_state = 39},
  [2031] = {.lex_state = 9},
  [2032] = {.lex_state = 39},
  [2033] = {.lex_state = 9},
  [2034] = {.lex_state = 9},
  [2035] = {.lex_state = 39},
  [2036] = {.lex_state = 39},
  [2037] = {.lex_state = 39},
  [2038] = {.lex_state = 39},
  [2039] = {.lex_state = 39},
  [2040] = {.lex_state = 39},
  [2041] = {.lex_state = 39},
  [2042] = {.lex_state = 39},
  [2043] = {.lex_state = 9},
  [2044] = {.lex_state = 39},
  [2045] = {.lex_state = 9},
  [2046] = {.lex_state = 4},
  [2047] = {.lex_state = 39},
  [2048] = {.lex_state = 39},
  [2049] = {.lex_state = 39},
  [2050] = {.lex_state = 39},
  [2051] = {.lex_state = 39},
  [2052] = {.lex_state = 39},
  [2053] = {.lex_state = 39},
  [2054] = {.lex_state = 39},
  [2055] = {.lex_state = 39},
  [2056] = {.lex_state = 39},
  [2057] = {.lex_state = 39},
  [2058] = {.lex_state = 39},
  [2059] = {.lex_state = 39},
  [2060] = {.lex_state = 39},
  [2061] = {.lex_state = 39},
  [2062] = {.lex_state = 39},
  [2063] = {.lex_state = 39},
  [2064] = {.lex_state = 39},
  [2065] = {.lex_state = 39},
  [2066] = {.lex_state = 39},
  [2067] = {.lex_state = 39},
  [2068] = {.lex_state = 39},
  [2069] = {.lex_state = 39},
  [2070] = {.lex_state = 39},
  [2071] = {.lex_state = 39},
  [2072] = {.lex_state = 39},
  [2073] = {.lex_state = 39},
  [2074] = {.lex_state = 39},
  [2075] = {.lex_state = 9},
  [2076] = {.lex_state = 39},
  [2077] = {.lex_state = 4},
  [2078] = {.lex_state = 39},
  [2079] = {.lex_state = 39},
  [2080] = {.lex_state = 39},
  [2081] = {.lex_state = 39},
  [2082] = {.lex_state = 39},
  [2083] = {.lex_state = 39},
  [2084] = {.lex_state = 39},
  [2085] = {.lex_state = 39},
  [2086] = {.lex_state = 9},
  [2087] = {.lex_state = 39},
  [2088] = {.lex_state = 39},
  [2089] = {.lex_state = 39},
  [2090] = {.lex_state = 39},
  [2091] = {.lex_state = 39},
  [2092] = {.lex_state = 39},
  [2093] = {.lex_state = 39},
  [2094] = {.lex_state = 4},
  [2095] = {.lex_state = 39},
  [2096] = {.lex_state = 40},
  [2097] = {.lex_state = 39},
  [2098] = {.lex_state = 39},
  [2099] = {.lex_state = 39},
  [2100] = {.lex_state = 39},
  [2101] = {.lex_state = 39},
  [2102] = {.lex_state = 39},
  [2103] = {.lex_state = 39},
  [2104] = {.lex_state = 39},
  [2105] = {.lex_state = 39},
  [2106] = {.lex_state = 39},
  [2107] = {.lex_state = 39},
  [2108] = {.lex_state = 39},
  [2109] = {.lex_state = 39},
  [2110] = {.lex_state = 39},
  [2111] = {.lex_state = 39},
  [2112] = {.lex_state = 39},
  [2113] = {.lex_state = 39},
  [2114] = {.lex_state = 39},
  [2115] = {.lex_state = 39},
  [2116] = {.lex_state = 39},
  [2117] = {.lex_state = 39},
  [2118] = {.lex_state = 39},
  [2119] = {.lex_state = 39},
  [2120] = {.lex_state = 39},
  [2121] = {.lex_state = 39},
  [2122] = {.lex_state = 39},
  [2123] = {.lex_state = 39},
  [2124] = {.lex_state = 39},
  [2125] = {.lex_state = 39},
  [2126] = {.lex_state = 39},
  [2127] = {.lex_state = 39},
  [2128] = {.lex_state = 39},
  [2129] = {.lex_state = 39},
  [2130] = {.lex_state = 39},
  [2131] = {.lex_state = 39},
  [2132] = {.lex_state = 39},
  [2133] = {.lex_state = 39},
  [2134] = {.lex_state = 39},
  [2135] = {.lex_state = 39},
  [2136] = {.lex_state = 39},
  [2137] = {.lex_state = 39},
  [2138] = {.lex_state = 39},
  [2139] = {.lex_state = 39},
  [2140] = {.lex_state = 39},
  [2141] = {.lex_state = 39},
  [2142] = {.lex_state = 39},
  [2143] = {.lex_state = 39},
  [2144] = {.lex_state = 39},
  [2145] = {.lex_state = 39},
  [2146] = {.lex_state = 39},
  [2147] = {.lex_state = 39},
  [2148] = {.lex_state = 39},
  [2149] = {.lex_state = 39},
  [2150] = {.lex_state = 39},
  [2151] = {.lex_state = 39},
  [2152] = {.lex_state = 39},
  [2153] = {.lex_state = 39},
  [2154] = {.lex_state = 39},
  [2155] = {.lex_state = 39},
  [2156] = {.lex_state = 39},
  [2157] = {.lex_state = 39},
  [2158] = {.lex_state = 39},
  [2159] = {.lex_state = 39},
  [2160] = {.lex_state = 39},
  [2161] = {.lex_state = 39},
  [2162] = {.lex_state = 39},
  [2163] = {.lex_state = 39},
  [2164] = {.lex_state = 39},
  [2165] = {.lex_state = 39},
  [2166] = {.lex_state = 39},
  [2167] = {.lex_state = 39},
  [2168] = {.lex_state = 39},
  [2169] = {.lex_state = 39},
  [2170] = {.lex_state = 39},
  [2171] = {.lex_state = 39},
  [2172] = {.lex_state = 39},
  [2173] = {.lex_state = 39},
  [2174] = {.lex_state = 39},
  [2175] = {.lex_state = 4},
  [2176] = {.lex_state = 39},
  [2177] = {.lex_state = 39},
  [2178] = {.lex_state = 39},
  [2179] = {.lex_state = 39},
  [2180] = {.lex_state = 39},
  [2181] = {.lex_state = 39},
  [2182] = {.lex_state = 39},
  [2183] = {.lex_state = 39},
  [2184] = {.lex_state = 39},
  [2185] = {.lex_state = 39},
  [2186] = {.lex_state = 39},
  [2187] = {.lex_state = 39},
  [2188] = {.lex_state = 39},
  [2189] = {.lex_state = 39},
  [2190] = {.lex_state = 39},
  [2191] = {.lex_state = 39},
  [2192] = {.lex_state = 39},
  [2193] = {.lex_state = 39},
  [2194] = {.lex_state = 39},
  [2195] = {.lex_state = 39},
  [2196] = {.lex_state = 39},
  [2197] = {.lex_state = 39},
  [2198] = {.lex_state = 39},
  [2199] = {.lex_state = 39},
  [2200] = {.lex_state = 39},
  [2201] = {.lex_state = 39},
  [2202] = {.lex_state = 39},
  [2203] = {.lex_state = 39},
  [2204] = {.lex_state = 39},
  [2205] = {.lex_state = 39},
  [2206] = {.lex_state = 39},
  [2207] = {.lex_state = 39},
  [2208] = {.lex_state = 39},
  [2209] = {.lex_state = 39},
  [2210] = {.lex_state = 39},
  [2211] = {.lex_state = 39},
  [2212] = {.lex_state = 39},
  [2213] = {.lex_state = 39},
  [2214] = {.lex_state = 39},
  [2215] = {.lex_state = 39},
  [2216] = {.lex_state = 39},
  [2217] = {.lex_state = 39},
  [2218] = {.lex_state = 39},
  [2219] = {.lex_state = 39},
  [2220] = {.lex_state = 39},
  [2221] = {.lex_state = 39},
  [2222] = {.lex_state = 39},
  [2223] = {.lex_state = 39},
  [2224] = {.lex_state = 39},
  [2225] = {.lex_state = 39},
  [2226] = {.lex_state = 39},
  [2227] = {.lex_state = 39},
  [2228] = {.lex_state = 39},
  [2229] = {.lex_state = 39},
  [2230] = {.lex_state = 39},
  [2231] = {.lex_state = 39},
  [2232] = {.lex_state = 39},
  [2233] = {.lex_state = 39},
  [2234] = {.lex_state = 39},
  [2235] = {.lex_state = 39},
  [2236] = {.lex_state = 39},
  [2237] = {.lex_state = 39},
  [2238] = {.lex_state = 39},
  [2239] = {.lex_state = 39},
  [2240] = {.lex_state = 39},
  [2241] = {.lex_state = 39},
  [2242] = {.lex_state = 39},
  [2243] = {.lex_state = 39},
  [2244] = {.lex_state = 39},
  [2245] = {.lex_state = 39},
  [2246] = {.lex_state = 39},
  [2247] = {.lex_state = 39},
  [2248] = {.lex_state = 39},
  [2249] = {.lex_state = 39},
  [2250] = {.lex_state = 39},
  [2251] = {.lex_state = 39},
  [2252] = {.lex_state = 39},
  [2253] = {.lex_state = 39},
  [2254] = {.lex_state = 39},
  [2255] = {.lex_state = 39},
  [2256] = {.lex_state = 39},
  [2257] = {.lex_state = 39},
  [2258] = {.lex_state = 39},
  [2259] = {.lex_state = 39},
  [2260] = {.lex_state = 39},
  [2261] = {.lex_state = 39},
  [2262] = {.lex_state = 39},
  [2263] = {.lex_state = 39},
  [2264] = {.lex_state = 39},
  [2265] = {.lex_state = 39},
  [2266] = {.lex_state = 39},
  [2267] = {.lex_state = 39},
  [2268] = {.lex_state = 39},
  [2269] = {.lex_state = 39},
  [2270] = {.lex_state = 39},
  [2271] = {.lex_state = 39},
  [2272] = {.lex_state = 39},
  [2273] = {.lex_state = 39},
  [2274] = {.lex_state = 39},
  [2275] = {.lex_state = 39},
  [2276] = {.lex_state = 39},
  [2277] = {.lex_state = 39},
  [2278] = {.lex_state = 39},
  [2279] = {.lex_state = 39},
  [2280] = {.lex_state = 39},
  [2281] = {.lex_state = 39},
  [2282] = {.lex_state = 39},
  [2283] = {.lex_state = 39},
  [2284] = {.lex_state = 39},
  [2285] = {.lex_state = 39},
  [2286] = {.lex_state = 39},
  [2287] = {.lex_state = 39},
  [2288] = {.lex_state = 39},
  [2289] = {.lex_state = 39},
  [2290] = {.lex_state = 39},
  [2291] = {.lex_state = 39},
  [2292] = {.lex_state = 39},
  [2293] = {.lex_state = 39},
  [2294] = {.lex_state = 39},
  [2295] = {.lex_state = 39},
  [2296] = {.lex_state = 39},
  [2297] = {.lex_state = 39},
  [2298] = {.lex_state = 39},
  [2299] = {.lex_state = 39},
  [2300] = {.lex_state = 39},
  [2301] = {.lex_state = 39},
  [2302] = {.lex_state = 39},
  [2303] = {.lex_state = 39},
  [2304] = {.lex_state = 39},
  [2305] = {.lex_state = 39},
  [2306] = {.lex_state = 39},
  [2307] = {.lex_state = 39},
  [2308] = {.lex_state = 39},
  [2309] = {.lex_state = 39},
  [2310] = {.lex_state = 39},
  [2311] = {.lex_state = 39},
  [2312] = {.lex_state = 39},
  [2313] = {.lex_state = 39},
  [2314] = {.lex_state = 39},
  [2315] = {.lex_state = 39},
  [2316] = {.lex_state = 39},
  [2317] = {.lex_state = 39},
  [2318] = {.lex_state = 4},
  [2319] = {.lex_state = 39},
  [2320] = {.lex_state = 39},
  [2321] = {.lex_state = 39},
  [2322] = {.lex_state = 39},
  [2323] = {.lex_state = 39},
  [2324] = {.lex_state = 39},
  [2325] = {.lex_state = 39},
  [2326] = {.lex_state = 39},
  [2327] = {.lex_state = 39},
  [2328] = {.lex_state = 39},
  [2329] = {.lex_state = 39},
  [2330] = {.lex_state = 39},
  [2331] = {.lex_state = 39},
  [2332] = {.lex_state = 39},
  [2333] = {.lex_state = 39},
  [2334] = {.lex_state = 39},
  [2335] = {.lex_state = 39},
  [2336] = {.lex_state = 39},
  [2337] = {.lex_state = 39},
  [2338] = {.lex_state = 39},
  [2339] = {.lex_state = 39},
  [2340] = {.lex_state = 39},
  [2341] = {.lex_state = 39},
  [2342] = {.lex_state = 39},
  [2343] = {.lex_state = 39},
  [2344] = {.lex_state = 39},
  [2345] = {.lex_state = 39},
  [2346] = {.lex_state = 39},
  [2347] = {.lex_state = 39},
  [2348] = {.lex_state = 39},
  [2349] = {.lex_state = 39},
  [2350] = {.lex_state = 39},
  [2351] = {.lex_state = 39},
  [2352] = {.lex_state = 39},
  [2353] = {.lex_state = 39},
  [2354] = {.lex_state = 39},
  [2355] = {.lex_state = 39},
  [2356] = {.lex_state = 39},
  [2357] = {.lex_state = 39},
  [2358] = {.lex_state = 39},
  [2359] = {.lex_state = 39},
  [2360] = {.lex_state = 39},
  [2361] = {.lex_state = 39},
  [2362] = {.lex_state = 39},
  [2363] = {.lex_state = 39},
  [2364] = {.lex_state = 39},
  [2365] = {.lex_state = 39},
  [2366] = {.lex_state = 39},
  [2367] = {.lex_state = 39},
  [2368] = {.lex_state = 39},
  [2369] = {.lex_state = 39},
  [2370] = {.lex_state = 39},
  [2371] = {.lex_state = 39},
  [2372] = {.lex_state = 39},
  [2373] = {.lex_state = 39},
  [2374] = {.lex_state = 39},
  [2375] = {.lex_state = 39},
  [2376] = {.lex_state = 39},
  [2377] = {.lex_state = 39},
  [2378] = {.lex_state = 39},
  [2379] = {.lex_state = 39},
  [2380] = {.lex_state = 39},
  [2381] = {.lex_state = 39},
  [2382] = {.lex_state = 39},
  [2383] = {.lex_state = 39},
  [2384] = {.lex_state = 39},
  [2385] = {.lex_state = 39},
  [2386] = {.lex_state = 39},
  [2387] = {.lex_state = 39},
  [2388] = {.lex_state = 39},
  [2389] = {.lex_state = 39},
  [2390] = {.lex_state = 39},
  [2391] = {.lex_state = 39},
  [2392] = {.lex_state = 39},
  [2393] = {.lex_state = 39},
  [2394] = {.lex_state = 39},
  [2395] = {.lex_state = 39},
  [2396] = {.lex_state = 39},
  [2397] = {.lex_state = 39},
  [2398] = {.lex_state = 39},
  [2399] = {.lex_state = 39},
  [2400] = {.lex_state = 39},
  [2401] = {.lex_state = 39},
  [2402] = {.lex_state = 39},
  [2403] = {.lex_state = 39},
  [2404] = {.lex_state = 39},
  [2405] = {.lex_state = 39},
  [2406] = {.lex_state = 39},
  [2407] = {.lex_state = 39},
  [2408] = {.lex_state = 39},
  [2409] = {.lex_state = 39},
  [2410] = {.lex_state = 39},
  [2411] = {.lex_state = 39},
  [2412] = {.lex_state = 39},
  [2413] = {.lex_state = 39},
  [2414] = {.lex_state = 39},
  [2415] = {.lex_state = 39},
  [2416] = {.lex_state = 39},
  [2417] = {.lex_state = 39},
  [2418] = {.lex_state = 39},
  [2419] = {.lex_state = 39},
  [2420] = {.lex_state = 39},
  [2421] = {.lex_state = 39},
  [2422] = {.lex_state = 39},
  [2423] = {.lex_state = 39},
  [2424] = {.lex_state = 39},
  [2425] = {.lex_state = 39},
  [2426] = {.lex_state = 39},
  [2427] = {.lex_state = 39},
  [2428] = {.lex_state = 39},
  [2429] = {.lex_state = 39},
  [2430] = {.lex_state = 39},
  [2431] = {.lex_state = 39},
  [2432] = {.lex_state = 39},
  [2433] = {.lex_state = 39},
  [2434] = {.lex_state = 39},
  [2435] = {.lex_state = 39},
  [2436] = {.lex_state = 4},
  [2437] = {.lex_state = 39},
  [2438] = {.lex_state = 39},
  [2439] = {.lex_state = 39},
  [2440] = {.lex_state = 39},
  [2441] = {.lex_state = 39},
  [2442] = {.lex_state = 39},
  [2443] = {.lex_state = 39},
  [2444] = {.lex_state = 39},
  [2445] = {.lex_state = 39},
  [2446] = {.lex_state = 39},
  [2447] = {.lex_state = 39},
  [2448] = {.lex_state = 39},
  [2449] = {.lex_state = 39},
  [2450] = {.lex_state = 39},
  [2451] = {.lex_state = 39},
  [2452] = {.lex_state = 39},
  [2453] = {.lex_state = 39},
  [2454] = {.lex_state = 39},
  [2455] = {.lex_state = 39},
  [2456] = {.lex_state = 39},
  [2457] = {.lex_state = 39},
  [2458] = {.lex_state = 39},
  [2459] = {.lex_state = 39},
  [2460] = {.lex_state = 39},
  [2461] = {.lex_state = 39},
  [2462] = {.lex_state = 39},
  [2463] = {.lex_state = 39},
  [2464] = {.lex_state = 39},
  [2465] = {.lex_state = 39},
  [2466] = {.lex_state = 39},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_asmBody_token1] = ACTIONS(1),
    [aux_sym_asmBody_token2] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_type_token1] = ACTIONS(1),
    [aux_sym_type_token2] = ACTIONS(1),
    [aux_sym_type_token3] = ACTIONS(1),
    [aux_sym__literalString_token1] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_kProgram] = ACTIONS(1),
    [sym_kLibrary] = ACTIONS(1),
    [sym_kUnit] = ACTIONS(1),
    [sym_kUses] = ACTIONS(1),
    [sym_kInterface] = ACTIONS(1),
    [sym_kImplementation] = ACTIONS(1),
    [sym_kInitialization] = ACTIONS(1),
    [sym_kFinalization] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_kBegin] = ACTIONS(1),
    [sym_kEnd] = ACTIONS(1),
    [sym_kAsm] = ACTIONS(1),
    [sym_kVar] = ACTIONS(1),
    [sym_kThreadvar] = ACTIONS(1),
    [sym_kConst] = ACTIONS(1),
    [sym_kConstref] = ACTIONS(1),
    [sym_kResourcestring] = ACTIONS(1),
    [sym_kOut] = ACTIONS(1),
    [sym_kType] = ACTIONS(1),
    [sym_kLabel] = ACTIONS(1),
    [sym_kExports] = ACTIONS(1),
    [sym_kAbsolute] = ACTIONS(1),
    [sym_kProperty] = ACTIONS(1),
    [sym_kRead] = ACTIONS(1),
    [sym_kWrite] = ACTIONS(1),
    [sym_kImplements] = ACTIONS(1),
    [sym_kDefault] = ACTIONS(1),
    [sym_kNodefault] = ACTIONS(1),
    [sym_kStored] = ACTIONS(1),
    [sym_kIndex] = ACTIONS(1),
    [sym_kClass] = ACTIONS(1),
    [sym_kObject] = ACTIONS(1),
    [sym_kRecord] = ACTIONS(1),
    [sym_kObjcclass] = ACTIONS(1),
    [sym_kObjccategory] = ACTIONS(1),
    [sym_kObjcprotocol] = ACTIONS(1),
    [sym_kArray] = ACTIONS(1),
    [sym_kFile] = ACTIONS(1),
    [sym_kString] = ACTIONS(1),
    [sym_kSet] = ACTIONS(1),
    [sym_kOf] = ACTIONS(1),
    [sym_kHelper] = ACTIONS(1),
    [sym_kPacked] = ACTIONS(1),
    [sym_kGeneric] = ACTIONS(1),
    [sym_kSpecialize] = ACTIONS(1),
    [sym_kLt] = ACTIONS(1),
    [sym_kEq] = ACTIONS(1),
    [sym_kGt] = ACTIONS(1),
    [sym_kLte] = ACTIONS(1),
    [sym_kGte] = ACTIONS(1),
    [sym_kAdd] = ACTIONS(1),
    [sym_kSub] = ACTIONS(1),
    [sym_kMul] = ACTIONS(1),
    [sym_kFdiv] = ACTIONS(1),
    [sym_kAt] = ACTIONS(1),
    [sym_kHat] = ACTIONS(1),
    [sym_kAssign] = ACTIONS(1),
    [sym_kAssignAdd] = ACTIONS(1),
    [sym_kAssignSub] = ACTIONS(1),
    [sym_kAssignMul] = ACTIONS(1),
    [sym_kAssignDiv] = ACTIONS(1),
    [sym_kOr] = ACTIONS(1),
    [sym_kXor] = ACTIONS(1),
    [sym_kDiv] = ACTIONS(1),
    [sym_kMod] = ACTIONS(1),
    [sym_kAnd] = ACTIONS(1),
    [sym_kShl] = ACTIONS(1),
    [sym_kShr] = ACTIONS(1),
    [sym_kNot] = ACTIONS(1),
    [sym_kIs] = ACTIONS(1),
    [sym_kAs] = ACTIONS(1),
    [sym_kIn] = ACTIONS(1),
    [sym_kFor] = ACTIONS(1),
    [sym_kTo] = ACTIONS(1),
    [sym_kDownto] = ACTIONS(1),
    [sym_kIf] = ACTIONS(1),
    [sym_kThen] = ACTIONS(1),
    [sym_kElse] = ACTIONS(1),
    [sym_kDo] = ACTIONS(1),
    [sym_kWhile] = ACTIONS(1),
    [sym_kRepeat] = ACTIONS(1),
    [sym_kUntil] = ACTIONS(1),
    [sym_kTry] = ACTIONS(1),
    [sym_kExcept] = ACTIONS(1),
    [sym_kFinally] = ACTIONS(1),
    [sym_kRaise] = ACTIONS(1),
    [sym_kOn] = ACTIONS(1),
    [sym_kCase] = ACTIONS(1),
    [sym_kWith] = ACTIONS(1),
    [sym_kGoto] = ACTIONS(1),
    [sym_kFunction] = ACTIONS(1),
    [sym_kProcedure] = ACTIONS(1),
    [sym_kConstructor] = ACTIONS(1),
    [sym_kDestructor] = ACTIONS(1),
    [sym_kOperator] = ACTIONS(1),
    [sym_kReference] = ACTIONS(1),
    [sym_kPublished] = ACTIONS(1),
    [sym_kPublic] = ACTIONS(1),
    [sym_kProtected] = ACTIONS(1),
    [sym_kPrivate] = ACTIONS(1),
    [sym_kStrict] = ACTIONS(1),
    [sym_kRequired] = ACTIONS(1),
    [sym_kOptional] = ACTIONS(1),
    [sym_kForward] = ACTIONS(1),
    [sym_kStatic] = ACTIONS(1),
    [sym_kVirtual] = ACTIONS(1),
    [sym_kAbstract] = ACTIONS(1),
    [sym_kSealed] = ACTIONS(1),
    [sym_kDynamic] = ACTIONS(1),
    [sym_kOverride] = ACTIONS(1),
    [sym_kOverload] = ACTIONS(1),
    [sym_kReintroduce] = ACTIONS(1),
    [sym_kInherited] = ACTIONS(1),
    [sym_kInline] = ACTIONS(1),
    [sym_kStdcall] = ACTIONS(1),
    [sym_kCdecl] = ACTIONS(1),
    [sym_kCppdecl] = ACTIONS(1),
    [sym_kPascal] = ACTIONS(1),
    [sym_kRegister] = ACTIONS(1),
    [sym_kMwpascal] = ACTIONS(1),
    [sym_kExternal] = ACTIONS(1),
    [sym_kName] = ACTIONS(1),
    [sym_kMessage] = ACTIONS(1),
    [sym_kDeprecated] = ACTIONS(1),
    [sym_kExperimental] = ACTIONS(1),
    [sym_kPlatform] = ACTIONS(1),
    [sym_kUnimplemented] = ACTIONS(1),
    [sym_kCvar] = ACTIONS(1),
    [sym_kExport] = ACTIONS(1),
    [sym_kFar] = ACTIONS(1),
    [sym_kNear] = ACTIONS(1),
    [sym_kSafecall] = ACTIONS(1),
    [sym_kAssembler] = ACTIONS(1),
    [sym_kNostackframe] = ACTIONS(1),
    [sym_kInterrupt] = ACTIONS(1),
    [sym_kNoreturn] = ACTIONS(1),
    [sym_kIocheck] = ACTIONS(1),
    [sym_kLocal] = ACTIONS(1),
    [sym_kHardfloat] = ACTIONS(1),
    [sym_kSoftfloat] = ACTIONS(1),
    [sym_kMs_abi_default] = ACTIONS(1),
    [sym_kMs_abi_cdecl] = ACTIONS(1),
    [sym_kSaveregisters] = ACTIONS(1),
    [sym_kSysv_abi_default] = ACTIONS(1),
    [sym_kSysv_abi_cdecl] = ACTIONS(1),
    [sym_kVectorcall] = ACTIONS(1),
    [sym_kVarargs] = ACTIONS(1),
    [sym_kWinapi] = ACTIONS(1),
    [sym_kAlias] = ACTIONS(1),
    [sym_kDelayed] = ACTIONS(1),
    [sym_kNil] = ACTIONS(1),
    [sym_kTrue] = ACTIONS(1),
    [sym_kFalse] = ACTIONS(1),
    [sym_kIfdef] = ACTIONS(1),
    [sym_kIfndef] = ACTIONS(1),
    [sym_kEndif] = ACTIONS(1),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_root] = STATE(2361),
    [sym_program] = STATE(2209),
    [sym_library] = STATE(2209),
    [sym_unit] = STATE(2209),
    [sym_blockTr] = STATE(1060),
    [aux_sym__definitions] = STATE(1060),
    [sym__definition] = STATE(1060),
    [sym_defProc] = STATE(1060),
    [sym_declProcFwd] = STATE(1060),
    [sym_declUses] = STATE(1060),
    [sym_declExports] = STATE(1060),
    [sym_declTypes] = STATE(1060),
    [sym_declVars] = STATE(1060),
    [sym_declConsts] = STATE(1060),
    [sym_declProc] = STATE(976),
    [sym_declLabels] = STATE(1060),
    [sym__declProc] = STATE(1408),
    [sym__declOperator] = STATE(1443),
    [sym_rttiAttributes] = STATE(1565),
    [aux_sym_rttiAttributes_repeat2] = STATE(1485),
    [ts_builtin_sym_end] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [sym_kProgram] = ACTIONS(11),
    [sym_kLibrary] = ACTIONS(13),
    [sym_kUnit] = ACTIONS(15),
    [sym_kUses] = ACTIONS(17),
    [sym_kBegin] = ACTIONS(19),
    [sym_kVar] = ACTIONS(21),
    [sym_kThreadvar] = ACTIONS(21),
    [sym_kConst] = ACTIONS(23),
    [sym_kResourcestring] = ACTIONS(25),
    [sym_kType] = ACTIONS(27),
    [sym_kLabel] = ACTIONS(29),
    [sym_kExports] = ACTIONS(31),
    [sym_kClass] = ACTIONS(33),
    [sym_kGeneric] = ACTIONS(35),
    [sym_kFunction] = ACTIONS(37),
    [sym_kProcedure] = ACTIONS(37),
    [sym_kConstructor] = ACTIONS(37),
    [sym_kDestructor] = ACTIONS(37),
    [sym_kOperator] = ACTIONS(39),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_exceptionHandler] = STATE(1769),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_exceptionHandlerTr] = STATE(1858),
    [sym__exceptionHandlersTr] = STATE(2307),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2307),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__exceptionHandlers_repeat1] = STATE(1762),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(59),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kOn] = ACTIONS(83),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_exceptionHandler] = STATE(1769),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_exceptionHandlerTr] = STATE(1858),
    [sym__exceptionHandlersTr] = STATE(2342),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2342),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__exceptionHandlers_repeat1] = STATE(1762),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(97),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kOn] = ACTIONS(83),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_exceptionHandler] = STATE(1769),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_exceptionHandlerTr] = STATE(1858),
    [sym__exceptionHandlersTr] = STATE(2348),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2348),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__exceptionHandlers_repeat1] = STATE(1762),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(99),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kOn] = ACTIONS(83),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_exceptionHandler] = STATE(1769),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_exceptionHandlerTr] = STATE(1858),
    [sym__exceptionHandlersTr] = STATE(2360),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2360),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__exceptionHandlers_repeat1] = STATE(1762),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(101),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kOn] = ACTIONS(83),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1689),
    [sym_ifElseTr] = STATE(1689),
    [sym_whileTr] = STATE(1689),
    [sym_repeatTr] = STATE(1689),
    [sym_forTr] = STATE(1689),
    [sym_foreachTr] = STATE(1689),
    [sym_tryTr] = STATE(1689),
    [sym_caseTr] = STATE(1689),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1689),
    [sym_withTr] = STATE(1689),
    [sym_raiseTr] = STATE(1689),
    [sym_statementTr] = STATE(1689),
    [sym_gotoTr] = STATE(1689),
    [sym__statementTr] = STATE(1689),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(56),
    [sym__statementsTr] = STATE(1689),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym__statementsTr_repeat1] = STATE(56),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(117),
    [sym_kImplementation] = ACTIONS(117),
    [sym_kInitialization] = ACTIONS(117),
    [sym_kFinalization] = ACTIONS(117),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(117),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1690),
    [sym_ifElseTr] = STATE(1690),
    [sym_whileTr] = STATE(1690),
    [sym_repeatTr] = STATE(1690),
    [sym_forTr] = STATE(1690),
    [sym_foreachTr] = STATE(1690),
    [sym_tryTr] = STATE(1690),
    [sym_caseTr] = STATE(1690),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1690),
    [sym_withTr] = STATE(1690),
    [sym_raiseTr] = STATE(1690),
    [sym_statementTr] = STATE(1690),
    [sym_gotoTr] = STATE(1690),
    [sym__statementTr] = STATE(1690),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(56),
    [sym__statementsTr] = STATE(1690),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym__statementsTr_repeat1] = STATE(56),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(143),
    [sym_kImplementation] = ACTIONS(143),
    [sym_kInitialization] = ACTIONS(143),
    [sym_kFinalization] = ACTIONS(143),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(143),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2021),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(145),
    [sym_kFinally] = ACTIONS(147),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(753),
    [sym_while] = STATE(753),
    [sym_repeat] = STATE(753),
    [sym_for] = STATE(753),
    [sym_foreach] = STATE(753),
    [sym_try] = STATE(753),
    [sym_case] = STATE(753),
    [sym_block] = STATE(753),
    [sym_asm] = STATE(753),
    [sym_with] = STATE(753),
    [sym_raise] = STATE(753),
    [sym_statement] = STATE(753),
    [sym_goto] = STATE(753),
    [sym__statement] = STATE(753),
    [sym_ifTr] = STATE(1535),
    [sym_ifElseTr] = STATE(1535),
    [sym_whileTr] = STATE(1535),
    [sym_repeatTr] = STATE(1535),
    [sym_forTr] = STATE(1535),
    [sym_foreachTr] = STATE(1535),
    [sym_tryTr] = STATE(1535),
    [sym_caseTr] = STATE(1535),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1535),
    [sym_withTr] = STATE(1535),
    [sym_raiseTr] = STATE(1535),
    [sym_statementTr] = STATE(1535),
    [sym_gotoTr] = STATE(1535),
    [sym__statementTr] = STATE(1535),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(151),
    [sym_kImplementation] = ACTIONS(151),
    [sym_kInitialization] = ACTIONS(151),
    [sym_kFinalization] = ACTIONS(151),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(151),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(151),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(744),
    [sym_while] = STATE(744),
    [sym_repeat] = STATE(744),
    [sym_for] = STATE(744),
    [sym_foreach] = STATE(744),
    [sym_try] = STATE(744),
    [sym_case] = STATE(744),
    [sym_block] = STATE(744),
    [sym_asm] = STATE(744),
    [sym_with] = STATE(744),
    [sym_raise] = STATE(744),
    [sym_statement] = STATE(744),
    [sym_goto] = STATE(744),
    [sym__statement] = STATE(744),
    [sym_ifTr] = STATE(1529),
    [sym_ifElseTr] = STATE(1529),
    [sym_whileTr] = STATE(1529),
    [sym_repeatTr] = STATE(1529),
    [sym_forTr] = STATE(1529),
    [sym_foreachTr] = STATE(1529),
    [sym_tryTr] = STATE(1529),
    [sym_caseTr] = STATE(1529),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1529),
    [sym_withTr] = STATE(1529),
    [sym_raiseTr] = STATE(1529),
    [sym_statementTr] = STATE(1529),
    [sym_gotoTr] = STATE(1529),
    [sym__statementTr] = STATE(1529),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(153),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(155),
    [sym_kImplementation] = ACTIONS(155),
    [sym_kInitialization] = ACTIONS(155),
    [sym_kFinalization] = ACTIONS(155),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(155),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(155),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2061),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(157),
    [sym_kFinally] = ACTIONS(159),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(795),
    [sym_while] = STATE(795),
    [sym_repeat] = STATE(795),
    [sym_for] = STATE(795),
    [sym_foreach] = STATE(795),
    [sym_try] = STATE(795),
    [sym_case] = STATE(795),
    [sym_block] = STATE(795),
    [sym_asm] = STATE(795),
    [sym_with] = STATE(795),
    [sym_raise] = STATE(795),
    [sym_statement] = STATE(795),
    [sym_goto] = STATE(795),
    [sym__statement] = STATE(795),
    [sym_ifTr] = STATE(1540),
    [sym_ifElseTr] = STATE(1540),
    [sym_whileTr] = STATE(1540),
    [sym_repeatTr] = STATE(1540),
    [sym_forTr] = STATE(1540),
    [sym_foreachTr] = STATE(1540),
    [sym_tryTr] = STATE(1540),
    [sym_caseTr] = STATE(1540),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1540),
    [sym_withTr] = STATE(1540),
    [sym_raiseTr] = STATE(1540),
    [sym_statementTr] = STATE(1540),
    [sym_gotoTr] = STATE(1540),
    [sym__statementTr] = STATE(1540),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(163),
    [sym_kImplementation] = ACTIONS(163),
    [sym_kInitialization] = ACTIONS(163),
    [sym_kFinalization] = ACTIONS(163),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(163),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(163),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(808),
    [sym_while] = STATE(808),
    [sym_repeat] = STATE(808),
    [sym_for] = STATE(808),
    [sym_foreach] = STATE(808),
    [sym_try] = STATE(808),
    [sym_case] = STATE(808),
    [sym_block] = STATE(808),
    [sym_asm] = STATE(808),
    [sym_with] = STATE(808),
    [sym_raise] = STATE(808),
    [sym_statement] = STATE(808),
    [sym_goto] = STATE(808),
    [sym__statement] = STATE(808),
    [sym_ifTr] = STATE(1552),
    [sym_ifElseTr] = STATE(1552),
    [sym_whileTr] = STATE(1552),
    [sym_repeatTr] = STATE(1552),
    [sym_forTr] = STATE(1552),
    [sym_foreachTr] = STATE(1552),
    [sym_tryTr] = STATE(1552),
    [sym_caseTr] = STATE(1552),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1552),
    [sym_withTr] = STATE(1552),
    [sym_raiseTr] = STATE(1552),
    [sym_statementTr] = STATE(1552),
    [sym_gotoTr] = STATE(1552),
    [sym__statementTr] = STATE(1552),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(167),
    [sym_kImplementation] = ACTIONS(167),
    [sym_kInitialization] = ACTIONS(167),
    [sym_kFinalization] = ACTIONS(167),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(167),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(167),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(793),
    [sym_while] = STATE(793),
    [sym_repeat] = STATE(793),
    [sym_for] = STATE(793),
    [sym_foreach] = STATE(793),
    [sym_try] = STATE(793),
    [sym_case] = STATE(793),
    [sym_block] = STATE(793),
    [sym_asm] = STATE(793),
    [sym_with] = STATE(793),
    [sym_raise] = STATE(793),
    [sym_statement] = STATE(793),
    [sym_goto] = STATE(793),
    [sym__statement] = STATE(793),
    [sym_ifTr] = STATE(1546),
    [sym_ifElseTr] = STATE(1546),
    [sym_whileTr] = STATE(1546),
    [sym_repeatTr] = STATE(1546),
    [sym_forTr] = STATE(1546),
    [sym_foreachTr] = STATE(1546),
    [sym_tryTr] = STATE(1546),
    [sym_caseTr] = STATE(1546),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1546),
    [sym_withTr] = STATE(1546),
    [sym_raiseTr] = STATE(1546),
    [sym_statementTr] = STATE(1546),
    [sym_gotoTr] = STATE(1546),
    [sym__statementTr] = STATE(1546),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(171),
    [sym_kImplementation] = ACTIONS(171),
    [sym_kInitialization] = ACTIONS(171),
    [sym_kFinalization] = ACTIONS(171),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(171),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(171),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(794),
    [sym_while] = STATE(794),
    [sym_repeat] = STATE(794),
    [sym_for] = STATE(794),
    [sym_foreach] = STATE(794),
    [sym_try] = STATE(794),
    [sym_case] = STATE(794),
    [sym_block] = STATE(794),
    [sym_asm] = STATE(794),
    [sym_with] = STATE(794),
    [sym_raise] = STATE(794),
    [sym_statement] = STATE(794),
    [sym_goto] = STATE(794),
    [sym__statement] = STATE(794),
    [sym_ifTr] = STATE(1545),
    [sym_ifElseTr] = STATE(1545),
    [sym_whileTr] = STATE(1545),
    [sym_repeatTr] = STATE(1545),
    [sym_forTr] = STATE(1545),
    [sym_foreachTr] = STATE(1545),
    [sym_tryTr] = STATE(1545),
    [sym_caseTr] = STATE(1545),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1545),
    [sym_withTr] = STATE(1545),
    [sym_raiseTr] = STATE(1545),
    [sym_statementTr] = STATE(1545),
    [sym_gotoTr] = STATE(1545),
    [sym__statementTr] = STATE(1545),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(175),
    [sym_kImplementation] = ACTIONS(175),
    [sym_kInitialization] = ACTIONS(175),
    [sym_kFinalization] = ACTIONS(175),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(175),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(175),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(791),
    [sym_while] = STATE(791),
    [sym_repeat] = STATE(791),
    [sym_for] = STATE(791),
    [sym_foreach] = STATE(791),
    [sym_try] = STATE(791),
    [sym_case] = STATE(791),
    [sym_block] = STATE(791),
    [sym_asm] = STATE(791),
    [sym_with] = STATE(791),
    [sym_raise] = STATE(791),
    [sym_statement] = STATE(791),
    [sym_goto] = STATE(791),
    [sym__statement] = STATE(791),
    [sym_ifTr] = STATE(1564),
    [sym_ifElseTr] = STATE(1564),
    [sym_whileTr] = STATE(1564),
    [sym_repeatTr] = STATE(1564),
    [sym_forTr] = STATE(1564),
    [sym_foreachTr] = STATE(1564),
    [sym_tryTr] = STATE(1564),
    [sym_caseTr] = STATE(1564),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1564),
    [sym_withTr] = STATE(1564),
    [sym_raiseTr] = STATE(1564),
    [sym_statementTr] = STATE(1564),
    [sym_gotoTr] = STATE(1564),
    [sym__statementTr] = STATE(1564),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(179),
    [sym_kImplementation] = ACTIONS(179),
    [sym_kInitialization] = ACTIONS(179),
    [sym_kFinalization] = ACTIONS(179),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(179),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(179),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_if] = STATE(918),
    [sym_ifElse] = STATE(756),
    [sym_while] = STATE(756),
    [sym_repeat] = STATE(756),
    [sym_for] = STATE(756),
    [sym_foreach] = STATE(756),
    [sym_try] = STATE(756),
    [sym_case] = STATE(756),
    [sym_block] = STATE(756),
    [sym_asm] = STATE(756),
    [sym_with] = STATE(756),
    [sym_raise] = STATE(756),
    [sym_statement] = STATE(756),
    [sym_goto] = STATE(756),
    [sym__statement] = STATE(756),
    [sym_ifTr] = STATE(1677),
    [sym_ifElseTr] = STATE(1677),
    [sym_whileTr] = STATE(1677),
    [sym_repeatTr] = STATE(1677),
    [sym_forTr] = STATE(1677),
    [sym_foreachTr] = STATE(1677),
    [sym_tryTr] = STATE(1677),
    [sym_caseTr] = STATE(1677),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1677),
    [sym_withTr] = STATE(1677),
    [sym_raiseTr] = STATE(1677),
    [sym_statementTr] = STATE(1677),
    [sym_gotoTr] = STATE(1677),
    [sym__statementTr] = STATE(1677),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(183),
    [sym_kImplementation] = ACTIONS(183),
    [sym_kInitialization] = ACTIONS(183),
    [sym_kFinalization] = ACTIONS(183),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(183),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kElse] = ACTIONS(185),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(795),
    [sym_while] = STATE(795),
    [sym_repeat] = STATE(795),
    [sym_for] = STATE(795),
    [sym_foreach] = STATE(795),
    [sym_try] = STATE(795),
    [sym_case] = STATE(795),
    [sym_block] = STATE(795),
    [sym_asm] = STATE(795),
    [sym_with] = STATE(795),
    [sym_raise] = STATE(795),
    [sym_statement] = STATE(795),
    [sym_goto] = STATE(795),
    [sym__statement] = STATE(795),
    [sym_ifTr] = STATE(1540),
    [sym_ifElseTr] = STATE(1540),
    [sym_whileTr] = STATE(1540),
    [sym_repeatTr] = STATE(1540),
    [sym_forTr] = STATE(1540),
    [sym_foreachTr] = STATE(1540),
    [sym_tryTr] = STATE(1540),
    [sym_caseTr] = STATE(1540),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1540),
    [sym_withTr] = STATE(1540),
    [sym_raiseTr] = STATE(1540),
    [sym_statementTr] = STATE(1540),
    [sym_gotoTr] = STATE(1540),
    [sym__statementTr] = STATE(1540),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(163),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(163),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(163),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(163),
    [sym_kFinally] = ACTIONS(163),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2402),
    [sym_ifElseTr] = STATE(2402),
    [sym_whileTr] = STATE(2402),
    [sym_repeatTr] = STATE(2402),
    [sym_forTr] = STATE(2402),
    [sym_foreachTr] = STATE(2402),
    [sym_tryTr] = STATE(2402),
    [sym_caseTr] = STATE(2402),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2402),
    [sym_withTr] = STATE(2402),
    [sym_raiseTr] = STATE(2402),
    [sym_statementTr] = STATE(2402),
    [sym_gotoTr] = STATE(2402),
    [sym__statementTr] = STATE(2402),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2402),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(187),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(189),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2266),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(191),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(744),
    [sym_while] = STATE(744),
    [sym_repeat] = STATE(744),
    [sym_for] = STATE(744),
    [sym_foreach] = STATE(744),
    [sym_try] = STATE(744),
    [sym_case] = STATE(744),
    [sym_block] = STATE(744),
    [sym_asm] = STATE(744),
    [sym_with] = STATE(744),
    [sym_raise] = STATE(744),
    [sym_statement] = STATE(744),
    [sym_goto] = STATE(744),
    [sym__statement] = STATE(744),
    [sym_ifTr] = STATE(1529),
    [sym_ifElseTr] = STATE(1529),
    [sym_whileTr] = STATE(1529),
    [sym_repeatTr] = STATE(1529),
    [sym_forTr] = STATE(1529),
    [sym_foreachTr] = STATE(1529),
    [sym_tryTr] = STATE(1529),
    [sym_caseTr] = STATE(1529),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1529),
    [sym_withTr] = STATE(1529),
    [sym_raiseTr] = STATE(1529),
    [sym_statementTr] = STATE(1529),
    [sym_gotoTr] = STATE(1529),
    [sym__statementTr] = STATE(1529),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(153),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(155),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(155),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(155),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(155),
    [sym_kFinally] = ACTIONS(155),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(808),
    [sym_while] = STATE(808),
    [sym_repeat] = STATE(808),
    [sym_for] = STATE(808),
    [sym_foreach] = STATE(808),
    [sym_try] = STATE(808),
    [sym_case] = STATE(808),
    [sym_block] = STATE(808),
    [sym_asm] = STATE(808),
    [sym_with] = STATE(808),
    [sym_raise] = STATE(808),
    [sym_statement] = STATE(808),
    [sym_goto] = STATE(808),
    [sym__statement] = STATE(808),
    [sym_ifTr] = STATE(1552),
    [sym_ifElseTr] = STATE(1552),
    [sym_whileTr] = STATE(1552),
    [sym_repeatTr] = STATE(1552),
    [sym_forTr] = STATE(1552),
    [sym_foreachTr] = STATE(1552),
    [sym_tryTr] = STATE(1552),
    [sym_caseTr] = STATE(1552),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1552),
    [sym_withTr] = STATE(1552),
    [sym_raiseTr] = STATE(1552),
    [sym_statementTr] = STATE(1552),
    [sym_gotoTr] = STATE(1552),
    [sym__statementTr] = STATE(1552),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(167),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(167),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(167),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(167),
    [sym_kFinally] = ACTIONS(167),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(791),
    [sym_while] = STATE(791),
    [sym_repeat] = STATE(791),
    [sym_for] = STATE(791),
    [sym_foreach] = STATE(791),
    [sym_try] = STATE(791),
    [sym_case] = STATE(791),
    [sym_block] = STATE(791),
    [sym_asm] = STATE(791),
    [sym_with] = STATE(791),
    [sym_raise] = STATE(791),
    [sym_statement] = STATE(791),
    [sym_goto] = STATE(791),
    [sym__statement] = STATE(791),
    [sym_ifTr] = STATE(1564),
    [sym_ifElseTr] = STATE(1564),
    [sym_whileTr] = STATE(1564),
    [sym_repeatTr] = STATE(1564),
    [sym_forTr] = STATE(1564),
    [sym_foreachTr] = STATE(1564),
    [sym_tryTr] = STATE(1564),
    [sym_caseTr] = STATE(1564),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1564),
    [sym_withTr] = STATE(1564),
    [sym_raiseTr] = STATE(1564),
    [sym_statementTr] = STATE(1564),
    [sym_gotoTr] = STATE(1564),
    [sym__statementTr] = STATE(1564),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(179),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(179),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(179),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(179),
    [sym_kFinally] = ACTIONS(179),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(793),
    [sym_while] = STATE(793),
    [sym_repeat] = STATE(793),
    [sym_for] = STATE(793),
    [sym_foreach] = STATE(793),
    [sym_try] = STATE(793),
    [sym_case] = STATE(793),
    [sym_block] = STATE(793),
    [sym_asm] = STATE(793),
    [sym_with] = STATE(793),
    [sym_raise] = STATE(793),
    [sym_statement] = STATE(793),
    [sym_goto] = STATE(793),
    [sym__statement] = STATE(793),
    [sym_ifTr] = STATE(1546),
    [sym_ifElseTr] = STATE(1546),
    [sym_whileTr] = STATE(1546),
    [sym_repeatTr] = STATE(1546),
    [sym_forTr] = STATE(1546),
    [sym_foreachTr] = STATE(1546),
    [sym_tryTr] = STATE(1546),
    [sym_caseTr] = STATE(1546),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1546),
    [sym_withTr] = STATE(1546),
    [sym_raiseTr] = STATE(1546),
    [sym_statementTr] = STATE(1546),
    [sym_gotoTr] = STATE(1546),
    [sym__statementTr] = STATE(1546),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(171),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(171),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(171),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(171),
    [sym_kFinally] = ACTIONS(171),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(794),
    [sym_while] = STATE(794),
    [sym_repeat] = STATE(794),
    [sym_for] = STATE(794),
    [sym_foreach] = STATE(794),
    [sym_try] = STATE(794),
    [sym_case] = STATE(794),
    [sym_block] = STATE(794),
    [sym_asm] = STATE(794),
    [sym_with] = STATE(794),
    [sym_raise] = STATE(794),
    [sym_statement] = STATE(794),
    [sym_goto] = STATE(794),
    [sym__statement] = STATE(794),
    [sym_ifTr] = STATE(1545),
    [sym_ifElseTr] = STATE(1545),
    [sym_whileTr] = STATE(1545),
    [sym_repeatTr] = STATE(1545),
    [sym_forTr] = STATE(1545),
    [sym_foreachTr] = STATE(1545),
    [sym_tryTr] = STATE(1545),
    [sym_caseTr] = STATE(1545),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1545),
    [sym_withTr] = STATE(1545),
    [sym_raiseTr] = STATE(1545),
    [sym_statementTr] = STATE(1545),
    [sym_gotoTr] = STATE(1545),
    [sym__statementTr] = STATE(1545),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(175),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(175),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(175),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(175),
    [sym_kFinally] = ACTIONS(175),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2378),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(193),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2425),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(195),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2355),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(197),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2314),
    [sym_ifElseTr] = STATE(2314),
    [sym_whileTr] = STATE(2314),
    [sym_repeatTr] = STATE(2314),
    [sym_forTr] = STATE(2314),
    [sym_foreachTr] = STATE(2314),
    [sym_tryTr] = STATE(2314),
    [sym_caseTr] = STATE(2314),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2314),
    [sym_withTr] = STATE(2314),
    [sym_raiseTr] = STATE(2314),
    [sym_statementTr] = STATE(2314),
    [sym_gotoTr] = STATE(2314),
    [sym__statementTr] = STATE(2314),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2314),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(201),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2351),
    [sym_ifElseTr] = STATE(2351),
    [sym_whileTr] = STATE(2351),
    [sym_repeatTr] = STATE(2351),
    [sym_forTr] = STATE(2351),
    [sym_foreachTr] = STATE(2351),
    [sym_tryTr] = STATE(2351),
    [sym_caseTr] = STATE(2351),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2351),
    [sym_withTr] = STATE(2351),
    [sym_raiseTr] = STATE(2351),
    [sym_statementTr] = STATE(2351),
    [sym_gotoTr] = STATE(2351),
    [sym__statementTr] = STATE(2351),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2351),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(205),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2344),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(207),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2354),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(209),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2245),
    [sym_ifElseTr] = STATE(2245),
    [sym_whileTr] = STATE(2245),
    [sym_repeatTr] = STATE(2245),
    [sym_forTr] = STATE(2245),
    [sym_foreachTr] = STATE(2245),
    [sym_tryTr] = STATE(2245),
    [sym_caseTr] = STATE(2245),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2245),
    [sym_withTr] = STATE(2245),
    [sym_raiseTr] = STATE(2245),
    [sym_statementTr] = STATE(2245),
    [sym_gotoTr] = STATE(2245),
    [sym__statementTr] = STATE(2245),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2245),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(213),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2151),
    [sym_ifElseTr] = STATE(2151),
    [sym_whileTr] = STATE(2151),
    [sym_repeatTr] = STATE(2151),
    [sym_forTr] = STATE(2151),
    [sym_foreachTr] = STATE(2151),
    [sym_tryTr] = STATE(2151),
    [sym_caseTr] = STATE(2151),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2151),
    [sym_withTr] = STATE(2151),
    [sym_raiseTr] = STATE(2151),
    [sym_statementTr] = STATE(2151),
    [sym_gotoTr] = STATE(2151),
    [sym__statementTr] = STATE(2151),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2151),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(217),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_if] = STATE(917),
    [sym_ifElse] = STATE(756),
    [sym_while] = STATE(756),
    [sym_repeat] = STATE(756),
    [sym_for] = STATE(756),
    [sym_foreach] = STATE(756),
    [sym_try] = STATE(756),
    [sym_case] = STATE(756),
    [sym_block] = STATE(756),
    [sym_asm] = STATE(756),
    [sym_with] = STATE(756),
    [sym_raise] = STATE(756),
    [sym_statement] = STATE(756),
    [sym_goto] = STATE(756),
    [sym__statement] = STATE(756),
    [sym_ifTr] = STATE(1705),
    [sym_ifElseTr] = STATE(1705),
    [sym_whileTr] = STATE(1705),
    [sym_repeatTr] = STATE(1705),
    [sym_forTr] = STATE(1705),
    [sym_foreachTr] = STATE(1705),
    [sym_tryTr] = STATE(1705),
    [sym_caseTr] = STATE(1705),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1705),
    [sym_withTr] = STATE(1705),
    [sym_raiseTr] = STATE(1705),
    [sym_statementTr] = STATE(1705),
    [sym_gotoTr] = STATE(1705),
    [sym__statementTr] = STATE(1705),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(183),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(219),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(183),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(183),
    [sym_kFinally] = ACTIONS(183),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(1786),
    [sym_ifElseTr] = STATE(1786),
    [sym_whileTr] = STATE(1786),
    [sym_repeatTr] = STATE(1786),
    [sym_forTr] = STATE(1786),
    [sym_foreachTr] = STATE(1786),
    [sym_tryTr] = STATE(1786),
    [sym_caseTr] = STATE(1786),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1786),
    [sym_withTr] = STATE(1786),
    [sym_raiseTr] = STATE(1786),
    [sym_statementTr] = STATE(1786),
    [sym_gotoTr] = STATE(1786),
    [sym__statementTr] = STATE(1786),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(1786),
    [sym_statementsTr] = STATE(2321),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(221),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(753),
    [sym_while] = STATE(753),
    [sym_repeat] = STATE(753),
    [sym_for] = STATE(753),
    [sym_foreach] = STATE(753),
    [sym_try] = STATE(753),
    [sym_case] = STATE(753),
    [sym_block] = STATE(753),
    [sym_asm] = STATE(753),
    [sym_with] = STATE(753),
    [sym_raise] = STATE(753),
    [sym_statement] = STATE(753),
    [sym_goto] = STATE(753),
    [sym__statement] = STATE(753),
    [sym_ifTr] = STATE(1535),
    [sym_ifElseTr] = STATE(1535),
    [sym_whileTr] = STATE(1535),
    [sym_repeatTr] = STATE(1535),
    [sym_forTr] = STATE(1535),
    [sym_foreachTr] = STATE(1535),
    [sym_tryTr] = STATE(1535),
    [sym_caseTr] = STATE(1535),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1535),
    [sym_withTr] = STATE(1535),
    [sym_raiseTr] = STATE(1535),
    [sym_statementTr] = STATE(1535),
    [sym_gotoTr] = STATE(1535),
    [sym__statementTr] = STATE(1535),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(151),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(151),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kUntil] = ACTIONS(151),
    [sym_kTry] = ACTIONS(79),
    [sym_kExcept] = ACTIONS(151),
    [sym_kFinally] = ACTIONS(151),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2331),
    [sym_ifElseTr] = STATE(2331),
    [sym_whileTr] = STATE(2331),
    [sym_repeatTr] = STATE(2331),
    [sym_forTr] = STATE(2331),
    [sym_foreachTr] = STATE(2331),
    [sym_tryTr] = STATE(2331),
    [sym_caseTr] = STATE(2331),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2331),
    [sym_withTr] = STATE(2331),
    [sym_raiseTr] = STATE(2331),
    [sym_statementTr] = STATE(2331),
    [sym_gotoTr] = STATE(2331),
    [sym__statementTr] = STATE(2331),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2331),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_COLON] = ACTIONS(223),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(225),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2314),
    [sym_ifElseTr] = STATE(2314),
    [sym_whileTr] = STATE(2314),
    [sym_repeatTr] = STATE(2314),
    [sym_forTr] = STATE(2314),
    [sym_foreachTr] = STATE(2314),
    [sym_tryTr] = STATE(2314),
    [sym_caseTr] = STATE(2314),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2314),
    [sym_withTr] = STATE(2314),
    [sym_raiseTr] = STATE(2314),
    [sym_statementTr] = STATE(2314),
    [sym_gotoTr] = STATE(2314),
    [sym__statementTr] = STATE(2314),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2314),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(201),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2144),
    [sym_ifElseTr] = STATE(2144),
    [sym_whileTr] = STATE(2144),
    [sym_repeatTr] = STATE(2144),
    [sym_forTr] = STATE(2144),
    [sym_foreachTr] = STATE(2144),
    [sym_tryTr] = STATE(2144),
    [sym_caseTr] = STATE(2144),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2144),
    [sym_withTr] = STATE(2144),
    [sym_raiseTr] = STATE(2144),
    [sym_statementTr] = STATE(2144),
    [sym_gotoTr] = STATE(2144),
    [sym__statementTr] = STATE(2144),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2144),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(227),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2402),
    [sym_ifElseTr] = STATE(2402),
    [sym_whileTr] = STATE(2402),
    [sym_repeatTr] = STATE(2402),
    [sym_forTr] = STATE(2402),
    [sym_foreachTr] = STATE(2402),
    [sym_tryTr] = STATE(2402),
    [sym_caseTr] = STATE(2402),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2402),
    [sym_withTr] = STATE(2402),
    [sym_raiseTr] = STATE(2402),
    [sym_statementTr] = STATE(2402),
    [sym_gotoTr] = STATE(2402),
    [sym__statementTr] = STATE(2402),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2402),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(189),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2277),
    [sym_ifElseTr] = STATE(2277),
    [sym_whileTr] = STATE(2277),
    [sym_repeatTr] = STATE(2277),
    [sym_forTr] = STATE(2277),
    [sym_foreachTr] = STATE(2277),
    [sym_tryTr] = STATE(2277),
    [sym_caseTr] = STATE(2277),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2277),
    [sym_withTr] = STATE(2277),
    [sym_raiseTr] = STATE(2277),
    [sym_statementTr] = STATE(2277),
    [sym_gotoTr] = STATE(2277),
    [sym__statementTr] = STATE(2277),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2277),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(229),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2285),
    [sym_ifElseTr] = STATE(2285),
    [sym_whileTr] = STATE(2285),
    [sym_repeatTr] = STATE(2285),
    [sym_forTr] = STATE(2285),
    [sym_foreachTr] = STATE(2285),
    [sym_tryTr] = STATE(2285),
    [sym_caseTr] = STATE(2285),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2285),
    [sym_withTr] = STATE(2285),
    [sym_raiseTr] = STATE(2285),
    [sym_statementTr] = STATE(2285),
    [sym_gotoTr] = STATE(2285),
    [sym__statementTr] = STATE(2285),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2285),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(231),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2414),
    [sym_ifElseTr] = STATE(2414),
    [sym_whileTr] = STATE(2414),
    [sym_repeatTr] = STATE(2414),
    [sym_forTr] = STATE(2414),
    [sym_foreachTr] = STATE(2414),
    [sym_tryTr] = STATE(2414),
    [sym_caseTr] = STATE(2414),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2414),
    [sym_withTr] = STATE(2414),
    [sym_raiseTr] = STATE(2414),
    [sym_statementTr] = STATE(2414),
    [sym_gotoTr] = STATE(2414),
    [sym__statementTr] = STATE(2414),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2414),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(233),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2331),
    [sym_ifElseTr] = STATE(2331),
    [sym_whileTr] = STATE(2331),
    [sym_repeatTr] = STATE(2331),
    [sym_forTr] = STATE(2331),
    [sym_foreachTr] = STATE(2331),
    [sym_tryTr] = STATE(2331),
    [sym_caseTr] = STATE(2331),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2331),
    [sym_withTr] = STATE(2331),
    [sym_raiseTr] = STATE(2331),
    [sym_statementTr] = STATE(2331),
    [sym_gotoTr] = STATE(2331),
    [sym__statementTr] = STATE(2331),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2331),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(225),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2351),
    [sym_ifElseTr] = STATE(2351),
    [sym_whileTr] = STATE(2351),
    [sym_repeatTr] = STATE(2351),
    [sym_forTr] = STATE(2351),
    [sym_foreachTr] = STATE(2351),
    [sym_tryTr] = STATE(2351),
    [sym_caseTr] = STATE(2351),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2351),
    [sym_withTr] = STATE(2351),
    [sym_raiseTr] = STATE(2351),
    [sym_statementTr] = STATE(2351),
    [sym_gotoTr] = STATE(2351),
    [sym__statementTr] = STATE(2351),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2351),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(205),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2406),
    [sym_ifElseTr] = STATE(2406),
    [sym_whileTr] = STATE(2406),
    [sym_repeatTr] = STATE(2406),
    [sym_forTr] = STATE(2406),
    [sym_foreachTr] = STATE(2406),
    [sym_tryTr] = STATE(2406),
    [sym_caseTr] = STATE(2406),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2406),
    [sym_withTr] = STATE(2406),
    [sym_raiseTr] = STATE(2406),
    [sym_statementTr] = STATE(2406),
    [sym_gotoTr] = STATE(2406),
    [sym__statementTr] = STATE(2406),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2406),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(235),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2214),
    [sym_ifElseTr] = STATE(2214),
    [sym_whileTr] = STATE(2214),
    [sym_repeatTr] = STATE(2214),
    [sym_forTr] = STATE(2214),
    [sym_foreachTr] = STATE(2214),
    [sym_tryTr] = STATE(2214),
    [sym_caseTr] = STATE(2214),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2214),
    [sym_withTr] = STATE(2214),
    [sym_raiseTr] = STATE(2214),
    [sym_statementTr] = STATE(2214),
    [sym_gotoTr] = STATE(2214),
    [sym__statementTr] = STATE(2214),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2214),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(237),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2286),
    [sym_ifElseTr] = STATE(2286),
    [sym_whileTr] = STATE(2286),
    [sym_repeatTr] = STATE(2286),
    [sym_forTr] = STATE(2286),
    [sym_foreachTr] = STATE(2286),
    [sym_tryTr] = STATE(2286),
    [sym_caseTr] = STATE(2286),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2286),
    [sym_withTr] = STATE(2286),
    [sym_raiseTr] = STATE(2286),
    [sym_statementTr] = STATE(2286),
    [sym_gotoTr] = STATE(2286),
    [sym__statementTr] = STATE(2286),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2286),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(239),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2239),
    [sym_ifElseTr] = STATE(2239),
    [sym_whileTr] = STATE(2239),
    [sym_repeatTr] = STATE(2239),
    [sym_forTr] = STATE(2239),
    [sym_foreachTr] = STATE(2239),
    [sym_tryTr] = STATE(2239),
    [sym_caseTr] = STATE(2239),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2239),
    [sym_withTr] = STATE(2239),
    [sym_raiseTr] = STATE(2239),
    [sym_statementTr] = STATE(2239),
    [sym_gotoTr] = STATE(2239),
    [sym__statementTr] = STATE(2239),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2239),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(241),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_foreach] = STATE(913),
    [sym_try] = STATE(913),
    [sym_case] = STATE(913),
    [sym_block] = STATE(913),
    [sym_asm] = STATE(913),
    [sym_with] = STATE(913),
    [sym_raise] = STATE(913),
    [sym_statement] = STATE(913),
    [sym_goto] = STATE(913),
    [sym__statement] = STATE(913),
    [sym_ifTr] = STATE(2367),
    [sym_ifElseTr] = STATE(2367),
    [sym_whileTr] = STATE(2367),
    [sym_repeatTr] = STATE(2367),
    [sym_forTr] = STATE(2367),
    [sym_foreachTr] = STATE(2367),
    [sym_tryTr] = STATE(2367),
    [sym_caseTr] = STATE(2367),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2367),
    [sym_withTr] = STATE(2367),
    [sym_raiseTr] = STATE(2367),
    [sym_statementTr] = STATE(2367),
    [sym_gotoTr] = STATE(2367),
    [sym__statementTr] = STATE(2367),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(54),
    [sym__statementsTr] = STATE(2367),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(54),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(243),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1906),
    [sym_while] = STATE(1906),
    [sym_repeat] = STATE(1906),
    [sym_for] = STATE(1906),
    [sym_foreach] = STATE(1906),
    [sym_try] = STATE(1906),
    [sym_case] = STATE(1906),
    [sym_block] = STATE(1906),
    [sym_asm] = STATE(1906),
    [sym_with] = STATE(1906),
    [sym_raise] = STATE(1906),
    [sym_statement] = STATE(1906),
    [sym_goto] = STATE(1906),
    [sym__statement] = STATE(1906),
    [sym_ifTr] = STATE(1936),
    [sym_ifElseTr] = STATE(1936),
    [sym_whileTr] = STATE(1936),
    [sym_repeatTr] = STATE(1936),
    [sym_forTr] = STATE(1936),
    [sym_foreachTr] = STATE(1936),
    [sym_tryTr] = STATE(1936),
    [sym_caseTr] = STATE(1936),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1936),
    [sym_withTr] = STATE(1936),
    [sym_raiseTr] = STATE(1936),
    [sym_statementTr] = STATE(1936),
    [sym_gotoTr] = STATE(1936),
    [sym__statementTr] = STATE(1936),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(247),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(247),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1414),
    [sym_while] = STATE(1414),
    [sym_repeat] = STATE(1414),
    [sym_for] = STATE(1414),
    [sym_foreach] = STATE(1414),
    [sym_try] = STATE(1414),
    [sym_case] = STATE(1414),
    [sym_block] = STATE(1414),
    [sym_asm] = STATE(1414),
    [sym_with] = STATE(1414),
    [sym_raise] = STATE(1414),
    [sym_statement] = STATE(1414),
    [sym_goto] = STATE(1414),
    [sym__statement] = STATE(1414),
    [sym_ifTr] = STATE(2066),
    [sym_ifElseTr] = STATE(2066),
    [sym_whileTr] = STATE(2066),
    [sym_repeatTr] = STATE(2066),
    [sym_forTr] = STATE(2066),
    [sym_foreachTr] = STATE(2066),
    [sym_tryTr] = STATE(2066),
    [sym_caseTr] = STATE(2066),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2066),
    [sym_withTr] = STATE(2066),
    [sym_raiseTr] = STATE(2066),
    [sym_statementTr] = STATE(2066),
    [sym_gotoTr] = STATE(2066),
    [sym__statementTr] = STATE(2066),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(251),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(251),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(911),
    [sym_while] = STATE(911),
    [sym_repeat] = STATE(911),
    [sym_for] = STATE(911),
    [sym_foreach] = STATE(911),
    [sym_try] = STATE(911),
    [sym_case] = STATE(911),
    [sym_block] = STATE(911),
    [sym_asm] = STATE(911),
    [sym_with] = STATE(911),
    [sym_raise] = STATE(911),
    [sym_statement] = STATE(911),
    [sym_goto] = STATE(911),
    [sym__statement] = STATE(911),
    [sym_ifTr] = STATE(1591),
    [sym_ifElseTr] = STATE(1591),
    [sym_whileTr] = STATE(1591),
    [sym_repeatTr] = STATE(1591),
    [sym_forTr] = STATE(1591),
    [sym_foreachTr] = STATE(1591),
    [sym_tryTr] = STATE(1591),
    [sym_caseTr] = STATE(1591),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1591),
    [sym_withTr] = STATE(1591),
    [sym_raiseTr] = STATE(1591),
    [sym_statementTr] = STATE(1591),
    [sym_gotoTr] = STATE(1591),
    [sym__statementTr] = STATE(1591),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(92),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(92),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1808),
    [sym_while] = STATE(1808),
    [sym_repeat] = STATE(1808),
    [sym_for] = STATE(1808),
    [sym_foreach] = STATE(1808),
    [sym_try] = STATE(1808),
    [sym_case] = STATE(1808),
    [sym_block] = STATE(1808),
    [sym_asm] = STATE(1808),
    [sym_with] = STATE(1808),
    [sym_raise] = STATE(1808),
    [sym_statement] = STATE(1808),
    [sym_goto] = STATE(1808),
    [sym__statement] = STATE(1808),
    [sym_ifTr] = STATE(2054),
    [sym_ifElseTr] = STATE(2054),
    [sym_whileTr] = STATE(2054),
    [sym_repeatTr] = STATE(2054),
    [sym_forTr] = STATE(2054),
    [sym_foreachTr] = STATE(2054),
    [sym_tryTr] = STATE(2054),
    [sym_caseTr] = STATE(2054),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2054),
    [sym_withTr] = STATE(2054),
    [sym_raiseTr] = STATE(2054),
    [sym_statementTr] = STATE(2054),
    [sym_gotoTr] = STATE(2054),
    [sym__statementTr] = STATE(2054),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kEnd] = ACTIONS(257),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(257),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(911),
    [sym_while] = STATE(911),
    [sym_repeat] = STATE(911),
    [sym_for] = STATE(911),
    [sym_foreach] = STATE(911),
    [sym_try] = STATE(911),
    [sym_case] = STATE(911),
    [sym_block] = STATE(911),
    [sym_asm] = STATE(911),
    [sym_with] = STATE(911),
    [sym_raise] = STATE(911),
    [sym_statement] = STATE(911),
    [sym_goto] = STATE(911),
    [sym__statement] = STATE(911),
    [sym_ifTr] = STATE(1591),
    [sym_ifElseTr] = STATE(1591),
    [sym_whileTr] = STATE(1591),
    [sym_repeatTr] = STATE(1591),
    [sym_forTr] = STATE(1591),
    [sym_foreachTr] = STATE(1591),
    [sym_tryTr] = STATE(1591),
    [sym_caseTr] = STATE(1591),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(1591),
    [sym_withTr] = STATE(1591),
    [sym_raiseTr] = STATE(1591),
    [sym_statementTr] = STATE(1591),
    [sym_gotoTr] = STATE(1591),
    [sym__statementTr] = STATE(1591),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1713),
    [sym_varDef] = STATE(1517),
    [sym_label] = STATE(92),
    [sym__expr] = STATE(1068),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(1068),
    [sym_exprUnary] = STATE(1068),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym__statementsTr_repeat1] = STATE(92),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kAdd] = ACTIONS(121),
    [sym_kSub] = ACTIONS(121),
    [sym_kAt] = ACTIONS(123),
    [sym_kNot] = ACTIONS(121),
    [sym_kFor] = ACTIONS(125),
    [sym_kIf] = ACTIONS(127),
    [sym_kWhile] = ACTIONS(129),
    [sym_kRepeat] = ACTIONS(131),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(133),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(135),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_if] = STATE(1045),
    [sym_ifElse] = STATE(756),
    [sym_while] = STATE(756),
    [sym_repeat] = STATE(756),
    [sym_for] = STATE(756),
    [sym_foreach] = STATE(756),
    [sym_try] = STATE(756),
    [sym_case] = STATE(756),
    [sym_block] = STATE(756),
    [sym_asm] = STATE(756),
    [sym_with] = STATE(756),
    [sym_raise] = STATE(756),
    [sym_statement] = STATE(756),
    [sym_goto] = STATE(756),
    [sym__statement] = STATE(756),
    [sym_ifTr] = STATE(2338),
    [sym_ifElseTr] = STATE(2338),
    [sym_whileTr] = STATE(2338),
    [sym_repeatTr] = STATE(2338),
    [sym_forTr] = STATE(2338),
    [sym_foreachTr] = STATE(2338),
    [sym_tryTr] = STATE(2338),
    [sym_caseTr] = STATE(2338),
    [sym_blockTr] = STATE(1531),
    [sym_asmTr] = STATE(2338),
    [sym_withTr] = STATE(2338),
    [sym_raiseTr] = STATE(2338),
    [sym_statementTr] = STATE(2338),
    [sym_gotoTr] = STATE(2338),
    [sym__statementTr] = STATE(2338),
    [sym_assignment] = STATE(1517),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(1517),
    [sym__expr] = STATE(1080),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1080),
    [sym_exprUnary] = STATE(1080),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(57),
    [sym_kAsm] = ACTIONS(61),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(71),
    [sym_kIf] = ACTIONS(73),
    [sym_kElse] = ACTIONS(259),
    [sym_kWhile] = ACTIONS(75),
    [sym_kRepeat] = ACTIONS(77),
    [sym_kTry] = ACTIONS(79),
    [sym_kRaise] = ACTIONS(81),
    [sym_kCase] = ACTIONS(85),
    [sym_kWith] = ACTIONS(87),
    [sym_kGoto] = ACTIONS(89),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__expr] = STATE(606),
    [sym__ref] = STATE(591),
    [sym_lambda] = STATE(591),
    [sym_inherited] = STATE(591),
    [sym_exprDot] = STATE(591),
    [sym_exprDeref] = STATE(591),
    [sym_exprAs] = STATE(591),
    [sym_exprTpl] = STATE(591),
    [sym_exprSubscript] = STATE(591),
    [sym_exprCall] = STATE(591),
    [sym_exprBinary] = STATE(606),
    [sym_exprUnary] = STATE(606),
    [sym_exprParens] = STATE(591),
    [sym_exprBrackets] = STATE(591),
    [sym__literal] = STATE(591),
    [sym_literalString] = STATE(591),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(591),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kVar] = ACTIONS(261),
    [sym_kThreadvar] = ACTIONS(261),
    [sym_kConst] = ACTIONS(261),
    [sym_kResourcestring] = ACTIONS(261),
    [sym_kType] = ACTIONS(261),
    [sym_kProperty] = ACTIONS(261),
    [sym_kClass] = ACTIONS(261),
    [sym_kGeneric] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(265),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(267),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(269),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kCase] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(261),
    [sym_kProcedure] = ACTIONS(261),
    [sym_kConstructor] = ACTIONS(261),
    [sym_kDestructor] = ACTIONS(261),
    [sym_kOperator] = ACTIONS(261),
    [sym_kPublished] = ACTIONS(261),
    [sym_kPublic] = ACTIONS(261),
    [sym_kProtected] = ACTIONS(261),
    [sym_kPrivate] = ACTIONS(261),
    [sym_kStrict] = ACTIONS(261),
    [sym_kRequired] = ACTIONS(261),
    [sym_kOptional] = ACTIONS(261),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(271),
    [sym_kTrue] = ACTIONS(271),
    [sym_kFalse] = ACTIONS(271),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__expr] = STATE(597),
    [sym__ref] = STATE(593),
    [sym_lambda] = STATE(593),
    [sym_inherited] = STATE(593),
    [sym_exprDot] = STATE(593),
    [sym_exprDeref] = STATE(593),
    [sym_exprAs] = STATE(593),
    [sym_exprTpl] = STATE(593),
    [sym_exprSubscript] = STATE(593),
    [sym_exprCall] = STATE(593),
    [sym_exprBinary] = STATE(597),
    [sym_exprUnary] = STATE(597),
    [sym_exprParens] = STATE(593),
    [sym_exprBrackets] = STATE(593),
    [sym__literal] = STATE(593),
    [sym_literalString] = STATE(593),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(593),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kVar] = ACTIONS(261),
    [sym_kThreadvar] = ACTIONS(261),
    [sym_kConst] = ACTIONS(261),
    [sym_kResourcestring] = ACTIONS(261),
    [sym_kType] = ACTIONS(261),
    [sym_kProperty] = ACTIONS(261),
    [sym_kClass] = ACTIONS(261),
    [sym_kGeneric] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(265),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(273),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(275),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kCase] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(261),
    [sym_kProcedure] = ACTIONS(261),
    [sym_kConstructor] = ACTIONS(261),
    [sym_kDestructor] = ACTIONS(261),
    [sym_kOperator] = ACTIONS(261),
    [sym_kPublished] = ACTIONS(261),
    [sym_kPublic] = ACTIONS(261),
    [sym_kProtected] = ACTIONS(261),
    [sym_kPrivate] = ACTIONS(261),
    [sym_kStrict] = ACTIONS(261),
    [sym_kRequired] = ACTIONS(261),
    [sym_kOptional] = ACTIONS(261),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(277),
    [sym_kTrue] = ACTIONS(277),
    [sym_kFalse] = ACTIONS(277),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(279),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(279),
    [sym_kEnd] = ACTIONS(279),
    [sym_kVar] = ACTIONS(279),
    [sym_kThreadvar] = ACTIONS(279),
    [sym_kConst] = ACTIONS(279),
    [sym_kResourcestring] = ACTIONS(279),
    [sym_kType] = ACTIONS(279),
    [sym_kProperty] = ACTIONS(279),
    [sym_kClass] = ACTIONS(279),
    [sym_kGeneric] = ACTIONS(279),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(279),
    [sym_kEq] = ACTIONS(281),
    [sym_kNeq] = ACTIONS(281),
    [sym_kGt] = ACTIONS(279),
    [sym_kLte] = ACTIONS(281),
    [sym_kGte] = ACTIONS(281),
    [sym_kAdd] = ACTIONS(279),
    [sym_kSub] = ACTIONS(279),
    [sym_kMul] = ACTIONS(281),
    [sym_kFdiv] = ACTIONS(279),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(281),
    [sym_kOr] = ACTIONS(279),
    [sym_kXor] = ACTIONS(279),
    [sym_kDiv] = ACTIONS(279),
    [sym_kMod] = ACTIONS(279),
    [sym_kAnd] = ACTIONS(279),
    [sym_kShl] = ACTIONS(279),
    [sym_kShr] = ACTIONS(279),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(279),
    [sym_kAs] = ACTIONS(279),
    [sym_kIn] = ACTIONS(279),
    [sym_kCase] = ACTIONS(279),
    [sym_kFunction] = ACTIONS(279),
    [sym_kProcedure] = ACTIONS(279),
    [sym_kConstructor] = ACTIONS(279),
    [sym_kDestructor] = ACTIONS(279),
    [sym_kOperator] = ACTIONS(279),
    [sym_kPublished] = ACTIONS(279),
    [sym_kPublic] = ACTIONS(279),
    [sym_kProtected] = ACTIONS(279),
    [sym_kPrivate] = ACTIONS(279),
    [sym_kStrict] = ACTIONS(279),
    [sym_kRequired] = ACTIONS(279),
    [sym_kOptional] = ACTIONS(279),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kVar] = ACTIONS(261),
    [sym_kThreadvar] = ACTIONS(261),
    [sym_kConst] = ACTIONS(261),
    [sym_kResourcestring] = ACTIONS(261),
    [sym_kType] = ACTIONS(261),
    [sym_kProperty] = ACTIONS(261),
    [sym_kClass] = ACTIONS(261),
    [sym_kGeneric] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kCase] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(261),
    [sym_kProcedure] = ACTIONS(261),
    [sym_kConstructor] = ACTIONS(261),
    [sym_kDestructor] = ACTIONS(261),
    [sym_kOperator] = ACTIONS(261),
    [sym_kPublished] = ACTIONS(261),
    [sym_kPublic] = ACTIONS(261),
    [sym_kProtected] = ACTIONS(261),
    [sym_kPrivate] = ACTIONS(261),
    [sym_kStrict] = ACTIONS(261),
    [sym_kRequired] = ACTIONS(261),
    [sym_kOptional] = ACTIONS(261),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__expr] = STATE(732),
    [sym__ref] = STATE(689),
    [sym_lambda] = STATE(689),
    [sym_inherited] = STATE(689),
    [sym_exprDot] = STATE(689),
    [sym_exprDeref] = STATE(689),
    [sym_exprAs] = STATE(689),
    [sym_exprTpl] = STATE(689),
    [sym_exprSubscript] = STATE(689),
    [sym_exprCall] = STATE(689),
    [sym_exprBinary] = STATE(732),
    [sym_exprUnary] = STATE(732),
    [sym_exprParens] = STATE(689),
    [sym_exprBrackets] = STATE(689),
    [sym__literal] = STATE(689),
    [sym_literalString] = STATE(689),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(689),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(283),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_RPAREN] = ACTIONS(263),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kOf] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(261),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(285),
    [sym_kHat] = ACTIONS(263),
    [sym_kAssign] = ACTIONS(263),
    [sym_kAssignAdd] = ACTIONS(263),
    [sym_kAssignSub] = ACTIONS(263),
    [sym_kAssignMul] = ACTIONS(263),
    [sym_kAssignDiv] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(287),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kThen] = ACTIONS(261),
    [sym_kElse] = ACTIONS(261),
    [sym_kDo] = ACTIONS(261),
    [sym_kUntil] = ACTIONS(261),
    [sym_kExcept] = ACTIONS(261),
    [sym_kFinally] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kDelayed] = ACTIONS(261),
    [sym_kNil] = ACTIONS(283),
    [sym_kTrue] = ACTIONS(283),
    [sym_kFalse] = ACTIONS(283),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(281),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(281),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(279),
    [sym_kEnd] = ACTIONS(279),
    [sym_kOf] = ACTIONS(279),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(279),
    [sym_kEq] = ACTIONS(281),
    [sym_kNeq] = ACTIONS(281),
    [sym_kGt] = ACTIONS(279),
    [sym_kLte] = ACTIONS(281),
    [sym_kGte] = ACTIONS(281),
    [sym_kAdd] = ACTIONS(279),
    [sym_kSub] = ACTIONS(279),
    [sym_kMul] = ACTIONS(279),
    [sym_kFdiv] = ACTIONS(279),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(281),
    [sym_kAssign] = ACTIONS(281),
    [sym_kAssignAdd] = ACTIONS(281),
    [sym_kAssignSub] = ACTIONS(281),
    [sym_kAssignMul] = ACTIONS(281),
    [sym_kAssignDiv] = ACTIONS(281),
    [sym_kOr] = ACTIONS(279),
    [sym_kXor] = ACTIONS(279),
    [sym_kDiv] = ACTIONS(279),
    [sym_kMod] = ACTIONS(279),
    [sym_kAnd] = ACTIONS(279),
    [sym_kShl] = ACTIONS(279),
    [sym_kShr] = ACTIONS(279),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(279),
    [sym_kAs] = ACTIONS(279),
    [sym_kIn] = ACTIONS(279),
    [sym_kThen] = ACTIONS(279),
    [sym_kElse] = ACTIONS(279),
    [sym_kDo] = ACTIONS(279),
    [sym_kUntil] = ACTIONS(279),
    [sym_kExcept] = ACTIONS(279),
    [sym_kFinally] = ACTIONS(279),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kDelayed] = ACTIONS(279),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_RPAREN] = ACTIONS(263),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kOf] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(261),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(263),
    [sym_kAssign] = ACTIONS(263),
    [sym_kAssignAdd] = ACTIONS(263),
    [sym_kAssignSub] = ACTIONS(263),
    [sym_kAssignMul] = ACTIONS(263),
    [sym_kAssignDiv] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kThen] = ACTIONS(261),
    [sym_kElse] = ACTIONS(261),
    [sym_kDo] = ACTIONS(261),
    [sym_kUntil] = ACTIONS(261),
    [sym_kExcept] = ACTIONS(261),
    [sym_kFinally] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kDelayed] = ACTIONS(261),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [sym_kUses] = ACTIONS(291),
    [sym_kInterface] = ACTIONS(291),
    [sym_kImplementation] = ACTIONS(291),
    [sym_kInitialization] = ACTIONS(291),
    [sym_kFinalization] = ACTIONS(291),
    [sym_kBegin] = ACTIONS(291),
    [sym_kEnd] = ACTIONS(291),
    [sym_kAsm] = ACTIONS(291),
    [sym_kVar] = ACTIONS(291),
    [sym_kThreadvar] = ACTIONS(291),
    [sym_kConst] = ACTIONS(291),
    [sym_kResourcestring] = ACTIONS(291),
    [sym_kType] = ACTIONS(291),
    [sym_kLabel] = ACTIONS(291),
    [sym_kExports] = ACTIONS(291),
    [sym_kProperty] = ACTIONS(291),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(291),
    [sym_kGeneric] = ACTIONS(291),
    [sym_kFunction] = ACTIONS(291),
    [sym_kProcedure] = ACTIONS(291),
    [sym_kConstructor] = ACTIONS(291),
    [sym_kDestructor] = ACTIONS(291),
    [sym_kOperator] = ACTIONS(291),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(310),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACK] = ACTIONS(314),
    [sym_kUses] = ACTIONS(312),
    [sym_kInterface] = ACTIONS(312),
    [sym_kImplementation] = ACTIONS(312),
    [sym_kInitialization] = ACTIONS(312),
    [sym_kFinalization] = ACTIONS(312),
    [sym_kBegin] = ACTIONS(312),
    [sym_kEnd] = ACTIONS(312),
    [sym_kAsm] = ACTIONS(312),
    [sym_kVar] = ACTIONS(312),
    [sym_kThreadvar] = ACTIONS(312),
    [sym_kConst] = ACTIONS(312),
    [sym_kResourcestring] = ACTIONS(312),
    [sym_kType] = ACTIONS(312),
    [sym_kLabel] = ACTIONS(312),
    [sym_kExports] = ACTIONS(312),
    [sym_kProperty] = ACTIONS(312),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(312),
    [sym_kGeneric] = ACTIONS(312),
    [sym_kFunction] = ACTIONS(312),
    [sym_kProcedure] = ACTIONS(312),
    [sym_kConstructor] = ACTIONS(312),
    [sym_kDestructor] = ACTIONS(312),
    [sym_kOperator] = ACTIONS(312),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(317),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_LBRACK] = ACTIONS(321),
    [sym_kUses] = ACTIONS(319),
    [sym_kInterface] = ACTIONS(319),
    [sym_kImplementation] = ACTIONS(319),
    [sym_kInitialization] = ACTIONS(319),
    [sym_kFinalization] = ACTIONS(319),
    [sym_kBegin] = ACTIONS(319),
    [sym_kEnd] = ACTIONS(319),
    [sym_kAsm] = ACTIONS(319),
    [sym_kVar] = ACTIONS(319),
    [sym_kThreadvar] = ACTIONS(319),
    [sym_kConst] = ACTIONS(319),
    [sym_kResourcestring] = ACTIONS(319),
    [sym_kType] = ACTIONS(319),
    [sym_kLabel] = ACTIONS(319),
    [sym_kExports] = ACTIONS(319),
    [sym_kProperty] = ACTIONS(319),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(319),
    [sym_kGeneric] = ACTIONS(319),
    [sym_kFunction] = ACTIONS(319),
    [sym_kProcedure] = ACTIONS(319),
    [sym_kConstructor] = ACTIONS(319),
    [sym_kDestructor] = ACTIONS(319),
    [sym_kOperator] = ACTIONS(319),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(79),
    [aux_sym_declVar_repeat1] = STATE(79),
    [ts_builtin_sym_end] = ACTIONS(324),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_LBRACK] = ACTIONS(328),
    [sym_kUses] = ACTIONS(326),
    [sym_kInterface] = ACTIONS(326),
    [sym_kImplementation] = ACTIONS(326),
    [sym_kInitialization] = ACTIONS(326),
    [sym_kFinalization] = ACTIONS(326),
    [sym_kBegin] = ACTIONS(326),
    [sym_kEnd] = ACTIONS(326),
    [sym_kAsm] = ACTIONS(326),
    [sym_kVar] = ACTIONS(326),
    [sym_kThreadvar] = ACTIONS(326),
    [sym_kConst] = ACTIONS(326),
    [sym_kResourcestring] = ACTIONS(326),
    [sym_kType] = ACTIONS(326),
    [sym_kLabel] = ACTIONS(326),
    [sym_kExports] = ACTIONS(326),
    [sym_kProperty] = ACTIONS(326),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(326),
    [sym_kGeneric] = ACTIONS(326),
    [sym_kFunction] = ACTIONS(326),
    [sym_kProcedure] = ACTIONS(326),
    [sym_kConstructor] = ACTIONS(326),
    [sym_kDestructor] = ACTIONS(326),
    [sym_kOperator] = ACTIONS(326),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(82),
    [aux_sym_declVar_repeat1] = STATE(82),
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(335),
    [sym_kUses] = ACTIONS(333),
    [sym_kInterface] = ACTIONS(333),
    [sym_kImplementation] = ACTIONS(333),
    [sym_kInitialization] = ACTIONS(333),
    [sym_kFinalization] = ACTIONS(333),
    [sym_kBegin] = ACTIONS(333),
    [sym_kEnd] = ACTIONS(333),
    [sym_kAsm] = ACTIONS(333),
    [sym_kVar] = ACTIONS(333),
    [sym_kThreadvar] = ACTIONS(333),
    [sym_kConst] = ACTIONS(333),
    [sym_kResourcestring] = ACTIONS(333),
    [sym_kType] = ACTIONS(333),
    [sym_kLabel] = ACTIONS(333),
    [sym_kExports] = ACTIONS(333),
    [sym_kProperty] = ACTIONS(333),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(333),
    [sym_kGeneric] = ACTIONS(333),
    [sym_kFunction] = ACTIONS(333),
    [sym_kProcedure] = ACTIONS(333),
    [sym_kConstructor] = ACTIONS(333),
    [sym_kDestructor] = ACTIONS(333),
    [sym_kOperator] = ACTIONS(333),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(338),
    [sym_identifier] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(342),
    [sym_kUses] = ACTIONS(340),
    [sym_kInterface] = ACTIONS(340),
    [sym_kImplementation] = ACTIONS(340),
    [sym_kInitialization] = ACTIONS(340),
    [sym_kFinalization] = ACTIONS(340),
    [sym_kBegin] = ACTIONS(340),
    [sym_kEnd] = ACTIONS(340),
    [sym_kAsm] = ACTIONS(340),
    [sym_kVar] = ACTIONS(340),
    [sym_kThreadvar] = ACTIONS(340),
    [sym_kConst] = ACTIONS(340),
    [sym_kResourcestring] = ACTIONS(340),
    [sym_kType] = ACTIONS(340),
    [sym_kLabel] = ACTIONS(340),
    [sym_kExports] = ACTIONS(340),
    [sym_kProperty] = ACTIONS(340),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(340),
    [sym_kGeneric] = ACTIONS(340),
    [sym_kFunction] = ACTIONS(340),
    [sym_kProcedure] = ACTIONS(340),
    [sym_kConstructor] = ACTIONS(340),
    [sym_kDestructor] = ACTIONS(340),
    [sym_kOperator] = ACTIONS(340),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(67),
    [aux_sym_declVar_repeat1] = STATE(67),
    [ts_builtin_sym_end] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LBRACK] = ACTIONS(349),
    [sym_kUses] = ACTIONS(347),
    [sym_kInterface] = ACTIONS(347),
    [sym_kImplementation] = ACTIONS(347),
    [sym_kInitialization] = ACTIONS(347),
    [sym_kFinalization] = ACTIONS(347),
    [sym_kBegin] = ACTIONS(347),
    [sym_kEnd] = ACTIONS(347),
    [sym_kAsm] = ACTIONS(347),
    [sym_kVar] = ACTIONS(347),
    [sym_kThreadvar] = ACTIONS(347),
    [sym_kConst] = ACTIONS(347),
    [sym_kResourcestring] = ACTIONS(347),
    [sym_kType] = ACTIONS(347),
    [sym_kLabel] = ACTIONS(347),
    [sym_kExports] = ACTIONS(347),
    [sym_kProperty] = ACTIONS(347),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(347),
    [sym_kGeneric] = ACTIONS(347),
    [sym_kFunction] = ACTIONS(347),
    [sym_kProcedure] = ACTIONS(347),
    [sym_kConstructor] = ACTIONS(347),
    [sym_kDestructor] = ACTIONS(347),
    [sym_kOperator] = ACTIONS(347),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(83),
    [aux_sym_declVar_repeat1] = STATE(83),
    [ts_builtin_sym_end] = ACTIONS(352),
    [sym_identifier] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(356),
    [sym_kUses] = ACTIONS(354),
    [sym_kInterface] = ACTIONS(354),
    [sym_kImplementation] = ACTIONS(354),
    [sym_kInitialization] = ACTIONS(354),
    [sym_kFinalization] = ACTIONS(354),
    [sym_kBegin] = ACTIONS(354),
    [sym_kEnd] = ACTIONS(354),
    [sym_kAsm] = ACTIONS(354),
    [sym_kVar] = ACTIONS(354),
    [sym_kThreadvar] = ACTIONS(354),
    [sym_kConst] = ACTIONS(354),
    [sym_kResourcestring] = ACTIONS(354),
    [sym_kType] = ACTIONS(354),
    [sym_kLabel] = ACTIONS(354),
    [sym_kExports] = ACTIONS(354),
    [sym_kProperty] = ACTIONS(354),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(354),
    [sym_kGeneric] = ACTIONS(354),
    [sym_kFunction] = ACTIONS(354),
    [sym_kProcedure] = ACTIONS(354),
    [sym_kConstructor] = ACTIONS(354),
    [sym_kDestructor] = ACTIONS(354),
    [sym_kOperator] = ACTIONS(354),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(359),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(363),
    [sym_kUses] = ACTIONS(361),
    [sym_kInterface] = ACTIONS(361),
    [sym_kImplementation] = ACTIONS(361),
    [sym_kInitialization] = ACTIONS(361),
    [sym_kFinalization] = ACTIONS(361),
    [sym_kBegin] = ACTIONS(361),
    [sym_kEnd] = ACTIONS(361),
    [sym_kAsm] = ACTIONS(361),
    [sym_kVar] = ACTIONS(361),
    [sym_kThreadvar] = ACTIONS(361),
    [sym_kConst] = ACTIONS(361),
    [sym_kResourcestring] = ACTIONS(361),
    [sym_kType] = ACTIONS(361),
    [sym_kLabel] = ACTIONS(361),
    [sym_kExports] = ACTIONS(361),
    [sym_kProperty] = ACTIONS(361),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(361),
    [sym_kGeneric] = ACTIONS(361),
    [sym_kFunction] = ACTIONS(361),
    [sym_kProcedure] = ACTIONS(361),
    [sym_kConstructor] = ACTIONS(361),
    [sym_kDestructor] = ACTIONS(361),
    [sym_kOperator] = ACTIONS(361),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(66),
    [aux_sym_declVar_repeat1] = STATE(66),
    [ts_builtin_sym_end] = ACTIONS(366),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(370),
    [sym_kUses] = ACTIONS(368),
    [sym_kInterface] = ACTIONS(368),
    [sym_kImplementation] = ACTIONS(368),
    [sym_kInitialization] = ACTIONS(368),
    [sym_kFinalization] = ACTIONS(368),
    [sym_kBegin] = ACTIONS(368),
    [sym_kEnd] = ACTIONS(368),
    [sym_kAsm] = ACTIONS(368),
    [sym_kVar] = ACTIONS(368),
    [sym_kThreadvar] = ACTIONS(368),
    [sym_kConst] = ACTIONS(368),
    [sym_kResourcestring] = ACTIONS(368),
    [sym_kType] = ACTIONS(368),
    [sym_kLabel] = ACTIONS(368),
    [sym_kExports] = ACTIONS(368),
    [sym_kProperty] = ACTIONS(368),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(368),
    [sym_kGeneric] = ACTIONS(368),
    [sym_kFunction] = ACTIONS(368),
    [sym_kProcedure] = ACTIONS(368),
    [sym_kConstructor] = ACTIONS(368),
    [sym_kDestructor] = ACTIONS(368),
    [sym_kOperator] = ACTIONS(368),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(373),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [sym_kUses] = ACTIONS(375),
    [sym_kInterface] = ACTIONS(375),
    [sym_kImplementation] = ACTIONS(375),
    [sym_kInitialization] = ACTIONS(375),
    [sym_kFinalization] = ACTIONS(375),
    [sym_kBegin] = ACTIONS(375),
    [sym_kEnd] = ACTIONS(375),
    [sym_kAsm] = ACTIONS(375),
    [sym_kVar] = ACTIONS(375),
    [sym_kThreadvar] = ACTIONS(375),
    [sym_kConst] = ACTIONS(375),
    [sym_kResourcestring] = ACTIONS(375),
    [sym_kType] = ACTIONS(375),
    [sym_kLabel] = ACTIONS(375),
    [sym_kExports] = ACTIONS(375),
    [sym_kProperty] = ACTIONS(375),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(375),
    [sym_kGeneric] = ACTIONS(375),
    [sym_kFunction] = ACTIONS(375),
    [sym_kProcedure] = ACTIONS(375),
    [sym_kConstructor] = ACTIONS(375),
    [sym_kDestructor] = ACTIONS(375),
    [sym_kOperator] = ACTIONS(375),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(384),
    [sym_kUses] = ACTIONS(382),
    [sym_kInterface] = ACTIONS(382),
    [sym_kImplementation] = ACTIONS(382),
    [sym_kInitialization] = ACTIONS(382),
    [sym_kFinalization] = ACTIONS(382),
    [sym_kBegin] = ACTIONS(382),
    [sym_kEnd] = ACTIONS(382),
    [sym_kAsm] = ACTIONS(382),
    [sym_kVar] = ACTIONS(382),
    [sym_kThreadvar] = ACTIONS(382),
    [sym_kConst] = ACTIONS(382),
    [sym_kResourcestring] = ACTIONS(382),
    [sym_kType] = ACTIONS(382),
    [sym_kLabel] = ACTIONS(382),
    [sym_kExports] = ACTIONS(382),
    [sym_kProperty] = ACTIONS(382),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(382),
    [sym_kGeneric] = ACTIONS(382),
    [sym_kFunction] = ACTIONS(382),
    [sym_kProcedure] = ACTIONS(382),
    [sym_kConstructor] = ACTIONS(382),
    [sym_kDestructor] = ACTIONS(382),
    [sym_kOperator] = ACTIONS(382),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(73),
    [aux_sym_declVar_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_LBRACK] = ACTIONS(391),
    [sym_kUses] = ACTIONS(389),
    [sym_kInterface] = ACTIONS(389),
    [sym_kImplementation] = ACTIONS(389),
    [sym_kInitialization] = ACTIONS(389),
    [sym_kFinalization] = ACTIONS(389),
    [sym_kBegin] = ACTIONS(389),
    [sym_kEnd] = ACTIONS(389),
    [sym_kAsm] = ACTIONS(389),
    [sym_kVar] = ACTIONS(389),
    [sym_kThreadvar] = ACTIONS(389),
    [sym_kConst] = ACTIONS(389),
    [sym_kResourcestring] = ACTIONS(389),
    [sym_kType] = ACTIONS(389),
    [sym_kLabel] = ACTIONS(389),
    [sym_kExports] = ACTIONS(389),
    [sym_kProperty] = ACTIONS(389),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(389),
    [sym_kGeneric] = ACTIONS(389),
    [sym_kFunction] = ACTIONS(389),
    [sym_kProcedure] = ACTIONS(389),
    [sym_kConstructor] = ACTIONS(389),
    [sym_kDestructor] = ACTIONS(389),
    [sym_kOperator] = ACTIONS(389),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(394),
    [sym_identifier] = ACTIONS(396),
    [anon_sym_LBRACK] = ACTIONS(398),
    [sym_kUses] = ACTIONS(396),
    [sym_kInterface] = ACTIONS(396),
    [sym_kImplementation] = ACTIONS(396),
    [sym_kInitialization] = ACTIONS(396),
    [sym_kFinalization] = ACTIONS(396),
    [sym_kBegin] = ACTIONS(396),
    [sym_kEnd] = ACTIONS(396),
    [sym_kAsm] = ACTIONS(396),
    [sym_kVar] = ACTIONS(396),
    [sym_kThreadvar] = ACTIONS(396),
    [sym_kConst] = ACTIONS(396),
    [sym_kResourcestring] = ACTIONS(396),
    [sym_kType] = ACTIONS(396),
    [sym_kLabel] = ACTIONS(396),
    [sym_kExports] = ACTIONS(396),
    [sym_kProperty] = ACTIONS(396),
    [sym_kDefault] = ACTIONS(401),
    [sym_kNodefault] = ACTIONS(401),
    [sym_kClass] = ACTIONS(396),
    [sym_kGeneric] = ACTIONS(396),
    [sym_kFunction] = ACTIONS(396),
    [sym_kProcedure] = ACTIONS(396),
    [sym_kConstructor] = ACTIONS(396),
    [sym_kDestructor] = ACTIONS(396),
    [sym_kOperator] = ACTIONS(396),
    [sym_kPublic] = ACTIONS(404),
    [sym_kStatic] = ACTIONS(401),
    [sym_kVirtual] = ACTIONS(401),
    [sym_kAbstract] = ACTIONS(401),
    [sym_kDynamic] = ACTIONS(401),
    [sym_kOverride] = ACTIONS(401),
    [sym_kOverload] = ACTIONS(401),
    [sym_kReintroduce] = ACTIONS(401),
    [sym_kInline] = ACTIONS(401),
    [sym_kStdcall] = ACTIONS(401),
    [sym_kCdecl] = ACTIONS(401),
    [sym_kCppdecl] = ACTIONS(401),
    [sym_kPascal] = ACTIONS(401),
    [sym_kRegister] = ACTIONS(401),
    [sym_kMwpascal] = ACTIONS(401),
    [sym_kExternal] = ACTIONS(407),
    [sym_kMessage] = ACTIONS(410),
    [sym_kDeprecated] = ACTIONS(413),
    [sym_kExperimental] = ACTIONS(401),
    [sym_kPlatform] = ACTIONS(401),
    [sym_kUnimplemented] = ACTIONS(401),
    [sym_kCvar] = ACTIONS(401),
    [sym_kExport] = ACTIONS(416),
    [sym_kFar] = ACTIONS(401),
    [sym_kNear] = ACTIONS(401),
    [sym_kSafecall] = ACTIONS(401),
    [sym_kAssembler] = ACTIONS(401),
    [sym_kNostackframe] = ACTIONS(401),
    [sym_kInterrupt] = ACTIONS(401),
    [sym_kNoreturn] = ACTIONS(401),
    [sym_kIocheck] = ACTIONS(401),
    [sym_kLocal] = ACTIONS(401),
    [sym_kHardfloat] = ACTIONS(401),
    [sym_kSoftfloat] = ACTIONS(401),
    [sym_kMs_abi_default] = ACTIONS(401),
    [sym_kMs_abi_cdecl] = ACTIONS(401),
    [sym_kSaveregisters] = ACTIONS(401),
    [sym_kSysv_abi_default] = ACTIONS(401),
    [sym_kSysv_abi_cdecl] = ACTIONS(401),
    [sym_kVectorcall] = ACTIONS(401),
    [sym_kVarargs] = ACTIONS(401),
    [sym_kWinapi] = ACTIONS(401),
    [sym_kAlias] = ACTIONS(419),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(422),
    [sym_identifier] = ACTIONS(424),
    [anon_sym_LBRACK] = ACTIONS(426),
    [sym_kUses] = ACTIONS(424),
    [sym_kInterface] = ACTIONS(424),
    [sym_kImplementation] = ACTIONS(424),
    [sym_kInitialization] = ACTIONS(424),
    [sym_kFinalization] = ACTIONS(424),
    [sym_kBegin] = ACTIONS(424),
    [sym_kEnd] = ACTIONS(424),
    [sym_kAsm] = ACTIONS(424),
    [sym_kVar] = ACTIONS(424),
    [sym_kThreadvar] = ACTIONS(424),
    [sym_kConst] = ACTIONS(424),
    [sym_kResourcestring] = ACTIONS(424),
    [sym_kType] = ACTIONS(424),
    [sym_kLabel] = ACTIONS(424),
    [sym_kExports] = ACTIONS(424),
    [sym_kProperty] = ACTIONS(424),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(424),
    [sym_kGeneric] = ACTIONS(424),
    [sym_kFunction] = ACTIONS(424),
    [sym_kProcedure] = ACTIONS(424),
    [sym_kConstructor] = ACTIONS(424),
    [sym_kDestructor] = ACTIONS(424),
    [sym_kOperator] = ACTIONS(424),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(87),
    [aux_sym_declVar_repeat1] = STATE(87),
    [ts_builtin_sym_end] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(433),
    [sym_kUses] = ACTIONS(431),
    [sym_kInterface] = ACTIONS(431),
    [sym_kImplementation] = ACTIONS(431),
    [sym_kInitialization] = ACTIONS(431),
    [sym_kFinalization] = ACTIONS(431),
    [sym_kBegin] = ACTIONS(431),
    [sym_kEnd] = ACTIONS(431),
    [sym_kAsm] = ACTIONS(431),
    [sym_kVar] = ACTIONS(431),
    [sym_kThreadvar] = ACTIONS(431),
    [sym_kConst] = ACTIONS(431),
    [sym_kResourcestring] = ACTIONS(431),
    [sym_kType] = ACTIONS(431),
    [sym_kLabel] = ACTIONS(431),
    [sym_kExports] = ACTIONS(431),
    [sym_kProperty] = ACTIONS(431),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(431),
    [sym_kGeneric] = ACTIONS(431),
    [sym_kFunction] = ACTIONS(431),
    [sym_kProcedure] = ACTIONS(431),
    [sym_kConstructor] = ACTIONS(431),
    [sym_kDestructor] = ACTIONS(431),
    [sym_kOperator] = ACTIONS(431),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(84),
    [aux_sym_declVar_repeat1] = STATE(84),
    [ts_builtin_sym_end] = ACTIONS(436),
    [sym_identifier] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_kUses] = ACTIONS(438),
    [sym_kInterface] = ACTIONS(438),
    [sym_kImplementation] = ACTIONS(438),
    [sym_kInitialization] = ACTIONS(438),
    [sym_kFinalization] = ACTIONS(438),
    [sym_kBegin] = ACTIONS(438),
    [sym_kEnd] = ACTIONS(438),
    [sym_kAsm] = ACTIONS(438),
    [sym_kVar] = ACTIONS(438),
    [sym_kThreadvar] = ACTIONS(438),
    [sym_kConst] = ACTIONS(438),
    [sym_kResourcestring] = ACTIONS(438),
    [sym_kType] = ACTIONS(438),
    [sym_kLabel] = ACTIONS(438),
    [sym_kExports] = ACTIONS(438),
    [sym_kProperty] = ACTIONS(438),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(438),
    [sym_kGeneric] = ACTIONS(438),
    [sym_kFunction] = ACTIONS(438),
    [sym_kProcedure] = ACTIONS(438),
    [sym_kConstructor] = ACTIONS(438),
    [sym_kDestructor] = ACTIONS(438),
    [sym_kOperator] = ACTIONS(438),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(443),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(447),
    [sym_kUses] = ACTIONS(445),
    [sym_kInterface] = ACTIONS(445),
    [sym_kImplementation] = ACTIONS(445),
    [sym_kInitialization] = ACTIONS(445),
    [sym_kFinalization] = ACTIONS(445),
    [sym_kBegin] = ACTIONS(445),
    [sym_kEnd] = ACTIONS(445),
    [sym_kAsm] = ACTIONS(445),
    [sym_kVar] = ACTIONS(445),
    [sym_kThreadvar] = ACTIONS(445),
    [sym_kConst] = ACTIONS(445),
    [sym_kResourcestring] = ACTIONS(445),
    [sym_kType] = ACTIONS(445),
    [sym_kLabel] = ACTIONS(445),
    [sym_kExports] = ACTIONS(445),
    [sym_kProperty] = ACTIONS(445),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(445),
    [sym_kGeneric] = ACTIONS(445),
    [sym_kFunction] = ACTIONS(445),
    [sym_kProcedure] = ACTIONS(445),
    [sym_kConstructor] = ACTIONS(445),
    [sym_kDestructor] = ACTIONS(445),
    [sym_kOperator] = ACTIONS(445),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(450),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(454),
    [sym_kUses] = ACTIONS(452),
    [sym_kInterface] = ACTIONS(452),
    [sym_kImplementation] = ACTIONS(452),
    [sym_kInitialization] = ACTIONS(452),
    [sym_kFinalization] = ACTIONS(452),
    [sym_kBegin] = ACTIONS(452),
    [sym_kEnd] = ACTIONS(452),
    [sym_kAsm] = ACTIONS(452),
    [sym_kVar] = ACTIONS(452),
    [sym_kThreadvar] = ACTIONS(452),
    [sym_kConst] = ACTIONS(452),
    [sym_kResourcestring] = ACTIONS(452),
    [sym_kType] = ACTIONS(452),
    [sym_kLabel] = ACTIONS(452),
    [sym_kExports] = ACTIONS(452),
    [sym_kProperty] = ACTIONS(452),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(452),
    [sym_kGeneric] = ACTIONS(452),
    [sym_kFunction] = ACTIONS(452),
    [sym_kProcedure] = ACTIONS(452),
    [sym_kConstructor] = ACTIONS(452),
    [sym_kDestructor] = ACTIONS(452),
    [sym_kOperator] = ACTIONS(452),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(457),
    [sym_identifier] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(461),
    [sym_kUses] = ACTIONS(459),
    [sym_kInterface] = ACTIONS(459),
    [sym_kImplementation] = ACTIONS(459),
    [sym_kInitialization] = ACTIONS(459),
    [sym_kFinalization] = ACTIONS(459),
    [sym_kBegin] = ACTIONS(459),
    [sym_kEnd] = ACTIONS(459),
    [sym_kAsm] = ACTIONS(459),
    [sym_kVar] = ACTIONS(459),
    [sym_kThreadvar] = ACTIONS(459),
    [sym_kConst] = ACTIONS(459),
    [sym_kResourcestring] = ACTIONS(459),
    [sym_kType] = ACTIONS(459),
    [sym_kLabel] = ACTIONS(459),
    [sym_kExports] = ACTIONS(459),
    [sym_kProperty] = ACTIONS(459),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(459),
    [sym_kGeneric] = ACTIONS(459),
    [sym_kFunction] = ACTIONS(459),
    [sym_kProcedure] = ACTIONS(459),
    [sym_kConstructor] = ACTIONS(459),
    [sym_kDestructor] = ACTIONS(459),
    [sym_kOperator] = ACTIONS(459),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(65),
    [aux_sym_declVar_repeat1] = STATE(65),
    [ts_builtin_sym_end] = ACTIONS(464),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [sym_kUses] = ACTIONS(466),
    [sym_kInterface] = ACTIONS(466),
    [sym_kImplementation] = ACTIONS(466),
    [sym_kInitialization] = ACTIONS(466),
    [sym_kFinalization] = ACTIONS(466),
    [sym_kBegin] = ACTIONS(466),
    [sym_kEnd] = ACTIONS(466),
    [sym_kAsm] = ACTIONS(466),
    [sym_kVar] = ACTIONS(466),
    [sym_kThreadvar] = ACTIONS(466),
    [sym_kConst] = ACTIONS(466),
    [sym_kResourcestring] = ACTIONS(466),
    [sym_kType] = ACTIONS(466),
    [sym_kLabel] = ACTIONS(466),
    [sym_kExports] = ACTIONS(466),
    [sym_kProperty] = ACTIONS(466),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(466),
    [sym_kGeneric] = ACTIONS(466),
    [sym_kFunction] = ACTIONS(466),
    [sym_kProcedure] = ACTIONS(466),
    [sym_kConstructor] = ACTIONS(466),
    [sym_kDestructor] = ACTIONS(466),
    [sym_kOperator] = ACTIONS(466),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(70),
    [aux_sym_declVar_repeat1] = STATE(70),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(475),
    [sym_kUses] = ACTIONS(473),
    [sym_kInterface] = ACTIONS(473),
    [sym_kImplementation] = ACTIONS(473),
    [sym_kInitialization] = ACTIONS(473),
    [sym_kFinalization] = ACTIONS(473),
    [sym_kBegin] = ACTIONS(473),
    [sym_kEnd] = ACTIONS(473),
    [sym_kAsm] = ACTIONS(473),
    [sym_kVar] = ACTIONS(473),
    [sym_kThreadvar] = ACTIONS(473),
    [sym_kConst] = ACTIONS(473),
    [sym_kResourcestring] = ACTIONS(473),
    [sym_kType] = ACTIONS(473),
    [sym_kLabel] = ACTIONS(473),
    [sym_kExports] = ACTIONS(473),
    [sym_kProperty] = ACTIONS(473),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(473),
    [sym_kGeneric] = ACTIONS(473),
    [sym_kFunction] = ACTIONS(473),
    [sym_kProcedure] = ACTIONS(473),
    [sym_kConstructor] = ACTIONS(473),
    [sym_kDestructor] = ACTIONS(473),
    [sym_kOperator] = ACTIONS(473),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(78),
    [aux_sym_declVar_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(478),
    [sym_identifier] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(482),
    [sym_kUses] = ACTIONS(480),
    [sym_kInterface] = ACTIONS(480),
    [sym_kImplementation] = ACTIONS(480),
    [sym_kInitialization] = ACTIONS(480),
    [sym_kFinalization] = ACTIONS(480),
    [sym_kBegin] = ACTIONS(480),
    [sym_kEnd] = ACTIONS(480),
    [sym_kAsm] = ACTIONS(480),
    [sym_kVar] = ACTIONS(480),
    [sym_kThreadvar] = ACTIONS(480),
    [sym_kConst] = ACTIONS(480),
    [sym_kResourcestring] = ACTIONS(480),
    [sym_kType] = ACTIONS(480),
    [sym_kLabel] = ACTIONS(480),
    [sym_kExports] = ACTIONS(480),
    [sym_kProperty] = ACTIONS(480),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(480),
    [sym_kGeneric] = ACTIONS(480),
    [sym_kFunction] = ACTIONS(480),
    [sym_kProcedure] = ACTIONS(480),
    [sym_kConstructor] = ACTIONS(480),
    [sym_kDestructor] = ACTIONS(480),
    [sym_kOperator] = ACTIONS(480),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(76),
    [aux_sym_declVar_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(485),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [sym_kUses] = ACTIONS(487),
    [sym_kInterface] = ACTIONS(487),
    [sym_kImplementation] = ACTIONS(487),
    [sym_kInitialization] = ACTIONS(487),
    [sym_kFinalization] = ACTIONS(487),
    [sym_kBegin] = ACTIONS(487),
    [sym_kEnd] = ACTIONS(487),
    [sym_kAsm] = ACTIONS(487),
    [sym_kVar] = ACTIONS(487),
    [sym_kThreadvar] = ACTIONS(487),
    [sym_kConst] = ACTIONS(487),
    [sym_kResourcestring] = ACTIONS(487),
    [sym_kType] = ACTIONS(487),
    [sym_kLabel] = ACTIONS(487),
    [sym_kExports] = ACTIONS(487),
    [sym_kProperty] = ACTIONS(487),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(487),
    [sym_kGeneric] = ACTIONS(487),
    [sym_kFunction] = ACTIONS(487),
    [sym_kProcedure] = ACTIONS(487),
    [sym_kConstructor] = ACTIONS(487),
    [sym_kDestructor] = ACTIONS(487),
    [sym_kOperator] = ACTIONS(487),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym__procAttribute] = STATE(194),
    [sym_procAttribute] = STATE(2407),
    [sym_procExternal] = STATE(75),
    [aux_sym_declVar_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(492),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(496),
    [sym_kUses] = ACTIONS(494),
    [sym_kInterface] = ACTIONS(494),
    [sym_kImplementation] = ACTIONS(494),
    [sym_kInitialization] = ACTIONS(494),
    [sym_kFinalization] = ACTIONS(494),
    [sym_kBegin] = ACTIONS(494),
    [sym_kEnd] = ACTIONS(494),
    [sym_kAsm] = ACTIONS(494),
    [sym_kVar] = ACTIONS(494),
    [sym_kThreadvar] = ACTIONS(494),
    [sym_kConst] = ACTIONS(494),
    [sym_kResourcestring] = ACTIONS(494),
    [sym_kType] = ACTIONS(494),
    [sym_kLabel] = ACTIONS(494),
    [sym_kExports] = ACTIONS(494),
    [sym_kProperty] = ACTIONS(494),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(494),
    [sym_kGeneric] = ACTIONS(494),
    [sym_kFunction] = ACTIONS(494),
    [sym_kProcedure] = ACTIONS(494),
    [sym_kConstructor] = ACTIONS(494),
    [sym_kDestructor] = ACTIONS(494),
    [sym_kOperator] = ACTIONS(494),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(300),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kInterface] = ACTIONS(261),
    [sym_kImplementation] = ACTIONS(261),
    [sym_kInitialization] = ACTIONS(261),
    [sym_kFinalization] = ACTIONS(261),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(261),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(263),
    [sym_kAssign] = ACTIONS(263),
    [sym_kAssignAdd] = ACTIONS(263),
    [sym_kAssignSub] = ACTIONS(263),
    [sym_kAssignMul] = ACTIONS(263),
    [sym_kAssignDiv] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kElse] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym__expr] = STATE(930),
    [sym__ref] = STATE(923),
    [sym_lambda] = STATE(923),
    [sym_inherited] = STATE(923),
    [sym_exprDot] = STATE(923),
    [sym_exprDeref] = STATE(923),
    [sym_exprAs] = STATE(923),
    [sym_exprTpl] = STATE(923),
    [sym_exprSubscript] = STATE(923),
    [sym_exprCall] = STATE(923),
    [sym_exprBinary] = STATE(930),
    [sym_exprUnary] = STATE(930),
    [sym_exprParens] = STATE(923),
    [sym_exprBrackets] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_literalString] = STATE(923),
    [sym__literalString] = STATE(783),
    [sym_literalChar] = STATE(783),
    [sym_literalNumber] = STATE(923),
    [sym__literalInt] = STATE(956),
    [sym__literalFloat] = STATE(956),
    [aux_sym_literalString_repeat1] = STATE(783),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(109),
    [anon_sym_POUND] = ACTIONS(111),
    [aux_sym__literalInt_token1] = ACTIONS(113),
    [aux_sym__literalInt_token2] = ACTIONS(115),
    [aux_sym__literalFloat_token1] = ACTIONS(113),
    [sym_kInterface] = ACTIONS(261),
    [sym_kImplementation] = ACTIONS(261),
    [sym_kInitialization] = ACTIONS(261),
    [sym_kFinalization] = ACTIONS(261),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kEnd] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(119),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(261),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(123),
    [sym_kHat] = ACTIONS(263),
    [sym_kAssign] = ACTIONS(263),
    [sym_kAssignAdd] = ACTIONS(263),
    [sym_kAssignSub] = ACTIONS(263),
    [sym_kAssignMul] = ACTIONS(263),
    [sym_kAssignDiv] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(121),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kElse] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(137),
    [sym_kProcedure] = ACTIONS(137),
    [sym_kInherited] = ACTIONS(139),
    [sym_kNil] = ACTIONS(141),
    [sym_kTrue] = ACTIONS(141),
    [sym_kFalse] = ACTIONS(141),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(92),
    [sym_while] = STATE(92),
    [sym_repeat] = STATE(92),
    [sym_for] = STATE(92),
    [sym_foreach] = STATE(92),
    [sym_try] = STATE(92),
    [sym_case] = STATE(92),
    [sym_block] = STATE(92),
    [sym_asm] = STATE(92),
    [sym_with] = STATE(92),
    [sym_raise] = STATE(92),
    [sym_statement] = STATE(92),
    [sym_goto] = STATE(92),
    [sym__statement] = STATE(92),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym_label] = STATE(92),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym__statementsTr_repeat1] = STATE(92),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(508),
    [aux_sym__literalString_token1] = ACTIONS(511),
    [anon_sym_POUND] = ACTIONS(514),
    [aux_sym__literalInt_token1] = ACTIONS(517),
    [aux_sym__literalInt_token2] = ACTIONS(520),
    [aux_sym__literalFloat_token1] = ACTIONS(517),
    [sym_kBegin] = ACTIONS(523),
    [sym_kAsm] = ACTIONS(526),
    [sym_kVar] = ACTIONS(529),
    [sym_kSpecialize] = ACTIONS(532),
    [sym_kAdd] = ACTIONS(535),
    [sym_kSub] = ACTIONS(535),
    [sym_kAt] = ACTIONS(538),
    [sym_kNot] = ACTIONS(535),
    [sym_kFor] = ACTIONS(541),
    [sym_kIf] = ACTIONS(544),
    [sym_kWhile] = ACTIONS(547),
    [sym_kRepeat] = ACTIONS(550),
    [sym_kTry] = ACTIONS(553),
    [sym_kRaise] = ACTIONS(556),
    [sym_kCase] = ACTIONS(559),
    [sym_kWith] = ACTIONS(562),
    [sym_kGoto] = ACTIONS(565),
    [sym_kFunction] = ACTIONS(568),
    [sym_kProcedure] = ACTIONS(568),
    [sym_kInherited] = ACTIONS(571),
    [sym_kNil] = ACTIONS(574),
    [sym_kTrue] = ACTIONS(574),
    [sym_kFalse] = ACTIONS(574),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kInterface] = ACTIONS(279),
    [sym_kImplementation] = ACTIONS(279),
    [sym_kInitialization] = ACTIONS(279),
    [sym_kFinalization] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(279),
    [sym_kEnd] = ACTIONS(279),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(279),
    [sym_kEq] = ACTIONS(281),
    [sym_kNeq] = ACTIONS(281),
    [sym_kGt] = ACTIONS(279),
    [sym_kLte] = ACTIONS(281),
    [sym_kGte] = ACTIONS(281),
    [sym_kAdd] = ACTIONS(279),
    [sym_kSub] = ACTIONS(279),
    [sym_kMul] = ACTIONS(279),
    [sym_kFdiv] = ACTIONS(279),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(281),
    [sym_kAssign] = ACTIONS(281),
    [sym_kAssignAdd] = ACTIONS(281),
    [sym_kAssignSub] = ACTIONS(281),
    [sym_kAssignMul] = ACTIONS(281),
    [sym_kAssignDiv] = ACTIONS(281),
    [sym_kOr] = ACTIONS(279),
    [sym_kXor] = ACTIONS(279),
    [sym_kDiv] = ACTIONS(279),
    [sym_kMod] = ACTIONS(279),
    [sym_kAnd] = ACTIONS(279),
    [sym_kShl] = ACTIONS(279),
    [sym_kShr] = ACTIONS(279),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(279),
    [sym_kAs] = ACTIONS(279),
    [sym_kIn] = ACTIONS(279),
    [sym_kElse] = ACTIONS(279),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1063),
    [sym_while] = STATE(1063),
    [sym_repeat] = STATE(1063),
    [sym_for] = STATE(1063),
    [sym_foreach] = STATE(1063),
    [sym_try] = STATE(1063),
    [sym_case] = STATE(1063),
    [sym_block] = STATE(1063),
    [sym_asm] = STATE(1063),
    [sym_with] = STATE(1063),
    [sym_raise] = STATE(1063),
    [sym_statement] = STATE(1063),
    [sym_goto] = STATE(1063),
    [sym__statement] = STATE(1063),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_exceptionElse_repeat1] = STATE(115),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(601),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(605),
    [sym_kUses] = ACTIONS(603),
    [sym_kInterface] = ACTIONS(603),
    [sym_kImplementation] = ACTIONS(603),
    [sym_kInitialization] = ACTIONS(603),
    [sym_kFinalization] = ACTIONS(603),
    [sym_kBegin] = ACTIONS(603),
    [sym_kEnd] = ACTIONS(603),
    [sym_kAsm] = ACTIONS(603),
    [sym_kVar] = ACTIONS(603),
    [sym_kThreadvar] = ACTIONS(603),
    [sym_kConst] = ACTIONS(603),
    [sym_kResourcestring] = ACTIONS(603),
    [sym_kType] = ACTIONS(603),
    [sym_kLabel] = ACTIONS(603),
    [sym_kExports] = ACTIONS(603),
    [sym_kProperty] = ACTIONS(603),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(603),
    [sym_kGeneric] = ACTIONS(603),
    [sym_kFunction] = ACTIONS(603),
    [sym_kProcedure] = ACTIONS(603),
    [sym_kConstructor] = ACTIONS(603),
    [sym_kDestructor] = ACTIONS(603),
    [sym_kOperator] = ACTIONS(603),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(608),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [sym_kUses] = ACTIONS(610),
    [sym_kInterface] = ACTIONS(610),
    [sym_kImplementation] = ACTIONS(610),
    [sym_kInitialization] = ACTIONS(610),
    [sym_kFinalization] = ACTIONS(610),
    [sym_kBegin] = ACTIONS(610),
    [sym_kEnd] = ACTIONS(610),
    [sym_kAsm] = ACTIONS(610),
    [sym_kVar] = ACTIONS(610),
    [sym_kThreadvar] = ACTIONS(610),
    [sym_kConst] = ACTIONS(610),
    [sym_kResourcestring] = ACTIONS(610),
    [sym_kType] = ACTIONS(610),
    [sym_kLabel] = ACTIONS(610),
    [sym_kExports] = ACTIONS(610),
    [sym_kProperty] = ACTIONS(610),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(610),
    [sym_kGeneric] = ACTIONS(610),
    [sym_kFunction] = ACTIONS(610),
    [sym_kProcedure] = ACTIONS(610),
    [sym_kConstructor] = ACTIONS(610),
    [sym_kDestructor] = ACTIONS(610),
    [sym_kOperator] = ACTIONS(610),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_identifier] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(619),
    [sym_kUses] = ACTIONS(617),
    [sym_kInterface] = ACTIONS(617),
    [sym_kImplementation] = ACTIONS(617),
    [sym_kInitialization] = ACTIONS(617),
    [sym_kFinalization] = ACTIONS(617),
    [sym_kBegin] = ACTIONS(617),
    [sym_kEnd] = ACTIONS(617),
    [sym_kAsm] = ACTIONS(617),
    [sym_kVar] = ACTIONS(617),
    [sym_kThreadvar] = ACTIONS(617),
    [sym_kConst] = ACTIONS(617),
    [sym_kResourcestring] = ACTIONS(617),
    [sym_kType] = ACTIONS(617),
    [sym_kLabel] = ACTIONS(617),
    [sym_kExports] = ACTIONS(617),
    [sym_kProperty] = ACTIONS(617),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(617),
    [sym_kGeneric] = ACTIONS(617),
    [sym_kFunction] = ACTIONS(617),
    [sym_kProcedure] = ACTIONS(617),
    [sym_kConstructor] = ACTIONS(617),
    [sym_kDestructor] = ACTIONS(617),
    [sym_kOperator] = ACTIONS(617),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(622),
    [sym_identifier] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(622),
    [anon_sym_RBRACK] = ACTIONS(622),
    [sym_kUses] = ACTIONS(624),
    [sym_kInterface] = ACTIONS(624),
    [sym_kImplementation] = ACTIONS(624),
    [sym_kInitialization] = ACTIONS(624),
    [sym_kFinalization] = ACTIONS(624),
    [sym_kBegin] = ACTIONS(624),
    [sym_kEnd] = ACTIONS(624),
    [sym_kAsm] = ACTIONS(624),
    [sym_kVar] = ACTIONS(624),
    [sym_kThreadvar] = ACTIONS(624),
    [sym_kConst] = ACTIONS(624),
    [sym_kResourcestring] = ACTIONS(624),
    [sym_kType] = ACTIONS(624),
    [sym_kLabel] = ACTIONS(624),
    [sym_kExports] = ACTIONS(624),
    [sym_kProperty] = ACTIONS(624),
    [sym_kDefault] = ACTIONS(624),
    [sym_kNodefault] = ACTIONS(624),
    [sym_kClass] = ACTIONS(624),
    [sym_kGeneric] = ACTIONS(624),
    [sym_kFunction] = ACTIONS(624),
    [sym_kProcedure] = ACTIONS(624),
    [sym_kConstructor] = ACTIONS(624),
    [sym_kDestructor] = ACTIONS(624),
    [sym_kOperator] = ACTIONS(624),
    [sym_kPublic] = ACTIONS(624),
    [sym_kStatic] = ACTIONS(624),
    [sym_kVirtual] = ACTIONS(624),
    [sym_kAbstract] = ACTIONS(624),
    [sym_kDynamic] = ACTIONS(624),
    [sym_kOverride] = ACTIONS(624),
    [sym_kOverload] = ACTIONS(624),
    [sym_kReintroduce] = ACTIONS(624),
    [sym_kInline] = ACTIONS(624),
    [sym_kStdcall] = ACTIONS(624),
    [sym_kCdecl] = ACTIONS(624),
    [sym_kCppdecl] = ACTIONS(624),
    [sym_kPascal] = ACTIONS(624),
    [sym_kRegister] = ACTIONS(624),
    [sym_kMwpascal] = ACTIONS(624),
    [sym_kExternal] = ACTIONS(624),
    [sym_kMessage] = ACTIONS(624),
    [sym_kDeprecated] = ACTIONS(624),
    [sym_kExperimental] = ACTIONS(624),
    [sym_kPlatform] = ACTIONS(624),
    [sym_kUnimplemented] = ACTIONS(624),
    [sym_kCvar] = ACTIONS(624),
    [sym_kExport] = ACTIONS(624),
    [sym_kFar] = ACTIONS(624),
    [sym_kNear] = ACTIONS(624),
    [sym_kSafecall] = ACTIONS(624),
    [sym_kAssembler] = ACTIONS(624),
    [sym_kNostackframe] = ACTIONS(624),
    [sym_kInterrupt] = ACTIONS(624),
    [sym_kNoreturn] = ACTIONS(624),
    [sym_kIocheck] = ACTIONS(624),
    [sym_kLocal] = ACTIONS(624),
    [sym_kHardfloat] = ACTIONS(624),
    [sym_kSoftfloat] = ACTIONS(624),
    [sym_kMs_abi_default] = ACTIONS(624),
    [sym_kMs_abi_cdecl] = ACTIONS(624),
    [sym_kSaveregisters] = ACTIONS(624),
    [sym_kSysv_abi_default] = ACTIONS(624),
    [sym_kSysv_abi_cdecl] = ACTIONS(624),
    [sym_kVectorcall] = ACTIONS(624),
    [sym_kVarargs] = ACTIONS(624),
    [sym_kWinapi] = ACTIONS(624),
    [sym_kAlias] = ACTIONS(624),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(626),
    [sym_identifier] = ACTIONS(628),
    [anon_sym_LBRACK] = ACTIONS(630),
    [sym_kUses] = ACTIONS(628),
    [sym_kInterface] = ACTIONS(628),
    [sym_kImplementation] = ACTIONS(628),
    [sym_kInitialization] = ACTIONS(628),
    [sym_kFinalization] = ACTIONS(628),
    [sym_kBegin] = ACTIONS(628),
    [sym_kEnd] = ACTIONS(628),
    [sym_kAsm] = ACTIONS(628),
    [sym_kVar] = ACTIONS(628),
    [sym_kThreadvar] = ACTIONS(628),
    [sym_kConst] = ACTIONS(628),
    [sym_kResourcestring] = ACTIONS(628),
    [sym_kType] = ACTIONS(628),
    [sym_kLabel] = ACTIONS(628),
    [sym_kExports] = ACTIONS(628),
    [sym_kProperty] = ACTIONS(628),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(628),
    [sym_kGeneric] = ACTIONS(628),
    [sym_kFunction] = ACTIONS(628),
    [sym_kProcedure] = ACTIONS(628),
    [sym_kConstructor] = ACTIONS(628),
    [sym_kDestructor] = ACTIONS(628),
    [sym_kOperator] = ACTIONS(628),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(633),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [sym_kUses] = ACTIONS(635),
    [sym_kInterface] = ACTIONS(635),
    [sym_kImplementation] = ACTIONS(635),
    [sym_kInitialization] = ACTIONS(635),
    [sym_kFinalization] = ACTIONS(635),
    [sym_kBegin] = ACTIONS(635),
    [sym_kEnd] = ACTIONS(635),
    [sym_kAsm] = ACTIONS(635),
    [sym_kVar] = ACTIONS(635),
    [sym_kThreadvar] = ACTIONS(635),
    [sym_kConst] = ACTIONS(635),
    [sym_kResourcestring] = ACTIONS(635),
    [sym_kType] = ACTIONS(635),
    [sym_kLabel] = ACTIONS(635),
    [sym_kExports] = ACTIONS(635),
    [sym_kProperty] = ACTIONS(635),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(635),
    [sym_kGeneric] = ACTIONS(635),
    [sym_kFunction] = ACTIONS(635),
    [sym_kProcedure] = ACTIONS(635),
    [sym_kConstructor] = ACTIONS(635),
    [sym_kDestructor] = ACTIONS(635),
    [sym_kOperator] = ACTIONS(635),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [sym_kUses] = ACTIONS(642),
    [sym_kInterface] = ACTIONS(642),
    [sym_kImplementation] = ACTIONS(642),
    [sym_kInitialization] = ACTIONS(642),
    [sym_kFinalization] = ACTIONS(642),
    [sym_kBegin] = ACTIONS(642),
    [sym_kEnd] = ACTIONS(642),
    [sym_kAsm] = ACTIONS(642),
    [sym_kVar] = ACTIONS(642),
    [sym_kThreadvar] = ACTIONS(642),
    [sym_kConst] = ACTIONS(642),
    [sym_kResourcestring] = ACTIONS(642),
    [sym_kType] = ACTIONS(642),
    [sym_kLabel] = ACTIONS(642),
    [sym_kExports] = ACTIONS(642),
    [sym_kProperty] = ACTIONS(642),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(642),
    [sym_kGeneric] = ACTIONS(642),
    [sym_kFunction] = ACTIONS(642),
    [sym_kProcedure] = ACTIONS(642),
    [sym_kConstructor] = ACTIONS(642),
    [sym_kDestructor] = ACTIONS(642),
    [sym_kOperator] = ACTIONS(642),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(647),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(651),
    [sym_kUses] = ACTIONS(649),
    [sym_kInterface] = ACTIONS(649),
    [sym_kImplementation] = ACTIONS(649),
    [sym_kInitialization] = ACTIONS(649),
    [sym_kFinalization] = ACTIONS(649),
    [sym_kBegin] = ACTIONS(649),
    [sym_kEnd] = ACTIONS(649),
    [sym_kAsm] = ACTIONS(649),
    [sym_kVar] = ACTIONS(649),
    [sym_kThreadvar] = ACTIONS(649),
    [sym_kConst] = ACTIONS(649),
    [sym_kResourcestring] = ACTIONS(649),
    [sym_kType] = ACTIONS(649),
    [sym_kLabel] = ACTIONS(649),
    [sym_kExports] = ACTIONS(649),
    [sym_kProperty] = ACTIONS(649),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(649),
    [sym_kGeneric] = ACTIONS(649),
    [sym_kFunction] = ACTIONS(649),
    [sym_kProcedure] = ACTIONS(649),
    [sym_kConstructor] = ACTIONS(649),
    [sym_kDestructor] = ACTIONS(649),
    [sym_kOperator] = ACTIONS(649),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(105),
    [ts_builtin_sym_end] = ACTIONS(654),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [sym_kUses] = ACTIONS(656),
    [sym_kInterface] = ACTIONS(656),
    [sym_kImplementation] = ACTIONS(656),
    [sym_kInitialization] = ACTIONS(656),
    [sym_kFinalization] = ACTIONS(656),
    [sym_kBegin] = ACTIONS(656),
    [sym_kEnd] = ACTIONS(656),
    [sym_kAsm] = ACTIONS(656),
    [sym_kVar] = ACTIONS(656),
    [sym_kThreadvar] = ACTIONS(656),
    [sym_kConst] = ACTIONS(656),
    [sym_kResourcestring] = ACTIONS(656),
    [sym_kType] = ACTIONS(656),
    [sym_kLabel] = ACTIONS(656),
    [sym_kExports] = ACTIONS(656),
    [sym_kProperty] = ACTIONS(656),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(656),
    [sym_kGeneric] = ACTIONS(656),
    [sym_kFunction] = ACTIONS(656),
    [sym_kProcedure] = ACTIONS(656),
    [sym_kConstructor] = ACTIONS(656),
    [sym_kDestructor] = ACTIONS(656),
    [sym_kOperator] = ACTIONS(656),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(661),
    [sym_identifier] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [sym_kUses] = ACTIONS(663),
    [sym_kInterface] = ACTIONS(663),
    [sym_kImplementation] = ACTIONS(663),
    [sym_kInitialization] = ACTIONS(663),
    [sym_kFinalization] = ACTIONS(663),
    [sym_kBegin] = ACTIONS(663),
    [sym_kEnd] = ACTIONS(663),
    [sym_kAsm] = ACTIONS(663),
    [sym_kVar] = ACTIONS(663),
    [sym_kThreadvar] = ACTIONS(663),
    [sym_kConst] = ACTIONS(663),
    [sym_kResourcestring] = ACTIONS(663),
    [sym_kType] = ACTIONS(663),
    [sym_kLabel] = ACTIONS(663),
    [sym_kExports] = ACTIONS(663),
    [sym_kProperty] = ACTIONS(663),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(663),
    [sym_kGeneric] = ACTIONS(663),
    [sym_kFunction] = ACTIONS(663),
    [sym_kProcedure] = ACTIONS(663),
    [sym_kConstructor] = ACTIONS(663),
    [sym_kDestructor] = ACTIONS(663),
    [sym_kOperator] = ACTIONS(663),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(668),
    [sym_identifier] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(672),
    [sym_kUses] = ACTIONS(670),
    [sym_kInterface] = ACTIONS(670),
    [sym_kImplementation] = ACTIONS(670),
    [sym_kInitialization] = ACTIONS(670),
    [sym_kFinalization] = ACTIONS(670),
    [sym_kBegin] = ACTIONS(670),
    [sym_kEnd] = ACTIONS(670),
    [sym_kAsm] = ACTIONS(670),
    [sym_kVar] = ACTIONS(670),
    [sym_kThreadvar] = ACTIONS(670),
    [sym_kConst] = ACTIONS(670),
    [sym_kResourcestring] = ACTIONS(670),
    [sym_kType] = ACTIONS(670),
    [sym_kLabel] = ACTIONS(670),
    [sym_kExports] = ACTIONS(670),
    [sym_kProperty] = ACTIONS(670),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(670),
    [sym_kGeneric] = ACTIONS(670),
    [sym_kFunction] = ACTIONS(670),
    [sym_kProcedure] = ACTIONS(670),
    [sym_kConstructor] = ACTIONS(670),
    [sym_kDestructor] = ACTIONS(670),
    [sym_kOperator] = ACTIONS(670),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(675),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(675),
    [sym_kUses] = ACTIONS(677),
    [sym_kInterface] = ACTIONS(677),
    [sym_kImplementation] = ACTIONS(677),
    [sym_kInitialization] = ACTIONS(677),
    [sym_kFinalization] = ACTIONS(677),
    [sym_kBegin] = ACTIONS(677),
    [sym_kEnd] = ACTIONS(677),
    [sym_kAsm] = ACTIONS(677),
    [sym_kVar] = ACTIONS(677),
    [sym_kThreadvar] = ACTIONS(677),
    [sym_kConst] = ACTIONS(677),
    [sym_kResourcestring] = ACTIONS(677),
    [sym_kType] = ACTIONS(677),
    [sym_kLabel] = ACTIONS(677),
    [sym_kExports] = ACTIONS(677),
    [sym_kProperty] = ACTIONS(677),
    [sym_kDefault] = ACTIONS(677),
    [sym_kNodefault] = ACTIONS(677),
    [sym_kClass] = ACTIONS(677),
    [sym_kGeneric] = ACTIONS(677),
    [sym_kFunction] = ACTIONS(677),
    [sym_kProcedure] = ACTIONS(677),
    [sym_kConstructor] = ACTIONS(677),
    [sym_kDestructor] = ACTIONS(677),
    [sym_kOperator] = ACTIONS(677),
    [sym_kPublic] = ACTIONS(677),
    [sym_kStatic] = ACTIONS(677),
    [sym_kVirtual] = ACTIONS(677),
    [sym_kAbstract] = ACTIONS(677),
    [sym_kDynamic] = ACTIONS(677),
    [sym_kOverride] = ACTIONS(677),
    [sym_kOverload] = ACTIONS(677),
    [sym_kReintroduce] = ACTIONS(677),
    [sym_kInline] = ACTIONS(677),
    [sym_kStdcall] = ACTIONS(677),
    [sym_kCdecl] = ACTIONS(677),
    [sym_kCppdecl] = ACTIONS(677),
    [sym_kPascal] = ACTIONS(677),
    [sym_kRegister] = ACTIONS(677),
    [sym_kMwpascal] = ACTIONS(677),
    [sym_kExternal] = ACTIONS(677),
    [sym_kMessage] = ACTIONS(677),
    [sym_kDeprecated] = ACTIONS(677),
    [sym_kExperimental] = ACTIONS(677),
    [sym_kPlatform] = ACTIONS(677),
    [sym_kUnimplemented] = ACTIONS(677),
    [sym_kCvar] = ACTIONS(677),
    [sym_kExport] = ACTIONS(677),
    [sym_kFar] = ACTIONS(677),
    [sym_kNear] = ACTIONS(677),
    [sym_kSafecall] = ACTIONS(677),
    [sym_kAssembler] = ACTIONS(677),
    [sym_kNostackframe] = ACTIONS(677),
    [sym_kInterrupt] = ACTIONS(677),
    [sym_kNoreturn] = ACTIONS(677),
    [sym_kIocheck] = ACTIONS(677),
    [sym_kLocal] = ACTIONS(677),
    [sym_kHardfloat] = ACTIONS(677),
    [sym_kSoftfloat] = ACTIONS(677),
    [sym_kMs_abi_default] = ACTIONS(677),
    [sym_kMs_abi_cdecl] = ACTIONS(677),
    [sym_kSaveregisters] = ACTIONS(677),
    [sym_kSysv_abi_default] = ACTIONS(677),
    [sym_kSysv_abi_cdecl] = ACTIONS(677),
    [sym_kVectorcall] = ACTIONS(677),
    [sym_kVarargs] = ACTIONS(677),
    [sym_kWinapi] = ACTIONS(677),
    [sym_kAlias] = ACTIONS(677),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(96),
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(683),
    [sym_kUses] = ACTIONS(681),
    [sym_kInterface] = ACTIONS(681),
    [sym_kImplementation] = ACTIONS(681),
    [sym_kInitialization] = ACTIONS(681),
    [sym_kFinalization] = ACTIONS(681),
    [sym_kBegin] = ACTIONS(681),
    [sym_kEnd] = ACTIONS(681),
    [sym_kAsm] = ACTIONS(681),
    [sym_kVar] = ACTIONS(681),
    [sym_kThreadvar] = ACTIONS(681),
    [sym_kConst] = ACTIONS(681),
    [sym_kResourcestring] = ACTIONS(681),
    [sym_kType] = ACTIONS(681),
    [sym_kLabel] = ACTIONS(681),
    [sym_kExports] = ACTIONS(681),
    [sym_kProperty] = ACTIONS(681),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(681),
    [sym_kGeneric] = ACTIONS(681),
    [sym_kFunction] = ACTIONS(681),
    [sym_kProcedure] = ACTIONS(681),
    [sym_kConstructor] = ACTIONS(681),
    [sym_kDestructor] = ACTIONS(681),
    [sym_kOperator] = ACTIONS(681),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(109),
    [ts_builtin_sym_end] = ACTIONS(686),
    [sym_identifier] = ACTIONS(688),
    [anon_sym_LBRACK] = ACTIONS(690),
    [sym_kUses] = ACTIONS(688),
    [sym_kInterface] = ACTIONS(688),
    [sym_kImplementation] = ACTIONS(688),
    [sym_kInitialization] = ACTIONS(688),
    [sym_kFinalization] = ACTIONS(688),
    [sym_kBegin] = ACTIONS(688),
    [sym_kEnd] = ACTIONS(688),
    [sym_kAsm] = ACTIONS(688),
    [sym_kVar] = ACTIONS(688),
    [sym_kThreadvar] = ACTIONS(688),
    [sym_kConst] = ACTIONS(688),
    [sym_kResourcestring] = ACTIONS(688),
    [sym_kType] = ACTIONS(688),
    [sym_kLabel] = ACTIONS(688),
    [sym_kExports] = ACTIONS(688),
    [sym_kProperty] = ACTIONS(688),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(688),
    [sym_kGeneric] = ACTIONS(688),
    [sym_kFunction] = ACTIONS(688),
    [sym_kProcedure] = ACTIONS(688),
    [sym_kConstructor] = ACTIONS(688),
    [sym_kDestructor] = ACTIONS(688),
    [sym_kOperator] = ACTIONS(688),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(697),
    [sym_kUses] = ACTIONS(695),
    [sym_kInterface] = ACTIONS(695),
    [sym_kImplementation] = ACTIONS(695),
    [sym_kInitialization] = ACTIONS(695),
    [sym_kFinalization] = ACTIONS(695),
    [sym_kBegin] = ACTIONS(695),
    [sym_kEnd] = ACTIONS(695),
    [sym_kAsm] = ACTIONS(695),
    [sym_kVar] = ACTIONS(695),
    [sym_kThreadvar] = ACTIONS(695),
    [sym_kConst] = ACTIONS(695),
    [sym_kResourcestring] = ACTIONS(695),
    [sym_kType] = ACTIONS(695),
    [sym_kLabel] = ACTIONS(695),
    [sym_kExports] = ACTIONS(695),
    [sym_kProperty] = ACTIONS(695),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(695),
    [sym_kGeneric] = ACTIONS(695),
    [sym_kFunction] = ACTIONS(695),
    [sym_kProcedure] = ACTIONS(695),
    [sym_kConstructor] = ACTIONS(695),
    [sym_kDestructor] = ACTIONS(695),
    [sym_kOperator] = ACTIONS(695),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(700),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(700),
    [anon_sym_RBRACK] = ACTIONS(700),
    [sym_kUses] = ACTIONS(702),
    [sym_kInterface] = ACTIONS(702),
    [sym_kImplementation] = ACTIONS(702),
    [sym_kInitialization] = ACTIONS(702),
    [sym_kFinalization] = ACTIONS(702),
    [sym_kBegin] = ACTIONS(702),
    [sym_kEnd] = ACTIONS(702),
    [sym_kAsm] = ACTIONS(702),
    [sym_kVar] = ACTIONS(702),
    [sym_kThreadvar] = ACTIONS(702),
    [sym_kConst] = ACTIONS(702),
    [sym_kResourcestring] = ACTIONS(702),
    [sym_kType] = ACTIONS(702),
    [sym_kLabel] = ACTIONS(702),
    [sym_kExports] = ACTIONS(702),
    [sym_kProperty] = ACTIONS(702),
    [sym_kDefault] = ACTIONS(702),
    [sym_kNodefault] = ACTIONS(702),
    [sym_kClass] = ACTIONS(702),
    [sym_kGeneric] = ACTIONS(702),
    [sym_kFunction] = ACTIONS(702),
    [sym_kProcedure] = ACTIONS(702),
    [sym_kConstructor] = ACTIONS(702),
    [sym_kDestructor] = ACTIONS(702),
    [sym_kOperator] = ACTIONS(702),
    [sym_kPublic] = ACTIONS(702),
    [sym_kStatic] = ACTIONS(702),
    [sym_kVirtual] = ACTIONS(702),
    [sym_kAbstract] = ACTIONS(702),
    [sym_kDynamic] = ACTIONS(702),
    [sym_kOverride] = ACTIONS(702),
    [sym_kOverload] = ACTIONS(702),
    [sym_kReintroduce] = ACTIONS(702),
    [sym_kInline] = ACTIONS(702),
    [sym_kStdcall] = ACTIONS(702),
    [sym_kCdecl] = ACTIONS(702),
    [sym_kCppdecl] = ACTIONS(702),
    [sym_kPascal] = ACTIONS(702),
    [sym_kRegister] = ACTIONS(702),
    [sym_kMwpascal] = ACTIONS(702),
    [sym_kExternal] = ACTIONS(702),
    [sym_kMessage] = ACTIONS(702),
    [sym_kDeprecated] = ACTIONS(702),
    [sym_kExperimental] = ACTIONS(702),
    [sym_kPlatform] = ACTIONS(702),
    [sym_kUnimplemented] = ACTIONS(702),
    [sym_kCvar] = ACTIONS(702),
    [sym_kExport] = ACTIONS(702),
    [sym_kFar] = ACTIONS(702),
    [sym_kNear] = ACTIONS(702),
    [sym_kSafecall] = ACTIONS(702),
    [sym_kAssembler] = ACTIONS(702),
    [sym_kNostackframe] = ACTIONS(702),
    [sym_kInterrupt] = ACTIONS(702),
    [sym_kNoreturn] = ACTIONS(702),
    [sym_kIocheck] = ACTIONS(702),
    [sym_kLocal] = ACTIONS(702),
    [sym_kHardfloat] = ACTIONS(702),
    [sym_kSoftfloat] = ACTIONS(702),
    [sym_kMs_abi_default] = ACTIONS(702),
    [sym_kMs_abi_cdecl] = ACTIONS(702),
    [sym_kSaveregisters] = ACTIONS(702),
    [sym_kSysv_abi_default] = ACTIONS(702),
    [sym_kSysv_abi_cdecl] = ACTIONS(702),
    [sym_kVectorcall] = ACTIONS(702),
    [sym_kVarargs] = ACTIONS(702),
    [sym_kWinapi] = ACTIONS(702),
    [sym_kAlias] = ACTIONS(702),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(704),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(708),
    [sym_kUses] = ACTIONS(706),
    [sym_kInterface] = ACTIONS(706),
    [sym_kImplementation] = ACTIONS(706),
    [sym_kInitialization] = ACTIONS(706),
    [sym_kFinalization] = ACTIONS(706),
    [sym_kBegin] = ACTIONS(706),
    [sym_kEnd] = ACTIONS(706),
    [sym_kAsm] = ACTIONS(706),
    [sym_kVar] = ACTIONS(706),
    [sym_kThreadvar] = ACTIONS(706),
    [sym_kConst] = ACTIONS(706),
    [sym_kResourcestring] = ACTIONS(706),
    [sym_kType] = ACTIONS(706),
    [sym_kLabel] = ACTIONS(706),
    [sym_kExports] = ACTIONS(706),
    [sym_kProperty] = ACTIONS(706),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(706),
    [sym_kGeneric] = ACTIONS(706),
    [sym_kFunction] = ACTIONS(706),
    [sym_kProcedure] = ACTIONS(706),
    [sym_kConstructor] = ACTIONS(706),
    [sym_kDestructor] = ACTIONS(706),
    [sym_kOperator] = ACTIONS(706),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(711),
    [sym_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [sym_kUses] = ACTIONS(713),
    [sym_kInterface] = ACTIONS(713),
    [sym_kImplementation] = ACTIONS(713),
    [sym_kInitialization] = ACTIONS(713),
    [sym_kFinalization] = ACTIONS(713),
    [sym_kBegin] = ACTIONS(713),
    [sym_kEnd] = ACTIONS(713),
    [sym_kAsm] = ACTIONS(713),
    [sym_kVar] = ACTIONS(713),
    [sym_kThreadvar] = ACTIONS(713),
    [sym_kConst] = ACTIONS(713),
    [sym_kResourcestring] = ACTIONS(713),
    [sym_kType] = ACTIONS(713),
    [sym_kLabel] = ACTIONS(713),
    [sym_kExports] = ACTIONS(713),
    [sym_kProperty] = ACTIONS(713),
    [sym_kDefault] = ACTIONS(713),
    [sym_kNodefault] = ACTIONS(713),
    [sym_kClass] = ACTIONS(713),
    [sym_kGeneric] = ACTIONS(713),
    [sym_kFunction] = ACTIONS(713),
    [sym_kProcedure] = ACTIONS(713),
    [sym_kConstructor] = ACTIONS(713),
    [sym_kDestructor] = ACTIONS(713),
    [sym_kOperator] = ACTIONS(713),
    [sym_kPublic] = ACTIONS(713),
    [sym_kStatic] = ACTIONS(713),
    [sym_kVirtual] = ACTIONS(713),
    [sym_kAbstract] = ACTIONS(713),
    [sym_kDynamic] = ACTIONS(713),
    [sym_kOverride] = ACTIONS(713),
    [sym_kOverload] = ACTIONS(713),
    [sym_kReintroduce] = ACTIONS(713),
    [sym_kInline] = ACTIONS(713),
    [sym_kStdcall] = ACTIONS(713),
    [sym_kCdecl] = ACTIONS(713),
    [sym_kCppdecl] = ACTIONS(713),
    [sym_kPascal] = ACTIONS(713),
    [sym_kRegister] = ACTIONS(713),
    [sym_kMwpascal] = ACTIONS(713),
    [sym_kExternal] = ACTIONS(713),
    [sym_kMessage] = ACTIONS(713),
    [sym_kDeprecated] = ACTIONS(713),
    [sym_kExperimental] = ACTIONS(713),
    [sym_kPlatform] = ACTIONS(713),
    [sym_kUnimplemented] = ACTIONS(713),
    [sym_kCvar] = ACTIONS(713),
    [sym_kExport] = ACTIONS(713),
    [sym_kFar] = ACTIONS(713),
    [sym_kNear] = ACTIONS(713),
    [sym_kSafecall] = ACTIONS(713),
    [sym_kAssembler] = ACTIONS(713),
    [sym_kNostackframe] = ACTIONS(713),
    [sym_kInterrupt] = ACTIONS(713),
    [sym_kNoreturn] = ACTIONS(713),
    [sym_kIocheck] = ACTIONS(713),
    [sym_kLocal] = ACTIONS(713),
    [sym_kHardfloat] = ACTIONS(713),
    [sym_kSoftfloat] = ACTIONS(713),
    [sym_kMs_abi_default] = ACTIONS(713),
    [sym_kMs_abi_cdecl] = ACTIONS(713),
    [sym_kSaveregisters] = ACTIONS(713),
    [sym_kSysv_abi_default] = ACTIONS(713),
    [sym_kSysv_abi_cdecl] = ACTIONS(713),
    [sym_kVectorcall] = ACTIONS(713),
    [sym_kVarargs] = ACTIONS(713),
    [sym_kWinapi] = ACTIONS(713),
    [sym_kAlias] = ACTIONS(713),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(97),
    [ts_builtin_sym_end] = ACTIONS(715),
    [sym_identifier] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [sym_kUses] = ACTIONS(717),
    [sym_kInterface] = ACTIONS(717),
    [sym_kImplementation] = ACTIONS(717),
    [sym_kInitialization] = ACTIONS(717),
    [sym_kFinalization] = ACTIONS(717),
    [sym_kBegin] = ACTIONS(717),
    [sym_kEnd] = ACTIONS(717),
    [sym_kAsm] = ACTIONS(717),
    [sym_kVar] = ACTIONS(717),
    [sym_kThreadvar] = ACTIONS(717),
    [sym_kConst] = ACTIONS(717),
    [sym_kResourcestring] = ACTIONS(717),
    [sym_kType] = ACTIONS(717),
    [sym_kLabel] = ACTIONS(717),
    [sym_kExports] = ACTIONS(717),
    [sym_kProperty] = ACTIONS(717),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(717),
    [sym_kGeneric] = ACTIONS(717),
    [sym_kFunction] = ACTIONS(717),
    [sym_kProcedure] = ACTIONS(717),
    [sym_kConstructor] = ACTIONS(717),
    [sym_kDestructor] = ACTIONS(717),
    [sym_kOperator] = ACTIONS(717),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(722),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [sym_kUses] = ACTIONS(724),
    [sym_kInterface] = ACTIONS(724),
    [sym_kImplementation] = ACTIONS(724),
    [sym_kInitialization] = ACTIONS(724),
    [sym_kFinalization] = ACTIONS(724),
    [sym_kBegin] = ACTIONS(724),
    [sym_kEnd] = ACTIONS(724),
    [sym_kAsm] = ACTIONS(724),
    [sym_kVar] = ACTIONS(724),
    [sym_kThreadvar] = ACTIONS(724),
    [sym_kConst] = ACTIONS(724),
    [sym_kResourcestring] = ACTIONS(724),
    [sym_kType] = ACTIONS(724),
    [sym_kLabel] = ACTIONS(724),
    [sym_kExports] = ACTIONS(724),
    [sym_kProperty] = ACTIONS(724),
    [sym_kDefault] = ACTIONS(729),
    [sym_kNodefault] = ACTIONS(729),
    [sym_kClass] = ACTIONS(724),
    [sym_kGeneric] = ACTIONS(724),
    [sym_kFunction] = ACTIONS(724),
    [sym_kProcedure] = ACTIONS(724),
    [sym_kConstructor] = ACTIONS(724),
    [sym_kDestructor] = ACTIONS(724),
    [sym_kOperator] = ACTIONS(724),
    [sym_kPublic] = ACTIONS(732),
    [sym_kStatic] = ACTIONS(729),
    [sym_kVirtual] = ACTIONS(729),
    [sym_kAbstract] = ACTIONS(729),
    [sym_kDynamic] = ACTIONS(729),
    [sym_kOverride] = ACTIONS(729),
    [sym_kOverload] = ACTIONS(729),
    [sym_kReintroduce] = ACTIONS(729),
    [sym_kInline] = ACTIONS(729),
    [sym_kStdcall] = ACTIONS(729),
    [sym_kCdecl] = ACTIONS(729),
    [sym_kCppdecl] = ACTIONS(729),
    [sym_kPascal] = ACTIONS(729),
    [sym_kRegister] = ACTIONS(729),
    [sym_kMwpascal] = ACTIONS(729),
    [sym_kMessage] = ACTIONS(735),
    [sym_kDeprecated] = ACTIONS(738),
    [sym_kExperimental] = ACTIONS(729),
    [sym_kPlatform] = ACTIONS(729),
    [sym_kUnimplemented] = ACTIONS(729),
    [sym_kCvar] = ACTIONS(729),
    [sym_kExport] = ACTIONS(741),
    [sym_kFar] = ACTIONS(729),
    [sym_kNear] = ACTIONS(729),
    [sym_kSafecall] = ACTIONS(729),
    [sym_kAssembler] = ACTIONS(729),
    [sym_kNostackframe] = ACTIONS(729),
    [sym_kInterrupt] = ACTIONS(729),
    [sym_kNoreturn] = ACTIONS(729),
    [sym_kIocheck] = ACTIONS(729),
    [sym_kLocal] = ACTIONS(729),
    [sym_kHardfloat] = ACTIONS(729),
    [sym_kSoftfloat] = ACTIONS(729),
    [sym_kMs_abi_default] = ACTIONS(729),
    [sym_kMs_abi_cdecl] = ACTIONS(729),
    [sym_kSaveregisters] = ACTIONS(729),
    [sym_kSysv_abi_default] = ACTIONS(729),
    [sym_kSysv_abi_cdecl] = ACTIONS(729),
    [sym_kVectorcall] = ACTIONS(729),
    [sym_kVarargs] = ACTIONS(729),
    [sym_kWinapi] = ACTIONS(729),
    [sym_kAlias] = ACTIONS(744),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(115),
    [sym_while] = STATE(115),
    [sym_repeat] = STATE(115),
    [sym_for] = STATE(115),
    [sym_foreach] = STATE(115),
    [sym_try] = STATE(115),
    [sym_case] = STATE(115),
    [sym_block] = STATE(115),
    [sym_asm] = STATE(115),
    [sym_with] = STATE(115),
    [sym_raise] = STATE(115),
    [sym_statement] = STATE(115),
    [sym_goto] = STATE(115),
    [sym__statement] = STATE(115),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_exceptionElse_repeat1] = STATE(115),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(747),
    [anon_sym_SEMI] = ACTIONS(750),
    [anon_sym_LBRACK] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(756),
    [aux_sym__literalString_token1] = ACTIONS(759),
    [anon_sym_POUND] = ACTIONS(762),
    [aux_sym__literalInt_token1] = ACTIONS(765),
    [aux_sym__literalInt_token2] = ACTIONS(768),
    [aux_sym__literalFloat_token1] = ACTIONS(765),
    [sym_kBegin] = ACTIONS(771),
    [sym_kAsm] = ACTIONS(774),
    [sym_kVar] = ACTIONS(777),
    [sym_kSpecialize] = ACTIONS(780),
    [sym_kAdd] = ACTIONS(783),
    [sym_kSub] = ACTIONS(783),
    [sym_kAt] = ACTIONS(786),
    [sym_kNot] = ACTIONS(783),
    [sym_kFor] = ACTIONS(789),
    [sym_kIf] = ACTIONS(792),
    [sym_kWhile] = ACTIONS(795),
    [sym_kRepeat] = ACTIONS(798),
    [sym_kTry] = ACTIONS(801),
    [sym_kRaise] = ACTIONS(804),
    [sym_kCase] = ACTIONS(807),
    [sym_kWith] = ACTIONS(810),
    [sym_kGoto] = ACTIONS(813),
    [sym_kFunction] = ACTIONS(816),
    [sym_kProcedure] = ACTIONS(816),
    [sym_kInherited] = ACTIONS(819),
    [sym_kNil] = ACTIONS(747),
    [sym_kTrue] = ACTIONS(747),
    [sym_kFalse] = ACTIONS(747),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(111),
    [ts_builtin_sym_end] = ACTIONS(822),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(826),
    [sym_kUses] = ACTIONS(824),
    [sym_kInterface] = ACTIONS(824),
    [sym_kImplementation] = ACTIONS(824),
    [sym_kInitialization] = ACTIONS(824),
    [sym_kFinalization] = ACTIONS(824),
    [sym_kBegin] = ACTIONS(824),
    [sym_kEnd] = ACTIONS(824),
    [sym_kAsm] = ACTIONS(824),
    [sym_kVar] = ACTIONS(824),
    [sym_kThreadvar] = ACTIONS(824),
    [sym_kConst] = ACTIONS(824),
    [sym_kResourcestring] = ACTIONS(824),
    [sym_kType] = ACTIONS(824),
    [sym_kLabel] = ACTIONS(824),
    [sym_kExports] = ACTIONS(824),
    [sym_kProperty] = ACTIONS(824),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(824),
    [sym_kGeneric] = ACTIONS(824),
    [sym_kFunction] = ACTIONS(824),
    [sym_kProcedure] = ACTIONS(824),
    [sym_kConstructor] = ACTIONS(824),
    [sym_kDestructor] = ACTIONS(824),
    [sym_kOperator] = ACTIONS(824),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(101),
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(833),
    [sym_kUses] = ACTIONS(831),
    [sym_kInterface] = ACTIONS(831),
    [sym_kImplementation] = ACTIONS(831),
    [sym_kInitialization] = ACTIONS(831),
    [sym_kFinalization] = ACTIONS(831),
    [sym_kBegin] = ACTIONS(831),
    [sym_kEnd] = ACTIONS(831),
    [sym_kAsm] = ACTIONS(831),
    [sym_kVar] = ACTIONS(831),
    [sym_kThreadvar] = ACTIONS(831),
    [sym_kConst] = ACTIONS(831),
    [sym_kResourcestring] = ACTIONS(831),
    [sym_kType] = ACTIONS(831),
    [sym_kLabel] = ACTIONS(831),
    [sym_kExports] = ACTIONS(831),
    [sym_kProperty] = ACTIONS(831),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(831),
    [sym_kGeneric] = ACTIONS(831),
    [sym_kFunction] = ACTIONS(831),
    [sym_kProcedure] = ACTIONS(831),
    [sym_kConstructor] = ACTIONS(831),
    [sym_kDestructor] = ACTIONS(831),
    [sym_kOperator] = ACTIONS(831),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(104),
    [ts_builtin_sym_end] = ACTIONS(836),
    [sym_identifier] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(840),
    [sym_kUses] = ACTIONS(838),
    [sym_kInterface] = ACTIONS(838),
    [sym_kImplementation] = ACTIONS(838),
    [sym_kInitialization] = ACTIONS(838),
    [sym_kFinalization] = ACTIONS(838),
    [sym_kBegin] = ACTIONS(838),
    [sym_kEnd] = ACTIONS(838),
    [sym_kAsm] = ACTIONS(838),
    [sym_kVar] = ACTIONS(838),
    [sym_kThreadvar] = ACTIONS(838),
    [sym_kConst] = ACTIONS(838),
    [sym_kResourcestring] = ACTIONS(838),
    [sym_kType] = ACTIONS(838),
    [sym_kLabel] = ACTIONS(838),
    [sym_kExports] = ACTIONS(838),
    [sym_kProperty] = ACTIONS(838),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(838),
    [sym_kGeneric] = ACTIONS(838),
    [sym_kFunction] = ACTIONS(838),
    [sym_kProcedure] = ACTIONS(838),
    [sym_kConstructor] = ACTIONS(838),
    [sym_kDestructor] = ACTIONS(838),
    [sym_kOperator] = ACTIONS(838),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1071),
    [sym_while] = STATE(1071),
    [sym_repeat] = STATE(1071),
    [sym_for] = STATE(1071),
    [sym_foreach] = STATE(1071),
    [sym_try] = STATE(1071),
    [sym_case] = STATE(1071),
    [sym_block] = STATE(1071),
    [sym_asm] = STATE(1071),
    [sym_with] = STATE(1071),
    [sym_raise] = STATE(1071),
    [sym_statement] = STATE(1071),
    [sym_goto] = STATE(1071),
    [sym__statement] = STATE(1071),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_exceptionElse_repeat1] = STATE(94),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(845),
    [sym_identifier] = ACTIONS(847),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(845),
    [sym_kUses] = ACTIONS(847),
    [sym_kInterface] = ACTIONS(847),
    [sym_kImplementation] = ACTIONS(847),
    [sym_kInitialization] = ACTIONS(847),
    [sym_kFinalization] = ACTIONS(847),
    [sym_kBegin] = ACTIONS(847),
    [sym_kEnd] = ACTIONS(847),
    [sym_kAsm] = ACTIONS(847),
    [sym_kVar] = ACTIONS(847),
    [sym_kThreadvar] = ACTIONS(847),
    [sym_kConst] = ACTIONS(847),
    [sym_kResourcestring] = ACTIONS(847),
    [sym_kType] = ACTIONS(847),
    [sym_kLabel] = ACTIONS(847),
    [sym_kExports] = ACTIONS(847),
    [sym_kProperty] = ACTIONS(847),
    [sym_kDefault] = ACTIONS(847),
    [sym_kNodefault] = ACTIONS(847),
    [sym_kClass] = ACTIONS(847),
    [sym_kGeneric] = ACTIONS(847),
    [sym_kFunction] = ACTIONS(847),
    [sym_kProcedure] = ACTIONS(847),
    [sym_kConstructor] = ACTIONS(847),
    [sym_kDestructor] = ACTIONS(847),
    [sym_kOperator] = ACTIONS(847),
    [sym_kPublic] = ACTIONS(847),
    [sym_kStatic] = ACTIONS(847),
    [sym_kVirtual] = ACTIONS(847),
    [sym_kAbstract] = ACTIONS(847),
    [sym_kDynamic] = ACTIONS(847),
    [sym_kOverride] = ACTIONS(847),
    [sym_kOverload] = ACTIONS(847),
    [sym_kReintroduce] = ACTIONS(847),
    [sym_kInline] = ACTIONS(847),
    [sym_kStdcall] = ACTIONS(847),
    [sym_kCdecl] = ACTIONS(847),
    [sym_kCppdecl] = ACTIONS(847),
    [sym_kPascal] = ACTIONS(847),
    [sym_kRegister] = ACTIONS(847),
    [sym_kMwpascal] = ACTIONS(847),
    [sym_kExternal] = ACTIONS(847),
    [sym_kMessage] = ACTIONS(847),
    [sym_kDeprecated] = ACTIONS(847),
    [sym_kExperimental] = ACTIONS(847),
    [sym_kPlatform] = ACTIONS(847),
    [sym_kUnimplemented] = ACTIONS(847),
    [sym_kCvar] = ACTIONS(847),
    [sym_kExport] = ACTIONS(847),
    [sym_kFar] = ACTIONS(847),
    [sym_kNear] = ACTIONS(847),
    [sym_kSafecall] = ACTIONS(847),
    [sym_kAssembler] = ACTIONS(847),
    [sym_kNostackframe] = ACTIONS(847),
    [sym_kInterrupt] = ACTIONS(847),
    [sym_kNoreturn] = ACTIONS(847),
    [sym_kIocheck] = ACTIONS(847),
    [sym_kLocal] = ACTIONS(847),
    [sym_kHardfloat] = ACTIONS(847),
    [sym_kSoftfloat] = ACTIONS(847),
    [sym_kMs_abi_default] = ACTIONS(847),
    [sym_kMs_abi_cdecl] = ACTIONS(847),
    [sym_kSaveregisters] = ACTIONS(847),
    [sym_kSysv_abi_default] = ACTIONS(847),
    [sym_kSysv_abi_cdecl] = ACTIONS(847),
    [sym_kVectorcall] = ACTIONS(847),
    [sym_kVarargs] = ACTIONS(847),
    [sym_kWinapi] = ACTIONS(847),
    [sym_kAlias] = ACTIONS(847),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(853),
    [sym_kUses] = ACTIONS(851),
    [sym_kInterface] = ACTIONS(851),
    [sym_kImplementation] = ACTIONS(851),
    [sym_kInitialization] = ACTIONS(851),
    [sym_kFinalization] = ACTIONS(851),
    [sym_kBegin] = ACTIONS(851),
    [sym_kEnd] = ACTIONS(851),
    [sym_kAsm] = ACTIONS(851),
    [sym_kVar] = ACTIONS(851),
    [sym_kThreadvar] = ACTIONS(851),
    [sym_kConst] = ACTIONS(851),
    [sym_kResourcestring] = ACTIONS(851),
    [sym_kType] = ACTIONS(851),
    [sym_kLabel] = ACTIONS(851),
    [sym_kExports] = ACTIONS(851),
    [sym_kProperty] = ACTIONS(851),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(851),
    [sym_kGeneric] = ACTIONS(851),
    [sym_kFunction] = ACTIONS(851),
    [sym_kProcedure] = ACTIONS(851),
    [sym_kConstructor] = ACTIONS(851),
    [sym_kDestructor] = ACTIONS(851),
    [sym_kOperator] = ACTIONS(851),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(100),
    [ts_builtin_sym_end] = ACTIONS(856),
    [sym_identifier] = ACTIONS(858),
    [anon_sym_LBRACK] = ACTIONS(860),
    [sym_kUses] = ACTIONS(858),
    [sym_kInterface] = ACTIONS(858),
    [sym_kImplementation] = ACTIONS(858),
    [sym_kInitialization] = ACTIONS(858),
    [sym_kFinalization] = ACTIONS(858),
    [sym_kBegin] = ACTIONS(858),
    [sym_kEnd] = ACTIONS(858),
    [sym_kAsm] = ACTIONS(858),
    [sym_kVar] = ACTIONS(858),
    [sym_kThreadvar] = ACTIONS(858),
    [sym_kConst] = ACTIONS(858),
    [sym_kResourcestring] = ACTIONS(858),
    [sym_kType] = ACTIONS(858),
    [sym_kLabel] = ACTIONS(858),
    [sym_kExports] = ACTIONS(858),
    [sym_kProperty] = ACTIONS(858),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(858),
    [sym_kGeneric] = ACTIONS(858),
    [sym_kFunction] = ACTIONS(858),
    [sym_kProcedure] = ACTIONS(858),
    [sym_kConstructor] = ACTIONS(858),
    [sym_kDestructor] = ACTIONS(858),
    [sym_kOperator] = ACTIONS(858),
    [sym_kPublic] = ACTIONS(298),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_LBRACK] = ACTIONS(863),
    [sym_kEnd] = ACTIONS(319),
    [sym_kVar] = ACTIONS(319),
    [sym_kThreadvar] = ACTIONS(319),
    [sym_kConst] = ACTIONS(319),
    [sym_kResourcestring] = ACTIONS(319),
    [sym_kType] = ACTIONS(319),
    [sym_kProperty] = ACTIONS(319),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(319),
    [sym_kGeneric] = ACTIONS(319),
    [sym_kCase] = ACTIONS(319),
    [sym_kFunction] = ACTIONS(319),
    [sym_kProcedure] = ACTIONS(319),
    [sym_kConstructor] = ACTIONS(319),
    [sym_kDestructor] = ACTIONS(319),
    [sym_kOperator] = ACTIONS(319),
    [sym_kPublished] = ACTIONS(319),
    [sym_kPublic] = ACTIONS(866),
    [sym_kProtected] = ACTIONS(319),
    [sym_kPrivate] = ACTIONS(319),
    [sym_kStrict] = ACTIONS(319),
    [sym_kRequired] = ACTIONS(319),
    [sym_kOptional] = ACTIONS(319),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(794),
    [sym_while] = STATE(794),
    [sym_repeat] = STATE(794),
    [sym_for] = STATE(794),
    [sym_foreach] = STATE(794),
    [sym_try] = STATE(794),
    [sym_case] = STATE(794),
    [sym_block] = STATE(794),
    [sym_asm] = STATE(794),
    [sym_with] = STATE(794),
    [sym_raise] = STATE(794),
    [sym_statement] = STATE(794),
    [sym_goto] = STATE(794),
    [sym__statement] = STATE(794),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(873),
    [sym_kUses] = ACTIONS(871),
    [sym_kInterface] = ACTIONS(871),
    [sym_kImplementation] = ACTIONS(871),
    [sym_kInitialization] = ACTIONS(871),
    [sym_kFinalization] = ACTIONS(871),
    [sym_kBegin] = ACTIONS(871),
    [sym_kEnd] = ACTIONS(871),
    [sym_kAsm] = ACTIONS(871),
    [sym_kVar] = ACTIONS(876),
    [sym_kThreadvar] = ACTIONS(871),
    [sym_kConst] = ACTIONS(876),
    [sym_kResourcestring] = ACTIONS(871),
    [sym_kType] = ACTIONS(871),
    [sym_kLabel] = ACTIONS(871),
    [sym_kExports] = ACTIONS(871),
    [sym_kProperty] = ACTIONS(871),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(871),
    [sym_kGeneric] = ACTIONS(871),
    [sym_kFunction] = ACTIONS(871),
    [sym_kProcedure] = ACTIONS(871),
    [sym_kConstructor] = ACTIONS(871),
    [sym_kDestructor] = ACTIONS(871),
    [sym_kOperator] = ACTIONS(871),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1808),
    [sym_while] = STATE(1808),
    [sym_repeat] = STATE(1808),
    [sym_for] = STATE(1808),
    [sym_foreach] = STATE(1808),
    [sym_try] = STATE(1808),
    [sym_case] = STATE(1808),
    [sym_block] = STATE(1808),
    [sym_asm] = STATE(1808),
    [sym_with] = STATE(1808),
    [sym_raise] = STATE(1808),
    [sym_statement] = STATE(1808),
    [sym_goto] = STATE(1808),
    [sym__statement] = STATE(1808),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(888),
    [sym_kEnd] = ACTIONS(459),
    [sym_kVar] = ACTIONS(459),
    [sym_kThreadvar] = ACTIONS(459),
    [sym_kConst] = ACTIONS(459),
    [sym_kResourcestring] = ACTIONS(459),
    [sym_kType] = ACTIONS(459),
    [sym_kProperty] = ACTIONS(459),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(459),
    [sym_kGeneric] = ACTIONS(459),
    [sym_kCase] = ACTIONS(459),
    [sym_kFunction] = ACTIONS(459),
    [sym_kProcedure] = ACTIONS(459),
    [sym_kConstructor] = ACTIONS(459),
    [sym_kDestructor] = ACTIONS(459),
    [sym_kOperator] = ACTIONS(459),
    [sym_kPublished] = ACTIONS(459),
    [sym_kPublic] = ACTIONS(891),
    [sym_kProtected] = ACTIONS(459),
    [sym_kPrivate] = ACTIONS(459),
    [sym_kStrict] = ACTIONS(459),
    [sym_kRequired] = ACTIONS(459),
    [sym_kOptional] = ACTIONS(459),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(151),
    [aux_sym_declVar_repeat1] = STATE(151),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(894),
    [sym_kEnd] = ACTIONS(431),
    [sym_kVar] = ACTIONS(431),
    [sym_kThreadvar] = ACTIONS(431),
    [sym_kConst] = ACTIONS(431),
    [sym_kResourcestring] = ACTIONS(431),
    [sym_kType] = ACTIONS(431),
    [sym_kProperty] = ACTIONS(431),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(431),
    [sym_kGeneric] = ACTIONS(431),
    [sym_kCase] = ACTIONS(431),
    [sym_kFunction] = ACTIONS(431),
    [sym_kProcedure] = ACTIONS(431),
    [sym_kConstructor] = ACTIONS(431),
    [sym_kDestructor] = ACTIONS(431),
    [sym_kOperator] = ACTIONS(431),
    [sym_kPublished] = ACTIONS(431),
    [sym_kPublic] = ACTIONS(897),
    [sym_kProtected] = ACTIONS(431),
    [sym_kPrivate] = ACTIONS(431),
    [sym_kStrict] = ACTIONS(431),
    [sym_kRequired] = ACTIONS(431),
    [sym_kOptional] = ACTIONS(431),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(123),
    [aux_sym_declVar_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LBRACK] = ACTIONS(900),
    [sym_kEnd] = ACTIONS(347),
    [sym_kVar] = ACTIONS(347),
    [sym_kThreadvar] = ACTIONS(347),
    [sym_kConst] = ACTIONS(347),
    [sym_kResourcestring] = ACTIONS(347),
    [sym_kType] = ACTIONS(347),
    [sym_kProperty] = ACTIONS(347),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(347),
    [sym_kGeneric] = ACTIONS(347),
    [sym_kCase] = ACTIONS(347),
    [sym_kFunction] = ACTIONS(347),
    [sym_kProcedure] = ACTIONS(347),
    [sym_kConstructor] = ACTIONS(347),
    [sym_kDestructor] = ACTIONS(347),
    [sym_kOperator] = ACTIONS(347),
    [sym_kPublished] = ACTIONS(347),
    [sym_kPublic] = ACTIONS(903),
    [sym_kProtected] = ACTIONS(347),
    [sym_kPrivate] = ACTIONS(347),
    [sym_kStrict] = ACTIONS(347),
    [sym_kRequired] = ACTIONS(347),
    [sym_kOptional] = ACTIONS(347),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(155),
    [aux_sym_declVar_repeat1] = STATE(155),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(906),
    [sym_kEnd] = ACTIONS(473),
    [sym_kVar] = ACTIONS(473),
    [sym_kThreadvar] = ACTIONS(473),
    [sym_kConst] = ACTIONS(473),
    [sym_kResourcestring] = ACTIONS(473),
    [sym_kType] = ACTIONS(473),
    [sym_kProperty] = ACTIONS(473),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(473),
    [sym_kGeneric] = ACTIONS(473),
    [sym_kCase] = ACTIONS(473),
    [sym_kFunction] = ACTIONS(473),
    [sym_kProcedure] = ACTIONS(473),
    [sym_kConstructor] = ACTIONS(473),
    [sym_kDestructor] = ACTIONS(473),
    [sym_kOperator] = ACTIONS(473),
    [sym_kPublished] = ACTIONS(473),
    [sym_kPublic] = ACTIONS(909),
    [sym_kProtected] = ACTIONS(473),
    [sym_kPrivate] = ACTIONS(473),
    [sym_kStrict] = ACTIONS(473),
    [sym_kRequired] = ACTIONS(473),
    [sym_kOptional] = ACTIONS(473),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(914),
    [sym_kUses] = ACTIONS(912),
    [sym_kInterface] = ACTIONS(912),
    [sym_kImplementation] = ACTIONS(912),
    [sym_kInitialization] = ACTIONS(912),
    [sym_kFinalization] = ACTIONS(912),
    [sym_kBegin] = ACTIONS(912),
    [sym_kEnd] = ACTIONS(912),
    [sym_kAsm] = ACTIONS(912),
    [sym_kVar] = ACTIONS(917),
    [sym_kThreadvar] = ACTIONS(912),
    [sym_kConst] = ACTIONS(917),
    [sym_kResourcestring] = ACTIONS(912),
    [sym_kType] = ACTIONS(912),
    [sym_kLabel] = ACTIONS(912),
    [sym_kExports] = ACTIONS(912),
    [sym_kProperty] = ACTIONS(912),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(912),
    [sym_kGeneric] = ACTIONS(912),
    [sym_kFunction] = ACTIONS(912),
    [sym_kProcedure] = ACTIONS(912),
    [sym_kConstructor] = ACTIONS(912),
    [sym_kDestructor] = ACTIONS(912),
    [sym_kOperator] = ACTIONS(912),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kRead] = ACTIONS(261),
    [sym_kWrite] = ACTIONS(261),
    [sym_kImplements] = ACTIONS(261),
    [sym_kDefault] = ACTIONS(261),
    [sym_kNodefault] = ACTIONS(261),
    [sym_kStored] = ACTIONS(261),
    [sym_kIndex] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kName] = ACTIONS(261),
    [sym_kDelayed] = ACTIONS(261),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(919),
    [sym_kEnd] = ACTIONS(361),
    [sym_kVar] = ACTIONS(361),
    [sym_kThreadvar] = ACTIONS(361),
    [sym_kConst] = ACTIONS(361),
    [sym_kResourcestring] = ACTIONS(361),
    [sym_kType] = ACTIONS(361),
    [sym_kProperty] = ACTIONS(361),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(361),
    [sym_kGeneric] = ACTIONS(361),
    [sym_kCase] = ACTIONS(361),
    [sym_kFunction] = ACTIONS(361),
    [sym_kProcedure] = ACTIONS(361),
    [sym_kConstructor] = ACTIONS(361),
    [sym_kDestructor] = ACTIONS(361),
    [sym_kOperator] = ACTIONS(361),
    [sym_kPublished] = ACTIONS(361),
    [sym_kPublic] = ACTIONS(922),
    [sym_kProtected] = ACTIONS(361),
    [sym_kPrivate] = ACTIONS(361),
    [sym_kStrict] = ACTIONS(361),
    [sym_kRequired] = ACTIONS(361),
    [sym_kOptional] = ACTIONS(361),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(125),
    [ts_builtin_sym_end] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(927),
    [sym_kUses] = ACTIONS(925),
    [sym_kInterface] = ACTIONS(925),
    [sym_kImplementation] = ACTIONS(925),
    [sym_kInitialization] = ACTIONS(925),
    [sym_kFinalization] = ACTIONS(925),
    [sym_kBegin] = ACTIONS(925),
    [sym_kEnd] = ACTIONS(925),
    [sym_kAsm] = ACTIONS(925),
    [sym_kVar] = ACTIONS(930),
    [sym_kThreadvar] = ACTIONS(925),
    [sym_kConst] = ACTIONS(930),
    [sym_kResourcestring] = ACTIONS(925),
    [sym_kType] = ACTIONS(925),
    [sym_kLabel] = ACTIONS(925),
    [sym_kExports] = ACTIONS(925),
    [sym_kProperty] = ACTIONS(925),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(925),
    [sym_kGeneric] = ACTIONS(925),
    [sym_kFunction] = ACTIONS(925),
    [sym_kProcedure] = ACTIONS(925),
    [sym_kConstructor] = ACTIONS(925),
    [sym_kDestructor] = ACTIONS(925),
    [sym_kOperator] = ACTIONS(925),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1906),
    [sym_while] = STATE(1906),
    [sym_repeat] = STATE(1906),
    [sym_for] = STATE(1906),
    [sym_foreach] = STATE(1906),
    [sym_try] = STATE(1906),
    [sym_case] = STATE(1906),
    [sym_block] = STATE(1906),
    [sym_asm] = STATE(1906),
    [sym_with] = STATE(1906),
    [sym_raise] = STATE(1906),
    [sym_statement] = STATE(1906),
    [sym_goto] = STATE(1906),
    [sym__statement] = STATE(1906),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(932),
    [sym_kEnd] = ACTIONS(375),
    [sym_kVar] = ACTIONS(375),
    [sym_kThreadvar] = ACTIONS(375),
    [sym_kConst] = ACTIONS(375),
    [sym_kResourcestring] = ACTIONS(375),
    [sym_kType] = ACTIONS(375),
    [sym_kProperty] = ACTIONS(375),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(375),
    [sym_kGeneric] = ACTIONS(375),
    [sym_kCase] = ACTIONS(375),
    [sym_kFunction] = ACTIONS(375),
    [sym_kProcedure] = ACTIONS(375),
    [sym_kConstructor] = ACTIONS(375),
    [sym_kDestructor] = ACTIONS(375),
    [sym_kOperator] = ACTIONS(375),
    [sym_kPublished] = ACTIONS(375),
    [sym_kPublic] = ACTIONS(935),
    [sym_kProtected] = ACTIONS(375),
    [sym_kPrivate] = ACTIONS(375),
    [sym_kStrict] = ACTIONS(375),
    [sym_kRequired] = ACTIONS(375),
    [sym_kOptional] = ACTIONS(375),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(938),
    [sym_kEnd] = ACTIONS(382),
    [sym_kVar] = ACTIONS(382),
    [sym_kThreadvar] = ACTIONS(382),
    [sym_kConst] = ACTIONS(382),
    [sym_kResourcestring] = ACTIONS(382),
    [sym_kType] = ACTIONS(382),
    [sym_kProperty] = ACTIONS(382),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(382),
    [sym_kGeneric] = ACTIONS(382),
    [sym_kCase] = ACTIONS(382),
    [sym_kFunction] = ACTIONS(382),
    [sym_kProcedure] = ACTIONS(382),
    [sym_kConstructor] = ACTIONS(382),
    [sym_kDestructor] = ACTIONS(382),
    [sym_kOperator] = ACTIONS(382),
    [sym_kPublished] = ACTIONS(382),
    [sym_kPublic] = ACTIONS(941),
    [sym_kProtected] = ACTIONS(382),
    [sym_kPrivate] = ACTIONS(382),
    [sym_kStrict] = ACTIONS(382),
    [sym_kRequired] = ACTIONS(382),
    [sym_kOptional] = ACTIONS(382),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(133),
    [aux_sym_declVar_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_LBRACK] = ACTIONS(944),
    [sym_kEnd] = ACTIONS(389),
    [sym_kVar] = ACTIONS(389),
    [sym_kThreadvar] = ACTIONS(389),
    [sym_kConst] = ACTIONS(389),
    [sym_kResourcestring] = ACTIONS(389),
    [sym_kType] = ACTIONS(389),
    [sym_kProperty] = ACTIONS(389),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(389),
    [sym_kGeneric] = ACTIONS(389),
    [sym_kCase] = ACTIONS(389),
    [sym_kFunction] = ACTIONS(389),
    [sym_kProcedure] = ACTIONS(389),
    [sym_kConstructor] = ACTIONS(389),
    [sym_kDestructor] = ACTIONS(389),
    [sym_kOperator] = ACTIONS(389),
    [sym_kPublished] = ACTIONS(389),
    [sym_kPublic] = ACTIONS(947),
    [sym_kProtected] = ACTIONS(389),
    [sym_kPrivate] = ACTIONS(389),
    [sym_kStrict] = ACTIONS(389),
    [sym_kRequired] = ACTIONS(389),
    [sym_kOptional] = ACTIONS(389),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(744),
    [sym_while] = STATE(744),
    [sym_repeat] = STATE(744),
    [sym_for] = STATE(744),
    [sym_foreach] = STATE(744),
    [sym_try] = STATE(744),
    [sym_case] = STATE(744),
    [sym_block] = STATE(744),
    [sym_asm] = STATE(744),
    [sym_with] = STATE(744),
    [sym_raise] = STATE(744),
    [sym_statement] = STATE(744),
    [sym_goto] = STATE(744),
    [sym__statement] = STATE(744),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(153),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(950),
    [sym_kEnd] = ACTIONS(291),
    [sym_kVar] = ACTIONS(291),
    [sym_kThreadvar] = ACTIONS(291),
    [sym_kConst] = ACTIONS(291),
    [sym_kResourcestring] = ACTIONS(291),
    [sym_kType] = ACTIONS(291),
    [sym_kProperty] = ACTIONS(291),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(291),
    [sym_kGeneric] = ACTIONS(291),
    [sym_kCase] = ACTIONS(291),
    [sym_kFunction] = ACTIONS(291),
    [sym_kProcedure] = ACTIONS(291),
    [sym_kConstructor] = ACTIONS(291),
    [sym_kDestructor] = ACTIONS(291),
    [sym_kOperator] = ACTIONS(291),
    [sym_kPublished] = ACTIONS(291),
    [sym_kPublic] = ACTIONS(953),
    [sym_kProtected] = ACTIONS(291),
    [sym_kPrivate] = ACTIONS(291),
    [sym_kStrict] = ACTIONS(291),
    [sym_kRequired] = ACTIONS(291),
    [sym_kOptional] = ACTIONS(291),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(127),
    [aux_sym_declVar_repeat1] = STATE(127),
    [sym_identifier] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(956),
    [sym_kEnd] = ACTIONS(438),
    [sym_kVar] = ACTIONS(438),
    [sym_kThreadvar] = ACTIONS(438),
    [sym_kConst] = ACTIONS(438),
    [sym_kResourcestring] = ACTIONS(438),
    [sym_kType] = ACTIONS(438),
    [sym_kProperty] = ACTIONS(438),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(438),
    [sym_kGeneric] = ACTIONS(438),
    [sym_kCase] = ACTIONS(438),
    [sym_kFunction] = ACTIONS(438),
    [sym_kProcedure] = ACTIONS(438),
    [sym_kConstructor] = ACTIONS(438),
    [sym_kDestructor] = ACTIONS(438),
    [sym_kOperator] = ACTIONS(438),
    [sym_kPublished] = ACTIONS(438),
    [sym_kPublic] = ACTIONS(959),
    [sym_kProtected] = ACTIONS(438),
    [sym_kPrivate] = ACTIONS(438),
    [sym_kStrict] = ACTIONS(438),
    [sym_kRequired] = ACTIONS(438),
    [sym_kOptional] = ACTIONS(438),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(793),
    [sym_while] = STATE(793),
    [sym_repeat] = STATE(793),
    [sym_for] = STATE(793),
    [sym_foreach] = STATE(793),
    [sym_try] = STATE(793),
    [sym_case] = STATE(793),
    [sym_block] = STATE(793),
    [sym_asm] = STATE(793),
    [sym_with] = STATE(793),
    [sym_raise] = STATE(793),
    [sym_statement] = STATE(793),
    [sym_goto] = STATE(793),
    [sym__statement] = STATE(793),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym__expr] = STATE(1006),
    [sym__ref] = STATE(972),
    [sym_lambda] = STATE(972),
    [sym_inherited] = STATE(972),
    [sym_exprDot] = STATE(972),
    [sym_exprDeref] = STATE(972),
    [sym_exprAs] = STATE(972),
    [sym_exprTpl] = STATE(972),
    [sym_exprSubscript] = STATE(972),
    [sym_exprCall] = STATE(972),
    [sym_exprBinary] = STATE(1006),
    [sym_exprUnary] = STATE(1006),
    [sym_exprParens] = STATE(972),
    [sym_exprBrackets] = STATE(972),
    [sym__literal] = STATE(972),
    [sym_literalString] = STATE(972),
    [sym__literalString] = STATE(907),
    [sym_literalChar] = STATE(907),
    [sym_literalNumber] = STATE(972),
    [sym__literalInt] = STATE(1032),
    [sym__literalFloat] = STATE(1032),
    [aux_sym_literalString_repeat1] = STATE(907),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(964),
    [anon_sym_POUND] = ACTIONS(966),
    [aux_sym__literalInt_token1] = ACTIONS(968),
    [aux_sym__literalInt_token2] = ACTIONS(970),
    [aux_sym__literalFloat_token1] = ACTIONS(968),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kRead] = ACTIONS(261),
    [sym_kWrite] = ACTIONS(261),
    [sym_kImplements] = ACTIONS(261),
    [sym_kDefault] = ACTIONS(261),
    [sym_kNodefault] = ACTIONS(261),
    [sym_kStored] = ACTIONS(261),
    [sym_kIndex] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(972),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(974),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(976),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(978),
    [sym_kProcedure] = ACTIONS(978),
    [sym_kInherited] = ACTIONS(980),
    [sym_kName] = ACTIONS(261),
    [sym_kDelayed] = ACTIONS(261),
    [sym_kNil] = ACTIONS(962),
    [sym_kTrue] = ACTIONS(962),
    [sym_kFalse] = ACTIONS(962),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(791),
    [sym_while] = STATE(791),
    [sym_repeat] = STATE(791),
    [sym_for] = STATE(791),
    [sym_foreach] = STATE(791),
    [sym_try] = STATE(791),
    [sym_case] = STATE(791),
    [sym_block] = STATE(791),
    [sym_asm] = STATE(791),
    [sym_with] = STATE(791),
    [sym_raise] = STATE(791),
    [sym_statement] = STATE(791),
    [sym_goto] = STATE(791),
    [sym__statement] = STATE(791),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(753),
    [sym_while] = STATE(753),
    [sym_repeat] = STATE(753),
    [sym_for] = STATE(753),
    [sym_foreach] = STATE(753),
    [sym_try] = STATE(753),
    [sym_case] = STATE(753),
    [sym_block] = STATE(753),
    [sym_asm] = STATE(753),
    [sym_with] = STATE(753),
    [sym_raise] = STATE(753),
    [sym_statement] = STATE(753),
    [sym_goto] = STATE(753),
    [sym__statement] = STATE(753),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(279),
    [sym_kRead] = ACTIONS(279),
    [sym_kWrite] = ACTIONS(279),
    [sym_kImplements] = ACTIONS(279),
    [sym_kDefault] = ACTIONS(279),
    [sym_kNodefault] = ACTIONS(279),
    [sym_kStored] = ACTIONS(279),
    [sym_kIndex] = ACTIONS(279),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(279),
    [sym_kEq] = ACTIONS(281),
    [sym_kNeq] = ACTIONS(281),
    [sym_kGt] = ACTIONS(279),
    [sym_kLte] = ACTIONS(281),
    [sym_kGte] = ACTIONS(281),
    [sym_kAdd] = ACTIONS(279),
    [sym_kSub] = ACTIONS(279),
    [sym_kMul] = ACTIONS(281),
    [sym_kFdiv] = ACTIONS(279),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(281),
    [sym_kOr] = ACTIONS(279),
    [sym_kXor] = ACTIONS(279),
    [sym_kDiv] = ACTIONS(279),
    [sym_kMod] = ACTIONS(279),
    [sym_kAnd] = ACTIONS(279),
    [sym_kShl] = ACTIONS(279),
    [sym_kShr] = ACTIONS(279),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(279),
    [sym_kAs] = ACTIONS(279),
    [sym_kIn] = ACTIONS(279),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kName] = ACTIONS(279),
    [sym_kDelayed] = ACTIONS(279),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(982),
    [sym_kEnd] = ACTIONS(452),
    [sym_kVar] = ACTIONS(452),
    [sym_kThreadvar] = ACTIONS(452),
    [sym_kConst] = ACTIONS(452),
    [sym_kResourcestring] = ACTIONS(452),
    [sym_kType] = ACTIONS(452),
    [sym_kProperty] = ACTIONS(452),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(452),
    [sym_kGeneric] = ACTIONS(452),
    [sym_kCase] = ACTIONS(452),
    [sym_kFunction] = ACTIONS(452),
    [sym_kProcedure] = ACTIONS(452),
    [sym_kConstructor] = ACTIONS(452),
    [sym_kDestructor] = ACTIONS(452),
    [sym_kOperator] = ACTIONS(452),
    [sym_kPublished] = ACTIONS(452),
    [sym_kPublic] = ACTIONS(985),
    [sym_kProtected] = ACTIONS(452),
    [sym_kPrivate] = ACTIONS(452),
    [sym_kStrict] = ACTIONS(452),
    [sym_kRequired] = ACTIONS(452),
    [sym_kOptional] = ACTIONS(452),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(136),
    [aux_sym_declVar_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(988),
    [sym_kEnd] = ACTIONS(494),
    [sym_kVar] = ACTIONS(494),
    [sym_kThreadvar] = ACTIONS(494),
    [sym_kConst] = ACTIONS(494),
    [sym_kResourcestring] = ACTIONS(494),
    [sym_kType] = ACTIONS(494),
    [sym_kProperty] = ACTIONS(494),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(494),
    [sym_kGeneric] = ACTIONS(494),
    [sym_kCase] = ACTIONS(494),
    [sym_kFunction] = ACTIONS(494),
    [sym_kProcedure] = ACTIONS(494),
    [sym_kConstructor] = ACTIONS(494),
    [sym_kDestructor] = ACTIONS(494),
    [sym_kOperator] = ACTIONS(494),
    [sym_kPublished] = ACTIONS(494),
    [sym_kPublic] = ACTIONS(991),
    [sym_kProtected] = ACTIONS(494),
    [sym_kPrivate] = ACTIONS(494),
    [sym_kStrict] = ACTIONS(494),
    [sym_kRequired] = ACTIONS(494),
    [sym_kOptional] = ACTIONS(494),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(396),
    [anon_sym_LBRACK] = ACTIONS(994),
    [sym_kEnd] = ACTIONS(396),
    [sym_kVar] = ACTIONS(396),
    [sym_kThreadvar] = ACTIONS(396),
    [sym_kConst] = ACTIONS(396),
    [sym_kResourcestring] = ACTIONS(396),
    [sym_kType] = ACTIONS(396),
    [sym_kProperty] = ACTIONS(396),
    [sym_kDefault] = ACTIONS(401),
    [sym_kNodefault] = ACTIONS(401),
    [sym_kClass] = ACTIONS(396),
    [sym_kGeneric] = ACTIONS(396),
    [sym_kCase] = ACTIONS(396),
    [sym_kFunction] = ACTIONS(396),
    [sym_kProcedure] = ACTIONS(396),
    [sym_kConstructor] = ACTIONS(396),
    [sym_kDestructor] = ACTIONS(396),
    [sym_kOperator] = ACTIONS(396),
    [sym_kPublished] = ACTIONS(396),
    [sym_kPublic] = ACTIONS(404),
    [sym_kProtected] = ACTIONS(396),
    [sym_kPrivate] = ACTIONS(396),
    [sym_kStrict] = ACTIONS(396),
    [sym_kRequired] = ACTIONS(396),
    [sym_kOptional] = ACTIONS(396),
    [sym_kStatic] = ACTIONS(401),
    [sym_kVirtual] = ACTIONS(401),
    [sym_kAbstract] = ACTIONS(401),
    [sym_kDynamic] = ACTIONS(401),
    [sym_kOverride] = ACTIONS(401),
    [sym_kOverload] = ACTIONS(401),
    [sym_kReintroduce] = ACTIONS(401),
    [sym_kInline] = ACTIONS(401),
    [sym_kStdcall] = ACTIONS(401),
    [sym_kCdecl] = ACTIONS(401),
    [sym_kCppdecl] = ACTIONS(401),
    [sym_kPascal] = ACTIONS(401),
    [sym_kRegister] = ACTIONS(401),
    [sym_kMwpascal] = ACTIONS(401),
    [sym_kExternal] = ACTIONS(997),
    [sym_kMessage] = ACTIONS(410),
    [sym_kDeprecated] = ACTIONS(413),
    [sym_kExperimental] = ACTIONS(401),
    [sym_kPlatform] = ACTIONS(401),
    [sym_kUnimplemented] = ACTIONS(401),
    [sym_kCvar] = ACTIONS(401),
    [sym_kExport] = ACTIONS(416),
    [sym_kFar] = ACTIONS(401),
    [sym_kNear] = ACTIONS(401),
    [sym_kSafecall] = ACTIONS(401),
    [sym_kAssembler] = ACTIONS(401),
    [sym_kNostackframe] = ACTIONS(401),
    [sym_kInterrupt] = ACTIONS(401),
    [sym_kNoreturn] = ACTIONS(401),
    [sym_kIocheck] = ACTIONS(401),
    [sym_kLocal] = ACTIONS(401),
    [sym_kHardfloat] = ACTIONS(401),
    [sym_kSoftfloat] = ACTIONS(401),
    [sym_kMs_abi_default] = ACTIONS(401),
    [sym_kMs_abi_cdecl] = ACTIONS(401),
    [sym_kSaveregisters] = ACTIONS(401),
    [sym_kSysv_abi_default] = ACTIONS(401),
    [sym_kSysv_abi_cdecl] = ACTIONS(401),
    [sym_kVectorcall] = ACTIONS(401),
    [sym_kVarargs] = ACTIONS(401),
    [sym_kWinapi] = ACTIONS(401),
    [sym_kAlias] = ACTIONS(419),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(160),
    [aux_sym_declVar_repeat1] = STATE(160),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(1000),
    [sym_kEnd] = ACTIONS(368),
    [sym_kVar] = ACTIONS(368),
    [sym_kThreadvar] = ACTIONS(368),
    [sym_kConst] = ACTIONS(368),
    [sym_kResourcestring] = ACTIONS(368),
    [sym_kType] = ACTIONS(368),
    [sym_kProperty] = ACTIONS(368),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(368),
    [sym_kGeneric] = ACTIONS(368),
    [sym_kCase] = ACTIONS(368),
    [sym_kFunction] = ACTIONS(368),
    [sym_kProcedure] = ACTIONS(368),
    [sym_kConstructor] = ACTIONS(368),
    [sym_kDestructor] = ACTIONS(368),
    [sym_kOperator] = ACTIONS(368),
    [sym_kPublished] = ACTIONS(368),
    [sym_kPublic] = ACTIONS(1003),
    [sym_kProtected] = ACTIONS(368),
    [sym_kPrivate] = ACTIONS(368),
    [sym_kStrict] = ACTIONS(368),
    [sym_kRequired] = ACTIONS(368),
    [sym_kOptional] = ACTIONS(368),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [sym_kEnd] = ACTIONS(480),
    [sym_kVar] = ACTIONS(480),
    [sym_kThreadvar] = ACTIONS(480),
    [sym_kConst] = ACTIONS(480),
    [sym_kResourcestring] = ACTIONS(480),
    [sym_kType] = ACTIONS(480),
    [sym_kProperty] = ACTIONS(480),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(480),
    [sym_kGeneric] = ACTIONS(480),
    [sym_kCase] = ACTIONS(480),
    [sym_kFunction] = ACTIONS(480),
    [sym_kProcedure] = ACTIONS(480),
    [sym_kConstructor] = ACTIONS(480),
    [sym_kDestructor] = ACTIONS(480),
    [sym_kOperator] = ACTIONS(480),
    [sym_kPublished] = ACTIONS(480),
    [sym_kPublic] = ACTIONS(1009),
    [sym_kProtected] = ACTIONS(480),
    [sym_kPrivate] = ACTIONS(480),
    [sym_kStrict] = ACTIONS(480),
    [sym_kRequired] = ACTIONS(480),
    [sym_kOptional] = ACTIONS(480),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(158),
    [aux_sym_declVar_repeat1] = STATE(158),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_LBRACK] = ACTIONS(1012),
    [sym_kEnd] = ACTIONS(326),
    [sym_kVar] = ACTIONS(326),
    [sym_kThreadvar] = ACTIONS(326),
    [sym_kConst] = ACTIONS(326),
    [sym_kResourcestring] = ACTIONS(326),
    [sym_kType] = ACTIONS(326),
    [sym_kProperty] = ACTIONS(326),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(326),
    [sym_kGeneric] = ACTIONS(326),
    [sym_kCase] = ACTIONS(326),
    [sym_kFunction] = ACTIONS(326),
    [sym_kProcedure] = ACTIONS(326),
    [sym_kConstructor] = ACTIONS(326),
    [sym_kDestructor] = ACTIONS(326),
    [sym_kOperator] = ACTIONS(326),
    [sym_kPublished] = ACTIONS(326),
    [sym_kPublic] = ACTIONS(1015),
    [sym_kProtected] = ACTIONS(326),
    [sym_kPrivate] = ACTIONS(326),
    [sym_kStrict] = ACTIONS(326),
    [sym_kRequired] = ACTIONS(326),
    [sym_kOptional] = ACTIONS(326),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(137),
    [aux_sym_declVar_repeat1] = STATE(137),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [sym_kEnd] = ACTIONS(487),
    [sym_kVar] = ACTIONS(487),
    [sym_kThreadvar] = ACTIONS(487),
    [sym_kConst] = ACTIONS(487),
    [sym_kResourcestring] = ACTIONS(487),
    [sym_kType] = ACTIONS(487),
    [sym_kProperty] = ACTIONS(487),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(487),
    [sym_kGeneric] = ACTIONS(487),
    [sym_kCase] = ACTIONS(487),
    [sym_kFunction] = ACTIONS(487),
    [sym_kProcedure] = ACTIONS(487),
    [sym_kConstructor] = ACTIONS(487),
    [sym_kDestructor] = ACTIONS(487),
    [sym_kOperator] = ACTIONS(487),
    [sym_kPublished] = ACTIONS(487),
    [sym_kPublic] = ACTIONS(1021),
    [sym_kProtected] = ACTIONS(487),
    [sym_kPrivate] = ACTIONS(487),
    [sym_kStrict] = ACTIONS(487),
    [sym_kRequired] = ACTIONS(487),
    [sym_kOptional] = ACTIONS(487),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(157),
    [aux_sym_declVar_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [sym_kEnd] = ACTIONS(333),
    [sym_kVar] = ACTIONS(333),
    [sym_kThreadvar] = ACTIONS(333),
    [sym_kConst] = ACTIONS(333),
    [sym_kResourcestring] = ACTIONS(333),
    [sym_kType] = ACTIONS(333),
    [sym_kProperty] = ACTIONS(333),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(333),
    [sym_kGeneric] = ACTIONS(333),
    [sym_kCase] = ACTIONS(333),
    [sym_kFunction] = ACTIONS(333),
    [sym_kProcedure] = ACTIONS(333),
    [sym_kConstructor] = ACTIONS(333),
    [sym_kDestructor] = ACTIONS(333),
    [sym_kOperator] = ACTIONS(333),
    [sym_kPublished] = ACTIONS(333),
    [sym_kPublic] = ACTIONS(1027),
    [sym_kProtected] = ACTIONS(333),
    [sym_kPrivate] = ACTIONS(333),
    [sym_kStrict] = ACTIONS(333),
    [sym_kRequired] = ACTIONS(333),
    [sym_kOptional] = ACTIONS(333),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(1030),
    [sym_kEnd] = ACTIONS(340),
    [sym_kVar] = ACTIONS(340),
    [sym_kThreadvar] = ACTIONS(340),
    [sym_kConst] = ACTIONS(340),
    [sym_kResourcestring] = ACTIONS(340),
    [sym_kType] = ACTIONS(340),
    [sym_kProperty] = ACTIONS(340),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(340),
    [sym_kGeneric] = ACTIONS(340),
    [sym_kCase] = ACTIONS(340),
    [sym_kFunction] = ACTIONS(340),
    [sym_kProcedure] = ACTIONS(340),
    [sym_kConstructor] = ACTIONS(340),
    [sym_kDestructor] = ACTIONS(340),
    [sym_kOperator] = ACTIONS(340),
    [sym_kPublished] = ACTIONS(340),
    [sym_kPublic] = ACTIONS(1033),
    [sym_kProtected] = ACTIONS(340),
    [sym_kPrivate] = ACTIONS(340),
    [sym_kStrict] = ACTIONS(340),
    [sym_kRequired] = ACTIONS(340),
    [sym_kOptional] = ACTIONS(340),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(147),
    [aux_sym_declVar_repeat1] = STATE(147),
    [sym_identifier] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [sym_kEnd] = ACTIONS(354),
    [sym_kVar] = ACTIONS(354),
    [sym_kThreadvar] = ACTIONS(354),
    [sym_kConst] = ACTIONS(354),
    [sym_kResourcestring] = ACTIONS(354),
    [sym_kType] = ACTIONS(354),
    [sym_kProperty] = ACTIONS(354),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(354),
    [sym_kGeneric] = ACTIONS(354),
    [sym_kCase] = ACTIONS(354),
    [sym_kFunction] = ACTIONS(354),
    [sym_kProcedure] = ACTIONS(354),
    [sym_kConstructor] = ACTIONS(354),
    [sym_kDestructor] = ACTIONS(354),
    [sym_kOperator] = ACTIONS(354),
    [sym_kPublished] = ACTIONS(354),
    [sym_kPublic] = ACTIONS(1039),
    [sym_kProtected] = ACTIONS(354),
    [sym_kPrivate] = ACTIONS(354),
    [sym_kStrict] = ACTIONS(354),
    [sym_kRequired] = ACTIONS(354),
    [sym_kOptional] = ACTIONS(354),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(1042),
    [sym_kEnd] = ACTIONS(445),
    [sym_kVar] = ACTIONS(445),
    [sym_kThreadvar] = ACTIONS(445),
    [sym_kConst] = ACTIONS(445),
    [sym_kResourcestring] = ACTIONS(445),
    [sym_kType] = ACTIONS(445),
    [sym_kProperty] = ACTIONS(445),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(445),
    [sym_kGeneric] = ACTIONS(445),
    [sym_kCase] = ACTIONS(445),
    [sym_kFunction] = ACTIONS(445),
    [sym_kProcedure] = ACTIONS(445),
    [sym_kConstructor] = ACTIONS(445),
    [sym_kDestructor] = ACTIONS(445),
    [sym_kOperator] = ACTIONS(445),
    [sym_kPublished] = ACTIONS(445),
    [sym_kPublic] = ACTIONS(1045),
    [sym_kProtected] = ACTIONS(445),
    [sym_kPrivate] = ACTIONS(445),
    [sym_kStrict] = ACTIONS(445),
    [sym_kRequired] = ACTIONS(445),
    [sym_kOptional] = ACTIONS(445),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(424),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [sym_kEnd] = ACTIONS(424),
    [sym_kVar] = ACTIONS(424),
    [sym_kThreadvar] = ACTIONS(424),
    [sym_kConst] = ACTIONS(424),
    [sym_kResourcestring] = ACTIONS(424),
    [sym_kType] = ACTIONS(424),
    [sym_kProperty] = ACTIONS(424),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(424),
    [sym_kGeneric] = ACTIONS(424),
    [sym_kCase] = ACTIONS(424),
    [sym_kFunction] = ACTIONS(424),
    [sym_kProcedure] = ACTIONS(424),
    [sym_kConstructor] = ACTIONS(424),
    [sym_kDestructor] = ACTIONS(424),
    [sym_kOperator] = ACTIONS(424),
    [sym_kPublished] = ACTIONS(424),
    [sym_kPublic] = ACTIONS(1051),
    [sym_kProtected] = ACTIONS(424),
    [sym_kPrivate] = ACTIONS(424),
    [sym_kStrict] = ACTIONS(424),
    [sym_kRequired] = ACTIONS(424),
    [sym_kOptional] = ACTIONS(424),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(140),
    [aux_sym_declVar_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(1054),
    [sym_kEnd] = ACTIONS(466),
    [sym_kVar] = ACTIONS(466),
    [sym_kThreadvar] = ACTIONS(466),
    [sym_kConst] = ACTIONS(466),
    [sym_kResourcestring] = ACTIONS(466),
    [sym_kType] = ACTIONS(466),
    [sym_kProperty] = ACTIONS(466),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(466),
    [sym_kGeneric] = ACTIONS(466),
    [sym_kCase] = ACTIONS(466),
    [sym_kFunction] = ACTIONS(466),
    [sym_kProcedure] = ACTIONS(466),
    [sym_kConstructor] = ACTIONS(466),
    [sym_kDestructor] = ACTIONS(466),
    [sym_kOperator] = ACTIONS(466),
    [sym_kPublished] = ACTIONS(466),
    [sym_kPublic] = ACTIONS(1057),
    [sym_kProtected] = ACTIONS(466),
    [sym_kPrivate] = ACTIONS(466),
    [sym_kStrict] = ACTIONS(466),
    [sym_kRequired] = ACTIONS(466),
    [sym_kOptional] = ACTIONS(466),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym__procAttribute] = STATE(456),
    [sym_procAttribute] = STATE(2249),
    [sym_procExternal] = STATE(149),
    [aux_sym_declVar_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [sym_kEnd] = ACTIONS(312),
    [sym_kVar] = ACTIONS(312),
    [sym_kThreadvar] = ACTIONS(312),
    [sym_kConst] = ACTIONS(312),
    [sym_kResourcestring] = ACTIONS(312),
    [sym_kType] = ACTIONS(312),
    [sym_kProperty] = ACTIONS(312),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(312),
    [sym_kGeneric] = ACTIONS(312),
    [sym_kCase] = ACTIONS(312),
    [sym_kFunction] = ACTIONS(312),
    [sym_kProcedure] = ACTIONS(312),
    [sym_kConstructor] = ACTIONS(312),
    [sym_kDestructor] = ACTIONS(312),
    [sym_kOperator] = ACTIONS(312),
    [sym_kPublished] = ACTIONS(312),
    [sym_kPublic] = ACTIONS(1063),
    [sym_kProtected] = ACTIONS(312),
    [sym_kPrivate] = ACTIONS(312),
    [sym_kStrict] = ACTIONS(312),
    [sym_kRequired] = ACTIONS(312),
    [sym_kOptional] = ACTIONS(312),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kExternal] = ACTIONS(869),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(131),
    [ts_builtin_sym_end] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [sym_kUses] = ACTIONS(1066),
    [sym_kInterface] = ACTIONS(1066),
    [sym_kImplementation] = ACTIONS(1066),
    [sym_kInitialization] = ACTIONS(1066),
    [sym_kFinalization] = ACTIONS(1066),
    [sym_kBegin] = ACTIONS(1066),
    [sym_kEnd] = ACTIONS(1066),
    [sym_kAsm] = ACTIONS(1066),
    [sym_kVar] = ACTIONS(1071),
    [sym_kThreadvar] = ACTIONS(1066),
    [sym_kConst] = ACTIONS(1071),
    [sym_kResourcestring] = ACTIONS(1066),
    [sym_kType] = ACTIONS(1066),
    [sym_kLabel] = ACTIONS(1066),
    [sym_kExports] = ACTIONS(1066),
    [sym_kProperty] = ACTIONS(1066),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1066),
    [sym_kGeneric] = ACTIONS(1066),
    [sym_kFunction] = ACTIONS(1066),
    [sym_kProcedure] = ACTIONS(1066),
    [sym_kConstructor] = ACTIONS(1066),
    [sym_kDestructor] = ACTIONS(1066),
    [sym_kOperator] = ACTIONS(1066),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(1414),
    [sym_while] = STATE(1414),
    [sym_repeat] = STATE(1414),
    [sym_for] = STATE(1414),
    [sym_foreach] = STATE(1414),
    [sym_try] = STATE(1414),
    [sym_case] = STATE(1414),
    [sym_block] = STATE(1414),
    [sym_asm] = STATE(1414),
    [sym_with] = STATE(1414),
    [sym_raise] = STATE(1414),
    [sym_statement] = STATE(1414),
    [sym_goto] = STATE(1414),
    [sym__statement] = STATE(1414),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(795),
    [sym_while] = STATE(795),
    [sym_repeat] = STATE(795),
    [sym_for] = STATE(795),
    [sym_foreach] = STATE(795),
    [sym_try] = STATE(795),
    [sym_case] = STATE(795),
    [sym_block] = STATE(795),
    [sym_asm] = STATE(795),
    [sym_with] = STATE(795),
    [sym_raise] = STATE(795),
    [sym_statement] = STATE(795),
    [sym_goto] = STATE(795),
    [sym__statement] = STATE(795),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_if] = STATE(797),
    [sym_ifElse] = STATE(808),
    [sym_while] = STATE(808),
    [sym_repeat] = STATE(808),
    [sym_for] = STATE(808),
    [sym_foreach] = STATE(808),
    [sym_try] = STATE(808),
    [sym_case] = STATE(808),
    [sym_block] = STATE(808),
    [sym_asm] = STATE(808),
    [sym_with] = STATE(808),
    [sym_raise] = STATE(808),
    [sym_statement] = STATE(808),
    [sym_goto] = STATE(808),
    [sym__statement] = STATE(808),
    [sym_assignment] = STATE(2267),
    [sym_varAssignDef] = STATE(1716),
    [sym_varDef] = STATE(2267),
    [sym__expr] = STATE(1247),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(1247),
    [sym_exprUnary] = STATE(1247),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [sym_kBegin] = ACTIONS(579),
    [sym_kAsm] = ACTIONS(581),
    [sym_kVar] = ACTIONS(63),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kAdd] = ACTIONS(67),
    [sym_kSub] = ACTIONS(67),
    [sym_kAt] = ACTIONS(69),
    [sym_kNot] = ACTIONS(67),
    [sym_kFor] = ACTIONS(583),
    [sym_kIf] = ACTIONS(585),
    [sym_kWhile] = ACTIONS(587),
    [sym_kRepeat] = ACTIONS(589),
    [sym_kTry] = ACTIONS(591),
    [sym_kRaise] = ACTIONS(593),
    [sym_kCase] = ACTIONS(595),
    [sym_kWith] = ACTIONS(597),
    [sym_kGoto] = ACTIONS(599),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(180),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_kUses] = ACTIONS(1076),
    [sym_kInterface] = ACTIONS(1076),
    [sym_kImplementation] = ACTIONS(1076),
    [sym_kInitialization] = ACTIONS(1076),
    [sym_kFinalization] = ACTIONS(1076),
    [sym_kEnd] = ACTIONS(1076),
    [sym_kVar] = ACTIONS(1078),
    [sym_kThreadvar] = ACTIONS(1076),
    [sym_kConst] = ACTIONS(1078),
    [sym_kResourcestring] = ACTIONS(1076),
    [sym_kType] = ACTIONS(1076),
    [sym_kLabel] = ACTIONS(1076),
    [sym_kExports] = ACTIONS(1076),
    [sym_kProperty] = ACTIONS(1076),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1076),
    [sym_kGeneric] = ACTIONS(1076),
    [sym_kFunction] = ACTIONS(1076),
    [sym_kProcedure] = ACTIONS(1076),
    [sym_kConstructor] = ACTIONS(1076),
    [sym_kDestructor] = ACTIONS(1076),
    [sym_kOperator] = ACTIONS(1076),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1076),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1076),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(216),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [sym_kUses] = ACTIONS(1083),
    [sym_kInterface] = ACTIONS(1083),
    [sym_kImplementation] = ACTIONS(1083),
    [sym_kInitialization] = ACTIONS(1083),
    [sym_kFinalization] = ACTIONS(1083),
    [sym_kEnd] = ACTIONS(1083),
    [sym_kVar] = ACTIONS(1085),
    [sym_kThreadvar] = ACTIONS(1083),
    [sym_kConst] = ACTIONS(1085),
    [sym_kResourcestring] = ACTIONS(1083),
    [sym_kType] = ACTIONS(1083),
    [sym_kLabel] = ACTIONS(1083),
    [sym_kExports] = ACTIONS(1083),
    [sym_kProperty] = ACTIONS(1083),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1083),
    [sym_kGeneric] = ACTIONS(1083),
    [sym_kFunction] = ACTIONS(1083),
    [sym_kProcedure] = ACTIONS(1083),
    [sym_kConstructor] = ACTIONS(1083),
    [sym_kDestructor] = ACTIONS(1083),
    [sym_kOperator] = ACTIONS(1083),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1083),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1083),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(207),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [sym_kUses] = ACTIONS(1090),
    [sym_kInterface] = ACTIONS(1090),
    [sym_kImplementation] = ACTIONS(1090),
    [sym_kInitialization] = ACTIONS(1090),
    [sym_kFinalization] = ACTIONS(1090),
    [sym_kEnd] = ACTIONS(1090),
    [sym_kVar] = ACTIONS(1092),
    [sym_kThreadvar] = ACTIONS(1090),
    [sym_kConst] = ACTIONS(1092),
    [sym_kResourcestring] = ACTIONS(1090),
    [sym_kType] = ACTIONS(1090),
    [sym_kLabel] = ACTIONS(1090),
    [sym_kExports] = ACTIONS(1090),
    [sym_kProperty] = ACTIONS(1090),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1090),
    [sym_kGeneric] = ACTIONS(1090),
    [sym_kFunction] = ACTIONS(1090),
    [sym_kProcedure] = ACTIONS(1090),
    [sym_kConstructor] = ACTIONS(1090),
    [sym_kDestructor] = ACTIONS(1090),
    [sym_kOperator] = ACTIONS(1090),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1090),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1090),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [sym_kUses] = ACTIONS(1097),
    [sym_kInterface] = ACTIONS(1097),
    [sym_kImplementation] = ACTIONS(1097),
    [sym_kInitialization] = ACTIONS(1097),
    [sym_kFinalization] = ACTIONS(1097),
    [sym_kEnd] = ACTIONS(1097),
    [sym_kVar] = ACTIONS(1099),
    [sym_kThreadvar] = ACTIONS(1097),
    [sym_kConst] = ACTIONS(1099),
    [sym_kResourcestring] = ACTIONS(1097),
    [sym_kType] = ACTIONS(1097),
    [sym_kLabel] = ACTIONS(1097),
    [sym_kExports] = ACTIONS(1097),
    [sym_kProperty] = ACTIONS(1097),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1097),
    [sym_kGeneric] = ACTIONS(1097),
    [sym_kFunction] = ACTIONS(1097),
    [sym_kProcedure] = ACTIONS(1097),
    [sym_kConstructor] = ACTIONS(1097),
    [sym_kDestructor] = ACTIONS(1097),
    [sym_kOperator] = ACTIONS(1097),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1097),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1097),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(209),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [sym_kUses] = ACTIONS(1104),
    [sym_kInterface] = ACTIONS(1104),
    [sym_kImplementation] = ACTIONS(1104),
    [sym_kInitialization] = ACTIONS(1104),
    [sym_kFinalization] = ACTIONS(1104),
    [sym_kEnd] = ACTIONS(1104),
    [sym_kVar] = ACTIONS(1106),
    [sym_kThreadvar] = ACTIONS(1104),
    [sym_kConst] = ACTIONS(1106),
    [sym_kResourcestring] = ACTIONS(1104),
    [sym_kType] = ACTIONS(1104),
    [sym_kLabel] = ACTIONS(1104),
    [sym_kExports] = ACTIONS(1104),
    [sym_kProperty] = ACTIONS(1104),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1104),
    [sym_kGeneric] = ACTIONS(1104),
    [sym_kFunction] = ACTIONS(1104),
    [sym_kProcedure] = ACTIONS(1104),
    [sym_kConstructor] = ACTIONS(1104),
    [sym_kDestructor] = ACTIONS(1104),
    [sym_kOperator] = ACTIONS(1104),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1104),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1104),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [sym_kUses] = ACTIONS(1111),
    [sym_kInterface] = ACTIONS(1111),
    [sym_kImplementation] = ACTIONS(1111),
    [sym_kInitialization] = ACTIONS(1111),
    [sym_kFinalization] = ACTIONS(1111),
    [sym_kEnd] = ACTIONS(1111),
    [sym_kVar] = ACTIONS(1113),
    [sym_kThreadvar] = ACTIONS(1111),
    [sym_kConst] = ACTIONS(1113),
    [sym_kResourcestring] = ACTIONS(1111),
    [sym_kType] = ACTIONS(1111),
    [sym_kLabel] = ACTIONS(1111),
    [sym_kExports] = ACTIONS(1111),
    [sym_kProperty] = ACTIONS(1111),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1111),
    [sym_kGeneric] = ACTIONS(1111),
    [sym_kFunction] = ACTIONS(1111),
    [sym_kProcedure] = ACTIONS(1111),
    [sym_kConstructor] = ACTIONS(1111),
    [sym_kDestructor] = ACTIONS(1111),
    [sym_kOperator] = ACTIONS(1111),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1111),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1111),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [sym_kUses] = ACTIONS(1118),
    [sym_kInterface] = ACTIONS(1118),
    [sym_kImplementation] = ACTIONS(1118),
    [sym_kInitialization] = ACTIONS(1118),
    [sym_kFinalization] = ACTIONS(1118),
    [sym_kEnd] = ACTIONS(1118),
    [sym_kVar] = ACTIONS(1120),
    [sym_kThreadvar] = ACTIONS(1118),
    [sym_kConst] = ACTIONS(1120),
    [sym_kResourcestring] = ACTIONS(1118),
    [sym_kType] = ACTIONS(1118),
    [sym_kLabel] = ACTIONS(1118),
    [sym_kExports] = ACTIONS(1118),
    [sym_kProperty] = ACTIONS(1118),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1118),
    [sym_kGeneric] = ACTIONS(1118),
    [sym_kFunction] = ACTIONS(1118),
    [sym_kProcedure] = ACTIONS(1118),
    [sym_kConstructor] = ACTIONS(1118),
    [sym_kDestructor] = ACTIONS(1118),
    [sym_kOperator] = ACTIONS(1118),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1118),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1118),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(215),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [sym_kUses] = ACTIONS(1125),
    [sym_kInterface] = ACTIONS(1125),
    [sym_kImplementation] = ACTIONS(1125),
    [sym_kInitialization] = ACTIONS(1125),
    [sym_kFinalization] = ACTIONS(1125),
    [sym_kEnd] = ACTIONS(1125),
    [sym_kVar] = ACTIONS(1127),
    [sym_kThreadvar] = ACTIONS(1125),
    [sym_kConst] = ACTIONS(1127),
    [sym_kResourcestring] = ACTIONS(1125),
    [sym_kType] = ACTIONS(1125),
    [sym_kLabel] = ACTIONS(1125),
    [sym_kExports] = ACTIONS(1125),
    [sym_kProperty] = ACTIONS(1125),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1125),
    [sym_kGeneric] = ACTIONS(1125),
    [sym_kFunction] = ACTIONS(1125),
    [sym_kProcedure] = ACTIONS(1125),
    [sym_kConstructor] = ACTIONS(1125),
    [sym_kDestructor] = ACTIONS(1125),
    [sym_kOperator] = ACTIONS(1125),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1125),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1125),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(219),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [sym_kUses] = ACTIONS(1132),
    [sym_kInterface] = ACTIONS(1132),
    [sym_kImplementation] = ACTIONS(1132),
    [sym_kInitialization] = ACTIONS(1132),
    [sym_kFinalization] = ACTIONS(1132),
    [sym_kEnd] = ACTIONS(1132),
    [sym_kVar] = ACTIONS(1134),
    [sym_kThreadvar] = ACTIONS(1132),
    [sym_kConst] = ACTIONS(1134),
    [sym_kResourcestring] = ACTIONS(1132),
    [sym_kType] = ACTIONS(1132),
    [sym_kLabel] = ACTIONS(1132),
    [sym_kExports] = ACTIONS(1132),
    [sym_kProperty] = ACTIONS(1132),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1132),
    [sym_kGeneric] = ACTIONS(1132),
    [sym_kFunction] = ACTIONS(1132),
    [sym_kProcedure] = ACTIONS(1132),
    [sym_kConstructor] = ACTIONS(1132),
    [sym_kDestructor] = ACTIONS(1132),
    [sym_kOperator] = ACTIONS(1132),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1132),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1132),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1136),
    [sym_kUses] = ACTIONS(1139),
    [sym_kInterface] = ACTIONS(1139),
    [sym_kImplementation] = ACTIONS(1139),
    [sym_kInitialization] = ACTIONS(1139),
    [sym_kFinalization] = ACTIONS(1139),
    [sym_kEnd] = ACTIONS(1139),
    [sym_kVar] = ACTIONS(1141),
    [sym_kThreadvar] = ACTIONS(1139),
    [sym_kConst] = ACTIONS(1141),
    [sym_kResourcestring] = ACTIONS(1139),
    [sym_kType] = ACTIONS(1139),
    [sym_kLabel] = ACTIONS(1139),
    [sym_kExports] = ACTIONS(1139),
    [sym_kProperty] = ACTIONS(1139),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1139),
    [sym_kGeneric] = ACTIONS(1139),
    [sym_kFunction] = ACTIONS(1139),
    [sym_kProcedure] = ACTIONS(1139),
    [sym_kConstructor] = ACTIONS(1139),
    [sym_kDestructor] = ACTIONS(1139),
    [sym_kOperator] = ACTIONS(1139),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1139),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1139),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [sym_kUses] = ACTIONS(1146),
    [sym_kInterface] = ACTIONS(1146),
    [sym_kImplementation] = ACTIONS(1146),
    [sym_kInitialization] = ACTIONS(1146),
    [sym_kFinalization] = ACTIONS(1146),
    [sym_kEnd] = ACTIONS(1146),
    [sym_kVar] = ACTIONS(1148),
    [sym_kThreadvar] = ACTIONS(1146),
    [sym_kConst] = ACTIONS(1148),
    [sym_kResourcestring] = ACTIONS(1146),
    [sym_kType] = ACTIONS(1146),
    [sym_kLabel] = ACTIONS(1146),
    [sym_kExports] = ACTIONS(1146),
    [sym_kProperty] = ACTIONS(1146),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1146),
    [sym_kGeneric] = ACTIONS(1146),
    [sym_kFunction] = ACTIONS(1146),
    [sym_kProcedure] = ACTIONS(1146),
    [sym_kConstructor] = ACTIONS(1146),
    [sym_kDestructor] = ACTIONS(1146),
    [sym_kOperator] = ACTIONS(1146),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1146),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1146),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1150),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_RBRACK] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [sym_kUses] = ACTIONS(1152),
    [anon_sym_DOT] = ACTIONS(1150),
    [sym_kBegin] = ACTIONS(1152),
    [sym_kEnd] = ACTIONS(1152),
    [sym_kAsm] = ACTIONS(1152),
    [sym_kVar] = ACTIONS(1152),
    [sym_kThreadvar] = ACTIONS(1152),
    [sym_kConst] = ACTIONS(1152),
    [sym_kResourcestring] = ACTIONS(1152),
    [sym_kType] = ACTIONS(1152),
    [sym_kLabel] = ACTIONS(1152),
    [sym_kExports] = ACTIONS(1152),
    [sym_kProperty] = ACTIONS(1152),
    [sym_kClass] = ACTIONS(1152),
    [sym_kOf] = ACTIONS(1152),
    [sym_kGeneric] = ACTIONS(1152),
    [sym_kLt] = ACTIONS(1152),
    [sym_kEq] = ACTIONS(1150),
    [sym_kNeq] = ACTIONS(1150),
    [sym_kGt] = ACTIONS(1152),
    [sym_kLte] = ACTIONS(1150),
    [sym_kGte] = ACTIONS(1150),
    [sym_kAdd] = ACTIONS(1152),
    [sym_kSub] = ACTIONS(1152),
    [sym_kMul] = ACTIONS(1152),
    [sym_kFdiv] = ACTIONS(1152),
    [sym_kHat] = ACTIONS(1150),
    [sym_kAssign] = ACTIONS(1150),
    [sym_kAssignAdd] = ACTIONS(1150),
    [sym_kAssignSub] = ACTIONS(1150),
    [sym_kAssignMul] = ACTIONS(1150),
    [sym_kAssignDiv] = ACTIONS(1150),
    [sym_kOr] = ACTIONS(1152),
    [sym_kXor] = ACTIONS(1152),
    [sym_kDiv] = ACTIONS(1152),
    [sym_kMod] = ACTIONS(1152),
    [sym_kAnd] = ACTIONS(1152),
    [sym_kShl] = ACTIONS(1152),
    [sym_kShr] = ACTIONS(1152),
    [sym_kIs] = ACTIONS(1152),
    [sym_kAs] = ACTIONS(1152),
    [sym_kIn] = ACTIONS(1152),
    [sym_kThen] = ACTIONS(1152),
    [sym_kElse] = ACTIONS(1152),
    [sym_kDo] = ACTIONS(1152),
    [sym_kUntil] = ACTIONS(1152),
    [sym_kExcept] = ACTIONS(1152),
    [sym_kFinally] = ACTIONS(1152),
    [sym_kCase] = ACTIONS(1152),
    [sym_kFunction] = ACTIONS(1152),
    [sym_kProcedure] = ACTIONS(1152),
    [sym_kConstructor] = ACTIONS(1152),
    [sym_kDestructor] = ACTIONS(1152),
    [sym_kOperator] = ACTIONS(1152),
    [sym_kPublished] = ACTIONS(1152),
    [sym_kPublic] = ACTIONS(1152),
    [sym_kProtected] = ACTIONS(1152),
    [sym_kPrivate] = ACTIONS(1152),
    [sym_kStrict] = ACTIONS(1152),
    [sym_kRequired] = ACTIONS(1152),
    [sym_kOptional] = ACTIONS(1152),
    [sym_kDelayed] = ACTIONS(1152),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(217),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [sym_kUses] = ACTIONS(1157),
    [sym_kInterface] = ACTIONS(1157),
    [sym_kImplementation] = ACTIONS(1157),
    [sym_kInitialization] = ACTIONS(1157),
    [sym_kFinalization] = ACTIONS(1157),
    [sym_kEnd] = ACTIONS(1157),
    [sym_kVar] = ACTIONS(1159),
    [sym_kThreadvar] = ACTIONS(1157),
    [sym_kConst] = ACTIONS(1159),
    [sym_kResourcestring] = ACTIONS(1157),
    [sym_kType] = ACTIONS(1157),
    [sym_kLabel] = ACTIONS(1157),
    [sym_kExports] = ACTIONS(1157),
    [sym_kProperty] = ACTIONS(1157),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1157),
    [sym_kGeneric] = ACTIONS(1157),
    [sym_kFunction] = ACTIONS(1157),
    [sym_kProcedure] = ACTIONS(1157),
    [sym_kConstructor] = ACTIONS(1157),
    [sym_kDestructor] = ACTIONS(1157),
    [sym_kOperator] = ACTIONS(1157),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1157),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1157),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [sym_kUses] = ACTIONS(1164),
    [sym_kInterface] = ACTIONS(1164),
    [sym_kImplementation] = ACTIONS(1164),
    [sym_kInitialization] = ACTIONS(1164),
    [sym_kFinalization] = ACTIONS(1164),
    [sym_kEnd] = ACTIONS(1164),
    [sym_kVar] = ACTIONS(1166),
    [sym_kThreadvar] = ACTIONS(1164),
    [sym_kConst] = ACTIONS(1166),
    [sym_kResourcestring] = ACTIONS(1164),
    [sym_kType] = ACTIONS(1164),
    [sym_kLabel] = ACTIONS(1164),
    [sym_kExports] = ACTIONS(1164),
    [sym_kProperty] = ACTIONS(1164),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1164),
    [sym_kGeneric] = ACTIONS(1164),
    [sym_kFunction] = ACTIONS(1164),
    [sym_kProcedure] = ACTIONS(1164),
    [sym_kConstructor] = ACTIONS(1164),
    [sym_kDestructor] = ACTIONS(1164),
    [sym_kOperator] = ACTIONS(1164),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1164),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1164),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(1168),
    [sym_identifier] = ACTIONS(1170),
    [anon_sym_SEMI] = ACTIONS(1168),
    [anon_sym_COLON] = ACTIONS(1170),
    [anon_sym_COMMA] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1168),
    [anon_sym_RBRACK] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [sym_kUses] = ACTIONS(1170),
    [anon_sym_DOT] = ACTIONS(1168),
    [sym_kBegin] = ACTIONS(1170),
    [sym_kEnd] = ACTIONS(1170),
    [sym_kAsm] = ACTIONS(1170),
    [sym_kVar] = ACTIONS(1170),
    [sym_kThreadvar] = ACTIONS(1170),
    [sym_kConst] = ACTIONS(1170),
    [sym_kResourcestring] = ACTIONS(1170),
    [sym_kType] = ACTIONS(1170),
    [sym_kLabel] = ACTIONS(1170),
    [sym_kExports] = ACTIONS(1170),
    [sym_kProperty] = ACTIONS(1170),
    [sym_kClass] = ACTIONS(1170),
    [sym_kOf] = ACTIONS(1170),
    [sym_kGeneric] = ACTIONS(1170),
    [sym_kLt] = ACTIONS(1170),
    [sym_kEq] = ACTIONS(1168),
    [sym_kNeq] = ACTIONS(1168),
    [sym_kGt] = ACTIONS(1170),
    [sym_kLte] = ACTIONS(1168),
    [sym_kGte] = ACTIONS(1168),
    [sym_kAdd] = ACTIONS(1170),
    [sym_kSub] = ACTIONS(1170),
    [sym_kMul] = ACTIONS(1170),
    [sym_kFdiv] = ACTIONS(1170),
    [sym_kHat] = ACTIONS(1168),
    [sym_kAssign] = ACTIONS(1168),
    [sym_kAssignAdd] = ACTIONS(1168),
    [sym_kAssignSub] = ACTIONS(1168),
    [sym_kAssignMul] = ACTIONS(1168),
    [sym_kAssignDiv] = ACTIONS(1168),
    [sym_kOr] = ACTIONS(1170),
    [sym_kXor] = ACTIONS(1170),
    [sym_kDiv] = ACTIONS(1170),
    [sym_kMod] = ACTIONS(1170),
    [sym_kAnd] = ACTIONS(1170),
    [sym_kShl] = ACTIONS(1170),
    [sym_kShr] = ACTIONS(1170),
    [sym_kIs] = ACTIONS(1170),
    [sym_kAs] = ACTIONS(1170),
    [sym_kIn] = ACTIONS(1170),
    [sym_kThen] = ACTIONS(1170),
    [sym_kElse] = ACTIONS(1170),
    [sym_kDo] = ACTIONS(1170),
    [sym_kUntil] = ACTIONS(1170),
    [sym_kExcept] = ACTIONS(1170),
    [sym_kFinally] = ACTIONS(1170),
    [sym_kCase] = ACTIONS(1170),
    [sym_kFunction] = ACTIONS(1170),
    [sym_kProcedure] = ACTIONS(1170),
    [sym_kConstructor] = ACTIONS(1170),
    [sym_kDestructor] = ACTIONS(1170),
    [sym_kOperator] = ACTIONS(1170),
    [sym_kPublished] = ACTIONS(1170),
    [sym_kPublic] = ACTIONS(1170),
    [sym_kProtected] = ACTIONS(1170),
    [sym_kPrivate] = ACTIONS(1170),
    [sym_kStrict] = ACTIONS(1170),
    [sym_kRequired] = ACTIONS(1170),
    [sym_kOptional] = ACTIONS(1170),
    [sym_kDelayed] = ACTIONS(1170),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [sym_kUses] = ACTIONS(1175),
    [sym_kInterface] = ACTIONS(1175),
    [sym_kImplementation] = ACTIONS(1175),
    [sym_kInitialization] = ACTIONS(1175),
    [sym_kFinalization] = ACTIONS(1175),
    [sym_kEnd] = ACTIONS(1175),
    [sym_kVar] = ACTIONS(1177),
    [sym_kThreadvar] = ACTIONS(1175),
    [sym_kConst] = ACTIONS(1177),
    [sym_kResourcestring] = ACTIONS(1175),
    [sym_kType] = ACTIONS(1175),
    [sym_kLabel] = ACTIONS(1175),
    [sym_kExports] = ACTIONS(1175),
    [sym_kProperty] = ACTIONS(1175),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1175),
    [sym_kGeneric] = ACTIONS(1175),
    [sym_kFunction] = ACTIONS(1175),
    [sym_kProcedure] = ACTIONS(1175),
    [sym_kConstructor] = ACTIONS(1175),
    [sym_kDestructor] = ACTIONS(1175),
    [sym_kOperator] = ACTIONS(1175),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1175),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1175),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(220),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_kUses] = ACTIONS(1182),
    [sym_kInterface] = ACTIONS(1182),
    [sym_kImplementation] = ACTIONS(1182),
    [sym_kInitialization] = ACTIONS(1182),
    [sym_kFinalization] = ACTIONS(1182),
    [sym_kEnd] = ACTIONS(1182),
    [sym_kVar] = ACTIONS(1184),
    [sym_kThreadvar] = ACTIONS(1182),
    [sym_kConst] = ACTIONS(1184),
    [sym_kResourcestring] = ACTIONS(1182),
    [sym_kType] = ACTIONS(1182),
    [sym_kLabel] = ACTIONS(1182),
    [sym_kExports] = ACTIONS(1182),
    [sym_kProperty] = ACTIONS(1182),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1182),
    [sym_kGeneric] = ACTIONS(1182),
    [sym_kFunction] = ACTIONS(1182),
    [sym_kProcedure] = ACTIONS(1182),
    [sym_kConstructor] = ACTIONS(1182),
    [sym_kDestructor] = ACTIONS(1182),
    [sym_kOperator] = ACTIONS(1182),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1182),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1182),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(204),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [sym_kUses] = ACTIONS(1189),
    [sym_kInterface] = ACTIONS(1189),
    [sym_kImplementation] = ACTIONS(1189),
    [sym_kInitialization] = ACTIONS(1189),
    [sym_kFinalization] = ACTIONS(1189),
    [sym_kEnd] = ACTIONS(1189),
    [sym_kVar] = ACTIONS(1191),
    [sym_kThreadvar] = ACTIONS(1189),
    [sym_kConst] = ACTIONS(1191),
    [sym_kResourcestring] = ACTIONS(1189),
    [sym_kType] = ACTIONS(1189),
    [sym_kLabel] = ACTIONS(1189),
    [sym_kExports] = ACTIONS(1189),
    [sym_kProperty] = ACTIONS(1189),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1189),
    [sym_kGeneric] = ACTIONS(1189),
    [sym_kFunction] = ACTIONS(1189),
    [sym_kProcedure] = ACTIONS(1189),
    [sym_kConstructor] = ACTIONS(1189),
    [sym_kDestructor] = ACTIONS(1189),
    [sym_kOperator] = ACTIONS(1189),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1189),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1189),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [sym_kUses] = ACTIONS(1196),
    [sym_kInterface] = ACTIONS(1196),
    [sym_kImplementation] = ACTIONS(1196),
    [sym_kInitialization] = ACTIONS(1196),
    [sym_kFinalization] = ACTIONS(1196),
    [sym_kEnd] = ACTIONS(1196),
    [sym_kVar] = ACTIONS(1198),
    [sym_kThreadvar] = ACTIONS(1196),
    [sym_kConst] = ACTIONS(1198),
    [sym_kResourcestring] = ACTIONS(1196),
    [sym_kType] = ACTIONS(1196),
    [sym_kLabel] = ACTIONS(1196),
    [sym_kExports] = ACTIONS(1196),
    [sym_kProperty] = ACTIONS(1196),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1196),
    [sym_kGeneric] = ACTIONS(1196),
    [sym_kFunction] = ACTIONS(1196),
    [sym_kProcedure] = ACTIONS(1196),
    [sym_kConstructor] = ACTIONS(1196),
    [sym_kDestructor] = ACTIONS(1196),
    [sym_kOperator] = ACTIONS(1196),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1196),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1196),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(1200),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [sym_kUses] = ACTIONS(1202),
    [sym_kInterface] = ACTIONS(1202),
    [sym_kImplementation] = ACTIONS(1202),
    [sym_kInitialization] = ACTIONS(1202),
    [sym_kFinalization] = ACTIONS(1202),
    [sym_kBegin] = ACTIONS(1202),
    [sym_kEnd] = ACTIONS(1202),
    [sym_kAsm] = ACTIONS(1202),
    [sym_kVar] = ACTIONS(1202),
    [sym_kThreadvar] = ACTIONS(1202),
    [sym_kConst] = ACTIONS(1202),
    [sym_kResourcestring] = ACTIONS(1202),
    [sym_kType] = ACTIONS(1202),
    [sym_kLabel] = ACTIONS(1202),
    [sym_kExports] = ACTIONS(1202),
    [sym_kProperty] = ACTIONS(1202),
    [sym_kDefault] = ACTIONS(1202),
    [sym_kNodefault] = ACTIONS(1202),
    [sym_kClass] = ACTIONS(1202),
    [sym_kGeneric] = ACTIONS(1202),
    [sym_kFunction] = ACTIONS(1202),
    [sym_kProcedure] = ACTIONS(1202),
    [sym_kConstructor] = ACTIONS(1202),
    [sym_kDestructor] = ACTIONS(1202),
    [sym_kOperator] = ACTIONS(1202),
    [sym_kPublic] = ACTIONS(1202),
    [sym_kStatic] = ACTIONS(1202),
    [sym_kVirtual] = ACTIONS(1202),
    [sym_kAbstract] = ACTIONS(1202),
    [sym_kDynamic] = ACTIONS(1202),
    [sym_kOverride] = ACTIONS(1202),
    [sym_kOverload] = ACTIONS(1202),
    [sym_kReintroduce] = ACTIONS(1202),
    [sym_kInline] = ACTIONS(1202),
    [sym_kStdcall] = ACTIONS(1202),
    [sym_kCdecl] = ACTIONS(1202),
    [sym_kCppdecl] = ACTIONS(1202),
    [sym_kPascal] = ACTIONS(1202),
    [sym_kRegister] = ACTIONS(1202),
    [sym_kMwpascal] = ACTIONS(1202),
    [sym_kExternal] = ACTIONS(1202),
    [sym_kMessage] = ACTIONS(1202),
    [sym_kDeprecated] = ACTIONS(1202),
    [sym_kExperimental] = ACTIONS(1202),
    [sym_kPlatform] = ACTIONS(1202),
    [sym_kUnimplemented] = ACTIONS(1202),
    [sym_kCvar] = ACTIONS(1202),
    [sym_kExport] = ACTIONS(1202),
    [sym_kFar] = ACTIONS(1202),
    [sym_kNear] = ACTIONS(1202),
    [sym_kSafecall] = ACTIONS(1202),
    [sym_kAssembler] = ACTIONS(1202),
    [sym_kNostackframe] = ACTIONS(1202),
    [sym_kInterrupt] = ACTIONS(1202),
    [sym_kNoreturn] = ACTIONS(1202),
    [sym_kIocheck] = ACTIONS(1202),
    [sym_kLocal] = ACTIONS(1202),
    [sym_kHardfloat] = ACTIONS(1202),
    [sym_kSoftfloat] = ACTIONS(1202),
    [sym_kMs_abi_default] = ACTIONS(1202),
    [sym_kMs_abi_cdecl] = ACTIONS(1202),
    [sym_kSaveregisters] = ACTIONS(1202),
    [sym_kSysv_abi_default] = ACTIONS(1202),
    [sym_kSysv_abi_cdecl] = ACTIONS(1202),
    [sym_kVectorcall] = ACTIONS(1202),
    [sym_kVarargs] = ACTIONS(1202),
    [sym_kWinapi] = ACTIONS(1202),
    [sym_kAlias] = ACTIONS(1202),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [sym_kUses] = ACTIONS(1207),
    [sym_kInterface] = ACTIONS(1207),
    [sym_kImplementation] = ACTIONS(1207),
    [sym_kInitialization] = ACTIONS(1207),
    [sym_kFinalization] = ACTIONS(1207),
    [sym_kEnd] = ACTIONS(1207),
    [sym_kVar] = ACTIONS(1209),
    [sym_kThreadvar] = ACTIONS(1207),
    [sym_kConst] = ACTIONS(1209),
    [sym_kResourcestring] = ACTIONS(1207),
    [sym_kType] = ACTIONS(1207),
    [sym_kLabel] = ACTIONS(1207),
    [sym_kExports] = ACTIONS(1207),
    [sym_kProperty] = ACTIONS(1207),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1207),
    [sym_kGeneric] = ACTIONS(1207),
    [sym_kFunction] = ACTIONS(1207),
    [sym_kProcedure] = ACTIONS(1207),
    [sym_kConstructor] = ACTIONS(1207),
    [sym_kDestructor] = ACTIONS(1207),
    [sym_kOperator] = ACTIONS(1207),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1207),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1207),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(1211),
    [sym_identifier] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [sym_kUses] = ACTIONS(1213),
    [sym_kInterface] = ACTIONS(1213),
    [sym_kImplementation] = ACTIONS(1213),
    [sym_kInitialization] = ACTIONS(1213),
    [sym_kFinalization] = ACTIONS(1213),
    [sym_kBegin] = ACTIONS(1213),
    [sym_kEnd] = ACTIONS(1213),
    [sym_kAsm] = ACTIONS(1213),
    [sym_kVar] = ACTIONS(1213),
    [sym_kThreadvar] = ACTIONS(1213),
    [sym_kConst] = ACTIONS(1213),
    [sym_kResourcestring] = ACTIONS(1213),
    [sym_kType] = ACTIONS(1213),
    [sym_kLabel] = ACTIONS(1213),
    [sym_kExports] = ACTIONS(1213),
    [sym_kProperty] = ACTIONS(1213),
    [sym_kDefault] = ACTIONS(1213),
    [sym_kNodefault] = ACTIONS(1213),
    [sym_kClass] = ACTIONS(1213),
    [sym_kGeneric] = ACTIONS(1213),
    [sym_kFunction] = ACTIONS(1213),
    [sym_kProcedure] = ACTIONS(1213),
    [sym_kConstructor] = ACTIONS(1213),
    [sym_kDestructor] = ACTIONS(1213),
    [sym_kOperator] = ACTIONS(1213),
    [sym_kPublic] = ACTIONS(1213),
    [sym_kStatic] = ACTIONS(1213),
    [sym_kVirtual] = ACTIONS(1213),
    [sym_kAbstract] = ACTIONS(1213),
    [sym_kDynamic] = ACTIONS(1213),
    [sym_kOverride] = ACTIONS(1213),
    [sym_kOverload] = ACTIONS(1213),
    [sym_kReintroduce] = ACTIONS(1213),
    [sym_kInline] = ACTIONS(1213),
    [sym_kStdcall] = ACTIONS(1213),
    [sym_kCdecl] = ACTIONS(1213),
    [sym_kCppdecl] = ACTIONS(1213),
    [sym_kPascal] = ACTIONS(1213),
    [sym_kRegister] = ACTIONS(1213),
    [sym_kMwpascal] = ACTIONS(1213),
    [sym_kExternal] = ACTIONS(1213),
    [sym_kMessage] = ACTIONS(1213),
    [sym_kDeprecated] = ACTIONS(1213),
    [sym_kExperimental] = ACTIONS(1213),
    [sym_kPlatform] = ACTIONS(1213),
    [sym_kUnimplemented] = ACTIONS(1213),
    [sym_kCvar] = ACTIONS(1213),
    [sym_kExport] = ACTIONS(1213),
    [sym_kFar] = ACTIONS(1213),
    [sym_kNear] = ACTIONS(1213),
    [sym_kSafecall] = ACTIONS(1213),
    [sym_kAssembler] = ACTIONS(1213),
    [sym_kNostackframe] = ACTIONS(1213),
    [sym_kInterrupt] = ACTIONS(1213),
    [sym_kNoreturn] = ACTIONS(1213),
    [sym_kIocheck] = ACTIONS(1213),
    [sym_kLocal] = ACTIONS(1213),
    [sym_kHardfloat] = ACTIONS(1213),
    [sym_kSoftfloat] = ACTIONS(1213),
    [sym_kMs_abi_default] = ACTIONS(1213),
    [sym_kMs_abi_cdecl] = ACTIONS(1213),
    [sym_kSaveregisters] = ACTIONS(1213),
    [sym_kSysv_abi_default] = ACTIONS(1213),
    [sym_kSysv_abi_cdecl] = ACTIONS(1213),
    [sym_kVectorcall] = ACTIONS(1213),
    [sym_kVarargs] = ACTIONS(1213),
    [sym_kWinapi] = ACTIONS(1213),
    [sym_kAlias] = ACTIONS(1213),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1215),
    [sym_kUses] = ACTIONS(1218),
    [sym_kInterface] = ACTIONS(1218),
    [sym_kImplementation] = ACTIONS(1218),
    [sym_kInitialization] = ACTIONS(1218),
    [sym_kFinalization] = ACTIONS(1218),
    [sym_kEnd] = ACTIONS(1218),
    [sym_kVar] = ACTIONS(1220),
    [sym_kThreadvar] = ACTIONS(1218),
    [sym_kConst] = ACTIONS(1220),
    [sym_kResourcestring] = ACTIONS(1218),
    [sym_kType] = ACTIONS(1218),
    [sym_kLabel] = ACTIONS(1218),
    [sym_kExports] = ACTIONS(1218),
    [sym_kProperty] = ACTIONS(1218),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1218),
    [sym_kGeneric] = ACTIONS(1218),
    [sym_kFunction] = ACTIONS(1218),
    [sym_kProcedure] = ACTIONS(1218),
    [sym_kConstructor] = ACTIONS(1218),
    [sym_kDestructor] = ACTIONS(1218),
    [sym_kOperator] = ACTIONS(1218),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1218),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1218),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_kUses] = ACTIONS(1224),
    [sym_kInterface] = ACTIONS(1224),
    [sym_kImplementation] = ACTIONS(1224),
    [sym_kInitialization] = ACTIONS(1224),
    [sym_kFinalization] = ACTIONS(1224),
    [sym_kBegin] = ACTIONS(1224),
    [sym_kEnd] = ACTIONS(1224),
    [sym_kAsm] = ACTIONS(1224),
    [sym_kVar] = ACTIONS(1224),
    [sym_kThreadvar] = ACTIONS(1224),
    [sym_kConst] = ACTIONS(1224),
    [sym_kResourcestring] = ACTIONS(1224),
    [sym_kType] = ACTIONS(1224),
    [sym_kLabel] = ACTIONS(1224),
    [sym_kExports] = ACTIONS(1224),
    [sym_kProperty] = ACTIONS(1224),
    [sym_kDefault] = ACTIONS(1224),
    [sym_kNodefault] = ACTIONS(1224),
    [sym_kClass] = ACTIONS(1224),
    [sym_kGeneric] = ACTIONS(1224),
    [sym_kFunction] = ACTIONS(1224),
    [sym_kProcedure] = ACTIONS(1224),
    [sym_kConstructor] = ACTIONS(1224),
    [sym_kDestructor] = ACTIONS(1224),
    [sym_kOperator] = ACTIONS(1224),
    [sym_kPublic] = ACTIONS(1224),
    [sym_kStatic] = ACTIONS(1224),
    [sym_kVirtual] = ACTIONS(1224),
    [sym_kAbstract] = ACTIONS(1224),
    [sym_kDynamic] = ACTIONS(1224),
    [sym_kOverride] = ACTIONS(1224),
    [sym_kOverload] = ACTIONS(1224),
    [sym_kReintroduce] = ACTIONS(1224),
    [sym_kInline] = ACTIONS(1224),
    [sym_kStdcall] = ACTIONS(1224),
    [sym_kCdecl] = ACTIONS(1224),
    [sym_kCppdecl] = ACTIONS(1224),
    [sym_kPascal] = ACTIONS(1224),
    [sym_kRegister] = ACTIONS(1224),
    [sym_kMwpascal] = ACTIONS(1224),
    [sym_kExternal] = ACTIONS(1224),
    [sym_kMessage] = ACTIONS(1224),
    [sym_kDeprecated] = ACTIONS(1224),
    [sym_kExperimental] = ACTIONS(1224),
    [sym_kPlatform] = ACTIONS(1224),
    [sym_kUnimplemented] = ACTIONS(1224),
    [sym_kCvar] = ACTIONS(1224),
    [sym_kExport] = ACTIONS(1224),
    [sym_kFar] = ACTIONS(1224),
    [sym_kNear] = ACTIONS(1224),
    [sym_kSafecall] = ACTIONS(1224),
    [sym_kAssembler] = ACTIONS(1224),
    [sym_kNostackframe] = ACTIONS(1224),
    [sym_kInterrupt] = ACTIONS(1224),
    [sym_kNoreturn] = ACTIONS(1224),
    [sym_kIocheck] = ACTIONS(1224),
    [sym_kLocal] = ACTIONS(1224),
    [sym_kHardfloat] = ACTIONS(1224),
    [sym_kSoftfloat] = ACTIONS(1224),
    [sym_kMs_abi_default] = ACTIONS(1224),
    [sym_kMs_abi_cdecl] = ACTIONS(1224),
    [sym_kSaveregisters] = ACTIONS(1224),
    [sym_kSysv_abi_default] = ACTIONS(1224),
    [sym_kSysv_abi_cdecl] = ACTIONS(1224),
    [sym_kVectorcall] = ACTIONS(1224),
    [sym_kVarargs] = ACTIONS(1224),
    [sym_kWinapi] = ACTIONS(1224),
    [sym_kAlias] = ACTIONS(1224),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [sym_kUses] = ACTIONS(1229),
    [sym_kInterface] = ACTIONS(1229),
    [sym_kImplementation] = ACTIONS(1229),
    [sym_kInitialization] = ACTIONS(1229),
    [sym_kFinalization] = ACTIONS(1229),
    [sym_kEnd] = ACTIONS(1229),
    [sym_kVar] = ACTIONS(1231),
    [sym_kThreadvar] = ACTIONS(1229),
    [sym_kConst] = ACTIONS(1231),
    [sym_kResourcestring] = ACTIONS(1229),
    [sym_kType] = ACTIONS(1229),
    [sym_kLabel] = ACTIONS(1229),
    [sym_kExports] = ACTIONS(1229),
    [sym_kProperty] = ACTIONS(1229),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1229),
    [sym_kGeneric] = ACTIONS(1229),
    [sym_kFunction] = ACTIONS(1229),
    [sym_kProcedure] = ACTIONS(1229),
    [sym_kConstructor] = ACTIONS(1229),
    [sym_kDestructor] = ACTIONS(1229),
    [sym_kOperator] = ACTIONS(1229),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1229),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1229),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_kUses] = ACTIONS(1235),
    [sym_kInterface] = ACTIONS(1235),
    [sym_kImplementation] = ACTIONS(1235),
    [sym_kInitialization] = ACTIONS(1235),
    [sym_kFinalization] = ACTIONS(1235),
    [sym_kBegin] = ACTIONS(1235),
    [sym_kEnd] = ACTIONS(1235),
    [sym_kAsm] = ACTIONS(1235),
    [sym_kVar] = ACTIONS(1235),
    [sym_kThreadvar] = ACTIONS(1235),
    [sym_kConst] = ACTIONS(1235),
    [sym_kResourcestring] = ACTIONS(1235),
    [sym_kType] = ACTIONS(1235),
    [sym_kLabel] = ACTIONS(1235),
    [sym_kExports] = ACTIONS(1235),
    [sym_kProperty] = ACTIONS(1235),
    [sym_kDefault] = ACTIONS(1235),
    [sym_kNodefault] = ACTIONS(1235),
    [sym_kClass] = ACTIONS(1235),
    [sym_kGeneric] = ACTIONS(1235),
    [sym_kFunction] = ACTIONS(1235),
    [sym_kProcedure] = ACTIONS(1235),
    [sym_kConstructor] = ACTIONS(1235),
    [sym_kDestructor] = ACTIONS(1235),
    [sym_kOperator] = ACTIONS(1235),
    [sym_kPublic] = ACTIONS(1235),
    [sym_kStatic] = ACTIONS(1235),
    [sym_kVirtual] = ACTIONS(1235),
    [sym_kAbstract] = ACTIONS(1235),
    [sym_kDynamic] = ACTIONS(1235),
    [sym_kOverride] = ACTIONS(1235),
    [sym_kOverload] = ACTIONS(1235),
    [sym_kReintroduce] = ACTIONS(1235),
    [sym_kInline] = ACTIONS(1235),
    [sym_kStdcall] = ACTIONS(1235),
    [sym_kCdecl] = ACTIONS(1235),
    [sym_kCppdecl] = ACTIONS(1235),
    [sym_kPascal] = ACTIONS(1235),
    [sym_kRegister] = ACTIONS(1235),
    [sym_kMwpascal] = ACTIONS(1235),
    [sym_kExternal] = ACTIONS(1235),
    [sym_kMessage] = ACTIONS(1235),
    [sym_kDeprecated] = ACTIONS(1235),
    [sym_kExperimental] = ACTIONS(1235),
    [sym_kPlatform] = ACTIONS(1235),
    [sym_kUnimplemented] = ACTIONS(1235),
    [sym_kCvar] = ACTIONS(1235),
    [sym_kExport] = ACTIONS(1235),
    [sym_kFar] = ACTIONS(1235),
    [sym_kNear] = ACTIONS(1235),
    [sym_kSafecall] = ACTIONS(1235),
    [sym_kAssembler] = ACTIONS(1235),
    [sym_kNostackframe] = ACTIONS(1235),
    [sym_kInterrupt] = ACTIONS(1235),
    [sym_kNoreturn] = ACTIONS(1235),
    [sym_kIocheck] = ACTIONS(1235),
    [sym_kLocal] = ACTIONS(1235),
    [sym_kHardfloat] = ACTIONS(1235),
    [sym_kSoftfloat] = ACTIONS(1235),
    [sym_kMs_abi_default] = ACTIONS(1235),
    [sym_kMs_abi_cdecl] = ACTIONS(1235),
    [sym_kSaveregisters] = ACTIONS(1235),
    [sym_kSysv_abi_default] = ACTIONS(1235),
    [sym_kSysv_abi_cdecl] = ACTIONS(1235),
    [sym_kVectorcall] = ACTIONS(1235),
    [sym_kVarargs] = ACTIONS(1235),
    [sym_kWinapi] = ACTIONS(1235),
    [sym_kAlias] = ACTIONS(1235),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(183),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [sym_kUses] = ACTIONS(1240),
    [sym_kInterface] = ACTIONS(1240),
    [sym_kImplementation] = ACTIONS(1240),
    [sym_kInitialization] = ACTIONS(1240),
    [sym_kFinalization] = ACTIONS(1240),
    [sym_kEnd] = ACTIONS(1240),
    [sym_kVar] = ACTIONS(1242),
    [sym_kThreadvar] = ACTIONS(1240),
    [sym_kConst] = ACTIONS(1242),
    [sym_kResourcestring] = ACTIONS(1240),
    [sym_kType] = ACTIONS(1240),
    [sym_kLabel] = ACTIONS(1240),
    [sym_kExports] = ACTIONS(1240),
    [sym_kProperty] = ACTIONS(1240),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1240),
    [sym_kGeneric] = ACTIONS(1240),
    [sym_kFunction] = ACTIONS(1240),
    [sym_kProcedure] = ACTIONS(1240),
    [sym_kConstructor] = ACTIONS(1240),
    [sym_kDestructor] = ACTIONS(1240),
    [sym_kOperator] = ACTIONS(1240),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1240),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1240),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [sym_kUses] = ACTIONS(1247),
    [sym_kInterface] = ACTIONS(1247),
    [sym_kImplementation] = ACTIONS(1247),
    [sym_kInitialization] = ACTIONS(1247),
    [sym_kFinalization] = ACTIONS(1247),
    [sym_kEnd] = ACTIONS(1247),
    [sym_kVar] = ACTIONS(1249),
    [sym_kThreadvar] = ACTIONS(1247),
    [sym_kConst] = ACTIONS(1249),
    [sym_kResourcestring] = ACTIONS(1247),
    [sym_kType] = ACTIONS(1247),
    [sym_kLabel] = ACTIONS(1247),
    [sym_kExports] = ACTIONS(1247),
    [sym_kProperty] = ACTIONS(1247),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1247),
    [sym_kGeneric] = ACTIONS(1247),
    [sym_kFunction] = ACTIONS(1247),
    [sym_kProcedure] = ACTIONS(1247),
    [sym_kConstructor] = ACTIONS(1247),
    [sym_kDestructor] = ACTIONS(1247),
    [sym_kOperator] = ACTIONS(1247),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1247),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1247),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(206),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [sym_kUses] = ACTIONS(1254),
    [sym_kInterface] = ACTIONS(1254),
    [sym_kImplementation] = ACTIONS(1254),
    [sym_kInitialization] = ACTIONS(1254),
    [sym_kFinalization] = ACTIONS(1254),
    [sym_kEnd] = ACTIONS(1254),
    [sym_kVar] = ACTIONS(1256),
    [sym_kThreadvar] = ACTIONS(1254),
    [sym_kConst] = ACTIONS(1256),
    [sym_kResourcestring] = ACTIONS(1254),
    [sym_kType] = ACTIONS(1254),
    [sym_kLabel] = ACTIONS(1254),
    [sym_kExports] = ACTIONS(1254),
    [sym_kProperty] = ACTIONS(1254),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1254),
    [sym_kGeneric] = ACTIONS(1254),
    [sym_kFunction] = ACTIONS(1254),
    [sym_kProcedure] = ACTIONS(1254),
    [sym_kConstructor] = ACTIONS(1254),
    [sym_kDestructor] = ACTIONS(1254),
    [sym_kOperator] = ACTIONS(1254),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1254),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1254),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [sym_kUses] = ACTIONS(1260),
    [sym_kInterface] = ACTIONS(1260),
    [sym_kImplementation] = ACTIONS(1260),
    [sym_kInitialization] = ACTIONS(1260),
    [sym_kFinalization] = ACTIONS(1260),
    [sym_kBegin] = ACTIONS(1260),
    [sym_kEnd] = ACTIONS(1260),
    [sym_kAsm] = ACTIONS(1260),
    [sym_kVar] = ACTIONS(1260),
    [sym_kThreadvar] = ACTIONS(1260),
    [sym_kConst] = ACTIONS(1260),
    [sym_kResourcestring] = ACTIONS(1260),
    [sym_kType] = ACTIONS(1260),
    [sym_kLabel] = ACTIONS(1260),
    [sym_kExports] = ACTIONS(1260),
    [sym_kProperty] = ACTIONS(1260),
    [sym_kDefault] = ACTIONS(1260),
    [sym_kNodefault] = ACTIONS(1260),
    [sym_kClass] = ACTIONS(1260),
    [sym_kGeneric] = ACTIONS(1260),
    [sym_kFunction] = ACTIONS(1260),
    [sym_kProcedure] = ACTIONS(1260),
    [sym_kConstructor] = ACTIONS(1260),
    [sym_kDestructor] = ACTIONS(1260),
    [sym_kOperator] = ACTIONS(1260),
    [sym_kPublic] = ACTIONS(1260),
    [sym_kStatic] = ACTIONS(1260),
    [sym_kVirtual] = ACTIONS(1260),
    [sym_kAbstract] = ACTIONS(1260),
    [sym_kDynamic] = ACTIONS(1260),
    [sym_kOverride] = ACTIONS(1260),
    [sym_kOverload] = ACTIONS(1260),
    [sym_kReintroduce] = ACTIONS(1260),
    [sym_kInline] = ACTIONS(1260),
    [sym_kStdcall] = ACTIONS(1260),
    [sym_kCdecl] = ACTIONS(1260),
    [sym_kCppdecl] = ACTIONS(1260),
    [sym_kPascal] = ACTIONS(1260),
    [sym_kRegister] = ACTIONS(1260),
    [sym_kMwpascal] = ACTIONS(1260),
    [sym_kExternal] = ACTIONS(1260),
    [sym_kMessage] = ACTIONS(1260),
    [sym_kDeprecated] = ACTIONS(1260),
    [sym_kExperimental] = ACTIONS(1260),
    [sym_kPlatform] = ACTIONS(1260),
    [sym_kUnimplemented] = ACTIONS(1260),
    [sym_kCvar] = ACTIONS(1260),
    [sym_kExport] = ACTIONS(1260),
    [sym_kFar] = ACTIONS(1260),
    [sym_kNear] = ACTIONS(1260),
    [sym_kSafecall] = ACTIONS(1260),
    [sym_kAssembler] = ACTIONS(1260),
    [sym_kNostackframe] = ACTIONS(1260),
    [sym_kInterrupt] = ACTIONS(1260),
    [sym_kNoreturn] = ACTIONS(1260),
    [sym_kIocheck] = ACTIONS(1260),
    [sym_kLocal] = ACTIONS(1260),
    [sym_kHardfloat] = ACTIONS(1260),
    [sym_kSoftfloat] = ACTIONS(1260),
    [sym_kMs_abi_default] = ACTIONS(1260),
    [sym_kMs_abi_cdecl] = ACTIONS(1260),
    [sym_kSaveregisters] = ACTIONS(1260),
    [sym_kSysv_abi_default] = ACTIONS(1260),
    [sym_kSysv_abi_cdecl] = ACTIONS(1260),
    [sym_kVectorcall] = ACTIONS(1260),
    [sym_kVarargs] = ACTIONS(1260),
    [sym_kWinapi] = ACTIONS(1260),
    [sym_kAlias] = ACTIONS(1260),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1262),
    [sym_kUses] = ACTIONS(1265),
    [sym_kInterface] = ACTIONS(1265),
    [sym_kImplementation] = ACTIONS(1265),
    [sym_kInitialization] = ACTIONS(1265),
    [sym_kFinalization] = ACTIONS(1265),
    [sym_kEnd] = ACTIONS(1265),
    [sym_kVar] = ACTIONS(1267),
    [sym_kThreadvar] = ACTIONS(1265),
    [sym_kConst] = ACTIONS(1267),
    [sym_kResourcestring] = ACTIONS(1265),
    [sym_kType] = ACTIONS(1265),
    [sym_kLabel] = ACTIONS(1265),
    [sym_kExports] = ACTIONS(1265),
    [sym_kProperty] = ACTIONS(1265),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1265),
    [sym_kGeneric] = ACTIONS(1265),
    [sym_kFunction] = ACTIONS(1265),
    [sym_kProcedure] = ACTIONS(1265),
    [sym_kConstructor] = ACTIONS(1265),
    [sym_kDestructor] = ACTIONS(1265),
    [sym_kOperator] = ACTIONS(1265),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1265),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1265),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [sym_kUses] = ACTIONS(1272),
    [sym_kInterface] = ACTIONS(1272),
    [sym_kImplementation] = ACTIONS(1272),
    [sym_kInitialization] = ACTIONS(1272),
    [sym_kFinalization] = ACTIONS(1272),
    [sym_kEnd] = ACTIONS(1272),
    [sym_kVar] = ACTIONS(1274),
    [sym_kThreadvar] = ACTIONS(1272),
    [sym_kConst] = ACTIONS(1274),
    [sym_kResourcestring] = ACTIONS(1272),
    [sym_kType] = ACTIONS(1272),
    [sym_kLabel] = ACTIONS(1272),
    [sym_kExports] = ACTIONS(1272),
    [sym_kProperty] = ACTIONS(1272),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1272),
    [sym_kGeneric] = ACTIONS(1272),
    [sym_kFunction] = ACTIONS(1272),
    [sym_kProcedure] = ACTIONS(1272),
    [sym_kConstructor] = ACTIONS(1272),
    [sym_kDestructor] = ACTIONS(1272),
    [sym_kOperator] = ACTIONS(1272),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1272),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1272),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(175),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [sym_kUses] = ACTIONS(1279),
    [sym_kInterface] = ACTIONS(1279),
    [sym_kImplementation] = ACTIONS(1279),
    [sym_kInitialization] = ACTIONS(1279),
    [sym_kFinalization] = ACTIONS(1279),
    [sym_kEnd] = ACTIONS(1279),
    [sym_kVar] = ACTIONS(1281),
    [sym_kThreadvar] = ACTIONS(1279),
    [sym_kConst] = ACTIONS(1281),
    [sym_kResourcestring] = ACTIONS(1279),
    [sym_kType] = ACTIONS(1279),
    [sym_kLabel] = ACTIONS(1279),
    [sym_kExports] = ACTIONS(1279),
    [sym_kProperty] = ACTIONS(1279),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1279),
    [sym_kGeneric] = ACTIONS(1279),
    [sym_kFunction] = ACTIONS(1279),
    [sym_kProcedure] = ACTIONS(1279),
    [sym_kConstructor] = ACTIONS(1279),
    [sym_kDestructor] = ACTIONS(1279),
    [sym_kOperator] = ACTIONS(1279),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1279),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1279),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [sym_kUses] = ACTIONS(1286),
    [sym_kInterface] = ACTIONS(1286),
    [sym_kImplementation] = ACTIONS(1286),
    [sym_kInitialization] = ACTIONS(1286),
    [sym_kFinalization] = ACTIONS(1286),
    [sym_kEnd] = ACTIONS(1286),
    [sym_kVar] = ACTIONS(1288),
    [sym_kThreadvar] = ACTIONS(1286),
    [sym_kConst] = ACTIONS(1288),
    [sym_kResourcestring] = ACTIONS(1286),
    [sym_kType] = ACTIONS(1286),
    [sym_kLabel] = ACTIONS(1286),
    [sym_kExports] = ACTIONS(1286),
    [sym_kProperty] = ACTIONS(1286),
    [sym_kDefault] = ACTIONS(1290),
    [sym_kNodefault] = ACTIONS(1290),
    [sym_kClass] = ACTIONS(1286),
    [sym_kGeneric] = ACTIONS(1286),
    [sym_kFunction] = ACTIONS(1286),
    [sym_kProcedure] = ACTIONS(1286),
    [sym_kConstructor] = ACTIONS(1286),
    [sym_kDestructor] = ACTIONS(1286),
    [sym_kOperator] = ACTIONS(1286),
    [sym_kPublic] = ACTIONS(1293),
    [sym_kForward] = ACTIONS(1286),
    [sym_kStatic] = ACTIONS(1290),
    [sym_kVirtual] = ACTIONS(1290),
    [sym_kAbstract] = ACTIONS(1290),
    [sym_kDynamic] = ACTIONS(1290),
    [sym_kOverride] = ACTIONS(1290),
    [sym_kOverload] = ACTIONS(1290),
    [sym_kReintroduce] = ACTIONS(1290),
    [sym_kInline] = ACTIONS(1290),
    [sym_kStdcall] = ACTIONS(1290),
    [sym_kCdecl] = ACTIONS(1290),
    [sym_kCppdecl] = ACTIONS(1290),
    [sym_kPascal] = ACTIONS(1290),
    [sym_kRegister] = ACTIONS(1290),
    [sym_kMwpascal] = ACTIONS(1290),
    [sym_kExternal] = ACTIONS(1286),
    [sym_kMessage] = ACTIONS(1296),
    [sym_kDeprecated] = ACTIONS(1299),
    [sym_kExperimental] = ACTIONS(1290),
    [sym_kPlatform] = ACTIONS(1290),
    [sym_kUnimplemented] = ACTIONS(1290),
    [sym_kCvar] = ACTIONS(1290),
    [sym_kExport] = ACTIONS(1302),
    [sym_kFar] = ACTIONS(1290),
    [sym_kNear] = ACTIONS(1290),
    [sym_kSafecall] = ACTIONS(1290),
    [sym_kAssembler] = ACTIONS(1290),
    [sym_kNostackframe] = ACTIONS(1290),
    [sym_kInterrupt] = ACTIONS(1290),
    [sym_kNoreturn] = ACTIONS(1290),
    [sym_kIocheck] = ACTIONS(1290),
    [sym_kLocal] = ACTIONS(1290),
    [sym_kHardfloat] = ACTIONS(1290),
    [sym_kSoftfloat] = ACTIONS(1290),
    [sym_kMs_abi_default] = ACTIONS(1290),
    [sym_kMs_abi_cdecl] = ACTIONS(1290),
    [sym_kSaveregisters] = ACTIONS(1290),
    [sym_kSysv_abi_default] = ACTIONS(1290),
    [sym_kSysv_abi_cdecl] = ACTIONS(1290),
    [sym_kVectorcall] = ACTIONS(1290),
    [sym_kVarargs] = ACTIONS(1290),
    [sym_kWinapi] = ACTIONS(1290),
    [sym_kAlias] = ACTIONS(1305),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(187),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_kUses] = ACTIONS(1311),
    [sym_kInterface] = ACTIONS(1311),
    [sym_kImplementation] = ACTIONS(1311),
    [sym_kInitialization] = ACTIONS(1311),
    [sym_kFinalization] = ACTIONS(1311),
    [sym_kEnd] = ACTIONS(1311),
    [sym_kVar] = ACTIONS(1313),
    [sym_kThreadvar] = ACTIONS(1311),
    [sym_kConst] = ACTIONS(1313),
    [sym_kResourcestring] = ACTIONS(1311),
    [sym_kType] = ACTIONS(1311),
    [sym_kLabel] = ACTIONS(1311),
    [sym_kExports] = ACTIONS(1311),
    [sym_kProperty] = ACTIONS(1311),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1311),
    [sym_kGeneric] = ACTIONS(1311),
    [sym_kFunction] = ACTIONS(1311),
    [sym_kProcedure] = ACTIONS(1311),
    [sym_kConstructor] = ACTIONS(1311),
    [sym_kDestructor] = ACTIONS(1311),
    [sym_kOperator] = ACTIONS(1311),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1311),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1311),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_kUses] = ACTIONS(1318),
    [sym_kInterface] = ACTIONS(1318),
    [sym_kImplementation] = ACTIONS(1318),
    [sym_kInitialization] = ACTIONS(1318),
    [sym_kFinalization] = ACTIONS(1318),
    [sym_kEnd] = ACTIONS(1318),
    [sym_kVar] = ACTIONS(1320),
    [sym_kThreadvar] = ACTIONS(1318),
    [sym_kConst] = ACTIONS(1320),
    [sym_kResourcestring] = ACTIONS(1318),
    [sym_kType] = ACTIONS(1318),
    [sym_kLabel] = ACTIONS(1318),
    [sym_kExports] = ACTIONS(1318),
    [sym_kProperty] = ACTIONS(1318),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1318),
    [sym_kGeneric] = ACTIONS(1318),
    [sym_kFunction] = ACTIONS(1318),
    [sym_kProcedure] = ACTIONS(1318),
    [sym_kConstructor] = ACTIONS(1318),
    [sym_kDestructor] = ACTIONS(1318),
    [sym_kOperator] = ACTIONS(1318),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1318),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1318),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [sym_kUses] = ACTIONS(1325),
    [sym_kInterface] = ACTIONS(1325),
    [sym_kImplementation] = ACTIONS(1325),
    [sym_kInitialization] = ACTIONS(1325),
    [sym_kFinalization] = ACTIONS(1325),
    [sym_kEnd] = ACTIONS(1325),
    [sym_kVar] = ACTIONS(1327),
    [sym_kThreadvar] = ACTIONS(1325),
    [sym_kConst] = ACTIONS(1327),
    [sym_kResourcestring] = ACTIONS(1325),
    [sym_kType] = ACTIONS(1325),
    [sym_kLabel] = ACTIONS(1325),
    [sym_kExports] = ACTIONS(1325),
    [sym_kProperty] = ACTIONS(1325),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1325),
    [sym_kGeneric] = ACTIONS(1325),
    [sym_kFunction] = ACTIONS(1325),
    [sym_kProcedure] = ACTIONS(1325),
    [sym_kConstructor] = ACTIONS(1325),
    [sym_kDestructor] = ACTIONS(1325),
    [sym_kOperator] = ACTIONS(1325),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1325),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1325),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_kUses] = ACTIONS(1235),
    [sym_kInterface] = ACTIONS(1235),
    [sym_kImplementation] = ACTIONS(1235),
    [sym_kInitialization] = ACTIONS(1235),
    [sym_kFinalization] = ACTIONS(1235),
    [sym_kBegin] = ACTIONS(1235),
    [sym_kEnd] = ACTIONS(1235),
    [sym_kAsm] = ACTIONS(1235),
    [sym_kVar] = ACTIONS(1235),
    [sym_kThreadvar] = ACTIONS(1235),
    [sym_kConst] = ACTIONS(1235),
    [sym_kResourcestring] = ACTIONS(1235),
    [sym_kType] = ACTIONS(1235),
    [sym_kLabel] = ACTIONS(1235),
    [sym_kExports] = ACTIONS(1235),
    [sym_kProperty] = ACTIONS(1235),
    [sym_kDefault] = ACTIONS(1235),
    [sym_kNodefault] = ACTIONS(1235),
    [sym_kClass] = ACTIONS(1235),
    [sym_kGeneric] = ACTIONS(1235),
    [sym_kFunction] = ACTIONS(1235),
    [sym_kProcedure] = ACTIONS(1235),
    [sym_kConstructor] = ACTIONS(1235),
    [sym_kDestructor] = ACTIONS(1235),
    [sym_kOperator] = ACTIONS(1235),
    [sym_kPublic] = ACTIONS(1235),
    [sym_kStatic] = ACTIONS(1235),
    [sym_kVirtual] = ACTIONS(1235),
    [sym_kAbstract] = ACTIONS(1235),
    [sym_kDynamic] = ACTIONS(1235),
    [sym_kOverride] = ACTIONS(1235),
    [sym_kOverload] = ACTIONS(1235),
    [sym_kReintroduce] = ACTIONS(1235),
    [sym_kInline] = ACTIONS(1235),
    [sym_kStdcall] = ACTIONS(1235),
    [sym_kCdecl] = ACTIONS(1235),
    [sym_kCppdecl] = ACTIONS(1235),
    [sym_kPascal] = ACTIONS(1235),
    [sym_kRegister] = ACTIONS(1235),
    [sym_kMwpascal] = ACTIONS(1235),
    [sym_kExternal] = ACTIONS(1235),
    [sym_kMessage] = ACTIONS(1235),
    [sym_kDeprecated] = ACTIONS(1235),
    [sym_kExperimental] = ACTIONS(1235),
    [sym_kPlatform] = ACTIONS(1235),
    [sym_kUnimplemented] = ACTIONS(1235),
    [sym_kCvar] = ACTIONS(1235),
    [sym_kExport] = ACTIONS(1235),
    [sym_kFar] = ACTIONS(1235),
    [sym_kNear] = ACTIONS(1235),
    [sym_kSafecall] = ACTIONS(1235),
    [sym_kAssembler] = ACTIONS(1235),
    [sym_kNostackframe] = ACTIONS(1235),
    [sym_kInterrupt] = ACTIONS(1235),
    [sym_kNoreturn] = ACTIONS(1235),
    [sym_kIocheck] = ACTIONS(1235),
    [sym_kLocal] = ACTIONS(1235),
    [sym_kHardfloat] = ACTIONS(1235),
    [sym_kSoftfloat] = ACTIONS(1235),
    [sym_kMs_abi_default] = ACTIONS(1235),
    [sym_kMs_abi_cdecl] = ACTIONS(1235),
    [sym_kSaveregisters] = ACTIONS(1235),
    [sym_kSysv_abi_default] = ACTIONS(1235),
    [sym_kSysv_abi_cdecl] = ACTIONS(1235),
    [sym_kVectorcall] = ACTIONS(1235),
    [sym_kVarargs] = ACTIONS(1235),
    [sym_kWinapi] = ACTIONS(1235),
    [sym_kAlias] = ACTIONS(1235),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(174),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [sym_kUses] = ACTIONS(1332),
    [sym_kInterface] = ACTIONS(1332),
    [sym_kImplementation] = ACTIONS(1332),
    [sym_kInitialization] = ACTIONS(1332),
    [sym_kFinalization] = ACTIONS(1332),
    [sym_kEnd] = ACTIONS(1332),
    [sym_kVar] = ACTIONS(1334),
    [sym_kThreadvar] = ACTIONS(1332),
    [sym_kConst] = ACTIONS(1334),
    [sym_kResourcestring] = ACTIONS(1332),
    [sym_kType] = ACTIONS(1332),
    [sym_kLabel] = ACTIONS(1332),
    [sym_kExports] = ACTIONS(1332),
    [sym_kProperty] = ACTIONS(1332),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1332),
    [sym_kGeneric] = ACTIONS(1332),
    [sym_kFunction] = ACTIONS(1332),
    [sym_kProcedure] = ACTIONS(1332),
    [sym_kConstructor] = ACTIONS(1332),
    [sym_kDestructor] = ACTIONS(1332),
    [sym_kOperator] = ACTIONS(1332),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1332),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1332),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [sym_kUses] = ACTIONS(1339),
    [sym_kInterface] = ACTIONS(1339),
    [sym_kImplementation] = ACTIONS(1339),
    [sym_kInitialization] = ACTIONS(1339),
    [sym_kFinalization] = ACTIONS(1339),
    [sym_kEnd] = ACTIONS(1339),
    [sym_kVar] = ACTIONS(1341),
    [sym_kThreadvar] = ACTIONS(1339),
    [sym_kConst] = ACTIONS(1341),
    [sym_kResourcestring] = ACTIONS(1339),
    [sym_kType] = ACTIONS(1339),
    [sym_kLabel] = ACTIONS(1339),
    [sym_kExports] = ACTIONS(1339),
    [sym_kProperty] = ACTIONS(1339),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1339),
    [sym_kGeneric] = ACTIONS(1339),
    [sym_kFunction] = ACTIONS(1339),
    [sym_kProcedure] = ACTIONS(1339),
    [sym_kConstructor] = ACTIONS(1339),
    [sym_kDestructor] = ACTIONS(1339),
    [sym_kOperator] = ACTIONS(1339),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1339),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1339),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(185),
    [anon_sym_LBRACK] = ACTIONS(1343),
    [sym_kUses] = ACTIONS(1346),
    [sym_kInterface] = ACTIONS(1346),
    [sym_kImplementation] = ACTIONS(1346),
    [sym_kInitialization] = ACTIONS(1346),
    [sym_kFinalization] = ACTIONS(1346),
    [sym_kEnd] = ACTIONS(1346),
    [sym_kVar] = ACTIONS(1348),
    [sym_kThreadvar] = ACTIONS(1346),
    [sym_kConst] = ACTIONS(1348),
    [sym_kResourcestring] = ACTIONS(1346),
    [sym_kType] = ACTIONS(1346),
    [sym_kLabel] = ACTIONS(1346),
    [sym_kExports] = ACTIONS(1346),
    [sym_kProperty] = ACTIONS(1346),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1346),
    [sym_kGeneric] = ACTIONS(1346),
    [sym_kFunction] = ACTIONS(1346),
    [sym_kProcedure] = ACTIONS(1346),
    [sym_kConstructor] = ACTIONS(1346),
    [sym_kDestructor] = ACTIONS(1346),
    [sym_kOperator] = ACTIONS(1346),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1346),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1346),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [sym_kUses] = ACTIONS(1353),
    [sym_kInterface] = ACTIONS(1353),
    [sym_kImplementation] = ACTIONS(1353),
    [sym_kInitialization] = ACTIONS(1353),
    [sym_kFinalization] = ACTIONS(1353),
    [sym_kEnd] = ACTIONS(1353),
    [sym_kVar] = ACTIONS(1355),
    [sym_kThreadvar] = ACTIONS(1353),
    [sym_kConst] = ACTIONS(1355),
    [sym_kResourcestring] = ACTIONS(1353),
    [sym_kType] = ACTIONS(1353),
    [sym_kLabel] = ACTIONS(1353),
    [sym_kExports] = ACTIONS(1353),
    [sym_kProperty] = ACTIONS(1353),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1353),
    [sym_kGeneric] = ACTIONS(1353),
    [sym_kFunction] = ACTIONS(1353),
    [sym_kProcedure] = ACTIONS(1353),
    [sym_kConstructor] = ACTIONS(1353),
    [sym_kDestructor] = ACTIONS(1353),
    [sym_kOperator] = ACTIONS(1353),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1353),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1353),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [sym_kUses] = ACTIONS(1360),
    [sym_kInterface] = ACTIONS(1360),
    [sym_kImplementation] = ACTIONS(1360),
    [sym_kInitialization] = ACTIONS(1360),
    [sym_kFinalization] = ACTIONS(1360),
    [sym_kEnd] = ACTIONS(1360),
    [sym_kVar] = ACTIONS(1362),
    [sym_kThreadvar] = ACTIONS(1360),
    [sym_kConst] = ACTIONS(1362),
    [sym_kResourcestring] = ACTIONS(1360),
    [sym_kType] = ACTIONS(1360),
    [sym_kLabel] = ACTIONS(1360),
    [sym_kExports] = ACTIONS(1360),
    [sym_kProperty] = ACTIONS(1360),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1360),
    [sym_kGeneric] = ACTIONS(1360),
    [sym_kFunction] = ACTIONS(1360),
    [sym_kProcedure] = ACTIONS(1360),
    [sym_kConstructor] = ACTIONS(1360),
    [sym_kDestructor] = ACTIONS(1360),
    [sym_kOperator] = ACTIONS(1360),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1360),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1360),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(195),
    [anon_sym_LBRACK] = ACTIONS(1364),
    [sym_kUses] = ACTIONS(1367),
    [sym_kInterface] = ACTIONS(1367),
    [sym_kImplementation] = ACTIONS(1367),
    [sym_kInitialization] = ACTIONS(1367),
    [sym_kFinalization] = ACTIONS(1367),
    [sym_kEnd] = ACTIONS(1367),
    [sym_kVar] = ACTIONS(1369),
    [sym_kThreadvar] = ACTIONS(1367),
    [sym_kConst] = ACTIONS(1369),
    [sym_kResourcestring] = ACTIONS(1367),
    [sym_kType] = ACTIONS(1367),
    [sym_kLabel] = ACTIONS(1367),
    [sym_kExports] = ACTIONS(1367),
    [sym_kProperty] = ACTIONS(1367),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1367),
    [sym_kGeneric] = ACTIONS(1367),
    [sym_kFunction] = ACTIONS(1367),
    [sym_kProcedure] = ACTIONS(1367),
    [sym_kConstructor] = ACTIONS(1367),
    [sym_kDestructor] = ACTIONS(1367),
    [sym_kOperator] = ACTIONS(1367),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1367),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1367),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [sym_kUses] = ACTIONS(1374),
    [sym_kInterface] = ACTIONS(1374),
    [sym_kImplementation] = ACTIONS(1374),
    [sym_kInitialization] = ACTIONS(1374),
    [sym_kFinalization] = ACTIONS(1374),
    [sym_kEnd] = ACTIONS(1374),
    [sym_kVar] = ACTIONS(1376),
    [sym_kThreadvar] = ACTIONS(1374),
    [sym_kConst] = ACTIONS(1376),
    [sym_kResourcestring] = ACTIONS(1374),
    [sym_kType] = ACTIONS(1374),
    [sym_kLabel] = ACTIONS(1374),
    [sym_kExports] = ACTIONS(1374),
    [sym_kProperty] = ACTIONS(1374),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1374),
    [sym_kGeneric] = ACTIONS(1374),
    [sym_kFunction] = ACTIONS(1374),
    [sym_kProcedure] = ACTIONS(1374),
    [sym_kConstructor] = ACTIONS(1374),
    [sym_kDestructor] = ACTIONS(1374),
    [sym_kOperator] = ACTIONS(1374),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1374),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1374),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(201),
    [anon_sym_LBRACK] = ACTIONS(1378),
    [sym_kUses] = ACTIONS(1381),
    [sym_kInterface] = ACTIONS(1381),
    [sym_kImplementation] = ACTIONS(1381),
    [sym_kInitialization] = ACTIONS(1381),
    [sym_kFinalization] = ACTIONS(1381),
    [sym_kEnd] = ACTIONS(1381),
    [sym_kVar] = ACTIONS(1383),
    [sym_kThreadvar] = ACTIONS(1381),
    [sym_kConst] = ACTIONS(1383),
    [sym_kResourcestring] = ACTIONS(1381),
    [sym_kType] = ACTIONS(1381),
    [sym_kLabel] = ACTIONS(1381),
    [sym_kExports] = ACTIONS(1381),
    [sym_kProperty] = ACTIONS(1381),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1381),
    [sym_kGeneric] = ACTIONS(1381),
    [sym_kFunction] = ACTIONS(1381),
    [sym_kProcedure] = ACTIONS(1381),
    [sym_kConstructor] = ACTIONS(1381),
    [sym_kDestructor] = ACTIONS(1381),
    [sym_kOperator] = ACTIONS(1381),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1381),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1381),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(1385),
    [sym_kUses] = ACTIONS(1388),
    [sym_kInterface] = ACTIONS(1388),
    [sym_kImplementation] = ACTIONS(1388),
    [sym_kInitialization] = ACTIONS(1388),
    [sym_kFinalization] = ACTIONS(1388),
    [sym_kEnd] = ACTIONS(1388),
    [sym_kVar] = ACTIONS(1390),
    [sym_kThreadvar] = ACTIONS(1388),
    [sym_kConst] = ACTIONS(1390),
    [sym_kResourcestring] = ACTIONS(1388),
    [sym_kType] = ACTIONS(1388),
    [sym_kLabel] = ACTIONS(1388),
    [sym_kExports] = ACTIONS(1388),
    [sym_kProperty] = ACTIONS(1388),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1388),
    [sym_kGeneric] = ACTIONS(1388),
    [sym_kFunction] = ACTIONS(1388),
    [sym_kProcedure] = ACTIONS(1388),
    [sym_kConstructor] = ACTIONS(1388),
    [sym_kDestructor] = ACTIONS(1388),
    [sym_kOperator] = ACTIONS(1388),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1388),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1388),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(200),
    [anon_sym_LBRACK] = ACTIONS(1392),
    [sym_kUses] = ACTIONS(1395),
    [sym_kInterface] = ACTIONS(1395),
    [sym_kImplementation] = ACTIONS(1395),
    [sym_kInitialization] = ACTIONS(1395),
    [sym_kFinalization] = ACTIONS(1395),
    [sym_kEnd] = ACTIONS(1395),
    [sym_kVar] = ACTIONS(1397),
    [sym_kThreadvar] = ACTIONS(1395),
    [sym_kConst] = ACTIONS(1397),
    [sym_kResourcestring] = ACTIONS(1395),
    [sym_kType] = ACTIONS(1395),
    [sym_kLabel] = ACTIONS(1395),
    [sym_kExports] = ACTIONS(1395),
    [sym_kProperty] = ACTIONS(1395),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1395),
    [sym_kGeneric] = ACTIONS(1395),
    [sym_kFunction] = ACTIONS(1395),
    [sym_kProcedure] = ACTIONS(1395),
    [sym_kConstructor] = ACTIONS(1395),
    [sym_kDestructor] = ACTIONS(1395),
    [sym_kOperator] = ACTIONS(1395),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1395),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1395),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(170),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [sym_kUses] = ACTIONS(1402),
    [sym_kInterface] = ACTIONS(1402),
    [sym_kImplementation] = ACTIONS(1402),
    [sym_kInitialization] = ACTIONS(1402),
    [sym_kFinalization] = ACTIONS(1402),
    [sym_kEnd] = ACTIONS(1402),
    [sym_kVar] = ACTIONS(1404),
    [sym_kThreadvar] = ACTIONS(1402),
    [sym_kConst] = ACTIONS(1404),
    [sym_kResourcestring] = ACTIONS(1402),
    [sym_kType] = ACTIONS(1402),
    [sym_kLabel] = ACTIONS(1402),
    [sym_kExports] = ACTIONS(1402),
    [sym_kProperty] = ACTIONS(1402),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1402),
    [sym_kGeneric] = ACTIONS(1402),
    [sym_kFunction] = ACTIONS(1402),
    [sym_kProcedure] = ACTIONS(1402),
    [sym_kConstructor] = ACTIONS(1402),
    [sym_kDestructor] = ACTIONS(1402),
    [sym_kOperator] = ACTIONS(1402),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1402),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1402),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(196),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [sym_kUses] = ACTIONS(1409),
    [sym_kInterface] = ACTIONS(1409),
    [sym_kImplementation] = ACTIONS(1409),
    [sym_kInitialization] = ACTIONS(1409),
    [sym_kFinalization] = ACTIONS(1409),
    [sym_kEnd] = ACTIONS(1409),
    [sym_kVar] = ACTIONS(1411),
    [sym_kThreadvar] = ACTIONS(1409),
    [sym_kConst] = ACTIONS(1411),
    [sym_kResourcestring] = ACTIONS(1409),
    [sym_kType] = ACTIONS(1409),
    [sym_kLabel] = ACTIONS(1409),
    [sym_kExports] = ACTIONS(1409),
    [sym_kProperty] = ACTIONS(1409),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1409),
    [sym_kGeneric] = ACTIONS(1409),
    [sym_kFunction] = ACTIONS(1409),
    [sym_kProcedure] = ACTIONS(1409),
    [sym_kConstructor] = ACTIONS(1409),
    [sym_kDestructor] = ACTIONS(1409),
    [sym_kOperator] = ACTIONS(1409),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1409),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1409),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [sym_kUses] = ACTIONS(1416),
    [sym_kInterface] = ACTIONS(1416),
    [sym_kImplementation] = ACTIONS(1416),
    [sym_kInitialization] = ACTIONS(1416),
    [sym_kFinalization] = ACTIONS(1416),
    [sym_kEnd] = ACTIONS(1416),
    [sym_kVar] = ACTIONS(1418),
    [sym_kThreadvar] = ACTIONS(1416),
    [sym_kConst] = ACTIONS(1418),
    [sym_kResourcestring] = ACTIONS(1416),
    [sym_kType] = ACTIONS(1416),
    [sym_kLabel] = ACTIONS(1416),
    [sym_kExports] = ACTIONS(1416),
    [sym_kProperty] = ACTIONS(1416),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1416),
    [sym_kGeneric] = ACTIONS(1416),
    [sym_kFunction] = ACTIONS(1416),
    [sym_kProcedure] = ACTIONS(1416),
    [sym_kConstructor] = ACTIONS(1416),
    [sym_kDestructor] = ACTIONS(1416),
    [sym_kOperator] = ACTIONS(1416),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1416),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1416),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [sym_kUses] = ACTIONS(1423),
    [sym_kInterface] = ACTIONS(1423),
    [sym_kImplementation] = ACTIONS(1423),
    [sym_kInitialization] = ACTIONS(1423),
    [sym_kFinalization] = ACTIONS(1423),
    [sym_kEnd] = ACTIONS(1423),
    [sym_kVar] = ACTIONS(1425),
    [sym_kThreadvar] = ACTIONS(1423),
    [sym_kConst] = ACTIONS(1425),
    [sym_kResourcestring] = ACTIONS(1423),
    [sym_kType] = ACTIONS(1423),
    [sym_kLabel] = ACTIONS(1423),
    [sym_kExports] = ACTIONS(1423),
    [sym_kProperty] = ACTIONS(1423),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1423),
    [sym_kGeneric] = ACTIONS(1423),
    [sym_kFunction] = ACTIONS(1423),
    [sym_kProcedure] = ACTIONS(1423),
    [sym_kConstructor] = ACTIONS(1423),
    [sym_kDestructor] = ACTIONS(1423),
    [sym_kOperator] = ACTIONS(1423),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1423),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1423),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [sym_kUses] = ACTIONS(1430),
    [sym_kInterface] = ACTIONS(1430),
    [sym_kImplementation] = ACTIONS(1430),
    [sym_kInitialization] = ACTIONS(1430),
    [sym_kFinalization] = ACTIONS(1430),
    [sym_kEnd] = ACTIONS(1430),
    [sym_kVar] = ACTIONS(1432),
    [sym_kThreadvar] = ACTIONS(1430),
    [sym_kConst] = ACTIONS(1432),
    [sym_kResourcestring] = ACTIONS(1430),
    [sym_kType] = ACTIONS(1430),
    [sym_kLabel] = ACTIONS(1430),
    [sym_kExports] = ACTIONS(1430),
    [sym_kProperty] = ACTIONS(1430),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1430),
    [sym_kGeneric] = ACTIONS(1430),
    [sym_kFunction] = ACTIONS(1430),
    [sym_kProcedure] = ACTIONS(1430),
    [sym_kConstructor] = ACTIONS(1430),
    [sym_kDestructor] = ACTIONS(1430),
    [sym_kOperator] = ACTIONS(1430),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1430),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1430),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(168),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [sym_kUses] = ACTIONS(1437),
    [sym_kInterface] = ACTIONS(1437),
    [sym_kImplementation] = ACTIONS(1437),
    [sym_kInitialization] = ACTIONS(1437),
    [sym_kFinalization] = ACTIONS(1437),
    [sym_kEnd] = ACTIONS(1437),
    [sym_kVar] = ACTIONS(1439),
    [sym_kThreadvar] = ACTIONS(1437),
    [sym_kConst] = ACTIONS(1439),
    [sym_kResourcestring] = ACTIONS(1437),
    [sym_kType] = ACTIONS(1437),
    [sym_kLabel] = ACTIONS(1437),
    [sym_kExports] = ACTIONS(1437),
    [sym_kProperty] = ACTIONS(1437),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1437),
    [sym_kGeneric] = ACTIONS(1437),
    [sym_kFunction] = ACTIONS(1437),
    [sym_kProcedure] = ACTIONS(1437),
    [sym_kConstructor] = ACTIONS(1437),
    [sym_kDestructor] = ACTIONS(1437),
    [sym_kOperator] = ACTIONS(1437),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1437),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1437),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [sym_kUses] = ACTIONS(1444),
    [sym_kInterface] = ACTIONS(1444),
    [sym_kImplementation] = ACTIONS(1444),
    [sym_kInitialization] = ACTIONS(1444),
    [sym_kFinalization] = ACTIONS(1444),
    [sym_kEnd] = ACTIONS(1444),
    [sym_kVar] = ACTIONS(1446),
    [sym_kThreadvar] = ACTIONS(1444),
    [sym_kConst] = ACTIONS(1446),
    [sym_kResourcestring] = ACTIONS(1444),
    [sym_kType] = ACTIONS(1444),
    [sym_kLabel] = ACTIONS(1444),
    [sym_kExports] = ACTIONS(1444),
    [sym_kProperty] = ACTIONS(1444),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1444),
    [sym_kGeneric] = ACTIONS(1444),
    [sym_kFunction] = ACTIONS(1444),
    [sym_kProcedure] = ACTIONS(1444),
    [sym_kConstructor] = ACTIONS(1444),
    [sym_kDestructor] = ACTIONS(1444),
    [sym_kOperator] = ACTIONS(1444),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1444),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1444),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1448),
    [sym_kUses] = ACTIONS(1451),
    [sym_kInterface] = ACTIONS(1451),
    [sym_kImplementation] = ACTIONS(1451),
    [sym_kInitialization] = ACTIONS(1451),
    [sym_kFinalization] = ACTIONS(1451),
    [sym_kEnd] = ACTIONS(1451),
    [sym_kVar] = ACTIONS(1453),
    [sym_kThreadvar] = ACTIONS(1451),
    [sym_kConst] = ACTIONS(1453),
    [sym_kResourcestring] = ACTIONS(1451),
    [sym_kType] = ACTIONS(1451),
    [sym_kLabel] = ACTIONS(1451),
    [sym_kExports] = ACTIONS(1451),
    [sym_kProperty] = ACTIONS(1451),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1451),
    [sym_kGeneric] = ACTIONS(1451),
    [sym_kFunction] = ACTIONS(1451),
    [sym_kProcedure] = ACTIONS(1451),
    [sym_kConstructor] = ACTIONS(1451),
    [sym_kDestructor] = ACTIONS(1451),
    [sym_kOperator] = ACTIONS(1451),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1451),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1451),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(178),
    [anon_sym_LBRACK] = ACTIONS(1455),
    [sym_kUses] = ACTIONS(1458),
    [sym_kInterface] = ACTIONS(1458),
    [sym_kImplementation] = ACTIONS(1458),
    [sym_kInitialization] = ACTIONS(1458),
    [sym_kFinalization] = ACTIONS(1458),
    [sym_kEnd] = ACTIONS(1458),
    [sym_kVar] = ACTIONS(1460),
    [sym_kThreadvar] = ACTIONS(1458),
    [sym_kConst] = ACTIONS(1460),
    [sym_kResourcestring] = ACTIONS(1458),
    [sym_kType] = ACTIONS(1458),
    [sym_kLabel] = ACTIONS(1458),
    [sym_kExports] = ACTIONS(1458),
    [sym_kProperty] = ACTIONS(1458),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1458),
    [sym_kGeneric] = ACTIONS(1458),
    [sym_kFunction] = ACTIONS(1458),
    [sym_kProcedure] = ACTIONS(1458),
    [sym_kConstructor] = ACTIONS(1458),
    [sym_kDestructor] = ACTIONS(1458),
    [sym_kOperator] = ACTIONS(1458),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1458),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1458),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [sym_kEnd] = ACTIONS(681),
    [sym_kVar] = ACTIONS(681),
    [sym_kThreadvar] = ACTIONS(681),
    [sym_kConst] = ACTIONS(681),
    [sym_kResourcestring] = ACTIONS(681),
    [sym_kType] = ACTIONS(681),
    [sym_kProperty] = ACTIONS(681),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(681),
    [sym_kGeneric] = ACTIONS(681),
    [sym_kCase] = ACTIONS(681),
    [sym_kFunction] = ACTIONS(681),
    [sym_kProcedure] = ACTIONS(681),
    [sym_kConstructor] = ACTIONS(681),
    [sym_kDestructor] = ACTIONS(681),
    [sym_kOperator] = ACTIONS(681),
    [sym_kPublished] = ACTIONS(681),
    [sym_kPublic] = ACTIONS(1465),
    [sym_kProtected] = ACTIONS(681),
    [sym_kPrivate] = ACTIONS(681),
    [sym_kStrict] = ACTIONS(681),
    [sym_kRequired] = ACTIONS(681),
    [sym_kOptional] = ACTIONS(681),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(1468),
    [sym_kEnd] = ACTIONS(610),
    [sym_kVar] = ACTIONS(610),
    [sym_kThreadvar] = ACTIONS(610),
    [sym_kConst] = ACTIONS(610),
    [sym_kResourcestring] = ACTIONS(610),
    [sym_kType] = ACTIONS(610),
    [sym_kProperty] = ACTIONS(610),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(610),
    [sym_kGeneric] = ACTIONS(610),
    [sym_kCase] = ACTIONS(610),
    [sym_kFunction] = ACTIONS(610),
    [sym_kProcedure] = ACTIONS(610),
    [sym_kConstructor] = ACTIONS(610),
    [sym_kDestructor] = ACTIONS(610),
    [sym_kOperator] = ACTIONS(610),
    [sym_kPublished] = ACTIONS(610),
    [sym_kPublic] = ACTIONS(1471),
    [sym_kProtected] = ACTIONS(610),
    [sym_kPrivate] = ACTIONS(610),
    [sym_kStrict] = ACTIONS(610),
    [sym_kRequired] = ACTIONS(610),
    [sym_kOptional] = ACTIONS(610),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [sym_kEnd] = ACTIONS(603),
    [sym_kVar] = ACTIONS(603),
    [sym_kThreadvar] = ACTIONS(603),
    [sym_kConst] = ACTIONS(603),
    [sym_kResourcestring] = ACTIONS(603),
    [sym_kType] = ACTIONS(603),
    [sym_kProperty] = ACTIONS(603),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(603),
    [sym_kGeneric] = ACTIONS(603),
    [sym_kCase] = ACTIONS(603),
    [sym_kFunction] = ACTIONS(603),
    [sym_kProcedure] = ACTIONS(603),
    [sym_kConstructor] = ACTIONS(603),
    [sym_kDestructor] = ACTIONS(603),
    [sym_kOperator] = ACTIONS(603),
    [sym_kPublished] = ACTIONS(603),
    [sym_kPublic] = ACTIONS(1477),
    [sym_kProtected] = ACTIONS(603),
    [sym_kPrivate] = ACTIONS(603),
    [sym_kStrict] = ACTIONS(603),
    [sym_kRequired] = ACTIONS(603),
    [sym_kOptional] = ACTIONS(603),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__literalString] = STATE(225),
    [sym_literalChar] = STATE(225),
    [aux_sym_literalString_repeat1] = STATE(225),
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_COMMA] = ACTIONS(1482),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1480),
    [anon_sym_RPAREN] = ACTIONS(1482),
    [aux_sym__literalString_token1] = ACTIONS(1484),
    [anon_sym_POUND] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1482),
    [sym_kEnd] = ACTIONS(1480),
    [sym_kVar] = ACTIONS(1480),
    [sym_kThreadvar] = ACTIONS(1480),
    [sym_kConst] = ACTIONS(1480),
    [sym_kResourcestring] = ACTIONS(1480),
    [sym_kType] = ACTIONS(1480),
    [sym_kProperty] = ACTIONS(1480),
    [sym_kClass] = ACTIONS(1480),
    [sym_kOf] = ACTIONS(1480),
    [sym_kGeneric] = ACTIONS(1480),
    [sym_kLt] = ACTIONS(1480),
    [sym_kEq] = ACTIONS(1482),
    [sym_kNeq] = ACTIONS(1482),
    [sym_kGt] = ACTIONS(1480),
    [sym_kLte] = ACTIONS(1482),
    [sym_kGte] = ACTIONS(1482),
    [sym_kAdd] = ACTIONS(1480),
    [sym_kSub] = ACTIONS(1480),
    [sym_kMul] = ACTIONS(1480),
    [sym_kFdiv] = ACTIONS(1480),
    [sym_kHat] = ACTIONS(1482),
    [sym_kAssign] = ACTIONS(1482),
    [sym_kAssignAdd] = ACTIONS(1482),
    [sym_kAssignSub] = ACTIONS(1482),
    [sym_kAssignMul] = ACTIONS(1482),
    [sym_kAssignDiv] = ACTIONS(1482),
    [sym_kOr] = ACTIONS(1480),
    [sym_kXor] = ACTIONS(1480),
    [sym_kDiv] = ACTIONS(1480),
    [sym_kMod] = ACTIONS(1480),
    [sym_kAnd] = ACTIONS(1480),
    [sym_kShl] = ACTIONS(1480),
    [sym_kShr] = ACTIONS(1480),
    [sym_kIs] = ACTIONS(1480),
    [sym_kAs] = ACTIONS(1480),
    [sym_kIn] = ACTIONS(1480),
    [sym_kThen] = ACTIONS(1480),
    [sym_kElse] = ACTIONS(1480),
    [sym_kDo] = ACTIONS(1480),
    [sym_kUntil] = ACTIONS(1480),
    [sym_kExcept] = ACTIONS(1480),
    [sym_kFinally] = ACTIONS(1480),
    [sym_kCase] = ACTIONS(1480),
    [sym_kFunction] = ACTIONS(1480),
    [sym_kProcedure] = ACTIONS(1480),
    [sym_kConstructor] = ACTIONS(1480),
    [sym_kDestructor] = ACTIONS(1480),
    [sym_kOperator] = ACTIONS(1480),
    [sym_kPublished] = ACTIONS(1480),
    [sym_kPublic] = ACTIONS(1480),
    [sym_kProtected] = ACTIONS(1480),
    [sym_kPrivate] = ACTIONS(1480),
    [sym_kStrict] = ACTIONS(1480),
    [sym_kRequired] = ACTIONS(1480),
    [sym_kOptional] = ACTIONS(1480),
    [sym_kDelayed] = ACTIONS(1480),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [sym_kEnd] = ACTIONS(724),
    [sym_kVar] = ACTIONS(724),
    [sym_kThreadvar] = ACTIONS(724),
    [sym_kConst] = ACTIONS(724),
    [sym_kResourcestring] = ACTIONS(724),
    [sym_kType] = ACTIONS(724),
    [sym_kProperty] = ACTIONS(724),
    [sym_kDefault] = ACTIONS(729),
    [sym_kNodefault] = ACTIONS(729),
    [sym_kClass] = ACTIONS(724),
    [sym_kGeneric] = ACTIONS(724),
    [sym_kCase] = ACTIONS(724),
    [sym_kFunction] = ACTIONS(724),
    [sym_kProcedure] = ACTIONS(724),
    [sym_kConstructor] = ACTIONS(724),
    [sym_kDestructor] = ACTIONS(724),
    [sym_kOperator] = ACTIONS(724),
    [sym_kPublished] = ACTIONS(724),
    [sym_kPublic] = ACTIONS(732),
    [sym_kProtected] = ACTIONS(724),
    [sym_kPrivate] = ACTIONS(724),
    [sym_kStrict] = ACTIONS(724),
    [sym_kRequired] = ACTIONS(724),
    [sym_kOptional] = ACTIONS(724),
    [sym_kStatic] = ACTIONS(729),
    [sym_kVirtual] = ACTIONS(729),
    [sym_kAbstract] = ACTIONS(729),
    [sym_kDynamic] = ACTIONS(729),
    [sym_kOverride] = ACTIONS(729),
    [sym_kOverload] = ACTIONS(729),
    [sym_kReintroduce] = ACTIONS(729),
    [sym_kInline] = ACTIONS(729),
    [sym_kStdcall] = ACTIONS(729),
    [sym_kCdecl] = ACTIONS(729),
    [sym_kCppdecl] = ACTIONS(729),
    [sym_kPascal] = ACTIONS(729),
    [sym_kRegister] = ACTIONS(729),
    [sym_kMwpascal] = ACTIONS(729),
    [sym_kMessage] = ACTIONS(735),
    [sym_kDeprecated] = ACTIONS(738),
    [sym_kExperimental] = ACTIONS(729),
    [sym_kPlatform] = ACTIONS(729),
    [sym_kUnimplemented] = ACTIONS(729),
    [sym_kCvar] = ACTIONS(729),
    [sym_kExport] = ACTIONS(741),
    [sym_kFar] = ACTIONS(729),
    [sym_kNear] = ACTIONS(729),
    [sym_kSafecall] = ACTIONS(729),
    [sym_kAssembler] = ACTIONS(729),
    [sym_kNostackframe] = ACTIONS(729),
    [sym_kInterrupt] = ACTIONS(729),
    [sym_kNoreturn] = ACTIONS(729),
    [sym_kIocheck] = ACTIONS(729),
    [sym_kLocal] = ACTIONS(729),
    [sym_kHardfloat] = ACTIONS(729),
    [sym_kSoftfloat] = ACTIONS(729),
    [sym_kMs_abi_default] = ACTIONS(729),
    [sym_kMs_abi_cdecl] = ACTIONS(729),
    [sym_kSaveregisters] = ACTIONS(729),
    [sym_kSysv_abi_default] = ACTIONS(729),
    [sym_kSysv_abi_cdecl] = ACTIONS(729),
    [sym_kVectorcall] = ACTIONS(729),
    [sym_kVarargs] = ACTIONS(729),
    [sym_kWinapi] = ACTIONS(729),
    [sym_kAlias] = ACTIONS(744),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(1493),
    [sym_kEnd] = ACTIONS(717),
    [sym_kVar] = ACTIONS(717),
    [sym_kThreadvar] = ACTIONS(717),
    [sym_kConst] = ACTIONS(717),
    [sym_kResourcestring] = ACTIONS(717),
    [sym_kType] = ACTIONS(717),
    [sym_kProperty] = ACTIONS(717),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(717),
    [sym_kGeneric] = ACTIONS(717),
    [sym_kCase] = ACTIONS(717),
    [sym_kFunction] = ACTIONS(717),
    [sym_kProcedure] = ACTIONS(717),
    [sym_kConstructor] = ACTIONS(717),
    [sym_kDestructor] = ACTIONS(717),
    [sym_kOperator] = ACTIONS(717),
    [sym_kPublished] = ACTIONS(717),
    [sym_kPublic] = ACTIONS(1496),
    [sym_kProtected] = ACTIONS(717),
    [sym_kPrivate] = ACTIONS(717),
    [sym_kStrict] = ACTIONS(717),
    [sym_kRequired] = ACTIONS(717),
    [sym_kOptional] = ACTIONS(717),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [sym_kEnd] = ACTIONS(617),
    [sym_kVar] = ACTIONS(617),
    [sym_kThreadvar] = ACTIONS(617),
    [sym_kConst] = ACTIONS(617),
    [sym_kResourcestring] = ACTIONS(617),
    [sym_kType] = ACTIONS(617),
    [sym_kProperty] = ACTIONS(617),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(617),
    [sym_kGeneric] = ACTIONS(617),
    [sym_kCase] = ACTIONS(617),
    [sym_kFunction] = ACTIONS(617),
    [sym_kProcedure] = ACTIONS(617),
    [sym_kConstructor] = ACTIONS(617),
    [sym_kDestructor] = ACTIONS(617),
    [sym_kOperator] = ACTIONS(617),
    [sym_kPublished] = ACTIONS(617),
    [sym_kPublic] = ACTIONS(1502),
    [sym_kProtected] = ACTIONS(617),
    [sym_kPrivate] = ACTIONS(617),
    [sym_kStrict] = ACTIONS(617),
    [sym_kRequired] = ACTIONS(617),
    [sym_kOptional] = ACTIONS(617),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [sym_kEnd] = ACTIONS(649),
    [sym_kVar] = ACTIONS(649),
    [sym_kThreadvar] = ACTIONS(649),
    [sym_kConst] = ACTIONS(649),
    [sym_kResourcestring] = ACTIONS(649),
    [sym_kType] = ACTIONS(649),
    [sym_kProperty] = ACTIONS(649),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(649),
    [sym_kGeneric] = ACTIONS(649),
    [sym_kCase] = ACTIONS(649),
    [sym_kFunction] = ACTIONS(649),
    [sym_kProcedure] = ACTIONS(649),
    [sym_kConstructor] = ACTIONS(649),
    [sym_kDestructor] = ACTIONS(649),
    [sym_kOperator] = ACTIONS(649),
    [sym_kPublished] = ACTIONS(649),
    [sym_kPublic] = ACTIONS(1508),
    [sym_kProtected] = ACTIONS(649),
    [sym_kPrivate] = ACTIONS(649),
    [sym_kStrict] = ACTIONS(649),
    [sym_kRequired] = ACTIONS(649),
    [sym_kOptional] = ACTIONS(649),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_kEnd] = ACTIONS(642),
    [sym_kVar] = ACTIONS(642),
    [sym_kThreadvar] = ACTIONS(642),
    [sym_kConst] = ACTIONS(642),
    [sym_kResourcestring] = ACTIONS(642),
    [sym_kType] = ACTIONS(642),
    [sym_kProperty] = ACTIONS(642),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(642),
    [sym_kGeneric] = ACTIONS(642),
    [sym_kCase] = ACTIONS(642),
    [sym_kFunction] = ACTIONS(642),
    [sym_kProcedure] = ACTIONS(642),
    [sym_kConstructor] = ACTIONS(642),
    [sym_kDestructor] = ACTIONS(642),
    [sym_kOperator] = ACTIONS(642),
    [sym_kPublished] = ACTIONS(642),
    [sym_kPublic] = ACTIONS(1514),
    [sym_kProtected] = ACTIONS(642),
    [sym_kPrivate] = ACTIONS(642),
    [sym_kStrict] = ACTIONS(642),
    [sym_kRequired] = ACTIONS(642),
    [sym_kOptional] = ACTIONS(642),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(241),
    [sym_identifier] = ACTIONS(688),
    [anon_sym_LBRACK] = ACTIONS(1517),
    [sym_kEnd] = ACTIONS(688),
    [sym_kVar] = ACTIONS(688),
    [sym_kThreadvar] = ACTIONS(688),
    [sym_kConst] = ACTIONS(688),
    [sym_kResourcestring] = ACTIONS(688),
    [sym_kType] = ACTIONS(688),
    [sym_kProperty] = ACTIONS(688),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(688),
    [sym_kGeneric] = ACTIONS(688),
    [sym_kCase] = ACTIONS(688),
    [sym_kFunction] = ACTIONS(688),
    [sym_kProcedure] = ACTIONS(688),
    [sym_kConstructor] = ACTIONS(688),
    [sym_kDestructor] = ACTIONS(688),
    [sym_kOperator] = ACTIONS(688),
    [sym_kPublished] = ACTIONS(688),
    [sym_kPublic] = ACTIONS(1520),
    [sym_kProtected] = ACTIONS(688),
    [sym_kPrivate] = ACTIONS(688),
    [sym_kStrict] = ACTIONS(688),
    [sym_kRequired] = ACTIONS(688),
    [sym_kOptional] = ACTIONS(688),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(1523),
    [sym_kEnd] = ACTIONS(635),
    [sym_kVar] = ACTIONS(635),
    [sym_kThreadvar] = ACTIONS(635),
    [sym_kConst] = ACTIONS(635),
    [sym_kResourcestring] = ACTIONS(635),
    [sym_kType] = ACTIONS(635),
    [sym_kProperty] = ACTIONS(635),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(635),
    [sym_kGeneric] = ACTIONS(635),
    [sym_kCase] = ACTIONS(635),
    [sym_kFunction] = ACTIONS(635),
    [sym_kProcedure] = ACTIONS(635),
    [sym_kConstructor] = ACTIONS(635),
    [sym_kDestructor] = ACTIONS(635),
    [sym_kOperator] = ACTIONS(635),
    [sym_kPublished] = ACTIONS(635),
    [sym_kPublic] = ACTIONS(1526),
    [sym_kProtected] = ACTIONS(635),
    [sym_kPrivate] = ACTIONS(635),
    [sym_kStrict] = ACTIONS(635),
    [sym_kRequired] = ACTIONS(635),
    [sym_kOptional] = ACTIONS(635),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym__literalString] = STATE(225),
    [sym_literalChar] = STATE(225),
    [aux_sym_literalString_repeat1] = STATE(225),
    [sym_identifier] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [aux_sym__literalString_token1] = ACTIONS(1533),
    [anon_sym_POUND] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(1531),
    [sym_kEnd] = ACTIONS(1529),
    [sym_kVar] = ACTIONS(1529),
    [sym_kThreadvar] = ACTIONS(1529),
    [sym_kConst] = ACTIONS(1529),
    [sym_kResourcestring] = ACTIONS(1529),
    [sym_kType] = ACTIONS(1529),
    [sym_kProperty] = ACTIONS(1529),
    [sym_kClass] = ACTIONS(1529),
    [sym_kOf] = ACTIONS(1529),
    [sym_kGeneric] = ACTIONS(1529),
    [sym_kLt] = ACTIONS(1529),
    [sym_kEq] = ACTIONS(1531),
    [sym_kNeq] = ACTIONS(1531),
    [sym_kGt] = ACTIONS(1529),
    [sym_kLte] = ACTIONS(1531),
    [sym_kGte] = ACTIONS(1531),
    [sym_kAdd] = ACTIONS(1529),
    [sym_kSub] = ACTIONS(1529),
    [sym_kMul] = ACTIONS(1529),
    [sym_kFdiv] = ACTIONS(1529),
    [sym_kHat] = ACTIONS(1531),
    [sym_kAssign] = ACTIONS(1531),
    [sym_kAssignAdd] = ACTIONS(1531),
    [sym_kAssignSub] = ACTIONS(1531),
    [sym_kAssignMul] = ACTIONS(1531),
    [sym_kAssignDiv] = ACTIONS(1531),
    [sym_kOr] = ACTIONS(1529),
    [sym_kXor] = ACTIONS(1529),
    [sym_kDiv] = ACTIONS(1529),
    [sym_kMod] = ACTIONS(1529),
    [sym_kAnd] = ACTIONS(1529),
    [sym_kShl] = ACTIONS(1529),
    [sym_kShr] = ACTIONS(1529),
    [sym_kIs] = ACTIONS(1529),
    [sym_kAs] = ACTIONS(1529),
    [sym_kIn] = ACTIONS(1529),
    [sym_kThen] = ACTIONS(1529),
    [sym_kElse] = ACTIONS(1529),
    [sym_kDo] = ACTIONS(1529),
    [sym_kUntil] = ACTIONS(1529),
    [sym_kExcept] = ACTIONS(1529),
    [sym_kFinally] = ACTIONS(1529),
    [sym_kCase] = ACTIONS(1529),
    [sym_kFunction] = ACTIONS(1529),
    [sym_kProcedure] = ACTIONS(1529),
    [sym_kConstructor] = ACTIONS(1529),
    [sym_kDestructor] = ACTIONS(1529),
    [sym_kOperator] = ACTIONS(1529),
    [sym_kPublished] = ACTIONS(1529),
    [sym_kPublic] = ACTIONS(1529),
    [sym_kProtected] = ACTIONS(1529),
    [sym_kPrivate] = ACTIONS(1529),
    [sym_kStrict] = ACTIONS(1529),
    [sym_kRequired] = ACTIONS(1529),
    [sym_kOptional] = ACTIONS(1529),
    [sym_kDelayed] = ACTIONS(1529),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(628),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [sym_kEnd] = ACTIONS(628),
    [sym_kVar] = ACTIONS(628),
    [sym_kThreadvar] = ACTIONS(628),
    [sym_kConst] = ACTIONS(628),
    [sym_kResourcestring] = ACTIONS(628),
    [sym_kType] = ACTIONS(628),
    [sym_kProperty] = ACTIONS(628),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(628),
    [sym_kGeneric] = ACTIONS(628),
    [sym_kCase] = ACTIONS(628),
    [sym_kFunction] = ACTIONS(628),
    [sym_kProcedure] = ACTIONS(628),
    [sym_kConstructor] = ACTIONS(628),
    [sym_kDestructor] = ACTIONS(628),
    [sym_kOperator] = ACTIONS(628),
    [sym_kPublished] = ACTIONS(628),
    [sym_kPublic] = ACTIONS(1538),
    [sym_kProtected] = ACTIONS(628),
    [sym_kPrivate] = ACTIONS(628),
    [sym_kStrict] = ACTIONS(628),
    [sym_kRequired] = ACTIONS(628),
    [sym_kOptional] = ACTIONS(628),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(858),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_kEnd] = ACTIONS(858),
    [sym_kVar] = ACTIONS(858),
    [sym_kThreadvar] = ACTIONS(858),
    [sym_kConst] = ACTIONS(858),
    [sym_kResourcestring] = ACTIONS(858),
    [sym_kType] = ACTIONS(858),
    [sym_kProperty] = ACTIONS(858),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(858),
    [sym_kGeneric] = ACTIONS(858),
    [sym_kCase] = ACTIONS(858),
    [sym_kFunction] = ACTIONS(858),
    [sym_kProcedure] = ACTIONS(858),
    [sym_kConstructor] = ACTIONS(858),
    [sym_kDestructor] = ACTIONS(858),
    [sym_kOperator] = ACTIONS(858),
    [sym_kPublished] = ACTIONS(858),
    [sym_kPublic] = ACTIONS(1544),
    [sym_kProtected] = ACTIONS(858),
    [sym_kPrivate] = ACTIONS(858),
    [sym_kStrict] = ACTIONS(858),
    [sym_kRequired] = ACTIONS(858),
    [sym_kOptional] = ACTIONS(858),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(1547),
    [sym_kEnd] = ACTIONS(831),
    [sym_kVar] = ACTIONS(831),
    [sym_kThreadvar] = ACTIONS(831),
    [sym_kConst] = ACTIONS(831),
    [sym_kResourcestring] = ACTIONS(831),
    [sym_kType] = ACTIONS(831),
    [sym_kProperty] = ACTIONS(831),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(831),
    [sym_kGeneric] = ACTIONS(831),
    [sym_kCase] = ACTIONS(831),
    [sym_kFunction] = ACTIONS(831),
    [sym_kProcedure] = ACTIONS(831),
    [sym_kConstructor] = ACTIONS(831),
    [sym_kDestructor] = ACTIONS(831),
    [sym_kOperator] = ACTIONS(831),
    [sym_kPublished] = ACTIONS(831),
    [sym_kPublic] = ACTIONS(1550),
    [sym_kProtected] = ACTIONS(831),
    [sym_kPrivate] = ACTIONS(831),
    [sym_kStrict] = ACTIONS(831),
    [sym_kRequired] = ACTIONS(831),
    [sym_kOptional] = ACTIONS(831),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(242),
    [sym_identifier] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [sym_kEnd] = ACTIONS(838),
    [sym_kVar] = ACTIONS(838),
    [sym_kThreadvar] = ACTIONS(838),
    [sym_kConst] = ACTIONS(838),
    [sym_kResourcestring] = ACTIONS(838),
    [sym_kType] = ACTIONS(838),
    [sym_kProperty] = ACTIONS(838),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(838),
    [sym_kGeneric] = ACTIONS(838),
    [sym_kCase] = ACTIONS(838),
    [sym_kFunction] = ACTIONS(838),
    [sym_kProcedure] = ACTIONS(838),
    [sym_kConstructor] = ACTIONS(838),
    [sym_kDestructor] = ACTIONS(838),
    [sym_kOperator] = ACTIONS(838),
    [sym_kPublished] = ACTIONS(838),
    [sym_kPublic] = ACTIONS(1556),
    [sym_kProtected] = ACTIONS(838),
    [sym_kPrivate] = ACTIONS(838),
    [sym_kStrict] = ACTIONS(838),
    [sym_kRequired] = ACTIONS(838),
    [sym_kOptional] = ACTIONS(838),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(1559),
    [sym_kEnd] = ACTIONS(824),
    [sym_kVar] = ACTIONS(824),
    [sym_kThreadvar] = ACTIONS(824),
    [sym_kConst] = ACTIONS(824),
    [sym_kResourcestring] = ACTIONS(824),
    [sym_kType] = ACTIONS(824),
    [sym_kProperty] = ACTIONS(824),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(824),
    [sym_kGeneric] = ACTIONS(824),
    [sym_kCase] = ACTIONS(824),
    [sym_kFunction] = ACTIONS(824),
    [sym_kProcedure] = ACTIONS(824),
    [sym_kConstructor] = ACTIONS(824),
    [sym_kDestructor] = ACTIONS(824),
    [sym_kOperator] = ACTIONS(824),
    [sym_kPublished] = ACTIONS(824),
    [sym_kPublic] = ACTIONS(1562),
    [sym_kProtected] = ACTIONS(824),
    [sym_kPrivate] = ACTIONS(824),
    [sym_kStrict] = ACTIONS(824),
    [sym_kRequired] = ACTIONS(824),
    [sym_kOptional] = ACTIONS(824),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(1565),
    [sym_kEnd] = ACTIONS(670),
    [sym_kVar] = ACTIONS(670),
    [sym_kThreadvar] = ACTIONS(670),
    [sym_kConst] = ACTIONS(670),
    [sym_kResourcestring] = ACTIONS(670),
    [sym_kType] = ACTIONS(670),
    [sym_kProperty] = ACTIONS(670),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(670),
    [sym_kGeneric] = ACTIONS(670),
    [sym_kCase] = ACTIONS(670),
    [sym_kFunction] = ACTIONS(670),
    [sym_kProcedure] = ACTIONS(670),
    [sym_kConstructor] = ACTIONS(670),
    [sym_kDestructor] = ACTIONS(670),
    [sym_kOperator] = ACTIONS(670),
    [sym_kPublished] = ACTIONS(670),
    [sym_kPublic] = ACTIONS(1568),
    [sym_kProtected] = ACTIONS(670),
    [sym_kPrivate] = ACTIONS(670),
    [sym_kStrict] = ACTIONS(670),
    [sym_kRequired] = ACTIONS(670),
    [sym_kOptional] = ACTIONS(670),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [sym_kEnd] = ACTIONS(706),
    [sym_kVar] = ACTIONS(706),
    [sym_kThreadvar] = ACTIONS(706),
    [sym_kConst] = ACTIONS(706),
    [sym_kResourcestring] = ACTIONS(706),
    [sym_kType] = ACTIONS(706),
    [sym_kProperty] = ACTIONS(706),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(706),
    [sym_kGeneric] = ACTIONS(706),
    [sym_kCase] = ACTIONS(706),
    [sym_kFunction] = ACTIONS(706),
    [sym_kProcedure] = ACTIONS(706),
    [sym_kConstructor] = ACTIONS(706),
    [sym_kDestructor] = ACTIONS(706),
    [sym_kOperator] = ACTIONS(706),
    [sym_kPublished] = ACTIONS(706),
    [sym_kPublic] = ACTIONS(1574),
    [sym_kProtected] = ACTIONS(706),
    [sym_kPrivate] = ACTIONS(706),
    [sym_kStrict] = ACTIONS(706),
    [sym_kRequired] = ACTIONS(706),
    [sym_kOptional] = ACTIONS(706),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [sym_kEnd] = ACTIONS(695),
    [sym_kVar] = ACTIONS(695),
    [sym_kThreadvar] = ACTIONS(695),
    [sym_kConst] = ACTIONS(695),
    [sym_kResourcestring] = ACTIONS(695),
    [sym_kType] = ACTIONS(695),
    [sym_kProperty] = ACTIONS(695),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(695),
    [sym_kGeneric] = ACTIONS(695),
    [sym_kCase] = ACTIONS(695),
    [sym_kFunction] = ACTIONS(695),
    [sym_kProcedure] = ACTIONS(695),
    [sym_kConstructor] = ACTIONS(695),
    [sym_kDestructor] = ACTIONS(695),
    [sym_kOperator] = ACTIONS(695),
    [sym_kPublished] = ACTIONS(695),
    [sym_kPublic] = ACTIONS(1580),
    [sym_kProtected] = ACTIONS(695),
    [sym_kPrivate] = ACTIONS(695),
    [sym_kStrict] = ACTIONS(695),
    [sym_kRequired] = ACTIONS(695),
    [sym_kOptional] = ACTIONS(695),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(1583),
    [sym_kEnd] = ACTIONS(663),
    [sym_kVar] = ACTIONS(663),
    [sym_kThreadvar] = ACTIONS(663),
    [sym_kConst] = ACTIONS(663),
    [sym_kResourcestring] = ACTIONS(663),
    [sym_kType] = ACTIONS(663),
    [sym_kProperty] = ACTIONS(663),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(663),
    [sym_kGeneric] = ACTIONS(663),
    [sym_kCase] = ACTIONS(663),
    [sym_kFunction] = ACTIONS(663),
    [sym_kProcedure] = ACTIONS(663),
    [sym_kConstructor] = ACTIONS(663),
    [sym_kDestructor] = ACTIONS(663),
    [sym_kOperator] = ACTIONS(663),
    [sym_kPublished] = ACTIONS(663),
    [sym_kPublic] = ACTIONS(1586),
    [sym_kProtected] = ACTIONS(663),
    [sym_kPrivate] = ACTIONS(663),
    [sym_kStrict] = ACTIONS(663),
    [sym_kRequired] = ACTIONS(663),
    [sym_kOptional] = ACTIONS(663),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [sym_kUses] = ACTIONS(1591),
    [sym_kInterface] = ACTIONS(1591),
    [sym_kImplementation] = ACTIONS(1591),
    [sym_kInitialization] = ACTIONS(1591),
    [sym_kFinalization] = ACTIONS(1591),
    [sym_kBegin] = ACTIONS(1591),
    [sym_kEnd] = ACTIONS(1591),
    [sym_kAsm] = ACTIONS(1591),
    [sym_kVar] = ACTIONS(1591),
    [sym_kThreadvar] = ACTIONS(1591),
    [sym_kConst] = ACTIONS(1591),
    [sym_kResourcestring] = ACTIONS(1591),
    [sym_kType] = ACTIONS(1591),
    [sym_kLabel] = ACTIONS(1591),
    [sym_kExports] = ACTIONS(1591),
    [sym_kProperty] = ACTIONS(1591),
    [sym_kDefault] = ACTIONS(1591),
    [sym_kNodefault] = ACTIONS(1591),
    [sym_kClass] = ACTIONS(1591),
    [sym_kGeneric] = ACTIONS(1591),
    [sym_kFunction] = ACTIONS(1591),
    [sym_kProcedure] = ACTIONS(1591),
    [sym_kConstructor] = ACTIONS(1591),
    [sym_kDestructor] = ACTIONS(1591),
    [sym_kOperator] = ACTIONS(1591),
    [sym_kPublic] = ACTIONS(1591),
    [sym_kStatic] = ACTIONS(1591),
    [sym_kVirtual] = ACTIONS(1591),
    [sym_kAbstract] = ACTIONS(1591),
    [sym_kDynamic] = ACTIONS(1591),
    [sym_kOverride] = ACTIONS(1591),
    [sym_kOverload] = ACTIONS(1591),
    [sym_kReintroduce] = ACTIONS(1591),
    [sym_kInline] = ACTIONS(1591),
    [sym_kStdcall] = ACTIONS(1591),
    [sym_kCdecl] = ACTIONS(1591),
    [sym_kCppdecl] = ACTIONS(1591),
    [sym_kPascal] = ACTIONS(1591),
    [sym_kRegister] = ACTIONS(1591),
    [sym_kMwpascal] = ACTIONS(1591),
    [sym_kMessage] = ACTIONS(1591),
    [sym_kDeprecated] = ACTIONS(1591),
    [sym_kExperimental] = ACTIONS(1591),
    [sym_kPlatform] = ACTIONS(1591),
    [sym_kUnimplemented] = ACTIONS(1591),
    [sym_kCvar] = ACTIONS(1591),
    [sym_kExport] = ACTIONS(1591),
    [sym_kFar] = ACTIONS(1591),
    [sym_kNear] = ACTIONS(1591),
    [sym_kSafecall] = ACTIONS(1591),
    [sym_kAssembler] = ACTIONS(1591),
    [sym_kNostackframe] = ACTIONS(1591),
    [sym_kInterrupt] = ACTIONS(1591),
    [sym_kNoreturn] = ACTIONS(1591),
    [sym_kIocheck] = ACTIONS(1591),
    [sym_kLocal] = ACTIONS(1591),
    [sym_kHardfloat] = ACTIONS(1591),
    [sym_kSoftfloat] = ACTIONS(1591),
    [sym_kMs_abi_default] = ACTIONS(1591),
    [sym_kMs_abi_cdecl] = ACTIONS(1591),
    [sym_kSaveregisters] = ACTIONS(1591),
    [sym_kSysv_abi_default] = ACTIONS(1591),
    [sym_kSysv_abi_cdecl] = ACTIONS(1591),
    [sym_kVectorcall] = ACTIONS(1591),
    [sym_kVarargs] = ACTIONS(1591),
    [sym_kWinapi] = ACTIONS(1591),
    [sym_kAlias] = ACTIONS(1591),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(239),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1593),
    [sym_kEnd] = ACTIONS(656),
    [sym_kVar] = ACTIONS(656),
    [sym_kThreadvar] = ACTIONS(656),
    [sym_kConst] = ACTIONS(656),
    [sym_kResourcestring] = ACTIONS(656),
    [sym_kType] = ACTIONS(656),
    [sym_kProperty] = ACTIONS(656),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(656),
    [sym_kGeneric] = ACTIONS(656),
    [sym_kCase] = ACTIONS(656),
    [sym_kFunction] = ACTIONS(656),
    [sym_kProcedure] = ACTIONS(656),
    [sym_kConstructor] = ACTIONS(656),
    [sym_kDestructor] = ACTIONS(656),
    [sym_kOperator] = ACTIONS(656),
    [sym_kPublished] = ACTIONS(656),
    [sym_kPublic] = ACTIONS(1596),
    [sym_kProtected] = ACTIONS(656),
    [sym_kPrivate] = ACTIONS(656),
    [sym_kStrict] = ACTIONS(656),
    [sym_kRequired] = ACTIONS(656),
    [sym_kOptional] = ACTIONS(656),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(234),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [sym_kEnd] = ACTIONS(851),
    [sym_kVar] = ACTIONS(851),
    [sym_kThreadvar] = ACTIONS(851),
    [sym_kConst] = ACTIONS(851),
    [sym_kResourcestring] = ACTIONS(851),
    [sym_kType] = ACTIONS(851),
    [sym_kProperty] = ACTIONS(851),
    [sym_kDefault] = ACTIONS(296),
    [sym_kNodefault] = ACTIONS(296),
    [sym_kClass] = ACTIONS(851),
    [sym_kGeneric] = ACTIONS(851),
    [sym_kCase] = ACTIONS(851),
    [sym_kFunction] = ACTIONS(851),
    [sym_kProcedure] = ACTIONS(851),
    [sym_kConstructor] = ACTIONS(851),
    [sym_kDestructor] = ACTIONS(851),
    [sym_kOperator] = ACTIONS(851),
    [sym_kPublished] = ACTIONS(851),
    [sym_kPublic] = ACTIONS(1602),
    [sym_kProtected] = ACTIONS(851),
    [sym_kPrivate] = ACTIONS(851),
    [sym_kStrict] = ACTIONS(851),
    [sym_kRequired] = ACTIONS(851),
    [sym_kOptional] = ACTIONS(851),
    [sym_kStatic] = ACTIONS(296),
    [sym_kVirtual] = ACTIONS(296),
    [sym_kAbstract] = ACTIONS(296),
    [sym_kDynamic] = ACTIONS(296),
    [sym_kOverride] = ACTIONS(296),
    [sym_kOverload] = ACTIONS(296),
    [sym_kReintroduce] = ACTIONS(296),
    [sym_kInline] = ACTIONS(296),
    [sym_kStdcall] = ACTIONS(296),
    [sym_kCdecl] = ACTIONS(296),
    [sym_kCppdecl] = ACTIONS(296),
    [sym_kPascal] = ACTIONS(296),
    [sym_kRegister] = ACTIONS(296),
    [sym_kMwpascal] = ACTIONS(296),
    [sym_kMessage] = ACTIONS(302),
    [sym_kDeprecated] = ACTIONS(304),
    [sym_kExperimental] = ACTIONS(296),
    [sym_kPlatform] = ACTIONS(296),
    [sym_kUnimplemented] = ACTIONS(296),
    [sym_kCvar] = ACTIONS(296),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(296),
    [sym_kNear] = ACTIONS(296),
    [sym_kSafecall] = ACTIONS(296),
    [sym_kAssembler] = ACTIONS(296),
    [sym_kNostackframe] = ACTIONS(296),
    [sym_kInterrupt] = ACTIONS(296),
    [sym_kNoreturn] = ACTIONS(296),
    [sym_kIocheck] = ACTIONS(296),
    [sym_kLocal] = ACTIONS(296),
    [sym_kHardfloat] = ACTIONS(296),
    [sym_kSoftfloat] = ACTIONS(296),
    [sym_kMs_abi_default] = ACTIONS(296),
    [sym_kMs_abi_cdecl] = ACTIONS(296),
    [sym_kSaveregisters] = ACTIONS(296),
    [sym_kSysv_abi_default] = ACTIONS(296),
    [sym_kSysv_abi_cdecl] = ACTIONS(296),
    [sym_kVectorcall] = ACTIONS(296),
    [sym_kVarargs] = ACTIONS(296),
    [sym_kWinapi] = ACTIONS(296),
    [sym_kAlias] = ACTIONS(308),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [sym_kEnd] = ACTIONS(1207),
    [sym_kVar] = ACTIONS(1209),
    [sym_kThreadvar] = ACTIONS(1207),
    [sym_kConst] = ACTIONS(1209),
    [sym_kResourcestring] = ACTIONS(1207),
    [sym_kType] = ACTIONS(1207),
    [sym_kProperty] = ACTIONS(1207),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1207),
    [sym_kGeneric] = ACTIONS(1207),
    [sym_kCase] = ACTIONS(1207),
    [sym_kFunction] = ACTIONS(1207),
    [sym_kProcedure] = ACTIONS(1207),
    [sym_kConstructor] = ACTIONS(1207),
    [sym_kDestructor] = ACTIONS(1207),
    [sym_kOperator] = ACTIONS(1207),
    [sym_kPublished] = ACTIONS(1207),
    [sym_kPublic] = ACTIONS(1608),
    [sym_kProtected] = ACTIONS(1207),
    [sym_kPrivate] = ACTIONS(1207),
    [sym_kStrict] = ACTIONS(1207),
    [sym_kRequired] = ACTIONS(1207),
    [sym_kOptional] = ACTIONS(1207),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(258),
    [anon_sym_LBRACK] = ACTIONS(1613),
    [sym_kEnd] = ACTIONS(1616),
    [sym_kVar] = ACTIONS(1618),
    [sym_kThreadvar] = ACTIONS(1616),
    [sym_kConst] = ACTIONS(1618),
    [sym_kResourcestring] = ACTIONS(1616),
    [sym_kType] = ACTIONS(1616),
    [sym_kProperty] = ACTIONS(1616),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1616),
    [sym_kGeneric] = ACTIONS(1616),
    [sym_kCase] = ACTIONS(1616),
    [sym_kFunction] = ACTIONS(1616),
    [sym_kProcedure] = ACTIONS(1616),
    [sym_kConstructor] = ACTIONS(1616),
    [sym_kDestructor] = ACTIONS(1616),
    [sym_kOperator] = ACTIONS(1616),
    [sym_kPublished] = ACTIONS(1616),
    [sym_kPublic] = ACTIONS(1620),
    [sym_kProtected] = ACTIONS(1616),
    [sym_kPrivate] = ACTIONS(1616),
    [sym_kStrict] = ACTIONS(1616),
    [sym_kRequired] = ACTIONS(1616),
    [sym_kOptional] = ACTIONS(1616),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(256),
    [anon_sym_LBRACK] = ACTIONS(1623),
    [sym_kEnd] = ACTIONS(1626),
    [sym_kVar] = ACTIONS(1628),
    [sym_kThreadvar] = ACTIONS(1626),
    [sym_kConst] = ACTIONS(1628),
    [sym_kResourcestring] = ACTIONS(1626),
    [sym_kType] = ACTIONS(1626),
    [sym_kProperty] = ACTIONS(1626),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1626),
    [sym_kGeneric] = ACTIONS(1626),
    [sym_kCase] = ACTIONS(1626),
    [sym_kFunction] = ACTIONS(1626),
    [sym_kProcedure] = ACTIONS(1626),
    [sym_kConstructor] = ACTIONS(1626),
    [sym_kDestructor] = ACTIONS(1626),
    [sym_kOperator] = ACTIONS(1626),
    [sym_kPublished] = ACTIONS(1626),
    [sym_kPublic] = ACTIONS(1630),
    [sym_kProtected] = ACTIONS(1626),
    [sym_kPrivate] = ACTIONS(1626),
    [sym_kStrict] = ACTIONS(1626),
    [sym_kRequired] = ACTIONS(1626),
    [sym_kOptional] = ACTIONS(1626),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [sym_kEnd] = ACTIONS(1636),
    [sym_kVar] = ACTIONS(1638),
    [sym_kThreadvar] = ACTIONS(1636),
    [sym_kConst] = ACTIONS(1638),
    [sym_kResourcestring] = ACTIONS(1636),
    [sym_kType] = ACTIONS(1636),
    [sym_kProperty] = ACTIONS(1636),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1636),
    [sym_kGeneric] = ACTIONS(1636),
    [sym_kCase] = ACTIONS(1636),
    [sym_kFunction] = ACTIONS(1636),
    [sym_kProcedure] = ACTIONS(1636),
    [sym_kConstructor] = ACTIONS(1636),
    [sym_kDestructor] = ACTIONS(1636),
    [sym_kOperator] = ACTIONS(1636),
    [sym_kPublished] = ACTIONS(1636),
    [sym_kPublic] = ACTIONS(1640),
    [sym_kProtected] = ACTIONS(1636),
    [sym_kPrivate] = ACTIONS(1636),
    [sym_kStrict] = ACTIONS(1636),
    [sym_kRequired] = ACTIONS(1636),
    [sym_kOptional] = ACTIONS(1636),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(255),
    [anon_sym_LBRACK] = ACTIONS(1643),
    [sym_kEnd] = ACTIONS(1646),
    [sym_kVar] = ACTIONS(1648),
    [sym_kThreadvar] = ACTIONS(1646),
    [sym_kConst] = ACTIONS(1648),
    [sym_kResourcestring] = ACTIONS(1646),
    [sym_kType] = ACTIONS(1646),
    [sym_kProperty] = ACTIONS(1646),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1646),
    [sym_kGeneric] = ACTIONS(1646),
    [sym_kCase] = ACTIONS(1646),
    [sym_kFunction] = ACTIONS(1646),
    [sym_kProcedure] = ACTIONS(1646),
    [sym_kConstructor] = ACTIONS(1646),
    [sym_kDestructor] = ACTIONS(1646),
    [sym_kOperator] = ACTIONS(1646),
    [sym_kPublished] = ACTIONS(1646),
    [sym_kPublic] = ACTIONS(1650),
    [sym_kProtected] = ACTIONS(1646),
    [sym_kPrivate] = ACTIONS(1646),
    [sym_kStrict] = ACTIONS(1646),
    [sym_kRequired] = ACTIONS(1646),
    [sym_kOptional] = ACTIONS(1646),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(1653),
    [sym_kUses] = ACTIONS(1656),
    [sym_kInterface] = ACTIONS(1656),
    [sym_kImplementation] = ACTIONS(1656),
    [sym_kInitialization] = ACTIONS(1656),
    [sym_kFinalization] = ACTIONS(1656),
    [sym_kEnd] = ACTIONS(1656),
    [sym_kVar] = ACTIONS(1658),
    [sym_kThreadvar] = ACTIONS(1656),
    [sym_kConst] = ACTIONS(1658),
    [sym_kResourcestring] = ACTIONS(1656),
    [sym_kType] = ACTIONS(1656),
    [sym_kLabel] = ACTIONS(1656),
    [sym_kExports] = ACTIONS(1656),
    [sym_kProperty] = ACTIONS(1656),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1656),
    [sym_kGeneric] = ACTIONS(1656),
    [sym_kFunction] = ACTIONS(1656),
    [sym_kProcedure] = ACTIONS(1656),
    [sym_kConstructor] = ACTIONS(1656),
    [sym_kDestructor] = ACTIONS(1656),
    [sym_kOperator] = ACTIONS(1656),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(264),
    [anon_sym_LBRACK] = ACTIONS(1660),
    [sym_kEnd] = ACTIONS(1663),
    [sym_kVar] = ACTIONS(1665),
    [sym_kThreadvar] = ACTIONS(1663),
    [sym_kConst] = ACTIONS(1665),
    [sym_kResourcestring] = ACTIONS(1663),
    [sym_kType] = ACTIONS(1663),
    [sym_kProperty] = ACTIONS(1663),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1663),
    [sym_kGeneric] = ACTIONS(1663),
    [sym_kCase] = ACTIONS(1663),
    [sym_kFunction] = ACTIONS(1663),
    [sym_kProcedure] = ACTIONS(1663),
    [sym_kConstructor] = ACTIONS(1663),
    [sym_kDestructor] = ACTIONS(1663),
    [sym_kOperator] = ACTIONS(1663),
    [sym_kPublished] = ACTIONS(1663),
    [sym_kPublic] = ACTIONS(1667),
    [sym_kProtected] = ACTIONS(1663),
    [sym_kPrivate] = ACTIONS(1663),
    [sym_kStrict] = ACTIONS(1663),
    [sym_kRequired] = ACTIONS(1663),
    [sym_kOptional] = ACTIONS(1663),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [sym_kEnd] = ACTIONS(1673),
    [sym_kVar] = ACTIONS(1675),
    [sym_kThreadvar] = ACTIONS(1673),
    [sym_kConst] = ACTIONS(1675),
    [sym_kResourcestring] = ACTIONS(1673),
    [sym_kType] = ACTIONS(1673),
    [sym_kProperty] = ACTIONS(1673),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1673),
    [sym_kGeneric] = ACTIONS(1673),
    [sym_kCase] = ACTIONS(1673),
    [sym_kFunction] = ACTIONS(1673),
    [sym_kProcedure] = ACTIONS(1673),
    [sym_kConstructor] = ACTIONS(1673),
    [sym_kDestructor] = ACTIONS(1673),
    [sym_kOperator] = ACTIONS(1673),
    [sym_kPublished] = ACTIONS(1673),
    [sym_kPublic] = ACTIONS(1677),
    [sym_kProtected] = ACTIONS(1673),
    [sym_kPrivate] = ACTIONS(1673),
    [sym_kStrict] = ACTIONS(1673),
    [sym_kRequired] = ACTIONS(1673),
    [sym_kOptional] = ACTIONS(1673),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [sym_kEnd] = ACTIONS(1683),
    [sym_kVar] = ACTIONS(1685),
    [sym_kThreadvar] = ACTIONS(1683),
    [sym_kConst] = ACTIONS(1685),
    [sym_kResourcestring] = ACTIONS(1683),
    [sym_kType] = ACTIONS(1683),
    [sym_kProperty] = ACTIONS(1683),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1683),
    [sym_kGeneric] = ACTIONS(1683),
    [sym_kCase] = ACTIONS(1683),
    [sym_kFunction] = ACTIONS(1683),
    [sym_kProcedure] = ACTIONS(1683),
    [sym_kConstructor] = ACTIONS(1683),
    [sym_kDestructor] = ACTIONS(1683),
    [sym_kOperator] = ACTIONS(1683),
    [sym_kPublished] = ACTIONS(1683),
    [sym_kPublic] = ACTIONS(1687),
    [sym_kProtected] = ACTIONS(1683),
    [sym_kPrivate] = ACTIONS(1683),
    [sym_kStrict] = ACTIONS(1683),
    [sym_kRequired] = ACTIONS(1683),
    [sym_kOptional] = ACTIONS(1683),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [sym_kEnd] = ACTIONS(1693),
    [sym_kVar] = ACTIONS(1695),
    [sym_kThreadvar] = ACTIONS(1693),
    [sym_kConst] = ACTIONS(1695),
    [sym_kResourcestring] = ACTIONS(1693),
    [sym_kType] = ACTIONS(1693),
    [sym_kProperty] = ACTIONS(1693),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1693),
    [sym_kGeneric] = ACTIONS(1693),
    [sym_kCase] = ACTIONS(1693),
    [sym_kFunction] = ACTIONS(1693),
    [sym_kProcedure] = ACTIONS(1693),
    [sym_kConstructor] = ACTIONS(1693),
    [sym_kDestructor] = ACTIONS(1693),
    [sym_kOperator] = ACTIONS(1693),
    [sym_kPublished] = ACTIONS(1693),
    [sym_kPublic] = ACTIONS(1697),
    [sym_kProtected] = ACTIONS(1693),
    [sym_kPrivate] = ACTIONS(1693),
    [sym_kStrict] = ACTIONS(1693),
    [sym_kRequired] = ACTIONS(1693),
    [sym_kOptional] = ACTIONS(1693),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1700),
    [sym_kEnd] = ACTIONS(1703),
    [sym_kVar] = ACTIONS(1705),
    [sym_kThreadvar] = ACTIONS(1703),
    [sym_kConst] = ACTIONS(1705),
    [sym_kResourcestring] = ACTIONS(1703),
    [sym_kType] = ACTIONS(1703),
    [sym_kProperty] = ACTIONS(1703),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1703),
    [sym_kGeneric] = ACTIONS(1703),
    [sym_kCase] = ACTIONS(1703),
    [sym_kFunction] = ACTIONS(1703),
    [sym_kProcedure] = ACTIONS(1703),
    [sym_kConstructor] = ACTIONS(1703),
    [sym_kDestructor] = ACTIONS(1703),
    [sym_kOperator] = ACTIONS(1703),
    [sym_kPublished] = ACTIONS(1703),
    [sym_kPublic] = ACTIONS(1707),
    [sym_kProtected] = ACTIONS(1703),
    [sym_kPrivate] = ACTIONS(1703),
    [sym_kStrict] = ACTIONS(1703),
    [sym_kRequired] = ACTIONS(1703),
    [sym_kOptional] = ACTIONS(1703),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [sym_kUses] = ACTIONS(1713),
    [sym_kInterface] = ACTIONS(1713),
    [sym_kImplementation] = ACTIONS(1713),
    [sym_kInitialization] = ACTIONS(1713),
    [sym_kFinalization] = ACTIONS(1713),
    [sym_kEnd] = ACTIONS(1713),
    [sym_kVar] = ACTIONS(1715),
    [sym_kThreadvar] = ACTIONS(1713),
    [sym_kConst] = ACTIONS(1715),
    [sym_kResourcestring] = ACTIONS(1713),
    [sym_kType] = ACTIONS(1713),
    [sym_kLabel] = ACTIONS(1713),
    [sym_kExports] = ACTIONS(1713),
    [sym_kProperty] = ACTIONS(1713),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1713),
    [sym_kGeneric] = ACTIONS(1713),
    [sym_kFunction] = ACTIONS(1713),
    [sym_kProcedure] = ACTIONS(1713),
    [sym_kConstructor] = ACTIONS(1713),
    [sym_kDestructor] = ACTIONS(1713),
    [sym_kOperator] = ACTIONS(1713),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [sym_kEnd] = ACTIONS(1720),
    [sym_kVar] = ACTIONS(1722),
    [sym_kThreadvar] = ACTIONS(1720),
    [sym_kConst] = ACTIONS(1722),
    [sym_kResourcestring] = ACTIONS(1720),
    [sym_kType] = ACTIONS(1720),
    [sym_kProperty] = ACTIONS(1720),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1720),
    [sym_kGeneric] = ACTIONS(1720),
    [sym_kCase] = ACTIONS(1720),
    [sym_kFunction] = ACTIONS(1720),
    [sym_kProcedure] = ACTIONS(1720),
    [sym_kConstructor] = ACTIONS(1720),
    [sym_kDestructor] = ACTIONS(1720),
    [sym_kOperator] = ACTIONS(1720),
    [sym_kPublished] = ACTIONS(1720),
    [sym_kPublic] = ACTIONS(1724),
    [sym_kProtected] = ACTIONS(1720),
    [sym_kPrivate] = ACTIONS(1720),
    [sym_kStrict] = ACTIONS(1720),
    [sym_kRequired] = ACTIONS(1720),
    [sym_kOptional] = ACTIONS(1720),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(249),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [sym_kEnd] = ACTIONS(1730),
    [sym_kVar] = ACTIONS(1732),
    [sym_kThreadvar] = ACTIONS(1730),
    [sym_kConst] = ACTIONS(1732),
    [sym_kResourcestring] = ACTIONS(1730),
    [sym_kType] = ACTIONS(1730),
    [sym_kProperty] = ACTIONS(1730),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1730),
    [sym_kGeneric] = ACTIONS(1730),
    [sym_kCase] = ACTIONS(1730),
    [sym_kFunction] = ACTIONS(1730),
    [sym_kProcedure] = ACTIONS(1730),
    [sym_kConstructor] = ACTIONS(1730),
    [sym_kDestructor] = ACTIONS(1730),
    [sym_kOperator] = ACTIONS(1730),
    [sym_kPublished] = ACTIONS(1730),
    [sym_kPublic] = ACTIONS(1734),
    [sym_kProtected] = ACTIONS(1730),
    [sym_kPrivate] = ACTIONS(1730),
    [sym_kStrict] = ACTIONS(1730),
    [sym_kRequired] = ACTIONS(1730),
    [sym_kOptional] = ACTIONS(1730),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(253),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [sym_kEnd] = ACTIONS(1740),
    [sym_kVar] = ACTIONS(1742),
    [sym_kThreadvar] = ACTIONS(1740),
    [sym_kConst] = ACTIONS(1742),
    [sym_kResourcestring] = ACTIONS(1740),
    [sym_kType] = ACTIONS(1740),
    [sym_kProperty] = ACTIONS(1740),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1740),
    [sym_kGeneric] = ACTIONS(1740),
    [sym_kCase] = ACTIONS(1740),
    [sym_kFunction] = ACTIONS(1740),
    [sym_kProcedure] = ACTIONS(1740),
    [sym_kConstructor] = ACTIONS(1740),
    [sym_kDestructor] = ACTIONS(1740),
    [sym_kOperator] = ACTIONS(1740),
    [sym_kPublished] = ACTIONS(1740),
    [sym_kPublic] = ACTIONS(1744),
    [sym_kProtected] = ACTIONS(1740),
    [sym_kPrivate] = ACTIONS(1740),
    [sym_kStrict] = ACTIONS(1740),
    [sym_kRequired] = ACTIONS(1740),
    [sym_kOptional] = ACTIONS(1740),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(254),
    [anon_sym_LBRACK] = ACTIONS(1747),
    [sym_kEnd] = ACTIONS(1750),
    [sym_kVar] = ACTIONS(1752),
    [sym_kThreadvar] = ACTIONS(1750),
    [sym_kConst] = ACTIONS(1752),
    [sym_kResourcestring] = ACTIONS(1750),
    [sym_kType] = ACTIONS(1750),
    [sym_kProperty] = ACTIONS(1750),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1750),
    [sym_kGeneric] = ACTIONS(1750),
    [sym_kCase] = ACTIONS(1750),
    [sym_kFunction] = ACTIONS(1750),
    [sym_kProcedure] = ACTIONS(1750),
    [sym_kConstructor] = ACTIONS(1750),
    [sym_kDestructor] = ACTIONS(1750),
    [sym_kOperator] = ACTIONS(1750),
    [sym_kPublished] = ACTIONS(1750),
    [sym_kPublic] = ACTIONS(1754),
    [sym_kProtected] = ACTIONS(1750),
    [sym_kPrivate] = ACTIONS(1750),
    [sym_kStrict] = ACTIONS(1750),
    [sym_kRequired] = ACTIONS(1750),
    [sym_kOptional] = ACTIONS(1750),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1757),
    [sym_kEnd] = ACTIONS(1760),
    [sym_kVar] = ACTIONS(1762),
    [sym_kThreadvar] = ACTIONS(1760),
    [sym_kConst] = ACTIONS(1762),
    [sym_kResourcestring] = ACTIONS(1760),
    [sym_kType] = ACTIONS(1760),
    [sym_kProperty] = ACTIONS(1760),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1760),
    [sym_kGeneric] = ACTIONS(1760),
    [sym_kCase] = ACTIONS(1760),
    [sym_kFunction] = ACTIONS(1760),
    [sym_kProcedure] = ACTIONS(1760),
    [sym_kConstructor] = ACTIONS(1760),
    [sym_kDestructor] = ACTIONS(1760),
    [sym_kOperator] = ACTIONS(1760),
    [sym_kPublished] = ACTIONS(1760),
    [sym_kPublic] = ACTIONS(1764),
    [sym_kProtected] = ACTIONS(1760),
    [sym_kPrivate] = ACTIONS(1760),
    [sym_kStrict] = ACTIONS(1760),
    [sym_kRequired] = ACTIONS(1760),
    [sym_kOptional] = ACTIONS(1760),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(268),
    [anon_sym_LBRACK] = ACTIONS(1767),
    [sym_kEnd] = ACTIONS(1770),
    [sym_kVar] = ACTIONS(1772),
    [sym_kThreadvar] = ACTIONS(1770),
    [sym_kConst] = ACTIONS(1772),
    [sym_kResourcestring] = ACTIONS(1770),
    [sym_kType] = ACTIONS(1770),
    [sym_kProperty] = ACTIONS(1770),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1770),
    [sym_kGeneric] = ACTIONS(1770),
    [sym_kCase] = ACTIONS(1770),
    [sym_kFunction] = ACTIONS(1770),
    [sym_kProcedure] = ACTIONS(1770),
    [sym_kConstructor] = ACTIONS(1770),
    [sym_kDestructor] = ACTIONS(1770),
    [sym_kOperator] = ACTIONS(1770),
    [sym_kPublished] = ACTIONS(1770),
    [sym_kPublic] = ACTIONS(1774),
    [sym_kProtected] = ACTIONS(1770),
    [sym_kPrivate] = ACTIONS(1770),
    [sym_kStrict] = ACTIONS(1770),
    [sym_kRequired] = ACTIONS(1770),
    [sym_kOptional] = ACTIONS(1770),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1777),
    [sym_kEnd] = ACTIONS(1780),
    [sym_kVar] = ACTIONS(1782),
    [sym_kThreadvar] = ACTIONS(1780),
    [sym_kConst] = ACTIONS(1782),
    [sym_kResourcestring] = ACTIONS(1780),
    [sym_kType] = ACTIONS(1780),
    [sym_kProperty] = ACTIONS(1780),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1780),
    [sym_kGeneric] = ACTIONS(1780),
    [sym_kCase] = ACTIONS(1780),
    [sym_kFunction] = ACTIONS(1780),
    [sym_kProcedure] = ACTIONS(1780),
    [sym_kConstructor] = ACTIONS(1780),
    [sym_kDestructor] = ACTIONS(1780),
    [sym_kOperator] = ACTIONS(1780),
    [sym_kPublished] = ACTIONS(1780),
    [sym_kPublic] = ACTIONS(1784),
    [sym_kProtected] = ACTIONS(1780),
    [sym_kPrivate] = ACTIONS(1780),
    [sym_kStrict] = ACTIONS(1780),
    [sym_kRequired] = ACTIONS(1780),
    [sym_kOptional] = ACTIONS(1780),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [sym_kUses] = ACTIONS(1790),
    [sym_kInterface] = ACTIONS(1790),
    [sym_kImplementation] = ACTIONS(1790),
    [sym_kInitialization] = ACTIONS(1790),
    [sym_kFinalization] = ACTIONS(1790),
    [sym_kEnd] = ACTIONS(1790),
    [sym_kVar] = ACTIONS(1792),
    [sym_kThreadvar] = ACTIONS(1790),
    [sym_kConst] = ACTIONS(1792),
    [sym_kResourcestring] = ACTIONS(1790),
    [sym_kType] = ACTIONS(1790),
    [sym_kLabel] = ACTIONS(1790),
    [sym_kExports] = ACTIONS(1790),
    [sym_kProperty] = ACTIONS(1790),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1790),
    [sym_kGeneric] = ACTIONS(1790),
    [sym_kFunction] = ACTIONS(1790),
    [sym_kProcedure] = ACTIONS(1790),
    [sym_kConstructor] = ACTIONS(1790),
    [sym_kDestructor] = ACTIONS(1790),
    [sym_kOperator] = ACTIONS(1790),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(269),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [sym_kEnd] = ACTIONS(1797),
    [sym_kVar] = ACTIONS(1799),
    [sym_kThreadvar] = ACTIONS(1797),
    [sym_kConst] = ACTIONS(1799),
    [sym_kResourcestring] = ACTIONS(1797),
    [sym_kType] = ACTIONS(1797),
    [sym_kProperty] = ACTIONS(1797),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1797),
    [sym_kGeneric] = ACTIONS(1797),
    [sym_kCase] = ACTIONS(1797),
    [sym_kFunction] = ACTIONS(1797),
    [sym_kProcedure] = ACTIONS(1797),
    [sym_kConstructor] = ACTIONS(1797),
    [sym_kDestructor] = ACTIONS(1797),
    [sym_kOperator] = ACTIONS(1797),
    [sym_kPublished] = ACTIONS(1797),
    [sym_kPublic] = ACTIONS(1801),
    [sym_kProtected] = ACTIONS(1797),
    [sym_kPrivate] = ACTIONS(1797),
    [sym_kStrict] = ACTIONS(1797),
    [sym_kRequired] = ACTIONS(1797),
    [sym_kOptional] = ACTIONS(1797),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(270),
    [anon_sym_LBRACK] = ACTIONS(1804),
    [sym_kEnd] = ACTIONS(1807),
    [sym_kVar] = ACTIONS(1809),
    [sym_kThreadvar] = ACTIONS(1807),
    [sym_kConst] = ACTIONS(1809),
    [sym_kResourcestring] = ACTIONS(1807),
    [sym_kType] = ACTIONS(1807),
    [sym_kProperty] = ACTIONS(1807),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1807),
    [sym_kGeneric] = ACTIONS(1807),
    [sym_kCase] = ACTIONS(1807),
    [sym_kFunction] = ACTIONS(1807),
    [sym_kProcedure] = ACTIONS(1807),
    [sym_kConstructor] = ACTIONS(1807),
    [sym_kDestructor] = ACTIONS(1807),
    [sym_kOperator] = ACTIONS(1807),
    [sym_kPublished] = ACTIONS(1807),
    [sym_kPublic] = ACTIONS(1811),
    [sym_kProtected] = ACTIONS(1807),
    [sym_kPrivate] = ACTIONS(1807),
    [sym_kStrict] = ACTIONS(1807),
    [sym_kRequired] = ACTIONS(1807),
    [sym_kOptional] = ACTIONS(1807),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_kEnd] = ACTIONS(1817),
    [sym_kVar] = ACTIONS(1819),
    [sym_kThreadvar] = ACTIONS(1817),
    [sym_kConst] = ACTIONS(1819),
    [sym_kResourcestring] = ACTIONS(1817),
    [sym_kType] = ACTIONS(1817),
    [sym_kProperty] = ACTIONS(1817),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1817),
    [sym_kGeneric] = ACTIONS(1817),
    [sym_kCase] = ACTIONS(1817),
    [sym_kFunction] = ACTIONS(1817),
    [sym_kProcedure] = ACTIONS(1817),
    [sym_kConstructor] = ACTIONS(1817),
    [sym_kDestructor] = ACTIONS(1817),
    [sym_kOperator] = ACTIONS(1817),
    [sym_kPublished] = ACTIONS(1817),
    [sym_kPublic] = ACTIONS(1821),
    [sym_kProtected] = ACTIONS(1817),
    [sym_kPrivate] = ACTIONS(1817),
    [sym_kStrict] = ACTIONS(1817),
    [sym_kRequired] = ACTIONS(1817),
    [sym_kOptional] = ACTIONS(1817),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1824),
    [sym_kEnd] = ACTIONS(1827),
    [sym_kVar] = ACTIONS(1829),
    [sym_kThreadvar] = ACTIONS(1827),
    [sym_kConst] = ACTIONS(1829),
    [sym_kResourcestring] = ACTIONS(1827),
    [sym_kType] = ACTIONS(1827),
    [sym_kProperty] = ACTIONS(1827),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1827),
    [sym_kGeneric] = ACTIONS(1827),
    [sym_kCase] = ACTIONS(1827),
    [sym_kFunction] = ACTIONS(1827),
    [sym_kProcedure] = ACTIONS(1827),
    [sym_kConstructor] = ACTIONS(1827),
    [sym_kDestructor] = ACTIONS(1827),
    [sym_kOperator] = ACTIONS(1827),
    [sym_kPublished] = ACTIONS(1827),
    [sym_kPublic] = ACTIONS(1831),
    [sym_kProtected] = ACTIONS(1827),
    [sym_kPrivate] = ACTIONS(1827),
    [sym_kStrict] = ACTIONS(1827),
    [sym_kRequired] = ACTIONS(1827),
    [sym_kOptional] = ACTIONS(1827),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [sym_kEnd] = ACTIONS(1656),
    [sym_kVar] = ACTIONS(1658),
    [sym_kThreadvar] = ACTIONS(1656),
    [sym_kConst] = ACTIONS(1658),
    [sym_kResourcestring] = ACTIONS(1656),
    [sym_kType] = ACTIONS(1656),
    [sym_kProperty] = ACTIONS(1656),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1656),
    [sym_kGeneric] = ACTIONS(1656),
    [sym_kCase] = ACTIONS(1656),
    [sym_kFunction] = ACTIONS(1656),
    [sym_kProcedure] = ACTIONS(1656),
    [sym_kConstructor] = ACTIONS(1656),
    [sym_kDestructor] = ACTIONS(1656),
    [sym_kOperator] = ACTIONS(1656),
    [sym_kPublished] = ACTIONS(1656),
    [sym_kPublic] = ACTIONS(1837),
    [sym_kProtected] = ACTIONS(1656),
    [sym_kPrivate] = ACTIONS(1656),
    [sym_kStrict] = ACTIONS(1656),
    [sym_kRequired] = ACTIONS(1656),
    [sym_kOptional] = ACTIONS(1656),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(257),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [sym_kUses] = ACTIONS(1843),
    [sym_kInterface] = ACTIONS(1843),
    [sym_kImplementation] = ACTIONS(1843),
    [sym_kInitialization] = ACTIONS(1843),
    [sym_kFinalization] = ACTIONS(1843),
    [sym_kEnd] = ACTIONS(1843),
    [sym_kVar] = ACTIONS(1845),
    [sym_kThreadvar] = ACTIONS(1843),
    [sym_kConst] = ACTIONS(1845),
    [sym_kResourcestring] = ACTIONS(1843),
    [sym_kType] = ACTIONS(1843),
    [sym_kLabel] = ACTIONS(1843),
    [sym_kExports] = ACTIONS(1843),
    [sym_kProperty] = ACTIONS(1843),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1843),
    [sym_kGeneric] = ACTIONS(1843),
    [sym_kFunction] = ACTIONS(1843),
    [sym_kProcedure] = ACTIONS(1843),
    [sym_kConstructor] = ACTIONS(1843),
    [sym_kDestructor] = ACTIONS(1843),
    [sym_kOperator] = ACTIONS(1843),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [sym_kUses] = ACTIONS(1850),
    [sym_kInterface] = ACTIONS(1850),
    [sym_kImplementation] = ACTIONS(1850),
    [sym_kInitialization] = ACTIONS(1850),
    [sym_kFinalization] = ACTIONS(1850),
    [sym_kEnd] = ACTIONS(1850),
    [sym_kVar] = ACTIONS(1852),
    [sym_kThreadvar] = ACTIONS(1850),
    [sym_kConst] = ACTIONS(1852),
    [sym_kResourcestring] = ACTIONS(1850),
    [sym_kType] = ACTIONS(1850),
    [sym_kLabel] = ACTIONS(1850),
    [sym_kExports] = ACTIONS(1850),
    [sym_kProperty] = ACTIONS(1850),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1850),
    [sym_kGeneric] = ACTIONS(1850),
    [sym_kFunction] = ACTIONS(1850),
    [sym_kProcedure] = ACTIONS(1850),
    [sym_kConstructor] = ACTIONS(1850),
    [sym_kDestructor] = ACTIONS(1850),
    [sym_kOperator] = ACTIONS(1850),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [sym_kUses] = ACTIONS(1857),
    [sym_kInterface] = ACTIONS(1857),
    [sym_kImplementation] = ACTIONS(1857),
    [sym_kInitialization] = ACTIONS(1857),
    [sym_kFinalization] = ACTIONS(1857),
    [sym_kEnd] = ACTIONS(1857),
    [sym_kVar] = ACTIONS(1859),
    [sym_kThreadvar] = ACTIONS(1857),
    [sym_kConst] = ACTIONS(1859),
    [sym_kResourcestring] = ACTIONS(1857),
    [sym_kType] = ACTIONS(1857),
    [sym_kLabel] = ACTIONS(1857),
    [sym_kExports] = ACTIONS(1857),
    [sym_kProperty] = ACTIONS(1857),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1857),
    [sym_kGeneric] = ACTIONS(1857),
    [sym_kFunction] = ACTIONS(1857),
    [sym_kProcedure] = ACTIONS(1857),
    [sym_kConstructor] = ACTIONS(1857),
    [sym_kDestructor] = ACTIONS(1857),
    [sym_kOperator] = ACTIONS(1857),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(275),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [sym_kEnd] = ACTIONS(1864),
    [sym_kVar] = ACTIONS(1866),
    [sym_kThreadvar] = ACTIONS(1864),
    [sym_kConst] = ACTIONS(1866),
    [sym_kResourcestring] = ACTIONS(1864),
    [sym_kType] = ACTIONS(1864),
    [sym_kProperty] = ACTIONS(1864),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1864),
    [sym_kGeneric] = ACTIONS(1864),
    [sym_kCase] = ACTIONS(1864),
    [sym_kFunction] = ACTIONS(1864),
    [sym_kProcedure] = ACTIONS(1864),
    [sym_kConstructor] = ACTIONS(1864),
    [sym_kDestructor] = ACTIONS(1864),
    [sym_kOperator] = ACTIONS(1864),
    [sym_kPublished] = ACTIONS(1864),
    [sym_kPublic] = ACTIONS(1868),
    [sym_kProtected] = ACTIONS(1864),
    [sym_kPrivate] = ACTIONS(1864),
    [sym_kStrict] = ACTIONS(1864),
    [sym_kRequired] = ACTIONS(1864),
    [sym_kOptional] = ACTIONS(1864),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [sym_kEnd] = ACTIONS(1874),
    [sym_kVar] = ACTIONS(1876),
    [sym_kThreadvar] = ACTIONS(1874),
    [sym_kConst] = ACTIONS(1876),
    [sym_kResourcestring] = ACTIONS(1874),
    [sym_kType] = ACTIONS(1874),
    [sym_kProperty] = ACTIONS(1874),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1874),
    [sym_kGeneric] = ACTIONS(1874),
    [sym_kCase] = ACTIONS(1874),
    [sym_kFunction] = ACTIONS(1874),
    [sym_kProcedure] = ACTIONS(1874),
    [sym_kConstructor] = ACTIONS(1874),
    [sym_kDestructor] = ACTIONS(1874),
    [sym_kOperator] = ACTIONS(1874),
    [sym_kPublished] = ACTIONS(1874),
    [sym_kPublic] = ACTIONS(1878),
    [sym_kProtected] = ACTIONS(1874),
    [sym_kPrivate] = ACTIONS(1874),
    [sym_kStrict] = ACTIONS(1874),
    [sym_kRequired] = ACTIONS(1874),
    [sym_kOptional] = ACTIONS(1874),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1881),
    [sym_kUses] = ACTIONS(1884),
    [sym_kInterface] = ACTIONS(1884),
    [sym_kImplementation] = ACTIONS(1884),
    [sym_kInitialization] = ACTIONS(1884),
    [sym_kFinalization] = ACTIONS(1884),
    [sym_kEnd] = ACTIONS(1884),
    [sym_kVar] = ACTIONS(1886),
    [sym_kThreadvar] = ACTIONS(1884),
    [sym_kConst] = ACTIONS(1886),
    [sym_kResourcestring] = ACTIONS(1884),
    [sym_kType] = ACTIONS(1884),
    [sym_kLabel] = ACTIONS(1884),
    [sym_kExports] = ACTIONS(1884),
    [sym_kProperty] = ACTIONS(1884),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1884),
    [sym_kGeneric] = ACTIONS(1884),
    [sym_kFunction] = ACTIONS(1884),
    [sym_kProcedure] = ACTIONS(1884),
    [sym_kConstructor] = ACTIONS(1884),
    [sym_kDestructor] = ACTIONS(1884),
    [sym_kOperator] = ACTIONS(1884),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(1888),
    [sym_kUses] = ACTIONS(1874),
    [sym_kInterface] = ACTIONS(1874),
    [sym_kImplementation] = ACTIONS(1874),
    [sym_kInitialization] = ACTIONS(1874),
    [sym_kFinalization] = ACTIONS(1874),
    [sym_kEnd] = ACTIONS(1874),
    [sym_kVar] = ACTIONS(1876),
    [sym_kThreadvar] = ACTIONS(1874),
    [sym_kConst] = ACTIONS(1876),
    [sym_kResourcestring] = ACTIONS(1874),
    [sym_kType] = ACTIONS(1874),
    [sym_kLabel] = ACTIONS(1874),
    [sym_kExports] = ACTIONS(1874),
    [sym_kProperty] = ACTIONS(1874),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1874),
    [sym_kGeneric] = ACTIONS(1874),
    [sym_kFunction] = ACTIONS(1874),
    [sym_kProcedure] = ACTIONS(1874),
    [sym_kConstructor] = ACTIONS(1874),
    [sym_kDestructor] = ACTIONS(1874),
    [sym_kOperator] = ACTIONS(1874),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(277),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [sym_kUses] = ACTIONS(1864),
    [sym_kInterface] = ACTIONS(1864),
    [sym_kImplementation] = ACTIONS(1864),
    [sym_kInitialization] = ACTIONS(1864),
    [sym_kFinalization] = ACTIONS(1864),
    [sym_kEnd] = ACTIONS(1864),
    [sym_kVar] = ACTIONS(1866),
    [sym_kThreadvar] = ACTIONS(1864),
    [sym_kConst] = ACTIONS(1866),
    [sym_kResourcestring] = ACTIONS(1864),
    [sym_kType] = ACTIONS(1864),
    [sym_kLabel] = ACTIONS(1864),
    [sym_kExports] = ACTIONS(1864),
    [sym_kProperty] = ACTIONS(1864),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1864),
    [sym_kGeneric] = ACTIONS(1864),
    [sym_kFunction] = ACTIONS(1864),
    [sym_kProcedure] = ACTIONS(1864),
    [sym_kConstructor] = ACTIONS(1864),
    [sym_kDestructor] = ACTIONS(1864),
    [sym_kOperator] = ACTIONS(1864),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(402),
    [anon_sym_LBRACK] = ACTIONS(1894),
    [sym_kUses] = ACTIONS(1897),
    [sym_kInterface] = ACTIONS(1897),
    [sym_kImplementation] = ACTIONS(1897),
    [sym_kInitialization] = ACTIONS(1897),
    [sym_kFinalization] = ACTIONS(1897),
    [sym_kEnd] = ACTIONS(1897),
    [sym_kVar] = ACTIONS(1899),
    [sym_kThreadvar] = ACTIONS(1897),
    [sym_kConst] = ACTIONS(1899),
    [sym_kResourcestring] = ACTIONS(1897),
    [sym_kType] = ACTIONS(1897),
    [sym_kLabel] = ACTIONS(1897),
    [sym_kExports] = ACTIONS(1897),
    [sym_kProperty] = ACTIONS(1897),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1897),
    [sym_kGeneric] = ACTIONS(1897),
    [sym_kFunction] = ACTIONS(1897),
    [sym_kProcedure] = ACTIONS(1897),
    [sym_kConstructor] = ACTIONS(1897),
    [sym_kDestructor] = ACTIONS(1897),
    [sym_kOperator] = ACTIONS(1897),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [sym_kUses] = ACTIONS(1827),
    [sym_kInterface] = ACTIONS(1827),
    [sym_kImplementation] = ACTIONS(1827),
    [sym_kInitialization] = ACTIONS(1827),
    [sym_kFinalization] = ACTIONS(1827),
    [sym_kEnd] = ACTIONS(1827),
    [sym_kVar] = ACTIONS(1829),
    [sym_kThreadvar] = ACTIONS(1827),
    [sym_kConst] = ACTIONS(1829),
    [sym_kResourcestring] = ACTIONS(1827),
    [sym_kType] = ACTIONS(1827),
    [sym_kLabel] = ACTIONS(1827),
    [sym_kExports] = ACTIONS(1827),
    [sym_kProperty] = ACTIONS(1827),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1827),
    [sym_kGeneric] = ACTIONS(1827),
    [sym_kFunction] = ACTIONS(1827),
    [sym_kProcedure] = ACTIONS(1827),
    [sym_kConstructor] = ACTIONS(1827),
    [sym_kDestructor] = ACTIONS(1827),
    [sym_kOperator] = ACTIONS(1827),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(291),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [sym_kEnd] = ACTIONS(1229),
    [sym_kVar] = ACTIONS(1231),
    [sym_kThreadvar] = ACTIONS(1229),
    [sym_kConst] = ACTIONS(1231),
    [sym_kResourcestring] = ACTIONS(1229),
    [sym_kType] = ACTIONS(1229),
    [sym_kProperty] = ACTIONS(1229),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1229),
    [sym_kGeneric] = ACTIONS(1229),
    [sym_kCase] = ACTIONS(1229),
    [sym_kFunction] = ACTIONS(1229),
    [sym_kProcedure] = ACTIONS(1229),
    [sym_kConstructor] = ACTIONS(1229),
    [sym_kDestructor] = ACTIONS(1229),
    [sym_kOperator] = ACTIONS(1229),
    [sym_kPublished] = ACTIONS(1229),
    [sym_kPublic] = ACTIONS(1907),
    [sym_kProtected] = ACTIONS(1229),
    [sym_kPrivate] = ACTIONS(1229),
    [sym_kStrict] = ACTIONS(1229),
    [sym_kRequired] = ACTIONS(1229),
    [sym_kOptional] = ACTIONS(1229),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(1910),
    [sym_kUses] = ACTIONS(1817),
    [sym_kInterface] = ACTIONS(1817),
    [sym_kImplementation] = ACTIONS(1817),
    [sym_kInitialization] = ACTIONS(1817),
    [sym_kFinalization] = ACTIONS(1817),
    [sym_kEnd] = ACTIONS(1817),
    [sym_kVar] = ACTIONS(1819),
    [sym_kThreadvar] = ACTIONS(1817),
    [sym_kConst] = ACTIONS(1819),
    [sym_kResourcestring] = ACTIONS(1817),
    [sym_kType] = ACTIONS(1817),
    [sym_kLabel] = ACTIONS(1817),
    [sym_kExports] = ACTIONS(1817),
    [sym_kProperty] = ACTIONS(1817),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1817),
    [sym_kGeneric] = ACTIONS(1817),
    [sym_kFunction] = ACTIONS(1817),
    [sym_kProcedure] = ACTIONS(1817),
    [sym_kConstructor] = ACTIONS(1817),
    [sym_kDestructor] = ACTIONS(1817),
    [sym_kOperator] = ACTIONS(1817),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(251),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [sym_kUses] = ACTIONS(1807),
    [sym_kInterface] = ACTIONS(1807),
    [sym_kImplementation] = ACTIONS(1807),
    [sym_kInitialization] = ACTIONS(1807),
    [sym_kFinalization] = ACTIONS(1807),
    [sym_kEnd] = ACTIONS(1807),
    [sym_kVar] = ACTIONS(1809),
    [sym_kThreadvar] = ACTIONS(1807),
    [sym_kConst] = ACTIONS(1809),
    [sym_kResourcestring] = ACTIONS(1807),
    [sym_kType] = ACTIONS(1807),
    [sym_kLabel] = ACTIONS(1807),
    [sym_kExports] = ACTIONS(1807),
    [sym_kProperty] = ACTIONS(1807),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1807),
    [sym_kGeneric] = ACTIONS(1807),
    [sym_kFunction] = ACTIONS(1807),
    [sym_kProcedure] = ACTIONS(1807),
    [sym_kConstructor] = ACTIONS(1807),
    [sym_kDestructor] = ACTIONS(1807),
    [sym_kOperator] = ACTIONS(1807),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(297),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [sym_kEnd] = ACTIONS(1240),
    [sym_kVar] = ACTIONS(1242),
    [sym_kThreadvar] = ACTIONS(1240),
    [sym_kConst] = ACTIONS(1242),
    [sym_kResourcestring] = ACTIONS(1240),
    [sym_kType] = ACTIONS(1240),
    [sym_kProperty] = ACTIONS(1240),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1240),
    [sym_kGeneric] = ACTIONS(1240),
    [sym_kCase] = ACTIONS(1240),
    [sym_kFunction] = ACTIONS(1240),
    [sym_kProcedure] = ACTIONS(1240),
    [sym_kConstructor] = ACTIONS(1240),
    [sym_kDestructor] = ACTIONS(1240),
    [sym_kOperator] = ACTIONS(1240),
    [sym_kPublished] = ACTIONS(1240),
    [sym_kPublic] = ACTIONS(1919),
    [sym_kProtected] = ACTIONS(1240),
    [sym_kPrivate] = ACTIONS(1240),
    [sym_kStrict] = ACTIONS(1240),
    [sym_kRequired] = ACTIONS(1240),
    [sym_kOptional] = ACTIONS(1240),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym__procAttribute] = STATE(472),
    [sym_procAttribute] = STATE(2249),
    [aux_sym_declProcFwd_repeat1] = STATE(262),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [sym_kEnd] = ACTIONS(1897),
    [sym_kVar] = ACTIONS(1899),
    [sym_kThreadvar] = ACTIONS(1897),
    [sym_kConst] = ACTIONS(1899),
    [sym_kResourcestring] = ACTIONS(1897),
    [sym_kType] = ACTIONS(1897),
    [sym_kProperty] = ACTIONS(1897),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1897),
    [sym_kGeneric] = ACTIONS(1897),
    [sym_kCase] = ACTIONS(1897),
    [sym_kFunction] = ACTIONS(1897),
    [sym_kProcedure] = ACTIONS(1897),
    [sym_kConstructor] = ACTIONS(1897),
    [sym_kDestructor] = ACTIONS(1897),
    [sym_kOperator] = ACTIONS(1897),
    [sym_kPublished] = ACTIONS(1897),
    [sym_kPublic] = ACTIONS(1925),
    [sym_kProtected] = ACTIONS(1897),
    [sym_kPrivate] = ACTIONS(1897),
    [sym_kStrict] = ACTIONS(1897),
    [sym_kRequired] = ACTIONS(1897),
    [sym_kOptional] = ACTIONS(1897),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(265),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [sym_kUses] = ACTIONS(1931),
    [sym_kInterface] = ACTIONS(1931),
    [sym_kImplementation] = ACTIONS(1931),
    [sym_kInitialization] = ACTIONS(1931),
    [sym_kFinalization] = ACTIONS(1931),
    [sym_kEnd] = ACTIONS(1931),
    [sym_kVar] = ACTIONS(1933),
    [sym_kThreadvar] = ACTIONS(1931),
    [sym_kConst] = ACTIONS(1933),
    [sym_kResourcestring] = ACTIONS(1931),
    [sym_kType] = ACTIONS(1931),
    [sym_kLabel] = ACTIONS(1931),
    [sym_kExports] = ACTIONS(1931),
    [sym_kProperty] = ACTIONS(1931),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1931),
    [sym_kGeneric] = ACTIONS(1931),
    [sym_kFunction] = ACTIONS(1931),
    [sym_kProcedure] = ACTIONS(1931),
    [sym_kConstructor] = ACTIONS(1931),
    [sym_kDestructor] = ACTIONS(1931),
    [sym_kOperator] = ACTIONS(1931),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1935),
    [sym_kUses] = ACTIONS(1938),
    [sym_kInterface] = ACTIONS(1938),
    [sym_kImplementation] = ACTIONS(1938),
    [sym_kInitialization] = ACTIONS(1938),
    [sym_kFinalization] = ACTIONS(1938),
    [sym_kEnd] = ACTIONS(1938),
    [sym_kVar] = ACTIONS(1940),
    [sym_kThreadvar] = ACTIONS(1938),
    [sym_kConst] = ACTIONS(1940),
    [sym_kResourcestring] = ACTIONS(1938),
    [sym_kType] = ACTIONS(1938),
    [sym_kLabel] = ACTIONS(1938),
    [sym_kExports] = ACTIONS(1938),
    [sym_kProperty] = ACTIONS(1938),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1938),
    [sym_kGeneric] = ACTIONS(1938),
    [sym_kFunction] = ACTIONS(1938),
    [sym_kProcedure] = ACTIONS(1938),
    [sym_kConstructor] = ACTIONS(1938),
    [sym_kDestructor] = ACTIONS(1938),
    [sym_kOperator] = ACTIONS(1938),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [sym_kUses] = ACTIONS(1945),
    [sym_kInterface] = ACTIONS(1945),
    [sym_kImplementation] = ACTIONS(1945),
    [sym_kInitialization] = ACTIONS(1945),
    [sym_kFinalization] = ACTIONS(1945),
    [sym_kEnd] = ACTIONS(1945),
    [sym_kVar] = ACTIONS(1947),
    [sym_kThreadvar] = ACTIONS(1945),
    [sym_kConst] = ACTIONS(1947),
    [sym_kResourcestring] = ACTIONS(1945),
    [sym_kType] = ACTIONS(1945),
    [sym_kLabel] = ACTIONS(1945),
    [sym_kExports] = ACTIONS(1945),
    [sym_kProperty] = ACTIONS(1945),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1945),
    [sym_kGeneric] = ACTIONS(1945),
    [sym_kFunction] = ACTIONS(1945),
    [sym_kProcedure] = ACTIONS(1945),
    [sym_kConstructor] = ACTIONS(1945),
    [sym_kDestructor] = ACTIONS(1945),
    [sym_kOperator] = ACTIONS(1945),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(1949),
    [sym_kUses] = ACTIONS(1952),
    [sym_kInterface] = ACTIONS(1952),
    [sym_kImplementation] = ACTIONS(1952),
    [sym_kInitialization] = ACTIONS(1952),
    [sym_kFinalization] = ACTIONS(1952),
    [sym_kEnd] = ACTIONS(1952),
    [sym_kVar] = ACTIONS(1954),
    [sym_kThreadvar] = ACTIONS(1952),
    [sym_kConst] = ACTIONS(1954),
    [sym_kResourcestring] = ACTIONS(1952),
    [sym_kType] = ACTIONS(1952),
    [sym_kLabel] = ACTIONS(1952),
    [sym_kExports] = ACTIONS(1952),
    [sym_kProperty] = ACTIONS(1952),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1952),
    [sym_kGeneric] = ACTIONS(1952),
    [sym_kFunction] = ACTIONS(1952),
    [sym_kProcedure] = ACTIONS(1952),
    [sym_kConstructor] = ACTIONS(1952),
    [sym_kDestructor] = ACTIONS(1952),
    [sym_kOperator] = ACTIONS(1952),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(280),
    [anon_sym_LBRACK] = ACTIONS(1956),
    [sym_kUses] = ACTIONS(1797),
    [sym_kInterface] = ACTIONS(1797),
    [sym_kImplementation] = ACTIONS(1797),
    [sym_kInitialization] = ACTIONS(1797),
    [sym_kFinalization] = ACTIONS(1797),
    [sym_kEnd] = ACTIONS(1797),
    [sym_kVar] = ACTIONS(1799),
    [sym_kThreadvar] = ACTIONS(1797),
    [sym_kConst] = ACTIONS(1799),
    [sym_kResourcestring] = ACTIONS(1797),
    [sym_kType] = ACTIONS(1797),
    [sym_kLabel] = ACTIONS(1797),
    [sym_kExports] = ACTIONS(1797),
    [sym_kProperty] = ACTIONS(1797),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1797),
    [sym_kGeneric] = ACTIONS(1797),
    [sym_kFunction] = ACTIONS(1797),
    [sym_kProcedure] = ACTIONS(1797),
    [sym_kConstructor] = ACTIONS(1797),
    [sym_kDestructor] = ACTIONS(1797),
    [sym_kOperator] = ACTIONS(1797),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(1959),
    [sym_kEnd] = ACTIONS(1247),
    [sym_kVar] = ACTIONS(1249),
    [sym_kThreadvar] = ACTIONS(1247),
    [sym_kConst] = ACTIONS(1249),
    [sym_kResourcestring] = ACTIONS(1247),
    [sym_kType] = ACTIONS(1247),
    [sym_kProperty] = ACTIONS(1247),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1247),
    [sym_kGeneric] = ACTIONS(1247),
    [sym_kCase] = ACTIONS(1247),
    [sym_kFunction] = ACTIONS(1247),
    [sym_kProcedure] = ACTIONS(1247),
    [sym_kConstructor] = ACTIONS(1247),
    [sym_kDestructor] = ACTIONS(1247),
    [sym_kOperator] = ACTIONS(1247),
    [sym_kPublished] = ACTIONS(1247),
    [sym_kPublic] = ACTIONS(1962),
    [sym_kProtected] = ACTIONS(1247),
    [sym_kPrivate] = ACTIONS(1247),
    [sym_kStrict] = ACTIONS(1247),
    [sym_kRequired] = ACTIONS(1247),
    [sym_kOptional] = ACTIONS(1247),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(310),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [sym_kEnd] = ACTIONS(1076),
    [sym_kVar] = ACTIONS(1078),
    [sym_kThreadvar] = ACTIONS(1076),
    [sym_kConst] = ACTIONS(1078),
    [sym_kResourcestring] = ACTIONS(1076),
    [sym_kType] = ACTIONS(1076),
    [sym_kProperty] = ACTIONS(1076),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1076),
    [sym_kGeneric] = ACTIONS(1076),
    [sym_kCase] = ACTIONS(1076),
    [sym_kFunction] = ACTIONS(1076),
    [sym_kProcedure] = ACTIONS(1076),
    [sym_kConstructor] = ACTIONS(1076),
    [sym_kDestructor] = ACTIONS(1076),
    [sym_kOperator] = ACTIONS(1076),
    [sym_kPublished] = ACTIONS(1076),
    [sym_kPublic] = ACTIONS(1968),
    [sym_kProtected] = ACTIONS(1076),
    [sym_kPrivate] = ACTIONS(1076),
    [sym_kStrict] = ACTIONS(1076),
    [sym_kRequired] = ACTIONS(1076),
    [sym_kOptional] = ACTIONS(1076),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(246),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [sym_kEnd] = ACTIONS(1346),
    [sym_kVar] = ACTIONS(1348),
    [sym_kThreadvar] = ACTIONS(1346),
    [sym_kConst] = ACTIONS(1348),
    [sym_kResourcestring] = ACTIONS(1346),
    [sym_kType] = ACTIONS(1346),
    [sym_kProperty] = ACTIONS(1346),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1346),
    [sym_kGeneric] = ACTIONS(1346),
    [sym_kCase] = ACTIONS(1346),
    [sym_kFunction] = ACTIONS(1346),
    [sym_kProcedure] = ACTIONS(1346),
    [sym_kConstructor] = ACTIONS(1346),
    [sym_kDestructor] = ACTIONS(1346),
    [sym_kOperator] = ACTIONS(1346),
    [sym_kPublished] = ACTIONS(1346),
    [sym_kPublic] = ACTIONS(1974),
    [sym_kProtected] = ACTIONS(1346),
    [sym_kPrivate] = ACTIONS(1346),
    [sym_kStrict] = ACTIONS(1346),
    [sym_kRequired] = ACTIONS(1346),
    [sym_kOptional] = ACTIONS(1346),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [sym_kUses] = ACTIONS(1780),
    [sym_kInterface] = ACTIONS(1780),
    [sym_kImplementation] = ACTIONS(1780),
    [sym_kInitialization] = ACTIONS(1780),
    [sym_kFinalization] = ACTIONS(1780),
    [sym_kEnd] = ACTIONS(1780),
    [sym_kVar] = ACTIONS(1782),
    [sym_kThreadvar] = ACTIONS(1780),
    [sym_kConst] = ACTIONS(1782),
    [sym_kResourcestring] = ACTIONS(1780),
    [sym_kType] = ACTIONS(1780),
    [sym_kLabel] = ACTIONS(1780),
    [sym_kExports] = ACTIONS(1780),
    [sym_kProperty] = ACTIONS(1780),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1780),
    [sym_kGeneric] = ACTIONS(1780),
    [sym_kFunction] = ACTIONS(1780),
    [sym_kProcedure] = ACTIONS(1780),
    [sym_kConstructor] = ACTIONS(1780),
    [sym_kDestructor] = ACTIONS(1780),
    [sym_kOperator] = ACTIONS(1780),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(282),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [sym_kUses] = ACTIONS(1770),
    [sym_kInterface] = ACTIONS(1770),
    [sym_kImplementation] = ACTIONS(1770),
    [sym_kInitialization] = ACTIONS(1770),
    [sym_kFinalization] = ACTIONS(1770),
    [sym_kEnd] = ACTIONS(1770),
    [sym_kVar] = ACTIONS(1772),
    [sym_kThreadvar] = ACTIONS(1770),
    [sym_kConst] = ACTIONS(1772),
    [sym_kResourcestring] = ACTIONS(1770),
    [sym_kType] = ACTIONS(1770),
    [sym_kLabel] = ACTIONS(1770),
    [sym_kExports] = ACTIONS(1770),
    [sym_kProperty] = ACTIONS(1770),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1770),
    [sym_kGeneric] = ACTIONS(1770),
    [sym_kFunction] = ACTIONS(1770),
    [sym_kProcedure] = ACTIONS(1770),
    [sym_kConstructor] = ACTIONS(1770),
    [sym_kDestructor] = ACTIONS(1770),
    [sym_kOperator] = ACTIONS(1770),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [sym_kUses] = ACTIONS(1720),
    [sym_kInterface] = ACTIONS(1720),
    [sym_kImplementation] = ACTIONS(1720),
    [sym_kInitialization] = ACTIONS(1720),
    [sym_kFinalization] = ACTIONS(1720),
    [sym_kEnd] = ACTIONS(1720),
    [sym_kVar] = ACTIONS(1722),
    [sym_kThreadvar] = ACTIONS(1720),
    [sym_kConst] = ACTIONS(1722),
    [sym_kResourcestring] = ACTIONS(1720),
    [sym_kType] = ACTIONS(1720),
    [sym_kLabel] = ACTIONS(1720),
    [sym_kExports] = ACTIONS(1720),
    [sym_kProperty] = ACTIONS(1720),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1720),
    [sym_kGeneric] = ACTIONS(1720),
    [sym_kFunction] = ACTIONS(1720),
    [sym_kProcedure] = ACTIONS(1720),
    [sym_kConstructor] = ACTIONS(1720),
    [sym_kDestructor] = ACTIONS(1720),
    [sym_kOperator] = ACTIONS(1720),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [sym_kEnd] = ACTIONS(1196),
    [sym_kVar] = ACTIONS(1198),
    [sym_kThreadvar] = ACTIONS(1196),
    [sym_kConst] = ACTIONS(1198),
    [sym_kResourcestring] = ACTIONS(1196),
    [sym_kType] = ACTIONS(1196),
    [sym_kProperty] = ACTIONS(1196),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1196),
    [sym_kGeneric] = ACTIONS(1196),
    [sym_kCase] = ACTIONS(1196),
    [sym_kFunction] = ACTIONS(1196),
    [sym_kProcedure] = ACTIONS(1196),
    [sym_kConstructor] = ACTIONS(1196),
    [sym_kDestructor] = ACTIONS(1196),
    [sym_kOperator] = ACTIONS(1196),
    [sym_kPublished] = ACTIONS(1196),
    [sym_kPublic] = ACTIONS(1989),
    [sym_kProtected] = ACTIONS(1196),
    [sym_kPrivate] = ACTIONS(1196),
    [sym_kStrict] = ACTIONS(1196),
    [sym_kRequired] = ACTIONS(1196),
    [sym_kOptional] = ACTIONS(1196),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(272),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [sym_kUses] = ACTIONS(1995),
    [sym_kInterface] = ACTIONS(1995),
    [sym_kImplementation] = ACTIONS(1995),
    [sym_kInitialization] = ACTIONS(1995),
    [sym_kFinalization] = ACTIONS(1995),
    [sym_kEnd] = ACTIONS(1995),
    [sym_kVar] = ACTIONS(1997),
    [sym_kThreadvar] = ACTIONS(1995),
    [sym_kConst] = ACTIONS(1997),
    [sym_kResourcestring] = ACTIONS(1995),
    [sym_kType] = ACTIONS(1995),
    [sym_kLabel] = ACTIONS(1995),
    [sym_kExports] = ACTIONS(1995),
    [sym_kProperty] = ACTIONS(1995),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1995),
    [sym_kGeneric] = ACTIONS(1995),
    [sym_kFunction] = ACTIONS(1995),
    [sym_kProcedure] = ACTIONS(1995),
    [sym_kConstructor] = ACTIONS(1995),
    [sym_kDestructor] = ACTIONS(1995),
    [sym_kOperator] = ACTIONS(1995),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(273),
    [anon_sym_LBRACK] = ACTIONS(1999),
    [sym_kUses] = ACTIONS(2002),
    [sym_kInterface] = ACTIONS(2002),
    [sym_kImplementation] = ACTIONS(2002),
    [sym_kInitialization] = ACTIONS(2002),
    [sym_kFinalization] = ACTIONS(2002),
    [sym_kEnd] = ACTIONS(2002),
    [sym_kVar] = ACTIONS(2004),
    [sym_kThreadvar] = ACTIONS(2002),
    [sym_kConst] = ACTIONS(2004),
    [sym_kResourcestring] = ACTIONS(2002),
    [sym_kType] = ACTIONS(2002),
    [sym_kLabel] = ACTIONS(2002),
    [sym_kExports] = ACTIONS(2002),
    [sym_kProperty] = ACTIONS(2002),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2002),
    [sym_kGeneric] = ACTIONS(2002),
    [sym_kFunction] = ACTIONS(2002),
    [sym_kProcedure] = ACTIONS(2002),
    [sym_kConstructor] = ACTIONS(2002),
    [sym_kDestructor] = ACTIONS(2002),
    [sym_kOperator] = ACTIONS(2002),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2006),
    [sym_kUses] = ACTIONS(2009),
    [sym_kInterface] = ACTIONS(2009),
    [sym_kImplementation] = ACTIONS(2009),
    [sym_kInitialization] = ACTIONS(2009),
    [sym_kFinalization] = ACTIONS(2009),
    [sym_kEnd] = ACTIONS(2009),
    [sym_kVar] = ACTIONS(2011),
    [sym_kThreadvar] = ACTIONS(2009),
    [sym_kConst] = ACTIONS(2011),
    [sym_kResourcestring] = ACTIONS(2009),
    [sym_kType] = ACTIONS(2009),
    [sym_kLabel] = ACTIONS(2009),
    [sym_kExports] = ACTIONS(2009),
    [sym_kProperty] = ACTIONS(2009),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2009),
    [sym_kGeneric] = ACTIONS(2009),
    [sym_kFunction] = ACTIONS(2009),
    [sym_kProcedure] = ACTIONS(2009),
    [sym_kConstructor] = ACTIONS(2009),
    [sym_kDestructor] = ACTIONS(2009),
    [sym_kOperator] = ACTIONS(2009),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(276),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [sym_kUses] = ACTIONS(2016),
    [sym_kInterface] = ACTIONS(2016),
    [sym_kImplementation] = ACTIONS(2016),
    [sym_kInitialization] = ACTIONS(2016),
    [sym_kFinalization] = ACTIONS(2016),
    [sym_kEnd] = ACTIONS(2016),
    [sym_kVar] = ACTIONS(2018),
    [sym_kThreadvar] = ACTIONS(2016),
    [sym_kConst] = ACTIONS(2018),
    [sym_kResourcestring] = ACTIONS(2016),
    [sym_kType] = ACTIONS(2016),
    [sym_kLabel] = ACTIONS(2016),
    [sym_kExports] = ACTIONS(2016),
    [sym_kProperty] = ACTIONS(2016),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2016),
    [sym_kGeneric] = ACTIONS(2016),
    [sym_kFunction] = ACTIONS(2016),
    [sym_kProcedure] = ACTIONS(2016),
    [sym_kConstructor] = ACTIONS(2016),
    [sym_kDestructor] = ACTIONS(2016),
    [sym_kOperator] = ACTIONS(2016),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_kUses] = ACTIONS(2023),
    [sym_kInterface] = ACTIONS(2023),
    [sym_kImplementation] = ACTIONS(2023),
    [sym_kInitialization] = ACTIONS(2023),
    [sym_kFinalization] = ACTIONS(2023),
    [sym_kEnd] = ACTIONS(2023),
    [sym_kVar] = ACTIONS(2025),
    [sym_kThreadvar] = ACTIONS(2023),
    [sym_kConst] = ACTIONS(2025),
    [sym_kResourcestring] = ACTIONS(2023),
    [sym_kType] = ACTIONS(2023),
    [sym_kLabel] = ACTIONS(2023),
    [sym_kExports] = ACTIONS(2023),
    [sym_kProperty] = ACTIONS(2023),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2023),
    [sym_kGeneric] = ACTIONS(2023),
    [sym_kFunction] = ACTIONS(2023),
    [sym_kProcedure] = ACTIONS(2023),
    [sym_kConstructor] = ACTIONS(2023),
    [sym_kDestructor] = ACTIONS(2023),
    [sym_kOperator] = ACTIONS(2023),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [sym_kUses] = ACTIONS(2030),
    [sym_kInterface] = ACTIONS(2030),
    [sym_kImplementation] = ACTIONS(2030),
    [sym_kInitialization] = ACTIONS(2030),
    [sym_kFinalization] = ACTIONS(2030),
    [sym_kEnd] = ACTIONS(2030),
    [sym_kVar] = ACTIONS(2032),
    [sym_kThreadvar] = ACTIONS(2030),
    [sym_kConst] = ACTIONS(2032),
    [sym_kResourcestring] = ACTIONS(2030),
    [sym_kType] = ACTIONS(2030),
    [sym_kLabel] = ACTIONS(2030),
    [sym_kExports] = ACTIONS(2030),
    [sym_kProperty] = ACTIONS(2030),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2030),
    [sym_kGeneric] = ACTIONS(2030),
    [sym_kFunction] = ACTIONS(2030),
    [sym_kProcedure] = ACTIONS(2030),
    [sym_kConstructor] = ACTIONS(2030),
    [sym_kDestructor] = ACTIONS(2030),
    [sym_kOperator] = ACTIONS(2030),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(315),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [sym_kEnd] = ACTIONS(1182),
    [sym_kVar] = ACTIONS(1184),
    [sym_kThreadvar] = ACTIONS(1182),
    [sym_kConst] = ACTIONS(1184),
    [sym_kResourcestring] = ACTIONS(1182),
    [sym_kType] = ACTIONS(1182),
    [sym_kProperty] = ACTIONS(1182),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1182),
    [sym_kGeneric] = ACTIONS(1182),
    [sym_kCase] = ACTIONS(1182),
    [sym_kFunction] = ACTIONS(1182),
    [sym_kProcedure] = ACTIONS(1182),
    [sym_kConstructor] = ACTIONS(1182),
    [sym_kDestructor] = ACTIONS(1182),
    [sym_kOperator] = ACTIONS(1182),
    [sym_kPublished] = ACTIONS(1182),
    [sym_kPublic] = ACTIONS(2037),
    [sym_kProtected] = ACTIONS(1182),
    [sym_kPrivate] = ACTIONS(1182),
    [sym_kStrict] = ACTIONS(1182),
    [sym_kRequired] = ACTIONS(1182),
    [sym_kOptional] = ACTIONS(1182),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(316),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [sym_kEnd] = ACTIONS(1132),
    [sym_kVar] = ACTIONS(1134),
    [sym_kThreadvar] = ACTIONS(1132),
    [sym_kConst] = ACTIONS(1134),
    [sym_kResourcestring] = ACTIONS(1132),
    [sym_kType] = ACTIONS(1132),
    [sym_kProperty] = ACTIONS(1132),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1132),
    [sym_kGeneric] = ACTIONS(1132),
    [sym_kCase] = ACTIONS(1132),
    [sym_kFunction] = ACTIONS(1132),
    [sym_kProcedure] = ACTIONS(1132),
    [sym_kConstructor] = ACTIONS(1132),
    [sym_kDestructor] = ACTIONS(1132),
    [sym_kOperator] = ACTIONS(1132),
    [sym_kPublished] = ACTIONS(1132),
    [sym_kPublic] = ACTIONS(2043),
    [sym_kProtected] = ACTIONS(1132),
    [sym_kPrivate] = ACTIONS(1132),
    [sym_kStrict] = ACTIONS(1132),
    [sym_kRequired] = ACTIONS(1132),
    [sym_kOptional] = ACTIONS(1132),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(319),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [sym_kEnd] = ACTIONS(1083),
    [sym_kVar] = ACTIONS(1085),
    [sym_kThreadvar] = ACTIONS(1083),
    [sym_kConst] = ACTIONS(1085),
    [sym_kResourcestring] = ACTIONS(1083),
    [sym_kType] = ACTIONS(1083),
    [sym_kProperty] = ACTIONS(1083),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1083),
    [sym_kGeneric] = ACTIONS(1083),
    [sym_kCase] = ACTIONS(1083),
    [sym_kFunction] = ACTIONS(1083),
    [sym_kProcedure] = ACTIONS(1083),
    [sym_kConstructor] = ACTIONS(1083),
    [sym_kDestructor] = ACTIONS(1083),
    [sym_kOperator] = ACTIONS(1083),
    [sym_kPublished] = ACTIONS(1083),
    [sym_kPublic] = ACTIONS(2049),
    [sym_kProtected] = ACTIONS(1083),
    [sym_kPrivate] = ACTIONS(1083),
    [sym_kStrict] = ACTIONS(1083),
    [sym_kRequired] = ACTIONS(1083),
    [sym_kOptional] = ACTIONS(1083),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [sym_kUses] = ACTIONS(1703),
    [sym_kInterface] = ACTIONS(1703),
    [sym_kImplementation] = ACTIONS(1703),
    [sym_kInitialization] = ACTIONS(1703),
    [sym_kFinalization] = ACTIONS(1703),
    [sym_kEnd] = ACTIONS(1703),
    [sym_kVar] = ACTIONS(1705),
    [sym_kThreadvar] = ACTIONS(1703),
    [sym_kConst] = ACTIONS(1705),
    [sym_kResourcestring] = ACTIONS(1703),
    [sym_kType] = ACTIONS(1703),
    [sym_kLabel] = ACTIONS(1703),
    [sym_kExports] = ACTIONS(1703),
    [sym_kProperty] = ACTIONS(1703),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1703),
    [sym_kGeneric] = ACTIONS(1703),
    [sym_kFunction] = ACTIONS(1703),
    [sym_kProcedure] = ACTIONS(1703),
    [sym_kConstructor] = ACTIONS(1703),
    [sym_kDestructor] = ACTIONS(1703),
    [sym_kOperator] = ACTIONS(1703),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [sym_kEnd] = ACTIONS(1286),
    [sym_kVar] = ACTIONS(1288),
    [sym_kThreadvar] = ACTIONS(1286),
    [sym_kConst] = ACTIONS(1288),
    [sym_kResourcestring] = ACTIONS(1286),
    [sym_kType] = ACTIONS(1286),
    [sym_kProperty] = ACTIONS(1286),
    [sym_kDefault] = ACTIONS(1290),
    [sym_kNodefault] = ACTIONS(1290),
    [sym_kClass] = ACTIONS(1286),
    [sym_kGeneric] = ACTIONS(1286),
    [sym_kCase] = ACTIONS(1286),
    [sym_kFunction] = ACTIONS(1286),
    [sym_kProcedure] = ACTIONS(1286),
    [sym_kConstructor] = ACTIONS(1286),
    [sym_kDestructor] = ACTIONS(1286),
    [sym_kOperator] = ACTIONS(1286),
    [sym_kPublished] = ACTIONS(1286),
    [sym_kPublic] = ACTIONS(1293),
    [sym_kProtected] = ACTIONS(1286),
    [sym_kPrivate] = ACTIONS(1286),
    [sym_kStrict] = ACTIONS(1286),
    [sym_kRequired] = ACTIONS(1286),
    [sym_kOptional] = ACTIONS(1286),
    [sym_kStatic] = ACTIONS(1290),
    [sym_kVirtual] = ACTIONS(1290),
    [sym_kAbstract] = ACTIONS(1290),
    [sym_kDynamic] = ACTIONS(1290),
    [sym_kOverride] = ACTIONS(1290),
    [sym_kOverload] = ACTIONS(1290),
    [sym_kReintroduce] = ACTIONS(1290),
    [sym_kInline] = ACTIONS(1290),
    [sym_kStdcall] = ACTIONS(1290),
    [sym_kCdecl] = ACTIONS(1290),
    [sym_kCppdecl] = ACTIONS(1290),
    [sym_kPascal] = ACTIONS(1290),
    [sym_kRegister] = ACTIONS(1290),
    [sym_kMwpascal] = ACTIONS(1290),
    [sym_kMessage] = ACTIONS(1296),
    [sym_kDeprecated] = ACTIONS(1299),
    [sym_kExperimental] = ACTIONS(1290),
    [sym_kPlatform] = ACTIONS(1290),
    [sym_kUnimplemented] = ACTIONS(1290),
    [sym_kCvar] = ACTIONS(1290),
    [sym_kExport] = ACTIONS(2058),
    [sym_kFar] = ACTIONS(1290),
    [sym_kNear] = ACTIONS(1290),
    [sym_kSafecall] = ACTIONS(1290),
    [sym_kAssembler] = ACTIONS(1290),
    [sym_kNostackframe] = ACTIONS(1290),
    [sym_kInterrupt] = ACTIONS(1290),
    [sym_kNoreturn] = ACTIONS(1290),
    [sym_kIocheck] = ACTIONS(1290),
    [sym_kLocal] = ACTIONS(1290),
    [sym_kHardfloat] = ACTIONS(1290),
    [sym_kSoftfloat] = ACTIONS(1290),
    [sym_kMs_abi_default] = ACTIONS(1290),
    [sym_kMs_abi_cdecl] = ACTIONS(1290),
    [sym_kSaveregisters] = ACTIONS(1290),
    [sym_kSysv_abi_default] = ACTIONS(1290),
    [sym_kSysv_abi_cdecl] = ACTIONS(1290),
    [sym_kVectorcall] = ACTIONS(1290),
    [sym_kVarargs] = ACTIONS(1290),
    [sym_kWinapi] = ACTIONS(1290),
    [sym_kAlias] = ACTIONS(1305),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(324),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_kEnd] = ACTIONS(1189),
    [sym_kVar] = ACTIONS(1191),
    [sym_kThreadvar] = ACTIONS(1189),
    [sym_kConst] = ACTIONS(1191),
    [sym_kResourcestring] = ACTIONS(1189),
    [sym_kType] = ACTIONS(1189),
    [sym_kProperty] = ACTIONS(1189),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1189),
    [sym_kGeneric] = ACTIONS(1189),
    [sym_kCase] = ACTIONS(1189),
    [sym_kFunction] = ACTIONS(1189),
    [sym_kProcedure] = ACTIONS(1189),
    [sym_kConstructor] = ACTIONS(1189),
    [sym_kDestructor] = ACTIONS(1189),
    [sym_kOperator] = ACTIONS(1189),
    [sym_kPublished] = ACTIONS(1189),
    [sym_kPublic] = ACTIONS(2064),
    [sym_kProtected] = ACTIONS(1189),
    [sym_kPrivate] = ACTIONS(1189),
    [sym_kStrict] = ACTIONS(1189),
    [sym_kRequired] = ACTIONS(1189),
    [sym_kOptional] = ACTIONS(1189),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [sym_kEnd] = ACTIONS(1175),
    [sym_kVar] = ACTIONS(1177),
    [sym_kThreadvar] = ACTIONS(1175),
    [sym_kConst] = ACTIONS(1177),
    [sym_kResourcestring] = ACTIONS(1175),
    [sym_kType] = ACTIONS(1175),
    [sym_kProperty] = ACTIONS(1175),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1175),
    [sym_kGeneric] = ACTIONS(1175),
    [sym_kCase] = ACTIONS(1175),
    [sym_kFunction] = ACTIONS(1175),
    [sym_kProcedure] = ACTIONS(1175),
    [sym_kConstructor] = ACTIONS(1175),
    [sym_kDestructor] = ACTIONS(1175),
    [sym_kOperator] = ACTIONS(1175),
    [sym_kPublished] = ACTIONS(1175),
    [sym_kPublic] = ACTIONS(2070),
    [sym_kProtected] = ACTIONS(1175),
    [sym_kPrivate] = ACTIONS(1175),
    [sym_kStrict] = ACTIONS(1175),
    [sym_kRequired] = ACTIONS(1175),
    [sym_kOptional] = ACTIONS(1175),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(330),
    [anon_sym_LBRACK] = ACTIONS(2073),
    [sym_kEnd] = ACTIONS(1409),
    [sym_kVar] = ACTIONS(1411),
    [sym_kThreadvar] = ACTIONS(1409),
    [sym_kConst] = ACTIONS(1411),
    [sym_kResourcestring] = ACTIONS(1409),
    [sym_kType] = ACTIONS(1409),
    [sym_kProperty] = ACTIONS(1409),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1409),
    [sym_kGeneric] = ACTIONS(1409),
    [sym_kCase] = ACTIONS(1409),
    [sym_kFunction] = ACTIONS(1409),
    [sym_kProcedure] = ACTIONS(1409),
    [sym_kConstructor] = ACTIONS(1409),
    [sym_kDestructor] = ACTIONS(1409),
    [sym_kOperator] = ACTIONS(1409),
    [sym_kPublished] = ACTIONS(1409),
    [sym_kPublic] = ACTIONS(2076),
    [sym_kProtected] = ACTIONS(1409),
    [sym_kPrivate] = ACTIONS(1409),
    [sym_kStrict] = ACTIONS(1409),
    [sym_kRequired] = ACTIONS(1409),
    [sym_kOptional] = ACTIONS(1409),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(332),
    [anon_sym_LBRACK] = ACTIONS(2079),
    [sym_kEnd] = ACTIONS(2082),
    [sym_kVar] = ACTIONS(2084),
    [sym_kThreadvar] = ACTIONS(2082),
    [sym_kConst] = ACTIONS(2084),
    [sym_kResourcestring] = ACTIONS(2082),
    [sym_kType] = ACTIONS(2082),
    [sym_kProperty] = ACTIONS(2082),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2082),
    [sym_kGeneric] = ACTIONS(2082),
    [sym_kCase] = ACTIONS(2082),
    [sym_kFunction] = ACTIONS(2082),
    [sym_kProcedure] = ACTIONS(2082),
    [sym_kConstructor] = ACTIONS(2082),
    [sym_kDestructor] = ACTIONS(2082),
    [sym_kOperator] = ACTIONS(2082),
    [sym_kPublished] = ACTIONS(2082),
    [sym_kPublic] = ACTIONS(2086),
    [sym_kProtected] = ACTIONS(2082),
    [sym_kPrivate] = ACTIONS(2082),
    [sym_kStrict] = ACTIONS(2082),
    [sym_kRequired] = ACTIONS(2082),
    [sym_kOptional] = ACTIONS(2082),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(2089),
    [sym_kUses] = ACTIONS(1693),
    [sym_kInterface] = ACTIONS(1693),
    [sym_kImplementation] = ACTIONS(1693),
    [sym_kInitialization] = ACTIONS(1693),
    [sym_kFinalization] = ACTIONS(1693),
    [sym_kEnd] = ACTIONS(1693),
    [sym_kVar] = ACTIONS(1695),
    [sym_kThreadvar] = ACTIONS(1693),
    [sym_kConst] = ACTIONS(1695),
    [sym_kResourcestring] = ACTIONS(1693),
    [sym_kType] = ACTIONS(1693),
    [sym_kLabel] = ACTIONS(1693),
    [sym_kExports] = ACTIONS(1693),
    [sym_kProperty] = ACTIONS(1693),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1693),
    [sym_kGeneric] = ACTIONS(1693),
    [sym_kFunction] = ACTIONS(1693),
    [sym_kProcedure] = ACTIONS(1693),
    [sym_kConstructor] = ACTIONS(1693),
    [sym_kDestructor] = ACTIONS(1693),
    [sym_kOperator] = ACTIONS(1693),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(339),
    [anon_sym_LBRACK] = ACTIONS(2092),
    [sym_kEnd] = ACTIONS(1458),
    [sym_kVar] = ACTIONS(1460),
    [sym_kThreadvar] = ACTIONS(1458),
    [sym_kConst] = ACTIONS(1460),
    [sym_kResourcestring] = ACTIONS(1458),
    [sym_kType] = ACTIONS(1458),
    [sym_kProperty] = ACTIONS(1458),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1458),
    [sym_kGeneric] = ACTIONS(1458),
    [sym_kCase] = ACTIONS(1458),
    [sym_kFunction] = ACTIONS(1458),
    [sym_kProcedure] = ACTIONS(1458),
    [sym_kConstructor] = ACTIONS(1458),
    [sym_kDestructor] = ACTIONS(1458),
    [sym_kOperator] = ACTIONS(1458),
    [sym_kPublished] = ACTIONS(1458),
    [sym_kPublic] = ACTIONS(2095),
    [sym_kProtected] = ACTIONS(1458),
    [sym_kPrivate] = ACTIONS(1458),
    [sym_kStrict] = ACTIONS(1458),
    [sym_kRequired] = ACTIONS(1458),
    [sym_kOptional] = ACTIONS(1458),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [sym_kEnd] = ACTIONS(1451),
    [sym_kVar] = ACTIONS(1453),
    [sym_kThreadvar] = ACTIONS(1451),
    [sym_kConst] = ACTIONS(1453),
    [sym_kResourcestring] = ACTIONS(1451),
    [sym_kType] = ACTIONS(1451),
    [sym_kProperty] = ACTIONS(1451),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1451),
    [sym_kGeneric] = ACTIONS(1451),
    [sym_kCase] = ACTIONS(1451),
    [sym_kFunction] = ACTIONS(1451),
    [sym_kProcedure] = ACTIONS(1451),
    [sym_kConstructor] = ACTIONS(1451),
    [sym_kDestructor] = ACTIONS(1451),
    [sym_kOperator] = ACTIONS(1451),
    [sym_kPublished] = ACTIONS(1451),
    [sym_kPublic] = ACTIONS(2101),
    [sym_kProtected] = ACTIONS(1451),
    [sym_kPrivate] = ACTIONS(1451),
    [sym_kStrict] = ACTIONS(1451),
    [sym_kRequired] = ACTIONS(1451),
    [sym_kOptional] = ACTIONS(1451),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [sym_kEnd] = ACTIONS(1444),
    [sym_kVar] = ACTIONS(1446),
    [sym_kThreadvar] = ACTIONS(1444),
    [sym_kConst] = ACTIONS(1446),
    [sym_kResourcestring] = ACTIONS(1444),
    [sym_kType] = ACTIONS(1444),
    [sym_kProperty] = ACTIONS(1444),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1444),
    [sym_kGeneric] = ACTIONS(1444),
    [sym_kCase] = ACTIONS(1444),
    [sym_kFunction] = ACTIONS(1444),
    [sym_kProcedure] = ACTIONS(1444),
    [sym_kConstructor] = ACTIONS(1444),
    [sym_kDestructor] = ACTIONS(1444),
    [sym_kOperator] = ACTIONS(1444),
    [sym_kPublished] = ACTIONS(1444),
    [sym_kPublic] = ACTIONS(2107),
    [sym_kProtected] = ACTIONS(1444),
    [sym_kPrivate] = ACTIONS(1444),
    [sym_kStrict] = ACTIONS(1444),
    [sym_kRequired] = ACTIONS(1444),
    [sym_kOptional] = ACTIONS(1444),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(342),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [sym_kEnd] = ACTIONS(1437),
    [sym_kVar] = ACTIONS(1439),
    [sym_kThreadvar] = ACTIONS(1437),
    [sym_kConst] = ACTIONS(1439),
    [sym_kResourcestring] = ACTIONS(1437),
    [sym_kType] = ACTIONS(1437),
    [sym_kProperty] = ACTIONS(1437),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1437),
    [sym_kGeneric] = ACTIONS(1437),
    [sym_kCase] = ACTIONS(1437),
    [sym_kFunction] = ACTIONS(1437),
    [sym_kProcedure] = ACTIONS(1437),
    [sym_kConstructor] = ACTIONS(1437),
    [sym_kDestructor] = ACTIONS(1437),
    [sym_kOperator] = ACTIONS(1437),
    [sym_kPublished] = ACTIONS(1437),
    [sym_kPublic] = ACTIONS(2113),
    [sym_kProtected] = ACTIONS(1437),
    [sym_kPrivate] = ACTIONS(1437),
    [sym_kStrict] = ACTIONS(1437),
    [sym_kRequired] = ACTIONS(1437),
    [sym_kOptional] = ACTIONS(1437),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(343),
    [anon_sym_LBRACK] = ACTIONS(2116),
    [sym_kEnd] = ACTIONS(2119),
    [sym_kVar] = ACTIONS(2121),
    [sym_kThreadvar] = ACTIONS(2119),
    [sym_kConst] = ACTIONS(2121),
    [sym_kResourcestring] = ACTIONS(2119),
    [sym_kType] = ACTIONS(2119),
    [sym_kProperty] = ACTIONS(2119),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2119),
    [sym_kGeneric] = ACTIONS(2119),
    [sym_kCase] = ACTIONS(2119),
    [sym_kFunction] = ACTIONS(2119),
    [sym_kProcedure] = ACTIONS(2119),
    [sym_kConstructor] = ACTIONS(2119),
    [sym_kDestructor] = ACTIONS(2119),
    [sym_kOperator] = ACTIONS(2119),
    [sym_kPublished] = ACTIONS(2119),
    [sym_kPublic] = ACTIONS(2123),
    [sym_kProtected] = ACTIONS(2119),
    [sym_kPrivate] = ACTIONS(2119),
    [sym_kStrict] = ACTIONS(2119),
    [sym_kRequired] = ACTIONS(2119),
    [sym_kOptional] = ACTIONS(2119),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [sym_kEnd] = ACTIONS(1423),
    [sym_kVar] = ACTIONS(1425),
    [sym_kThreadvar] = ACTIONS(1423),
    [sym_kConst] = ACTIONS(1425),
    [sym_kResourcestring] = ACTIONS(1423),
    [sym_kType] = ACTIONS(1423),
    [sym_kProperty] = ACTIONS(1423),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1423),
    [sym_kGeneric] = ACTIONS(1423),
    [sym_kCase] = ACTIONS(1423),
    [sym_kFunction] = ACTIONS(1423),
    [sym_kProcedure] = ACTIONS(1423),
    [sym_kConstructor] = ACTIONS(1423),
    [sym_kDestructor] = ACTIONS(1423),
    [sym_kOperator] = ACTIONS(1423),
    [sym_kPublished] = ACTIONS(1423),
    [sym_kPublic] = ACTIONS(2129),
    [sym_kProtected] = ACTIONS(1423),
    [sym_kPrivate] = ACTIONS(1423),
    [sym_kStrict] = ACTIONS(1423),
    [sym_kRequired] = ACTIONS(1423),
    [sym_kOptional] = ACTIONS(1423),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(352),
    [anon_sym_LBRACK] = ACTIONS(2132),
    [sym_kEnd] = ACTIONS(1402),
    [sym_kVar] = ACTIONS(1404),
    [sym_kThreadvar] = ACTIONS(1402),
    [sym_kConst] = ACTIONS(1404),
    [sym_kResourcestring] = ACTIONS(1402),
    [sym_kType] = ACTIONS(1402),
    [sym_kProperty] = ACTIONS(1402),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1402),
    [sym_kGeneric] = ACTIONS(1402),
    [sym_kCase] = ACTIONS(1402),
    [sym_kFunction] = ACTIONS(1402),
    [sym_kProcedure] = ACTIONS(1402),
    [sym_kConstructor] = ACTIONS(1402),
    [sym_kDestructor] = ACTIONS(1402),
    [sym_kOperator] = ACTIONS(1402),
    [sym_kPublished] = ACTIONS(1402),
    [sym_kPublic] = ACTIONS(2135),
    [sym_kProtected] = ACTIONS(1402),
    [sym_kPrivate] = ACTIONS(1402),
    [sym_kStrict] = ACTIONS(1402),
    [sym_kRequired] = ACTIONS(1402),
    [sym_kOptional] = ACTIONS(1402),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(294),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [sym_kUses] = ACTIONS(1663),
    [sym_kInterface] = ACTIONS(1663),
    [sym_kImplementation] = ACTIONS(1663),
    [sym_kInitialization] = ACTIONS(1663),
    [sym_kFinalization] = ACTIONS(1663),
    [sym_kEnd] = ACTIONS(1663),
    [sym_kVar] = ACTIONS(1665),
    [sym_kThreadvar] = ACTIONS(1663),
    [sym_kConst] = ACTIONS(1665),
    [sym_kResourcestring] = ACTIONS(1663),
    [sym_kType] = ACTIONS(1663),
    [sym_kLabel] = ACTIONS(1663),
    [sym_kExports] = ACTIONS(1663),
    [sym_kProperty] = ACTIONS(1663),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1663),
    [sym_kGeneric] = ACTIONS(1663),
    [sym_kFunction] = ACTIONS(1663),
    [sym_kProcedure] = ACTIONS(1663),
    [sym_kConstructor] = ACTIONS(1663),
    [sym_kDestructor] = ACTIONS(1663),
    [sym_kOperator] = ACTIONS(1663),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(353),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [sym_kEnd] = ACTIONS(1388),
    [sym_kVar] = ACTIONS(1390),
    [sym_kThreadvar] = ACTIONS(1388),
    [sym_kConst] = ACTIONS(1390),
    [sym_kResourcestring] = ACTIONS(1388),
    [sym_kType] = ACTIONS(1388),
    [sym_kProperty] = ACTIONS(1388),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1388),
    [sym_kGeneric] = ACTIONS(1388),
    [sym_kCase] = ACTIONS(1388),
    [sym_kFunction] = ACTIONS(1388),
    [sym_kProcedure] = ACTIONS(1388),
    [sym_kConstructor] = ACTIONS(1388),
    [sym_kDestructor] = ACTIONS(1388),
    [sym_kOperator] = ACTIONS(1388),
    [sym_kPublished] = ACTIONS(1388),
    [sym_kPublic] = ACTIONS(2144),
    [sym_kProtected] = ACTIONS(1388),
    [sym_kPrivate] = ACTIONS(1388),
    [sym_kStrict] = ACTIONS(1388),
    [sym_kRequired] = ACTIONS(1388),
    [sym_kOptional] = ACTIONS(1388),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(296),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [sym_kUses] = ACTIONS(1616),
    [sym_kInterface] = ACTIONS(1616),
    [sym_kImplementation] = ACTIONS(1616),
    [sym_kInitialization] = ACTIONS(1616),
    [sym_kFinalization] = ACTIONS(1616),
    [sym_kEnd] = ACTIONS(1616),
    [sym_kVar] = ACTIONS(1618),
    [sym_kThreadvar] = ACTIONS(1616),
    [sym_kConst] = ACTIONS(1618),
    [sym_kResourcestring] = ACTIONS(1616),
    [sym_kType] = ACTIONS(1616),
    [sym_kLabel] = ACTIONS(1616),
    [sym_kExports] = ACTIONS(1616),
    [sym_kProperty] = ACTIONS(1616),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1616),
    [sym_kGeneric] = ACTIONS(1616),
    [sym_kFunction] = ACTIONS(1616),
    [sym_kProcedure] = ACTIONS(1616),
    [sym_kConstructor] = ACTIONS(1616),
    [sym_kDestructor] = ACTIONS(1616),
    [sym_kOperator] = ACTIONS(1616),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [sym_kEnd] = ACTIONS(1339),
    [sym_kVar] = ACTIONS(1341),
    [sym_kThreadvar] = ACTIONS(1339),
    [sym_kConst] = ACTIONS(1341),
    [sym_kResourcestring] = ACTIONS(1339),
    [sym_kType] = ACTIONS(1339),
    [sym_kProperty] = ACTIONS(1339),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1339),
    [sym_kGeneric] = ACTIONS(1339),
    [sym_kCase] = ACTIONS(1339),
    [sym_kFunction] = ACTIONS(1339),
    [sym_kProcedure] = ACTIONS(1339),
    [sym_kConstructor] = ACTIONS(1339),
    [sym_kDestructor] = ACTIONS(1339),
    [sym_kOperator] = ACTIONS(1339),
    [sym_kPublished] = ACTIONS(1339),
    [sym_kPublic] = ACTIONS(2153),
    [sym_kProtected] = ACTIONS(1339),
    [sym_kPrivate] = ACTIONS(1339),
    [sym_kStrict] = ACTIONS(1339),
    [sym_kRequired] = ACTIONS(1339),
    [sym_kOptional] = ACTIONS(1339),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(356),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [sym_kEnd] = ACTIONS(1332),
    [sym_kVar] = ACTIONS(1334),
    [sym_kThreadvar] = ACTIONS(1332),
    [sym_kConst] = ACTIONS(1334),
    [sym_kResourcestring] = ACTIONS(1332),
    [sym_kType] = ACTIONS(1332),
    [sym_kProperty] = ACTIONS(1332),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1332),
    [sym_kGeneric] = ACTIONS(1332),
    [sym_kCase] = ACTIONS(1332),
    [sym_kFunction] = ACTIONS(1332),
    [sym_kProcedure] = ACTIONS(1332),
    [sym_kConstructor] = ACTIONS(1332),
    [sym_kDestructor] = ACTIONS(1332),
    [sym_kOperator] = ACTIONS(1332),
    [sym_kPublished] = ACTIONS(1332),
    [sym_kPublic] = ACTIONS(2159),
    [sym_kProtected] = ACTIONS(1332),
    [sym_kPrivate] = ACTIONS(1332),
    [sym_kStrict] = ACTIONS(1332),
    [sym_kRequired] = ACTIONS(1332),
    [sym_kOptional] = ACTIONS(1332),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(357),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [sym_kEnd] = ACTIONS(1279),
    [sym_kVar] = ACTIONS(1281),
    [sym_kThreadvar] = ACTIONS(1279),
    [sym_kConst] = ACTIONS(1281),
    [sym_kResourcestring] = ACTIONS(1279),
    [sym_kType] = ACTIONS(1279),
    [sym_kProperty] = ACTIONS(1279),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1279),
    [sym_kGeneric] = ACTIONS(1279),
    [sym_kCase] = ACTIONS(1279),
    [sym_kFunction] = ACTIONS(1279),
    [sym_kProcedure] = ACTIONS(1279),
    [sym_kConstructor] = ACTIONS(1279),
    [sym_kDestructor] = ACTIONS(1279),
    [sym_kOperator] = ACTIONS(1279),
    [sym_kPublished] = ACTIONS(1279),
    [sym_kPublic] = ACTIONS(2165),
    [sym_kProtected] = ACTIONS(1279),
    [sym_kPrivate] = ACTIONS(1279),
    [sym_kStrict] = ACTIONS(1279),
    [sym_kRequired] = ACTIONS(1279),
    [sym_kOptional] = ACTIONS(1279),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [sym_kUses] = ACTIONS(2171),
    [sym_kInterface] = ACTIONS(2171),
    [sym_kImplementation] = ACTIONS(2171),
    [sym_kInitialization] = ACTIONS(2171),
    [sym_kFinalization] = ACTIONS(2171),
    [sym_kEnd] = ACTIONS(2171),
    [sym_kVar] = ACTIONS(2173),
    [sym_kThreadvar] = ACTIONS(2171),
    [sym_kConst] = ACTIONS(2173),
    [sym_kResourcestring] = ACTIONS(2171),
    [sym_kType] = ACTIONS(2171),
    [sym_kLabel] = ACTIONS(2171),
    [sym_kExports] = ACTIONS(2171),
    [sym_kProperty] = ACTIONS(2171),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2171),
    [sym_kGeneric] = ACTIONS(2171),
    [sym_kFunction] = ACTIONS(2171),
    [sym_kProcedure] = ACTIONS(2171),
    [sym_kConstructor] = ACTIONS(2171),
    [sym_kDestructor] = ACTIONS(2171),
    [sym_kOperator] = ACTIONS(2171),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(288),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [sym_kUses] = ACTIONS(2178),
    [sym_kInterface] = ACTIONS(2178),
    [sym_kImplementation] = ACTIONS(2178),
    [sym_kInitialization] = ACTIONS(2178),
    [sym_kFinalization] = ACTIONS(2178),
    [sym_kEnd] = ACTIONS(2178),
    [sym_kVar] = ACTIONS(2180),
    [sym_kThreadvar] = ACTIONS(2178),
    [sym_kConst] = ACTIONS(2180),
    [sym_kResourcestring] = ACTIONS(2178),
    [sym_kType] = ACTIONS(2178),
    [sym_kLabel] = ACTIONS(2178),
    [sym_kExports] = ACTIONS(2178),
    [sym_kProperty] = ACTIONS(2178),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2178),
    [sym_kGeneric] = ACTIONS(2178),
    [sym_kFunction] = ACTIONS(2178),
    [sym_kProcedure] = ACTIONS(2178),
    [sym_kConstructor] = ACTIONS(2178),
    [sym_kDestructor] = ACTIONS(2178),
    [sym_kOperator] = ACTIONS(2178),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [sym_kUses] = ACTIONS(2185),
    [sym_kInterface] = ACTIONS(2185),
    [sym_kImplementation] = ACTIONS(2185),
    [sym_kInitialization] = ACTIONS(2185),
    [sym_kFinalization] = ACTIONS(2185),
    [sym_kEnd] = ACTIONS(2185),
    [sym_kVar] = ACTIONS(2187),
    [sym_kThreadvar] = ACTIONS(2185),
    [sym_kConst] = ACTIONS(2187),
    [sym_kResourcestring] = ACTIONS(2185),
    [sym_kType] = ACTIONS(2185),
    [sym_kLabel] = ACTIONS(2185),
    [sym_kExports] = ACTIONS(2185),
    [sym_kProperty] = ACTIONS(2185),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2185),
    [sym_kGeneric] = ACTIONS(2185),
    [sym_kFunction] = ACTIONS(2185),
    [sym_kProcedure] = ACTIONS(2185),
    [sym_kConstructor] = ACTIONS(2185),
    [sym_kDestructor] = ACTIONS(2185),
    [sym_kOperator] = ACTIONS(2185),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [sym_kEnd] = ACTIONS(1272),
    [sym_kVar] = ACTIONS(1274),
    [sym_kThreadvar] = ACTIONS(1272),
    [sym_kConst] = ACTIONS(1274),
    [sym_kResourcestring] = ACTIONS(1272),
    [sym_kType] = ACTIONS(1272),
    [sym_kProperty] = ACTIONS(1272),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1272),
    [sym_kGeneric] = ACTIONS(1272),
    [sym_kCase] = ACTIONS(1272),
    [sym_kFunction] = ACTIONS(1272),
    [sym_kProcedure] = ACTIONS(1272),
    [sym_kConstructor] = ACTIONS(1272),
    [sym_kDestructor] = ACTIONS(1272),
    [sym_kOperator] = ACTIONS(1272),
    [sym_kPublished] = ACTIONS(1272),
    [sym_kPublic] = ACTIONS(2192),
    [sym_kProtected] = ACTIONS(1272),
    [sym_kPrivate] = ACTIONS(1272),
    [sym_kStrict] = ACTIONS(1272),
    [sym_kRequired] = ACTIONS(1272),
    [sym_kOptional] = ACTIONS(1272),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(289),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [sym_kUses] = ACTIONS(2198),
    [sym_kInterface] = ACTIONS(2198),
    [sym_kImplementation] = ACTIONS(2198),
    [sym_kInitialization] = ACTIONS(2198),
    [sym_kFinalization] = ACTIONS(2198),
    [sym_kEnd] = ACTIONS(2198),
    [sym_kVar] = ACTIONS(2200),
    [sym_kThreadvar] = ACTIONS(2198),
    [sym_kConst] = ACTIONS(2200),
    [sym_kResourcestring] = ACTIONS(2198),
    [sym_kType] = ACTIONS(2198),
    [sym_kLabel] = ACTIONS(2198),
    [sym_kExports] = ACTIONS(2198),
    [sym_kProperty] = ACTIONS(2198),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2198),
    [sym_kGeneric] = ACTIONS(2198),
    [sym_kFunction] = ACTIONS(2198),
    [sym_kProcedure] = ACTIONS(2198),
    [sym_kConstructor] = ACTIONS(2198),
    [sym_kDestructor] = ACTIONS(2198),
    [sym_kOperator] = ACTIONS(2198),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [sym_kEnd] = ACTIONS(2205),
    [sym_kVar] = ACTIONS(2207),
    [sym_kThreadvar] = ACTIONS(2205),
    [sym_kConst] = ACTIONS(2207),
    [sym_kResourcestring] = ACTIONS(2205),
    [sym_kType] = ACTIONS(2205),
    [sym_kProperty] = ACTIONS(2205),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2205),
    [sym_kGeneric] = ACTIONS(2205),
    [sym_kCase] = ACTIONS(2205),
    [sym_kFunction] = ACTIONS(2205),
    [sym_kProcedure] = ACTIONS(2205),
    [sym_kConstructor] = ACTIONS(2205),
    [sym_kDestructor] = ACTIONS(2205),
    [sym_kOperator] = ACTIONS(2205),
    [sym_kPublished] = ACTIONS(2205),
    [sym_kPublic] = ACTIONS(2209),
    [sym_kProtected] = ACTIONS(2205),
    [sym_kPrivate] = ACTIONS(2205),
    [sym_kStrict] = ACTIONS(2205),
    [sym_kRequired] = ACTIONS(2205),
    [sym_kOptional] = ACTIONS(2205),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [sym_kUses] = ACTIONS(2215),
    [sym_kInterface] = ACTIONS(2215),
    [sym_kImplementation] = ACTIONS(2215),
    [sym_kInitialization] = ACTIONS(2215),
    [sym_kFinalization] = ACTIONS(2215),
    [sym_kEnd] = ACTIONS(2215),
    [sym_kVar] = ACTIONS(2217),
    [sym_kThreadvar] = ACTIONS(2215),
    [sym_kConst] = ACTIONS(2217),
    [sym_kResourcestring] = ACTIONS(2215),
    [sym_kType] = ACTIONS(2215),
    [sym_kLabel] = ACTIONS(2215),
    [sym_kExports] = ACTIONS(2215),
    [sym_kProperty] = ACTIONS(2215),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2215),
    [sym_kGeneric] = ACTIONS(2215),
    [sym_kFunction] = ACTIONS(2215),
    [sym_kProcedure] = ACTIONS(2215),
    [sym_kConstructor] = ACTIONS(2215),
    [sym_kDestructor] = ACTIONS(2215),
    [sym_kOperator] = ACTIONS(2215),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [sym_kUses] = ACTIONS(2222),
    [sym_kInterface] = ACTIONS(2222),
    [sym_kImplementation] = ACTIONS(2222),
    [sym_kInitialization] = ACTIONS(2222),
    [sym_kFinalization] = ACTIONS(2222),
    [sym_kEnd] = ACTIONS(2222),
    [sym_kVar] = ACTIONS(2224),
    [sym_kThreadvar] = ACTIONS(2222),
    [sym_kConst] = ACTIONS(2224),
    [sym_kResourcestring] = ACTIONS(2222),
    [sym_kType] = ACTIONS(2222),
    [sym_kLabel] = ACTIONS(2222),
    [sym_kExports] = ACTIONS(2222),
    [sym_kProperty] = ACTIONS(2222),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2222),
    [sym_kGeneric] = ACTIONS(2222),
    [sym_kFunction] = ACTIONS(2222),
    [sym_kProcedure] = ACTIONS(2222),
    [sym_kConstructor] = ACTIONS(2222),
    [sym_kDestructor] = ACTIONS(2222),
    [sym_kOperator] = ACTIONS(2222),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(359),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [sym_kEnd] = ACTIONS(2229),
    [sym_kVar] = ACTIONS(2231),
    [sym_kThreadvar] = ACTIONS(2229),
    [sym_kConst] = ACTIONS(2231),
    [sym_kResourcestring] = ACTIONS(2229),
    [sym_kType] = ACTIONS(2229),
    [sym_kProperty] = ACTIONS(2229),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2229),
    [sym_kGeneric] = ACTIONS(2229),
    [sym_kCase] = ACTIONS(2229),
    [sym_kFunction] = ACTIONS(2229),
    [sym_kProcedure] = ACTIONS(2229),
    [sym_kConstructor] = ACTIONS(2229),
    [sym_kDestructor] = ACTIONS(2229),
    [sym_kOperator] = ACTIONS(2229),
    [sym_kPublished] = ACTIONS(2229),
    [sym_kPublic] = ACTIONS(2233),
    [sym_kProtected] = ACTIONS(2229),
    [sym_kPrivate] = ACTIONS(2229),
    [sym_kStrict] = ACTIONS(2229),
    [sym_kRequired] = ACTIONS(2229),
    [sym_kOptional] = ACTIONS(2229),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(360),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [sym_kEnd] = ACTIONS(2239),
    [sym_kVar] = ACTIONS(2241),
    [sym_kThreadvar] = ACTIONS(2239),
    [sym_kConst] = ACTIONS(2241),
    [sym_kResourcestring] = ACTIONS(2239),
    [sym_kType] = ACTIONS(2239),
    [sym_kProperty] = ACTIONS(2239),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2239),
    [sym_kGeneric] = ACTIONS(2239),
    [sym_kCase] = ACTIONS(2239),
    [sym_kFunction] = ACTIONS(2239),
    [sym_kProcedure] = ACTIONS(2239),
    [sym_kConstructor] = ACTIONS(2239),
    [sym_kDestructor] = ACTIONS(2239),
    [sym_kOperator] = ACTIONS(2239),
    [sym_kPublished] = ACTIONS(2239),
    [sym_kPublic] = ACTIONS(2243),
    [sym_kProtected] = ACTIONS(2239),
    [sym_kPrivate] = ACTIONS(2239),
    [sym_kStrict] = ACTIONS(2239),
    [sym_kRequired] = ACTIONS(2239),
    [sym_kOptional] = ACTIONS(2239),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(362),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [sym_kEnd] = ACTIONS(2249),
    [sym_kVar] = ACTIONS(2251),
    [sym_kThreadvar] = ACTIONS(2249),
    [sym_kConst] = ACTIONS(2251),
    [sym_kResourcestring] = ACTIONS(2249),
    [sym_kType] = ACTIONS(2249),
    [sym_kProperty] = ACTIONS(2249),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2249),
    [sym_kGeneric] = ACTIONS(2249),
    [sym_kCase] = ACTIONS(2249),
    [sym_kFunction] = ACTIONS(2249),
    [sym_kProcedure] = ACTIONS(2249),
    [sym_kConstructor] = ACTIONS(2249),
    [sym_kDestructor] = ACTIONS(2249),
    [sym_kOperator] = ACTIONS(2249),
    [sym_kPublished] = ACTIONS(2249),
    [sym_kPublic] = ACTIONS(2253),
    [sym_kProtected] = ACTIONS(2249),
    [sym_kPrivate] = ACTIONS(2249),
    [sym_kStrict] = ACTIONS(2249),
    [sym_kRequired] = ACTIONS(2249),
    [sym_kOptional] = ACTIONS(2249),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(307),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [sym_kUses] = ACTIONS(1626),
    [sym_kInterface] = ACTIONS(1626),
    [sym_kImplementation] = ACTIONS(1626),
    [sym_kInitialization] = ACTIONS(1626),
    [sym_kFinalization] = ACTIONS(1626),
    [sym_kEnd] = ACTIONS(1626),
    [sym_kVar] = ACTIONS(1628),
    [sym_kThreadvar] = ACTIONS(1626),
    [sym_kConst] = ACTIONS(1628),
    [sym_kResourcestring] = ACTIONS(1626),
    [sym_kType] = ACTIONS(1626),
    [sym_kLabel] = ACTIONS(1626),
    [sym_kExports] = ACTIONS(1626),
    [sym_kProperty] = ACTIONS(1626),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1626),
    [sym_kGeneric] = ACTIONS(1626),
    [sym_kFunction] = ACTIONS(1626),
    [sym_kProcedure] = ACTIONS(1626),
    [sym_kConstructor] = ACTIONS(1626),
    [sym_kDestructor] = ACTIONS(1626),
    [sym_kOperator] = ACTIONS(1626),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [sym_kEnd] = ACTIONS(1164),
    [sym_kVar] = ACTIONS(1166),
    [sym_kThreadvar] = ACTIONS(1164),
    [sym_kConst] = ACTIONS(1166),
    [sym_kResourcestring] = ACTIONS(1164),
    [sym_kType] = ACTIONS(1164),
    [sym_kProperty] = ACTIONS(1164),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1164),
    [sym_kGeneric] = ACTIONS(1164),
    [sym_kCase] = ACTIONS(1164),
    [sym_kFunction] = ACTIONS(1164),
    [sym_kProcedure] = ACTIONS(1164),
    [sym_kConstructor] = ACTIONS(1164),
    [sym_kDestructor] = ACTIONS(1164),
    [sym_kOperator] = ACTIONS(1164),
    [sym_kPublished] = ACTIONS(1164),
    [sym_kPublic] = ACTIONS(2262),
    [sym_kProtected] = ACTIONS(1164),
    [sym_kPrivate] = ACTIONS(1164),
    [sym_kStrict] = ACTIONS(1164),
    [sym_kRequired] = ACTIONS(1164),
    [sym_kOptional] = ACTIONS(1164),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(365),
    [anon_sym_LBRACK] = ACTIONS(2265),
    [sym_kEnd] = ACTIONS(1254),
    [sym_kVar] = ACTIONS(1256),
    [sym_kThreadvar] = ACTIONS(1254),
    [sym_kConst] = ACTIONS(1256),
    [sym_kResourcestring] = ACTIONS(1254),
    [sym_kType] = ACTIONS(1254),
    [sym_kProperty] = ACTIONS(1254),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1254),
    [sym_kGeneric] = ACTIONS(1254),
    [sym_kCase] = ACTIONS(1254),
    [sym_kFunction] = ACTIONS(1254),
    [sym_kProcedure] = ACTIONS(1254),
    [sym_kConstructor] = ACTIONS(1254),
    [sym_kDestructor] = ACTIONS(1254),
    [sym_kOperator] = ACTIONS(1254),
    [sym_kPublished] = ACTIONS(1254),
    [sym_kPublic] = ACTIONS(2268),
    [sym_kProtected] = ACTIONS(1254),
    [sym_kPrivate] = ACTIONS(1254),
    [sym_kStrict] = ACTIONS(1254),
    [sym_kRequired] = ACTIONS(1254),
    [sym_kOptional] = ACTIONS(1254),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(366),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [sym_kEnd] = ACTIONS(1090),
    [sym_kVar] = ACTIONS(1092),
    [sym_kThreadvar] = ACTIONS(1090),
    [sym_kConst] = ACTIONS(1092),
    [sym_kResourcestring] = ACTIONS(1090),
    [sym_kType] = ACTIONS(1090),
    [sym_kProperty] = ACTIONS(1090),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1090),
    [sym_kGeneric] = ACTIONS(1090),
    [sym_kCase] = ACTIONS(1090),
    [sym_kFunction] = ACTIONS(1090),
    [sym_kProcedure] = ACTIONS(1090),
    [sym_kConstructor] = ACTIONS(1090),
    [sym_kDestructor] = ACTIONS(1090),
    [sym_kOperator] = ACTIONS(1090),
    [sym_kPublished] = ACTIONS(1090),
    [sym_kPublic] = ACTIONS(2274),
    [sym_kProtected] = ACTIONS(1090),
    [sym_kPrivate] = ACTIONS(1090),
    [sym_kStrict] = ACTIONS(1090),
    [sym_kRequired] = ACTIONS(1090),
    [sym_kOptional] = ACTIONS(1090),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_kEnd] = ACTIONS(1097),
    [sym_kVar] = ACTIONS(1099),
    [sym_kThreadvar] = ACTIONS(1097),
    [sym_kConst] = ACTIONS(1099),
    [sym_kResourcestring] = ACTIONS(1097),
    [sym_kType] = ACTIONS(1097),
    [sym_kProperty] = ACTIONS(1097),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1097),
    [sym_kGeneric] = ACTIONS(1097),
    [sym_kCase] = ACTIONS(1097),
    [sym_kFunction] = ACTIONS(1097),
    [sym_kProcedure] = ACTIONS(1097),
    [sym_kConstructor] = ACTIONS(1097),
    [sym_kDestructor] = ACTIONS(1097),
    [sym_kOperator] = ACTIONS(1097),
    [sym_kPublished] = ACTIONS(1097),
    [sym_kPublic] = ACTIONS(2280),
    [sym_kProtected] = ACTIONS(1097),
    [sym_kPrivate] = ACTIONS(1097),
    [sym_kStrict] = ACTIONS(1097),
    [sym_kRequired] = ACTIONS(1097),
    [sym_kOptional] = ACTIONS(1097),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [sym_kEnd] = ACTIONS(2286),
    [sym_kVar] = ACTIONS(2288),
    [sym_kThreadvar] = ACTIONS(2286),
    [sym_kConst] = ACTIONS(2288),
    [sym_kResourcestring] = ACTIONS(2286),
    [sym_kType] = ACTIONS(2286),
    [sym_kProperty] = ACTIONS(2286),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2286),
    [sym_kGeneric] = ACTIONS(2286),
    [sym_kCase] = ACTIONS(2286),
    [sym_kFunction] = ACTIONS(2286),
    [sym_kProcedure] = ACTIONS(2286),
    [sym_kConstructor] = ACTIONS(2286),
    [sym_kDestructor] = ACTIONS(2286),
    [sym_kOperator] = ACTIONS(2286),
    [sym_kPublished] = ACTIONS(2286),
    [sym_kPublic] = ACTIONS(2290),
    [sym_kProtected] = ACTIONS(2286),
    [sym_kPrivate] = ACTIONS(2286),
    [sym_kStrict] = ACTIONS(2286),
    [sym_kRequired] = ACTIONS(2286),
    [sym_kOptional] = ACTIONS(2286),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(368),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [sym_kEnd] = ACTIONS(2296),
    [sym_kVar] = ACTIONS(2298),
    [sym_kThreadvar] = ACTIONS(2296),
    [sym_kConst] = ACTIONS(2298),
    [sym_kResourcestring] = ACTIONS(2296),
    [sym_kType] = ACTIONS(2296),
    [sym_kProperty] = ACTIONS(2296),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2296),
    [sym_kGeneric] = ACTIONS(2296),
    [sym_kCase] = ACTIONS(2296),
    [sym_kFunction] = ACTIONS(2296),
    [sym_kProcedure] = ACTIONS(2296),
    [sym_kConstructor] = ACTIONS(2296),
    [sym_kDestructor] = ACTIONS(2296),
    [sym_kOperator] = ACTIONS(2296),
    [sym_kPublished] = ACTIONS(2296),
    [sym_kPublic] = ACTIONS(2300),
    [sym_kProtected] = ACTIONS(2296),
    [sym_kPrivate] = ACTIONS(2296),
    [sym_kStrict] = ACTIONS(2296),
    [sym_kRequired] = ACTIONS(2296),
    [sym_kOptional] = ACTIONS(2296),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(300),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [sym_kUses] = ACTIONS(2306),
    [sym_kInterface] = ACTIONS(2306),
    [sym_kImplementation] = ACTIONS(2306),
    [sym_kInitialization] = ACTIONS(2306),
    [sym_kFinalization] = ACTIONS(2306),
    [sym_kEnd] = ACTIONS(2306),
    [sym_kVar] = ACTIONS(2308),
    [sym_kThreadvar] = ACTIONS(2306),
    [sym_kConst] = ACTIONS(2308),
    [sym_kResourcestring] = ACTIONS(2306),
    [sym_kType] = ACTIONS(2306),
    [sym_kLabel] = ACTIONS(2306),
    [sym_kExports] = ACTIONS(2306),
    [sym_kProperty] = ACTIONS(2306),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2306),
    [sym_kGeneric] = ACTIONS(2306),
    [sym_kFunction] = ACTIONS(2306),
    [sym_kProcedure] = ACTIONS(2306),
    [sym_kConstructor] = ACTIONS(2306),
    [sym_kDestructor] = ACTIONS(2306),
    [sym_kOperator] = ACTIONS(2306),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(302),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [sym_kUses] = ACTIONS(2313),
    [sym_kInterface] = ACTIONS(2313),
    [sym_kImplementation] = ACTIONS(2313),
    [sym_kInitialization] = ACTIONS(2313),
    [sym_kFinalization] = ACTIONS(2313),
    [sym_kEnd] = ACTIONS(2313),
    [sym_kVar] = ACTIONS(2315),
    [sym_kThreadvar] = ACTIONS(2313),
    [sym_kConst] = ACTIONS(2315),
    [sym_kResourcestring] = ACTIONS(2313),
    [sym_kType] = ACTIONS(2313),
    [sym_kLabel] = ACTIONS(2313),
    [sym_kExports] = ACTIONS(2313),
    [sym_kProperty] = ACTIONS(2313),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2313),
    [sym_kGeneric] = ACTIONS(2313),
    [sym_kFunction] = ACTIONS(2313),
    [sym_kProcedure] = ACTIONS(2313),
    [sym_kConstructor] = ACTIONS(2313),
    [sym_kDestructor] = ACTIONS(2313),
    [sym_kOperator] = ACTIONS(2313),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(303),
    [anon_sym_LBRACK] = ACTIONS(2317),
    [sym_kUses] = ACTIONS(2296),
    [sym_kInterface] = ACTIONS(2296),
    [sym_kImplementation] = ACTIONS(2296),
    [sym_kInitialization] = ACTIONS(2296),
    [sym_kFinalization] = ACTIONS(2296),
    [sym_kEnd] = ACTIONS(2296),
    [sym_kVar] = ACTIONS(2298),
    [sym_kThreadvar] = ACTIONS(2296),
    [sym_kConst] = ACTIONS(2298),
    [sym_kResourcestring] = ACTIONS(2296),
    [sym_kType] = ACTIONS(2296),
    [sym_kLabel] = ACTIONS(2296),
    [sym_kExports] = ACTIONS(2296),
    [sym_kProperty] = ACTIONS(2296),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2296),
    [sym_kGeneric] = ACTIONS(2296),
    [sym_kFunction] = ACTIONS(2296),
    [sym_kProcedure] = ACTIONS(2296),
    [sym_kConstructor] = ACTIONS(2296),
    [sym_kDestructor] = ACTIONS(2296),
    [sym_kOperator] = ACTIONS(2296),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2320),
    [sym_kUses] = ACTIONS(2286),
    [sym_kInterface] = ACTIONS(2286),
    [sym_kImplementation] = ACTIONS(2286),
    [sym_kInitialization] = ACTIONS(2286),
    [sym_kFinalization] = ACTIONS(2286),
    [sym_kEnd] = ACTIONS(2286),
    [sym_kVar] = ACTIONS(2288),
    [sym_kThreadvar] = ACTIONS(2286),
    [sym_kConst] = ACTIONS(2288),
    [sym_kResourcestring] = ACTIONS(2286),
    [sym_kType] = ACTIONS(2286),
    [sym_kLabel] = ACTIONS(2286),
    [sym_kExports] = ACTIONS(2286),
    [sym_kProperty] = ACTIONS(2286),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2286),
    [sym_kGeneric] = ACTIONS(2286),
    [sym_kFunction] = ACTIONS(2286),
    [sym_kProcedure] = ACTIONS(2286),
    [sym_kConstructor] = ACTIONS(2286),
    [sym_kDestructor] = ACTIONS(2286),
    [sym_kOperator] = ACTIONS(2286),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(373),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [sym_kEnd] = ACTIONS(2313),
    [sym_kVar] = ACTIONS(2315),
    [sym_kThreadvar] = ACTIONS(2313),
    [sym_kConst] = ACTIONS(2315),
    [sym_kResourcestring] = ACTIONS(2313),
    [sym_kType] = ACTIONS(2313),
    [sym_kProperty] = ACTIONS(2313),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2313),
    [sym_kGeneric] = ACTIONS(2313),
    [sym_kCase] = ACTIONS(2313),
    [sym_kFunction] = ACTIONS(2313),
    [sym_kProcedure] = ACTIONS(2313),
    [sym_kConstructor] = ACTIONS(2313),
    [sym_kDestructor] = ACTIONS(2313),
    [sym_kOperator] = ACTIONS(2313),
    [sym_kPublished] = ACTIONS(2313),
    [sym_kPublic] = ACTIONS(2326),
    [sym_kProtected] = ACTIONS(2313),
    [sym_kPrivate] = ACTIONS(2313),
    [sym_kStrict] = ACTIONS(2313),
    [sym_kRequired] = ACTIONS(2313),
    [sym_kOptional] = ACTIONS(2313),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(375),
    [anon_sym_LBRACK] = ACTIONS(2329),
    [sym_kEnd] = ACTIONS(2306),
    [sym_kVar] = ACTIONS(2308),
    [sym_kThreadvar] = ACTIONS(2306),
    [sym_kConst] = ACTIONS(2308),
    [sym_kResourcestring] = ACTIONS(2306),
    [sym_kType] = ACTIONS(2306),
    [sym_kProperty] = ACTIONS(2306),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2306),
    [sym_kGeneric] = ACTIONS(2306),
    [sym_kCase] = ACTIONS(2306),
    [sym_kFunction] = ACTIONS(2306),
    [sym_kProcedure] = ACTIONS(2306),
    [sym_kConstructor] = ACTIONS(2306),
    [sym_kDestructor] = ACTIONS(2306),
    [sym_kOperator] = ACTIONS(2306),
    [sym_kPublished] = ACTIONS(2306),
    [sym_kPublic] = ACTIONS(2332),
    [sym_kProtected] = ACTIONS(2306),
    [sym_kPrivate] = ACTIONS(2306),
    [sym_kStrict] = ACTIONS(2306),
    [sym_kRequired] = ACTIONS(2306),
    [sym_kOptional] = ACTIONS(2306),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(378),
    [anon_sym_LBRACK] = ACTIONS(2335),
    [sym_kEnd] = ACTIONS(1104),
    [sym_kVar] = ACTIONS(1106),
    [sym_kThreadvar] = ACTIONS(1104),
    [sym_kConst] = ACTIONS(1106),
    [sym_kResourcestring] = ACTIONS(1104),
    [sym_kType] = ACTIONS(1104),
    [sym_kProperty] = ACTIONS(1104),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1104),
    [sym_kGeneric] = ACTIONS(1104),
    [sym_kCase] = ACTIONS(1104),
    [sym_kFunction] = ACTIONS(1104),
    [sym_kProcedure] = ACTIONS(1104),
    [sym_kConstructor] = ACTIONS(1104),
    [sym_kDestructor] = ACTIONS(1104),
    [sym_kOperator] = ACTIONS(1104),
    [sym_kPublished] = ACTIONS(1104),
    [sym_kPublic] = ACTIONS(2338),
    [sym_kProtected] = ACTIONS(1104),
    [sym_kPrivate] = ACTIONS(1104),
    [sym_kStrict] = ACTIONS(1104),
    [sym_kRequired] = ACTIONS(1104),
    [sym_kOptional] = ACTIONS(1104),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [sym_kEnd] = ACTIONS(1111),
    [sym_kVar] = ACTIONS(1113),
    [sym_kThreadvar] = ACTIONS(1111),
    [sym_kConst] = ACTIONS(1113),
    [sym_kResourcestring] = ACTIONS(1111),
    [sym_kType] = ACTIONS(1111),
    [sym_kProperty] = ACTIONS(1111),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1111),
    [sym_kGeneric] = ACTIONS(1111),
    [sym_kCase] = ACTIONS(1111),
    [sym_kFunction] = ACTIONS(1111),
    [sym_kProcedure] = ACTIONS(1111),
    [sym_kConstructor] = ACTIONS(1111),
    [sym_kDestructor] = ACTIONS(1111),
    [sym_kOperator] = ACTIONS(1111),
    [sym_kPublished] = ACTIONS(1111),
    [sym_kPublic] = ACTIONS(2344),
    [sym_kProtected] = ACTIONS(1111),
    [sym_kPrivate] = ACTIONS(1111),
    [sym_kStrict] = ACTIONS(1111),
    [sym_kRequired] = ACTIONS(1111),
    [sym_kOptional] = ACTIONS(1111),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [sym_kEnd] = ACTIONS(1118),
    [sym_kVar] = ACTIONS(1120),
    [sym_kThreadvar] = ACTIONS(1118),
    [sym_kConst] = ACTIONS(1120),
    [sym_kResourcestring] = ACTIONS(1118),
    [sym_kType] = ACTIONS(1118),
    [sym_kProperty] = ACTIONS(1118),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1118),
    [sym_kGeneric] = ACTIONS(1118),
    [sym_kCase] = ACTIONS(1118),
    [sym_kFunction] = ACTIONS(1118),
    [sym_kProcedure] = ACTIONS(1118),
    [sym_kConstructor] = ACTIONS(1118),
    [sym_kDestructor] = ACTIONS(1118),
    [sym_kOperator] = ACTIONS(1118),
    [sym_kPublished] = ACTIONS(1118),
    [sym_kPublic] = ACTIONS(2350),
    [sym_kProtected] = ACTIONS(1118),
    [sym_kPrivate] = ACTIONS(1118),
    [sym_kStrict] = ACTIONS(1118),
    [sym_kRequired] = ACTIONS(1118),
    [sym_kOptional] = ACTIONS(1118),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(382),
    [anon_sym_LBRACK] = ACTIONS(2353),
    [sym_kEnd] = ACTIONS(1125),
    [sym_kVar] = ACTIONS(1127),
    [sym_kThreadvar] = ACTIONS(1125),
    [sym_kConst] = ACTIONS(1127),
    [sym_kResourcestring] = ACTIONS(1125),
    [sym_kType] = ACTIONS(1125),
    [sym_kProperty] = ACTIONS(1125),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1125),
    [sym_kGeneric] = ACTIONS(1125),
    [sym_kCase] = ACTIONS(1125),
    [sym_kFunction] = ACTIONS(1125),
    [sym_kProcedure] = ACTIONS(1125),
    [sym_kConstructor] = ACTIONS(1125),
    [sym_kDestructor] = ACTIONS(1125),
    [sym_kOperator] = ACTIONS(1125),
    [sym_kPublished] = ACTIONS(1125),
    [sym_kPublic] = ACTIONS(2356),
    [sym_kProtected] = ACTIONS(1125),
    [sym_kPrivate] = ACTIONS(1125),
    [sym_kStrict] = ACTIONS(1125),
    [sym_kRequired] = ACTIONS(1125),
    [sym_kOptional] = ACTIONS(1125),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [sym_kUses] = ACTIONS(1636),
    [sym_kInterface] = ACTIONS(1636),
    [sym_kImplementation] = ACTIONS(1636),
    [sym_kInitialization] = ACTIONS(1636),
    [sym_kFinalization] = ACTIONS(1636),
    [sym_kEnd] = ACTIONS(1636),
    [sym_kVar] = ACTIONS(1638),
    [sym_kThreadvar] = ACTIONS(1636),
    [sym_kConst] = ACTIONS(1638),
    [sym_kResourcestring] = ACTIONS(1636),
    [sym_kType] = ACTIONS(1636),
    [sym_kLabel] = ACTIONS(1636),
    [sym_kExports] = ACTIONS(1636),
    [sym_kProperty] = ACTIONS(1636),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1636),
    [sym_kGeneric] = ACTIONS(1636),
    [sym_kFunction] = ACTIONS(1636),
    [sym_kProcedure] = ACTIONS(1636),
    [sym_kConstructor] = ACTIONS(1636),
    [sym_kDestructor] = ACTIONS(1636),
    [sym_kOperator] = ACTIONS(1636),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [sym_kEnd] = ACTIONS(1139),
    [sym_kVar] = ACTIONS(1141),
    [sym_kThreadvar] = ACTIONS(1139),
    [sym_kConst] = ACTIONS(1141),
    [sym_kResourcestring] = ACTIONS(1139),
    [sym_kType] = ACTIONS(1139),
    [sym_kProperty] = ACTIONS(1139),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1139),
    [sym_kGeneric] = ACTIONS(1139),
    [sym_kCase] = ACTIONS(1139),
    [sym_kFunction] = ACTIONS(1139),
    [sym_kProcedure] = ACTIONS(1139),
    [sym_kConstructor] = ACTIONS(1139),
    [sym_kDestructor] = ACTIONS(1139),
    [sym_kOperator] = ACTIONS(1139),
    [sym_kPublished] = ACTIONS(1139),
    [sym_kPublic] = ACTIONS(2365),
    [sym_kProtected] = ACTIONS(1139),
    [sym_kPrivate] = ACTIONS(1139),
    [sym_kStrict] = ACTIONS(1139),
    [sym_kRequired] = ACTIONS(1139),
    [sym_kOptional] = ACTIONS(1139),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [sym_kEnd] = ACTIONS(1146),
    [sym_kVar] = ACTIONS(1148),
    [sym_kThreadvar] = ACTIONS(1146),
    [sym_kConst] = ACTIONS(1148),
    [sym_kResourcestring] = ACTIONS(1146),
    [sym_kType] = ACTIONS(1146),
    [sym_kProperty] = ACTIONS(1146),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1146),
    [sym_kGeneric] = ACTIONS(1146),
    [sym_kCase] = ACTIONS(1146),
    [sym_kFunction] = ACTIONS(1146),
    [sym_kProcedure] = ACTIONS(1146),
    [sym_kConstructor] = ACTIONS(1146),
    [sym_kDestructor] = ACTIONS(1146),
    [sym_kOperator] = ACTIONS(1146),
    [sym_kPublished] = ACTIONS(1146),
    [sym_kPublic] = ACTIONS(2371),
    [sym_kProtected] = ACTIONS(1146),
    [sym_kPrivate] = ACTIONS(1146),
    [sym_kStrict] = ACTIONS(1146),
    [sym_kRequired] = ACTIONS(1146),
    [sym_kOptional] = ACTIONS(1146),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(384),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [sym_kEnd] = ACTIONS(1157),
    [sym_kVar] = ACTIONS(1159),
    [sym_kThreadvar] = ACTIONS(1157),
    [sym_kConst] = ACTIONS(1159),
    [sym_kResourcestring] = ACTIONS(1157),
    [sym_kType] = ACTIONS(1157),
    [sym_kProperty] = ACTIONS(1157),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1157),
    [sym_kGeneric] = ACTIONS(1157),
    [sym_kCase] = ACTIONS(1157),
    [sym_kFunction] = ACTIONS(1157),
    [sym_kProcedure] = ACTIONS(1157),
    [sym_kConstructor] = ACTIONS(1157),
    [sym_kDestructor] = ACTIONS(1157),
    [sym_kOperator] = ACTIONS(1157),
    [sym_kPublished] = ACTIONS(1157),
    [sym_kPublic] = ACTIONS(2377),
    [sym_kProtected] = ACTIONS(1157),
    [sym_kPrivate] = ACTIONS(1157),
    [sym_kStrict] = ACTIONS(1157),
    [sym_kRequired] = ACTIONS(1157),
    [sym_kOptional] = ACTIONS(1157),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [sym_kEnd] = ACTIONS(2222),
    [sym_kVar] = ACTIONS(2224),
    [sym_kThreadvar] = ACTIONS(2222),
    [sym_kConst] = ACTIONS(2224),
    [sym_kResourcestring] = ACTIONS(2222),
    [sym_kType] = ACTIONS(2222),
    [sym_kProperty] = ACTIONS(2222),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2222),
    [sym_kGeneric] = ACTIONS(2222),
    [sym_kCase] = ACTIONS(2222),
    [sym_kFunction] = ACTIONS(2222),
    [sym_kProcedure] = ACTIONS(2222),
    [sym_kConstructor] = ACTIONS(2222),
    [sym_kDestructor] = ACTIONS(2222),
    [sym_kOperator] = ACTIONS(2222),
    [sym_kPublished] = ACTIONS(2222),
    [sym_kPublic] = ACTIONS(2383),
    [sym_kProtected] = ACTIONS(2222),
    [sym_kPrivate] = ACTIONS(2222),
    [sym_kStrict] = ACTIONS(2222),
    [sym_kRequired] = ACTIONS(2222),
    [sym_kOptional] = ACTIONS(2222),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [sym_kEnd] = ACTIONS(2215),
    [sym_kVar] = ACTIONS(2217),
    [sym_kThreadvar] = ACTIONS(2215),
    [sym_kConst] = ACTIONS(2217),
    [sym_kResourcestring] = ACTIONS(2215),
    [sym_kType] = ACTIONS(2215),
    [sym_kProperty] = ACTIONS(2215),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2215),
    [sym_kGeneric] = ACTIONS(2215),
    [sym_kCase] = ACTIONS(2215),
    [sym_kFunction] = ACTIONS(2215),
    [sym_kProcedure] = ACTIONS(2215),
    [sym_kConstructor] = ACTIONS(2215),
    [sym_kDestructor] = ACTIONS(2215),
    [sym_kOperator] = ACTIONS(2215),
    [sym_kPublished] = ACTIONS(2215),
    [sym_kPublic] = ACTIONS(2389),
    [sym_kProtected] = ACTIONS(2215),
    [sym_kPrivate] = ACTIONS(2215),
    [sym_kStrict] = ACTIONS(2215),
    [sym_kRequired] = ACTIONS(2215),
    [sym_kOptional] = ACTIONS(2215),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(386),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [sym_kEnd] = ACTIONS(2198),
    [sym_kVar] = ACTIONS(2200),
    [sym_kThreadvar] = ACTIONS(2198),
    [sym_kConst] = ACTIONS(2200),
    [sym_kResourcestring] = ACTIONS(2198),
    [sym_kType] = ACTIONS(2198),
    [sym_kProperty] = ACTIONS(2198),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2198),
    [sym_kGeneric] = ACTIONS(2198),
    [sym_kCase] = ACTIONS(2198),
    [sym_kFunction] = ACTIONS(2198),
    [sym_kProcedure] = ACTIONS(2198),
    [sym_kConstructor] = ACTIONS(2198),
    [sym_kDestructor] = ACTIONS(2198),
    [sym_kOperator] = ACTIONS(2198),
    [sym_kPublished] = ACTIONS(2198),
    [sym_kPublic] = ACTIONS(2395),
    [sym_kProtected] = ACTIONS(2198),
    [sym_kPrivate] = ACTIONS(2198),
    [sym_kStrict] = ACTIONS(2198),
    [sym_kRequired] = ACTIONS(2198),
    [sym_kOptional] = ACTIONS(2198),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [sym_kEnd] = ACTIONS(2185),
    [sym_kVar] = ACTIONS(2187),
    [sym_kThreadvar] = ACTIONS(2185),
    [sym_kConst] = ACTIONS(2187),
    [sym_kResourcestring] = ACTIONS(2185),
    [sym_kType] = ACTIONS(2185),
    [sym_kProperty] = ACTIONS(2185),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2185),
    [sym_kGeneric] = ACTIONS(2185),
    [sym_kCase] = ACTIONS(2185),
    [sym_kFunction] = ACTIONS(2185),
    [sym_kProcedure] = ACTIONS(2185),
    [sym_kConstructor] = ACTIONS(2185),
    [sym_kDestructor] = ACTIONS(2185),
    [sym_kOperator] = ACTIONS(2185),
    [sym_kPublished] = ACTIONS(2185),
    [sym_kPublic] = ACTIONS(2401),
    [sym_kProtected] = ACTIONS(2185),
    [sym_kPrivate] = ACTIONS(2185),
    [sym_kStrict] = ACTIONS(2185),
    [sym_kRequired] = ACTIONS(2185),
    [sym_kOptional] = ACTIONS(2185),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(388),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [sym_kEnd] = ACTIONS(2178),
    [sym_kVar] = ACTIONS(2180),
    [sym_kThreadvar] = ACTIONS(2178),
    [sym_kConst] = ACTIONS(2180),
    [sym_kResourcestring] = ACTIONS(2178),
    [sym_kType] = ACTIONS(2178),
    [sym_kProperty] = ACTIONS(2178),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2178),
    [sym_kGeneric] = ACTIONS(2178),
    [sym_kCase] = ACTIONS(2178),
    [sym_kFunction] = ACTIONS(2178),
    [sym_kProcedure] = ACTIONS(2178),
    [sym_kConstructor] = ACTIONS(2178),
    [sym_kDestructor] = ACTIONS(2178),
    [sym_kOperator] = ACTIONS(2178),
    [sym_kPublished] = ACTIONS(2178),
    [sym_kPublic] = ACTIONS(2407),
    [sym_kProtected] = ACTIONS(2178),
    [sym_kPrivate] = ACTIONS(2178),
    [sym_kStrict] = ACTIONS(2178),
    [sym_kRequired] = ACTIONS(2178),
    [sym_kOptional] = ACTIONS(2178),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(389),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym_kEnd] = ACTIONS(2171),
    [sym_kVar] = ACTIONS(2173),
    [sym_kThreadvar] = ACTIONS(2171),
    [sym_kConst] = ACTIONS(2173),
    [sym_kResourcestring] = ACTIONS(2171),
    [sym_kType] = ACTIONS(2171),
    [sym_kProperty] = ACTIONS(2171),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2171),
    [sym_kGeneric] = ACTIONS(2171),
    [sym_kCase] = ACTIONS(2171),
    [sym_kFunction] = ACTIONS(2171),
    [sym_kProcedure] = ACTIONS(2171),
    [sym_kConstructor] = ACTIONS(2171),
    [sym_kDestructor] = ACTIONS(2171),
    [sym_kOperator] = ACTIONS(2171),
    [sym_kPublished] = ACTIONS(2171),
    [sym_kPublic] = ACTIONS(2413),
    [sym_kProtected] = ACTIONS(2171),
    [sym_kPrivate] = ACTIONS(2171),
    [sym_kStrict] = ACTIONS(2171),
    [sym_kRequired] = ACTIONS(2171),
    [sym_kOptional] = ACTIONS(2171),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [sym_kEnd] = ACTIONS(1353),
    [sym_kVar] = ACTIONS(1355),
    [sym_kThreadvar] = ACTIONS(1353),
    [sym_kConst] = ACTIONS(1355),
    [sym_kResourcestring] = ACTIONS(1353),
    [sym_kType] = ACTIONS(1353),
    [sym_kProperty] = ACTIONS(1353),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1353),
    [sym_kGeneric] = ACTIONS(1353),
    [sym_kCase] = ACTIONS(1353),
    [sym_kFunction] = ACTIONS(1353),
    [sym_kProcedure] = ACTIONS(1353),
    [sym_kConstructor] = ACTIONS(1353),
    [sym_kDestructor] = ACTIONS(1353),
    [sym_kOperator] = ACTIONS(1353),
    [sym_kPublished] = ACTIONS(1353),
    [sym_kPublic] = ACTIONS(2419),
    [sym_kProtected] = ACTIONS(1353),
    [sym_kPrivate] = ACTIONS(1353),
    [sym_kStrict] = ACTIONS(1353),
    [sym_kRequired] = ACTIONS(1353),
    [sym_kOptional] = ACTIONS(1353),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [sym_kEnd] = ACTIONS(1360),
    [sym_kVar] = ACTIONS(1362),
    [sym_kThreadvar] = ACTIONS(1360),
    [sym_kConst] = ACTIONS(1362),
    [sym_kResourcestring] = ACTIONS(1360),
    [sym_kType] = ACTIONS(1360),
    [sym_kProperty] = ACTIONS(1360),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1360),
    [sym_kGeneric] = ACTIONS(1360),
    [sym_kCase] = ACTIONS(1360),
    [sym_kFunction] = ACTIONS(1360),
    [sym_kProcedure] = ACTIONS(1360),
    [sym_kConstructor] = ACTIONS(1360),
    [sym_kDestructor] = ACTIONS(1360),
    [sym_kOperator] = ACTIONS(1360),
    [sym_kPublished] = ACTIONS(1360),
    [sym_kPublic] = ACTIONS(2425),
    [sym_kProtected] = ACTIONS(1360),
    [sym_kPrivate] = ACTIONS(1360),
    [sym_kStrict] = ACTIONS(1360),
    [sym_kRequired] = ACTIONS(1360),
    [sym_kOptional] = ACTIONS(1360),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(391),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [sym_kEnd] = ACTIONS(1367),
    [sym_kVar] = ACTIONS(1369),
    [sym_kThreadvar] = ACTIONS(1367),
    [sym_kConst] = ACTIONS(1369),
    [sym_kResourcestring] = ACTIONS(1367),
    [sym_kType] = ACTIONS(1367),
    [sym_kProperty] = ACTIONS(1367),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1367),
    [sym_kGeneric] = ACTIONS(1367),
    [sym_kCase] = ACTIONS(1367),
    [sym_kFunction] = ACTIONS(1367),
    [sym_kProcedure] = ACTIONS(1367),
    [sym_kConstructor] = ACTIONS(1367),
    [sym_kDestructor] = ACTIONS(1367),
    [sym_kOperator] = ACTIONS(1367),
    [sym_kPublished] = ACTIONS(1367),
    [sym_kPublic] = ACTIONS(2431),
    [sym_kProtected] = ACTIONS(1367),
    [sym_kPrivate] = ACTIONS(1367),
    [sym_kStrict] = ACTIONS(1367),
    [sym_kRequired] = ACTIONS(1367),
    [sym_kOptional] = ACTIONS(1367),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [sym_kEnd] = ACTIONS(2030),
    [sym_kVar] = ACTIONS(2032),
    [sym_kThreadvar] = ACTIONS(2030),
    [sym_kConst] = ACTIONS(2032),
    [sym_kResourcestring] = ACTIONS(2030),
    [sym_kType] = ACTIONS(2030),
    [sym_kProperty] = ACTIONS(2030),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2030),
    [sym_kGeneric] = ACTIONS(2030),
    [sym_kCase] = ACTIONS(2030),
    [sym_kFunction] = ACTIONS(2030),
    [sym_kProcedure] = ACTIONS(2030),
    [sym_kConstructor] = ACTIONS(2030),
    [sym_kDestructor] = ACTIONS(2030),
    [sym_kOperator] = ACTIONS(2030),
    [sym_kPublished] = ACTIONS(2030),
    [sym_kPublic] = ACTIONS(2437),
    [sym_kProtected] = ACTIONS(2030),
    [sym_kPrivate] = ACTIONS(2030),
    [sym_kStrict] = ACTIONS(2030),
    [sym_kRequired] = ACTIONS(2030),
    [sym_kOptional] = ACTIONS(2030),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(329),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [sym_kUses] = ACTIONS(2249),
    [sym_kInterface] = ACTIONS(2249),
    [sym_kImplementation] = ACTIONS(2249),
    [sym_kInitialization] = ACTIONS(2249),
    [sym_kFinalization] = ACTIONS(2249),
    [sym_kEnd] = ACTIONS(2249),
    [sym_kVar] = ACTIONS(2251),
    [sym_kThreadvar] = ACTIONS(2249),
    [sym_kConst] = ACTIONS(2251),
    [sym_kResourcestring] = ACTIONS(2249),
    [sym_kType] = ACTIONS(2249),
    [sym_kLabel] = ACTIONS(2249),
    [sym_kExports] = ACTIONS(2249),
    [sym_kProperty] = ACTIONS(2249),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2249),
    [sym_kGeneric] = ACTIONS(2249),
    [sym_kFunction] = ACTIONS(2249),
    [sym_kProcedure] = ACTIONS(2249),
    [sym_kConstructor] = ACTIONS(2249),
    [sym_kDestructor] = ACTIONS(2249),
    [sym_kOperator] = ACTIONS(2249),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(333),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [sym_kUses] = ACTIONS(2239),
    [sym_kInterface] = ACTIONS(2239),
    [sym_kImplementation] = ACTIONS(2239),
    [sym_kInitialization] = ACTIONS(2239),
    [sym_kFinalization] = ACTIONS(2239),
    [sym_kEnd] = ACTIONS(2239),
    [sym_kVar] = ACTIONS(2241),
    [sym_kThreadvar] = ACTIONS(2239),
    [sym_kConst] = ACTIONS(2241),
    [sym_kResourcestring] = ACTIONS(2239),
    [sym_kType] = ACTIONS(2239),
    [sym_kLabel] = ACTIONS(2239),
    [sym_kExports] = ACTIONS(2239),
    [sym_kProperty] = ACTIONS(2239),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2239),
    [sym_kGeneric] = ACTIONS(2239),
    [sym_kFunction] = ACTIONS(2239),
    [sym_kProcedure] = ACTIONS(2239),
    [sym_kConstructor] = ACTIONS(2239),
    [sym_kDestructor] = ACTIONS(2239),
    [sym_kOperator] = ACTIONS(2239),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(334),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [sym_kUses] = ACTIONS(2229),
    [sym_kInterface] = ACTIONS(2229),
    [sym_kImplementation] = ACTIONS(2229),
    [sym_kInitialization] = ACTIONS(2229),
    [sym_kFinalization] = ACTIONS(2229),
    [sym_kEnd] = ACTIONS(2229),
    [sym_kVar] = ACTIONS(2231),
    [sym_kThreadvar] = ACTIONS(2229),
    [sym_kConst] = ACTIONS(2231),
    [sym_kResourcestring] = ACTIONS(2229),
    [sym_kType] = ACTIONS(2229),
    [sym_kLabel] = ACTIONS(2229),
    [sym_kExports] = ACTIONS(2229),
    [sym_kProperty] = ACTIONS(2229),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2229),
    [sym_kGeneric] = ACTIONS(2229),
    [sym_kFunction] = ACTIONS(2229),
    [sym_kProcedure] = ACTIONS(2229),
    [sym_kConstructor] = ACTIONS(2229),
    [sym_kDestructor] = ACTIONS(2229),
    [sym_kOperator] = ACTIONS(2229),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [sym_kUses] = ACTIONS(2205),
    [sym_kInterface] = ACTIONS(2205),
    [sym_kImplementation] = ACTIONS(2205),
    [sym_kInitialization] = ACTIONS(2205),
    [sym_kFinalization] = ACTIONS(2205),
    [sym_kEnd] = ACTIONS(2205),
    [sym_kVar] = ACTIONS(2207),
    [sym_kThreadvar] = ACTIONS(2205),
    [sym_kConst] = ACTIONS(2207),
    [sym_kResourcestring] = ACTIONS(2205),
    [sym_kType] = ACTIONS(2205),
    [sym_kLabel] = ACTIONS(2205),
    [sym_kExports] = ACTIONS(2205),
    [sym_kProperty] = ACTIONS(2205),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2205),
    [sym_kGeneric] = ACTIONS(2205),
    [sym_kFunction] = ACTIONS(2205),
    [sym_kProcedure] = ACTIONS(2205),
    [sym_kConstructor] = ACTIONS(2205),
    [sym_kDestructor] = ACTIONS(2205),
    [sym_kOperator] = ACTIONS(2205),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [sym_kEnd] = ACTIONS(2023),
    [sym_kVar] = ACTIONS(2025),
    [sym_kThreadvar] = ACTIONS(2023),
    [sym_kConst] = ACTIONS(2025),
    [sym_kResourcestring] = ACTIONS(2023),
    [sym_kType] = ACTIONS(2023),
    [sym_kProperty] = ACTIONS(2023),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2023),
    [sym_kGeneric] = ACTIONS(2023),
    [sym_kCase] = ACTIONS(2023),
    [sym_kFunction] = ACTIONS(2023),
    [sym_kProcedure] = ACTIONS(2023),
    [sym_kConstructor] = ACTIONS(2023),
    [sym_kDestructor] = ACTIONS(2023),
    [sym_kOperator] = ACTIONS(2023),
    [sym_kPublished] = ACTIONS(2023),
    [sym_kPublic] = ACTIONS(2455),
    [sym_kProtected] = ACTIONS(2023),
    [sym_kPrivate] = ACTIONS(2023),
    [sym_kStrict] = ACTIONS(2023),
    [sym_kRequired] = ACTIONS(2023),
    [sym_kOptional] = ACTIONS(2023),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(392),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [sym_kEnd] = ACTIONS(2016),
    [sym_kVar] = ACTIONS(2018),
    [sym_kThreadvar] = ACTIONS(2016),
    [sym_kConst] = ACTIONS(2018),
    [sym_kResourcestring] = ACTIONS(2016),
    [sym_kType] = ACTIONS(2016),
    [sym_kProperty] = ACTIONS(2016),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2016),
    [sym_kGeneric] = ACTIONS(2016),
    [sym_kCase] = ACTIONS(2016),
    [sym_kFunction] = ACTIONS(2016),
    [sym_kProcedure] = ACTIONS(2016),
    [sym_kConstructor] = ACTIONS(2016),
    [sym_kDestructor] = ACTIONS(2016),
    [sym_kOperator] = ACTIONS(2016),
    [sym_kPublished] = ACTIONS(2016),
    [sym_kPublic] = ACTIONS(2461),
    [sym_kProtected] = ACTIONS(2016),
    [sym_kPrivate] = ACTIONS(2016),
    [sym_kStrict] = ACTIONS(2016),
    [sym_kRequired] = ACTIONS(2016),
    [sym_kOptional] = ACTIONS(2016),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [sym_kEnd] = ACTIONS(2009),
    [sym_kVar] = ACTIONS(2011),
    [sym_kThreadvar] = ACTIONS(2009),
    [sym_kConst] = ACTIONS(2011),
    [sym_kResourcestring] = ACTIONS(2009),
    [sym_kType] = ACTIONS(2009),
    [sym_kProperty] = ACTIONS(2009),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2009),
    [sym_kGeneric] = ACTIONS(2009),
    [sym_kCase] = ACTIONS(2009),
    [sym_kFunction] = ACTIONS(2009),
    [sym_kProcedure] = ACTIONS(2009),
    [sym_kConstructor] = ACTIONS(2009),
    [sym_kDestructor] = ACTIONS(2009),
    [sym_kOperator] = ACTIONS(2009),
    [sym_kPublished] = ACTIONS(2009),
    [sym_kPublic] = ACTIONS(2467),
    [sym_kProtected] = ACTIONS(2009),
    [sym_kPrivate] = ACTIONS(2009),
    [sym_kStrict] = ACTIONS(2009),
    [sym_kRequired] = ACTIONS(2009),
    [sym_kOptional] = ACTIONS(2009),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(393),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [sym_kEnd] = ACTIONS(2002),
    [sym_kVar] = ACTIONS(2004),
    [sym_kThreadvar] = ACTIONS(2002),
    [sym_kConst] = ACTIONS(2004),
    [sym_kResourcestring] = ACTIONS(2002),
    [sym_kType] = ACTIONS(2002),
    [sym_kProperty] = ACTIONS(2002),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2002),
    [sym_kGeneric] = ACTIONS(2002),
    [sym_kCase] = ACTIONS(2002),
    [sym_kFunction] = ACTIONS(2002),
    [sym_kProcedure] = ACTIONS(2002),
    [sym_kConstructor] = ACTIONS(2002),
    [sym_kDestructor] = ACTIONS(2002),
    [sym_kOperator] = ACTIONS(2002),
    [sym_kPublished] = ACTIONS(2002),
    [sym_kPublic] = ACTIONS(2473),
    [sym_kProtected] = ACTIONS(2002),
    [sym_kPrivate] = ACTIONS(2002),
    [sym_kStrict] = ACTIONS(2002),
    [sym_kRequired] = ACTIONS(2002),
    [sym_kOptional] = ACTIONS(2002),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(394),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [sym_kEnd] = ACTIONS(1995),
    [sym_kVar] = ACTIONS(1997),
    [sym_kThreadvar] = ACTIONS(1995),
    [sym_kConst] = ACTIONS(1997),
    [sym_kResourcestring] = ACTIONS(1995),
    [sym_kType] = ACTIONS(1995),
    [sym_kProperty] = ACTIONS(1995),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1995),
    [sym_kGeneric] = ACTIONS(1995),
    [sym_kCase] = ACTIONS(1995),
    [sym_kFunction] = ACTIONS(1995),
    [sym_kProcedure] = ACTIONS(1995),
    [sym_kConstructor] = ACTIONS(1995),
    [sym_kDestructor] = ACTIONS(1995),
    [sym_kOperator] = ACTIONS(1995),
    [sym_kPublished] = ACTIONS(1995),
    [sym_kPublic] = ACTIONS(2479),
    [sym_kProtected] = ACTIONS(1995),
    [sym_kPrivate] = ACTIONS(1995),
    [sym_kStrict] = ACTIONS(1995),
    [sym_kRequired] = ACTIONS(1995),
    [sym_kOptional] = ACTIONS(1995),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [sym_kEnd] = ACTIONS(1374),
    [sym_kVar] = ACTIONS(1376),
    [sym_kThreadvar] = ACTIONS(1374),
    [sym_kConst] = ACTIONS(1376),
    [sym_kResourcestring] = ACTIONS(1374),
    [sym_kType] = ACTIONS(1374),
    [sym_kProperty] = ACTIONS(1374),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1374),
    [sym_kGeneric] = ACTIONS(1374),
    [sym_kCase] = ACTIONS(1374),
    [sym_kFunction] = ACTIONS(1374),
    [sym_kProcedure] = ACTIONS(1374),
    [sym_kConstructor] = ACTIONS(1374),
    [sym_kDestructor] = ACTIONS(1374),
    [sym_kOperator] = ACTIONS(1374),
    [sym_kPublished] = ACTIONS(1374),
    [sym_kPublic] = ACTIONS(2485),
    [sym_kProtected] = ACTIONS(1374),
    [sym_kPrivate] = ACTIONS(1374),
    [sym_kStrict] = ACTIONS(1374),
    [sym_kRequired] = ACTIONS(1374),
    [sym_kOptional] = ACTIONS(1374),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(397),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [sym_kEnd] = ACTIONS(1381),
    [sym_kVar] = ACTIONS(1383),
    [sym_kThreadvar] = ACTIONS(1381),
    [sym_kConst] = ACTIONS(1383),
    [sym_kResourcestring] = ACTIONS(1381),
    [sym_kType] = ACTIONS(1381),
    [sym_kProperty] = ACTIONS(1381),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1381),
    [sym_kGeneric] = ACTIONS(1381),
    [sym_kCase] = ACTIONS(1381),
    [sym_kFunction] = ACTIONS(1381),
    [sym_kProcedure] = ACTIONS(1381),
    [sym_kConstructor] = ACTIONS(1381),
    [sym_kDestructor] = ACTIONS(1381),
    [sym_kOperator] = ACTIONS(1381),
    [sym_kPublished] = ACTIONS(1381),
    [sym_kPublic] = ACTIONS(2491),
    [sym_kProtected] = ACTIONS(1381),
    [sym_kPrivate] = ACTIONS(1381),
    [sym_kStrict] = ACTIONS(1381),
    [sym_kRequired] = ACTIONS(1381),
    [sym_kOptional] = ACTIONS(1381),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(348),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [sym_kUses] = ACTIONS(2119),
    [sym_kInterface] = ACTIONS(2119),
    [sym_kImplementation] = ACTIONS(2119),
    [sym_kInitialization] = ACTIONS(2119),
    [sym_kFinalization] = ACTIONS(2119),
    [sym_kEnd] = ACTIONS(2119),
    [sym_kVar] = ACTIONS(2121),
    [sym_kThreadvar] = ACTIONS(2119),
    [sym_kConst] = ACTIONS(2121),
    [sym_kResourcestring] = ACTIONS(2119),
    [sym_kType] = ACTIONS(2119),
    [sym_kLabel] = ACTIONS(2119),
    [sym_kExports] = ACTIONS(2119),
    [sym_kProperty] = ACTIONS(2119),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2119),
    [sym_kGeneric] = ACTIONS(2119),
    [sym_kFunction] = ACTIONS(2119),
    [sym_kProcedure] = ACTIONS(2119),
    [sym_kConstructor] = ACTIONS(2119),
    [sym_kDestructor] = ACTIONS(2119),
    [sym_kOperator] = ACTIONS(2119),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(401),
    [anon_sym_LBRACK] = ACTIONS(2497),
    [sym_kEnd] = ACTIONS(1395),
    [sym_kVar] = ACTIONS(1397),
    [sym_kThreadvar] = ACTIONS(1395),
    [sym_kConst] = ACTIONS(1397),
    [sym_kResourcestring] = ACTIONS(1395),
    [sym_kType] = ACTIONS(1395),
    [sym_kProperty] = ACTIONS(1395),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1395),
    [sym_kGeneric] = ACTIONS(1395),
    [sym_kCase] = ACTIONS(1395),
    [sym_kFunction] = ACTIONS(1395),
    [sym_kProcedure] = ACTIONS(1395),
    [sym_kConstructor] = ACTIONS(1395),
    [sym_kDestructor] = ACTIONS(1395),
    [sym_kOperator] = ACTIONS(1395),
    [sym_kPublished] = ACTIONS(1395),
    [sym_kPublic] = ACTIONS(2500),
    [sym_kProtected] = ACTIONS(1395),
    [sym_kPrivate] = ACTIONS(1395),
    [sym_kStrict] = ACTIONS(1395),
    [sym_kRequired] = ACTIONS(1395),
    [sym_kOptional] = ACTIONS(1395),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [sym_kEnd] = ACTIONS(1416),
    [sym_kVar] = ACTIONS(1418),
    [sym_kThreadvar] = ACTIONS(1416),
    [sym_kConst] = ACTIONS(1418),
    [sym_kResourcestring] = ACTIONS(1416),
    [sym_kType] = ACTIONS(1416),
    [sym_kProperty] = ACTIONS(1416),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1416),
    [sym_kGeneric] = ACTIONS(1416),
    [sym_kCase] = ACTIONS(1416),
    [sym_kFunction] = ACTIONS(1416),
    [sym_kProcedure] = ACTIONS(1416),
    [sym_kConstructor] = ACTIONS(1416),
    [sym_kDestructor] = ACTIONS(1416),
    [sym_kOperator] = ACTIONS(1416),
    [sym_kPublished] = ACTIONS(1416),
    [sym_kPublic] = ACTIONS(2506),
    [sym_kProtected] = ACTIONS(1416),
    [sym_kPrivate] = ACTIONS(1416),
    [sym_kStrict] = ACTIONS(1416),
    [sym_kRequired] = ACTIONS(1416),
    [sym_kOptional] = ACTIONS(1416),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(313),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [sym_kUses] = ACTIONS(1646),
    [sym_kInterface] = ACTIONS(1646),
    [sym_kImplementation] = ACTIONS(1646),
    [sym_kInitialization] = ACTIONS(1646),
    [sym_kFinalization] = ACTIONS(1646),
    [sym_kEnd] = ACTIONS(1646),
    [sym_kVar] = ACTIONS(1648),
    [sym_kThreadvar] = ACTIONS(1646),
    [sym_kConst] = ACTIONS(1648),
    [sym_kResourcestring] = ACTIONS(1646),
    [sym_kType] = ACTIONS(1646),
    [sym_kLabel] = ACTIONS(1646),
    [sym_kExports] = ACTIONS(1646),
    [sym_kProperty] = ACTIONS(1646),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1646),
    [sym_kGeneric] = ACTIONS(1646),
    [sym_kFunction] = ACTIONS(1646),
    [sym_kProcedure] = ACTIONS(1646),
    [sym_kConstructor] = ACTIONS(1646),
    [sym_kDestructor] = ACTIONS(1646),
    [sym_kOperator] = ACTIONS(1646),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [sym_kEnd] = ACTIONS(1430),
    [sym_kVar] = ACTIONS(1432),
    [sym_kThreadvar] = ACTIONS(1430),
    [sym_kConst] = ACTIONS(1432),
    [sym_kResourcestring] = ACTIONS(1430),
    [sym_kType] = ACTIONS(1430),
    [sym_kProperty] = ACTIONS(1430),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1430),
    [sym_kGeneric] = ACTIONS(1430),
    [sym_kCase] = ACTIONS(1430),
    [sym_kFunction] = ACTIONS(1430),
    [sym_kProcedure] = ACTIONS(1430),
    [sym_kConstructor] = ACTIONS(1430),
    [sym_kDestructor] = ACTIONS(1430),
    [sym_kOperator] = ACTIONS(1430),
    [sym_kPublished] = ACTIONS(1430),
    [sym_kPublic] = ACTIONS(2515),
    [sym_kProtected] = ACTIONS(1430),
    [sym_kPrivate] = ACTIONS(1430),
    [sym_kStrict] = ACTIONS(1430),
    [sym_kRequired] = ACTIONS(1430),
    [sym_kOptional] = ACTIONS(1430),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [sym_kUses] = ACTIONS(1673),
    [sym_kInterface] = ACTIONS(1673),
    [sym_kImplementation] = ACTIONS(1673),
    [sym_kInitialization] = ACTIONS(1673),
    [sym_kFinalization] = ACTIONS(1673),
    [sym_kEnd] = ACTIONS(1673),
    [sym_kVar] = ACTIONS(1675),
    [sym_kThreadvar] = ACTIONS(1673),
    [sym_kConst] = ACTIONS(1675),
    [sym_kResourcestring] = ACTIONS(1673),
    [sym_kType] = ACTIONS(1673),
    [sym_kLabel] = ACTIONS(1673),
    [sym_kExports] = ACTIONS(1673),
    [sym_kProperty] = ACTIONS(1673),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1673),
    [sym_kGeneric] = ACTIONS(1673),
    [sym_kFunction] = ACTIONS(1673),
    [sym_kProcedure] = ACTIONS(1673),
    [sym_kConstructor] = ACTIONS(1673),
    [sym_kDestructor] = ACTIONS(1673),
    [sym_kOperator] = ACTIONS(1673),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2521),
    [sym_kEnd] = ACTIONS(1952),
    [sym_kVar] = ACTIONS(1954),
    [sym_kThreadvar] = ACTIONS(1952),
    [sym_kConst] = ACTIONS(1954),
    [sym_kResourcestring] = ACTIONS(1952),
    [sym_kType] = ACTIONS(1952),
    [sym_kProperty] = ACTIONS(1952),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1952),
    [sym_kGeneric] = ACTIONS(1952),
    [sym_kCase] = ACTIONS(1952),
    [sym_kFunction] = ACTIONS(1952),
    [sym_kProcedure] = ACTIONS(1952),
    [sym_kConstructor] = ACTIONS(1952),
    [sym_kDestructor] = ACTIONS(1952),
    [sym_kOperator] = ACTIONS(1952),
    [sym_kPublished] = ACTIONS(1952),
    [sym_kPublic] = ACTIONS(2524),
    [sym_kProtected] = ACTIONS(1952),
    [sym_kPrivate] = ACTIONS(1952),
    [sym_kStrict] = ACTIONS(1952),
    [sym_kRequired] = ACTIONS(1952),
    [sym_kOptional] = ACTIONS(1952),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [sym_kUses] = ACTIONS(1683),
    [sym_kInterface] = ACTIONS(1683),
    [sym_kImplementation] = ACTIONS(1683),
    [sym_kInitialization] = ACTIONS(1683),
    [sym_kFinalization] = ACTIONS(1683),
    [sym_kEnd] = ACTIONS(1683),
    [sym_kVar] = ACTIONS(1685),
    [sym_kThreadvar] = ACTIONS(1683),
    [sym_kConst] = ACTIONS(1685),
    [sym_kResourcestring] = ACTIONS(1683),
    [sym_kType] = ACTIONS(1683),
    [sym_kLabel] = ACTIONS(1683),
    [sym_kExports] = ACTIONS(1683),
    [sym_kProperty] = ACTIONS(1683),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1683),
    [sym_kGeneric] = ACTIONS(1683),
    [sym_kFunction] = ACTIONS(1683),
    [sym_kProcedure] = ACTIONS(1683),
    [sym_kConstructor] = ACTIONS(1683),
    [sym_kDestructor] = ACTIONS(1683),
    [sym_kOperator] = ACTIONS(1683),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2530),
    [sym_kEnd] = ACTIONS(1945),
    [sym_kVar] = ACTIONS(1947),
    [sym_kThreadvar] = ACTIONS(1945),
    [sym_kConst] = ACTIONS(1947),
    [sym_kResourcestring] = ACTIONS(1945),
    [sym_kType] = ACTIONS(1945),
    [sym_kProperty] = ACTIONS(1945),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1945),
    [sym_kGeneric] = ACTIONS(1945),
    [sym_kCase] = ACTIONS(1945),
    [sym_kFunction] = ACTIONS(1945),
    [sym_kProcedure] = ACTIONS(1945),
    [sym_kConstructor] = ACTIONS(1945),
    [sym_kDestructor] = ACTIONS(1945),
    [sym_kOperator] = ACTIONS(1945),
    [sym_kPublished] = ACTIONS(1945),
    [sym_kPublic] = ACTIONS(2533),
    [sym_kProtected] = ACTIONS(1945),
    [sym_kPrivate] = ACTIONS(1945),
    [sym_kStrict] = ACTIONS(1945),
    [sym_kRequired] = ACTIONS(1945),
    [sym_kOptional] = ACTIONS(1945),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [sym_kEnd] = ACTIONS(1938),
    [sym_kVar] = ACTIONS(1940),
    [sym_kThreadvar] = ACTIONS(1938),
    [sym_kConst] = ACTIONS(1940),
    [sym_kResourcestring] = ACTIONS(1938),
    [sym_kType] = ACTIONS(1938),
    [sym_kProperty] = ACTIONS(1938),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1938),
    [sym_kGeneric] = ACTIONS(1938),
    [sym_kCase] = ACTIONS(1938),
    [sym_kFunction] = ACTIONS(1938),
    [sym_kProcedure] = ACTIONS(1938),
    [sym_kConstructor] = ACTIONS(1938),
    [sym_kDestructor] = ACTIONS(1938),
    [sym_kOperator] = ACTIONS(1938),
    [sym_kPublished] = ACTIONS(1938),
    [sym_kPublic] = ACTIONS(2539),
    [sym_kProtected] = ACTIONS(1938),
    [sym_kPrivate] = ACTIONS(1938),
    [sym_kStrict] = ACTIONS(1938),
    [sym_kRequired] = ACTIONS(1938),
    [sym_kOptional] = ACTIONS(1938),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(404),
    [anon_sym_LBRACK] = ACTIONS(2542),
    [sym_kEnd] = ACTIONS(1931),
    [sym_kVar] = ACTIONS(1933),
    [sym_kThreadvar] = ACTIONS(1931),
    [sym_kConst] = ACTIONS(1933),
    [sym_kResourcestring] = ACTIONS(1931),
    [sym_kType] = ACTIONS(1931),
    [sym_kProperty] = ACTIONS(1931),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1931),
    [sym_kGeneric] = ACTIONS(1931),
    [sym_kCase] = ACTIONS(1931),
    [sym_kFunction] = ACTIONS(1931),
    [sym_kProcedure] = ACTIONS(1931),
    [sym_kConstructor] = ACTIONS(1931),
    [sym_kDestructor] = ACTIONS(1931),
    [sym_kOperator] = ACTIONS(1931),
    [sym_kPublished] = ACTIONS(1931),
    [sym_kPublic] = ACTIONS(2545),
    [sym_kProtected] = ACTIONS(1931),
    [sym_kPrivate] = ACTIONS(1931),
    [sym_kStrict] = ACTIONS(1931),
    [sym_kRequired] = ACTIONS(1931),
    [sym_kOptional] = ACTIONS(1931),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [sym_kEnd] = ACTIONS(1265),
    [sym_kVar] = ACTIONS(1267),
    [sym_kThreadvar] = ACTIONS(1265),
    [sym_kConst] = ACTIONS(1267),
    [sym_kResourcestring] = ACTIONS(1265),
    [sym_kType] = ACTIONS(1265),
    [sym_kProperty] = ACTIONS(1265),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1265),
    [sym_kGeneric] = ACTIONS(1265),
    [sym_kCase] = ACTIONS(1265),
    [sym_kFunction] = ACTIONS(1265),
    [sym_kProcedure] = ACTIONS(1265),
    [sym_kConstructor] = ACTIONS(1265),
    [sym_kDestructor] = ACTIONS(1265),
    [sym_kOperator] = ACTIONS(1265),
    [sym_kPublished] = ACTIONS(1265),
    [sym_kPublic] = ACTIONS(2551),
    [sym_kProtected] = ACTIONS(1265),
    [sym_kPrivate] = ACTIONS(1265),
    [sym_kStrict] = ACTIONS(1265),
    [sym_kRequired] = ACTIONS(1265),
    [sym_kOptional] = ACTIONS(1265),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [sym_kEnd] = ACTIONS(1884),
    [sym_kVar] = ACTIONS(1886),
    [sym_kThreadvar] = ACTIONS(1884),
    [sym_kConst] = ACTIONS(1886),
    [sym_kResourcestring] = ACTIONS(1884),
    [sym_kType] = ACTIONS(1884),
    [sym_kProperty] = ACTIONS(1884),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1884),
    [sym_kGeneric] = ACTIONS(1884),
    [sym_kCase] = ACTIONS(1884),
    [sym_kFunction] = ACTIONS(1884),
    [sym_kProcedure] = ACTIONS(1884),
    [sym_kConstructor] = ACTIONS(1884),
    [sym_kDestructor] = ACTIONS(1884),
    [sym_kOperator] = ACTIONS(1884),
    [sym_kPublished] = ACTIONS(1884),
    [sym_kPublic] = ACTIONS(2557),
    [sym_kProtected] = ACTIONS(1884),
    [sym_kPrivate] = ACTIONS(1884),
    [sym_kStrict] = ACTIONS(1884),
    [sym_kRequired] = ACTIONS(1884),
    [sym_kOptional] = ACTIONS(1884),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [sym_kEnd] = ACTIONS(1857),
    [sym_kVar] = ACTIONS(1859),
    [sym_kThreadvar] = ACTIONS(1857),
    [sym_kConst] = ACTIONS(1859),
    [sym_kResourcestring] = ACTIONS(1857),
    [sym_kType] = ACTIONS(1857),
    [sym_kProperty] = ACTIONS(1857),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1857),
    [sym_kGeneric] = ACTIONS(1857),
    [sym_kCase] = ACTIONS(1857),
    [sym_kFunction] = ACTIONS(1857),
    [sym_kProcedure] = ACTIONS(1857),
    [sym_kConstructor] = ACTIONS(1857),
    [sym_kDestructor] = ACTIONS(1857),
    [sym_kOperator] = ACTIONS(1857),
    [sym_kPublished] = ACTIONS(1857),
    [sym_kPublic] = ACTIONS(2563),
    [sym_kProtected] = ACTIONS(1857),
    [sym_kPrivate] = ACTIONS(1857),
    [sym_kStrict] = ACTIONS(1857),
    [sym_kRequired] = ACTIONS(1857),
    [sym_kOptional] = ACTIONS(1857),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [sym_kEnd] = ACTIONS(1850),
    [sym_kVar] = ACTIONS(1852),
    [sym_kThreadvar] = ACTIONS(1850),
    [sym_kConst] = ACTIONS(1852),
    [sym_kResourcestring] = ACTIONS(1850),
    [sym_kType] = ACTIONS(1850),
    [sym_kProperty] = ACTIONS(1850),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1850),
    [sym_kGeneric] = ACTIONS(1850),
    [sym_kCase] = ACTIONS(1850),
    [sym_kFunction] = ACTIONS(1850),
    [sym_kProcedure] = ACTIONS(1850),
    [sym_kConstructor] = ACTIONS(1850),
    [sym_kDestructor] = ACTIONS(1850),
    [sym_kOperator] = ACTIONS(1850),
    [sym_kPublished] = ACTIONS(1850),
    [sym_kPublic] = ACTIONS(2569),
    [sym_kProtected] = ACTIONS(1850),
    [sym_kPrivate] = ACTIONS(1850),
    [sym_kStrict] = ACTIONS(1850),
    [sym_kRequired] = ACTIONS(1850),
    [sym_kOptional] = ACTIONS(1850),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(355),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [sym_kUses] = ACTIONS(1730),
    [sym_kInterface] = ACTIONS(1730),
    [sym_kImplementation] = ACTIONS(1730),
    [sym_kInitialization] = ACTIONS(1730),
    [sym_kFinalization] = ACTIONS(1730),
    [sym_kEnd] = ACTIONS(1730),
    [sym_kVar] = ACTIONS(1732),
    [sym_kThreadvar] = ACTIONS(1730),
    [sym_kConst] = ACTIONS(1732),
    [sym_kResourcestring] = ACTIONS(1730),
    [sym_kType] = ACTIONS(1730),
    [sym_kLabel] = ACTIONS(1730),
    [sym_kExports] = ACTIONS(1730),
    [sym_kProperty] = ACTIONS(1730),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1730),
    [sym_kGeneric] = ACTIONS(1730),
    [sym_kFunction] = ACTIONS(1730),
    [sym_kProcedure] = ACTIONS(1730),
    [sym_kConstructor] = ACTIONS(1730),
    [sym_kDestructor] = ACTIONS(1730),
    [sym_kOperator] = ACTIONS(1730),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(405),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [sym_kEnd] = ACTIONS(1843),
    [sym_kVar] = ACTIONS(1845),
    [sym_kThreadvar] = ACTIONS(1843),
    [sym_kConst] = ACTIONS(1845),
    [sym_kResourcestring] = ACTIONS(1843),
    [sym_kType] = ACTIONS(1843),
    [sym_kProperty] = ACTIONS(1843),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1843),
    [sym_kGeneric] = ACTIONS(1843),
    [sym_kCase] = ACTIONS(1843),
    [sym_kFunction] = ACTIONS(1843),
    [sym_kProcedure] = ACTIONS(1843),
    [sym_kConstructor] = ACTIONS(1843),
    [sym_kDestructor] = ACTIONS(1843),
    [sym_kOperator] = ACTIONS(1843),
    [sym_kPublished] = ACTIONS(1843),
    [sym_kPublic] = ACTIONS(2578),
    [sym_kProtected] = ACTIONS(1843),
    [sym_kPrivate] = ACTIONS(1843),
    [sym_kStrict] = ACTIONS(1843),
    [sym_kRequired] = ACTIONS(1843),
    [sym_kOptional] = ACTIONS(1843),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [sym_kEnd] = ACTIONS(1325),
    [sym_kVar] = ACTIONS(1327),
    [sym_kThreadvar] = ACTIONS(1325),
    [sym_kConst] = ACTIONS(1327),
    [sym_kResourcestring] = ACTIONS(1325),
    [sym_kType] = ACTIONS(1325),
    [sym_kProperty] = ACTIONS(1325),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1325),
    [sym_kGeneric] = ACTIONS(1325),
    [sym_kCase] = ACTIONS(1325),
    [sym_kFunction] = ACTIONS(1325),
    [sym_kProcedure] = ACTIONS(1325),
    [sym_kConstructor] = ACTIONS(1325),
    [sym_kDestructor] = ACTIONS(1325),
    [sym_kOperator] = ACTIONS(1325),
    [sym_kPublished] = ACTIONS(1325),
    [sym_kPublic] = ACTIONS(2584),
    [sym_kProtected] = ACTIONS(1325),
    [sym_kPrivate] = ACTIONS(1325),
    [sym_kStrict] = ACTIONS(1325),
    [sym_kRequired] = ACTIONS(1325),
    [sym_kOptional] = ACTIONS(1325),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(385),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [sym_kUses] = ACTIONS(1740),
    [sym_kInterface] = ACTIONS(1740),
    [sym_kImplementation] = ACTIONS(1740),
    [sym_kInitialization] = ACTIONS(1740),
    [sym_kFinalization] = ACTIONS(1740),
    [sym_kEnd] = ACTIONS(1740),
    [sym_kVar] = ACTIONS(1742),
    [sym_kThreadvar] = ACTIONS(1740),
    [sym_kConst] = ACTIONS(1742),
    [sym_kResourcestring] = ACTIONS(1740),
    [sym_kType] = ACTIONS(1740),
    [sym_kLabel] = ACTIONS(1740),
    [sym_kExports] = ACTIONS(1740),
    [sym_kProperty] = ACTIONS(1740),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1740),
    [sym_kGeneric] = ACTIONS(1740),
    [sym_kFunction] = ACTIONS(1740),
    [sym_kProcedure] = ACTIONS(1740),
    [sym_kConstructor] = ACTIONS(1740),
    [sym_kDestructor] = ACTIONS(1740),
    [sym_kOperator] = ACTIONS(1740),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym__procAttributeNoExt] = STATE(457),
    [sym_procAttribute] = STATE(2221),
    [aux_sym__declProc_repeat1] = STATE(372),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [sym_kUses] = ACTIONS(2082),
    [sym_kInterface] = ACTIONS(2082),
    [sym_kImplementation] = ACTIONS(2082),
    [sym_kInitialization] = ACTIONS(2082),
    [sym_kFinalization] = ACTIONS(2082),
    [sym_kEnd] = ACTIONS(2082),
    [sym_kVar] = ACTIONS(2084),
    [sym_kThreadvar] = ACTIONS(2082),
    [sym_kConst] = ACTIONS(2084),
    [sym_kResourcestring] = ACTIONS(2082),
    [sym_kType] = ACTIONS(2082),
    [sym_kLabel] = ACTIONS(2082),
    [sym_kExports] = ACTIONS(2082),
    [sym_kProperty] = ACTIONS(2082),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2082),
    [sym_kGeneric] = ACTIONS(2082),
    [sym_kFunction] = ACTIONS(2082),
    [sym_kProcedure] = ACTIONS(2082),
    [sym_kConstructor] = ACTIONS(2082),
    [sym_kDestructor] = ACTIONS(2082),
    [sym_kOperator] = ACTIONS(2082),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(387),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [sym_kUses] = ACTIONS(1750),
    [sym_kInterface] = ACTIONS(1750),
    [sym_kImplementation] = ACTIONS(1750),
    [sym_kInitialization] = ACTIONS(1750),
    [sym_kFinalization] = ACTIONS(1750),
    [sym_kEnd] = ACTIONS(1750),
    [sym_kVar] = ACTIONS(1752),
    [sym_kThreadvar] = ACTIONS(1750),
    [sym_kConst] = ACTIONS(1752),
    [sym_kResourcestring] = ACTIONS(1750),
    [sym_kType] = ACTIONS(1750),
    [sym_kLabel] = ACTIONS(1750),
    [sym_kExports] = ACTIONS(1750),
    [sym_kProperty] = ACTIONS(1750),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1750),
    [sym_kGeneric] = ACTIONS(1750),
    [sym_kFunction] = ACTIONS(1750),
    [sym_kProcedure] = ACTIONS(1750),
    [sym_kConstructor] = ACTIONS(1750),
    [sym_kDestructor] = ACTIONS(1750),
    [sym_kOperator] = ACTIONS(1750),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [sym_kEnd] = ACTIONS(1318),
    [sym_kVar] = ACTIONS(1320),
    [sym_kThreadvar] = ACTIONS(1318),
    [sym_kConst] = ACTIONS(1320),
    [sym_kResourcestring] = ACTIONS(1318),
    [sym_kType] = ACTIONS(1318),
    [sym_kProperty] = ACTIONS(1318),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1318),
    [sym_kGeneric] = ACTIONS(1318),
    [sym_kCase] = ACTIONS(1318),
    [sym_kFunction] = ACTIONS(1318),
    [sym_kProcedure] = ACTIONS(1318),
    [sym_kConstructor] = ACTIONS(1318),
    [sym_kDestructor] = ACTIONS(1318),
    [sym_kOperator] = ACTIONS(1318),
    [sym_kPublished] = ACTIONS(1318),
    [sym_kPublic] = ACTIONS(2599),
    [sym_kProtected] = ACTIONS(1318),
    [sym_kPrivate] = ACTIONS(1318),
    [sym_kStrict] = ACTIONS(1318),
    [sym_kRequired] = ACTIONS(1318),
    [sym_kOptional] = ACTIONS(1318),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym__procAttribute] = STATE(243),
    [sym_procAttribute] = STATE(2407),
    [aux_sym_declProcFwd_repeat1] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [sym_kUses] = ACTIONS(1760),
    [sym_kInterface] = ACTIONS(1760),
    [sym_kImplementation] = ACTIONS(1760),
    [sym_kInitialization] = ACTIONS(1760),
    [sym_kFinalization] = ACTIONS(1760),
    [sym_kEnd] = ACTIONS(1760),
    [sym_kVar] = ACTIONS(1762),
    [sym_kThreadvar] = ACTIONS(1760),
    [sym_kConst] = ACTIONS(1762),
    [sym_kResourcestring] = ACTIONS(1760),
    [sym_kType] = ACTIONS(1760),
    [sym_kLabel] = ACTIONS(1760),
    [sym_kExports] = ACTIONS(1760),
    [sym_kProperty] = ACTIONS(1760),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1760),
    [sym_kGeneric] = ACTIONS(1760),
    [sym_kFunction] = ACTIONS(1760),
    [sym_kProcedure] = ACTIONS(1760),
    [sym_kConstructor] = ACTIONS(1760),
    [sym_kDestructor] = ACTIONS(1760),
    [sym_kOperator] = ACTIONS(1760),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(406),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [sym_kEnd] = ACTIONS(1311),
    [sym_kVar] = ACTIONS(1313),
    [sym_kThreadvar] = ACTIONS(1311),
    [sym_kConst] = ACTIONS(1313),
    [sym_kResourcestring] = ACTIONS(1311),
    [sym_kType] = ACTIONS(1311),
    [sym_kProperty] = ACTIONS(1311),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1311),
    [sym_kGeneric] = ACTIONS(1311),
    [sym_kCase] = ACTIONS(1311),
    [sym_kFunction] = ACTIONS(1311),
    [sym_kProcedure] = ACTIONS(1311),
    [sym_kConstructor] = ACTIONS(1311),
    [sym_kDestructor] = ACTIONS(1311),
    [sym_kOperator] = ACTIONS(1311),
    [sym_kPublished] = ACTIONS(1311),
    [sym_kPublic] = ACTIONS(2608),
    [sym_kProtected] = ACTIONS(1311),
    [sym_kPrivate] = ACTIONS(1311),
    [sym_kStrict] = ACTIONS(1311),
    [sym_kRequired] = ACTIONS(1311),
    [sym_kOptional] = ACTIONS(1311),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [sym_kEnd] = ACTIONS(1790),
    [sym_kVar] = ACTIONS(1792),
    [sym_kThreadvar] = ACTIONS(1790),
    [sym_kConst] = ACTIONS(1792),
    [sym_kResourcestring] = ACTIONS(1790),
    [sym_kType] = ACTIONS(1790),
    [sym_kProperty] = ACTIONS(1790),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1790),
    [sym_kGeneric] = ACTIONS(1790),
    [sym_kCase] = ACTIONS(1790),
    [sym_kFunction] = ACTIONS(1790),
    [sym_kProcedure] = ACTIONS(1790),
    [sym_kConstructor] = ACTIONS(1790),
    [sym_kDestructor] = ACTIONS(1790),
    [sym_kOperator] = ACTIONS(1790),
    [sym_kPublished] = ACTIONS(1790),
    [sym_kPublic] = ACTIONS(2614),
    [sym_kProtected] = ACTIONS(1790),
    [sym_kPrivate] = ACTIONS(1790),
    [sym_kStrict] = ACTIONS(1790),
    [sym_kRequired] = ACTIONS(1790),
    [sym_kOptional] = ACTIONS(1790),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [sym_kEnd] = ACTIONS(1713),
    [sym_kVar] = ACTIONS(1715),
    [sym_kThreadvar] = ACTIONS(1713),
    [sym_kConst] = ACTIONS(1715),
    [sym_kResourcestring] = ACTIONS(1713),
    [sym_kType] = ACTIONS(1713),
    [sym_kProperty] = ACTIONS(1713),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1713),
    [sym_kGeneric] = ACTIONS(1713),
    [sym_kCase] = ACTIONS(1713),
    [sym_kFunction] = ACTIONS(1713),
    [sym_kProcedure] = ACTIONS(1713),
    [sym_kConstructor] = ACTIONS(1713),
    [sym_kDestructor] = ACTIONS(1713),
    [sym_kOperator] = ACTIONS(1713),
    [sym_kPublished] = ACTIONS(1713),
    [sym_kPublic] = ACTIONS(2620),
    [sym_kProtected] = ACTIONS(1713),
    [sym_kPrivate] = ACTIONS(1713),
    [sym_kStrict] = ACTIONS(1713),
    [sym_kRequired] = ACTIONS(1713),
    [sym_kOptional] = ACTIONS(1713),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym__procAttributeNoExt] = STATE(482),
    [sym_procAttribute] = STATE(2168),
    [aux_sym__declProc_repeat1] = STATE(308),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [sym_kEnd] = ACTIONS(1218),
    [sym_kVar] = ACTIONS(1220),
    [sym_kThreadvar] = ACTIONS(1218),
    [sym_kConst] = ACTIONS(1220),
    [sym_kResourcestring] = ACTIONS(1218),
    [sym_kType] = ACTIONS(1218),
    [sym_kProperty] = ACTIONS(1218),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1218),
    [sym_kGeneric] = ACTIONS(1218),
    [sym_kCase] = ACTIONS(1218),
    [sym_kFunction] = ACTIONS(1218),
    [sym_kProcedure] = ACTIONS(1218),
    [sym_kConstructor] = ACTIONS(1218),
    [sym_kDestructor] = ACTIONS(1218),
    [sym_kOperator] = ACTIONS(1218),
    [sym_kPublished] = ACTIONS(1218),
    [sym_kPublic] = ACTIONS(2626),
    [sym_kProtected] = ACTIONS(1218),
    [sym_kPrivate] = ACTIONS(1218),
    [sym_kStrict] = ACTIONS(1218),
    [sym_kRequired] = ACTIONS(1218),
    [sym_kOptional] = ACTIONS(1218),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(1611),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_identifier] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(711),
    [sym_kEnd] = ACTIONS(713),
    [sym_kVar] = ACTIONS(713),
    [sym_kThreadvar] = ACTIONS(713),
    [sym_kConst] = ACTIONS(713),
    [sym_kResourcestring] = ACTIONS(713),
    [sym_kType] = ACTIONS(713),
    [sym_kProperty] = ACTIONS(713),
    [sym_kDefault] = ACTIONS(713),
    [sym_kNodefault] = ACTIONS(713),
    [sym_kClass] = ACTIONS(713),
    [sym_kGeneric] = ACTIONS(713),
    [sym_kCase] = ACTIONS(713),
    [sym_kFunction] = ACTIONS(713),
    [sym_kProcedure] = ACTIONS(713),
    [sym_kConstructor] = ACTIONS(713),
    [sym_kDestructor] = ACTIONS(713),
    [sym_kOperator] = ACTIONS(713),
    [sym_kPublished] = ACTIONS(713),
    [sym_kPublic] = ACTIONS(713),
    [sym_kProtected] = ACTIONS(713),
    [sym_kPrivate] = ACTIONS(713),
    [sym_kStrict] = ACTIONS(713),
    [sym_kRequired] = ACTIONS(713),
    [sym_kOptional] = ACTIONS(713),
    [sym_kStatic] = ACTIONS(713),
    [sym_kVirtual] = ACTIONS(713),
    [sym_kAbstract] = ACTIONS(713),
    [sym_kDynamic] = ACTIONS(713),
    [sym_kOverride] = ACTIONS(713),
    [sym_kOverload] = ACTIONS(713),
    [sym_kReintroduce] = ACTIONS(713),
    [sym_kInline] = ACTIONS(713),
    [sym_kStdcall] = ACTIONS(713),
    [sym_kCdecl] = ACTIONS(713),
    [sym_kCppdecl] = ACTIONS(713),
    [sym_kPascal] = ACTIONS(713),
    [sym_kRegister] = ACTIONS(713),
    [sym_kMwpascal] = ACTIONS(713),
    [sym_kExternal] = ACTIONS(713),
    [sym_kMessage] = ACTIONS(713),
    [sym_kDeprecated] = ACTIONS(713),
    [sym_kExperimental] = ACTIONS(713),
    [sym_kPlatform] = ACTIONS(713),
    [sym_kUnimplemented] = ACTIONS(713),
    [sym_kCvar] = ACTIONS(713),
    [sym_kExport] = ACTIONS(713),
    [sym_kFar] = ACTIONS(713),
    [sym_kNear] = ACTIONS(713),
    [sym_kSafecall] = ACTIONS(713),
    [sym_kAssembler] = ACTIONS(713),
    [sym_kNostackframe] = ACTIONS(713),
    [sym_kInterrupt] = ACTIONS(713),
    [sym_kNoreturn] = ACTIONS(713),
    [sym_kIocheck] = ACTIONS(713),
    [sym_kLocal] = ACTIONS(713),
    [sym_kHardfloat] = ACTIONS(713),
    [sym_kSoftfloat] = ACTIONS(713),
    [sym_kMs_abi_default] = ACTIONS(713),
    [sym_kMs_abi_cdecl] = ACTIONS(713),
    [sym_kSaveregisters] = ACTIONS(713),
    [sym_kSysv_abi_default] = ACTIONS(713),
    [sym_kSysv_abi_cdecl] = ACTIONS(713),
    [sym_kVectorcall] = ACTIONS(713),
    [sym_kVarargs] = ACTIONS(713),
    [sym_kWinapi] = ACTIONS(713),
    [sym_kAlias] = ACTIONS(713),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_kEnd] = ACTIONS(1235),
    [sym_kVar] = ACTIONS(1235),
    [sym_kThreadvar] = ACTIONS(1235),
    [sym_kConst] = ACTIONS(1235),
    [sym_kResourcestring] = ACTIONS(1235),
    [sym_kType] = ACTIONS(1235),
    [sym_kProperty] = ACTIONS(1235),
    [sym_kDefault] = ACTIONS(1235),
    [sym_kNodefault] = ACTIONS(1235),
    [sym_kClass] = ACTIONS(1235),
    [sym_kGeneric] = ACTIONS(1235),
    [sym_kCase] = ACTIONS(1235),
    [sym_kFunction] = ACTIONS(1235),
    [sym_kProcedure] = ACTIONS(1235),
    [sym_kConstructor] = ACTIONS(1235),
    [sym_kDestructor] = ACTIONS(1235),
    [sym_kOperator] = ACTIONS(1235),
    [sym_kPublished] = ACTIONS(1235),
    [sym_kPublic] = ACTIONS(1235),
    [sym_kProtected] = ACTIONS(1235),
    [sym_kPrivate] = ACTIONS(1235),
    [sym_kStrict] = ACTIONS(1235),
    [sym_kRequired] = ACTIONS(1235),
    [sym_kOptional] = ACTIONS(1235),
    [sym_kStatic] = ACTIONS(1235),
    [sym_kVirtual] = ACTIONS(1235),
    [sym_kAbstract] = ACTIONS(1235),
    [sym_kDynamic] = ACTIONS(1235),
    [sym_kOverride] = ACTIONS(1235),
    [sym_kOverload] = ACTIONS(1235),
    [sym_kReintroduce] = ACTIONS(1235),
    [sym_kInline] = ACTIONS(1235),
    [sym_kStdcall] = ACTIONS(1235),
    [sym_kCdecl] = ACTIONS(1235),
    [sym_kCppdecl] = ACTIONS(1235),
    [sym_kPascal] = ACTIONS(1235),
    [sym_kRegister] = ACTIONS(1235),
    [sym_kMwpascal] = ACTIONS(1235),
    [sym_kExternal] = ACTIONS(1235),
    [sym_kMessage] = ACTIONS(1235),
    [sym_kDeprecated] = ACTIONS(1235),
    [sym_kExperimental] = ACTIONS(1235),
    [sym_kPlatform] = ACTIONS(1235),
    [sym_kUnimplemented] = ACTIONS(1235),
    [sym_kCvar] = ACTIONS(1235),
    [sym_kExport] = ACTIONS(1235),
    [sym_kFar] = ACTIONS(1235),
    [sym_kNear] = ACTIONS(1235),
    [sym_kSafecall] = ACTIONS(1235),
    [sym_kAssembler] = ACTIONS(1235),
    [sym_kNostackframe] = ACTIONS(1235),
    [sym_kInterrupt] = ACTIONS(1235),
    [sym_kNoreturn] = ACTIONS(1235),
    [sym_kIocheck] = ACTIONS(1235),
    [sym_kLocal] = ACTIONS(1235),
    [sym_kHardfloat] = ACTIONS(1235),
    [sym_kSoftfloat] = ACTIONS(1235),
    [sym_kMs_abi_default] = ACTIONS(1235),
    [sym_kMs_abi_cdecl] = ACTIONS(1235),
    [sym_kSaveregisters] = ACTIONS(1235),
    [sym_kSysv_abi_default] = ACTIONS(1235),
    [sym_kSysv_abi_cdecl] = ACTIONS(1235),
    [sym_kVectorcall] = ACTIONS(1235),
    [sym_kVarargs] = ACTIONS(1235),
    [sym_kWinapi] = ACTIONS(1235),
    [sym_kAlias] = ACTIONS(1235),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [sym_kEnd] = ACTIONS(1202),
    [sym_kVar] = ACTIONS(1202),
    [sym_kThreadvar] = ACTIONS(1202),
    [sym_kConst] = ACTIONS(1202),
    [sym_kResourcestring] = ACTIONS(1202),
    [sym_kType] = ACTIONS(1202),
    [sym_kProperty] = ACTIONS(1202),
    [sym_kDefault] = ACTIONS(1202),
    [sym_kNodefault] = ACTIONS(1202),
    [sym_kClass] = ACTIONS(1202),
    [sym_kGeneric] = ACTIONS(1202),
    [sym_kCase] = ACTIONS(1202),
    [sym_kFunction] = ACTIONS(1202),
    [sym_kProcedure] = ACTIONS(1202),
    [sym_kConstructor] = ACTIONS(1202),
    [sym_kDestructor] = ACTIONS(1202),
    [sym_kOperator] = ACTIONS(1202),
    [sym_kPublished] = ACTIONS(1202),
    [sym_kPublic] = ACTIONS(1202),
    [sym_kProtected] = ACTIONS(1202),
    [sym_kPrivate] = ACTIONS(1202),
    [sym_kStrict] = ACTIONS(1202),
    [sym_kRequired] = ACTIONS(1202),
    [sym_kOptional] = ACTIONS(1202),
    [sym_kStatic] = ACTIONS(1202),
    [sym_kVirtual] = ACTIONS(1202),
    [sym_kAbstract] = ACTIONS(1202),
    [sym_kDynamic] = ACTIONS(1202),
    [sym_kOverride] = ACTIONS(1202),
    [sym_kOverload] = ACTIONS(1202),
    [sym_kReintroduce] = ACTIONS(1202),
    [sym_kInline] = ACTIONS(1202),
    [sym_kStdcall] = ACTIONS(1202),
    [sym_kCdecl] = ACTIONS(1202),
    [sym_kCppdecl] = ACTIONS(1202),
    [sym_kPascal] = ACTIONS(1202),
    [sym_kRegister] = ACTIONS(1202),
    [sym_kMwpascal] = ACTIONS(1202),
    [sym_kExternal] = ACTIONS(1202),
    [sym_kMessage] = ACTIONS(1202),
    [sym_kDeprecated] = ACTIONS(1202),
    [sym_kExperimental] = ACTIONS(1202),
    [sym_kPlatform] = ACTIONS(1202),
    [sym_kUnimplemented] = ACTIONS(1202),
    [sym_kCvar] = ACTIONS(1202),
    [sym_kExport] = ACTIONS(1202),
    [sym_kFar] = ACTIONS(1202),
    [sym_kNear] = ACTIONS(1202),
    [sym_kSafecall] = ACTIONS(1202),
    [sym_kAssembler] = ACTIONS(1202),
    [sym_kNostackframe] = ACTIONS(1202),
    [sym_kInterrupt] = ACTIONS(1202),
    [sym_kNoreturn] = ACTIONS(1202),
    [sym_kIocheck] = ACTIONS(1202),
    [sym_kLocal] = ACTIONS(1202),
    [sym_kHardfloat] = ACTIONS(1202),
    [sym_kSoftfloat] = ACTIONS(1202),
    [sym_kMs_abi_default] = ACTIONS(1202),
    [sym_kMs_abi_cdecl] = ACTIONS(1202),
    [sym_kSaveregisters] = ACTIONS(1202),
    [sym_kSysv_abi_default] = ACTIONS(1202),
    [sym_kSysv_abi_cdecl] = ACTIONS(1202),
    [sym_kVectorcall] = ACTIONS(1202),
    [sym_kVarargs] = ACTIONS(1202),
    [sym_kWinapi] = ACTIONS(1202),
    [sym_kAlias] = ACTIONS(1202),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(446),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [aux_sym_type_token1] = ACTIONS(1458),
    [sym_kUses] = ACTIONS(1458),
    [sym_kBegin] = ACTIONS(1458),
    [sym_kAsm] = ACTIONS(1458),
    [sym_kVar] = ACTIONS(1460),
    [sym_kThreadvar] = ACTIONS(1458),
    [sym_kConst] = ACTIONS(1460),
    [sym_kResourcestring] = ACTIONS(1458),
    [sym_kType] = ACTIONS(1458),
    [sym_kLabel] = ACTIONS(1458),
    [sym_kExports] = ACTIONS(1458),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1458),
    [sym_kGeneric] = ACTIONS(1458),
    [sym_kFunction] = ACTIONS(1458),
    [sym_kProcedure] = ACTIONS(1458),
    [sym_kConstructor] = ACTIONS(1458),
    [sym_kDestructor] = ACTIONS(1458),
    [sym_kOperator] = ACTIONS(1458),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1458),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1458),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [aux_sym_type_token1] = ACTIONS(1196),
    [sym_kUses] = ACTIONS(1196),
    [sym_kBegin] = ACTIONS(1196),
    [sym_kAsm] = ACTIONS(1196),
    [sym_kVar] = ACTIONS(1198),
    [sym_kThreadvar] = ACTIONS(1196),
    [sym_kConst] = ACTIONS(1198),
    [sym_kResourcestring] = ACTIONS(1196),
    [sym_kType] = ACTIONS(1196),
    [sym_kLabel] = ACTIONS(1196),
    [sym_kExports] = ACTIONS(1196),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1196),
    [sym_kGeneric] = ACTIONS(1196),
    [sym_kFunction] = ACTIONS(1196),
    [sym_kProcedure] = ACTIONS(1196),
    [sym_kConstructor] = ACTIONS(1196),
    [sym_kDestructor] = ACTIONS(1196),
    [sym_kOperator] = ACTIONS(1196),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1196),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1196),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(414),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [aux_sym_type_token1] = ACTIONS(1182),
    [sym_kUses] = ACTIONS(1182),
    [sym_kBegin] = ACTIONS(1182),
    [sym_kAsm] = ACTIONS(1182),
    [sym_kVar] = ACTIONS(1184),
    [sym_kThreadvar] = ACTIONS(1182),
    [sym_kConst] = ACTIONS(1184),
    [sym_kResourcestring] = ACTIONS(1182),
    [sym_kType] = ACTIONS(1182),
    [sym_kLabel] = ACTIONS(1182),
    [sym_kExports] = ACTIONS(1182),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1182),
    [sym_kGeneric] = ACTIONS(1182),
    [sym_kFunction] = ACTIONS(1182),
    [sym_kProcedure] = ACTIONS(1182),
    [sym_kConstructor] = ACTIONS(1182),
    [sym_kDestructor] = ACTIONS(1182),
    [sym_kOperator] = ACTIONS(1182),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1182),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1182),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(415),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [aux_sym_type_token1] = ACTIONS(1132),
    [sym_kUses] = ACTIONS(1132),
    [sym_kBegin] = ACTIONS(1132),
    [sym_kAsm] = ACTIONS(1132),
    [sym_kVar] = ACTIONS(1134),
    [sym_kThreadvar] = ACTIONS(1132),
    [sym_kConst] = ACTIONS(1134),
    [sym_kResourcestring] = ACTIONS(1132),
    [sym_kType] = ACTIONS(1132),
    [sym_kLabel] = ACTIONS(1132),
    [sym_kExports] = ACTIONS(1132),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1132),
    [sym_kGeneric] = ACTIONS(1132),
    [sym_kFunction] = ACTIONS(1132),
    [sym_kProcedure] = ACTIONS(1132),
    [sym_kConstructor] = ACTIONS(1132),
    [sym_kDestructor] = ACTIONS(1132),
    [sym_kOperator] = ACTIONS(1132),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1132),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1132),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [aux_sym_type_token1] = ACTIONS(1451),
    [sym_kUses] = ACTIONS(1451),
    [sym_kBegin] = ACTIONS(1451),
    [sym_kAsm] = ACTIONS(1451),
    [sym_kVar] = ACTIONS(1453),
    [sym_kThreadvar] = ACTIONS(1451),
    [sym_kConst] = ACTIONS(1453),
    [sym_kResourcestring] = ACTIONS(1451),
    [sym_kType] = ACTIONS(1451),
    [sym_kLabel] = ACTIONS(1451),
    [sym_kExports] = ACTIONS(1451),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1451),
    [sym_kGeneric] = ACTIONS(1451),
    [sym_kFunction] = ACTIONS(1451),
    [sym_kProcedure] = ACTIONS(1451),
    [sym_kConstructor] = ACTIONS(1451),
    [sym_kDestructor] = ACTIONS(1451),
    [sym_kOperator] = ACTIONS(1451),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1451),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1451),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [aux_sym_type_token1] = ACTIONS(1444),
    [sym_kUses] = ACTIONS(1444),
    [sym_kBegin] = ACTIONS(1444),
    [sym_kAsm] = ACTIONS(1444),
    [sym_kVar] = ACTIONS(1446),
    [sym_kThreadvar] = ACTIONS(1444),
    [sym_kConst] = ACTIONS(1446),
    [sym_kResourcestring] = ACTIONS(1444),
    [sym_kType] = ACTIONS(1444),
    [sym_kLabel] = ACTIONS(1444),
    [sym_kExports] = ACTIONS(1444),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1444),
    [sym_kGeneric] = ACTIONS(1444),
    [sym_kFunction] = ACTIONS(1444),
    [sym_kProcedure] = ACTIONS(1444),
    [sym_kConstructor] = ACTIONS(1444),
    [sym_kDestructor] = ACTIONS(1444),
    [sym_kOperator] = ACTIONS(1444),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1444),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1444),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(432),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [aux_sym_type_token1] = ACTIONS(1437),
    [sym_kUses] = ACTIONS(1437),
    [sym_kBegin] = ACTIONS(1437),
    [sym_kAsm] = ACTIONS(1437),
    [sym_kVar] = ACTIONS(1439),
    [sym_kThreadvar] = ACTIONS(1437),
    [sym_kConst] = ACTIONS(1439),
    [sym_kResourcestring] = ACTIONS(1437),
    [sym_kType] = ACTIONS(1437),
    [sym_kLabel] = ACTIONS(1437),
    [sym_kExports] = ACTIONS(1437),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1437),
    [sym_kGeneric] = ACTIONS(1437),
    [sym_kFunction] = ACTIONS(1437),
    [sym_kProcedure] = ACTIONS(1437),
    [sym_kConstructor] = ACTIONS(1437),
    [sym_kDestructor] = ACTIONS(1437),
    [sym_kOperator] = ACTIONS(1437),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1437),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1437),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [sym_kEnd] = ACTIONS(1213),
    [sym_kVar] = ACTIONS(1213),
    [sym_kThreadvar] = ACTIONS(1213),
    [sym_kConst] = ACTIONS(1213),
    [sym_kResourcestring] = ACTIONS(1213),
    [sym_kType] = ACTIONS(1213),
    [sym_kProperty] = ACTIONS(1213),
    [sym_kDefault] = ACTIONS(1213),
    [sym_kNodefault] = ACTIONS(1213),
    [sym_kClass] = ACTIONS(1213),
    [sym_kGeneric] = ACTIONS(1213),
    [sym_kCase] = ACTIONS(1213),
    [sym_kFunction] = ACTIONS(1213),
    [sym_kProcedure] = ACTIONS(1213),
    [sym_kConstructor] = ACTIONS(1213),
    [sym_kDestructor] = ACTIONS(1213),
    [sym_kOperator] = ACTIONS(1213),
    [sym_kPublished] = ACTIONS(1213),
    [sym_kPublic] = ACTIONS(1213),
    [sym_kProtected] = ACTIONS(1213),
    [sym_kPrivate] = ACTIONS(1213),
    [sym_kStrict] = ACTIONS(1213),
    [sym_kRequired] = ACTIONS(1213),
    [sym_kOptional] = ACTIONS(1213),
    [sym_kStatic] = ACTIONS(1213),
    [sym_kVirtual] = ACTIONS(1213),
    [sym_kAbstract] = ACTIONS(1213),
    [sym_kDynamic] = ACTIONS(1213),
    [sym_kOverride] = ACTIONS(1213),
    [sym_kOverload] = ACTIONS(1213),
    [sym_kReintroduce] = ACTIONS(1213),
    [sym_kInline] = ACTIONS(1213),
    [sym_kStdcall] = ACTIONS(1213),
    [sym_kCdecl] = ACTIONS(1213),
    [sym_kCppdecl] = ACTIONS(1213),
    [sym_kPascal] = ACTIONS(1213),
    [sym_kRegister] = ACTIONS(1213),
    [sym_kMwpascal] = ACTIONS(1213),
    [sym_kExternal] = ACTIONS(1213),
    [sym_kMessage] = ACTIONS(1213),
    [sym_kDeprecated] = ACTIONS(1213),
    [sym_kExperimental] = ACTIONS(1213),
    [sym_kPlatform] = ACTIONS(1213),
    [sym_kUnimplemented] = ACTIONS(1213),
    [sym_kCvar] = ACTIONS(1213),
    [sym_kExport] = ACTIONS(1213),
    [sym_kFar] = ACTIONS(1213),
    [sym_kNear] = ACTIONS(1213),
    [sym_kSafecall] = ACTIONS(1213),
    [sym_kAssembler] = ACTIONS(1213),
    [sym_kNostackframe] = ACTIONS(1213),
    [sym_kInterrupt] = ACTIONS(1213),
    [sym_kNoreturn] = ACTIONS(1213),
    [sym_kIocheck] = ACTIONS(1213),
    [sym_kLocal] = ACTIONS(1213),
    [sym_kHardfloat] = ACTIONS(1213),
    [sym_kSoftfloat] = ACTIONS(1213),
    [sym_kMs_abi_default] = ACTIONS(1213),
    [sym_kMs_abi_cdecl] = ACTIONS(1213),
    [sym_kSaveregisters] = ACTIONS(1213),
    [sym_kSysv_abi_default] = ACTIONS(1213),
    [sym_kSysv_abi_cdecl] = ACTIONS(1213),
    [sym_kVectorcall] = ACTIONS(1213),
    [sym_kVarargs] = ACTIONS(1213),
    [sym_kWinapi] = ACTIONS(1213),
    [sym_kAlias] = ACTIONS(1213),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2650),
    [aux_sym_type_token1] = ACTIONS(1247),
    [sym_kUses] = ACTIONS(1247),
    [sym_kBegin] = ACTIONS(1247),
    [sym_kAsm] = ACTIONS(1247),
    [sym_kVar] = ACTIONS(1249),
    [sym_kThreadvar] = ACTIONS(1247),
    [sym_kConst] = ACTIONS(1249),
    [sym_kResourcestring] = ACTIONS(1247),
    [sym_kType] = ACTIONS(1247),
    [sym_kLabel] = ACTIONS(1247),
    [sym_kExports] = ACTIONS(1247),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1247),
    [sym_kGeneric] = ACTIONS(1247),
    [sym_kFunction] = ACTIONS(1247),
    [sym_kProcedure] = ACTIONS(1247),
    [sym_kConstructor] = ACTIONS(1247),
    [sym_kDestructor] = ACTIONS(1247),
    [sym_kOperator] = ACTIONS(1247),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1247),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1247),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_identifier] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(700),
    [sym_kEnd] = ACTIONS(702),
    [sym_kVar] = ACTIONS(702),
    [sym_kThreadvar] = ACTIONS(702),
    [sym_kConst] = ACTIONS(702),
    [sym_kResourcestring] = ACTIONS(702),
    [sym_kType] = ACTIONS(702),
    [sym_kProperty] = ACTIONS(702),
    [sym_kDefault] = ACTIONS(702),
    [sym_kNodefault] = ACTIONS(702),
    [sym_kClass] = ACTIONS(702),
    [sym_kGeneric] = ACTIONS(702),
    [sym_kCase] = ACTIONS(702),
    [sym_kFunction] = ACTIONS(702),
    [sym_kProcedure] = ACTIONS(702),
    [sym_kConstructor] = ACTIONS(702),
    [sym_kDestructor] = ACTIONS(702),
    [sym_kOperator] = ACTIONS(702),
    [sym_kPublished] = ACTIONS(702),
    [sym_kPublic] = ACTIONS(702),
    [sym_kProtected] = ACTIONS(702),
    [sym_kPrivate] = ACTIONS(702),
    [sym_kStrict] = ACTIONS(702),
    [sym_kRequired] = ACTIONS(702),
    [sym_kOptional] = ACTIONS(702),
    [sym_kStatic] = ACTIONS(702),
    [sym_kVirtual] = ACTIONS(702),
    [sym_kAbstract] = ACTIONS(702),
    [sym_kDynamic] = ACTIONS(702),
    [sym_kOverride] = ACTIONS(702),
    [sym_kOverload] = ACTIONS(702),
    [sym_kReintroduce] = ACTIONS(702),
    [sym_kInline] = ACTIONS(702),
    [sym_kStdcall] = ACTIONS(702),
    [sym_kCdecl] = ACTIONS(702),
    [sym_kCppdecl] = ACTIONS(702),
    [sym_kPascal] = ACTIONS(702),
    [sym_kRegister] = ACTIONS(702),
    [sym_kMwpascal] = ACTIONS(702),
    [sym_kExternal] = ACTIONS(702),
    [sym_kMessage] = ACTIONS(702),
    [sym_kDeprecated] = ACTIONS(702),
    [sym_kExperimental] = ACTIONS(702),
    [sym_kPlatform] = ACTIONS(702),
    [sym_kUnimplemented] = ACTIONS(702),
    [sym_kCvar] = ACTIONS(702),
    [sym_kExport] = ACTIONS(702),
    [sym_kFar] = ACTIONS(702),
    [sym_kNear] = ACTIONS(702),
    [sym_kSafecall] = ACTIONS(702),
    [sym_kAssembler] = ACTIONS(702),
    [sym_kNostackframe] = ACTIONS(702),
    [sym_kInterrupt] = ACTIONS(702),
    [sym_kNoreturn] = ACTIONS(702),
    [sym_kIocheck] = ACTIONS(702),
    [sym_kLocal] = ACTIONS(702),
    [sym_kHardfloat] = ACTIONS(702),
    [sym_kSoftfloat] = ACTIONS(702),
    [sym_kMs_abi_default] = ACTIONS(702),
    [sym_kMs_abi_cdecl] = ACTIONS(702),
    [sym_kSaveregisters] = ACTIONS(702),
    [sym_kSysv_abi_default] = ACTIONS(702),
    [sym_kSysv_abi_cdecl] = ACTIONS(702),
    [sym_kVectorcall] = ACTIONS(702),
    [sym_kVarargs] = ACTIONS(702),
    [sym_kWinapi] = ACTIONS(702),
    [sym_kAlias] = ACTIONS(702),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(411),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [aux_sym_type_token1] = ACTIONS(1240),
    [sym_kUses] = ACTIONS(1240),
    [sym_kBegin] = ACTIONS(1240),
    [sym_kAsm] = ACTIONS(1240),
    [sym_kVar] = ACTIONS(1242),
    [sym_kThreadvar] = ACTIONS(1240),
    [sym_kConst] = ACTIONS(1242),
    [sym_kResourcestring] = ACTIONS(1240),
    [sym_kType] = ACTIONS(1240),
    [sym_kLabel] = ACTIONS(1240),
    [sym_kExports] = ACTIONS(1240),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1240),
    [sym_kGeneric] = ACTIONS(1240),
    [sym_kFunction] = ACTIONS(1240),
    [sym_kProcedure] = ACTIONS(1240),
    [sym_kConstructor] = ACTIONS(1240),
    [sym_kDestructor] = ACTIONS(1240),
    [sym_kOperator] = ACTIONS(1240),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1240),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1240),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(429),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [aux_sym_type_token1] = ACTIONS(1076),
    [sym_kUses] = ACTIONS(1076),
    [sym_kBegin] = ACTIONS(1076),
    [sym_kAsm] = ACTIONS(1076),
    [sym_kVar] = ACTIONS(1078),
    [sym_kThreadvar] = ACTIONS(1076),
    [sym_kConst] = ACTIONS(1078),
    [sym_kResourcestring] = ACTIONS(1076),
    [sym_kType] = ACTIONS(1076),
    [sym_kLabel] = ACTIONS(1076),
    [sym_kExports] = ACTIONS(1076),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1076),
    [sym_kGeneric] = ACTIONS(1076),
    [sym_kFunction] = ACTIONS(1076),
    [sym_kProcedure] = ACTIONS(1076),
    [sym_kConstructor] = ACTIONS(1076),
    [sym_kDestructor] = ACTIONS(1076),
    [sym_kOperator] = ACTIONS(1076),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1076),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1076),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(440),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [aux_sym_type_token1] = ACTIONS(1346),
    [sym_kUses] = ACTIONS(1346),
    [sym_kBegin] = ACTIONS(1346),
    [sym_kAsm] = ACTIONS(1346),
    [sym_kVar] = ACTIONS(1348),
    [sym_kThreadvar] = ACTIONS(1346),
    [sym_kConst] = ACTIONS(1348),
    [sym_kResourcestring] = ACTIONS(1346),
    [sym_kType] = ACTIONS(1346),
    [sym_kLabel] = ACTIONS(1346),
    [sym_kExports] = ACTIONS(1346),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1346),
    [sym_kGeneric] = ACTIONS(1346),
    [sym_kFunction] = ACTIONS(1346),
    [sym_kProcedure] = ACTIONS(1346),
    [sym_kConstructor] = ACTIONS(1346),
    [sym_kDestructor] = ACTIONS(1346),
    [sym_kOperator] = ACTIONS(1346),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1346),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1346),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2662),
    [aux_sym_type_token1] = ACTIONS(1318),
    [sym_kUses] = ACTIONS(1318),
    [sym_kBegin] = ACTIONS(1318),
    [sym_kAsm] = ACTIONS(1318),
    [sym_kVar] = ACTIONS(1320),
    [sym_kThreadvar] = ACTIONS(1318),
    [sym_kConst] = ACTIONS(1320),
    [sym_kResourcestring] = ACTIONS(1318),
    [sym_kType] = ACTIONS(1318),
    [sym_kLabel] = ACTIONS(1318),
    [sym_kExports] = ACTIONS(1318),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1318),
    [sym_kGeneric] = ACTIONS(1318),
    [sym_kFunction] = ACTIONS(1318),
    [sym_kProcedure] = ACTIONS(1318),
    [sym_kConstructor] = ACTIONS(1318),
    [sym_kDestructor] = ACTIONS(1318),
    [sym_kOperator] = ACTIONS(1318),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1318),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1318),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [aux_sym_type_token1] = ACTIONS(1423),
    [sym_kUses] = ACTIONS(1423),
    [sym_kBegin] = ACTIONS(1423),
    [sym_kAsm] = ACTIONS(1423),
    [sym_kVar] = ACTIONS(1425),
    [sym_kThreadvar] = ACTIONS(1423),
    [sym_kConst] = ACTIONS(1425),
    [sym_kResourcestring] = ACTIONS(1423),
    [sym_kType] = ACTIONS(1423),
    [sym_kLabel] = ACTIONS(1423),
    [sym_kExports] = ACTIONS(1423),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1423),
    [sym_kGeneric] = ACTIONS(1423),
    [sym_kFunction] = ACTIONS(1423),
    [sym_kProcedure] = ACTIONS(1423),
    [sym_kConstructor] = ACTIONS(1423),
    [sym_kDestructor] = ACTIONS(1423),
    [sym_kOperator] = ACTIONS(1423),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1423),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1423),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(459),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [aux_sym_type_token1] = ACTIONS(1402),
    [sym_kUses] = ACTIONS(1402),
    [sym_kBegin] = ACTIONS(1402),
    [sym_kAsm] = ACTIONS(1402),
    [sym_kVar] = ACTIONS(1404),
    [sym_kThreadvar] = ACTIONS(1402),
    [sym_kConst] = ACTIONS(1404),
    [sym_kResourcestring] = ACTIONS(1402),
    [sym_kType] = ACTIONS(1402),
    [sym_kLabel] = ACTIONS(1402),
    [sym_kExports] = ACTIONS(1402),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1402),
    [sym_kGeneric] = ACTIONS(1402),
    [sym_kFunction] = ACTIONS(1402),
    [sym_kProcedure] = ACTIONS(1402),
    [sym_kConstructor] = ACTIONS(1402),
    [sym_kDestructor] = ACTIONS(1402),
    [sym_kOperator] = ACTIONS(1402),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1402),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1402),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(460),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [aux_sym_type_token1] = ACTIONS(1388),
    [sym_kUses] = ACTIONS(1388),
    [sym_kBegin] = ACTIONS(1388),
    [sym_kAsm] = ACTIONS(1388),
    [sym_kVar] = ACTIONS(1390),
    [sym_kThreadvar] = ACTIONS(1388),
    [sym_kConst] = ACTIONS(1390),
    [sym_kResourcestring] = ACTIONS(1388),
    [sym_kType] = ACTIONS(1388),
    [sym_kLabel] = ACTIONS(1388),
    [sym_kExports] = ACTIONS(1388),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1388),
    [sym_kGeneric] = ACTIONS(1388),
    [sym_kFunction] = ACTIONS(1388),
    [sym_kProcedure] = ACTIONS(1388),
    [sym_kConstructor] = ACTIONS(1388),
    [sym_kDestructor] = ACTIONS(1388),
    [sym_kOperator] = ACTIONS(1388),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1388),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1388),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(447),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [aux_sym_type_token1] = ACTIONS(1311),
    [sym_kUses] = ACTIONS(1311),
    [sym_kBegin] = ACTIONS(1311),
    [sym_kAsm] = ACTIONS(1311),
    [sym_kVar] = ACTIONS(1313),
    [sym_kThreadvar] = ACTIONS(1311),
    [sym_kConst] = ACTIONS(1313),
    [sym_kResourcestring] = ACTIONS(1311),
    [sym_kType] = ACTIONS(1311),
    [sym_kLabel] = ACTIONS(1311),
    [sym_kExports] = ACTIONS(1311),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1311),
    [sym_kGeneric] = ACTIONS(1311),
    [sym_kFunction] = ACTIONS(1311),
    [sym_kProcedure] = ACTIONS(1311),
    [sym_kConstructor] = ACTIONS(1311),
    [sym_kDestructor] = ACTIONS(1311),
    [sym_kOperator] = ACTIONS(1311),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1311),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1311),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [aux_sym_type_token1] = ACTIONS(1339),
    [sym_kUses] = ACTIONS(1339),
    [sym_kBegin] = ACTIONS(1339),
    [sym_kAsm] = ACTIONS(1339),
    [sym_kVar] = ACTIONS(1341),
    [sym_kThreadvar] = ACTIONS(1339),
    [sym_kConst] = ACTIONS(1341),
    [sym_kResourcestring] = ACTIONS(1339),
    [sym_kType] = ACTIONS(1339),
    [sym_kLabel] = ACTIONS(1339),
    [sym_kExports] = ACTIONS(1339),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1339),
    [sym_kGeneric] = ACTIONS(1339),
    [sym_kFunction] = ACTIONS(1339),
    [sym_kProcedure] = ACTIONS(1339),
    [sym_kConstructor] = ACTIONS(1339),
    [sym_kDestructor] = ACTIONS(1339),
    [sym_kOperator] = ACTIONS(1339),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1339),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1339),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [aux_sym_type_token1] = ACTIONS(1175),
    [sym_kUses] = ACTIONS(1175),
    [sym_kBegin] = ACTIONS(1175),
    [sym_kAsm] = ACTIONS(1175),
    [sym_kVar] = ACTIONS(1177),
    [sym_kThreadvar] = ACTIONS(1175),
    [sym_kConst] = ACTIONS(1177),
    [sym_kResourcestring] = ACTIONS(1175),
    [sym_kType] = ACTIONS(1175),
    [sym_kLabel] = ACTIONS(1175),
    [sym_kExports] = ACTIONS(1175),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1175),
    [sym_kGeneric] = ACTIONS(1175),
    [sym_kFunction] = ACTIONS(1175),
    [sym_kProcedure] = ACTIONS(1175),
    [sym_kConstructor] = ACTIONS(1175),
    [sym_kDestructor] = ACTIONS(1175),
    [sym_kOperator] = ACTIONS(1175),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1175),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1175),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_kUses] = ACTIONS(2683),
    [sym_kInterface] = ACTIONS(2683),
    [sym_kImplementation] = ACTIONS(2683),
    [sym_kInitialization] = ACTIONS(2683),
    [sym_kFinalization] = ACTIONS(2683),
    [sym_kEnd] = ACTIONS(2683),
    [sym_kVar] = ACTIONS(2685),
    [sym_kThreadvar] = ACTIONS(2683),
    [sym_kConst] = ACTIONS(2685),
    [sym_kResourcestring] = ACTIONS(2683),
    [sym_kType] = ACTIONS(2683),
    [sym_kLabel] = ACTIONS(2683),
    [sym_kExports] = ACTIONS(2683),
    [sym_kProperty] = ACTIONS(2683),
    [sym_kDefault] = ACTIONS(2683),
    [sym_kNodefault] = ACTIONS(2683),
    [sym_kClass] = ACTIONS(2683),
    [sym_kGeneric] = ACTIONS(2683),
    [sym_kFunction] = ACTIONS(2683),
    [sym_kProcedure] = ACTIONS(2683),
    [sym_kConstructor] = ACTIONS(2683),
    [sym_kDestructor] = ACTIONS(2683),
    [sym_kOperator] = ACTIONS(2683),
    [sym_kPublic] = ACTIONS(2683),
    [sym_kForward] = ACTIONS(2683),
    [sym_kStatic] = ACTIONS(2683),
    [sym_kVirtual] = ACTIONS(2683),
    [sym_kAbstract] = ACTIONS(2683),
    [sym_kDynamic] = ACTIONS(2683),
    [sym_kOverride] = ACTIONS(2683),
    [sym_kOverload] = ACTIONS(2683),
    [sym_kReintroduce] = ACTIONS(2683),
    [sym_kInline] = ACTIONS(2683),
    [sym_kStdcall] = ACTIONS(2683),
    [sym_kCdecl] = ACTIONS(2683),
    [sym_kCppdecl] = ACTIONS(2683),
    [sym_kPascal] = ACTIONS(2683),
    [sym_kRegister] = ACTIONS(2683),
    [sym_kMwpascal] = ACTIONS(2683),
    [sym_kExternal] = ACTIONS(2683),
    [sym_kMessage] = ACTIONS(2683),
    [sym_kDeprecated] = ACTIONS(2683),
    [sym_kExperimental] = ACTIONS(2683),
    [sym_kPlatform] = ACTIONS(2683),
    [sym_kUnimplemented] = ACTIONS(2683),
    [sym_kCvar] = ACTIONS(2683),
    [sym_kExport] = ACTIONS(2685),
    [sym_kFar] = ACTIONS(2683),
    [sym_kNear] = ACTIONS(2683),
    [sym_kSafecall] = ACTIONS(2683),
    [sym_kAssembler] = ACTIONS(2683),
    [sym_kNostackframe] = ACTIONS(2683),
    [sym_kInterrupt] = ACTIONS(2683),
    [sym_kNoreturn] = ACTIONS(2683),
    [sym_kIocheck] = ACTIONS(2683),
    [sym_kLocal] = ACTIONS(2683),
    [sym_kHardfloat] = ACTIONS(2683),
    [sym_kSoftfloat] = ACTIONS(2683),
    [sym_kMs_abi_default] = ACTIONS(2683),
    [sym_kMs_abi_cdecl] = ACTIONS(2683),
    [sym_kSaveregisters] = ACTIONS(2683),
    [sym_kSysv_abi_default] = ACTIONS(2683),
    [sym_kSysv_abi_cdecl] = ACTIONS(2683),
    [sym_kVectorcall] = ACTIONS(2683),
    [sym_kVarargs] = ACTIONS(2683),
    [sym_kWinapi] = ACTIONS(2683),
    [sym_kAlias] = ACTIONS(2683),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [anon_sym_LBRACK] = ACTIONS(2687),
    [sym_kUses] = ACTIONS(2687),
    [sym_kInterface] = ACTIONS(2687),
    [sym_kImplementation] = ACTIONS(2687),
    [sym_kInitialization] = ACTIONS(2687),
    [sym_kFinalization] = ACTIONS(2687),
    [sym_kEnd] = ACTIONS(2687),
    [sym_kVar] = ACTIONS(2689),
    [sym_kThreadvar] = ACTIONS(2687),
    [sym_kConst] = ACTIONS(2689),
    [sym_kResourcestring] = ACTIONS(2687),
    [sym_kType] = ACTIONS(2687),
    [sym_kLabel] = ACTIONS(2687),
    [sym_kExports] = ACTIONS(2687),
    [sym_kProperty] = ACTIONS(2687),
    [sym_kDefault] = ACTIONS(2687),
    [sym_kNodefault] = ACTIONS(2687),
    [sym_kClass] = ACTIONS(2687),
    [sym_kGeneric] = ACTIONS(2687),
    [sym_kFunction] = ACTIONS(2687),
    [sym_kProcedure] = ACTIONS(2687),
    [sym_kConstructor] = ACTIONS(2687),
    [sym_kDestructor] = ACTIONS(2687),
    [sym_kOperator] = ACTIONS(2687),
    [sym_kPublic] = ACTIONS(2687),
    [sym_kForward] = ACTIONS(2687),
    [sym_kStatic] = ACTIONS(2687),
    [sym_kVirtual] = ACTIONS(2687),
    [sym_kAbstract] = ACTIONS(2687),
    [sym_kDynamic] = ACTIONS(2687),
    [sym_kOverride] = ACTIONS(2687),
    [sym_kOverload] = ACTIONS(2687),
    [sym_kReintroduce] = ACTIONS(2687),
    [sym_kInline] = ACTIONS(2687),
    [sym_kStdcall] = ACTIONS(2687),
    [sym_kCdecl] = ACTIONS(2687),
    [sym_kCppdecl] = ACTIONS(2687),
    [sym_kPascal] = ACTIONS(2687),
    [sym_kRegister] = ACTIONS(2687),
    [sym_kMwpascal] = ACTIONS(2687),
    [sym_kExternal] = ACTIONS(2687),
    [sym_kMessage] = ACTIONS(2687),
    [sym_kDeprecated] = ACTIONS(2687),
    [sym_kExperimental] = ACTIONS(2687),
    [sym_kPlatform] = ACTIONS(2687),
    [sym_kUnimplemented] = ACTIONS(2687),
    [sym_kCvar] = ACTIONS(2687),
    [sym_kExport] = ACTIONS(2689),
    [sym_kFar] = ACTIONS(2687),
    [sym_kNear] = ACTIONS(2687),
    [sym_kSafecall] = ACTIONS(2687),
    [sym_kAssembler] = ACTIONS(2687),
    [sym_kNostackframe] = ACTIONS(2687),
    [sym_kInterrupt] = ACTIONS(2687),
    [sym_kNoreturn] = ACTIONS(2687),
    [sym_kIocheck] = ACTIONS(2687),
    [sym_kLocal] = ACTIONS(2687),
    [sym_kHardfloat] = ACTIONS(2687),
    [sym_kSoftfloat] = ACTIONS(2687),
    [sym_kMs_abi_default] = ACTIONS(2687),
    [sym_kMs_abi_cdecl] = ACTIONS(2687),
    [sym_kSaveregisters] = ACTIONS(2687),
    [sym_kSysv_abi_default] = ACTIONS(2687),
    [sym_kSysv_abi_cdecl] = ACTIONS(2687),
    [sym_kVectorcall] = ACTIONS(2687),
    [sym_kVarargs] = ACTIONS(2687),
    [sym_kWinapi] = ACTIONS(2687),
    [sym_kAlias] = ACTIONS(2687),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [aux_sym_type_token1] = ACTIONS(1097),
    [sym_kUses] = ACTIONS(1097),
    [sym_kBegin] = ACTIONS(1097),
    [sym_kAsm] = ACTIONS(1097),
    [sym_kVar] = ACTIONS(1099),
    [sym_kThreadvar] = ACTIONS(1097),
    [sym_kConst] = ACTIONS(1099),
    [sym_kResourcestring] = ACTIONS(1097),
    [sym_kType] = ACTIONS(1097),
    [sym_kLabel] = ACTIONS(1097),
    [sym_kExports] = ACTIONS(1097),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1097),
    [sym_kGeneric] = ACTIONS(1097),
    [sym_kFunction] = ACTIONS(1097),
    [sym_kProcedure] = ACTIONS(1097),
    [sym_kConstructor] = ACTIONS(1097),
    [sym_kDestructor] = ACTIONS(1097),
    [sym_kOperator] = ACTIONS(1097),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1097),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1097),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [aux_sym_type_token1] = ACTIONS(1325),
    [sym_kUses] = ACTIONS(1325),
    [sym_kBegin] = ACTIONS(1325),
    [sym_kAsm] = ACTIONS(1325),
    [sym_kVar] = ACTIONS(1327),
    [sym_kThreadvar] = ACTIONS(1325),
    [sym_kConst] = ACTIONS(1327),
    [sym_kResourcestring] = ACTIONS(1325),
    [sym_kType] = ACTIONS(1325),
    [sym_kLabel] = ACTIONS(1325),
    [sym_kExports] = ACTIONS(1325),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1325),
    [sym_kGeneric] = ACTIONS(1325),
    [sym_kFunction] = ACTIONS(1325),
    [sym_kProcedure] = ACTIONS(1325),
    [sym_kConstructor] = ACTIONS(1325),
    [sym_kDestructor] = ACTIONS(1325),
    [sym_kOperator] = ACTIONS(1325),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1325),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1325),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(424),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [aux_sym_type_token1] = ACTIONS(1083),
    [sym_kUses] = ACTIONS(1083),
    [sym_kBegin] = ACTIONS(1083),
    [sym_kAsm] = ACTIONS(1083),
    [sym_kVar] = ACTIONS(1085),
    [sym_kThreadvar] = ACTIONS(1083),
    [sym_kConst] = ACTIONS(1085),
    [sym_kResourcestring] = ACTIONS(1083),
    [sym_kType] = ACTIONS(1083),
    [sym_kLabel] = ACTIONS(1083),
    [sym_kExports] = ACTIONS(1083),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1083),
    [sym_kGeneric] = ACTIONS(1083),
    [sym_kFunction] = ACTIONS(1083),
    [sym_kProcedure] = ACTIONS(1083),
    [sym_kConstructor] = ACTIONS(1083),
    [sym_kDestructor] = ACTIONS(1083),
    [sym_kOperator] = ACTIONS(1083),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1083),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1083),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(453),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [aux_sym_type_token1] = ACTIONS(1090),
    [sym_kUses] = ACTIONS(1090),
    [sym_kBegin] = ACTIONS(1090),
    [sym_kAsm] = ACTIONS(1090),
    [sym_kVar] = ACTIONS(1092),
    [sym_kThreadvar] = ACTIONS(1090),
    [sym_kConst] = ACTIONS(1092),
    [sym_kResourcestring] = ACTIONS(1090),
    [sym_kType] = ACTIONS(1090),
    [sym_kLabel] = ACTIONS(1090),
    [sym_kExports] = ACTIONS(1090),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1090),
    [sym_kGeneric] = ACTIONS(1090),
    [sym_kFunction] = ACTIONS(1090),
    [sym_kProcedure] = ACTIONS(1090),
    [sym_kConstructor] = ACTIONS(1090),
    [sym_kDestructor] = ACTIONS(1090),
    [sym_kOperator] = ACTIONS(1090),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1090),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1090),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(450),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [aux_sym_type_token1] = ACTIONS(1254),
    [sym_kUses] = ACTIONS(1254),
    [sym_kBegin] = ACTIONS(1254),
    [sym_kAsm] = ACTIONS(1254),
    [sym_kVar] = ACTIONS(1256),
    [sym_kThreadvar] = ACTIONS(1254),
    [sym_kConst] = ACTIONS(1256),
    [sym_kResourcestring] = ACTIONS(1254),
    [sym_kType] = ACTIONS(1254),
    [sym_kLabel] = ACTIONS(1254),
    [sym_kExports] = ACTIONS(1254),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1254),
    [sym_kGeneric] = ACTIONS(1254),
    [sym_kFunction] = ACTIONS(1254),
    [sym_kProcedure] = ACTIONS(1254),
    [sym_kConstructor] = ACTIONS(1254),
    [sym_kDestructor] = ACTIONS(1254),
    [sym_kOperator] = ACTIONS(1254),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1254),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1254),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [anon_sym_LBRACK] = ACTIONS(2706),
    [sym_kUses] = ACTIONS(2706),
    [sym_kInterface] = ACTIONS(2706),
    [sym_kImplementation] = ACTIONS(2706),
    [sym_kInitialization] = ACTIONS(2706),
    [sym_kFinalization] = ACTIONS(2706),
    [sym_kEnd] = ACTIONS(2706),
    [sym_kVar] = ACTIONS(2708),
    [sym_kThreadvar] = ACTIONS(2706),
    [sym_kConst] = ACTIONS(2708),
    [sym_kResourcestring] = ACTIONS(2706),
    [sym_kType] = ACTIONS(2706),
    [sym_kLabel] = ACTIONS(2706),
    [sym_kExports] = ACTIONS(2706),
    [sym_kProperty] = ACTIONS(2706),
    [sym_kDefault] = ACTIONS(2706),
    [sym_kNodefault] = ACTIONS(2706),
    [sym_kClass] = ACTIONS(2706),
    [sym_kGeneric] = ACTIONS(2706),
    [sym_kFunction] = ACTIONS(2706),
    [sym_kProcedure] = ACTIONS(2706),
    [sym_kConstructor] = ACTIONS(2706),
    [sym_kDestructor] = ACTIONS(2706),
    [sym_kOperator] = ACTIONS(2706),
    [sym_kPublic] = ACTIONS(2706),
    [sym_kForward] = ACTIONS(2706),
    [sym_kStatic] = ACTIONS(2706),
    [sym_kVirtual] = ACTIONS(2706),
    [sym_kAbstract] = ACTIONS(2706),
    [sym_kDynamic] = ACTIONS(2706),
    [sym_kOverride] = ACTIONS(2706),
    [sym_kOverload] = ACTIONS(2706),
    [sym_kReintroduce] = ACTIONS(2706),
    [sym_kInline] = ACTIONS(2706),
    [sym_kStdcall] = ACTIONS(2706),
    [sym_kCdecl] = ACTIONS(2706),
    [sym_kCppdecl] = ACTIONS(2706),
    [sym_kPascal] = ACTIONS(2706),
    [sym_kRegister] = ACTIONS(2706),
    [sym_kMwpascal] = ACTIONS(2706),
    [sym_kExternal] = ACTIONS(2706),
    [sym_kMessage] = ACTIONS(2706),
    [sym_kDeprecated] = ACTIONS(2706),
    [sym_kExperimental] = ACTIONS(2706),
    [sym_kPlatform] = ACTIONS(2706),
    [sym_kUnimplemented] = ACTIONS(2706),
    [sym_kCvar] = ACTIONS(2706),
    [sym_kExport] = ACTIONS(2708),
    [sym_kFar] = ACTIONS(2706),
    [sym_kNear] = ACTIONS(2706),
    [sym_kSafecall] = ACTIONS(2706),
    [sym_kAssembler] = ACTIONS(2706),
    [sym_kNostackframe] = ACTIONS(2706),
    [sym_kInterrupt] = ACTIONS(2706),
    [sym_kNoreturn] = ACTIONS(2706),
    [sym_kIocheck] = ACTIONS(2706),
    [sym_kLocal] = ACTIONS(2706),
    [sym_kHardfloat] = ACTIONS(2706),
    [sym_kSoftfloat] = ACTIONS(2706),
    [sym_kMs_abi_default] = ACTIONS(2706),
    [sym_kMs_abi_cdecl] = ACTIONS(2706),
    [sym_kSaveregisters] = ACTIONS(2706),
    [sym_kSysv_abi_default] = ACTIONS(2706),
    [sym_kSysv_abi_cdecl] = ACTIONS(2706),
    [sym_kVectorcall] = ACTIONS(2706),
    [sym_kVarargs] = ACTIONS(2706),
    [sym_kWinapi] = ACTIONS(2706),
    [sym_kAlias] = ACTIONS(2706),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(449),
    [anon_sym_LBRACK] = ACTIONS(2710),
    [aux_sym_type_token1] = ACTIONS(1332),
    [sym_kUses] = ACTIONS(1332),
    [sym_kBegin] = ACTIONS(1332),
    [sym_kAsm] = ACTIONS(1332),
    [sym_kVar] = ACTIONS(1334),
    [sym_kThreadvar] = ACTIONS(1332),
    [sym_kConst] = ACTIONS(1334),
    [sym_kResourcestring] = ACTIONS(1332),
    [sym_kType] = ACTIONS(1332),
    [sym_kLabel] = ACTIONS(1332),
    [sym_kExports] = ACTIONS(1332),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1332),
    [sym_kGeneric] = ACTIONS(1332),
    [sym_kFunction] = ACTIONS(1332),
    [sym_kProcedure] = ACTIONS(1332),
    [sym_kConstructor] = ACTIONS(1332),
    [sym_kDestructor] = ACTIONS(1332),
    [sym_kOperator] = ACTIONS(1332),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1332),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1332),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_identifier] = ACTIONS(677),
    [anon_sym_LBRACK] = ACTIONS(675),
    [sym_kEnd] = ACTIONS(677),
    [sym_kVar] = ACTIONS(677),
    [sym_kThreadvar] = ACTIONS(677),
    [sym_kConst] = ACTIONS(677),
    [sym_kResourcestring] = ACTIONS(677),
    [sym_kType] = ACTIONS(677),
    [sym_kProperty] = ACTIONS(677),
    [sym_kDefault] = ACTIONS(677),
    [sym_kNodefault] = ACTIONS(677),
    [sym_kClass] = ACTIONS(677),
    [sym_kGeneric] = ACTIONS(677),
    [sym_kCase] = ACTIONS(677),
    [sym_kFunction] = ACTIONS(677),
    [sym_kProcedure] = ACTIONS(677),
    [sym_kConstructor] = ACTIONS(677),
    [sym_kDestructor] = ACTIONS(677),
    [sym_kOperator] = ACTIONS(677),
    [sym_kPublished] = ACTIONS(677),
    [sym_kPublic] = ACTIONS(677),
    [sym_kProtected] = ACTIONS(677),
    [sym_kPrivate] = ACTIONS(677),
    [sym_kStrict] = ACTIONS(677),
    [sym_kRequired] = ACTIONS(677),
    [sym_kOptional] = ACTIONS(677),
    [sym_kStatic] = ACTIONS(677),
    [sym_kVirtual] = ACTIONS(677),
    [sym_kAbstract] = ACTIONS(677),
    [sym_kDynamic] = ACTIONS(677),
    [sym_kOverride] = ACTIONS(677),
    [sym_kOverload] = ACTIONS(677),
    [sym_kReintroduce] = ACTIONS(677),
    [sym_kInline] = ACTIONS(677),
    [sym_kStdcall] = ACTIONS(677),
    [sym_kCdecl] = ACTIONS(677),
    [sym_kCppdecl] = ACTIONS(677),
    [sym_kPascal] = ACTIONS(677),
    [sym_kRegister] = ACTIONS(677),
    [sym_kMwpascal] = ACTIONS(677),
    [sym_kExternal] = ACTIONS(677),
    [sym_kMessage] = ACTIONS(677),
    [sym_kDeprecated] = ACTIONS(677),
    [sym_kExperimental] = ACTIONS(677),
    [sym_kPlatform] = ACTIONS(677),
    [sym_kUnimplemented] = ACTIONS(677),
    [sym_kCvar] = ACTIONS(677),
    [sym_kExport] = ACTIONS(677),
    [sym_kFar] = ACTIONS(677),
    [sym_kNear] = ACTIONS(677),
    [sym_kSafecall] = ACTIONS(677),
    [sym_kAssembler] = ACTIONS(677),
    [sym_kNostackframe] = ACTIONS(677),
    [sym_kInterrupt] = ACTIONS(677),
    [sym_kNoreturn] = ACTIONS(677),
    [sym_kIocheck] = ACTIONS(677),
    [sym_kLocal] = ACTIONS(677),
    [sym_kHardfloat] = ACTIONS(677),
    [sym_kSoftfloat] = ACTIONS(677),
    [sym_kMs_abi_default] = ACTIONS(677),
    [sym_kMs_abi_cdecl] = ACTIONS(677),
    [sym_kSaveregisters] = ACTIONS(677),
    [sym_kSysv_abi_default] = ACTIONS(677),
    [sym_kSysv_abi_cdecl] = ACTIONS(677),
    [sym_kVectorcall] = ACTIONS(677),
    [sym_kVarargs] = ACTIONS(677),
    [sym_kWinapi] = ACTIONS(677),
    [sym_kAlias] = ACTIONS(677),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [440] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [aux_sym_type_token1] = ACTIONS(1207),
    [sym_kUses] = ACTIONS(1207),
    [sym_kBegin] = ACTIONS(1207),
    [sym_kAsm] = ACTIONS(1207),
    [sym_kVar] = ACTIONS(1209),
    [sym_kThreadvar] = ACTIONS(1207),
    [sym_kConst] = ACTIONS(1209),
    [sym_kResourcestring] = ACTIONS(1207),
    [sym_kType] = ACTIONS(1207),
    [sym_kLabel] = ACTIONS(1207),
    [sym_kExports] = ACTIONS(1207),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1207),
    [sym_kGeneric] = ACTIONS(1207),
    [sym_kFunction] = ACTIONS(1207),
    [sym_kProcedure] = ACTIONS(1207),
    [sym_kConstructor] = ACTIONS(1207),
    [sym_kDestructor] = ACTIONS(1207),
    [sym_kOperator] = ACTIONS(1207),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1207),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1207),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(448),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [aux_sym_type_token1] = ACTIONS(1279),
    [sym_kUses] = ACTIONS(1279),
    [sym_kBegin] = ACTIONS(1279),
    [sym_kAsm] = ACTIONS(1279),
    [sym_kVar] = ACTIONS(1281),
    [sym_kThreadvar] = ACTIONS(1279),
    [sym_kConst] = ACTIONS(1281),
    [sym_kResourcestring] = ACTIONS(1279),
    [sym_kType] = ACTIONS(1279),
    [sym_kLabel] = ACTIONS(1279),
    [sym_kExports] = ACTIONS(1279),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1279),
    [sym_kGeneric] = ACTIONS(1279),
    [sym_kFunction] = ACTIONS(1279),
    [sym_kProcedure] = ACTIONS(1279),
    [sym_kConstructor] = ACTIONS(1279),
    [sym_kDestructor] = ACTIONS(1279),
    [sym_kOperator] = ACTIONS(1279),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1279),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1279),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [442] = {
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_kEnd] = ACTIONS(1235),
    [sym_kVar] = ACTIONS(1235),
    [sym_kThreadvar] = ACTIONS(1235),
    [sym_kConst] = ACTIONS(1235),
    [sym_kResourcestring] = ACTIONS(1235),
    [sym_kType] = ACTIONS(1235),
    [sym_kProperty] = ACTIONS(1235),
    [sym_kDefault] = ACTIONS(1235),
    [sym_kNodefault] = ACTIONS(1235),
    [sym_kClass] = ACTIONS(1235),
    [sym_kGeneric] = ACTIONS(1235),
    [sym_kCase] = ACTIONS(1235),
    [sym_kFunction] = ACTIONS(1235),
    [sym_kProcedure] = ACTIONS(1235),
    [sym_kConstructor] = ACTIONS(1235),
    [sym_kDestructor] = ACTIONS(1235),
    [sym_kOperator] = ACTIONS(1235),
    [sym_kPublished] = ACTIONS(1235),
    [sym_kPublic] = ACTIONS(1235),
    [sym_kProtected] = ACTIONS(1235),
    [sym_kPrivate] = ACTIONS(1235),
    [sym_kStrict] = ACTIONS(1235),
    [sym_kRequired] = ACTIONS(1235),
    [sym_kOptional] = ACTIONS(1235),
    [sym_kStatic] = ACTIONS(1235),
    [sym_kVirtual] = ACTIONS(1235),
    [sym_kAbstract] = ACTIONS(1235),
    [sym_kDynamic] = ACTIONS(1235),
    [sym_kOverride] = ACTIONS(1235),
    [sym_kOverload] = ACTIONS(1235),
    [sym_kReintroduce] = ACTIONS(1235),
    [sym_kInline] = ACTIONS(1235),
    [sym_kStdcall] = ACTIONS(1235),
    [sym_kCdecl] = ACTIONS(1235),
    [sym_kCppdecl] = ACTIONS(1235),
    [sym_kPascal] = ACTIONS(1235),
    [sym_kRegister] = ACTIONS(1235),
    [sym_kMwpascal] = ACTIONS(1235),
    [sym_kExternal] = ACTIONS(1235),
    [sym_kMessage] = ACTIONS(1235),
    [sym_kDeprecated] = ACTIONS(1235),
    [sym_kExperimental] = ACTIONS(1235),
    [sym_kPlatform] = ACTIONS(1235),
    [sym_kUnimplemented] = ACTIONS(1235),
    [sym_kCvar] = ACTIONS(1235),
    [sym_kExport] = ACTIONS(1235),
    [sym_kFar] = ACTIONS(1235),
    [sym_kNear] = ACTIONS(1235),
    [sym_kSafecall] = ACTIONS(1235),
    [sym_kAssembler] = ACTIONS(1235),
    [sym_kNostackframe] = ACTIONS(1235),
    [sym_kInterrupt] = ACTIONS(1235),
    [sym_kNoreturn] = ACTIONS(1235),
    [sym_kIocheck] = ACTIONS(1235),
    [sym_kLocal] = ACTIONS(1235),
    [sym_kHardfloat] = ACTIONS(1235),
    [sym_kSoftfloat] = ACTIONS(1235),
    [sym_kMs_abi_default] = ACTIONS(1235),
    [sym_kMs_abi_cdecl] = ACTIONS(1235),
    [sym_kSaveregisters] = ACTIONS(1235),
    [sym_kSysv_abi_default] = ACTIONS(1235),
    [sym_kSysv_abi_cdecl] = ACTIONS(1235),
    [sym_kVectorcall] = ACTIONS(1235),
    [sym_kVarargs] = ACTIONS(1235),
    [sym_kWinapi] = ACTIONS(1235),
    [sym_kAlias] = ACTIONS(1235),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [443] = {
    [anon_sym_LBRACK] = ACTIONS(2719),
    [sym_kUses] = ACTIONS(2719),
    [sym_kInterface] = ACTIONS(2719),
    [sym_kImplementation] = ACTIONS(2719),
    [sym_kInitialization] = ACTIONS(2719),
    [sym_kFinalization] = ACTIONS(2719),
    [sym_kEnd] = ACTIONS(2719),
    [sym_kVar] = ACTIONS(2721),
    [sym_kThreadvar] = ACTIONS(2719),
    [sym_kConst] = ACTIONS(2721),
    [sym_kResourcestring] = ACTIONS(2719),
    [sym_kType] = ACTIONS(2719),
    [sym_kLabel] = ACTIONS(2719),
    [sym_kExports] = ACTIONS(2719),
    [sym_kProperty] = ACTIONS(2719),
    [sym_kDefault] = ACTIONS(2719),
    [sym_kNodefault] = ACTIONS(2719),
    [sym_kClass] = ACTIONS(2719),
    [sym_kGeneric] = ACTIONS(2719),
    [sym_kFunction] = ACTIONS(2719),
    [sym_kProcedure] = ACTIONS(2719),
    [sym_kConstructor] = ACTIONS(2719),
    [sym_kDestructor] = ACTIONS(2719),
    [sym_kOperator] = ACTIONS(2719),
    [sym_kPublic] = ACTIONS(2719),
    [sym_kForward] = ACTIONS(2719),
    [sym_kStatic] = ACTIONS(2719),
    [sym_kVirtual] = ACTIONS(2719),
    [sym_kAbstract] = ACTIONS(2719),
    [sym_kDynamic] = ACTIONS(2719),
    [sym_kOverride] = ACTIONS(2719),
    [sym_kOverload] = ACTIONS(2719),
    [sym_kReintroduce] = ACTIONS(2719),
    [sym_kInline] = ACTIONS(2719),
    [sym_kStdcall] = ACTIONS(2719),
    [sym_kCdecl] = ACTIONS(2719),
    [sym_kCppdecl] = ACTIONS(2719),
    [sym_kPascal] = ACTIONS(2719),
    [sym_kRegister] = ACTIONS(2719),
    [sym_kMwpascal] = ACTIONS(2719),
    [sym_kExternal] = ACTIONS(2719),
    [sym_kMessage] = ACTIONS(2719),
    [sym_kDeprecated] = ACTIONS(2719),
    [sym_kExperimental] = ACTIONS(2719),
    [sym_kPlatform] = ACTIONS(2719),
    [sym_kUnimplemented] = ACTIONS(2719),
    [sym_kCvar] = ACTIONS(2719),
    [sym_kExport] = ACTIONS(2721),
    [sym_kFar] = ACTIONS(2719),
    [sym_kNear] = ACTIONS(2719),
    [sym_kSafecall] = ACTIONS(2719),
    [sym_kAssembler] = ACTIONS(2719),
    [sym_kNostackframe] = ACTIONS(2719),
    [sym_kInterrupt] = ACTIONS(2719),
    [sym_kNoreturn] = ACTIONS(2719),
    [sym_kIocheck] = ACTIONS(2719),
    [sym_kLocal] = ACTIONS(2719),
    [sym_kHardfloat] = ACTIONS(2719),
    [sym_kSoftfloat] = ACTIONS(2719),
    [sym_kMs_abi_default] = ACTIONS(2719),
    [sym_kMs_abi_cdecl] = ACTIONS(2719),
    [sym_kSaveregisters] = ACTIONS(2719),
    [sym_kSysv_abi_default] = ACTIONS(2719),
    [sym_kSysv_abi_cdecl] = ACTIONS(2719),
    [sym_kVectorcall] = ACTIONS(2719),
    [sym_kVarargs] = ACTIONS(2719),
    [sym_kWinapi] = ACTIONS(2719),
    [sym_kAlias] = ACTIONS(2719),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [aux_sym_type_token1] = ACTIONS(1272),
    [sym_kUses] = ACTIONS(1272),
    [sym_kBegin] = ACTIONS(1272),
    [sym_kAsm] = ACTIONS(1272),
    [sym_kVar] = ACTIONS(1274),
    [sym_kThreadvar] = ACTIONS(1272),
    [sym_kConst] = ACTIONS(1274),
    [sym_kResourcestring] = ACTIONS(1272),
    [sym_kType] = ACTIONS(1272),
    [sym_kLabel] = ACTIONS(1272),
    [sym_kExports] = ACTIONS(1272),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1272),
    [sym_kGeneric] = ACTIONS(1272),
    [sym_kFunction] = ACTIONS(1272),
    [sym_kProcedure] = ACTIONS(1272),
    [sym_kConstructor] = ACTIONS(1272),
    [sym_kDestructor] = ACTIONS(1272),
    [sym_kOperator] = ACTIONS(1272),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1272),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1272),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [445] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(470),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [aux_sym_type_token1] = ACTIONS(1157),
    [sym_kUses] = ACTIONS(1157),
    [sym_kBegin] = ACTIONS(1157),
    [sym_kAsm] = ACTIONS(1157),
    [sym_kVar] = ACTIONS(1159),
    [sym_kThreadvar] = ACTIONS(1157),
    [sym_kConst] = ACTIONS(1159),
    [sym_kResourcestring] = ACTIONS(1157),
    [sym_kType] = ACTIONS(1157),
    [sym_kLabel] = ACTIONS(1157),
    [sym_kExports] = ACTIONS(1157),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1157),
    [sym_kGeneric] = ACTIONS(1157),
    [sym_kFunction] = ACTIONS(1157),
    [sym_kProcedure] = ACTIONS(1157),
    [sym_kConstructor] = ACTIONS(1157),
    [sym_kDestructor] = ACTIONS(1157),
    [sym_kOperator] = ACTIONS(1157),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1157),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1157),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [446] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [aux_sym_type_token1] = ACTIONS(1164),
    [sym_kUses] = ACTIONS(1164),
    [sym_kBegin] = ACTIONS(1164),
    [sym_kAsm] = ACTIONS(1164),
    [sym_kVar] = ACTIONS(1166),
    [sym_kThreadvar] = ACTIONS(1164),
    [sym_kConst] = ACTIONS(1166),
    [sym_kResourcestring] = ACTIONS(1164),
    [sym_kType] = ACTIONS(1164),
    [sym_kLabel] = ACTIONS(1164),
    [sym_kExports] = ACTIONS(1164),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1164),
    [sym_kGeneric] = ACTIONS(1164),
    [sym_kFunction] = ACTIONS(1164),
    [sym_kProcedure] = ACTIONS(1164),
    [sym_kConstructor] = ACTIONS(1164),
    [sym_kDestructor] = ACTIONS(1164),
    [sym_kOperator] = ACTIONS(1164),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1164),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1164),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [aux_sym_type_token1] = ACTIONS(1218),
    [sym_kUses] = ACTIONS(1218),
    [sym_kBegin] = ACTIONS(1218),
    [sym_kAsm] = ACTIONS(1218),
    [sym_kVar] = ACTIONS(1220),
    [sym_kThreadvar] = ACTIONS(1218),
    [sym_kConst] = ACTIONS(1220),
    [sym_kResourcestring] = ACTIONS(1218),
    [sym_kType] = ACTIONS(1218),
    [sym_kLabel] = ACTIONS(1218),
    [sym_kExports] = ACTIONS(1218),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1218),
    [sym_kGeneric] = ACTIONS(1218),
    [sym_kFunction] = ACTIONS(1218),
    [sym_kProcedure] = ACTIONS(1218),
    [sym_kConstructor] = ACTIONS(1218),
    [sym_kDestructor] = ACTIONS(1218),
    [sym_kOperator] = ACTIONS(1218),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1218),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1218),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [aux_sym_type_token1] = ACTIONS(1146),
    [sym_kUses] = ACTIONS(1146),
    [sym_kBegin] = ACTIONS(1146),
    [sym_kAsm] = ACTIONS(1146),
    [sym_kVar] = ACTIONS(1148),
    [sym_kThreadvar] = ACTIONS(1146),
    [sym_kConst] = ACTIONS(1148),
    [sym_kResourcestring] = ACTIONS(1146),
    [sym_kType] = ACTIONS(1146),
    [sym_kLabel] = ACTIONS(1146),
    [sym_kExports] = ACTIONS(1146),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1146),
    [sym_kGeneric] = ACTIONS(1146),
    [sym_kFunction] = ACTIONS(1146),
    [sym_kProcedure] = ACTIONS(1146),
    [sym_kConstructor] = ACTIONS(1146),
    [sym_kDestructor] = ACTIONS(1146),
    [sym_kOperator] = ACTIONS(1146),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1146),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1146),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [aux_sym_type_token1] = ACTIONS(1139),
    [sym_kUses] = ACTIONS(1139),
    [sym_kBegin] = ACTIONS(1139),
    [sym_kAsm] = ACTIONS(1139),
    [sym_kVar] = ACTIONS(1141),
    [sym_kThreadvar] = ACTIONS(1139),
    [sym_kConst] = ACTIONS(1141),
    [sym_kResourcestring] = ACTIONS(1139),
    [sym_kType] = ACTIONS(1139),
    [sym_kLabel] = ACTIONS(1139),
    [sym_kExports] = ACTIONS(1139),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1139),
    [sym_kGeneric] = ACTIONS(1139),
    [sym_kFunction] = ACTIONS(1139),
    [sym_kProcedure] = ACTIONS(1139),
    [sym_kConstructor] = ACTIONS(1139),
    [sym_kDestructor] = ACTIONS(1139),
    [sym_kOperator] = ACTIONS(1139),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1139),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1139),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2741),
    [aux_sym_type_token1] = ACTIONS(1353),
    [sym_kUses] = ACTIONS(1353),
    [sym_kBegin] = ACTIONS(1353),
    [sym_kAsm] = ACTIONS(1353),
    [sym_kVar] = ACTIONS(1355),
    [sym_kThreadvar] = ACTIONS(1353),
    [sym_kConst] = ACTIONS(1355),
    [sym_kResourcestring] = ACTIONS(1353),
    [sym_kType] = ACTIONS(1353),
    [sym_kLabel] = ACTIONS(1353),
    [sym_kExports] = ACTIONS(1353),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1353),
    [sym_kGeneric] = ACTIONS(1353),
    [sym_kFunction] = ACTIONS(1353),
    [sym_kProcedure] = ACTIONS(1353),
    [sym_kConstructor] = ACTIONS(1353),
    [sym_kDestructor] = ACTIONS(1353),
    [sym_kOperator] = ACTIONS(1353),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1353),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1353),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_identifier] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_kEnd] = ACTIONS(1224),
    [sym_kVar] = ACTIONS(1224),
    [sym_kThreadvar] = ACTIONS(1224),
    [sym_kConst] = ACTIONS(1224),
    [sym_kResourcestring] = ACTIONS(1224),
    [sym_kType] = ACTIONS(1224),
    [sym_kProperty] = ACTIONS(1224),
    [sym_kDefault] = ACTIONS(1224),
    [sym_kNodefault] = ACTIONS(1224),
    [sym_kClass] = ACTIONS(1224),
    [sym_kGeneric] = ACTIONS(1224),
    [sym_kCase] = ACTIONS(1224),
    [sym_kFunction] = ACTIONS(1224),
    [sym_kProcedure] = ACTIONS(1224),
    [sym_kConstructor] = ACTIONS(1224),
    [sym_kDestructor] = ACTIONS(1224),
    [sym_kOperator] = ACTIONS(1224),
    [sym_kPublished] = ACTIONS(1224),
    [sym_kPublic] = ACTIONS(1224),
    [sym_kProtected] = ACTIONS(1224),
    [sym_kPrivate] = ACTIONS(1224),
    [sym_kStrict] = ACTIONS(1224),
    [sym_kRequired] = ACTIONS(1224),
    [sym_kOptional] = ACTIONS(1224),
    [sym_kStatic] = ACTIONS(1224),
    [sym_kVirtual] = ACTIONS(1224),
    [sym_kAbstract] = ACTIONS(1224),
    [sym_kDynamic] = ACTIONS(1224),
    [sym_kOverride] = ACTIONS(1224),
    [sym_kOverload] = ACTIONS(1224),
    [sym_kReintroduce] = ACTIONS(1224),
    [sym_kInline] = ACTIONS(1224),
    [sym_kStdcall] = ACTIONS(1224),
    [sym_kCdecl] = ACTIONS(1224),
    [sym_kCppdecl] = ACTIONS(1224),
    [sym_kPascal] = ACTIONS(1224),
    [sym_kRegister] = ACTIONS(1224),
    [sym_kMwpascal] = ACTIONS(1224),
    [sym_kExternal] = ACTIONS(1224),
    [sym_kMessage] = ACTIONS(1224),
    [sym_kDeprecated] = ACTIONS(1224),
    [sym_kExperimental] = ACTIONS(1224),
    [sym_kPlatform] = ACTIONS(1224),
    [sym_kUnimplemented] = ACTIONS(1224),
    [sym_kCvar] = ACTIONS(1224),
    [sym_kExport] = ACTIONS(1224),
    [sym_kFar] = ACTIONS(1224),
    [sym_kNear] = ACTIONS(1224),
    [sym_kSafecall] = ACTIONS(1224),
    [sym_kAssembler] = ACTIONS(1224),
    [sym_kNostackframe] = ACTIONS(1224),
    [sym_kInterrupt] = ACTIONS(1224),
    [sym_kNoreturn] = ACTIONS(1224),
    [sym_kIocheck] = ACTIONS(1224),
    [sym_kLocal] = ACTIONS(1224),
    [sym_kHardfloat] = ACTIONS(1224),
    [sym_kSoftfloat] = ACTIONS(1224),
    [sym_kMs_abi_default] = ACTIONS(1224),
    [sym_kMs_abi_cdecl] = ACTIONS(1224),
    [sym_kSaveregisters] = ACTIONS(1224),
    [sym_kSysv_abi_default] = ACTIONS(1224),
    [sym_kSysv_abi_cdecl] = ACTIONS(1224),
    [sym_kVectorcall] = ACTIONS(1224),
    [sym_kVarargs] = ACTIONS(1224),
    [sym_kWinapi] = ACTIONS(1224),
    [sym_kAlias] = ACTIONS(1224),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_identifier] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(845),
    [sym_kEnd] = ACTIONS(847),
    [sym_kVar] = ACTIONS(847),
    [sym_kThreadvar] = ACTIONS(847),
    [sym_kConst] = ACTIONS(847),
    [sym_kResourcestring] = ACTIONS(847),
    [sym_kType] = ACTIONS(847),
    [sym_kProperty] = ACTIONS(847),
    [sym_kDefault] = ACTIONS(847),
    [sym_kNodefault] = ACTIONS(847),
    [sym_kClass] = ACTIONS(847),
    [sym_kGeneric] = ACTIONS(847),
    [sym_kCase] = ACTIONS(847),
    [sym_kFunction] = ACTIONS(847),
    [sym_kProcedure] = ACTIONS(847),
    [sym_kConstructor] = ACTIONS(847),
    [sym_kDestructor] = ACTIONS(847),
    [sym_kOperator] = ACTIONS(847),
    [sym_kPublished] = ACTIONS(847),
    [sym_kPublic] = ACTIONS(847),
    [sym_kProtected] = ACTIONS(847),
    [sym_kPrivate] = ACTIONS(847),
    [sym_kStrict] = ACTIONS(847),
    [sym_kRequired] = ACTIONS(847),
    [sym_kOptional] = ACTIONS(847),
    [sym_kStatic] = ACTIONS(847),
    [sym_kVirtual] = ACTIONS(847),
    [sym_kAbstract] = ACTIONS(847),
    [sym_kDynamic] = ACTIONS(847),
    [sym_kOverride] = ACTIONS(847),
    [sym_kOverload] = ACTIONS(847),
    [sym_kReintroduce] = ACTIONS(847),
    [sym_kInline] = ACTIONS(847),
    [sym_kStdcall] = ACTIONS(847),
    [sym_kCdecl] = ACTIONS(847),
    [sym_kCppdecl] = ACTIONS(847),
    [sym_kPascal] = ACTIONS(847),
    [sym_kRegister] = ACTIONS(847),
    [sym_kMwpascal] = ACTIONS(847),
    [sym_kExternal] = ACTIONS(847),
    [sym_kMessage] = ACTIONS(847),
    [sym_kDeprecated] = ACTIONS(847),
    [sym_kExperimental] = ACTIONS(847),
    [sym_kPlatform] = ACTIONS(847),
    [sym_kUnimplemented] = ACTIONS(847),
    [sym_kCvar] = ACTIONS(847),
    [sym_kExport] = ACTIONS(847),
    [sym_kFar] = ACTIONS(847),
    [sym_kNear] = ACTIONS(847),
    [sym_kSafecall] = ACTIONS(847),
    [sym_kAssembler] = ACTIONS(847),
    [sym_kNostackframe] = ACTIONS(847),
    [sym_kInterrupt] = ACTIONS(847),
    [sym_kNoreturn] = ACTIONS(847),
    [sym_kIocheck] = ACTIONS(847),
    [sym_kLocal] = ACTIONS(847),
    [sym_kHardfloat] = ACTIONS(847),
    [sym_kSoftfloat] = ACTIONS(847),
    [sym_kMs_abi_default] = ACTIONS(847),
    [sym_kMs_abi_cdecl] = ACTIONS(847),
    [sym_kSaveregisters] = ACTIONS(847),
    [sym_kSysv_abi_default] = ACTIONS(847),
    [sym_kSysv_abi_cdecl] = ACTIONS(847),
    [sym_kVectorcall] = ACTIONS(847),
    [sym_kVarargs] = ACTIONS(847),
    [sym_kWinapi] = ACTIONS(847),
    [sym_kAlias] = ACTIONS(847),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [453] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [aux_sym_type_token1] = ACTIONS(1360),
    [sym_kUses] = ACTIONS(1360),
    [sym_kBegin] = ACTIONS(1360),
    [sym_kAsm] = ACTIONS(1360),
    [sym_kVar] = ACTIONS(1362),
    [sym_kThreadvar] = ACTIONS(1360),
    [sym_kConst] = ACTIONS(1362),
    [sym_kResourcestring] = ACTIONS(1360),
    [sym_kType] = ACTIONS(1360),
    [sym_kLabel] = ACTIONS(1360),
    [sym_kExports] = ACTIONS(1360),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1360),
    [sym_kGeneric] = ACTIONS(1360),
    [sym_kFunction] = ACTIONS(1360),
    [sym_kProcedure] = ACTIONS(1360),
    [sym_kConstructor] = ACTIONS(1360),
    [sym_kDestructor] = ACTIONS(1360),
    [sym_kOperator] = ACTIONS(1360),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1360),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1360),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(455),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [aux_sym_type_token1] = ACTIONS(1367),
    [sym_kUses] = ACTIONS(1367),
    [sym_kBegin] = ACTIONS(1367),
    [sym_kAsm] = ACTIONS(1367),
    [sym_kVar] = ACTIONS(1369),
    [sym_kThreadvar] = ACTIONS(1367),
    [sym_kConst] = ACTIONS(1369),
    [sym_kResourcestring] = ACTIONS(1367),
    [sym_kType] = ACTIONS(1367),
    [sym_kLabel] = ACTIONS(1367),
    [sym_kExports] = ACTIONS(1367),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1367),
    [sym_kGeneric] = ACTIONS(1367),
    [sym_kFunction] = ACTIONS(1367),
    [sym_kProcedure] = ACTIONS(1367),
    [sym_kConstructor] = ACTIONS(1367),
    [sym_kDestructor] = ACTIONS(1367),
    [sym_kOperator] = ACTIONS(1367),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1367),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1367),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [aux_sym_type_token1] = ACTIONS(1265),
    [sym_kUses] = ACTIONS(1265),
    [sym_kBegin] = ACTIONS(1265),
    [sym_kAsm] = ACTIONS(1265),
    [sym_kVar] = ACTIONS(1267),
    [sym_kThreadvar] = ACTIONS(1265),
    [sym_kConst] = ACTIONS(1267),
    [sym_kResourcestring] = ACTIONS(1265),
    [sym_kType] = ACTIONS(1265),
    [sym_kLabel] = ACTIONS(1265),
    [sym_kExports] = ACTIONS(1265),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1265),
    [sym_kGeneric] = ACTIONS(1265),
    [sym_kFunction] = ACTIONS(1265),
    [sym_kProcedure] = ACTIONS(1265),
    [sym_kConstructor] = ACTIONS(1265),
    [sym_kDestructor] = ACTIONS(1265),
    [sym_kOperator] = ACTIONS(1265),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1265),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1265),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [sym_kEnd] = ACTIONS(1260),
    [sym_kVar] = ACTIONS(1260),
    [sym_kThreadvar] = ACTIONS(1260),
    [sym_kConst] = ACTIONS(1260),
    [sym_kResourcestring] = ACTIONS(1260),
    [sym_kType] = ACTIONS(1260),
    [sym_kProperty] = ACTIONS(1260),
    [sym_kDefault] = ACTIONS(1260),
    [sym_kNodefault] = ACTIONS(1260),
    [sym_kClass] = ACTIONS(1260),
    [sym_kGeneric] = ACTIONS(1260),
    [sym_kCase] = ACTIONS(1260),
    [sym_kFunction] = ACTIONS(1260),
    [sym_kProcedure] = ACTIONS(1260),
    [sym_kConstructor] = ACTIONS(1260),
    [sym_kDestructor] = ACTIONS(1260),
    [sym_kOperator] = ACTIONS(1260),
    [sym_kPublished] = ACTIONS(1260),
    [sym_kPublic] = ACTIONS(1260),
    [sym_kProtected] = ACTIONS(1260),
    [sym_kPrivate] = ACTIONS(1260),
    [sym_kStrict] = ACTIONS(1260),
    [sym_kRequired] = ACTIONS(1260),
    [sym_kOptional] = ACTIONS(1260),
    [sym_kStatic] = ACTIONS(1260),
    [sym_kVirtual] = ACTIONS(1260),
    [sym_kAbstract] = ACTIONS(1260),
    [sym_kDynamic] = ACTIONS(1260),
    [sym_kOverride] = ACTIONS(1260),
    [sym_kOverload] = ACTIONS(1260),
    [sym_kReintroduce] = ACTIONS(1260),
    [sym_kInline] = ACTIONS(1260),
    [sym_kStdcall] = ACTIONS(1260),
    [sym_kCdecl] = ACTIONS(1260),
    [sym_kCppdecl] = ACTIONS(1260),
    [sym_kPascal] = ACTIONS(1260),
    [sym_kRegister] = ACTIONS(1260),
    [sym_kMwpascal] = ACTIONS(1260),
    [sym_kExternal] = ACTIONS(1260),
    [sym_kMessage] = ACTIONS(1260),
    [sym_kDeprecated] = ACTIONS(1260),
    [sym_kExperimental] = ACTIONS(1260),
    [sym_kPlatform] = ACTIONS(1260),
    [sym_kUnimplemented] = ACTIONS(1260),
    [sym_kCvar] = ACTIONS(1260),
    [sym_kExport] = ACTIONS(1260),
    [sym_kFar] = ACTIONS(1260),
    [sym_kNear] = ACTIONS(1260),
    [sym_kSafecall] = ACTIONS(1260),
    [sym_kAssembler] = ACTIONS(1260),
    [sym_kNostackframe] = ACTIONS(1260),
    [sym_kInterrupt] = ACTIONS(1260),
    [sym_kNoreturn] = ACTIONS(1260),
    [sym_kIocheck] = ACTIONS(1260),
    [sym_kLocal] = ACTIONS(1260),
    [sym_kHardfloat] = ACTIONS(1260),
    [sym_kSoftfloat] = ACTIONS(1260),
    [sym_kMs_abi_default] = ACTIONS(1260),
    [sym_kMs_abi_cdecl] = ACTIONS(1260),
    [sym_kSaveregisters] = ACTIONS(1260),
    [sym_kSysv_abi_default] = ACTIONS(1260),
    [sym_kSysv_abi_cdecl] = ACTIONS(1260),
    [sym_kVectorcall] = ACTIONS(1260),
    [sym_kVarargs] = ACTIONS(1260),
    [sym_kWinapi] = ACTIONS(1260),
    [sym_kAlias] = ACTIONS(1260),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [anon_sym_LBRACK] = ACTIONS(2753),
    [sym_kUses] = ACTIONS(2753),
    [sym_kInterface] = ACTIONS(2753),
    [sym_kImplementation] = ACTIONS(2753),
    [sym_kInitialization] = ACTIONS(2753),
    [sym_kFinalization] = ACTIONS(2753),
    [sym_kEnd] = ACTIONS(2753),
    [sym_kVar] = ACTIONS(2755),
    [sym_kThreadvar] = ACTIONS(2753),
    [sym_kConst] = ACTIONS(2755),
    [sym_kResourcestring] = ACTIONS(2753),
    [sym_kType] = ACTIONS(2753),
    [sym_kLabel] = ACTIONS(2753),
    [sym_kExports] = ACTIONS(2753),
    [sym_kProperty] = ACTIONS(2753),
    [sym_kDefault] = ACTIONS(2753),
    [sym_kNodefault] = ACTIONS(2753),
    [sym_kClass] = ACTIONS(2753),
    [sym_kGeneric] = ACTIONS(2753),
    [sym_kFunction] = ACTIONS(2753),
    [sym_kProcedure] = ACTIONS(2753),
    [sym_kConstructor] = ACTIONS(2753),
    [sym_kDestructor] = ACTIONS(2753),
    [sym_kOperator] = ACTIONS(2753),
    [sym_kPublic] = ACTIONS(2753),
    [sym_kForward] = ACTIONS(2753),
    [sym_kStatic] = ACTIONS(2753),
    [sym_kVirtual] = ACTIONS(2753),
    [sym_kAbstract] = ACTIONS(2753),
    [sym_kDynamic] = ACTIONS(2753),
    [sym_kOverride] = ACTIONS(2753),
    [sym_kOverload] = ACTIONS(2753),
    [sym_kReintroduce] = ACTIONS(2753),
    [sym_kInline] = ACTIONS(2753),
    [sym_kStdcall] = ACTIONS(2753),
    [sym_kCdecl] = ACTIONS(2753),
    [sym_kCppdecl] = ACTIONS(2753),
    [sym_kPascal] = ACTIONS(2753),
    [sym_kRegister] = ACTIONS(2753),
    [sym_kMwpascal] = ACTIONS(2753),
    [sym_kExternal] = ACTIONS(2753),
    [sym_kMessage] = ACTIONS(2753),
    [sym_kDeprecated] = ACTIONS(2753),
    [sym_kExperimental] = ACTIONS(2753),
    [sym_kPlatform] = ACTIONS(2753),
    [sym_kUnimplemented] = ACTIONS(2753),
    [sym_kCvar] = ACTIONS(2753),
    [sym_kExport] = ACTIONS(2755),
    [sym_kFar] = ACTIONS(2753),
    [sym_kNear] = ACTIONS(2753),
    [sym_kSafecall] = ACTIONS(2753),
    [sym_kAssembler] = ACTIONS(2753),
    [sym_kNostackframe] = ACTIONS(2753),
    [sym_kInterrupt] = ACTIONS(2753),
    [sym_kNoreturn] = ACTIONS(2753),
    [sym_kIocheck] = ACTIONS(2753),
    [sym_kLocal] = ACTIONS(2753),
    [sym_kHardfloat] = ACTIONS(2753),
    [sym_kSoftfloat] = ACTIONS(2753),
    [sym_kMs_abi_default] = ACTIONS(2753),
    [sym_kMs_abi_cdecl] = ACTIONS(2753),
    [sym_kSaveregisters] = ACTIONS(2753),
    [sym_kSysv_abi_default] = ACTIONS(2753),
    [sym_kSysv_abi_cdecl] = ACTIONS(2753),
    [sym_kVectorcall] = ACTIONS(2753),
    [sym_kVarargs] = ACTIONS(2753),
    [sym_kWinapi] = ACTIONS(2753),
    [sym_kAlias] = ACTIONS(2753),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(462),
    [anon_sym_LBRACK] = ACTIONS(2757),
    [aux_sym_type_token1] = ACTIONS(1104),
    [sym_kUses] = ACTIONS(1104),
    [sym_kBegin] = ACTIONS(1104),
    [sym_kAsm] = ACTIONS(1104),
    [sym_kVar] = ACTIONS(1106),
    [sym_kThreadvar] = ACTIONS(1104),
    [sym_kConst] = ACTIONS(1106),
    [sym_kResourcestring] = ACTIONS(1104),
    [sym_kType] = ACTIONS(1104),
    [sym_kLabel] = ACTIONS(1104),
    [sym_kExports] = ACTIONS(1104),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1104),
    [sym_kGeneric] = ACTIONS(1104),
    [sym_kFunction] = ACTIONS(1104),
    [sym_kProcedure] = ACTIONS(1104),
    [sym_kConstructor] = ACTIONS(1104),
    [sym_kDestructor] = ACTIONS(1104),
    [sym_kOperator] = ACTIONS(1104),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1104),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1104),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [aux_sym_type_token1] = ACTIONS(1111),
    [sym_kUses] = ACTIONS(1111),
    [sym_kBegin] = ACTIONS(1111),
    [sym_kAsm] = ACTIONS(1111),
    [sym_kVar] = ACTIONS(1113),
    [sym_kThreadvar] = ACTIONS(1111),
    [sym_kConst] = ACTIONS(1113),
    [sym_kResourcestring] = ACTIONS(1111),
    [sym_kType] = ACTIONS(1111),
    [sym_kLabel] = ACTIONS(1111),
    [sym_kExports] = ACTIONS(1111),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1111),
    [sym_kGeneric] = ACTIONS(1111),
    [sym_kFunction] = ACTIONS(1111),
    [sym_kProcedure] = ACTIONS(1111),
    [sym_kConstructor] = ACTIONS(1111),
    [sym_kDestructor] = ACTIONS(1111),
    [sym_kOperator] = ACTIONS(1111),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1111),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1111),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [aux_sym_type_token1] = ACTIONS(1118),
    [sym_kUses] = ACTIONS(1118),
    [sym_kBegin] = ACTIONS(1118),
    [sym_kAsm] = ACTIONS(1118),
    [sym_kVar] = ACTIONS(1120),
    [sym_kThreadvar] = ACTIONS(1118),
    [sym_kConst] = ACTIONS(1120),
    [sym_kResourcestring] = ACTIONS(1118),
    [sym_kType] = ACTIONS(1118),
    [sym_kLabel] = ACTIONS(1118),
    [sym_kExports] = ACTIONS(1118),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1118),
    [sym_kGeneric] = ACTIONS(1118),
    [sym_kFunction] = ACTIONS(1118),
    [sym_kProcedure] = ACTIONS(1118),
    [sym_kConstructor] = ACTIONS(1118),
    [sym_kDestructor] = ACTIONS(1118),
    [sym_kOperator] = ACTIONS(1118),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1118),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1118),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(418),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [aux_sym_type_token1] = ACTIONS(1229),
    [sym_kUses] = ACTIONS(1229),
    [sym_kBegin] = ACTIONS(1229),
    [sym_kAsm] = ACTIONS(1229),
    [sym_kVar] = ACTIONS(1231),
    [sym_kThreadvar] = ACTIONS(1229),
    [sym_kConst] = ACTIONS(1231),
    [sym_kResourcestring] = ACTIONS(1229),
    [sym_kType] = ACTIONS(1229),
    [sym_kLabel] = ACTIONS(1229),
    [sym_kExports] = ACTIONS(1229),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1229),
    [sym_kGeneric] = ACTIONS(1229),
    [sym_kFunction] = ACTIONS(1229),
    [sym_kProcedure] = ACTIONS(1229),
    [sym_kConstructor] = ACTIONS(1229),
    [sym_kDestructor] = ACTIONS(1229),
    [sym_kOperator] = ACTIONS(1229),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1229),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1229),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [aux_sym_type_token1] = ACTIONS(1374),
    [sym_kUses] = ACTIONS(1374),
    [sym_kBegin] = ACTIONS(1374),
    [sym_kAsm] = ACTIONS(1374),
    [sym_kVar] = ACTIONS(1376),
    [sym_kThreadvar] = ACTIONS(1374),
    [sym_kConst] = ACTIONS(1376),
    [sym_kResourcestring] = ACTIONS(1374),
    [sym_kType] = ACTIONS(1374),
    [sym_kLabel] = ACTIONS(1374),
    [sym_kExports] = ACTIONS(1374),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1374),
    [sym_kGeneric] = ACTIONS(1374),
    [sym_kFunction] = ACTIONS(1374),
    [sym_kProcedure] = ACTIONS(1374),
    [sym_kConstructor] = ACTIONS(1374),
    [sym_kDestructor] = ACTIONS(1374),
    [sym_kOperator] = ACTIONS(1374),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1374),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1374),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(433),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [aux_sym_type_token1] = ACTIONS(1381),
    [sym_kUses] = ACTIONS(1381),
    [sym_kBegin] = ACTIONS(1381),
    [sym_kAsm] = ACTIONS(1381),
    [sym_kVar] = ACTIONS(1383),
    [sym_kThreadvar] = ACTIONS(1381),
    [sym_kConst] = ACTIONS(1383),
    [sym_kResourcestring] = ACTIONS(1381),
    [sym_kType] = ACTIONS(1381),
    [sym_kLabel] = ACTIONS(1381),
    [sym_kExports] = ACTIONS(1381),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1381),
    [sym_kGeneric] = ACTIONS(1381),
    [sym_kFunction] = ACTIONS(1381),
    [sym_kProcedure] = ACTIONS(1381),
    [sym_kConstructor] = ACTIONS(1381),
    [sym_kDestructor] = ACTIONS(1381),
    [sym_kOperator] = ACTIONS(1381),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1381),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1381),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(444),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [aux_sym_type_token1] = ACTIONS(1409),
    [sym_kUses] = ACTIONS(1409),
    [sym_kBegin] = ACTIONS(1409),
    [sym_kAsm] = ACTIONS(1409),
    [sym_kVar] = ACTIONS(1411),
    [sym_kThreadvar] = ACTIONS(1409),
    [sym_kConst] = ACTIONS(1411),
    [sym_kResourcestring] = ACTIONS(1409),
    [sym_kType] = ACTIONS(1409),
    [sym_kLabel] = ACTIONS(1409),
    [sym_kExports] = ACTIONS(1409),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1409),
    [sym_kGeneric] = ACTIONS(1409),
    [sym_kFunction] = ACTIONS(1409),
    [sym_kProcedure] = ACTIONS(1409),
    [sym_kConstructor] = ACTIONS(1409),
    [sym_kDestructor] = ACTIONS(1409),
    [sym_kOperator] = ACTIONS(1409),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1409),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1409),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(469),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [aux_sym_type_token1] = ACTIONS(1125),
    [sym_kUses] = ACTIONS(1125),
    [sym_kBegin] = ACTIONS(1125),
    [sym_kAsm] = ACTIONS(1125),
    [sym_kVar] = ACTIONS(1127),
    [sym_kThreadvar] = ACTIONS(1125),
    [sym_kConst] = ACTIONS(1127),
    [sym_kResourcestring] = ACTIONS(1125),
    [sym_kType] = ACTIONS(1125),
    [sym_kLabel] = ACTIONS(1125),
    [sym_kExports] = ACTIONS(1125),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1125),
    [sym_kGeneric] = ACTIONS(1125),
    [sym_kFunction] = ACTIONS(1125),
    [sym_kProcedure] = ACTIONS(1125),
    [sym_kConstructor] = ACTIONS(1125),
    [sym_kDestructor] = ACTIONS(1125),
    [sym_kOperator] = ACTIONS(1125),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1125),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1125),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(423),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [aux_sym_type_token1] = ACTIONS(1395),
    [sym_kUses] = ACTIONS(1395),
    [sym_kBegin] = ACTIONS(1395),
    [sym_kAsm] = ACTIONS(1395),
    [sym_kVar] = ACTIONS(1397),
    [sym_kThreadvar] = ACTIONS(1395),
    [sym_kConst] = ACTIONS(1397),
    [sym_kResourcestring] = ACTIONS(1395),
    [sym_kType] = ACTIONS(1395),
    [sym_kLabel] = ACTIONS(1395),
    [sym_kExports] = ACTIONS(1395),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1395),
    [sym_kGeneric] = ACTIONS(1395),
    [sym_kFunction] = ACTIONS(1395),
    [sym_kProcedure] = ACTIONS(1395),
    [sym_kConstructor] = ACTIONS(1395),
    [sym_kDestructor] = ACTIONS(1395),
    [sym_kOperator] = ACTIONS(1395),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1395),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1395),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(428),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [aux_sym_type_token1] = ACTIONS(1189),
    [sym_kUses] = ACTIONS(1189),
    [sym_kBegin] = ACTIONS(1189),
    [sym_kAsm] = ACTIONS(1189),
    [sym_kVar] = ACTIONS(1191),
    [sym_kThreadvar] = ACTIONS(1189),
    [sym_kConst] = ACTIONS(1191),
    [sym_kResourcestring] = ACTIONS(1189),
    [sym_kType] = ACTIONS(1189),
    [sym_kLabel] = ACTIONS(1189),
    [sym_kExports] = ACTIONS(1189),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1189),
    [sym_kGeneric] = ACTIONS(1189),
    [sym_kFunction] = ACTIONS(1189),
    [sym_kProcedure] = ACTIONS(1189),
    [sym_kConstructor] = ACTIONS(1189),
    [sym_kDestructor] = ACTIONS(1189),
    [sym_kOperator] = ACTIONS(1189),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1189),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1189),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [sym_identifier] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(622),
    [sym_kEnd] = ACTIONS(624),
    [sym_kVar] = ACTIONS(624),
    [sym_kThreadvar] = ACTIONS(624),
    [sym_kConst] = ACTIONS(624),
    [sym_kResourcestring] = ACTIONS(624),
    [sym_kType] = ACTIONS(624),
    [sym_kProperty] = ACTIONS(624),
    [sym_kDefault] = ACTIONS(624),
    [sym_kNodefault] = ACTIONS(624),
    [sym_kClass] = ACTIONS(624),
    [sym_kGeneric] = ACTIONS(624),
    [sym_kCase] = ACTIONS(624),
    [sym_kFunction] = ACTIONS(624),
    [sym_kProcedure] = ACTIONS(624),
    [sym_kConstructor] = ACTIONS(624),
    [sym_kDestructor] = ACTIONS(624),
    [sym_kOperator] = ACTIONS(624),
    [sym_kPublished] = ACTIONS(624),
    [sym_kPublic] = ACTIONS(624),
    [sym_kProtected] = ACTIONS(624),
    [sym_kPrivate] = ACTIONS(624),
    [sym_kStrict] = ACTIONS(624),
    [sym_kRequired] = ACTIONS(624),
    [sym_kOptional] = ACTIONS(624),
    [sym_kStatic] = ACTIONS(624),
    [sym_kVirtual] = ACTIONS(624),
    [sym_kAbstract] = ACTIONS(624),
    [sym_kDynamic] = ACTIONS(624),
    [sym_kOverride] = ACTIONS(624),
    [sym_kOverload] = ACTIONS(624),
    [sym_kReintroduce] = ACTIONS(624),
    [sym_kInline] = ACTIONS(624),
    [sym_kStdcall] = ACTIONS(624),
    [sym_kCdecl] = ACTIONS(624),
    [sym_kCppdecl] = ACTIONS(624),
    [sym_kPascal] = ACTIONS(624),
    [sym_kRegister] = ACTIONS(624),
    [sym_kMwpascal] = ACTIONS(624),
    [sym_kExternal] = ACTIONS(624),
    [sym_kMessage] = ACTIONS(624),
    [sym_kDeprecated] = ACTIONS(624),
    [sym_kExperimental] = ACTIONS(624),
    [sym_kPlatform] = ACTIONS(624),
    [sym_kUnimplemented] = ACTIONS(624),
    [sym_kCvar] = ACTIONS(624),
    [sym_kExport] = ACTIONS(624),
    [sym_kFar] = ACTIONS(624),
    [sym_kNear] = ACTIONS(624),
    [sym_kSafecall] = ACTIONS(624),
    [sym_kAssembler] = ACTIONS(624),
    [sym_kNostackframe] = ACTIONS(624),
    [sym_kInterrupt] = ACTIONS(624),
    [sym_kNoreturn] = ACTIONS(624),
    [sym_kIocheck] = ACTIONS(624),
    [sym_kLocal] = ACTIONS(624),
    [sym_kHardfloat] = ACTIONS(624),
    [sym_kSoftfloat] = ACTIONS(624),
    [sym_kMs_abi_default] = ACTIONS(624),
    [sym_kMs_abi_cdecl] = ACTIONS(624),
    [sym_kSaveregisters] = ACTIONS(624),
    [sym_kSysv_abi_default] = ACTIONS(624),
    [sym_kSysv_abi_cdecl] = ACTIONS(624),
    [sym_kVectorcall] = ACTIONS(624),
    [sym_kVarargs] = ACTIONS(624),
    [sym_kWinapi] = ACTIONS(624),
    [sym_kAlias] = ACTIONS(624),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [aux_sym_type_token1] = ACTIONS(1416),
    [sym_kUses] = ACTIONS(1416),
    [sym_kBegin] = ACTIONS(1416),
    [sym_kAsm] = ACTIONS(1416),
    [sym_kVar] = ACTIONS(1418),
    [sym_kThreadvar] = ACTIONS(1416),
    [sym_kConst] = ACTIONS(1418),
    [sym_kResourcestring] = ACTIONS(1416),
    [sym_kType] = ACTIONS(1416),
    [sym_kLabel] = ACTIONS(1416),
    [sym_kExports] = ACTIONS(1416),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1416),
    [sym_kGeneric] = ACTIONS(1416),
    [sym_kFunction] = ACTIONS(1416),
    [sym_kProcedure] = ACTIONS(1416),
    [sym_kConstructor] = ACTIONS(1416),
    [sym_kDestructor] = ACTIONS(1416),
    [sym_kOperator] = ACTIONS(1416),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1416),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1416),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [aux_sym_type_token1] = ACTIONS(1430),
    [sym_kUses] = ACTIONS(1430),
    [sym_kBegin] = ACTIONS(1430),
    [sym_kAsm] = ACTIONS(1430),
    [sym_kVar] = ACTIONS(1432),
    [sym_kThreadvar] = ACTIONS(1430),
    [sym_kConst] = ACTIONS(1432),
    [sym_kResourcestring] = ACTIONS(1430),
    [sym_kType] = ACTIONS(1430),
    [sym_kLabel] = ACTIONS(1430),
    [sym_kExports] = ACTIONS(1430),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1430),
    [sym_kGeneric] = ACTIONS(1430),
    [sym_kFunction] = ACTIONS(1430),
    [sym_kProcedure] = ACTIONS(1430),
    [sym_kConstructor] = ACTIONS(1430),
    [sym_kDestructor] = ACTIONS(1430),
    [sym_kOperator] = ACTIONS(1430),
    [sym_kPublic] = ACTIONS(880),
    [sym_kForward] = ACTIONS(1430),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kExternal] = ACTIONS(1430),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [aux_sym_type_token1] = ACTIONS(1286),
    [sym_kUses] = ACTIONS(1286),
    [sym_kBegin] = ACTIONS(1286),
    [sym_kAsm] = ACTIONS(1286),
    [sym_kVar] = ACTIONS(1288),
    [sym_kThreadvar] = ACTIONS(1286),
    [sym_kConst] = ACTIONS(1288),
    [sym_kResourcestring] = ACTIONS(1286),
    [sym_kType] = ACTIONS(1286),
    [sym_kLabel] = ACTIONS(1286),
    [sym_kExports] = ACTIONS(1286),
    [sym_kDefault] = ACTIONS(1290),
    [sym_kNodefault] = ACTIONS(1290),
    [sym_kClass] = ACTIONS(1286),
    [sym_kGeneric] = ACTIONS(1286),
    [sym_kFunction] = ACTIONS(1286),
    [sym_kProcedure] = ACTIONS(1286),
    [sym_kConstructor] = ACTIONS(1286),
    [sym_kDestructor] = ACTIONS(1286),
    [sym_kOperator] = ACTIONS(1286),
    [sym_kPublic] = ACTIONS(1293),
    [sym_kForward] = ACTIONS(1286),
    [sym_kStatic] = ACTIONS(1290),
    [sym_kVirtual] = ACTIONS(1290),
    [sym_kAbstract] = ACTIONS(1290),
    [sym_kDynamic] = ACTIONS(1290),
    [sym_kOverride] = ACTIONS(1290),
    [sym_kOverload] = ACTIONS(1290),
    [sym_kReintroduce] = ACTIONS(1290),
    [sym_kInline] = ACTIONS(1290),
    [sym_kStdcall] = ACTIONS(1290),
    [sym_kCdecl] = ACTIONS(1290),
    [sym_kCppdecl] = ACTIONS(1290),
    [sym_kPascal] = ACTIONS(1290),
    [sym_kRegister] = ACTIONS(1290),
    [sym_kMwpascal] = ACTIONS(1290),
    [sym_kExternal] = ACTIONS(1286),
    [sym_kMessage] = ACTIONS(1296),
    [sym_kDeprecated] = ACTIONS(1299),
    [sym_kExperimental] = ACTIONS(1290),
    [sym_kPlatform] = ACTIONS(1290),
    [sym_kUnimplemented] = ACTIONS(1290),
    [sym_kCvar] = ACTIONS(1290),
    [sym_kExport] = ACTIONS(1302),
    [sym_kFar] = ACTIONS(1290),
    [sym_kNear] = ACTIONS(1290),
    [sym_kSafecall] = ACTIONS(1290),
    [sym_kAssembler] = ACTIONS(1290),
    [sym_kNostackframe] = ACTIONS(1290),
    [sym_kInterrupt] = ACTIONS(1290),
    [sym_kNoreturn] = ACTIONS(1290),
    [sym_kIocheck] = ACTIONS(1290),
    [sym_kLocal] = ACTIONS(1290),
    [sym_kHardfloat] = ACTIONS(1290),
    [sym_kSoftfloat] = ACTIONS(1290),
    [sym_kMs_abi_default] = ACTIONS(1290),
    [sym_kMs_abi_cdecl] = ACTIONS(1290),
    [sym_kSaveregisters] = ACTIONS(1290),
    [sym_kSysv_abi_default] = ACTIONS(1290),
    [sym_kSysv_abi_cdecl] = ACTIONS(1290),
    [sym_kVectorcall] = ACTIONS(1290),
    [sym_kVarargs] = ACTIONS(1290),
    [sym_kWinapi] = ACTIONS(1290),
    [sym_kAlias] = ACTIONS(1305),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [sym_kEnd] = ACTIONS(1591),
    [sym_kVar] = ACTIONS(1591),
    [sym_kThreadvar] = ACTIONS(1591),
    [sym_kConst] = ACTIONS(1591),
    [sym_kResourcestring] = ACTIONS(1591),
    [sym_kType] = ACTIONS(1591),
    [sym_kProperty] = ACTIONS(1591),
    [sym_kDefault] = ACTIONS(1591),
    [sym_kNodefault] = ACTIONS(1591),
    [sym_kClass] = ACTIONS(1591),
    [sym_kGeneric] = ACTIONS(1591),
    [sym_kCase] = ACTIONS(1591),
    [sym_kFunction] = ACTIONS(1591),
    [sym_kProcedure] = ACTIONS(1591),
    [sym_kConstructor] = ACTIONS(1591),
    [sym_kDestructor] = ACTIONS(1591),
    [sym_kOperator] = ACTIONS(1591),
    [sym_kPublished] = ACTIONS(1591),
    [sym_kPublic] = ACTIONS(1591),
    [sym_kProtected] = ACTIONS(1591),
    [sym_kPrivate] = ACTIONS(1591),
    [sym_kStrict] = ACTIONS(1591),
    [sym_kRequired] = ACTIONS(1591),
    [sym_kOptional] = ACTIONS(1591),
    [sym_kStatic] = ACTIONS(1591),
    [sym_kVirtual] = ACTIONS(1591),
    [sym_kAbstract] = ACTIONS(1591),
    [sym_kDynamic] = ACTIONS(1591),
    [sym_kOverride] = ACTIONS(1591),
    [sym_kOverload] = ACTIONS(1591),
    [sym_kReintroduce] = ACTIONS(1591),
    [sym_kInline] = ACTIONS(1591),
    [sym_kStdcall] = ACTIONS(1591),
    [sym_kCdecl] = ACTIONS(1591),
    [sym_kCppdecl] = ACTIONS(1591),
    [sym_kPascal] = ACTIONS(1591),
    [sym_kRegister] = ACTIONS(1591),
    [sym_kMwpascal] = ACTIONS(1591),
    [sym_kMessage] = ACTIONS(1591),
    [sym_kDeprecated] = ACTIONS(1591),
    [sym_kExperimental] = ACTIONS(1591),
    [sym_kPlatform] = ACTIONS(1591),
    [sym_kUnimplemented] = ACTIONS(1591),
    [sym_kCvar] = ACTIONS(1591),
    [sym_kExport] = ACTIONS(1591),
    [sym_kFar] = ACTIONS(1591),
    [sym_kNear] = ACTIONS(1591),
    [sym_kSafecall] = ACTIONS(1591),
    [sym_kAssembler] = ACTIONS(1591),
    [sym_kNostackframe] = ACTIONS(1591),
    [sym_kInterrupt] = ACTIONS(1591),
    [sym_kNoreturn] = ACTIONS(1591),
    [sym_kIocheck] = ACTIONS(1591),
    [sym_kLocal] = ACTIONS(1591),
    [sym_kHardfloat] = ACTIONS(1591),
    [sym_kSoftfloat] = ACTIONS(1591),
    [sym_kMs_abi_default] = ACTIONS(1591),
    [sym_kMs_abi_cdecl] = ACTIONS(1591),
    [sym_kSaveregisters] = ACTIONS(1591),
    [sym_kSysv_abi_default] = ACTIONS(1591),
    [sym_kSysv_abi_cdecl] = ACTIONS(1591),
    [sym_kVectorcall] = ACTIONS(1591),
    [sym_kVarargs] = ACTIONS(1591),
    [sym_kWinapi] = ACTIONS(1591),
    [sym_kAlias] = ACTIONS(1591),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_COLON] = ACTIONS(2796),
    [anon_sym_COMMA] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_RBRACK] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_RPAREN] = ACTIONS(2798),
    [aux_sym__literalString_token1] = ACTIONS(2798),
    [anon_sym_POUND] = ACTIONS(2798),
    [anon_sym_DOT] = ACTIONS(2798),
    [sym_kEnd] = ACTIONS(2796),
    [sym_kVar] = ACTIONS(2796),
    [sym_kThreadvar] = ACTIONS(2796),
    [sym_kConst] = ACTIONS(2796),
    [sym_kResourcestring] = ACTIONS(2796),
    [sym_kType] = ACTIONS(2796),
    [sym_kProperty] = ACTIONS(2796),
    [sym_kClass] = ACTIONS(2796),
    [sym_kOf] = ACTIONS(2796),
    [sym_kGeneric] = ACTIONS(2796),
    [sym_kLt] = ACTIONS(2796),
    [sym_kEq] = ACTIONS(2798),
    [sym_kNeq] = ACTIONS(2798),
    [sym_kGt] = ACTIONS(2796),
    [sym_kLte] = ACTIONS(2798),
    [sym_kGte] = ACTIONS(2798),
    [sym_kAdd] = ACTIONS(2796),
    [sym_kSub] = ACTIONS(2796),
    [sym_kMul] = ACTIONS(2796),
    [sym_kFdiv] = ACTIONS(2796),
    [sym_kHat] = ACTIONS(2798),
    [sym_kAssign] = ACTIONS(2798),
    [sym_kAssignAdd] = ACTIONS(2798),
    [sym_kAssignSub] = ACTIONS(2798),
    [sym_kAssignMul] = ACTIONS(2798),
    [sym_kAssignDiv] = ACTIONS(2798),
    [sym_kOr] = ACTIONS(2796),
    [sym_kXor] = ACTIONS(2796),
    [sym_kDiv] = ACTIONS(2796),
    [sym_kMod] = ACTIONS(2796),
    [sym_kAnd] = ACTIONS(2796),
    [sym_kShl] = ACTIONS(2796),
    [sym_kShr] = ACTIONS(2796),
    [sym_kIs] = ACTIONS(2796),
    [sym_kAs] = ACTIONS(2796),
    [sym_kIn] = ACTIONS(2796),
    [sym_kThen] = ACTIONS(2796),
    [sym_kElse] = ACTIONS(2796),
    [sym_kDo] = ACTIONS(2796),
    [sym_kUntil] = ACTIONS(2796),
    [sym_kExcept] = ACTIONS(2796),
    [sym_kFinally] = ACTIONS(2796),
    [sym_kCase] = ACTIONS(2796),
    [sym_kFunction] = ACTIONS(2796),
    [sym_kProcedure] = ACTIONS(2796),
    [sym_kConstructor] = ACTIONS(2796),
    [sym_kDestructor] = ACTIONS(2796),
    [sym_kOperator] = ACTIONS(2796),
    [sym_kPublished] = ACTIONS(2796),
    [sym_kPublic] = ACTIONS(2796),
    [sym_kProtected] = ACTIONS(2796),
    [sym_kPrivate] = ACTIONS(2796),
    [sym_kStrict] = ACTIONS(2796),
    [sym_kRequired] = ACTIONS(2796),
    [sym_kOptional] = ACTIONS(2796),
    [sym_kDelayed] = ACTIONS(2796),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(475),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [aux_sym_type_token1] = ACTIONS(2198),
    [sym_kUses] = ACTIONS(2198),
    [sym_kBegin] = ACTIONS(2198),
    [sym_kAsm] = ACTIONS(2198),
    [sym_kVar] = ACTIONS(2200),
    [sym_kThreadvar] = ACTIONS(2198),
    [sym_kConst] = ACTIONS(2200),
    [sym_kResourcestring] = ACTIONS(2198),
    [sym_kType] = ACTIONS(2198),
    [sym_kLabel] = ACTIONS(2198),
    [sym_kExports] = ACTIONS(2198),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2198),
    [sym_kGeneric] = ACTIONS(2198),
    [sym_kFunction] = ACTIONS(2198),
    [sym_kProcedure] = ACTIONS(2198),
    [sym_kConstructor] = ACTIONS(2198),
    [sym_kDestructor] = ACTIONS(2198),
    [sym_kOperator] = ACTIONS(2198),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [aux_sym_type_token1] = ACTIONS(1952),
    [sym_kUses] = ACTIONS(1952),
    [sym_kBegin] = ACTIONS(1952),
    [sym_kAsm] = ACTIONS(1952),
    [sym_kVar] = ACTIONS(1954),
    [sym_kThreadvar] = ACTIONS(1952),
    [sym_kConst] = ACTIONS(1954),
    [sym_kResourcestring] = ACTIONS(1952),
    [sym_kType] = ACTIONS(1952),
    [sym_kLabel] = ACTIONS(1952),
    [sym_kExports] = ACTIONS(1952),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1952),
    [sym_kGeneric] = ACTIONS(1952),
    [sym_kFunction] = ACTIONS(1952),
    [sym_kProcedure] = ACTIONS(1952),
    [sym_kConstructor] = ACTIONS(1952),
    [sym_kDestructor] = ACTIONS(1952),
    [sym_kOperator] = ACTIONS(1952),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [aux_sym_type_token1] = ACTIONS(1945),
    [sym_kUses] = ACTIONS(1945),
    [sym_kBegin] = ACTIONS(1945),
    [sym_kAsm] = ACTIONS(1945),
    [sym_kVar] = ACTIONS(1947),
    [sym_kThreadvar] = ACTIONS(1945),
    [sym_kConst] = ACTIONS(1947),
    [sym_kResourcestring] = ACTIONS(1945),
    [sym_kType] = ACTIONS(1945),
    [sym_kLabel] = ACTIONS(1945),
    [sym_kExports] = ACTIONS(1945),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1945),
    [sym_kGeneric] = ACTIONS(1945),
    [sym_kFunction] = ACTIONS(1945),
    [sym_kProcedure] = ACTIONS(1945),
    [sym_kConstructor] = ACTIONS(1945),
    [sym_kDestructor] = ACTIONS(1945),
    [sym_kOperator] = ACTIONS(1945),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [aux_sym_type_token1] = ACTIONS(1938),
    [sym_kUses] = ACTIONS(1938),
    [sym_kBegin] = ACTIONS(1938),
    [sym_kAsm] = ACTIONS(1938),
    [sym_kVar] = ACTIONS(1940),
    [sym_kThreadvar] = ACTIONS(1938),
    [sym_kConst] = ACTIONS(1940),
    [sym_kResourcestring] = ACTIONS(1938),
    [sym_kType] = ACTIONS(1938),
    [sym_kLabel] = ACTIONS(1938),
    [sym_kExports] = ACTIONS(1938),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1938),
    [sym_kGeneric] = ACTIONS(1938),
    [sym_kFunction] = ACTIONS(1938),
    [sym_kProcedure] = ACTIONS(1938),
    [sym_kConstructor] = ACTIONS(1938),
    [sym_kDestructor] = ACTIONS(1938),
    [sym_kOperator] = ACTIONS(1938),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(507),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [aux_sym_type_token1] = ACTIONS(1931),
    [sym_kUses] = ACTIONS(1931),
    [sym_kBegin] = ACTIONS(1931),
    [sym_kAsm] = ACTIONS(1931),
    [sym_kVar] = ACTIONS(1933),
    [sym_kThreadvar] = ACTIONS(1931),
    [sym_kConst] = ACTIONS(1933),
    [sym_kResourcestring] = ACTIONS(1931),
    [sym_kType] = ACTIONS(1931),
    [sym_kLabel] = ACTIONS(1931),
    [sym_kExports] = ACTIONS(1931),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1931),
    [sym_kGeneric] = ACTIONS(1931),
    [sym_kFunction] = ACTIONS(1931),
    [sym_kProcedure] = ACTIONS(1931),
    [sym_kConstructor] = ACTIONS(1931),
    [sym_kDestructor] = ACTIONS(1931),
    [sym_kOperator] = ACTIONS(1931),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(503),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [aux_sym_type_token1] = ACTIONS(2119),
    [sym_kUses] = ACTIONS(2119),
    [sym_kBegin] = ACTIONS(2119),
    [sym_kAsm] = ACTIONS(2119),
    [sym_kVar] = ACTIONS(2121),
    [sym_kThreadvar] = ACTIONS(2119),
    [sym_kConst] = ACTIONS(2121),
    [sym_kResourcestring] = ACTIONS(2119),
    [sym_kType] = ACTIONS(2119),
    [sym_kLabel] = ACTIONS(2119),
    [sym_kExports] = ACTIONS(2119),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2119),
    [sym_kGeneric] = ACTIONS(2119),
    [sym_kFunction] = ACTIONS(2119),
    [sym_kProcedure] = ACTIONS(2119),
    [sym_kConstructor] = ACTIONS(2119),
    [sym_kDestructor] = ACTIONS(2119),
    [sym_kOperator] = ACTIONS(2119),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(505),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [aux_sym_type_token1] = ACTIONS(2249),
    [sym_kUses] = ACTIONS(2249),
    [sym_kBegin] = ACTIONS(2249),
    [sym_kAsm] = ACTIONS(2249),
    [sym_kVar] = ACTIONS(2251),
    [sym_kThreadvar] = ACTIONS(2249),
    [sym_kConst] = ACTIONS(2251),
    [sym_kResourcestring] = ACTIONS(2249),
    [sym_kType] = ACTIONS(2249),
    [sym_kLabel] = ACTIONS(2249),
    [sym_kExports] = ACTIONS(2249),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2249),
    [sym_kGeneric] = ACTIONS(2249),
    [sym_kFunction] = ACTIONS(2249),
    [sym_kProcedure] = ACTIONS(2249),
    [sym_kConstructor] = ACTIONS(2249),
    [sym_kDestructor] = ACTIONS(2249),
    [sym_kOperator] = ACTIONS(2249),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(500),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [aux_sym_type_token1] = ACTIONS(2082),
    [sym_kUses] = ACTIONS(2082),
    [sym_kBegin] = ACTIONS(2082),
    [sym_kAsm] = ACTIONS(2082),
    [sym_kVar] = ACTIONS(2084),
    [sym_kThreadvar] = ACTIONS(2082),
    [sym_kConst] = ACTIONS(2084),
    [sym_kResourcestring] = ACTIONS(2082),
    [sym_kType] = ACTIONS(2082),
    [sym_kLabel] = ACTIONS(2082),
    [sym_kExports] = ACTIONS(2082),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2082),
    [sym_kGeneric] = ACTIONS(2082),
    [sym_kFunction] = ACTIONS(2082),
    [sym_kProcedure] = ACTIONS(2082),
    [sym_kConstructor] = ACTIONS(2082),
    [sym_kDestructor] = ACTIONS(2082),
    [sym_kOperator] = ACTIONS(2082),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [anon_sym_LBRACK] = ACTIONS(2753),
    [sym_kEnd] = ACTIONS(2753),
    [sym_kVar] = ACTIONS(2755),
    [sym_kThreadvar] = ACTIONS(2753),
    [sym_kConst] = ACTIONS(2755),
    [sym_kResourcestring] = ACTIONS(2753),
    [sym_kType] = ACTIONS(2753),
    [sym_kProperty] = ACTIONS(2753),
    [sym_kDefault] = ACTIONS(2753),
    [sym_kNodefault] = ACTIONS(2753),
    [sym_kClass] = ACTIONS(2753),
    [sym_kGeneric] = ACTIONS(2753),
    [sym_kCase] = ACTIONS(2753),
    [sym_kFunction] = ACTIONS(2753),
    [sym_kProcedure] = ACTIONS(2753),
    [sym_kConstructor] = ACTIONS(2753),
    [sym_kDestructor] = ACTIONS(2753),
    [sym_kOperator] = ACTIONS(2753),
    [sym_kPublished] = ACTIONS(2753),
    [sym_kPublic] = ACTIONS(2753),
    [sym_kProtected] = ACTIONS(2753),
    [sym_kPrivate] = ACTIONS(2753),
    [sym_kStrict] = ACTIONS(2753),
    [sym_kRequired] = ACTIONS(2753),
    [sym_kOptional] = ACTIONS(2753),
    [sym_kStatic] = ACTIONS(2753),
    [sym_kVirtual] = ACTIONS(2753),
    [sym_kAbstract] = ACTIONS(2753),
    [sym_kDynamic] = ACTIONS(2753),
    [sym_kOverride] = ACTIONS(2753),
    [sym_kOverload] = ACTIONS(2753),
    [sym_kReintroduce] = ACTIONS(2753),
    [sym_kInline] = ACTIONS(2753),
    [sym_kStdcall] = ACTIONS(2753),
    [sym_kCdecl] = ACTIONS(2753),
    [sym_kCppdecl] = ACTIONS(2753),
    [sym_kPascal] = ACTIONS(2753),
    [sym_kRegister] = ACTIONS(2753),
    [sym_kMwpascal] = ACTIONS(2753),
    [sym_kMessage] = ACTIONS(2753),
    [sym_kDeprecated] = ACTIONS(2753),
    [sym_kExperimental] = ACTIONS(2753),
    [sym_kPlatform] = ACTIONS(2753),
    [sym_kUnimplemented] = ACTIONS(2753),
    [sym_kCvar] = ACTIONS(2753),
    [sym_kExport] = ACTIONS(2753),
    [sym_kFar] = ACTIONS(2753),
    [sym_kNear] = ACTIONS(2753),
    [sym_kSafecall] = ACTIONS(2753),
    [sym_kAssembler] = ACTIONS(2753),
    [sym_kNostackframe] = ACTIONS(2753),
    [sym_kInterrupt] = ACTIONS(2753),
    [sym_kNoreturn] = ACTIONS(2753),
    [sym_kIocheck] = ACTIONS(2753),
    [sym_kLocal] = ACTIONS(2753),
    [sym_kHardfloat] = ACTIONS(2753),
    [sym_kSoftfloat] = ACTIONS(2753),
    [sym_kMs_abi_default] = ACTIONS(2753),
    [sym_kMs_abi_cdecl] = ACTIONS(2753),
    [sym_kSaveregisters] = ACTIONS(2753),
    [sym_kSysv_abi_default] = ACTIONS(2753),
    [sym_kSysv_abi_cdecl] = ACTIONS(2753),
    [sym_kVectorcall] = ACTIONS(2753),
    [sym_kVarargs] = ACTIONS(2753),
    [sym_kWinapi] = ACTIONS(2753),
    [sym_kAlias] = ACTIONS(2753),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(502),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [aux_sym_type_token1] = ACTIONS(2239),
    [sym_kUses] = ACTIONS(2239),
    [sym_kBegin] = ACTIONS(2239),
    [sym_kAsm] = ACTIONS(2239),
    [sym_kVar] = ACTIONS(2241),
    [sym_kThreadvar] = ACTIONS(2239),
    [sym_kConst] = ACTIONS(2241),
    [sym_kResourcestring] = ACTIONS(2239),
    [sym_kType] = ACTIONS(2239),
    [sym_kLabel] = ACTIONS(2239),
    [sym_kExports] = ACTIONS(2239),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2239),
    [sym_kGeneric] = ACTIONS(2239),
    [sym_kFunction] = ACTIONS(2239),
    [sym_kProcedure] = ACTIONS(2239),
    [sym_kConstructor] = ACTIONS(2239),
    [sym_kDestructor] = ACTIONS(2239),
    [sym_kOperator] = ACTIONS(2239),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(493),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [aux_sym_type_token1] = ACTIONS(1995),
    [sym_kUses] = ACTIONS(1995),
    [sym_kBegin] = ACTIONS(1995),
    [sym_kAsm] = ACTIONS(1995),
    [sym_kVar] = ACTIONS(1997),
    [sym_kThreadvar] = ACTIONS(1995),
    [sym_kConst] = ACTIONS(1997),
    [sym_kResourcestring] = ACTIONS(1995),
    [sym_kType] = ACTIONS(1995),
    [sym_kLabel] = ACTIONS(1995),
    [sym_kExports] = ACTIONS(1995),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1995),
    [sym_kGeneric] = ACTIONS(1995),
    [sym_kFunction] = ACTIONS(1995),
    [sym_kProcedure] = ACTIONS(1995),
    [sym_kConstructor] = ACTIONS(1995),
    [sym_kDestructor] = ACTIONS(1995),
    [sym_kOperator] = ACTIONS(1995),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(491),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [aux_sym_type_token1] = ACTIONS(2002),
    [sym_kUses] = ACTIONS(2002),
    [sym_kBegin] = ACTIONS(2002),
    [sym_kAsm] = ACTIONS(2002),
    [sym_kVar] = ACTIONS(2004),
    [sym_kThreadvar] = ACTIONS(2002),
    [sym_kConst] = ACTIONS(2004),
    [sym_kResourcestring] = ACTIONS(2002),
    [sym_kType] = ACTIONS(2002),
    [sym_kLabel] = ACTIONS(2002),
    [sym_kExports] = ACTIONS(2002),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2002),
    [sym_kGeneric] = ACTIONS(2002),
    [sym_kFunction] = ACTIONS(2002),
    [sym_kProcedure] = ACTIONS(2002),
    [sym_kConstructor] = ACTIONS(2002),
    [sym_kDestructor] = ACTIONS(2002),
    [sym_kOperator] = ACTIONS(2002),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_kEnd] = ACTIONS(2683),
    [sym_kVar] = ACTIONS(2685),
    [sym_kThreadvar] = ACTIONS(2683),
    [sym_kConst] = ACTIONS(2685),
    [sym_kResourcestring] = ACTIONS(2683),
    [sym_kType] = ACTIONS(2683),
    [sym_kProperty] = ACTIONS(2683),
    [sym_kDefault] = ACTIONS(2683),
    [sym_kNodefault] = ACTIONS(2683),
    [sym_kClass] = ACTIONS(2683),
    [sym_kGeneric] = ACTIONS(2683),
    [sym_kCase] = ACTIONS(2683),
    [sym_kFunction] = ACTIONS(2683),
    [sym_kProcedure] = ACTIONS(2683),
    [sym_kConstructor] = ACTIONS(2683),
    [sym_kDestructor] = ACTIONS(2683),
    [sym_kOperator] = ACTIONS(2683),
    [sym_kPublished] = ACTIONS(2683),
    [sym_kPublic] = ACTIONS(2683),
    [sym_kProtected] = ACTIONS(2683),
    [sym_kPrivate] = ACTIONS(2683),
    [sym_kStrict] = ACTIONS(2683),
    [sym_kRequired] = ACTIONS(2683),
    [sym_kOptional] = ACTIONS(2683),
    [sym_kStatic] = ACTIONS(2683),
    [sym_kVirtual] = ACTIONS(2683),
    [sym_kAbstract] = ACTIONS(2683),
    [sym_kDynamic] = ACTIONS(2683),
    [sym_kOverride] = ACTIONS(2683),
    [sym_kOverload] = ACTIONS(2683),
    [sym_kReintroduce] = ACTIONS(2683),
    [sym_kInline] = ACTIONS(2683),
    [sym_kStdcall] = ACTIONS(2683),
    [sym_kCdecl] = ACTIONS(2683),
    [sym_kCppdecl] = ACTIONS(2683),
    [sym_kPascal] = ACTIONS(2683),
    [sym_kRegister] = ACTIONS(2683),
    [sym_kMwpascal] = ACTIONS(2683),
    [sym_kMessage] = ACTIONS(2683),
    [sym_kDeprecated] = ACTIONS(2683),
    [sym_kExperimental] = ACTIONS(2683),
    [sym_kPlatform] = ACTIONS(2683),
    [sym_kUnimplemented] = ACTIONS(2683),
    [sym_kCvar] = ACTIONS(2683),
    [sym_kExport] = ACTIONS(2683),
    [sym_kFar] = ACTIONS(2683),
    [sym_kNear] = ACTIONS(2683),
    [sym_kSafecall] = ACTIONS(2683),
    [sym_kAssembler] = ACTIONS(2683),
    [sym_kNostackframe] = ACTIONS(2683),
    [sym_kInterrupt] = ACTIONS(2683),
    [sym_kNoreturn] = ACTIONS(2683),
    [sym_kIocheck] = ACTIONS(2683),
    [sym_kLocal] = ACTIONS(2683),
    [sym_kHardfloat] = ACTIONS(2683),
    [sym_kSoftfloat] = ACTIONS(2683),
    [sym_kMs_abi_default] = ACTIONS(2683),
    [sym_kMs_abi_cdecl] = ACTIONS(2683),
    [sym_kSaveregisters] = ACTIONS(2683),
    [sym_kSysv_abi_default] = ACTIONS(2683),
    [sym_kSysv_abi_cdecl] = ACTIONS(2683),
    [sym_kVectorcall] = ACTIONS(2683),
    [sym_kVarargs] = ACTIONS(2683),
    [sym_kWinapi] = ACTIONS(2683),
    [sym_kAlias] = ACTIONS(2683),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [aux_sym_type_token1] = ACTIONS(2009),
    [sym_kUses] = ACTIONS(2009),
    [sym_kBegin] = ACTIONS(2009),
    [sym_kAsm] = ACTIONS(2009),
    [sym_kVar] = ACTIONS(2011),
    [sym_kThreadvar] = ACTIONS(2009),
    [sym_kConst] = ACTIONS(2011),
    [sym_kResourcestring] = ACTIONS(2009),
    [sym_kType] = ACTIONS(2009),
    [sym_kLabel] = ACTIONS(2009),
    [sym_kExports] = ACTIONS(2009),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2009),
    [sym_kGeneric] = ACTIONS(2009),
    [sym_kFunction] = ACTIONS(2009),
    [sym_kProcedure] = ACTIONS(2009),
    [sym_kConstructor] = ACTIONS(2009),
    [sym_kDestructor] = ACTIONS(2009),
    [sym_kOperator] = ACTIONS(2009),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(490),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [aux_sym_type_token1] = ACTIONS(2016),
    [sym_kUses] = ACTIONS(2016),
    [sym_kBegin] = ACTIONS(2016),
    [sym_kAsm] = ACTIONS(2016),
    [sym_kVar] = ACTIONS(2018),
    [sym_kThreadvar] = ACTIONS(2016),
    [sym_kConst] = ACTIONS(2018),
    [sym_kResourcestring] = ACTIONS(2016),
    [sym_kType] = ACTIONS(2016),
    [sym_kLabel] = ACTIONS(2016),
    [sym_kExports] = ACTIONS(2016),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2016),
    [sym_kGeneric] = ACTIONS(2016),
    [sym_kFunction] = ACTIONS(2016),
    [sym_kProcedure] = ACTIONS(2016),
    [sym_kConstructor] = ACTIONS(2016),
    [sym_kDestructor] = ACTIONS(2016),
    [sym_kOperator] = ACTIONS(2016),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [aux_sym_type_token1] = ACTIONS(2023),
    [sym_kUses] = ACTIONS(2023),
    [sym_kBegin] = ACTIONS(2023),
    [sym_kAsm] = ACTIONS(2023),
    [sym_kVar] = ACTIONS(2025),
    [sym_kThreadvar] = ACTIONS(2023),
    [sym_kConst] = ACTIONS(2025),
    [sym_kResourcestring] = ACTIONS(2023),
    [sym_kType] = ACTIONS(2023),
    [sym_kLabel] = ACTIONS(2023),
    [sym_kExports] = ACTIONS(2023),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2023),
    [sym_kGeneric] = ACTIONS(2023),
    [sym_kFunction] = ACTIONS(2023),
    [sym_kProcedure] = ACTIONS(2023),
    [sym_kConstructor] = ACTIONS(2023),
    [sym_kDestructor] = ACTIONS(2023),
    [sym_kOperator] = ACTIONS(2023),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [aux_sym_type_token1] = ACTIONS(1884),
    [sym_kUses] = ACTIONS(1884),
    [sym_kBegin] = ACTIONS(1884),
    [sym_kAsm] = ACTIONS(1884),
    [sym_kVar] = ACTIONS(1886),
    [sym_kThreadvar] = ACTIONS(1884),
    [sym_kConst] = ACTIONS(1886),
    [sym_kResourcestring] = ACTIONS(1884),
    [sym_kType] = ACTIONS(1884),
    [sym_kLabel] = ACTIONS(1884),
    [sym_kExports] = ACTIONS(1884),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1884),
    [sym_kGeneric] = ACTIONS(1884),
    [sym_kFunction] = ACTIONS(1884),
    [sym_kProcedure] = ACTIONS(1884),
    [sym_kConstructor] = ACTIONS(1884),
    [sym_kDestructor] = ACTIONS(1884),
    [sym_kOperator] = ACTIONS(1884),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2845),
    [aux_sym_type_token1] = ACTIONS(1857),
    [sym_kUses] = ACTIONS(1857),
    [sym_kBegin] = ACTIONS(1857),
    [sym_kAsm] = ACTIONS(1857),
    [sym_kVar] = ACTIONS(1859),
    [sym_kThreadvar] = ACTIONS(1857),
    [sym_kConst] = ACTIONS(1859),
    [sym_kResourcestring] = ACTIONS(1857),
    [sym_kType] = ACTIONS(1857),
    [sym_kLabel] = ACTIONS(1857),
    [sym_kExports] = ACTIONS(1857),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1857),
    [sym_kGeneric] = ACTIONS(1857),
    [sym_kFunction] = ACTIONS(1857),
    [sym_kProcedure] = ACTIONS(1857),
    [sym_kConstructor] = ACTIONS(1857),
    [sym_kDestructor] = ACTIONS(1857),
    [sym_kOperator] = ACTIONS(1857),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [anon_sym_LBRACK] = ACTIONS(2687),
    [sym_kEnd] = ACTIONS(2687),
    [sym_kVar] = ACTIONS(2689),
    [sym_kThreadvar] = ACTIONS(2687),
    [sym_kConst] = ACTIONS(2689),
    [sym_kResourcestring] = ACTIONS(2687),
    [sym_kType] = ACTIONS(2687),
    [sym_kProperty] = ACTIONS(2687),
    [sym_kDefault] = ACTIONS(2687),
    [sym_kNodefault] = ACTIONS(2687),
    [sym_kClass] = ACTIONS(2687),
    [sym_kGeneric] = ACTIONS(2687),
    [sym_kCase] = ACTIONS(2687),
    [sym_kFunction] = ACTIONS(2687),
    [sym_kProcedure] = ACTIONS(2687),
    [sym_kConstructor] = ACTIONS(2687),
    [sym_kDestructor] = ACTIONS(2687),
    [sym_kOperator] = ACTIONS(2687),
    [sym_kPublished] = ACTIONS(2687),
    [sym_kPublic] = ACTIONS(2687),
    [sym_kProtected] = ACTIONS(2687),
    [sym_kPrivate] = ACTIONS(2687),
    [sym_kStrict] = ACTIONS(2687),
    [sym_kRequired] = ACTIONS(2687),
    [sym_kOptional] = ACTIONS(2687),
    [sym_kStatic] = ACTIONS(2687),
    [sym_kVirtual] = ACTIONS(2687),
    [sym_kAbstract] = ACTIONS(2687),
    [sym_kDynamic] = ACTIONS(2687),
    [sym_kOverride] = ACTIONS(2687),
    [sym_kOverload] = ACTIONS(2687),
    [sym_kReintroduce] = ACTIONS(2687),
    [sym_kInline] = ACTIONS(2687),
    [sym_kStdcall] = ACTIONS(2687),
    [sym_kCdecl] = ACTIONS(2687),
    [sym_kCppdecl] = ACTIONS(2687),
    [sym_kPascal] = ACTIONS(2687),
    [sym_kRegister] = ACTIONS(2687),
    [sym_kMwpascal] = ACTIONS(2687),
    [sym_kMessage] = ACTIONS(2687),
    [sym_kDeprecated] = ACTIONS(2687),
    [sym_kExperimental] = ACTIONS(2687),
    [sym_kPlatform] = ACTIONS(2687),
    [sym_kUnimplemented] = ACTIONS(2687),
    [sym_kCvar] = ACTIONS(2687),
    [sym_kExport] = ACTIONS(2687),
    [sym_kFar] = ACTIONS(2687),
    [sym_kNear] = ACTIONS(2687),
    [sym_kSafecall] = ACTIONS(2687),
    [sym_kAssembler] = ACTIONS(2687),
    [sym_kNostackframe] = ACTIONS(2687),
    [sym_kInterrupt] = ACTIONS(2687),
    [sym_kNoreturn] = ACTIONS(2687),
    [sym_kIocheck] = ACTIONS(2687),
    [sym_kLocal] = ACTIONS(2687),
    [sym_kHardfloat] = ACTIONS(2687),
    [sym_kSoftfloat] = ACTIONS(2687),
    [sym_kMs_abi_default] = ACTIONS(2687),
    [sym_kMs_abi_cdecl] = ACTIONS(2687),
    [sym_kSaveregisters] = ACTIONS(2687),
    [sym_kSysv_abi_default] = ACTIONS(2687),
    [sym_kSysv_abi_cdecl] = ACTIONS(2687),
    [sym_kVectorcall] = ACTIONS(2687),
    [sym_kVarargs] = ACTIONS(2687),
    [sym_kWinapi] = ACTIONS(2687),
    [sym_kAlias] = ACTIONS(2687),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2848),
    [aux_sym_type_token1] = ACTIONS(1850),
    [sym_kUses] = ACTIONS(1850),
    [sym_kBegin] = ACTIONS(1850),
    [sym_kAsm] = ACTIONS(1850),
    [sym_kVar] = ACTIONS(1852),
    [sym_kThreadvar] = ACTIONS(1850),
    [sym_kConst] = ACTIONS(1852),
    [sym_kResourcestring] = ACTIONS(1850),
    [sym_kType] = ACTIONS(1850),
    [sym_kLabel] = ACTIONS(1850),
    [sym_kExports] = ACTIONS(1850),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1850),
    [sym_kGeneric] = ACTIONS(1850),
    [sym_kFunction] = ACTIONS(1850),
    [sym_kProcedure] = ACTIONS(1850),
    [sym_kConstructor] = ACTIONS(1850),
    [sym_kDestructor] = ACTIONS(1850),
    [sym_kOperator] = ACTIONS(1850),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [anon_sym_LBRACK] = ACTIONS(2706),
    [sym_kEnd] = ACTIONS(2706),
    [sym_kVar] = ACTIONS(2708),
    [sym_kThreadvar] = ACTIONS(2706),
    [sym_kConst] = ACTIONS(2708),
    [sym_kResourcestring] = ACTIONS(2706),
    [sym_kType] = ACTIONS(2706),
    [sym_kProperty] = ACTIONS(2706),
    [sym_kDefault] = ACTIONS(2706),
    [sym_kNodefault] = ACTIONS(2706),
    [sym_kClass] = ACTIONS(2706),
    [sym_kGeneric] = ACTIONS(2706),
    [sym_kCase] = ACTIONS(2706),
    [sym_kFunction] = ACTIONS(2706),
    [sym_kProcedure] = ACTIONS(2706),
    [sym_kConstructor] = ACTIONS(2706),
    [sym_kDestructor] = ACTIONS(2706),
    [sym_kOperator] = ACTIONS(2706),
    [sym_kPublished] = ACTIONS(2706),
    [sym_kPublic] = ACTIONS(2706),
    [sym_kProtected] = ACTIONS(2706),
    [sym_kPrivate] = ACTIONS(2706),
    [sym_kStrict] = ACTIONS(2706),
    [sym_kRequired] = ACTIONS(2706),
    [sym_kOptional] = ACTIONS(2706),
    [sym_kStatic] = ACTIONS(2706),
    [sym_kVirtual] = ACTIONS(2706),
    [sym_kAbstract] = ACTIONS(2706),
    [sym_kDynamic] = ACTIONS(2706),
    [sym_kOverride] = ACTIONS(2706),
    [sym_kOverload] = ACTIONS(2706),
    [sym_kReintroduce] = ACTIONS(2706),
    [sym_kInline] = ACTIONS(2706),
    [sym_kStdcall] = ACTIONS(2706),
    [sym_kCdecl] = ACTIONS(2706),
    [sym_kCppdecl] = ACTIONS(2706),
    [sym_kPascal] = ACTIONS(2706),
    [sym_kRegister] = ACTIONS(2706),
    [sym_kMwpascal] = ACTIONS(2706),
    [sym_kMessage] = ACTIONS(2706),
    [sym_kDeprecated] = ACTIONS(2706),
    [sym_kExperimental] = ACTIONS(2706),
    [sym_kPlatform] = ACTIONS(2706),
    [sym_kUnimplemented] = ACTIONS(2706),
    [sym_kCvar] = ACTIONS(2706),
    [sym_kExport] = ACTIONS(2706),
    [sym_kFar] = ACTIONS(2706),
    [sym_kNear] = ACTIONS(2706),
    [sym_kSafecall] = ACTIONS(2706),
    [sym_kAssembler] = ACTIONS(2706),
    [sym_kNostackframe] = ACTIONS(2706),
    [sym_kInterrupt] = ACTIONS(2706),
    [sym_kNoreturn] = ACTIONS(2706),
    [sym_kIocheck] = ACTIONS(2706),
    [sym_kLocal] = ACTIONS(2706),
    [sym_kHardfloat] = ACTIONS(2706),
    [sym_kSoftfloat] = ACTIONS(2706),
    [sym_kMs_abi_default] = ACTIONS(2706),
    [sym_kMs_abi_cdecl] = ACTIONS(2706),
    [sym_kSaveregisters] = ACTIONS(2706),
    [sym_kSysv_abi_default] = ACTIONS(2706),
    [sym_kSysv_abi_cdecl] = ACTIONS(2706),
    [sym_kVectorcall] = ACTIONS(2706),
    [sym_kVarargs] = ACTIONS(2706),
    [sym_kWinapi] = ACTIONS(2706),
    [sym_kAlias] = ACTIONS(2706),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [anon_sym_LBRACK] = ACTIONS(2719),
    [sym_kEnd] = ACTIONS(2719),
    [sym_kVar] = ACTIONS(2721),
    [sym_kThreadvar] = ACTIONS(2719),
    [sym_kConst] = ACTIONS(2721),
    [sym_kResourcestring] = ACTIONS(2719),
    [sym_kType] = ACTIONS(2719),
    [sym_kProperty] = ACTIONS(2719),
    [sym_kDefault] = ACTIONS(2719),
    [sym_kNodefault] = ACTIONS(2719),
    [sym_kClass] = ACTIONS(2719),
    [sym_kGeneric] = ACTIONS(2719),
    [sym_kCase] = ACTIONS(2719),
    [sym_kFunction] = ACTIONS(2719),
    [sym_kProcedure] = ACTIONS(2719),
    [sym_kConstructor] = ACTIONS(2719),
    [sym_kDestructor] = ACTIONS(2719),
    [sym_kOperator] = ACTIONS(2719),
    [sym_kPublished] = ACTIONS(2719),
    [sym_kPublic] = ACTIONS(2719),
    [sym_kProtected] = ACTIONS(2719),
    [sym_kPrivate] = ACTIONS(2719),
    [sym_kStrict] = ACTIONS(2719),
    [sym_kRequired] = ACTIONS(2719),
    [sym_kOptional] = ACTIONS(2719),
    [sym_kStatic] = ACTIONS(2719),
    [sym_kVirtual] = ACTIONS(2719),
    [sym_kAbstract] = ACTIONS(2719),
    [sym_kDynamic] = ACTIONS(2719),
    [sym_kOverride] = ACTIONS(2719),
    [sym_kOverload] = ACTIONS(2719),
    [sym_kReintroduce] = ACTIONS(2719),
    [sym_kInline] = ACTIONS(2719),
    [sym_kStdcall] = ACTIONS(2719),
    [sym_kCdecl] = ACTIONS(2719),
    [sym_kCppdecl] = ACTIONS(2719),
    [sym_kPascal] = ACTIONS(2719),
    [sym_kRegister] = ACTIONS(2719),
    [sym_kMwpascal] = ACTIONS(2719),
    [sym_kMessage] = ACTIONS(2719),
    [sym_kDeprecated] = ACTIONS(2719),
    [sym_kExperimental] = ACTIONS(2719),
    [sym_kPlatform] = ACTIONS(2719),
    [sym_kUnimplemented] = ACTIONS(2719),
    [sym_kCvar] = ACTIONS(2719),
    [sym_kExport] = ACTIONS(2719),
    [sym_kFar] = ACTIONS(2719),
    [sym_kNear] = ACTIONS(2719),
    [sym_kSafecall] = ACTIONS(2719),
    [sym_kAssembler] = ACTIONS(2719),
    [sym_kNostackframe] = ACTIONS(2719),
    [sym_kInterrupt] = ACTIONS(2719),
    [sym_kNoreturn] = ACTIONS(2719),
    [sym_kIocheck] = ACTIONS(2719),
    [sym_kLocal] = ACTIONS(2719),
    [sym_kHardfloat] = ACTIONS(2719),
    [sym_kSoftfloat] = ACTIONS(2719),
    [sym_kMs_abi_default] = ACTIONS(2719),
    [sym_kMs_abi_cdecl] = ACTIONS(2719),
    [sym_kSaveregisters] = ACTIONS(2719),
    [sym_kSysv_abi_default] = ACTIONS(2719),
    [sym_kSysv_abi_cdecl] = ACTIONS(2719),
    [sym_kVectorcall] = ACTIONS(2719),
    [sym_kVarargs] = ACTIONS(2719),
    [sym_kWinapi] = ACTIONS(2719),
    [sym_kAlias] = ACTIONS(2719),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(498),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [aux_sym_type_token1] = ACTIONS(1843),
    [sym_kUses] = ACTIONS(1843),
    [sym_kBegin] = ACTIONS(1843),
    [sym_kAsm] = ACTIONS(1843),
    [sym_kVar] = ACTIONS(1845),
    [sym_kThreadvar] = ACTIONS(1843),
    [sym_kConst] = ACTIONS(1845),
    [sym_kResourcestring] = ACTIONS(1843),
    [sym_kType] = ACTIONS(1843),
    [sym_kLabel] = ACTIONS(1843),
    [sym_kExports] = ACTIONS(1843),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1843),
    [sym_kGeneric] = ACTIONS(1843),
    [sym_kFunction] = ACTIONS(1843),
    [sym_kProcedure] = ACTIONS(1843),
    [sym_kConstructor] = ACTIONS(1843),
    [sym_kDestructor] = ACTIONS(1843),
    [sym_kOperator] = ACTIONS(1843),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [aux_sym_type_token1] = ACTIONS(2030),
    [sym_kUses] = ACTIONS(2030),
    [sym_kBegin] = ACTIONS(2030),
    [sym_kAsm] = ACTIONS(2030),
    [sym_kVar] = ACTIONS(2032),
    [sym_kThreadvar] = ACTIONS(2030),
    [sym_kConst] = ACTIONS(2032),
    [sym_kResourcestring] = ACTIONS(2030),
    [sym_kType] = ACTIONS(2030),
    [sym_kLabel] = ACTIONS(2030),
    [sym_kExports] = ACTIONS(2030),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2030),
    [sym_kGeneric] = ACTIONS(2030),
    [sym_kFunction] = ACTIONS(2030),
    [sym_kProcedure] = ACTIONS(2030),
    [sym_kConstructor] = ACTIONS(2030),
    [sym_kDestructor] = ACTIONS(2030),
    [sym_kOperator] = ACTIONS(2030),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [aux_sym_type_token1] = ACTIONS(1713),
    [sym_kUses] = ACTIONS(1713),
    [sym_kBegin] = ACTIONS(1713),
    [sym_kAsm] = ACTIONS(1713),
    [sym_kVar] = ACTIONS(1715),
    [sym_kThreadvar] = ACTIONS(1713),
    [sym_kConst] = ACTIONS(1715),
    [sym_kResourcestring] = ACTIONS(1713),
    [sym_kType] = ACTIONS(1713),
    [sym_kLabel] = ACTIONS(1713),
    [sym_kExports] = ACTIONS(1713),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1713),
    [sym_kGeneric] = ACTIONS(1713),
    [sym_kFunction] = ACTIONS(1713),
    [sym_kProcedure] = ACTIONS(1713),
    [sym_kConstructor] = ACTIONS(1713),
    [sym_kDestructor] = ACTIONS(1713),
    [sym_kOperator] = ACTIONS(1713),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(501),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [aux_sym_type_token1] = ACTIONS(2229),
    [sym_kUses] = ACTIONS(2229),
    [sym_kBegin] = ACTIONS(2229),
    [sym_kAsm] = ACTIONS(2229),
    [sym_kVar] = ACTIONS(2231),
    [sym_kThreadvar] = ACTIONS(2229),
    [sym_kConst] = ACTIONS(2231),
    [sym_kResourcestring] = ACTIONS(2229),
    [sym_kType] = ACTIONS(2229),
    [sym_kLabel] = ACTIONS(2229),
    [sym_kExports] = ACTIONS(2229),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2229),
    [sym_kGeneric] = ACTIONS(2229),
    [sym_kFunction] = ACTIONS(2229),
    [sym_kProcedure] = ACTIONS(2229),
    [sym_kConstructor] = ACTIONS(2229),
    [sym_kDestructor] = ACTIONS(2229),
    [sym_kOperator] = ACTIONS(2229),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [aux_sym_type_token1] = ACTIONS(2205),
    [sym_kUses] = ACTIONS(2205),
    [sym_kBegin] = ACTIONS(2205),
    [sym_kAsm] = ACTIONS(2205),
    [sym_kVar] = ACTIONS(2207),
    [sym_kThreadvar] = ACTIONS(2205),
    [sym_kConst] = ACTIONS(2207),
    [sym_kResourcestring] = ACTIONS(2205),
    [sym_kType] = ACTIONS(2205),
    [sym_kLabel] = ACTIONS(2205),
    [sym_kExports] = ACTIONS(2205),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2205),
    [sym_kGeneric] = ACTIONS(2205),
    [sym_kFunction] = ACTIONS(2205),
    [sym_kProcedure] = ACTIONS(2205),
    [sym_kConstructor] = ACTIONS(2205),
    [sym_kDestructor] = ACTIONS(2205),
    [sym_kOperator] = ACTIONS(2205),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [aux_sym_type_token1] = ACTIONS(2222),
    [sym_kUses] = ACTIONS(2222),
    [sym_kBegin] = ACTIONS(2222),
    [sym_kAsm] = ACTIONS(2222),
    [sym_kVar] = ACTIONS(2224),
    [sym_kThreadvar] = ACTIONS(2222),
    [sym_kConst] = ACTIONS(2224),
    [sym_kResourcestring] = ACTIONS(2222),
    [sym_kType] = ACTIONS(2222),
    [sym_kLabel] = ACTIONS(2222),
    [sym_kExports] = ACTIONS(2222),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2222),
    [sym_kGeneric] = ACTIONS(2222),
    [sym_kFunction] = ACTIONS(2222),
    [sym_kProcedure] = ACTIONS(2222),
    [sym_kConstructor] = ACTIONS(2222),
    [sym_kDestructor] = ACTIONS(2222),
    [sym_kOperator] = ACTIONS(2222),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [aux_sym_type_token1] = ACTIONS(2215),
    [sym_kUses] = ACTIONS(2215),
    [sym_kBegin] = ACTIONS(2215),
    [sym_kAsm] = ACTIONS(2215),
    [sym_kVar] = ACTIONS(2217),
    [sym_kThreadvar] = ACTIONS(2215),
    [sym_kConst] = ACTIONS(2217),
    [sym_kResourcestring] = ACTIONS(2215),
    [sym_kType] = ACTIONS(2215),
    [sym_kLabel] = ACTIONS(2215),
    [sym_kExports] = ACTIONS(2215),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2215),
    [sym_kGeneric] = ACTIONS(2215),
    [sym_kFunction] = ACTIONS(2215),
    [sym_kProcedure] = ACTIONS(2215),
    [sym_kConstructor] = ACTIONS(2215),
    [sym_kDestructor] = ACTIONS(2215),
    [sym_kOperator] = ACTIONS(2215),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2872),
    [aux_sym_type_token1] = ACTIONS(2286),
    [sym_kUses] = ACTIONS(2286),
    [sym_kBegin] = ACTIONS(2286),
    [sym_kAsm] = ACTIONS(2286),
    [sym_kVar] = ACTIONS(2288),
    [sym_kThreadvar] = ACTIONS(2286),
    [sym_kConst] = ACTIONS(2288),
    [sym_kResourcestring] = ACTIONS(2286),
    [sym_kType] = ACTIONS(2286),
    [sym_kLabel] = ACTIONS(2286),
    [sym_kExports] = ACTIONS(2286),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2286),
    [sym_kGeneric] = ACTIONS(2286),
    [sym_kFunction] = ACTIONS(2286),
    [sym_kProcedure] = ACTIONS(2286),
    [sym_kConstructor] = ACTIONS(2286),
    [sym_kDestructor] = ACTIONS(2286),
    [sym_kOperator] = ACTIONS(2286),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_COLON] = ACTIONS(2875),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_RBRACK] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2875),
    [sym_kEnd] = ACTIONS(2875),
    [sym_kVar] = ACTIONS(2875),
    [sym_kThreadvar] = ACTIONS(2875),
    [sym_kConst] = ACTIONS(2875),
    [sym_kResourcestring] = ACTIONS(2875),
    [sym_kType] = ACTIONS(2875),
    [sym_kProperty] = ACTIONS(2875),
    [sym_kClass] = ACTIONS(2875),
    [sym_kOf] = ACTIONS(2875),
    [sym_kGeneric] = ACTIONS(2875),
    [sym_kLt] = ACTIONS(2875),
    [sym_kEq] = ACTIONS(2877),
    [sym_kNeq] = ACTIONS(2877),
    [sym_kGt] = ACTIONS(2875),
    [sym_kLte] = ACTIONS(2877),
    [sym_kGte] = ACTIONS(2877),
    [sym_kAdd] = ACTIONS(2875),
    [sym_kSub] = ACTIONS(2875),
    [sym_kMul] = ACTIONS(2875),
    [sym_kFdiv] = ACTIONS(2875),
    [sym_kHat] = ACTIONS(2877),
    [sym_kAssign] = ACTIONS(2877),
    [sym_kAssignAdd] = ACTIONS(2877),
    [sym_kAssignSub] = ACTIONS(2877),
    [sym_kAssignMul] = ACTIONS(2877),
    [sym_kAssignDiv] = ACTIONS(2877),
    [sym_kOr] = ACTIONS(2875),
    [sym_kXor] = ACTIONS(2875),
    [sym_kDiv] = ACTIONS(2875),
    [sym_kMod] = ACTIONS(2875),
    [sym_kAnd] = ACTIONS(2875),
    [sym_kShl] = ACTIONS(2875),
    [sym_kShr] = ACTIONS(2875),
    [sym_kIs] = ACTIONS(2875),
    [sym_kAs] = ACTIONS(2875),
    [sym_kIn] = ACTIONS(2875),
    [sym_kThen] = ACTIONS(2875),
    [sym_kElse] = ACTIONS(2875),
    [sym_kDo] = ACTIONS(2875),
    [sym_kUntil] = ACTIONS(2875),
    [sym_kExcept] = ACTIONS(2875),
    [sym_kFinally] = ACTIONS(2875),
    [sym_kCase] = ACTIONS(2875),
    [sym_kFunction] = ACTIONS(2875),
    [sym_kProcedure] = ACTIONS(2875),
    [sym_kConstructor] = ACTIONS(2875),
    [sym_kDestructor] = ACTIONS(2875),
    [sym_kOperator] = ACTIONS(2875),
    [sym_kPublished] = ACTIONS(2875),
    [sym_kPublic] = ACTIONS(2875),
    [sym_kProtected] = ACTIONS(2875),
    [sym_kPrivate] = ACTIONS(2875),
    [sym_kStrict] = ACTIONS(2875),
    [sym_kRequired] = ACTIONS(2875),
    [sym_kOptional] = ACTIONS(2875),
    [sym_kDelayed] = ACTIONS(2875),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [aux_sym_type_token1] = ACTIONS(2185),
    [sym_kUses] = ACTIONS(2185),
    [sym_kBegin] = ACTIONS(2185),
    [sym_kAsm] = ACTIONS(2185),
    [sym_kVar] = ACTIONS(2187),
    [sym_kThreadvar] = ACTIONS(2185),
    [sym_kConst] = ACTIONS(2187),
    [sym_kResourcestring] = ACTIONS(2185),
    [sym_kType] = ACTIONS(2185),
    [sym_kLabel] = ACTIONS(2185),
    [sym_kExports] = ACTIONS(2185),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2185),
    [sym_kGeneric] = ACTIONS(2185),
    [sym_kFunction] = ACTIONS(2185),
    [sym_kProcedure] = ACTIONS(2185),
    [sym_kConstructor] = ACTIONS(2185),
    [sym_kDestructor] = ACTIONS(2185),
    [sym_kOperator] = ACTIONS(2185),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(497),
    [anon_sym_LBRACK] = ACTIONS(2882),
    [aux_sym_type_token1] = ACTIONS(2296),
    [sym_kUses] = ACTIONS(2296),
    [sym_kBegin] = ACTIONS(2296),
    [sym_kAsm] = ACTIONS(2296),
    [sym_kVar] = ACTIONS(2298),
    [sym_kThreadvar] = ACTIONS(2296),
    [sym_kConst] = ACTIONS(2298),
    [sym_kResourcestring] = ACTIONS(2296),
    [sym_kType] = ACTIONS(2296),
    [sym_kLabel] = ACTIONS(2296),
    [sym_kExports] = ACTIONS(2296),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2296),
    [sym_kGeneric] = ACTIONS(2296),
    [sym_kFunction] = ACTIONS(2296),
    [sym_kProcedure] = ACTIONS(2296),
    [sym_kConstructor] = ACTIONS(2296),
    [sym_kDestructor] = ACTIONS(2296),
    [sym_kOperator] = ACTIONS(2296),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(471),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [aux_sym_type_token1] = ACTIONS(1790),
    [sym_kUses] = ACTIONS(1790),
    [sym_kBegin] = ACTIONS(1790),
    [sym_kAsm] = ACTIONS(1790),
    [sym_kVar] = ACTIONS(1792),
    [sym_kThreadvar] = ACTIONS(1790),
    [sym_kConst] = ACTIONS(1792),
    [sym_kResourcestring] = ACTIONS(1790),
    [sym_kType] = ACTIONS(1790),
    [sym_kLabel] = ACTIONS(1790),
    [sym_kExports] = ACTIONS(1790),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(1790),
    [sym_kGeneric] = ACTIONS(1790),
    [sym_kFunction] = ACTIONS(1790),
    [sym_kProcedure] = ACTIONS(1790),
    [sym_kConstructor] = ACTIONS(1790),
    [sym_kDestructor] = ACTIONS(1790),
    [sym_kOperator] = ACTIONS(1790),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(476),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [aux_sym_type_token1] = ACTIONS(2178),
    [sym_kUses] = ACTIONS(2178),
    [sym_kBegin] = ACTIONS(2178),
    [sym_kAsm] = ACTIONS(2178),
    [sym_kVar] = ACTIONS(2180),
    [sym_kThreadvar] = ACTIONS(2178),
    [sym_kConst] = ACTIONS(2180),
    [sym_kResourcestring] = ACTIONS(2178),
    [sym_kType] = ACTIONS(2178),
    [sym_kLabel] = ACTIONS(2178),
    [sym_kExports] = ACTIONS(2178),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2178),
    [sym_kGeneric] = ACTIONS(2178),
    [sym_kFunction] = ACTIONS(2178),
    [sym_kProcedure] = ACTIONS(2178),
    [sym_kConstructor] = ACTIONS(2178),
    [sym_kDestructor] = ACTIONS(2178),
    [sym_kOperator] = ACTIONS(2178),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(489),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [aux_sym_type_token1] = ACTIONS(2313),
    [sym_kUses] = ACTIONS(2313),
    [sym_kBegin] = ACTIONS(2313),
    [sym_kAsm] = ACTIONS(2313),
    [sym_kVar] = ACTIONS(2315),
    [sym_kThreadvar] = ACTIONS(2313),
    [sym_kConst] = ACTIONS(2315),
    [sym_kResourcestring] = ACTIONS(2313),
    [sym_kType] = ACTIONS(2313),
    [sym_kLabel] = ACTIONS(2313),
    [sym_kExports] = ACTIONS(2313),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2313),
    [sym_kGeneric] = ACTIONS(2313),
    [sym_kFunction] = ACTIONS(2313),
    [sym_kProcedure] = ACTIONS(2313),
    [sym_kConstructor] = ACTIONS(2313),
    [sym_kDestructor] = ACTIONS(2313),
    [sym_kOperator] = ACTIONS(2313),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(487),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [aux_sym_type_token1] = ACTIONS(2306),
    [sym_kUses] = ACTIONS(2306),
    [sym_kBegin] = ACTIONS(2306),
    [sym_kAsm] = ACTIONS(2306),
    [sym_kVar] = ACTIONS(2308),
    [sym_kThreadvar] = ACTIONS(2306),
    [sym_kConst] = ACTIONS(2308),
    [sym_kResourcestring] = ACTIONS(2306),
    [sym_kType] = ACTIONS(2306),
    [sym_kLabel] = ACTIONS(2306),
    [sym_kExports] = ACTIONS(2306),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2306),
    [sym_kGeneric] = ACTIONS(2306),
    [sym_kFunction] = ACTIONS(2306),
    [sym_kProcedure] = ACTIONS(2306),
    [sym_kConstructor] = ACTIONS(2306),
    [sym_kDestructor] = ACTIONS(2306),
    [sym_kOperator] = ACTIONS(2306),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [sym__procAttributeNoExt] = STATE(521),
    [sym_procAttribute] = STATE(2293),
    [aux_sym__declProc_repeat1] = STATE(477),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [aux_sym_type_token1] = ACTIONS(2171),
    [sym_kUses] = ACTIONS(2171),
    [sym_kBegin] = ACTIONS(2171),
    [sym_kAsm] = ACTIONS(2171),
    [sym_kVar] = ACTIONS(2173),
    [sym_kThreadvar] = ACTIONS(2171),
    [sym_kConst] = ACTIONS(2173),
    [sym_kResourcestring] = ACTIONS(2171),
    [sym_kType] = ACTIONS(2171),
    [sym_kLabel] = ACTIONS(2171),
    [sym_kExports] = ACTIONS(2171),
    [sym_kDefault] = ACTIONS(878),
    [sym_kNodefault] = ACTIONS(878),
    [sym_kClass] = ACTIONS(2171),
    [sym_kGeneric] = ACTIONS(2171),
    [sym_kFunction] = ACTIONS(2171),
    [sym_kProcedure] = ACTIONS(2171),
    [sym_kConstructor] = ACTIONS(2171),
    [sym_kDestructor] = ACTIONS(2171),
    [sym_kOperator] = ACTIONS(2171),
    [sym_kPublic] = ACTIONS(880),
    [sym_kStatic] = ACTIONS(878),
    [sym_kVirtual] = ACTIONS(878),
    [sym_kAbstract] = ACTIONS(878),
    [sym_kDynamic] = ACTIONS(878),
    [sym_kOverride] = ACTIONS(878),
    [sym_kOverload] = ACTIONS(878),
    [sym_kReintroduce] = ACTIONS(878),
    [sym_kInline] = ACTIONS(878),
    [sym_kStdcall] = ACTIONS(878),
    [sym_kCdecl] = ACTIONS(878),
    [sym_kCppdecl] = ACTIONS(878),
    [sym_kPascal] = ACTIONS(878),
    [sym_kRegister] = ACTIONS(878),
    [sym_kMwpascal] = ACTIONS(878),
    [sym_kMessage] = ACTIONS(882),
    [sym_kDeprecated] = ACTIONS(884),
    [sym_kExperimental] = ACTIONS(878),
    [sym_kPlatform] = ACTIONS(878),
    [sym_kUnimplemented] = ACTIONS(878),
    [sym_kCvar] = ACTIONS(878),
    [sym_kExport] = ACTIONS(306),
    [sym_kFar] = ACTIONS(878),
    [sym_kNear] = ACTIONS(878),
    [sym_kSafecall] = ACTIONS(878),
    [sym_kAssembler] = ACTIONS(878),
    [sym_kNostackframe] = ACTIONS(878),
    [sym_kInterrupt] = ACTIONS(878),
    [sym_kNoreturn] = ACTIONS(878),
    [sym_kIocheck] = ACTIONS(878),
    [sym_kLocal] = ACTIONS(878),
    [sym_kHardfloat] = ACTIONS(878),
    [sym_kSoftfloat] = ACTIONS(878),
    [sym_kMs_abi_default] = ACTIONS(878),
    [sym_kMs_abi_cdecl] = ACTIONS(878),
    [sym_kSaveregisters] = ACTIONS(878),
    [sym_kSysv_abi_default] = ACTIONS(878),
    [sym_kSysv_abi_cdecl] = ACTIONS(878),
    [sym_kVectorcall] = ACTIONS(878),
    [sym_kVarargs] = ACTIONS(878),
    [sym_kWinapi] = ACTIONS(878),
    [sym_kAlias] = ACTIONS(886),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_COLON] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [sym_kEnd] = ACTIONS(2900),
    [sym_kVar] = ACTIONS(2900),
    [sym_kThreadvar] = ACTIONS(2900),
    [sym_kConst] = ACTIONS(2900),
    [sym_kResourcestring] = ACTIONS(2900),
    [sym_kType] = ACTIONS(2900),
    [sym_kProperty] = ACTIONS(2900),
    [sym_kClass] = ACTIONS(2900),
    [sym_kOf] = ACTIONS(2900),
    [sym_kGeneric] = ACTIONS(2900),
    [sym_kLt] = ACTIONS(2900),
    [sym_kEq] = ACTIONS(2902),
    [sym_kNeq] = ACTIONS(2902),
    [sym_kGt] = ACTIONS(2900),
    [sym_kLte] = ACTIONS(2902),
    [sym_kGte] = ACTIONS(2902),
    [sym_kAdd] = ACTIONS(2900),
    [sym_kSub] = ACTIONS(2900),
    [sym_kMul] = ACTIONS(2900),
    [sym_kFdiv] = ACTIONS(2900),
    [sym_kHat] = ACTIONS(2904),
    [sym_kAssign] = ACTIONS(2902),
    [sym_kAssignAdd] = ACTIONS(2902),
    [sym_kAssignSub] = ACTIONS(2902),
    [sym_kAssignMul] = ACTIONS(2902),
    [sym_kAssignDiv] = ACTIONS(2902),
    [sym_kOr] = ACTIONS(2900),
    [sym_kXor] = ACTIONS(2900),
    [sym_kDiv] = ACTIONS(2900),
    [sym_kMod] = ACTIONS(2900),
    [sym_kAnd] = ACTIONS(2900),
    [sym_kShl] = ACTIONS(2900),
    [sym_kShr] = ACTIONS(2900),
    [sym_kIs] = ACTIONS(2900),
    [sym_kAs] = ACTIONS(2900),
    [sym_kIn] = ACTIONS(2900),
    [sym_kThen] = ACTIONS(2900),
    [sym_kElse] = ACTIONS(2900),
    [sym_kDo] = ACTIONS(2900),
    [sym_kUntil] = ACTIONS(2900),
    [sym_kExcept] = ACTIONS(2900),
    [sym_kFinally] = ACTIONS(2900),
    [sym_kCase] = ACTIONS(2900),
    [sym_kFunction] = ACTIONS(2900),
    [sym_kProcedure] = ACTIONS(2900),
    [sym_kConstructor] = ACTIONS(2900),
    [sym_kDestructor] = ACTIONS(2900),
    [sym_kOperator] = ACTIONS(2900),
    [sym_kPublished] = ACTIONS(2900),
    [sym_kPublic] = ACTIONS(2900),
    [sym_kProtected] = ACTIONS(2900),
    [sym_kPrivate] = ACTIONS(2900),
    [sym_kStrict] = ACTIONS(2900),
    [sym_kRequired] = ACTIONS(2900),
    [sym_kOptional] = ACTIONS(2900),
    [sym_kDelayed] = ACTIONS(2900),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [sym__visibility] = STATE(966),
    [aux_sym__classDeclarations] = STATE(965),
    [sym_declTypes] = STATE(965),
    [sym_declVars] = STATE(965),
    [sym_declConsts] = STATE(965),
    [sym_declProc] = STATE(965),
    [sym__declClass] = STATE(2372),
    [sym_declSection] = STATE(1457),
    [aux_sym__declFields] = STATE(854),
    [sym_declField] = STATE(854),
    [sym_declProp] = STATE(965),
    [sym_declVariant] = STATE(2284),
    [sym__declProc] = STATE(1359),
    [sym__declOperator] = STATE(1099),
    [sym_rttiAttributes] = STATE(1483),
    [aux_sym_genericArg_repeat1] = STATE(2004),
    [aux_sym__declClass_repeat1] = STATE(1457),
    [aux_sym_rttiAttributes_repeat2] = STATE(1485),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [sym_kEnd] = ACTIONS(2912),
    [sym_kVar] = ACTIONS(2914),
    [sym_kThreadvar] = ACTIONS(2914),
    [sym_kConst] = ACTIONS(2916),
    [sym_kResourcestring] = ACTIONS(2916),
    [sym_kType] = ACTIONS(2918),
    [sym_kProperty] = ACTIONS(2920),
    [sym_kClass] = ACTIONS(2922),
    [sym_kGeneric] = ACTIONS(2924),
    [sym_kLt] = ACTIONS(2926),
    [sym_kEq] = ACTIONS(2928),
    [sym_kNeq] = ACTIONS(2928),
    [sym_kGt] = ACTIONS(2926),
    [sym_kLte] = ACTIONS(2928),
    [sym_kGte] = ACTIONS(2928),
    [sym_kAdd] = ACTIONS(2930),
    [sym_kSub] = ACTIONS(2930),
    [sym_kMul] = ACTIONS(2932),
    [sym_kFdiv] = ACTIONS(2934),
    [sym_kHat] = ACTIONS(2904),
    [sym_kOr] = ACTIONS(2936),
    [sym_kXor] = ACTIONS(2936),
    [sym_kDiv] = ACTIONS(2934),
    [sym_kMod] = ACTIONS(2934),
    [sym_kAnd] = ACTIONS(2934),
    [sym_kShl] = ACTIONS(2934),
    [sym_kShr] = ACTIONS(2934),
    [sym_kIs] = ACTIONS(2926),
    [sym_kAs] = ACTIONS(2938),
    [sym_kIn] = ACTIONS(2926),
    [sym_kCase] = ACTIONS(2940),
    [sym_kFunction] = ACTIONS(2942),
    [sym_kProcedure] = ACTIONS(2942),
    [sym_kConstructor] = ACTIONS(2942),
    [sym_kDestructor] = ACTIONS(2942),
    [sym_kOperator] = ACTIONS(2944),
    [sym_kPublished] = ACTIONS(2946),
    [sym_kPublic] = ACTIONS(2946),
    [sym_kProtected] = ACTIONS(2946),
    [sym_kPrivate] = ACTIONS(2946),
    [sym_kStrict] = ACTIONS(2948),
    [sym_kRequired] = ACTIONS(2946),
    [sym_kOptional] = ACTIONS(2946),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_RBRACK] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [sym_kEnd] = ACTIONS(2950),
    [sym_kVar] = ACTIONS(2950),
    [sym_kThreadvar] = ACTIONS(2950),
    [sym_kConst] = ACTIONS(2950),
    [sym_kResourcestring] = ACTIONS(2950),
    [sym_kType] = ACTIONS(2950),
    [sym_kProperty] = ACTIONS(2950),
    [sym_kClass] = ACTIONS(2950),
    [sym_kOf] = ACTIONS(2950),
    [sym_kGeneric] = ACTIONS(2950),
    [sym_kLt] = ACTIONS(2950),
    [sym_kEq] = ACTIONS(2952),
    [sym_kNeq] = ACTIONS(2952),
    [sym_kGt] = ACTIONS(2950),
    [sym_kLte] = ACTIONS(2952),
    [sym_kGte] = ACTIONS(2952),
    [sym_kAdd] = ACTIONS(2950),
    [sym_kSub] = ACTIONS(2950),
    [sym_kMul] = ACTIONS(2950),
    [sym_kFdiv] = ACTIONS(2950),
    [sym_kHat] = ACTIONS(2952),
    [sym_kAssign] = ACTIONS(2952),
    [sym_kAssignAdd] = ACTIONS(2952),
    [sym_kAssignSub] = ACTIONS(2952),
    [sym_kAssignMul] = ACTIONS(2952),
    [sym_kAssignDiv] = ACTIONS(2952),
    [sym_kOr] = ACTIONS(2950),
    [sym_kXor] = ACTIONS(2950),
    [sym_kDiv] = ACTIONS(2950),
    [sym_kMod] = ACTIONS(2950),
    [sym_kAnd] = ACTIONS(2950),
    [sym_kShl] = ACTIONS(2950),
    [sym_kShr] = ACTIONS(2950),
    [sym_kIs] = ACTIONS(2950),
    [sym_kAs] = ACTIONS(2950),
    [sym_kIn] = ACTIONS(2950),
    [sym_kThen] = ACTIONS(2950),
    [sym_kElse] = ACTIONS(2950),
    [sym_kDo] = ACTIONS(2950),
    [sym_kUntil] = ACTIONS(2950),
    [sym_kExcept] = ACTIONS(2950),
    [sym_kFinally] = ACTIONS(2950),
    [sym_kCase] = ACTIONS(2950),
    [sym_kFunction] = ACTIONS(2950),
    [sym_kProcedure] = ACTIONS(2950),
    [sym_kConstructor] = ACTIONS(2950),
    [sym_kDestructor] = ACTIONS(2950),
    [sym_kOperator] = ACTIONS(2950),
    [sym_kPublished] = ACTIONS(2950),
    [sym_kPublic] = ACTIONS(2950),
    [sym_kProtected] = ACTIONS(2950),
    [sym_kPrivate] = ACTIONS(2950),
    [sym_kStrict] = ACTIONS(2950),
    [sym_kRequired] = ACTIONS(2950),
    [sym_kOptional] = ACTIONS(2950),
    [sym_kDelayed] = ACTIONS(2950),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_RBRACK] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2956),
    [anon_sym_DOT] = ACTIONS(2956),
    [sym_kEnd] = ACTIONS(2954),
    [sym_kVar] = ACTIONS(2954),
    [sym_kThreadvar] = ACTIONS(2954),
    [sym_kConst] = ACTIONS(2954),
    [sym_kResourcestring] = ACTIONS(2954),
    [sym_kType] = ACTIONS(2954),
    [sym_kProperty] = ACTIONS(2954),
    [sym_kClass] = ACTIONS(2954),
    [sym_kOf] = ACTIONS(2954),
    [sym_kGeneric] = ACTIONS(2954),
    [sym_kLt] = ACTIONS(2954),
    [sym_kEq] = ACTIONS(2956),
    [sym_kNeq] = ACTIONS(2956),
    [sym_kGt] = ACTIONS(2954),
    [sym_kLte] = ACTIONS(2956),
    [sym_kGte] = ACTIONS(2956),
    [sym_kAdd] = ACTIONS(2954),
    [sym_kSub] = ACTIONS(2954),
    [sym_kMul] = ACTIONS(2954),
    [sym_kFdiv] = ACTIONS(2954),
    [sym_kHat] = ACTIONS(2956),
    [sym_kAssign] = ACTIONS(2956),
    [sym_kAssignAdd] = ACTIONS(2956),
    [sym_kAssignSub] = ACTIONS(2956),
    [sym_kAssignMul] = ACTIONS(2956),
    [sym_kAssignDiv] = ACTIONS(2956),
    [sym_kOr] = ACTIONS(2954),
    [sym_kXor] = ACTIONS(2954),
    [sym_kDiv] = ACTIONS(2954),
    [sym_kMod] = ACTIONS(2954),
    [sym_kAnd] = ACTIONS(2954),
    [sym_kShl] = ACTIONS(2954),
    [sym_kShr] = ACTIONS(2954),
    [sym_kIs] = ACTIONS(2954),
    [sym_kAs] = ACTIONS(2954),
    [sym_kIn] = ACTIONS(2954),
    [sym_kThen] = ACTIONS(2954),
    [sym_kElse] = ACTIONS(2954),
    [sym_kDo] = ACTIONS(2954),
    [sym_kUntil] = ACTIONS(2954),
    [sym_kExcept] = ACTIONS(2954),
    [sym_kFinally] = ACTIONS(2954),
    [sym_kCase] = ACTIONS(2954),
    [sym_kFunction] = ACTIONS(2954),
    [sym_kProcedure] = ACTIONS(2954),
    [sym_kConstructor] = ACTIONS(2954),
    [sym_kDestructor] = ACTIONS(2954),
    [sym_kOperator] = ACTIONS(2954),
    [sym_kPublished] = ACTIONS(2954),
    [sym_kPublic] = ACTIONS(2954),
    [sym_kProtected] = ACTIONS(2954),
    [sym_kPrivate] = ACTIONS(2954),
    [sym_kStrict] = ACTIONS(2954),
    [sym_kRequired] = ACTIONS(2954),
    [sym_kOptional] = ACTIONS(2954),
    [sym_kDelayed] = ACTIONS(2954),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(281),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT_DOT] = ACTIONS(281),
    [anon_sym_DOT] = ACTIONS(279),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(279),
    [sym_kEq] = ACTIONS(281),
    [sym_kNeq] = ACTIONS(281),
    [sym_kGt] = ACTIONS(279),
    [sym_kLte] = ACTIONS(281),
    [sym_kGte] = ACTIONS(281),
    [sym_kAdd] = ACTIONS(279),
    [sym_kSub] = ACTIONS(279),
    [sym_kMul] = ACTIONS(281),
    [sym_kFdiv] = ACTIONS(279),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(281),
    [sym_kOr] = ACTIONS(279),
    [sym_kXor] = ACTIONS(279),
    [sym_kDiv] = ACTIONS(279),
    [sym_kMod] = ACTIONS(279),
    [sym_kAnd] = ACTIONS(279),
    [sym_kShl] = ACTIONS(279),
    [sym_kShr] = ACTIONS(279),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(279),
    [sym_kAs] = ACTIONS(279),
    [sym_kIn] = ACTIONS(279),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_RBRACK] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2960),
    [sym_kEnd] = ACTIONS(2958),
    [sym_kVar] = ACTIONS(2958),
    [sym_kThreadvar] = ACTIONS(2958),
    [sym_kConst] = ACTIONS(2958),
    [sym_kResourcestring] = ACTIONS(2958),
    [sym_kType] = ACTIONS(2958),
    [sym_kProperty] = ACTIONS(2958),
    [sym_kClass] = ACTIONS(2958),
    [sym_kOf] = ACTIONS(2958),
    [sym_kGeneric] = ACTIONS(2958),
    [sym_kLt] = ACTIONS(2958),
    [sym_kEq] = ACTIONS(2960),
    [sym_kNeq] = ACTIONS(2960),
    [sym_kGt] = ACTIONS(2958),
    [sym_kLte] = ACTIONS(2960),
    [sym_kGte] = ACTIONS(2960),
    [sym_kAdd] = ACTIONS(2958),
    [sym_kSub] = ACTIONS(2958),
    [sym_kMul] = ACTIONS(2958),
    [sym_kFdiv] = ACTIONS(2958),
    [sym_kHat] = ACTIONS(2960),
    [sym_kAssign] = ACTIONS(2960),
    [sym_kAssignAdd] = ACTIONS(2960),
    [sym_kAssignSub] = ACTIONS(2960),
    [sym_kAssignMul] = ACTIONS(2960),
    [sym_kAssignDiv] = ACTIONS(2960),
    [sym_kOr] = ACTIONS(2958),
    [sym_kXor] = ACTIONS(2958),
    [sym_kDiv] = ACTIONS(2958),
    [sym_kMod] = ACTIONS(2958),
    [sym_kAnd] = ACTIONS(2958),
    [sym_kShl] = ACTIONS(2958),
    [sym_kShr] = ACTIONS(2958),
    [sym_kIs] = ACTIONS(2958),
    [sym_kAs] = ACTIONS(2958),
    [sym_kIn] = ACTIONS(2958),
    [sym_kThen] = ACTIONS(2958),
    [sym_kElse] = ACTIONS(2958),
    [sym_kDo] = ACTIONS(2958),
    [sym_kUntil] = ACTIONS(2958),
    [sym_kExcept] = ACTIONS(2958),
    [sym_kFinally] = ACTIONS(2958),
    [sym_kCase] = ACTIONS(2958),
    [sym_kFunction] = ACTIONS(2958),
    [sym_kProcedure] = ACTIONS(2958),
    [sym_kConstructor] = ACTIONS(2958),
    [sym_kDestructor] = ACTIONS(2958),
    [sym_kOperator] = ACTIONS(2958),
    [sym_kPublished] = ACTIONS(2958),
    [sym_kPublic] = ACTIONS(2958),
    [sym_kProtected] = ACTIONS(2958),
    [sym_kPrivate] = ACTIONS(2958),
    [sym_kStrict] = ACTIONS(2958),
    [sym_kRequired] = ACTIONS(2958),
    [sym_kOptional] = ACTIONS(2958),
    [sym_kDelayed] = ACTIONS(2958),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_RBRACK] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_kEnd] = ACTIONS(2962),
    [sym_kVar] = ACTIONS(2962),
    [sym_kThreadvar] = ACTIONS(2962),
    [sym_kConst] = ACTIONS(2962),
    [sym_kResourcestring] = ACTIONS(2962),
    [sym_kType] = ACTIONS(2962),
    [sym_kProperty] = ACTIONS(2962),
    [sym_kClass] = ACTIONS(2962),
    [sym_kOf] = ACTIONS(2962),
    [sym_kGeneric] = ACTIONS(2962),
    [sym_kLt] = ACTIONS(2962),
    [sym_kEq] = ACTIONS(2964),
    [sym_kNeq] = ACTIONS(2964),
    [sym_kGt] = ACTIONS(2962),
    [sym_kLte] = ACTIONS(2964),
    [sym_kGte] = ACTIONS(2964),
    [sym_kAdd] = ACTIONS(2962),
    [sym_kSub] = ACTIONS(2962),
    [sym_kMul] = ACTIONS(2962),
    [sym_kFdiv] = ACTIONS(2962),
    [sym_kHat] = ACTIONS(2964),
    [sym_kAssign] = ACTIONS(2964),
    [sym_kAssignAdd] = ACTIONS(2964),
    [sym_kAssignSub] = ACTIONS(2964),
    [sym_kAssignMul] = ACTIONS(2964),
    [sym_kAssignDiv] = ACTIONS(2964),
    [sym_kOr] = ACTIONS(2962),
    [sym_kXor] = ACTIONS(2962),
    [sym_kDiv] = ACTIONS(2962),
    [sym_kMod] = ACTIONS(2962),
    [sym_kAnd] = ACTIONS(2962),
    [sym_kShl] = ACTIONS(2962),
    [sym_kShr] = ACTIONS(2962),
    [sym_kIs] = ACTIONS(2962),
    [sym_kAs] = ACTIONS(2962),
    [sym_kIn] = ACTIONS(2962),
    [sym_kThen] = ACTIONS(2962),
    [sym_kElse] = ACTIONS(2962),
    [sym_kDo] = ACTIONS(2962),
    [sym_kUntil] = ACTIONS(2962),
    [sym_kExcept] = ACTIONS(2962),
    [sym_kFinally] = ACTIONS(2962),
    [sym_kCase] = ACTIONS(2962),
    [sym_kFunction] = ACTIONS(2962),
    [sym_kProcedure] = ACTIONS(2962),
    [sym_kConstructor] = ACTIONS(2962),
    [sym_kDestructor] = ACTIONS(2962),
    [sym_kOperator] = ACTIONS(2962),
    [sym_kPublished] = ACTIONS(2962),
    [sym_kPublic] = ACTIONS(2962),
    [sym_kProtected] = ACTIONS(2962),
    [sym_kPrivate] = ACTIONS(2962),
    [sym_kStrict] = ACTIONS(2962),
    [sym_kRequired] = ACTIONS(2962),
    [sym_kOptional] = ACTIONS(2962),
    [sym_kDelayed] = ACTIONS(2962),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_RBRACK] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_RPAREN] = ACTIONS(2968),
    [anon_sym_DOT] = ACTIONS(2968),
    [sym_kEnd] = ACTIONS(2966),
    [sym_kVar] = ACTIONS(2966),
    [sym_kThreadvar] = ACTIONS(2966),
    [sym_kConst] = ACTIONS(2966),
    [sym_kResourcestring] = ACTIONS(2966),
    [sym_kType] = ACTIONS(2966),
    [sym_kProperty] = ACTIONS(2966),
    [sym_kClass] = ACTIONS(2966),
    [sym_kOf] = ACTIONS(2966),
    [sym_kGeneric] = ACTIONS(2966),
    [sym_kLt] = ACTIONS(2966),
    [sym_kEq] = ACTIONS(2968),
    [sym_kNeq] = ACTIONS(2968),
    [sym_kGt] = ACTIONS(2966),
    [sym_kLte] = ACTIONS(2968),
    [sym_kGte] = ACTIONS(2968),
    [sym_kAdd] = ACTIONS(2966),
    [sym_kSub] = ACTIONS(2966),
    [sym_kMul] = ACTIONS(2966),
    [sym_kFdiv] = ACTIONS(2966),
    [sym_kHat] = ACTIONS(2968),
    [sym_kAssign] = ACTIONS(2968),
    [sym_kAssignAdd] = ACTIONS(2968),
    [sym_kAssignSub] = ACTIONS(2968),
    [sym_kAssignMul] = ACTIONS(2968),
    [sym_kAssignDiv] = ACTIONS(2968),
    [sym_kOr] = ACTIONS(2966),
    [sym_kXor] = ACTIONS(2966),
    [sym_kDiv] = ACTIONS(2966),
    [sym_kMod] = ACTIONS(2966),
    [sym_kAnd] = ACTIONS(2966),
    [sym_kShl] = ACTIONS(2966),
    [sym_kShr] = ACTIONS(2966),
    [sym_kIs] = ACTIONS(2966),
    [sym_kAs] = ACTIONS(2966),
    [sym_kIn] = ACTIONS(2966),
    [sym_kThen] = ACTIONS(2966),
    [sym_kElse] = ACTIONS(2966),
    [sym_kDo] = ACTIONS(2966),
    [sym_kUntil] = ACTIONS(2966),
    [sym_kExcept] = ACTIONS(2966),
    [sym_kFinally] = ACTIONS(2966),
    [sym_kCase] = ACTIONS(2966),
    [sym_kFunction] = ACTIONS(2966),
    [sym_kProcedure] = ACTIONS(2966),
    [sym_kConstructor] = ACTIONS(2966),
    [sym_kDestructor] = ACTIONS(2966),
    [sym_kOperator] = ACTIONS(2966),
    [sym_kPublished] = ACTIONS(2966),
    [sym_kPublic] = ACTIONS(2966),
    [sym_kProtected] = ACTIONS(2966),
    [sym_kPrivate] = ACTIONS(2966),
    [sym_kStrict] = ACTIONS(2966),
    [sym_kRequired] = ACTIONS(2966),
    [sym_kOptional] = ACTIONS(2966),
    [sym_kDelayed] = ACTIONS(2966),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2972),
    [sym_kEnd] = ACTIONS(2970),
    [sym_kVar] = ACTIONS(2970),
    [sym_kThreadvar] = ACTIONS(2970),
    [sym_kConst] = ACTIONS(2970),
    [sym_kResourcestring] = ACTIONS(2970),
    [sym_kType] = ACTIONS(2970),
    [sym_kProperty] = ACTIONS(2970),
    [sym_kClass] = ACTIONS(2970),
    [sym_kOf] = ACTIONS(2970),
    [sym_kGeneric] = ACTIONS(2970),
    [sym_kLt] = ACTIONS(2970),
    [sym_kEq] = ACTIONS(2972),
    [sym_kNeq] = ACTIONS(2972),
    [sym_kGt] = ACTIONS(2970),
    [sym_kLte] = ACTIONS(2972),
    [sym_kGte] = ACTIONS(2972),
    [sym_kAdd] = ACTIONS(2970),
    [sym_kSub] = ACTIONS(2970),
    [sym_kMul] = ACTIONS(2970),
    [sym_kFdiv] = ACTIONS(2970),
    [sym_kHat] = ACTIONS(2972),
    [sym_kAssign] = ACTIONS(2972),
    [sym_kAssignAdd] = ACTIONS(2972),
    [sym_kAssignSub] = ACTIONS(2972),
    [sym_kAssignMul] = ACTIONS(2972),
    [sym_kAssignDiv] = ACTIONS(2972),
    [sym_kOr] = ACTIONS(2970),
    [sym_kXor] = ACTIONS(2970),
    [sym_kDiv] = ACTIONS(2970),
    [sym_kMod] = ACTIONS(2970),
    [sym_kAnd] = ACTIONS(2970),
    [sym_kShl] = ACTIONS(2970),
    [sym_kShr] = ACTIONS(2970),
    [sym_kIs] = ACTIONS(2970),
    [sym_kAs] = ACTIONS(2970),
    [sym_kIn] = ACTIONS(2970),
    [sym_kThen] = ACTIONS(2970),
    [sym_kElse] = ACTIONS(2970),
    [sym_kDo] = ACTIONS(2970),
    [sym_kUntil] = ACTIONS(2970),
    [sym_kExcept] = ACTIONS(2970),
    [sym_kFinally] = ACTIONS(2970),
    [sym_kCase] = ACTIONS(2970),
    [sym_kFunction] = ACTIONS(2970),
    [sym_kProcedure] = ACTIONS(2970),
    [sym_kConstructor] = ACTIONS(2970),
    [sym_kDestructor] = ACTIONS(2970),
    [sym_kOperator] = ACTIONS(2970),
    [sym_kPublished] = ACTIONS(2970),
    [sym_kPublic] = ACTIONS(2970),
    [sym_kProtected] = ACTIONS(2970),
    [sym_kPrivate] = ACTIONS(2970),
    [sym_kStrict] = ACTIONS(2970),
    [sym_kRequired] = ACTIONS(2970),
    [sym_kOptional] = ACTIONS(2970),
    [sym_kDelayed] = ACTIONS(2970),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [anon_sym_LBRACK] = ACTIONS(2753),
    [aux_sym_type_token1] = ACTIONS(2753),
    [sym_kUses] = ACTIONS(2753),
    [sym_kBegin] = ACTIONS(2753),
    [sym_kAsm] = ACTIONS(2753),
    [sym_kVar] = ACTIONS(2755),
    [sym_kThreadvar] = ACTIONS(2753),
    [sym_kConst] = ACTIONS(2755),
    [sym_kResourcestring] = ACTIONS(2753),
    [sym_kType] = ACTIONS(2753),
    [sym_kLabel] = ACTIONS(2753),
    [sym_kExports] = ACTIONS(2753),
    [sym_kDefault] = ACTIONS(2753),
    [sym_kNodefault] = ACTIONS(2753),
    [sym_kClass] = ACTIONS(2753),
    [sym_kGeneric] = ACTIONS(2753),
    [sym_kFunction] = ACTIONS(2753),
    [sym_kProcedure] = ACTIONS(2753),
    [sym_kConstructor] = ACTIONS(2753),
    [sym_kDestructor] = ACTIONS(2753),
    [sym_kOperator] = ACTIONS(2753),
    [sym_kPublic] = ACTIONS(2753),
    [sym_kForward] = ACTIONS(2753),
    [sym_kStatic] = ACTIONS(2753),
    [sym_kVirtual] = ACTIONS(2753),
    [sym_kAbstract] = ACTIONS(2753),
    [sym_kDynamic] = ACTIONS(2753),
    [sym_kOverride] = ACTIONS(2753),
    [sym_kOverload] = ACTIONS(2753),
    [sym_kReintroduce] = ACTIONS(2753),
    [sym_kInline] = ACTIONS(2753),
    [sym_kStdcall] = ACTIONS(2753),
    [sym_kCdecl] = ACTIONS(2753),
    [sym_kCppdecl] = ACTIONS(2753),
    [sym_kPascal] = ACTIONS(2753),
    [sym_kRegister] = ACTIONS(2753),
    [sym_kMwpascal] = ACTIONS(2753),
    [sym_kExternal] = ACTIONS(2753),
    [sym_kMessage] = ACTIONS(2753),
    [sym_kDeprecated] = ACTIONS(2753),
    [sym_kExperimental] = ACTIONS(2753),
    [sym_kPlatform] = ACTIONS(2753),
    [sym_kUnimplemented] = ACTIONS(2753),
    [sym_kCvar] = ACTIONS(2753),
    [sym_kExport] = ACTIONS(2755),
    [sym_kFar] = ACTIONS(2753),
    [sym_kNear] = ACTIONS(2753),
    [sym_kSafecall] = ACTIONS(2753),
    [sym_kAssembler] = ACTIONS(2753),
    [sym_kNostackframe] = ACTIONS(2753),
    [sym_kInterrupt] = ACTIONS(2753),
    [sym_kNoreturn] = ACTIONS(2753),
    [sym_kIocheck] = ACTIONS(2753),
    [sym_kLocal] = ACTIONS(2753),
    [sym_kHardfloat] = ACTIONS(2753),
    [sym_kSoftfloat] = ACTIONS(2753),
    [sym_kMs_abi_default] = ACTIONS(2753),
    [sym_kMs_abi_cdecl] = ACTIONS(2753),
    [sym_kSaveregisters] = ACTIONS(2753),
    [sym_kSysv_abi_default] = ACTIONS(2753),
    [sym_kSysv_abi_cdecl] = ACTIONS(2753),
    [sym_kVectorcall] = ACTIONS(2753),
    [sym_kVarargs] = ACTIONS(2753),
    [sym_kWinapi] = ACTIONS(2753),
    [sym_kAlias] = ACTIONS(2753),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_RBRACK] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2976),
    [sym_kEnd] = ACTIONS(2974),
    [sym_kVar] = ACTIONS(2974),
    [sym_kThreadvar] = ACTIONS(2974),
    [sym_kConst] = ACTIONS(2974),
    [sym_kResourcestring] = ACTIONS(2974),
    [sym_kType] = ACTIONS(2974),
    [sym_kProperty] = ACTIONS(2974),
    [sym_kClass] = ACTIONS(2974),
    [sym_kOf] = ACTIONS(2974),
    [sym_kGeneric] = ACTIONS(2974),
    [sym_kLt] = ACTIONS(2974),
    [sym_kEq] = ACTIONS(2976),
    [sym_kNeq] = ACTIONS(2976),
    [sym_kGt] = ACTIONS(2974),
    [sym_kLte] = ACTIONS(2976),
    [sym_kGte] = ACTIONS(2976),
    [sym_kAdd] = ACTIONS(2974),
    [sym_kSub] = ACTIONS(2974),
    [sym_kMul] = ACTIONS(2974),
    [sym_kFdiv] = ACTIONS(2974),
    [sym_kHat] = ACTIONS(2976),
    [sym_kAssign] = ACTIONS(2976),
    [sym_kAssignAdd] = ACTIONS(2976),
    [sym_kAssignSub] = ACTIONS(2976),
    [sym_kAssignMul] = ACTIONS(2976),
    [sym_kAssignDiv] = ACTIONS(2976),
    [sym_kOr] = ACTIONS(2974),
    [sym_kXor] = ACTIONS(2974),
    [sym_kDiv] = ACTIONS(2974),
    [sym_kMod] = ACTIONS(2974),
    [sym_kAnd] = ACTIONS(2974),
    [sym_kShl] = ACTIONS(2974),
    [sym_kShr] = ACTIONS(2974),
    [sym_kIs] = ACTIONS(2974),
    [sym_kAs] = ACTIONS(2974),
    [sym_kIn] = ACTIONS(2974),
    [sym_kThen] = ACTIONS(2974),
    [sym_kElse] = ACTIONS(2974),
    [sym_kDo] = ACTIONS(2974),
    [sym_kUntil] = ACTIONS(2974),
    [sym_kExcept] = ACTIONS(2974),
    [sym_kFinally] = ACTIONS(2974),
    [sym_kCase] = ACTIONS(2974),
    [sym_kFunction] = ACTIONS(2974),
    [sym_kProcedure] = ACTIONS(2974),
    [sym_kConstructor] = ACTIONS(2974),
    [sym_kDestructor] = ACTIONS(2974),
    [sym_kOperator] = ACTIONS(2974),
    [sym_kPublished] = ACTIONS(2974),
    [sym_kPublic] = ACTIONS(2974),
    [sym_kProtected] = ACTIONS(2974),
    [sym_kPrivate] = ACTIONS(2974),
    [sym_kStrict] = ACTIONS(2974),
    [sym_kRequired] = ACTIONS(2974),
    [sym_kOptional] = ACTIONS(2974),
    [sym_kDelayed] = ACTIONS(2974),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [anon_sym_LBRACK] = ACTIONS(2687),
    [aux_sym_type_token1] = ACTIONS(2687),
    [sym_kUses] = ACTIONS(2687),
    [sym_kBegin] = ACTIONS(2687),
    [sym_kAsm] = ACTIONS(2687),
    [sym_kVar] = ACTIONS(2689),
    [sym_kThreadvar] = ACTIONS(2687),
    [sym_kConst] = ACTIONS(2689),
    [sym_kResourcestring] = ACTIONS(2687),
    [sym_kType] = ACTIONS(2687),
    [sym_kLabel] = ACTIONS(2687),
    [sym_kExports] = ACTIONS(2687),
    [sym_kDefault] = ACTIONS(2687),
    [sym_kNodefault] = ACTIONS(2687),
    [sym_kClass] = ACTIONS(2687),
    [sym_kGeneric] = ACTIONS(2687),
    [sym_kFunction] = ACTIONS(2687),
    [sym_kProcedure] = ACTIONS(2687),
    [sym_kConstructor] = ACTIONS(2687),
    [sym_kDestructor] = ACTIONS(2687),
    [sym_kOperator] = ACTIONS(2687),
    [sym_kPublic] = ACTIONS(2687),
    [sym_kForward] = ACTIONS(2687),
    [sym_kStatic] = ACTIONS(2687),
    [sym_kVirtual] = ACTIONS(2687),
    [sym_kAbstract] = ACTIONS(2687),
    [sym_kDynamic] = ACTIONS(2687),
    [sym_kOverride] = ACTIONS(2687),
    [sym_kOverload] = ACTIONS(2687),
    [sym_kReintroduce] = ACTIONS(2687),
    [sym_kInline] = ACTIONS(2687),
    [sym_kStdcall] = ACTIONS(2687),
    [sym_kCdecl] = ACTIONS(2687),
    [sym_kCppdecl] = ACTIONS(2687),
    [sym_kPascal] = ACTIONS(2687),
    [sym_kRegister] = ACTIONS(2687),
    [sym_kMwpascal] = ACTIONS(2687),
    [sym_kExternal] = ACTIONS(2687),
    [sym_kMessage] = ACTIONS(2687),
    [sym_kDeprecated] = ACTIONS(2687),
    [sym_kExperimental] = ACTIONS(2687),
    [sym_kPlatform] = ACTIONS(2687),
    [sym_kUnimplemented] = ACTIONS(2687),
    [sym_kCvar] = ACTIONS(2687),
    [sym_kExport] = ACTIONS(2689),
    [sym_kFar] = ACTIONS(2687),
    [sym_kNear] = ACTIONS(2687),
    [sym_kSafecall] = ACTIONS(2687),
    [sym_kAssembler] = ACTIONS(2687),
    [sym_kNostackframe] = ACTIONS(2687),
    [sym_kInterrupt] = ACTIONS(2687),
    [sym_kNoreturn] = ACTIONS(2687),
    [sym_kIocheck] = ACTIONS(2687),
    [sym_kLocal] = ACTIONS(2687),
    [sym_kHardfloat] = ACTIONS(2687),
    [sym_kSoftfloat] = ACTIONS(2687),
    [sym_kMs_abi_default] = ACTIONS(2687),
    [sym_kMs_abi_cdecl] = ACTIONS(2687),
    [sym_kSaveregisters] = ACTIONS(2687),
    [sym_kSysv_abi_default] = ACTIONS(2687),
    [sym_kSysv_abi_cdecl] = ACTIONS(2687),
    [sym_kVectorcall] = ACTIONS(2687),
    [sym_kVarargs] = ACTIONS(2687),
    [sym_kWinapi] = ACTIONS(2687),
    [sym_kAlias] = ACTIONS(2687),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_RBRACK] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_DOT] = ACTIONS(2980),
    [sym_kEnd] = ACTIONS(2978),
    [sym_kVar] = ACTIONS(2978),
    [sym_kThreadvar] = ACTIONS(2978),
    [sym_kConst] = ACTIONS(2978),
    [sym_kResourcestring] = ACTIONS(2978),
    [sym_kType] = ACTIONS(2978),
    [sym_kProperty] = ACTIONS(2978),
    [sym_kClass] = ACTIONS(2978),
    [sym_kOf] = ACTIONS(2978),
    [sym_kGeneric] = ACTIONS(2978),
    [sym_kLt] = ACTIONS(2978),
    [sym_kEq] = ACTIONS(2980),
    [sym_kNeq] = ACTIONS(2980),
    [sym_kGt] = ACTIONS(2978),
    [sym_kLte] = ACTIONS(2980),
    [sym_kGte] = ACTIONS(2980),
    [sym_kAdd] = ACTIONS(2978),
    [sym_kSub] = ACTIONS(2978),
    [sym_kMul] = ACTIONS(2978),
    [sym_kFdiv] = ACTIONS(2978),
    [sym_kHat] = ACTIONS(2980),
    [sym_kAssign] = ACTIONS(2980),
    [sym_kAssignAdd] = ACTIONS(2980),
    [sym_kAssignSub] = ACTIONS(2980),
    [sym_kAssignMul] = ACTIONS(2980),
    [sym_kAssignDiv] = ACTIONS(2980),
    [sym_kOr] = ACTIONS(2978),
    [sym_kXor] = ACTIONS(2978),
    [sym_kDiv] = ACTIONS(2978),
    [sym_kMod] = ACTIONS(2978),
    [sym_kAnd] = ACTIONS(2978),
    [sym_kShl] = ACTIONS(2978),
    [sym_kShr] = ACTIONS(2978),
    [sym_kIs] = ACTIONS(2978),
    [sym_kAs] = ACTIONS(2978),
    [sym_kIn] = ACTIONS(2978),
    [sym_kThen] = ACTIONS(2978),
    [sym_kElse] = ACTIONS(2978),
    [sym_kDo] = ACTIONS(2978),
    [sym_kUntil] = ACTIONS(2978),
    [sym_kExcept] = ACTIONS(2978),
    [sym_kFinally] = ACTIONS(2978),
    [sym_kCase] = ACTIONS(2978),
    [sym_kFunction] = ACTIONS(2978),
    [sym_kProcedure] = ACTIONS(2978),
    [sym_kConstructor] = ACTIONS(2978),
    [sym_kDestructor] = ACTIONS(2978),
    [sym_kOperator] = ACTIONS(2978),
    [sym_kPublished] = ACTIONS(2978),
    [sym_kPublic] = ACTIONS(2978),
    [sym_kProtected] = ACTIONS(2978),
    [sym_kPrivate] = ACTIONS(2978),
    [sym_kStrict] = ACTIONS(2978),
    [sym_kRequired] = ACTIONS(2978),
    [sym_kOptional] = ACTIONS(2978),
    [sym_kDelayed] = ACTIONS(2978),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_COLON] = ACTIONS(2982),
    [anon_sym_COMMA] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_RBRACK] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [sym_kEnd] = ACTIONS(2982),
    [sym_kVar] = ACTIONS(2982),
    [sym_kThreadvar] = ACTIONS(2982),
    [sym_kConst] = ACTIONS(2982),
    [sym_kResourcestring] = ACTIONS(2982),
    [sym_kType] = ACTIONS(2982),
    [sym_kProperty] = ACTIONS(2982),
    [sym_kClass] = ACTIONS(2982),
    [sym_kOf] = ACTIONS(2982),
    [sym_kGeneric] = ACTIONS(2982),
    [sym_kLt] = ACTIONS(2982),
    [sym_kEq] = ACTIONS(2984),
    [sym_kNeq] = ACTIONS(2984),
    [sym_kGt] = ACTIONS(2982),
    [sym_kLte] = ACTIONS(2984),
    [sym_kGte] = ACTIONS(2984),
    [sym_kAdd] = ACTIONS(2982),
    [sym_kSub] = ACTIONS(2982),
    [sym_kMul] = ACTIONS(2982),
    [sym_kFdiv] = ACTIONS(2982),
    [sym_kHat] = ACTIONS(2984),
    [sym_kAssign] = ACTIONS(2984),
    [sym_kAssignAdd] = ACTIONS(2984),
    [sym_kAssignSub] = ACTIONS(2984),
    [sym_kAssignMul] = ACTIONS(2984),
    [sym_kAssignDiv] = ACTIONS(2984),
    [sym_kOr] = ACTIONS(2982),
    [sym_kXor] = ACTIONS(2982),
    [sym_kDiv] = ACTIONS(2982),
    [sym_kMod] = ACTIONS(2982),
    [sym_kAnd] = ACTIONS(2982),
    [sym_kShl] = ACTIONS(2982),
    [sym_kShr] = ACTIONS(2982),
    [sym_kIs] = ACTIONS(2982),
    [sym_kAs] = ACTIONS(2982),
    [sym_kIn] = ACTIONS(2982),
    [sym_kThen] = ACTIONS(2982),
    [sym_kElse] = ACTIONS(2982),
    [sym_kDo] = ACTIONS(2982),
    [sym_kUntil] = ACTIONS(2982),
    [sym_kExcept] = ACTIONS(2982),
    [sym_kFinally] = ACTIONS(2982),
    [sym_kCase] = ACTIONS(2982),
    [sym_kFunction] = ACTIONS(2982),
    [sym_kProcedure] = ACTIONS(2982),
    [sym_kConstructor] = ACTIONS(2982),
    [sym_kDestructor] = ACTIONS(2982),
    [sym_kOperator] = ACTIONS(2982),
    [sym_kPublished] = ACTIONS(2982),
    [sym_kPublic] = ACTIONS(2982),
    [sym_kProtected] = ACTIONS(2982),
    [sym_kPrivate] = ACTIONS(2982),
    [sym_kStrict] = ACTIONS(2982),
    [sym_kRequired] = ACTIONS(2982),
    [sym_kOptional] = ACTIONS(2982),
    [sym_kDelayed] = ACTIONS(2982),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [anon_sym_LBRACK] = ACTIONS(2719),
    [aux_sym_type_token1] = ACTIONS(2719),
    [sym_kUses] = ACTIONS(2719),
    [sym_kBegin] = ACTIONS(2719),
    [sym_kAsm] = ACTIONS(2719),
    [sym_kVar] = ACTIONS(2721),
    [sym_kThreadvar] = ACTIONS(2719),
    [sym_kConst] = ACTIONS(2721),
    [sym_kResourcestring] = ACTIONS(2719),
    [sym_kType] = ACTIONS(2719),
    [sym_kLabel] = ACTIONS(2719),
    [sym_kExports] = ACTIONS(2719),
    [sym_kDefault] = ACTIONS(2719),
    [sym_kNodefault] = ACTIONS(2719),
    [sym_kClass] = ACTIONS(2719),
    [sym_kGeneric] = ACTIONS(2719),
    [sym_kFunction] = ACTIONS(2719),
    [sym_kProcedure] = ACTIONS(2719),
    [sym_kConstructor] = ACTIONS(2719),
    [sym_kDestructor] = ACTIONS(2719),
    [sym_kOperator] = ACTIONS(2719),
    [sym_kPublic] = ACTIONS(2719),
    [sym_kForward] = ACTIONS(2719),
    [sym_kStatic] = ACTIONS(2719),
    [sym_kVirtual] = ACTIONS(2719),
    [sym_kAbstract] = ACTIONS(2719),
    [sym_kDynamic] = ACTIONS(2719),
    [sym_kOverride] = ACTIONS(2719),
    [sym_kOverload] = ACTIONS(2719),
    [sym_kReintroduce] = ACTIONS(2719),
    [sym_kInline] = ACTIONS(2719),
    [sym_kStdcall] = ACTIONS(2719),
    [sym_kCdecl] = ACTIONS(2719),
    [sym_kCppdecl] = ACTIONS(2719),
    [sym_kPascal] = ACTIONS(2719),
    [sym_kRegister] = ACTIONS(2719),
    [sym_kMwpascal] = ACTIONS(2719),
    [sym_kExternal] = ACTIONS(2719),
    [sym_kMessage] = ACTIONS(2719),
    [sym_kDeprecated] = ACTIONS(2719),
    [sym_kExperimental] = ACTIONS(2719),
    [sym_kPlatform] = ACTIONS(2719),
    [sym_kUnimplemented] = ACTIONS(2719),
    [sym_kCvar] = ACTIONS(2719),
    [sym_kExport] = ACTIONS(2721),
    [sym_kFar] = ACTIONS(2719),
    [sym_kNear] = ACTIONS(2719),
    [sym_kSafecall] = ACTIONS(2719),
    [sym_kAssembler] = ACTIONS(2719),
    [sym_kNostackframe] = ACTIONS(2719),
    [sym_kInterrupt] = ACTIONS(2719),
    [sym_kNoreturn] = ACTIONS(2719),
    [sym_kIocheck] = ACTIONS(2719),
    [sym_kLocal] = ACTIONS(2719),
    [sym_kHardfloat] = ACTIONS(2719),
    [sym_kSoftfloat] = ACTIONS(2719),
    [sym_kMs_abi_default] = ACTIONS(2719),
    [sym_kMs_abi_cdecl] = ACTIONS(2719),
    [sym_kSaveregisters] = ACTIONS(2719),
    [sym_kSysv_abi_default] = ACTIONS(2719),
    [sym_kSysv_abi_cdecl] = ACTIONS(2719),
    [sym_kVectorcall] = ACTIONS(2719),
    [sym_kVarargs] = ACTIONS(2719),
    [sym_kWinapi] = ACTIONS(2719),
    [sym_kAlias] = ACTIONS(2719),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_COLON] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2986),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [sym_kEnd] = ACTIONS(2986),
    [sym_kVar] = ACTIONS(2986),
    [sym_kThreadvar] = ACTIONS(2986),
    [sym_kConst] = ACTIONS(2986),
    [sym_kResourcestring] = ACTIONS(2986),
    [sym_kType] = ACTIONS(2986),
    [sym_kProperty] = ACTIONS(2986),
    [sym_kClass] = ACTIONS(2986),
    [sym_kOf] = ACTIONS(2986),
    [sym_kGeneric] = ACTIONS(2986),
    [sym_kLt] = ACTIONS(2986),
    [sym_kEq] = ACTIONS(2988),
    [sym_kNeq] = ACTIONS(2988),
    [sym_kGt] = ACTIONS(2986),
    [sym_kLte] = ACTIONS(2988),
    [sym_kGte] = ACTIONS(2988),
    [sym_kAdd] = ACTIONS(2986),
    [sym_kSub] = ACTIONS(2986),
    [sym_kMul] = ACTIONS(2986),
    [sym_kFdiv] = ACTIONS(2986),
    [sym_kHat] = ACTIONS(2988),
    [sym_kAssign] = ACTIONS(2988),
    [sym_kAssignAdd] = ACTIONS(2988),
    [sym_kAssignSub] = ACTIONS(2988),
    [sym_kAssignMul] = ACTIONS(2988),
    [sym_kAssignDiv] = ACTIONS(2988),
    [sym_kOr] = ACTIONS(2986),
    [sym_kXor] = ACTIONS(2986),
    [sym_kDiv] = ACTIONS(2986),
    [sym_kMod] = ACTIONS(2986),
    [sym_kAnd] = ACTIONS(2986),
    [sym_kShl] = ACTIONS(2986),
    [sym_kShr] = ACTIONS(2986),
    [sym_kIs] = ACTIONS(2986),
    [sym_kAs] = ACTIONS(2986),
    [sym_kIn] = ACTIONS(2986),
    [sym_kThen] = ACTIONS(2986),
    [sym_kElse] = ACTIONS(2986),
    [sym_kDo] = ACTIONS(2986),
    [sym_kUntil] = ACTIONS(2986),
    [sym_kExcept] = ACTIONS(2986),
    [sym_kFinally] = ACTIONS(2986),
    [sym_kCase] = ACTIONS(2986),
    [sym_kFunction] = ACTIONS(2986),
    [sym_kProcedure] = ACTIONS(2986),
    [sym_kConstructor] = ACTIONS(2986),
    [sym_kDestructor] = ACTIONS(2986),
    [sym_kOperator] = ACTIONS(2986),
    [sym_kPublished] = ACTIONS(2986),
    [sym_kPublic] = ACTIONS(2986),
    [sym_kProtected] = ACTIONS(2986),
    [sym_kPrivate] = ACTIONS(2986),
    [sym_kStrict] = ACTIONS(2986),
    [sym_kRequired] = ACTIONS(2986),
    [sym_kOptional] = ACTIONS(2986),
    [sym_kDelayed] = ACTIONS(2986),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2994),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [sym_kEnd] = ACTIONS(2994),
    [sym_kVar] = ACTIONS(2994),
    [sym_kThreadvar] = ACTIONS(2994),
    [sym_kConst] = ACTIONS(2994),
    [sym_kResourcestring] = ACTIONS(2994),
    [sym_kType] = ACTIONS(2994),
    [sym_kProperty] = ACTIONS(2994),
    [sym_kClass] = ACTIONS(2994),
    [sym_kOf] = ACTIONS(2994),
    [sym_kGeneric] = ACTIONS(2994),
    [sym_kLt] = ACTIONS(2994),
    [sym_kEq] = ACTIONS(2992),
    [sym_kNeq] = ACTIONS(2992),
    [sym_kGt] = ACTIONS(2994),
    [sym_kLte] = ACTIONS(2992),
    [sym_kGte] = ACTIONS(2992),
    [sym_kAdd] = ACTIONS(2994),
    [sym_kSub] = ACTIONS(2994),
    [sym_kMul] = ACTIONS(2994),
    [sym_kFdiv] = ACTIONS(2994),
    [sym_kHat] = ACTIONS(2992),
    [sym_kAssign] = ACTIONS(2992),
    [sym_kAssignAdd] = ACTIONS(2992),
    [sym_kAssignSub] = ACTIONS(2992),
    [sym_kAssignMul] = ACTIONS(2992),
    [sym_kAssignDiv] = ACTIONS(2992),
    [sym_kOr] = ACTIONS(2994),
    [sym_kXor] = ACTIONS(2994),
    [sym_kDiv] = ACTIONS(2994),
    [sym_kMod] = ACTIONS(2994),
    [sym_kAnd] = ACTIONS(2994),
    [sym_kShl] = ACTIONS(2994),
    [sym_kShr] = ACTIONS(2994),
    [sym_kIs] = ACTIONS(2994),
    [sym_kAs] = ACTIONS(2994),
    [sym_kIn] = ACTIONS(2994),
    [sym_kThen] = ACTIONS(2994),
    [sym_kElse] = ACTIONS(2994),
    [sym_kDo] = ACTIONS(2994),
    [sym_kUntil] = ACTIONS(2994),
    [sym_kExcept] = ACTIONS(2994),
    [sym_kFinally] = ACTIONS(2994),
    [sym_kCase] = ACTIONS(2994),
    [sym_kFunction] = ACTIONS(2994),
    [sym_kProcedure] = ACTIONS(2994),
    [sym_kConstructor] = ACTIONS(2994),
    [sym_kDestructor] = ACTIONS(2994),
    [sym_kOperator] = ACTIONS(2994),
    [sym_kPublished] = ACTIONS(2994),
    [sym_kPublic] = ACTIONS(2994),
    [sym_kProtected] = ACTIONS(2994),
    [sym_kPrivate] = ACTIONS(2994),
    [sym_kStrict] = ACTIONS(2994),
    [sym_kRequired] = ACTIONS(2994),
    [sym_kOptional] = ACTIONS(2994),
    [sym_kDelayed] = ACTIONS(2994),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_RBRACK] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(2998),
    [sym_kEnd] = ACTIONS(2996),
    [sym_kVar] = ACTIONS(2996),
    [sym_kThreadvar] = ACTIONS(2996),
    [sym_kConst] = ACTIONS(2996),
    [sym_kResourcestring] = ACTIONS(2996),
    [sym_kType] = ACTIONS(2996),
    [sym_kProperty] = ACTIONS(2996),
    [sym_kClass] = ACTIONS(2996),
    [sym_kOf] = ACTIONS(2996),
    [sym_kGeneric] = ACTIONS(2996),
    [sym_kLt] = ACTIONS(2996),
    [sym_kEq] = ACTIONS(2998),
    [sym_kNeq] = ACTIONS(2998),
    [sym_kGt] = ACTIONS(2996),
    [sym_kLte] = ACTIONS(2998),
    [sym_kGte] = ACTIONS(2998),
    [sym_kAdd] = ACTIONS(2996),
    [sym_kSub] = ACTIONS(2996),
    [sym_kMul] = ACTIONS(2996),
    [sym_kFdiv] = ACTIONS(2996),
    [sym_kHat] = ACTIONS(2998),
    [sym_kAssign] = ACTIONS(2998),
    [sym_kAssignAdd] = ACTIONS(2998),
    [sym_kAssignSub] = ACTIONS(2998),
    [sym_kAssignMul] = ACTIONS(2998),
    [sym_kAssignDiv] = ACTIONS(2998),
    [sym_kOr] = ACTIONS(2996),
    [sym_kXor] = ACTIONS(2996),
    [sym_kDiv] = ACTIONS(2996),
    [sym_kMod] = ACTIONS(2996),
    [sym_kAnd] = ACTIONS(2996),
    [sym_kShl] = ACTIONS(2996),
    [sym_kShr] = ACTIONS(2996),
    [sym_kIs] = ACTIONS(2996),
    [sym_kAs] = ACTIONS(2996),
    [sym_kIn] = ACTIONS(2996),
    [sym_kThen] = ACTIONS(2996),
    [sym_kElse] = ACTIONS(2996),
    [sym_kDo] = ACTIONS(2996),
    [sym_kUntil] = ACTIONS(2996),
    [sym_kExcept] = ACTIONS(2996),
    [sym_kFinally] = ACTIONS(2996),
    [sym_kCase] = ACTIONS(2996),
    [sym_kFunction] = ACTIONS(2996),
    [sym_kProcedure] = ACTIONS(2996),
    [sym_kConstructor] = ACTIONS(2996),
    [sym_kDestructor] = ACTIONS(2996),
    [sym_kOperator] = ACTIONS(2996),
    [sym_kPublished] = ACTIONS(2996),
    [sym_kPublic] = ACTIONS(2996),
    [sym_kProtected] = ACTIONS(2996),
    [sym_kPrivate] = ACTIONS(2996),
    [sym_kStrict] = ACTIONS(2996),
    [sym_kRequired] = ACTIONS(2996),
    [sym_kOptional] = ACTIONS(2996),
    [sym_kDelayed] = ACTIONS(2996),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_RBRACK] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3000),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3002),
    [sym_kEnd] = ACTIONS(3000),
    [sym_kVar] = ACTIONS(3000),
    [sym_kThreadvar] = ACTIONS(3000),
    [sym_kConst] = ACTIONS(3000),
    [sym_kResourcestring] = ACTIONS(3000),
    [sym_kType] = ACTIONS(3000),
    [sym_kProperty] = ACTIONS(3000),
    [sym_kClass] = ACTIONS(3000),
    [sym_kOf] = ACTIONS(3000),
    [sym_kGeneric] = ACTIONS(3000),
    [sym_kLt] = ACTIONS(3000),
    [sym_kEq] = ACTIONS(3002),
    [sym_kNeq] = ACTIONS(3002),
    [sym_kGt] = ACTIONS(3000),
    [sym_kLte] = ACTIONS(3002),
    [sym_kGte] = ACTIONS(3002),
    [sym_kAdd] = ACTIONS(3000),
    [sym_kSub] = ACTIONS(3000),
    [sym_kMul] = ACTIONS(3000),
    [sym_kFdiv] = ACTIONS(3000),
    [sym_kHat] = ACTIONS(3002),
    [sym_kAssign] = ACTIONS(3002),
    [sym_kAssignAdd] = ACTIONS(3002),
    [sym_kAssignSub] = ACTIONS(3002),
    [sym_kAssignMul] = ACTIONS(3002),
    [sym_kAssignDiv] = ACTIONS(3002),
    [sym_kOr] = ACTIONS(3000),
    [sym_kXor] = ACTIONS(3000),
    [sym_kDiv] = ACTIONS(3000),
    [sym_kMod] = ACTIONS(3000),
    [sym_kAnd] = ACTIONS(3000),
    [sym_kShl] = ACTIONS(3000),
    [sym_kShr] = ACTIONS(3000),
    [sym_kIs] = ACTIONS(3000),
    [sym_kAs] = ACTIONS(3000),
    [sym_kIn] = ACTIONS(3000),
    [sym_kThen] = ACTIONS(3000),
    [sym_kElse] = ACTIONS(3000),
    [sym_kDo] = ACTIONS(3000),
    [sym_kUntil] = ACTIONS(3000),
    [sym_kExcept] = ACTIONS(3000),
    [sym_kFinally] = ACTIONS(3000),
    [sym_kCase] = ACTIONS(3000),
    [sym_kFunction] = ACTIONS(3000),
    [sym_kProcedure] = ACTIONS(3000),
    [sym_kConstructor] = ACTIONS(3000),
    [sym_kDestructor] = ACTIONS(3000),
    [sym_kOperator] = ACTIONS(3000),
    [sym_kPublished] = ACTIONS(3000),
    [sym_kPublic] = ACTIONS(3000),
    [sym_kProtected] = ACTIONS(3000),
    [sym_kPrivate] = ACTIONS(3000),
    [sym_kStrict] = ACTIONS(3000),
    [sym_kRequired] = ACTIONS(3000),
    [sym_kOptional] = ACTIONS(3000),
    [sym_kDelayed] = ACTIONS(3000),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [sym__expr] = STATE(1146),
    [sym__ref] = STATE(1114),
    [sym_lambda] = STATE(1114),
    [sym_inherited] = STATE(1114),
    [sym_exprDot] = STATE(1114),
    [sym_exprDeref] = STATE(1114),
    [sym_exprAs] = STATE(1114),
    [sym_exprTpl] = STATE(1114),
    [sym_exprSubscript] = STATE(1114),
    [sym_exprCall] = STATE(1114),
    [sym_exprBinary] = STATE(1146),
    [sym_exprUnary] = STATE(1146),
    [sym_exprParens] = STATE(1114),
    [sym_exprBrackets] = STATE(1114),
    [sym__literal] = STATE(1114),
    [sym_literalString] = STATE(1114),
    [sym__literalString] = STATE(1069),
    [sym_literalChar] = STATE(1069),
    [sym_literalNumber] = STATE(1114),
    [sym__literalInt] = STATE(1131),
    [sym__literalFloat] = STATE(1131),
    [aux_sym_literalString_repeat1] = STATE(1069),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_COLON] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(3006),
    [anon_sym_POUND] = ACTIONS(3008),
    [aux_sym__literalInt_token1] = ACTIONS(3010),
    [aux_sym__literalInt_token2] = ACTIONS(3012),
    [aux_sym__literalFloat_token1] = ACTIONS(3010),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(3014),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(3016),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(3018),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(3020),
    [sym_kProcedure] = ACTIONS(3020),
    [sym_kInherited] = ACTIONS(3022),
    [sym_kNil] = ACTIONS(3004),
    [sym_kTrue] = ACTIONS(3004),
    [sym_kFalse] = ACTIONS(3004),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_COLON] = ACTIONS(2875),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_RBRACK] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [sym_kEnd] = ACTIONS(2875),
    [sym_kVar] = ACTIONS(2875),
    [sym_kThreadvar] = ACTIONS(2875),
    [sym_kConst] = ACTIONS(2875),
    [sym_kResourcestring] = ACTIONS(2875),
    [sym_kType] = ACTIONS(2875),
    [sym_kProperty] = ACTIONS(2875),
    [sym_kClass] = ACTIONS(2875),
    [sym_kOf] = ACTIONS(2875),
    [sym_kGeneric] = ACTIONS(2875),
    [sym_kLt] = ACTIONS(2875),
    [sym_kEq] = ACTIONS(2877),
    [sym_kNeq] = ACTIONS(2877),
    [sym_kGt] = ACTIONS(2875),
    [sym_kLte] = ACTIONS(2877),
    [sym_kGte] = ACTIONS(2877),
    [sym_kAdd] = ACTIONS(2875),
    [sym_kSub] = ACTIONS(2875),
    [sym_kMul] = ACTIONS(2875),
    [sym_kFdiv] = ACTIONS(2875),
    [sym_kHat] = ACTIONS(2877),
    [sym_kAssign] = ACTIONS(2877),
    [sym_kAssignAdd] = ACTIONS(2877),
    [sym_kAssignSub] = ACTIONS(2877),
    [sym_kAssignMul] = ACTIONS(2877),
    [sym_kAssignDiv] = ACTIONS(2877),
    [sym_kOr] = ACTIONS(2875),
    [sym_kXor] = ACTIONS(2875),
    [sym_kDiv] = ACTIONS(2875),
    [sym_kMod] = ACTIONS(2875),
    [sym_kAnd] = ACTIONS(2875),
    [sym_kShl] = ACTIONS(2875),
    [sym_kShr] = ACTIONS(2875),
    [sym_kIs] = ACTIONS(2875),
    [sym_kAs] = ACTIONS(2875),
    [sym_kIn] = ACTIONS(2875),
    [sym_kThen] = ACTIONS(2875),
    [sym_kElse] = ACTIONS(2875),
    [sym_kDo] = ACTIONS(2875),
    [sym_kUntil] = ACTIONS(2875),
    [sym_kExcept] = ACTIONS(2875),
    [sym_kFinally] = ACTIONS(2875),
    [sym_kCase] = ACTIONS(2875),
    [sym_kFunction] = ACTIONS(2875),
    [sym_kProcedure] = ACTIONS(2875),
    [sym_kConstructor] = ACTIONS(2875),
    [sym_kDestructor] = ACTIONS(2875),
    [sym_kOperator] = ACTIONS(2875),
    [sym_kPublished] = ACTIONS(2875),
    [sym_kPublic] = ACTIONS(2875),
    [sym_kProtected] = ACTIONS(2875),
    [sym_kPrivate] = ACTIONS(2875),
    [sym_kStrict] = ACTIONS(2875),
    [sym_kRequired] = ACTIONS(2875),
    [sym_kOptional] = ACTIONS(2875),
    [sym_kDelayed] = ACTIONS(2875),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [sym_identifier] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_RBRACK] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_RPAREN] = ACTIONS(3026),
    [anon_sym_DOT] = ACTIONS(3026),
    [sym_kEnd] = ACTIONS(3024),
    [sym_kVar] = ACTIONS(3024),
    [sym_kThreadvar] = ACTIONS(3024),
    [sym_kConst] = ACTIONS(3024),
    [sym_kResourcestring] = ACTIONS(3024),
    [sym_kType] = ACTIONS(3024),
    [sym_kProperty] = ACTIONS(3024),
    [sym_kClass] = ACTIONS(3024),
    [sym_kOf] = ACTIONS(3024),
    [sym_kGeneric] = ACTIONS(3024),
    [sym_kLt] = ACTIONS(3024),
    [sym_kEq] = ACTIONS(3026),
    [sym_kNeq] = ACTIONS(3026),
    [sym_kGt] = ACTIONS(3024),
    [sym_kLte] = ACTIONS(3026),
    [sym_kGte] = ACTIONS(3026),
    [sym_kAdd] = ACTIONS(3024),
    [sym_kSub] = ACTIONS(3024),
    [sym_kMul] = ACTIONS(3024),
    [sym_kFdiv] = ACTIONS(3024),
    [sym_kHat] = ACTIONS(3026),
    [sym_kAssign] = ACTIONS(3026),
    [sym_kAssignAdd] = ACTIONS(3026),
    [sym_kAssignSub] = ACTIONS(3026),
    [sym_kAssignMul] = ACTIONS(3026),
    [sym_kAssignDiv] = ACTIONS(3026),
    [sym_kOr] = ACTIONS(3024),
    [sym_kXor] = ACTIONS(3024),
    [sym_kDiv] = ACTIONS(3024),
    [sym_kMod] = ACTIONS(3024),
    [sym_kAnd] = ACTIONS(3024),
    [sym_kShl] = ACTIONS(3024),
    [sym_kShr] = ACTIONS(3024),
    [sym_kIs] = ACTIONS(3024),
    [sym_kAs] = ACTIONS(3024),
    [sym_kIn] = ACTIONS(3024),
    [sym_kThen] = ACTIONS(3024),
    [sym_kElse] = ACTIONS(3024),
    [sym_kDo] = ACTIONS(3024),
    [sym_kUntil] = ACTIONS(3024),
    [sym_kExcept] = ACTIONS(3024),
    [sym_kFinally] = ACTIONS(3024),
    [sym_kCase] = ACTIONS(3024),
    [sym_kFunction] = ACTIONS(3024),
    [sym_kProcedure] = ACTIONS(3024),
    [sym_kConstructor] = ACTIONS(3024),
    [sym_kDestructor] = ACTIONS(3024),
    [sym_kOperator] = ACTIONS(3024),
    [sym_kPublished] = ACTIONS(3024),
    [sym_kPublic] = ACTIONS(3024),
    [sym_kProtected] = ACTIONS(3024),
    [sym_kPrivate] = ACTIONS(3024),
    [sym_kStrict] = ACTIONS(3024),
    [sym_kRequired] = ACTIONS(3024),
    [sym_kOptional] = ACTIONS(3024),
    [sym_kDelayed] = ACTIONS(3024),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [sym__visibility] = STATE(966),
    [aux_sym__classDeclarations] = STATE(965),
    [sym_declTypes] = STATE(965),
    [sym_declVars] = STATE(965),
    [sym_declConsts] = STATE(965),
    [sym_declProc] = STATE(965),
    [sym__declClass] = STATE(2154),
    [sym_declSection] = STATE(1457),
    [aux_sym__declFields] = STATE(854),
    [sym_declField] = STATE(854),
    [sym_declProp] = STATE(965),
    [sym_declVariant] = STATE(2284),
    [sym__declProc] = STATE(1359),
    [sym__declOperator] = STATE(1099),
    [sym_rttiAttributes] = STATE(1483),
    [aux_sym_genericArg_repeat1] = STATE(2004),
    [aux_sym__declClass_repeat1] = STATE(1457),
    [aux_sym_rttiAttributes_repeat2] = STATE(1485),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(3030),
    [sym_kEnd] = ACTIONS(3032),
    [sym_kVar] = ACTIONS(2914),
    [sym_kThreadvar] = ACTIONS(2914),
    [sym_kConst] = ACTIONS(2916),
    [sym_kResourcestring] = ACTIONS(2916),
    [sym_kType] = ACTIONS(2918),
    [sym_kProperty] = ACTIONS(2920),
    [sym_kClass] = ACTIONS(2922),
    [sym_kGeneric] = ACTIONS(2924),
    [sym_kLt] = ACTIONS(2926),
    [sym_kEq] = ACTIONS(2928),
    [sym_kNeq] = ACTIONS(2928),
    [sym_kGt] = ACTIONS(2926),
    [sym_kLte] = ACTIONS(2928),
    [sym_kGte] = ACTIONS(2928),
    [sym_kAdd] = ACTIONS(2930),
    [sym_kSub] = ACTIONS(2930),
    [sym_kMul] = ACTIONS(2932),
    [sym_kFdiv] = ACTIONS(2934),
    [sym_kHat] = ACTIONS(2904),
    [sym_kOr] = ACTIONS(2936),
    [sym_kXor] = ACTIONS(2936),
    [sym_kDiv] = ACTIONS(2934),
    [sym_kMod] = ACTIONS(2934),
    [sym_kAnd] = ACTIONS(2934),
    [sym_kShl] = ACTIONS(2934),
    [sym_kShr] = ACTIONS(2934),
    [sym_kIs] = ACTIONS(2926),
    [sym_kAs] = ACTIONS(2938),
    [sym_kIn] = ACTIONS(2926),
    [sym_kCase] = ACTIONS(2940),
    [sym_kFunction] = ACTIONS(2942),
    [sym_kProcedure] = ACTIONS(2942),
    [sym_kConstructor] = ACTIONS(2942),
    [sym_kDestructor] = ACTIONS(2942),
    [sym_kOperator] = ACTIONS(2944),
    [sym_kPublished] = ACTIONS(2946),
    [sym_kPublic] = ACTIONS(2946),
    [sym_kProtected] = ACTIONS(2946),
    [sym_kPrivate] = ACTIONS(2946),
    [sym_kStrict] = ACTIONS(2948),
    [sym_kRequired] = ACTIONS(2946),
    [sym_kOptional] = ACTIONS(2946),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_COLON] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_RBRACK] = ACTIONS(3036),
    [anon_sym_LPAREN] = ACTIONS(3034),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_DOT] = ACTIONS(3036),
    [sym_kEnd] = ACTIONS(3034),
    [sym_kVar] = ACTIONS(3034),
    [sym_kThreadvar] = ACTIONS(3034),
    [sym_kConst] = ACTIONS(3034),
    [sym_kResourcestring] = ACTIONS(3034),
    [sym_kType] = ACTIONS(3034),
    [sym_kProperty] = ACTIONS(3034),
    [sym_kClass] = ACTIONS(3034),
    [sym_kOf] = ACTIONS(3034),
    [sym_kGeneric] = ACTIONS(3034),
    [sym_kLt] = ACTIONS(3034),
    [sym_kEq] = ACTIONS(3036),
    [sym_kNeq] = ACTIONS(3036),
    [sym_kGt] = ACTIONS(3034),
    [sym_kLte] = ACTIONS(3036),
    [sym_kGte] = ACTIONS(3036),
    [sym_kAdd] = ACTIONS(3034),
    [sym_kSub] = ACTIONS(3034),
    [sym_kMul] = ACTIONS(3034),
    [sym_kFdiv] = ACTIONS(3034),
    [sym_kHat] = ACTIONS(3036),
    [sym_kAssign] = ACTIONS(3036),
    [sym_kAssignAdd] = ACTIONS(3036),
    [sym_kAssignSub] = ACTIONS(3036),
    [sym_kAssignMul] = ACTIONS(3036),
    [sym_kAssignDiv] = ACTIONS(3036),
    [sym_kOr] = ACTIONS(3034),
    [sym_kXor] = ACTIONS(3034),
    [sym_kDiv] = ACTIONS(3034),
    [sym_kMod] = ACTIONS(3034),
    [sym_kAnd] = ACTIONS(3034),
    [sym_kShl] = ACTIONS(3034),
    [sym_kShr] = ACTIONS(3034),
    [sym_kIs] = ACTIONS(3034),
    [sym_kAs] = ACTIONS(3034),
    [sym_kIn] = ACTIONS(3034),
    [sym_kThen] = ACTIONS(3034),
    [sym_kElse] = ACTIONS(3034),
    [sym_kDo] = ACTIONS(3034),
    [sym_kUntil] = ACTIONS(3034),
    [sym_kExcept] = ACTIONS(3034),
    [sym_kFinally] = ACTIONS(3034),
    [sym_kCase] = ACTIONS(3034),
    [sym_kFunction] = ACTIONS(3034),
    [sym_kProcedure] = ACTIONS(3034),
    [sym_kConstructor] = ACTIONS(3034),
    [sym_kDestructor] = ACTIONS(3034),
    [sym_kOperator] = ACTIONS(3034),
    [sym_kPublished] = ACTIONS(3034),
    [sym_kPublic] = ACTIONS(3034),
    [sym_kProtected] = ACTIONS(3034),
    [sym_kPrivate] = ACTIONS(3034),
    [sym_kStrict] = ACTIONS(3034),
    [sym_kRequired] = ACTIONS(3034),
    [sym_kOptional] = ACTIONS(3034),
    [sym_kDelayed] = ACTIONS(3034),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [anon_sym_LBRACK] = ACTIONS(2706),
    [aux_sym_type_token1] = ACTIONS(2706),
    [sym_kUses] = ACTIONS(2706),
    [sym_kBegin] = ACTIONS(2706),
    [sym_kAsm] = ACTIONS(2706),
    [sym_kVar] = ACTIONS(2708),
    [sym_kThreadvar] = ACTIONS(2706),
    [sym_kConst] = ACTIONS(2708),
    [sym_kResourcestring] = ACTIONS(2706),
    [sym_kType] = ACTIONS(2706),
    [sym_kLabel] = ACTIONS(2706),
    [sym_kExports] = ACTIONS(2706),
    [sym_kDefault] = ACTIONS(2706),
    [sym_kNodefault] = ACTIONS(2706),
    [sym_kClass] = ACTIONS(2706),
    [sym_kGeneric] = ACTIONS(2706),
    [sym_kFunction] = ACTIONS(2706),
    [sym_kProcedure] = ACTIONS(2706),
    [sym_kConstructor] = ACTIONS(2706),
    [sym_kDestructor] = ACTIONS(2706),
    [sym_kOperator] = ACTIONS(2706),
    [sym_kPublic] = ACTIONS(2706),
    [sym_kForward] = ACTIONS(2706),
    [sym_kStatic] = ACTIONS(2706),
    [sym_kVirtual] = ACTIONS(2706),
    [sym_kAbstract] = ACTIONS(2706),
    [sym_kDynamic] = ACTIONS(2706),
    [sym_kOverride] = ACTIONS(2706),
    [sym_kOverload] = ACTIONS(2706),
    [sym_kReintroduce] = ACTIONS(2706),
    [sym_kInline] = ACTIONS(2706),
    [sym_kStdcall] = ACTIONS(2706),
    [sym_kCdecl] = ACTIONS(2706),
    [sym_kCppdecl] = ACTIONS(2706),
    [sym_kPascal] = ACTIONS(2706),
    [sym_kRegister] = ACTIONS(2706),
    [sym_kMwpascal] = ACTIONS(2706),
    [sym_kExternal] = ACTIONS(2706),
    [sym_kMessage] = ACTIONS(2706),
    [sym_kDeprecated] = ACTIONS(2706),
    [sym_kExperimental] = ACTIONS(2706),
    [sym_kPlatform] = ACTIONS(2706),
    [sym_kUnimplemented] = ACTIONS(2706),
    [sym_kCvar] = ACTIONS(2706),
    [sym_kExport] = ACTIONS(2708),
    [sym_kFar] = ACTIONS(2706),
    [sym_kNear] = ACTIONS(2706),
    [sym_kSafecall] = ACTIONS(2706),
    [sym_kAssembler] = ACTIONS(2706),
    [sym_kNostackframe] = ACTIONS(2706),
    [sym_kInterrupt] = ACTIONS(2706),
    [sym_kNoreturn] = ACTIONS(2706),
    [sym_kIocheck] = ACTIONS(2706),
    [sym_kLocal] = ACTIONS(2706),
    [sym_kHardfloat] = ACTIONS(2706),
    [sym_kSoftfloat] = ACTIONS(2706),
    [sym_kMs_abi_default] = ACTIONS(2706),
    [sym_kMs_abi_cdecl] = ACTIONS(2706),
    [sym_kSaveregisters] = ACTIONS(2706),
    [sym_kSysv_abi_default] = ACTIONS(2706),
    [sym_kSysv_abi_cdecl] = ACTIONS(2706),
    [sym_kVectorcall] = ACTIONS(2706),
    [sym_kVarargs] = ACTIONS(2706),
    [sym_kWinapi] = ACTIONS(2706),
    [sym_kAlias] = ACTIONS(2706),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_COLON] = ACTIONS(3038),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3040),
    [sym_kEnd] = ACTIONS(3038),
    [sym_kVar] = ACTIONS(3038),
    [sym_kThreadvar] = ACTIONS(3038),
    [sym_kConst] = ACTIONS(3038),
    [sym_kResourcestring] = ACTIONS(3038),
    [sym_kType] = ACTIONS(3038),
    [sym_kProperty] = ACTIONS(3038),
    [sym_kClass] = ACTIONS(3038),
    [sym_kOf] = ACTIONS(3038),
    [sym_kGeneric] = ACTIONS(3038),
    [sym_kLt] = ACTIONS(3038),
    [sym_kEq] = ACTIONS(3040),
    [sym_kNeq] = ACTIONS(3040),
    [sym_kGt] = ACTIONS(3038),
    [sym_kLte] = ACTIONS(3040),
    [sym_kGte] = ACTIONS(3040),
    [sym_kAdd] = ACTIONS(3038),
    [sym_kSub] = ACTIONS(3038),
    [sym_kMul] = ACTIONS(3038),
    [sym_kFdiv] = ACTIONS(3038),
    [sym_kHat] = ACTIONS(3040),
    [sym_kAssign] = ACTIONS(3040),
    [sym_kAssignAdd] = ACTIONS(3040),
    [sym_kAssignSub] = ACTIONS(3040),
    [sym_kAssignMul] = ACTIONS(3040),
    [sym_kAssignDiv] = ACTIONS(3040),
    [sym_kOr] = ACTIONS(3038),
    [sym_kXor] = ACTIONS(3038),
    [sym_kDiv] = ACTIONS(3038),
    [sym_kMod] = ACTIONS(3038),
    [sym_kAnd] = ACTIONS(3038),
    [sym_kShl] = ACTIONS(3038),
    [sym_kShr] = ACTIONS(3038),
    [sym_kIs] = ACTIONS(3038),
    [sym_kAs] = ACTIONS(3038),
    [sym_kIn] = ACTIONS(3038),
    [sym_kThen] = ACTIONS(3038),
    [sym_kElse] = ACTIONS(3038),
    [sym_kDo] = ACTIONS(3038),
    [sym_kUntil] = ACTIONS(3038),
    [sym_kExcept] = ACTIONS(3038),
    [sym_kFinally] = ACTIONS(3038),
    [sym_kCase] = ACTIONS(3038),
    [sym_kFunction] = ACTIONS(3038),
    [sym_kProcedure] = ACTIONS(3038),
    [sym_kConstructor] = ACTIONS(3038),
    [sym_kDestructor] = ACTIONS(3038),
    [sym_kOperator] = ACTIONS(3038),
    [sym_kPublished] = ACTIONS(3038),
    [sym_kPublic] = ACTIONS(3038),
    [sym_kProtected] = ACTIONS(3038),
    [sym_kPrivate] = ACTIONS(3038),
    [sym_kStrict] = ACTIONS(3038),
    [sym_kRequired] = ACTIONS(3038),
    [sym_kOptional] = ACTIONS(3038),
    [sym_kDelayed] = ACTIONS(3038),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [anon_sym_LBRACK] = ACTIONS(2683),
    [aux_sym_type_token1] = ACTIONS(2683),
    [sym_kUses] = ACTIONS(2683),
    [sym_kBegin] = ACTIONS(2683),
    [sym_kAsm] = ACTIONS(2683),
    [sym_kVar] = ACTIONS(2685),
    [sym_kThreadvar] = ACTIONS(2683),
    [sym_kConst] = ACTIONS(2685),
    [sym_kResourcestring] = ACTIONS(2683),
    [sym_kType] = ACTIONS(2683),
    [sym_kLabel] = ACTIONS(2683),
    [sym_kExports] = ACTIONS(2683),
    [sym_kDefault] = ACTIONS(2683),
    [sym_kNodefault] = ACTIONS(2683),
    [sym_kClass] = ACTIONS(2683),
    [sym_kGeneric] = ACTIONS(2683),
    [sym_kFunction] = ACTIONS(2683),
    [sym_kProcedure] = ACTIONS(2683),
    [sym_kConstructor] = ACTIONS(2683),
    [sym_kDestructor] = ACTIONS(2683),
    [sym_kOperator] = ACTIONS(2683),
    [sym_kPublic] = ACTIONS(2683),
    [sym_kForward] = ACTIONS(2683),
    [sym_kStatic] = ACTIONS(2683),
    [sym_kVirtual] = ACTIONS(2683),
    [sym_kAbstract] = ACTIONS(2683),
    [sym_kDynamic] = ACTIONS(2683),
    [sym_kOverride] = ACTIONS(2683),
    [sym_kOverload] = ACTIONS(2683),
    [sym_kReintroduce] = ACTIONS(2683),
    [sym_kInline] = ACTIONS(2683),
    [sym_kStdcall] = ACTIONS(2683),
    [sym_kCdecl] = ACTIONS(2683),
    [sym_kCppdecl] = ACTIONS(2683),
    [sym_kPascal] = ACTIONS(2683),
    [sym_kRegister] = ACTIONS(2683),
    [sym_kMwpascal] = ACTIONS(2683),
    [sym_kExternal] = ACTIONS(2683),
    [sym_kMessage] = ACTIONS(2683),
    [sym_kDeprecated] = ACTIONS(2683),
    [sym_kExperimental] = ACTIONS(2683),
    [sym_kPlatform] = ACTIONS(2683),
    [sym_kUnimplemented] = ACTIONS(2683),
    [sym_kCvar] = ACTIONS(2683),
    [sym_kExport] = ACTIONS(2685),
    [sym_kFar] = ACTIONS(2683),
    [sym_kNear] = ACTIONS(2683),
    [sym_kSafecall] = ACTIONS(2683),
    [sym_kAssembler] = ACTIONS(2683),
    [sym_kNostackframe] = ACTIONS(2683),
    [sym_kInterrupt] = ACTIONS(2683),
    [sym_kNoreturn] = ACTIONS(2683),
    [sym_kIocheck] = ACTIONS(2683),
    [sym_kLocal] = ACTIONS(2683),
    [sym_kHardfloat] = ACTIONS(2683),
    [sym_kSoftfloat] = ACTIONS(2683),
    [sym_kMs_abi_default] = ACTIONS(2683),
    [sym_kMs_abi_cdecl] = ACTIONS(2683),
    [sym_kSaveregisters] = ACTIONS(2683),
    [sym_kSysv_abi_default] = ACTIONS(2683),
    [sym_kSysv_abi_cdecl] = ACTIONS(2683),
    [sym_kVectorcall] = ACTIONS(2683),
    [sym_kVarargs] = ACTIONS(2683),
    [sym_kWinapi] = ACTIONS(2683),
    [sym_kAlias] = ACTIONS(2683),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_RBRACK] = ACTIONS(3044),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_DOT] = ACTIONS(3044),
    [sym_kEnd] = ACTIONS(3042),
    [sym_kVar] = ACTIONS(3042),
    [sym_kThreadvar] = ACTIONS(3042),
    [sym_kConst] = ACTIONS(3042),
    [sym_kResourcestring] = ACTIONS(3042),
    [sym_kType] = ACTIONS(3042),
    [sym_kProperty] = ACTIONS(3042),
    [sym_kClass] = ACTIONS(3042),
    [sym_kOf] = ACTIONS(3042),
    [sym_kGeneric] = ACTIONS(3042),
    [sym_kLt] = ACTIONS(3042),
    [sym_kEq] = ACTIONS(3044),
    [sym_kNeq] = ACTIONS(3044),
    [sym_kGt] = ACTIONS(3042),
    [sym_kLte] = ACTIONS(3044),
    [sym_kGte] = ACTIONS(3044),
    [sym_kAdd] = ACTIONS(3042),
    [sym_kSub] = ACTIONS(3042),
    [sym_kMul] = ACTIONS(3042),
    [sym_kFdiv] = ACTIONS(3042),
    [sym_kHat] = ACTIONS(3044),
    [sym_kAssign] = ACTIONS(3044),
    [sym_kAssignAdd] = ACTIONS(3044),
    [sym_kAssignSub] = ACTIONS(3044),
    [sym_kAssignMul] = ACTIONS(3044),
    [sym_kAssignDiv] = ACTIONS(3044),
    [sym_kOr] = ACTIONS(3042),
    [sym_kXor] = ACTIONS(3042),
    [sym_kDiv] = ACTIONS(3042),
    [sym_kMod] = ACTIONS(3042),
    [sym_kAnd] = ACTIONS(3042),
    [sym_kShl] = ACTIONS(3042),
    [sym_kShr] = ACTIONS(3042),
    [sym_kIs] = ACTIONS(3042),
    [sym_kAs] = ACTIONS(3042),
    [sym_kIn] = ACTIONS(3042),
    [sym_kThen] = ACTIONS(3042),
    [sym_kElse] = ACTIONS(3042),
    [sym_kDo] = ACTIONS(3042),
    [sym_kUntil] = ACTIONS(3042),
    [sym_kExcept] = ACTIONS(3042),
    [sym_kFinally] = ACTIONS(3042),
    [sym_kCase] = ACTIONS(3042),
    [sym_kFunction] = ACTIONS(3042),
    [sym_kProcedure] = ACTIONS(3042),
    [sym_kConstructor] = ACTIONS(3042),
    [sym_kDestructor] = ACTIONS(3042),
    [sym_kOperator] = ACTIONS(3042),
    [sym_kPublished] = ACTIONS(3042),
    [sym_kPublic] = ACTIONS(3042),
    [sym_kProtected] = ACTIONS(3042),
    [sym_kPrivate] = ACTIONS(3042),
    [sym_kStrict] = ACTIONS(3042),
    [sym_kRequired] = ACTIONS(3042),
    [sym_kOptional] = ACTIONS(3042),
    [sym_kDelayed] = ACTIONS(3042),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_identifier] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_COLON] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_RBRACK] = ACTIONS(3048),
    [anon_sym_LPAREN] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3048),
    [sym_kEnd] = ACTIONS(3046),
    [sym_kVar] = ACTIONS(3046),
    [sym_kThreadvar] = ACTIONS(3046),
    [sym_kConst] = ACTIONS(3046),
    [sym_kResourcestring] = ACTIONS(3046),
    [sym_kType] = ACTIONS(3046),
    [sym_kProperty] = ACTIONS(3046),
    [sym_kClass] = ACTIONS(3046),
    [sym_kOf] = ACTIONS(3046),
    [sym_kGeneric] = ACTIONS(3046),
    [sym_kLt] = ACTIONS(3046),
    [sym_kEq] = ACTIONS(3048),
    [sym_kNeq] = ACTIONS(3048),
    [sym_kGt] = ACTIONS(3046),
    [sym_kLte] = ACTIONS(3048),
    [sym_kGte] = ACTIONS(3048),
    [sym_kAdd] = ACTIONS(3046),
    [sym_kSub] = ACTIONS(3046),
    [sym_kMul] = ACTIONS(3046),
    [sym_kFdiv] = ACTIONS(3046),
    [sym_kHat] = ACTIONS(2904),
    [sym_kAssign] = ACTIONS(3048),
    [sym_kAssignAdd] = ACTIONS(3048),
    [sym_kAssignSub] = ACTIONS(3048),
    [sym_kAssignMul] = ACTIONS(3048),
    [sym_kAssignDiv] = ACTIONS(3048),
    [sym_kOr] = ACTIONS(3046),
    [sym_kXor] = ACTIONS(3046),
    [sym_kDiv] = ACTIONS(3046),
    [sym_kMod] = ACTIONS(3046),
    [sym_kAnd] = ACTIONS(3046),
    [sym_kShl] = ACTIONS(3046),
    [sym_kShr] = ACTIONS(3046),
    [sym_kIs] = ACTIONS(3046),
    [sym_kAs] = ACTIONS(3046),
    [sym_kIn] = ACTIONS(3046),
    [sym_kThen] = ACTIONS(3046),
    [sym_kElse] = ACTIONS(3046),
    [sym_kDo] = ACTIONS(3046),
    [sym_kUntil] = ACTIONS(3046),
    [sym_kExcept] = ACTIONS(3046),
    [sym_kFinally] = ACTIONS(3046),
    [sym_kCase] = ACTIONS(3046),
    [sym_kFunction] = ACTIONS(3046),
    [sym_kProcedure] = ACTIONS(3046),
    [sym_kConstructor] = ACTIONS(3046),
    [sym_kDestructor] = ACTIONS(3046),
    [sym_kOperator] = ACTIONS(3046),
    [sym_kPublished] = ACTIONS(3046),
    [sym_kPublic] = ACTIONS(3046),
    [sym_kProtected] = ACTIONS(3046),
    [sym_kPrivate] = ACTIONS(3046),
    [sym_kStrict] = ACTIONS(3046),
    [sym_kRequired] = ACTIONS(3046),
    [sym_kOptional] = ACTIONS(3046),
    [sym_kDelayed] = ACTIONS(3046),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_COLON] = ACTIONS(3050),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3050),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3052),
    [sym_kEnd] = ACTIONS(3050),
    [sym_kVar] = ACTIONS(3050),
    [sym_kThreadvar] = ACTIONS(3050),
    [sym_kConst] = ACTIONS(3050),
    [sym_kResourcestring] = ACTIONS(3050),
    [sym_kType] = ACTIONS(3050),
    [sym_kProperty] = ACTIONS(3050),
    [sym_kClass] = ACTIONS(3050),
    [sym_kOf] = ACTIONS(3050),
    [sym_kGeneric] = ACTIONS(3050),
    [sym_kLt] = ACTIONS(3050),
    [sym_kEq] = ACTIONS(3052),
    [sym_kNeq] = ACTIONS(3052),
    [sym_kGt] = ACTIONS(3050),
    [sym_kLte] = ACTIONS(3052),
    [sym_kGte] = ACTIONS(3052),
    [sym_kAdd] = ACTIONS(3050),
    [sym_kSub] = ACTIONS(3050),
    [sym_kMul] = ACTIONS(3050),
    [sym_kFdiv] = ACTIONS(3050),
    [sym_kHat] = ACTIONS(3052),
    [sym_kAssign] = ACTIONS(3052),
    [sym_kAssignAdd] = ACTIONS(3052),
    [sym_kAssignSub] = ACTIONS(3052),
    [sym_kAssignMul] = ACTIONS(3052),
    [sym_kAssignDiv] = ACTIONS(3052),
    [sym_kOr] = ACTIONS(3050),
    [sym_kXor] = ACTIONS(3050),
    [sym_kDiv] = ACTIONS(3050),
    [sym_kMod] = ACTIONS(3050),
    [sym_kAnd] = ACTIONS(3050),
    [sym_kShl] = ACTIONS(3050),
    [sym_kShr] = ACTIONS(3050),
    [sym_kIs] = ACTIONS(3050),
    [sym_kAs] = ACTIONS(3050),
    [sym_kIn] = ACTIONS(3050),
    [sym_kThen] = ACTIONS(3050),
    [sym_kElse] = ACTIONS(3050),
    [sym_kDo] = ACTIONS(3050),
    [sym_kUntil] = ACTIONS(3050),
    [sym_kExcept] = ACTIONS(3050),
    [sym_kFinally] = ACTIONS(3050),
    [sym_kCase] = ACTIONS(3050),
    [sym_kFunction] = ACTIONS(3050),
    [sym_kProcedure] = ACTIONS(3050),
    [sym_kConstructor] = ACTIONS(3050),
    [sym_kDestructor] = ACTIONS(3050),
    [sym_kOperator] = ACTIONS(3050),
    [sym_kPublished] = ACTIONS(3050),
    [sym_kPublic] = ACTIONS(3050),
    [sym_kProtected] = ACTIONS(3050),
    [sym_kPrivate] = ACTIONS(3050),
    [sym_kStrict] = ACTIONS(3050),
    [sym_kRequired] = ACTIONS(3050),
    [sym_kOptional] = ACTIONS(3050),
    [sym_kDelayed] = ACTIONS(3050),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_COLON] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_LPAREN] = ACTIONS(3054),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3056),
    [sym_kEnd] = ACTIONS(3054),
    [sym_kVar] = ACTIONS(3054),
    [sym_kThreadvar] = ACTIONS(3054),
    [sym_kConst] = ACTIONS(3054),
    [sym_kResourcestring] = ACTIONS(3054),
    [sym_kType] = ACTIONS(3054),
    [sym_kProperty] = ACTIONS(3054),
    [sym_kClass] = ACTIONS(3054),
    [sym_kOf] = ACTIONS(3054),
    [sym_kGeneric] = ACTIONS(3054),
    [sym_kLt] = ACTIONS(3054),
    [sym_kEq] = ACTIONS(3056),
    [sym_kNeq] = ACTIONS(3056),
    [sym_kGt] = ACTIONS(3054),
    [sym_kLte] = ACTIONS(3056),
    [sym_kGte] = ACTIONS(3056),
    [sym_kAdd] = ACTIONS(3054),
    [sym_kSub] = ACTIONS(3054),
    [sym_kMul] = ACTIONS(3054),
    [sym_kFdiv] = ACTIONS(3054),
    [sym_kHat] = ACTIONS(3056),
    [sym_kAssign] = ACTIONS(3056),
    [sym_kAssignAdd] = ACTIONS(3056),
    [sym_kAssignSub] = ACTIONS(3056),
    [sym_kAssignMul] = ACTIONS(3056),
    [sym_kAssignDiv] = ACTIONS(3056),
    [sym_kOr] = ACTIONS(3054),
    [sym_kXor] = ACTIONS(3054),
    [sym_kDiv] = ACTIONS(3054),
    [sym_kMod] = ACTIONS(3054),
    [sym_kAnd] = ACTIONS(3054),
    [sym_kShl] = ACTIONS(3054),
    [sym_kShr] = ACTIONS(3054),
    [sym_kIs] = ACTIONS(3054),
    [sym_kAs] = ACTIONS(3054),
    [sym_kIn] = ACTIONS(3054),
    [sym_kThen] = ACTIONS(3054),
    [sym_kElse] = ACTIONS(3054),
    [sym_kDo] = ACTIONS(3054),
    [sym_kUntil] = ACTIONS(3054),
    [sym_kExcept] = ACTIONS(3054),
    [sym_kFinally] = ACTIONS(3054),
    [sym_kCase] = ACTIONS(3054),
    [sym_kFunction] = ACTIONS(3054),
    [sym_kProcedure] = ACTIONS(3054),
    [sym_kConstructor] = ACTIONS(3054),
    [sym_kDestructor] = ACTIONS(3054),
    [sym_kOperator] = ACTIONS(3054),
    [sym_kPublished] = ACTIONS(3054),
    [sym_kPublic] = ACTIONS(3054),
    [sym_kProtected] = ACTIONS(3054),
    [sym_kPrivate] = ACTIONS(3054),
    [sym_kStrict] = ACTIONS(3054),
    [sym_kRequired] = ACTIONS(3054),
    [sym_kOptional] = ACTIONS(3054),
    [sym_kDelayed] = ACTIONS(3054),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_RBRACK] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(3058),
    [anon_sym_RPAREN] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [sym_kEnd] = ACTIONS(3058),
    [sym_kVar] = ACTIONS(3058),
    [sym_kThreadvar] = ACTIONS(3058),
    [sym_kConst] = ACTIONS(3058),
    [sym_kResourcestring] = ACTIONS(3058),
    [sym_kType] = ACTIONS(3058),
    [sym_kProperty] = ACTIONS(3058),
    [sym_kClass] = ACTIONS(3058),
    [sym_kOf] = ACTIONS(3058),
    [sym_kGeneric] = ACTIONS(3058),
    [sym_kLt] = ACTIONS(3058),
    [sym_kEq] = ACTIONS(3060),
    [sym_kNeq] = ACTIONS(3060),
    [sym_kGt] = ACTIONS(3058),
    [sym_kLte] = ACTIONS(3060),
    [sym_kGte] = ACTIONS(3060),
    [sym_kAdd] = ACTIONS(3058),
    [sym_kSub] = ACTIONS(3058),
    [sym_kMul] = ACTIONS(3058),
    [sym_kFdiv] = ACTIONS(3058),
    [sym_kHat] = ACTIONS(3060),
    [sym_kAssign] = ACTIONS(3060),
    [sym_kAssignAdd] = ACTIONS(3060),
    [sym_kAssignSub] = ACTIONS(3060),
    [sym_kAssignMul] = ACTIONS(3060),
    [sym_kAssignDiv] = ACTIONS(3060),
    [sym_kOr] = ACTIONS(3058),
    [sym_kXor] = ACTIONS(3058),
    [sym_kDiv] = ACTIONS(3058),
    [sym_kMod] = ACTIONS(3058),
    [sym_kAnd] = ACTIONS(3058),
    [sym_kShl] = ACTIONS(3058),
    [sym_kShr] = ACTIONS(3058),
    [sym_kIs] = ACTIONS(3058),
    [sym_kAs] = ACTIONS(3058),
    [sym_kIn] = ACTIONS(3058),
    [sym_kThen] = ACTIONS(3058),
    [sym_kElse] = ACTIONS(3058),
    [sym_kDo] = ACTIONS(3058),
    [sym_kUntil] = ACTIONS(3058),
    [sym_kExcept] = ACTIONS(3058),
    [sym_kFinally] = ACTIONS(3058),
    [sym_kCase] = ACTIONS(3058),
    [sym_kFunction] = ACTIONS(3058),
    [sym_kProcedure] = ACTIONS(3058),
    [sym_kConstructor] = ACTIONS(3058),
    [sym_kDestructor] = ACTIONS(3058),
    [sym_kOperator] = ACTIONS(3058),
    [sym_kPublished] = ACTIONS(3058),
    [sym_kPublic] = ACTIONS(3058),
    [sym_kProtected] = ACTIONS(3058),
    [sym_kPrivate] = ACTIONS(3058),
    [sym_kStrict] = ACTIONS(3058),
    [sym_kRequired] = ACTIONS(3058),
    [sym_kOptional] = ACTIONS(3058),
    [sym_kDelayed] = ACTIONS(3058),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_identifier] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3064),
    [anon_sym_COLON] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_RBRACK] = ACTIONS(3064),
    [anon_sym_LPAREN] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3064),
    [anon_sym_DOT] = ACTIONS(3064),
    [sym_kEnd] = ACTIONS(3062),
    [sym_kVar] = ACTIONS(3062),
    [sym_kThreadvar] = ACTIONS(3062),
    [sym_kConst] = ACTIONS(3062),
    [sym_kResourcestring] = ACTIONS(3062),
    [sym_kType] = ACTIONS(3062),
    [sym_kProperty] = ACTIONS(3062),
    [sym_kClass] = ACTIONS(3062),
    [sym_kOf] = ACTIONS(3062),
    [sym_kGeneric] = ACTIONS(3062),
    [sym_kLt] = ACTIONS(3062),
    [sym_kEq] = ACTIONS(3064),
    [sym_kNeq] = ACTIONS(3064),
    [sym_kGt] = ACTIONS(3062),
    [sym_kLte] = ACTIONS(3064),
    [sym_kGte] = ACTIONS(3064),
    [sym_kAdd] = ACTIONS(3062),
    [sym_kSub] = ACTIONS(3062),
    [sym_kMul] = ACTIONS(3062),
    [sym_kFdiv] = ACTIONS(3062),
    [sym_kHat] = ACTIONS(3064),
    [sym_kAssign] = ACTIONS(3064),
    [sym_kAssignAdd] = ACTIONS(3064),
    [sym_kAssignSub] = ACTIONS(3064),
    [sym_kAssignMul] = ACTIONS(3064),
    [sym_kAssignDiv] = ACTIONS(3064),
    [sym_kOr] = ACTIONS(3062),
    [sym_kXor] = ACTIONS(3062),
    [sym_kDiv] = ACTIONS(3062),
    [sym_kMod] = ACTIONS(3062),
    [sym_kAnd] = ACTIONS(3062),
    [sym_kShl] = ACTIONS(3062),
    [sym_kShr] = ACTIONS(3062),
    [sym_kIs] = ACTIONS(3062),
    [sym_kAs] = ACTIONS(3062),
    [sym_kIn] = ACTIONS(3062),
    [sym_kThen] = ACTIONS(3062),
    [sym_kElse] = ACTIONS(3062),
    [sym_kDo] = ACTIONS(3062),
    [sym_kUntil] = ACTIONS(3062),
    [sym_kExcept] = ACTIONS(3062),
    [sym_kFinally] = ACTIONS(3062),
    [sym_kCase] = ACTIONS(3062),
    [sym_kFunction] = ACTIONS(3062),
    [sym_kProcedure] = ACTIONS(3062),
    [sym_kConstructor] = ACTIONS(3062),
    [sym_kDestructor] = ACTIONS(3062),
    [sym_kOperator] = ACTIONS(3062),
    [sym_kPublished] = ACTIONS(3062),
    [sym_kPublic] = ACTIONS(3062),
    [sym_kProtected] = ACTIONS(3062),
    [sym_kPrivate] = ACTIONS(3062),
    [sym_kStrict] = ACTIONS(3062),
    [sym_kRequired] = ACTIONS(3062),
    [sym_kOptional] = ACTIONS(3062),
    [sym_kDelayed] = ACTIONS(3062),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [sym_identifier] = ACTIONS(3066),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym_COLON] = ACTIONS(3066),
    [anon_sym_COMMA] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_RBRACK] = ACTIONS(3068),
    [anon_sym_LPAREN] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3068),
    [anon_sym_DOT] = ACTIONS(3068),
    [sym_kEnd] = ACTIONS(3066),
    [sym_kVar] = ACTIONS(3066),
    [sym_kThreadvar] = ACTIONS(3066),
    [sym_kConst] = ACTIONS(3066),
    [sym_kResourcestring] = ACTIONS(3066),
    [sym_kType] = ACTIONS(3066),
    [sym_kProperty] = ACTIONS(3066),
    [sym_kClass] = ACTIONS(3066),
    [sym_kOf] = ACTIONS(3066),
    [sym_kGeneric] = ACTIONS(3066),
    [sym_kLt] = ACTIONS(3066),
    [sym_kEq] = ACTIONS(3068),
    [sym_kNeq] = ACTIONS(3068),
    [sym_kGt] = ACTIONS(3066),
    [sym_kLte] = ACTIONS(3068),
    [sym_kGte] = ACTIONS(3068),
    [sym_kAdd] = ACTIONS(3066),
    [sym_kSub] = ACTIONS(3066),
    [sym_kMul] = ACTIONS(3066),
    [sym_kFdiv] = ACTIONS(3066),
    [sym_kHat] = ACTIONS(3068),
    [sym_kAssign] = ACTIONS(3068),
    [sym_kAssignAdd] = ACTIONS(3068),
    [sym_kAssignSub] = ACTIONS(3068),
    [sym_kAssignMul] = ACTIONS(3068),
    [sym_kAssignDiv] = ACTIONS(3068),
    [sym_kOr] = ACTIONS(3066),
    [sym_kXor] = ACTIONS(3066),
    [sym_kDiv] = ACTIONS(3066),
    [sym_kMod] = ACTIONS(3066),
    [sym_kAnd] = ACTIONS(3066),
    [sym_kShl] = ACTIONS(3066),
    [sym_kShr] = ACTIONS(3066),
    [sym_kIs] = ACTIONS(3066),
    [sym_kAs] = ACTIONS(3066),
    [sym_kIn] = ACTIONS(3066),
    [sym_kThen] = ACTIONS(3066),
    [sym_kElse] = ACTIONS(3066),
    [sym_kDo] = ACTIONS(3066),
    [sym_kUntil] = ACTIONS(3066),
    [sym_kExcept] = ACTIONS(3066),
    [sym_kFinally] = ACTIONS(3066),
    [sym_kCase] = ACTIONS(3066),
    [sym_kFunction] = ACTIONS(3066),
    [sym_kProcedure] = ACTIONS(3066),
    [sym_kConstructor] = ACTIONS(3066),
    [sym_kDestructor] = ACTIONS(3066),
    [sym_kOperator] = ACTIONS(3066),
    [sym_kPublished] = ACTIONS(3066),
    [sym_kPublic] = ACTIONS(3066),
    [sym_kProtected] = ACTIONS(3066),
    [sym_kPrivate] = ACTIONS(3066),
    [sym_kStrict] = ACTIONS(3066),
    [sym_kRequired] = ACTIONS(3066),
    [sym_kOptional] = ACTIONS(3066),
    [sym_kDelayed] = ACTIONS(3066),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [sym__expr] = STATE(1273),
    [sym__ref] = STATE(1134),
    [sym_lambda] = STATE(1134),
    [sym_inherited] = STATE(1134),
    [sym_exprDot] = STATE(1134),
    [sym_exprDeref] = STATE(1134),
    [sym_exprAs] = STATE(1134),
    [sym_exprTpl] = STATE(1134),
    [sym_exprSubscript] = STATE(1134),
    [sym_exprCall] = STATE(1134),
    [sym_exprBinary] = STATE(1273),
    [sym_exprUnary] = STATE(1273),
    [sym_exprParens] = STATE(1134),
    [sym_exprBrackets] = STATE(1134),
    [sym__literal] = STATE(1134),
    [sym_literalString] = STATE(1134),
    [sym__literalString] = STATE(1078),
    [sym_literalChar] = STATE(1078),
    [sym_literalNumber] = STATE(1134),
    [sym__literalInt] = STATE(1238),
    [sym__literalFloat] = STATE(1238),
    [aux_sym_literalString_repeat1] = STATE(1078),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(3072),
    [anon_sym_POUND] = ACTIONS(3074),
    [aux_sym__literalInt_token1] = ACTIONS(3076),
    [aux_sym__literalInt_token2] = ACTIONS(3078),
    [aux_sym__literalFloat_token1] = ACTIONS(3076),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(3080),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(3082),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(3084),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kTo] = ACTIONS(261),
    [sym_kDownto] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(3086),
    [sym_kProcedure] = ACTIONS(3086),
    [sym_kInherited] = ACTIONS(3088),
    [sym_kNil] = ACTIONS(3070),
    [sym_kTrue] = ACTIONS(3070),
    [sym_kFalse] = ACTIONS(3070),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(279),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(279),
    [sym_kEq] = ACTIONS(281),
    [sym_kNeq] = ACTIONS(281),
    [sym_kGt] = ACTIONS(279),
    [sym_kLte] = ACTIONS(281),
    [sym_kGte] = ACTIONS(281),
    [sym_kAdd] = ACTIONS(279),
    [sym_kSub] = ACTIONS(279),
    [sym_kMul] = ACTIONS(281),
    [sym_kFdiv] = ACTIONS(279),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(281),
    [sym_kOr] = ACTIONS(279),
    [sym_kXor] = ACTIONS(279),
    [sym_kDiv] = ACTIONS(279),
    [sym_kMod] = ACTIONS(279),
    [sym_kAnd] = ACTIONS(279),
    [sym_kShl] = ACTIONS(279),
    [sym_kShr] = ACTIONS(279),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(279),
    [sym_kAs] = ACTIONS(279),
    [sym_kIn] = ACTIONS(279),
    [sym_kTo] = ACTIONS(279),
    [sym_kDownto] = ACTIONS(279),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [sym__expr] = STATE(912),
    [sym__ref] = STATE(687),
    [sym_lambda] = STATE(687),
    [sym_inherited] = STATE(687),
    [sym_exprDot] = STATE(687),
    [sym_exprDeref] = STATE(687),
    [sym_exprAs] = STATE(687),
    [sym_exprTpl] = STATE(687),
    [sym_exprSubscript] = STATE(687),
    [sym_exprCall] = STATE(687),
    [sym_exprBinary] = STATE(912),
    [sym_exprUnary] = STATE(912),
    [sym_exprParens] = STATE(687),
    [sym_exprBrackets] = STATE(687),
    [sym__literal] = STATE(687),
    [sym_literalString] = STATE(687),
    [sym__literalString] = STATE(233),
    [sym_literalChar] = STATE(233),
    [sym_literalNumber] = STATE(687),
    [sym__literalInt] = STATE(533),
    [sym__literalFloat] = STATE(533),
    [aux_sym_literalString_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [aux_sym__literalString_token1] = ACTIONS(49),
    [anon_sym_POUND] = ACTIONS(51),
    [aux_sym__literalInt_token1] = ACTIONS(53),
    [aux_sym__literalInt_token2] = ACTIONS(55),
    [aux_sym__literalFloat_token1] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(261),
    [sym_kSpecialize] = ACTIONS(65),
    [sym_kLt] = ACTIONS(261),
    [sym_kEq] = ACTIONS(263),
    [sym_kNeq] = ACTIONS(263),
    [sym_kGt] = ACTIONS(261),
    [sym_kLte] = ACTIONS(263),
    [sym_kGte] = ACTIONS(263),
    [sym_kAdd] = ACTIONS(261),
    [sym_kSub] = ACTIONS(261),
    [sym_kMul] = ACTIONS(263),
    [sym_kFdiv] = ACTIONS(261),
    [sym_kAt] = ACTIONS(69),
    [sym_kHat] = ACTIONS(263),
    [sym_kOr] = ACTIONS(261),
    [sym_kXor] = ACTIONS(261),
    [sym_kDiv] = ACTIONS(261),
    [sym_kMod] = ACTIONS(261),
    [sym_kAnd] = ACTIONS(261),
    [sym_kShl] = ACTIONS(261),
    [sym_kShr] = ACTIONS(261),
    [sym_kNot] = ACTIONS(67),
    [sym_kIs] = ACTIONS(261),
    [sym_kAs] = ACTIONS(261),
    [sym_kIn] = ACTIONS(261),
    [sym_kTo] = ACTIONS(261),
    [sym_kDownto] = ACTIONS(261),
    [sym_kFunction] = ACTIONS(91),
    [sym_kProcedure] = ACTIONS(91),
    [sym_kInherited] = ACTIONS(93),
    [sym_kNil] = ACTIONS(95),
    [sym_kTrue] = ACTIONS(95),
    [sym_kFalse] = ACTIONS(95),
    [sym__space] = ACTIONS(3),
    [sym_pp] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3096), 1,
      sym_kLt,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3092), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEq,
      sym_kGt,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3090), 46,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kProperty,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [77] = 4,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3100), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kEq,
      sym_kGt,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3098), 46,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kProperty,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [150] = 4,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3104), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kEq,
      sym_kGt,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3102), 46,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kProperty,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [223] = 6,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3096), 1,
      sym_kLt,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3108), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEq,
      sym_kGt,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3106), 46,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kProperty,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [300] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3112), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3110), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [374] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3120), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3118), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [448] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3124), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3122), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [522] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3128), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kEq,
      sym_kGt,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3126), 46,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kProperty,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [592] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3132), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3130), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [666] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3136), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3134), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [740] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3140), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3138), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [814] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3144), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3142), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [888] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3148), 9,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3146), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [962] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3134), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3136), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1028] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3132), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3130), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1096] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3144), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3142), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1164] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3148), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3146), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1232] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1152), 10,
      anon_sym_LPAREN,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(1150), 44,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [1296] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3120), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3118), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1364] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3124), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3122), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1432] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3136), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3134), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1500] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3122), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3124), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1566] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3118), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3120), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1632] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3130), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3132), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1698] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3112), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3110), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [1766] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3110), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3112), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1832] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3138), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3140), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1898] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3142), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3144), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [1964] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3116), 5,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kLabel,
      sym_kExports,
    ACTIONS(3146), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3148), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [2030] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1170), 10,
      anon_sym_LPAREN,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(1168), 44,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [2094] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3140), 9,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3138), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kElse,
  [2162] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3124), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3122), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2228] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3120), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3118), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2294] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1170), 7,
      anon_sym_LPAREN,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(1168), 45,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kUses,
      anon_sym_DOT,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kName,
      sym_kDelayed,
  [2356] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3132), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3130), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2422] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3112), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3110), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2488] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3136), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3134), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2554] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3144), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3142), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2620] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3148), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3146), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2686] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3140), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3138), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [2752] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1152), 7,
      anon_sym_LPAREN,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
      sym_kIn,
    ACTIONS(1150), 45,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kUses,
      anon_sym_DOT,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kName,
      sym_kDelayed,
  [2814] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3158), 1,
      sym_kLt,
    STATE(882), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3150), 35,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [2884] = 4,
    STATE(882), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3162), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3160), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [2946] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3164), 1,
      sym_kLt,
    STATE(882), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3150), 35,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [3016] = 20,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3166), 1,
      anon_sym_SEMI,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    STATE(745), 1,
      aux_sym_declProp_repeat1,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1093), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    ACTIONS(3172), 7,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [3110] = 32,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3174), 1,
      anon_sym_SEMI,
    ACTIONS(3176), 1,
      anon_sym_LPAREN,
    ACTIONS(3178), 1,
      sym_kEnd,
    ACTIONS(3180), 1,
      sym_kOf,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(3186), 1,
      sym_kExternal,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2310), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    ACTIONS(3184), 2,
      sym_kAbstract,
      sym_kSealed,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [3227] = 24,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3192), 1,
      sym_kEnd,
    ACTIONS(3194), 1,
      sym_kElse,
    STATE(53), 1,
      sym_caseLabel,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1980), 1,
      sym_caseCaseTr,
    STATE(2042), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(600), 2,
      sym_caseCase,
      aux_sym_case_repeat1,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [3328] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(2938), 1,
      sym_kAs,
    ACTIONS(3198), 1,
      sym_kMul,
    ACTIONS(3196), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3202), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3200), 6,
      sym_kFdiv,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
    ACTIONS(3046), 28,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kIs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [3399] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3206), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3204), 37,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [3458] = 7,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(2938), 1,
      sym_kAs,
    ACTIONS(3198), 1,
      sym_kMul,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3200), 6,
      sym_kFdiv,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3046), 30,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [3525] = 24,
    ACTIONS(213), 1,
      sym_kEnd,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3208), 1,
      sym_kElse,
    STATE(53), 1,
      sym_caseLabel,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2009), 1,
      sym_caseCaseTr,
    STATE(2042), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(610), 2,
      sym_caseCase,
      aux_sym_case_repeat1,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [3626] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(2938), 1,
      sym_kAs,
    ACTIONS(3198), 1,
      sym_kMul,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      sym_kGt,
    ACTIONS(3196), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3202), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3200), 6,
      sym_kFdiv,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 7,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
    ACTIONS(3046), 27,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kIs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [3701] = 11,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3214), 1,
      anon_sym_RBRACK,
    ACTIONS(3216), 1,
      sym_kExternal,
    STATE(612), 1,
      aux_sym__procAttribute_repeat1,
    STATE(1983), 2,
      sym_procAttribute,
      sym_procExternal,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [3776] = 24,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3218), 1,
      sym_kEnd,
    ACTIONS(3220), 1,
      sym_kElse,
    STATE(53), 1,
      sym_caseLabel,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1991), 1,
      sym_caseCaseTr,
    STATE(2042), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(605), 2,
      sym_caseCase,
      aux_sym_case_repeat1,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [3877] = 11,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3216), 1,
      sym_kExternal,
    ACTIONS(3222), 1,
      anon_sym_RBRACK,
    STATE(609), 1,
      aux_sym__procAttribute_repeat1,
    STATE(1920), 2,
      sym_procAttribute,
      sym_procExternal,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [3952] = 24,
    ACTIONS(217), 1,
      sym_kEnd,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3224), 1,
      sym_kElse,
    STATE(53), 1,
      sym_caseLabel,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2020), 1,
      sym_caseCaseTr,
    STATE(2042), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(610), 2,
      sym_caseCase,
      aux_sym_case_repeat1,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [4053] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(2932), 1,
      sym_kMul,
    ACTIONS(2938), 1,
      sym_kAs,
    ACTIONS(2930), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(2936), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2934), 6,
      sym_kFdiv,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
    ACTIONS(3046), 28,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kIs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [4123] = 7,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(2932), 1,
      sym_kMul,
    ACTIONS(2938), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2934), 6,
      sym_kFdiv,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3046), 30,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kGt,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [4189] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(2932), 1,
      sym_kMul,
    ACTIONS(2938), 1,
      sym_kAs,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3226), 1,
      sym_kGt,
    ACTIONS(2930), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(2936), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2934), 6,
      sym_kFdiv,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
    ACTIONS(3046), 27,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kLt,
      sym_kIs,
      sym_kIn,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [4263] = 11,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3216), 1,
      sym_kExternal,
    STATE(611), 1,
      aux_sym__procAttribute_repeat1,
    STATE(1926), 1,
      sym_procExternal,
    STATE(1927), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [4337] = 22,
    ACTIONS(3231), 1,
      anon_sym_LBRACK,
    ACTIONS(3234), 1,
      anon_sym_LPAREN,
    ACTIONS(3237), 1,
      aux_sym__literalString_token1,
    ACTIONS(3240), 1,
      anon_sym_POUND,
    ACTIONS(3246), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3251), 1,
      sym_kSpecialize,
    ACTIONS(3257), 1,
      sym_kAt,
    ACTIONS(3263), 1,
      sym_kInherited,
    STATE(162), 1,
      sym_caseLabel,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2042), 1,
      sym_range,
    ACTIONS(3243), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3249), 2,
      sym_kEnd,
      sym_kElse,
    ACTIONS(3260), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(610), 2,
      sym_caseCase,
      aux_sym_case_repeat1,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3254), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3228), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [4433] = 10,
    ACTIONS(3269), 1,
      sym_kPublic,
    ACTIONS(3272), 1,
      sym_kExternal,
    ACTIONS(3275), 1,
      sym_kMessage,
    ACTIONS(3278), 1,
      sym_kDeprecated,
    ACTIONS(3281), 1,
      sym_kExport,
    ACTIONS(3284), 1,
      sym_kAlias,
    STATE(611), 1,
      aux_sym__procAttribute_repeat1,
    STATE(2280), 2,
      sym_procAttribute,
      sym_procExternal,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3266), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [4505] = 11,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3216), 1,
      sym_kExternal,
    STATE(611), 1,
      aux_sym__procAttribute_repeat1,
    STATE(1940), 1,
      sym_procExternal,
    STATE(2067), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [4579] = 31,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3174), 1,
      anon_sym_SEMI,
    ACTIONS(3176), 1,
      anon_sym_LPAREN,
    ACTIONS(3178), 1,
      sym_kEnd,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(3186), 1,
      sym_kExternal,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2310), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    ACTIONS(3184), 2,
      sym_kAbstract,
      sym_kSealed,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [4693] = 10,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3287), 1,
      anon_sym_RBRACK,
    STATE(622), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(2013), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [4764] = 10,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3289), 1,
      anon_sym_RBRACK,
    STATE(629), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(1929), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [4835] = 30,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3174), 1,
      anon_sym_SEMI,
    ACTIONS(3176), 1,
      anon_sym_LPAREN,
    ACTIONS(3178), 1,
      sym_kEnd,
    ACTIONS(3186), 1,
      sym_kExternal,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2310), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    ACTIONS(3184), 2,
      sym_kAbstract,
      sym_kSealed,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [4946] = 22,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3291), 1,
      sym_identifier,
    ACTIONS(3293), 1,
      anon_sym_LPAREN,
    STATE(624), 1,
      aux_sym_recInitializer_repeat1,
    STATE(647), 1,
      aux_sym_arrInitializer_repeat1,
    STATE(1956), 1,
      sym_recInitializerField,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    ACTIONS(95), 3,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1346), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1855), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5041] = 30,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3295), 1,
      anon_sym_SEMI,
    ACTIONS(3297), 1,
      anon_sym_LPAREN,
    ACTIONS(3299), 1,
      sym_kEnd,
    ACTIONS(3303), 1,
      sym_kExternal,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2250), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    ACTIONS(3301), 2,
      sym_kAbstract,
      sym_kSealed,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [5152] = 10,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    ACTIONS(3305), 1,
      anon_sym_RBRACK,
    STATE(623), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(2055), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [5223] = 22,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      aux_sym_declVariant_repeat1,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1830), 1,
      sym_declVariantClause,
    STATE(2042), 1,
      sym_range,
    STATE(2127), 1,
      sym_caseLabel,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5317] = 9,
    ACTIONS(3310), 1,
      sym_kPublic,
    ACTIONS(3313), 1,
      sym_kMessage,
    ACTIONS(3316), 1,
      sym_kDeprecated,
    ACTIONS(3319), 1,
      sym_kExport,
    ACTIONS(3322), 1,
      sym_kAlias,
    STATE(621), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(2421), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3307), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [5385] = 9,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    STATE(621), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(2023), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [5453] = 9,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    STATE(621), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(2091), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [5521] = 21,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3291), 1,
      sym_identifier,
    ACTIONS(3293), 1,
      anon_sym_LPAREN,
    STATE(626), 1,
      aux_sym_recInitializer_repeat1,
    STATE(1934), 1,
      sym_recInitializerField,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    ACTIONS(95), 3,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1309), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1932), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5613] = 22,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      aux_sym_declVariant_repeat1,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1893), 1,
      sym_declVariantClause,
    STATE(2042), 1,
      sym_range,
    STATE(2127), 1,
      sym_caseLabel,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5707] = 21,
    ACTIONS(3325), 1,
      sym_identifier,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3334), 1,
      aux_sym__literalString_token1,
    ACTIONS(3337), 1,
      anon_sym_POUND,
    ACTIONS(3343), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3346), 1,
      sym_kSpecialize,
    ACTIONS(3352), 1,
      sym_kAt,
    ACTIONS(3358), 1,
      sym_kInherited,
    STATE(626), 1,
      aux_sym_recInitializer_repeat1,
    STATE(2399), 1,
      sym_recInitializerField,
    ACTIONS(3340), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3355), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3349), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    ACTIONS(3361), 3,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1309), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1932), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5799] = 22,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(625), 1,
      aux_sym_declVariant_repeat1,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1869), 1,
      sym_declVariantClause,
    STATE(2042), 1,
      sym_range,
    STATE(2127), 1,
      sym_caseLabel,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5893] = 22,
    ACTIONS(3367), 1,
      anon_sym_LBRACK,
    ACTIONS(3370), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      aux_sym__literalString_token1,
    ACTIONS(3376), 1,
      anon_sym_POUND,
    ACTIONS(3382), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3385), 1,
      sym_kSpecialize,
    ACTIONS(3391), 1,
      sym_kAt,
    ACTIONS(3397), 1,
      sym_kInherited,
    STATE(628), 1,
      aux_sym_declVariant_repeat1,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2042), 1,
      sym_range,
    STATE(2127), 1,
      sym_caseLabel,
    STATE(2330), 1,
      sym_declVariantClause,
    ACTIONS(3379), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3394), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3388), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3364), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [5987] = 9,
    ACTIONS(880), 1,
      sym_kPublic,
    ACTIONS(882), 1,
      sym_kMessage,
    ACTIONS(884), 1,
      sym_kDeprecated,
    ACTIONS(886), 1,
      sym_kAlias,
    ACTIONS(1611), 1,
      sym_kExport,
    STATE(621), 1,
      aux_sym__procAttributeNoExt_repeat1,
    STATE(1979), 1,
      sym_procAttribute,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(878), 39,
      sym_kDefault,
      sym_kNodefault,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
  [6055] = 22,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(620), 1,
      aux_sym_declVariant_repeat1,
    STATE(708), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1913), 1,
      sym_declVariantClause,
    STATE(2042), 1,
      sym_range,
    STATE(2127), 1,
      sym_caseLabel,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1350), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [6149] = 20,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3400), 1,
      anon_sym_SEMI,
    ACTIONS(3404), 1,
      sym_kDelayed,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3402), 2,
      sym_kIndex,
      sym_kName,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1310), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [6238] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3120), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3118), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [6297] = 29,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3295), 1,
      anon_sym_SEMI,
    ACTIONS(3297), 1,
      anon_sym_LPAREN,
    ACTIONS(3299), 1,
      sym_kEnd,
    ACTIONS(3406), 1,
      sym_kName,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2250), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [6404] = 29,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3408), 1,
      anon_sym_SEMI,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3412), 1,
      anon_sym_LPAREN,
    ACTIONS(3414), 1,
      sym_kEnd,
    STATE(718), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2244), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [6511] = 19,
    ACTIONS(3419), 1,
      anon_sym_LBRACK,
    ACTIONS(3422), 1,
      anon_sym_LPAREN,
    ACTIONS(3425), 1,
      aux_sym__literalString_token1,
    ACTIONS(3428), 1,
      anon_sym_POUND,
    ACTIONS(3434), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3437), 1,
      sym_kSpecialize,
    ACTIONS(3443), 1,
      sym_kAt,
    ACTIONS(3449), 1,
      sym_kInherited,
    STATE(635), 1,
      aux_sym_arrInitializer_repeat1,
    ACTIONS(3431), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3446), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3440), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1309), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(2401), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    ACTIONS(3416), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [6598] = 29,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3452), 1,
      anon_sym_SEMI,
    ACTIONS(3454), 1,
      anon_sym_LPAREN,
    ACTIONS(3456), 1,
      sym_kEnd,
    ACTIONS(3458), 1,
      sym_kName,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2451), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [6705] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3132), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3130), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [6764] = 29,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3460), 1,
      anon_sym_SEMI,
    ACTIONS(3462), 1,
      anon_sym_LPAREN,
    ACTIONS(3464), 1,
      sym_kEnd,
    STATE(712), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2117), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [6871] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3124), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3122), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [6930] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3112), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3110), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [6989] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3140), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3138), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [7048] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3144), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3142), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [7107] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3148), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3146), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [7166] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1152), 7,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(1150), 38,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [7221] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3136), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3134), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
  [7280] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1170), 7,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(1168), 38,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [7335] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3293), 1,
      anon_sym_LPAREN,
    STATE(635), 1,
      aux_sym_arrInitializer_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1309), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1935), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [7422] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3466), 45,
      sym_kDefault,
      sym_kNodefault,
      sym_kPublic,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kExternal,
      sym_kMessage,
      sym_kDeprecated,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kExport,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
      sym_kAlias,
  [7475] = 20,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      sym_kDelayed,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3470), 2,
      sym_kIndex,
      sym_kName,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1314), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [7564] = 4,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3160), 8,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3162), 35,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [7620] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3474), 1,
      sym_kVar,
    STATE(1717), 1,
      sym_varAssignDef,
    STATE(2047), 1,
      sym_assignment,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1292), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [7708] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3476), 1,
      anon_sym_RBRACK,
    STATE(705), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1974), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1320), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [7796] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3144), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3142), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [7854] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3478), 1,
      anon_sym_RPAREN,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2383), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [7942] = 28,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3480), 1,
      anon_sym_SEMI,
    ACTIONS(3482), 1,
      sym_kEnd,
    STATE(707), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2123), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [8046] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3293), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1309), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(2097), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [8130] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3293), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1309), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1722), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [8214] = 28,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3295), 1,
      anon_sym_SEMI,
    ACTIONS(3297), 1,
      anon_sym_LPAREN,
    ACTIONS(3299), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2250), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [8318] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3484), 1,
      anon_sym_RBRACK,
    STATE(694), 1,
      aux_sym_declArray_repeat1,
    STATE(1995), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1339), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [8406] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3486), 1,
      anon_sym_RPAREN,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2236), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [8494] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3474), 1,
      sym_kVar,
    STATE(1717), 1,
      sym_varAssignDef,
    STATE(2057), 1,
      sym_assignment,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1291), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [8582] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3293), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1407), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1722), 3,
      sym__initializer,
      sym_recInitializer,
      sym_arrInitializer,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [8666] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3136), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3134), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [8724] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3140), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3138), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [8782] = 28,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3488), 1,
      anon_sym_SEMI,
    ACTIONS(3490), 1,
      sym_kEnd,
    STATE(738), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2431), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [8886] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3112), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3110), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [8944] = 28,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3452), 1,
      anon_sym_SEMI,
    ACTIONS(3454), 1,
      anon_sym_LPAREN,
    ACTIONS(3456), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2451), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [9048] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3148), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3146), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [9106] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3492), 1,
      anon_sym_RBRACK,
    STATE(736), 1,
      aux_sym_declArray_repeat1,
    STATE(2056), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1317), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [9194] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3494), 1,
      anon_sym_RBRACK,
    STATE(737), 1,
      aux_sym_declArray_repeat1,
    STATE(1982), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1341), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [9282] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1170), 6,
      anon_sym_LPAREN,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(1168), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kUses,
      anon_sym_DOT,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [9336] = 28,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_SEMI,
    ACTIONS(3498), 1,
      sym_kEnd,
    STATE(702), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2313), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [9440] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3132), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3130), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [9498] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1152), 6,
      anon_sym_LPAREN,
      sym_kConst,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(1150), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kUses,
      anon_sym_DOT,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [9552] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3500), 1,
      anon_sym_RBRACK,
    STATE(720), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2079), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1323), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [9640] = 28,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3502), 1,
      anon_sym_SEMI,
    ACTIONS(3504), 1,
      sym_kEnd,
    STATE(716), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2375), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [9744] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3506), 1,
      anon_sym_RBRACK,
    STATE(735), 1,
      aux_sym_declArray_repeat1,
    STATE(1922), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1330), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [9832] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3508), 1,
      anon_sym_RPAREN,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2163), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [9920] = 28,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3510), 1,
      anon_sym_SEMI,
    ACTIONS(3512), 1,
      sym_kEnd,
    STATE(710), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2160), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [10024] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3514), 1,
      anon_sym_RBRACK,
    STATE(724), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2022), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1344), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [10112] = 4,
    ACTIONS(3516), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3206), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3204), 27,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kEnd,
      sym_kOf,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [10168] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3518), 1,
      anon_sym_RPAREN,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2228), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [10256] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    ACTIONS(3520), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1327), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [10340] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3522), 1,
      anon_sym_RBRACK,
    STATE(728), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2003), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1345), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [10428] = 20,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3524), 1,
      anon_sym_RBRACK,
    STATE(697), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2032), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1337), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [10516] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3124), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3122), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [10574] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3150), 6,
      anon_sym_COLON,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3152), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [10638] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2253), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [10726] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3530), 1,
      sym_kLt,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3150), 6,
      anon_sym_COLON,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3152), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [10790] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3120), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kAs,
    ACTIONS(3114), 16,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
    ACTIONS(3118), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [10848] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3532), 44,
      sym_kDefault,
      sym_kNodefault,
      sym_kPublic,
      sym_kStatic,
      sym_kVirtual,
      sym_kAbstract,
      sym_kDynamic,
      sym_kOverride,
      sym_kOverload,
      sym_kReintroduce,
      sym_kInline,
      sym_kStdcall,
      sym_kCdecl,
      sym_kCppdecl,
      sym_kPascal,
      sym_kRegister,
      sym_kMwpascal,
      sym_kMessage,
      sym_kDeprecated,
      sym_kExperimental,
      sym_kPlatform,
      sym_kUnimplemented,
      sym_kCvar,
      sym_kExport,
      sym_kFar,
      sym_kNear,
      sym_kSafecall,
      sym_kAssembler,
      sym_kNostackframe,
      sym_kInterrupt,
      sym_kNoreturn,
      sym_kIocheck,
      sym_kLocal,
      sym_kHardfloat,
      sym_kSoftfloat,
      sym_kMs_abi_default,
      sym_kMs_abi_cdecl,
      sym_kSaveregisters,
      sym_kSysv_abi_default,
      sym_kSysv_abi_cdecl,
      sym_kVectorcall,
      sym_kVarargs,
      sym_kWinapi,
      sym_kAlias,
  [10900] = 28,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3410), 1,
      anon_sym_LBRACK,
    ACTIONS(3534), 1,
      anon_sym_SEMI,
    ACTIONS(3536), 1,
      sym_kEnd,
    STATE(714), 1,
      sym_guid,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2391), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11004] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3474), 1,
      sym_kVar,
    STATE(1717), 1,
      sym_varAssignDef,
    STATE(1998), 1,
      sym_assignment,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1286), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [11092] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(711), 1,
      aux_sym_declArray_repeat1,
    STATE(2035), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1347), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [11177] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3538), 1,
      anon_sym_SEMI,
    ACTIONS(3540), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2261), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11278] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3544), 1,
      anon_sym_RBRACK,
    STATE(774), 1,
      aux_sym_rttiAttributes_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3542), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1209), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [11363] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2039), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1343), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [11448] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3546), 1,
      anon_sym_SEMI,
    ACTIONS(3548), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2146), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11549] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3550), 1,
      anon_sym_SEMI,
    ACTIONS(3552), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2382), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11650] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3554), 1,
      anon_sym_SEMI,
    ACTIONS(3556), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2263), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11751] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3558), 1,
      anon_sym_SEMI,
    ACTIONS(3560), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2381), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11852] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3562), 1,
      anon_sym_SEMI,
    ACTIONS(3564), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2262), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [11953] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3566), 1,
      sym_identifier,
    ACTIONS(3568), 1,
      anon_sym_RBRACK,
    STATE(807), 1,
      aux_sym_rttiAttributes_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    ACTIONS(3570), 3,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1220), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [12040] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2242), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [12125] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1997), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1340), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [12210] = 20,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3566), 1,
      sym_identifier,
    ACTIONS(3568), 1,
      anon_sym_RBRACK,
    STATE(807), 1,
      aux_sym_rttiAttributes_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    ACTIONS(3572), 3,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1174), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [12297] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3574), 1,
      anon_sym_SEMI,
    ACTIONS(3576), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2392), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [12398] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2012), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1351), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [12483] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3578), 1,
      anon_sym_SEMI,
    ACTIONS(3580), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2311), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [12584] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3582), 1,
      anon_sym_SEMI,
    ACTIONS(3584), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2376), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [12685] = 19,
    ACTIONS(3589), 1,
      anon_sym_LBRACK,
    ACTIONS(3592), 1,
      anon_sym_LPAREN,
    ACTIONS(3595), 1,
      aux_sym__literalString_token1,
    ACTIONS(3598), 1,
      anon_sym_POUND,
    ACTIONS(3604), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3607), 1,
      sym_kSpecialize,
    ACTIONS(3613), 1,
      sym_kAt,
    ACTIONS(3619), 1,
      sym_kInherited,
    STATE(711), 1,
      aux_sym_declArray_repeat1,
    STATE(2217), 1,
      sym_range,
    ACTIONS(3601), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3616), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3610), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1365), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3586), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [12770] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3622), 1,
      anon_sym_SEMI,
    ACTIONS(3624), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2269), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [12871] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3626), 1,
      anon_sym_SEMI,
    ACTIONS(3628), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2374), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [12972] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3630), 1,
      anon_sym_SEMI,
    ACTIONS(3632), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2345), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [13073] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3634), 1,
      anon_sym_SEMI,
    ACTIONS(3636), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2148), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [13174] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3638), 1,
      anon_sym_SEMI,
    ACTIONS(3640), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2315), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [13275] = 19,
    ACTIONS(3645), 1,
      anon_sym_LBRACK,
    ACTIONS(3648), 1,
      anon_sym_LPAREN,
    ACTIONS(3651), 1,
      aux_sym__literalString_token1,
    ACTIONS(3654), 1,
      anon_sym_POUND,
    ACTIONS(3660), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3663), 1,
      sym_kSpecialize,
    ACTIONS(3669), 1,
      sym_kAt,
    ACTIONS(3675), 1,
      sym_kInherited,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2264), 1,
      sym_range,
    ACTIONS(3657), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3672), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3666), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1370), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3642), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [13360] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3678), 1,
      anon_sym_SEMI,
    ACTIONS(3680), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2445), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [13461] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3682), 1,
      anon_sym_SEMI,
    ACTIONS(3684), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2459), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [13562] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2073), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1329), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [13647] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2162), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [13732] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3686), 1,
      sym_kGt,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(3688), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3690), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3692), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
    ACTIONS(3694), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 25,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [13801] = 7,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(3690), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3694), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3046), 6,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3048), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [13862] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(2016), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1321), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [13947] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2227), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [14032] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3698), 1,
      anon_sym_SEMI,
    ACTIONS(3700), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2319), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [14133] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3702), 1,
      anon_sym_SEMI,
    ACTIONS(3704), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2324), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [14234] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      aux_sym_caseLabel_repeat1,
    STATE(1993), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1353), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [14319] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2252), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [14404] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3706), 1,
      anon_sym_SEMI,
    ACTIONS(3708), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2115), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [14505] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3710), 1,
      anon_sym_SEMI,
    ACTIONS(3712), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2232), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [14606] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(3688), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(3690), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3692), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
    ACTIONS(3694), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [14671] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3714), 1,
      anon_sym_SEMI,
    ACTIONS(3716), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2260), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [14772] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3718), 1,
      anon_sym_SEMI,
    ACTIONS(3720), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2238), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [14873] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(711), 1,
      aux_sym_declArray_repeat1,
    STATE(1982), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1341), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [14958] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(711), 1,
      aux_sym_declArray_repeat1,
    STATE(1995), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1339), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [15043] = 19,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(711), 1,
      aux_sym_declArray_repeat1,
    STATE(1986), 1,
      sym_range,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1354), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [15128] = 27,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3722), 1,
      anon_sym_SEMI,
    ACTIONS(3724), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2122), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [15229] = 19,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(773), 1,
      aux_sym_exprArgs_repeat1,
    STATE(2390), 1,
      sym_exprArgs,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1211), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [15314] = 6,
    ACTIONS(3726), 1,
      aux_sym__literalString_token1,
    ACTIONS(3729), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(740), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1480), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(1482), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [15372] = 18,
    ACTIONS(3735), 1,
      anon_sym_LBRACK,
    ACTIONS(3738), 1,
      anon_sym_LPAREN,
    ACTIONS(3741), 1,
      aux_sym__literalString_token1,
    ACTIONS(3744), 1,
      anon_sym_POUND,
    ACTIONS(3750), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3753), 1,
      sym_kSpecialize,
    ACTIONS(3759), 1,
      sym_kAt,
    ACTIONS(3765), 1,
      sym_kInherited,
    STATE(741), 1,
      aux_sym_with_repeat1,
    ACTIONS(3747), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3762), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3756), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1393), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3732), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [15454] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(741), 1,
      aux_sym_with_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1361), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [15536] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3770), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3768), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [15588] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3774), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3772), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [15640] = 18,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    STATE(750), 1,
      aux_sym_declProp_repeat1,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1097), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [15722] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3776), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2328), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [15820] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3780), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3778), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [15872] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3782), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2268), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [15970] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3786), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3784), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16022] = 18,
    ACTIONS(3791), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3797), 1,
      aux_sym__literalString_token1,
    ACTIONS(3800), 1,
      anon_sym_POUND,
    ACTIONS(3806), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3809), 1,
      sym_kSpecialize,
    ACTIONS(3815), 1,
      sym_kAt,
    ACTIONS(3821), 1,
      sym_kInherited,
    STATE(750), 1,
      aux_sym_declProp_repeat1,
    ACTIONS(3803), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3818), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3812), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1403), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3788), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [16104] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3826), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3824), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16156] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3830), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3828), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16208] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3834), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3832), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16260] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3838), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3836), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16312] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3840), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2240), 1,
      sym__declClass,
    STATE(2284), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [16410] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3844), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3842), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16462] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3848), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3846), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16514] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1395), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [16596] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1401), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [16678] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3852), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3850), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [16730] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1378), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [16812] = 18,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    STATE(784), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1152), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [16894] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1388), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [16976] = 18,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3860), 1,
      anon_sym_LPAREN,
    ACTIONS(3863), 1,
      aux_sym__literalString_token1,
    ACTIONS(3866), 1,
      anon_sym_POUND,
    ACTIONS(3872), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3875), 1,
      sym_kSpecialize,
    ACTIONS(3881), 1,
      sym_kAt,
    ACTIONS(3887), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(3869), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3884), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3878), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1406), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3854), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17058] = 18,
    ACTIONS(3893), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LPAREN,
    ACTIONS(3899), 1,
      aux_sym__literalString_token1,
    ACTIONS(3902), 1,
      anon_sym_POUND,
    ACTIONS(3908), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3911), 1,
      sym_kSpecialize,
    ACTIONS(3917), 1,
      sym_kAt,
    ACTIONS(3923), 1,
      sym_kInherited,
    STATE(765), 1,
      aux_sym_exprArgs_repeat1,
    ACTIONS(3905), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3920), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3914), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1297), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3890), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17140] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3928), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3926), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [17192] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(742), 1,
      aux_sym_with_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1368), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17274] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3932), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3930), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [17326] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3936), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3934), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [17378] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3940), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3938), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [17430] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3944), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3942), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [17482] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1405), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17564] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(765), 1,
      aux_sym_exprArgs_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1197), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17646] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(781), 1,
      aux_sym_rttiAttributes_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3946), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1198), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17728] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(3948), 1,
      sym_kName,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1327), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17810] = 18,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    STATE(763), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1001), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [17892] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(3950), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2284), 1,
      sym_declVariant,
    STATE(2294), 1,
      sym__declClass,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(854), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1457), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(965), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [17990] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3954), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3952), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [18042] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3958), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3956), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [18094] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(741), 1,
      aux_sym_with_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1363), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18176] = 18,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3966), 1,
      anon_sym_LPAREN,
    ACTIONS(3969), 1,
      aux_sym__literalString_token1,
    ACTIONS(3972), 1,
      anon_sym_POUND,
    ACTIONS(3978), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3981), 1,
      sym_kSpecialize,
    ACTIONS(3987), 1,
      sym_kAt,
    ACTIONS(3993), 1,
      sym_kInherited,
    STATE(781), 1,
      aux_sym_rttiAttributes_repeat1,
    ACTIONS(3975), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3990), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3984), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3960), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1288), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18258] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(772), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(909), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18340] = 6,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(3996), 1,
      aux_sym__literalString_token1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(740), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1529), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(1531), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [18398] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(764), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1377), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18480] = 18,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    STATE(761), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(943), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18562] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4000), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(3998), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [18614] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4004), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4002), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [18666] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4008), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4006), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [18718] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(741), 1,
      aux_sym_with_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1367), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18800] = 18,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    STATE(759), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1279), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [18882] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4016), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4014), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [18934] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(789), 1,
      aux_sym_with_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1369), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [19016] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4020), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4018), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19068] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4024), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4022), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19120] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4028), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4026), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19172] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    STATE(758), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(608), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [19254] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4034), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4032), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19306] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4038), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4036), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19358] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(780), 1,
      aux_sym_with_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1358), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [19440] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(285), 1,
      sym_kAt,
    STATE(772), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(287), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(722), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(283), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(689), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [19522] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4042), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4040), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19574] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4046), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4044), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19626] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4050), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4048), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19678] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4054), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4052), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19730] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4058), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4056), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19782] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(273), 1,
      sym_kAt,
    STATE(758), 1,
      aux_sym_exprTpl_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(275), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(601), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(277), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(593), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [19864] = 18,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    STATE(781), 1,
      aux_sym_rttiAttributes_repeat1,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4060), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1200), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [19946] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4064), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4062), 36,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [19998] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1117), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20077] = 17,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1147), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20156] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1396), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20235] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1400), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20314] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1409), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20393] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1412), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20472] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4066), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1289), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20551] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(534), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20630] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1224), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20709] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1239), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20788] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1413), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20867] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1392), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [20946] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1196), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21025] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1382), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21104] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1385), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21183] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1364), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21262] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4068), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1295), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21341] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1294), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21420] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(932), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21499] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(933), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21578] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(504), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21657] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(934), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21736] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(930), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21815] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1372), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21894] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4072), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1293), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [21973] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4074), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1290), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22052] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1328), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22131] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1327), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22210] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1394), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22289] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1371), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22368] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1033), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22447] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(962), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22526] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(285), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(287), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(512), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(283), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(689), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22605] = 17,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1248), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22684] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1006), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22763] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1005), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22842] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(273), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(275), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(540), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(277), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(593), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [22921] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1004), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23000] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(273), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(275), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(599), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(277), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(593), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23079] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1003), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23158] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(273), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(275), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(532), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(277), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(593), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23237] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1166), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23316] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1373), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23395] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1411), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23474] = 17,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1421), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4076), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(981), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23553] = 25,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(2948), 1,
      sym_kStrict,
    ACTIONS(4078), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2273), 1,
      sym_declVariant,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(1111), 2,
      aux_sym__declFields,
      sym_declField,
    STATE(1456), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(2946), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(959), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [23648] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(912), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23727] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(513), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23806] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1397), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23885] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1366), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [23964] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1304), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24043] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1380), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24122] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1356), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24201] = 17,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1362), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24280] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1379), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24359] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(285), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(287), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(540), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(283), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(689), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24438] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(285), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(287), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(723), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(283), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(689), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24517] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1376), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24596] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1360), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24675] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1188), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24754] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4080), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1296), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24833] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(910), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24912] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(540), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [24991] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1387), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25070] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1153), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25149] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(285), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(287), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(532), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(283), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(689), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25228] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1234), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25307] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1103), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25386] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1386), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25465] = 17,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1415), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4082), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1112), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25544] = 17,
    ACTIONS(964), 1,
      aux_sym__literalString_token1,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(970), 1,
      aux_sym__literalInt_token2,
    ACTIONS(972), 1,
      sym_kSpecialize,
    ACTIONS(974), 1,
      sym_kAt,
    ACTIONS(980), 1,
      sym_kInherited,
    ACTIONS(3168), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(968), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(978), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1032), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(976), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(907), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1120), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(962), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(972), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25623] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4084), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1285), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25702] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1384), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25781] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1418), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4086), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(592), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25860] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1374), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [25939] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1315), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26018] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(273), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(275), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(512), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(277), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(593), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26097] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(540), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26176] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(607), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26255] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(606), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26334] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1375), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26413] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(265), 1,
      sym_kSpecialize,
    ACTIONS(267), 1,
      sym_kAt,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(4030), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(269), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(504), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(271), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(591), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26492] = 17,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1273), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26571] = 17,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(504), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26650] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4088), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1287), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26729] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1135), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26808] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1223), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26887] = 17,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(123), 1,
      sym_kAt,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(121), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1161), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(141), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(923), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [26966] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1420), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4090), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(650), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27045] = 17,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1146), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27124] = 17,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1416), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4092), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1133), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27203] = 17,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(105), 1,
      anon_sym_LBRACK,
    ACTIONS(107), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      aux_sym__literalString_token1,
    ACTIONS(111), 1,
      anon_sym_POUND,
    ACTIONS(115), 1,
      aux_sym__literalInt_token2,
    ACTIONS(119), 1,
      sym_kSpecialize,
    ACTIONS(139), 1,
      sym_kInherited,
    ACTIONS(113), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(137), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(956), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(783), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1417), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(4094), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(929), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27282] = 17,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1149), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27361] = 17,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1277), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27440] = 17,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1275), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27519] = 17,
    ACTIONS(3006), 1,
      aux_sym__literalString_token1,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3014), 1,
      sym_kSpecialize,
    ACTIONS(3016), 1,
      sym_kAt,
    ACTIONS(3022), 1,
      sym_kInherited,
    ACTIONS(3188), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3020), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1131), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3018), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1069), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1150), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3004), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1114), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27598] = 17,
    ACTIONS(45), 1,
      anon_sym_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LPAREN,
    ACTIONS(49), 1,
      aux_sym__literalString_token1,
    ACTIONS(51), 1,
      anon_sym_POUND,
    ACTIONS(55), 1,
      aux_sym__literalInt_token2,
    ACTIONS(65), 1,
      sym_kSpecialize,
    ACTIONS(69), 1,
      sym_kAt,
    ACTIONS(93), 1,
      sym_kInherited,
    ACTIONS(53), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(91), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(533), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(67), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(233), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1167), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(95), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(687), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27677] = 17,
    ACTIONS(3072), 1,
      aux_sym__literalString_token1,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(3078), 1,
      aux_sym__literalInt_token2,
    ACTIONS(3080), 1,
      sym_kSpecialize,
    ACTIONS(3082), 1,
      sym_kAt,
    ACTIONS(3088), 1,
      sym_kInherited,
    ACTIONS(4010), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
    ACTIONS(3086), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1238), 2,
      sym__literalInt,
      sym__literalFloat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3084), 3,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
    STATE(1078), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    STATE(1274), 3,
      sym__expr,
      sym_exprBinary,
      sym_exprUnary,
    ACTIONS(3070), 4,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
    STATE(1134), 14,
      sym__ref,
      sym_lambda,
      sym_inherited,
      sym_exprDot,
      sym_exprDeref,
      sym_exprAs,
      sym_exprTpl,
      sym_exprSubscript,
      sym_exprCall,
      sym_exprParens,
      sym_exprBrackets,
      sym__literal,
      sym_literalString,
      sym_literalNumber,
  [27756] = 6,
    ACTIONS(966), 1,
      anon_sym_POUND,
    ACTIONS(4096), 1,
      aux_sym__literalString_token1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(908), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1529), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(1531), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [27812] = 6,
    ACTIONS(4098), 1,
      aux_sym__literalString_token1,
    ACTIONS(4101), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(908), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1480), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(1482), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [27868] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4104), 1,
      sym_kGt,
    ACTIONS(3046), 2,
      anon_sym_COLON,
      sym_kLt,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 23,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [27934] = 7,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 5,
      anon_sym_COLON,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [27992] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4116), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4118), 8,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
    ACTIONS(4114), 26,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [28044] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_COLON,
      sym_kLt,
      sym_kGt,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEnd,
      sym_kOf,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
      sym_kThen,
      sym_kElse,
      sym_kDo,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
      sym_kDelayed,
  [28106] = 4,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4116), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4120), 8,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
    ACTIONS(4114), 26,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [28158] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2796), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2798), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [28207] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4122), 1,
      anon_sym_COLON,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(515), 1,
      sym_asmTr,
    STATE(563), 1,
      sym_blockTr,
    STATE(971), 1,
      sym_declArgs,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1050), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [28301] = 21,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4128), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
    STATE(919), 11,
      sym_blockTr,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [28385] = 4,
    ACTIONS(4132), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4034), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4032), 31,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kUntil,
      sym_kTry,
      sym_kExcept,
      sym_kFinally,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [28435] = 4,
    ACTIONS(4134), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4034), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4032), 31,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [28485] = 21,
    ACTIONS(4136), 1,
      anon_sym_LBRACK,
    ACTIONS(4139), 1,
      sym_kUses,
    ACTIONS(4144), 1,
      sym_kBegin,
    ACTIONS(4150), 1,
      sym_kConst,
    ACTIONS(4153), 1,
      sym_kResourcestring,
    ACTIONS(4156), 1,
      sym_kType,
    ACTIONS(4159), 1,
      sym_kLabel,
    ACTIONS(4162), 1,
      sym_kExports,
    ACTIONS(4165), 1,
      sym_kClass,
    ACTIONS(4168), 1,
      sym_kGeneric,
    ACTIONS(4174), 1,
      sym_kOperator,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(4147), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4171), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4142), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
    STATE(919), 11,
      sym_blockTr,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [28569] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(4126), 1,
      sym_kAsm,
    ACTIONS(4177), 1,
      anon_sym_COLON,
    STATE(515), 1,
      sym_asmTr,
    STATE(559), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(977), 1,
      sym_declArgs,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1035), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [28663] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4179), 1,
      anon_sym_COLON,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(570), 1,
      sym_blockTr,
    STATE(950), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(980), 1,
      sym_declArgs,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1044), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [28757] = 4,
    ACTIONS(4183), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3206), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(3204), 23,
      anon_sym_LPAREN,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kElse,
  [28807] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4185), 1,
      anon_sym_LBRACK,
    ACTIONS(4187), 1,
      anon_sym_LPAREN,
    ACTIONS(4189), 1,
      sym_kLt,
    STATE(900), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3150), 6,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3152), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [28865] = 4,
    ACTIONS(4191), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2992), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(2994), 23,
      anon_sym_LPAREN,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kElse,
  [28915] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(4193), 1,
      anon_sym_COLON,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(586), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(978), 1,
      sym_declArgs,
    STATE(1024), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1031), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [29009] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(4199), 1,
      anon_sym_COLON,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(645), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(982), 1,
      sym_declArgs,
    STATE(1125), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1025), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [29103] = 21,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4205), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
    STATE(916), 11,
      sym_blockTr,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [29187] = 26,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(4207), 1,
      anon_sym_COLON,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(663), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(985), 1,
      sym_declArgs,
    STATE(1250), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1055), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [29281] = 4,
    STATE(900), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3160), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3162), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29331] = 9,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4213), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4215), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4219), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4221), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kElse,
  [29390] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2978), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2980), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29437] = 4,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2900), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2902), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29486] = 4,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3048), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29535] = 7,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4215), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4221), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3046), 6,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kIn,
    ACTIONS(3048), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kElse,
  [29590] = 22,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4231), 1,
      sym_kInterface,
    ACTIONS(4233), 1,
      sym_kType,
    ACTIONS(4235), 1,
      sym_kClass,
    ACTIONS(4239), 1,
      sym_kRecord,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4249), 1,
      sym_kPacked,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(4237), 4,
      sym_kObject,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2265), 4,
      sym_type,
      sym_declClass,
      sym_declIntf,
      sym_declHelper,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [29675] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3050), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3052), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29722] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3066), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3068), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29769] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2958), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2960), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29816] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2966), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2968), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29863] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3062), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3064), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [29910] = 22,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4231), 1,
      sym_kInterface,
    ACTIONS(4235), 1,
      sym_kClass,
    ACTIONS(4239), 1,
      sym_kRecord,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4249), 1,
      sym_kPacked,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4259), 1,
      sym_kType,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(4237), 4,
      sym_kObject,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2308), 4,
      sym_type,
      sym_declClass,
      sym_declIntf,
      sym_declHelper,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [29995] = 22,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4231), 1,
      sym_kInterface,
    ACTIONS(4235), 1,
      sym_kClass,
    ACTIONS(4239), 1,
      sym_kRecord,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4249), 1,
      sym_kPacked,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4261), 1,
      sym_kType,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(4237), 4,
      sym_kObject,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2233), 4,
      sym_type,
      sym_declClass,
      sym_declIntf,
      sym_declHelper,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [30080] = 11,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4263), 1,
      sym_kGt,
    ACTIONS(4213), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4215), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4219), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kIn,
    ACTIONS(4221), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 19,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kElse,
  [30143] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2974), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2976), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30190] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3000), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3002), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30237] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2982), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2984), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30284] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2996), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2998), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30331] = 22,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4231), 1,
      sym_kInterface,
    ACTIONS(4235), 1,
      sym_kClass,
    ACTIONS(4239), 1,
      sym_kRecord,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4249), 1,
      sym_kPacked,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4265), 1,
      sym_kType,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(4237), 4,
      sym_kObject,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2156), 4,
      sym_type,
      sym_declClass,
      sym_declIntf,
      sym_declHelper,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [30416] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2950), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2952), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30463] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2954), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2956), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30510] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2962), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2964), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30557] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3034), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3036), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30604] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2970), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2972), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30651] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3054), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3056), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30698] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3058), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3060), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30745] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3024), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3026), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30792] = 19,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2944), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(1111), 2,
      aux_sym__declFields,
      sym_declField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1064), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4267), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [30871] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3038), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3040), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [30918] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2916), 1,
      sym_kConst,
    ACTIONS(4269), 1,
      sym_kEnd,
    ACTIONS(4273), 1,
      sym_kResourcestring,
    ACTIONS(4275), 1,
      sym_kType,
    ACTIONS(4277), 1,
      sym_kProperty,
    ACTIONS(4279), 1,
      sym_kClass,
    ACTIONS(4281), 1,
      sym_kGeneric,
    ACTIONS(4283), 1,
      sym_kCase,
    ACTIONS(4287), 1,
      sym_kOperator,
    ACTIONS(4291), 1,
      sym_kStrict,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1494), 1,
      sym_rttiAttributes,
    STATE(2443), 1,
      sym_declVariant,
    ACTIONS(4271), 2,
      sym_kVar,
      sym_kThreadvar,
    STATE(1452), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4285), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4289), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(1072), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [31005] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3042), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3044), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [31052] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2986), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2988), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [31099] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2875), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2877), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kElse,
  [31146] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2796), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2798), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [31193] = 19,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2944), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(1111), 2,
      aux_sym__declFields,
      sym_declField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1062), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4293), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [31272] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2916), 1,
      sym_kConst,
    ACTIONS(4273), 1,
      sym_kResourcestring,
    ACTIONS(4275), 1,
      sym_kType,
    ACTIONS(4277), 1,
      sym_kProperty,
    ACTIONS(4279), 1,
      sym_kClass,
    ACTIONS(4281), 1,
      sym_kGeneric,
    ACTIONS(4283), 1,
      sym_kCase,
    ACTIONS(4287), 1,
      sym_kOperator,
    ACTIONS(4291), 1,
      sym_kStrict,
    ACTIONS(4295), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1494), 1,
      sym_rttiAttributes,
    STATE(2273), 1,
      sym_declVariant,
    ACTIONS(4271), 2,
      sym_kVar,
      sym_kThreadvar,
    STATE(1456), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4285), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4289), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
    STATE(1072), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
  [31359] = 19,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2944), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(964), 2,
      aux_sym__declFields,
      sym_declField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1073), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4297), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [31438] = 19,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      sym_kType,
    ACTIONS(2920), 1,
      sym_kProperty,
    ACTIONS(2922), 1,
      sym_kClass,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2944), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1483), 1,
      sym_rttiAttributes,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(2914), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(2916), 2,
      sym_kConst,
      sym_kResourcestring,
    STATE(957), 2,
      aux_sym__declFields,
      sym_declField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1062), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4293), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [31517] = 22,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4231), 1,
      sym_kInterface,
    ACTIONS(4235), 1,
      sym_kClass,
    ACTIONS(4239), 1,
      sym_kRecord,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4249), 1,
      sym_kPacked,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4299), 1,
      sym_kType,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(4237), 4,
      sym_kObject,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2198), 4,
      sym_type,
      sym_declClass,
      sym_declIntf,
      sym_declHelper,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [31602] = 22,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4231), 1,
      sym_kInterface,
    ACTIONS(4235), 1,
      sym_kClass,
    ACTIONS(4239), 1,
      sym_kRecord,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4249), 1,
      sym_kPacked,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4301), 1,
      sym_kType,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(4237), 4,
      sym_kObject,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2225), 4,
      sym_type,
      sym_declClass,
      sym_declIntf,
      sym_declHelper,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [31687] = 20,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4306), 1,
      sym_kUses,
    ACTIONS(4314), 1,
      sym_kConst,
    ACTIONS(4317), 1,
      sym_kResourcestring,
    ACTIONS(4320), 1,
      sym_kType,
    ACTIONS(4323), 1,
      sym_kLabel,
    ACTIONS(4326), 1,
      sym_kExports,
    ACTIONS(4329), 1,
      sym_kProperty,
    ACTIONS(4332), 1,
      sym_kClass,
    ACTIONS(4335), 1,
      sym_kGeneric,
    ACTIONS(4341), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1305), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1515), 1,
      sym_rttiAttributes,
    ACTIONS(4311), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4338), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4309), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
    STATE(970), 10,
      sym_declProcFwd,
      aux_sym__declarations,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declLabels,
      sym_declProp,
  [31767] = 24,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    ACTIONS(4344), 1,
      anon_sym_COLON,
    STATE(541), 1,
      sym_asmTr,
    STATE(577), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1020), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [31855] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4346), 1,
      anon_sym_LBRACK,
    ACTIONS(4348), 1,
      anon_sym_LPAREN,
    ACTIONS(4350), 1,
      sym_kLt,
    STATE(853), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3150), 3,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3152), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [31911] = 20,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(4354), 1,
      sym_kProperty,
    ACTIONS(4356), 1,
      sym_kClass,
    ACTIONS(4358), 1,
      sym_kGeneric,
    ACTIONS(4362), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1305), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1515), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4360), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4352), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
    STATE(970), 10,
      sym_declProcFwd,
      aux_sym__declarations,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declLabels,
      sym_declProp,
  [31991] = 4,
    ACTIONS(4366), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4368), 8,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(4364), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
  [32039] = 4,
    ACTIONS(4370), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2992), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(2994), 23,
      anon_sym_LPAREN,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kName,
      sym_kDelayed,
  [32087] = 25,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    ACTIONS(4372), 1,
      aux_sym_type_token1,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1428), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    STATE(2365), 1,
      sym_asmTr,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(999), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32177] = 24,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    ACTIONS(4374), 1,
      anon_sym_COLON,
    STATE(541), 1,
      sym_asmTr,
    STATE(561), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1041), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32265] = 24,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    ACTIONS(4376), 1,
      anon_sym_COLON,
    STATE(587), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1007), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1037), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32353] = 4,
    ACTIONS(4378), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3206), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3204), 23,
      anon_sym_LPAREN,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kName,
      sym_kDelayed,
  [32401] = 24,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    ACTIONS(4380), 1,
      anon_sym_COLON,
    STATE(565), 1,
      sym_blockTr,
    STATE(936), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1051), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32489] = 4,
    STATE(853), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3160), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3162), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [32537] = 24,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    ACTIONS(4382), 1,
      anon_sym_COLON,
    STATE(642), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1145), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(992), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32625] = 21,
    ACTIONS(4136), 1,
      anon_sym_LBRACK,
    ACTIONS(4139), 1,
      sym_kUses,
    ACTIONS(4150), 1,
      sym_kConst,
    ACTIONS(4153), 1,
      sym_kResourcestring,
    ACTIONS(4156), 1,
      sym_kType,
    ACTIONS(4159), 1,
      sym_kLabel,
    ACTIONS(4162), 1,
      sym_kExports,
    ACTIONS(4165), 1,
      sym_kClass,
    ACTIONS(4168), 1,
      sym_kGeneric,
    ACTIONS(4174), 1,
      sym_kOperator,
    ACTIONS(4384), 1,
      sym_kBegin,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(4147), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4142), 3,
      ts_builtin_sym_end,
      sym_kEnd,
      sym_kAsm,
    ACTIONS(4171), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 11,
      sym_blockTr,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32707] = 20,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(4354), 1,
      sym_kProperty,
    ACTIONS(4356), 1,
      sym_kClass,
    ACTIONS(4358), 1,
      sym_kGeneric,
    ACTIONS(4362), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1305), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1515), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4360), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    ACTIONS(4387), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
    STATE(973), 10,
      sym_declProcFwd,
      aux_sym__declarations,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declLabels,
      sym_declProp,
  [32787] = 24,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    ACTIONS(4389), 1,
      anon_sym_COLON,
    STATE(653), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1271), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1034), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [32875] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2996), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2998), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [32920] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2950), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2952), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [32965] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3042), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3044), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33010] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2978), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2980), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33055] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1441), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    STATE(2386), 1,
      sym_asmTr,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [33140] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(641), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1157), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1010), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [33225] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(640), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1158), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [33310] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3058), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3060), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33355] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3054), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3056), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33400] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3034), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3036), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33445] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(690), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1269), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1047), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [33530] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2982), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2984), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33575] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2974), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2976), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33620] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1436), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    STATE(2413), 1,
      sym_asmTr,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [33705] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(524), 1,
      sym_asmTr,
    STATE(558), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [33790] = 10,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(4391), 1,
      sym_kGt,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 17,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [33849] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3038), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3040), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33894] = 4,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2900), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2902), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33941] = 4,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3048), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [33988] = 7,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [34041] = 8,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kName,
      sym_kDelayed,
  [34096] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3050), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3052), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [34141] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3066), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3068), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [34186] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2958), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2960), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [34231] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(637), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1162), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34316] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2966), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2968), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [34361] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3062), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3064), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [34406] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1427), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    STATE(2275), 1,
      sym_asmTr,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34491] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(539), 1,
      sym_asmTr,
    STATE(572), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1023), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34576] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(632), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1163), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1016), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34661] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(639), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1165), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34746] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(539), 1,
      sym_asmTr,
    STATE(555), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1046), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34831] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3000), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3002), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [34876] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(524), 1,
      sym_asmTr,
    STATE(573), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [34961] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(535), 1,
      sym_asmTr,
    STATE(575), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35046] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(529), 1,
      sym_asmTr,
    STATE(576), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1019), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35131] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1435), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    STATE(2246), 1,
      sym_asmTr,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(990), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35216] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(527), 1,
      sym_asmTr,
    STATE(571), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35301] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2954), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2956), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [35346] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4201), 1,
      sym_kBegin,
    ACTIONS(4203), 1,
      sym_kAsm,
    STATE(643), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1144), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35431] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2962), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2964), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [35476] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2986), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2988), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [35521] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2970), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2972), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [35566] = 4,
    ACTIONS(4366), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4368), 7,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4364), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEnd,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kHat,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [35613] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(673), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1184), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35698] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(588), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1008), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35783] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3024), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(3026), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [35828] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2875), 5,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kIn,
    ACTIONS(2877), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kName,
      sym_kDelayed,
  [35873] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(666), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1217), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [35958] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(546), 1,
      sym_asmTr,
    STATE(562), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36043] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(589), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(986), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1038), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36128] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(585), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(995), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36213] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(584), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(989), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36298] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(664), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1242), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1030), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36383] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(529), 1,
      sym_asmTr,
    STATE(560), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1000), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36468] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(535), 1,
      sym_asmTr,
    STATE(554), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36553] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(582), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(988), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1043), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36638] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4195), 1,
      sym_kBegin,
    ACTIONS(4197), 1,
      sym_kAsm,
    STATE(581), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1027), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36723] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(566), 1,
      sym_blockTr,
    STATE(937), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36808] = 4,
    ACTIONS(4403), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4034), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4032), 28,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kOn,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [36855] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(527), 1,
      sym_asmTr,
    STATE(556), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [36940] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(686), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1263), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37025] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1445), 1,
      sym_blockTr,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    STATE(2457), 1,
      sym_asmTr,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1013), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37110] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(580), 1,
      sym_blockTr,
    STATE(947), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1052), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37195] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4126), 1,
      sym_kAsm,
    STATE(546), 1,
      sym_asmTr,
    STATE(578), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37280] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(574), 1,
      sym_blockTr,
    STATE(952), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37365] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(564), 1,
      sym_blockTr,
    STATE(931), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37450] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(568), 1,
      sym_blockTr,
    STATE(960), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1054), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37535] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4130), 1,
      sym_kBegin,
    ACTIONS(4181), 1,
      sym_kAsm,
    STATE(569), 1,
      sym_blockTr,
    STATE(961), 1,
      sym_asmTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37620] = 23,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4209), 1,
      sym_kBegin,
    ACTIONS(4211), 1,
      sym_kAsm,
    STATE(668), 1,
      sym_blockTr,
    STATE(976), 1,
      sym_declProc,
    STATE(1267), 1,
      sym_asmTr,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37705] = 22,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4405), 1,
      sym_kEnd,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1422), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37787] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4409), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4407), 28,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [37831] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4413), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4411), 28,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kElse,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [37875] = 22,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4415), 1,
      sym_kEnd,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1423), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1056), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [37957] = 21,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(4417), 1,
      ts_builtin_sym_end,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 11,
      sym_blockTr,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [38037] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4421), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEq,
    ACTIONS(4419), 27,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [38080] = 17,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2916), 1,
      sym_kConst,
    ACTIONS(4273), 1,
      sym_kResourcestring,
    ACTIONS(4275), 1,
      sym_kType,
    ACTIONS(4277), 1,
      sym_kProperty,
    ACTIONS(4279), 1,
      sym_kClass,
    ACTIONS(4281), 1,
      sym_kGeneric,
    ACTIONS(4287), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1494), 1,
      sym_rttiAttributes,
    ACTIONS(4271), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4285), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1072), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4423), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [38151] = 4,
    ACTIONS(4429), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4427), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4425), 26,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [38196] = 17,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2916), 1,
      sym_kConst,
    ACTIONS(4273), 1,
      sym_kResourcestring,
    ACTIONS(4275), 1,
      sym_kType,
    ACTIONS(4277), 1,
      sym_kProperty,
    ACTIONS(4279), 1,
      sym_kClass,
    ACTIONS(4281), 1,
      sym_kGeneric,
    ACTIONS(4287), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1494), 1,
      sym_rttiAttributes,
    ACTIONS(4271), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4285), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1072), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4431), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [38267] = 21,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1439), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(983), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [38346] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4435), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEq,
    ACTIONS(4433), 27,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [38389] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4439), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kEq,
    ACTIONS(4437), 27,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kClass,
      sym_kOf,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [38432] = 12,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4441), 1,
      anon_sym_SEMI,
    ACTIONS(4213), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4215), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4219), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4445), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4221), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4447), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4449), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(4443), 6,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
  [38493] = 6,
    ACTIONS(3008), 1,
      anon_sym_POUND,
    ACTIONS(4451), 1,
      aux_sym__literalString_token1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1070), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1529), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(1531), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [38542] = 6,
    ACTIONS(4453), 1,
      aux_sym__literalString_token1,
    ACTIONS(4456), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1070), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1480), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(1482), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [38591] = 4,
    ACTIONS(4459), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4427), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4425), 26,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [38636] = 17,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4469), 1,
      sym_kConst,
    ACTIONS(4472), 1,
      sym_kResourcestring,
    ACTIONS(4475), 1,
      sym_kType,
    ACTIONS(4478), 1,
      sym_kProperty,
    ACTIONS(4481), 1,
      sym_kClass,
    ACTIONS(4484), 1,
      sym_kGeneric,
    ACTIONS(4490), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1494), 1,
      sym_rttiAttributes,
    ACTIONS(4466), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4487), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1072), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4464), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [38707] = 17,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(2916), 1,
      sym_kConst,
    ACTIONS(4273), 1,
      sym_kResourcestring,
    ACTIONS(4275), 1,
      sym_kType,
    ACTIONS(4277), 1,
      sym_kProperty,
    ACTIONS(4279), 1,
      sym_kClass,
    ACTIONS(4281), 1,
      sym_kGeneric,
    ACTIONS(4287), 1,
      sym_kOperator,
    STATE(1099), 1,
      sym__declOperator,
    STATE(1359), 1,
      sym__declProc,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1494), 1,
      sym_rttiAttributes,
    ACTIONS(4271), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4285), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1072), 6,
      aux_sym__classDeclarations,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declProc,
      sym_declProp,
    ACTIONS(4493), 9,
      sym_kEnd,
      sym_kCase,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [38778] = 10,
    ACTIONS(4495), 1,
      ts_builtin_sym_end,
    ACTIONS(4497), 1,
      sym_identifier,
    ACTIONS(4499), 1,
      anon_sym_LBRACK,
    ACTIONS(4504), 1,
      sym_kGeneric,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1706), 1,
      sym_rttiAttributes,
    STATE(1075), 2,
      sym_declType,
      aux_sym_declTypes_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1724), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4502), 22,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [38835] = 10,
    ACTIONS(4507), 1,
      ts_builtin_sym_end,
    ACTIONS(4509), 1,
      sym_identifier,
    ACTIONS(4512), 1,
      anon_sym_LBRACK,
    ACTIONS(4517), 1,
      sym_kGeneric,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1706), 1,
      sym_rttiAttributes,
    STATE(1075), 2,
      sym_declType,
      aux_sym_declTypes_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1724), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4515), 22,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [38892] = 21,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      sym_kUses,
    ACTIONS(19), 1,
      sym_kBegin,
    ACTIONS(23), 1,
      sym_kConst,
    ACTIONS(25), 1,
      sym_kResourcestring,
    ACTIONS(27), 1,
      sym_kType,
    ACTIONS(29), 1,
      sym_kLabel,
    ACTIONS(31), 1,
      sym_kExports,
    ACTIONS(33), 1,
      sym_kClass,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    STATE(976), 1,
      sym_declProc,
    STATE(1408), 1,
      sym__declProc,
    STATE(1434), 1,
      sym_blockTr,
    STATE(1443), 1,
      sym__declOperator,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1565), 1,
      sym_rttiAttributes,
    ACTIONS(21), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
    STATE(1065), 10,
      aux_sym__definitions,
      sym__definition,
      sym_defProc,
      sym_declProcFwd,
      sym_declUses,
      sym_declExports,
      sym_declTypes,
      sym_declVars,
      sym_declConsts,
      sym_declLabels,
  [38971] = 10,
    ACTIONS(4497), 1,
      sym_identifier,
    ACTIONS(4520), 1,
      ts_builtin_sym_end,
    ACTIONS(4522), 1,
      anon_sym_LBRACK,
    ACTIONS(4527), 1,
      sym_kGeneric,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1706), 1,
      sym_rttiAttributes,
    STATE(1074), 2,
      sym_declType,
      aux_sym_declTypes_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1724), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4525), 22,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39028] = 6,
    ACTIONS(3074), 1,
      anon_sym_POUND,
    ACTIONS(4530), 1,
      aux_sym__literalString_token1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1081), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1529), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(1531), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [39076] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4534), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(4532), 26,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFor,
      sym_kIf,
      sym_kWhile,
      sym_kRepeat,
      sym_kTry,
      sym_kRaise,
      sym_kCase,
      sym_kWith,
      sym_kGoto,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [39118] = 12,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4441), 1,
      anon_sym_SEMI,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4443), 5,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
    ACTIONS(4540), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [39178] = 6,
    ACTIONS(4542), 1,
      aux_sym__literalString_token1,
    ACTIONS(4545), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1081), 3,
      sym__literalString,
      sym_literalChar,
      aux_sym_literalString_repeat1,
    ACTIONS(1480), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(1482), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [39226] = 9,
    ACTIONS(4548), 1,
      ts_builtin_sym_end,
    ACTIONS(4550), 1,
      sym_identifier,
    ACTIONS(4552), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1959), 1,
      aux_sym_genericArg_repeat1,
    STATE(1960), 1,
      sym_rttiAttributes,
    STATE(1087), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4555), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39279] = 9,
    ACTIONS(4557), 1,
      ts_builtin_sym_end,
    ACTIONS(4559), 1,
      sym_identifier,
    ACTIONS(4562), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1959), 1,
      aux_sym_genericArg_repeat1,
    STATE(1960), 1,
      sym_rttiAttributes,
    STATE(1083), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4565), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39332] = 9,
    ACTIONS(4522), 1,
      anon_sym_LBRACK,
    ACTIONS(4567), 1,
      sym_identifier,
    ACTIONS(4569), 1,
      sym_kGeneric,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1721), 1,
      sym_rttiAttributes,
    STATE(1089), 2,
      sym_declType,
      aux_sym_declTypes_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1790), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4525), 21,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [39385] = 9,
    ACTIONS(4550), 1,
      sym_identifier,
    ACTIONS(4572), 1,
      ts_builtin_sym_end,
    ACTIONS(4574), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1959), 1,
      aux_sym_genericArg_repeat1,
    STATE(1960), 1,
      sym_rttiAttributes,
    STATE(1088), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4577), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39438] = 9,
    ACTIONS(4512), 1,
      anon_sym_LBRACK,
    ACTIONS(4579), 1,
      sym_identifier,
    ACTIONS(4582), 1,
      sym_kGeneric,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1721), 1,
      sym_rttiAttributes,
    STATE(1086), 2,
      sym_declType,
      aux_sym_declTypes_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1790), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4515), 21,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [39491] = 9,
    ACTIONS(4550), 1,
      sym_identifier,
    ACTIONS(4585), 1,
      ts_builtin_sym_end,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1959), 1,
      aux_sym_genericArg_repeat1,
    STATE(1960), 1,
      sym_rttiAttributes,
    STATE(1083), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4590), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39544] = 9,
    ACTIONS(4548), 1,
      ts_builtin_sym_end,
    ACTIONS(4550), 1,
      sym_identifier,
    ACTIONS(4552), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1959), 1,
      aux_sym_genericArg_repeat1,
    STATE(1960), 1,
      sym_rttiAttributes,
    STATE(1083), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4555), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39597] = 9,
    ACTIONS(4499), 1,
      anon_sym_LBRACK,
    ACTIONS(4567), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      sym_kGeneric,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(1721), 1,
      sym_rttiAttributes,
    STATE(1086), 2,
      sym_declType,
      aux_sym_declTypes_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1790), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4502), 21,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [39650] = 3,
    ACTIONS(4597), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4595), 29,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [39690] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2796), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2798), 25,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [39730] = 8,
    ACTIONS(4599), 1,
      ts_builtin_sym_end,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2287), 1,
      sym_rttiAttributes,
    STATE(1094), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4606), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39780] = 10,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(4610), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4608), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [39834] = 8,
    ACTIONS(4616), 1,
      ts_builtin_sym_end,
    ACTIONS(4618), 1,
      sym_identifier,
    ACTIONS(4621), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2287), 1,
      sym_rttiAttributes,
    STATE(1094), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4624), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39884] = 8,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4626), 1,
      ts_builtin_sym_end,
    ACTIONS(4628), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2287), 1,
      sym_rttiAttributes,
    STATE(1094), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4631), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39934] = 8,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4633), 1,
      ts_builtin_sym_end,
    ACTIONS(4635), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2287), 1,
      sym_rttiAttributes,
    STATE(1092), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4638), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [39984] = 10,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(4610), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4640), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [40038] = 8,
    ACTIONS(4599), 1,
      ts_builtin_sym_end,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2287), 1,
      sym_rttiAttributes,
    STATE(1095), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4606), 23,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [40088] = 3,
    ACTIONS(4644), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4642), 29,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40128] = 3,
    ACTIONS(4648), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4646), 29,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40168] = 8,
    ACTIONS(4552), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2089), 1,
      sym_rttiAttributes,
    STATE(2093), 1,
      aux_sym_genericArg_repeat1,
    STATE(1105), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4555), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40217] = 8,
    ACTIONS(4552), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2089), 1,
      sym_rttiAttributes,
    STATE(2093), 1,
      aux_sym_genericArg_repeat1,
    STATE(1104), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4555), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40266] = 9,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4652), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [40317] = 8,
    ACTIONS(4562), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2089), 1,
      sym_rttiAttributes,
    STATE(2093), 1,
      aux_sym_genericArg_repeat1,
    STATE(1104), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4565), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40366] = 8,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2089), 1,
      sym_rttiAttributes,
    STATE(2093), 1,
      aux_sym_genericArg_repeat1,
    STATE(1104), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4590), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40415] = 4,
    ACTIONS(4657), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3204), 15,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [40456] = 4,
    ACTIONS(4659), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2992), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(2994), 15,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [40497] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4661), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1679), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    STATE(1755), 3,
      sym_operatorDot,
      sym__operatorName,
      sym_operatorName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [40546] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2796), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2798), 25,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [40585] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4661), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1679), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    STATE(1739), 3,
      sym_operatorDot,
      sym__operatorName,
      sym_operatorName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [40634] = 8,
    ACTIONS(4667), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_LBRACK,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2004), 1,
      aux_sym_genericArg_repeat1,
    STATE(2078), 1,
      sym_rttiAttributes,
    STATE(1111), 2,
      aux_sym__declFields,
      sym_declField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4673), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40683] = 4,
    STATE(878), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3160), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3162), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [40724] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4661), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1679), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    STATE(1792), 3,
      sym_operatorDot,
      sym__operatorName,
      sym_operatorName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [40773] = 8,
    ACTIONS(4675), 1,
      anon_sym_LBRACK,
    ACTIONS(4677), 1,
      anon_sym_LPAREN,
    ACTIONS(4679), 1,
      anon_sym_DOT,
    ACTIONS(4681), 1,
      sym_kLt,
    STATE(878), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [40822] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4661), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1679), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    STATE(1758), 3,
      sym_operatorDot,
      sym__operatorName,
      sym_operatorName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [40871] = 8,
    ACTIONS(4574), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2089), 1,
      sym_rttiAttributes,
    STATE(2093), 1,
      aux_sym_genericArg_repeat1,
    STATE(1102), 2,
      sym_declVar,
      aux_sym_declVars_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4577), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [40920] = 9,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4683), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [40971] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4661), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1679), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    STATE(1753), 3,
      sym_operatorDot,
      sym__operatorName,
      sym_operatorName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [41020] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4661), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1679), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    STATE(1784), 3,
      sym_operatorDot,
      sym__operatorName,
      sym_operatorName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [41069] = 9,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4685), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [41120] = 19,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(2191), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [41190] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2970), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2972), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41228] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2950), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2952), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41266] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2962), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2964), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41304] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2954), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2956), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41342] = 19,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(2101), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [41412] = 7,
    ACTIONS(4603), 1,
      anon_sym_LBRACK,
    ACTIONS(4691), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2403), 1,
      sym_rttiAttributes,
    STATE(1132), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4606), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [41458] = 7,
    ACTIONS(4621), 1,
      anon_sym_LBRACK,
    ACTIONS(4693), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2403), 1,
      sym_rttiAttributes,
    STATE(1128), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4624), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [41504] = 7,
    ACTIONS(4603), 1,
      anon_sym_LBRACK,
    ACTIONS(4691), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2403), 1,
      sym_rttiAttributes,
    STATE(1128), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4606), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [41550] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3000), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3002), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41588] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3024), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3026), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41626] = 7,
    ACTIONS(4628), 1,
      anon_sym_LBRACK,
    ACTIONS(4691), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2403), 1,
      sym_rttiAttributes,
    STATE(1128), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4631), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [41672] = 4,
    STATE(899), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3160), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3162), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [41712] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4696), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_LPAREN,
    ACTIONS(4700), 1,
      sym_kLt,
    STATE(899), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 21,
      anon_sym_COMMA,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [41760] = 10,
    ACTIONS(4215), 1,
      sym_kFdiv,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4702), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4445), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4219), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4447), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4221), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4704), 6,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
  [41812] = 4,
    ACTIONS(4706), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3206), 11,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(3204), 16,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [41852] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3062), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3064), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [41890] = 7,
    ACTIONS(4635), 1,
      anon_sym_LBRACK,
    ACTIONS(4691), 1,
      sym_identifier,
    STATE(1485), 1,
      aux_sym_rttiAttributes_repeat2,
    STATE(2403), 1,
      sym_rttiAttributes,
    STATE(1129), 2,
      sym_declConst,
      aux_sym_declConsts_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4638), 22,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [41936] = 4,
    ACTIONS(4708), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2992), 11,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
    ACTIONS(2994), 16,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [41976] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2966), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2968), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42014] = 19,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(2454), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [42084] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2958), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2960), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42122] = 19,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(2309), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [42192] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3066), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3068), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42230] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3050), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3052), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42268] = 8,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [42316] = 7,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kIn,
  [42362] = 4,
    ACTIONS(4720), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4368), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(4364), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42402] = 4,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3048), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42442] = 4,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2900), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2902), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42482] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3038), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3040), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42520] = 10,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4722), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 10,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [42572] = 10,
    ACTIONS(4215), 1,
      sym_kFdiv,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4724), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4445), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4219), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4447), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4221), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4726), 6,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
  [42624] = 19,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(2159), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [42694] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2974), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2976), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42732] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2982), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2984), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42770] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2996), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2998), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42808] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3034), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3036), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42846] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3054), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3056), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42884] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3058), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3060), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [42922] = 10,
    ACTIONS(4215), 1,
      sym_kFdiv,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4728), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4445), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4219), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4447), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4221), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4730), 6,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
  [42974] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2978), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2980), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [43012] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3042), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3044), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [43050] = 19,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3182), 1,
      sym_kHelper,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(2272), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43120] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2986), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2988), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [43158] = 9,
    ACTIONS(4215), 1,
      sym_kFdiv,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4445), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4219), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4447), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4221), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4732), 7,
      anon_sym_SEMI,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
  [43208] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4734), 1,
      sym_kDo,
    ACTIONS(3046), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 11,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
  [43259] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1814), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43326] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1736), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43393] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1938), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43460] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1848), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43527] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1832), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43594] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1895), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43661] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    ACTIONS(4738), 1,
      anon_sym_RBRACK,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [43712] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1470), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43779] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1465), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43846] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1894), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [43913] = 8,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4740), 1,
      sym_identifier,
    STATE(1877), 1,
      sym_kDot,
    STATE(1918), 1,
      sym_operatorName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1487), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
    ACTIONS(4665), 8,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(4663), 12,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
  [43960] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1892), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44027] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1464), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44094] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1781), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44161] = 4,
    ACTIONS(4742), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4368), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(4364), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [44200] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1796), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44267] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2978), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2980), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [44304] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1933), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44371] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1810), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44438] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1804), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44505] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4702), 1,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4704), 5,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [44556] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1574), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44623] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1573), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44690] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1949), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44757] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1703), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44824] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1803), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44891] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1768), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [44958] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3058), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3060), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [44995] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4744), 1,
      sym_kDo,
    ACTIONS(3046), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 11,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
  [45046] = 13,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4746), 1,
      anon_sym_COLON,
    ACTIONS(4748), 1,
      anon_sym_COMMA,
    STATE(1692), 1,
      aux_sym_legacyFormat_repeat1,
    STATE(1839), 1,
      sym_legacyFormat,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(4750), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [45103] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    ACTIONS(4752), 1,
      anon_sym_RBRACK,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [45154] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1482), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45221] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(3544), 1,
      anon_sym_RBRACK,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [45272] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1710), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45339] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1463), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45406] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1472), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45473] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1799), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45540] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1903), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45607] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(1967), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45674] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(2043), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45741] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(1966), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45808] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    ACTIONS(4780), 1,
      anon_sym_RBRACK,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [45859] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1766), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [45926] = 13,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4746), 1,
      anon_sym_COLON,
    ACTIONS(4748), 1,
      anon_sym_COMMA,
    STATE(1692), 1,
      aux_sym_legacyFormat_repeat1,
    STATE(1824), 1,
      sym_legacyFormat,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(4782), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [45983] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(1964), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46050] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1699), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46117] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1862), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46184] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1774), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46251] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3054), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3056), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [46288] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3034), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3036), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [46325] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(2033), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46392] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1778), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46459] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    ACTIONS(4784), 1,
      anon_sym_RBRACK,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [46510] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(1943), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46577] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1831), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46644] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4724), 1,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4726), 5,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [46695] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4728), 1,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4730), 5,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [46746] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1693), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46813] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1478), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46880] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(2015), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [46947] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1818), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47014] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1817), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47081] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1834), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47148] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1815), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47215] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1797), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47282] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1547), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47349] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
    ACTIONS(4732), 6,
      anon_sym_SEMI,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [47398] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1809), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47465] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1551), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47532] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1807), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47599] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3024), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3026), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [47636] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4786), 1,
      sym_kDo,
    ACTIONS(3046), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 11,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
      sym_kIs,
      sym_kIn,
  [47687] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2970), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2972), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [47724] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1801), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47791] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2996), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2998), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [47828] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1826), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [47895] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2982), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2984), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [47932] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2962), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2964), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [47969] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1800), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48036] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4441), 1,
      anon_sym_SEMI,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4540), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [48089] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2875), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2877), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48126] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1829), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48193] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2954), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2956), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48230] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1582), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48297] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2950), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2952), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48334] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3000), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3002), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48371] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1568), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48438] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1569), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48505] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1744), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48572] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1581), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48639] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3062), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3064), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48676] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1746), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48743] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1902), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48810] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2966), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2968), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48847] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2958), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2960), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48884] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2986), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2988), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [48921] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1572), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [48988] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1957), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49055] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1550), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49122] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3066), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3068), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49159] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1548), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49226] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3042), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3044), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49263] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1532), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49330] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3050), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3052), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49367] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1480), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49434] = 8,
    ACTIONS(4792), 1,
      sym_kFdiv,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(4796), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
    ACTIONS(4788), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4790), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 11,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49481] = 7,
    ACTIONS(4792), 1,
      sym_kFdiv,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(4796), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 3,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
    ACTIONS(4790), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 15,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49526] = 4,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3048), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49565] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1919), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49632] = 4,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2900), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2902), 22,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49671] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3038), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3040), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49708] = 10,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(4792), 1,
      sym_kFdiv,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(4796), 1,
      sym_kAs,
    ACTIONS(4798), 1,
      sym_kGt,
    ACTIONS(3046), 2,
      anon_sym_LPAREN,
      sym_kLt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4788), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4790), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(3048), 10,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49759] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      aux_sym_type_token1,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    STATE(1925), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(2031), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49826] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1900), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49893] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2974), 4,
      anon_sym_LPAREN,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(2976), 23,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
      sym_kTo,
      sym_kDownto,
  [49930] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1883), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [49997] = 18,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_LPAREN,
    ACTIONS(4229), 1,
      aux_sym_type_token1,
    ACTIONS(4241), 1,
      sym_kArray,
    ACTIONS(4243), 1,
      sym_kFile,
    ACTIONS(4245), 1,
      sym_kString,
    ACTIONS(4247), 1,
      sym_kSet,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(4257), 1,
      sym_kReference,
    ACTIONS(4687), 1,
      sym_kClass,
    ACTIONS(4689), 1,
      sym_kPacked,
    STATE(1882), 1,
      sym_type,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4255), 2,
      sym_kFunction,
      sym_kProcedure,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1467), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [50064] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4800), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50112] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4804), 1,
      sym_kIn,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4802), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [50164] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4806), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50212] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50260] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4808), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50308] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4810), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50356] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4812), 1,
      sym_kIn,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4802), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [50408] = 11,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4814), 1,
      sym_kIn,
    ACTIONS(4106), 2,
      sym_kAdd,
      sym_kSub,
    ACTIONS(4108), 2,
      sym_kMul,
      sym_kFdiv,
    ACTIONS(4110), 2,
      sym_kOr,
      sym_kXor,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4112), 5,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4802), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [50460] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4816), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50508] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4818), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50556] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4820), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50604] = 9,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_LPAREN,
    ACTIONS(3526), 1,
      sym_kLt,
    ACTIONS(4822), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_kDot,
    ACTIONS(3150), 2,
      sym_kGt,
      sym_kFdiv,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3152), 18,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kHat,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kIs,
      sym_kAs,
      sym_kIn,
  [50652] = 12,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4746), 1,
      anon_sym_COLON,
    ACTIONS(4748), 1,
      anon_sym_COMMA,
    STATE(1692), 1,
      aux_sym_legacyFormat_repeat1,
    STATE(2292), 1,
      sym_legacyFormat,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [50705] = 3,
    ACTIONS(4826), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4824), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [50740] = 15,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1972), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [50799] = 3,
    ACTIONS(4830), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4828), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [50834] = 3,
    ACTIONS(4834), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4832), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [50869] = 3,
    ACTIONS(4838), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4836), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [50904] = 3,
    ACTIONS(4842), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4840), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [50939] = 9,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4844), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_kIndex,
      sym_kName,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [50986] = 6,
    ACTIONS(3216), 1,
      sym_kExternal,
    ACTIONS(4848), 1,
      sym_kConst,
    ACTIONS(4850), 1,
      sym_kForward,
    STATE(161), 1,
      sym_procExternal,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4846), 21,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51027] = 3,
    ACTIONS(4854), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4852), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51062] = 3,
    ACTIONS(4858), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4856), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51097] = 15,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1821), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [51156] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4860), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51203] = 11,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(4862), 1,
      anon_sym_SEMI,
    ACTIONS(4866), 1,
      sym_kDelayed,
    ACTIONS(4864), 2,
      sym_kIndex,
      sym_kName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [51254] = 3,
    ACTIONS(4870), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4868), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51289] = 15,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    ACTIONS(4760), 1,
      sym_kClass,
    ACTIONS(4762), 1,
      sym_kArray,
    ACTIONS(4764), 1,
      sym_kFile,
    ACTIONS(4766), 1,
      sym_kString,
    ACTIONS(4768), 1,
      sym_kSet,
    ACTIONS(4770), 1,
      sym_kPacked,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(4778), 1,
      sym_kReference,
    ACTIONS(4776), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
    STATE(1840), 8,
      sym_typeref,
      sym_declEnum,
      sym_declSet,
      sym_declArray,
      sym_declFile,
      sym_declString,
      sym_declProcRef,
      sym_declMetaClass,
  [51348] = 3,
    ACTIONS(4874), 2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4872), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [51383] = 11,
    ACTIONS(4397), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(4876), 1,
      anon_sym_SEMI,
    ACTIONS(4880), 1,
      sym_kDelayed,
    ACTIONS(4878), 2,
      sym_kIndex,
      sym_kName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4612), 3,
      sym_kLt,
      sym_kGt,
      sym_kIn,
    ACTIONS(4393), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4614), 5,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
    ACTIONS(4395), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [51434] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4882), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51481] = 3,
    ACTIONS(4886), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4884), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51515] = 11,
    ACTIONS(3484), 1,
      anon_sym_RBRACK,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51565] = 3,
    ACTIONS(4898), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4896), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51599] = 3,
    ACTIONS(4902), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4900), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51633] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4906), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51683] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4908), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51733] = 3,
    ACTIONS(4912), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4910), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [51767] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4914), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51817] = 3,
    ACTIONS(4918), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4916), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51851] = 3,
    ACTIONS(4922), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4920), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51885] = 3,
    ACTIONS(4926), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4924), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [51919] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4928), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [51965] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4930), 3,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52011] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4932), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52061] = 11,
    ACTIONS(3494), 1,
      anon_sym_RBRACK,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52111] = 3,
    ACTIONS(4936), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4934), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [52145] = 3,
    ACTIONS(4940), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4938), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [52179] = 3,
    ACTIONS(4944), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4942), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [52213] = 3,
    ACTIONS(4948), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4946), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [52247] = 3,
    ACTIONS(4952), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4950), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [52281] = 3,
    ACTIONS(4956), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4954), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [52315] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4958), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52365] = 3,
    ACTIONS(4962), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4960), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [52399] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4964), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52449] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4966), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52499] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4968), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52549] = 3,
    ACTIONS(4972), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4970), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [52583] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4974), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52633] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4976), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52683] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52733] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4980), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(4860), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52781] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4982), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52831] = 3,
    ACTIONS(4986), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4984), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [52865] = 3,
    ACTIONS(4990), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4988), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [52899] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4992), 1,
      anon_sym_COLON,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52949] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4994), 1,
      anon_sym_COLON,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [52999] = 3,
    ACTIONS(4998), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4996), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [53033] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(5000), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53083] = 11,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5002), 1,
      anon_sym_RBRACK,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53133] = 3,
    ACTIONS(5006), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5004), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kBegin,
      sym_kEnd,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [53167] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5008), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53213] = 3,
    ACTIONS(5012), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5010), 23,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kConst,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
      sym_identifier,
  [53247] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(5016), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53294] = 3,
    ACTIONS(4848), 1,
      sym_kConst,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4846), 22,
      anon_sym_LBRACK,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kCase,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kStrict,
      sym_kRequired,
      sym_kOptional,
  [53327] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5018), 1,
      anon_sym_SEMI,
    ACTIONS(5020), 1,
      sym_kDelayed,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53374] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(5022), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53421] = 9,
    ACTIONS(4792), 1,
      sym_kFdiv,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(4796), 1,
      sym_kAs,
    ACTIONS(4732), 2,
      sym_kTo,
      sym_kDownto,
    ACTIONS(5024), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4788), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4790), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(5026), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53466] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(5028), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53513] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5030), 1,
      anon_sym_SEMI,
    ACTIONS(5032), 1,
      sym_kDelayed,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53560] = 10,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53607] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5034), 1,
      anon_sym_SEMI,
    ACTIONS(5036), 1,
      sym_kDelayed,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53654] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(5038), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53701] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(5040), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53748] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(5042), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53795] = 10,
    ACTIONS(4714), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4892), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4710), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4712), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4894), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53842] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5044), 1,
      anon_sym_SEMI,
    ACTIONS(5046), 1,
      sym_kDelayed,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53889] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5048), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53933] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4724), 1,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [53977] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5050), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54021] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5052), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54065] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5054), 1,
      sym_kOf,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54109] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(5056), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54155] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(5058), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54201] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5060), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54245] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5062), 1,
      sym_kThen,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54289] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3046), 1,
      sym_kLt,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5064), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(3048), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [54335] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5066), 1,
      anon_sym_RBRACK,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54379] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3046), 1,
      sym_kLt,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5068), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(3048), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [54425] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5070), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54469] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5072), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54513] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5074), 1,
      sym_kThen,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54557] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5076), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54601] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(5078), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54647] = 5,
    ACTIONS(5086), 1,
      sym_kEnd,
    ACTIONS(5082), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5084), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5080), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [54683] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3046), 1,
      sym_kLt,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5088), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(3048), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [54729] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3046), 1,
      sym_kLt,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5090), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(3048), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [54775] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4980), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54819] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54863] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5092), 1,
      anon_sym_RBRACK,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54907] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(5094), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54953] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5096), 1,
      sym_kOf,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [54997] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5098), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55041] = 5,
    ACTIONS(5102), 1,
      sym_kEnd,
    ACTIONS(5100), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5084), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5080), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [55077] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3046), 1,
      sym_kLt,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5104), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(3048), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
  [55123] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4702), 1,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55167] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(5106), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55213] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5110), 9,
      anon_sym_DOT,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kAdd,
      sym_kSub,
      sym_kMul,
      sym_kAssign,
    ACTIONS(5108), 13,
      sym_kLt,
      sym_kGt,
      sym_kFdiv,
      sym_kOr,
      sym_kXor,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
      sym_kNot,
      sym_kIn,
      sym_identifier,
  [55245] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4610), 1,
      anon_sym_COMMA,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55289] = 5,
    ACTIONS(5114), 1,
      sym_kEnd,
    ACTIONS(5112), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5084), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5080), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [55325] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(5116), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55371] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55415] = 10,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 1,
      sym_kLt,
    ACTIONS(4860), 1,
      anon_sym_SEMI,
    ACTIONS(5118), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55461] = 7,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3216), 1,
      sym_kExternal,
    ACTIONS(4848), 1,
      sym_kConst,
    ACTIONS(4850), 1,
      sym_kForward,
    STATE(161), 1,
      sym_procExternal,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4846), 18,
      anon_sym_LBRACK,
      aux_sym_type_token1,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [55501] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5120), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55545] = 5,
    ACTIONS(5124), 1,
      sym_kEnd,
    ACTIONS(5122), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5084), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5080), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [55581] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4728), 1,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55625] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5126), 1,
      sym_kThen,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55669] = 9,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5128), 1,
      sym_kDo,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55713] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5132), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5130), 16,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kEnd,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kElse,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [55744] = 8,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4716), 1,
      sym_kHat,
    ACTIONS(4718), 1,
      sym_kAs,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55785] = 8,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4794), 1,
      sym_kHat,
    ACTIONS(4796), 1,
      sym_kAs,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55826] = 8,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4217), 1,
      sym_kHat,
    ACTIONS(4223), 1,
      sym_kAs,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55867] = 8,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(5134), 1,
      sym_kAs,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55908] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5110), 7,
      anon_sym_COLON,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
      sym_kHat,
    ACTIONS(5108), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [55939] = 8,
    ACTIONS(2904), 1,
      sym_kHat,
    ACTIONS(3696), 1,
      sym_kAs,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [55980] = 8,
    ACTIONS(4108), 1,
      sym_kFdiv,
    ACTIONS(4399), 1,
      sym_kHat,
    ACTIONS(4401), 1,
      sym_kAs,
    ACTIONS(4536), 2,
      sym_kLt,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4110), 4,
      sym_kAdd,
      sym_kSub,
      sym_kOr,
      sym_kXor,
    ACTIONS(4112), 6,
      sym_kMul,
      sym_kDiv,
      sym_kMod,
      sym_kAnd,
      sym_kShl,
      sym_kShr,
    ACTIONS(4538), 6,
      sym_kEq,
      sym_kNeq,
      sym_kLte,
      sym_kGte,
      sym_kIs,
      sym_kIn,
  [56021] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2357), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56055] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2116), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kEnd,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56089] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5140), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5138), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56118] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5144), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5142), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56147] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5148), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5146), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56176] = 4,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5150), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56207] = 4,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5152), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56238] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5156), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5154), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56267] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5160), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5158), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56296] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4648), 1,
      sym_kConst,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4646), 18,
      anon_sym_LBRACK,
      aux_sym_type_token1,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56327] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5084), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5080), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56356] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5164), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5162), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56385] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2172), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 16,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56418] = 4,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5166), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56449] = 4,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5168), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56480] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5172), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5170), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56509] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4597), 1,
      sym_kConst,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4595), 18,
      anon_sym_LBRACK,
      aux_sym_type_token1,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56540] = 5,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2370), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 16,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56573] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5176), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5174), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56602] = 4,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5178), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56633] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5182), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5180), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56662] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(4644), 1,
      sym_kConst,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4642), 18,
      anon_sym_LBRACK,
      aux_sym_type_token1,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56693] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5186), 5,
      anon_sym_LBRACK,
      aux_sym__literalString_token1,
      anon_sym_POUND,
      aux_sym__literalInt_token2,
      sym_kAt,
    ACTIONS(5184), 14,
      anon_sym_LPAREN,
      aux_sym__literalInt_token1,
      aux_sym__literalFloat_token1,
      sym_kSpecialize,
      sym_kAdd,
      sym_kSub,
      sym_kNot,
      sym_kFunction,
      sym_kProcedure,
      sym_kInherited,
      sym_kNil,
      sym_kTrue,
      sym_kFalse,
      sym_identifier,
  [56722] = 4,
    ACTIONS(3116), 1,
      sym_kConst,
    ACTIONS(5188), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3114), 17,
      anon_sym_LBRACK,
      sym_kUses,
      sym_kBegin,
      sym_kAsm,
      sym_kVar,
      sym_kThreadvar,
      sym_kResourcestring,
      sym_kType,
      sym_kLabel,
      sym_kExports,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
  [56753] = 6,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5192), 1,
      anon_sym_COLON,
    ACTIONS(5194), 1,
      sym_kOf,
    STATE(1450), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5190), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56785] = 6,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5198), 1,
      anon_sym_COLON,
    ACTIONS(5200), 1,
      sym_kOf,
    STATE(1449), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5196), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56817] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5204), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
    ACTIONS(5202), 10,
      anon_sym_SEMI,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [56842] = 4,
    ACTIONS(5208), 1,
      anon_sym_COLON,
    ACTIONS(5210), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5206), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56868] = 4,
    ACTIONS(5214), 1,
      anon_sym_COLON,
    ACTIONS(5216), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5212), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56894] = 3,
    ACTIONS(5220), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5218), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56917] = 8,
    ACTIONS(4283), 1,
      sym_kCase,
    ACTIONS(4291), 1,
      sym_kStrict,
    ACTIONS(5222), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(2134), 1,
      sym_declVariant,
    STATE(1484), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4289), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
  [56950] = 3,
    ACTIONS(5226), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5224), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56973] = 3,
    ACTIONS(5230), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5228), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [56996] = 3,
    ACTIONS(5234), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5232), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57019] = 8,
    ACTIONS(4269), 1,
      sym_kEnd,
    ACTIONS(4283), 1,
      sym_kCase,
    ACTIONS(4291), 1,
      sym_kStrict,
    STATE(966), 1,
      sym__visibility,
    STATE(2443), 1,
      sym_declVariant,
    STATE(1484), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4289), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
  [57052] = 8,
    ACTIONS(4283), 1,
      sym_kCase,
    ACTIONS(4291), 1,
      sym_kStrict,
    ACTIONS(4295), 1,
      sym_kEnd,
    STATE(966), 1,
      sym__visibility,
    STATE(2273), 1,
      sym_declVariant,
    STATE(1484), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4289), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
  [57085] = 3,
    ACTIONS(5238), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5236), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57108] = 3,
    ACTIONS(5242), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5240), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57131] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5244), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57151] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5246), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57171] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5248), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57191] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5250), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57211] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5252), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57231] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5254), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57251] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5256), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57271] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5258), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57291] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5260), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57311] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5262), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57331] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5264), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57351] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5266), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57371] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5268), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57391] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5270), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57411] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5272), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57431] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5274), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57451] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5276), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57471] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5196), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57491] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5278), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57511] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5280), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57531] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5282), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57551] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5284), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57571] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5286), 12,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kAbsolute,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
      sym_kEq,
  [57591] = 10,
    ACTIONS(2924), 1,
      sym_kGeneric,
    ACTIONS(2944), 1,
      sym_kOperator,
    ACTIONS(5288), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      sym_kProperty,
    ACTIONS(5292), 1,
      sym_kClass,
    STATE(1090), 1,
      sym__declOperator,
    STATE(1100), 1,
      sym__declProc,
    STATE(1984), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2942), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [57627] = 6,
    ACTIONS(5299), 1,
      sym_kStrict,
    STATE(966), 1,
      sym__visibility,
    ACTIONS(5294), 2,
      sym_kEnd,
      sym_kCase,
    STATE(1484), 2,
      sym_declSection,
      aux_sym__declClass_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5296), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
  [57655] = 4,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    STATE(1486), 1,
      aux_sym_rttiAttributes_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5302), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [57678] = 4,
    ACTIONS(5306), 1,
      anon_sym_LBRACK,
    STATE(1486), 1,
      aux_sym_rttiAttributes_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5304), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [57701] = 5,
    ACTIONS(5313), 1,
      sym_kLt,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5309), 4,
      anon_sym_LPAREN,
      sym_kIndex,
      sym_kName,
      sym_identifier,
    ACTIONS(5311), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_kEq,
  [57726] = 3,
    ACTIONS(5315), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5317), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [57746] = 3,
    ACTIONS(5321), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5319), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [57766] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5323), 1,
      anon_sym_RPAREN,
    STATE(1539), 1,
      aux_sym_declClass_repeat1,
    STATE(2065), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [57796] = 3,
    ACTIONS(5325), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5304), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [57816] = 3,
    ACTIONS(5327), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5329), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [57836] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5331), 1,
      anon_sym_RPAREN,
    STATE(1555), 1,
      aux_sym_declClass_repeat1,
    STATE(1988), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [57866] = 8,
    ACTIONS(4281), 1,
      sym_kGeneric,
    ACTIONS(4287), 1,
      sym_kOperator,
    ACTIONS(5333), 1,
      sym_kProperty,
    ACTIONS(5335), 1,
      sym_kClass,
    STATE(1090), 1,
      sym__declOperator,
    STATE(1100), 1,
      sym__declProc,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4285), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [57896] = 7,
    ACTIONS(5337), 1,
      sym_kInterface,
    ACTIONS(5339), 1,
      sym_kImplementation,
    ACTIONS(5341), 1,
      sym_kInitialization,
    ACTIONS(5343), 1,
      sym_kFinalization,
    ACTIONS(5345), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1527), 5,
      sym_interface,
      sym_implementation,
      sym_initialization,
      sym_finalization,
      aux_sym_unit_repeat1,
  [57924] = 3,
    ACTIONS(5347), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5349), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [57944] = 3,
    ACTIONS(5353), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5351), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [57964] = 3,
    ACTIONS(5357), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5355), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [57984] = 7,
    ACTIONS(5361), 1,
      sym_kConst,
    ACTIONS(5363), 1,
      sym_kResourcestring,
    ACTIONS(5365), 1,
      sym_kProperty,
    ACTIONS(5369), 1,
      sym_kOperator,
    ACTIONS(5359), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5367), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [58012] = 3,
    ACTIONS(5371), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1150), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58032] = 3,
    ACTIONS(5373), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(2976), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58052] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5375), 1,
      anon_sym_RPAREN,
    STATE(1530), 1,
      aux_sym_declClass_repeat1,
    STATE(2006), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58082] = 3,
    ACTIONS(5377), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5379), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58102] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5381), 1,
      anon_sym_RPAREN,
    STATE(1538), 1,
      aux_sym_declClass_repeat1,
    STATE(1990), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58132] = 3,
    ACTIONS(5383), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5385), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58152] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
    STATE(1537), 1,
      aux_sym_declClass_repeat1,
    STATE(2092), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58182] = 3,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5389), 4,
      anon_sym_LPAREN,
      sym_kIndex,
      sym_kName,
      sym_identifier,
    ACTIONS(5391), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym_kLt,
      sym_kEq,
  [58202] = 7,
    ACTIONS(5333), 1,
      sym_kProperty,
    ACTIONS(5395), 1,
      sym_kConst,
    ACTIONS(5397), 1,
      sym_kResourcestring,
    ACTIONS(5401), 1,
      sym_kOperator,
    ACTIONS(5393), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5399), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [58230] = 3,
    ACTIONS(5405), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5403), 9,
      sym_kProperty,
      sym_kClass,
      sym_kGeneric,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
      sym_kOperator,
      sym_identifier,
  [58250] = 3,
    ACTIONS(5407), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5409), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58270] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5411), 1,
      anon_sym_RPAREN,
    STATE(1549), 1,
      aux_sym_declClass_repeat1,
    STATE(1950), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58300] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5413), 1,
      anon_sym_RPAREN,
    STATE(1570), 1,
      aux_sym_declClass_repeat1,
    STATE(1958), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58330] = 7,
    ACTIONS(5337), 1,
      sym_kInterface,
    ACTIONS(5339), 1,
      sym_kImplementation,
    ACTIONS(5341), 1,
      sym_kInitialization,
    ACTIONS(5343), 1,
      sym_kFinalization,
    ACTIONS(5415), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1495), 5,
      sym_interface,
      sym_implementation,
      sym_initialization,
      sym_finalization,
      aux_sym_unit_repeat1,
  [58358] = 3,
    ACTIONS(5417), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(1168), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58378] = 8,
    ACTIONS(4358), 1,
      sym_kGeneric,
    ACTIONS(4362), 1,
      sym_kOperator,
    ACTIONS(5365), 1,
      sym_kProperty,
    ACTIONS(5419), 1,
      sym_kClass,
    STATE(1090), 1,
      sym__declOperator,
    STATE(1100), 1,
      sym__declProc,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4360), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [58408] = 3,
    ACTIONS(5421), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5423), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58428] = 3,
    ACTIONS(5425), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5427), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58448] = 3,
    ACTIONS(5429), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5431), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58468] = 3,
    ACTIONS(5433), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5435), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58488] = 3,
    ACTIONS(5437), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5439), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58508] = 3,
    ACTIONS(5441), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5443), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58528] = 3,
    ACTIONS(5445), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5447), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58548] = 3,
    ACTIONS(5449), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3064), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58568] = 3,
    ACTIONS(5451), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5453), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58588] = 8,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5455), 1,
      anon_sym_RPAREN,
    STATE(1541), 1,
      aux_sym_declClass_repeat1,
    STATE(2074), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58618] = 3,
    ACTIONS(5457), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5459), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58638] = 7,
    ACTIONS(5461), 1,
      sym_kInterface,
    ACTIONS(5464), 1,
      sym_kImplementation,
    ACTIONS(5467), 1,
      sym_kInitialization,
    ACTIONS(5470), 1,
      sym_kFinalization,
    ACTIONS(5473), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1527), 5,
      sym_interface,
      sym_implementation,
      sym_initialization,
      sym_finalization,
      aux_sym_unit_repeat1,
  [58666] = 3,
    ACTIONS(5475), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5477), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58686] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5479), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58703] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2026), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58730] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5481), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58747] = 10,
    ACTIONS(5483), 1,
      anon_sym_SEMI,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5493), 1,
      sym_kNodefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    STATE(1536), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [58780] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5499), 1,
      anon_sym_SEMI,
    ACTIONS(5501), 1,
      sym_kNodefault,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [58813] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5503), 1,
      anon_sym_SEMI,
    ACTIONS(5505), 1,
      anon_sym_COLON,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(1743), 1,
      sym_declArgs,
    STATE(1757), 1,
      sym_kDot,
    STATE(2301), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [58846] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5509), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58863] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5511), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [58896] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2084), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58923] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2098), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58950] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2076), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [58977] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5513), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [58994] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2051), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [59021] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5515), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59054] = 7,
    ACTIONS(5517), 1,
      sym_identifier,
    ACTIONS(5519), 1,
      anon_sym_RBRACK,
    STATE(1608), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(1975), 1,
      sym_declArg,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5521), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [59081] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5523), 1,
      anon_sym_SEMI,
    ACTIONS(5525), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1788), 1,
      sym_declArgs,
    STATE(2409), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59114] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5527), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [59131] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5529), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [59148] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5531), 1,
      anon_sym_SEMI,
    ACTIONS(5533), 1,
      sym_kNodefault,
    STATE(1576), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59181] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5535), 1,
      anon_sym_SEMI,
    ACTIONS(5537), 1,
      sym_kNodefault,
    STATE(1553), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59214] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(1987), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [59241] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5539), 1,
      anon_sym_SEMI,
    ACTIONS(5541), 1,
      sym_kNodefault,
    STATE(1563), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59274] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5543), 1,
      anon_sym_SEMI,
    ACTIONS(5545), 1,
      sym_kNodefault,
    STATE(1575), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59307] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5547), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [59324] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5549), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59357] = 7,
    ACTIONS(5551), 1,
      sym_identifier,
    ACTIONS(5554), 1,
      sym_kSpecialize,
    ACTIONS(5557), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2125), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [59384] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2005), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [59411] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5560), 1,
      anon_sym_SEMI,
    ACTIONS(5562), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1798), 1,
      sym_declArgs,
    STATE(2188), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59444] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5564), 1,
      anon_sym_SEMI,
    ACTIONS(5566), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1787), 1,
      sym_declArgs,
    STATE(2178), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59477] = 7,
    ACTIONS(5517), 1,
      sym_identifier,
    ACTIONS(5568), 1,
      anon_sym_RPAREN,
    STATE(1646), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(2030), 1,
      sym_declArg,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5521), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [59504] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5570), 1,
      anon_sym_SEMI,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1767), 1,
      sym_declArgs,
    STATE(2165), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59537] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5574), 1,
      anon_sym_SEMI,
    ACTIONS(5576), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1780), 1,
      sym_declArgs,
    STATE(2224), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59570] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5578), 1,
      anon_sym_SEMI,
    ACTIONS(5580), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1763), 1,
      sym_declArgs,
    STATE(2155), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59603] = 6,
    ACTIONS(5361), 1,
      sym_kConst,
    ACTIONS(5363), 1,
      sym_kResourcestring,
    ACTIONS(5584), 1,
      sym_kOperator,
    ACTIONS(5359), 2,
      sym_kVar,
      sym_kThreadvar,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5582), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [59628] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5586), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59661] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5588), 9,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kElse,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [59678] = 7,
    ACTIONS(35), 1,
      sym_kGeneric,
    ACTIONS(39), 1,
      sym_kOperator,
    ACTIONS(5590), 1,
      sym_kClass,
    STATE(1431), 1,
      sym__declProc,
    STATE(1438), 1,
      sym__declOperator,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(37), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [59705] = 7,
    ACTIONS(5517), 1,
      sym_identifier,
    ACTIONS(5592), 1,
      anon_sym_RPAREN,
    STATE(1594), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(2001), 1,
      sym_declArg,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5521), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [59732] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5594), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59765] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5596), 1,
      anon_sym_SEMI,
    ACTIONS(5598), 1,
      sym_kNodefault,
    STATE(1577), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59798] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5600), 1,
      anon_sym_SEMI,
    ACTIONS(5602), 1,
      sym_kNodefault,
    STATE(1567), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59831] = 7,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1554), 1,
      aux_sym_declClass_repeat1,
    STATE(2063), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [59858] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5604), 1,
      anon_sym_SEMI,
    ACTIONS(5606), 1,
      anon_sym_COLON,
    STATE(1729), 1,
      sym_declArgs,
    STATE(1757), 1,
      sym_kDot,
    STATE(2460), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59891] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5608), 1,
      anon_sym_SEMI,
    ACTIONS(5610), 1,
      sym_kNodefault,
    STATE(1533), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59924] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5612), 1,
      anon_sym_SEMI,
    ACTIONS(5614), 1,
      sym_kNodefault,
    STATE(1584), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59957] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5616), 1,
      anon_sym_SEMI,
    ACTIONS(5618), 1,
      sym_kNodefault,
    STATE(1579), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [59990] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5620), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60023] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5622), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60056] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5624), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60089] = 10,
    ACTIONS(5626), 1,
      anon_sym_SEMI,
    ACTIONS(5628), 1,
      sym_kRead,
    ACTIONS(5631), 1,
      sym_kWrite,
    ACTIONS(5634), 1,
      sym_kImplements,
    ACTIONS(5637), 1,
      sym_kDefault,
    ACTIONS(5640), 1,
      sym_kNodefault,
    ACTIONS(5643), 1,
      sym_kStored,
    ACTIONS(5646), 1,
      sym_kIndex,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60122] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5649), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60155] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5651), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60188] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5653), 1,
      anon_sym_SEMI,
    ACTIONS(5655), 1,
      sym_kNodefault,
    STATE(1580), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60221] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5657), 1,
      anon_sym_SEMI,
    ACTIONS(5659), 1,
      sym_kNodefault,
    STATE(1542), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60254] = 10,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5661), 1,
      anon_sym_SEMI,
    ACTIONS(5663), 1,
      anon_sym_COLON,
    STATE(1757), 1,
      sym_kDot,
    STATE(1765), 1,
      sym_declArgs,
    STATE(2257), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60287] = 10,
    ACTIONS(5485), 1,
      sym_kRead,
    ACTIONS(5487), 1,
      sym_kWrite,
    ACTIONS(5489), 1,
      sym_kImplements,
    ACTIONS(5491), 1,
      sym_kDefault,
    ACTIONS(5495), 1,
      sym_kStored,
    ACTIONS(5497), 1,
      sym_kIndex,
    ACTIONS(5501), 1,
      sym_kNodefault,
    ACTIONS(5665), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declProp_repeat2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60320] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5667), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [60336] = 6,
    ACTIONS(5669), 1,
      sym_identifier,
    STATE(1586), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    STATE(2395), 1,
      sym_declArg,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5672), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [60360] = 6,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5675), 1,
      sym_identifier,
    STATE(2278), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60384] = 6,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    STATE(1880), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60408] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1910), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60432] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(2126), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60456] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5677), 8,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [60472] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1888), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60496] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1459), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60520] = 6,
    ACTIONS(5517), 1,
      sym_identifier,
    STATE(1586), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(2028), 1,
      sym_declArg,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5521), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [60544] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5679), 8,
      anon_sym_SEMI,
      sym_kRead,
      sym_kWrite,
      sym_kImplements,
      sym_kDefault,
      sym_kNodefault,
      sym_kStored,
      sym_kIndex,
  [60560] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1911), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60584] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1036), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60608] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1802), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60632] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1015), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60656] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1861), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60680] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1042), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60704] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1837), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60728] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1458), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60752] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1805), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60776] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1469), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60800] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1794), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60824] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1811), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60848] = 6,
    ACTIONS(5517), 1,
      sym_identifier,
    STATE(1586), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    STATE(2060), 1,
      sym_declArg,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5521), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [60872] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1816), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60896] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1812), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60920] = 7,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    STATE(1715), 1,
      aux_sym_declExport_repeat1,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(5681), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(5683), 2,
      sym_kIndex,
      sym_kName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [60946] = 6,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    STATE(1836), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60970] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(2410), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [60994] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(2320), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61018] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1718), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61042] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1820), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61066] = 6,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5685), 1,
      sym_identifier,
    STATE(2296), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61090] = 6,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5687), 1,
      sym_identifier,
    STATE(2325), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61114] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(748), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61138] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1833), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61162] = 6,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5689), 1,
      sym_identifier,
    STATE(1660), 1,
      aux_sym_typerefArgs_repeat1,
    STATE(2175), 1,
      sym_typerefArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1709), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61186] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1448), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61210] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(755), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61234] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1742), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61258] = 4,
    ACTIONS(5691), 1,
      sym_kInterface,
    ACTIONS(5695), 1,
      sym_kArray,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5693), 6,
      sym_kClass,
      sym_kObject,
      sym_kRecord,
      sym_kObjcclass,
      sym_kObjccategory,
      sym_kObjcprotocol,
  [61278] = 6,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    STATE(1914), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61302] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1847), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61326] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(991), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61350] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1873), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61374] = 6,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5689), 1,
      sym_identifier,
    STATE(1660), 1,
      aux_sym_typerefArgs_repeat1,
    STATE(2436), 1,
      sym_typerefArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1709), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61398] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1838), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61422] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1451), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61446] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1860), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61470] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1014), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61494] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1049), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61518] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(777), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61542] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(746), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61566] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1884), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61590] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1021), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61614] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1806), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61638] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1040), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61662] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1874), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61686] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1053), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61710] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(996), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61734] = 9,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(5697), 1,
      sym_identifier,
    ACTIONS(5699), 1,
      anon_sym_SEMI,
    ACTIONS(5701), 1,
      anon_sym_RPAREN,
    STATE(1745), 1,
      aux_sym_declVariantClause_repeat1,
    STATE(1924), 1,
      sym_declVariant,
    STATE(1928), 1,
      sym_declVariantField,
    STATE(1930), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [61764] = 6,
    ACTIONS(5517), 1,
      sym_identifier,
    STATE(1586), 1,
      aux_sym_declPropArgs_repeat1,
    STATE(1999), 1,
      sym_declArg,
    STATE(2049), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5521), 4,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
  [61788] = 6,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    STATE(1915), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61812] = 6,
    ACTIONS(4754), 1,
      sym_identifier,
    ACTIONS(4772), 1,
      sym_kSpecialize,
    ACTIONS(4774), 1,
      sym_kHat,
    STATE(1969), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1673), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61836] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1455), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61860] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1017), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61884] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1916), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61908] = 6,
    ACTIONS(4225), 1,
      sym_identifier,
    ACTIONS(4251), 1,
      sym_kSpecialize,
    ACTIONS(4253), 1,
      sym_kHat,
    STATE(1039), 1,
      sym_typeref,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(550), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [61932] = 3,
    STATE(967), 1,
      sym__visibility,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5703), 6,
      sym_kPublished,
      sym_kPublic,
      sym_kProtected,
      sym_kPrivate,
      sym_kRequired,
      sym_kOptional,
  [61949] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5709), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2247), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [61972] = 6,
    ACTIONS(5711), 1,
      sym_identifier,
    ACTIONS(5713), 1,
      anon_sym_SEMI,
    STATE(1685), 1,
      aux_sym_declExports_repeat1,
    STATE(1946), 1,
      sym_declExport,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1611), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [61995] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5715), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2222), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62018] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5717), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2256), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62041] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5719), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2157), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62064] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5721), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2447), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62087] = 5,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5723), 1,
      sym_identifier,
    STATE(1663), 1,
      aux_sym_typerefArgs_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1704), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62108] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5725), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2416), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62131] = 6,
    ACTIONS(5707), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5727), 1,
      sym_kEnd,
    STATE(1687), 1,
      aux_sym_asmBody_repeat1,
    STATE(2369), 1,
      sym_asmBody,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5705), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62154] = 5,
    ACTIONS(5729), 1,
      sym_identifier,
    ACTIONS(5732), 1,
      sym_kHat,
    STATE(1663), 1,
      aux_sym_typerefArgs_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1776), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62175] = 5,
    ACTIONS(5735), 1,
      sym_identifier,
    STATE(1664), 1,
      aux_sym_declExports_repeat1,
    STATE(2305), 1,
      sym_declExport,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1611), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [62195] = 6,
    ACTIONS(5740), 1,
      anon_sym_COLON,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(5744), 1,
      sym_kEq,
    STATE(1954), 1,
      sym_defaultValue,
    ACTIONS(5738), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62217] = 4,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(5746), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1680), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62235] = 4,
    ACTIONS(5401), 1,
      sym_kOperator,
    ACTIONS(5748), 1,
      sym_kProperty,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5399), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [62253] = 4,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5750), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(551), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62271] = 4,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5752), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(553), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62289] = 4,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(5754), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1678), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62307] = 6,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(5744), 1,
      sym_kEq,
    ACTIONS(5758), 1,
      anon_sym_COLON,
    STATE(1992), 1,
      sym_defaultValue,
    ACTIONS(5756), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62329] = 4,
    ACTIONS(4253), 1,
      sym_kHat,
    ACTIONS(5760), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(552), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62347] = 6,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5762), 1,
      sym_kLt,
    STATE(1666), 1,
      sym_kDot,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(3092), 3,
      aux_sym_type_token2,
      aux_sym_type_token3,
      sym_kOf,
  [62369] = 4,
    ACTIONS(5), 1,
      sym_pp,
    STATE(1666), 1,
      sym_kDot,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(3100), 5,
      aux_sym_type_token2,
      aux_sym_type_token3,
      anon_sym_DOT,
      sym_kOf,
      sym_kLt,
  [62387] = 4,
    ACTIONS(5369), 1,
      sym_kOperator,
    ACTIONS(5764), 1,
      sym_kProperty,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5367), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [62405] = 3,
    ACTIONS(5766), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5768), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [62421] = 3,
    ACTIONS(5772), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5770), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
  [62437] = 6,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5762), 1,
      sym_kLt,
    STATE(1666), 1,
      sym_kDot,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(3108), 3,
      aux_sym_type_token2,
      aux_sym_type_token3,
      sym_kOf,
  [62459] = 6,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5776), 1,
      anon_sym_LPAREN,
    ACTIONS(5778), 1,
      anon_sym_DOT,
    STATE(1178), 1,
      sym_kDot,
    ACTIONS(5774), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62481] = 4,
    ACTIONS(5), 1,
      sym_pp,
    STATE(1666), 1,
      sym_kDot,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(3104), 5,
      aux_sym_type_token2,
      aux_sym_type_token3,
      anon_sym_DOT,
      sym_kOf,
      sym_kLt,
  [62499] = 7,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(5780), 1,
      anon_sym_COLON,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      sym_kOf,
    STATE(1732), 1,
      sym_declArgs,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5196), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [62523] = 4,
    ACTIONS(4774), 1,
      sym_kHat,
    ACTIONS(5786), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1674), 4,
      sym__typeref,
      sym_typerefDot,
      sym_typerefTpl,
      sym_typerefPtr,
  [62541] = 3,
    ACTIONS(5788), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5768), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [62557] = 5,
    ACTIONS(5793), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5796), 1,
      sym_kEnd,
    STATE(1684), 1,
      aux_sym_asmBody_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5790), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62577] = 5,
    ACTIONS(5711), 1,
      sym_identifier,
    STATE(1664), 1,
      aux_sym_declExports_repeat1,
    STATE(2088), 1,
      sym_declExport,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1611), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [62597] = 7,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_COLON,
    ACTIONS(5800), 1,
      sym_kOf,
    STATE(1772), 1,
      sym_declArgs,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5190), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [62621] = 5,
    ACTIONS(5804), 1,
      aux_sym_asmBody_token3,
    ACTIONS(5806), 1,
      sym_kEnd,
    STATE(1684), 1,
      aux_sym_asmBody_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5802), 3,
      aux_sym_asmBody_token1,
      aux_sym_asmBody_token2,
      sym_identifier,
  [62641] = 3,
    ACTIONS(5584), 1,
      sym_kOperator,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5582), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [62656] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5808), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
  [62669] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5810), 5,
      sym_kInterface,
      sym_kImplementation,
      sym_kInitialization,
      sym_kFinalization,
      sym_kEnd,
  [62682] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(3128), 5,
      aux_sym_type_token2,
      aux_sym_type_token3,
      anon_sym_DOT,
      sym_kOf,
      sym_kLt,
  [62697] = 4,
    ACTIONS(4746), 1,
      anon_sym_COLON,
    STATE(1708), 1,
      aux_sym_legacyFormat_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5812), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62714] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(1856), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5814), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62731] = 3,
    ACTIONS(5816), 1,
      sym_kClass,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5367), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [62746] = 4,
    STATE(1695), 1,
      aux_sym_declExport_repeat1,
    ACTIONS(4844), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(5818), 2,
      sym_kIndex,
      sym_kName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62763] = 6,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(5756), 1,
      anon_sym_SEMI,
    ACTIONS(5821), 1,
      anon_sym_COLON,
    STATE(1992), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62784] = 3,
    ACTIONS(5823), 1,
      sym_kClass,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5582), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [62799] = 4,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(5827), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5825), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62816] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(1881), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5829), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62833] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5831), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kGt,
  [62846] = 6,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5738), 1,
      anon_sym_SEMI,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(5833), 1,
      anon_sym_COLON,
    STATE(1954), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62867] = 4,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(5837), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5835), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62884] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(1850), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5839), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62901] = 6,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3096), 1,
      sym_kLt,
    ACTIONS(5841), 1,
      anon_sym_COMMA,
    ACTIONS(5843), 1,
      sym_kGt,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [62922] = 3,
    ACTIONS(5845), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5770), 4,
      sym_kEnd,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [62937] = 4,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(5849), 1,
      sym_kGeneric,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1760), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [62954] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5851), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kGt,
  [62967] = 4,
    ACTIONS(5853), 1,
      anon_sym_COLON,
    STATE(1708), 1,
      aux_sym_legacyFormat_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4882), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [62984] = 6,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3096), 1,
      sym_kLt,
    ACTIONS(5841), 1,
      anon_sym_COMMA,
    ACTIONS(5856), 1,
      sym_kGt,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63005] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(1854), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5858), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [63022] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5860), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kGt,
  [63035] = 6,
    ACTIONS(5862), 1,
      sym_identifier,
    ACTIONS(5864), 1,
      anon_sym_SEMI,
    STATE(1777), 1,
      aux_sym_declUses_repeat1,
    STATE(2008), 1,
      sym_moduleName,
    STATE(2090), 1,
      aux_sym_moduleName_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63056] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4449), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [63069] = 3,
    ACTIONS(5866), 1,
      sym_kClass,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5399), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [63084] = 4,
    STATE(1695), 1,
      aux_sym_declExport_repeat1,
    ACTIONS(5683), 2,
      sym_kIndex,
      sym_kName,
    ACTIONS(5868), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63101] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4540), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [63114] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(4802), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [63127] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5204), 5,
      sym_kAssign,
      sym_kAssignAdd,
      sym_kAssignSub,
      sym_kAssignMul,
      sym_kAssignDiv,
  [63140] = 6,
    ACTIONS(5870), 1,
      sym_identifier,
    STATE(1791), 1,
      aux_sym_genericArgs_repeat1,
    STATE(1947), 1,
      aux_sym_genericArg_repeat1,
    STATE(1951), 1,
      sym_genericArg,
    STATE(2318), 1,
      sym_genericArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63161] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5872), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kGt,
  [63174] = 4,
    ACTIONS(5874), 1,
      sym_identifier,
    ACTIONS(5876), 1,
      sym_kGeneric,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1795), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63191] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5878), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      sym_kGt,
  [63204] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5880), 5,
      sym_kVar,
      sym_kConst,
      sym_kConstref,
      sym_kOut,
      sym_identifier,
  [63217] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5882), 1,
      sym_kEq,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63235] = 5,
    ACTIONS(5884), 1,
      sym_identifier,
    STATE(1725), 1,
      aux_sym_declUses_repeat1,
    STATE(2090), 1,
      aux_sym_moduleName_repeat1,
    STATE(2371), 1,
      sym_moduleName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63253] = 3,
    ACTIONS(5887), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1785), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63267] = 5,
    ACTIONS(5889), 1,
      sym_kEnd,
    ACTIONS(5891), 1,
      sym_kElse,
    ACTIONS(5893), 1,
      sym_kOn,
    STATE(2174), 1,
      sym_exceptionElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63285] = 3,
    ACTIONS(5895), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1760), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63299] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5897), 1,
      anon_sym_SEMI,
    ACTIONS(5899), 1,
      anon_sym_COLON,
    STATE(2291), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63317] = 3,
    ACTIONS(5901), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1556), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63331] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4435), 4,
      anon_sym_COLON,
      aux_sym_type_token2,
      aux_sym_type_token3,
      sym_kOf,
  [63345] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(5903), 1,
      anon_sym_COLON,
    ACTIONS(5905), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5206), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [63363] = 3,
    ACTIONS(5907), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5909), 3,
      anon_sym_DOT,
      sym_kOf,
      sym_kLt,
  [63377] = 3,
    ACTIONS(5911), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1795), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63391] = 3,
    ACTIONS(5913), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1544), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63405] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5915), 1,
      anon_sym_SEMI,
    ACTIONS(5917), 1,
      sym_kAbsolute,
    STATE(2404), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63423] = 3,
    ACTIONS(5919), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1534), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63437] = 4,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    STATE(2411), 1,
      sym_kDot,
    ACTIONS(5921), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63453] = 5,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5923), 1,
      sym_identifier,
    ACTIONS(5925), 1,
      anon_sym_COLON,
    STATE(1955), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63471] = 3,
    ACTIONS(5927), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5909), 3,
      anon_sym_DOT,
      sym_kLt,
      sym_kDo,
  [63485] = 3,
    ACTIONS(5929), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5909), 3,
      anon_sym_DOT,
      sym_kLt,
      sym_kDo,
  [63499] = 4,
    ACTIONS(5744), 1,
      sym_kEq,
    STATE(2046), 1,
      sym_defaultValue,
    ACTIONS(5931), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63515] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5933), 1,
      anon_sym_SEMI,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    STATE(2379), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63533] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5937), 1,
      anon_sym_SEMI,
    ACTIONS(5939), 1,
      sym_kAbsolute,
    STATE(2363), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63551] = 5,
    ACTIONS(5941), 1,
      sym_identifier,
    STATE(1759), 1,
      aux_sym_declVariantClause_repeat1,
    STATE(1930), 1,
      aux_sym_genericArg_repeat1,
    STATE(1973), 1,
      sym_declVariantField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63569] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5943), 1,
      anon_sym_SEMI,
    ACTIONS(5945), 1,
      sym_kAbsolute,
    STATE(2350), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63587] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5947), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [63599] = 5,
    ACTIONS(5949), 1,
      sym_identifier,
    STATE(1748), 1,
      aux_sym_genericArgs_repeat1,
    STATE(1948), 1,
      aux_sym_genericArg_repeat1,
    STATE(2298), 1,
      sym_genericArg,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63617] = 3,
    ACTIONS(5952), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1560), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63631] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5954), 1,
      sym_kEq,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63649] = 5,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(5956), 1,
      sym_identifier,
    ACTIONS(5958), 1,
      anon_sym_RPAREN,
    STATE(2000), 1,
      sym_declVariant,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63667] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4439), 4,
      anon_sym_COLON,
      aux_sym_type_token2,
      aux_sym_type_token3,
      sym_kOf,
  [63681] = 5,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5960), 1,
      sym_identifier,
    ACTIONS(5962), 1,
      anon_sym_COLON,
    STATE(2081), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63699] = 3,
    ACTIONS(5964), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1583), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63713] = 5,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5966), 1,
      sym_identifier,
    ACTIONS(5968), 1,
      anon_sym_COLON,
    STATE(2082), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63731] = 3,
    ACTIONS(5970), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1750), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63745] = 3,
    ACTIONS(5972), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1487), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63759] = 5,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(5974), 1,
      sym_identifier,
    ACTIONS(5976), 1,
      anon_sym_COLON,
    STATE(2080), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63777] = 5,
    ACTIONS(5978), 1,
      sym_identifier,
    STATE(1759), 1,
      aux_sym_declVariantClause_repeat1,
    STATE(1930), 1,
      aux_sym_genericArg_repeat1,
    STATE(2241), 1,
      sym_declVariantField,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63795] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(5981), 1,
      sym_kEq,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63813] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(5983), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [63825] = 5,
    ACTIONS(5985), 1,
      sym_kOn,
    STATE(1727), 1,
      sym_exceptionHandler,
    STATE(1851), 1,
      sym_exceptionHandlerTr,
    STATE(1917), 1,
      aux_sym__exceptionHandlers_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63843] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5987), 1,
      anon_sym_SEMI,
    ACTIONS(5989), 1,
      anon_sym_COLON,
    STATE(2170), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63861] = 3,
    ACTIONS(5991), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1561), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63875] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5993), 1,
      anon_sym_SEMI,
    ACTIONS(5995), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63893] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5997), 1,
      anon_sym_SEMI,
    ACTIONS(5999), 1,
      sym_kAbsolute,
    STATE(2120), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63911] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6001), 1,
      anon_sym_SEMI,
    ACTIONS(6003), 1,
      anon_sym_COLON,
    STATE(2176), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63929] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6005), 1,
      anon_sym_SEMI,
    ACTIONS(6007), 1,
      sym_kAbsolute,
    STATE(2393), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63947] = 5,
    ACTIONS(5891), 1,
      sym_kElse,
    ACTIONS(5893), 1,
      sym_kOn,
    ACTIONS(6009), 1,
      sym_kEnd,
    STATE(2304), 1,
      sym_exceptionElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [63965] = 3,
    ACTIONS(6011), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1559), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63979] = 3,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1557), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [63993] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6015), 1,
      anon_sym_COLON,
    ACTIONS(6017), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5212), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [64011] = 3,
    ACTIONS(6019), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    STATE(1571), 3,
      sym_genericDot,
      sym_genericTpl,
      sym__genericName,
  [64025] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(2019), 1,
      sym_defaultValue,
    ACTIONS(6021), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64041] = 5,
    ACTIONS(2940), 1,
      sym_kCase,
    ACTIONS(5956), 1,
      sym_identifier,
    ACTIONS(6023), 1,
      anon_sym_RPAREN,
    STATE(2025), 1,
      sym_declVariant,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64059] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(3096), 1,
      sym_kLt,
    ACTIONS(5841), 1,
      anon_sym_COMMA,
    STATE(1672), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64077] = 5,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(1725), 1,
      aux_sym_declUses_repeat1,
    STATE(2052), 1,
      sym_moduleName,
    STATE(2090), 1,
      aux_sym_moduleName_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64095] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6025), 1,
      anon_sym_SEMI,
    ACTIONS(6027), 1,
      sym_kAbsolute,
    STATE(2204), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64113] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(4421), 4,
      anon_sym_COLON,
      aux_sym_type_token2,
      aux_sym_type_token3,
      sym_kOf,
  [64127] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6029), 1,
      anon_sym_SEMI,
    ACTIONS(6031), 1,
      anon_sym_COLON,
    STATE(2190), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64145] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(2069), 1,
      sym_defaultValue,
    ACTIONS(6033), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64161] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(1976), 1,
      sym_defaultValue,
    ACTIONS(6035), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64177] = 3,
    ACTIONS(6037), 1,
      sym_kName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3520), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [64191] = 5,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6041), 1,
      anon_sym_COLON,
    STATE(2058), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64209] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(6043), 1,
      sym_kEq,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64227] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6045), 4,
      sym_kEnd,
      sym_kUntil,
      sym_kExcept,
      sym_kFinally,
  [64239] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6047), 1,
      anon_sym_SEMI,
    ACTIONS(6049), 1,
      anon_sym_COLON,
    STATE(2193), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64257] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6051), 1,
      anon_sym_SEMI,
    ACTIONS(6053), 1,
      anon_sym_COLON,
    STATE(2152), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64275] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6055), 4,
      sym_kFunction,
      sym_kProcedure,
      sym_kConstructor,
      sym_kDestructor,
  [64287] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(6057), 1,
      sym_kEq,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64305] = 5,
    ACTIONS(5870), 1,
      sym_identifier,
    STATE(1748), 1,
      aux_sym_genericArgs_repeat1,
    STATE(1947), 1,
      aux_sym_genericArg_repeat1,
    STATE(2077), 1,
      sym_genericArg,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64323] = 5,
    ACTIONS(4124), 1,
      anon_sym_LPAREN,
    ACTIONS(6059), 1,
      sym_identifier,
    ACTIONS(6061), 1,
      anon_sym_COLON,
    STATE(2062), 1,
      sym_declArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64341] = 4,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    STATE(2411), 1,
      sym_kDot,
    ACTIONS(6063), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64357] = 4,
    ACTIONS(5744), 1,
      sym_kEq,
    STATE(2094), 1,
      sym_defaultValue,
    ACTIONS(6065), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64373] = 5,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      sym_kLt,
    ACTIONS(6067), 1,
      sym_kEq,
    STATE(1757), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64391] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6069), 1,
      anon_sym_SEMI,
    ACTIONS(6071), 1,
      sym_kAbsolute,
    STATE(2166), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64409] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6073), 1,
      anon_sym_SEMI,
    ACTIONS(6075), 1,
      sym_kAbsolute,
    STATE(2167), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64427] = 5,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6077), 1,
      anon_sym_SEMI,
    ACTIONS(6079), 1,
      anon_sym_COLON,
    STATE(2149), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64445] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6081), 1,
      anon_sym_SEMI,
    STATE(2455), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64460] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6083), 1,
      anon_sym_SEMI,
    STATE(2183), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64475] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6085), 1,
      anon_sym_SEMI,
    STATE(2189), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64490] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6087), 1,
      anon_sym_SEMI,
    STATE(2130), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64505] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6089), 1,
      anon_sym_SEMI,
    STATE(2141), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64520] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6091), 1,
      anon_sym_SEMI,
    STATE(2142), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64535] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6093), 1,
      anon_sym_SEMI,
    STATE(2195), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64550] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6095), 1,
      anon_sym_SEMI,
    STATE(2145), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64565] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6097), 1,
      anon_sym_SEMI,
    STATE(2196), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64580] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6099), 3,
      sym_kEnd,
      sym_kElse,
      sym_kOn,
  [64591] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6101), 1,
      anon_sym_SEMI,
    STATE(2197), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64606] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6103), 1,
      anon_sym_SEMI,
    STATE(2150), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64621] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6105), 1,
      anon_sym_SEMI,
    STATE(2199), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64636] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6107), 1,
      anon_sym_SEMI,
    STATE(2153), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64651] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(3520), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [64662] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6109), 1,
      anon_sym_SEMI,
    STATE(2200), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64677] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6111), 1,
      anon_sym_SEMI,
    STATE(2201), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64692] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6113), 1,
      anon_sym_SEMI,
    STATE(2203), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64707] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6115), 1,
      anon_sym_SEMI,
    STATE(2206), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64722] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6117), 1,
      anon_sym_SEMI,
    STATE(2207), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64737] = 4,
    ACTIONS(6119), 1,
      sym_identifier,
    STATE(1898), 1,
      aux_sym_declEnum_repeat1,
    STATE(2099), 1,
      sym_declEnumValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64752] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6121), 1,
      anon_sym_SEMI,
    STATE(2208), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64767] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6123), 1,
      aux_sym_type_token2,
    ACTIONS(6125), 1,
      aux_sym_type_token3,
    STATE(1853), 1,
      aux_sym_type_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [64784] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6127), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5228), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [64799] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6129), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5224), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [64814] = 3,
    ACTIONS(6131), 1,
      anon_sym_COMMA,
    ACTIONS(4750), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64827] = 3,
    STATE(914), 1,
      sym__literalInt,
    ACTIONS(6133), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalInt_token2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64840] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6135), 1,
      anon_sym_SEMI,
    STATE(2396), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64855] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6139), 1,
      aux_sym_type_token3,
    STATE(1865), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [64872] = 4,
    ACTIONS(6141), 1,
      sym_identifier,
    STATE(1889), 1,
      aux_sym_declLabels_repeat1,
    STATE(1952), 1,
      sym_declLabel,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64887] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6143), 1,
      anon_sym_SEMI,
    STATE(2211), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64902] = 3,
    ACTIONS(6145), 1,
      anon_sym_SEMI,
    ACTIONS(5100), 2,
      anon_sym_RPAREN,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64915] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6147), 1,
      anon_sym_SEMI,
    STATE(2184), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64930] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6149), 1,
      anon_sym_SEMI,
    STATE(2329), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64945] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6151), 1,
      anon_sym_SEMI,
    STATE(2185), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64960] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6153), 1,
      anon_sym_SEMI,
    STATE(2212), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [64975] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6155), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym_kEnd,
  [64986] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6157), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5236), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [65001] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6159), 1,
      anon_sym_SEMI,
    STATE(2187), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65016] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6161), 1,
      anon_sym_SEMI,
    STATE(2461), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65031] = 3,
    ACTIONS(6131), 1,
      anon_sym_COMMA,
    ACTIONS(6163), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65044] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6123), 1,
      aux_sym_type_token2,
    ACTIONS(6165), 1,
      aux_sym_type_token3,
    STATE(1845), 1,
      aux_sym_type_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65061] = 4,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    ACTIONS(6169), 1,
      anon_sym_LBRACK,
    STATE(2434), 1,
      sym_declPropArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65076] = 3,
    ACTIONS(6173), 1,
      sym_kHat,
    ACTIONS(6171), 2,
      sym_kSpecialize,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65089] = 3,
    STATE(473), 1,
      sym__literalInt,
    ACTIONS(6175), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalInt_token2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65102] = 3,
    STATE(1109), 1,
      sym__literalInt,
    ACTIONS(6177), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalInt_token2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65115] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6123), 1,
      aux_sym_type_token2,
    ACTIONS(6179), 1,
      aux_sym_type_token3,
    STATE(1859), 1,
      aux_sym_type_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65132] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6181), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym_kEnd,
  [65143] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6183), 1,
      anon_sym_SEMI,
    STATE(2433), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65158] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6185), 1,
      anon_sym_SEMI,
    STATE(2353), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65173] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6187), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym_kEnd,
  [65184] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6189), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65195] = 4,
    ACTIONS(5889), 1,
      sym_kEnd,
    ACTIONS(5891), 1,
      sym_kElse,
    STATE(2174), 1,
      sym_exceptionElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65210] = 4,
    ACTIONS(6169), 1,
      anon_sym_LBRACK,
    ACTIONS(6191), 1,
      anon_sym_COLON,
    STATE(2437), 1,
      sym_declPropArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65225] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6123), 1,
      aux_sym_type_token2,
    ACTIONS(6193), 1,
      aux_sym_type_token3,
    STATE(1859), 1,
      aux_sym_type_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65242] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6195), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65253] = 4,
    ACTIONS(6197), 1,
      anon_sym_SEMI,
    ACTIONS(6199), 1,
      anon_sym_COMMA,
    ACTIONS(6201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65268] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6203), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65279] = 4,
    ACTIONS(6169), 1,
      anon_sym_LBRACK,
    ACTIONS(6205), 1,
      anon_sym_COLON,
    STATE(2439), 1,
      sym_declPropArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65294] = 4,
    ACTIONS(5891), 1,
      sym_kElse,
    ACTIONS(6009), 1,
      sym_kEnd,
    STATE(2304), 1,
      sym_exceptionElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65309] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6207), 1,
      aux_sym_type_token2,
    ACTIONS(6210), 1,
      aux_sym_type_token3,
    STATE(1859), 1,
      aux_sym_type_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65326] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6212), 1,
      anon_sym_SEMI,
    STATE(2465), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65341] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6214), 1,
      anon_sym_SEMI,
    STATE(2181), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65356] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6216), 1,
      anon_sym_SEMI,
    STATE(2131), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65371] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6218), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym_kEnd,
  [65382] = 4,
    ACTIONS(6169), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_COLON,
    STATE(2295), 1,
      sym_declPropArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65397] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6222), 1,
      aux_sym_type_token2,
    ACTIONS(6225), 1,
      aux_sym_type_token3,
    STATE(1865), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65414] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6227), 1,
      anon_sym_COLON,
    STATE(2100), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65429] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6229), 1,
      aux_sym_type_token3,
    STATE(1865), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65446] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6231), 1,
      aux_sym_type_token3,
    STATE(1865), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65463] = 3,
    ACTIONS(6233), 1,
      anon_sym_SEMI,
    ACTIONS(6235), 2,
      anon_sym_RPAREN,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65476] = 4,
    ACTIONS(4283), 1,
      sym_kCase,
    ACTIONS(6237), 1,
      anon_sym_RPAREN,
    STATE(1963), 1,
      sym_declVariant,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65491] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6239), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym_kEnd,
  [65502] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6241), 1,
      aux_sym_type_token3,
    STATE(1865), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65519] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(5931), 1,
      anon_sym_SEMI,
    STATE(2046), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65534] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6243), 1,
      anon_sym_SEMI,
    STATE(2102), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65549] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6245), 1,
      aux_sym_type_token3,
    STATE(1827), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [65566] = 4,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(2090), 1,
      aux_sym_moduleName_repeat1,
    STATE(2137), 1,
      sym_moduleName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65581] = 3,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6247), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65594] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6251), 1,
      anon_sym_COLON,
    STATE(2226), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65609] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6253), 1,
      anon_sym_COLON,
    STATE(2441), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65624] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6255), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5218), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [65639] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6257), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65650] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6259), 1,
      anon_sym_SEMI,
    STATE(2103), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65665] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6261), 1,
      anon_sym_SEMI,
    STATE(2104), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65680] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6263), 1,
      anon_sym_SEMI,
    STATE(2105), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65695] = 4,
    ACTIONS(6265), 1,
      sym_identifier,
    STATE(1885), 1,
      aux_sym_declLabels_repeat1,
    STATE(2306), 1,
      sym_declLabel,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65710] = 4,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(2090), 1,
      aux_sym_moduleName_repeat1,
    STATE(2290), 1,
      sym_moduleName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65725] = 4,
    ACTIONS(6169), 1,
      anon_sym_LBRACK,
    ACTIONS(6268), 1,
      anon_sym_COLON,
    STATE(2417), 1,
      sym_declPropArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65740] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6270), 1,
      anon_sym_SEMI,
    STATE(2230), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65755] = 4,
    ACTIONS(6141), 1,
      sym_identifier,
    STATE(1885), 1,
      aux_sym_declLabels_repeat1,
    STATE(2083), 1,
      sym_declLabel,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65770] = 3,
    STATE(1091), 1,
      sym__literalInt,
    ACTIONS(6272), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalInt_token2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65783] = 4,
    ACTIONS(6119), 1,
      sym_identifier,
    STATE(1819), 1,
      aux_sym_declEnum_repeat1,
    STATE(2041), 1,
      sym_declEnumValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65798] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6274), 1,
      anon_sym_SEMI,
    STATE(2423), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65813] = 3,
    ACTIONS(6276), 1,
      anon_sym_SEMI,
    ACTIONS(5082), 2,
      anon_sym_RPAREN,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65826] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6278), 1,
      anon_sym_SEMI,
    STATE(2385), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65841] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6280), 1,
      anon_sym_SEMI,
    STATE(2387), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65856] = 4,
    ACTIONS(6119), 1,
      sym_identifier,
    STATE(1905), 1,
      aux_sym_declEnum_repeat1,
    STATE(2036), 1,
      sym_declEnumValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65871] = 3,
    STATE(963), 1,
      sym__literalInt,
    ACTIONS(6282), 2,
      aux_sym__literalInt_token1,
      aux_sym__literalInt_token2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65884] = 4,
    ACTIONS(6284), 1,
      sym_identifier,
    STATE(1898), 1,
      aux_sym_declEnum_repeat1,
    STATE(2359), 1,
      sym_declEnumValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65899] = 4,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(2090), 1,
      aux_sym_moduleName_repeat1,
    STATE(2135), 1,
      sym_moduleName,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65914] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6287), 1,
      anon_sym_SEMI,
    STATE(2107), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65929] = 4,
    ACTIONS(6169), 1,
      anon_sym_LBRACK,
    ACTIONS(6289), 1,
      anon_sym_COLON,
    STATE(2336), 1,
      sym_declPropArgs,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65944] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6291), 1,
      anon_sym_SEMI,
    STATE(2219), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65959] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6293), 1,
      anon_sym_SEMI,
    STATE(2452), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [65974] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6295), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym_kEnd,
  [65985] = 4,
    ACTIONS(6119), 1,
      sym_identifier,
    STATE(1898), 1,
      aux_sym_declEnum_repeat1,
    STATE(2064), 1,
      sym_declEnumValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66000] = 2,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
    ACTIONS(6297), 3,
      sym_kEnd,
      sym_kElse,
      sym_kOn,
  [66011] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6299), 1,
      aux_sym_type_token3,
    STATE(1872), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [66028] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6301), 1,
      anon_sym_COLON,
    STATE(2258), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66043] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6303), 1,
      aux_sym_type_token3,
    STATE(1868), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [66060] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6305), 1,
      anon_sym_SEMI,
    STATE(2114), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66075] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6307), 1,
      anon_sym_SEMI,
    STATE(2418), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66090] = 5,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6137), 1,
      aux_sym_type_token2,
    ACTIONS(6309), 1,
      aux_sym_type_token3,
    STATE(1867), 1,
      aux_sym_defProc_repeat1,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
  [66107] = 3,
    ACTIONS(6311), 1,
      anon_sym_SEMI,
    ACTIONS(6313), 2,
      anon_sym_RPAREN,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66120] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6315), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5232), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66135] = 4,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(6317), 1,
      sym_kOf,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5240), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66150] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6065), 1,
      anon_sym_SEMI,
    STATE(2094), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66165] = 3,
    ACTIONS(6319), 1,
      sym_kOn,
    STATE(1917), 2,
      sym_exceptionHandler,
      aux_sym__exceptionHandlers_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66178] = 3,
    ACTIONS(6324), 1,
      anon_sym_LPAREN,
    ACTIONS(6322), 2,
      anon_sym_COLON,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66191] = 4,
    ACTIONS(5507), 1,
      sym_kEq,
    ACTIONS(6326), 1,
      anon_sym_SEMI,
    STATE(2113), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66206] = 3,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(6330), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66218] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5248), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66230] = 3,
    ACTIONS(3494), 1,
      anon_sym_RBRACK,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66242] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5244), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66254] = 3,
    ACTIONS(6237), 1,
      anon_sym_RPAREN,
    ACTIONS(6332), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66266] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5278), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66278] = 3,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(6334), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66290] = 3,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(6336), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66302] = 3,
    ACTIONS(6237), 1,
      anon_sym_RPAREN,
    ACTIONS(6338), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66314] = 3,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(6342), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66326] = 3,
    ACTIONS(6344), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66338] = 3,
    ACTIONS(6346), 1,
      anon_sym_LBRACK,
    ACTIONS(6348), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66350] = 2,
    ACTIONS(6197), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66360] = 3,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(2161), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66372] = 3,
    ACTIONS(6350), 1,
      anon_sym_SEMI,
    ACTIONS(6352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66384] = 3,
    ACTIONS(6199), 1,
      anon_sym_COMMA,
    ACTIONS(6354), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66396] = 2,
    ACTIONS(6356), 2,
      sym_kEnd,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66406] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6358), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66418] = 3,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(2297), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66430] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6360), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66442] = 3,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(6362), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66454] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6364), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66466] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5246), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66478] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5286), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66490] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5280), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66502] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5270), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66514] = 3,
    ACTIONS(6366), 1,
      anon_sym_SEMI,
    ACTIONS(6368), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66526] = 3,
    ACTIONS(6370), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66538] = 3,
    ACTIONS(6372), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66550] = 3,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(2202), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66562] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6376), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66574] = 3,
    ACTIONS(6378), 1,
      anon_sym_SEMI,
    ACTIONS(6380), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66586] = 3,
    ACTIONS(6382), 1,
      anon_sym_SEMI,
    ACTIONS(6384), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66598] = 2,
    ACTIONS(6386), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66608] = 2,
    ACTIONS(6388), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66618] = 3,
    ACTIONS(6390), 1,
      sym_identifier,
    ACTIONS(6392), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66630] = 3,
    ACTIONS(6350), 1,
      anon_sym_SEMI,
    ACTIONS(6394), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66642] = 3,
    ACTIONS(5507), 1,
      sym_kEq,
    STATE(2316), 1,
      sym_defaultValue,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66654] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6396), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66666] = 3,
    ACTIONS(6398), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66678] = 3,
    ACTIONS(6400), 1,
      sym_identifier,
    STATE(2070), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66690] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6402), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66702] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5196), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66714] = 3,
    ACTIONS(5958), 1,
      anon_sym_RPAREN,
    ACTIONS(6404), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66726] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5264), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66738] = 2,
    ACTIONS(6406), 2,
      sym_kHat,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66748] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5254), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66760] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5252), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66772] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6408), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66784] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5262), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66796] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5260), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66808] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5266), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66820] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(6210), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [66832] = 3,
    ACTIONS(5958), 1,
      anon_sym_RPAREN,
    ACTIONS(6410), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66844] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4906), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66856] = 3,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(6414), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66868] = 2,
    ACTIONS(6416), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66878] = 2,
    ACTIONS(6418), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66888] = 3,
    ACTIONS(6420), 1,
      anon_sym_LPAREN,
    ACTIONS(6422), 1,
      sym_kFor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66900] = 3,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(6424), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66912] = 3,
    ACTIONS(6426), 1,
      sym_kEnd,
    ACTIONS(6428), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66924] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6430), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66936] = 3,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4968), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66948] = 3,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(6432), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66960] = 3,
    ACTIONS(6434), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66972] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6436), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66984] = 3,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(5002), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [66996] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6438), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67008] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6440), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67020] = 3,
    ACTIONS(6442), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67032] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67044] = 3,
    ACTIONS(6446), 1,
      sym_kEnd,
    ACTIONS(6448), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67056] = 2,
    ACTIONS(6450), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67066] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(5000), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67078] = 3,
    ACTIONS(6452), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67090] = 3,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4964), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67102] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6454), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67114] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4966), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67126] = 2,
    ACTIONS(6456), 2,
      sym_kTo,
      sym_kDownto,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67136] = 3,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(6458), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67148] = 3,
    ACTIONS(6023), 1,
      anon_sym_RPAREN,
    ACTIONS(6460), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67160] = 3,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(6462), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67172] = 3,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2229), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67184] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67196] = 3,
    ACTIONS(6464), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67208] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67220] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6468), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67232] = 3,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2108), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67244] = 3,
    ACTIONS(6470), 1,
      anon_sym_SEMI,
    ACTIONS(6472), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67256] = 3,
    ACTIONS(6474), 1,
      sym_kEnd,
    ACTIONS(6476), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67268] = 3,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2332), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67280] = 3,
    ACTIONS(6478), 1,
      anon_sym_LBRACK,
    ACTIONS(6480), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67292] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4994), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67304] = 3,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(6482), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67316] = 3,
    ACTIONS(3094), 1,
      anon_sym_DOT,
    STATE(2411), 1,
      sym_kDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67328] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5268), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67340] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4908), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67352] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5272), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67364] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5276), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67376] = 2,
    ACTIONS(6484), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67386] = 3,
    ACTIONS(6486), 1,
      sym_kEnd,
    ACTIONS(6488), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67398] = 3,
    ACTIONS(6490), 1,
      sym_kExcept,
    ACTIONS(6492), 1,
      sym_kFinally,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67410] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4976), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67422] = 3,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(6494), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67434] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(6496), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67446] = 3,
    ACTIONS(6498), 1,
      anon_sym_SEMI,
    ACTIONS(6500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67458] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6502), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67470] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(6504), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67482] = 3,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(6506), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67494] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5274), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67506] = 3,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(6508), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67518] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5258), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67530] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4958), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67542] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5250), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67554] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5256), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67566] = 3,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(4982), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67578] = 3,
    ACTIONS(6510), 1,
      anon_sym_COMMA,
    ACTIONS(6512), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67590] = 3,
    ACTIONS(6514), 1,
      sym_identifier,
    STATE(1989), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67602] = 3,
    ACTIONS(6516), 1,
      anon_sym_LBRACK,
    ACTIONS(6518), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67614] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4974), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67626] = 2,
    ACTIONS(6520), 2,
      sym_kFunction,
      sym_kProcedure,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67636] = 3,
    ACTIONS(6510), 1,
      anon_sym_COMMA,
    ACTIONS(6522), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67648] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4992), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67660] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5282), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67672] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6524), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67684] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(5284), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [67696] = 2,
    ACTIONS(6526), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67706] = 2,
    ACTIONS(6528), 2,
      sym_kTo,
      sym_kDownto,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67716] = 3,
    ACTIONS(6530), 1,
      sym_identifier,
    STATE(2048), 1,
      aux_sym_moduleName_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67728] = 3,
    ACTIONS(6533), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67740] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6535), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67752] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67764] = 3,
    ACTIONS(6472), 1,
      anon_sym_COMMA,
    ACTIONS(6539), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67776] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6541), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67788] = 2,
    ACTIONS(6543), 2,
      sym_kEnd,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67798] = 3,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(6545), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67810] = 3,
    ACTIONS(3484), 1,
      anon_sym_RBRACK,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67822] = 2,
    ACTIONS(6547), 2,
      sym_kTo,
      sym_kDownto,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67832] = 3,
    ACTIONS(6549), 1,
      sym_identifier,
    ACTIONS(6551), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67844] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6553), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67856] = 3,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(6555), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67868] = 3,
    ACTIONS(6557), 1,
      sym_kExcept,
    ACTIONS(6559), 1,
      sym_kFinally,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67880] = 3,
    ACTIONS(6561), 1,
      sym_identifier,
    ACTIONS(6563), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67892] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67904] = 3,
    ACTIONS(6510), 1,
      anon_sym_COMMA,
    ACTIONS(6567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67916] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67928] = 2,
    ACTIONS(6571), 2,
      sym_kEnd,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67938] = 3,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(6573), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67950] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6575), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67962] = 2,
    ACTIONS(6577), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67972] = 3,
    ACTIONS(6579), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67984] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6581), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [67996] = 3,
    ACTIONS(6583), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68008] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4932), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68020] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6586), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68032] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(6588), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [68044] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6590), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68056] = 3,
    ACTIONS(6378), 1,
      anon_sym_SEMI,
    ACTIONS(6592), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68068] = 3,
    ACTIONS(6594), 1,
      sym_identifier,
    STATE(1984), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68080] = 3,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(4914), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68092] = 3,
    ACTIONS(6596), 1,
      sym_identifier,
    ACTIONS(6598), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68104] = 3,
    ACTIONS(6600), 1,
      sym_identifier,
    ACTIONS(6602), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68116] = 3,
    ACTIONS(6604), 1,
      sym_identifier,
    ACTIONS(6606), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68128] = 3,
    ACTIONS(6384), 1,
      anon_sym_COMMA,
    ACTIONS(6608), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68140] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6610), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68152] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6612), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68164] = 3,
    ACTIONS(5), 1,
      sym_pp,
    ACTIONS(3), 2,
      sym__space,
      sym_comment,
    ACTIONS(6614), 2,
      aux_sym_type_token2,
      aux_sym_type_token3,
  [68176] = 3,
    ACTIONS(6616), 1,
      anon_sym_LBRACK,
    ACTIONS(6618), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68188] = 3,
    ACTIONS(6368), 1,
      anon_sym_COMMA,
    ACTIONS(6620), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68200] = 3,
    ACTIONS(6622), 1,
      sym_identifier,
    STATE(1994), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68212] = 3,
    ACTIONS(6624), 1,
      sym_identifier,
    STATE(2048), 1,
      aux_sym_moduleName_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68224] = 3,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(6626), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68236] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6628), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68248] = 3,
    ACTIONS(6630), 1,
      sym_identifier,
    STATE(2072), 1,
      aux_sym_genericArg_repeat1,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68260] = 2,
    ACTIONS(6632), 2,
      anon_sym_SEMI,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68270] = 3,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(6634), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68282] = 3,
    ACTIONS(5136), 1,
      anon_sym_DOT,
    STATE(2358), 1,
      sym_kEndDot,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68294] = 2,
    ACTIONS(6636), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68304] = 3,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(6638), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68316] = 3,
    ACTIONS(6510), 1,
      anon_sym_COMMA,
    ACTIONS(6640), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68328] = 2,
    ACTIONS(6642), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68337] = 2,
    ACTIONS(6644), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68346] = 2,
    ACTIONS(6646), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68355] = 2,
    ACTIONS(6648), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68364] = 2,
    ACTIONS(6650), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68373] = 2,
    ACTIONS(6652), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68382] = 2,
    ACTIONS(6654), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68391] = 2,
    ACTIONS(6656), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68400] = 2,
    ACTIONS(6658), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68409] = 2,
    ACTIONS(6660), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68418] = 2,
    ACTIONS(6662), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68427] = 2,
    ACTIONS(6664), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68436] = 2,
    ACTIONS(6666), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68445] = 2,
    ACTIONS(6668), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68454] = 2,
    ACTIONS(6670), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68463] = 2,
    ACTIONS(6672), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68472] = 2,
    ACTIONS(6674), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68481] = 2,
    ACTIONS(3408), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68490] = 2,
    ACTIONS(6676), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68499] = 2,
    ACTIONS(6678), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68508] = 2,
    ACTIONS(6680), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68517] = 2,
    ACTIONS(6682), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68526] = 2,
    ACTIONS(6684), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68535] = 2,
    ACTIONS(6686), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68544] = 2,
    ACTIONS(6688), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68553] = 2,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68562] = 2,
    ACTIONS(6690), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68571] = 2,
    ACTIONS(6692), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68580] = 2,
    ACTIONS(6694), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68589] = 2,
    ACTIONS(6696), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68598] = 2,
    ACTIONS(6698), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68607] = 2,
    ACTIONS(6700), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68616] = 2,
    ACTIONS(6702), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68625] = 2,
    ACTIONS(6704), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68634] = 2,
    ACTIONS(6706), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68643] = 2,
    ACTIONS(6708), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68652] = 2,
    ACTIONS(6710), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68661] = 2,
    ACTIONS(6712), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68670] = 2,
    ACTIONS(6714), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68679] = 2,
    ACTIONS(6716), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68688] = 2,
    ACTIONS(6718), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68697] = 2,
    ACTIONS(6720), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68706] = 2,
    ACTIONS(6722), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68715] = 2,
    ACTIONS(6724), 1,
      sym_kFor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68724] = 2,
    ACTIONS(6726), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68733] = 2,
    ACTIONS(6728), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68742] = 2,
    ACTIONS(6730), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68751] = 2,
    ACTIONS(6732), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68760] = 2,
    ACTIONS(6734), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68769] = 2,
    ACTIONS(6736), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68778] = 2,
    ACTIONS(6738), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68787] = 2,
    ACTIONS(6486), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68796] = 2,
    ACTIONS(6740), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68805] = 2,
    ACTIONS(6742), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68814] = 2,
    ACTIONS(2908), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68823] = 2,
    ACTIONS(6744), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68832] = 2,
    ACTIONS(6746), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68841] = 2,
    ACTIONS(6748), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68850] = 2,
    ACTIONS(6750), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68859] = 2,
    ACTIONS(6752), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68868] = 2,
    ACTIONS(6754), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68877] = 2,
    ACTIONS(6756), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68886] = 2,
    ACTIONS(6758), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68895] = 2,
    ACTIONS(6760), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68904] = 2,
    ACTIONS(6762), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68913] = 2,
    ACTIONS(6764), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68922] = 2,
    ACTIONS(6766), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68931] = 2,
    ACTIONS(6768), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68940] = 2,
    ACTIONS(6770), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68949] = 2,
    ACTIONS(6772), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68958] = 2,
    ACTIONS(6774), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68967] = 2,
    ACTIONS(6776), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68976] = 2,
    ACTIONS(6778), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68985] = 2,
    ACTIONS(6780), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [68994] = 2,
    ACTIONS(6782), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69003] = 2,
    ACTIONS(6784), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69012] = 2,
    ACTIONS(6786), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69021] = 2,
    ACTIONS(6788), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69030] = 2,
    ACTIONS(6790), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69039] = 2,
    ACTIONS(6792), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69048] = 2,
    ACTIONS(6794), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69057] = 2,
    ACTIONS(6796), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69066] = 2,
    ACTIONS(5018), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69075] = 2,
    ACTIONS(6798), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69084] = 2,
    ACTIONS(6800), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69093] = 2,
    ACTIONS(6802), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69102] = 2,
    ACTIONS(6804), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69111] = 2,
    ACTIONS(6806), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69120] = 2,
    ACTIONS(6808), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69129] = 2,
    ACTIONS(6810), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69138] = 2,
    ACTIONS(6812), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69147] = 2,
    ACTIONS(6814), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69156] = 2,
    ACTIONS(6816), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69165] = 2,
    ACTIONS(6818), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69174] = 2,
    ACTIONS(6820), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69183] = 2,
    ACTIONS(6822), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69192] = 2,
    ACTIONS(6824), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69201] = 2,
    ACTIONS(6826), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69210] = 2,
    ACTIONS(6828), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69219] = 2,
    ACTIONS(6830), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69228] = 2,
    ACTIONS(6832), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69237] = 2,
    ACTIONS(6834), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69246] = 2,
    ACTIONS(6836), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69255] = 2,
    ACTIONS(6838), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69264] = 2,
    ACTIONS(6840), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69273] = 2,
    ACTIONS(6842), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69282] = 2,
    ACTIONS(6844), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69291] = 2,
    ACTIONS(6846), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69300] = 2,
    ACTIONS(6848), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69309] = 2,
    ACTIONS(4417), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69318] = 2,
    ACTIONS(5315), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69327] = 2,
    ACTIONS(6850), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69336] = 2,
    ACTIONS(6852), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69345] = 2,
    ACTIONS(6854), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69354] = 2,
    ACTIONS(6856), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69363] = 2,
    ACTIONS(6858), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69372] = 2,
    ACTIONS(5030), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69381] = 2,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69390] = 2,
    ACTIONS(6500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69399] = 2,
    ACTIONS(6860), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69408] = 2,
    ACTIONS(6862), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69417] = 2,
    ACTIONS(6864), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69426] = 2,
    ACTIONS(6866), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69435] = 2,
    ACTIONS(6868), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69444] = 2,
    ACTIONS(6870), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69453] = 2,
    ACTIONS(6872), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69462] = 2,
    ACTIONS(6874), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69471] = 2,
    ACTIONS(6876), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69480] = 2,
    ACTIONS(6878), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69489] = 2,
    ACTIONS(6880), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69498] = 2,
    ACTIONS(6882), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69507] = 2,
    ACTIONS(6884), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69516] = 2,
    ACTIONS(6886), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69525] = 2,
    ACTIONS(6888), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69534] = 2,
    ACTIONS(6890), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69543] = 2,
    ACTIONS(5371), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69552] = 2,
    ACTIONS(6892), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69561] = 2,
    ACTIONS(5373), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69570] = 2,
    ACTIONS(6894), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69579] = 2,
    ACTIONS(6896), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69588] = 2,
    ACTIONS(6898), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69597] = 2,
    ACTIONS(6900), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69606] = 2,
    ACTIONS(6902), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69615] = 2,
    ACTIONS(6904), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69624] = 2,
    ACTIONS(6906), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69633] = 2,
    ACTIONS(6474), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69642] = 2,
    ACTIONS(6908), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69651] = 2,
    ACTIONS(6910), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69660] = 2,
    ACTIONS(5327), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69669] = 2,
    ACTIONS(6912), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69678] = 2,
    ACTIONS(3452), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69687] = 2,
    ACTIONS(6023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69696] = 2,
    ACTIONS(6914), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69705] = 2,
    ACTIONS(6916), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69714] = 2,
    ACTIONS(5475), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69723] = 2,
    ACTIONS(4876), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69732] = 2,
    ACTIONS(6918), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69741] = 2,
    ACTIONS(6920), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69750] = 2,
    ACTIONS(6922), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69759] = 2,
    ACTIONS(5377), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69768] = 2,
    ACTIONS(6924), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69777] = 2,
    ACTIONS(6926), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69786] = 2,
    ACTIONS(6928), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69795] = 2,
    ACTIONS(6930), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69804] = 2,
    ACTIONS(4904), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69813] = 2,
    ACTIONS(6932), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69822] = 2,
    ACTIONS(6934), 1,
      sym_kUntil,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69831] = 2,
    ACTIONS(5425), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69840] = 2,
    ACTIONS(6936), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69849] = 2,
    ACTIONS(6938), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69858] = 2,
    ACTIONS(6940), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69867] = 2,
    ACTIONS(5044), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69876] = 2,
    ACTIONS(6942), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69885] = 2,
    ACTIONS(4269), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69894] = 2,
    ACTIONS(6944), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69903] = 2,
    ACTIONS(6946), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69912] = 2,
    ACTIONS(6948), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69921] = 2,
    ACTIONS(6950), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69930] = 2,
    ACTIONS(6952), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69939] = 2,
    ACTIONS(6954), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69948] = 2,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69957] = 2,
    ACTIONS(5958), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69966] = 2,
    ACTIONS(6956), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69975] = 2,
    ACTIONS(6958), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69984] = 2,
    ACTIONS(4295), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [69993] = 2,
    ACTIONS(6960), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70002] = 2,
    ACTIONS(6962), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70011] = 2,
    ACTIONS(6964), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70020] = 2,
    ACTIONS(5383), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70029] = 2,
    ACTIONS(5451), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70038] = 2,
    ACTIONS(6966), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70047] = 2,
    ACTIONS(6968), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70056] = 2,
    ACTIONS(6131), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70065] = 2,
    ACTIONS(6970), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70074] = 2,
    ACTIONS(6972), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70083] = 2,
    ACTIONS(6974), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70092] = 2,
    ACTIONS(6976), 1,
      sym_kDo,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70101] = 2,
    ACTIONS(6978), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70110] = 2,
    ACTIONS(6378), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70119] = 2,
    ACTIONS(6980), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70128] = 2,
    ACTIONS(6982), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70137] = 2,
    ACTIONS(6984), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70146] = 2,
    ACTIONS(6986), 1,
      sym_kArray,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70155] = 2,
    ACTIONS(6988), 1,
      sym_kTo,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70164] = 2,
    ACTIONS(5889), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70173] = 2,
    ACTIONS(6368), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70182] = 2,
    ACTIONS(6384), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70191] = 2,
    ACTIONS(6990), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70200] = 2,
    ACTIONS(6992), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70209] = 2,
    ACTIONS(6994), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70218] = 2,
    ACTIONS(3295), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70227] = 2,
    ACTIONS(6996), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70236] = 2,
    ACTIONS(5407), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70245] = 2,
    ACTIONS(6998), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70254] = 2,
    ACTIONS(7000), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70263] = 2,
    ACTIONS(7002), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70272] = 2,
    ACTIONS(7004), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70281] = 2,
    ACTIONS(7006), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70290] = 2,
    ACTIONS(7008), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70299] = 2,
    ACTIONS(7010), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70308] = 2,
    ACTIONS(7012), 1,
      sym_kDo,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70317] = 2,
    ACTIONS(7014), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70326] = 2,
    ACTIONS(5742), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70335] = 2,
    ACTIONS(7016), 1,
      sym_kTo,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70344] = 2,
    ACTIONS(7018), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70353] = 2,
    ACTIONS(7020), 1,
      sym_kDo,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70362] = 2,
    ACTIONS(5695), 1,
      sym_kArray,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70371] = 2,
    ACTIONS(7022), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70380] = 2,
    ACTIONS(7024), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70389] = 2,
    ACTIONS(7026), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70398] = 2,
    ACTIONS(7028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70407] = 2,
    ACTIONS(7030), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70416] = 2,
    ACTIONS(7032), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70425] = 2,
    ACTIONS(7034), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70434] = 2,
    ACTIONS(7036), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70443] = 2,
    ACTIONS(7038), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70452] = 2,
    ACTIONS(7040), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70461] = 2,
    ACTIONS(7042), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70470] = 2,
    ACTIONS(7044), 1,
      sym_kElse,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70479] = 2,
    ACTIONS(5441), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70488] = 2,
    ACTIONS(5429), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70497] = 2,
    ACTIONS(5445), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70506] = 2,
    ACTIONS(7046), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70515] = 2,
    ACTIONS(5433), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70524] = 2,
    ACTIONS(7048), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70533] = 2,
    ACTIONS(7050), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70542] = 2,
    ACTIONS(5437), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70551] = 2,
    ACTIONS(7052), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70560] = 2,
    ACTIONS(7054), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70569] = 2,
    ACTIONS(5034), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70578] = 2,
    ACTIONS(7056), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70587] = 2,
    ACTIONS(7058), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70596] = 2,
    ACTIONS(5457), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70605] = 2,
    ACTIONS(7060), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70614] = 2,
    ACTIONS(7062), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70623] = 2,
    ACTIONS(7064), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70632] = 2,
    ACTIONS(7066), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70641] = 2,
    ACTIONS(7068), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70650] = 2,
    ACTIONS(7070), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70659] = 2,
    ACTIONS(6510), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70668] = 2,
    ACTIONS(7072), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70677] = 2,
    ACTIONS(7074), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70686] = 2,
    ACTIONS(7076), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70695] = 2,
    ACTIONS(7078), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70704] = 2,
    ACTIONS(7080), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70713] = 2,
    ACTIONS(7082), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70722] = 2,
    ACTIONS(5417), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70731] = 2,
    ACTIONS(7084), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70740] = 2,
    ACTIONS(5449), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70749] = 2,
    ACTIONS(7086), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70758] = 2,
    ACTIONS(7088), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70767] = 2,
    ACTIONS(6472), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70776] = 2,
    ACTIONS(7090), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70785] = 2,
    ACTIONS(7092), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70794] = 2,
    ACTIONS(7094), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70803] = 2,
    ACTIONS(7096), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70812] = 2,
    ACTIONS(7098), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70821] = 2,
    ACTIONS(7100), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70830] = 2,
    ACTIONS(7102), 1,
      sym_kUntil,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70839] = 2,
    ACTIONS(7104), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70848] = 2,
    ACTIONS(7106), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70857] = 2,
    ACTIONS(7108), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70866] = 2,
    ACTIONS(7110), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70875] = 2,
    ACTIONS(7112), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70884] = 2,
    ACTIONS(7114), 1,
      sym_kFor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70893] = 2,
    ACTIONS(7116), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70902] = 2,
    ACTIONS(7118), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70911] = 2,
    ACTIONS(7120), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70920] = 2,
    ACTIONS(7122), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70929] = 2,
    ACTIONS(7124), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70938] = 2,
    ACTIONS(7126), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70947] = 2,
    ACTIONS(7128), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70956] = 2,
    ACTIONS(7130), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70965] = 2,
    ACTIONS(7132), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70974] = 2,
    ACTIONS(5347), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70983] = 2,
    ACTIONS(6412), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [70992] = 2,
    ACTIONS(7134), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71001] = 2,
    ACTIONS(7136), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71010] = 2,
    ACTIONS(7138), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71019] = 2,
    ACTIONS(6350), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71028] = 2,
    ACTIONS(7140), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71037] = 2,
    ACTIONS(6199), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71046] = 2,
    ACTIONS(7142), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71055] = 2,
    ACTIONS(7144), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71064] = 2,
    ACTIONS(7146), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71073] = 2,
    ACTIONS(5421), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71082] = 2,
    ACTIONS(7148), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71091] = 2,
    ACTIONS(7150), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71100] = 2,
    ACTIONS(6037), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71109] = 2,
    ACTIONS(7152), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71118] = 2,
    ACTIONS(7154), 1,
      sym_kDo,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71127] = 2,
    ACTIONS(7156), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71136] = 2,
    ACTIONS(7158), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71145] = 2,
    ACTIONS(7160), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71154] = 2,
    ACTIONS(7162), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71163] = 2,
    ACTIONS(7164), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71172] = 2,
    ACTIONS(7166), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71181] = 2,
    ACTIONS(7168), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71190] = 2,
    ACTIONS(7170), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71199] = 2,
    ACTIONS(7172), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71208] = 2,
    ACTIONS(7174), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71217] = 2,
    ACTIONS(6340), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71226] = 2,
    ACTIONS(7176), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71235] = 2,
    ACTIONS(7178), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71244] = 2,
    ACTIONS(7180), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71253] = 2,
    ACTIONS(7182), 1,
      sym_kUntil,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71262] = 2,
    ACTIONS(7184), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71271] = 2,
    ACTIONS(7186), 1,
      sym_kOf,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71280] = 2,
    ACTIONS(7188), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71289] = 2,
    ACTIONS(7190), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71298] = 2,
    ACTIONS(7192), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71307] = 2,
    ACTIONS(7194), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71316] = 2,
    ACTIONS(7196), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71325] = 2,
    ACTIONS(7198), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71334] = 2,
    ACTIONS(7200), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71343] = 2,
    ACTIONS(4862), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71352] = 2,
    ACTIONS(7202), 1,
      sym_kGt,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71361] = 2,
    ACTIONS(7204), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71370] = 2,
    ACTIONS(7206), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71379] = 2,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71388] = 2,
    ACTIONS(7210), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71397] = 2,
    ACTIONS(7212), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71406] = 2,
    ACTIONS(7214), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71415] = 2,
    ACTIONS(5222), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71424] = 2,
    ACTIONS(7216), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71433] = 2,
    ACTIONS(7218), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71442] = 2,
    ACTIONS(7220), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71451] = 2,
    ACTIONS(7222), 1,
      sym_kEnd,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71460] = 2,
    ACTIONS(7224), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71469] = 2,
    ACTIONS(7226), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71478] = 2,
    ACTIONS(7228), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71487] = 2,
    ACTIONS(3028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71496] = 2,
    ACTIONS(7230), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71505] = 2,
    ACTIONS(7232), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71514] = 2,
    ACTIONS(7234), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71523] = 2,
    ACTIONS(7236), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71532] = 2,
    ACTIONS(7238), 1,
      sym_kFor,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71541] = 2,
    ACTIONS(7240), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71550] = 2,
    ACTIONS(7242), 1,
      sym_kObject,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71559] = 2,
    ACTIONS(7244), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71568] = 2,
    ACTIONS(7246), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71577] = 2,
    ACTIONS(7248), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71586] = 2,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71595] = 2,
    ACTIONS(7252), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71604] = 2,
    ACTIONS(7254), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71613] = 2,
    ACTIONS(7256), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
  [71622] = 2,
    ACTIONS(7258), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__space,
      sym_pp,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(550)] = 0,
  [SMALL_STATE(551)] = 77,
  [SMALL_STATE(552)] = 150,
  [SMALL_STATE(553)] = 223,
  [SMALL_STATE(554)] = 300,
  [SMALL_STATE(555)] = 374,
  [SMALL_STATE(556)] = 448,
  [SMALL_STATE(557)] = 522,
  [SMALL_STATE(558)] = 592,
  [SMALL_STATE(559)] = 666,
  [SMALL_STATE(560)] = 740,
  [SMALL_STATE(561)] = 814,
  [SMALL_STATE(562)] = 888,
  [SMALL_STATE(563)] = 962,
  [SMALL_STATE(564)] = 1028,
  [SMALL_STATE(565)] = 1096,
  [SMALL_STATE(566)] = 1164,
  [SMALL_STATE(567)] = 1232,
  [SMALL_STATE(568)] = 1296,
  [SMALL_STATE(569)] = 1364,
  [SMALL_STATE(570)] = 1432,
  [SMALL_STATE(571)] = 1500,
  [SMALL_STATE(572)] = 1566,
  [SMALL_STATE(573)] = 1632,
  [SMALL_STATE(574)] = 1698,
  [SMALL_STATE(575)] = 1766,
  [SMALL_STATE(576)] = 1832,
  [SMALL_STATE(577)] = 1898,
  [SMALL_STATE(578)] = 1964,
  [SMALL_STATE(579)] = 2030,
  [SMALL_STATE(580)] = 2094,
  [SMALL_STATE(581)] = 2162,
  [SMALL_STATE(582)] = 2228,
  [SMALL_STATE(583)] = 2294,
  [SMALL_STATE(584)] = 2356,
  [SMALL_STATE(585)] = 2422,
  [SMALL_STATE(586)] = 2488,
  [SMALL_STATE(587)] = 2554,
  [SMALL_STATE(588)] = 2620,
  [SMALL_STATE(589)] = 2686,
  [SMALL_STATE(590)] = 2752,
  [SMALL_STATE(591)] = 2814,
  [SMALL_STATE(592)] = 2884,
  [SMALL_STATE(593)] = 2946,
  [SMALL_STATE(594)] = 3016,
  [SMALL_STATE(595)] = 3110,
  [SMALL_STATE(596)] = 3227,
  [SMALL_STATE(597)] = 3328,
  [SMALL_STATE(598)] = 3399,
  [SMALL_STATE(599)] = 3458,
  [SMALL_STATE(600)] = 3525,
  [SMALL_STATE(601)] = 3626,
  [SMALL_STATE(602)] = 3701,
  [SMALL_STATE(603)] = 3776,
  [SMALL_STATE(604)] = 3877,
  [SMALL_STATE(605)] = 3952,
  [SMALL_STATE(606)] = 4053,
  [SMALL_STATE(607)] = 4123,
  [SMALL_STATE(608)] = 4189,
  [SMALL_STATE(609)] = 4263,
  [SMALL_STATE(610)] = 4337,
  [SMALL_STATE(611)] = 4433,
  [SMALL_STATE(612)] = 4505,
  [SMALL_STATE(613)] = 4579,
  [SMALL_STATE(614)] = 4693,
  [SMALL_STATE(615)] = 4764,
  [SMALL_STATE(616)] = 4835,
  [SMALL_STATE(617)] = 4946,
  [SMALL_STATE(618)] = 5041,
  [SMALL_STATE(619)] = 5152,
  [SMALL_STATE(620)] = 5223,
  [SMALL_STATE(621)] = 5317,
  [SMALL_STATE(622)] = 5385,
  [SMALL_STATE(623)] = 5453,
  [SMALL_STATE(624)] = 5521,
  [SMALL_STATE(625)] = 5613,
  [SMALL_STATE(626)] = 5707,
  [SMALL_STATE(627)] = 5799,
  [SMALL_STATE(628)] = 5893,
  [SMALL_STATE(629)] = 5987,
  [SMALL_STATE(630)] = 6055,
  [SMALL_STATE(631)] = 6149,
  [SMALL_STATE(632)] = 6238,
  [SMALL_STATE(633)] = 6297,
  [SMALL_STATE(634)] = 6404,
  [SMALL_STATE(635)] = 6511,
  [SMALL_STATE(636)] = 6598,
  [SMALL_STATE(637)] = 6705,
  [SMALL_STATE(638)] = 6764,
  [SMALL_STATE(639)] = 6871,
  [SMALL_STATE(640)] = 6930,
  [SMALL_STATE(641)] = 6989,
  [SMALL_STATE(642)] = 7048,
  [SMALL_STATE(643)] = 7107,
  [SMALL_STATE(644)] = 7166,
  [SMALL_STATE(645)] = 7221,
  [SMALL_STATE(646)] = 7280,
  [SMALL_STATE(647)] = 7335,
  [SMALL_STATE(648)] = 7422,
  [SMALL_STATE(649)] = 7475,
  [SMALL_STATE(650)] = 7564,
  [SMALL_STATE(651)] = 7620,
  [SMALL_STATE(652)] = 7708,
  [SMALL_STATE(653)] = 7796,
  [SMALL_STATE(654)] = 7854,
  [SMALL_STATE(655)] = 7942,
  [SMALL_STATE(656)] = 8046,
  [SMALL_STATE(657)] = 8130,
  [SMALL_STATE(658)] = 8214,
  [SMALL_STATE(659)] = 8318,
  [SMALL_STATE(660)] = 8406,
  [SMALL_STATE(661)] = 8494,
  [SMALL_STATE(662)] = 8582,
  [SMALL_STATE(663)] = 8666,
  [SMALL_STATE(664)] = 8724,
  [SMALL_STATE(665)] = 8782,
  [SMALL_STATE(666)] = 8886,
  [SMALL_STATE(667)] = 8944,
  [SMALL_STATE(668)] = 9048,
  [SMALL_STATE(669)] = 9106,
  [SMALL_STATE(670)] = 9194,
  [SMALL_STATE(671)] = 9282,
  [SMALL_STATE(672)] = 9336,
  [SMALL_STATE(673)] = 9440,
  [SMALL_STATE(674)] = 9498,
  [SMALL_STATE(675)] = 9552,
  [SMALL_STATE(676)] = 9640,
  [SMALL_STATE(677)] = 9744,
  [SMALL_STATE(678)] = 9832,
  [SMALL_STATE(679)] = 9920,
  [SMALL_STATE(680)] = 10024,
  [SMALL_STATE(681)] = 10112,
  [SMALL_STATE(682)] = 10168,
  [SMALL_STATE(683)] = 10256,
  [SMALL_STATE(684)] = 10340,
  [SMALL_STATE(685)] = 10428,
  [SMALL_STATE(686)] = 10516,
  [SMALL_STATE(687)] = 10574,
  [SMALL_STATE(688)] = 10638,
  [SMALL_STATE(689)] = 10726,
  [SMALL_STATE(690)] = 10790,
  [SMALL_STATE(691)] = 10848,
  [SMALL_STATE(692)] = 10900,
  [SMALL_STATE(693)] = 11004,
  [SMALL_STATE(694)] = 11092,
  [SMALL_STATE(695)] = 11177,
  [SMALL_STATE(696)] = 11278,
  [SMALL_STATE(697)] = 11363,
  [SMALL_STATE(698)] = 11448,
  [SMALL_STATE(699)] = 11549,
  [SMALL_STATE(700)] = 11650,
  [SMALL_STATE(701)] = 11751,
  [SMALL_STATE(702)] = 11852,
  [SMALL_STATE(703)] = 11953,
  [SMALL_STATE(704)] = 12040,
  [SMALL_STATE(705)] = 12125,
  [SMALL_STATE(706)] = 12210,
  [SMALL_STATE(707)] = 12297,
  [SMALL_STATE(708)] = 12398,
  [SMALL_STATE(709)] = 12483,
  [SMALL_STATE(710)] = 12584,
  [SMALL_STATE(711)] = 12685,
  [SMALL_STATE(712)] = 12770,
  [SMALL_STATE(713)] = 12871,
  [SMALL_STATE(714)] = 12972,
  [SMALL_STATE(715)] = 13073,
  [SMALL_STATE(716)] = 13174,
  [SMALL_STATE(717)] = 13275,
  [SMALL_STATE(718)] = 13360,
  [SMALL_STATE(719)] = 13461,
  [SMALL_STATE(720)] = 13562,
  [SMALL_STATE(721)] = 13647,
  [SMALL_STATE(722)] = 13732,
  [SMALL_STATE(723)] = 13801,
  [SMALL_STATE(724)] = 13862,
  [SMALL_STATE(725)] = 13947,
  [SMALL_STATE(726)] = 14032,
  [SMALL_STATE(727)] = 14133,
  [SMALL_STATE(728)] = 14234,
  [SMALL_STATE(729)] = 14319,
  [SMALL_STATE(730)] = 14404,
  [SMALL_STATE(731)] = 14505,
  [SMALL_STATE(732)] = 14606,
  [SMALL_STATE(733)] = 14671,
  [SMALL_STATE(734)] = 14772,
  [SMALL_STATE(735)] = 14873,
  [SMALL_STATE(736)] = 14958,
  [SMALL_STATE(737)] = 15043,
  [SMALL_STATE(738)] = 15128,
  [SMALL_STATE(739)] = 15229,
  [SMALL_STATE(740)] = 15314,
  [SMALL_STATE(741)] = 15372,
  [SMALL_STATE(742)] = 15454,
  [SMALL_STATE(743)] = 15536,
  [SMALL_STATE(744)] = 15588,
  [SMALL_STATE(745)] = 15640,
  [SMALL_STATE(746)] = 15722,
  [SMALL_STATE(747)] = 15820,
  [SMALL_STATE(748)] = 15872,
  [SMALL_STATE(749)] = 15970,
  [SMALL_STATE(750)] = 16022,
  [SMALL_STATE(751)] = 16104,
  [SMALL_STATE(752)] = 16156,
  [SMALL_STATE(753)] = 16208,
  [SMALL_STATE(754)] = 16260,
  [SMALL_STATE(755)] = 16312,
  [SMALL_STATE(756)] = 16410,
  [SMALL_STATE(757)] = 16462,
  [SMALL_STATE(758)] = 16514,
  [SMALL_STATE(759)] = 16596,
  [SMALL_STATE(760)] = 16678,
  [SMALL_STATE(761)] = 16730,
  [SMALL_STATE(762)] = 16812,
  [SMALL_STATE(763)] = 16894,
  [SMALL_STATE(764)] = 16976,
  [SMALL_STATE(765)] = 17058,
  [SMALL_STATE(766)] = 17140,
  [SMALL_STATE(767)] = 17192,
  [SMALL_STATE(768)] = 17274,
  [SMALL_STATE(769)] = 17326,
  [SMALL_STATE(770)] = 17378,
  [SMALL_STATE(771)] = 17430,
  [SMALL_STATE(772)] = 17482,
  [SMALL_STATE(773)] = 17564,
  [SMALL_STATE(774)] = 17646,
  [SMALL_STATE(775)] = 17728,
  [SMALL_STATE(776)] = 17810,
  [SMALL_STATE(777)] = 17892,
  [SMALL_STATE(778)] = 17990,
  [SMALL_STATE(779)] = 18042,
  [SMALL_STATE(780)] = 18094,
  [SMALL_STATE(781)] = 18176,
  [SMALL_STATE(782)] = 18258,
  [SMALL_STATE(783)] = 18340,
  [SMALL_STATE(784)] = 18398,
  [SMALL_STATE(785)] = 18480,
  [SMALL_STATE(786)] = 18562,
  [SMALL_STATE(787)] = 18614,
  [SMALL_STATE(788)] = 18666,
  [SMALL_STATE(789)] = 18718,
  [SMALL_STATE(790)] = 18800,
  [SMALL_STATE(791)] = 18882,
  [SMALL_STATE(792)] = 18934,
  [SMALL_STATE(793)] = 19016,
  [SMALL_STATE(794)] = 19068,
  [SMALL_STATE(795)] = 19120,
  [SMALL_STATE(796)] = 19172,
  [SMALL_STATE(797)] = 19254,
  [SMALL_STATE(798)] = 19306,
  [SMALL_STATE(799)] = 19358,
  [SMALL_STATE(800)] = 19440,
  [SMALL_STATE(801)] = 19522,
  [SMALL_STATE(802)] = 19574,
  [SMALL_STATE(803)] = 19626,
  [SMALL_STATE(804)] = 19678,
  [SMALL_STATE(805)] = 19730,
  [SMALL_STATE(806)] = 19782,
  [SMALL_STATE(807)] = 19864,
  [SMALL_STATE(808)] = 19946,
  [SMALL_STATE(809)] = 19998,
  [SMALL_STATE(810)] = 20077,
  [SMALL_STATE(811)] = 20156,
  [SMALL_STATE(812)] = 20235,
  [SMALL_STATE(813)] = 20314,
  [SMALL_STATE(814)] = 20393,
  [SMALL_STATE(815)] = 20472,
  [SMALL_STATE(816)] = 20551,
  [SMALL_STATE(817)] = 20630,
  [SMALL_STATE(818)] = 20709,
  [SMALL_STATE(819)] = 20788,
  [SMALL_STATE(820)] = 20867,
  [SMALL_STATE(821)] = 20946,
  [SMALL_STATE(822)] = 21025,
  [SMALL_STATE(823)] = 21104,
  [SMALL_STATE(824)] = 21183,
  [SMALL_STATE(825)] = 21262,
  [SMALL_STATE(826)] = 21341,
  [SMALL_STATE(827)] = 21420,
  [SMALL_STATE(828)] = 21499,
  [SMALL_STATE(829)] = 21578,
  [SMALL_STATE(830)] = 21657,
  [SMALL_STATE(831)] = 21736,
  [SMALL_STATE(832)] = 21815,
  [SMALL_STATE(833)] = 21894,
  [SMALL_STATE(834)] = 21973,
  [SMALL_STATE(835)] = 22052,
  [SMALL_STATE(836)] = 22131,
  [SMALL_STATE(837)] = 22210,
  [SMALL_STATE(838)] = 22289,
  [SMALL_STATE(839)] = 22368,
  [SMALL_STATE(840)] = 22447,
  [SMALL_STATE(841)] = 22526,
  [SMALL_STATE(842)] = 22605,
  [SMALL_STATE(843)] = 22684,
  [SMALL_STATE(844)] = 22763,
  [SMALL_STATE(845)] = 22842,
  [SMALL_STATE(846)] = 22921,
  [SMALL_STATE(847)] = 23000,
  [SMALL_STATE(848)] = 23079,
  [SMALL_STATE(849)] = 23158,
  [SMALL_STATE(850)] = 23237,
  [SMALL_STATE(851)] = 23316,
  [SMALL_STATE(852)] = 23395,
  [SMALL_STATE(853)] = 23474,
  [SMALL_STATE(854)] = 23553,
  [SMALL_STATE(855)] = 23648,
  [SMALL_STATE(856)] = 23727,
  [SMALL_STATE(857)] = 23806,
  [SMALL_STATE(858)] = 23885,
  [SMALL_STATE(859)] = 23964,
  [SMALL_STATE(860)] = 24043,
  [SMALL_STATE(861)] = 24122,
  [SMALL_STATE(862)] = 24201,
  [SMALL_STATE(863)] = 24280,
  [SMALL_STATE(864)] = 24359,
  [SMALL_STATE(865)] = 24438,
  [SMALL_STATE(866)] = 24517,
  [SMALL_STATE(867)] = 24596,
  [SMALL_STATE(868)] = 24675,
  [SMALL_STATE(869)] = 24754,
  [SMALL_STATE(870)] = 24833,
  [SMALL_STATE(871)] = 24912,
  [SMALL_STATE(872)] = 24991,
  [SMALL_STATE(873)] = 25070,
  [SMALL_STATE(874)] = 25149,
  [SMALL_STATE(875)] = 25228,
  [SMALL_STATE(876)] = 25307,
  [SMALL_STATE(877)] = 25386,
  [SMALL_STATE(878)] = 25465,
  [SMALL_STATE(879)] = 25544,
  [SMALL_STATE(880)] = 25623,
  [SMALL_STATE(881)] = 25702,
  [SMALL_STATE(882)] = 25781,
  [SMALL_STATE(883)] = 25860,
  [SMALL_STATE(884)] = 25939,
  [SMALL_STATE(885)] = 26018,
  [SMALL_STATE(886)] = 26097,
  [SMALL_STATE(887)] = 26176,
  [SMALL_STATE(888)] = 26255,
  [SMALL_STATE(889)] = 26334,
  [SMALL_STATE(890)] = 26413,
  [SMALL_STATE(891)] = 26492,
  [SMALL_STATE(892)] = 26571,
  [SMALL_STATE(893)] = 26650,
  [SMALL_STATE(894)] = 26729,
  [SMALL_STATE(895)] = 26808,
  [SMALL_STATE(896)] = 26887,
  [SMALL_STATE(897)] = 26966,
  [SMALL_STATE(898)] = 27045,
  [SMALL_STATE(899)] = 27124,
  [SMALL_STATE(900)] = 27203,
  [SMALL_STATE(901)] = 27282,
  [SMALL_STATE(902)] = 27361,
  [SMALL_STATE(903)] = 27440,
  [SMALL_STATE(904)] = 27519,
  [SMALL_STATE(905)] = 27598,
  [SMALL_STATE(906)] = 27677,
  [SMALL_STATE(907)] = 27756,
  [SMALL_STATE(908)] = 27812,
  [SMALL_STATE(909)] = 27868,
  [SMALL_STATE(910)] = 27934,
  [SMALL_STATE(911)] = 27992,
  [SMALL_STATE(912)] = 28044,
  [SMALL_STATE(913)] = 28106,
  [SMALL_STATE(914)] = 28158,
  [SMALL_STATE(915)] = 28207,
  [SMALL_STATE(916)] = 28301,
  [SMALL_STATE(917)] = 28385,
  [SMALL_STATE(918)] = 28435,
  [SMALL_STATE(919)] = 28485,
  [SMALL_STATE(920)] = 28569,
  [SMALL_STATE(921)] = 28663,
  [SMALL_STATE(922)] = 28757,
  [SMALL_STATE(923)] = 28807,
  [SMALL_STATE(924)] = 28865,
  [SMALL_STATE(925)] = 28915,
  [SMALL_STATE(926)] = 29009,
  [SMALL_STATE(927)] = 29103,
  [SMALL_STATE(928)] = 29187,
  [SMALL_STATE(929)] = 29281,
  [SMALL_STATE(930)] = 29331,
  [SMALL_STATE(931)] = 29390,
  [SMALL_STATE(932)] = 29437,
  [SMALL_STATE(933)] = 29486,
  [SMALL_STATE(934)] = 29535,
  [SMALL_STATE(935)] = 29590,
  [SMALL_STATE(936)] = 29675,
  [SMALL_STATE(937)] = 29722,
  [SMALL_STATE(938)] = 29769,
  [SMALL_STATE(939)] = 29816,
  [SMALL_STATE(940)] = 29863,
  [SMALL_STATE(941)] = 29910,
  [SMALL_STATE(942)] = 29995,
  [SMALL_STATE(943)] = 30080,
  [SMALL_STATE(944)] = 30143,
  [SMALL_STATE(945)] = 30190,
  [SMALL_STATE(946)] = 30237,
  [SMALL_STATE(947)] = 30284,
  [SMALL_STATE(948)] = 30331,
  [SMALL_STATE(949)] = 30416,
  [SMALL_STATE(950)] = 30463,
  [SMALL_STATE(951)] = 30510,
  [SMALL_STATE(952)] = 30557,
  [SMALL_STATE(953)] = 30604,
  [SMALL_STATE(954)] = 30651,
  [SMALL_STATE(955)] = 30698,
  [SMALL_STATE(956)] = 30745,
  [SMALL_STATE(957)] = 30792,
  [SMALL_STATE(958)] = 30871,
  [SMALL_STATE(959)] = 30918,
  [SMALL_STATE(960)] = 31005,
  [SMALL_STATE(961)] = 31052,
  [SMALL_STATE(962)] = 31099,
  [SMALL_STATE(963)] = 31146,
  [SMALL_STATE(964)] = 31193,
  [SMALL_STATE(965)] = 31272,
  [SMALL_STATE(966)] = 31359,
  [SMALL_STATE(967)] = 31438,
  [SMALL_STATE(968)] = 31517,
  [SMALL_STATE(969)] = 31602,
  [SMALL_STATE(970)] = 31687,
  [SMALL_STATE(971)] = 31767,
  [SMALL_STATE(972)] = 31855,
  [SMALL_STATE(973)] = 31911,
  [SMALL_STATE(974)] = 31991,
  [SMALL_STATE(975)] = 32039,
  [SMALL_STATE(976)] = 32087,
  [SMALL_STATE(977)] = 32177,
  [SMALL_STATE(978)] = 32265,
  [SMALL_STATE(979)] = 32353,
  [SMALL_STATE(980)] = 32401,
  [SMALL_STATE(981)] = 32489,
  [SMALL_STATE(982)] = 32537,
  [SMALL_STATE(983)] = 32625,
  [SMALL_STATE(984)] = 32707,
  [SMALL_STATE(985)] = 32787,
  [SMALL_STATE(986)] = 32875,
  [SMALL_STATE(987)] = 32920,
  [SMALL_STATE(988)] = 32965,
  [SMALL_STATE(989)] = 33010,
  [SMALL_STATE(990)] = 33055,
  [SMALL_STATE(991)] = 33140,
  [SMALL_STATE(992)] = 33225,
  [SMALL_STATE(993)] = 33310,
  [SMALL_STATE(994)] = 33355,
  [SMALL_STATE(995)] = 33400,
  [SMALL_STATE(996)] = 33445,
  [SMALL_STATE(997)] = 33530,
  [SMALL_STATE(998)] = 33575,
  [SMALL_STATE(999)] = 33620,
  [SMALL_STATE(1000)] = 33705,
  [SMALL_STATE(1001)] = 33790,
  [SMALL_STATE(1002)] = 33849,
  [SMALL_STATE(1003)] = 33894,
  [SMALL_STATE(1004)] = 33941,
  [SMALL_STATE(1005)] = 33988,
  [SMALL_STATE(1006)] = 34041,
  [SMALL_STATE(1007)] = 34096,
  [SMALL_STATE(1008)] = 34141,
  [SMALL_STATE(1009)] = 34186,
  [SMALL_STATE(1010)] = 34231,
  [SMALL_STATE(1011)] = 34316,
  [SMALL_STATE(1012)] = 34361,
  [SMALL_STATE(1013)] = 34406,
  [SMALL_STATE(1014)] = 34491,
  [SMALL_STATE(1015)] = 34576,
  [SMALL_STATE(1016)] = 34661,
  [SMALL_STATE(1017)] = 34746,
  [SMALL_STATE(1018)] = 34831,
  [SMALL_STATE(1019)] = 34876,
  [SMALL_STATE(1020)] = 34961,
  [SMALL_STATE(1021)] = 35046,
  [SMALL_STATE(1022)] = 35131,
  [SMALL_STATE(1023)] = 35216,
  [SMALL_STATE(1024)] = 35301,
  [SMALL_STATE(1025)] = 35346,
  [SMALL_STATE(1026)] = 35431,
  [SMALL_STATE(1027)] = 35476,
  [SMALL_STATE(1028)] = 35521,
  [SMALL_STATE(1029)] = 35566,
  [SMALL_STATE(1030)] = 35613,
  [SMALL_STATE(1031)] = 35698,
  [SMALL_STATE(1032)] = 35783,
  [SMALL_STATE(1033)] = 35828,
  [SMALL_STATE(1034)] = 35873,
  [SMALL_STATE(1035)] = 35958,
  [SMALL_STATE(1036)] = 36043,
  [SMALL_STATE(1037)] = 36128,
  [SMALL_STATE(1038)] = 36213,
  [SMALL_STATE(1039)] = 36298,
  [SMALL_STATE(1040)] = 36383,
  [SMALL_STATE(1041)] = 36468,
  [SMALL_STATE(1042)] = 36553,
  [SMALL_STATE(1043)] = 36638,
  [SMALL_STATE(1044)] = 36723,
  [SMALL_STATE(1045)] = 36808,
  [SMALL_STATE(1046)] = 36855,
  [SMALL_STATE(1047)] = 36940,
  [SMALL_STATE(1048)] = 37025,
  [SMALL_STATE(1049)] = 37110,
  [SMALL_STATE(1050)] = 37195,
  [SMALL_STATE(1051)] = 37280,
  [SMALL_STATE(1052)] = 37365,
  [SMALL_STATE(1053)] = 37450,
  [SMALL_STATE(1054)] = 37535,
  [SMALL_STATE(1055)] = 37620,
  [SMALL_STATE(1056)] = 37705,
  [SMALL_STATE(1057)] = 37787,
  [SMALL_STATE(1058)] = 37831,
  [SMALL_STATE(1059)] = 37875,
  [SMALL_STATE(1060)] = 37957,
  [SMALL_STATE(1061)] = 38037,
  [SMALL_STATE(1062)] = 38080,
  [SMALL_STATE(1063)] = 38151,
  [SMALL_STATE(1064)] = 38196,
  [SMALL_STATE(1065)] = 38267,
  [SMALL_STATE(1066)] = 38346,
  [SMALL_STATE(1067)] = 38389,
  [SMALL_STATE(1068)] = 38432,
  [SMALL_STATE(1069)] = 38493,
  [SMALL_STATE(1070)] = 38542,
  [SMALL_STATE(1071)] = 38591,
  [SMALL_STATE(1072)] = 38636,
  [SMALL_STATE(1073)] = 38707,
  [SMALL_STATE(1074)] = 38778,
  [SMALL_STATE(1075)] = 38835,
  [SMALL_STATE(1076)] = 38892,
  [SMALL_STATE(1077)] = 38971,
  [SMALL_STATE(1078)] = 39028,
  [SMALL_STATE(1079)] = 39076,
  [SMALL_STATE(1080)] = 39118,
  [SMALL_STATE(1081)] = 39178,
  [SMALL_STATE(1082)] = 39226,
  [SMALL_STATE(1083)] = 39279,
  [SMALL_STATE(1084)] = 39332,
  [SMALL_STATE(1085)] = 39385,
  [SMALL_STATE(1086)] = 39438,
  [SMALL_STATE(1087)] = 39491,
  [SMALL_STATE(1088)] = 39544,
  [SMALL_STATE(1089)] = 39597,
  [SMALL_STATE(1090)] = 39650,
  [SMALL_STATE(1091)] = 39690,
  [SMALL_STATE(1092)] = 39730,
  [SMALL_STATE(1093)] = 39780,
  [SMALL_STATE(1094)] = 39834,
  [SMALL_STATE(1095)] = 39884,
  [SMALL_STATE(1096)] = 39934,
  [SMALL_STATE(1097)] = 39984,
  [SMALL_STATE(1098)] = 40038,
  [SMALL_STATE(1099)] = 40088,
  [SMALL_STATE(1100)] = 40128,
  [SMALL_STATE(1101)] = 40168,
  [SMALL_STATE(1102)] = 40217,
  [SMALL_STATE(1103)] = 40266,
  [SMALL_STATE(1104)] = 40317,
  [SMALL_STATE(1105)] = 40366,
  [SMALL_STATE(1106)] = 40415,
  [SMALL_STATE(1107)] = 40456,
  [SMALL_STATE(1108)] = 40497,
  [SMALL_STATE(1109)] = 40546,
  [SMALL_STATE(1110)] = 40585,
  [SMALL_STATE(1111)] = 40634,
  [SMALL_STATE(1112)] = 40683,
  [SMALL_STATE(1113)] = 40724,
  [SMALL_STATE(1114)] = 40773,
  [SMALL_STATE(1115)] = 40822,
  [SMALL_STATE(1116)] = 40871,
  [SMALL_STATE(1117)] = 40920,
  [SMALL_STATE(1118)] = 40971,
  [SMALL_STATE(1119)] = 41020,
  [SMALL_STATE(1120)] = 41069,
  [SMALL_STATE(1121)] = 41120,
  [SMALL_STATE(1122)] = 41190,
  [SMALL_STATE(1123)] = 41228,
  [SMALL_STATE(1124)] = 41266,
  [SMALL_STATE(1125)] = 41304,
  [SMALL_STATE(1126)] = 41342,
  [SMALL_STATE(1127)] = 41412,
  [SMALL_STATE(1128)] = 41458,
  [SMALL_STATE(1129)] = 41504,
  [SMALL_STATE(1130)] = 41550,
  [SMALL_STATE(1131)] = 41588,
  [SMALL_STATE(1132)] = 41626,
  [SMALL_STATE(1133)] = 41672,
  [SMALL_STATE(1134)] = 41712,
  [SMALL_STATE(1135)] = 41760,
  [SMALL_STATE(1136)] = 41812,
  [SMALL_STATE(1137)] = 41852,
  [SMALL_STATE(1138)] = 41890,
  [SMALL_STATE(1139)] = 41936,
  [SMALL_STATE(1140)] = 41976,
  [SMALL_STATE(1141)] = 42014,
  [SMALL_STATE(1142)] = 42084,
  [SMALL_STATE(1143)] = 42122,
  [SMALL_STATE(1144)] = 42192,
  [SMALL_STATE(1145)] = 42230,
  [SMALL_STATE(1146)] = 42268,
  [SMALL_STATE(1147)] = 42316,
  [SMALL_STATE(1148)] = 42362,
  [SMALL_STATE(1149)] = 42402,
  [SMALL_STATE(1150)] = 42442,
  [SMALL_STATE(1151)] = 42482,
  [SMALL_STATE(1152)] = 42520,
  [SMALL_STATE(1153)] = 42572,
  [SMALL_STATE(1154)] = 42624,
  [SMALL_STATE(1155)] = 42694,
  [SMALL_STATE(1156)] = 42732,
  [SMALL_STATE(1157)] = 42770,
  [SMALL_STATE(1158)] = 42808,
  [SMALL_STATE(1159)] = 42846,
  [SMALL_STATE(1160)] = 42884,
  [SMALL_STATE(1161)] = 42922,
  [SMALL_STATE(1162)] = 42974,
  [SMALL_STATE(1163)] = 43012,
  [SMALL_STATE(1164)] = 43050,
  [SMALL_STATE(1165)] = 43120,
  [SMALL_STATE(1166)] = 43158,
  [SMALL_STATE(1167)] = 43208,
  [SMALL_STATE(1168)] = 43259,
  [SMALL_STATE(1169)] = 43326,
  [SMALL_STATE(1170)] = 43393,
  [SMALL_STATE(1171)] = 43460,
  [SMALL_STATE(1172)] = 43527,
  [SMALL_STATE(1173)] = 43594,
  [SMALL_STATE(1174)] = 43661,
  [SMALL_STATE(1175)] = 43712,
  [SMALL_STATE(1176)] = 43779,
  [SMALL_STATE(1177)] = 43846,
  [SMALL_STATE(1178)] = 43913,
  [SMALL_STATE(1179)] = 43960,
  [SMALL_STATE(1180)] = 44027,
  [SMALL_STATE(1181)] = 44094,
  [SMALL_STATE(1182)] = 44161,
  [SMALL_STATE(1183)] = 44200,
  [SMALL_STATE(1184)] = 44267,
  [SMALL_STATE(1185)] = 44304,
  [SMALL_STATE(1186)] = 44371,
  [SMALL_STATE(1187)] = 44438,
  [SMALL_STATE(1188)] = 44505,
  [SMALL_STATE(1189)] = 44556,
  [SMALL_STATE(1190)] = 44623,
  [SMALL_STATE(1191)] = 44690,
  [SMALL_STATE(1192)] = 44757,
  [SMALL_STATE(1193)] = 44824,
  [SMALL_STATE(1194)] = 44891,
  [SMALL_STATE(1195)] = 44958,
  [SMALL_STATE(1196)] = 44995,
  [SMALL_STATE(1197)] = 45046,
  [SMALL_STATE(1198)] = 45103,
  [SMALL_STATE(1199)] = 45154,
  [SMALL_STATE(1200)] = 45221,
  [SMALL_STATE(1201)] = 45272,
  [SMALL_STATE(1202)] = 45339,
  [SMALL_STATE(1203)] = 45406,
  [SMALL_STATE(1204)] = 45473,
  [SMALL_STATE(1205)] = 45540,
  [SMALL_STATE(1206)] = 45607,
  [SMALL_STATE(1207)] = 45674,
  [SMALL_STATE(1208)] = 45741,
  [SMALL_STATE(1209)] = 45808,
  [SMALL_STATE(1210)] = 45859,
  [SMALL_STATE(1211)] = 45926,
  [SMALL_STATE(1212)] = 45983,
  [SMALL_STATE(1213)] = 46050,
  [SMALL_STATE(1214)] = 46117,
  [SMALL_STATE(1215)] = 46184,
  [SMALL_STATE(1216)] = 46251,
  [SMALL_STATE(1217)] = 46288,
  [SMALL_STATE(1218)] = 46325,
  [SMALL_STATE(1219)] = 46392,
  [SMALL_STATE(1220)] = 46459,
  [SMALL_STATE(1221)] = 46510,
  [SMALL_STATE(1222)] = 46577,
  [SMALL_STATE(1223)] = 46644,
  [SMALL_STATE(1224)] = 46695,
  [SMALL_STATE(1225)] = 46746,
  [SMALL_STATE(1226)] = 46813,
  [SMALL_STATE(1227)] = 46880,
  [SMALL_STATE(1228)] = 46947,
  [SMALL_STATE(1229)] = 47014,
  [SMALL_STATE(1230)] = 47081,
  [SMALL_STATE(1231)] = 47148,
  [SMALL_STATE(1232)] = 47215,
  [SMALL_STATE(1233)] = 47282,
  [SMALL_STATE(1234)] = 47349,
  [SMALL_STATE(1235)] = 47398,
  [SMALL_STATE(1236)] = 47465,
  [SMALL_STATE(1237)] = 47532,
  [SMALL_STATE(1238)] = 47599,
  [SMALL_STATE(1239)] = 47636,
  [SMALL_STATE(1240)] = 47687,
  [SMALL_STATE(1241)] = 47724,
  [SMALL_STATE(1242)] = 47791,
  [SMALL_STATE(1243)] = 47828,
  [SMALL_STATE(1244)] = 47895,
  [SMALL_STATE(1245)] = 47932,
  [SMALL_STATE(1246)] = 47969,
  [SMALL_STATE(1247)] = 48036,
  [SMALL_STATE(1248)] = 48089,
  [SMALL_STATE(1249)] = 48126,
  [SMALL_STATE(1250)] = 48193,
  [SMALL_STATE(1251)] = 48230,
  [SMALL_STATE(1252)] = 48297,
  [SMALL_STATE(1253)] = 48334,
  [SMALL_STATE(1254)] = 48371,
  [SMALL_STATE(1255)] = 48438,
  [SMALL_STATE(1256)] = 48505,
  [SMALL_STATE(1257)] = 48572,
  [SMALL_STATE(1258)] = 48639,
  [SMALL_STATE(1259)] = 48676,
  [SMALL_STATE(1260)] = 48743,
  [SMALL_STATE(1261)] = 48810,
  [SMALL_STATE(1262)] = 48847,
  [SMALL_STATE(1263)] = 48884,
  [SMALL_STATE(1264)] = 48921,
  [SMALL_STATE(1265)] = 48988,
  [SMALL_STATE(1266)] = 49055,
  [SMALL_STATE(1267)] = 49122,
  [SMALL_STATE(1268)] = 49159,
  [SMALL_STATE(1269)] = 49226,
  [SMALL_STATE(1270)] = 49263,
  [SMALL_STATE(1271)] = 49330,
  [SMALL_STATE(1272)] = 49367,
  [SMALL_STATE(1273)] = 49434,
  [SMALL_STATE(1274)] = 49481,
  [SMALL_STATE(1275)] = 49526,
  [SMALL_STATE(1276)] = 49565,
  [SMALL_STATE(1277)] = 49632,
  [SMALL_STATE(1278)] = 49671,
  [SMALL_STATE(1279)] = 49708,
  [SMALL_STATE(1280)] = 49759,
  [SMALL_STATE(1281)] = 49826,
  [SMALL_STATE(1282)] = 49893,
  [SMALL_STATE(1283)] = 49930,
  [SMALL_STATE(1284)] = 49997,
  [SMALL_STATE(1285)] = 50064,
  [SMALL_STATE(1286)] = 50112,
  [SMALL_STATE(1287)] = 50164,
  [SMALL_STATE(1288)] = 50212,
  [SMALL_STATE(1289)] = 50260,
  [SMALL_STATE(1290)] = 50308,
  [SMALL_STATE(1291)] = 50356,
  [SMALL_STATE(1292)] = 50408,
  [SMALL_STATE(1293)] = 50460,
  [SMALL_STATE(1294)] = 50508,
  [SMALL_STATE(1295)] = 50556,
  [SMALL_STATE(1296)] = 50604,
  [SMALL_STATE(1297)] = 50652,
  [SMALL_STATE(1298)] = 50705,
  [SMALL_STATE(1299)] = 50740,
  [SMALL_STATE(1300)] = 50799,
  [SMALL_STATE(1301)] = 50834,
  [SMALL_STATE(1302)] = 50869,
  [SMALL_STATE(1303)] = 50904,
  [SMALL_STATE(1304)] = 50939,
  [SMALL_STATE(1305)] = 50986,
  [SMALL_STATE(1306)] = 51027,
  [SMALL_STATE(1307)] = 51062,
  [SMALL_STATE(1308)] = 51097,
  [SMALL_STATE(1309)] = 51156,
  [SMALL_STATE(1310)] = 51203,
  [SMALL_STATE(1311)] = 51254,
  [SMALL_STATE(1312)] = 51289,
  [SMALL_STATE(1313)] = 51348,
  [SMALL_STATE(1314)] = 51383,
  [SMALL_STATE(1315)] = 51434,
  [SMALL_STATE(1316)] = 51481,
  [SMALL_STATE(1317)] = 51515,
  [SMALL_STATE(1318)] = 51565,
  [SMALL_STATE(1319)] = 51599,
  [SMALL_STATE(1320)] = 51633,
  [SMALL_STATE(1321)] = 51683,
  [SMALL_STATE(1322)] = 51733,
  [SMALL_STATE(1323)] = 51767,
  [SMALL_STATE(1324)] = 51817,
  [SMALL_STATE(1325)] = 51851,
  [SMALL_STATE(1326)] = 51885,
  [SMALL_STATE(1327)] = 51919,
  [SMALL_STATE(1328)] = 51965,
  [SMALL_STATE(1329)] = 52011,
  [SMALL_STATE(1330)] = 52061,
  [SMALL_STATE(1331)] = 52111,
  [SMALL_STATE(1332)] = 52145,
  [SMALL_STATE(1333)] = 52179,
  [SMALL_STATE(1334)] = 52213,
  [SMALL_STATE(1335)] = 52247,
  [SMALL_STATE(1336)] = 52281,
  [SMALL_STATE(1337)] = 52315,
  [SMALL_STATE(1338)] = 52365,
  [SMALL_STATE(1339)] = 52399,
  [SMALL_STATE(1340)] = 52449,
  [SMALL_STATE(1341)] = 52499,
  [SMALL_STATE(1342)] = 52549,
  [SMALL_STATE(1343)] = 52583,
  [SMALL_STATE(1344)] = 52633,
  [SMALL_STATE(1345)] = 52683,
  [SMALL_STATE(1346)] = 52733,
  [SMALL_STATE(1347)] = 52781,
  [SMALL_STATE(1348)] = 52831,
  [SMALL_STATE(1349)] = 52865,
  [SMALL_STATE(1350)] = 52899,
  [SMALL_STATE(1351)] = 52949,
  [SMALL_STATE(1352)] = 52999,
  [SMALL_STATE(1353)] = 53033,
  [SMALL_STATE(1354)] = 53083,
  [SMALL_STATE(1355)] = 53133,
  [SMALL_STATE(1356)] = 53167,
  [SMALL_STATE(1357)] = 53213,
  [SMALL_STATE(1358)] = 53247,
  [SMALL_STATE(1359)] = 53294,
  [SMALL_STATE(1360)] = 53327,
  [SMALL_STATE(1361)] = 53374,
  [SMALL_STATE(1362)] = 53421,
  [SMALL_STATE(1363)] = 53466,
  [SMALL_STATE(1364)] = 53513,
  [SMALL_STATE(1365)] = 53560,
  [SMALL_STATE(1366)] = 53607,
  [SMALL_STATE(1367)] = 53654,
  [SMALL_STATE(1368)] = 53701,
  [SMALL_STATE(1369)] = 53748,
  [SMALL_STATE(1370)] = 53795,
  [SMALL_STATE(1371)] = 53842,
  [SMALL_STATE(1372)] = 53889,
  [SMALL_STATE(1373)] = 53933,
  [SMALL_STATE(1374)] = 53977,
  [SMALL_STATE(1375)] = 54021,
  [SMALL_STATE(1376)] = 54065,
  [SMALL_STATE(1377)] = 54109,
  [SMALL_STATE(1378)] = 54155,
  [SMALL_STATE(1379)] = 54201,
  [SMALL_STATE(1380)] = 54245,
  [SMALL_STATE(1381)] = 54289,
  [SMALL_STATE(1382)] = 54335,
  [SMALL_STATE(1383)] = 54379,
  [SMALL_STATE(1384)] = 54425,
  [SMALL_STATE(1385)] = 54469,
  [SMALL_STATE(1386)] = 54513,
  [SMALL_STATE(1387)] = 54557,
  [SMALL_STATE(1388)] = 54601,
  [SMALL_STATE(1389)] = 54647,
  [SMALL_STATE(1390)] = 54683,
  [SMALL_STATE(1391)] = 54729,
  [SMALL_STATE(1392)] = 54775,
  [SMALL_STATE(1393)] = 54819,
  [SMALL_STATE(1394)] = 54863,
  [SMALL_STATE(1395)] = 54907,
  [SMALL_STATE(1396)] = 54953,
  [SMALL_STATE(1397)] = 54997,
  [SMALL_STATE(1398)] = 55041,
  [SMALL_STATE(1399)] = 55077,
  [SMALL_STATE(1400)] = 55123,
  [SMALL_STATE(1401)] = 55167,
  [SMALL_STATE(1402)] = 55213,
  [SMALL_STATE(1403)] = 55245,
  [SMALL_STATE(1404)] = 55289,
  [SMALL_STATE(1405)] = 55325,
  [SMALL_STATE(1406)] = 55371,
  [SMALL_STATE(1407)] = 55415,
  [SMALL_STATE(1408)] = 55461,
  [SMALL_STATE(1409)] = 55501,
  [SMALL_STATE(1410)] = 55545,
  [SMALL_STATE(1411)] = 55581,
  [SMALL_STATE(1412)] = 55625,
  [SMALL_STATE(1413)] = 55669,
  [SMALL_STATE(1414)] = 55713,
  [SMALL_STATE(1415)] = 55744,
  [SMALL_STATE(1416)] = 55785,
  [SMALL_STATE(1417)] = 55826,
  [SMALL_STATE(1418)] = 55867,
  [SMALL_STATE(1419)] = 55908,
  [SMALL_STATE(1420)] = 55939,
  [SMALL_STATE(1421)] = 55980,
  [SMALL_STATE(1422)] = 56021,
  [SMALL_STATE(1423)] = 56055,
  [SMALL_STATE(1424)] = 56089,
  [SMALL_STATE(1425)] = 56118,
  [SMALL_STATE(1426)] = 56147,
  [SMALL_STATE(1427)] = 56176,
  [SMALL_STATE(1428)] = 56207,
  [SMALL_STATE(1429)] = 56238,
  [SMALL_STATE(1430)] = 56267,
  [SMALL_STATE(1431)] = 56296,
  [SMALL_STATE(1432)] = 56327,
  [SMALL_STATE(1433)] = 56356,
  [SMALL_STATE(1434)] = 56385,
  [SMALL_STATE(1435)] = 56418,
  [SMALL_STATE(1436)] = 56449,
  [SMALL_STATE(1437)] = 56480,
  [SMALL_STATE(1438)] = 56509,
  [SMALL_STATE(1439)] = 56540,
  [SMALL_STATE(1440)] = 56573,
  [SMALL_STATE(1441)] = 56602,
  [SMALL_STATE(1442)] = 56633,
  [SMALL_STATE(1443)] = 56662,
  [SMALL_STATE(1444)] = 56693,
  [SMALL_STATE(1445)] = 56722,
  [SMALL_STATE(1446)] = 56753,
  [SMALL_STATE(1447)] = 56785,
  [SMALL_STATE(1448)] = 56817,
  [SMALL_STATE(1449)] = 56842,
  [SMALL_STATE(1450)] = 56868,
  [SMALL_STATE(1451)] = 56894,
  [SMALL_STATE(1452)] = 56917,
  [SMALL_STATE(1453)] = 56950,
  [SMALL_STATE(1454)] = 56973,
  [SMALL_STATE(1455)] = 56996,
  [SMALL_STATE(1456)] = 57019,
  [SMALL_STATE(1457)] = 57052,
  [SMALL_STATE(1458)] = 57085,
  [SMALL_STATE(1459)] = 57108,
  [SMALL_STATE(1460)] = 57131,
  [SMALL_STATE(1461)] = 57151,
  [SMALL_STATE(1462)] = 57171,
  [SMALL_STATE(1463)] = 57191,
  [SMALL_STATE(1464)] = 57211,
  [SMALL_STATE(1465)] = 57231,
  [SMALL_STATE(1466)] = 57251,
  [SMALL_STATE(1467)] = 57271,
  [SMALL_STATE(1468)] = 57291,
  [SMALL_STATE(1469)] = 57311,
  [SMALL_STATE(1470)] = 57331,
  [SMALL_STATE(1471)] = 57351,
  [SMALL_STATE(1472)] = 57371,
  [SMALL_STATE(1473)] = 57391,
  [SMALL_STATE(1474)] = 57411,
  [SMALL_STATE(1475)] = 57431,
  [SMALL_STATE(1476)] = 57451,
  [SMALL_STATE(1477)] = 57471,
  [SMALL_STATE(1478)] = 57491,
  [SMALL_STATE(1479)] = 57511,
  [SMALL_STATE(1480)] = 57531,
  [SMALL_STATE(1481)] = 57551,
  [SMALL_STATE(1482)] = 57571,
  [SMALL_STATE(1483)] = 57591,
  [SMALL_STATE(1484)] = 57627,
  [SMALL_STATE(1485)] = 57655,
  [SMALL_STATE(1486)] = 57678,
  [SMALL_STATE(1487)] = 57701,
  [SMALL_STATE(1488)] = 57726,
  [SMALL_STATE(1489)] = 57746,
  [SMALL_STATE(1490)] = 57766,
  [SMALL_STATE(1491)] = 57796,
  [SMALL_STATE(1492)] = 57816,
  [SMALL_STATE(1493)] = 57836,
  [SMALL_STATE(1494)] = 57866,
  [SMALL_STATE(1495)] = 57896,
  [SMALL_STATE(1496)] = 57924,
  [SMALL_STATE(1497)] = 57944,
  [SMALL_STATE(1498)] = 57964,
  [SMALL_STATE(1499)] = 57984,
  [SMALL_STATE(1500)] = 58012,
  [SMALL_STATE(1501)] = 58032,
  [SMALL_STATE(1502)] = 58052,
  [SMALL_STATE(1503)] = 58082,
  [SMALL_STATE(1504)] = 58102,
  [SMALL_STATE(1505)] = 58132,
  [SMALL_STATE(1506)] = 58152,
  [SMALL_STATE(1507)] = 58182,
  [SMALL_STATE(1508)] = 58202,
  [SMALL_STATE(1509)] = 58230,
  [SMALL_STATE(1510)] = 58250,
  [SMALL_STATE(1511)] = 58270,
  [SMALL_STATE(1512)] = 58300,
  [SMALL_STATE(1513)] = 58330,
  [SMALL_STATE(1514)] = 58358,
  [SMALL_STATE(1515)] = 58378,
  [SMALL_STATE(1516)] = 58408,
  [SMALL_STATE(1517)] = 58428,
  [SMALL_STATE(1518)] = 58448,
  [SMALL_STATE(1519)] = 58468,
  [SMALL_STATE(1520)] = 58488,
  [SMALL_STATE(1521)] = 58508,
  [SMALL_STATE(1522)] = 58528,
  [SMALL_STATE(1523)] = 58548,
  [SMALL_STATE(1524)] = 58568,
  [SMALL_STATE(1525)] = 58588,
  [SMALL_STATE(1526)] = 58618,
  [SMALL_STATE(1527)] = 58638,
  [SMALL_STATE(1528)] = 58666,
  [SMALL_STATE(1529)] = 58686,
  [SMALL_STATE(1530)] = 58703,
  [SMALL_STATE(1531)] = 58730,
  [SMALL_STATE(1532)] = 58747,
  [SMALL_STATE(1533)] = 58780,
  [SMALL_STATE(1534)] = 58813,
  [SMALL_STATE(1535)] = 58846,
  [SMALL_STATE(1536)] = 58863,
  [SMALL_STATE(1537)] = 58896,
  [SMALL_STATE(1538)] = 58923,
  [SMALL_STATE(1539)] = 58950,
  [SMALL_STATE(1540)] = 58977,
  [SMALL_STATE(1541)] = 58994,
  [SMALL_STATE(1542)] = 59021,
  [SMALL_STATE(1543)] = 59054,
  [SMALL_STATE(1544)] = 59081,
  [SMALL_STATE(1545)] = 59114,
  [SMALL_STATE(1546)] = 59131,
  [SMALL_STATE(1547)] = 59148,
  [SMALL_STATE(1548)] = 59181,
  [SMALL_STATE(1549)] = 59214,
  [SMALL_STATE(1550)] = 59241,
  [SMALL_STATE(1551)] = 59274,
  [SMALL_STATE(1552)] = 59307,
  [SMALL_STATE(1553)] = 59324,
  [SMALL_STATE(1554)] = 59357,
  [SMALL_STATE(1555)] = 59384,
  [SMALL_STATE(1556)] = 59411,
  [SMALL_STATE(1557)] = 59444,
  [SMALL_STATE(1558)] = 59477,
  [SMALL_STATE(1559)] = 59504,
  [SMALL_STATE(1560)] = 59537,
  [SMALL_STATE(1561)] = 59570,
  [SMALL_STATE(1562)] = 59603,
  [SMALL_STATE(1563)] = 59628,
  [SMALL_STATE(1564)] = 59661,
  [SMALL_STATE(1565)] = 59678,
  [SMALL_STATE(1566)] = 59705,
  [SMALL_STATE(1567)] = 59732,
  [SMALL_STATE(1568)] = 59765,
  [SMALL_STATE(1569)] = 59798,
  [SMALL_STATE(1570)] = 59831,
  [SMALL_STATE(1571)] = 59858,
  [SMALL_STATE(1572)] = 59891,
  [SMALL_STATE(1573)] = 59924,
  [SMALL_STATE(1574)] = 59957,
  [SMALL_STATE(1575)] = 59990,
  [SMALL_STATE(1576)] = 60023,
  [SMALL_STATE(1577)] = 60056,
  [SMALL_STATE(1578)] = 60089,
  [SMALL_STATE(1579)] = 60122,
  [SMALL_STATE(1580)] = 60155,
  [SMALL_STATE(1581)] = 60188,
  [SMALL_STATE(1582)] = 60221,
  [SMALL_STATE(1583)] = 60254,
  [SMALL_STATE(1584)] = 60287,
  [SMALL_STATE(1585)] = 60320,
  [SMALL_STATE(1586)] = 60336,
  [SMALL_STATE(1587)] = 60360,
  [SMALL_STATE(1588)] = 60384,
  [SMALL_STATE(1589)] = 60408,
  [SMALL_STATE(1590)] = 60432,
  [SMALL_STATE(1591)] = 60456,
  [SMALL_STATE(1592)] = 60472,
  [SMALL_STATE(1593)] = 60496,
  [SMALL_STATE(1594)] = 60520,
  [SMALL_STATE(1595)] = 60544,
  [SMALL_STATE(1596)] = 60560,
  [SMALL_STATE(1597)] = 60584,
  [SMALL_STATE(1598)] = 60608,
  [SMALL_STATE(1599)] = 60632,
  [SMALL_STATE(1600)] = 60656,
  [SMALL_STATE(1601)] = 60680,
  [SMALL_STATE(1602)] = 60704,
  [SMALL_STATE(1603)] = 60728,
  [SMALL_STATE(1604)] = 60752,
  [SMALL_STATE(1605)] = 60776,
  [SMALL_STATE(1606)] = 60800,
  [SMALL_STATE(1607)] = 60824,
  [SMALL_STATE(1608)] = 60848,
  [SMALL_STATE(1609)] = 60872,
  [SMALL_STATE(1610)] = 60896,
  [SMALL_STATE(1611)] = 60920,
  [SMALL_STATE(1612)] = 60946,
  [SMALL_STATE(1613)] = 60970,
  [SMALL_STATE(1614)] = 60994,
  [SMALL_STATE(1615)] = 61018,
  [SMALL_STATE(1616)] = 61042,
  [SMALL_STATE(1617)] = 61066,
  [SMALL_STATE(1618)] = 61090,
  [SMALL_STATE(1619)] = 61114,
  [SMALL_STATE(1620)] = 61138,
  [SMALL_STATE(1621)] = 61162,
  [SMALL_STATE(1622)] = 61186,
  [SMALL_STATE(1623)] = 61210,
  [SMALL_STATE(1624)] = 61234,
  [SMALL_STATE(1625)] = 61258,
  [SMALL_STATE(1626)] = 61278,
  [SMALL_STATE(1627)] = 61302,
  [SMALL_STATE(1628)] = 61326,
  [SMALL_STATE(1629)] = 61350,
  [SMALL_STATE(1630)] = 61374,
  [SMALL_STATE(1631)] = 61398,
  [SMALL_STATE(1632)] = 61422,
  [SMALL_STATE(1633)] = 61446,
  [SMALL_STATE(1634)] = 61470,
  [SMALL_STATE(1635)] = 61494,
  [SMALL_STATE(1636)] = 61518,
  [SMALL_STATE(1637)] = 61542,
  [SMALL_STATE(1638)] = 61566,
  [SMALL_STATE(1639)] = 61590,
  [SMALL_STATE(1640)] = 61614,
  [SMALL_STATE(1641)] = 61638,
  [SMALL_STATE(1642)] = 61662,
  [SMALL_STATE(1643)] = 61686,
  [SMALL_STATE(1644)] = 61710,
  [SMALL_STATE(1645)] = 61734,
  [SMALL_STATE(1646)] = 61764,
  [SMALL_STATE(1647)] = 61788,
  [SMALL_STATE(1648)] = 61812,
  [SMALL_STATE(1649)] = 61836,
  [SMALL_STATE(1650)] = 61860,
  [SMALL_STATE(1651)] = 61884,
  [SMALL_STATE(1652)] = 61908,
  [SMALL_STATE(1653)] = 61932,
  [SMALL_STATE(1654)] = 61949,
  [SMALL_STATE(1655)] = 61972,
  [SMALL_STATE(1656)] = 61995,
  [SMALL_STATE(1657)] = 62018,
  [SMALL_STATE(1658)] = 62041,
  [SMALL_STATE(1659)] = 62064,
  [SMALL_STATE(1660)] = 62087,
  [SMALL_STATE(1661)] = 62108,
  [SMALL_STATE(1662)] = 62131,
  [SMALL_STATE(1663)] = 62154,
  [SMALL_STATE(1664)] = 62175,
  [SMALL_STATE(1665)] = 62195,
  [SMALL_STATE(1666)] = 62217,
  [SMALL_STATE(1667)] = 62235,
  [SMALL_STATE(1668)] = 62253,
  [SMALL_STATE(1669)] = 62271,
  [SMALL_STATE(1670)] = 62289,
  [SMALL_STATE(1671)] = 62307,
  [SMALL_STATE(1672)] = 62329,
  [SMALL_STATE(1673)] = 62347,
  [SMALL_STATE(1674)] = 62369,
  [SMALL_STATE(1675)] = 62387,
  [SMALL_STATE(1676)] = 62405,
  [SMALL_STATE(1677)] = 62421,
  [SMALL_STATE(1678)] = 62437,
  [SMALL_STATE(1679)] = 62459,
  [SMALL_STATE(1680)] = 62481,
  [SMALL_STATE(1681)] = 62499,
  [SMALL_STATE(1682)] = 62523,
  [SMALL_STATE(1683)] = 62541,
  [SMALL_STATE(1684)] = 62557,
  [SMALL_STATE(1685)] = 62577,
  [SMALL_STATE(1686)] = 62597,
  [SMALL_STATE(1687)] = 62621,
  [SMALL_STATE(1688)] = 62641,
  [SMALL_STATE(1689)] = 62656,
  [SMALL_STATE(1690)] = 62669,
  [SMALL_STATE(1691)] = 62682,
  [SMALL_STATE(1692)] = 62697,
  [SMALL_STATE(1693)] = 62714,
  [SMALL_STATE(1694)] = 62731,
  [SMALL_STATE(1695)] = 62746,
  [SMALL_STATE(1696)] = 62763,
  [SMALL_STATE(1697)] = 62784,
  [SMALL_STATE(1698)] = 62799,
  [SMALL_STATE(1699)] = 62816,
  [SMALL_STATE(1700)] = 62833,
  [SMALL_STATE(1701)] = 62846,
  [SMALL_STATE(1702)] = 62867,
  [SMALL_STATE(1703)] = 62884,
  [SMALL_STATE(1704)] = 62901,
  [SMALL_STATE(1705)] = 62922,
  [SMALL_STATE(1706)] = 62937,
  [SMALL_STATE(1707)] = 62954,
  [SMALL_STATE(1708)] = 62967,
  [SMALL_STATE(1709)] = 62984,
  [SMALL_STATE(1710)] = 63005,
  [SMALL_STATE(1711)] = 63022,
  [SMALL_STATE(1712)] = 63035,
  [SMALL_STATE(1713)] = 63056,
  [SMALL_STATE(1714)] = 63069,
  [SMALL_STATE(1715)] = 63084,
  [SMALL_STATE(1716)] = 63101,
  [SMALL_STATE(1717)] = 63114,
  [SMALL_STATE(1718)] = 63127,
  [SMALL_STATE(1719)] = 63140,
  [SMALL_STATE(1720)] = 63161,
  [SMALL_STATE(1721)] = 63174,
  [SMALL_STATE(1722)] = 63191,
  [SMALL_STATE(1723)] = 63204,
  [SMALL_STATE(1724)] = 63217,
  [SMALL_STATE(1725)] = 63235,
  [SMALL_STATE(1726)] = 63253,
  [SMALL_STATE(1727)] = 63267,
  [SMALL_STATE(1728)] = 63285,
  [SMALL_STATE(1729)] = 63299,
  [SMALL_STATE(1730)] = 63317,
  [SMALL_STATE(1731)] = 63331,
  [SMALL_STATE(1732)] = 63345,
  [SMALL_STATE(1733)] = 63363,
  [SMALL_STATE(1734)] = 63377,
  [SMALL_STATE(1735)] = 63391,
  [SMALL_STATE(1736)] = 63405,
  [SMALL_STATE(1737)] = 63423,
  [SMALL_STATE(1738)] = 63437,
  [SMALL_STATE(1739)] = 63453,
  [SMALL_STATE(1740)] = 63471,
  [SMALL_STATE(1741)] = 63485,
  [SMALL_STATE(1742)] = 63499,
  [SMALL_STATE(1743)] = 63515,
  [SMALL_STATE(1744)] = 63533,
  [SMALL_STATE(1745)] = 63551,
  [SMALL_STATE(1746)] = 63569,
  [SMALL_STATE(1747)] = 63587,
  [SMALL_STATE(1748)] = 63599,
  [SMALL_STATE(1749)] = 63617,
  [SMALL_STATE(1750)] = 63631,
  [SMALL_STATE(1751)] = 63649,
  [SMALL_STATE(1752)] = 63667,
  [SMALL_STATE(1753)] = 63681,
  [SMALL_STATE(1754)] = 63699,
  [SMALL_STATE(1755)] = 63713,
  [SMALL_STATE(1756)] = 63731,
  [SMALL_STATE(1757)] = 63745,
  [SMALL_STATE(1758)] = 63759,
  [SMALL_STATE(1759)] = 63777,
  [SMALL_STATE(1760)] = 63795,
  [SMALL_STATE(1761)] = 63813,
  [SMALL_STATE(1762)] = 63825,
  [SMALL_STATE(1763)] = 63843,
  [SMALL_STATE(1764)] = 63861,
  [SMALL_STATE(1765)] = 63875,
  [SMALL_STATE(1766)] = 63893,
  [SMALL_STATE(1767)] = 63911,
  [SMALL_STATE(1768)] = 63929,
  [SMALL_STATE(1769)] = 63947,
  [SMALL_STATE(1770)] = 63965,
  [SMALL_STATE(1771)] = 63979,
  [SMALL_STATE(1772)] = 63993,
  [SMALL_STATE(1773)] = 64011,
  [SMALL_STATE(1774)] = 64025,
  [SMALL_STATE(1775)] = 64041,
  [SMALL_STATE(1776)] = 64059,
  [SMALL_STATE(1777)] = 64077,
  [SMALL_STATE(1778)] = 64095,
  [SMALL_STATE(1779)] = 64113,
  [SMALL_STATE(1780)] = 64127,
  [SMALL_STATE(1781)] = 64145,
  [SMALL_STATE(1782)] = 64161,
  [SMALL_STATE(1783)] = 64177,
  [SMALL_STATE(1784)] = 64191,
  [SMALL_STATE(1785)] = 64209,
  [SMALL_STATE(1786)] = 64227,
  [SMALL_STATE(1787)] = 64239,
  [SMALL_STATE(1788)] = 64257,
  [SMALL_STATE(1789)] = 64275,
  [SMALL_STATE(1790)] = 64287,
  [SMALL_STATE(1791)] = 64305,
  [SMALL_STATE(1792)] = 64323,
  [SMALL_STATE(1793)] = 64341,
  [SMALL_STATE(1794)] = 64357,
  [SMALL_STATE(1795)] = 64373,
  [SMALL_STATE(1796)] = 64391,
  [SMALL_STATE(1797)] = 64409,
  [SMALL_STATE(1798)] = 64427,
  [SMALL_STATE(1799)] = 64445,
  [SMALL_STATE(1800)] = 64460,
  [SMALL_STATE(1801)] = 64475,
  [SMALL_STATE(1802)] = 64490,
  [SMALL_STATE(1803)] = 64505,
  [SMALL_STATE(1804)] = 64520,
  [SMALL_STATE(1805)] = 64535,
  [SMALL_STATE(1806)] = 64550,
  [SMALL_STATE(1807)] = 64565,
  [SMALL_STATE(1808)] = 64580,
  [SMALL_STATE(1809)] = 64591,
  [SMALL_STATE(1810)] = 64606,
  [SMALL_STATE(1811)] = 64621,
  [SMALL_STATE(1812)] = 64636,
  [SMALL_STATE(1813)] = 64651,
  [SMALL_STATE(1814)] = 64662,
  [SMALL_STATE(1815)] = 64677,
  [SMALL_STATE(1816)] = 64692,
  [SMALL_STATE(1817)] = 64707,
  [SMALL_STATE(1818)] = 64722,
  [SMALL_STATE(1819)] = 64737,
  [SMALL_STATE(1820)] = 64752,
  [SMALL_STATE(1821)] = 64767,
  [SMALL_STATE(1822)] = 64784,
  [SMALL_STATE(1823)] = 64799,
  [SMALL_STATE(1824)] = 64814,
  [SMALL_STATE(1825)] = 64827,
  [SMALL_STATE(1826)] = 64840,
  [SMALL_STATE(1827)] = 64855,
  [SMALL_STATE(1828)] = 64872,
  [SMALL_STATE(1829)] = 64887,
  [SMALL_STATE(1830)] = 64902,
  [SMALL_STATE(1831)] = 64915,
  [SMALL_STATE(1832)] = 64930,
  [SMALL_STATE(1833)] = 64945,
  [SMALL_STATE(1834)] = 64960,
  [SMALL_STATE(1835)] = 64975,
  [SMALL_STATE(1836)] = 64986,
  [SMALL_STATE(1837)] = 65001,
  [SMALL_STATE(1838)] = 65016,
  [SMALL_STATE(1839)] = 65031,
  [SMALL_STATE(1840)] = 65044,
  [SMALL_STATE(1841)] = 65061,
  [SMALL_STATE(1842)] = 65076,
  [SMALL_STATE(1843)] = 65089,
  [SMALL_STATE(1844)] = 65102,
  [SMALL_STATE(1845)] = 65115,
  [SMALL_STATE(1846)] = 65132,
  [SMALL_STATE(1847)] = 65143,
  [SMALL_STATE(1848)] = 65158,
  [SMALL_STATE(1849)] = 65173,
  [SMALL_STATE(1850)] = 65184,
  [SMALL_STATE(1851)] = 65195,
  [SMALL_STATE(1852)] = 65210,
  [SMALL_STATE(1853)] = 65225,
  [SMALL_STATE(1854)] = 65242,
  [SMALL_STATE(1855)] = 65253,
  [SMALL_STATE(1856)] = 65268,
  [SMALL_STATE(1857)] = 65279,
  [SMALL_STATE(1858)] = 65294,
  [SMALL_STATE(1859)] = 65309,
  [SMALL_STATE(1860)] = 65326,
  [SMALL_STATE(1861)] = 65341,
  [SMALL_STATE(1862)] = 65356,
  [SMALL_STATE(1863)] = 65371,
  [SMALL_STATE(1864)] = 65382,
  [SMALL_STATE(1865)] = 65397,
  [SMALL_STATE(1866)] = 65414,
  [SMALL_STATE(1867)] = 65429,
  [SMALL_STATE(1868)] = 65446,
  [SMALL_STATE(1869)] = 65463,
  [SMALL_STATE(1870)] = 65476,
  [SMALL_STATE(1871)] = 65491,
  [SMALL_STATE(1872)] = 65502,
  [SMALL_STATE(1873)] = 65519,
  [SMALL_STATE(1874)] = 65534,
  [SMALL_STATE(1875)] = 65549,
  [SMALL_STATE(1876)] = 65566,
  [SMALL_STATE(1877)] = 65581,
  [SMALL_STATE(1878)] = 65594,
  [SMALL_STATE(1879)] = 65609,
  [SMALL_STATE(1880)] = 65624,
  [SMALL_STATE(1881)] = 65639,
  [SMALL_STATE(1882)] = 65650,
  [SMALL_STATE(1883)] = 65665,
  [SMALL_STATE(1884)] = 65680,
  [SMALL_STATE(1885)] = 65695,
  [SMALL_STATE(1886)] = 65710,
  [SMALL_STATE(1887)] = 65725,
  [SMALL_STATE(1888)] = 65740,
  [SMALL_STATE(1889)] = 65755,
  [SMALL_STATE(1890)] = 65770,
  [SMALL_STATE(1891)] = 65783,
  [SMALL_STATE(1892)] = 65798,
  [SMALL_STATE(1893)] = 65813,
  [SMALL_STATE(1894)] = 65826,
  [SMALL_STATE(1895)] = 65841,
  [SMALL_STATE(1896)] = 65856,
  [SMALL_STATE(1897)] = 65871,
  [SMALL_STATE(1898)] = 65884,
  [SMALL_STATE(1899)] = 65899,
  [SMALL_STATE(1900)] = 65914,
  [SMALL_STATE(1901)] = 65929,
  [SMALL_STATE(1902)] = 65944,
  [SMALL_STATE(1903)] = 65959,
  [SMALL_STATE(1904)] = 65974,
  [SMALL_STATE(1905)] = 65985,
  [SMALL_STATE(1906)] = 66000,
  [SMALL_STATE(1907)] = 66011,
  [SMALL_STATE(1908)] = 66028,
  [SMALL_STATE(1909)] = 66043,
  [SMALL_STATE(1910)] = 66060,
  [SMALL_STATE(1911)] = 66075,
  [SMALL_STATE(1912)] = 66090,
  [SMALL_STATE(1913)] = 66107,
  [SMALL_STATE(1914)] = 66120,
  [SMALL_STATE(1915)] = 66135,
  [SMALL_STATE(1916)] = 66150,
  [SMALL_STATE(1917)] = 66165,
  [SMALL_STATE(1918)] = 66178,
  [SMALL_STATE(1919)] = 66191,
  [SMALL_STATE(1920)] = 66206,
  [SMALL_STATE(1921)] = 66218,
  [SMALL_STATE(1922)] = 66230,
  [SMALL_STATE(1923)] = 66242,
  [SMALL_STATE(1924)] = 66254,
  [SMALL_STATE(1925)] = 66266,
  [SMALL_STATE(1926)] = 66278,
  [SMALL_STATE(1927)] = 66290,
  [SMALL_STATE(1928)] = 66302,
  [SMALL_STATE(1929)] = 66314,
  [SMALL_STATE(1930)] = 66326,
  [SMALL_STATE(1931)] = 66338,
  [SMALL_STATE(1932)] = 66350,
  [SMALL_STATE(1933)] = 66360,
  [SMALL_STATE(1934)] = 66372,
  [SMALL_STATE(1935)] = 66384,
  [SMALL_STATE(1936)] = 66396,
  [SMALL_STATE(1937)] = 66406,
  [SMALL_STATE(1938)] = 66418,
  [SMALL_STATE(1939)] = 66430,
  [SMALL_STATE(1940)] = 66442,
  [SMALL_STATE(1941)] = 66454,
  [SMALL_STATE(1942)] = 66466,
  [SMALL_STATE(1943)] = 66478,
  [SMALL_STATE(1944)] = 66490,
  [SMALL_STATE(1945)] = 66502,
  [SMALL_STATE(1946)] = 66514,
  [SMALL_STATE(1947)] = 66526,
  [SMALL_STATE(1948)] = 66538,
  [SMALL_STATE(1949)] = 66550,
  [SMALL_STATE(1950)] = 66562,
  [SMALL_STATE(1951)] = 66574,
  [SMALL_STATE(1952)] = 66586,
  [SMALL_STATE(1953)] = 66598,
  [SMALL_STATE(1954)] = 66608,
  [SMALL_STATE(1955)] = 66618,
  [SMALL_STATE(1956)] = 66630,
  [SMALL_STATE(1957)] = 66642,
  [SMALL_STATE(1958)] = 66654,
  [SMALL_STATE(1959)] = 66666,
  [SMALL_STATE(1960)] = 66678,
  [SMALL_STATE(1961)] = 66690,
  [SMALL_STATE(1962)] = 66702,
  [SMALL_STATE(1963)] = 66714,
  [SMALL_STATE(1964)] = 66726,
  [SMALL_STATE(1965)] = 66738,
  [SMALL_STATE(1966)] = 66748,
  [SMALL_STATE(1967)] = 66760,
  [SMALL_STATE(1968)] = 66772,
  [SMALL_STATE(1969)] = 66784,
  [SMALL_STATE(1970)] = 66796,
  [SMALL_STATE(1971)] = 66808,
  [SMALL_STATE(1972)] = 66820,
  [SMALL_STATE(1973)] = 66832,
  [SMALL_STATE(1974)] = 66844,
  [SMALL_STATE(1975)] = 66856,
  [SMALL_STATE(1976)] = 66868,
  [SMALL_STATE(1977)] = 66878,
  [SMALL_STATE(1978)] = 66888,
  [SMALL_STATE(1979)] = 66900,
  [SMALL_STATE(1980)] = 66912,
  [SMALL_STATE(1981)] = 66924,
  [SMALL_STATE(1982)] = 66936,
  [SMALL_STATE(1983)] = 66948,
  [SMALL_STATE(1984)] = 66960,
  [SMALL_STATE(1985)] = 66972,
  [SMALL_STATE(1986)] = 66984,
  [SMALL_STATE(1987)] = 66996,
  [SMALL_STATE(1988)] = 67008,
  [SMALL_STATE(1989)] = 67020,
  [SMALL_STATE(1990)] = 67032,
  [SMALL_STATE(1991)] = 67044,
  [SMALL_STATE(1992)] = 67056,
  [SMALL_STATE(1993)] = 67066,
  [SMALL_STATE(1994)] = 67078,
  [SMALL_STATE(1995)] = 67090,
  [SMALL_STATE(1996)] = 67102,
  [SMALL_STATE(1997)] = 67114,
  [SMALL_STATE(1998)] = 67126,
  [SMALL_STATE(1999)] = 67136,
  [SMALL_STATE(2000)] = 67148,
  [SMALL_STATE(2001)] = 67160,
  [SMALL_STATE(2002)] = 67172,
  [SMALL_STATE(2003)] = 67184,
  [SMALL_STATE(2004)] = 67196,
  [SMALL_STATE(2005)] = 67208,
  [SMALL_STATE(2006)] = 67220,
  [SMALL_STATE(2007)] = 67232,
  [SMALL_STATE(2008)] = 67244,
  [SMALL_STATE(2009)] = 67256,
  [SMALL_STATE(2010)] = 67268,
  [SMALL_STATE(2011)] = 67280,
  [SMALL_STATE(2012)] = 67292,
  [SMALL_STATE(2013)] = 67304,
  [SMALL_STATE(2014)] = 67316,
  [SMALL_STATE(2015)] = 67328,
  [SMALL_STATE(2016)] = 67340,
  [SMALL_STATE(2017)] = 67352,
  [SMALL_STATE(2018)] = 67364,
  [SMALL_STATE(2019)] = 67376,
  [SMALL_STATE(2020)] = 67386,
  [SMALL_STATE(2021)] = 67398,
  [SMALL_STATE(2022)] = 67410,
  [SMALL_STATE(2023)] = 67422,
  [SMALL_STATE(2024)] = 67434,
  [SMALL_STATE(2025)] = 67446,
  [SMALL_STATE(2026)] = 67458,
  [SMALL_STATE(2027)] = 67470,
  [SMALL_STATE(2028)] = 67482,
  [SMALL_STATE(2029)] = 67494,
  [SMALL_STATE(2030)] = 67506,
  [SMALL_STATE(2031)] = 67518,
  [SMALL_STATE(2032)] = 67530,
  [SMALL_STATE(2033)] = 67542,
  [SMALL_STATE(2034)] = 67554,
  [SMALL_STATE(2035)] = 67566,
  [SMALL_STATE(2036)] = 67578,
  [SMALL_STATE(2037)] = 67590,
  [SMALL_STATE(2038)] = 67602,
  [SMALL_STATE(2039)] = 67614,
  [SMALL_STATE(2040)] = 67626,
  [SMALL_STATE(2041)] = 67636,
  [SMALL_STATE(2042)] = 67648,
  [SMALL_STATE(2043)] = 67660,
  [SMALL_STATE(2044)] = 67672,
  [SMALL_STATE(2045)] = 67684,
  [SMALL_STATE(2046)] = 67696,
  [SMALL_STATE(2047)] = 67706,
  [SMALL_STATE(2048)] = 67716,
  [SMALL_STATE(2049)] = 67728,
  [SMALL_STATE(2050)] = 67740,
  [SMALL_STATE(2051)] = 67752,
  [SMALL_STATE(2052)] = 67764,
  [SMALL_STATE(2053)] = 67776,
  [SMALL_STATE(2054)] = 67788,
  [SMALL_STATE(2055)] = 67798,
  [SMALL_STATE(2056)] = 67810,
  [SMALL_STATE(2057)] = 67822,
  [SMALL_STATE(2058)] = 67832,
  [SMALL_STATE(2059)] = 67844,
  [SMALL_STATE(2060)] = 67856,
  [SMALL_STATE(2061)] = 67868,
  [SMALL_STATE(2062)] = 67880,
  [SMALL_STATE(2063)] = 67892,
  [SMALL_STATE(2064)] = 67904,
  [SMALL_STATE(2065)] = 67916,
  [SMALL_STATE(2066)] = 67928,
  [SMALL_STATE(2067)] = 67938,
  [SMALL_STATE(2068)] = 67950,
  [SMALL_STATE(2069)] = 67962,
  [SMALL_STATE(2070)] = 67972,
  [SMALL_STATE(2071)] = 67984,
  [SMALL_STATE(2072)] = 67996,
  [SMALL_STATE(2073)] = 68008,
  [SMALL_STATE(2074)] = 68020,
  [SMALL_STATE(2075)] = 68032,
  [SMALL_STATE(2076)] = 68044,
  [SMALL_STATE(2077)] = 68056,
  [SMALL_STATE(2078)] = 68068,
  [SMALL_STATE(2079)] = 68080,
  [SMALL_STATE(2080)] = 68092,
  [SMALL_STATE(2081)] = 68104,
  [SMALL_STATE(2082)] = 68116,
  [SMALL_STATE(2083)] = 68128,
  [SMALL_STATE(2084)] = 68140,
  [SMALL_STATE(2085)] = 68152,
  [SMALL_STATE(2086)] = 68164,
  [SMALL_STATE(2087)] = 68176,
  [SMALL_STATE(2088)] = 68188,
  [SMALL_STATE(2089)] = 68200,
  [SMALL_STATE(2090)] = 68212,
  [SMALL_STATE(2091)] = 68224,
  [SMALL_STATE(2092)] = 68236,
  [SMALL_STATE(2093)] = 68248,
  [SMALL_STATE(2094)] = 68260,
  [SMALL_STATE(2095)] = 68270,
  [SMALL_STATE(2096)] = 68282,
  [SMALL_STATE(2097)] = 68294,
  [SMALL_STATE(2098)] = 68304,
  [SMALL_STATE(2099)] = 68316,
  [SMALL_STATE(2100)] = 68328,
  [SMALL_STATE(2101)] = 68337,
  [SMALL_STATE(2102)] = 68346,
  [SMALL_STATE(2103)] = 68355,
  [SMALL_STATE(2104)] = 68364,
  [SMALL_STATE(2105)] = 68373,
  [SMALL_STATE(2106)] = 68382,
  [SMALL_STATE(2107)] = 68391,
  [SMALL_STATE(2108)] = 68400,
  [SMALL_STATE(2109)] = 68409,
  [SMALL_STATE(2110)] = 68418,
  [SMALL_STATE(2111)] = 68427,
  [SMALL_STATE(2112)] = 68436,
  [SMALL_STATE(2113)] = 68445,
  [SMALL_STATE(2114)] = 68454,
  [SMALL_STATE(2115)] = 68463,
  [SMALL_STATE(2116)] = 68472,
  [SMALL_STATE(2117)] = 68481,
  [SMALL_STATE(2118)] = 68490,
  [SMALL_STATE(2119)] = 68499,
  [SMALL_STATE(2120)] = 68508,
  [SMALL_STATE(2121)] = 68517,
  [SMALL_STATE(2122)] = 68526,
  [SMALL_STATE(2123)] = 68535,
  [SMALL_STATE(2124)] = 68544,
  [SMALL_STATE(2125)] = 68553,
  [SMALL_STATE(2126)] = 68562,
  [SMALL_STATE(2127)] = 68571,
  [SMALL_STATE(2128)] = 68580,
  [SMALL_STATE(2129)] = 68589,
  [SMALL_STATE(2130)] = 68598,
  [SMALL_STATE(2131)] = 68607,
  [SMALL_STATE(2132)] = 68616,
  [SMALL_STATE(2133)] = 68625,
  [SMALL_STATE(2134)] = 68634,
  [SMALL_STATE(2135)] = 68643,
  [SMALL_STATE(2136)] = 68652,
  [SMALL_STATE(2137)] = 68661,
  [SMALL_STATE(2138)] = 68670,
  [SMALL_STATE(2139)] = 68679,
  [SMALL_STATE(2140)] = 68688,
  [SMALL_STATE(2141)] = 68697,
  [SMALL_STATE(2142)] = 68706,
  [SMALL_STATE(2143)] = 68715,
  [SMALL_STATE(2144)] = 68724,
  [SMALL_STATE(2145)] = 68733,
  [SMALL_STATE(2146)] = 68742,
  [SMALL_STATE(2147)] = 68751,
  [SMALL_STATE(2148)] = 68760,
  [SMALL_STATE(2149)] = 68769,
  [SMALL_STATE(2150)] = 68778,
  [SMALL_STATE(2151)] = 68787,
  [SMALL_STATE(2152)] = 68796,
  [SMALL_STATE(2153)] = 68805,
  [SMALL_STATE(2154)] = 68814,
  [SMALL_STATE(2155)] = 68823,
  [SMALL_STATE(2156)] = 68832,
  [SMALL_STATE(2157)] = 68841,
  [SMALL_STATE(2158)] = 68850,
  [SMALL_STATE(2159)] = 68859,
  [SMALL_STATE(2160)] = 68868,
  [SMALL_STATE(2161)] = 68877,
  [SMALL_STATE(2162)] = 68886,
  [SMALL_STATE(2163)] = 68895,
  [SMALL_STATE(2164)] = 68904,
  [SMALL_STATE(2165)] = 68913,
  [SMALL_STATE(2166)] = 68922,
  [SMALL_STATE(2167)] = 68931,
  [SMALL_STATE(2168)] = 68940,
  [SMALL_STATE(2169)] = 68949,
  [SMALL_STATE(2170)] = 68958,
  [SMALL_STATE(2171)] = 68967,
  [SMALL_STATE(2172)] = 68976,
  [SMALL_STATE(2173)] = 68985,
  [SMALL_STATE(2174)] = 68994,
  [SMALL_STATE(2175)] = 69003,
  [SMALL_STATE(2176)] = 69012,
  [SMALL_STATE(2177)] = 69021,
  [SMALL_STATE(2178)] = 69030,
  [SMALL_STATE(2179)] = 69039,
  [SMALL_STATE(2180)] = 69048,
  [SMALL_STATE(2181)] = 69057,
  [SMALL_STATE(2182)] = 69066,
  [SMALL_STATE(2183)] = 69075,
  [SMALL_STATE(2184)] = 69084,
  [SMALL_STATE(2185)] = 69093,
  [SMALL_STATE(2186)] = 69102,
  [SMALL_STATE(2187)] = 69111,
  [SMALL_STATE(2188)] = 69120,
  [SMALL_STATE(2189)] = 69129,
  [SMALL_STATE(2190)] = 69138,
  [SMALL_STATE(2191)] = 69147,
  [SMALL_STATE(2192)] = 69156,
  [SMALL_STATE(2193)] = 69165,
  [SMALL_STATE(2194)] = 69174,
  [SMALL_STATE(2195)] = 69183,
  [SMALL_STATE(2196)] = 69192,
  [SMALL_STATE(2197)] = 69201,
  [SMALL_STATE(2198)] = 69210,
  [SMALL_STATE(2199)] = 69219,
  [SMALL_STATE(2200)] = 69228,
  [SMALL_STATE(2201)] = 69237,
  [SMALL_STATE(2202)] = 69246,
  [SMALL_STATE(2203)] = 69255,
  [SMALL_STATE(2204)] = 69264,
  [SMALL_STATE(2205)] = 69273,
  [SMALL_STATE(2206)] = 69282,
  [SMALL_STATE(2207)] = 69291,
  [SMALL_STATE(2208)] = 69300,
  [SMALL_STATE(2209)] = 69309,
  [SMALL_STATE(2210)] = 69318,
  [SMALL_STATE(2211)] = 69327,
  [SMALL_STATE(2212)] = 69336,
  [SMALL_STATE(2213)] = 69345,
  [SMALL_STATE(2214)] = 69354,
  [SMALL_STATE(2215)] = 69363,
  [SMALL_STATE(2216)] = 69372,
  [SMALL_STATE(2217)] = 69381,
  [SMALL_STATE(2218)] = 69390,
  [SMALL_STATE(2219)] = 69399,
  [SMALL_STATE(2220)] = 69408,
  [SMALL_STATE(2221)] = 69417,
  [SMALL_STATE(2222)] = 69426,
  [SMALL_STATE(2223)] = 69435,
  [SMALL_STATE(2224)] = 69444,
  [SMALL_STATE(2225)] = 69453,
  [SMALL_STATE(2226)] = 69462,
  [SMALL_STATE(2227)] = 69471,
  [SMALL_STATE(2228)] = 69480,
  [SMALL_STATE(2229)] = 69489,
  [SMALL_STATE(2230)] = 69498,
  [SMALL_STATE(2231)] = 69507,
  [SMALL_STATE(2232)] = 69516,
  [SMALL_STATE(2233)] = 69525,
  [SMALL_STATE(2234)] = 69534,
  [SMALL_STATE(2235)] = 69543,
  [SMALL_STATE(2236)] = 69552,
  [SMALL_STATE(2237)] = 69561,
  [SMALL_STATE(2238)] = 69570,
  [SMALL_STATE(2239)] = 69579,
  [SMALL_STATE(2240)] = 69588,
  [SMALL_STATE(2241)] = 69597,
  [SMALL_STATE(2242)] = 69606,
  [SMALL_STATE(2243)] = 69615,
  [SMALL_STATE(2244)] = 69624,
  [SMALL_STATE(2245)] = 69633,
  [SMALL_STATE(2246)] = 69642,
  [SMALL_STATE(2247)] = 69651,
  [SMALL_STATE(2248)] = 69660,
  [SMALL_STATE(2249)] = 69669,
  [SMALL_STATE(2250)] = 69678,
  [SMALL_STATE(2251)] = 69687,
  [SMALL_STATE(2252)] = 69696,
  [SMALL_STATE(2253)] = 69705,
  [SMALL_STATE(2254)] = 69714,
  [SMALL_STATE(2255)] = 69723,
  [SMALL_STATE(2256)] = 69732,
  [SMALL_STATE(2257)] = 69741,
  [SMALL_STATE(2258)] = 69750,
  [SMALL_STATE(2259)] = 69759,
  [SMALL_STATE(2260)] = 69768,
  [SMALL_STATE(2261)] = 69777,
  [SMALL_STATE(2262)] = 69786,
  [SMALL_STATE(2263)] = 69795,
  [SMALL_STATE(2264)] = 69804,
  [SMALL_STATE(2265)] = 69813,
  [SMALL_STATE(2266)] = 69822,
  [SMALL_STATE(2267)] = 69831,
  [SMALL_STATE(2268)] = 69840,
  [SMALL_STATE(2269)] = 69849,
  [SMALL_STATE(2270)] = 69858,
  [SMALL_STATE(2271)] = 69867,
  [SMALL_STATE(2272)] = 69876,
  [SMALL_STATE(2273)] = 69885,
  [SMALL_STATE(2274)] = 69894,
  [SMALL_STATE(2275)] = 69903,
  [SMALL_STATE(2276)] = 69912,
  [SMALL_STATE(2277)] = 69921,
  [SMALL_STATE(2278)] = 69930,
  [SMALL_STATE(2279)] = 69939,
  [SMALL_STATE(2280)] = 69948,
  [SMALL_STATE(2281)] = 69957,
  [SMALL_STATE(2282)] = 69966,
  [SMALL_STATE(2283)] = 69975,
  [SMALL_STATE(2284)] = 69984,
  [SMALL_STATE(2285)] = 69993,
  [SMALL_STATE(2286)] = 70002,
  [SMALL_STATE(2287)] = 70011,
  [SMALL_STATE(2288)] = 70020,
  [SMALL_STATE(2289)] = 70029,
  [SMALL_STATE(2290)] = 70038,
  [SMALL_STATE(2291)] = 70047,
  [SMALL_STATE(2292)] = 70056,
  [SMALL_STATE(2293)] = 70065,
  [SMALL_STATE(2294)] = 70074,
  [SMALL_STATE(2295)] = 70083,
  [SMALL_STATE(2296)] = 70092,
  [SMALL_STATE(2297)] = 70101,
  [SMALL_STATE(2298)] = 70110,
  [SMALL_STATE(2299)] = 70119,
  [SMALL_STATE(2300)] = 70128,
  [SMALL_STATE(2301)] = 70137,
  [SMALL_STATE(2302)] = 70146,
  [SMALL_STATE(2303)] = 70155,
  [SMALL_STATE(2304)] = 70164,
  [SMALL_STATE(2305)] = 70173,
  [SMALL_STATE(2306)] = 70182,
  [SMALL_STATE(2307)] = 70191,
  [SMALL_STATE(2308)] = 70200,
  [SMALL_STATE(2309)] = 70209,
  [SMALL_STATE(2310)] = 70218,
  [SMALL_STATE(2311)] = 70227,
  [SMALL_STATE(2312)] = 70236,
  [SMALL_STATE(2313)] = 70245,
  [SMALL_STATE(2314)] = 70254,
  [SMALL_STATE(2315)] = 70263,
  [SMALL_STATE(2316)] = 70272,
  [SMALL_STATE(2317)] = 70281,
  [SMALL_STATE(2318)] = 70290,
  [SMALL_STATE(2319)] = 70299,
  [SMALL_STATE(2320)] = 70308,
  [SMALL_STATE(2321)] = 70317,
  [SMALL_STATE(2322)] = 70326,
  [SMALL_STATE(2323)] = 70335,
  [SMALL_STATE(2324)] = 70344,
  [SMALL_STATE(2325)] = 70353,
  [SMALL_STATE(2326)] = 70362,
  [SMALL_STATE(2327)] = 70371,
  [SMALL_STATE(2328)] = 70380,
  [SMALL_STATE(2329)] = 70389,
  [SMALL_STATE(2330)] = 70398,
  [SMALL_STATE(2331)] = 70407,
  [SMALL_STATE(2332)] = 70416,
  [SMALL_STATE(2333)] = 70425,
  [SMALL_STATE(2334)] = 70434,
  [SMALL_STATE(2335)] = 70443,
  [SMALL_STATE(2336)] = 70452,
  [SMALL_STATE(2337)] = 70461,
  [SMALL_STATE(2338)] = 70470,
  [SMALL_STATE(2339)] = 70479,
  [SMALL_STATE(2340)] = 70488,
  [SMALL_STATE(2341)] = 70497,
  [SMALL_STATE(2342)] = 70506,
  [SMALL_STATE(2343)] = 70515,
  [SMALL_STATE(2344)] = 70524,
  [SMALL_STATE(2345)] = 70533,
  [SMALL_STATE(2346)] = 70542,
  [SMALL_STATE(2347)] = 70551,
  [SMALL_STATE(2348)] = 70560,
  [SMALL_STATE(2349)] = 70569,
  [SMALL_STATE(2350)] = 70578,
  [SMALL_STATE(2351)] = 70587,
  [SMALL_STATE(2352)] = 70596,
  [SMALL_STATE(2353)] = 70605,
  [SMALL_STATE(2354)] = 70614,
  [SMALL_STATE(2355)] = 70623,
  [SMALL_STATE(2356)] = 70632,
  [SMALL_STATE(2357)] = 70641,
  [SMALL_STATE(2358)] = 70650,
  [SMALL_STATE(2359)] = 70659,
  [SMALL_STATE(2360)] = 70668,
  [SMALL_STATE(2361)] = 70677,
  [SMALL_STATE(2362)] = 70686,
  [SMALL_STATE(2363)] = 70695,
  [SMALL_STATE(2364)] = 70704,
  [SMALL_STATE(2365)] = 70713,
  [SMALL_STATE(2366)] = 70722,
  [SMALL_STATE(2367)] = 70731,
  [SMALL_STATE(2368)] = 70740,
  [SMALL_STATE(2369)] = 70749,
  [SMALL_STATE(2370)] = 70758,
  [SMALL_STATE(2371)] = 70767,
  [SMALL_STATE(2372)] = 70776,
  [SMALL_STATE(2373)] = 70785,
  [SMALL_STATE(2374)] = 70794,
  [SMALL_STATE(2375)] = 70803,
  [SMALL_STATE(2376)] = 70812,
  [SMALL_STATE(2377)] = 70821,
  [SMALL_STATE(2378)] = 70830,
  [SMALL_STATE(2379)] = 70839,
  [SMALL_STATE(2380)] = 70848,
  [SMALL_STATE(2381)] = 70857,
  [SMALL_STATE(2382)] = 70866,
  [SMALL_STATE(2383)] = 70875,
  [SMALL_STATE(2384)] = 70884,
  [SMALL_STATE(2385)] = 70893,
  [SMALL_STATE(2386)] = 70902,
  [SMALL_STATE(2387)] = 70911,
  [SMALL_STATE(2388)] = 70920,
  [SMALL_STATE(2389)] = 70929,
  [SMALL_STATE(2390)] = 70938,
  [SMALL_STATE(2391)] = 70947,
  [SMALL_STATE(2392)] = 70956,
  [SMALL_STATE(2393)] = 70965,
  [SMALL_STATE(2394)] = 70974,
  [SMALL_STATE(2395)] = 70983,
  [SMALL_STATE(2396)] = 70992,
  [SMALL_STATE(2397)] = 71001,
  [SMALL_STATE(2398)] = 71010,
  [SMALL_STATE(2399)] = 71019,
  [SMALL_STATE(2400)] = 71028,
  [SMALL_STATE(2401)] = 71037,
  [SMALL_STATE(2402)] = 71046,
  [SMALL_STATE(2403)] = 71055,
  [SMALL_STATE(2404)] = 71064,
  [SMALL_STATE(2405)] = 71073,
  [SMALL_STATE(2406)] = 71082,
  [SMALL_STATE(2407)] = 71091,
  [SMALL_STATE(2408)] = 71100,
  [SMALL_STATE(2409)] = 71109,
  [SMALL_STATE(2410)] = 71118,
  [SMALL_STATE(2411)] = 71127,
  [SMALL_STATE(2412)] = 71136,
  [SMALL_STATE(2413)] = 71145,
  [SMALL_STATE(2414)] = 71154,
  [SMALL_STATE(2415)] = 71163,
  [SMALL_STATE(2416)] = 71172,
  [SMALL_STATE(2417)] = 71181,
  [SMALL_STATE(2418)] = 71190,
  [SMALL_STATE(2419)] = 71199,
  [SMALL_STATE(2420)] = 71208,
  [SMALL_STATE(2421)] = 71217,
  [SMALL_STATE(2422)] = 71226,
  [SMALL_STATE(2423)] = 71235,
  [SMALL_STATE(2424)] = 71244,
  [SMALL_STATE(2425)] = 71253,
  [SMALL_STATE(2426)] = 71262,
  [SMALL_STATE(2427)] = 71271,
  [SMALL_STATE(2428)] = 71280,
  [SMALL_STATE(2429)] = 71289,
  [SMALL_STATE(2430)] = 71298,
  [SMALL_STATE(2431)] = 71307,
  [SMALL_STATE(2432)] = 71316,
  [SMALL_STATE(2433)] = 71325,
  [SMALL_STATE(2434)] = 71334,
  [SMALL_STATE(2435)] = 71343,
  [SMALL_STATE(2436)] = 71352,
  [SMALL_STATE(2437)] = 71361,
  [SMALL_STATE(2438)] = 71370,
  [SMALL_STATE(2439)] = 71379,
  [SMALL_STATE(2440)] = 71388,
  [SMALL_STATE(2441)] = 71397,
  [SMALL_STATE(2442)] = 71406,
  [SMALL_STATE(2443)] = 71415,
  [SMALL_STATE(2444)] = 71424,
  [SMALL_STATE(2445)] = 71433,
  [SMALL_STATE(2446)] = 71442,
  [SMALL_STATE(2447)] = 71451,
  [SMALL_STATE(2448)] = 71460,
  [SMALL_STATE(2449)] = 71469,
  [SMALL_STATE(2450)] = 71478,
  [SMALL_STATE(2451)] = 71487,
  [SMALL_STATE(2452)] = 71496,
  [SMALL_STATE(2453)] = 71505,
  [SMALL_STATE(2454)] = 71514,
  [SMALL_STATE(2455)] = 71523,
  [SMALL_STATE(2456)] = 71532,
  [SMALL_STATE(2457)] = 71541,
  [SMALL_STATE(2458)] = 71550,
  [SMALL_STATE(2459)] = 71559,
  [SMALL_STATE(2460)] = 71568,
  [SMALL_STATE(2461)] = 71577,
  [SMALL_STATE(2462)] = 71586,
  [SMALL_STATE(2463)] = 71595,
  [SMALL_STATE(2464)] = 71604,
  [SMALL_STATE(2465)] = 71613,
  [SMALL_STATE(2466)] = 71622,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_root, 0),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initialization, 1),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finalization, 1),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_whileTr, 3, .production_id = 25),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_withTr, 3, .production_id = 29),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifElseTr, 4, .production_id = 25),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_withTr, 4, .production_id = 58),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreachTr, 5, .production_id = 84),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forTr, 5, .production_id = 83),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifElseTr, 5, .production_id = 49),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifTr, 3, .production_id = 25),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exceptionHandlerTr, 3, .production_id = 13),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_caseCaseTr, 1, .production_id = 56),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exceptionHandlerTr, 5, .production_id = 158),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprTpl, 4, .production_id = 46),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprTpl, 4, .production_id = 46),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprTpl, 5, .production_id = 81),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprTpl, 5, .production_id = 81),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 191),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 191),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 191), SHIFT(602),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 160),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 160),
  [314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 160), SHIFT(602),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 108),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 108),
  [321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 108), SHIFT(602),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 128),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 128),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 128), SHIFT(602),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 129),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 129),
  [335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 129), SHIFT(602),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 130),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 130),
  [342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 130), SHIFT(602),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 70),
  [347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 70),
  [349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 70), SHIFT(602),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 131),
  [354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 131),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 131), SHIFT(602),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 9, .production_id = 216),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 9, .production_id = 216),
  [363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 9, .production_id = 216), SHIFT(602),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 60),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 60),
  [370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 60), SHIFT(602),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 193),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 193),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 193), SHIFT(602),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 192),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 192),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 192), SHIFT(602),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 129),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 129),
  [391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 129), SHIFT(602),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(602),
  [401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1813),
  [404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1783),
  [407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(631),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(775),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(683),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(836),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(2408),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 161),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 161),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 161), SHIFT(602),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 93),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 93),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 93), SHIFT(602),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 4, .production_id = 60),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 4, .production_id = 60),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 4, .production_id = 60), SHIFT(602),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 162),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 162),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 162), SHIFT(602),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 164),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 164),
  [454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 164), SHIFT(602),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 92),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 92),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 92), SHIFT(602),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 70),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 70),
  [468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 70), SHIFT(602),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 94),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 94),
  [475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 94), SHIFT(602),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 127),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 127),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 127), SHIFT(602),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 163),
  [487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 163),
  [489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 163), SHIFT(602),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 94),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 94),
  [496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 94), SHIFT(602),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(1029),
  [502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(92),
  [505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(685),
  [508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(820),
  [511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(233),
  [514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(1843),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(533),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(533),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(51),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(1662),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(2243),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(681),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(829),
  [538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(829),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(693),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(814),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(813),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(26),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(8),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(812),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(811),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(767),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(2335),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(920),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(528),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 2), SHIFT_REPEAT(687),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 8, .production_id = 199),
  [603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 8, .production_id = 199),
  [605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 8, .production_id = 199), SHIFT(602),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 92),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 5, .production_id = 92),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 92), SHIFT(602),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 140),
  [617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 7, .production_id = 140),
  [619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 140), SHIFT(602),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procExternal, 2),
  [624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procExternal, 2),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 6, .production_id = 127),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 6, .production_id = 127),
  [630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 6, .production_id = 127), SHIFT(602),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 7, .production_id = 161),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 7, .production_id = 161),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 7, .production_id = 161), SHIFT(602),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 165),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 7, .production_id = 165),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 165), SHIFT(602),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 173),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 7, .production_id = 173),
  [651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 173), SHIFT(602),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 4, .production_id = 63),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 4, .production_id = 63),
  [658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 4, .production_id = 63), SHIFT(602),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 4, .production_id = 62),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 4, .production_id = 62),
  [665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 4, .production_id = 62), SHIFT(602),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 5, .production_id = 95),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 5, .production_id = 95),
  [672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 5, .production_id = 95), SHIFT(602),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procExternal, 6),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procExternal, 6),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 4, .production_id = 60),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 4, .production_id = 60),
  [683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 4, .production_id = 60), SHIFT(602),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 99),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 5, .production_id = 99),
  [690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 99), SHIFT(602),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 138),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 138),
  [697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 138), SHIFT(602),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procExternal, 4),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procExternal, 4),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 108),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 108),
  [708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 108), SHIFT(602),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procExternal, 5),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procExternal, 5),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 101),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 101),
  [719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 101), SHIFT(602),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40),
  [726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(602),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1813),
  [732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1783),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(775),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(683),
  [741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(836),
  [744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(2408),
  [747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(687),
  [750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(115),
  [753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(685),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(820),
  [759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(233),
  [762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(1843),
  [765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(533),
  [768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(533),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(51),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(1662),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(2243),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(681),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(829),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(829),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(693),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(814),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(813),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(26),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(8),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(812),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(811),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(767),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(2335),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(920),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 2), SHIFT_REPEAT(528),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 70),
  [824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 5, .production_id = 70),
  [826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 70), SHIFT(602),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 133),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 133),
  [833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 133), SHIFT(602),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 3, .production_id = 31),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 3, .production_id = 31),
  [840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 3, .production_id = 31), SHIFT(602),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procExternal, 3),
  [847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procExternal, 3),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 5, .production_id = 93),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 5, .production_id = 93),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 5, .production_id = 93), SHIFT(602),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConst, 6, .production_id = 128),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConst, 6, .production_id = 128),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 6, .production_id = 128), SHIFT(602),
  [863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 108), SHIFT(604),
  [866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 108), SHIFT(1783),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcFwd, 4, .production_id = 38),
  [873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProcFwd, 4, .production_id = 38), SHIFT(602),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProcFwd, 4, .production_id = 38),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 92), SHIFT(604),
  [891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 92), SHIFT(1783),
  [894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 93), SHIFT(604),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 93), SHIFT(1783),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 70), SHIFT(604),
  [903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 70), SHIFT(1783),
  [906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 5, .production_id = 94), SHIFT(604),
  [909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 5, .production_id = 94), SHIFT(1783),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcFwd, 3, .production_id = 18),
  [914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProcFwd, 3, .production_id = 18), SHIFT(602),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProcFwd, 3, .production_id = 18),
  [919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 9, .production_id = 216), SHIFT(604),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 9, .production_id = 216), SHIFT(1783),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcFwd, 3, .production_id = 1),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProcFwd, 3, .production_id = 1), SHIFT(602),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProcFwd, 3, .production_id = 1),
  [932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 193), SHIFT(604),
  [935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 193), SHIFT(1783),
  [938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 192), SHIFT(604),
  [941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 192), SHIFT(1783),
  [944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 129), SHIFT(604),
  [947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 129), SHIFT(1783),
  [950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 8, .production_id = 191), SHIFT(604),
  [953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 8, .production_id = 191), SHIFT(1783),
  [956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 4, .production_id = 60), SHIFT(604),
  [959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 4, .production_id = 60), SHIFT(1783),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 164), SHIFT(604),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 164), SHIFT(1783),
  [988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 94), SHIFT(604),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 94), SHIFT(1783),
  [994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(604),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 2, .production_id = 40), SHIFT_REPEAT(649),
  [1000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 60), SHIFT(604),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 60), SHIFT(1783),
  [1006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 127), SHIFT(604),
  [1009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 127), SHIFT(1783),
  [1012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 128), SHIFT(604),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 128), SHIFT(1783),
  [1018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 163), SHIFT(604),
  [1021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 163), SHIFT(1783),
  [1024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 129), SHIFT(604),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 129), SHIFT(1783),
  [1030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 130), SHIFT(604),
  [1033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 130), SHIFT(1783),
  [1036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 6, .production_id = 131), SHIFT(604),
  [1039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 6, .production_id = 131), SHIFT(1783),
  [1042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 162), SHIFT(604),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 162), SHIFT(1783),
  [1048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 161), SHIFT(604),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 161), SHIFT(1783),
  [1054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 70), SHIFT(604),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 70), SHIFT(1783),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVar, 7, .production_id = 160), SHIFT(604),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declVar, 7, .production_id = 160), SHIFT(1783),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcFwd, 2, .production_id = 1),
  [1068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProcFwd, 2, .production_id = 1), SHIFT(602),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProcFwd, 2, .production_id = 1),
  [1073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 34), SHIFT(615),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 34),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 4, .production_id = 34),
  [1080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 69), SHIFT(615),
  [1083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 69),
  [1085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 69),
  [1087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 142), SHIFT(615),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 142),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 142),
  [1094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 143), SHIFT(615),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 143),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 143),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 145), SHIFT(615),
  [1104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 145),
  [1106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 145),
  [1108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 146), SHIFT(615),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 146),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 146),
  [1115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 147), SHIFT(615),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 147),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 147),
  [1122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 148), SHIFT(615),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 148),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 148),
  [1129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 68), SHIFT(615),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 68),
  [1134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 68),
  [1136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 149), SHIFT(615),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 149),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 149),
  [1143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 150), SHIFT(615),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 150),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 150),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_blockTr, 3),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_blockTr, 3),
  [1154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 151), SHIFT(615),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 151),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 151),
  [1161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 140), SHIFT(615),
  [1164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 140),
  [1166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 140),
  [1168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_blockTr, 2),
  [1170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_blockTr, 2),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 71), SHIFT(615),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 71),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 71),
  [1179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 67), SHIFT(615),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 67),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 67),
  [1186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 70), SHIFT(615),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 70),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 70),
  [1193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 66), SHIFT(615),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 66),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 66),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttribute, 4, .production_id = 118),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttribute, 4, .production_id = 118),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 72), SHIFT(615),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 72),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 72),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttribute, 3),
  [1213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttribute, 3),
  [1215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 10, .production_id = 223), SHIFT(615),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 10, .production_id = 223),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 10, .production_id = 223),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttribute, 2, .production_id = 39),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttribute, 2, .production_id = 39),
  [1226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 3, .production_id = 14), SHIFT(615),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 3, .production_id = 14),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 3, .production_id = 14),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttribute, 5, .production_id = 157),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttribute, 5, .production_id = 157),
  [1237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 32), SHIFT(615),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 32),
  [1242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 4, .production_id = 32),
  [1244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 33), SHIFT(615),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 33),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 4, .production_id = 33),
  [1251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 141), SHIFT(615),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 141),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 7, .production_id = 141),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declVar_repeat1, 1, .production_id = 17),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declVar_repeat1, 1, .production_id = 17),
  [1262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 200), SHIFT(615),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 200),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 9, .production_id = 200),
  [1269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 111), SHIFT(615),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 111),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 111),
  [1276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 110), SHIFT(615),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 110),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 110),
  [1283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(615),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40),
  [1290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1813),
  [1293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1783),
  [1296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(775),
  [1299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(683),
  [1302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(836),
  [1305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(2408),
  [1308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 206), SHIFT(615),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 206),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 9, .production_id = 206),
  [1315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 205), SHIFT(615),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 205),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 9, .production_id = 205),
  [1322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 204), SHIFT(615),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 204),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 9, .production_id = 204),
  [1329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 109), SHIFT(615),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 109),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 109),
  [1336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 108), SHIFT(615),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 108),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 108),
  [1343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 35), SHIFT(615),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 35),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 4, .production_id = 35),
  [1350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 174), SHIFT(615),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 174),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 174),
  [1357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 175), SHIFT(615),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 175),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 175),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 176), SHIFT(615),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 176),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 176),
  [1371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 180), SHIFT(615),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 180),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 180),
  [1378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 181), SHIFT(615),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 181),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 181),
  [1385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 107), SHIFT(615),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 107),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 107),
  [1392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 182), SHIFT(615),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 182),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 182),
  [1399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 106), SHIFT(615),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 106),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 106),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 73), SHIFT(615),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 73),
  [1411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 5, .production_id = 73),
  [1413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 183), SHIFT(615),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 183),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 183),
  [1420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 105), SHIFT(615),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 105),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 105),
  [1427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 184), SHIFT(615),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 184),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 8, .production_id = 184),
  [1434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 104), SHIFT(615),
  [1437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 104),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 104),
  [1441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 103), SHIFT(615),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 103),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 103),
  [1448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 102), SHIFT(615),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 102),
  [1453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 102),
  [1455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 101), SHIFT(615),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 101),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declProc, 6, .production_id = 101),
  [1462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 4, .production_id = 60), SHIFT(604),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 4, .production_id = 60), SHIFT(1783),
  [1468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 92), SHIFT(604),
  [1471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 5, .production_id = 92), SHIFT(1783),
  [1474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 8, .production_id = 199), SHIFT(604),
  [1477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 8, .production_id = 199), SHIFT(1783),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_literalString_repeat1, 2),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2),
  [1484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(225),
  [1487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1843),
  [1490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProcFwd_repeat1, 2, .production_id = 40), SHIFT_REPEAT(604),
  [1493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 101), SHIFT(604),
  [1496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 101), SHIFT(1783),
  [1499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 140), SHIFT(604),
  [1502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 7, .production_id = 140), SHIFT(1783),
  [1505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 173), SHIFT(604),
  [1508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 7, .production_id = 173), SHIFT(1783),
  [1511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 7, .production_id = 165), SHIFT(604),
  [1514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 7, .production_id = 165), SHIFT(1783),
  [1517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 99), SHIFT(604),
  [1520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 5, .production_id = 99), SHIFT(1783),
  [1523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 7, .production_id = 161), SHIFT(604),
  [1526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 7, .production_id = 161), SHIFT(1783),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literalString, 1),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literalString, 1),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 6, .production_id = 127), SHIFT(604),
  [1538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 6, .production_id = 127), SHIFT(1783),
  [1541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 6, .production_id = 128), SHIFT(604),
  [1544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 6, .production_id = 128), SHIFT(1783),
  [1547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 133), SHIFT(604),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 133), SHIFT(1783),
  [1553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 3, .production_id = 31), SHIFT(604),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 3, .production_id = 31), SHIFT(1783),
  [1559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 5, .production_id = 70), SHIFT(604),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 5, .production_id = 70), SHIFT(1783),
  [1565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 5, .production_id = 95), SHIFT(604),
  [1568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 5, .production_id = 95), SHIFT(1783),
  [1571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 108), SHIFT(604),
  [1574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 108), SHIFT(1783),
  [1577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declType, 6, .production_id = 138), SHIFT(604),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declType, 6, .production_id = 138), SHIFT(1783),
  [1583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 4, .production_id = 62), SHIFT(604),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 4, .production_id = 62), SHIFT(1783),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProcFwd_repeat1, 1, .production_id = 17),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declProcFwd_repeat1, 1, .production_id = 17),
  [1593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 4, .production_id = 63), SHIFT(604),
  [1596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 4, .production_id = 63), SHIFT(1783),
  [1599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConst, 5, .production_id = 93), SHIFT(604),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declConst, 5, .production_id = 93), SHIFT(1783),
  [1605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 72), SHIFT(614),
  [1608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 72), SHIFT(1783),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 142), SHIFT(604),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 142),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 142),
  [1620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 142), SHIFT(1783),
  [1623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 227), SHIFT(604),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 227),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 227),
  [1630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 227), SHIFT(1783),
  [1633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 140), SHIFT(604),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 140),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 140),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 140), SHIFT(1783),
  [1643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 226), SHIFT(604),
  [1646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 226),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 226),
  [1650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 226), SHIFT(1783),
  [1653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 205), SHIFT(602),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 205),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 9, .production_id = 205),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 145), SHIFT(604),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 145),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 145),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 145), SHIFT(1783),
  [1670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 150), SHIFT(604),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 150),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 150),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 150), SHIFT(1783),
  [1680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 225), SHIFT(604),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 225),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 7, .production_id = 225),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 225), SHIFT(1783),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 230), SHIFT(604),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 230),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 230),
  [1697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 230), SHIFT(1783),
  [1700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 231), SHIFT(604),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 231),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 231),
  [1707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 231), SHIFT(1783),
  [1710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 10, .production_id = 222), SHIFT(615),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 10, .production_id = 222),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 10, .production_id = 222),
  [1717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 175), SHIFT(604),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 175),
  [1722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 175),
  [1724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 175), SHIFT(1783),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 101), SHIFT(604),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 101),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 6, .production_id = 101),
  [1734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 101), SHIFT(1783),
  [1737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 110), SHIFT(604),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 110),
  [1742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 6, .production_id = 110),
  [1744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 110), SHIFT(1783),
  [1747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 214), SHIFT(604),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 214),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 6, .production_id = 214),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 214), SHIFT(1783),
  [1757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 108), SHIFT(604),
  [1760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 108),
  [1762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 6, .production_id = 108),
  [1764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 108), SHIFT(1783),
  [1767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 232), SHIFT(604),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 232),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 232),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 232), SHIFT(1783),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 180), SHIFT(604),
  [1780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 180),
  [1782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 180),
  [1784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 180), SHIFT(1783),
  [1787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 207), SHIFT(615),
  [1790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 207),
  [1792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 9, .production_id = 207),
  [1794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 233), SHIFT(604),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 233),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 233),
  [1801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 233), SHIFT(1783),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 182), SHIFT(604),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 182),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 8, .production_id = 182),
  [1811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 182), SHIFT(1783),
  [1814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 235), SHIFT(604),
  [1817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 235),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 9, .production_id = 235),
  [1821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 235), SHIFT(1783),
  [1824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 236), SHIFT(604),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 236),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 9, .production_id = 236),
  [1831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 236), SHIFT(1783),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 205), SHIFT(604),
  [1837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 205), SHIFT(1783),
  [1840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 203), SHIFT(615),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 203),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 9, .production_id = 203),
  [1847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 202), SHIFT(615),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 202),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 9, .production_id = 202),
  [1854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 200), SHIFT(615),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 200),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 9, .production_id = 200),
  [1861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 237), SHIFT(604),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 237),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 9, .production_id = 237),
  [1868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 237), SHIFT(1783),
  [1871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 10, .production_id = 238), SHIFT(604),
  [1874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 10, .production_id = 238),
  [1876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 10, .production_id = 238),
  [1878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 10, .production_id = 238), SHIFT(1783),
  [1881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 201), SHIFT(615),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 201),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 9, .production_id = 201),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 10, .production_id = 238), SHIFT(602),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 237), SHIFT(602),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 5, .production_id = 70), SHIFT(602),
  [1897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProp, 5, .production_id = 70),
  [1899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProp, 5, .production_id = 70),
  [1901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 236), SHIFT(602),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 3, .production_id = 14), SHIFT(614),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 3, .production_id = 14), SHIFT(1783),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 9, .production_id = 235), SHIFT(602),
  [1913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 182), SHIFT(602),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 32), SHIFT(614),
  [1919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 32), SHIFT(1783),
  [1922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 5, .production_id = 70), SHIFT(604),
  [1925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 5, .production_id = 70), SHIFT(1783),
  [1928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 187), SHIFT(615),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 187),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 187),
  [1935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 186), SHIFT(615),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 186),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 186),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 184), SHIFT(615),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 184),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 184),
  [1949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 185), SHIFT(615),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 185),
  [1954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 185),
  [1956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 233), SHIFT(602),
  [1959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 33), SHIFT(614),
  [1962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 33), SHIFT(1783),
  [1965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 34), SHIFT(614),
  [1968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 34), SHIFT(1783),
  [1971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 35), SHIFT(614),
  [1974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 35), SHIFT(1783),
  [1977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 180), SHIFT(602),
  [1980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 232), SHIFT(602),
  [1983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 175), SHIFT(602),
  [1986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 66), SHIFT(614),
  [1989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 66), SHIFT(1783),
  [1992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 179), SHIFT(615),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 179),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 179),
  [1999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 176), SHIFT(615),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 176),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 176),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 175), SHIFT(615),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 175),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 175),
  [2013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 178), SHIFT(615),
  [2016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 178),
  [2018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 178),
  [2020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 177), SHIFT(615),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 177),
  [2025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 177),
  [2027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 174), SHIFT(615),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 174),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 8, .production_id = 174),
  [2034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 67), SHIFT(614),
  [2037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 67), SHIFT(1783),
  [2040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 68), SHIFT(614),
  [2043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 68), SHIFT(1783),
  [2046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 69), SHIFT(614),
  [2049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 69), SHIFT(1783),
  [2052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 231), SHIFT(602),
  [2055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(614),
  [2058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(836),
  [2061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 70), SHIFT(614),
  [2064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 70), SHIFT(1783),
  [2067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 71), SHIFT(614),
  [2070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 71), SHIFT(1783),
  [2073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 73), SHIFT(614),
  [2076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 73), SHIFT(1783),
  [2079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 5, .production_id = 70), SHIFT(614),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 5, .production_id = 70),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 5, .production_id = 70),
  [2086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 5, .production_id = 70), SHIFT(1783),
  [2089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 8, .production_id = 230), SHIFT(602),
  [2092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 101), SHIFT(614),
  [2095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 101), SHIFT(1783),
  [2098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 102), SHIFT(614),
  [2101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 102), SHIFT(1783),
  [2104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 103), SHIFT(614),
  [2107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 103), SHIFT(1783),
  [2110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 104), SHIFT(614),
  [2113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 104), SHIFT(1783),
  [2116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 101), SHIFT(614),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 101),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 6, .production_id = 101),
  [2123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 101), SHIFT(1783),
  [2126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 105), SHIFT(614),
  [2129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 105), SHIFT(1783),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 106), SHIFT(614),
  [2135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 106), SHIFT(1783),
  [2138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 145), SHIFT(602),
  [2141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 107), SHIFT(614),
  [2144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 107), SHIFT(1783),
  [2147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 142), SHIFT(602),
  [2150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 108), SHIFT(614),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 108), SHIFT(1783),
  [2156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 109), SHIFT(614),
  [2159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 109), SHIFT(1783),
  [2162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 110), SHIFT(614),
  [2165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 110), SHIFT(1783),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 154), SHIFT(615),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 154),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 154),
  [2175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 151), SHIFT(615),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 151),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 151),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 150), SHIFT(615),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 150),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 150),
  [2189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 111), SHIFT(614),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 111), SHIFT(1783),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 153), SHIFT(615),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 153),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 153),
  [2202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 108), SHIFT(614),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 108),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 6, .production_id = 108),
  [2209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 108), SHIFT(1783),
  [2212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 152), SHIFT(615),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 152),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 152),
  [2219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 149), SHIFT(615),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 149),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 149),
  [2226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 109), SHIFT(614),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 109),
  [2231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 6, .production_id = 109),
  [2233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 109), SHIFT(1783),
  [2236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 112), SHIFT(614),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 112),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 6, .production_id = 112),
  [2243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 112), SHIFT(1783),
  [2246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 110), SHIFT(614),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 110),
  [2251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 6, .production_id = 110),
  [2253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 110), SHIFT(1783),
  [2256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 227), SHIFT(602),
  [2259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 140), SHIFT(614),
  [2262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 140), SHIFT(1783),
  [2265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 141), SHIFT(614),
  [2268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 141), SHIFT(1783),
  [2271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 142), SHIFT(614),
  [2274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 142), SHIFT(1783),
  [2277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 143), SHIFT(614),
  [2280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 143), SHIFT(1783),
  [2283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 140), SHIFT(614),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 140),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 140),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 140), SHIFT(1783),
  [2293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 141), SHIFT(614),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 141),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 141),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 141), SHIFT(1783),
  [2303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 142), SHIFT(615),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 142),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 142),
  [2310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 144), SHIFT(615),
  [2313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 144),
  [2315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declOperator, 7, .production_id = 144),
  [2317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 141), SHIFT(615),
  [2320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 140), SHIFT(615),
  [2323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 144), SHIFT(614),
  [2326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 144), SHIFT(1783),
  [2329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 142), SHIFT(614),
  [2332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 142), SHIFT(1783),
  [2335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 145), SHIFT(614),
  [2338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 145), SHIFT(1783),
  [2341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 146), SHIFT(614),
  [2344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 146), SHIFT(1783),
  [2347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 147), SHIFT(614),
  [2350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 147), SHIFT(1783),
  [2353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 148), SHIFT(614),
  [2356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 148), SHIFT(1783),
  [2359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 140), SHIFT(602),
  [2362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 149), SHIFT(614),
  [2365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 149), SHIFT(1783),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 150), SHIFT(614),
  [2371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 150), SHIFT(1783),
  [2374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 151), SHIFT(614),
  [2377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 151), SHIFT(1783),
  [2380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 149), SHIFT(614),
  [2383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 149), SHIFT(1783),
  [2386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 152), SHIFT(614),
  [2389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 152), SHIFT(1783),
  [2392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 153), SHIFT(614),
  [2395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 153), SHIFT(1783),
  [2398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 150), SHIFT(614),
  [2401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 150), SHIFT(1783),
  [2404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 151), SHIFT(614),
  [2407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 151), SHIFT(1783),
  [2410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 154), SHIFT(614),
  [2413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 154), SHIFT(1783),
  [2416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 174), SHIFT(614),
  [2419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 174), SHIFT(1783),
  [2422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 175), SHIFT(614),
  [2425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 175), SHIFT(1783),
  [2428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 176), SHIFT(614),
  [2431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 176), SHIFT(1783),
  [2434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 174), SHIFT(614),
  [2437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 174), SHIFT(1783),
  [2440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 110), SHIFT(615),
  [2443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 112), SHIFT(615),
  [2446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 109), SHIFT(615),
  [2449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 108), SHIFT(615),
  [2452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 177), SHIFT(614),
  [2455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 177), SHIFT(1783),
  [2458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 178), SHIFT(614),
  [2461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 178), SHIFT(1783),
  [2464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 175), SHIFT(614),
  [2467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 175), SHIFT(1783),
  [2470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 176), SHIFT(614),
  [2473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 176), SHIFT(1783),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 179), SHIFT(614),
  [2479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 179), SHIFT(1783),
  [2482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 180), SHIFT(614),
  [2485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 180), SHIFT(1783),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 181), SHIFT(614),
  [2491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 181), SHIFT(1783),
  [2494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 101), SHIFT(615),
  [2497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 182), SHIFT(614),
  [2500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 182), SHIFT(1783),
  [2503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 183), SHIFT(614),
  [2506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 183), SHIFT(1783),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 226), SHIFT(602),
  [2512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 184), SHIFT(614),
  [2515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 184), SHIFT(1783),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 150), SHIFT(602),
  [2521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 185), SHIFT(614),
  [2524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 185), SHIFT(1783),
  [2527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 7, .production_id = 225), SHIFT(602),
  [2530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 184), SHIFT(614),
  [2533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 184), SHIFT(1783),
  [2536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 186), SHIFT(614),
  [2539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 186), SHIFT(1783),
  [2542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 187), SHIFT(614),
  [2545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 187), SHIFT(1783),
  [2548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 200), SHIFT(614),
  [2551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 200), SHIFT(1783),
  [2554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 201), SHIFT(614),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 201), SHIFT(1783),
  [2560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 200), SHIFT(614),
  [2563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 200), SHIFT(1783),
  [2566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 202), SHIFT(614),
  [2569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 202), SHIFT(1783),
  [2572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 101), SHIFT(602),
  [2575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 203), SHIFT(614),
  [2578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 203), SHIFT(1783),
  [2581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 204), SHIFT(614),
  [2584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 204), SHIFT(1783),
  [2587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 110), SHIFT(602),
  [2590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 5, .production_id = 70), SHIFT(615),
  [2593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 214), SHIFT(602),
  [2596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 205), SHIFT(614),
  [2599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 205), SHIFT(1783),
  [2602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declProp, 6, .production_id = 108), SHIFT(602),
  [2605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 206), SHIFT(614),
  [2608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 206), SHIFT(1783),
  [2611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 207), SHIFT(614),
  [2614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 207), SHIFT(1783),
  [2617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 10, .production_id = 222), SHIFT(614),
  [2620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 10, .production_id = 222), SHIFT(1783),
  [2623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 10, .production_id = 223), SHIFT(614),
  [2626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 10, .production_id = 223), SHIFT(1783),
  [2629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 101), SHIFT(619),
  [2632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 66), SHIFT(619),
  [2635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 67), SHIFT(619),
  [2638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 68), SHIFT(619),
  [2641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 102), SHIFT(619),
  [2644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 103), SHIFT(619),
  [2647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 104), SHIFT(619),
  [2650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 33), SHIFT(619),
  [2653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 32), SHIFT(619),
  [2656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 34), SHIFT(619),
  [2659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 4, .production_id = 35), SHIFT(619),
  [2662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 205), SHIFT(619),
  [2665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 105), SHIFT(619),
  [2668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 106), SHIFT(619),
  [2671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 107), SHIFT(619),
  [2674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 206), SHIFT(619),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 108), SHIFT(619),
  [2680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 71), SHIFT(619),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttributeNoExt, 2, .production_id = 39),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttributeNoExt, 2, .production_id = 39),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttributeNoExt, 3),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttributeNoExt, 3),
  [2691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 143), SHIFT(619),
  [2694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 204), SHIFT(619),
  [2697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 69), SHIFT(619),
  [2700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 142), SHIFT(619),
  [2703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 141), SHIFT(619),
  [2706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttributeNoExt, 4, .production_id = 118),
  [2708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttributeNoExt, 4, .production_id = 118),
  [2710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 109), SHIFT(619),
  [2713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 72), SHIFT(619),
  [2716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 110), SHIFT(619),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procAttributeNoExt, 5, .production_id = 157),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procAttributeNoExt, 5, .production_id = 157),
  [2723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 6, .production_id = 111), SHIFT(619),
  [2726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 151), SHIFT(619),
  [2729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 140), SHIFT(619),
  [2732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 10, .production_id = 223), SHIFT(619),
  [2735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 150), SHIFT(619),
  [2738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 149), SHIFT(619),
  [2741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 174), SHIFT(619),
  [2744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 175), SHIFT(619),
  [2747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 176), SHIFT(619),
  [2750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 9, .production_id = 200), SHIFT(619),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 1, .production_id = 17),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declProc_repeat1, 1, .production_id = 17),
  [2757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 145), SHIFT(619),
  [2760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 146), SHIFT(619),
  [2763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 147), SHIFT(619),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 3, .production_id = 14), SHIFT(619),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 180), SHIFT(619),
  [2772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 181), SHIFT(619),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 73), SHIFT(619),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 7, .production_id = 148), SHIFT(619),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 182), SHIFT(619),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 5, .production_id = 70), SHIFT(619),
  [2787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 183), SHIFT(619),
  [2790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declProc, 8, .production_id = 184), SHIFT(619),
  [2793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declProc_repeat1, 2, .production_id = 40), SHIFT_REPEAT(619),
  [2796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literalChar, 2),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literalChar, 2),
  [2800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 153), SHIFT(619),
  [2803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 185), SHIFT(619),
  [2806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 184), SHIFT(619),
  [2809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 186), SHIFT(619),
  [2812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 187), SHIFT(619),
  [2815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 101), SHIFT(619),
  [2818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 110), SHIFT(619),
  [2821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 5, .production_id = 70), SHIFT(619),
  [2824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 112), SHIFT(619),
  [2827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 179), SHIFT(619),
  [2830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 176), SHIFT(619),
  [2833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 175), SHIFT(619),
  [2836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 178), SHIFT(619),
  [2839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 177), SHIFT(619),
  [2842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 201), SHIFT(619),
  [2845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 200), SHIFT(619),
  [2848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 202), SHIFT(619),
  [2851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 203), SHIFT(619),
  [2854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 8, .production_id = 174), SHIFT(619),
  [2857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 10, .production_id = 222), SHIFT(619),
  [2860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 109), SHIFT(619),
  [2863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 6, .production_id = 108), SHIFT(619),
  [2866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 149), SHIFT(619),
  [2869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 152), SHIFT(619),
  [2872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 140), SHIFT(619),
  [2875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprUnary, 2, .production_id = 9),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprUnary, 2, .production_id = 9),
  [2879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 150), SHIFT(619),
  [2882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 141), SHIFT(619),
  [2885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 9, .production_id = 207), SHIFT(619),
  [2888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 151), SHIFT(619),
  [2891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 144), SHIFT(619),
  [2894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 142), SHIFT(619),
  [2897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declOperator, 7, .production_id = 154), SHIFT(619),
  [2900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprAs, 3, .production_id = 23),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprAs, 3, .production_id = 23),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 5),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [2924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inherited, 2),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inherited, 2),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 2, .production_id = 11),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 2, .production_id = 11),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprParens, 3),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprParens, 3),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ref, 2),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref, 2),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprBrackets, 3),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprBrackets, 3),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprBrackets, 2),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprBrackets, 2),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asmTr, 3),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asmTr, 3),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 5, .production_id = 77),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, .production_id = 77),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprBrackets, 4),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprBrackets, 4),
  [2986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 6, .production_id = 120),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 6, .production_id = 120),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inherited, 1),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inherited, 1),
  [2996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, .production_id = 43),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 43),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprDeref, 2, .production_id = 12),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprDeref, 2, .production_id = 12),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [3010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literalNumber, 1),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literalNumber, 1),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 4),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, .production_id = 45),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 45),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprCall, 3, .production_id = 24),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprCall, 3, .production_id = 24),
  [3042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 5, .production_id = 80),
  [3044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, .production_id = 80),
  [3046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprBinary, 3, .production_id = 23),
  [3048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprBinary, 3, .production_id = 23),
  [3050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, .production_id = 22),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 22),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprSubscript, 4, .production_id = 46),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprSubscript, 4, .production_id = 46),
  [3058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprCall, 4, .production_id = 46),
  [3060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprCall, 4, .production_id = 46),
  [3062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asmTr, 2),
  [3064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asmTr, 2),
  [3066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, .production_id = 20),
  [3068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 20),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [3086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeref, 1),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeref, 1),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typerefPtr, 2, .production_id = 9),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typerefPtr, 2, .production_id = 9),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typerefDot, 3, .production_id = 23),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typerefDot, 3, .production_id = 23),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeref, 2, .production_id = 41),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeref, 2, .production_id = 41),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 44),
  [3112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, .production_id = 44),
  [3114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__definition, 1),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__definition, 1),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, .production_id = 79),
  [3120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 5, .production_id = 79),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 6, .production_id = 119),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 6, .production_id = 119),
  [3126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typerefTpl, 4, .production_id = 46),
  [3128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typerefTpl, 4, .production_id = 46),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, .production_id = 76),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 5, .production_id = 76),
  [3134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 2, .production_id = 10),
  [3136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 2, .production_id = 10),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 42),
  [3140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, .production_id = 42),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 21),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, .production_id = 21),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 19),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, .production_id = 19),
  [3150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1),
  [3152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exprDot, 3, .production_id = 23),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprDot, 3, .production_id = 23),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [3166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 1, .production_id = 188),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [3172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declProp_repeat2, 1, .production_id = 188),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 1),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [3204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ref, 1, .production_id = 3),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref, 1, .production_id = 3),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [3228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1114),
  [3231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(652),
  [3234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(872),
  [3237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1069),
  [3240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1890),
  [3243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1131),
  [3246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1131),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2),
  [3251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1106),
  [3254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(892),
  [3257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(892),
  [3260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(926),
  [3263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(1107),
  [3266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1813),
  [3269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1783),
  [3272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(631),
  [3275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(775),
  [3278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(683),
  [3281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(836),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 40), SHIFT_REPEAT(2408),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 2),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [3307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1813),
  [3310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 40), SHIFT_REPEAT(1783),
  [3313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 40), SHIFT_REPEAT(775),
  [3316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 40), SHIFT_REPEAT(683),
  [3319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 40), SHIFT_REPEAT(836),
  [3322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 40), SHIFT_REPEAT(2408),
  [3325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(1148),
  [3328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(685),
  [3331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(617),
  [3334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(233),
  [3337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(1843),
  [3340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(533),
  [3343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(533),
  [3346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(681),
  [3349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(829),
  [3352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(829),
  [3355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(920),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(528),
  [3361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2), SHIFT_REPEAT(687),
  [3364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1114),
  [3367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(652),
  [3370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(872),
  [3373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1069),
  [3376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1890),
  [3379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1131),
  [3382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1131),
  [3385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1106),
  [3388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(892),
  [3391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(892),
  [3394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(926),
  [3397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2), SHIFT_REPEAT(1107),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 2),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [3416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(687),
  [3419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(685),
  [3422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(617),
  [3425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(233),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(1843),
  [3431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(533),
  [3434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(533),
  [3437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(681),
  [3440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(829),
  [3443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(829),
  [3446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(920),
  [3449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2), SHIFT_REPEAT(528),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 3),
  [3454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [3456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 1),
  [3462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__procAttribute_repeat1, 2, .production_id = 39),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 4, .production_id = 137),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 3, .production_id = 98),
  [3490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 195),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 170),
  [3504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 4, .production_id = 139),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procAttribute, 1),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__procAttributeNoExt_repeat1, 2, .production_id = 39),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 168),
  [3536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 7, .production_id = 220),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 4, .production_id = 137),
  [3548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 5, .production_id = 168),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 7, .production_id = 218),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 5, .production_id = 170),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 7, .production_id = 219),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [3574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 167),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6, .production_id = 198),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 171),
  [3584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [3586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1114),
  [3589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(652),
  [3592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(872),
  [3595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1069),
  [3598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1890),
  [3601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1131),
  [3604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1131),
  [3607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1106),
  [3610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(892),
  [3613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(892),
  [3616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(926),
  [3619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2), SHIFT_REPEAT(1107),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 2, .production_id = 65),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 5, .production_id = 172),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [3630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 194),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 4, .production_id = 139),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [3638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 197),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [3642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1114),
  [3645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(652),
  [3648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(872),
  [3651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1069),
  [3654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1890),
  [3657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1131),
  [3660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1131),
  [3663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1106),
  [3666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(892),
  [3669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(892),
  [3672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(926),
  [3675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2), SHIFT_REPEAT(1107),
  [3678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 3, .production_id = 100),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [3682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 3, .production_id = 98),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6, .production_id = 196),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [3702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6, .production_id = 195),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [3706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 9, .production_id = 234),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 8, .production_id = 229),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 7, .production_id = 221),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 8, .production_id = 228),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [3722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 4, .production_id = 136),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [3726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(740),
  [3729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1825),
  [3732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(687),
  [3735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(685),
  [3738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(820),
  [3741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(233),
  [3744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(1843),
  [3747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(533),
  [3750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(533),
  [3753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(681),
  [3756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(829),
  [3759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(829),
  [3762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(920),
  [3765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 30), SHIFT_REPEAT(528),
  [3768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 8),
  [3770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 8),
  [3772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with, 4, .production_id = 57),
  [3774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with, 4, .production_id = 57),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [3778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 9),
  [3780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 9),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [3784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 4, .production_id = 28),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 4, .production_id = 28),
  [3788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(687),
  [3791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(685),
  [3794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(820),
  [3797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(233),
  [3800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(1843),
  [3803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(533),
  [3806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(533),
  [3809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(681),
  [3812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(829),
  [3815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(829),
  [3818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(920),
  [3821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2), SHIFT_REPEAT(528),
  [3824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 4, .production_id = 27),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 4, .production_id = 27),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat, 4, .production_id = 26),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat, 4, .production_id = 26),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 4, .production_id = 50),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, .production_id = 50),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 10),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 10),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [3842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, .production_id = 49),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, .production_id = 49),
  [3846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm, 4),
  [3848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm, 4),
  [3850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4),
  [3852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4),
  [3854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(687),
  [3857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(685),
  [3860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(820),
  [3863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(233),
  [3866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(1843),
  [3869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(533),
  [3872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(533),
  [3875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(681),
  [3878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(829),
  [3881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(829),
  [3884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(920),
  [3887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2), SHIFT_REPEAT(528),
  [3890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(687),
  [3893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(685),
  [3896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(820),
  [3899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(233),
  [3902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(1843),
  [3905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(533),
  [3908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(533),
  [3911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(681),
  [3914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(829),
  [3917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(829),
  [3920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(920),
  [3923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2), SHIFT_REPEAT(528),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 7),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 7),
  [3930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto, 3),
  [3932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto, 3),
  [3934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raise, 3, .production_id = 13),
  [3936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise, 3, .production_id = 13),
  [3938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm, 3),
  [3940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm, 3),
  [3942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [3952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 2),
  [3954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2),
  [3956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 2),
  [3958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 2),
  [3960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(1288),
  [3963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(685),
  [3966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(820),
  [3969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(233),
  [3972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(1843),
  [3975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(533),
  [3978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(533),
  [3981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(681),
  [3984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(829),
  [3987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(829),
  [3990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(920),
  [3993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2), SHIFT_REPEAT(528),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6),
  [4002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 6, .production_id = 87),
  [4004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 6, .production_id = 87),
  [4006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 6, .production_id = 86),
  [4008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 6, .production_id = 86),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [4014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifElse, 6, .production_id = 123),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifElse, 6, .production_id = 123),
  [4018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach, 6, .production_id = 122),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach, 6, .production_id = 122),
  [4022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 6, .production_id = 121),
  [4024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 6, .production_id = 121),
  [4026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifElse, 5, .production_id = 85),
  [4028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifElse, 5, .production_id = 85),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [4032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, .production_id = 4),
  [4034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, .production_id = 4),
  [4036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat, 5, .production_id = 51),
  [4038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat, 5, .production_id = 51),
  [4040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 5, .production_id = 52),
  [4042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 5, .production_id = 52),
  [4044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 5, .production_id = 53),
  [4046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 5, .production_id = 53),
  [4048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 5, .production_id = 54),
  [4050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 5, .production_id = 54),
  [4052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 5, .production_id = 55),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 5, .production_id = 55),
  [4056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [4062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with, 5, .production_id = 89),
  [4064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with, 5, .production_id = 89),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(908),
  [4101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1897),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statementsTr_repeat1, 1),
  [4116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statementsTr_repeat1, 1),
  [4118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statementsTr, 2),
  [4120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statementsTr, 1),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [4128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implementation, 2),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [4136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(706),
  [4139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1712),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__definitions, 2),
  [4144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(48),
  [4147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1085),
  [4150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1096),
  [4153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1096),
  [4156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1077),
  [4159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1828),
  [4162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1655),
  [4165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1562),
  [4168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1697),
  [4171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1773),
  [4174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(1118),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [4205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implementation, 1),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [4267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declSection, 3),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [4293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declSection, 2),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [4297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declSection, 1),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [4303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(706),
  [4306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1712),
  [4309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declarations, 2),
  [4311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1085),
  [4314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1096),
  [4317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1096),
  [4320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1077),
  [4323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1828),
  [4326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1655),
  [4329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(2121),
  [4332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1499),
  [4335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1694),
  [4338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1754),
  [4341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations, 2), SHIFT_REPEAT(1119),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 2),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [4364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref, 1),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [4368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ref, 1),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__definitions, 2), SHIFT_REPEAT(49),
  [4387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 1),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [4407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_caseLabel, 2),
  [4409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseLabel, 2),
  [4411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_caseLabel, 3),
  [4413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseLabel, 3),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [4417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_root, 1),
  [4419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declArgs, 3),
  [4421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArgs, 3),
  [4423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declSection, 3),
  [4425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exceptionElse_repeat1, 1),
  [4427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exceptionElse_repeat1, 1),
  [4429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exceptionElse, 3),
  [4431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declSection, 4),
  [4433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declArgs, 2),
  [4435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArgs, 2),
  [4437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declArgs, 4),
  [4439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArgs, 4),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statementTr, 1),
  [4445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1070),
  [4456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1890),
  [4459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exceptionElse, 2),
  [4461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(706),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2),
  [4466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1116),
  [4469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1138),
  [4472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1138),
  [4475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1084),
  [4478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(2462),
  [4481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1508),
  [4484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1714),
  [4487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1764),
  [4490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__classDeclarations, 2), SHIFT_REPEAT(1115),
  [4493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declSection, 2),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declTypes, 2),
  [4497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [4499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declTypes, 2), SHIFT(706),
  [4502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declTypes, 2),
  [4504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declTypes, 2), SHIFT(1728),
  [4507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declTypes_repeat1, 2),
  [4509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declTypes_repeat1, 2), SHIFT_REPEAT(1724),
  [4512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declTypes_repeat1, 2), SHIFT_REPEAT(706),
  [4515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declTypes_repeat1, 2),
  [4517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declTypes_repeat1, 2), SHIFT_REPEAT(1728),
  [4520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declTypes, 1),
  [4522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declTypes, 1), SHIFT(706),
  [4525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declTypes, 1),
  [4527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declTypes, 1), SHIFT(1728),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2),
  [4534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1081),
  [4545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literalString_repeat1, 2), SHIFT_REPEAT(1844),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVars, 2),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [4552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVars, 2), SHIFT(706),
  [4555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVars, 2),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declVars_repeat1, 2),
  [4559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVars_repeat1, 2), SHIFT_REPEAT(1961),
  [4562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVars_repeat1, 2), SHIFT_REPEAT(706),
  [4565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declVars_repeat1, 2),
  [4567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [4569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declTypes, 1), SHIFT(1734),
  [4572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVars, 1),
  [4574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVars, 1), SHIFT(706),
  [4577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVars, 1),
  [4579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declTypes_repeat1, 2), SHIFT_REPEAT(1790),
  [4582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declTypes_repeat1, 2), SHIFT_REPEAT(1734),
  [4585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVars, 3),
  [4587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declVars, 3), SHIFT(706),
  [4590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVars, 3),
  [4592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_declTypes, 2), SHIFT(1734),
  [4595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProc, 2, .production_id = 8),
  [4597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProc, 2, .production_id = 8),
  [4599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConsts, 2),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [4603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConsts, 2), SHIFT(706),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConsts, 2),
  [4608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 210),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declConsts_repeat1, 2),
  [4618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declConsts_repeat1, 2), SHIFT_REPEAT(1879),
  [4621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declConsts_repeat1, 2), SHIFT_REPEAT(706),
  [4624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declConsts_repeat1, 2),
  [4626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConsts, 3),
  [4628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConsts, 3), SHIFT(706),
  [4631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConsts, 3),
  [4633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declConsts, 1),
  [4635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declConsts, 1), SHIFT(706),
  [4638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declConsts, 1),
  [4640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 3, .production_id = 224),
  [4642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProc, 1, .production_id = 2),
  [4644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProc, 1, .production_id = 2),
  [4646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProc, 2, .production_id = 7),
  [4648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProc, 2, .production_id = 7),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [4652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 212),
  [4654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declVars_repeat1, 2), SHIFT_REPEAT(2044),
  [4657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [4659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [4667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declFields, 2), SHIFT_REPEAT(2095),
  [4670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declFields, 2), SHIFT_REPEAT(706),
  [4673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declFields, 2),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [4683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 213),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 211),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [4691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [4693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declConsts_repeat1, 2), SHIFT_REPEAT(1908),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raiseTr, 2, .production_id = 13),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [4726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeatTr, 3, .production_id = 26),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeatTr, 4, .production_id = 51),
  [4732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 23),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [4750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprArgs, 2),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprArgs, 1),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declUses, 4),
  [4826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declUses, 4),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declExports, 4),
  [4830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declExports, 4),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declExports, 3),
  [4834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declExports, 3),
  [4836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declExports, 2),
  [4838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declExports, 2),
  [4840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declLabels, 4),
  [4842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declLabels, 4),
  [4844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declExport_repeat1, 2),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProc, 1, .production_id = 1),
  [4848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declProc, 1, .production_id = 1),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [4852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declLabels, 3),
  [4854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declLabels, 3),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declUses, 3),
  [4858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declUses, 3),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 1),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [4868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declUses, 2),
  [4870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declUses, 2),
  [4872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_guid, 3),
  [4874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guid, 3),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_legacyFormat_repeat1, 2),
  [4884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 7, .production_id = 156),
  [4886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 7, .production_id = 156),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 4, .production_id = 36),
  [4898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 4, .production_id = 36),
  [4900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 4, .production_id = 37),
  [4902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 4, .production_id = 37),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [4910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 5, .production_id = 70),
  [4912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 5, .production_id = 70),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 6, .production_id = 117),
  [4918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 6, .production_id = 117),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 6, .production_id = 116),
  [4922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 6, .production_id = 116),
  [4924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 6, .production_id = 115),
  [4926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 6, .production_id = 115),
  [4928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procAttribute, 2),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 5, .production_id = 93),
  [4936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 5, .production_id = 93),
  [4938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 6, .production_id = 113),
  [4940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 6, .production_id = 113),
  [4942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 6, .production_id = 128),
  [4944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 6, .production_id = 128),
  [4946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 7, .production_id = 155),
  [4948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 7, .production_id = 155),
  [4950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 6, .production_id = 129),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 6, .production_id = 129),
  [4954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 6, .production_id = 131),
  [4956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 6, .production_id = 131),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 7, .production_id = 163),
  [4962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 7, .production_id = 163),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 3, .production_id = 15),
  [4972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 3, .production_id = 15),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [4984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 5, .production_id = 75),
  [4986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 5, .production_id = 75),
  [4988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 4, .production_id = 60),
  [4990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 4, .production_id = 60),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 5, .production_id = 74),
  [4998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 5, .production_id = 74),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [5004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defProc, 3, .production_id = 16),
  [5006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defProc, 3, .production_id = 16),
  [5008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procAttribute, 3),
  [5010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declField, 5, .production_id = 94),
  [5012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declField, 5, .production_id = 94),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [5080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declVariant_repeat1, 2),
  [5082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariant, 7, .production_id = 217),
  [5084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declVariant_repeat1, 2),
  [5086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVariant, 7, .production_id = 217),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariant, 5, .production_id = 169),
  [5102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVariant, 5, .production_id = 169),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [5108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_kDot, 1),
  [5110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kDot, 1),
  [5112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariant, 8, .production_id = 217),
  [5114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVariant, 8, .production_id = 217),
  [5116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [5118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__initializer, 1),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [5122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariant, 6, .production_id = 169),
  [5124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declVariant, 6, .production_id = 169),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [5130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_caseCase, 2, .production_id = 88),
  [5132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseCase, 2, .production_id = 88),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [5138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declArray_repeat1, 2),
  [5140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declArray_repeat1, 2),
  [5142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 2),
  [5144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 2),
  [5146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 24),
  [5148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_repeat1, 2, .production_id = 24),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [5154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_arrInitializer_repeat1, 2),
  [5156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arrInitializer_repeat1, 2),
  [5158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exprTpl_repeat1, 2),
  [5160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exprTpl_repeat1, 2),
  [5162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exprArgs_repeat1, 3),
  [5164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exprArgs_repeat1, 3),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [5170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declProp_repeat1, 2),
  [5172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat1, 2),
  [5174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2),
  [5176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat1, 2),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [5180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_caseLabel_repeat1, 2),
  [5182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_caseLabel_repeat1, 2),
  [5184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_recInitializer_repeat1, 2),
  [5186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recInitializer_repeat1, 2),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [5190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 1),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [5196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 3),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [5202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varDef, 4, .production_id = 48),
  [5204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varAssignDef, 4, .production_id = 48),
  [5206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 4, .production_id = 126),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [5212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 2, .production_id = 59),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [5218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 5, .production_id = 159),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [5224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declString, 1),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [5228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declFile, 1),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 4, .production_id = 125),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [5236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 6, .production_id = 190),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [5240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 3, .production_id = 91),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [5244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 5, .production_id = 91),
  [5246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 4, .production_id = 59),
  [5248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 5),
  [5250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArray, 7),
  [5252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArray, 3),
  [5254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declFile, 3),
  [5256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 7, .production_id = 159),
  [5258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [5260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3),
  [5262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declMetaClass, 3),
  [5264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declSet, 3),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declEnum, 3),
  [5268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArray, 6),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declEnum, 4),
  [5272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 6, .production_id = 125),
  [5274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 4),
  [5276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 6, .production_id = 126),
  [5278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArray, 5),
  [5280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declString, 4),
  [5282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArray, 8),
  [5284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declProcRef, 8, .production_id = 190),
  [5286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArray, 4),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [5292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declClass_repeat1, 2),
  [5296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declClass_repeat1, 2), SHIFT_REPEAT(966),
  [5299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declClass_repeat1, 2), SHIFT_REPEAT(1653),
  [5302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rttiAttributes, 1),
  [5304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat2, 2),
  [5306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat2, 2), SHIFT_REPEAT(706),
  [5309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_genericDot, 3, .production_id = 23),
  [5311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericDot, 3, .production_id = 23),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [5317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 5, .production_id = 86),
  [5319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat2, 5),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat2, 5),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [5325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat2, 2),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseTr, 5),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [5349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gotoTr, 2),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat2, 6),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat2, 6),
  [5355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat2, 4),
  [5357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat2, 4),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [5361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 5, .production_id = 87),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [5385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 3, .production_id = 27),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [5389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_genericTpl, 4, .production_id = 46),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericTpl, 4, .production_id = 46),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [5403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rttiAttributes_repeat2, 3),
  [5405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rttiAttributes_repeat2, 3),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [5409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 3, .production_id = 28),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseTr, 6),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [5427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statementTr, 1),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 4, .production_id = 53),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [5435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 4, .production_id = 55),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [5439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseTr, 4),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 4, .production_id = 52),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [5447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tryTr, 4, .production_id = 54),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [5453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseTr, 8),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [5459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseTr, 7),
  [5461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(984),
  [5464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(927),
  [5467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(6),
  [5470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2), SHIFT_REPEAT(7),
  [5473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unit_repeat1, 2),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseTr, 9),
  [5479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_withTr, 4, .production_id = 57),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statementTr, 1, .production_id = 5),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [5509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_whileTr, 4, .production_id = 50),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [5513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifElseTr, 5, .production_id = 85),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [5527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forTr, 6, .production_id = 121),
  [5529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreachTr, 6, .production_id = 122),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [5547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_withTr, 5, .production_id = 89),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [5551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declClass_repeat1, 2), SHIFT_REPEAT(550),
  [5554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declClass_repeat1, 2), SHIFT_REPEAT(1669),
  [5557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declClass_repeat1, 2), SHIFT_REPEAT(1668),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifElseTr, 6, .production_id = 123),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [5626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215),
  [5628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(2432),
  [5631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(2430),
  [5634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(594),
  [5637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(879),
  [5640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(1578),
  [5643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(876),
  [5646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 215), SHIFT_REPEAT(809),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [5667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 209),
  [5669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declPropArgs_repeat1, 2), SHIFT_REPEAT(1941),
  [5672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declPropArgs_repeat1, 2), SHIFT_REPEAT(2037),
  [5675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [5677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statementsTr, 2),
  [5679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declProp_repeat2, 2, .production_id = 208),
  [5681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declExport, 1),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [5687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [5697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [5709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [5715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [5717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [5719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [5721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [5725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [5727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [5729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_typerefArgs_repeat1, 2), SHIFT_REPEAT(1776),
  [5732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_typerefArgs_repeat1, 2), SHIFT_REPEAT(1668),
  [5735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declExports_repeat1, 2), SHIFT_REPEAT(1611),
  [5738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 2, .production_id = 64),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 1, .production_id = 6),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [5768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varAssignDef, 2),
  [5770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifTr, 4, .production_id = 49),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [5774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operatorName, 1),
  [5776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operatorName, 1),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [5790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_asmBody_repeat1, 2), SHIFT_REPEAT(1684),
  [5793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asmBody_repeat1, 2), SHIFT_REPEAT(1684),
  [5796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_asmBody_repeat1, 2),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [5806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asmBody, 1),
  [5808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialization, 2),
  [5810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finalization, 2),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_legacyFormat, 1),
  [5814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 5, .production_id = 129),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [5818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declExport_repeat1, 2), SHIFT_REPEAT(859),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [5825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 3, .production_id = 78),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [5829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 3, .production_id = 60),
  [5831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrInitializer, 3),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 2, .production_id = 14),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 4, .production_id = 70),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typerefArgs, 2),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [5847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [5851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrInitializer, 4),
  [5853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_legacyFormat_repeat1, 2), SHIFT_REPEAT(884),
  [5856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typerefArgs, 1),
  [5858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 4, .production_id = 94),
  [5860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recInitializer, 4),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [5868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declExport, 2),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [5872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recInitializer, 3),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [5876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defaultValue, 2),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declPropArgs_repeat1, 2),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [5884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declUses_repeat1, 2), SHIFT_REPEAT(1738),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [5889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exceptionHandlersTr, 2),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [5893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exceptionHandlers_repeat1, 1),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [5909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typeref, 1),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleName, 1),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 3, .production_id = 96),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [5949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_genericArgs_repeat1, 2), SHIFT_REPEAT(1696),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declVariantClause_repeat1, 2),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declVariantClause_repeat1, 2), SHIFT_REPEAT(1939),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [6009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exceptionHandlersTr, 1),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [6021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantField, 3, .production_id = 60),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [6033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantField, 4, .production_id = 94),
  [6035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declEnumValue, 1, .production_id = 6),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statementsTr, 1),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [6063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_moduleName, 2),
  [6065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 4, .production_id = 135),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [6099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptionHandler, 6, .production_id = 189),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [6155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantClause, 6),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [6163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exprArgs, 3),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [6171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declClass_repeat1, 2),
  [6173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declClass_repeat1, 2),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [6181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantClause, 7),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [6187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantClause, 5),
  [6189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 5, .production_id = 128),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [6195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 5, .production_id = 131),
  [6197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recInitializerField, 1, .production_id = 61),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [6203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 6, .production_id = 163),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [6207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(1299),
  [6210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [6218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantClause, 8),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [6222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_defProc_repeat1, 2, .production_id = 114), SHIFT_REPEAT(1022),
  [6225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_defProc_repeat1, 2, .production_id = 114),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [6235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariant, 6, .production_id = 217),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [6239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantClause, 3),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [6247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operatorName, 1),
  [6249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operatorName, 1),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [6257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declArg, 4, .production_id = 93),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [6265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declLabels_repeat1, 2), SHIFT_REPEAT(1953),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [6284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declEnum_repeat1, 2), SHIFT_REPEAT(1782),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantClause, 4),
  [6297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptionHandler, 4, .production_id = 124),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [6313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariant, 4, .production_id = 169),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exceptionHandlers_repeat1, 2), SHIFT_REPEAT(1618),
  [6322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operatorDot, 3, .production_id = 23),
  [6324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operatorDot, 3, .production_id = 23),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [6356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptionHandlerTr, 4, .production_id = 124),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [6380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArgs, 1),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [6386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declLabel, 1, .production_id = 6),
  [6388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 3, .production_id = 97),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [6406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_typerefArgs_repeat1, 2),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declEnumValue, 2, .production_id = 90),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [6420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [6450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 2, .production_id = 31),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [6484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantField, 4, .production_id = 93),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [6496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_defProc_repeat1, 3, .production_id = 11),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [6504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_defProc_repeat1, 3, .production_id = 10),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [6526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 4, .production_id = 134),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_moduleName_repeat1, 2), SHIFT_REPEAT(2014),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptionHandlerTr, 6, .production_id = 189),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [6571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caseCaseTr, 2, .production_id = 88),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [6577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declVariantField, 5, .production_id = 131),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_genericArg_repeat1, 2), SHIFT_REPEAT(2322),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_defProc_repeat1, 4, .production_id = 20),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [6592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArgs, 2),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_defProc_repeat1, 4, .production_id = 19),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericArg, 5, .production_id = 166),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recInitializerField, 3, .production_id = 132),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library, 5),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [6672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 10, .production_id = 234),
  [6674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library, 5, .production_id = 47),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [6684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 136),
  [6686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 137),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [6692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [6702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declClass, 4),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [6730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 5, .production_id = 137),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 5, .production_id = 139),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [6750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_genericArgs_repeat1, 2),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [6754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 5, .production_id = 139),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [6778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 5, .production_id = 47),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [6782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exceptionHandlersTr, 3),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kEndDot, 1),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [6854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declVariantClause_repeat1, 2),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit, 5),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [6886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 9, .production_id = 229),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 9, .production_id = 228),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [6898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declHelper, 9, .production_id = 195),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [6906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 3),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [6924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 8, .production_id = 221),
  [6926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 8, .production_id = 220),
  [6928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 8, .production_id = 219),
  [6930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 8, .production_id = 218),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [6936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declHelper, 8, .production_id = 170),
  [6938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 3, .production_id = 65),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [6944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declClass, 2),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [6972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declHelper, 5),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [6996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 7, .production_id = 198),
  [6998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 7, .production_id = 195),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 7, .production_id = 197),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [7010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 7, .production_id = 196),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [7018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 7, .production_id = 195),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [7024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declHelper, 7, .production_id = 139),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [7032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit, 6),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [7036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declPropArgs, 2),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [7050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 7, .production_id = 194),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [7066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declPropArgs, 4),
  [7068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library, 6, .production_id = 82),
  [7070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library, 6),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [7074] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [7088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 6, .production_id = 82),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [7094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6, .production_id = 172),
  [7096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 170),
  [7098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 171),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [7108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6, .production_id = 170),
  [7110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 6, .production_id = 168),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [7122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declClass, 5),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 168),
  [7130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 6, .production_id = 167),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [7156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_moduleName_repeat1, 2),
  [7158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declUses_repeat1, 2),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [7188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declPropArgs, 3),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [7194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 4, .production_id = 98),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [7210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_genericArg_repeat1, 2),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [7214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declClass, 3),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [7218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declIntf, 4, .production_id = 100),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [7228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declLabels_repeat1, 2),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [7232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declExports_repeat1, 2),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [7244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declClass, 4, .production_id = 98),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [7258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declEnum_repeat1, 2),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_pascal() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
